/*===- TableGen'erated file -------------------------------------*- C++ -*-===*\
|*                                                                            *|
|* Global Instruction Selector for the ARM target                             *|
|*                                                                            *|
|* Automatically generated file, do not edit!                                 *|
|*                                                                            *|
\*===----------------------------------------------------------------------===*/

#ifdef GET_GLOBALISEL_PREDICATE_BITSET
const unsigned MAX_SUBTARGET_PREDICATES = 85;
using PredicateBitset = llvm::Bitset<MAX_SUBTARGET_PREDICATES>;
#endif // ifdef GET_GLOBALISEL_PREDICATE_BITSET

#ifdef GET_GLOBALISEL_TEMPORARIES_DECL
  mutable MatcherState State;
  typedef ComplexRendererFns(ARMInstructionSelector::*ComplexMatcherMemFn)(MachineOperand &) const;
  typedef void(ARMInstructionSelector::*CustomRendererFn)(MachineInstrBuilder &, const MachineInstr &, int) const;
  const ExecInfoTy<PredicateBitset, ComplexMatcherMemFn, CustomRendererFn> ExecInfo;
  static ARMInstructionSelector::ComplexMatcherMemFn ComplexPredicateFns[];
  static ARMInstructionSelector::CustomRendererFn CustomRenderers[];
  bool testImmPredicate_I64(unsigned PredicateID, int64_t Imm) const override;
  bool testImmPredicate_APInt(unsigned PredicateID, const APInt &Imm) const override;
  bool testImmPredicate_APFloat(unsigned PredicateID, const APFloat &Imm) const override;
  const uint8_t *getMatchTable() const override;
  bool testMIPredicate_MI(unsigned PredicateID, const MachineInstr &MI, const MatcherState &State) const override;
  bool testMOPredicate_MO(unsigned PredicateID, const MachineOperand &MO, const MatcherState &State) const override;
  bool testSimplePredicate(unsigned PredicateID) const override;
  bool runCustomAction(unsigned FnID, const MatcherState &State, NewMIVector &OutMIs) const override;
#endif // ifdef GET_GLOBALISEL_TEMPORARIES_DECL

#ifdef GET_GLOBALISEL_TEMPORARIES_INIT
, State(0),
ExecInfo(TypeObjects, NumTypeObjects, FeatureBitsets, ComplexPredicateFns, CustomRenderers)
#endif // ifdef GET_GLOBALISEL_TEMPORARIES_INIT

#ifdef GET_GLOBALISEL_IMPL
// LLT Objects.
enum {
  GILLT_s16,
  GILLT_s32,
  GILLT_s64,
  GILLT_v2s1,
  GILLT_v2s32,
  GILLT_v2s64,
  GILLT_v4s1,
  GILLT_v4s16,
  GILLT_v4s32,
  GILLT_v4s64,
  GILLT_v8s1,
  GILLT_v8s8,
  GILLT_v8s16,
  GILLT_v8s64,
  GILLT_v16s1,
  GILLT_v16s8,
};
const static size_t NumTypeObjects = 16;
const static LLT TypeObjects[] = {
  LLT::scalar(16),
  LLT::scalar(32),
  LLT::scalar(64),
  LLT::vector(ElementCount::getFixed(2), 1),
  LLT::vector(ElementCount::getFixed(2), 32),
  LLT::vector(ElementCount::getFixed(2), 64),
  LLT::vector(ElementCount::getFixed(4), 1),
  LLT::vector(ElementCount::getFixed(4), 16),
  LLT::vector(ElementCount::getFixed(4), 32),
  LLT::vector(ElementCount::getFixed(4), 64),
  LLT::vector(ElementCount::getFixed(8), 1),
  LLT::vector(ElementCount::getFixed(8), 8),
  LLT::vector(ElementCount::getFixed(8), 16),
  LLT::vector(ElementCount::getFixed(8), 64),
  LLT::vector(ElementCount::getFixed(16), 1),
  LLT::vector(ElementCount::getFixed(16), 8),
};

// Bits for subtarget features that participate in instruction matching.
enum SubtargetFeatureBits : uint8_t {
  Feature_NoHonorSignDependentRoundingBit = 75,
  Feature_HasV4TBit = 6,
  Feature_NoV4TBit = 7,
  Feature_HasV5TBit = 13,
  Feature_NoV5TBit = 65,
  Feature_HasV5TEBit = 11,
  Feature_HasV6Bit = 0,
  Feature_NoV6Bit = 9,
  Feature_HasV6MBit = 28,
  Feature_HasV8MBaselineBit = 35,
  Feature_HasV8_1MMainlineBit = 41,
  Feature_HasMVEIntBit = 63,
  Feature_HasMVEFloatBit = 64,
  Feature_HasCDEBit = 84,
  Feature_HasFPRegsBit = 42,
  Feature_HasFPRegs16Bit = 43,
  Feature_HasFPRegs64Bit = 76,
  Feature_HasV6T2Bit = 8,
  Feature_HasV6KBit = 18,
  Feature_HasV7Bit = 3,
  Feature_HasV8Bit = 55,
  Feature_PreV8Bit = 19,
  Feature_HasV8_1aBit = 78,
  Feature_HasV8_3aBit = 79,
  Feature_NoVFPBit = 22,
  Feature_HasVFP2Bit = 21,
  Feature_HasVFP3Bit = 52,
  Feature_HasVFP4Bit = 50,
  Feature_HasDPVFPBit = 44,
  Feature_HasFPARMv8Bit = 47,
  Feature_HasNEONBit = 53,
  Feature_HasSHA2Bit = 62,
  Feature_HasAESBit = 54,
  Feature_HasDotProdBit = 56,
  Feature_HasCRCBit = 14,
  Feature_HasLOBBit = 40,
  Feature_HasFP16Bit = 61,
  Feature_HasFullFP16Bit = 46,
  Feature_HasMatMulInt8Bit = 57,
  Feature_HasDivideInThumbBit = 37,
  Feature_HasDivideInARMBit = 12,
  Feature_HasDSPBit = 36,
  Feature_HasDBBit = 15,
  Feature_HasV7ClrexBit = 17,
  Feature_HasAcquireReleaseBit = 16,
  Feature_HasMPBit = 2,
  Feature_Has8MSecExtBit = 29,
  Feature_HasZCZBit = 58,
  Feature_UseNEONForFPBit = 82,
  Feature_DontUseNEONForFPBit = 45,
  Feature_IsThumbBit = 26,
  Feature_IsThumb1OnlyBit = 27,
  Feature_IsThumb2Bit = 34,
  Feature_IsNotMClassBit = 38,
  Feature_IsARMBit = 1,
  Feature_IsWindowsBit = 30,
  Feature_IsNotWindowsBit = 31,
  Feature_IsReadTPTPIDRURWBit = 68,
  Feature_IsReadTPTPIDRUROBit = 69,
  Feature_IsReadTPTPIDRPRWBit = 70,
  Feature_IsReadTPSoftBit = 20,
  Feature_UseNaClTrapBit = 4,
  Feature_DontUseNaClTrapBit = 5,
  Feature_UseMovtBit = 39,
  Feature_DontUseMovtBit = 23,
  Feature_UseMovtInPicBit = 24,
  Feature_DontUseMovtInPicBit = 25,
  Feature_UseFPVMLxBit = 49,
  Feature_SLSBLRMitigationBit = 67,
  Feature_NoSLSBLRMitigationBit = 66,
  Feature_UseMulOpsBit = 10,
  Feature_UseFusedMACBit = 51,
  Feature_HasFastVGETLNi32Bit = 59,
  Feature_HasSlowVGETLNi32Bit = 80,
  Feature_HasFastVDUP32Bit = 60,
  Feature_HasSlowVDUP32Bit = 81,
  Feature_UseVMOVSRBit = 48,
  Feature_DontUseVMOVSRBit = 83,
  Feature_IsLEBit = 74,
  Feature_IsBEBit = 77,
  Feature_GenExecuteOnlyBit = 33,
  Feature_DontGenExecuteOnlyBit = 32,
  Feature_GenT1ExecuteOnlyBit = 73,
  Feature_SignRetAddrBit = 72,
  Feature_NoSignRetAddrBit = 71,
};

PredicateBitset ARMInstructionSelector::
computeAvailableModuleFeatures(const ARMSubtarget *Subtarget) const {
  PredicateBitset Features{};
  if (!TM.Options.HonorSignDependentRoundingFPMath())
    Features.set(Feature_NoHonorSignDependentRoundingBit);
  if (Subtarget->hasV4TOps())
    Features.set(Feature_HasV4TBit);
  if (!Subtarget->hasV4TOps())
    Features.set(Feature_NoV4TBit);
  if (Subtarget->hasV5TOps())
    Features.set(Feature_HasV5TBit);
  if (!Subtarget->hasV5TOps())
    Features.set(Feature_NoV5TBit);
  if (Subtarget->hasV5TEOps())
    Features.set(Feature_HasV5TEBit);
  if (Subtarget->hasV6Ops())
    Features.set(Feature_HasV6Bit);
  if (!Subtarget->hasV6Ops())
    Features.set(Feature_NoV6Bit);
  if (Subtarget->hasV6MOps())
    Features.set(Feature_HasV6MBit);
  if (Subtarget->hasV8MBaselineOps())
    Features.set(Feature_HasV8MBaselineBit);
  if (Subtarget->hasV8_1MMainlineOps())
    Features.set(Feature_HasV8_1MMainlineBit);
  if (Subtarget->hasMVEIntegerOps())
    Features.set(Feature_HasMVEIntBit);
  if (Subtarget->hasMVEFloatOps())
    Features.set(Feature_HasMVEFloatBit);
  if (Subtarget->hasCDEOps())
    Features.set(Feature_HasCDEBit);
  if (Subtarget->hasFPRegs())
    Features.set(Feature_HasFPRegsBit);
  if (Subtarget->hasFPRegs16())
    Features.set(Feature_HasFPRegs16Bit);
  if (Subtarget->hasFPRegs64())
    Features.set(Feature_HasFPRegs64Bit);
  if (Subtarget->hasV6T2Ops())
    Features.set(Feature_HasV6T2Bit);
  if (Subtarget->hasV6KOps())
    Features.set(Feature_HasV6KBit);
  if (Subtarget->hasV7Ops())
    Features.set(Feature_HasV7Bit);
  if (Subtarget->hasV8Ops())
    Features.set(Feature_HasV8Bit);
  if (!Subtarget->hasV8Ops())
    Features.set(Feature_PreV8Bit);
  if (Subtarget->hasV8_1aOps())
    Features.set(Feature_HasV8_1aBit);
  if (Subtarget->hasV8_3aOps())
    Features.set(Feature_HasV8_3aBit);
  if (!Subtarget->hasVFP2Base())
    Features.set(Feature_NoVFPBit);
  if (Subtarget->hasVFP2Base())
    Features.set(Feature_HasVFP2Bit);
  if (Subtarget->hasVFP3Base())
    Features.set(Feature_HasVFP3Bit);
  if (Subtarget->hasVFP4Base())
    Features.set(Feature_HasVFP4Bit);
  if (Subtarget->hasFP64())
    Features.set(Feature_HasDPVFPBit);
  if (Subtarget->hasFPARMv8Base())
    Features.set(Feature_HasFPARMv8Bit);
  if (Subtarget->hasNEON())
    Features.set(Feature_HasNEONBit);
  if (Subtarget->hasSHA2())
    Features.set(Feature_HasSHA2Bit);
  if (Subtarget->hasAES())
    Features.set(Feature_HasAESBit);
  if (Subtarget->hasDotProd())
    Features.set(Feature_HasDotProdBit);
  if (Subtarget->hasCRC())
    Features.set(Feature_HasCRCBit);
  if (Subtarget->hasLOB())
    Features.set(Feature_HasLOBBit);
  if (Subtarget->hasFP16())
    Features.set(Feature_HasFP16Bit);
  if (Subtarget->hasFullFP16())
    Features.set(Feature_HasFullFP16Bit);
  if (Subtarget->hasMatMulInt8())
    Features.set(Feature_HasMatMulInt8Bit);
  if (Subtarget->hasDivideInThumbMode())
    Features.set(Feature_HasDivideInThumbBit);
  if (Subtarget->hasDivideInARMMode())
    Features.set(Feature_HasDivideInARMBit);
  if (Subtarget->hasDSP())
    Features.set(Feature_HasDSPBit);
  if (Subtarget->hasDataBarrier())
    Features.set(Feature_HasDBBit);
  if (Subtarget->hasV7Clrex())
    Features.set(Feature_HasV7ClrexBit);
  if (Subtarget->hasAcquireRelease())
    Features.set(Feature_HasAcquireReleaseBit);
  if (Subtarget->hasMPExtension())
    Features.set(Feature_HasMPBit);
  if (Subtarget->has8MSecExt())
    Features.set(Feature_Has8MSecExtBit);
  if (Subtarget->hasZeroCycleZeroing())
    Features.set(Feature_HasZCZBit);
  if (Subtarget->useNEONForSinglePrecisionFP())
    Features.set(Feature_UseNEONForFPBit);
  if (!Subtarget->useNEONForSinglePrecisionFP())
    Features.set(Feature_DontUseNEONForFPBit);
  if (Subtarget->isThumb())
    Features.set(Feature_IsThumbBit);
  if (Subtarget->isThumb1Only())
    Features.set(Feature_IsThumb1OnlyBit);
  if (Subtarget->isThumb2())
    Features.set(Feature_IsThumb2Bit);
  if (!Subtarget->isMClass())
    Features.set(Feature_IsNotMClassBit);
  if (!Subtarget->isThumb())
    Features.set(Feature_IsARMBit);
  if (Subtarget->isTargetWindows())
    Features.set(Feature_IsWindowsBit);
  if (!Subtarget->isTargetWindows())
    Features.set(Feature_IsNotWindowsBit);
  if (Subtarget->isReadTPTPIDRURW())
    Features.set(Feature_IsReadTPTPIDRURWBit);
  if (Subtarget->isReadTPTPIDRURO())
    Features.set(Feature_IsReadTPTPIDRUROBit);
  if (Subtarget->isReadTPTPIDRPRW())
    Features.set(Feature_IsReadTPTPIDRPRWBit);
  if (Subtarget->isReadTPSoft())
    Features.set(Feature_IsReadTPSoftBit);
  if (Subtarget->useNaClTrap())
    Features.set(Feature_UseNaClTrapBit);
  if (!Subtarget->useNaClTrap())
    Features.set(Feature_DontUseNaClTrapBit);
  if (Subtarget->useMulOps())
    Features.set(Feature_UseMulOpsBit);
  if (TM.Options.AllowFPOpFusion ==  FPOpFusion::Fast && Subtarget->useFPVFMx())
    Features.set(Feature_UseFusedMACBit);
  if (!Subtarget->hasSlowVGETLNi32())
    Features.set(Feature_HasFastVGETLNi32Bit);
  if (Subtarget->hasSlowVGETLNi32())
    Features.set(Feature_HasSlowVGETLNi32Bit);
  if (!Subtarget->hasSlowVDUP32())
    Features.set(Feature_HasFastVDUP32Bit);
  if (Subtarget->hasSlowVDUP32())
    Features.set(Feature_HasSlowVDUP32Bit);
  if (Subtarget->preferVMOVSR() ||!Subtarget->useNEONForSinglePrecisionFP())
    Features.set(Feature_UseVMOVSRBit);
  if (!Subtarget->preferVMOVSR() &&Subtarget->useNEONForSinglePrecisionFP())
    Features.set(Feature_DontUseVMOVSRBit);
  if (Subtarget->genExecuteOnly())
    Features.set(Feature_GenExecuteOnlyBit);
  if (!Subtarget->genExecuteOnly())
    Features.set(Feature_DontGenExecuteOnlyBit);
  if (Subtarget->genExecuteOnly() && Subtarget->isThumb1Only() && !Subtarget->hasV8MBaselineOps())
    Features.set(Feature_GenT1ExecuteOnlyBit);
  return Features;
}

void ARMInstructionSelector::setupGeneratedPerFunctionState(MachineFunction &MF) {
  AvailableFunctionFeatures = computeAvailableFunctionFeatures((const ARMSubtarget *)&MF.getSubtarget(), &MF);
}
PredicateBitset ARMInstructionSelector::
computeAvailableFunctionFeatures(const ARMSubtarget *Subtarget, const MachineFunction *MF) const {
  PredicateBitset Features{};
  if (Subtarget->useMovt())
    Features.set(Feature_UseMovtBit);
  if (!Subtarget->useMovt())
    Features.set(Feature_DontUseMovtBit);
  if (Subtarget->useMovt() && Subtarget->allowPositionIndependentMovt())
    Features.set(Feature_UseMovtInPicBit);
  if (!Subtarget->useMovt() || !Subtarget->allowPositionIndependentMovt())
    Features.set(Feature_DontUseMovtInPicBit);
  if (((Subtarget->useFPVMLx() &&  TM.Options.AllowFPOpFusion != FPOpFusion::Fast) ||Subtarget->hasMinSize()))
    Features.set(Feature_UseFPVMLxBit);
  if ( MF->getSubtarget<ARMSubtarget>().hardenSlsBlr() )
    Features.set(Feature_SLSBLRMitigationBit);
  if ( !MF->getSubtarget<ARMSubtarget>().hardenSlsBlr() )
    Features.set(Feature_NoSLSBLRMitigationBit);
  if (MF->getDataLayout().isLittleEndian())
    Features.set(Feature_IsLEBit);
  if (MF->getDataLayout().isBigEndian())
    Features.set(Feature_IsBEBit);
  if ( MF->getInfo<ARMFunctionInfo>()->shouldSignReturnAddress(true) )
    Features.set(Feature_SignRetAddrBit);
  if ( !MF->getInfo<ARMFunctionInfo>()->shouldSignReturnAddress(true) )
    Features.set(Feature_NoSignRetAddrBit);
  return Features;
}

// Feature bitsets.
enum {
  GIFBS_Invalid,
  GIFBS_HasDotProd,
  GIFBS_HasFP16,
  GIFBS_HasFPARMv8,
  GIFBS_HasFPRegs,
  GIFBS_HasFullFP16,
  GIFBS_HasMVEFloat,
  GIFBS_HasMVEInt,
  GIFBS_HasMatMulInt8,
  GIFBS_HasNEON,
  GIFBS_HasVFP2,
  GIFBS_HasVFP3,
  GIFBS_HasVFP4,
  GIFBS_IsARM,
  GIFBS_IsThumb,
  GIFBS_IsThumb2,
  GIFBS_NoHonorSignDependentRounding,
  GIFBS_DontUseNEONForFP_HasVFP2,
  GIFBS_DontUseNaClTrap_IsARM,
  GIFBS_DontUseVMOVSR_HasNEON,
  GIFBS_Has8MSecExt_IsThumb,
  GIFBS_HasAES_HasV8,
  GIFBS_HasCRC_IsARM,
  GIFBS_HasCRC_IsThumb2,
  GIFBS_HasDB_IsARM,
  GIFBS_HasDB_IsThumb,
  GIFBS_HasDPVFP_HasFPARMv8,
  GIFBS_HasDPVFP_HasVFP2,
  GIFBS_HasDPVFP_HasVFP3,
  GIFBS_HasDPVFP_HasVFP4,
  GIFBS_HasDPVFP_NoHonorSignDependentRounding,
  GIFBS_HasDSP_IsThumb2,
  GIFBS_HasDivideInARM_IsARM,
  GIFBS_HasFP16_HasNEON,
  GIFBS_HasFPARMv8_HasNEON,
  GIFBS_HasFPRegs_HasFastVGETLNi32,
  GIFBS_HasFPRegs_UseVMOVSR,
  GIFBS_HasFullFP16_HasNEON,
  GIFBS_HasMVEInt_HasV8_1MMainline,
  GIFBS_HasMVEInt_IsBE,
  GIFBS_HasMVEInt_IsLE,
  GIFBS_HasNEON_HasV8,
  GIFBS_HasNEON_HasV8_1a,
  GIFBS_HasNEON_HasV8_3a,
  GIFBS_HasNEON_HasVFP4,
  GIFBS_HasNEON_IsBE,
  GIFBS_HasNEON_IsLE,
  GIFBS_HasNEON_UseNEONForFP,
  GIFBS_HasSHA2_HasV8,
  GIFBS_HasV5T_IsARM,
  GIFBS_HasV5T_IsThumb,
  GIFBS_HasV5TE_IsARM,
  GIFBS_HasV6_IsARM,
  GIFBS_HasV6K_IsARM,
  GIFBS_HasV6M_IsThumb,
  GIFBS_HasV6T2_IsARM,
  GIFBS_HasV7_IsARM,
  GIFBS_HasV7Clrex_IsThumb,
  GIFBS_HasV8MBaseline_IsThumb,
  GIFBS_IsARM_NoV5T,
  GIFBS_IsARM_NoV6,
  GIFBS_IsARM_PreV8,
  GIFBS_IsARM_UseNaClTrap,
  GIFBS_IsThumb_IsThumb1Only,
  GIFBS_IsThumb_IsWindows,
  GIFBS_IsThumb_NoV5T,
  GIFBS_IsThumb_UseMovt,
  GIFBS_IsThumb2_PreV8,
  GIFBS_IsThumb2_UseMulOps,
  GIFBS_DontUseMovt_GenExecuteOnly_IsThumb1Only,
  GIFBS_HasDSP_IsThumb2_UseMulOps,
  GIFBS_HasDivideInThumb_HasV8MBaseline_IsThumb,
  GIFBS_HasFPARMv8_HasFullFP16_HasNEON,
  GIFBS_HasFullFP16_HasNEON_HasV8,
  GIFBS_HasFullFP16_HasNEON_HasV8_3a,
  GIFBS_HasFullFP16_HasNEON_UseFPVMLx,
  GIFBS_HasFullFP16_HasNEON_UseFusedMAC,
  GIFBS_HasLOB_HasV8_1MMainline_IsThumb2,
  GIFBS_HasNEON_UseFPVMLx_UseNEONForFP,
  GIFBS_HasV5TE_IsARM_UseMulOps,
  GIFBS_HasV6_IsARM_UseMulOps,
  GIFBS_HasV6_IsThumb_IsThumb1Only,
  GIFBS_HasV6T2_IsARM_UseMulOps,
  GIFBS_HasVFP4_UseFusedMAC_UseNEONForFP,
  GIFBS_IsARM_NoV6_UseMulOps,
};
constexpr static PredicateBitset FeatureBitsets[] {
  {}, // GIFBS_Invalid
  {Feature_HasDotProdBit, },
  {Feature_HasFP16Bit, },
  {Feature_HasFPARMv8Bit, },
  {Feature_HasFPRegsBit, },
  {Feature_HasFullFP16Bit, },
  {Feature_HasMVEFloatBit, },
  {Feature_HasMVEIntBit, },
  {Feature_HasMatMulInt8Bit, },
  {Feature_HasNEONBit, },
  {Feature_HasVFP2Bit, },
  {Feature_HasVFP3Bit, },
  {Feature_HasVFP4Bit, },
  {Feature_IsARMBit, },
  {Feature_IsThumbBit, },
  {Feature_IsThumb2Bit, },
  {Feature_NoHonorSignDependentRoundingBit, },
  {Feature_DontUseNEONForFPBit, Feature_HasVFP2Bit, },
  {Feature_DontUseNaClTrapBit, Feature_IsARMBit, },
  {Feature_DontUseVMOVSRBit, Feature_HasNEONBit, },
  {Feature_Has8MSecExtBit, Feature_IsThumbBit, },
  {Feature_HasAESBit, Feature_HasV8Bit, },
  {Feature_HasCRCBit, Feature_IsARMBit, },
  {Feature_HasCRCBit, Feature_IsThumb2Bit, },
  {Feature_HasDBBit, Feature_IsARMBit, },
  {Feature_HasDBBit, Feature_IsThumbBit, },
  {Feature_HasDPVFPBit, Feature_HasFPARMv8Bit, },
  {Feature_HasDPVFPBit, Feature_HasVFP2Bit, },
  {Feature_HasDPVFPBit, Feature_HasVFP3Bit, },
  {Feature_HasDPVFPBit, Feature_HasVFP4Bit, },
  {Feature_HasDPVFPBit, Feature_NoHonorSignDependentRoundingBit, },
  {Feature_HasDSPBit, Feature_IsThumb2Bit, },
  {Feature_HasDivideInARMBit, Feature_IsARMBit, },
  {Feature_HasFP16Bit, Feature_HasNEONBit, },
  {Feature_HasFPARMv8Bit, Feature_HasNEONBit, },
  {Feature_HasFPRegsBit, Feature_HasFastVGETLNi32Bit, },
  {Feature_HasFPRegsBit, Feature_UseVMOVSRBit, },
  {Feature_HasFullFP16Bit, Feature_HasNEONBit, },
  {Feature_HasMVEIntBit, Feature_HasV8_1MMainlineBit, },
  {Feature_HasMVEIntBit, Feature_IsBEBit, },
  {Feature_HasMVEIntBit, Feature_IsLEBit, },
  {Feature_HasNEONBit, Feature_HasV8Bit, },
  {Feature_HasNEONBit, Feature_HasV8_1aBit, },
  {Feature_HasNEONBit, Feature_HasV8_3aBit, },
  {Feature_HasNEONBit, Feature_HasVFP4Bit, },
  {Feature_HasNEONBit, Feature_IsBEBit, },
  {Feature_HasNEONBit, Feature_IsLEBit, },
  {Feature_HasNEONBit, Feature_UseNEONForFPBit, },
  {Feature_HasSHA2Bit, Feature_HasV8Bit, },
  {Feature_HasV5TBit, Feature_IsARMBit, },
  {Feature_HasV5TBit, Feature_IsThumbBit, },
  {Feature_HasV5TEBit, Feature_IsARMBit, },
  {Feature_HasV6Bit, Feature_IsARMBit, },
  {Feature_HasV6KBit, Feature_IsARMBit, },
  {Feature_HasV6MBit, Feature_IsThumbBit, },
  {Feature_HasV6T2Bit, Feature_IsARMBit, },
  {Feature_HasV7Bit, Feature_IsARMBit, },
  {Feature_HasV7ClrexBit, Feature_IsThumbBit, },
  {Feature_HasV8MBaselineBit, Feature_IsThumbBit, },
  {Feature_IsARMBit, Feature_NoV5TBit, },
  {Feature_IsARMBit, Feature_NoV6Bit, },
  {Feature_IsARMBit, Feature_PreV8Bit, },
  {Feature_IsARMBit, Feature_UseNaClTrapBit, },
  {Feature_IsThumbBit, Feature_IsThumb1OnlyBit, },
  {Feature_IsThumbBit, Feature_IsWindowsBit, },
  {Feature_IsThumbBit, Feature_NoV5TBit, },
  {Feature_IsThumbBit, Feature_UseMovtBit, },
  {Feature_IsThumb2Bit, Feature_PreV8Bit, },
  {Feature_IsThumb2Bit, Feature_UseMulOpsBit, },
  {Feature_DontUseMovtBit, Feature_GenExecuteOnlyBit, Feature_IsThumb1OnlyBit, },
  {Feature_HasDSPBit, Feature_IsThumb2Bit, Feature_UseMulOpsBit, },
  {Feature_HasDivideInThumbBit, Feature_HasV8MBaselineBit, Feature_IsThumbBit, },
  {Feature_HasFPARMv8Bit, Feature_HasFullFP16Bit, Feature_HasNEONBit, },
  {Feature_HasFullFP16Bit, Feature_HasNEONBit, Feature_HasV8Bit, },
  {Feature_HasFullFP16Bit, Feature_HasNEONBit, Feature_HasV8_3aBit, },
  {Feature_HasFullFP16Bit, Feature_HasNEONBit, Feature_UseFPVMLxBit, },
  {Feature_HasFullFP16Bit, Feature_HasNEONBit, Feature_UseFusedMACBit, },
  {Feature_HasLOBBit, Feature_HasV8_1MMainlineBit, Feature_IsThumb2Bit, },
  {Feature_HasNEONBit, Feature_UseFPVMLxBit, Feature_UseNEONForFPBit, },
  {Feature_HasV5TEBit, Feature_IsARMBit, Feature_UseMulOpsBit, },
  {Feature_HasV6Bit, Feature_IsARMBit, Feature_UseMulOpsBit, },
  {Feature_HasV6Bit, Feature_IsThumbBit, Feature_IsThumb1OnlyBit, },
  {Feature_HasV6T2Bit, Feature_IsARMBit, Feature_UseMulOpsBit, },
  {Feature_HasVFP4Bit, Feature_UseFusedMACBit, Feature_UseNEONForFPBit, },
  {Feature_IsARMBit, Feature_NoV6Bit, Feature_UseMulOpsBit, },
};

// ComplexPattern predicates.
enum {
  GICP_Invalid,
};
// See constructor for table contents

ARMInstructionSelector::ComplexMatcherMemFn
ARMInstructionSelector::ComplexPredicateFns[] = {
  nullptr, // GICP_Invalid
};

// PatFrag predicates.
enum {
  GICXXPred_MI_Predicate_bf_inv_mask_imm = GICXXPred_Invalid + 1,
  GICXXPred_MI_Predicate_vfp_f32imm,
  GICXXPred_MI_Predicate_vfp_f64imm,
};
bool ARMInstructionSelector::testMIPredicate_MI(unsigned PredicateID, const MachineInstr & MI, const MatcherState &State) const {
  const MachineFunction &MF = *MI.getParent()->getParent();
  const MachineRegisterInfo &MRI = MF.getRegInfo();
  const auto &Operands = State.RecordedOperands;
  (void)Operands;
  (void)MRI;
  switch (PredicateID) {
  case GICXXPred_MI_Predicate_bf_inv_mask_imm: {
    
        // There's better methods of implementing this check. IntImmLeaf<> would be
        // equivalent and have less boilerplate but we need a test for C++
        // predicates and this one causes new rules to be imported into GlobalISel
        // without requiring additional features first.
        const auto &MO = MI.getOperand(1);
        if (!MO.isCImm())
          return false;
        return ARM::isBitFieldInvertedMask(MO.getCImm()->getZExtValue());
      
    llvm_unreachable("bf_inv_mask_imm should have returned");
  }
  case GICXXPred_MI_Predicate_vfp_f32imm: {
    
          const auto &MO = MI.getOperand(1);
          if (!MO.isFPImm())
            return false;
          return ARM_AM::getFP32Imm(MO.getFPImm()->getValueAPF()) != -1;
        
    llvm_unreachable("vfp_f32imm should have returned");
  }
  case GICXXPred_MI_Predicate_vfp_f64imm: {
    
          const auto &MO = MI.getOperand(1);
          if (!MO.isFPImm())
            return false;
          return ARM_AM::getFP64Imm(MO.getFPImm()->getValueAPF()) != -1;
        
    llvm_unreachable("vfp_f64imm should have returned");
  }
  }
  llvm_unreachable("Unknown predicate");
  return false;
}
// PatFrag predicates.
bool ARMInstructionSelector::testMOPredicate_MO(unsigned PredicateID, const MachineOperand & MO, const MatcherState &State) const {
  const auto &Operands = State.RecordedOperands;
  Register Reg = MO.getReg();
  (void)Operands;
  (void)Reg;
  llvm_unreachable("Unknown predicate");
  return false;
}
// PatFrag predicates.
enum {
  GICXXPred_I64_Predicate_VectorIndex8 = GICXXPred_Invalid + 1,
  GICXXPred_I64_Predicate_VectorIndex16,
  GICXXPred_I64_Predicate_VectorIndex32,
  GICXXPred_I64_Predicate_VectorIndex64,
  GICXXPred_I64_Predicate_asr_imm,
  GICXXPred_I64_Predicate_imm0_7,
  GICXXPred_I64_Predicate_imm0_15,
  GICXXPred_I64_Predicate_imm0_31,
  GICXXPred_I64_Predicate_imm0_32,
  GICXXPred_I64_Predicate_imm0_63,
  GICXXPred_I64_Predicate_imm0_239,
  GICXXPred_I64_Predicate_imm0_255,
  GICXXPred_I64_Predicate_imm0_255_expr,
  GICXXPred_I64_Predicate_imm0_4095,
  GICXXPred_I64_Predicate_imm0_65535,
  GICXXPred_I64_Predicate_imm0_65535_expr,
  GICXXPred_I64_Predicate_imm0_65535_neg,
  GICXXPred_I64_Predicate_imm1_7,
  GICXXPred_I64_Predicate_imm1_15,
  GICXXPred_I64_Predicate_imm1_16,
  GICXXPred_I64_Predicate_imm1_31,
  GICXXPred_I64_Predicate_imm8,
  GICXXPred_I64_Predicate_imm8_255,
  GICXXPred_I64_Predicate_imm8_or_16,
  GICXXPred_I64_Predicate_imm16,
  GICXXPred_I64_Predicate_imm16_31,
  GICXXPred_I64_Predicate_imm24b,
  GICXXPred_I64_Predicate_imm32,
  GICXXPred_I64_Predicate_imm256_510,
  GICXXPred_I64_Predicate_imm_3b,
  GICXXPred_I64_Predicate_imm_4b,
  GICXXPred_I64_Predicate_imm_6b,
  GICXXPred_I64_Predicate_imm_7b,
  GICXXPred_I64_Predicate_imm_9b,
  GICXXPred_I64_Predicate_imm_11b,
  GICXXPred_I64_Predicate_imm_12b,
  GICXXPred_I64_Predicate_imm_13b,
  GICXXPred_I64_Predicate_imm_even,
  GICXXPred_I64_Predicate_imm_odd,
  GICXXPred_I64_Predicate_imm_sr,
  GICXXPred_I64_Predicate_long_shift,
  GICXXPred_I64_Predicate_mod_imm,
  GICXXPred_I64_Predicate_mod_imm_not,
  GICXXPred_I64_Predicate_pkh_asr_amt,
  GICXXPred_I64_Predicate_pkh_lsl_amt,
  GICXXPred_I64_Predicate_shr_imm8,
  GICXXPred_I64_Predicate_shr_imm16,
  GICXXPred_I64_Predicate_shr_imm32,
  GICXXPred_I64_Predicate_shr_imm64,
  GICXXPred_I64_Predicate_t2_so_imm,
  GICXXPred_I64_Predicate_t2_so_imm_neg,
};
bool ARMInstructionSelector::testImmPredicate_I64(unsigned PredicateID, int64_t Imm) const {
  switch (PredicateID) {
  case GICXXPred_I64_Predicate_VectorIndex8: {
    
      return ((uint64_t)Imm) < 8;
    
  }
  case GICXXPred_I64_Predicate_VectorIndex16: {
    
      return ((uint64_t)Imm) < 4;
    
  }
  case GICXXPred_I64_Predicate_VectorIndex32: {
    
      return ((uint64_t)Imm) < 2;
    
  }
  case GICXXPred_I64_Predicate_VectorIndex64: {
    
      return ((uint64_t)Imm) < 1;
    
  }
  case GICXXPred_I64_Predicate_asr_imm: {
     return Imm > 0 && Imm <= 32; 
  }
  case GICXXPred_I64_Predicate_imm0_7: {
    
      return Imm >= 0 && Imm < 8;
    
  }
  case GICXXPred_I64_Predicate_imm0_15: {
    
      return Imm >= 0 && Imm < 16;
    
  }
  case GICXXPred_I64_Predicate_imm0_31: {
    
      return Imm >= 0 && Imm < 32;
    
  }
  case GICXXPred_I64_Predicate_imm0_32: {
    
      return Imm >= 0 && Imm < 33;
    
  }
  case GICXXPred_I64_Predicate_imm0_63: {
    
      return Imm >= 0 && Imm < 64;
    
  }
  case GICXXPred_I64_Predicate_imm0_239: {
     return Imm >= 0 && Imm < 240; 
  }
  case GICXXPred_I64_Predicate_imm0_255: {
     return Imm >= 0 && Imm < 256; 
  }
  case GICXXPred_I64_Predicate_imm0_255_expr: {
     return Imm >= 0 && Imm < 256; 
  }
  case GICXXPred_I64_Predicate_imm0_4095: {
    
      return Imm >= 0 && Imm < 4096;
    
  }
  case GICXXPred_I64_Predicate_imm0_65535: {
    
      return Imm >= 0 && Imm < 65536;
    
  }
  case GICXXPred_I64_Predicate_imm0_65535_expr: {
    
      return Imm >= 0 && Imm < 65536;
    
  }
  case GICXXPred_I64_Predicate_imm0_65535_neg: {
    
      return -Imm >= 0 && -Imm < 65536;
    
  }
  case GICXXPred_I64_Predicate_imm1_7: {
     return Imm > 0 && Imm < 8; 
  }
  case GICXXPred_I64_Predicate_imm1_15: {
     return Imm > 0 && Imm < 16; 
  }
  case GICXXPred_I64_Predicate_imm1_16: {
    
        return Imm > 0 && Imm <= 16;
      
  }
  case GICXXPred_I64_Predicate_imm1_31: {
     return Imm > 0 && Imm < 32; 
  }
  case GICXXPred_I64_Predicate_imm8: {
     return Imm == 8; 
  }
  case GICXXPred_I64_Predicate_imm8_255: {
    
      return Imm >= 8 && Imm < 256;
    
  }
  case GICXXPred_I64_Predicate_imm8_or_16: {
     return Imm == 8 || Imm == 16;
  }
  case GICXXPred_I64_Predicate_imm16: {
     return Imm == 16; 
  }
  case GICXXPred_I64_Predicate_imm16_31: {
    
      return (int32_t)Imm >= 16 && (int32_t)Imm < 32;
    
  }
  case GICXXPred_I64_Predicate_imm24b: {
    
      return Imm >= 0 && Imm <= 0xffffff;
    
  }
  case GICXXPred_I64_Predicate_imm32: {
     return Imm == 32; 
  }
  case GICXXPred_I64_Predicate_imm256_510: {
    
      return Imm >= 256 && Imm < 511;
    
  }
  case GICXXPred_I64_Predicate_imm_3b: {
    { return Imm >= 0 && Imm < (1 << 3); }
    llvm_unreachable("imm_3b should have returned");
  }
  case GICXXPred_I64_Predicate_imm_4b: {
    { return Imm >= 0 && Imm < (1 << 4); }
    llvm_unreachable("imm_4b should have returned");
  }
  case GICXXPred_I64_Predicate_imm_6b: {
    { return Imm >= 0 && Imm < (1 << 6); }
    llvm_unreachable("imm_6b should have returned");
  }
  case GICXXPred_I64_Predicate_imm_7b: {
    { return Imm >= 0 && Imm < (1 << 7); }
    llvm_unreachable("imm_7b should have returned");
  }
  case GICXXPred_I64_Predicate_imm_9b: {
    { return Imm >= 0 && Imm < (1 << 9); }
    llvm_unreachable("imm_9b should have returned");
  }
  case GICXXPred_I64_Predicate_imm_11b: {
    { return Imm >= 0 && Imm < (1 << 11); }
    llvm_unreachable("imm_11b should have returned");
  }
  case GICXXPred_I64_Predicate_imm_12b: {
    { return Imm >= 0 && Imm < (1 << 12); }
    llvm_unreachable("imm_12b should have returned");
  }
  case GICXXPred_I64_Predicate_imm_13b: {
    { return Imm >= 0 && Imm < (1 << 13); }
    llvm_unreachable("imm_13b should have returned");
  }
  case GICXXPred_I64_Predicate_imm_even: {
     return (Imm & 1) == 0; 
  }
  case GICXXPred_I64_Predicate_imm_odd: {
     return (Imm & 1) == 1; 
  }
  case GICXXPred_I64_Predicate_imm_sr: {
    
      return Imm > 0 && Imm <= 32;
    
  }
  case GICXXPred_I64_Predicate_long_shift: {
     return Imm > 0 && Imm <= 32; 
  }
  case GICXXPred_I64_Predicate_mod_imm: {
    
        return ARM_AM::getSOImmVal(Imm) != -1;
      
  }
  case GICXXPred_I64_Predicate_mod_imm_not: {
    
        return ARM_AM::getSOImmVal(~(uint32_t)Imm) != -1;
      
  }
  case GICXXPred_I64_Predicate_pkh_asr_amt: {
     return Imm > 0 && Imm <= 32; 
  }
  case GICXXPred_I64_Predicate_pkh_lsl_amt: {
     return Imm >= 0 && Imm < 32; 
  }
  case GICXXPred_I64_Predicate_shr_imm8: {
     return Imm > 0 && Imm <= 8; 
  }
  case GICXXPred_I64_Predicate_shr_imm16: {
     return Imm > 0 && Imm <= 16; 
  }
  case GICXXPred_I64_Predicate_shr_imm32: {
     return Imm > 0 && Imm <= 32; 
  }
  case GICXXPred_I64_Predicate_shr_imm64: {
     return Imm > 0 && Imm <= 64; 
  }
  case GICXXPred_I64_Predicate_t2_so_imm: {
    
        return ARM_AM::getT2SOImmVal(Imm) != -1;
      
  }
  case GICXXPred_I64_Predicate_t2_so_imm_neg: {
    
      return Imm && ARM_AM::getT2SOImmVal(-(uint32_t)Imm) != -1;
    
  }
  }
  llvm_unreachable("Unknown predicate");
  return false;
}
// PatFrag predicates.
bool ARMInstructionSelector::testImmPredicate_APFloat(unsigned PredicateID, const APFloat & Imm) const {
  llvm_unreachable("Unknown predicate");
  return false;
}
// PatFrag predicates.
enum {
  GICXXPred_APInt_Predicate_arm_i32imm = GICXXPred_Invalid + 1,
};
bool ARMInstructionSelector::testImmPredicate_APInt(unsigned PredicateID, const APInt & Imm) const {
  switch (PredicateID) {
  case GICXXPred_APInt_Predicate_arm_i32imm: {
    
      if (Subtarget->useMovt())
        return true;
      if (ARM_AM::isSOImmTwoPartVal(Imm.getZExtValue()))
        return true;
      return ARM_AM::isSOImmTwoPartValNeg(Imm.getZExtValue());
    
    llvm_unreachable("arm_i32imm should have returned");
  }
  }
  llvm_unreachable("Unknown predicate");
  return false;
}
bool ARMInstructionSelector::testSimplePredicate(unsigned) const {
    llvm_unreachable("ARMInstructionSelector does not support simple predicates!");
  return false;
}
// Custom renderers.
enum {
  GICR_Invalid,
  GICR_renderInvertedImm,
  GICR_renderVFPF32Imm,
  GICR_renderVFPF64Imm,
};
ARMInstructionSelector::CustomRendererFn
ARMInstructionSelector::CustomRenderers[] = {
  nullptr, // GICR_Invalid
  &ARMInstructionSelector::renderInvertedImm,
  &ARMInstructionSelector::renderVFPF32Imm,
  &ARMInstructionSelector::renderVFPF64Imm,
};

bool ARMInstructionSelector::selectImpl(MachineInstr &I, CodeGenCoverage &CoverageInfo) const {
  const PredicateBitset AvailableFeatures = getAvailableFeatures();
  MachineIRBuilder B(I);
  State.MIs.clear();
  State.MIs.push_back(&I);

  if (executeMatchTable(*this, State, ExecInfo, B, getMatchTable(), TII, MF->getRegInfo(), TRI, RBI, AvailableFeatures, &CoverageInfo)) {
    return true;
  }

  return false;
}

bool ARMInstructionSelector::runCustomAction(unsigned, const MatcherState&, NewMIVector &) const {
    llvm_unreachable("ARMInstructionSelector does not support custom C++ actions!");
}
#if __BYTE_ORDER__ == __ORDER_LITTLE_ENDIAN__
#define GIMT_Encode2(Val) uint8_t(Val), uint8_t((uint16_t)Val >> 8)
#define GIMT_Encode4(Val) uint8_t(Val), uint8_t((uint32_t)Val >> 8), uint8_t((uint32_t)Val >> 16), uint8_t((uint32_t)Val >> 24)
#define GIMT_Encode8(Val) uint8_t(Val), uint8_t((uint64_t)Val >> 8), uint8_t((uint64_t)Val >> 16), uint8_t((uint64_t)Val >> 24),  uint8_t((uint64_t)Val >> 32), uint8_t((uint64_t)Val >> 40), uint8_t((uint64_t)Val >> 48), uint8_t((uint64_t)Val >> 56)
#else
#define GIMT_Encode2(Val) uint8_t((uint16_t)Val >> 8), uint8_t(Val)
#define GIMT_Encode4(Val) uint8_t((uint32_t)Val >> 24), uint8_t((uint32_t)Val >> 16), uint8_t((uint32_t)Val >> 8), uint8_t(Val)
#define GIMT_Encode8(Val) uint8_t((uint64_t)Val >> 56), uint8_t((uint64_t)Val >> 48), uint8_t((uint64_t)Val >> 40), uint8_t((uint64_t)Val >> 32),  uint8_t((uint64_t)Val >> 24), uint8_t((uint64_t)Val >> 16), uint8_t((uint64_t)Val >> 8), uint8_t(Val)
#endif
const uint8_t *ARMInstructionSelector::getMatchTable() const {
  constexpr static uint8_t MatchTable0[] = {
     /*      0 */ GIM_SwitchOpcode, /*MI*/0, /*[*/GIMT_Encode2(53), GIMT_Encode2(308), /*)*//*default:*//*Label 79*/ GIMT_Encode4(130753),
     /*     10 */ /*TargetOpcode::G_ADD*//*Label 0*/ GIMT_Encode4(1030),
     /*     14 */ /*TargetOpcode::G_SUB*//*Label 1*/ GIMT_Encode4(10357),
     /*     18 */ /*TargetOpcode::G_MUL*//*Label 2*/ GIMT_Encode4(13601),
     /*     22 */ /*TargetOpcode::G_SDIV*//*Label 3*/ GIMT_Encode4(15305),
     /*     26 */ /*TargetOpcode::G_UDIV*//*Label 4*/ GIMT_Encode4(15401), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*     46 */ /*TargetOpcode::G_AND*//*Label 5*/ GIMT_Encode4(15497),
     /*     50 */ /*TargetOpcode::G_OR*//*Label 6*/ GIMT_Encode4(18677),
     /*     54 */ /*TargetOpcode::G_XOR*//*Label 7*/ GIMT_Encode4(24486), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    114 */ /*TargetOpcode::G_CONCAT_VECTORS*//*Label 8*/ GIMT_Encode4(26181), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    126 */ /*TargetOpcode::G_BITCAST*//*Label 9*/ GIMT_Encode4(26568), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    142 */ /*TargetOpcode::G_INTRINSIC_TRUNC*//*Label 10*/ GIMT_Encode4(35580),
     /*    146 */ /*TargetOpcode::G_INTRINSIC_ROUND*//*Label 11*/ GIMT_Encode4(35988), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    158 */ /*TargetOpcode::G_INTRINSIC_ROUNDEVEN*//*Label 12*/ GIMT_Encode4(36363), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    174 */ /*TargetOpcode::G_SEXTLOAD*//*Label 13*/ GIMT_Encode4(36738), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    294 */ /*TargetOpcode::G_FENCE*//*Label 14*/ GIMT_Encode4(36901), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    314 */ /*TargetOpcode::G_INTRINSIC*//*Label 15*/ GIMT_Encode4(36922),
     /*    318 */ /*TargetOpcode::G_INTRINSIC_W_SIDE_EFFECTS*//*Label 16*/ GIMT_Encode4(90990), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    330 */ /*TargetOpcode::G_ANYEXT*//*Label 17*/ GIMT_Encode4(98652),
     /*    334 */ /*TargetOpcode::G_TRUNC*//*Label 18*/ GIMT_Encode4(98810),
     /*    338 */ /*TargetOpcode::G_CONSTANT*//*Label 19*/ GIMT_Encode4(98968),
     /*    342 */ /*TargetOpcode::G_FCONSTANT*//*Label 20*/ GIMT_Encode4(99289), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    354 */ /*TargetOpcode::G_SEXT*//*Label 21*/ GIMT_Encode4(99385),
     /*    358 */ /*TargetOpcode::G_SEXT_INREG*//*Label 22*/ GIMT_Encode4(99543),
     /*    362 */ /*TargetOpcode::G_ZEXT*//*Label 23*/ GIMT_Encode4(100148),
     /*    366 */ /*TargetOpcode::G_SHL*//*Label 24*/ GIMT_Encode4(100306),
     /*    370 */ /*TargetOpcode::G_LSHR*//*Label 25*/ GIMT_Encode4(100522),
     /*    374 */ /*TargetOpcode::G_ASHR*//*Label 26*/ GIMT_Encode4(100630), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    386 */ /*TargetOpcode::G_ROTR*//*Label 27*/ GIMT_Encode4(100903), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    454 */ /*TargetOpcode::G_UMULH*//*Label 28*/ GIMT_Encode4(101235),
     /*    458 */ /*TargetOpcode::G_SMULH*//*Label 29*/ GIMT_Encode4(101483),
     /*    462 */ /*TargetOpcode::G_UADDSAT*//*Label 30*/ GIMT_Encode4(101852),
     /*    466 */ /*TargetOpcode::G_SADDSAT*//*Label 31*/ GIMT_Encode4(102497),
     /*    470 */ /*TargetOpcode::G_USUBSAT*//*Label 32*/ GIMT_Encode4(103797),
     /*    474 */ /*TargetOpcode::G_SSUBSAT*//*Label 33*/ GIMT_Encode4(104442), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    518 */ /*TargetOpcode::G_FADD*//*Label 34*/ GIMT_Encode4(105462),
     /*    522 */ /*TargetOpcode::G_FSUB*//*Label 35*/ GIMT_Encode4(107815),
     /*    526 */ /*TargetOpcode::G_FMUL*//*Label 36*/ GIMT_Encode4(109492),
     /*    530 */ /*TargetOpcode::G_FMA*//*Label 37*/ GIMT_Encode4(110473), GIMT_Encode4(0),
     /*    538 */ /*TargetOpcode::G_FDIV*//*Label 38*/ GIMT_Encode4(112564), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    586 */ /*TargetOpcode::G_FNEG*//*Label 39*/ GIMT_Encode4(112729),
     /*    590 */ /*TargetOpcode::G_FPEXT*//*Label 40*/ GIMT_Encode4(114260),
     /*    594 */ /*TargetOpcode::G_FPTRUNC*//*Label 41*/ GIMT_Encode4(114496),
     /*    598 */ /*TargetOpcode::G_FPTOSI*//*Label 42*/ GIMT_Encode4(114768),
     /*    602 */ /*TargetOpcode::G_FPTOUI*//*Label 43*/ GIMT_Encode4(116102),
     /*    606 */ /*TargetOpcode::G_SITOFP*//*Label 44*/ GIMT_Encode4(117436),
     /*    610 */ /*TargetOpcode::G_UITOFP*//*Label 45*/ GIMT_Encode4(118088), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    622 */ /*TargetOpcode::G_FABS*//*Label 46*/ GIMT_Encode4(118740), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    638 */ /*TargetOpcode::G_FMINNUM*//*Label 47*/ GIMT_Encode4(119516),
     /*    642 */ /*TargetOpcode::G_FMAXNUM*//*Label 48*/ GIMT_Encode4(120108), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    654 */ /*TargetOpcode::G_FMINIMUM*//*Label 49*/ GIMT_Encode4(120700),
     /*    658 */ /*TargetOpcode::G_FMAXIMUM*//*Label 50*/ GIMT_Encode4(121434), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    670 */ /*TargetOpcode::G_GET_FPENV*//*Label 51*/ GIMT_Encode4(122168),
     /*    674 */ /*TargetOpcode::G_SET_FPENV*//*Label 52*/ GIMT_Encode4(122201),
     /*    678 */ /*TargetOpcode::G_RESET_FPENV*//*Label 53*/ GIMT_Encode4(122237),
     /*    682 */ /*TargetOpcode::G_GET_FPMODE*//*Label 54*/ GIMT_Encode4(122366), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    702 */ /*TargetOpcode::G_SMIN*//*Label 55*/ GIMT_Encode4(122399),
     /*    706 */ /*TargetOpcode::G_SMAX*//*Label 56*/ GIMT_Encode4(122942),
     /*    710 */ /*TargetOpcode::G_UMIN*//*Label 57*/ GIMT_Encode4(123485),
     /*    714 */ /*TargetOpcode::G_UMAX*//*Label 58*/ GIMT_Encode4(124406),
     /*    718 */ /*TargetOpcode::G_ABS*//*Label 59*/ GIMT_Encode4(125327), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    730 */ /*TargetOpcode::G_BR*//*Label 60*/ GIMT_Encode4(125798), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    750 */ /*TargetOpcode::G_INSERT_VECTOR_ELT*//*Label 61*/ GIMT_Encode4(125871),
     /*    754 */ /*TargetOpcode::G_EXTRACT_VECTOR_ELT*//*Label 62*/ GIMT_Encode4(126171), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    782 */ /*TargetOpcode::G_CTLZ*//*Label 63*/ GIMT_Encode4(126228), GIMT_Encode4(0),
     /*    790 */ /*TargetOpcode::G_CTPOP*//*Label 64*/ GIMT_Encode4(126789),
     /*    794 */ /*TargetOpcode::G_BSWAP*//*Label 65*/ GIMT_Encode4(126897),
     /*    798 */ /*TargetOpcode::G_BITREVERSE*//*Label 66*/ GIMT_Encode4(127187),
     /*    802 */ /*TargetOpcode::G_FCEIL*//*Label 67*/ GIMT_Encode4(127619), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    850 */ /*TargetOpcode::G_FSQRT*//*Label 68*/ GIMT_Encode4(127994),
     /*    854 */ /*TargetOpcode::G_FFLOOR*//*Label 69*/ GIMT_Encode4(128132),
     /*    858 */ /*TargetOpcode::G_FRINT*//*Label 70*/ GIMT_Encode4(128507),
     /*    862 */ /*TargetOpcode::G_FNEARBYINT*//*Label 71*/ GIMT_Encode4(128915), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    950 */ /*TargetOpcode::G_TRAP*//*Label 72*/ GIMT_Encode4(129053),
     /*    954 */ /*TargetOpcode::G_DEBUGTRAP*//*Label 73*/ GIMT_Encode4(129099), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    994 */ /*TargetOpcode::G_VECREDUCE_ADD*//*Label 74*/ GIMT_Encode4(129186), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*   1014 */ /*TargetOpcode::G_VECREDUCE_SMAX*//*Label 75*/ GIMT_Encode4(129607),
     /*   1018 */ /*TargetOpcode::G_VECREDUCE_SMIN*//*Label 76*/ GIMT_Encode4(129887),
     /*   1022 */ /*TargetOpcode::G_VECREDUCE_UMAX*//*Label 77*/ GIMT_Encode4(130176),
     /*   1026 */ /*TargetOpcode::G_VECREDUCE_UMIN*//*Label 78*/ GIMT_Encode4(130457),
     /*   1030 */ // Label 0: @1030
     /*   1030 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(16), /*)*//*default:*//*Label 89*/ GIMT_Encode4(10356),
     /*   1041 */ /*GILLT_s32*//*Label 80*/ GIMT_Encode4(1101),
     /*   1045 */ /*GILLT_s64*//*Label 81*/ GIMT_Encode4(6877), GIMT_Encode4(0),
     /*   1053 */ /*GILLT_v2s32*//*Label 82*/ GIMT_Encode4(6924),
     /*   1057 */ /*GILLT_v2s64*//*Label 83*/ GIMT_Encode4(7109), GIMT_Encode4(0),
     /*   1065 */ /*GILLT_v4s16*//*Label 84*/ GIMT_Encode4(7820),
     /*   1069 */ /*GILLT_v4s32*//*Label 85*/ GIMT_Encode4(8005), GIMT_Encode4(0), GIMT_Encode4(0),
     /*   1081 */ /*GILLT_v8s8*//*Label 86*/ GIMT_Encode4(8961),
     /*   1085 */ /*GILLT_v8s16*//*Label 87*/ GIMT_Encode4(9146), GIMT_Encode4(0), GIMT_Encode4(0),
     /*   1097 */ /*GILLT_v16s8*//*Label 88*/ GIMT_Encode4(10102),
     /*   1101 */ // Label 80: @1101
     /*   1101 */ GIM_Try, /*On fail goto*//*Label 90*/ GIMT_Encode4(6876),
     /*   1106 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*   1109 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*   1112 */   GIM_Try, /*On fail goto*//*Label 91*/ GIMT_Encode4(1187), // Rule ID 5667 //
     /*   1117 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*   1120 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   1124 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   1128 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*   1132 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   1136 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*   1140 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*   1145 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(255),
     /*   1156 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*   1160 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   1162 */     // (add:{ *:[i32] } (and:{ *:[i32] } GPR:{ *:[i32] }:$Rm, 255:{ *:[i32] }), GPR:{ *:[i32] }:$Rn)  =>  (UXTAB:{ *:[i32] } GPR:{ *:[i32] }:$Rn, GPR:{ *:[i32] }:$Rm, 0:{ *:[i32] })
     /*   1162 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::UXTAB),
     /*   1165 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   1167 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*   1169 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*   1173 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   1176 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   1179 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   1185 */     GIR_RootConstrainSelectedInstOperands,
     /*   1186 */     // GIR_Coverage, 5667,
     /*   1186 */     GIR_EraseRootFromParent_Done,
     /*   1187 */   // Label 91: @1187
     /*   1187 */   GIM_Try, /*On fail goto*//*Label 92*/ GIMT_Encode4(1262), // Rule ID 5668 //
     /*   1192 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*   1195 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   1199 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   1203 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*   1207 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   1211 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*   1215 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*   1220 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(65535),
     /*   1231 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*   1235 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   1237 */     // (add:{ *:[i32] } (and:{ *:[i32] } GPR:{ *:[i32] }:$Rm, 65535:{ *:[i32] }), GPR:{ *:[i32] }:$Rn)  =>  (UXTAH:{ *:[i32] } GPR:{ *:[i32] }:$Rn, GPR:{ *:[i32] }:$Rm, 0:{ *:[i32] })
     /*   1237 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::UXTAH),
     /*   1240 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   1242 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*   1244 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*   1248 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   1251 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   1254 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   1260 */     GIR_RootConstrainSelectedInstOperands,
     /*   1261 */     // GIR_Coverage, 5668,
     /*   1261 */     GIR_EraseRootFromParent_Done,
     /*   1262 */   // Label 92: @1262
     /*   1262 */   GIM_Try, /*On fail goto*//*Label 93*/ GIMT_Encode4(1337), // Rule ID 5702 //
     /*   1267 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*   1270 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   1274 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   1278 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*   1282 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   1286 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*   1290 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   1295 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(255),
     /*   1306 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   1310 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   1312 */     // (add:{ *:[i32] } (and:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, 255:{ *:[i32] }), rGPR:{ *:[i32] }:$Rn)  =>  (t2UXTAB:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm, 0:{ *:[i32] })
     /*   1312 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2UXTAB),
     /*   1315 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   1317 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*   1319 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*   1323 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   1326 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   1329 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   1335 */     GIR_RootConstrainSelectedInstOperands,
     /*   1336 */     // GIR_Coverage, 5702,
     /*   1336 */     GIR_EraseRootFromParent_Done,
     /*   1337 */   // Label 93: @1337
     /*   1337 */   GIM_Try, /*On fail goto*//*Label 94*/ GIMT_Encode4(1412), // Rule ID 5703 //
     /*   1342 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*   1345 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   1349 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   1353 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*   1357 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   1361 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*   1365 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   1370 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(65535),
     /*   1381 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   1385 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   1387 */     // (add:{ *:[i32] } (and:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, 65535:{ *:[i32] }), rGPR:{ *:[i32] }:$Rn)  =>  (t2UXTAH:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm, 0:{ *:[i32] })
     /*   1387 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2UXTAH),
     /*   1390 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   1392 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*   1394 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*   1398 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   1401 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   1404 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   1410 */     GIR_RootConstrainSelectedInstOperands,
     /*   1411 */     // GIR_Coverage, 5703,
     /*   1411 */     GIR_EraseRootFromParent_Done,
     /*   1412 */   // Label 94: @1412
     /*   1412 */   GIM_Try, /*On fail goto*//*Label 95*/ GIMT_Encode4(1487), // Rule ID 1997 //
     /*   1417 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*   1420 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   1424 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*   1428 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   1432 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*   1436 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   1440 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*   1444 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*   1449 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(255),
     /*   1460 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   1462 */     // (add:{ *:[i32] } GPR:{ *:[i32] }:$Rn, (and:{ *:[i32] } GPR:{ *:[i32] }:$Rm, 255:{ *:[i32] }))  =>  (UXTAB:{ *:[i32] } GPR:{ *:[i32] }:$Rn, GPR:{ *:[i32] }:$Rm, 0:{ *:[i32] })
     /*   1462 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::UXTAB),
     /*   1465 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   1467 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*   1469 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*   1473 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   1476 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   1479 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   1485 */     GIR_RootConstrainSelectedInstOperands,
     /*   1486 */     // GIR_Coverage, 1997,
     /*   1486 */     GIR_EraseRootFromParent_Done,
     /*   1487 */   // Label 95: @1487
     /*   1487 */   GIM_Try, /*On fail goto*//*Label 96*/ GIMT_Encode4(1562), // Rule ID 1998 //
     /*   1492 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*   1495 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   1499 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*   1503 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   1507 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*   1511 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   1515 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*   1519 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*   1524 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(65535),
     /*   1535 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   1537 */     // (add:{ *:[i32] } GPR:{ *:[i32] }:$Rn, (and:{ *:[i32] } GPR:{ *:[i32] }:$Rm, 65535:{ *:[i32] }))  =>  (UXTAH:{ *:[i32] } GPR:{ *:[i32] }:$Rn, GPR:{ *:[i32] }:$Rm, 0:{ *:[i32] })
     /*   1537 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::UXTAH),
     /*   1540 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   1542 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*   1544 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*   1548 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   1551 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   1554 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   1560 */     GIR_RootConstrainSelectedInstOperands,
     /*   1561 */     // GIR_Coverage, 1998,
     /*   1561 */     GIR_EraseRootFromParent_Done,
     /*   1562 */   // Label 96: @1562
     /*   1562 */   GIM_Try, /*On fail goto*//*Label 97*/ GIMT_Encode4(1637), // Rule ID 2236 //
     /*   1567 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*   1570 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   1574 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   1578 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   1582 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*   1586 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   1590 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*   1594 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   1599 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(255),
     /*   1610 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   1612 */     // (add:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, (and:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, 255:{ *:[i32] }))  =>  (t2UXTAB:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm, 0:{ *:[i32] })
     /*   1612 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2UXTAB),
     /*   1615 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   1617 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*   1619 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*   1623 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   1626 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   1629 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   1635 */     GIR_RootConstrainSelectedInstOperands,
     /*   1636 */     // GIR_Coverage, 2236,
     /*   1636 */     GIR_EraseRootFromParent_Done,
     /*   1637 */   // Label 97: @1637
     /*   1637 */   GIM_Try, /*On fail goto*//*Label 98*/ GIMT_Encode4(1712), // Rule ID 2237 //
     /*   1642 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*   1645 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   1649 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   1653 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   1657 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*   1661 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   1665 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*   1669 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   1674 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(65535),
     /*   1685 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   1687 */     // (add:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, (and:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, 65535:{ *:[i32] }))  =>  (t2UXTAH:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm, 0:{ *:[i32] })
     /*   1687 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2UXTAH),
     /*   1690 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   1692 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*   1694 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*   1698 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   1701 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   1704 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   1710 */     GIR_RootConstrainSelectedInstOperands,
     /*   1711 */     // GIR_Coverage, 2237,
     /*   1711 */     GIR_EraseRootFromParent_Done,
     /*   1712 */   // Label 98: @1712
     /*   1712 */   GIM_Try, /*On fail goto*//*Label 99*/ GIMT_Encode4(1840), // Rule ID 5678 //
     /*   1717 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*   1720 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   1724 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   1728 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*   1732 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   1736 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   1740 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*   1744 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   1748 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*   1752 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*   1756 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*   1760 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*   1764 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*   1768 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   1773 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 24,
     /*   1777 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/2, /*OpIdx*/2, // MIs[4]
     /*   1781 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_SHL),
     /*   1785 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s32,
     /*   1789 */     // MIs[4] Rm
     /*   1789 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*   1794 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 8,
     /*   1798 */     // MIs[1] Operand 2
     /*   1798 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(16),
     /*   1809 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   1813 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*   1815 */     // (add:{ *:[i32] } (sext_inreg:{ *:[i32] } (or:{ *:[i32] } (srl:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, 24:{ *:[i32] }), (shl:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, 8:{ *:[i32] })), i16:{ *:[Other] }), rGPR:{ *:[i32] }:$Rn)  =>  (t2SXTAH:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm, 3:{ *:[i32] })
     /*   1815 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SXTAH),
     /*   1818 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   1820 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*   1822 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*   1826 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   1829 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   1832 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   1838 */     GIR_RootConstrainSelectedInstOperands,
     /*   1839 */     // GIR_Coverage, 5678,
     /*   1839 */     GIR_EraseRootFromParent_Done,
     /*   1840 */   // Label 99: @1840
     /*   1840 */   GIM_Try, /*On fail goto*//*Label 100*/ GIMT_Encode4(1968), // Rule ID 5679 //
     /*   1845 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*   1848 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   1852 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   1856 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*   1860 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   1864 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   1868 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*   1872 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   1876 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*   1880 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*   1884 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SHL),
     /*   1888 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*   1892 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*   1896 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   1901 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 8,
     /*   1905 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/2, /*OpIdx*/2, // MIs[4]
     /*   1909 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*   1913 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s32,
     /*   1917 */     // MIs[4] Rm
     /*   1917 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*   1922 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 24,
     /*   1926 */     // MIs[1] Operand 2
     /*   1926 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(16),
     /*   1937 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   1941 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*   1943 */     // (add:{ *:[i32] } (sext_inreg:{ *:[i32] } (or:{ *:[i32] } (shl:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, 8:{ *:[i32] }), (srl:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, 24:{ *:[i32] })), i16:{ *:[Other] }), rGPR:{ *:[i32] }:$Rn)  =>  (t2SXTAH:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm, 3:{ *:[i32] })
     /*   1943 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SXTAH),
     /*   1946 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   1948 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*   1950 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*   1954 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   1957 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   1960 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   1966 */     GIR_RootConstrainSelectedInstOperands,
     /*   1967 */     // GIR_Coverage, 5679,
     /*   1967 */     GIR_EraseRootFromParent_Done,
     /*   1968 */   // Label 100: @1968
     /*   1968 */   GIM_Try, /*On fail goto*//*Label 101*/ GIMT_Encode4(2096), // Rule ID 2103 //
     /*   1973 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*   1976 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   1980 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   1984 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   1988 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*   1992 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   1996 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   2000 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*   2004 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   2008 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*   2012 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*   2016 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*   2020 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*   2024 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*   2028 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   2033 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 24,
     /*   2037 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/2, /*OpIdx*/2, // MIs[4]
     /*   2041 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_SHL),
     /*   2045 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s32,
     /*   2049 */     // MIs[4] Rm
     /*   2049 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*   2054 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 8,
     /*   2058 */     // MIs[1] Operand 2
     /*   2058 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(16),
     /*   2069 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*   2071 */     // (add:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, (sext_inreg:{ *:[i32] } (or:{ *:[i32] } (srl:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, 24:{ *:[i32] }), (shl:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, 8:{ *:[i32] })), i16:{ *:[Other] }))  =>  (t2SXTAH:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm, 3:{ *:[i32] })
     /*   2071 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SXTAH),
     /*   2074 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   2076 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*   2078 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*   2082 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   2085 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   2088 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   2094 */     GIR_RootConstrainSelectedInstOperands,
     /*   2095 */     // GIR_Coverage, 2103,
     /*   2095 */     GIR_EraseRootFromParent_Done,
     /*   2096 */   // Label 101: @2096
     /*   2096 */   GIM_Try, /*On fail goto*//*Label 102*/ GIMT_Encode4(2224), // Rule ID 5677 //
     /*   2101 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*   2104 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   2108 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   2112 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   2116 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*   2120 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   2124 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   2128 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*   2132 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   2136 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*   2140 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*   2144 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SHL),
     /*   2148 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*   2152 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*   2156 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   2161 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 8,
     /*   2165 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/2, /*OpIdx*/2, // MIs[4]
     /*   2169 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*   2173 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s32,
     /*   2177 */     // MIs[4] Rm
     /*   2177 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*   2182 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 24,
     /*   2186 */     // MIs[1] Operand 2
     /*   2186 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(16),
     /*   2197 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*   2199 */     // (add:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, (sext_inreg:{ *:[i32] } (or:{ *:[i32] } (shl:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, 8:{ *:[i32] }), (srl:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, 24:{ *:[i32] })), i16:{ *:[Other] }))  =>  (t2SXTAH:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm, 3:{ *:[i32] })
     /*   2199 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SXTAH),
     /*   2202 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   2204 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*   2206 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*   2210 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   2213 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   2216 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   2222 */     GIR_RootConstrainSelectedInstOperands,
     /*   2223 */     // GIR_Coverage, 5677,
     /*   2223 */     GIR_EraseRootFromParent_Done,
     /*   2224 */   // Label 102: @2224
     /*   2224 */   GIM_Try, /*On fail goto*//*Label 103*/ GIMT_Encode4(2334), // Rule ID 5446 //
     /*   2229 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV5TE_IsARM_UseMulOps),
     /*   2232 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   2236 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   2240 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   2244 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   2248 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*   2252 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   2256 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*   2260 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   2264 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*   2268 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   2273 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 16,
     /*   2277 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   2281 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*   2285 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*   2289 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*   2293 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   2298 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 16,
     /*   2302 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*   2306 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   2308 */     // (add:{ *:[i32] } (mul:{ *:[i32] } (sra:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, 16:{ *:[i32] }), (sra:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rm, 16:{ *:[i32] })), GPR:{ *:[i32] }:$Ra)  =>  (SMLATT:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm, GPR:{ *:[i32] }:$Ra)
     /*   2308 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SMLATT),
     /*   2311 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   2313 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*   2317 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*   2321 */     GIR_RootToRootCopy, /*OpIdx*/2, // Ra
     /*   2323 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   2326 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   2332 */     GIR_RootConstrainSelectedInstOperands,
     /*   2333 */     // GIR_Coverage, 5446,
     /*   2333 */     GIR_EraseRootFromParent_Done,
     /*   2334 */   // Label 103: @2334
     /*   2334 */   GIM_Try, /*On fail goto*//*Label 104*/ GIMT_Encode4(2444), // Rule ID 5483 //
     /*   2339 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2_UseMulOps),
     /*   2342 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   2346 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   2350 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   2354 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   2358 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*   2362 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   2366 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*   2370 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   2374 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*   2378 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   2383 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 16,
     /*   2387 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   2391 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*   2395 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*   2399 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*   2403 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   2408 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 16,
     /*   2412 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   2416 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   2418 */     // (add:{ *:[i32] } (mul:{ *:[i32] } (sra:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, 16:{ *:[i32] }), (sra:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, 16:{ *:[i32] })), rGPR:{ *:[i32] }:$Ra)  =>  (t2SMLATT:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm, rGPR:{ *:[i32] }:$Ra)
     /*   2418 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SMLATT),
     /*   2421 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   2423 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*   2427 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*   2431 */     GIR_RootToRootCopy, /*OpIdx*/2, // Ra
     /*   2433 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   2436 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   2442 */     GIR_RootConstrainSelectedInstOperands,
     /*   2443 */     // GIR_Coverage, 5483,
     /*   2443 */     GIR_EraseRootFromParent_Done,
     /*   2444 */   // Label 104: @2444
     /*   2444 */   GIM_Try, /*On fail goto*//*Label 105*/ GIMT_Encode4(2554), // Rule ID 192 //
     /*   2449 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV5TE_IsARM_UseMulOps),
     /*   2452 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   2456 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*   2460 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   2464 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   2468 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   2472 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*   2476 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   2480 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*   2484 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   2488 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*   2492 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   2497 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 16,
     /*   2501 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   2505 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*   2509 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*   2513 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*   2517 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   2522 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 16,
     /*   2526 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   2528 */     // (add:{ *:[i32] } GPR:{ *:[i32] }:$Ra, (mul:{ *:[i32] } (sra:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, 16:{ *:[i32] }), (sra:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rm, 16:{ *:[i32] })))  =>  (SMLATT:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm, GPR:{ *:[i32] }:$Ra)
     /*   2528 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SMLATT),
     /*   2531 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   2533 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*   2537 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*   2541 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ra
     /*   2543 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   2546 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   2552 */     GIR_RootConstrainSelectedInstOperands,
     /*   2553 */     // GIR_Coverage, 192,
     /*   2553 */     GIR_EraseRootFromParent_Done,
     /*   2554 */   // Label 105: @2554
     /*   2554 */   GIM_Try, /*On fail goto*//*Label 106*/ GIMT_Encode4(2664), // Rule ID 521 //
     /*   2559 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2_UseMulOps),
     /*   2562 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   2566 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   2570 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   2574 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   2578 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   2582 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*   2586 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   2590 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*   2594 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   2598 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*   2602 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   2607 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 16,
     /*   2611 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   2615 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*   2619 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*   2623 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*   2627 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   2632 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 16,
     /*   2636 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   2638 */     // (add:{ *:[i32] } rGPR:{ *:[i32] }:$Ra, (mul:{ *:[i32] } (sra:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, 16:{ *:[i32] }), (sra:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, 16:{ *:[i32] })))  =>  (t2SMLATT:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm, rGPR:{ *:[i32] }:$Ra)
     /*   2638 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SMLATT),
     /*   2641 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   2643 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*   2647 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*   2651 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ra
     /*   2653 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   2656 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   2662 */     GIR_RootConstrainSelectedInstOperands,
     /*   2663 */     // GIR_Coverage, 521,
     /*   2663 */     GIR_EraseRootFromParent_Done,
     /*   2664 */   // Label 106: @2664
     /*   2664 */   GIM_Try, /*On fail goto*//*Label 107*/ GIMT_Encode4(2777), // Rule ID 5445 //
     /*   2669 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV5TE_IsARM_UseMulOps),
     /*   2672 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   2676 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   2680 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   2684 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   2688 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*   2692 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   2696 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*   2700 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   2704 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*   2708 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   2713 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 16,
     /*   2717 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   2721 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*   2725 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*   2729 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   2734 */     // MIs[3] Operand 2
     /*   2734 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(16),
     /*   2745 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*   2749 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   2751 */     // (add:{ *:[i32] } (mul:{ *:[i32] } (sra:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rm, 16:{ *:[i32] }), (sext_inreg:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, i16:{ *:[Other] })), GPR:{ *:[i32] }:$Ra)  =>  (SMLABT:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm, GPR:{ *:[i32] }:$Ra)
     /*   2751 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SMLABT),
     /*   2754 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   2756 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /*   2760 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*   2764 */     GIR_RootToRootCopy, /*OpIdx*/2, // Ra
     /*   2766 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   2769 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   2775 */     GIR_RootConstrainSelectedInstOperands,
     /*   2776 */     // GIR_Coverage, 5445,
     /*   2776 */     GIR_EraseRootFromParent_Done,
     /*   2777 */   // Label 107: @2777
     /*   2777 */   GIM_Try, /*On fail goto*//*Label 108*/ GIMT_Encode4(2890), // Rule ID 5482 //
     /*   2782 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2_UseMulOps),
     /*   2785 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   2789 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   2793 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   2797 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   2801 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*   2805 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   2809 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*   2813 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   2817 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*   2821 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   2826 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 16,
     /*   2830 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   2834 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*   2838 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*   2842 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   2847 */     // MIs[3] Operand 2
     /*   2847 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(16),
     /*   2858 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   2862 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   2864 */     // (add:{ *:[i32] } (mul:{ *:[i32] } (sra:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, 16:{ *:[i32] }), (sext_inreg:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, i16:{ *:[Other] })), rGPR:{ *:[i32] }:$Ra)  =>  (t2SMLABT:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm, rGPR:{ *:[i32] }:$Ra)
     /*   2864 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SMLABT),
     /*   2867 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   2869 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /*   2873 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*   2877 */     GIR_RootToRootCopy, /*OpIdx*/2, // Ra
     /*   2879 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   2882 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   2888 */     GIR_RootConstrainSelectedInstOperands,
     /*   2889 */     // GIR_Coverage, 5482,
     /*   2889 */     GIR_EraseRootFromParent_Done,
     /*   2890 */   // Label 108: @2890
     /*   2890 */   GIM_Try, /*On fail goto*//*Label 109*/ GIMT_Encode4(3003), // Rule ID 5444 //
     /*   2895 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV5TE_IsARM_UseMulOps),
     /*   2898 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   2902 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   2906 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   2910 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   2914 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*   2918 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   2922 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*   2926 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   2930 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   2935 */     // MIs[2] Operand 2
     /*   2935 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(16),
     /*   2946 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   2950 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*   2954 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*   2958 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*   2962 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   2967 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 16,
     /*   2971 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*   2975 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   2977 */     // (add:{ *:[i32] } (mul:{ *:[i32] } (sext_inreg:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, i16:{ *:[Other] }), (sra:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rm, 16:{ *:[i32] })), GPR:{ *:[i32] }:$Ra)  =>  (SMLABT:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm, GPR:{ *:[i32] }:$Ra)
     /*   2977 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SMLABT),
     /*   2980 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   2982 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*   2986 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*   2990 */     GIR_RootToRootCopy, /*OpIdx*/2, // Ra
     /*   2992 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   2995 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   3001 */     GIR_RootConstrainSelectedInstOperands,
     /*   3002 */     // GIR_Coverage, 5444,
     /*   3002 */     GIR_EraseRootFromParent_Done,
     /*   3003 */   // Label 109: @3003
     /*   3003 */   GIM_Try, /*On fail goto*//*Label 110*/ GIMT_Encode4(3116), // Rule ID 5481 //
     /*   3008 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2_UseMulOps),
     /*   3011 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   3015 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   3019 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   3023 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   3027 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*   3031 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   3035 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*   3039 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   3043 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   3048 */     // MIs[2] Operand 2
     /*   3048 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(16),
     /*   3059 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   3063 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*   3067 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*   3071 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*   3075 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   3080 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 16,
     /*   3084 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   3088 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   3090 */     // (add:{ *:[i32] } (mul:{ *:[i32] } (sext_inreg:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, i16:{ *:[Other] }), (sra:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, 16:{ *:[i32] })), rGPR:{ *:[i32] }:$Ra)  =>  (t2SMLABT:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm, rGPR:{ *:[i32] }:$Ra)
     /*   3090 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SMLABT),
     /*   3093 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   3095 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*   3099 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*   3103 */     GIR_RootToRootCopy, /*OpIdx*/2, // Ra
     /*   3105 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   3108 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   3114 */     GIR_RootConstrainSelectedInstOperands,
     /*   3115 */     // GIR_Coverage, 5481,
     /*   3115 */     GIR_EraseRootFromParent_Done,
     /*   3116 */   // Label 110: @3116
     /*   3116 */   GIM_Try, /*On fail goto*//*Label 111*/ GIMT_Encode4(3229), // Rule ID 191 //
     /*   3121 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV5TE_IsARM_UseMulOps),
     /*   3124 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   3128 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*   3132 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   3136 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   3140 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   3144 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*   3148 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   3152 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*   3156 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   3160 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*   3164 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   3169 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 16,
     /*   3173 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   3177 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*   3181 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*   3185 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   3190 */     // MIs[3] Operand 2
     /*   3190 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(16),
     /*   3201 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   3203 */     // (add:{ *:[i32] } GPR:{ *:[i32] }:$Ra, (mul:{ *:[i32] } (sra:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, 16:{ *:[i32] }), (sext_inreg:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rm, i16:{ *:[Other] })))  =>  (SMLATB:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm, GPR:{ *:[i32] }:$Ra)
     /*   3203 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SMLATB),
     /*   3206 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   3208 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*   3212 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*   3216 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ra
     /*   3218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   3221 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   3227 */     GIR_RootConstrainSelectedInstOperands,
     /*   3228 */     // GIR_Coverage, 191,
     /*   3228 */     GIR_EraseRootFromParent_Done,
     /*   3229 */   // Label 111: @3229
     /*   3229 */   GIM_Try, /*On fail goto*//*Label 112*/ GIMT_Encode4(3342), // Rule ID 520 //
     /*   3234 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2_UseMulOps),
     /*   3237 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   3241 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   3245 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   3249 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   3253 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   3257 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*   3261 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   3265 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*   3269 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   3273 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*   3277 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   3282 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 16,
     /*   3286 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   3290 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*   3294 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*   3298 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   3303 */     // MIs[3] Operand 2
     /*   3303 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(16),
     /*   3314 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   3316 */     // (add:{ *:[i32] } rGPR:{ *:[i32] }:$Ra, (mul:{ *:[i32] } (sra:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, 16:{ *:[i32] }), (sext_inreg:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, i16:{ *:[Other] })))  =>  (t2SMLATB:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm, rGPR:{ *:[i32] }:$Ra)
     /*   3316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SMLATB),
     /*   3319 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   3321 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*   3325 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*   3329 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ra
     /*   3331 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   3334 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   3340 */     GIR_RootConstrainSelectedInstOperands,
     /*   3341 */     // GIR_Coverage, 520,
     /*   3341 */     GIR_EraseRootFromParent_Done,
     /*   3342 */   // Label 112: @3342
     /*   3342 */   GIM_Try, /*On fail goto*//*Label 113*/ GIMT_Encode4(3455), // Rule ID 190 //
     /*   3347 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV5TE_IsARM_UseMulOps),
     /*   3350 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   3354 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*   3358 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   3362 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   3366 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   3370 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*   3374 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   3378 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*   3382 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   3386 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   3391 */     // MIs[2] Operand 2
     /*   3391 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(16),
     /*   3402 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   3406 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*   3410 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*   3414 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*   3418 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   3423 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 16,
     /*   3427 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   3429 */     // (add:{ *:[i32] } GPR:{ *:[i32] }:$Ra, (mul:{ *:[i32] } (sext_inreg:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, i16:{ *:[Other] }), (sra:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rm, 16:{ *:[i32] })))  =>  (SMLABT:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm, GPR:{ *:[i32] }:$Ra)
     /*   3429 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SMLABT),
     /*   3432 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   3434 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*   3438 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*   3442 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ra
     /*   3444 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   3447 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   3453 */     GIR_RootConstrainSelectedInstOperands,
     /*   3454 */     // GIR_Coverage, 190,
     /*   3454 */     GIR_EraseRootFromParent_Done,
     /*   3455 */   // Label 113: @3455
     /*   3455 */   GIM_Try, /*On fail goto*//*Label 114*/ GIMT_Encode4(3568), // Rule ID 519 //
     /*   3460 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2_UseMulOps),
     /*   3463 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   3467 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   3471 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   3475 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   3479 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   3483 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*   3487 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   3491 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*   3495 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   3499 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   3504 */     // MIs[2] Operand 2
     /*   3504 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(16),
     /*   3515 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   3519 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*   3523 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*   3527 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*   3531 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   3536 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 16,
     /*   3540 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   3542 */     // (add:{ *:[i32] } rGPR:{ *:[i32] }:$Ra, (mul:{ *:[i32] } (sext_inreg:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, i16:{ *:[Other] }), (sra:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, 16:{ *:[i32] })))  =>  (t2SMLABT:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm, rGPR:{ *:[i32] }:$Ra)
     /*   3542 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SMLABT),
     /*   3545 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   3547 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*   3551 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*   3555 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ra
     /*   3557 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   3560 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   3566 */     GIR_RootConstrainSelectedInstOperands,
     /*   3567 */     // GIR_Coverage, 519,
     /*   3567 */     GIR_EraseRootFromParent_Done,
     /*   3568 */   // Label 114: @3568
     /*   3568 */   GIM_Try, /*On fail goto*//*Label 115*/ GIMT_Encode4(3659), // Rule ID 5676 //
     /*   3573 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*   3576 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   3580 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   3584 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*   3588 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   3592 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   3596 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ROTR),
     /*   3600 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   3604 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*   3608 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   3613 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 24,
     /*   3617 */     // MIs[1] Operand 2
     /*   3617 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(16),
     /*   3628 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   3632 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   3634 */     // (add:{ *:[i32] } (sext_inreg:{ *:[i32] } (rotr:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, 24:{ *:[i32] }), i16:{ *:[Other] }), rGPR:{ *:[i32] }:$Rn)  =>  (t2SXTAH:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm, 3:{ *:[i32] })
     /*   3634 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SXTAH),
     /*   3637 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   3639 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*   3641 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*   3645 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   3648 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   3651 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   3657 */     GIR_RootConstrainSelectedInstOperands,
     /*   3658 */     // GIR_Coverage, 5676,
     /*   3658 */     GIR_EraseRootFromParent_Done,
     /*   3659 */   // Label 115: @3659
     /*   3659 */   GIM_Try, /*On fail goto*//*Label 116*/ GIMT_Encode4(3750), // Rule ID 2102 //
     /*   3664 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*   3667 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   3671 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   3675 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   3679 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*   3683 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   3687 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   3691 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ROTR),
     /*   3695 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   3699 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*   3703 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   3708 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 24,
     /*   3712 */     // MIs[1] Operand 2
     /*   3712 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(16),
     /*   3723 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   3725 */     // (add:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, (sext_inreg:{ *:[i32] } (rotr:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, 24:{ *:[i32] }), i16:{ *:[Other] }))  =>  (t2SXTAH:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm, 3:{ *:[i32] })
     /*   3725 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SXTAH),
     /*   3728 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   3730 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*   3732 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*   3736 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   3739 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   3742 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   3748 */     GIR_RootConstrainSelectedInstOperands,
     /*   3749 */     // GIR_Coverage, 2102,
     /*   3749 */     GIR_EraseRootFromParent_Done,
     /*   3750 */   // Label 116: @3750
     /*   3750 */   GIM_Try, /*On fail goto*//*Label 117*/ GIMT_Encode4(3866), // Rule ID 5443 //
     /*   3755 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV5TE_IsARM_UseMulOps),
     /*   3758 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   3762 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   3766 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   3770 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   3774 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*   3778 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   3782 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*   3786 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   3790 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   3795 */     // MIs[2] Operand 2
     /*   3795 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(16),
     /*   3806 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   3810 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*   3814 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*   3818 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   3823 */     // MIs[3] Operand 2
     /*   3823 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(16),
     /*   3834 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*   3838 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   3840 */     // (add:{ *:[i32] } (mul:{ *:[i32] } (sext_inreg:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, i16:{ *:[Other] }), (sext_inreg:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rm, i16:{ *:[Other] })), GPR:{ *:[i32] }:$Ra)  =>  (SMLABB:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm, GPR:{ *:[i32] }:$Ra)
     /*   3840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SMLABB),
     /*   3843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   3845 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*   3849 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*   3853 */     GIR_RootToRootCopy, /*OpIdx*/2, // Ra
     /*   3855 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   3858 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   3864 */     GIR_RootConstrainSelectedInstOperands,
     /*   3865 */     // GIR_Coverage, 5443,
     /*   3865 */     GIR_EraseRootFromParent_Done,
     /*   3866 */   // Label 117: @3866
     /*   3866 */   GIM_Try, /*On fail goto*//*Label 118*/ GIMT_Encode4(3982), // Rule ID 5480 //
     /*   3871 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2_UseMulOps),
     /*   3874 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   3878 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   3882 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   3886 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   3890 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*   3894 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   3898 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*   3902 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   3906 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   3911 */     // MIs[2] Operand 2
     /*   3911 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(16),
     /*   3922 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   3926 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*   3930 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*   3934 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   3939 */     // MIs[3] Operand 2
     /*   3939 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(16),
     /*   3950 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   3954 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   3956 */     // (add:{ *:[i32] } (mul:{ *:[i32] } (sext_inreg:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, i16:{ *:[Other] }), (sext_inreg:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, i16:{ *:[Other] })), rGPR:{ *:[i32] }:$Ra)  =>  (t2SMLABB:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm, rGPR:{ *:[i32] }:$Ra)
     /*   3956 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SMLABB),
     /*   3959 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   3961 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*   3965 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*   3969 */     GIR_RootToRootCopy, /*OpIdx*/2, // Ra
     /*   3971 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   3974 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   3980 */     GIR_RootConstrainSelectedInstOperands,
     /*   3981 */     // GIR_Coverage, 5480,
     /*   3981 */     GIR_EraseRootFromParent_Done,
     /*   3982 */   // Label 118: @3982
     /*   3982 */   GIM_Try, /*On fail goto*//*Label 119*/ GIMT_Encode4(4098), // Rule ID 189 //
     /*   3987 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV5TE_IsARM_UseMulOps),
     /*   3990 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   3994 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*   3998 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   4002 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   4006 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   4010 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*   4014 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   4018 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*   4022 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   4026 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   4031 */     // MIs[2] Operand 2
     /*   4031 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(16),
     /*   4042 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   4046 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*   4050 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*   4054 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   4059 */     // MIs[3] Operand 2
     /*   4059 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(16),
     /*   4070 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   4072 */     // (add:{ *:[i32] } GPR:{ *:[i32] }:$Ra, (mul:{ *:[i32] } (sext_inreg:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, i16:{ *:[Other] }), (sext_inreg:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rm, i16:{ *:[Other] })))  =>  (SMLABB:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm, GPR:{ *:[i32] }:$Ra)
     /*   4072 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SMLABB),
     /*   4075 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   4077 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*   4081 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*   4085 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ra
     /*   4087 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   4090 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   4096 */     GIR_RootConstrainSelectedInstOperands,
     /*   4097 */     // GIR_Coverage, 189,
     /*   4097 */     GIR_EraseRootFromParent_Done,
     /*   4098 */   // Label 119: @4098
     /*   4098 */   GIM_Try, /*On fail goto*//*Label 120*/ GIMT_Encode4(4214), // Rule ID 518 //
     /*   4103 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2_UseMulOps),
     /*   4106 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   4110 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   4114 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   4118 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   4122 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   4126 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*   4130 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   4134 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*   4138 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   4142 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   4147 */     // MIs[2] Operand 2
     /*   4147 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(16),
     /*   4158 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   4162 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*   4166 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*   4170 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   4175 */     // MIs[3] Operand 2
     /*   4175 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(16),
     /*   4186 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   4188 */     // (add:{ *:[i32] } rGPR:{ *:[i32] }:$Ra, (mul:{ *:[i32] } (sext_inreg:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, i16:{ *:[Other] }), (sext_inreg:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, i16:{ *:[Other] })))  =>  (t2SMLABB:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm, rGPR:{ *:[i32] }:$Ra)
     /*   4188 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SMLABB),
     /*   4191 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   4193 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*   4197 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*   4201 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ra
     /*   4203 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   4206 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   4212 */     GIR_RootConstrainSelectedInstOperands,
     /*   4213 */     // GIR_Coverage, 518,
     /*   4213 */     GIR_EraseRootFromParent_Done,
     /*   4214 */   // Label 120: @4214
     /*   4214 */   GIM_Try, /*On fail goto*//*Label 121*/ GIMT_Encode4(4302), // Rule ID 3245 //
     /*   4219 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*   4222 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*   4226 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   4230 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_VECREDUCE_ADD),
     /*   4234 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   4238 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   4242 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   4246 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   4250 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   4254 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*   4259 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*   4264 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*   4268 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   4270 */     // (add:{ *:[i32] } (vecreduce_add:{ *:[i32] } (mul:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$src1, MQPR:{ *:[v4i32] }:$src2)), tGPREven:{ *:[i32] }:$src3)  =>  (MVE_VMLADAVau32:{ *:[i32] } ?:{ *:[i32] }:$src3, ?:{ *:[v4i32] }:$src1, ?:{ *:[v4i32] }:$src2)
     /*   4270 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMLADAVau32),
     /*   4273 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*   4275 */     GIR_RootToRootCopy, /*OpIdx*/2, // src3
     /*   4277 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src1
     /*   4281 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src2
     /*   4285 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   4288 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   4294 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   4300 */     GIR_RootConstrainSelectedInstOperands,
     /*   4301 */     // GIR_Coverage, 3245,
     /*   4301 */     GIR_EraseRootFromParent_Done,
     /*   4302 */   // Label 121: @4302
     /*   4302 */   GIM_Try, /*On fail goto*//*Label 122*/ GIMT_Encode4(4390), // Rule ID 3246 //
     /*   4307 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*   4310 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*   4314 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   4318 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_VECREDUCE_ADD),
     /*   4322 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*   4326 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   4330 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   4334 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*   4338 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s16,
     /*   4342 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*   4347 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*   4352 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*   4356 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   4358 */     // (add:{ *:[i32] } (vecreduce_add:{ *:[i32] } (mul:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$src1, MQPR:{ *:[v8i16] }:$src2)), tGPREven:{ *:[i32] }:$src3)  =>  (MVE_VMLADAVau16:{ *:[i32] } ?:{ *:[i32] }:$src3, ?:{ *:[v8i16] }:$src1, ?:{ *:[v8i16] }:$src2)
     /*   4358 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMLADAVau16),
     /*   4361 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*   4363 */     GIR_RootToRootCopy, /*OpIdx*/2, // src3
     /*   4365 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src1
     /*   4369 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src2
     /*   4373 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   4376 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   4382 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   4388 */     GIR_RootConstrainSelectedInstOperands,
     /*   4389 */     // GIR_Coverage, 3246,
     /*   4389 */     GIR_EraseRootFromParent_Done,
     /*   4390 */   // Label 122: @4390
     /*   4390 */   GIM_Try, /*On fail goto*//*Label 123*/ GIMT_Encode4(4478), // Rule ID 3249 //
     /*   4395 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*   4398 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*   4402 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   4406 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_VECREDUCE_ADD),
     /*   4410 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*   4414 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   4418 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   4422 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v16s8,
     /*   4426 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v16s8,
     /*   4430 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*   4435 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*   4440 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*   4444 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   4446 */     // (add:{ *:[i32] } (vecreduce_add:{ *:[i32] } (mul:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$src1, MQPR:{ *:[v16i8] }:$src2)), tGPREven:{ *:[i32] }:$src3)  =>  (MVE_VMLADAVau8:{ *:[i32] } ?:{ *:[i32] }:$src3, ?:{ *:[v16i8] }:$src1, ?:{ *:[v16i8] }:$src2)
     /*   4446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMLADAVau8),
     /*   4449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*   4451 */     GIR_RootToRootCopy, /*OpIdx*/2, // src3
     /*   4453 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src1
     /*   4457 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src2
     /*   4461 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   4464 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   4470 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   4476 */     GIR_RootConstrainSelectedInstOperands,
     /*   4477 */     // GIR_Coverage, 3249,
     /*   4477 */     GIR_EraseRootFromParent_Done,
     /*   4478 */   // Label 123: @4478
     /*   4478 */   GIM_Try, /*On fail goto*//*Label 124*/ GIMT_Encode4(4566), // Rule ID 5947 //
     /*   4483 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*   4486 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*   4490 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*   4494 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   4498 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_VECREDUCE_ADD),
     /*   4502 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   4506 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   4510 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   4514 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   4518 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   4522 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*   4527 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*   4532 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   4534 */     // (add:{ *:[i32] } tGPREven:{ *:[i32] }:$src3, (vecreduce_add:{ *:[i32] } (mul:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$src1, MQPR:{ *:[v4i32] }:$src2)))  =>  (MVE_VMLADAVau32:{ *:[i32] } ?:{ *:[i32] }:$src3, ?:{ *:[v4i32] }:$src1, ?:{ *:[v4i32] }:$src2)
     /*   4534 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMLADAVau32),
     /*   4537 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*   4539 */     GIR_RootToRootCopy, /*OpIdx*/1, // src3
     /*   4541 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src1
     /*   4545 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src2
     /*   4549 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   4552 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   4558 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   4564 */     GIR_RootConstrainSelectedInstOperands,
     /*   4565 */     // GIR_Coverage, 5947,
     /*   4565 */     GIR_EraseRootFromParent_Done,
     /*   4566 */   // Label 124: @4566
     /*   4566 */   GIM_Try, /*On fail goto*//*Label 125*/ GIMT_Encode4(4654), // Rule ID 5948 //
     /*   4571 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*   4574 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*   4578 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*   4582 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   4586 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_VECREDUCE_ADD),
     /*   4590 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*   4594 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   4598 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   4602 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*   4606 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s16,
     /*   4610 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*   4615 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*   4620 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   4622 */     // (add:{ *:[i32] } tGPREven:{ *:[i32] }:$src3, (vecreduce_add:{ *:[i32] } (mul:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$src1, MQPR:{ *:[v8i16] }:$src2)))  =>  (MVE_VMLADAVau16:{ *:[i32] } ?:{ *:[i32] }:$src3, ?:{ *:[v8i16] }:$src1, ?:{ *:[v8i16] }:$src2)
     /*   4622 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMLADAVau16),
     /*   4625 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*   4627 */     GIR_RootToRootCopy, /*OpIdx*/1, // src3
     /*   4629 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src1
     /*   4633 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src2
     /*   4637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   4640 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   4646 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   4652 */     GIR_RootConstrainSelectedInstOperands,
     /*   4653 */     // GIR_Coverage, 5948,
     /*   4653 */     GIR_EraseRootFromParent_Done,
     /*   4654 */   // Label 125: @4654
     /*   4654 */   GIM_Try, /*On fail goto*//*Label 126*/ GIMT_Encode4(4742), // Rule ID 5951 //
     /*   4659 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*   4662 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*   4666 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*   4670 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   4674 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_VECREDUCE_ADD),
     /*   4678 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*   4682 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   4686 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   4690 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v16s8,
     /*   4694 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v16s8,
     /*   4698 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*   4703 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*   4708 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   4710 */     // (add:{ *:[i32] } tGPREven:{ *:[i32] }:$src3, (vecreduce_add:{ *:[i32] } (mul:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$src1, MQPR:{ *:[v16i8] }:$src2)))  =>  (MVE_VMLADAVau8:{ *:[i32] } ?:{ *:[i32] }:$src3, ?:{ *:[v16i8] }:$src1, ?:{ *:[v16i8] }:$src2)
     /*   4710 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMLADAVau8),
     /*   4713 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*   4715 */     GIR_RootToRootCopy, /*OpIdx*/1, // src3
     /*   4717 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src1
     /*   4721 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src2
     /*   4725 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   4728 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   4734 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   4740 */     GIR_RootConstrainSelectedInstOperands,
     /*   4741 */     // GIR_Coverage, 5951,
     /*   4741 */     GIR_EraseRootFromParent_Done,
     /*   4742 */   // Label 126: @4742
     /*   4742 */   GIM_Try, /*On fail goto*//*Label 127*/ GIMT_Encode4(4799), // Rule ID 72 //
     /*   4747 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*   4750 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*   4754 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*   4758 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   4762 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*   4766 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_mod_imm),
     /*   4770 */     // MIs[1] Operand 1
     /*   4770 */     // No operand predicates
     /*   4770 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   4772 */     // (add:{ *:[i32] } GPR:{ *:[i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_mod_imm>>:$imm)  =>  (ADDri:{ *:[i32] } GPR:{ *:[i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*   4772 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::ADDri),
     /*   4775 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   4777 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*   4779 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*   4782 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   4785 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   4791 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   4797 */     GIR_RootConstrainSelectedInstOperands,
     /*   4798 */     // GIR_Coverage, 72,
     /*   4798 */     GIR_EraseRootFromParent_Done,
     /*   4799 */   // Label 127: @4799
     /*   4799 */   GIM_Try, /*On fail goto*//*Label 128*/ GIMT_Encode4(4856), // Rule ID 303 //
     /*   4804 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb_IsThumb1Only),
     /*   4807 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /*   4811 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /*   4815 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   4819 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*   4823 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_7),
     /*   4827 */     // MIs[1] Operand 1
     /*   4827 */     // No operand predicates
     /*   4827 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   4829 */     // (add:{ *:[i32] } tGPR:{ *:[i32] }:$Rm, (imm:{ *:[i32] })<<P:Predicate_imm0_7>>:$imm3)  =>  (tADDi3:{ *:[i32] } tGPR:{ *:[i32] }:$Rm, (imm:{ *:[i32] }):$imm3)
     /*   4829 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::tADDi3),
     /*   4832 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   4834 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::CPSR), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define | RegState::Dead),
     /*   4840 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /*   4842 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm3
     /*   4845 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   4848 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   4854 */     GIR_RootConstrainSelectedInstOperands,
     /*   4855 */     // GIR_Coverage, 303,
     /*   4855 */     GIR_EraseRootFromParent_Done,
     /*   4856 */   // Label 128: @4856
     /*   4856 */   GIM_Try, /*On fail goto*//*Label 129*/ GIMT_Encode4(4913), // Rule ID 304 //
     /*   4861 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb_IsThumb1Only),
     /*   4864 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /*   4868 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /*   4872 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   4876 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*   4880 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_255_expr),
     /*   4884 */     // MIs[1] Operand 1
     /*   4884 */     // No operand predicates
     /*   4884 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   4886 */     // (add:{ *:[i32] } tGPR:{ *:[i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_imm0_255_expr>>:$imm8)  =>  (tADDi8:{ *:[i32] } tGPR:{ *:[i32] }:$Rn, (imm:{ *:[i32] }):$imm8)
     /*   4886 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::tADDi8),
     /*   4889 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /*   4891 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::CPSR), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define | RegState::Dead),
     /*   4897 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*   4899 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm8
     /*   4902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   4905 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   4911 */     GIR_RootConstrainSelectedInstOperands,
     /*   4912 */     // GIR_Coverage, 304,
     /*   4912 */     GIR_EraseRootFromParent_Done,
     /*   4913 */   // Label 129: @4913
     /*   4913 */   GIM_Try, /*On fail goto*//*Label 130*/ GIMT_Encode4(4970), // Rule ID 407 //
     /*   4918 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /*   4921 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   4925 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   4929 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   4933 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*   4937 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_t2_so_imm),
     /*   4941 */     // MIs[1] Operand 1
     /*   4941 */     // No operand predicates
     /*   4941 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   4943 */     // (add:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_t2_so_imm>>:$imm)  =>  (t2ADDri:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*   4943 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2ADDri),
     /*   4946 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   4948 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*   4950 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*   4953 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   4956 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   4962 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   4968 */     GIR_RootConstrainSelectedInstOperands,
     /*   4969 */     // GIR_Coverage, 407,
     /*   4969 */     GIR_EraseRootFromParent_Done,
     /*   4970 */   // Label 130: @4970
     /*   4970 */   GIM_Try, /*On fail goto*//*Label 131*/ GIMT_Encode4(5021), // Rule ID 408 //
     /*   4975 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /*   4978 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   4982 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*   4986 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   4990 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*   4994 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_4095),
     /*   4998 */     // MIs[1] Operand 1
     /*   4998 */     // No operand predicates
     /*   4998 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   5000 */     // (add:{ *:[i32] } GPR:{ *:[i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_imm0_4095>>:$imm)  =>  (t2ADDri12:{ *:[i32] } GPR:{ *:[i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*   5000 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2ADDri12),
     /*   5003 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   5005 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*   5007 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*   5010 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   5013 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   5019 */     GIR_RootConstrainSelectedInstOperands,
     /*   5020 */     // GIR_Coverage, 408,
     /*   5020 */     GIR_EraseRootFromParent_Done,
     /*   5021 */   // Label 131: @5021
     /*   5021 */   GIM_Try, /*On fail goto*//*Label 132*/ GIMT_Encode4(5097), // Rule ID 171 //
     /*   5026 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM_UseMulOps),
     /*   5029 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   5033 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   5037 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   5041 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   5045 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*   5049 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   5054 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   5059 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   5063 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   5065 */     // (add:{ *:[i32] } (mul:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm), GPRnopc:{ *:[i32] }:$Ra)  =>  (MLA:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm, GPRnopc:{ *:[i32] }:$Ra)
     /*   5065 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MLA),
     /*   5068 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   5070 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*   5074 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*   5078 */     GIR_RootToRootCopy, /*OpIdx*/2, // Ra
     /*   5080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   5083 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   5089 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   5095 */     GIR_RootConstrainSelectedInstOperands,
     /*   5096 */     // GIR_Coverage, 171,
     /*   5096 */     GIR_EraseRootFromParent_Done,
     /*   5097 */   // Label 132: @5097
     /*   5097 */   GIM_Try, /*On fail goto*//*Label 133*/ GIMT_Encode4(5173), // Rule ID 172 //
     /*   5102 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM_NoV6),
     /*   5105 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   5109 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   5113 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   5117 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   5121 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*   5125 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   5130 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   5135 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   5139 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   5141 */     // (add:{ *:[i32] } (mul:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm), GPRnopc:{ *:[i32] }:$Ra)  =>  (MLAv5:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm, GPRnopc:{ *:[i32] }:$Ra)
     /*   5141 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MLAv5),
     /*   5144 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   5146 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*   5150 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*   5154 */     GIR_RootToRootCopy, /*OpIdx*/2, // Ra
     /*   5156 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   5159 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   5165 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   5171 */     GIR_RootConstrainSelectedInstOperands,
     /*   5172 */     // GIR_Coverage, 172,
     /*   5172 */     GIR_EraseRootFromParent_Done,
     /*   5173 */   // Label 133: @5173
     /*   5173 */   GIM_Try, /*On fail goto*//*Label 134*/ GIMT_Encode4(5243), // Rule ID 503 //
     /*   5178 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2_UseMulOps),
     /*   5181 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   5185 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   5189 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   5193 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   5197 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*   5201 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   5206 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   5211 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   5215 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   5217 */     // (add:{ *:[i32] } (mul:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm), rGPR:{ *:[i32] }:$Ra)  =>  (t2MLA:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm, rGPR:{ *:[i32] }:$Ra)
     /*   5217 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2MLA),
     /*   5220 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   5222 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*   5226 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*   5230 */     GIR_RootToRootCopy, /*OpIdx*/2, // Ra
     /*   5232 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   5235 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   5241 */     GIR_RootConstrainSelectedInstOperands,
     /*   5242 */     // GIR_Coverage, 503,
     /*   5242 */     GIR_EraseRootFromParent_Done,
     /*   5243 */   // Label 134: @5243
     /*   5243 */   GIM_Try, /*On fail goto*//*Label 135*/ GIMT_Encode4(5314), // Rule ID 5669 //
     /*   5248 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*   5251 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   5255 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   5259 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*   5263 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   5267 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   5272 */     // MIs[1] Operand 2
     /*   5272 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(8),
     /*   5283 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*   5287 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   5289 */     // (add:{ *:[i32] } (sext_inreg:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rm, i8:{ *:[Other] }), GPR:{ *:[i32] }:$Rn)  =>  (SXTAB:{ *:[i32] } GPR:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm, 0:{ *:[i32] })
     /*   5289 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SXTAB),
     /*   5292 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   5294 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*   5296 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*   5300 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   5303 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   5306 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   5312 */     GIR_RootConstrainSelectedInstOperands,
     /*   5313 */     // GIR_Coverage, 5669,
     /*   5313 */     GIR_EraseRootFromParent_Done,
     /*   5314 */   // Label 135: @5314
     /*   5314 */   GIM_Try, /*On fail goto*//*Label 136*/ GIMT_Encode4(5385), // Rule ID 5670 //
     /*   5319 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*   5322 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   5326 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   5330 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*   5334 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   5338 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   5343 */     // MIs[1] Operand 2
     /*   5343 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(16),
     /*   5354 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*   5358 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   5360 */     // (add:{ *:[i32] } (sext_inreg:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rm, i16:{ *:[Other] }), GPR:{ *:[i32] }:$Rn)  =>  (SXTAH:{ *:[i32] } GPR:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm, 0:{ *:[i32] })
     /*   5360 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SXTAH),
     /*   5363 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   5365 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*   5367 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*   5371 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   5374 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   5377 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   5383 */     GIR_RootConstrainSelectedInstOperands,
     /*   5384 */     // GIR_Coverage, 5670,
     /*   5384 */     GIR_EraseRootFromParent_Done,
     /*   5385 */   // Label 136: @5385
     /*   5385 */   GIM_Try, /*On fail goto*//*Label 137*/ GIMT_Encode4(5456), // Rule ID 5704 //
     /*   5390 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*   5393 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   5397 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   5401 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*   5405 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   5409 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   5414 */     // MIs[1] Operand 2
     /*   5414 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(8),
     /*   5425 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   5429 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   5431 */     // (add:{ *:[i32] } (sext_inreg:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, i8:{ *:[Other] }), rGPR:{ *:[i32] }:$Rn)  =>  (t2SXTAB:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm, 0:{ *:[i32] })
     /*   5431 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SXTAB),
     /*   5434 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   5436 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*   5438 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*   5442 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   5445 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   5448 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   5454 */     GIR_RootConstrainSelectedInstOperands,
     /*   5455 */     // GIR_Coverage, 5704,
     /*   5455 */     GIR_EraseRootFromParent_Done,
     /*   5456 */   // Label 137: @5456
     /*   5456 */   GIM_Try, /*On fail goto*//*Label 138*/ GIMT_Encode4(5527), // Rule ID 5705 //
     /*   5461 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*   5464 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   5468 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   5472 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*   5476 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   5480 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   5485 */     // MIs[1] Operand 2
     /*   5485 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(16),
     /*   5496 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   5500 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   5502 */     // (add:{ *:[i32] } (sext_inreg:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, i16:{ *:[Other] }), rGPR:{ *:[i32] }:$Rn)  =>  (t2SXTAH:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm, 0:{ *:[i32] })
     /*   5502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SXTAH),
     /*   5505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   5507 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*   5509 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*   5513 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   5516 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   5519 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   5525 */     GIR_RootConstrainSelectedInstOperands,
     /*   5526 */     // GIR_Coverage, 5705,
     /*   5526 */     GIR_EraseRootFromParent_Done,
     /*   5527 */   // Label 138: @5527
     /*   5527 */   GIM_Try, /*On fail goto*//*Label 139*/ GIMT_Encode4(5597), // Rule ID 180 //
     /*   5532 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM_UseMulOps),
     /*   5535 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*   5539 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   5543 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SMULH),
     /*   5547 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   5551 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*   5555 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*   5560 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*   5565 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*   5569 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   5571 */     // (add:{ *:[i32] } (mulhs:{ *:[i32] } GPR:{ *:[i32] }:$Rn, GPR:{ *:[i32] }:$Rm), GPR:{ *:[i32] }:$Ra)  =>  (SMMLA:{ *:[i32] } GPR:{ *:[i32] }:$Rn, GPR:{ *:[i32] }:$Rm, GPR:{ *:[i32] }:$Ra)
     /*   5571 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SMMLA),
     /*   5574 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   5576 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*   5580 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*   5584 */     GIR_RootToRootCopy, /*OpIdx*/2, // Ra
     /*   5586 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   5589 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   5595 */     GIR_RootConstrainSelectedInstOperands,
     /*   5596 */     // GIR_Coverage, 180,
     /*   5596 */     GIR_EraseRootFromParent_Done,
     /*   5597 */   // Label 139: @5597
     /*   5597 */   GIM_Try, /*On fail goto*//*Label 140*/ GIMT_Encode4(5667), // Rule ID 509 //
     /*   5602 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2_UseMulOps),
     /*   5605 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   5609 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   5613 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SMULH),
     /*   5617 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   5621 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*   5625 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   5630 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   5635 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   5639 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   5641 */     // (add:{ *:[i32] } (mulhs:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, rGPR:{ *:[i32] }:$Rn), rGPR:{ *:[i32] }:$Ra)  =>  (t2SMMLA:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm, rGPR:{ *:[i32] }:$Ra)
     /*   5641 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SMMLA),
     /*   5644 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   5646 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*   5650 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*   5654 */     GIR_RootToRootCopy, /*OpIdx*/2, // Ra
     /*   5656 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   5659 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   5665 */     GIR_RootConstrainSelectedInstOperands,
     /*   5666 */     // GIR_Coverage, 509,
     /*   5666 */     GIR_EraseRootFromParent_Done,
     /*   5667 */   // Label 140: @5667
     /*   5667 */   GIM_Try, /*On fail goto*//*Label 141*/ GIMT_Encode4(5730), // Rule ID 3050 //
     /*   5672 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*   5675 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*   5679 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   5683 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_VECREDUCE_ADD),
     /*   5687 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*   5691 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*   5696 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*   5700 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   5702 */     // (add:{ *:[i32] } (vecreduce_add:{ *:[i32] } MQPR:{ *:[v16i8] }:$vec), tGPREven:{ *:[i32] }:$acc)  =>  (MVE_VADDVu8acc:{ *:[i32] } ?:{ *:[i32] }:$acc, ?:{ *:[v16i8] }:$vec)
     /*   5702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VADDVu8acc),
     /*   5705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rda]
     /*   5707 */     GIR_RootToRootCopy, /*OpIdx*/2, // acc
     /*   5709 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vec
     /*   5713 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   5716 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   5722 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   5728 */     GIR_RootConstrainSelectedInstOperands,
     /*   5729 */     // GIR_Coverage, 3050,
     /*   5729 */     GIR_EraseRootFromParent_Done,
     /*   5730 */   // Label 141: @5730
     /*   5730 */   GIM_Try, /*On fail goto*//*Label 142*/ GIMT_Encode4(5793), // Rule ID 3078 //
     /*   5735 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*   5738 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*   5742 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   5746 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_VECREDUCE_ADD),
     /*   5750 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*   5754 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*   5759 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*   5763 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   5765 */     // (add:{ *:[i32] } (vecreduce_add:{ *:[i32] } MQPR:{ *:[v8i16] }:$vec), tGPREven:{ *:[i32] }:$acc)  =>  (MVE_VADDVu16acc:{ *:[i32] } ?:{ *:[i32] }:$acc, ?:{ *:[v8i16] }:$vec)
     /*   5765 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VADDVu16acc),
     /*   5768 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rda]
     /*   5770 */     GIR_RootToRootCopy, /*OpIdx*/2, // acc
     /*   5772 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vec
     /*   5776 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   5779 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   5785 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   5791 */     GIR_RootConstrainSelectedInstOperands,
     /*   5792 */     // GIR_Coverage, 3078,
     /*   5792 */     GIR_EraseRootFromParent_Done,
     /*   5793 */   // Label 142: @5793
     /*   5793 */   GIM_Try, /*On fail goto*//*Label 143*/ GIMT_Encode4(5856), // Rule ID 3088 //
     /*   5798 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*   5801 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*   5805 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   5809 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_VECREDUCE_ADD),
     /*   5813 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   5817 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*   5822 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*   5826 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   5828 */     // (add:{ *:[i32] } (vecreduce_add:{ *:[i32] } MQPR:{ *:[v4i32] }:$vec), tGPREven:{ *:[i32] }:$acc)  =>  (MVE_VADDVu32acc:{ *:[i32] } ?:{ *:[i32] }:$acc, ?:{ *:[v4i32] }:$vec)
     /*   5828 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VADDVu32acc),
     /*   5831 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rda]
     /*   5833 */     GIR_RootToRootCopy, /*OpIdx*/2, // acc
     /*   5835 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vec
     /*   5839 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   5842 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   5848 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   5854 */     GIR_RootConstrainSelectedInstOperands,
     /*   5855 */     // GIR_Coverage, 3088,
     /*   5855 */     GIR_EraseRootFromParent_Done,
     /*   5856 */   // Label 143: @5856
     /*   5856 */   GIM_Try, /*On fail goto*//*Label 144*/ GIMT_Encode4(5932), // Rule ID 5440 //
     /*   5861 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM_UseMulOps),
     /*   5864 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   5868 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   5872 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   5876 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   5880 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   5884 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*   5888 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   5893 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   5898 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   5900 */     // (add:{ *:[i32] } GPRnopc:{ *:[i32] }:$Ra, (mul:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm))  =>  (MLA:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm, GPRnopc:{ *:[i32] }:$Ra)
     /*   5900 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MLA),
     /*   5903 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   5905 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*   5909 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*   5913 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ra
     /*   5915 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   5918 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   5924 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   5930 */     GIR_RootConstrainSelectedInstOperands,
     /*   5931 */     // GIR_Coverage, 5440,
     /*   5931 */     GIR_EraseRootFromParent_Done,
     /*   5932 */   // Label 144: @5932
     /*   5932 */   GIM_Try, /*On fail goto*//*Label 145*/ GIMT_Encode4(6008), // Rule ID 5441 //
     /*   5937 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM_NoV6),
     /*   5940 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   5944 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   5948 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   5952 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   5956 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   5960 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*   5964 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   5969 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   5974 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   5976 */     // (add:{ *:[i32] } GPRnopc:{ *:[i32] }:$Ra, (mul:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm))  =>  (MLAv5:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm, GPRnopc:{ *:[i32] }:$Ra)
     /*   5976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MLAv5),
     /*   5979 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   5981 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*   5985 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*   5989 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ra
     /*   5991 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   5994 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   6000 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   6006 */     GIR_RootConstrainSelectedInstOperands,
     /*   6007 */     // GIR_Coverage, 5441,
     /*   6007 */     GIR_EraseRootFromParent_Done,
     /*   6008 */   // Label 145: @6008
     /*   6008 */   GIM_Try, /*On fail goto*//*Label 146*/ GIMT_Encode4(6078), // Rule ID 5478 //
     /*   6013 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2_UseMulOps),
     /*   6016 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   6020 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   6024 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   6028 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   6032 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   6036 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*   6040 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   6045 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   6050 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   6052 */     // (add:{ *:[i32] } rGPR:{ *:[i32] }:$Ra, (mul:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm))  =>  (t2MLA:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm, rGPR:{ *:[i32] }:$Ra)
     /*   6052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2MLA),
     /*   6055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   6057 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*   6061 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*   6065 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ra
     /*   6067 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   6070 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   6076 */     GIR_RootConstrainSelectedInstOperands,
     /*   6077 */     // GIR_Coverage, 5478,
     /*   6077 */     GIR_EraseRootFromParent_Done,
     /*   6078 */   // Label 146: @6078
     /*   6078 */   GIM_Try, /*On fail goto*//*Label 147*/ GIMT_Encode4(6149), // Rule ID 2001 //
     /*   6083 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*   6086 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   6090 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*   6094 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   6098 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*   6102 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   6106 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   6111 */     // MIs[1] Operand 2
     /*   6111 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(8),
     /*   6122 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   6124 */     // (add:{ *:[i32] } GPR:{ *:[i32] }:$Rn, (sext_inreg:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rm, i8:{ *:[Other] }))  =>  (SXTAB:{ *:[i32] } GPR:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm, 0:{ *:[i32] })
     /*   6124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SXTAB),
     /*   6127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   6129 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*   6131 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*   6135 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   6138 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   6141 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   6147 */     GIR_RootConstrainSelectedInstOperands,
     /*   6148 */     // GIR_Coverage, 2001,
     /*   6148 */     GIR_EraseRootFromParent_Done,
     /*   6149 */   // Label 147: @6149
     /*   6149 */   GIM_Try, /*On fail goto*//*Label 148*/ GIMT_Encode4(6220), // Rule ID 2002 //
     /*   6154 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*   6157 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   6161 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*   6165 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   6169 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*   6173 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   6177 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   6182 */     // MIs[1] Operand 2
     /*   6182 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(16),
     /*   6193 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   6195 */     // (add:{ *:[i32] } GPR:{ *:[i32] }:$Rn, (sext_inreg:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rm, i16:{ *:[Other] }))  =>  (SXTAH:{ *:[i32] } GPR:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm, 0:{ *:[i32] })
     /*   6195 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SXTAH),
     /*   6198 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   6200 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*   6202 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*   6206 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   6209 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   6212 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   6218 */     GIR_RootConstrainSelectedInstOperands,
     /*   6219 */     // GIR_Coverage, 2002,
     /*   6219 */     GIR_EraseRootFromParent_Done,
     /*   6220 */   // Label 148: @6220
     /*   6220 */   GIM_Try, /*On fail goto*//*Label 149*/ GIMT_Encode4(6291), // Rule ID 2240 //
     /*   6225 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*   6228 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   6232 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   6236 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   6240 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*   6244 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   6248 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   6253 */     // MIs[1] Operand 2
     /*   6253 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(8),
     /*   6264 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   6266 */     // (add:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, (sext_inreg:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, i8:{ *:[Other] }))  =>  (t2SXTAB:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm, 0:{ *:[i32] })
     /*   6266 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SXTAB),
     /*   6269 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   6271 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*   6273 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*   6277 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   6280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   6283 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   6289 */     GIR_RootConstrainSelectedInstOperands,
     /*   6290 */     // GIR_Coverage, 2240,
     /*   6290 */     GIR_EraseRootFromParent_Done,
     /*   6291 */   // Label 149: @6291
     /*   6291 */   GIM_Try, /*On fail goto*//*Label 150*/ GIMT_Encode4(6362), // Rule ID 2241 //
     /*   6296 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*   6299 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   6303 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   6307 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   6311 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*   6315 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   6319 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   6324 */     // MIs[1] Operand 2
     /*   6324 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(16),
     /*   6335 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   6337 */     // (add:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, (sext_inreg:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, i16:{ *:[Other] }))  =>  (t2SXTAH:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm, 0:{ *:[i32] })
     /*   6337 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SXTAH),
     /*   6340 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   6342 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*   6344 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*   6348 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   6351 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   6354 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   6360 */     GIR_RootConstrainSelectedInstOperands,
     /*   6361 */     // GIR_Coverage, 2241,
     /*   6361 */     GIR_EraseRootFromParent_Done,
     /*   6362 */   // Label 150: @6362
     /*   6362 */   GIM_Try, /*On fail goto*//*Label 151*/ GIMT_Encode4(6432), // Rule ID 5442 //
     /*   6367 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM_UseMulOps),
     /*   6370 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*   6374 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*   6378 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   6382 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SMULH),
     /*   6386 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   6390 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*   6394 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*   6399 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*   6404 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   6406 */     // (add:{ *:[i32] } GPR:{ *:[i32] }:$Ra, (mulhs:{ *:[i32] } GPR:{ *:[i32] }:$Rn, GPR:{ *:[i32] }:$Rm))  =>  (SMMLA:{ *:[i32] } GPR:{ *:[i32] }:$Rn, GPR:{ *:[i32] }:$Rm, GPR:{ *:[i32] }:$Ra)
     /*   6406 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SMMLA),
     /*   6409 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   6411 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*   6415 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*   6419 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ra
     /*   6421 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   6424 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   6430 */     GIR_RootConstrainSelectedInstOperands,
     /*   6431 */     // GIR_Coverage, 5442,
     /*   6431 */     GIR_EraseRootFromParent_Done,
     /*   6432 */   // Label 151: @6432
     /*   6432 */   GIM_Try, /*On fail goto*//*Label 152*/ GIMT_Encode4(6502), // Rule ID 5479 //
     /*   6437 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2_UseMulOps),
     /*   6440 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   6444 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   6448 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   6452 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SMULH),
     /*   6456 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   6460 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*   6464 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   6469 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   6474 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   6476 */     // (add:{ *:[i32] } rGPR:{ *:[i32] }:$Ra, (mulhs:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, rGPR:{ *:[i32] }:$Rn))  =>  (t2SMMLA:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm, rGPR:{ *:[i32] }:$Ra)
     /*   6476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SMMLA),
     /*   6479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   6481 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*   6485 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*   6489 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ra
     /*   6491 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   6494 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   6500 */     GIR_RootConstrainSelectedInstOperands,
     /*   6501 */     // GIR_Coverage, 5479,
     /*   6501 */     GIR_EraseRootFromParent_Done,
     /*   6502 */   // Label 152: @6502
     /*   6502 */   GIM_Try, /*On fail goto*//*Label 153*/ GIMT_Encode4(6565), // Rule ID 5923 //
     /*   6507 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*   6510 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*   6514 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*   6518 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   6522 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_VECREDUCE_ADD),
     /*   6526 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*   6530 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*   6535 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   6537 */     // (add:{ *:[i32] } tGPREven:{ *:[i32] }:$acc, (vecreduce_add:{ *:[i32] } MQPR:{ *:[v16i8] }:$vec))  =>  (MVE_VADDVu8acc:{ *:[i32] } ?:{ *:[i32] }:$acc, ?:{ *:[v16i8] }:$vec)
     /*   6537 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VADDVu8acc),
     /*   6540 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rda]
     /*   6542 */     GIR_RootToRootCopy, /*OpIdx*/1, // acc
     /*   6544 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vec
     /*   6548 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   6551 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   6557 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   6563 */     GIR_RootConstrainSelectedInstOperands,
     /*   6564 */     // GIR_Coverage, 5923,
     /*   6564 */     GIR_EraseRootFromParent_Done,
     /*   6565 */   // Label 153: @6565
     /*   6565 */   GIM_Try, /*On fail goto*//*Label 154*/ GIMT_Encode4(6628), // Rule ID 5937 //
     /*   6570 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*   6573 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*   6577 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*   6581 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   6585 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_VECREDUCE_ADD),
     /*   6589 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*   6593 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*   6598 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   6600 */     // (add:{ *:[i32] } tGPREven:{ *:[i32] }:$acc, (vecreduce_add:{ *:[i32] } MQPR:{ *:[v8i16] }:$vec))  =>  (MVE_VADDVu16acc:{ *:[i32] } ?:{ *:[i32] }:$acc, ?:{ *:[v8i16] }:$vec)
     /*   6600 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VADDVu16acc),
     /*   6603 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rda]
     /*   6605 */     GIR_RootToRootCopy, /*OpIdx*/1, // acc
     /*   6607 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vec
     /*   6611 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   6614 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   6620 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   6626 */     GIR_RootConstrainSelectedInstOperands,
     /*   6627 */     // GIR_Coverage, 5937,
     /*   6627 */     GIR_EraseRootFromParent_Done,
     /*   6628 */   // Label 154: @6628
     /*   6628 */   GIM_Try, /*On fail goto*//*Label 155*/ GIMT_Encode4(6691), // Rule ID 5942 //
     /*   6633 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*   6636 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*   6640 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*   6644 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   6648 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_VECREDUCE_ADD),
     /*   6652 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   6656 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*   6661 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   6663 */     // (add:{ *:[i32] } tGPREven:{ *:[i32] }:$acc, (vecreduce_add:{ *:[i32] } MQPR:{ *:[v4i32] }:$vec))  =>  (MVE_VADDVu32acc:{ *:[i32] } ?:{ *:[i32] }:$acc, ?:{ *:[v4i32] }:$vec)
     /*   6663 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VADDVu32acc),
     /*   6666 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rda]
     /*   6668 */     GIR_RootToRootCopy, /*OpIdx*/1, // acc
     /*   6670 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vec
     /*   6674 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   6677 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   6683 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   6689 */     GIR_RootConstrainSelectedInstOperands,
     /*   6690 */     // GIR_Coverage, 5942,
     /*   6690 */     GIR_EraseRootFromParent_Done,
     /*   6691 */   // Label 155: @6691
     /*   6691 */   GIM_Try, /*On fail goto*//*Label 156*/ GIMT_Encode4(6737), // Rule ID 73 //
     /*   6696 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*   6699 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*   6703 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*   6707 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*   6711 */     // (add:{ *:[i32] } GPR:{ *:[i32] }:$Rn, GPR:{ *:[i32] }:$Rm)  =>  (ADDrr:{ *:[i32] } GPR:{ *:[i32] }:$Rn, GPR:{ *:[i32] }:$Rm)
     /*   6711 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::ADDrr),
     /*   6714 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   6716 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*   6718 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /*   6720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   6723 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   6729 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   6735 */     GIR_RootConstrainSelectedInstOperands,
     /*   6736 */     // GIR_Coverage, 73,
     /*   6736 */     GIR_EraseRootFromParent_Done,
     /*   6737 */   // Label 156: @6737
     /*   6737 */   GIM_Try, /*On fail goto*//*Label 157*/ GIMT_Encode4(6783), // Rule ID 305 //
     /*   6742 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb_IsThumb1Only),
     /*   6745 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /*   6749 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /*   6753 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /*   6757 */     // (add:{ *:[i32] } tGPR:{ *:[i32] }:$Rn, tGPR:{ *:[i32] }:$Rm)  =>  (tADDrr:{ *:[i32] } tGPR:{ *:[i32] }:$Rn, tGPR:{ *:[i32] }:$Rm)
     /*   6757 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::tADDrr),
     /*   6760 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   6762 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::CPSR), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define | RegState::Dead),
     /*   6768 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*   6770 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /*   6772 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   6775 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   6781 */     GIR_RootConstrainSelectedInstOperands,
     /*   6782 */     // GIR_Coverage, 305,
     /*   6782 */     GIR_EraseRootFromParent_Done,
     /*   6783 */   // Label 157: @6783
     /*   6783 */   GIM_Try, /*On fail goto*//*Label 158*/ GIMT_Encode4(6829), // Rule ID 409 //
     /*   6788 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /*   6791 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   6795 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   6799 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   6803 */     // (add:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2ADDrr:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*   6803 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2ADDrr),
     /*   6806 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   6808 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*   6810 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /*   6812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   6815 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   6821 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   6827 */     GIR_RootConstrainSelectedInstOperands,
     /*   6828 */     // GIR_Coverage, 409,
     /*   6828 */     GIR_EraseRootFromParent_Done,
     /*   6829 */   // Label 158: @6829
     /*   6829 */   GIM_Try, /*On fail goto*//*Label 159*/ GIMT_Encode4(6875), // Rule ID 5460 //
     /*   6834 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /*   6837 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   6841 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   6845 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   6849 */     // (add:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, GPRnopc:{ *:[i32] }:$Rn)  =>  (t2ADDrr:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*   6849 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2ADDrr),
     /*   6852 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   6854 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*   6856 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /*   6858 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   6861 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   6867 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   6873 */     GIR_RootConstrainSelectedInstOperands,
     /*   6874 */     // GIR_Coverage, 5460,
     /*   6874 */     GIR_EraseRootFromParent_Done,
     /*   6875 */   // Label 159: @6875
     /*   6875 */   GIM_Reject,
     /*   6876 */ // Label 90: @6876
     /*   6876 */ GIM_Reject,
     /*   6877 */ // Label 81: @6877
     /*   6877 */ GIM_Try, /*On fail goto*//*Label 160*/ GIMT_Encode4(6923), // Rule ID 759 //
     /*   6882 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   6885 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*   6888 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*   6891 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   6895 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   6899 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   6903 */   // (add:{ *:[v1i64] } DPR:{ *:[v1i64] }:$Vn, DPR:{ *:[v1i64] }:$Vm)  =>  (VADDv1i64:{ *:[v1i64] } DPR:{ *:[v1i64] }:$Vn, DPR:{ *:[v1i64] }:$Vm)
     /*   6903 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDv1i64),
     /*   6906 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   6908 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*   6910 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*   6912 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   6915 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   6921 */   GIR_RootConstrainSelectedInstOperands,
     /*   6922 */   // GIR_Coverage, 759,
     /*   6922 */   GIR_EraseRootFromParent_Done,
     /*   6923 */ // Label 160: @6923
     /*   6923 */ GIM_Reject,
     /*   6924 */ // Label 82: @6924
     /*   6924 */ GIM_Try, /*On fail goto*//*Label 161*/ GIMT_Encode4(7108),
     /*   6929 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   6932 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*   6935 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   6939 */   GIM_Try, /*On fail goto*//*Label 162*/ GIMT_Encode4(7005), // Rule ID 5529 //
     /*   6944 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   6947 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   6951 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   6955 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   6959 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*   6963 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   6968 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   6973 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   6977 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   6979 */     // (add:{ *:[v2i32] } (mul:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm), DPR:{ *:[v2i32] }:$src1)  =>  (VMLAv2i32:{ *:[v2i32] } DPR:{ *:[v2i32] }:$src1, DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /*   6979 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMLAv2i32),
     /*   6982 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   6984 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*   6986 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*   6990 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /*   6994 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   6997 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   7003 */     GIR_RootConstrainSelectedInstOperands,
     /*   7004 */     // GIR_Coverage, 5529,
     /*   7004 */     GIR_EraseRootFromParent_Done,
     /*   7005 */   // Label 162: @7005
     /*   7005 */   GIM_Try, /*On fail goto*//*Label 163*/ GIMT_Encode4(7071), // Rule ID 886 //
     /*   7010 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   7013 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   7017 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   7021 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   7025 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   7029 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*   7033 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   7038 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   7043 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   7045 */     // (add:{ *:[v2i32] } DPR:{ *:[v2i32] }:$src1, (mul:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm))  =>  (VMLAv2i32:{ *:[v2i32] } DPR:{ *:[v2i32] }:$src1, DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /*   7045 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMLAv2i32),
     /*   7048 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   7050 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*   7052 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*   7056 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /*   7060 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   7063 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   7069 */     GIR_RootConstrainSelectedInstOperands,
     /*   7070 */     // GIR_Coverage, 886,
     /*   7070 */     GIR_EraseRootFromParent_Done,
     /*   7071 */   // Label 163: @7071
     /*   7071 */   GIM_Try, /*On fail goto*//*Label 164*/ GIMT_Encode4(7107), // Rule ID 755 //
     /*   7076 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   7079 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   7083 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   7087 */     // (add:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)  =>  (VADDv2i32:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /*   7087 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDv2i32),
     /*   7090 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   7092 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*   7094 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*   7096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   7099 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   7105 */     GIR_RootConstrainSelectedInstOperands,
     /*   7106 */     // GIR_Coverage, 755,
     /*   7106 */     GIR_EraseRootFromParent_Done,
     /*   7107 */   // Label 164: @7107
     /*   7107 */   GIM_Reject,
     /*   7108 */ // Label 161: @7108
     /*   7108 */ GIM_Reject,
     /*   7109 */ // Label 83: @7109
     /*   7109 */ GIM_Try, /*On fail goto*//*Label 165*/ GIMT_Encode4(7819),
     /*   7114 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*   7117 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*   7120 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   7124 */   GIM_Try, /*On fail goto*//*Label 166*/ GIMT_Encode4(7192), // Rule ID 779 //
     /*   7129 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   7132 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   7136 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   7140 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   7144 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   7149 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   7153 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   7157 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   7161 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   7166 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   7168 */     // (add:{ *:[v2i64] } (anyext:{ *:[v2i64] } DPR:{ *:[v2i32] }:$Vn), (anyext:{ *:[v2i64] } DPR:{ *:[v2i32] }:$Vm))  =>  (VADDLuv2i64:{ *:[v2i64] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /*   7168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDLuv2i64),
     /*   7171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   7173 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*   7177 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Vm
     /*   7181 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   7184 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   7190 */     GIR_RootConstrainSelectedInstOperands,
     /*   7191 */     // GIR_Coverage, 779,
     /*   7191 */     GIR_EraseRootFromParent_Done,
     /*   7192 */   // Label 166: @7192
     /*   7192 */   GIM_Try, /*On fail goto*//*Label 167*/ GIMT_Encode4(7260), // Rule ID 778 //
     /*   7197 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   7200 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   7204 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   7208 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   7212 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   7217 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   7221 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   7225 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   7229 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   7234 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   7236 */     // (add:{ *:[v2i64] } (anyext:{ *:[v2i64] } DPR:{ *:[v2i32] }:$Vn), (zext:{ *:[v2i64] } DPR:{ *:[v2i32] }:$Vm))  =>  (VADDLuv2i64:{ *:[v2i64] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /*   7236 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDLuv2i64),
     /*   7239 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   7241 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*   7245 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Vm
     /*   7249 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   7252 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   7258 */     GIR_RootConstrainSelectedInstOperands,
     /*   7259 */     // GIR_Coverage, 778,
     /*   7259 */     GIR_EraseRootFromParent_Done,
     /*   7260 */   // Label 167: @7260
     /*   7260 */   GIM_Try, /*On fail goto*//*Label 168*/ GIMT_Encode4(7328), // Rule ID 767 //
     /*   7265 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   7268 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   7272 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   7276 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   7280 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   7285 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   7289 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   7293 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   7297 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   7302 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   7304 */     // (add:{ *:[v2i64] } (sext:{ *:[v2i64] } DPR:{ *:[v2i32] }:$Vn), (sext:{ *:[v2i64] } DPR:{ *:[v2i32] }:$Vm))  =>  (VADDLsv2i64:{ *:[v2i64] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /*   7304 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDLsv2i64),
     /*   7307 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   7309 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*   7313 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Vm
     /*   7317 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   7320 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   7326 */     GIR_RootConstrainSelectedInstOperands,
     /*   7327 */     // GIR_Coverage, 767,
     /*   7327 */     GIR_EraseRootFromParent_Done,
     /*   7328 */   // Label 168: @7328
     /*   7328 */   GIM_Try, /*On fail goto*//*Label 169*/ GIMT_Encode4(7396), // Rule ID 777 //
     /*   7333 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   7336 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   7340 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   7344 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   7348 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   7353 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   7357 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   7361 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   7365 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   7370 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   7372 */     // (add:{ *:[v2i64] } (zext:{ *:[v2i64] } DPR:{ *:[v2i32] }:$Vn), (anyext:{ *:[v2i64] } DPR:{ *:[v2i32] }:$Vm))  =>  (VADDLuv2i64:{ *:[v2i64] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /*   7372 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDLuv2i64),
     /*   7375 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   7377 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*   7381 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Vm
     /*   7385 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   7388 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   7394 */     GIR_RootConstrainSelectedInstOperands,
     /*   7395 */     // GIR_Coverage, 777,
     /*   7395 */     GIR_EraseRootFromParent_Done,
     /*   7396 */   // Label 169: @7396
     /*   7396 */   GIM_Try, /*On fail goto*//*Label 170*/ GIMT_Encode4(7464), // Rule ID 776 //
     /*   7401 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   7404 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   7408 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   7412 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   7416 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   7421 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   7425 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   7429 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   7433 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   7438 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   7440 */     // (add:{ *:[v2i64] } (zext:{ *:[v2i64] } DPR:{ *:[v2i32] }:$Vn), (zext:{ *:[v2i64] } DPR:{ *:[v2i32] }:$Vm))  =>  (VADDLuv2i64:{ *:[v2i64] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /*   7440 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDLuv2i64),
     /*   7443 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   7445 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*   7449 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Vm
     /*   7453 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   7456 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   7462 */     GIR_RootConstrainSelectedInstOperands,
     /*   7463 */     // GIR_Coverage, 776,
     /*   7463 */     GIR_EraseRootFromParent_Done,
     /*   7464 */   // Label 170: @7464
     /*   7464 */   GIM_Try, /*On fail goto*//*Label 171*/ GIMT_Encode4(7517), // Rule ID 5508 //
     /*   7469 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   7472 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   7476 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   7480 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   7484 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   7489 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   7493 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   7495 */     // (add:{ *:[v2i64] } (anyext:{ *:[v2i64] } DPR:{ *:[v2i32] }:$Vm), QPR:{ *:[v2i64] }:$Vn)  =>  (VADDWuv2i64:{ *:[v2i64] } QPR:{ *:[v2i64] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /*   7495 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDWuv2i64),
     /*   7498 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   7500 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*   7502 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vm
     /*   7506 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   7509 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   7515 */     GIR_RootConstrainSelectedInstOperands,
     /*   7516 */     // GIR_Coverage, 5508,
     /*   7516 */     GIR_EraseRootFromParent_Done,
     /*   7517 */   // Label 171: @7517
     /*   7517 */   GIM_Try, /*On fail goto*//*Label 172*/ GIMT_Encode4(7570), // Rule ID 5502 //
     /*   7522 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   7525 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   7529 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   7533 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   7537 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   7542 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   7546 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   7548 */     // (add:{ *:[v2i64] } (sext:{ *:[v2i64] } DPR:{ *:[v2i32] }:$Vm), QPR:{ *:[v2i64] }:$Vn)  =>  (VADDWsv2i64:{ *:[v2i64] } QPR:{ *:[v2i64] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /*   7548 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDWsv2i64),
     /*   7551 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   7553 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*   7555 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vm
     /*   7559 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   7562 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   7568 */     GIR_RootConstrainSelectedInstOperands,
     /*   7569 */     // GIR_Coverage, 5502,
     /*   7569 */     GIR_EraseRootFromParent_Done,
     /*   7570 */   // Label 172: @7570
     /*   7570 */   GIM_Try, /*On fail goto*//*Label 173*/ GIMT_Encode4(7623), // Rule ID 5507 //
     /*   7575 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   7578 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   7582 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   7586 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   7590 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   7595 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   7599 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   7601 */     // (add:{ *:[v2i64] } (zext:{ *:[v2i64] } DPR:{ *:[v2i32] }:$Vm), QPR:{ *:[v2i64] }:$Vn)  =>  (VADDWuv2i64:{ *:[v2i64] } QPR:{ *:[v2i64] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /*   7601 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDWuv2i64),
     /*   7604 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   7606 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*   7608 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vm
     /*   7612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   7615 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   7621 */     GIR_RootConstrainSelectedInstOperands,
     /*   7622 */     // GIR_Coverage, 5507,
     /*   7622 */     GIR_EraseRootFromParent_Done,
     /*   7623 */   // Label 173: @7623
     /*   7623 */   GIM_Try, /*On fail goto*//*Label 174*/ GIMT_Encode4(7676), // Rule ID 788 //
     /*   7628 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   7631 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   7635 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   7639 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   7643 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   7647 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   7652 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   7654 */     // (add:{ *:[v2i64] } QPR:{ *:[v2i64] }:$Vn, (anyext:{ *:[v2i64] } DPR:{ *:[v2i32] }:$Vm))  =>  (VADDWuv2i64:{ *:[v2i64] } QPR:{ *:[v2i64] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /*   7654 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDWuv2i64),
     /*   7657 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   7659 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*   7661 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vm
     /*   7665 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   7668 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   7674 */     GIR_RootConstrainSelectedInstOperands,
     /*   7675 */     // GIR_Coverage, 788,
     /*   7675 */     GIR_EraseRootFromParent_Done,
     /*   7676 */   // Label 174: @7676
     /*   7676 */   GIM_Try, /*On fail goto*//*Label 175*/ GIMT_Encode4(7729), // Rule ID 782 //
     /*   7681 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   7684 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   7688 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   7692 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   7696 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   7700 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   7705 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   7707 */     // (add:{ *:[v2i64] } QPR:{ *:[v2i64] }:$Vn, (sext:{ *:[v2i64] } DPR:{ *:[v2i32] }:$Vm))  =>  (VADDWsv2i64:{ *:[v2i64] } QPR:{ *:[v2i64] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /*   7707 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDWsv2i64),
     /*   7710 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   7712 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*   7714 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vm
     /*   7718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   7721 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   7727 */     GIR_RootConstrainSelectedInstOperands,
     /*   7728 */     // GIR_Coverage, 782,
     /*   7728 */     GIR_EraseRootFromParent_Done,
     /*   7729 */   // Label 175: @7729
     /*   7729 */   GIM_Try, /*On fail goto*//*Label 176*/ GIMT_Encode4(7782), // Rule ID 787 //
     /*   7734 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   7737 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   7741 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   7745 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   7749 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   7753 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   7758 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   7760 */     // (add:{ *:[v2i64] } QPR:{ *:[v2i64] }:$Vn, (zext:{ *:[v2i64] } DPR:{ *:[v2i32] }:$Vm))  =>  (VADDWuv2i64:{ *:[v2i64] } QPR:{ *:[v2i64] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /*   7760 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDWuv2i64),
     /*   7763 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   7765 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*   7767 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vm
     /*   7771 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   7774 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   7780 */     GIR_RootConstrainSelectedInstOperands,
     /*   7781 */     // GIR_Coverage, 787,
     /*   7781 */     GIR_EraseRootFromParent_Done,
     /*   7782 */   // Label 176: @7782
     /*   7782 */   GIM_Try, /*On fail goto*//*Label 177*/ GIMT_Encode4(7818), // Rule ID 760 //
     /*   7787 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   7790 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   7794 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   7798 */     // (add:{ *:[v2i64] } QPR:{ *:[v2i64] }:$Vn, QPR:{ *:[v2i64] }:$Vm)  =>  (VADDv2i64:{ *:[v2i64] } QPR:{ *:[v2i64] }:$Vn, QPR:{ *:[v2i64] }:$Vm)
     /*   7798 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDv2i64),
     /*   7801 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   7803 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*   7805 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*   7807 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   7810 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   7816 */     GIR_RootConstrainSelectedInstOperands,
     /*   7817 */     // GIR_Coverage, 760,
     /*   7817 */     GIR_EraseRootFromParent_Done,
     /*   7818 */   // Label 177: @7818
     /*   7818 */   GIM_Reject,
     /*   7819 */ // Label 165: @7819
     /*   7819 */ GIM_Reject,
     /*   7820 */ // Label 84: @7820
     /*   7820 */ GIM_Try, /*On fail goto*//*Label 178*/ GIMT_Encode4(8004),
     /*   7825 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*   7828 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*   7831 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   7835 */   GIM_Try, /*On fail goto*//*Label 179*/ GIMT_Encode4(7901), // Rule ID 5528 //
     /*   7840 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   7843 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   7847 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   7851 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*   7855 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*   7859 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   7864 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   7869 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   7873 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   7875 */     // (add:{ *:[v4i16] } (mul:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm), DPR:{ *:[v4i16] }:$src1)  =>  (VMLAv4i16:{ *:[v4i16] } DPR:{ *:[v4i16] }:$src1, DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /*   7875 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMLAv4i16),
     /*   7878 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   7880 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*   7882 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*   7886 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /*   7890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   7893 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   7899 */     GIR_RootConstrainSelectedInstOperands,
     /*   7900 */     // GIR_Coverage, 5528,
     /*   7900 */     GIR_EraseRootFromParent_Done,
     /*   7901 */   // Label 179: @7901
     /*   7901 */   GIM_Try, /*On fail goto*//*Label 180*/ GIMT_Encode4(7967), // Rule ID 885 //
     /*   7906 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   7909 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   7913 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   7917 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   7921 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*   7925 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*   7929 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   7934 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   7939 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   7941 */     // (add:{ *:[v4i16] } DPR:{ *:[v4i16] }:$src1, (mul:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm))  =>  (VMLAv4i16:{ *:[v4i16] } DPR:{ *:[v4i16] }:$src1, DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /*   7941 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMLAv4i16),
     /*   7944 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   7946 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*   7948 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*   7952 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /*   7956 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   7959 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   7965 */     GIR_RootConstrainSelectedInstOperands,
     /*   7966 */     // GIR_Coverage, 885,
     /*   7966 */     GIR_EraseRootFromParent_Done,
     /*   7967 */   // Label 180: @7967
     /*   7967 */   GIM_Try, /*On fail goto*//*Label 181*/ GIMT_Encode4(8003), // Rule ID 754 //
     /*   7972 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   7975 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   7979 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   7983 */     // (add:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)  =>  (VADDv4i16:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /*   7983 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDv4i16),
     /*   7986 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   7988 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*   7990 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*   7992 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   7995 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   8001 */     GIR_RootConstrainSelectedInstOperands,
     /*   8002 */     // GIR_Coverage, 754,
     /*   8002 */     GIR_EraseRootFromParent_Done,
     /*   8003 */   // Label 181: @8003
     /*   8003 */   GIM_Reject,
     /*   8004 */ // Label 178: @8004
     /*   8004 */ GIM_Reject,
     /*   8005 */ // Label 85: @8005
     /*   8005 */ GIM_Try, /*On fail goto*//*Label 182*/ GIMT_Encode4(8960),
     /*   8010 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   8013 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   8016 */   GIM_Try, /*On fail goto*//*Label 183*/ GIMT_Encode4(8088), // Rule ID 775 //
     /*   8021 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   8024 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   8028 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   8032 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   8036 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*   8040 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   8045 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   8049 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   8053 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*   8057 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   8062 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   8064 */     // (add:{ *:[v4i32] } (anyext:{ *:[v4i32] } DPR:{ *:[v4i16] }:$Vn), (anyext:{ *:[v4i32] } DPR:{ *:[v4i16] }:$Vm))  =>  (VADDLuv4i32:{ *:[v4i32] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /*   8064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDLuv4i32),
     /*   8067 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   8069 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*   8073 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Vm
     /*   8077 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   8080 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   8086 */     GIR_RootConstrainSelectedInstOperands,
     /*   8087 */     // GIR_Coverage, 775,
     /*   8087 */     GIR_EraseRootFromParent_Done,
     /*   8088 */   // Label 183: @8088
     /*   8088 */   GIM_Try, /*On fail goto*//*Label 184*/ GIMT_Encode4(8160), // Rule ID 774 //
     /*   8093 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   8096 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   8100 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   8104 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   8108 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*   8112 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   8117 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   8121 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   8125 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*   8129 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   8134 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   8136 */     // (add:{ *:[v4i32] } (anyext:{ *:[v4i32] } DPR:{ *:[v4i16] }:$Vn), (zext:{ *:[v4i32] } DPR:{ *:[v4i16] }:$Vm))  =>  (VADDLuv4i32:{ *:[v4i32] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /*   8136 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDLuv4i32),
     /*   8139 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   8141 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*   8145 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Vm
     /*   8149 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   8152 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   8158 */     GIR_RootConstrainSelectedInstOperands,
     /*   8159 */     // GIR_Coverage, 774,
     /*   8159 */     GIR_EraseRootFromParent_Done,
     /*   8160 */   // Label 184: @8160
     /*   8160 */   GIM_Try, /*On fail goto*//*Label 185*/ GIMT_Encode4(8232), // Rule ID 766 //
     /*   8165 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   8168 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   8172 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   8176 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   8180 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*   8184 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   8189 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   8193 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   8197 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*   8201 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   8206 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   8208 */     // (add:{ *:[v4i32] } (sext:{ *:[v4i32] } DPR:{ *:[v4i16] }:$Vn), (sext:{ *:[v4i32] } DPR:{ *:[v4i16] }:$Vm))  =>  (VADDLsv4i32:{ *:[v4i32] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /*   8208 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDLsv4i32),
     /*   8211 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   8213 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*   8217 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Vm
     /*   8221 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   8224 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   8230 */     GIR_RootConstrainSelectedInstOperands,
     /*   8231 */     // GIR_Coverage, 766,
     /*   8231 */     GIR_EraseRootFromParent_Done,
     /*   8232 */   // Label 185: @8232
     /*   8232 */   GIM_Try, /*On fail goto*//*Label 186*/ GIMT_Encode4(8304), // Rule ID 773 //
     /*   8237 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   8240 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   8244 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   8248 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   8252 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*   8256 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   8261 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   8265 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   8269 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*   8273 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   8278 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   8280 */     // (add:{ *:[v4i32] } (zext:{ *:[v4i32] } DPR:{ *:[v4i16] }:$Vn), (anyext:{ *:[v4i32] } DPR:{ *:[v4i16] }:$Vm))  =>  (VADDLuv4i32:{ *:[v4i32] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /*   8280 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDLuv4i32),
     /*   8283 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   8285 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*   8289 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Vm
     /*   8293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   8296 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   8302 */     GIR_RootConstrainSelectedInstOperands,
     /*   8303 */     // GIR_Coverage, 773,
     /*   8303 */     GIR_EraseRootFromParent_Done,
     /*   8304 */   // Label 186: @8304
     /*   8304 */   GIM_Try, /*On fail goto*//*Label 187*/ GIMT_Encode4(8376), // Rule ID 772 //
     /*   8309 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   8312 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   8316 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   8320 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   8324 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*   8328 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   8333 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   8337 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   8341 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*   8345 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   8350 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   8352 */     // (add:{ *:[v4i32] } (zext:{ *:[v4i32] } DPR:{ *:[v4i16] }:$Vn), (zext:{ *:[v4i32] } DPR:{ *:[v4i16] }:$Vm))  =>  (VADDLuv4i32:{ *:[v4i32] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /*   8352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDLuv4i32),
     /*   8355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   8357 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*   8361 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Vm
     /*   8365 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   8368 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   8374 */     GIR_RootConstrainSelectedInstOperands,
     /*   8375 */     // GIR_Coverage, 772,
     /*   8375 */     GIR_EraseRootFromParent_Done,
     /*   8376 */   // Label 187: @8376
     /*   8376 */   GIM_Try, /*On fail goto*//*Label 188*/ GIMT_Encode4(8446), // Rule ID 5532 //
     /*   8381 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   8384 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   8388 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   8392 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   8396 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   8400 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   8404 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   8409 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   8414 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   8418 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   8420 */     // (add:{ *:[v4i32] } (mul:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm), QPR:{ *:[v4i32] }:$src1)  =>  (VMLAv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$src1, QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)
     /*   8420 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMLAv4i32),
     /*   8423 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   8425 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*   8427 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*   8431 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /*   8435 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   8438 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   8444 */     GIR_RootConstrainSelectedInstOperands,
     /*   8445 */     // GIR_Coverage, 5532,
     /*   8445 */     GIR_EraseRootFromParent_Done,
     /*   8446 */   // Label 188: @8446
     /*   8446 */   GIM_Try, /*On fail goto*//*Label 189*/ GIMT_Encode4(8503), // Rule ID 5506 //
     /*   8451 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   8454 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   8458 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   8462 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   8466 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*   8470 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   8475 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   8479 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   8481 */     // (add:{ *:[v4i32] } (anyext:{ *:[v4i32] } DPR:{ *:[v4i16] }:$Vm), QPR:{ *:[v4i32] }:$Vn)  =>  (VADDWuv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /*   8481 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDWuv4i32),
     /*   8484 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   8486 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*   8488 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vm
     /*   8492 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   8495 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   8501 */     GIR_RootConstrainSelectedInstOperands,
     /*   8502 */     // GIR_Coverage, 5506,
     /*   8502 */     GIR_EraseRootFromParent_Done,
     /*   8503 */   // Label 189: @8503
     /*   8503 */   GIM_Try, /*On fail goto*//*Label 190*/ GIMT_Encode4(8560), // Rule ID 5501 //
     /*   8508 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   8511 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   8515 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   8519 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   8523 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*   8527 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   8532 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   8536 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   8538 */     // (add:{ *:[v4i32] } (sext:{ *:[v4i32] } DPR:{ *:[v4i16] }:$Vm), QPR:{ *:[v4i32] }:$Vn)  =>  (VADDWsv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /*   8538 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDWsv4i32),
     /*   8541 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   8543 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*   8545 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vm
     /*   8549 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   8552 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   8558 */     GIR_RootConstrainSelectedInstOperands,
     /*   8559 */     // GIR_Coverage, 5501,
     /*   8559 */     GIR_EraseRootFromParent_Done,
     /*   8560 */   // Label 190: @8560
     /*   8560 */   GIM_Try, /*On fail goto*//*Label 191*/ GIMT_Encode4(8617), // Rule ID 5505 //
     /*   8565 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   8568 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   8572 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   8576 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   8580 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*   8584 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   8589 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   8593 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   8595 */     // (add:{ *:[v4i32] } (zext:{ *:[v4i32] } DPR:{ *:[v4i16] }:$Vm), QPR:{ *:[v4i32] }:$Vn)  =>  (VADDWuv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /*   8595 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDWuv4i32),
     /*   8598 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   8600 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*   8602 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vm
     /*   8606 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   8609 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   8615 */     GIR_RootConstrainSelectedInstOperands,
     /*   8616 */     // GIR_Coverage, 5505,
     /*   8616 */     GIR_EraseRootFromParent_Done,
     /*   8617 */   // Label 191: @8617
     /*   8617 */   GIM_Try, /*On fail goto*//*Label 192*/ GIMT_Encode4(8687), // Rule ID 889 //
     /*   8622 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   8625 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   8629 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   8633 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   8637 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   8641 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   8645 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   8649 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   8654 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   8659 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   8661 */     // (add:{ *:[v4i32] } QPR:{ *:[v4i32] }:$src1, (mul:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm))  =>  (VMLAv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$src1, QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)
     /*   8661 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMLAv4i32),
     /*   8664 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   8666 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*   8668 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*   8672 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /*   8676 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   8679 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   8685 */     GIR_RootConstrainSelectedInstOperands,
     /*   8686 */     // GIR_Coverage, 889,
     /*   8686 */     GIR_EraseRootFromParent_Done,
     /*   8687 */   // Label 192: @8687
     /*   8687 */   GIM_Try, /*On fail goto*//*Label 193*/ GIMT_Encode4(8744), // Rule ID 786 //
     /*   8692 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   8695 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   8699 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   8703 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   8707 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   8711 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*   8715 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   8720 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   8722 */     // (add:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, (anyext:{ *:[v4i32] } DPR:{ *:[v4i16] }:$Vm))  =>  (VADDWuv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /*   8722 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDWuv4i32),
     /*   8725 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   8727 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*   8729 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vm
     /*   8733 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   8736 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   8742 */     GIR_RootConstrainSelectedInstOperands,
     /*   8743 */     // GIR_Coverage, 786,
     /*   8743 */     GIR_EraseRootFromParent_Done,
     /*   8744 */   // Label 193: @8744
     /*   8744 */   GIM_Try, /*On fail goto*//*Label 194*/ GIMT_Encode4(8801), // Rule ID 781 //
     /*   8749 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   8752 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   8756 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   8760 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   8764 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   8768 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*   8772 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   8777 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   8779 */     // (add:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, (sext:{ *:[v4i32] } DPR:{ *:[v4i16] }:$Vm))  =>  (VADDWsv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /*   8779 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDWsv4i32),
     /*   8782 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   8784 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*   8786 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vm
     /*   8790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   8793 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   8799 */     GIR_RootConstrainSelectedInstOperands,
     /*   8800 */     // GIR_Coverage, 781,
     /*   8800 */     GIR_EraseRootFromParent_Done,
     /*   8801 */   // Label 194: @8801
     /*   8801 */   GIM_Try, /*On fail goto*//*Label 195*/ GIMT_Encode4(8858), // Rule ID 785 //
     /*   8806 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   8809 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   8813 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   8817 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   8821 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   8825 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*   8829 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   8834 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   8836 */     // (add:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, (zext:{ *:[v4i32] } DPR:{ *:[v4i16] }:$Vm))  =>  (VADDWuv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /*   8836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDWuv4i32),
     /*   8839 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   8841 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*   8843 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vm
     /*   8847 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   8850 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   8856 */     GIR_RootConstrainSelectedInstOperands,
     /*   8857 */     // GIR_Coverage, 785,
     /*   8857 */     GIR_EraseRootFromParent_Done,
     /*   8858 */   // Label 195: @8858
     /*   8858 */   GIM_Try, /*On fail goto*//*Label 196*/ GIMT_Encode4(8898), // Rule ID 758 //
     /*   8863 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   8866 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   8870 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   8874 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   8878 */     // (add:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)  =>  (VADDv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)
     /*   8878 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDv4i32),
     /*   8881 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   8883 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*   8885 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*   8887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   8890 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   8896 */     GIR_RootConstrainSelectedInstOperands,
     /*   8897 */     // GIR_Coverage, 758,
     /*   8897 */     GIR_EraseRootFromParent_Done,
     /*   8898 */   // Label 196: @8898
     /*   8898 */   GIM_Try, /*On fail goto*//*Label 197*/ GIMT_Encode4(8959), // Rule ID 3493 //
     /*   8903 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*   8906 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*   8910 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*   8914 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*   8918 */     // (add:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)  =>  (MVE_VADDi32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)
     /*   8918 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*   8921 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   8925 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   8930 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VADDi32),
     /*   8933 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*   8935 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /*   8937 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /*   8939 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   8942 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   8948 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   8954 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   8957 */     GIR_RootConstrainSelectedInstOperands,
     /*   8958 */     // GIR_Coverage, 3493,
     /*   8958 */     GIR_EraseRootFromParent_Done,
     /*   8959 */   // Label 197: @8959
     /*   8959 */   GIM_Reject,
     /*   8960 */ // Label 182: @8960
     /*   8960 */ GIM_Reject,
     /*   8961 */ // Label 86: @8961
     /*   8961 */ GIM_Try, /*On fail goto*//*Label 198*/ GIMT_Encode4(9145),
     /*   8966 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*   8969 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*   8972 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   8976 */   GIM_Try, /*On fail goto*//*Label 199*/ GIMT_Encode4(9042), // Rule ID 5527 //
     /*   8981 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   8984 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   8988 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   8992 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*   8996 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*   9000 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   9005 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   9010 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   9014 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   9016 */     // (add:{ *:[v8i8] } (mul:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm), DPR:{ *:[v8i8] }:$src1)  =>  (VMLAv8i8:{ *:[v8i8] } DPR:{ *:[v8i8] }:$src1, DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /*   9016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMLAv8i8),
     /*   9019 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   9021 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*   9023 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*   9027 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /*   9031 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   9034 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   9040 */     GIR_RootConstrainSelectedInstOperands,
     /*   9041 */     // GIR_Coverage, 5527,
     /*   9041 */     GIR_EraseRootFromParent_Done,
     /*   9042 */   // Label 199: @9042
     /*   9042 */   GIM_Try, /*On fail goto*//*Label 200*/ GIMT_Encode4(9108), // Rule ID 884 //
     /*   9047 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   9050 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   9054 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   9058 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   9062 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*   9066 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*   9070 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   9075 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   9080 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   9082 */     // (add:{ *:[v8i8] } DPR:{ *:[v8i8] }:$src1, (mul:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm))  =>  (VMLAv8i8:{ *:[v8i8] } DPR:{ *:[v8i8] }:$src1, DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /*   9082 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMLAv8i8),
     /*   9085 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   9087 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*   9089 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*   9093 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /*   9097 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   9100 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   9106 */     GIR_RootConstrainSelectedInstOperands,
     /*   9107 */     // GIR_Coverage, 884,
     /*   9107 */     GIR_EraseRootFromParent_Done,
     /*   9108 */   // Label 200: @9108
     /*   9108 */   GIM_Try, /*On fail goto*//*Label 201*/ GIMT_Encode4(9144), // Rule ID 753 //
     /*   9113 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   9116 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   9120 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   9124 */     // (add:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)  =>  (VADDv8i8:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /*   9124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDv8i8),
     /*   9127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   9129 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*   9131 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*   9133 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   9136 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   9142 */     GIR_RootConstrainSelectedInstOperands,
     /*   9143 */     // GIR_Coverage, 753,
     /*   9143 */     GIR_EraseRootFromParent_Done,
     /*   9144 */   // Label 201: @9144
     /*   9144 */   GIM_Reject,
     /*   9145 */ // Label 198: @9145
     /*   9145 */ GIM_Reject,
     /*   9146 */ // Label 87: @9146
     /*   9146 */ GIM_Try, /*On fail goto*//*Label 202*/ GIMT_Encode4(10101),
     /*   9151 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*   9154 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*   9157 */   GIM_Try, /*On fail goto*//*Label 203*/ GIMT_Encode4(9229), // Rule ID 771 //
     /*   9162 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   9165 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   9169 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   9173 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   9177 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*   9181 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   9186 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   9190 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   9194 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*   9198 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   9203 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   9205 */     // (add:{ *:[v8i16] } (anyext:{ *:[v8i16] } DPR:{ *:[v8i8] }:$Vn), (anyext:{ *:[v8i16] } DPR:{ *:[v8i8] }:$Vm))  =>  (VADDLuv8i16:{ *:[v8i16] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /*   9205 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDLuv8i16),
     /*   9208 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   9210 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*   9214 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Vm
     /*   9218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   9221 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   9227 */     GIR_RootConstrainSelectedInstOperands,
     /*   9228 */     // GIR_Coverage, 771,
     /*   9228 */     GIR_EraseRootFromParent_Done,
     /*   9229 */   // Label 203: @9229
     /*   9229 */   GIM_Try, /*On fail goto*//*Label 204*/ GIMT_Encode4(9301), // Rule ID 770 //
     /*   9234 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   9237 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   9241 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   9245 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   9249 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*   9253 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   9258 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   9262 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   9266 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*   9270 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   9275 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   9277 */     // (add:{ *:[v8i16] } (anyext:{ *:[v8i16] } DPR:{ *:[v8i8] }:$Vn), (zext:{ *:[v8i16] } DPR:{ *:[v8i8] }:$Vm))  =>  (VADDLuv8i16:{ *:[v8i16] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /*   9277 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDLuv8i16),
     /*   9280 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   9282 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*   9286 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Vm
     /*   9290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   9293 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   9299 */     GIR_RootConstrainSelectedInstOperands,
     /*   9300 */     // GIR_Coverage, 770,
     /*   9300 */     GIR_EraseRootFromParent_Done,
     /*   9301 */   // Label 204: @9301
     /*   9301 */   GIM_Try, /*On fail goto*//*Label 205*/ GIMT_Encode4(9373), // Rule ID 765 //
     /*   9306 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   9309 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   9313 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   9317 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   9321 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*   9325 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   9330 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   9334 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   9338 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*   9342 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   9347 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   9349 */     // (add:{ *:[v8i16] } (sext:{ *:[v8i16] } DPR:{ *:[v8i8] }:$Vn), (sext:{ *:[v8i16] } DPR:{ *:[v8i8] }:$Vm))  =>  (VADDLsv8i16:{ *:[v8i16] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /*   9349 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDLsv8i16),
     /*   9352 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   9354 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*   9358 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Vm
     /*   9362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   9365 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   9371 */     GIR_RootConstrainSelectedInstOperands,
     /*   9372 */     // GIR_Coverage, 765,
     /*   9372 */     GIR_EraseRootFromParent_Done,
     /*   9373 */   // Label 205: @9373
     /*   9373 */   GIM_Try, /*On fail goto*//*Label 206*/ GIMT_Encode4(9445), // Rule ID 769 //
     /*   9378 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   9381 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   9385 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   9389 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   9393 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*   9397 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   9402 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   9406 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   9410 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*   9414 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   9419 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   9421 */     // (add:{ *:[v8i16] } (zext:{ *:[v8i16] } DPR:{ *:[v8i8] }:$Vn), (anyext:{ *:[v8i16] } DPR:{ *:[v8i8] }:$Vm))  =>  (VADDLuv8i16:{ *:[v8i16] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /*   9421 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDLuv8i16),
     /*   9424 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   9426 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*   9430 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Vm
     /*   9434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   9437 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   9443 */     GIR_RootConstrainSelectedInstOperands,
     /*   9444 */     // GIR_Coverage, 769,
     /*   9444 */     GIR_EraseRootFromParent_Done,
     /*   9445 */   // Label 206: @9445
     /*   9445 */   GIM_Try, /*On fail goto*//*Label 207*/ GIMT_Encode4(9517), // Rule ID 768 //
     /*   9450 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   9453 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   9457 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   9461 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   9465 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*   9469 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   9474 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   9478 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   9482 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*   9486 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   9491 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   9493 */     // (add:{ *:[v8i16] } (zext:{ *:[v8i16] } DPR:{ *:[v8i8] }:$Vn), (zext:{ *:[v8i16] } DPR:{ *:[v8i8] }:$Vm))  =>  (VADDLuv8i16:{ *:[v8i16] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /*   9493 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDLuv8i16),
     /*   9496 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   9498 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*   9502 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Vm
     /*   9506 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   9509 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   9515 */     GIR_RootConstrainSelectedInstOperands,
     /*   9516 */     // GIR_Coverage, 768,
     /*   9516 */     GIR_EraseRootFromParent_Done,
     /*   9517 */   // Label 207: @9517
     /*   9517 */   GIM_Try, /*On fail goto*//*Label 208*/ GIMT_Encode4(9587), // Rule ID 5531 //
     /*   9522 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   9525 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   9529 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   9533 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   9537 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*   9541 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*   9545 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   9550 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   9555 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   9559 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   9561 */     // (add:{ *:[v8i16] } (mul:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm), QPR:{ *:[v8i16] }:$src1)  =>  (VMLAv8i16:{ *:[v8i16] } QPR:{ *:[v8i16] }:$src1, QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)
     /*   9561 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMLAv8i16),
     /*   9564 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   9566 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*   9568 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*   9572 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /*   9576 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   9579 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   9585 */     GIR_RootConstrainSelectedInstOperands,
     /*   9586 */     // GIR_Coverage, 5531,
     /*   9586 */     GIR_EraseRootFromParent_Done,
     /*   9587 */   // Label 208: @9587
     /*   9587 */   GIM_Try, /*On fail goto*//*Label 209*/ GIMT_Encode4(9644), // Rule ID 5504 //
     /*   9592 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   9595 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   9599 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   9603 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   9607 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*   9611 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   9616 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   9620 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   9622 */     // (add:{ *:[v8i16] } (anyext:{ *:[v8i16] } DPR:{ *:[v8i8] }:$Vm), QPR:{ *:[v8i16] }:$Vn)  =>  (VADDWuv8i16:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /*   9622 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDWuv8i16),
     /*   9625 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   9627 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*   9629 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vm
     /*   9633 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   9636 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   9642 */     GIR_RootConstrainSelectedInstOperands,
     /*   9643 */     // GIR_Coverage, 5504,
     /*   9643 */     GIR_EraseRootFromParent_Done,
     /*   9644 */   // Label 209: @9644
     /*   9644 */   GIM_Try, /*On fail goto*//*Label 210*/ GIMT_Encode4(9701), // Rule ID 5500 //
     /*   9649 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   9652 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   9656 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   9660 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   9664 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*   9668 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   9673 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   9677 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   9679 */     // (add:{ *:[v8i16] } (sext:{ *:[v8i16] } DPR:{ *:[v8i8] }:$Vm), QPR:{ *:[v8i16] }:$Vn)  =>  (VADDWsv8i16:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /*   9679 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDWsv8i16),
     /*   9682 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   9684 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*   9686 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vm
     /*   9690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   9693 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   9699 */     GIR_RootConstrainSelectedInstOperands,
     /*   9700 */     // GIR_Coverage, 5500,
     /*   9700 */     GIR_EraseRootFromParent_Done,
     /*   9701 */   // Label 210: @9701
     /*   9701 */   GIM_Try, /*On fail goto*//*Label 211*/ GIMT_Encode4(9758), // Rule ID 5503 //
     /*   9706 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   9709 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   9713 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   9717 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   9721 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*   9725 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   9730 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   9734 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   9736 */     // (add:{ *:[v8i16] } (zext:{ *:[v8i16] } DPR:{ *:[v8i8] }:$Vm), QPR:{ *:[v8i16] }:$Vn)  =>  (VADDWuv8i16:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /*   9736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDWuv8i16),
     /*   9739 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   9741 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*   9743 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vm
     /*   9747 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   9750 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   9756 */     GIR_RootConstrainSelectedInstOperands,
     /*   9757 */     // GIR_Coverage, 5503,
     /*   9757 */     GIR_EraseRootFromParent_Done,
     /*   9758 */   // Label 211: @9758
     /*   9758 */   GIM_Try, /*On fail goto*//*Label 212*/ GIMT_Encode4(9828), // Rule ID 888 //
     /*   9763 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   9766 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   9770 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   9774 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   9778 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   9782 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*   9786 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*   9790 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   9795 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   9800 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   9802 */     // (add:{ *:[v8i16] } QPR:{ *:[v8i16] }:$src1, (mul:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm))  =>  (VMLAv8i16:{ *:[v8i16] } QPR:{ *:[v8i16] }:$src1, QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)
     /*   9802 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMLAv8i16),
     /*   9805 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   9807 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*   9809 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*   9813 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /*   9817 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   9820 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   9826 */     GIR_RootConstrainSelectedInstOperands,
     /*   9827 */     // GIR_Coverage, 888,
     /*   9827 */     GIR_EraseRootFromParent_Done,
     /*   9828 */   // Label 212: @9828
     /*   9828 */   GIM_Try, /*On fail goto*//*Label 213*/ GIMT_Encode4(9885), // Rule ID 784 //
     /*   9833 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   9836 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   9840 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   9844 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   9848 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   9852 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*   9856 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   9861 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   9863 */     // (add:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, (anyext:{ *:[v8i16] } DPR:{ *:[v8i8] }:$Vm))  =>  (VADDWuv8i16:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /*   9863 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDWuv8i16),
     /*   9866 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   9868 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*   9870 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vm
     /*   9874 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   9877 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   9883 */     GIR_RootConstrainSelectedInstOperands,
     /*   9884 */     // GIR_Coverage, 784,
     /*   9884 */     GIR_EraseRootFromParent_Done,
     /*   9885 */   // Label 213: @9885
     /*   9885 */   GIM_Try, /*On fail goto*//*Label 214*/ GIMT_Encode4(9942), // Rule ID 780 //
     /*   9890 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   9893 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   9897 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   9901 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   9905 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   9909 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*   9913 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   9918 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   9920 */     // (add:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, (sext:{ *:[v8i16] } DPR:{ *:[v8i8] }:$Vm))  =>  (VADDWsv8i16:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /*   9920 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDWsv8i16),
     /*   9923 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   9925 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*   9927 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vm
     /*   9931 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   9934 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   9940 */     GIR_RootConstrainSelectedInstOperands,
     /*   9941 */     // GIR_Coverage, 780,
     /*   9941 */     GIR_EraseRootFromParent_Done,
     /*   9942 */   // Label 214: @9942
     /*   9942 */   GIM_Try, /*On fail goto*//*Label 215*/ GIMT_Encode4(9999), // Rule ID 783 //
     /*   9947 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   9950 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   9954 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   9958 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   9962 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   9966 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*   9970 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   9975 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   9977 */     // (add:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, (zext:{ *:[v8i16] } DPR:{ *:[v8i8] }:$Vm))  =>  (VADDWuv8i16:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /*   9977 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDWuv8i16),
     /*   9980 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   9982 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*   9984 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vm
     /*   9988 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   9991 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   9997 */     GIR_RootConstrainSelectedInstOperands,
     /*   9998 */     // GIR_Coverage, 783,
     /*   9998 */     GIR_EraseRootFromParent_Done,
     /*   9999 */   // Label 215: @9999
     /*   9999 */   GIM_Try, /*On fail goto*//*Label 216*/ GIMT_Encode4(10039), // Rule ID 757 //
     /*  10004 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  10007 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  10011 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  10015 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  10019 */     // (add:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)  =>  (VADDv8i16:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)
     /*  10019 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDv8i16),
     /*  10022 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  10024 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*  10026 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  10028 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  10031 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  10037 */     GIR_RootConstrainSelectedInstOperands,
     /*  10038 */     // GIR_Coverage, 757,
     /*  10038 */     GIR_EraseRootFromParent_Done,
     /*  10039 */   // Label 216: @10039
     /*  10039 */   GIM_Try, /*On fail goto*//*Label 217*/ GIMT_Encode4(10100), // Rule ID 3489 //
     /*  10044 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  10047 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  10051 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  10055 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  10059 */     // (add:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)  =>  (MVE_VADDi16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)
     /*  10059 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  10062 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  10066 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  10071 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VADDi16),
     /*  10074 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  10076 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /*  10078 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /*  10080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  10083 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  10089 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  10095 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  10098 */     GIR_RootConstrainSelectedInstOperands,
     /*  10099 */     // GIR_Coverage, 3489,
     /*  10099 */     GIR_EraseRootFromParent_Done,
     /*  10100 */   // Label 217: @10100
     /*  10100 */   GIM_Reject,
     /*  10101 */ // Label 202: @10101
     /*  10101 */ GIM_Reject,
     /*  10102 */ // Label 88: @10102
     /*  10102 */ GIM_Try, /*On fail goto*//*Label 218*/ GIMT_Encode4(10355),
     /*  10107 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  10110 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  10113 */   GIM_Try, /*On fail goto*//*Label 219*/ GIMT_Encode4(10183), // Rule ID 5530 //
     /*  10118 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  10121 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  10125 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  10129 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*  10133 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  10137 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  10141 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  10146 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  10151 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  10155 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  10157 */     // (add:{ *:[v16i8] } (mul:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm), QPR:{ *:[v16i8] }:$src1)  =>  (VMLAv16i8:{ *:[v16i8] } QPR:{ *:[v16i8] }:$src1, QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)
     /*  10157 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMLAv16i8),
     /*  10160 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  10162 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  10164 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*  10168 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /*  10172 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  10175 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  10181 */     GIR_RootConstrainSelectedInstOperands,
     /*  10182 */     // GIR_Coverage, 5530,
     /*  10182 */     GIR_EraseRootFromParent_Done,
     /*  10183 */   // Label 219: @10183
     /*  10183 */   GIM_Try, /*On fail goto*//*Label 220*/ GIMT_Encode4(10253), // Rule ID 887 //
     /*  10188 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  10191 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  10195 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  10199 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  10203 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*  10207 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  10211 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  10215 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  10220 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  10225 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  10227 */     // (add:{ *:[v16i8] } QPR:{ *:[v16i8] }:$src1, (mul:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm))  =>  (VMLAv16i8:{ *:[v16i8] } QPR:{ *:[v16i8] }:$src1, QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)
     /*  10227 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMLAv16i8),
     /*  10230 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  10232 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  10234 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*  10238 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /*  10242 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  10245 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  10251 */     GIR_RootConstrainSelectedInstOperands,
     /*  10252 */     // GIR_Coverage, 887,
     /*  10252 */     GIR_EraseRootFromParent_Done,
     /*  10253 */   // Label 220: @10253
     /*  10253 */   GIM_Try, /*On fail goto*//*Label 221*/ GIMT_Encode4(10293), // Rule ID 756 //
     /*  10258 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  10261 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  10265 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  10269 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  10273 */     // (add:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)  =>  (VADDv16i8:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)
     /*  10273 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDv16i8),
     /*  10276 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  10278 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*  10280 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  10282 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  10285 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  10291 */     GIR_RootConstrainSelectedInstOperands,
     /*  10292 */     // GIR_Coverage, 756,
     /*  10292 */     GIR_EraseRootFromParent_Done,
     /*  10293 */   // Label 221: @10293
     /*  10293 */   GIM_Try, /*On fail goto*//*Label 222*/ GIMT_Encode4(10354), // Rule ID 3485 //
     /*  10298 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  10301 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  10305 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  10309 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  10313 */     // (add:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)  =>  (MVE_VADDi8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)
     /*  10313 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  10316 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  10320 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  10325 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VADDi8),
     /*  10328 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  10330 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /*  10332 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /*  10334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  10337 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  10343 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  10349 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  10352 */     GIR_RootConstrainSelectedInstOperands,
     /*  10353 */     // GIR_Coverage, 3485,
     /*  10353 */     GIR_EraseRootFromParent_Done,
     /*  10354 */   // Label 222: @10354
     /*  10354 */   GIM_Reject,
     /*  10355 */ // Label 218: @10355
     /*  10355 */ GIM_Reject,
     /*  10356 */ // Label 89: @10356
     /*  10356 */ GIM_Reject,
     /*  10357 */ // Label 1: @10357
     /*  10357 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(16), /*)*//*default:*//*Label 232*/ GIMT_Encode4(13600),
     /*  10368 */ /*GILLT_s32*//*Label 223*/ GIMT_Encode4(10428),
     /*  10372 */ /*GILLT_s64*//*Label 224*/ GIMT_Encode4(11042), GIMT_Encode4(0),
     /*  10380 */ /*GILLT_v2s32*//*Label 225*/ GIMT_Encode4(11089),
     /*  10384 */ /*GILLT_v2s64*//*Label 226*/ GIMT_Encode4(11204), GIMT_Encode4(0),
     /*  10392 */ /*GILLT_v4s16*//*Label 227*/ GIMT_Encode4(11756),
     /*  10396 */ /*GILLT_v4s32*//*Label 228*/ GIMT_Encode4(11871), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  10408 */ /*GILLT_v8s8*//*Label 229*/ GIMT_Encode4(12586),
     /*  10412 */ /*GILLT_v8s16*//*Label 230*/ GIMT_Encode4(12701), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  10424 */ /*GILLT_v16s8*//*Label 231*/ GIMT_Encode4(13416),
     /*  10428 */ // Label 223: @10428
     /*  10428 */ GIM_Try, /*On fail goto*//*Label 233*/ GIMT_Encode4(11041),
     /*  10433 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  10436 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  10439 */   GIM_Try, /*On fail goto*//*Label 234*/ GIMT_Encode4(10483), // Rule ID 330 //
     /*  10444 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb_IsThumb1Only),
     /*  10447 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /*  10451 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/1, 0,
     /*  10455 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /*  10459 */     // (sub:{ *:[i32] } 0:{ *:[i32] }, tGPR:{ *:[i32] }:$Rn)  =>  (tRSB:{ *:[i32] } tGPR:{ *:[i32] }:$Rn)
     /*  10459 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::tRSB),
     /*  10462 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  10464 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::CPSR), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define | RegState::Dead),
     /*  10470 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  10472 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  10475 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  10481 */     GIR_RootConstrainSelectedInstOperands,
     /*  10482 */     // GIR_Coverage, 330,
     /*  10482 */     GIR_EraseRootFromParent_Done,
     /*  10483 */   // Label 234: @10483
     /*  10483 */   GIM_Try, /*On fail goto*//*Label 235*/ GIMT_Encode4(10540), // Rule ID 96 //
     /*  10488 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  10491 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  10495 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  10499 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  10503 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_mod_imm),
     /*  10507 */     // MIs[1] Operand 1
     /*  10507 */     // No operand predicates
     /*  10507 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  10511 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  10513 */     // (sub:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_mod_imm>>:$imm, GPR:{ *:[i32] }:$Rn)  =>  (RSBri:{ *:[i32] } GPR:{ *:[i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  10513 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::RSBri),
     /*  10516 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  10518 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  10520 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  10523 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  10526 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  10532 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  10538 */     GIR_RootConstrainSelectedInstOperands,
     /*  10539 */     // GIR_Coverage, 96,
     /*  10539 */     GIR_EraseRootFromParent_Done,
     /*  10540 */   // Label 235: @10540
     /*  10540 */   GIM_Try, /*On fail goto*//*Label 236*/ GIMT_Encode4(10597), // Rule ID 427 //
     /*  10545 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /*  10548 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  10552 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  10556 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  10560 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_t2_so_imm),
     /*  10564 */     // MIs[1] Operand 1
     /*  10564 */     // No operand predicates
     /*  10564 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  10568 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  10570 */     // (sub:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_t2_so_imm>>:$imm, rGPR:{ *:[i32] }:$Rn)  =>  (t2RSBri:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  10570 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2RSBri),
     /*  10573 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  10575 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  10577 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  10580 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  10583 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  10589 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  10595 */     GIR_RootConstrainSelectedInstOperands,
     /*  10596 */     // GIR_Coverage, 427,
     /*  10596 */     GIR_EraseRootFromParent_Done,
     /*  10597 */   // Label 236: @10597
     /*  10597 */   GIM_Try, /*On fail goto*//*Label 237*/ GIMT_Encode4(10654), // Rule ID 76 //
     /*  10602 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  10605 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  10609 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  10613 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  10617 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  10621 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_mod_imm),
     /*  10625 */     // MIs[1] Operand 1
     /*  10625 */     // No operand predicates
     /*  10625 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  10627 */     // (sub:{ *:[i32] } GPR:{ *:[i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_mod_imm>>:$imm)  =>  (SUBri:{ *:[i32] } GPR:{ *:[i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  10627 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SUBri),
     /*  10630 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  10632 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  10634 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  10637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  10640 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  10646 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  10652 */     GIR_RootConstrainSelectedInstOperands,
     /*  10653 */     // GIR_Coverage, 76,
     /*  10653 */     GIR_EraseRootFromParent_Done,
     /*  10654 */   // Label 237: @10654
     /*  10654 */   GIM_Try, /*On fail goto*//*Label 238*/ GIMT_Encode4(10711), // Rule ID 411 //
     /*  10659 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /*  10662 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  10666 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  10670 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  10674 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  10678 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_t2_so_imm),
     /*  10682 */     // MIs[1] Operand 1
     /*  10682 */     // No operand predicates
     /*  10682 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  10684 */     // (sub:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_t2_so_imm>>:$imm)  =>  (t2SUBri:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  10684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SUBri),
     /*  10687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  10689 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  10691 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  10694 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  10697 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  10703 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  10709 */     GIR_RootConstrainSelectedInstOperands,
     /*  10710 */     // GIR_Coverage, 411,
     /*  10710 */     GIR_EraseRootFromParent_Done,
     /*  10711 */   // Label 238: @10711
     /*  10711 */   GIM_Try, /*On fail goto*//*Label 239*/ GIMT_Encode4(10762), // Rule ID 412 //
     /*  10716 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /*  10719 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  10723 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  10727 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  10731 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  10735 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_4095),
     /*  10739 */     // MIs[1] Operand 1
     /*  10739 */     // No operand predicates
     /*  10739 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  10741 */     // (sub:{ *:[i32] } GPR:{ *:[i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_imm0_4095>>:$imm)  =>  (t2SUBri12:{ *:[i32] } GPR:{ *:[i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  10741 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SUBri12),
     /*  10744 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  10746 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  10748 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  10751 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  10754 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  10760 */     GIR_RootConstrainSelectedInstOperands,
     /*  10761 */     // GIR_Coverage, 412,
     /*  10761 */     GIR_EraseRootFromParent_Done,
     /*  10762 */   // Label 239: @10762
     /*  10762 */   GIM_Try, /*On fail goto*//*Label 240*/ GIMT_Encode4(10832), // Rule ID 173 //
     /*  10767 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6T2_IsARM_UseMulOps),
     /*  10770 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  10774 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  10778 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  10782 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*  10786 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  10790 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  10794 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  10799 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  10804 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  10806 */     // (sub:{ *:[i32] } GPR:{ *:[i32] }:$Ra, (mul:{ *:[i32] } GPR:{ *:[i32] }:$Rn, GPR:{ *:[i32] }:$Rm))  =>  (MLS:{ *:[i32] } GPR:{ *:[i32] }:$Rn, GPR:{ *:[i32] }:$Rm, GPR:{ *:[i32] }:$Ra)
     /*  10806 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MLS),
     /*  10809 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  10811 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  10815 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  10819 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ra
     /*  10821 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  10824 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  10830 */     GIR_RootConstrainSelectedInstOperands,
     /*  10831 */     // GIR_Coverage, 173,
     /*  10831 */     GIR_EraseRootFromParent_Done,
     /*  10832 */   // Label 240: @10832
     /*  10832 */   GIM_Try, /*On fail goto*//*Label 241*/ GIMT_Encode4(10902), // Rule ID 504 //
     /*  10837 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2_UseMulOps),
     /*  10840 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  10844 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  10848 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  10852 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*  10856 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  10860 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  10864 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  10869 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  10874 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  10876 */     // (sub:{ *:[i32] } rGPR:{ *:[i32] }:$Ra, (mul:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm))  =>  (t2MLS:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm, rGPR:{ *:[i32] }:$Ra)
     /*  10876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2MLS),
     /*  10879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  10881 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  10885 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  10889 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ra
     /*  10891 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  10894 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  10900 */     GIR_RootConstrainSelectedInstOperands,
     /*  10901 */     // GIR_Coverage, 504,
     /*  10901 */     GIR_EraseRootFromParent_Done,
     /*  10902 */   // Label 241: @10902
     /*  10902 */   GIM_Try, /*On fail goto*//*Label 242*/ GIMT_Encode4(10948), // Rule ID 77 //
     /*  10907 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  10910 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  10914 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  10918 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  10922 */     // (sub:{ *:[i32] } GPR:{ *:[i32] }:$Rn, GPR:{ *:[i32] }:$Rm)  =>  (SUBrr:{ *:[i32] } GPR:{ *:[i32] }:$Rn, GPR:{ *:[i32] }:$Rm)
     /*  10922 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SUBrr),
     /*  10925 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  10927 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  10929 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /*  10931 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  10934 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  10940 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  10946 */     GIR_RootConstrainSelectedInstOperands,
     /*  10947 */     // GIR_Coverage, 77,
     /*  10947 */     GIR_EraseRootFromParent_Done,
     /*  10948 */   // Label 242: @10948
     /*  10948 */   GIM_Try, /*On fail goto*//*Label 243*/ GIMT_Encode4(10994), // Rule ID 333 //
     /*  10953 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb_IsThumb1Only),
     /*  10956 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /*  10960 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /*  10964 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /*  10968 */     // (sub:{ *:[i32] } tGPR:{ *:[i32] }:$Rn, tGPR:{ *:[i32] }:$Rm)  =>  (tSUBrr:{ *:[i32] } tGPR:{ *:[i32] }:$Rn, tGPR:{ *:[i32] }:$Rm)
     /*  10968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::tSUBrr),
     /*  10971 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  10973 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::CPSR), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define | RegState::Dead),
     /*  10979 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  10981 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /*  10983 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  10986 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  10992 */     GIR_RootConstrainSelectedInstOperands,
     /*  10993 */     // GIR_Coverage, 333,
     /*  10993 */     GIR_EraseRootFromParent_Done,
     /*  10994 */   // Label 243: @10994
     /*  10994 */   GIM_Try, /*On fail goto*//*Label 244*/ GIMT_Encode4(11040), // Rule ID 413 //
     /*  10999 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /*  11002 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  11006 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  11010 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  11014 */     // (sub:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2SUBrr:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  11014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SUBrr),
     /*  11017 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  11019 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  11021 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /*  11023 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  11026 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  11032 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  11038 */     GIR_RootConstrainSelectedInstOperands,
     /*  11039 */     // GIR_Coverage, 413,
     /*  11039 */     GIR_EraseRootFromParent_Done,
     /*  11040 */   // Label 244: @11040
     /*  11040 */   GIM_Reject,
     /*  11041 */ // Label 233: @11041
     /*  11041 */ GIM_Reject,
     /*  11042 */ // Label 224: @11042
     /*  11042 */ GIM_Try, /*On fail goto*//*Label 245*/ GIMT_Encode4(11088), // Rule ID 963 //
     /*  11047 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  11050 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  11053 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  11056 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  11060 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  11064 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  11068 */   // (sub:{ *:[v1i64] } DPR:{ *:[v1i64] }:$Vn, DPR:{ *:[v1i64] }:$Vm)  =>  (VSUBv1i64:{ *:[v1i64] } DPR:{ *:[v1i64] }:$Vn, DPR:{ *:[v1i64] }:$Vm)
     /*  11068 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSUBv1i64),
     /*  11071 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  11073 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*  11075 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  11077 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  11080 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  11086 */   GIR_RootConstrainSelectedInstOperands,
     /*  11087 */   // GIR_Coverage, 963,
     /*  11087 */   GIR_EraseRootFromParent_Done,
     /*  11088 */ // Label 245: @11088
     /*  11088 */ GIM_Reject,
     /*  11089 */ // Label 225: @11089
     /*  11089 */ GIM_Try, /*On fail goto*//*Label 246*/ GIMT_Encode4(11203),
     /*  11094 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  11097 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  11100 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  11104 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  11108 */   GIM_Try, /*On fail goto*//*Label 247*/ GIMT_Encode4(11170), // Rule ID 914 //
     /*  11113 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  11116 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  11120 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*  11124 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  11128 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  11132 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  11137 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  11142 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  11144 */     // (sub:{ *:[v2i32] } DPR:{ *:[v2i32] }:$src1, (mul:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm))  =>  (VMLSv2i32:{ *:[v2i32] } DPR:{ *:[v2i32] }:$src1, DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /*  11144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMLSv2i32),
     /*  11147 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  11149 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  11151 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*  11155 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /*  11159 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  11162 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  11168 */     GIR_RootConstrainSelectedInstOperands,
     /*  11169 */     // GIR_Coverage, 914,
     /*  11169 */     GIR_EraseRootFromParent_Done,
     /*  11170 */   // Label 247: @11170
     /*  11170 */   GIM_Try, /*On fail goto*//*Label 248*/ GIMT_Encode4(11202), // Rule ID 959 //
     /*  11175 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  11178 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  11182 */     // (sub:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)  =>  (VSUBv2i32:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /*  11182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSUBv2i32),
     /*  11185 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  11187 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*  11189 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  11191 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  11194 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  11200 */     GIR_RootConstrainSelectedInstOperands,
     /*  11201 */     // GIR_Coverage, 959,
     /*  11201 */     GIR_EraseRootFromParent_Done,
     /*  11202 */   // Label 248: @11202
     /*  11202 */   GIM_Reject,
     /*  11203 */ // Label 246: @11203
     /*  11203 */ GIM_Reject,
     /*  11204 */ // Label 226: @11204
     /*  11204 */ GIM_Try, /*On fail goto*//*Label 249*/ GIMT_Encode4(11755),
     /*  11209 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  11212 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  11215 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  11219 */   GIM_Try, /*On fail goto*//*Label 250*/ GIMT_Encode4(11287), // Rule ID 983 //
     /*  11224 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  11227 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  11231 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  11235 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  11239 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  11244 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  11248 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  11252 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  11256 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  11261 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  11263 */     // (sub:{ *:[v2i64] } (anyext:{ *:[v2i64] } DPR:{ *:[v2i32] }:$Vn), (anyext:{ *:[v2i64] } DPR:{ *:[v2i32] }:$Vm))  =>  (VSUBLuv2i64:{ *:[v2i64] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /*  11263 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSUBLuv2i64),
     /*  11266 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  11268 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*  11272 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Vm
     /*  11276 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  11279 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  11285 */     GIR_RootConstrainSelectedInstOperands,
     /*  11286 */     // GIR_Coverage, 983,
     /*  11286 */     GIR_EraseRootFromParent_Done,
     /*  11287 */   // Label 250: @11287
     /*  11287 */   GIM_Try, /*On fail goto*//*Label 251*/ GIMT_Encode4(11355), // Rule ID 982 //
     /*  11292 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  11295 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  11299 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  11303 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  11307 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  11312 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  11316 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  11320 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  11324 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  11329 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  11331 */     // (sub:{ *:[v2i64] } (anyext:{ *:[v2i64] } DPR:{ *:[v2i32] }:$Vn), (zext:{ *:[v2i64] } DPR:{ *:[v2i32] }:$Vm))  =>  (VSUBLuv2i64:{ *:[v2i64] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /*  11331 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSUBLuv2i64),
     /*  11334 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  11336 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*  11340 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Vm
     /*  11344 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  11347 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  11353 */     GIR_RootConstrainSelectedInstOperands,
     /*  11354 */     // GIR_Coverage, 982,
     /*  11354 */     GIR_EraseRootFromParent_Done,
     /*  11355 */   // Label 251: @11355
     /*  11355 */   GIM_Try, /*On fail goto*//*Label 252*/ GIMT_Encode4(11423), // Rule ID 971 //
     /*  11360 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  11363 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  11367 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  11371 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  11375 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  11380 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  11384 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  11388 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  11392 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  11397 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  11399 */     // (sub:{ *:[v2i64] } (sext:{ *:[v2i64] } DPR:{ *:[v2i32] }:$Vn), (sext:{ *:[v2i64] } DPR:{ *:[v2i32] }:$Vm))  =>  (VSUBLsv2i64:{ *:[v2i64] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /*  11399 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSUBLsv2i64),
     /*  11402 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  11404 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*  11408 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Vm
     /*  11412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  11415 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  11421 */     GIR_RootConstrainSelectedInstOperands,
     /*  11422 */     // GIR_Coverage, 971,
     /*  11422 */     GIR_EraseRootFromParent_Done,
     /*  11423 */   // Label 252: @11423
     /*  11423 */   GIM_Try, /*On fail goto*//*Label 253*/ GIMT_Encode4(11491), // Rule ID 981 //
     /*  11428 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  11431 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  11435 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  11439 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  11443 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  11448 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  11452 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  11456 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  11460 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  11465 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  11467 */     // (sub:{ *:[v2i64] } (zext:{ *:[v2i64] } DPR:{ *:[v2i32] }:$Vn), (anyext:{ *:[v2i64] } DPR:{ *:[v2i32] }:$Vm))  =>  (VSUBLuv2i64:{ *:[v2i64] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /*  11467 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSUBLuv2i64),
     /*  11470 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  11472 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*  11476 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Vm
     /*  11480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  11483 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  11489 */     GIR_RootConstrainSelectedInstOperands,
     /*  11490 */     // GIR_Coverage, 981,
     /*  11490 */     GIR_EraseRootFromParent_Done,
     /*  11491 */   // Label 253: @11491
     /*  11491 */   GIM_Try, /*On fail goto*//*Label 254*/ GIMT_Encode4(11559), // Rule ID 980 //
     /*  11496 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  11499 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  11503 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  11507 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  11511 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  11516 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  11520 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  11524 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  11528 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  11533 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  11535 */     // (sub:{ *:[v2i64] } (zext:{ *:[v2i64] } DPR:{ *:[v2i32] }:$Vn), (zext:{ *:[v2i64] } DPR:{ *:[v2i32] }:$Vm))  =>  (VSUBLuv2i64:{ *:[v2i64] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /*  11535 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSUBLuv2i64),
     /*  11538 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  11540 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*  11544 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Vm
     /*  11548 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  11551 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  11557 */     GIR_RootConstrainSelectedInstOperands,
     /*  11558 */     // GIR_Coverage, 980,
     /*  11558 */     GIR_EraseRootFromParent_Done,
     /*  11559 */   // Label 254: @11559
     /*  11559 */   GIM_Try, /*On fail goto*//*Label 255*/ GIMT_Encode4(11612), // Rule ID 992 //
     /*  11564 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  11567 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  11571 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  11575 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  11579 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  11583 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  11588 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  11590 */     // (sub:{ *:[v2i64] } QPR:{ *:[v2i64] }:$Vn, (anyext:{ *:[v2i64] } DPR:{ *:[v2i32] }:$Vm))  =>  (VSUBWuv2i64:{ *:[v2i64] } QPR:{ *:[v2i64] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /*  11590 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSUBWuv2i64),
     /*  11593 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  11595 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*  11597 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vm
     /*  11601 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  11604 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  11610 */     GIR_RootConstrainSelectedInstOperands,
     /*  11611 */     // GIR_Coverage, 992,
     /*  11611 */     GIR_EraseRootFromParent_Done,
     /*  11612 */   // Label 255: @11612
     /*  11612 */   GIM_Try, /*On fail goto*//*Label 256*/ GIMT_Encode4(11665), // Rule ID 986 //
     /*  11617 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  11620 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  11624 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  11628 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  11632 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  11636 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  11641 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  11643 */     // (sub:{ *:[v2i64] } QPR:{ *:[v2i64] }:$Vn, (sext:{ *:[v2i64] } DPR:{ *:[v2i32] }:$Vm))  =>  (VSUBWsv2i64:{ *:[v2i64] } QPR:{ *:[v2i64] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /*  11643 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSUBWsv2i64),
     /*  11646 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  11648 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*  11650 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vm
     /*  11654 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  11657 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  11663 */     GIR_RootConstrainSelectedInstOperands,
     /*  11664 */     // GIR_Coverage, 986,
     /*  11664 */     GIR_EraseRootFromParent_Done,
     /*  11665 */   // Label 256: @11665
     /*  11665 */   GIM_Try, /*On fail goto*//*Label 257*/ GIMT_Encode4(11718), // Rule ID 991 //
     /*  11670 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  11673 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  11677 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  11681 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  11685 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  11689 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  11694 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  11696 */     // (sub:{ *:[v2i64] } QPR:{ *:[v2i64] }:$Vn, (zext:{ *:[v2i64] } DPR:{ *:[v2i32] }:$Vm))  =>  (VSUBWuv2i64:{ *:[v2i64] } QPR:{ *:[v2i64] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /*  11696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSUBWuv2i64),
     /*  11699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  11701 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*  11703 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vm
     /*  11707 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  11710 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  11716 */     GIR_RootConstrainSelectedInstOperands,
     /*  11717 */     // GIR_Coverage, 991,
     /*  11717 */     GIR_EraseRootFromParent_Done,
     /*  11718 */   // Label 257: @11718
     /*  11718 */   GIM_Try, /*On fail goto*//*Label 258*/ GIMT_Encode4(11754), // Rule ID 964 //
     /*  11723 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  11726 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  11730 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  11734 */     // (sub:{ *:[v2i64] } QPR:{ *:[v2i64] }:$Vn, QPR:{ *:[v2i64] }:$Vm)  =>  (VSUBv2i64:{ *:[v2i64] } QPR:{ *:[v2i64] }:$Vn, QPR:{ *:[v2i64] }:$Vm)
     /*  11734 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSUBv2i64),
     /*  11737 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  11739 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*  11741 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  11743 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  11746 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  11752 */     GIR_RootConstrainSelectedInstOperands,
     /*  11753 */     // GIR_Coverage, 964,
     /*  11753 */     GIR_EraseRootFromParent_Done,
     /*  11754 */   // Label 258: @11754
     /*  11754 */   GIM_Reject,
     /*  11755 */ // Label 249: @11755
     /*  11755 */ GIM_Reject,
     /*  11756 */ // Label 227: @11756
     /*  11756 */ GIM_Try, /*On fail goto*//*Label 259*/ GIMT_Encode4(11870),
     /*  11761 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  11764 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  11767 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  11771 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  11775 */   GIM_Try, /*On fail goto*//*Label 260*/ GIMT_Encode4(11837), // Rule ID 913 //
     /*  11780 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  11783 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  11787 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*  11791 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  11795 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  11799 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  11804 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  11809 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  11811 */     // (sub:{ *:[v4i16] } DPR:{ *:[v4i16] }:$src1, (mul:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm))  =>  (VMLSv4i16:{ *:[v4i16] } DPR:{ *:[v4i16] }:$src1, DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /*  11811 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMLSv4i16),
     /*  11814 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  11816 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  11818 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*  11822 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /*  11826 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  11829 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  11835 */     GIR_RootConstrainSelectedInstOperands,
     /*  11836 */     // GIR_Coverage, 913,
     /*  11836 */     GIR_EraseRootFromParent_Done,
     /*  11837 */   // Label 260: @11837
     /*  11837 */   GIM_Try, /*On fail goto*//*Label 261*/ GIMT_Encode4(11869), // Rule ID 958 //
     /*  11842 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  11845 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  11849 */     // (sub:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)  =>  (VSUBv4i16:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /*  11849 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSUBv4i16),
     /*  11852 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  11854 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*  11856 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  11858 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  11861 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  11867 */     GIR_RootConstrainSelectedInstOperands,
     /*  11868 */     // GIR_Coverage, 958,
     /*  11868 */     GIR_EraseRootFromParent_Done,
     /*  11869 */   // Label 261: @11869
     /*  11869 */   GIM_Reject,
     /*  11870 */ // Label 259: @11870
     /*  11870 */ GIM_Reject,
     /*  11871 */ // Label 228: @11871
     /*  11871 */ GIM_Try, /*On fail goto*//*Label 262*/ GIMT_Encode4(12585),
     /*  11876 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  11879 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  11882 */   GIM_Try, /*On fail goto*//*Label 263*/ GIMT_Encode4(11954), // Rule ID 979 //
     /*  11887 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  11890 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  11894 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  11898 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  11902 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  11906 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  11911 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  11915 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  11919 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  11923 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  11928 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  11930 */     // (sub:{ *:[v4i32] } (anyext:{ *:[v4i32] } DPR:{ *:[v4i16] }:$Vn), (anyext:{ *:[v4i32] } DPR:{ *:[v4i16] }:$Vm))  =>  (VSUBLuv4i32:{ *:[v4i32] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /*  11930 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSUBLuv4i32),
     /*  11933 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  11935 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*  11939 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Vm
     /*  11943 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  11946 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  11952 */     GIR_RootConstrainSelectedInstOperands,
     /*  11953 */     // GIR_Coverage, 979,
     /*  11953 */     GIR_EraseRootFromParent_Done,
     /*  11954 */   // Label 263: @11954
     /*  11954 */   GIM_Try, /*On fail goto*//*Label 264*/ GIMT_Encode4(12026), // Rule ID 978 //
     /*  11959 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  11962 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  11966 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  11970 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  11974 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  11978 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  11983 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  11987 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  11991 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  11995 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  12000 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  12002 */     // (sub:{ *:[v4i32] } (anyext:{ *:[v4i32] } DPR:{ *:[v4i16] }:$Vn), (zext:{ *:[v4i32] } DPR:{ *:[v4i16] }:$Vm))  =>  (VSUBLuv4i32:{ *:[v4i32] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /*  12002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSUBLuv4i32),
     /*  12005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  12007 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*  12011 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Vm
     /*  12015 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  12018 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  12024 */     GIR_RootConstrainSelectedInstOperands,
     /*  12025 */     // GIR_Coverage, 978,
     /*  12025 */     GIR_EraseRootFromParent_Done,
     /*  12026 */   // Label 264: @12026
     /*  12026 */   GIM_Try, /*On fail goto*//*Label 265*/ GIMT_Encode4(12098), // Rule ID 970 //
     /*  12031 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  12034 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  12038 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  12042 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  12046 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  12050 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  12055 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  12059 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  12063 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  12067 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  12072 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  12074 */     // (sub:{ *:[v4i32] } (sext:{ *:[v4i32] } DPR:{ *:[v4i16] }:$Vn), (sext:{ *:[v4i32] } DPR:{ *:[v4i16] }:$Vm))  =>  (VSUBLsv4i32:{ *:[v4i32] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /*  12074 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSUBLsv4i32),
     /*  12077 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  12079 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*  12083 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Vm
     /*  12087 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  12090 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  12096 */     GIR_RootConstrainSelectedInstOperands,
     /*  12097 */     // GIR_Coverage, 970,
     /*  12097 */     GIR_EraseRootFromParent_Done,
     /*  12098 */   // Label 265: @12098
     /*  12098 */   GIM_Try, /*On fail goto*//*Label 266*/ GIMT_Encode4(12170), // Rule ID 977 //
     /*  12103 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  12106 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  12110 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  12114 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  12118 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  12122 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  12127 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  12131 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  12135 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  12139 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  12144 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  12146 */     // (sub:{ *:[v4i32] } (zext:{ *:[v4i32] } DPR:{ *:[v4i16] }:$Vn), (anyext:{ *:[v4i32] } DPR:{ *:[v4i16] }:$Vm))  =>  (VSUBLuv4i32:{ *:[v4i32] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /*  12146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSUBLuv4i32),
     /*  12149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  12151 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*  12155 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Vm
     /*  12159 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  12162 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  12168 */     GIR_RootConstrainSelectedInstOperands,
     /*  12169 */     // GIR_Coverage, 977,
     /*  12169 */     GIR_EraseRootFromParent_Done,
     /*  12170 */   // Label 266: @12170
     /*  12170 */   GIM_Try, /*On fail goto*//*Label 267*/ GIMT_Encode4(12242), // Rule ID 976 //
     /*  12175 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  12178 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  12182 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  12186 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  12190 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  12194 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  12199 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  12203 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  12207 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  12211 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  12216 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  12218 */     // (sub:{ *:[v4i32] } (zext:{ *:[v4i32] } DPR:{ *:[v4i16] }:$Vn), (zext:{ *:[v4i32] } DPR:{ *:[v4i16] }:$Vm))  =>  (VSUBLuv4i32:{ *:[v4i32] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /*  12218 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSUBLuv4i32),
     /*  12221 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  12223 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*  12227 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Vm
     /*  12231 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  12234 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  12240 */     GIR_RootConstrainSelectedInstOperands,
     /*  12241 */     // GIR_Coverage, 976,
     /*  12241 */     GIR_EraseRootFromParent_Done,
     /*  12242 */   // Label 267: @12242
     /*  12242 */   GIM_Try, /*On fail goto*//*Label 268*/ GIMT_Encode4(12312), // Rule ID 917 //
     /*  12247 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  12250 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  12254 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  12258 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  12262 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*  12266 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  12270 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  12274 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  12279 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  12284 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  12286 */     // (sub:{ *:[v4i32] } QPR:{ *:[v4i32] }:$src1, (mul:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm))  =>  (VMLSv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$src1, QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)
     /*  12286 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMLSv4i32),
     /*  12289 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  12291 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  12293 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*  12297 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /*  12301 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  12304 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  12310 */     GIR_RootConstrainSelectedInstOperands,
     /*  12311 */     // GIR_Coverage, 917,
     /*  12311 */     GIR_EraseRootFromParent_Done,
     /*  12312 */   // Label 268: @12312
     /*  12312 */   GIM_Try, /*On fail goto*//*Label 269*/ GIMT_Encode4(12369), // Rule ID 990 //
     /*  12317 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  12320 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  12324 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  12328 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  12332 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  12336 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  12340 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  12345 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  12347 */     // (sub:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, (anyext:{ *:[v4i32] } DPR:{ *:[v4i16] }:$Vm))  =>  (VSUBWuv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /*  12347 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSUBWuv4i32),
     /*  12350 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  12352 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*  12354 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vm
     /*  12358 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  12361 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  12367 */     GIR_RootConstrainSelectedInstOperands,
     /*  12368 */     // GIR_Coverage, 990,
     /*  12368 */     GIR_EraseRootFromParent_Done,
     /*  12369 */   // Label 269: @12369
     /*  12369 */   GIM_Try, /*On fail goto*//*Label 270*/ GIMT_Encode4(12426), // Rule ID 985 //
     /*  12374 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  12377 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  12381 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  12385 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  12389 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  12393 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  12397 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  12402 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  12404 */     // (sub:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, (sext:{ *:[v4i32] } DPR:{ *:[v4i16] }:$Vm))  =>  (VSUBWsv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /*  12404 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSUBWsv4i32),
     /*  12407 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  12409 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*  12411 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vm
     /*  12415 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  12418 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  12424 */     GIR_RootConstrainSelectedInstOperands,
     /*  12425 */     // GIR_Coverage, 985,
     /*  12425 */     GIR_EraseRootFromParent_Done,
     /*  12426 */   // Label 270: @12426
     /*  12426 */   GIM_Try, /*On fail goto*//*Label 271*/ GIMT_Encode4(12483), // Rule ID 989 //
     /*  12431 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  12434 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  12438 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  12442 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  12446 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  12450 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  12454 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  12459 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  12461 */     // (sub:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, (zext:{ *:[v4i32] } DPR:{ *:[v4i16] }:$Vm))  =>  (VSUBWuv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /*  12461 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSUBWuv4i32),
     /*  12464 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  12466 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*  12468 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vm
     /*  12472 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  12475 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  12481 */     GIR_RootConstrainSelectedInstOperands,
     /*  12482 */     // GIR_Coverage, 989,
     /*  12482 */     GIR_EraseRootFromParent_Done,
     /*  12483 */   // Label 271: @12483
     /*  12483 */   GIM_Try, /*On fail goto*//*Label 272*/ GIMT_Encode4(12523), // Rule ID 962 //
     /*  12488 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  12491 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  12495 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  12499 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  12503 */     // (sub:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)  =>  (VSUBv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)
     /*  12503 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSUBv4i32),
     /*  12506 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  12508 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*  12510 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  12512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  12515 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  12521 */     GIR_RootConstrainSelectedInstOperands,
     /*  12522 */     // GIR_Coverage, 962,
     /*  12522 */     GIR_EraseRootFromParent_Done,
     /*  12523 */   // Label 272: @12523
     /*  12523 */   GIM_Try, /*On fail goto*//*Label 273*/ GIMT_Encode4(12584), // Rule ID 3505 //
     /*  12528 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  12531 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  12535 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  12539 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  12543 */     // (sub:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)  =>  (MVE_VSUBi32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)
     /*  12543 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  12546 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  12550 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  12555 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSUBi32),
     /*  12558 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  12560 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /*  12562 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /*  12564 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  12567 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  12573 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  12579 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  12582 */     GIR_RootConstrainSelectedInstOperands,
     /*  12583 */     // GIR_Coverage, 3505,
     /*  12583 */     GIR_EraseRootFromParent_Done,
     /*  12584 */   // Label 273: @12584
     /*  12584 */   GIM_Reject,
     /*  12585 */ // Label 262: @12585
     /*  12585 */ GIM_Reject,
     /*  12586 */ // Label 229: @12586
     /*  12586 */ GIM_Try, /*On fail goto*//*Label 274*/ GIMT_Encode4(12700),
     /*  12591 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  12594 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  12597 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  12601 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  12605 */   GIM_Try, /*On fail goto*//*Label 275*/ GIMT_Encode4(12667), // Rule ID 912 //
     /*  12610 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  12613 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  12617 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*  12621 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  12625 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  12629 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  12634 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  12639 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  12641 */     // (sub:{ *:[v8i8] } DPR:{ *:[v8i8] }:$src1, (mul:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm))  =>  (VMLSv8i8:{ *:[v8i8] } DPR:{ *:[v8i8] }:$src1, DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /*  12641 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMLSv8i8),
     /*  12644 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  12646 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  12648 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*  12652 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /*  12656 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  12659 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  12665 */     GIR_RootConstrainSelectedInstOperands,
     /*  12666 */     // GIR_Coverage, 912,
     /*  12666 */     GIR_EraseRootFromParent_Done,
     /*  12667 */   // Label 275: @12667
     /*  12667 */   GIM_Try, /*On fail goto*//*Label 276*/ GIMT_Encode4(12699), // Rule ID 957 //
     /*  12672 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  12675 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  12679 */     // (sub:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)  =>  (VSUBv8i8:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /*  12679 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSUBv8i8),
     /*  12682 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  12684 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*  12686 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  12688 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  12691 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  12697 */     GIR_RootConstrainSelectedInstOperands,
     /*  12698 */     // GIR_Coverage, 957,
     /*  12698 */     GIR_EraseRootFromParent_Done,
     /*  12699 */   // Label 276: @12699
     /*  12699 */   GIM_Reject,
     /*  12700 */ // Label 274: @12700
     /*  12700 */ GIM_Reject,
     /*  12701 */ // Label 230: @12701
     /*  12701 */ GIM_Try, /*On fail goto*//*Label 277*/ GIMT_Encode4(13415),
     /*  12706 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  12709 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  12712 */   GIM_Try, /*On fail goto*//*Label 278*/ GIMT_Encode4(12784), // Rule ID 975 //
     /*  12717 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  12720 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  12724 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  12728 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  12732 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  12736 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  12741 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  12745 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  12749 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  12753 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  12758 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  12760 */     // (sub:{ *:[v8i16] } (anyext:{ *:[v8i16] } DPR:{ *:[v8i8] }:$Vn), (anyext:{ *:[v8i16] } DPR:{ *:[v8i8] }:$Vm))  =>  (VSUBLuv8i16:{ *:[v8i16] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /*  12760 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSUBLuv8i16),
     /*  12763 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  12765 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*  12769 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Vm
     /*  12773 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  12776 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  12782 */     GIR_RootConstrainSelectedInstOperands,
     /*  12783 */     // GIR_Coverage, 975,
     /*  12783 */     GIR_EraseRootFromParent_Done,
     /*  12784 */   // Label 278: @12784
     /*  12784 */   GIM_Try, /*On fail goto*//*Label 279*/ GIMT_Encode4(12856), // Rule ID 974 //
     /*  12789 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  12792 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  12796 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  12800 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  12804 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  12808 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  12813 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  12817 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  12821 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  12825 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  12830 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  12832 */     // (sub:{ *:[v8i16] } (anyext:{ *:[v8i16] } DPR:{ *:[v8i8] }:$Vn), (zext:{ *:[v8i16] } DPR:{ *:[v8i8] }:$Vm))  =>  (VSUBLuv8i16:{ *:[v8i16] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /*  12832 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSUBLuv8i16),
     /*  12835 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  12837 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*  12841 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Vm
     /*  12845 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  12848 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  12854 */     GIR_RootConstrainSelectedInstOperands,
     /*  12855 */     // GIR_Coverage, 974,
     /*  12855 */     GIR_EraseRootFromParent_Done,
     /*  12856 */   // Label 279: @12856
     /*  12856 */   GIM_Try, /*On fail goto*//*Label 280*/ GIMT_Encode4(12928), // Rule ID 969 //
     /*  12861 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  12864 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  12868 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  12872 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  12876 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  12880 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  12885 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  12889 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  12893 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  12897 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  12902 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  12904 */     // (sub:{ *:[v8i16] } (sext:{ *:[v8i16] } DPR:{ *:[v8i8] }:$Vn), (sext:{ *:[v8i16] } DPR:{ *:[v8i8] }:$Vm))  =>  (VSUBLsv8i16:{ *:[v8i16] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /*  12904 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSUBLsv8i16),
     /*  12907 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  12909 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*  12913 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Vm
     /*  12917 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  12920 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  12926 */     GIR_RootConstrainSelectedInstOperands,
     /*  12927 */     // GIR_Coverage, 969,
     /*  12927 */     GIR_EraseRootFromParent_Done,
     /*  12928 */   // Label 280: @12928
     /*  12928 */   GIM_Try, /*On fail goto*//*Label 281*/ GIMT_Encode4(13000), // Rule ID 973 //
     /*  12933 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  12936 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  12940 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  12944 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  12948 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  12952 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  12957 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  12961 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  12965 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  12969 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  12974 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  12976 */     // (sub:{ *:[v8i16] } (zext:{ *:[v8i16] } DPR:{ *:[v8i8] }:$Vn), (anyext:{ *:[v8i16] } DPR:{ *:[v8i8] }:$Vm))  =>  (VSUBLuv8i16:{ *:[v8i16] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /*  12976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSUBLuv8i16),
     /*  12979 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  12981 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*  12985 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Vm
     /*  12989 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  12992 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  12998 */     GIR_RootConstrainSelectedInstOperands,
     /*  12999 */     // GIR_Coverage, 973,
     /*  12999 */     GIR_EraseRootFromParent_Done,
     /*  13000 */   // Label 281: @13000
     /*  13000 */   GIM_Try, /*On fail goto*//*Label 282*/ GIMT_Encode4(13072), // Rule ID 972 //
     /*  13005 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  13008 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  13012 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  13016 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  13020 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  13024 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  13029 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  13033 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  13037 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  13041 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  13046 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  13048 */     // (sub:{ *:[v8i16] } (zext:{ *:[v8i16] } DPR:{ *:[v8i8] }:$Vn), (zext:{ *:[v8i16] } DPR:{ *:[v8i8] }:$Vm))  =>  (VSUBLuv8i16:{ *:[v8i16] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /*  13048 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSUBLuv8i16),
     /*  13051 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  13053 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*  13057 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Vm
     /*  13061 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  13064 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  13070 */     GIR_RootConstrainSelectedInstOperands,
     /*  13071 */     // GIR_Coverage, 972,
     /*  13071 */     GIR_EraseRootFromParent_Done,
     /*  13072 */   // Label 282: @13072
     /*  13072 */   GIM_Try, /*On fail goto*//*Label 283*/ GIMT_Encode4(13142), // Rule ID 916 //
     /*  13077 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  13080 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  13084 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  13088 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  13092 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*  13096 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  13100 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  13104 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  13109 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  13114 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  13116 */     // (sub:{ *:[v8i16] } QPR:{ *:[v8i16] }:$src1, (mul:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm))  =>  (VMLSv8i16:{ *:[v8i16] } QPR:{ *:[v8i16] }:$src1, QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)
     /*  13116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMLSv8i16),
     /*  13119 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  13121 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  13123 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*  13127 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /*  13131 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  13134 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  13140 */     GIR_RootConstrainSelectedInstOperands,
     /*  13141 */     // GIR_Coverage, 916,
     /*  13141 */     GIR_EraseRootFromParent_Done,
     /*  13142 */   // Label 283: @13142
     /*  13142 */   GIM_Try, /*On fail goto*//*Label 284*/ GIMT_Encode4(13199), // Rule ID 988 //
     /*  13147 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  13150 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  13154 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  13158 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  13162 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  13166 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  13170 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  13175 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  13177 */     // (sub:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, (anyext:{ *:[v8i16] } DPR:{ *:[v8i8] }:$Vm))  =>  (VSUBWuv8i16:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /*  13177 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSUBWuv8i16),
     /*  13180 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  13182 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*  13184 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vm
     /*  13188 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  13191 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  13197 */     GIR_RootConstrainSelectedInstOperands,
     /*  13198 */     // GIR_Coverage, 988,
     /*  13198 */     GIR_EraseRootFromParent_Done,
     /*  13199 */   // Label 284: @13199
     /*  13199 */   GIM_Try, /*On fail goto*//*Label 285*/ GIMT_Encode4(13256), // Rule ID 984 //
     /*  13204 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  13207 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  13211 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  13215 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  13219 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  13223 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  13227 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  13232 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  13234 */     // (sub:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, (sext:{ *:[v8i16] } DPR:{ *:[v8i8] }:$Vm))  =>  (VSUBWsv8i16:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /*  13234 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSUBWsv8i16),
     /*  13237 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  13239 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*  13241 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vm
     /*  13245 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  13248 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  13254 */     GIR_RootConstrainSelectedInstOperands,
     /*  13255 */     // GIR_Coverage, 984,
     /*  13255 */     GIR_EraseRootFromParent_Done,
     /*  13256 */   // Label 285: @13256
     /*  13256 */   GIM_Try, /*On fail goto*//*Label 286*/ GIMT_Encode4(13313), // Rule ID 987 //
     /*  13261 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  13264 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  13268 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  13272 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  13276 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  13280 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  13284 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  13289 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  13291 */     // (sub:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, (zext:{ *:[v8i16] } DPR:{ *:[v8i8] }:$Vm))  =>  (VSUBWuv8i16:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /*  13291 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSUBWuv8i16),
     /*  13294 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  13296 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*  13298 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vm
     /*  13302 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  13305 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  13311 */     GIR_RootConstrainSelectedInstOperands,
     /*  13312 */     // GIR_Coverage, 987,
     /*  13312 */     GIR_EraseRootFromParent_Done,
     /*  13313 */   // Label 286: @13313
     /*  13313 */   GIM_Try, /*On fail goto*//*Label 287*/ GIMT_Encode4(13353), // Rule ID 961 //
     /*  13318 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  13321 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  13325 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  13329 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  13333 */     // (sub:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)  =>  (VSUBv8i16:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)
     /*  13333 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSUBv8i16),
     /*  13336 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  13338 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*  13340 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  13342 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  13345 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  13351 */     GIR_RootConstrainSelectedInstOperands,
     /*  13352 */     // GIR_Coverage, 961,
     /*  13352 */     GIR_EraseRootFromParent_Done,
     /*  13353 */   // Label 287: @13353
     /*  13353 */   GIM_Try, /*On fail goto*//*Label 288*/ GIMT_Encode4(13414), // Rule ID 3501 //
     /*  13358 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  13361 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  13365 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  13369 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  13373 */     // (sub:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)  =>  (MVE_VSUBi16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)
     /*  13373 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  13376 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  13380 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  13385 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSUBi16),
     /*  13388 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  13390 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /*  13392 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /*  13394 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  13397 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  13403 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  13409 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  13412 */     GIR_RootConstrainSelectedInstOperands,
     /*  13413 */     // GIR_Coverage, 3501,
     /*  13413 */     GIR_EraseRootFromParent_Done,
     /*  13414 */   // Label 288: @13414
     /*  13414 */   GIM_Reject,
     /*  13415 */ // Label 277: @13415
     /*  13415 */ GIM_Reject,
     /*  13416 */ // Label 231: @13416
     /*  13416 */ GIM_Try, /*On fail goto*//*Label 289*/ GIMT_Encode4(13599),
     /*  13421 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  13424 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  13427 */   GIM_Try, /*On fail goto*//*Label 290*/ GIMT_Encode4(13497), // Rule ID 915 //
     /*  13432 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  13435 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  13439 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  13443 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  13447 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*  13451 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  13455 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  13459 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  13464 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  13469 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  13471 */     // (sub:{ *:[v16i8] } QPR:{ *:[v16i8] }:$src1, (mul:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm))  =>  (VMLSv16i8:{ *:[v16i8] } QPR:{ *:[v16i8] }:$src1, QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)
     /*  13471 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMLSv16i8),
     /*  13474 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  13476 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  13478 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*  13482 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /*  13486 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  13489 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  13495 */     GIR_RootConstrainSelectedInstOperands,
     /*  13496 */     // GIR_Coverage, 915,
     /*  13496 */     GIR_EraseRootFromParent_Done,
     /*  13497 */   // Label 290: @13497
     /*  13497 */   GIM_Try, /*On fail goto*//*Label 291*/ GIMT_Encode4(13537), // Rule ID 960 //
     /*  13502 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  13505 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  13509 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  13513 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  13517 */     // (sub:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)  =>  (VSUBv16i8:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)
     /*  13517 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSUBv16i8),
     /*  13520 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  13522 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*  13524 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  13526 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  13529 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  13535 */     GIR_RootConstrainSelectedInstOperands,
     /*  13536 */     // GIR_Coverage, 960,
     /*  13536 */     GIR_EraseRootFromParent_Done,
     /*  13537 */   // Label 291: @13537
     /*  13537 */   GIM_Try, /*On fail goto*//*Label 292*/ GIMT_Encode4(13598), // Rule ID 3497 //
     /*  13542 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  13545 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  13549 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  13553 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  13557 */     // (sub:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)  =>  (MVE_VSUBi8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)
     /*  13557 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  13560 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  13564 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  13569 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSUBi8),
     /*  13572 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  13574 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /*  13576 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /*  13578 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  13581 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  13587 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  13593 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  13596 */     GIR_RootConstrainSelectedInstOperands,
     /*  13597 */     // GIR_Coverage, 3497,
     /*  13597 */     GIR_EraseRootFromParent_Done,
     /*  13598 */   // Label 292: @13598
     /*  13598 */   GIM_Reject,
     /*  13599 */ // Label 289: @13599
     /*  13599 */ GIM_Reject,
     /*  13600 */ // Label 232: @13600
     /*  13600 */ GIM_Reject,
     /*  13601 */ // Label 2: @13601
     /*  13601 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(16), /*)*//*default:*//*Label 300*/ GIMT_Encode4(15304),
     /*  13612 */ /*GILLT_s32*//*Label 293*/ GIMT_Encode4(13672), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  13624 */ /*GILLT_v2s32*//*Label 294*/ GIMT_Encode4(14591), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  13636 */ /*GILLT_v4s16*//*Label 295*/ GIMT_Encode4(14638),
     /*  13640 */ /*GILLT_v4s32*//*Label 296*/ GIMT_Encode4(14685), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  13652 */ /*GILLT_v8s8*//*Label 297*/ GIMT_Encode4(14914),
     /*  13656 */ /*GILLT_v8s16*//*Label 298*/ GIMT_Encode4(14961), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  13668 */ /*GILLT_v16s8*//*Label 299*/ GIMT_Encode4(15190),
     /*  13672 */ // Label 293: @13672
     /*  13672 */ GIM_Try, /*On fail goto*//*Label 301*/ GIMT_Encode4(14590),
     /*  13677 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  13680 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  13683 */   GIM_Try, /*On fail goto*//*Label 302*/ GIMT_Encode4(13771), // Rule ID 186 //
     /*  13688 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV5TE_IsARM),
     /*  13691 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  13695 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  13699 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*  13703 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  13707 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  13711 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  13716 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 16,
     /*  13720 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  13724 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*  13728 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  13732 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  13736 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  13741 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 16,
     /*  13745 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  13747 */     // (mul:{ *:[i32] } (sra:{ *:[i32] } GPR:{ *:[i32] }:$Rn, 16:{ *:[i32] }), (sra:{ *:[i32] } GPR:{ *:[i32] }:$Rm, 16:{ *:[i32] }))  =>  (SMULTT:{ *:[i32] } GPR:{ *:[i32] }:$Rn, GPR:{ *:[i32] }:$Rm)
     /*  13747 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SMULTT),
     /*  13750 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  13752 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  13756 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  13760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  13763 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  13769 */     GIR_RootConstrainSelectedInstOperands,
     /*  13770 */     // GIR_Coverage, 186,
     /*  13770 */     GIR_EraseRootFromParent_Done,
     /*  13771 */   // Label 302: @13771
     /*  13771 */   GIM_Try, /*On fail goto*//*Label 303*/ GIMT_Encode4(13859), // Rule ID 515 //
     /*  13776 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  13779 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  13783 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  13787 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*  13791 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  13795 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  13799 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  13804 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 16,
     /*  13808 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  13812 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*  13816 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  13820 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  13824 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  13829 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 16,
     /*  13833 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  13835 */     // (mul:{ *:[i32] } (sra:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, 16:{ *:[i32] }), (sra:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, 16:{ *:[i32] }))  =>  (t2SMULTT:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  13835 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SMULTT),
     /*  13838 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  13840 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  13844 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  13848 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  13851 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  13857 */     GIR_RootConstrainSelectedInstOperands,
     /*  13858 */     // GIR_Coverage, 515,
     /*  13858 */     GIR_EraseRootFromParent_Done,
     /*  13859 */   // Label 303: @13859
     /*  13859 */   GIM_Try, /*On fail goto*//*Label 304*/ GIMT_Encode4(13950), // Rule ID 185 //
     /*  13864 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV5TE_IsARM),
     /*  13867 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  13871 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  13875 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*  13879 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  13883 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  13887 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  13892 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 16,
     /*  13896 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  13900 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  13904 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  13908 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  13913 */     // MIs[2] Operand 2
     /*  13913 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(16),
     /*  13924 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  13926 */     // (mul:{ *:[i32] } (sra:{ *:[i32] } GPR:{ *:[i32] }:$Rn, 16:{ *:[i32] }), (sext_inreg:{ *:[i32] } GPR:{ *:[i32] }:$Rm, i16:{ *:[Other] }))  =>  (SMULTB:{ *:[i32] } GPR:{ *:[i32] }:$Rn, GPR:{ *:[i32] }:$Rm)
     /*  13926 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SMULTB),
     /*  13929 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  13931 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  13935 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  13939 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  13942 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  13948 */     GIR_RootConstrainSelectedInstOperands,
     /*  13949 */     // GIR_Coverage, 185,
     /*  13949 */     GIR_EraseRootFromParent_Done,
     /*  13950 */   // Label 304: @13950
     /*  13950 */   GIM_Try, /*On fail goto*//*Label 305*/ GIMT_Encode4(14041), // Rule ID 514 //
     /*  13955 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  13958 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  13962 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  13966 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*  13970 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  13974 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  13978 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  13983 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 16,
     /*  13987 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  13991 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  13995 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  13999 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  14004 */     // MIs[2] Operand 2
     /*  14004 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(16),
     /*  14015 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  14017 */     // (mul:{ *:[i32] } (sra:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, 16:{ *:[i32] }), (sext_inreg:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, i16:{ *:[Other] }))  =>  (t2SMULTB:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  14017 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SMULTB),
     /*  14020 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  14022 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  14026 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  14030 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  14033 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  14039 */     GIR_RootConstrainSelectedInstOperands,
     /*  14040 */     // GIR_Coverage, 514,
     /*  14040 */     GIR_EraseRootFromParent_Done,
     /*  14041 */   // Label 305: @14041
     /*  14041 */   GIM_Try, /*On fail goto*//*Label 306*/ GIMT_Encode4(14132), // Rule ID 184 //
     /*  14046 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV5TE_IsARM),
     /*  14049 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  14053 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  14057 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  14061 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  14065 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  14070 */     // MIs[1] Operand 2
     /*  14070 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(16),
     /*  14081 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  14085 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*  14089 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  14093 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  14097 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  14102 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 16,
     /*  14106 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  14108 */     // (mul:{ *:[i32] } (sext_inreg:{ *:[i32] } GPR:{ *:[i32] }:$Rn, i16:{ *:[Other] }), (sra:{ *:[i32] } GPR:{ *:[i32] }:$Rm, 16:{ *:[i32] }))  =>  (SMULBT:{ *:[i32] } GPR:{ *:[i32] }:$Rn, GPR:{ *:[i32] }:$Rm)
     /*  14108 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SMULBT),
     /*  14111 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  14113 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  14117 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  14121 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  14124 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  14130 */     GIR_RootConstrainSelectedInstOperands,
     /*  14131 */     // GIR_Coverage, 184,
     /*  14131 */     GIR_EraseRootFromParent_Done,
     /*  14132 */   // Label 306: @14132
     /*  14132 */   GIM_Try, /*On fail goto*//*Label 307*/ GIMT_Encode4(14223), // Rule ID 513 //
     /*  14137 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  14140 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  14144 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  14148 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  14152 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  14156 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  14161 */     // MIs[1] Operand 2
     /*  14161 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(16),
     /*  14172 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  14176 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*  14180 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  14184 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  14188 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  14193 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 16,
     /*  14197 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  14199 */     // (mul:{ *:[i32] } (sext_inreg:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, i16:{ *:[Other] }), (sra:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, 16:{ *:[i32] }))  =>  (t2SMULBT:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  14199 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SMULBT),
     /*  14202 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  14204 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  14208 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  14212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  14215 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  14221 */     GIR_RootConstrainSelectedInstOperands,
     /*  14222 */     // GIR_Coverage, 513,
     /*  14222 */     GIR_EraseRootFromParent_Done,
     /*  14223 */   // Label 307: @14223
     /*  14223 */   GIM_Try, /*On fail goto*//*Label 308*/ GIMT_Encode4(14317), // Rule ID 183 //
     /*  14228 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV5TE_IsARM),
     /*  14231 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  14235 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  14239 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  14243 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  14247 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  14252 */     // MIs[1] Operand 2
     /*  14252 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(16),
     /*  14263 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  14267 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  14271 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  14275 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  14280 */     // MIs[2] Operand 2
     /*  14280 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(16),
     /*  14291 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  14293 */     // (mul:{ *:[i32] } (sext_inreg:{ *:[i32] } GPR:{ *:[i32] }:$Rn, i16:{ *:[Other] }), (sext_inreg:{ *:[i32] } GPR:{ *:[i32] }:$Rm, i16:{ *:[Other] }))  =>  (SMULBB:{ *:[i32] } GPR:{ *:[i32] }:$Rn, GPR:{ *:[i32] }:$Rm)
     /*  14293 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SMULBB),
     /*  14296 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  14298 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  14302 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  14306 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  14309 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  14315 */     GIR_RootConstrainSelectedInstOperands,
     /*  14316 */     // GIR_Coverage, 183,
     /*  14316 */     GIR_EraseRootFromParent_Done,
     /*  14317 */   // Label 308: @14317
     /*  14317 */   GIM_Try, /*On fail goto*//*Label 309*/ GIMT_Encode4(14411), // Rule ID 512 //
     /*  14322 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  14325 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  14329 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  14333 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  14337 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  14341 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  14346 */     // MIs[1] Operand 2
     /*  14346 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(16),
     /*  14357 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  14361 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  14365 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  14369 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  14374 */     // MIs[2] Operand 2
     /*  14374 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(16),
     /*  14385 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  14387 */     // (mul:{ *:[i32] } (sext_inreg:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, i16:{ *:[Other] }), (sext_inreg:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, i16:{ *:[Other] }))  =>  (t2SMULBB:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  14387 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SMULBB),
     /*  14390 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  14392 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  14396 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  14400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  14403 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  14409 */     GIR_RootConstrainSelectedInstOperands,
     /*  14410 */     // GIR_Coverage, 512,
     /*  14410 */     GIR_EraseRootFromParent_Done,
     /*  14411 */   // Label 309: @14411
     /*  14411 */   GIM_Try, /*On fail goto*//*Label 310*/ GIMT_Encode4(14457), // Rule ID 169 //
     /*  14416 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*  14419 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  14423 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  14427 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  14431 */     // (mul:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (MUL:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  14431 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MUL),
     /*  14434 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  14436 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  14438 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /*  14440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  14443 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  14449 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  14455 */     GIR_RootConstrainSelectedInstOperands,
     /*  14456 */     // GIR_Coverage, 169,
     /*  14456 */     GIR_EraseRootFromParent_Done,
     /*  14457 */   // Label 310: @14457
     /*  14457 */   GIM_Try, /*On fail goto*//*Label 311*/ GIMT_Encode4(14503), // Rule ID 170 //
     /*  14462 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM_NoV6_UseMulOps),
     /*  14465 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  14469 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  14473 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  14477 */     // (mul:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (MULv5:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  14477 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MULv5),
     /*  14480 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  14482 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  14484 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /*  14486 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  14489 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  14495 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  14501 */     GIR_RootConstrainSelectedInstOperands,
     /*  14502 */     // GIR_Coverage, 170,
     /*  14502 */     GIR_EraseRootFromParent_Done,
     /*  14503 */   // Label 311: @14503
     /*  14503 */   GIM_Try, /*On fail goto*//*Label 312*/ GIMT_Encode4(14549), // Rule ID 323 //
     /*  14508 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb_IsThumb1Only),
     /*  14511 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /*  14515 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /*  14519 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /*  14523 */     // (mul:{ *:[i32] } tGPR:{ *:[i32] }:$Rn, tGPR:{ *:[i32] }:$Rm)  =>  (tMUL:{ *:[i32] } tGPR:{ *:[i32] }:$Rn, tGPR:{ *:[i32] }:$Rm)
     /*  14523 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::tMUL),
     /*  14526 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  14528 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::CPSR), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define | RegState::Dead),
     /*  14534 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  14536 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /*  14538 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  14541 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  14547 */     GIR_RootConstrainSelectedInstOperands,
     /*  14548 */     // GIR_Coverage, 323,
     /*  14548 */     GIR_EraseRootFromParent_Done,
     /*  14549 */   // Label 312: @14549
     /*  14549 */   GIM_Try, /*On fail goto*//*Label 313*/ GIMT_Encode4(14589), // Rule ID 502 //
     /*  14554 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /*  14557 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  14561 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  14565 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  14569 */     // (mul:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2MUL:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  14569 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2MUL),
     /*  14572 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  14574 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  14576 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /*  14578 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  14581 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  14587 */     GIR_RootConstrainSelectedInstOperands,
     /*  14588 */     // GIR_Coverage, 502,
     /*  14588 */     GIR_EraseRootFromParent_Done,
     /*  14589 */   // Label 313: @14589
     /*  14589 */   GIM_Reject,
     /*  14590 */ // Label 301: @14590
     /*  14590 */ GIM_Reject,
     /*  14591 */ // Label 294: @14591
     /*  14591 */ GIM_Try, /*On fail goto*//*Label 314*/ GIMT_Encode4(14637), // Rule ID 834 //
     /*  14596 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  14599 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  14602 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  14605 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  14609 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  14613 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  14617 */   // (mul:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)  =>  (VMULv2i32:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /*  14617 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMULv2i32),
     /*  14620 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  14622 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*  14624 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  14626 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  14629 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  14635 */   GIR_RootConstrainSelectedInstOperands,
     /*  14636 */   // GIR_Coverage, 834,
     /*  14636 */   GIR_EraseRootFromParent_Done,
     /*  14637 */ // Label 314: @14637
     /*  14637 */ GIM_Reject,
     /*  14638 */ // Label 295: @14638
     /*  14638 */ GIM_Try, /*On fail goto*//*Label 315*/ GIMT_Encode4(14684), // Rule ID 833 //
     /*  14643 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  14646 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  14649 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  14652 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  14656 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  14660 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  14664 */   // (mul:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)  =>  (VMULv4i16:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /*  14664 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMULv4i16),
     /*  14667 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  14669 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*  14671 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  14673 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  14676 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  14682 */   GIR_RootConstrainSelectedInstOperands,
     /*  14683 */   // GIR_Coverage, 833,
     /*  14683 */   GIR_EraseRootFromParent_Done,
     /*  14684 */ // Label 315: @14684
     /*  14684 */ GIM_Reject,
     /*  14685 */ // Label 296: @14685
     /*  14685 */ GIM_Try, /*On fail goto*//*Label 316*/ GIMT_Encode4(14913),
     /*  14690 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  14693 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  14696 */   GIM_Try, /*On fail goto*//*Label 317*/ GIMT_Encode4(14811), // Rule ID 4418 //
     /*  14701 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  14704 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  14708 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  14712 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  14716 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  14720 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  14725 */     // MIs[1] Operand 2
     /*  14725 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(16),
     /*  14736 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  14740 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  14744 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  14748 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  14753 */     // MIs[2] Operand 2
     /*  14753 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(16),
     /*  14764 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  14766 */     // (mul:{ *:[v4i32] } (sext_inreg:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$src1, v4i16:{ *:[Other] }), (sext_inreg:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$src2, v4i16:{ *:[Other] }))  =>  (MVE_VMULLBs16:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$src1, MQPR:{ *:[v4i32] }:$src2)
     /*  14766 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  14769 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  14773 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  14778 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMULLBs16),
     /*  14781 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  14783 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  14787 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src2
     /*  14791 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  14794 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  14800 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  14806 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  14809 */     GIR_RootConstrainSelectedInstOperands,
     /*  14810 */     // GIR_Coverage, 4418,
     /*  14810 */     GIR_EraseRootFromParent_Done,
     /*  14811 */   // Label 317: @14811
     /*  14811 */   GIM_Try, /*On fail goto*//*Label 318*/ GIMT_Encode4(14851), // Rule ID 837 //
     /*  14816 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  14819 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  14823 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  14827 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  14831 */     // (mul:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)  =>  (VMULv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)
     /*  14831 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMULv4i32),
     /*  14834 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  14836 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*  14838 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  14840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  14843 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  14849 */     GIR_RootConstrainSelectedInstOperands,
     /*  14850 */     // GIR_Coverage, 837,
     /*  14850 */     GIR_EraseRootFromParent_Done,
     /*  14851 */   // Label 318: @14851
     /*  14851 */   GIM_Try, /*On fail goto*//*Label 319*/ GIMT_Encode4(14912), // Rule ID 3463 //
     /*  14856 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  14859 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  14863 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  14867 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  14871 */     // (mul:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)  =>  (MVE_VMULi32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)
     /*  14871 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  14874 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  14878 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  14883 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMULi32),
     /*  14886 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  14888 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /*  14890 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /*  14892 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  14895 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  14901 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  14907 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  14910 */     GIR_RootConstrainSelectedInstOperands,
     /*  14911 */     // GIR_Coverage, 3463,
     /*  14911 */     GIR_EraseRootFromParent_Done,
     /*  14912 */   // Label 319: @14912
     /*  14912 */   GIM_Reject,
     /*  14913 */ // Label 316: @14913
     /*  14913 */ GIM_Reject,
     /*  14914 */ // Label 297: @14914
     /*  14914 */ GIM_Try, /*On fail goto*//*Label 320*/ GIMT_Encode4(14960), // Rule ID 832 //
     /*  14919 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  14922 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  14925 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  14928 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  14932 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  14936 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  14940 */   // (mul:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)  =>  (VMULv8i8:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /*  14940 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMULv8i8),
     /*  14943 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  14945 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*  14947 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  14949 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  14952 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  14958 */   GIR_RootConstrainSelectedInstOperands,
     /*  14959 */   // GIR_Coverage, 832,
     /*  14959 */   GIR_EraseRootFromParent_Done,
     /*  14960 */ // Label 320: @14960
     /*  14960 */ GIM_Reject,
     /*  14961 */ // Label 298: @14961
     /*  14961 */ GIM_Try, /*On fail goto*//*Label 321*/ GIMT_Encode4(15189),
     /*  14966 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  14969 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  14972 */   GIM_Try, /*On fail goto*//*Label 322*/ GIMT_Encode4(15087), // Rule ID 4423 //
     /*  14977 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  14980 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  14984 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  14988 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  14992 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  14996 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  15001 */     // MIs[1] Operand 2
     /*  15001 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(8),
     /*  15012 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  15016 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  15020 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  15024 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  15029 */     // MIs[2] Operand 2
     /*  15029 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(8),
     /*  15040 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  15042 */     // (mul:{ *:[v8i16] } (sext_inreg:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$src1, v8i8:{ *:[Other] }), (sext_inreg:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$src2, v8i8:{ *:[Other] }))  =>  (MVE_VMULLBs8:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$src1, MQPR:{ *:[v8i16] }:$src2)
     /*  15042 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  15045 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  15049 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  15054 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMULLBs8),
     /*  15057 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  15059 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  15063 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src2
     /*  15067 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  15070 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  15076 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  15082 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  15085 */     GIR_RootConstrainSelectedInstOperands,
     /*  15086 */     // GIR_Coverage, 4423,
     /*  15086 */     GIR_EraseRootFromParent_Done,
     /*  15087 */   // Label 322: @15087
     /*  15087 */   GIM_Try, /*On fail goto*//*Label 323*/ GIMT_Encode4(15127), // Rule ID 836 //
     /*  15092 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  15095 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  15099 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  15103 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  15107 */     // (mul:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)  =>  (VMULv8i16:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)
     /*  15107 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMULv8i16),
     /*  15110 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  15112 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*  15114 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  15116 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  15119 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  15125 */     GIR_RootConstrainSelectedInstOperands,
     /*  15126 */     // GIR_Coverage, 836,
     /*  15126 */     GIR_EraseRootFromParent_Done,
     /*  15127 */   // Label 323: @15127
     /*  15127 */   GIM_Try, /*On fail goto*//*Label 324*/ GIMT_Encode4(15188), // Rule ID 3459 //
     /*  15132 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  15135 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  15139 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  15143 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  15147 */     // (mul:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)  =>  (MVE_VMULi16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)
     /*  15147 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  15150 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  15154 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  15159 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMULi16),
     /*  15162 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  15164 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /*  15166 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /*  15168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  15171 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  15177 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  15183 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  15186 */     GIR_RootConstrainSelectedInstOperands,
     /*  15187 */     // GIR_Coverage, 3459,
     /*  15187 */     GIR_EraseRootFromParent_Done,
     /*  15188 */   // Label 324: @15188
     /*  15188 */   GIM_Reject,
     /*  15189 */ // Label 321: @15189
     /*  15189 */ GIM_Reject,
     /*  15190 */ // Label 299: @15190
     /*  15190 */ GIM_Try, /*On fail goto*//*Label 325*/ GIMT_Encode4(15303),
     /*  15195 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  15198 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  15201 */   GIM_Try, /*On fail goto*//*Label 326*/ GIMT_Encode4(15241), // Rule ID 835 //
     /*  15206 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  15209 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  15213 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  15217 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  15221 */     // (mul:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)  =>  (VMULv16i8:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)
     /*  15221 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMULv16i8),
     /*  15224 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  15226 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*  15228 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  15230 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  15233 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  15239 */     GIR_RootConstrainSelectedInstOperands,
     /*  15240 */     // GIR_Coverage, 835,
     /*  15240 */     GIR_EraseRootFromParent_Done,
     /*  15241 */   // Label 326: @15241
     /*  15241 */   GIM_Try, /*On fail goto*//*Label 327*/ GIMT_Encode4(15302), // Rule ID 3455 //
     /*  15246 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  15249 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  15253 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  15257 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  15261 */     // (mul:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)  =>  (MVE_VMULi8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)
     /*  15261 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  15264 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  15268 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  15273 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMULi8),
     /*  15276 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  15278 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /*  15280 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /*  15282 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  15285 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  15291 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  15297 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  15300 */     GIR_RootConstrainSelectedInstOperands,
     /*  15301 */     // GIR_Coverage, 3455,
     /*  15301 */     GIR_EraseRootFromParent_Done,
     /*  15302 */   // Label 327: @15302
     /*  15302 */   GIM_Reject,
     /*  15303 */ // Label 325: @15303
     /*  15303 */ GIM_Reject,
     /*  15304 */ // Label 300: @15304
     /*  15304 */ GIM_Reject,
     /*  15305 */ // Label 3: @15305
     /*  15305 */ GIM_Try, /*On fail goto*//*Label 328*/ GIMT_Encode4(15400),
     /*  15310 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  15313 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  15316 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  15319 */   GIM_Try, /*On fail goto*//*Label 329*/ GIMT_Encode4(15359), // Rule ID 195 //
     /*  15324 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDivideInARM_IsARM),
     /*  15327 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  15331 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  15335 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  15339 */     // (sdiv:{ *:[i32] } GPR:{ *:[i32] }:$Rn, GPR:{ *:[i32] }:$Rm)  =>  (SDIV:{ *:[i32] } GPR:{ *:[i32] }:$Rn, GPR:{ *:[i32] }:$Rm)
     /*  15339 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SDIV),
     /*  15342 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  15344 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  15346 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /*  15348 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  15351 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  15357 */     GIR_RootConstrainSelectedInstOperands,
     /*  15358 */     // GIR_Coverage, 195,
     /*  15358 */     GIR_EraseRootFromParent_Done,
     /*  15359 */   // Label 329: @15359
     /*  15359 */   GIM_Try, /*On fail goto*//*Label 330*/ GIMT_Encode4(15399), // Rule ID 532 //
     /*  15364 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDivideInThumb_HasV8MBaseline_IsThumb),
     /*  15367 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  15371 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  15375 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  15379 */     // (sdiv:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2SDIV:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  15379 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SDIV),
     /*  15382 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  15384 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  15386 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /*  15388 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  15391 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  15397 */     GIR_RootConstrainSelectedInstOperands,
     /*  15398 */     // GIR_Coverage, 532,
     /*  15398 */     GIR_EraseRootFromParent_Done,
     /*  15399 */   // Label 330: @15399
     /*  15399 */   GIM_Reject,
     /*  15400 */ // Label 328: @15400
     /*  15400 */ GIM_Reject,
     /*  15401 */ // Label 4: @15401
     /*  15401 */ GIM_Try, /*On fail goto*//*Label 331*/ GIMT_Encode4(15496),
     /*  15406 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  15409 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  15412 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  15415 */   GIM_Try, /*On fail goto*//*Label 332*/ GIMT_Encode4(15455), // Rule ID 196 //
     /*  15420 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDivideInARM_IsARM),
     /*  15423 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  15427 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  15431 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  15435 */     // (udiv:{ *:[i32] } GPR:{ *:[i32] }:$Rn, GPR:{ *:[i32] }:$Rm)  =>  (UDIV:{ *:[i32] } GPR:{ *:[i32] }:$Rn, GPR:{ *:[i32] }:$Rm)
     /*  15435 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::UDIV),
     /*  15438 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  15440 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  15442 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /*  15444 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  15447 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  15453 */     GIR_RootConstrainSelectedInstOperands,
     /*  15454 */     // GIR_Coverage, 196,
     /*  15454 */     GIR_EraseRootFromParent_Done,
     /*  15455 */   // Label 332: @15455
     /*  15455 */   GIM_Try, /*On fail goto*//*Label 333*/ GIMT_Encode4(15495), // Rule ID 533 //
     /*  15460 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDivideInThumb_HasV8MBaseline_IsThumb),
     /*  15463 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  15467 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  15471 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  15475 */     // (udiv:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2UDIV:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  15475 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2UDIV),
     /*  15478 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  15480 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  15482 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /*  15484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  15487 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  15493 */     GIR_RootConstrainSelectedInstOperands,
     /*  15494 */     // GIR_Coverage, 533,
     /*  15494 */     GIR_EraseRootFromParent_Done,
     /*  15495 */   // Label 333: @15495
     /*  15495 */   GIM_Reject,
     /*  15496 */ // Label 331: @15496
     /*  15496 */ GIM_Reject,
     /*  15497 */ // Label 5: @15497
     /*  15497 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(16), /*)*//*default:*//*Label 347*/ GIMT_Encode4(18676),
     /*  15508 */ /*GILLT_s32*//*Label 334*/ GIMT_Encode4(15568),
     /*  15512 */ /*GILLT_s64*//*Label 335*/ GIMT_Encode4(17560),
     /*  15516 */ /*GILLT_v2s1*//*Label 336*/ GIMT_Encode4(17607),
     /*  15520 */ /*GILLT_v2s32*//*Label 337*/ GIMT_Encode4(17725),
     /*  15524 */ /*GILLT_v2s64*//*Label 338*/ GIMT_Encode4(17772),
     /*  15528 */ /*GILLT_v4s1*//*Label 339*/ GIMT_Encode4(17886),
     /*  15532 */ /*GILLT_v4s16*//*Label 340*/ GIMT_Encode4(18004),
     /*  15536 */ /*GILLT_v4s32*//*Label 341*/ GIMT_Encode4(18051), GIMT_Encode4(0),
     /*  15544 */ /*GILLT_v8s1*//*Label 342*/ GIMT_Encode4(18165),
     /*  15548 */ /*GILLT_v8s8*//*Label 343*/ GIMT_Encode4(18283),
     /*  15552 */ /*GILLT_v8s16*//*Label 344*/ GIMT_Encode4(18330), GIMT_Encode4(0),
     /*  15560 */ /*GILLT_v16s1*//*Label 345*/ GIMT_Encode4(18444),
     /*  15564 */ /*GILLT_v16s8*//*Label 346*/ GIMT_Encode4(18562),
     /*  15568 */ // Label 334: @15568
     /*  15568 */ GIM_Try, /*On fail goto*//*Label 348*/ GIMT_Encode4(17559),
     /*  15573 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  15576 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  15579 */   GIM_Try, /*On fail goto*//*Label 349*/ GIMT_Encode4(15652), // Rule ID 1852 //
     /*  15584 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*  15587 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  15591 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  15595 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  15599 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  15603 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  15607 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  15612 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 8,
     /*  15616 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(16711935),
     /*  15627 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  15629 */     // (and:{ *:[i32] } (srl:{ *:[i32] } GPR:{ *:[i32] }:$Src, 8:{ *:[i32] }), 16711935:{ *:[i32] })  =>  (UXTB16:{ *:[i32] } GPR:{ *:[i32] }:$Src, 1:{ *:[i32] })
     /*  15629 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::UXTB16),
     /*  15632 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  15634 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Src
     /*  15638 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  15641 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  15644 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  15650 */     GIR_RootConstrainSelectedInstOperands,
     /*  15651 */     // GIR_Coverage, 1852,
     /*  15651 */     GIR_EraseRootFromParent_Done,
     /*  15652 */   // Label 349: @15652
     /*  15652 */   GIM_Try, /*On fail goto*//*Label 350*/ GIMT_Encode4(15725), // Rule ID 2109 //
     /*  15657 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  15660 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  15664 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  15668 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  15672 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  15676 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  15680 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  15685 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 8,
     /*  15689 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(16711935),
     /*  15700 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  15702 */     // (and:{ *:[i32] } (srl:{ *:[i32] } rGPR:{ *:[i32] }:$Src, 8:{ *:[i32] }), 16711935:{ *:[i32] })  =>  (t2UXTB16:{ *:[i32] } rGPR:{ *:[i32] }:$Src, 1:{ *:[i32] })
     /*  15702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2UXTB16),
     /*  15705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  15707 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Src
     /*  15711 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  15714 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  15717 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  15723 */     GIR_RootConstrainSelectedInstOperands,
     /*  15724 */     // GIR_Coverage, 2109,
     /*  15724 */     GIR_EraseRootFromParent_Done,
     /*  15725 */   // Label 350: @15725
     /*  15725 */   GIM_Try, /*On fail goto*//*Label 351*/ GIMT_Encode4(15773), // Rule ID 1994 //
     /*  15730 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*  15733 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  15737 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  15741 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(255),
     /*  15752 */     // (and:{ *:[i32] } GPR:{ *:[i32] }:$Src, 255:{ *:[i32] })  =>  (UXTB:{ *:[i32] } GPR:{ *:[i32] }:$Src, 0:{ *:[i32] })
     /*  15752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::UXTB),
     /*  15755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  15757 */     GIR_RootToRootCopy, /*OpIdx*/1, // Src
     /*  15759 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  15762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  15765 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  15771 */     GIR_RootConstrainSelectedInstOperands,
     /*  15772 */     // GIR_Coverage, 1994,
     /*  15772 */     GIR_EraseRootFromParent_Done,
     /*  15773 */   // Label 351: @15773
     /*  15773 */   GIM_Try, /*On fail goto*//*Label 352*/ GIMT_Encode4(15821), // Rule ID 1995 //
     /*  15778 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*  15781 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  15785 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  15789 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(65535),
     /*  15800 */     // (and:{ *:[i32] } GPR:{ *:[i32] }:$Src, 65535:{ *:[i32] })  =>  (UXTH:{ *:[i32] } GPR:{ *:[i32] }:$Src, 0:{ *:[i32] })
     /*  15800 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::UXTH),
     /*  15803 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  15805 */     GIR_RootToRootCopy, /*OpIdx*/1, // Src
     /*  15807 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  15810 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  15813 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  15819 */     GIR_RootConstrainSelectedInstOperands,
     /*  15820 */     // GIR_Coverage, 1995,
     /*  15820 */     GIR_EraseRootFromParent_Done,
     /*  15821 */   // Label 352: @15821
     /*  15821 */   GIM_Try, /*On fail goto*//*Label 353*/ GIMT_Encode4(15869), // Rule ID 1996 //
     /*  15826 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*  15829 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  15833 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  15837 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(16711935),
     /*  15848 */     // (and:{ *:[i32] } GPR:{ *:[i32] }:$Src, 16711935:{ *:[i32] })  =>  (UXTB16:{ *:[i32] } GPR:{ *:[i32] }:$Src, 0:{ *:[i32] })
     /*  15848 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::UXTB16),
     /*  15851 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  15853 */     GIR_RootToRootCopy, /*OpIdx*/1, // Src
     /*  15855 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  15858 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  15861 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  15867 */     GIR_RootConstrainSelectedInstOperands,
     /*  15868 */     // GIR_Coverage, 1996,
     /*  15868 */     GIR_EraseRootFromParent_Done,
     /*  15869 */   // Label 353: @15869
     /*  15869 */   GIM_Try, /*On fail goto*//*Label 354*/ GIMT_Encode4(15917), // Rule ID 2233 //
     /*  15874 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /*  15877 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  15881 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  15885 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(255),
     /*  15896 */     // (and:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, 255:{ *:[i32] })  =>  (t2UXTB:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, 0:{ *:[i32] })
     /*  15896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2UXTB),
     /*  15899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  15901 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /*  15903 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  15906 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  15909 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  15915 */     GIR_RootConstrainSelectedInstOperands,
     /*  15916 */     // GIR_Coverage, 2233,
     /*  15916 */     GIR_EraseRootFromParent_Done,
     /*  15917 */   // Label 354: @15917
     /*  15917 */   GIM_Try, /*On fail goto*//*Label 355*/ GIMT_Encode4(15965), // Rule ID 2234 //
     /*  15922 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /*  15925 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  15929 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  15933 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(65535),
     /*  15944 */     // (and:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, 65535:{ *:[i32] })  =>  (t2UXTH:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, 0:{ *:[i32] })
     /*  15944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2UXTH),
     /*  15947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  15949 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /*  15951 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  15954 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  15957 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  15963 */     GIR_RootConstrainSelectedInstOperands,
     /*  15964 */     // GIR_Coverage, 2234,
     /*  15964 */     GIR_EraseRootFromParent_Done,
     /*  15965 */   // Label 355: @15965
     /*  15965 */   GIM_Try, /*On fail goto*//*Label 356*/ GIMT_Encode4(16013), // Rule ID 2235 //
     /*  15970 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  15973 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  15977 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  15981 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(16711935),
     /*  15992 */     // (and:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, 16711935:{ *:[i32] })  =>  (t2UXTB16:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, 0:{ *:[i32] })
     /*  15992 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2UXTB16),
     /*  15995 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  15997 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /*  15999 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  16002 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  16005 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  16011 */     GIR_RootConstrainSelectedInstOperands,
     /*  16012 */     // GIR_Coverage, 2235,
     /*  16012 */     GIR_EraseRootFromParent_Done,
     /*  16013 */   // Label 356: @16013
     /*  16013 */   GIM_Try, /*On fail goto*//*Label 357*/ GIMT_Encode4(16090), // Rule ID 5436 //
     /*  16018 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  16021 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  16025 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  16029 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  16033 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  16037 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  16041 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, uint8_t(-1),
     /*  16045 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  16049 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  16053 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_mod_imm),
     /*  16057 */     // MIs[2] Operand 1
     /*  16057 */     // No operand predicates
     /*  16057 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  16061 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  16063 */     // (and:{ *:[i32] } (xor:{ *:[i32] } -1:{ *:[i32] }, (imm:{ *:[i32] })<<P:Predicate_mod_imm>>:$imm), GPR:{ *:[i32] }:$Rn)  =>  (BICri:{ *:[i32] } GPR:{ *:[i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  16063 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::BICri),
     /*  16066 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  16068 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  16070 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  16073 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  16076 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  16082 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  16088 */     GIR_RootConstrainSelectedInstOperands,
     /*  16089 */     // GIR_Coverage, 5436,
     /*  16089 */     GIR_EraseRootFromParent_Done,
     /*  16090 */   // Label 357: @16090
     /*  16090 */   GIM_Try, /*On fail goto*//*Label 358*/ GIMT_Encode4(16167), // Rule ID 5469 //
     /*  16095 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /*  16098 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  16102 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  16106 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  16110 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  16114 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  16118 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, uint8_t(-1),
     /*  16122 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  16126 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  16130 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_t2_so_imm),
     /*  16134 */     // MIs[2] Operand 1
     /*  16134 */     // No operand predicates
     /*  16134 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  16138 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  16140 */     // (and:{ *:[i32] } (xor:{ *:[i32] } -1:{ *:[i32] }, (imm:{ *:[i32] })<<P:Predicate_t2_so_imm>>:$imm), rGPR:{ *:[i32] }:$Rn)  =>  (t2BICri:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  16140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2BICri),
     /*  16143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  16145 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  16147 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  16150 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  16153 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  16159 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  16165 */     GIR_RootConstrainSelectedInstOperands,
     /*  16166 */     // GIR_Coverage, 5469,
     /*  16166 */     GIR_EraseRootFromParent_Done,
     /*  16167 */   // Label 358: @16167
     /*  16167 */   GIM_Try, /*On fail goto*//*Label 359*/ GIMT_Encode4(16244), // Rule ID 5435 //
     /*  16172 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  16175 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  16179 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  16183 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  16187 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  16191 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  16195 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  16199 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  16203 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_mod_imm),
     /*  16207 */     // MIs[2] Operand 1
     /*  16207 */     // No operand predicates
     /*  16207 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  16211 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  16215 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  16217 */     // (and:{ *:[i32] } (xor:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_mod_imm>>:$imm, -1:{ *:[i32] }), GPR:{ *:[i32] }:$Rn)  =>  (BICri:{ *:[i32] } GPR:{ *:[i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  16217 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::BICri),
     /*  16220 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  16222 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  16224 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  16227 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  16230 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  16236 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  16242 */     GIR_RootConstrainSelectedInstOperands,
     /*  16243 */     // GIR_Coverage, 5435,
     /*  16243 */     GIR_EraseRootFromParent_Done,
     /*  16244 */   // Label 359: @16244
     /*  16244 */   GIM_Try, /*On fail goto*//*Label 360*/ GIMT_Encode4(16321), // Rule ID 5468 //
     /*  16249 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /*  16252 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  16256 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  16260 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  16264 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  16268 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  16272 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  16276 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  16280 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_t2_so_imm),
     /*  16284 */     // MIs[2] Operand 1
     /*  16284 */     // No operand predicates
     /*  16284 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  16288 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  16292 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  16294 */     // (and:{ *:[i32] } (xor:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_t2_so_imm>>:$imm, -1:{ *:[i32] }), rGPR:{ *:[i32] }:$Rn)  =>  (t2BICri:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  16294 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2BICri),
     /*  16297 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  16299 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  16301 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  16304 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  16307 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  16313 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  16319 */     GIR_RootConstrainSelectedInstOperands,
     /*  16320 */     // GIR_Coverage, 5468,
     /*  16320 */     GIR_EraseRootFromParent_Done,
     /*  16321 */   // Label 360: @16321
     /*  16321 */   GIM_Try, /*On fail goto*//*Label 361*/ GIMT_Encode4(16398), // Rule ID 5434 //
     /*  16326 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  16329 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  16333 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  16337 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  16341 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  16345 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  16349 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  16353 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, uint8_t(-1),
     /*  16357 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  16361 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  16365 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_mod_imm),
     /*  16369 */     // MIs[2] Operand 1
     /*  16369 */     // No operand predicates
     /*  16369 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  16371 */     // (and:{ *:[i32] } GPR:{ *:[i32] }:$Rn, (xor:{ *:[i32] } -1:{ *:[i32] }, (imm:{ *:[i32] })<<P:Predicate_mod_imm>>:$imm))  =>  (BICri:{ *:[i32] } GPR:{ *:[i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  16371 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::BICri),
     /*  16374 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  16376 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  16378 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  16381 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  16384 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  16390 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  16396 */     GIR_RootConstrainSelectedInstOperands,
     /*  16397 */     // GIR_Coverage, 5434,
     /*  16397 */     GIR_EraseRootFromParent_Done,
     /*  16398 */   // Label 361: @16398
     /*  16398 */   GIM_Try, /*On fail goto*//*Label 362*/ GIMT_Encode4(16475), // Rule ID 5467 //
     /*  16403 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /*  16406 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  16410 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  16414 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  16418 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  16422 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  16426 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  16430 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, uint8_t(-1),
     /*  16434 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  16438 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  16442 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_t2_so_imm),
     /*  16446 */     // MIs[2] Operand 1
     /*  16446 */     // No operand predicates
     /*  16446 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  16448 */     // (and:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, (xor:{ *:[i32] } -1:{ *:[i32] }, (imm:{ *:[i32] })<<P:Predicate_t2_so_imm>>:$imm))  =>  (t2BICri:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  16448 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2BICri),
     /*  16451 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  16453 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  16455 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  16458 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  16461 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  16467 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  16473 */     GIR_RootConstrainSelectedInstOperands,
     /*  16474 */     // GIR_Coverage, 5467,
     /*  16474 */     GIR_EraseRootFromParent_Done,
     /*  16475 */   // Label 362: @16475
     /*  16475 */   GIM_Try, /*On fail goto*//*Label 363*/ GIMT_Encode4(16552), // Rule ID 159 //
     /*  16480 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  16483 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  16487 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  16491 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  16495 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  16499 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  16503 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  16507 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  16511 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  16515 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_mod_imm),
     /*  16519 */     // MIs[2] Operand 1
     /*  16519 */     // No operand predicates
     /*  16519 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  16523 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  16525 */     // (and:{ *:[i32] } GPR:{ *:[i32] }:$Rn, (xor:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_mod_imm>>:$imm, -1:{ *:[i32] }))  =>  (BICri:{ *:[i32] } GPR:{ *:[i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  16525 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::BICri),
     /*  16528 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  16530 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  16532 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  16535 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  16538 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  16544 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  16550 */     GIR_RootConstrainSelectedInstOperands,
     /*  16551 */     // GIR_Coverage, 159,
     /*  16551 */     GIR_EraseRootFromParent_Done,
     /*  16552 */   // Label 363: @16552
     /*  16552 */   GIM_Try, /*On fail goto*//*Label 364*/ GIMT_Encode4(16629), // Rule ID 490 //
     /*  16557 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /*  16560 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  16564 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  16568 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  16572 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  16576 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  16580 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  16584 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  16588 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  16592 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_t2_so_imm),
     /*  16596 */     // MIs[2] Operand 1
     /*  16596 */     // No operand predicates
     /*  16596 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  16600 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  16602 */     // (and:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, (xor:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_t2_so_imm>>:$imm, -1:{ *:[i32] }))  =>  (t2BICri:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  16602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2BICri),
     /*  16605 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  16607 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  16609 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  16612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  16615 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  16621 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  16627 */     GIR_RootConstrainSelectedInstOperands,
     /*  16628 */     // GIR_Coverage, 490,
     /*  16628 */     GIR_EraseRootFromParent_Done,
     /*  16629 */   // Label 364: @16629
     /*  16629 */   GIM_Try, /*On fail goto*//*Label 365*/ GIMT_Encode4(16700), // Rule ID 5437 //
     /*  16634 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  16637 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  16641 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  16645 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  16649 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  16653 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  16657 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  16662 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  16666 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  16670 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  16672 */     // (and:{ *:[i32] } (xor:{ *:[i32] } GPR:{ *:[i32] }:$Rm, -1:{ *:[i32] }), GPR:{ *:[i32] }:$Rn)  =>  (BICrr:{ *:[i32] } GPR:{ *:[i32] }:$Rn, GPR:{ *:[i32] }:$Rm)
     /*  16672 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::BICrr),
     /*  16675 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  16677 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  16679 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  16683 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  16686 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  16692 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  16698 */     GIR_RootConstrainSelectedInstOperands,
     /*  16699 */     // GIR_Coverage, 5437,
     /*  16699 */     GIR_EraseRootFromParent_Done,
     /*  16700 */   // Label 365: @16700
     /*  16700 */   GIM_Try, /*On fail goto*//*Label 366*/ GIMT_Encode4(16771), // Rule ID 5458 //
     /*  16705 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb_IsThumb1Only),
     /*  16708 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /*  16712 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  16716 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  16720 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  16724 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  16728 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /*  16733 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  16737 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /*  16741 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  16743 */     // (and:{ *:[i32] } (xor:{ *:[i32] } tGPR:{ *:[i32] }:$Rm, -1:{ *:[i32] }), tGPR:{ *:[i32] }:$Rn)  =>  (tBIC:{ *:[i32] } tGPR:{ *:[i32] }:$Rn, tGPR:{ *:[i32] }:$Rm)
     /*  16743 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::tBIC),
     /*  16746 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /*  16748 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::CPSR), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define | RegState::Dead),
     /*  16754 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  16756 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  16760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  16763 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  16769 */     GIR_RootConstrainSelectedInstOperands,
     /*  16770 */     // GIR_Coverage, 5458,
     /*  16770 */     GIR_EraseRootFromParent_Done,
     /*  16771 */   // Label 366: @16771
     /*  16771 */   GIM_Try, /*On fail goto*//*Label 367*/ GIMT_Encode4(16842), // Rule ID 5470 //
     /*  16776 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /*  16779 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  16783 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  16787 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  16791 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  16795 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  16799 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  16804 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  16808 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  16812 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  16814 */     // (and:{ *:[i32] } (xor:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, -1:{ *:[i32] }), rGPR:{ *:[i32] }:$Rn)  =>  (t2BICrr:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  16814 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2BICrr),
     /*  16817 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  16819 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  16821 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  16825 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  16828 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  16834 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  16840 */     GIR_RootConstrainSelectedInstOperands,
     /*  16841 */     // GIR_Coverage, 5470,
     /*  16841 */     GIR_EraseRootFromParent_Done,
     /*  16842 */   // Label 367: @16842
     /*  16842 */   GIM_Try, /*On fail goto*//*Label 368*/ GIMT_Encode4(16913), // Rule ID 160 //
     /*  16847 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  16850 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  16854 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  16858 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  16862 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  16866 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  16870 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  16874 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  16879 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  16883 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  16885 */     // (and:{ *:[i32] } GPR:{ *:[i32] }:$Rn, (xor:{ *:[i32] } GPR:{ *:[i32] }:$Rm, -1:{ *:[i32] }))  =>  (BICrr:{ *:[i32] } GPR:{ *:[i32] }:$Rn, GPR:{ *:[i32] }:$Rm)
     /*  16885 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::BICrr),
     /*  16888 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  16890 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  16892 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  16896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  16899 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  16905 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  16911 */     GIR_RootConstrainSelectedInstOperands,
     /*  16912 */     // GIR_Coverage, 160,
     /*  16912 */     GIR_EraseRootFromParent_Done,
     /*  16913 */   // Label 368: @16913
     /*  16913 */   GIM_Try, /*On fail goto*//*Label 369*/ GIMT_Encode4(16984), // Rule ID 313 //
     /*  16918 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb_IsThumb1Only),
     /*  16921 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /*  16925 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /*  16929 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  16933 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  16937 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  16941 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  16945 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /*  16950 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  16954 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  16956 */     // (and:{ *:[i32] } tGPR:{ *:[i32] }:$Rn, (xor:{ *:[i32] } tGPR:{ *:[i32] }:$Rm, -1:{ *:[i32] }))  =>  (tBIC:{ *:[i32] } tGPR:{ *:[i32] }:$Rn, tGPR:{ *:[i32] }:$Rm)
     /*  16956 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::tBIC),
     /*  16959 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /*  16961 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::CPSR), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define | RegState::Dead),
     /*  16967 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  16969 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  16973 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  16976 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  16982 */     GIR_RootConstrainSelectedInstOperands,
     /*  16983 */     // GIR_Coverage, 313,
     /*  16983 */     GIR_EraseRootFromParent_Done,
     /*  16984 */   // Label 369: @16984
     /*  16984 */   GIM_Try, /*On fail goto*//*Label 370*/ GIMT_Encode4(17055), // Rule ID 491 //
     /*  16989 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /*  16992 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  16996 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  17000 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  17004 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  17008 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  17012 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  17016 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  17021 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  17025 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  17027 */     // (and:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, (xor:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, -1:{ *:[i32] }))  =>  (t2BICrr:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  17027 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2BICrr),
     /*  17030 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  17032 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  17034 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  17038 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  17041 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  17047 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  17053 */     GIR_RootConstrainSelectedInstOperands,
     /*  17054 */     // GIR_Coverage, 491,
     /*  17054 */     GIR_EraseRootFromParent_Done,
     /*  17055 */   // Label 370: @17055
     /*  17055 */   GIM_Try, /*On fail goto*//*Label 371*/ GIMT_Encode4(17100), // Rule ID 345 //
     /*  17060 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsThumb_IsThumb1Only),
     /*  17063 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /*  17067 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /*  17071 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(255),
     /*  17082 */     // (and:{ *:[i32] } tGPR:{ *:[i32] }:$Rm, 255:{ *:[i32] })  =>  (tUXTB:{ *:[i32] } tGPR:{ *:[i32] }:$Rm)
     /*  17082 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::tUXTB),
     /*  17085 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  17087 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /*  17089 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  17092 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  17098 */     GIR_RootConstrainSelectedInstOperands,
     /*  17099 */     // GIR_Coverage, 345,
     /*  17099 */     GIR_EraseRootFromParent_Done,
     /*  17100 */   // Label 371: @17100
     /*  17100 */   GIM_Try, /*On fail goto*//*Label 372*/ GIMT_Encode4(17145), // Rule ID 346 //
     /*  17105 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsThumb_IsThumb1Only),
     /*  17108 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /*  17112 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /*  17116 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(65535),
     /*  17127 */     // (and:{ *:[i32] } tGPR:{ *:[i32] }:$Rm, 65535:{ *:[i32] })  =>  (tUXTH:{ *:[i32] } tGPR:{ *:[i32] }:$Rm)
     /*  17127 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::tUXTH),
     /*  17130 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  17132 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /*  17134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  17137 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  17143 */     GIR_RootConstrainSelectedInstOperands,
     /*  17144 */     // GIR_Coverage, 346,
     /*  17144 */     GIR_EraseRootFromParent_Done,
     /*  17145 */   // Label 372: @17145
     /*  17145 */   GIM_Try, /*On fail goto*//*Label 373*/ GIMT_Encode4(17204), // Rule ID 1891 //
     /*  17150 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  17153 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  17157 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  17161 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  17165 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  17169 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_mod_imm_not),
     /*  17173 */     // MIs[1] Operand 1
     /*  17173 */     // No operand predicates
     /*  17173 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  17175 */     // (and:{ *:[i32] } GPR:{ *:[i32] }:$src, (imm:{ *:[i32] })<<P:Predicate_mod_imm_not>><<X:imm_not_XFORM>>:$imm)  =>  (BICri:{ *:[i32] } GPR:{ *:[i32] }:$src, (imm_not_XFORM:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_mod_imm_not>>:$imm))
     /*  17175 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::BICri),
     /*  17178 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  17180 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  17182 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderInvertedImm), // imm
     /*  17187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  17190 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  17196 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  17202 */     GIR_RootConstrainSelectedInstOperands,
     /*  17203 */     // GIR_Coverage, 1891,
     /*  17203 */     GIR_EraseRootFromParent_Done,
     /*  17204 */   // Label 373: @17204
     /*  17204 */   GIM_Try, /*On fail goto*//*Label 374*/ GIMT_Encode4(17261), // Rule ID 147 //
     /*  17209 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  17212 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  17216 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  17220 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  17224 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  17228 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_mod_imm),
     /*  17232 */     // MIs[1] Operand 1
     /*  17232 */     // No operand predicates
     /*  17232 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  17234 */     // (and:{ *:[i32] } GPR:{ *:[i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_mod_imm>>:$imm)  =>  (ANDri:{ *:[i32] } GPR:{ *:[i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  17234 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::ANDri),
     /*  17237 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  17239 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  17241 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  17244 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  17247 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  17253 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  17259 */     GIR_RootConstrainSelectedInstOperands,
     /*  17260 */     // GIR_Coverage, 147,
     /*  17260 */     GIR_EraseRootFromParent_Done,
     /*  17261 */   // Label 374: @17261
     /*  17261 */   GIM_Try, /*On fail goto*//*Label 375*/ GIMT_Encode4(17318), // Rule ID 481 //
     /*  17266 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /*  17269 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  17273 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  17277 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  17281 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  17285 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_t2_so_imm),
     /*  17289 */     // MIs[1] Operand 1
     /*  17289 */     // No operand predicates
     /*  17289 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  17291 */     // (and:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_t2_so_imm>>:$imm)  =>  (t2ANDri:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  17291 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2ANDri),
     /*  17294 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  17296 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  17298 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  17301 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  17304 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  17310 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  17316 */     GIR_RootConstrainSelectedInstOperands,
     /*  17317 */     // GIR_Coverage, 481,
     /*  17317 */     GIR_EraseRootFromParent_Done,
     /*  17318 */   // Label 375: @17318
     /*  17318 */   GIM_Try, /*On fail goto*//*Label 376*/ GIMT_Encode4(17369), // Rule ID 163 //
     /*  17323 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6T2_IsARM),
     /*  17326 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  17330 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  17334 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  17338 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  17342 */     // MIs[1] Operand 1
     /*  17342 */     // No operand predicates
     /*  17342 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_bf_inv_mask_imm),
     /*  17346 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  17348 */     // (and:{ *:[i32] } GPR:{ *:[i32] }:$src, (imm:{ *:[i32] })<<P:Predicate_bf_inv_mask_imm>>:$imm)  =>  (BFC:{ *:[i32] } GPR:{ *:[i32] }:$src, (imm:{ *:[i32] }):$imm)
     /*  17348 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::BFC),
     /*  17351 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  17353 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  17355 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  17358 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  17361 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  17367 */     GIR_RootConstrainSelectedInstOperands,
     /*  17368 */     // GIR_Coverage, 163,
     /*  17368 */     GIR_EraseRootFromParent_Done,
     /*  17369 */   // Label 376: @17369
     /*  17369 */   GIM_Try, /*On fail goto*//*Label 377*/ GIMT_Encode4(17420), // Rule ID 493 //
     /*  17374 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /*  17377 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  17381 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  17385 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  17389 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  17393 */     // MIs[1] Operand 1
     /*  17393 */     // No operand predicates
     /*  17393 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_bf_inv_mask_imm),
     /*  17397 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  17399 */     // (and:{ *:[i32] } rGPR:{ *:[i32] }:$src, (imm:{ *:[i32] })<<P:Predicate_bf_inv_mask_imm>>:$imm)  =>  (t2BFC:{ *:[i32] } rGPR:{ *:[i32] }:$src, (imm:{ *:[i32] }):$imm)
     /*  17399 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2BFC),
     /*  17402 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  17404 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  17406 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  17409 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  17412 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  17418 */     GIR_RootConstrainSelectedInstOperands,
     /*  17419 */     // GIR_Coverage, 493,
     /*  17419 */     GIR_EraseRootFromParent_Done,
     /*  17420 */   // Label 377: @17420
     /*  17420 */   GIM_Try, /*On fail goto*//*Label 378*/ GIMT_Encode4(17466), // Rule ID 148 //
     /*  17425 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  17428 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  17432 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  17436 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  17440 */     // (and:{ *:[i32] } GPR:{ *:[i32] }:$Rn, GPR:{ *:[i32] }:$Rm)  =>  (ANDrr:{ *:[i32] } GPR:{ *:[i32] }:$Rn, GPR:{ *:[i32] }:$Rm)
     /*  17440 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::ANDrr),
     /*  17443 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  17445 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  17447 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /*  17449 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  17452 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  17458 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  17464 */     GIR_RootConstrainSelectedInstOperands,
     /*  17465 */     // GIR_Coverage, 148,
     /*  17465 */     GIR_EraseRootFromParent_Done,
     /*  17466 */   // Label 378: @17466
     /*  17466 */   GIM_Try, /*On fail goto*//*Label 379*/ GIMT_Encode4(17512), // Rule ID 310 //
     /*  17471 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb_IsThumb1Only),
     /*  17474 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /*  17478 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /*  17482 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /*  17486 */     // (and:{ *:[i32] } tGPR:{ *:[i32] }:$Rn, tGPR:{ *:[i32] }:$Rm)  =>  (tAND:{ *:[i32] } tGPR:{ *:[i32] }:$Rn, tGPR:{ *:[i32] }:$Rm)
     /*  17486 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::tAND),
     /*  17489 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /*  17491 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::CPSR), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define | RegState::Dead),
     /*  17497 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  17499 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /*  17501 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  17504 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  17510 */     GIR_RootConstrainSelectedInstOperands,
     /*  17511 */     // GIR_Coverage, 310,
     /*  17511 */     GIR_EraseRootFromParent_Done,
     /*  17512 */   // Label 379: @17512
     /*  17512 */   GIM_Try, /*On fail goto*//*Label 380*/ GIMT_Encode4(17558), // Rule ID 482 //
     /*  17517 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /*  17520 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  17524 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  17528 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  17532 */     // (and:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2ANDrr:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  17532 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2ANDrr),
     /*  17535 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  17537 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  17539 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /*  17541 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  17544 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  17550 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  17556 */     GIR_RootConstrainSelectedInstOperands,
     /*  17557 */     // GIR_Coverage, 482,
     /*  17557 */     GIR_EraseRootFromParent_Done,
     /*  17558 */   // Label 380: @17558
     /*  17558 */   GIM_Reject,
     /*  17559 */ // Label 348: @17559
     /*  17559 */ GIM_Reject,
     /*  17560 */ // Label 335: @17560
     /*  17560 */ GIM_Try, /*On fail goto*//*Label 381*/ GIMT_Encode4(17606), // Rule ID 2523 //
     /*  17565 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  17568 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  17571 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  17574 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  17578 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  17582 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  17586 */   // (and:{ *:[v1i64] } DPR:{ *:[v1i64] }:$LHS, DPR:{ *:[v1i64] }:$RHS)  =>  (VANDd:{ *:[v1i64] } DPR:{ *:[v1i64] }:$LHS, DPR:{ *:[v1i64] }:$RHS)
     /*  17586 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VANDd),
     /*  17589 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  17591 */   GIR_RootToRootCopy, /*OpIdx*/1, // LHS
     /*  17593 */   GIR_RootToRootCopy, /*OpIdx*/2, // RHS
     /*  17595 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  17598 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  17604 */   GIR_RootConstrainSelectedInstOperands,
     /*  17605 */   // GIR_Coverage, 2523,
     /*  17605 */   GIR_EraseRootFromParent_Done,
     /*  17606 */ // Label 381: @17606
     /*  17606 */ GIM_Reject,
     /*  17607 */ // Label 336: @17607
     /*  17607 */ GIM_Try, /*On fail goto*//*Label 382*/ GIMT_Encode4(17724), // Rule ID 1823 //
     /*  17612 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  17615 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s1,
     /*  17618 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s1,
     /*  17621 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::VCCRRegClassID),
     /*  17625 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::VCCRRegClassID),
     /*  17629 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::VCCRRegClassID),
     /*  17633 */   // (and:{ *:[v2i1] } VCCR:{ *:[v2i1] }:$p1, VCCR:{ *:[v2i1] }:$p2)  =>  (COPY_TO_REGCLASS:{ *:[v2i1] } (t2ANDrr:{ *:[i32] } (COPY_TO_REGCLASS:{ *:[i32] } VCCR:{ *:[v2i1] }:$p1, rGPR:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[i32] } VCCR:{ *:[v2i1] }:$p2, rGPR:{ *:[i32] })), VCCR:{ *:[i32] })
     /*  17633 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /*  17636 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  17640 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  17645 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // p2
     /*  17649 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(ARM::rGPRRegClassID),
     /*  17654 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  17657 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  17661 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  17666 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // p1
     /*  17670 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(ARM::rGPRRegClassID),
     /*  17675 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  17678 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::t2ANDrr),
     /*  17682 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  17687 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  17690 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  17693 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/14,
     /*  17696 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  17702 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  17708 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  17710 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  17713 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  17715 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  17718 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::VCCRRegClassID),
     /*  17723 */   // GIR_Coverage, 1823,
     /*  17723 */   GIR_EraseRootFromParent_Done,
     /*  17724 */ // Label 382: @17724
     /*  17724 */ GIM_Reject,
     /*  17725 */ // Label 337: @17725
     /*  17725 */ GIM_Try, /*On fail goto*//*Label 383*/ GIMT_Encode4(17771), // Rule ID 1130 //
     /*  17730 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  17733 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  17736 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  17739 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  17743 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  17747 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  17751 */   // (and:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)  =>  (VANDd:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /*  17751 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VANDd),
     /*  17754 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  17756 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*  17758 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  17760 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  17763 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  17769 */   GIR_RootConstrainSelectedInstOperands,
     /*  17770 */   // GIR_Coverage, 1130,
     /*  17770 */   GIR_EraseRootFromParent_Done,
     /*  17771 */ // Label 383: @17771
     /*  17771 */ GIM_Reject,
     /*  17772 */ // Label 338: @17772
     /*  17772 */ GIM_Try, /*On fail goto*//*Label 384*/ GIMT_Encode4(17885),
     /*  17777 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  17780 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  17783 */   GIM_Try, /*On fail goto*//*Label 385*/ GIMT_Encode4(17823), // Rule ID 2526 //
     /*  17788 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  17791 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  17795 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  17799 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  17803 */     // (and:{ *:[v2i64] } QPR:{ *:[v2i64] }:$LHS, QPR:{ *:[v2i64] }:$RHS)  =>  (VANDq:{ *:[v2i64] } QPR:{ *:[v2i64] }:$LHS, QPR:{ *:[v2i64] }:$RHS)
     /*  17803 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VANDq),
     /*  17806 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  17808 */     GIR_RootToRootCopy, /*OpIdx*/1, // LHS
     /*  17810 */     GIR_RootToRootCopy, /*OpIdx*/2, // RHS
     /*  17812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  17815 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  17821 */     GIR_RootConstrainSelectedInstOperands,
     /*  17822 */     // GIR_Coverage, 2526,
     /*  17822 */     GIR_EraseRootFromParent_Done,
     /*  17823 */   // Label 385: @17823
     /*  17823 */   GIM_Try, /*On fail goto*//*Label 386*/ GIMT_Encode4(17884), // Rule ID 3367 //
     /*  17828 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  17831 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  17835 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  17839 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  17843 */     // (and:{ *:[v2i64] } MQPR:{ *:[v2i64] }:$Qm, MQPR:{ *:[v2i64] }:$Qn)  =>  (MVE_VAND:{ *:[v2i64] } MQPR:{ *:[v2i64] }:$Qm, MQPR:{ *:[v2i64] }:$Qn)
     /*  17843 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  17846 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  17850 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  17855 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VAND),
     /*  17858 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  17860 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /*  17862 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /*  17864 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  17867 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  17873 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  17879 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  17882 */     GIR_RootConstrainSelectedInstOperands,
     /*  17883 */     // GIR_Coverage, 3367,
     /*  17883 */     GIR_EraseRootFromParent_Done,
     /*  17884 */   // Label 386: @17884
     /*  17884 */   GIM_Reject,
     /*  17885 */ // Label 384: @17885
     /*  17885 */ GIM_Reject,
     /*  17886 */ // Label 339: @17886
     /*  17886 */ GIM_Try, /*On fail goto*//*Label 387*/ GIMT_Encode4(18003), // Rule ID 1824 //
     /*  17891 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  17894 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s1,
     /*  17897 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s1,
     /*  17900 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::VCCRRegClassID),
     /*  17904 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::VCCRRegClassID),
     /*  17908 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::VCCRRegClassID),
     /*  17912 */   // (and:{ *:[v4i1] } VCCR:{ *:[v4i1] }:$p1, VCCR:{ *:[v4i1] }:$p2)  =>  (COPY_TO_REGCLASS:{ *:[v4i1] } (t2ANDrr:{ *:[i32] } (COPY_TO_REGCLASS:{ *:[i32] } VCCR:{ *:[v4i1] }:$p1, rGPR:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[i32] } VCCR:{ *:[v4i1] }:$p2, rGPR:{ *:[i32] })), VCCR:{ *:[i32] })
     /*  17912 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /*  17915 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  17919 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  17924 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // p2
     /*  17928 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(ARM::rGPRRegClassID),
     /*  17933 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  17936 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  17940 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  17945 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // p1
     /*  17949 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(ARM::rGPRRegClassID),
     /*  17954 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  17957 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::t2ANDrr),
     /*  17961 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  17966 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  17969 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  17972 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/14,
     /*  17975 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  17981 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  17987 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  17989 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  17992 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  17994 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  17997 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::VCCRRegClassID),
     /*  18002 */   // GIR_Coverage, 1824,
     /*  18002 */   GIR_EraseRootFromParent_Done,
     /*  18003 */ // Label 387: @18003
     /*  18003 */ GIM_Reject,
     /*  18004 */ // Label 340: @18004
     /*  18004 */ GIM_Try, /*On fail goto*//*Label 388*/ GIMT_Encode4(18050), // Rule ID 2522 //
     /*  18009 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  18012 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  18015 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  18018 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  18022 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  18026 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  18030 */   // (and:{ *:[v4i16] } DPR:{ *:[v4i16] }:$LHS, DPR:{ *:[v4i16] }:$RHS)  =>  (VANDd:{ *:[v4i16] } DPR:{ *:[v4i16] }:$LHS, DPR:{ *:[v4i16] }:$RHS)
     /*  18030 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VANDd),
     /*  18033 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  18035 */   GIR_RootToRootCopy, /*OpIdx*/1, // LHS
     /*  18037 */   GIR_RootToRootCopy, /*OpIdx*/2, // RHS
     /*  18039 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  18042 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  18048 */   GIR_RootConstrainSelectedInstOperands,
     /*  18049 */   // GIR_Coverage, 2522,
     /*  18049 */   GIR_EraseRootFromParent_Done,
     /*  18050 */ // Label 388: @18050
     /*  18050 */ GIM_Reject,
     /*  18051 */ // Label 341: @18051
     /*  18051 */ GIM_Try, /*On fail goto*//*Label 389*/ GIMT_Encode4(18164),
     /*  18056 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  18059 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  18062 */   GIM_Try, /*On fail goto*//*Label 390*/ GIMT_Encode4(18102), // Rule ID 1131 //
     /*  18067 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  18070 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  18074 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  18078 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  18082 */     // (and:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)  =>  (VANDq:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)
     /*  18082 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VANDq),
     /*  18085 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  18087 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*  18089 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  18091 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  18094 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  18100 */     GIR_RootConstrainSelectedInstOperands,
     /*  18101 */     // GIR_Coverage, 1131,
     /*  18101 */     GIR_EraseRootFromParent_Done,
     /*  18102 */   // Label 390: @18102
     /*  18102 */   GIM_Try, /*On fail goto*//*Label 391*/ GIMT_Encode4(18163), // Rule ID 3363 //
     /*  18107 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  18110 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  18114 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  18118 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  18122 */     // (and:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)  =>  (MVE_VAND:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)
     /*  18122 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  18125 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  18129 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  18134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VAND),
     /*  18137 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  18139 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /*  18141 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /*  18143 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  18146 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  18152 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  18158 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  18161 */     GIR_RootConstrainSelectedInstOperands,
     /*  18162 */     // GIR_Coverage, 3363,
     /*  18162 */     GIR_EraseRootFromParent_Done,
     /*  18163 */   // Label 391: @18163
     /*  18163 */   GIM_Reject,
     /*  18164 */ // Label 389: @18164
     /*  18164 */ GIM_Reject,
     /*  18165 */ // Label 342: @18165
     /*  18165 */ GIM_Try, /*On fail goto*//*Label 392*/ GIMT_Encode4(18282), // Rule ID 1825 //
     /*  18170 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  18173 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s1,
     /*  18176 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s1,
     /*  18179 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::VCCRRegClassID),
     /*  18183 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::VCCRRegClassID),
     /*  18187 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::VCCRRegClassID),
     /*  18191 */   // (and:{ *:[v8i1] } VCCR:{ *:[v8i1] }:$p1, VCCR:{ *:[v8i1] }:$p2)  =>  (COPY_TO_REGCLASS:{ *:[v8i1] } (t2ANDrr:{ *:[i32] } (COPY_TO_REGCLASS:{ *:[i32] } VCCR:{ *:[v8i1] }:$p1, rGPR:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[i32] } VCCR:{ *:[v8i1] }:$p2, rGPR:{ *:[i32] })), VCCR:{ *:[i32] })
     /*  18191 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /*  18194 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  18198 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  18203 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // p2
     /*  18207 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(ARM::rGPRRegClassID),
     /*  18212 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  18215 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  18219 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  18224 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // p1
     /*  18228 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(ARM::rGPRRegClassID),
     /*  18233 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  18236 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::t2ANDrr),
     /*  18240 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  18245 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  18248 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  18251 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/14,
     /*  18254 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  18260 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  18266 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  18268 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  18271 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  18273 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  18276 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::VCCRRegClassID),
     /*  18281 */   // GIR_Coverage, 1825,
     /*  18281 */   GIR_EraseRootFromParent_Done,
     /*  18282 */ // Label 392: @18282
     /*  18282 */ GIM_Reject,
     /*  18283 */ // Label 343: @18283
     /*  18283 */ GIM_Try, /*On fail goto*//*Label 393*/ GIMT_Encode4(18329), // Rule ID 2521 //
     /*  18288 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  18291 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  18294 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  18297 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  18301 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  18305 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  18309 */   // (and:{ *:[v8i8] } DPR:{ *:[v8i8] }:$LHS, DPR:{ *:[v8i8] }:$RHS)  =>  (VANDd:{ *:[v8i8] } DPR:{ *:[v8i8] }:$LHS, DPR:{ *:[v8i8] }:$RHS)
     /*  18309 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VANDd),
     /*  18312 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  18314 */   GIR_RootToRootCopy, /*OpIdx*/1, // LHS
     /*  18316 */   GIR_RootToRootCopy, /*OpIdx*/2, // RHS
     /*  18318 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  18321 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  18327 */   GIR_RootConstrainSelectedInstOperands,
     /*  18328 */   // GIR_Coverage, 2521,
     /*  18328 */   GIR_EraseRootFromParent_Done,
     /*  18329 */ // Label 393: @18329
     /*  18329 */ GIM_Reject,
     /*  18330 */ // Label 344: @18330
     /*  18330 */ GIM_Try, /*On fail goto*//*Label 394*/ GIMT_Encode4(18443),
     /*  18335 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  18338 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  18341 */   GIM_Try, /*On fail goto*//*Label 395*/ GIMT_Encode4(18381), // Rule ID 2525 //
     /*  18346 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  18349 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  18353 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  18357 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  18361 */     // (and:{ *:[v8i16] } QPR:{ *:[v8i16] }:$LHS, QPR:{ *:[v8i16] }:$RHS)  =>  (VANDq:{ *:[v8i16] } QPR:{ *:[v8i16] }:$LHS, QPR:{ *:[v8i16] }:$RHS)
     /*  18361 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VANDq),
     /*  18364 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  18366 */     GIR_RootToRootCopy, /*OpIdx*/1, // LHS
     /*  18368 */     GIR_RootToRootCopy, /*OpIdx*/2, // RHS
     /*  18370 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  18373 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  18379 */     GIR_RootConstrainSelectedInstOperands,
     /*  18380 */     // GIR_Coverage, 2525,
     /*  18380 */     GIR_EraseRootFromParent_Done,
     /*  18381 */   // Label 395: @18381
     /*  18381 */   GIM_Try, /*On fail goto*//*Label 396*/ GIMT_Encode4(18442), // Rule ID 3359 //
     /*  18386 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  18389 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  18393 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  18397 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  18401 */     // (and:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)  =>  (MVE_VAND:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)
     /*  18401 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  18404 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  18408 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  18413 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VAND),
     /*  18416 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  18418 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /*  18420 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /*  18422 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  18425 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  18431 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  18437 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  18440 */     GIR_RootConstrainSelectedInstOperands,
     /*  18441 */     // GIR_Coverage, 3359,
     /*  18441 */     GIR_EraseRootFromParent_Done,
     /*  18442 */   // Label 396: @18442
     /*  18442 */   GIM_Reject,
     /*  18443 */ // Label 394: @18443
     /*  18443 */ GIM_Reject,
     /*  18444 */ // Label 345: @18444
     /*  18444 */ GIM_Try, /*On fail goto*//*Label 397*/ GIMT_Encode4(18561), // Rule ID 1826 //
     /*  18449 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  18452 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s1,
     /*  18455 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s1,
     /*  18458 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::VCCRRegClassID),
     /*  18462 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::VCCRRegClassID),
     /*  18466 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::VCCRRegClassID),
     /*  18470 */   // (and:{ *:[v16i1] } VCCR:{ *:[v16i1] }:$p1, VCCR:{ *:[v16i1] }:$p2)  =>  (COPY_TO_REGCLASS:{ *:[v16i1] } (t2ANDrr:{ *:[i32] } (COPY_TO_REGCLASS:{ *:[i32] } VCCR:{ *:[v16i1] }:$p1, rGPR:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[i32] } VCCR:{ *:[v16i1] }:$p2, rGPR:{ *:[i32] })), VCCR:{ *:[i32] })
     /*  18470 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /*  18473 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  18477 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  18482 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // p2
     /*  18486 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(ARM::rGPRRegClassID),
     /*  18491 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  18494 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  18498 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  18503 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // p1
     /*  18507 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(ARM::rGPRRegClassID),
     /*  18512 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  18515 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::t2ANDrr),
     /*  18519 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  18524 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  18527 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  18530 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/14,
     /*  18533 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  18539 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  18545 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  18547 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  18550 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  18552 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  18555 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::VCCRRegClassID),
     /*  18560 */   // GIR_Coverage, 1826,
     /*  18560 */   GIR_EraseRootFromParent_Done,
     /*  18561 */ // Label 397: @18561
     /*  18561 */ GIM_Reject,
     /*  18562 */ // Label 346: @18562
     /*  18562 */ GIM_Try, /*On fail goto*//*Label 398*/ GIMT_Encode4(18675),
     /*  18567 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  18570 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  18573 */   GIM_Try, /*On fail goto*//*Label 399*/ GIMT_Encode4(18613), // Rule ID 2524 //
     /*  18578 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  18581 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  18585 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  18589 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  18593 */     // (and:{ *:[v16i8] } QPR:{ *:[v16i8] }:$LHS, QPR:{ *:[v16i8] }:$RHS)  =>  (VANDq:{ *:[v16i8] } QPR:{ *:[v16i8] }:$LHS, QPR:{ *:[v16i8] }:$RHS)
     /*  18593 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VANDq),
     /*  18596 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  18598 */     GIR_RootToRootCopy, /*OpIdx*/1, // LHS
     /*  18600 */     GIR_RootToRootCopy, /*OpIdx*/2, // RHS
     /*  18602 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  18605 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  18611 */     GIR_RootConstrainSelectedInstOperands,
     /*  18612 */     // GIR_Coverage, 2524,
     /*  18612 */     GIR_EraseRootFromParent_Done,
     /*  18613 */   // Label 399: @18613
     /*  18613 */   GIM_Try, /*On fail goto*//*Label 400*/ GIMT_Encode4(18674), // Rule ID 3355 //
     /*  18618 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  18621 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  18625 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  18629 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  18633 */     // (and:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)  =>  (MVE_VAND:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)
     /*  18633 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  18636 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  18640 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  18645 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VAND),
     /*  18648 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  18650 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /*  18652 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /*  18654 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  18657 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  18663 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  18669 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  18672 */     GIR_RootConstrainSelectedInstOperands,
     /*  18673 */     // GIR_Coverage, 3355,
     /*  18673 */     GIR_EraseRootFromParent_Done,
     /*  18674 */   // Label 400: @18674
     /*  18674 */   GIM_Reject,
     /*  18675 */ // Label 398: @18675
     /*  18675 */ GIM_Reject,
     /*  18676 */ // Label 347: @18676
     /*  18676 */ GIM_Reject,
     /*  18677 */ // Label 6: @18677
     /*  18677 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(16), /*)*//*default:*//*Label 414*/ GIMT_Encode4(24485),
     /*  18688 */ /*GILLT_s32*//*Label 401*/ GIMT_Encode4(18748),
     /*  18692 */ /*GILLT_s64*//*Label 402*/ GIMT_Encode4(23369),
     /*  18696 */ /*GILLT_v2s1*//*Label 403*/ GIMT_Encode4(23416),
     /*  18700 */ /*GILLT_v2s32*//*Label 404*/ GIMT_Encode4(23534),
     /*  18704 */ /*GILLT_v2s64*//*Label 405*/ GIMT_Encode4(23581),
     /*  18708 */ /*GILLT_v4s1*//*Label 406*/ GIMT_Encode4(23695),
     /*  18712 */ /*GILLT_v4s16*//*Label 407*/ GIMT_Encode4(23813),
     /*  18716 */ /*GILLT_v4s32*//*Label 408*/ GIMT_Encode4(23860), GIMT_Encode4(0),
     /*  18724 */ /*GILLT_v8s1*//*Label 409*/ GIMT_Encode4(23974),
     /*  18728 */ /*GILLT_v8s8*//*Label 410*/ GIMT_Encode4(24092),
     /*  18732 */ /*GILLT_v8s16*//*Label 411*/ GIMT_Encode4(24139), GIMT_Encode4(0),
     /*  18740 */ /*GILLT_v16s1*//*Label 412*/ GIMT_Encode4(24253),
     /*  18744 */ /*GILLT_v16s8*//*Label 413*/ GIMT_Encode4(24371),
     /*  18748 */ // Label 401: @18748
     /*  18748 */ GIM_Try, /*On fail goto*//*Label 415*/ GIMT_Encode4(23368),
     /*  18753 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  18756 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  18759 */   GIM_Try, /*On fail goto*//*Label 416*/ GIMT_Encode4(18886), // Rule ID 5652 //
     /*  18764 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*  18767 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  18771 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  18775 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  18779 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  18783 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  18787 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  18791 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  18795 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  18799 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  18803 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  18808 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 8,
     /*  18812 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(255),
     /*  18823 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  18827 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*  18831 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*  18835 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*  18839 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  18843 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  18847 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s32,
     /*  18851 */     // MIs[4] Rm
     /*  18851 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  18856 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 24,
     /*  18860 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 16,
     /*  18864 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  18866 */     // (or:{ *:[i32] } (and:{ *:[i32] } (srl:{ *:[i32] } GPR:{ *:[i32] }:$Rm, 8:{ *:[i32] }), 255:{ *:[i32] }), (sra:{ *:[i32] } (shl:{ *:[i32] } GPR:{ *:[i32] }:$Rm, 24:{ *:[i32] }), 16:{ *:[i32] }))  =>  (REVSH:{ *:[i32] } GPR:{ *:[i32] }:$Rm)
     /*  18866 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::REVSH),
     /*  18869 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  18871 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  18875 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  18878 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  18884 */     GIR_RootConstrainSelectedInstOperands,
     /*  18885 */     // GIR_Coverage, 5652,
     /*  18885 */     GIR_EraseRootFromParent_Done,
     /*  18886 */   // Label 416: @18886
     /*  18886 */   GIM_Try, /*On fail goto*//*Label 417*/ GIMT_Encode4(19013), // Rule ID 5694 //
     /*  18891 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /*  18894 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  18898 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  18902 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  18906 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  18910 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  18914 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  18918 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  18922 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  18926 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  18930 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  18935 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 8,
     /*  18939 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(255),
     /*  18950 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  18954 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*  18958 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*  18962 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*  18966 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  18970 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  18974 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s32,
     /*  18978 */     // MIs[4] Rm
     /*  18978 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  18983 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 24,
     /*  18987 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 16,
     /*  18991 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  18993 */     // (or:{ *:[i32] } (and:{ *:[i32] } (srl:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, 8:{ *:[i32] }), 255:{ *:[i32] }), (sra:{ *:[i32] } (shl:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, 24:{ *:[i32] }), 16:{ *:[i32] }))  =>  (t2REVSH:{ *:[i32] } rGPR:{ *:[i32] }:$Rm)
     /*  18993 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2REVSH),
     /*  18996 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  18998 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  19002 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  19005 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  19011 */     GIR_RootConstrainSelectedInstOperands,
     /*  19012 */     // GIR_Coverage, 5694,
     /*  19012 */     GIR_EraseRootFromParent_Done,
     /*  19013 */   // Label 417: @19013
     /*  19013 */   GIM_Try, /*On fail goto*//*Label 418*/ GIMT_Encode4(19140), // Rule ID 1911 //
     /*  19018 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*  19021 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  19025 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  19029 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*  19033 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  19037 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  19041 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  19045 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  19049 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  19053 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  19057 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  19062 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 24,
     /*  19066 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 16,
     /*  19070 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  19074 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_AND),
     /*  19078 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*  19082 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*  19086 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  19090 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  19094 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s32,
     /*  19098 */     // MIs[4] Rm
     /*  19098 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  19103 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 8,
     /*  19107 */     GIM_CheckConstantInt, /*MI*/3, /*Op*/2, GIMT_Encode8(255),
     /*  19118 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  19120 */     // (or:{ *:[i32] } (sra:{ *:[i32] } (shl:{ *:[i32] } GPR:{ *:[i32] }:$Rm, 24:{ *:[i32] }), 16:{ *:[i32] }), (and:{ *:[i32] } (srl:{ *:[i32] } GPR:{ *:[i32] }:$Rm, 8:{ *:[i32] }), 255:{ *:[i32] }))  =>  (REVSH:{ *:[i32] } GPR:{ *:[i32] }:$Rm)
     /*  19120 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::REVSH),
     /*  19123 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  19125 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  19129 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  19132 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  19138 */     GIR_RootConstrainSelectedInstOperands,
     /*  19139 */     // GIR_Coverage, 1911,
     /*  19139 */     GIR_EraseRootFromParent_Done,
     /*  19140 */   // Label 418: @19140
     /*  19140 */   GIM_Try, /*On fail goto*//*Label 419*/ GIMT_Encode4(19267), // Rule ID 2193 //
     /*  19145 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /*  19148 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  19152 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  19156 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*  19160 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  19164 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  19168 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  19172 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  19176 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  19180 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  19184 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  19189 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 24,
     /*  19193 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 16,
     /*  19197 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  19201 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_AND),
     /*  19205 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*  19209 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*  19213 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  19217 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  19221 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s32,
     /*  19225 */     // MIs[4] Rm
     /*  19225 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  19230 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 8,
     /*  19234 */     GIM_CheckConstantInt, /*MI*/3, /*Op*/2, GIMT_Encode8(255),
     /*  19245 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  19247 */     // (or:{ *:[i32] } (sra:{ *:[i32] } (shl:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, 24:{ *:[i32] }), 16:{ *:[i32] }), (and:{ *:[i32] } (srl:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, 8:{ *:[i32] }), 255:{ *:[i32] }))  =>  (t2REVSH:{ *:[i32] } rGPR:{ *:[i32] }:$Rm)
     /*  19247 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2REVSH),
     /*  19250 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  19252 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  19256 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  19259 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  19265 */     GIR_RootConstrainSelectedInstOperands,
     /*  19266 */     // GIR_Coverage, 2193,
     /*  19266 */     GIR_EraseRootFromParent_Done,
     /*  19267 */   // Label 419: @19267
     /*  19267 */   GIM_Try, /*On fail goto*//*Label 420*/ GIMT_Encode4(19400), // Rule ID 5450 //
     /*  19272 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*  19275 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  19279 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  19283 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  19287 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  19291 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  19295 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  19299 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*  19303 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  19307 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  19311 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  19316 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  19320 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  19324 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_pkh_asr_amt),
     /*  19328 */     // MIs[3] Operand 1
     /*  19328 */     // No operand predicates
     /*  19328 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(65535),
     /*  19339 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  19343 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  19347 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_s32,
     /*  19351 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s32,
     /*  19355 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  19360 */     GIM_CheckConstantInt, /*MI*/4, /*Op*/2, GIMT_Encode8(4294901760),
     /*  19371 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  19373 */     // (or:{ *:[i32] } (and:{ *:[i32] } (sra:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rm, (imm:{ *:[i32] })<<P:Predicate_pkh_asr_amt>>:$sh), 65535:{ *:[i32] }), (and:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, 4294901760:{ *:[i32] }))  =>  (PKHTB:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm, (imm:{ *:[i32] }):$sh)
     /*  19373 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::PKHTB),
     /*  19376 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  19378 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Rn
     /*  19382 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  19386 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // sh
     /*  19389 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  19392 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  19398 */     GIR_RootConstrainSelectedInstOperands,
     /*  19399 */     // GIR_Coverage, 5450,
     /*  19399 */     GIR_EraseRootFromParent_Done,
     /*  19400 */   // Label 420: @19400
     /*  19400 */   GIM_Try, /*On fail goto*//*Label 421*/ GIMT_Encode4(19533), // Rule ID 5487 //
     /*  19405 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  19408 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  19412 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  19416 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  19420 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  19424 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  19428 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  19432 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*  19436 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  19440 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  19444 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  19449 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  19453 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  19457 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_pkh_asr_amt),
     /*  19461 */     // MIs[3] Operand 1
     /*  19461 */     // No operand predicates
     /*  19461 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(65535),
     /*  19472 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  19476 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  19480 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_s32,
     /*  19484 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s32,
     /*  19488 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  19493 */     GIM_CheckConstantInt, /*MI*/4, /*Op*/2, GIMT_Encode8(4294901760),
     /*  19504 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  19506 */     // (or:{ *:[i32] } (and:{ *:[i32] } (sra:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, (imm:{ *:[i32] })<<P:Predicate_pkh_asr_amt>>:$sh), 65535:{ *:[i32] }), (and:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, 4294901760:{ *:[i32] }))  =>  (t2PKHTB:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm, (imm:{ *:[i32] }):$sh)
     /*  19506 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2PKHTB),
     /*  19509 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  19511 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Rn
     /*  19515 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  19519 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // sh
     /*  19522 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  19525 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  19531 */     GIR_RootConstrainSelectedInstOperands,
     /*  19532 */     // GIR_Coverage, 5487,
     /*  19532 */     GIR_EraseRootFromParent_Done,
     /*  19533 */   // Label 421: @19533
     /*  19533 */   GIM_Try, /*On fail goto*//*Label 422*/ GIMT_Encode4(19666), // Rule ID 5657 //
     /*  19538 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*  19541 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  19545 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  19549 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  19553 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  19557 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  19561 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  19565 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  19569 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  19573 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  19577 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  19582 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  19586 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  19590 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm1_15),
     /*  19594 */     // MIs[3] Operand 1
     /*  19594 */     // No operand predicates
     /*  19594 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(65535),
     /*  19605 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  19609 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  19613 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_s32,
     /*  19617 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s32,
     /*  19621 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  19626 */     GIM_CheckConstantInt, /*MI*/4, /*Op*/2, GIMT_Encode8(4294901760),
     /*  19637 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  19639 */     // (or:{ *:[i32] } (and:{ *:[i32] } (srl:{ *:[i32] } GPRnopc:{ *:[i32] }:$src2, (imm:{ *:[i32] })<<P:Predicate_imm1_15>>:$sh), 65535:{ *:[i32] }), (and:{ *:[i32] } GPRnopc:{ *:[i32] }:$src1, 4294901760:{ *:[i32] }))  =>  (PKHTB:{ *:[i32] } GPRnopc:{ *:[i32] }:$src1, GPRnopc:{ *:[i32] }:$src2, (imm:{ *:[i32] })<<P:Predicate_imm1_15>>:$sh)
     /*  19639 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::PKHTB),
     /*  19642 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  19644 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // src1
     /*  19648 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src2
     /*  19652 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // sh
     /*  19655 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  19658 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  19664 */     GIR_RootConstrainSelectedInstOperands,
     /*  19665 */     // GIR_Coverage, 5657,
     /*  19665 */     GIR_EraseRootFromParent_Done,
     /*  19666 */   // Label 422: @19666
     /*  19666 */   GIM_Try, /*On fail goto*//*Label 423*/ GIMT_Encode4(19799), // Rule ID 5699 //
     /*  19671 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  19674 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  19678 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  19682 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  19686 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  19690 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  19694 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  19698 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  19702 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  19706 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  19710 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  19715 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  19719 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  19723 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm1_15),
     /*  19727 */     // MIs[3] Operand 1
     /*  19727 */     // No operand predicates
     /*  19727 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(65535),
     /*  19738 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  19742 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  19746 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_s32,
     /*  19750 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s32,
     /*  19754 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  19759 */     GIM_CheckConstantInt, /*MI*/4, /*Op*/2, GIMT_Encode8(4294901760),
     /*  19770 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  19772 */     // (or:{ *:[i32] } (and:{ *:[i32] } (srl:{ *:[i32] } rGPR:{ *:[i32] }:$src2, (imm:{ *:[i32] })<<P:Predicate_imm1_15>>:$sh), 65535:{ *:[i32] }), (and:{ *:[i32] } rGPR:{ *:[i32] }:$src1, 4294901760:{ *:[i32] }))  =>  (t2PKHTB:{ *:[i32] } rGPR:{ *:[i32] }:$src1, rGPR:{ *:[i32] }:$src2, (imm:{ *:[i32] })<<P:Predicate_imm1_15>>:$sh)
     /*  19772 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2PKHTB),
     /*  19775 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  19777 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // src1
     /*  19781 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src2
     /*  19785 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // sh
     /*  19788 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  19791 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  19797 */     GIR_RootConstrainSelectedInstOperands,
     /*  19798 */     // GIR_Coverage, 5699,
     /*  19798 */     GIR_EraseRootFromParent_Done,
     /*  19799 */   // Label 423: @19799
     /*  19799 */   GIM_Try, /*On fail goto*//*Label 424*/ GIMT_Encode4(19932), // Rule ID 5449 //
     /*  19804 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*  19807 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  19811 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  19815 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  19819 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  19823 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  19827 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  19831 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  19835 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  19839 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  19843 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  19848 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  19852 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  19856 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_pkh_lsl_amt),
     /*  19860 */     // MIs[3] Operand 1
     /*  19860 */     // No operand predicates
     /*  19860 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(4294901760),
     /*  19871 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  19875 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  19879 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_s32,
     /*  19883 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s32,
     /*  19887 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  19892 */     GIM_CheckConstantInt, /*MI*/4, /*Op*/2, GIMT_Encode8(65535),
     /*  19903 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  19905 */     // (or:{ *:[i32] } (and:{ *:[i32] } (shl:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rm, (imm:{ *:[i32] })<<P:Predicate_pkh_lsl_amt>>:$sh), 4294901760:{ *:[i32] }), (and:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, 65535:{ *:[i32] }))  =>  (PKHBT:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm, (imm:{ *:[i32] }):$sh)
     /*  19905 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::PKHBT),
     /*  19908 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  19910 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Rn
     /*  19914 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  19918 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // sh
     /*  19921 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  19924 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  19930 */     GIR_RootConstrainSelectedInstOperands,
     /*  19931 */     // GIR_Coverage, 5449,
     /*  19931 */     GIR_EraseRootFromParent_Done,
     /*  19932 */   // Label 424: @19932
     /*  19932 */   GIM_Try, /*On fail goto*//*Label 425*/ GIMT_Encode4(20065), // Rule ID 5486 //
     /*  19937 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  19940 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  19944 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  19948 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  19952 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  19956 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  19960 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  19964 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  19968 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  19972 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  19976 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  19981 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  19985 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  19989 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_pkh_lsl_amt),
     /*  19993 */     // MIs[3] Operand 1
     /*  19993 */     // No operand predicates
     /*  19993 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(4294901760),
     /*  20004 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  20008 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  20012 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_s32,
     /*  20016 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s32,
     /*  20020 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  20025 */     GIM_CheckConstantInt, /*MI*/4, /*Op*/2, GIMT_Encode8(65535),
     /*  20036 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  20038 */     // (or:{ *:[i32] } (and:{ *:[i32] } (shl:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, (imm:{ *:[i32] })<<P:Predicate_pkh_lsl_amt>>:$sh), 4294901760:{ *:[i32] }), (and:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, 65535:{ *:[i32] }))  =>  (t2PKHBT:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm, (imm:{ *:[i32] }):$sh)
     /*  20038 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2PKHBT),
     /*  20041 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  20043 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Rn
     /*  20047 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  20051 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // sh
     /*  20054 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  20057 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  20063 */     GIR_RootConstrainSelectedInstOperands,
     /*  20064 */     // GIR_Coverage, 5486,
     /*  20064 */     GIR_EraseRootFromParent_Done,
     /*  20065 */   // Label 425: @20065
     /*  20065 */   GIM_Try, /*On fail goto*//*Label 426*/ GIMT_Encode4(20198), // Rule ID 203 //
     /*  20070 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*  20073 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  20077 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  20081 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  20085 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  20089 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  20093 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  20098 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(4294901760),
     /*  20109 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  20113 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  20117 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  20121 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  20125 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  20129 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*  20133 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*  20137 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*  20141 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  20146 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  20150 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  20154 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_pkh_asr_amt),
     /*  20158 */     // MIs[4] Operand 1
     /*  20158 */     // No operand predicates
     /*  20158 */     GIM_CheckConstantInt, /*MI*/2, /*Op*/2, GIMT_Encode8(65535),
     /*  20169 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  20171 */     // (or:{ *:[i32] } (and:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, 4294901760:{ *:[i32] }), (and:{ *:[i32] } (sra:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rm, (imm:{ *:[i32] })<<P:Predicate_pkh_asr_amt>>:$sh), 65535:{ *:[i32] }))  =>  (PKHTB:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm, (imm:{ *:[i32] }):$sh)
     /*  20171 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::PKHTB),
     /*  20174 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  20176 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  20180 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  20184 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // sh
     /*  20187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  20190 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  20196 */     GIR_RootConstrainSelectedInstOperands,
     /*  20197 */     // GIR_Coverage, 203,
     /*  20197 */     GIR_EraseRootFromParent_Done,
     /*  20198 */   // Label 426: @20198
     /*  20198 */   GIM_Try, /*On fail goto*//*Label 427*/ GIMT_Encode4(20331), // Rule ID 540 //
     /*  20203 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  20206 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  20210 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  20214 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  20218 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  20222 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  20226 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  20231 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(4294901760),
     /*  20242 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  20246 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  20250 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  20254 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  20258 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  20262 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*  20266 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*  20270 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*  20274 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  20279 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  20283 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  20287 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_pkh_asr_amt),
     /*  20291 */     // MIs[4] Operand 1
     /*  20291 */     // No operand predicates
     /*  20291 */     GIM_CheckConstantInt, /*MI*/2, /*Op*/2, GIMT_Encode8(65535),
     /*  20302 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  20304 */     // (or:{ *:[i32] } (and:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, 4294901760:{ *:[i32] }), (and:{ *:[i32] } (sra:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, (imm:{ *:[i32] })<<P:Predicate_pkh_asr_amt>>:$sh), 65535:{ *:[i32] }))  =>  (t2PKHTB:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm, (imm:{ *:[i32] }):$sh)
     /*  20304 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2PKHTB),
     /*  20307 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  20309 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  20313 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  20317 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // sh
     /*  20320 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  20323 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  20329 */     GIR_RootConstrainSelectedInstOperands,
     /*  20330 */     // GIR_Coverage, 540,
     /*  20330 */     GIR_EraseRootFromParent_Done,
     /*  20331 */   // Label 427: @20331
     /*  20331 */   GIM_Try, /*On fail goto*//*Label 428*/ GIMT_Encode4(20464), // Rule ID 1916 //
     /*  20336 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*  20339 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  20343 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  20347 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  20351 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  20355 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  20359 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  20364 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(4294901760),
     /*  20375 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  20379 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  20383 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  20387 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  20391 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  20395 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  20399 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*  20403 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*  20407 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  20412 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  20416 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  20420 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm1_15),
     /*  20424 */     // MIs[4] Operand 1
     /*  20424 */     // No operand predicates
     /*  20424 */     GIM_CheckConstantInt, /*MI*/2, /*Op*/2, GIMT_Encode8(65535),
     /*  20435 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  20437 */     // (or:{ *:[i32] } (and:{ *:[i32] } GPRnopc:{ *:[i32] }:$src1, 4294901760:{ *:[i32] }), (and:{ *:[i32] } (srl:{ *:[i32] } GPRnopc:{ *:[i32] }:$src2, (imm:{ *:[i32] })<<P:Predicate_imm1_15>>:$sh), 65535:{ *:[i32] }))  =>  (PKHTB:{ *:[i32] } GPRnopc:{ *:[i32] }:$src1, GPRnopc:{ *:[i32] }:$src2, (imm:{ *:[i32] })<<P:Predicate_imm1_15>>:$sh)
     /*  20437 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::PKHTB),
     /*  20440 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  20442 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  20446 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // src2
     /*  20450 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // sh
     /*  20453 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  20456 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  20462 */     GIR_RootConstrainSelectedInstOperands,
     /*  20463 */     // GIR_Coverage, 1916,
     /*  20463 */     GIR_EraseRootFromParent_Done,
     /*  20464 */   // Label 428: @20464
     /*  20464 */   GIM_Try, /*On fail goto*//*Label 429*/ GIMT_Encode4(20597), // Rule ID 2198 //
     /*  20469 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  20472 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  20476 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  20480 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  20484 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  20488 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  20492 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  20497 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(4294901760),
     /*  20508 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  20512 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  20516 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  20520 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  20524 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  20528 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  20532 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*  20536 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*  20540 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  20545 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  20549 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  20553 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm1_15),
     /*  20557 */     // MIs[4] Operand 1
     /*  20557 */     // No operand predicates
     /*  20557 */     GIM_CheckConstantInt, /*MI*/2, /*Op*/2, GIMT_Encode8(65535),
     /*  20568 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  20570 */     // (or:{ *:[i32] } (and:{ *:[i32] } rGPR:{ *:[i32] }:$src1, 4294901760:{ *:[i32] }), (and:{ *:[i32] } (srl:{ *:[i32] } rGPR:{ *:[i32] }:$src2, (imm:{ *:[i32] })<<P:Predicate_imm1_15>>:$sh), 65535:{ *:[i32] }))  =>  (t2PKHTB:{ *:[i32] } rGPR:{ *:[i32] }:$src1, rGPR:{ *:[i32] }:$src2, (imm:{ *:[i32] })<<P:Predicate_imm1_15>>:$sh)
     /*  20570 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2PKHTB),
     /*  20573 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  20575 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  20579 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // src2
     /*  20583 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // sh
     /*  20586 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  20589 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  20595 */     GIR_RootConstrainSelectedInstOperands,
     /*  20596 */     // GIR_Coverage, 2198,
     /*  20596 */     GIR_EraseRootFromParent_Done,
     /*  20597 */   // Label 429: @20597
     /*  20597 */   GIM_Try, /*On fail goto*//*Label 430*/ GIMT_Encode4(20730), // Rule ID 202 //
     /*  20602 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*  20605 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  20609 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  20613 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  20617 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  20621 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  20625 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  20630 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(65535),
     /*  20641 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  20645 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  20649 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  20653 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  20657 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  20661 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  20665 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*  20669 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*  20673 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  20678 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  20682 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  20686 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_pkh_lsl_amt),
     /*  20690 */     // MIs[4] Operand 1
     /*  20690 */     // No operand predicates
     /*  20690 */     GIM_CheckConstantInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4294901760),
     /*  20701 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  20703 */     // (or:{ *:[i32] } (and:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, 65535:{ *:[i32] }), (and:{ *:[i32] } (shl:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rm, (imm:{ *:[i32] })<<P:Predicate_pkh_lsl_amt>>:$sh), 4294901760:{ *:[i32] }))  =>  (PKHBT:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm, (imm:{ *:[i32] }):$sh)
     /*  20703 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::PKHBT),
     /*  20706 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  20708 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  20712 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  20716 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // sh
     /*  20719 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  20722 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  20728 */     GIR_RootConstrainSelectedInstOperands,
     /*  20729 */     // GIR_Coverage, 202,
     /*  20729 */     GIR_EraseRootFromParent_Done,
     /*  20730 */   // Label 430: @20730
     /*  20730 */   GIM_Try, /*On fail goto*//*Label 431*/ GIMT_Encode4(20863), // Rule ID 539 //
     /*  20735 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  20738 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  20742 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  20746 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  20750 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  20754 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  20758 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  20763 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(65535),
     /*  20774 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  20778 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  20782 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  20786 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  20790 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  20794 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  20798 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*  20802 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*  20806 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  20811 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  20815 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  20819 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_pkh_lsl_amt),
     /*  20823 */     // MIs[4] Operand 1
     /*  20823 */     // No operand predicates
     /*  20823 */     GIM_CheckConstantInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4294901760),
     /*  20834 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  20836 */     // (or:{ *:[i32] } (and:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, 65535:{ *:[i32] }), (and:{ *:[i32] } (shl:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, (imm:{ *:[i32] })<<P:Predicate_pkh_lsl_amt>>:$sh), 4294901760:{ *:[i32] }))  =>  (t2PKHBT:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm, (imm:{ *:[i32] }):$sh)
     /*  20836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2PKHBT),
     /*  20839 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  20841 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  20845 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  20849 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // sh
     /*  20852 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  20855 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  20861 */     GIR_RootConstrainSelectedInstOperands,
     /*  20862 */     // GIR_Coverage, 539,
     /*  20862 */     GIR_EraseRootFromParent_Done,
     /*  20863 */   // Label 431: @20863
     /*  20863 */   GIM_Try, /*On fail goto*//*Label 432*/ GIMT_Encode4(20968), // Rule ID 1912 //
     /*  20868 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*  20871 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  20875 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  20879 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  20883 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  20887 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  20891 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  20896 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(65535),
     /*  20907 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  20911 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  20915 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  20919 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  20923 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  20928 */     GIM_CheckConstantInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4294901760),
     /*  20939 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  20941 */     // (or:{ *:[i32] } (and:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, 65535:{ *:[i32] }), (and:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rm, 4294901760:{ *:[i32] }))  =>  (PKHBT:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm, 0:{ *:[i32] })
     /*  20941 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::PKHBT),
     /*  20944 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  20946 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  20950 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  20954 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  20957 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  20960 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  20966 */     GIR_RootConstrainSelectedInstOperands,
     /*  20967 */     // GIR_Coverage, 1912,
     /*  20967 */     GIR_EraseRootFromParent_Done,
     /*  20968 */   // Label 432: @20968
     /*  20968 */   GIM_Try, /*On fail goto*//*Label 433*/ GIMT_Encode4(21073), // Rule ID 2194 //
     /*  20973 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  20976 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  20980 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  20984 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  20988 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  20992 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  20996 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  21001 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(65535),
     /*  21012 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  21016 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  21020 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  21024 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  21028 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  21033 */     GIM_CheckConstantInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4294901760),
     /*  21044 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  21046 */     // (or:{ *:[i32] } (and:{ *:[i32] } rGPR:{ *:[i32] }:$src1, 65535:{ *:[i32] }), (and:{ *:[i32] } rGPR:{ *:[i32] }:$src2, 4294901760:{ *:[i32] }))  =>  (t2PKHBT:{ *:[i32] } rGPR:{ *:[i32] }:$src1, rGPR:{ *:[i32] }:$src2, 0:{ *:[i32] })
     /*  21046 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2PKHBT),
     /*  21049 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  21051 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  21055 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src2
     /*  21059 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  21062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  21065 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  21071 */     GIR_RootConstrainSelectedInstOperands,
     /*  21072 */     // GIR_Coverage, 2194,
     /*  21072 */     GIR_EraseRootFromParent_Done,
     /*  21073 */   // Label 433: @21073
     /*  21073 */   GIM_Try, /*On fail goto*//*Label 434*/ GIMT_Encode4(21178), // Rule ID 5653 //
     /*  21078 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*  21081 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  21085 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  21089 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  21093 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  21097 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  21101 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  21106 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(4294901760),
     /*  21117 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  21121 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  21125 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  21129 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  21133 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  21138 */     GIM_CheckConstantInt, /*MI*/2, /*Op*/2, GIMT_Encode8(65535),
     /*  21149 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  21151 */     // (or:{ *:[i32] } (and:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rm, 4294901760:{ *:[i32] }), (and:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, 65535:{ *:[i32] }))  =>  (PKHBT:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm, 0:{ *:[i32] })
     /*  21151 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::PKHBT),
     /*  21154 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  21156 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  21160 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  21164 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  21167 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  21170 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  21176 */     GIR_RootConstrainSelectedInstOperands,
     /*  21177 */     // GIR_Coverage, 5653,
     /*  21177 */     GIR_EraseRootFromParent_Done,
     /*  21178 */   // Label 434: @21178
     /*  21178 */   GIM_Try, /*On fail goto*//*Label 435*/ GIMT_Encode4(21283), // Rule ID 5695 //
     /*  21183 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  21186 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  21190 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  21194 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  21198 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  21202 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  21206 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  21211 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(4294901760),
     /*  21222 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  21226 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  21230 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  21234 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  21238 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  21243 */     GIM_CheckConstantInt, /*MI*/2, /*Op*/2, GIMT_Encode8(65535),
     /*  21254 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  21256 */     // (or:{ *:[i32] } (and:{ *:[i32] } rGPR:{ *:[i32] }:$src2, 4294901760:{ *:[i32] }), (and:{ *:[i32] } rGPR:{ *:[i32] }:$src1, 65535:{ *:[i32] }))  =>  (t2PKHBT:{ *:[i32] } rGPR:{ *:[i32] }:$src1, rGPR:{ *:[i32] }:$src2, 0:{ *:[i32] })
     /*  21256 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2PKHBT),
     /*  21259 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  21261 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src1
     /*  21265 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src2
     /*  21269 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  21272 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  21275 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  21281 */     GIR_RootConstrainSelectedInstOperands,
     /*  21282 */     // GIR_Coverage, 5695,
     /*  21282 */     GIR_EraseRootFromParent_Done,
     /*  21283 */   // Label 435: @21283
     /*  21283 */   GIM_Try, /*On fail goto*//*Label 436*/ GIMT_Encode4(21389), // Rule ID 1915 //
     /*  21288 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*  21291 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  21295 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  21299 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  21303 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  21307 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  21311 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  21316 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(4294901760),
     /*  21327 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  21331 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*  21335 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  21339 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  21343 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  21348 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  21352 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  21356 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm16_31),
     /*  21360 */     // MIs[3] Operand 1
     /*  21360 */     // No operand predicates
     /*  21360 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  21362 */     // (or:{ *:[i32] } (and:{ *:[i32] } GPRnopc:{ *:[i32] }:$src1, 4294901760:{ *:[i32] }), (sra:{ *:[i32] } GPRnopc:{ *:[i32] }:$src2, (imm:{ *:[i32] })<<P:Predicate_imm16_31>>:$sh))  =>  (PKHTB:{ *:[i32] } GPRnopc:{ *:[i32] }:$src1, GPRnopc:{ *:[i32] }:$src2, (imm:{ *:[i32] })<<P:Predicate_imm16_31>>:$sh)
     /*  21362 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::PKHTB),
     /*  21365 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  21367 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  21371 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src2
     /*  21375 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // sh
     /*  21378 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  21381 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  21387 */     GIR_RootConstrainSelectedInstOperands,
     /*  21388 */     // GIR_Coverage, 1915,
     /*  21388 */     GIR_EraseRootFromParent_Done,
     /*  21389 */   // Label 436: @21389
     /*  21389 */   GIM_Try, /*On fail goto*//*Label 437*/ GIMT_Encode4(21495), // Rule ID 2197 //
     /*  21394 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  21397 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  21401 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  21405 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  21409 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  21413 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  21417 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  21422 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(4294901760),
     /*  21433 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  21437 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*  21441 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  21445 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  21449 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  21454 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  21458 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  21462 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm16_31),
     /*  21466 */     // MIs[3] Operand 1
     /*  21466 */     // No operand predicates
     /*  21466 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  21468 */     // (or:{ *:[i32] } (and:{ *:[i32] } rGPR:{ *:[i32] }:$src1, 4294901760:{ *:[i32] }), (sra:{ *:[i32] } rGPR:{ *:[i32] }:$src2, (imm:{ *:[i32] })<<P:Predicate_imm16_31>>:$sh))  =>  (t2PKHTB:{ *:[i32] } rGPR:{ *:[i32] }:$src1, rGPR:{ *:[i32] }:$src2, (imm:{ *:[i32] })<<P:Predicate_imm16_31>>:$sh)
     /*  21468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2PKHTB),
     /*  21471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  21473 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  21477 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src2
     /*  21481 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // sh
     /*  21484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  21487 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  21493 */     GIR_RootConstrainSelectedInstOperands,
     /*  21494 */     // GIR_Coverage, 2197,
     /*  21494 */     GIR_EraseRootFromParent_Done,
     /*  21495 */   // Label 437: @21495
     /*  21495 */   GIM_Try, /*On fail goto*//*Label 438*/ GIMT_Encode4(21601), // Rule ID 1914 //
     /*  21500 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*  21503 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  21507 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  21511 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  21515 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  21519 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  21523 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  21528 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(4294901760),
     /*  21539 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  21543 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  21547 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  21551 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  21555 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  21560 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  21564 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  21568 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm16),
     /*  21572 */     // MIs[3] Operand 1
     /*  21572 */     // No operand predicates
     /*  21572 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  21574 */     // (or:{ *:[i32] } (and:{ *:[i32] } GPRnopc:{ *:[i32] }:$src1, 4294901760:{ *:[i32] }), (srl:{ *:[i32] } GPRnopc:{ *:[i32] }:$src2, (imm:{ *:[i32] })<<P:Predicate_imm16>>:$sh))  =>  (PKHTB:{ *:[i32] } GPRnopc:{ *:[i32] }:$src1, GPRnopc:{ *:[i32] }:$src2, (imm:{ *:[i32] })<<P:Predicate_imm16>>:$sh)
     /*  21574 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::PKHTB),
     /*  21577 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  21579 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  21583 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src2
     /*  21587 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // sh
     /*  21590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  21593 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  21599 */     GIR_RootConstrainSelectedInstOperands,
     /*  21600 */     // GIR_Coverage, 1914,
     /*  21600 */     GIR_EraseRootFromParent_Done,
     /*  21601 */   // Label 438: @21601
     /*  21601 */   GIM_Try, /*On fail goto*//*Label 439*/ GIMT_Encode4(21707), // Rule ID 2196 //
     /*  21606 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  21609 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  21613 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  21617 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  21621 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  21625 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  21629 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  21634 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(4294901760),
     /*  21645 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  21649 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  21653 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  21657 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  21661 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  21666 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  21670 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  21674 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm16),
     /*  21678 */     // MIs[3] Operand 1
     /*  21678 */     // No operand predicates
     /*  21678 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  21680 */     // (or:{ *:[i32] } (and:{ *:[i32] } rGPR:{ *:[i32] }:$src1, 4294901760:{ *:[i32] }), (srl:{ *:[i32] } rGPR:{ *:[i32] }:$src2, (imm:{ *:[i32] })<<P:Predicate_imm16>>:$sh))  =>  (t2PKHTB:{ *:[i32] } rGPR:{ *:[i32] }:$src1, rGPR:{ *:[i32] }:$src2, (imm:{ *:[i32] })<<P:Predicate_imm16>>:$sh)
     /*  21680 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2PKHTB),
     /*  21683 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  21685 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  21689 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src2
     /*  21693 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // sh
     /*  21696 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  21699 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  21705 */     GIR_RootConstrainSelectedInstOperands,
     /*  21706 */     // GIR_Coverage, 2196,
     /*  21706 */     GIR_EraseRootFromParent_Done,
     /*  21707 */   // Label 439: @21707
     /*  21707 */   GIM_Try, /*On fail goto*//*Label 440*/ GIMT_Encode4(21813), // Rule ID 1913 //
     /*  21712 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*  21715 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  21719 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  21723 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  21727 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  21731 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  21735 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  21740 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(65535),
     /*  21751 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  21755 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  21759 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  21763 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  21767 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  21772 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  21776 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  21780 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm16_31),
     /*  21784 */     // MIs[3] Operand 1
     /*  21784 */     // No operand predicates
     /*  21784 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  21786 */     // (or:{ *:[i32] } (and:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, 65535:{ *:[i32] }), (shl:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rm, (imm:{ *:[i32] })<<P:Predicate_imm16_31>>:$sh))  =>  (PKHBT:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm, (imm:{ *:[i32] })<<P:Predicate_imm16_31>>:$sh)
     /*  21786 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::PKHBT),
     /*  21789 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  21791 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  21795 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  21799 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // sh
     /*  21802 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  21805 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  21811 */     GIR_RootConstrainSelectedInstOperands,
     /*  21812 */     // GIR_Coverage, 1913,
     /*  21812 */     GIR_EraseRootFromParent_Done,
     /*  21813 */   // Label 440: @21813
     /*  21813 */   GIM_Try, /*On fail goto*//*Label 441*/ GIMT_Encode4(21919), // Rule ID 2195 //
     /*  21818 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  21821 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  21825 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  21829 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  21833 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  21837 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  21841 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  21846 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(65535),
     /*  21857 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  21861 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  21865 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  21869 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  21873 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  21878 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  21882 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  21886 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm16_31),
     /*  21890 */     // MIs[3] Operand 1
     /*  21890 */     // No operand predicates
     /*  21890 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  21892 */     // (or:{ *:[i32] } (and:{ *:[i32] } rGPR:{ *:[i32] }:$src1, 65535:{ *:[i32] }), (shl:{ *:[i32] } rGPR:{ *:[i32] }:$src2, (imm:{ *:[i32] })<<P:Predicate_imm16_31>>:$sh))  =>  (t2PKHBT:{ *:[i32] } rGPR:{ *:[i32] }:$src1, rGPR:{ *:[i32] }:$src2, (imm:{ *:[i32] })<<P:Predicate_imm16_31>>:$sh)
     /*  21892 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2PKHBT),
     /*  21895 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  21897 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  21901 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src2
     /*  21905 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // sh
     /*  21908 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  21911 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  21917 */     GIR_RootConstrainSelectedInstOperands,
     /*  21918 */     // GIR_Coverage, 2195,
     /*  21918 */     GIR_EraseRootFromParent_Done,
     /*  21919 */   // Label 441: @21919
     /*  21919 */   GIM_Try, /*On fail goto*//*Label 442*/ GIMT_Encode4(22025), // Rule ID 5656 //
     /*  21924 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*  21927 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  21931 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  21935 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*  21939 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  21943 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  21947 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  21952 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  21956 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  21960 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm16_31),
     /*  21964 */     // MIs[2] Operand 1
     /*  21964 */     // No operand predicates
     /*  21964 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  21968 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_AND),
     /*  21972 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*  21976 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*  21980 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  21985 */     GIM_CheckConstantInt, /*MI*/3, /*Op*/2, GIMT_Encode8(4294901760),
     /*  21996 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  21998 */     // (or:{ *:[i32] } (sra:{ *:[i32] } GPRnopc:{ *:[i32] }:$src2, (imm:{ *:[i32] })<<P:Predicate_imm16_31>>:$sh), (and:{ *:[i32] } GPRnopc:{ *:[i32] }:$src1, 4294901760:{ *:[i32] }))  =>  (PKHTB:{ *:[i32] } GPRnopc:{ *:[i32] }:$src1, GPRnopc:{ *:[i32] }:$src2, (imm:{ *:[i32] })<<P:Predicate_imm16_31>>:$sh)
     /*  21998 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::PKHTB),
     /*  22001 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  22003 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // src1
     /*  22007 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src2
     /*  22011 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // sh
     /*  22014 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  22017 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  22023 */     GIR_RootConstrainSelectedInstOperands,
     /*  22024 */     // GIR_Coverage, 5656,
     /*  22024 */     GIR_EraseRootFromParent_Done,
     /*  22025 */   // Label 442: @22025
     /*  22025 */   GIM_Try, /*On fail goto*//*Label 443*/ GIMT_Encode4(22131), // Rule ID 5698 //
     /*  22030 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  22033 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  22037 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  22041 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*  22045 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  22049 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  22053 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  22058 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  22062 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  22066 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm16_31),
     /*  22070 */     // MIs[2] Operand 1
     /*  22070 */     // No operand predicates
     /*  22070 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  22074 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_AND),
     /*  22078 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*  22082 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*  22086 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  22091 */     GIM_CheckConstantInt, /*MI*/3, /*Op*/2, GIMT_Encode8(4294901760),
     /*  22102 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  22104 */     // (or:{ *:[i32] } (sra:{ *:[i32] } rGPR:{ *:[i32] }:$src2, (imm:{ *:[i32] })<<P:Predicate_imm16_31>>:$sh), (and:{ *:[i32] } rGPR:{ *:[i32] }:$src1, 4294901760:{ *:[i32] }))  =>  (t2PKHTB:{ *:[i32] } rGPR:{ *:[i32] }:$src1, rGPR:{ *:[i32] }:$src2, (imm:{ *:[i32] })<<P:Predicate_imm16_31>>:$sh)
     /*  22104 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2PKHTB),
     /*  22107 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  22109 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // src1
     /*  22113 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src2
     /*  22117 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // sh
     /*  22120 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  22123 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  22129 */     GIR_RootConstrainSelectedInstOperands,
     /*  22130 */     // GIR_Coverage, 5698,
     /*  22130 */     GIR_EraseRootFromParent_Done,
     /*  22131 */   // Label 443: @22131
     /*  22131 */   GIM_Try, /*On fail goto*//*Label 444*/ GIMT_Encode4(22237), // Rule ID 5655 //
     /*  22136 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*  22139 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  22143 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  22147 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  22151 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  22155 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  22159 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  22164 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  22168 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  22172 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm16),
     /*  22176 */     // MIs[2] Operand 1
     /*  22176 */     // No operand predicates
     /*  22176 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  22180 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_AND),
     /*  22184 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*  22188 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*  22192 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  22197 */     GIM_CheckConstantInt, /*MI*/3, /*Op*/2, GIMT_Encode8(4294901760),
     /*  22208 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  22210 */     // (or:{ *:[i32] } (srl:{ *:[i32] } GPRnopc:{ *:[i32] }:$src2, (imm:{ *:[i32] })<<P:Predicate_imm16>>:$sh), (and:{ *:[i32] } GPRnopc:{ *:[i32] }:$src1, 4294901760:{ *:[i32] }))  =>  (PKHTB:{ *:[i32] } GPRnopc:{ *:[i32] }:$src1, GPRnopc:{ *:[i32] }:$src2, (imm:{ *:[i32] })<<P:Predicate_imm16>>:$sh)
     /*  22210 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::PKHTB),
     /*  22213 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  22215 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // src1
     /*  22219 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src2
     /*  22223 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // sh
     /*  22226 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  22229 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  22235 */     GIR_RootConstrainSelectedInstOperands,
     /*  22236 */     // GIR_Coverage, 5655,
     /*  22236 */     GIR_EraseRootFromParent_Done,
     /*  22237 */   // Label 444: @22237
     /*  22237 */   GIM_Try, /*On fail goto*//*Label 445*/ GIMT_Encode4(22343), // Rule ID 5697 //
     /*  22242 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  22245 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  22249 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  22253 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  22257 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  22261 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  22265 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  22270 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  22274 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  22278 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm16),
     /*  22282 */     // MIs[2] Operand 1
     /*  22282 */     // No operand predicates
     /*  22282 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  22286 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_AND),
     /*  22290 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*  22294 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*  22298 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  22303 */     GIM_CheckConstantInt, /*MI*/3, /*Op*/2, GIMT_Encode8(4294901760),
     /*  22314 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  22316 */     // (or:{ *:[i32] } (srl:{ *:[i32] } rGPR:{ *:[i32] }:$src2, (imm:{ *:[i32] })<<P:Predicate_imm16>>:$sh), (and:{ *:[i32] } rGPR:{ *:[i32] }:$src1, 4294901760:{ *:[i32] }))  =>  (t2PKHTB:{ *:[i32] } rGPR:{ *:[i32] }:$src1, rGPR:{ *:[i32] }:$src2, (imm:{ *:[i32] })<<P:Predicate_imm16>>:$sh)
     /*  22316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2PKHTB),
     /*  22319 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  22321 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // src1
     /*  22325 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src2
     /*  22329 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // sh
     /*  22332 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  22335 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  22341 */     GIR_RootConstrainSelectedInstOperands,
     /*  22342 */     // GIR_Coverage, 5697,
     /*  22342 */     GIR_EraseRootFromParent_Done,
     /*  22343 */   // Label 445: @22343
     /*  22343 */   GIM_Try, /*On fail goto*//*Label 446*/ GIMT_Encode4(22449), // Rule ID 5654 //
     /*  22348 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*  22351 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  22355 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  22359 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  22363 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  22367 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  22371 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  22376 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  22380 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  22384 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm16_31),
     /*  22388 */     // MIs[2] Operand 1
     /*  22388 */     // No operand predicates
     /*  22388 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  22392 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_AND),
     /*  22396 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*  22400 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*  22404 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  22409 */     GIM_CheckConstantInt, /*MI*/3, /*Op*/2, GIMT_Encode8(65535),
     /*  22420 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  22422 */     // (or:{ *:[i32] } (shl:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rm, (imm:{ *:[i32] })<<P:Predicate_imm16_31>>:$sh), (and:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, 65535:{ *:[i32] }))  =>  (PKHBT:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm, (imm:{ *:[i32] })<<P:Predicate_imm16_31>>:$sh)
     /*  22422 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::PKHBT),
     /*  22425 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  22427 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /*  22431 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  22435 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // sh
     /*  22438 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  22441 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  22447 */     GIR_RootConstrainSelectedInstOperands,
     /*  22448 */     // GIR_Coverage, 5654,
     /*  22448 */     GIR_EraseRootFromParent_Done,
     /*  22449 */   // Label 446: @22449
     /*  22449 */   GIM_Try, /*On fail goto*//*Label 447*/ GIMT_Encode4(22555), // Rule ID 5696 //
     /*  22454 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  22457 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  22461 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  22465 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  22469 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  22473 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  22477 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  22482 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  22486 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  22490 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm16_31),
     /*  22494 */     // MIs[2] Operand 1
     /*  22494 */     // No operand predicates
     /*  22494 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  22498 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_AND),
     /*  22502 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*  22506 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*  22510 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  22515 */     GIM_CheckConstantInt, /*MI*/3, /*Op*/2, GIMT_Encode8(65535),
     /*  22526 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  22528 */     // (or:{ *:[i32] } (shl:{ *:[i32] } rGPR:{ *:[i32] }:$src2, (imm:{ *:[i32] })<<P:Predicate_imm16_31>>:$sh), (and:{ *:[i32] } rGPR:{ *:[i32] }:$src1, 65535:{ *:[i32] }))  =>  (t2PKHBT:{ *:[i32] } rGPR:{ *:[i32] }:$src1, rGPR:{ *:[i32] }:$src2, (imm:{ *:[i32] })<<P:Predicate_imm16_31>>:$sh)
     /*  22528 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2PKHBT),
     /*  22531 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  22533 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // src1
     /*  22537 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src2
     /*  22541 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // sh
     /*  22544 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  22547 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  22553 */     GIR_RootConstrainSelectedInstOperands,
     /*  22554 */     // GIR_Coverage, 5696,
     /*  22554 */     GIR_EraseRootFromParent_Done,
     /*  22555 */   // Label 447: @22555
     /*  22555 */   GIM_Try, /*On fail goto*//*Label 448*/ GIMT_Encode4(22632), // Rule ID 5474 //
     /*  22560 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /*  22563 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  22567 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  22571 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  22575 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  22579 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  22583 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, uint8_t(-1),
     /*  22587 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  22591 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  22595 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_t2_so_imm),
     /*  22599 */     // MIs[2] Operand 1
     /*  22599 */     // No operand predicates
     /*  22599 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  22603 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  22605 */     // (or:{ *:[i32] } (xor:{ *:[i32] } -1:{ *:[i32] }, (imm:{ *:[i32] })<<P:Predicate_t2_so_imm>>:$imm), rGPR:{ *:[i32] }:$Rn)  =>  (t2ORNri:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  22605 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2ORNri),
     /*  22608 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  22610 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  22612 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  22615 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  22618 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  22624 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  22630 */     GIR_RootConstrainSelectedInstOperands,
     /*  22631 */     // GIR_Coverage, 5474,
     /*  22631 */     GIR_EraseRootFromParent_Done,
     /*  22632 */   // Label 448: @22632
     /*  22632 */   GIM_Try, /*On fail goto*//*Label 449*/ GIMT_Encode4(22709), // Rule ID 5473 //
     /*  22637 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /*  22640 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  22644 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  22648 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  22652 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  22656 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  22660 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  22664 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  22668 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_t2_so_imm),
     /*  22672 */     // MIs[2] Operand 1
     /*  22672 */     // No operand predicates
     /*  22672 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  22676 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  22680 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  22682 */     // (or:{ *:[i32] } (xor:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_t2_so_imm>>:$imm, -1:{ *:[i32] }), rGPR:{ *:[i32] }:$Rn)  =>  (t2ORNri:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  22682 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2ORNri),
     /*  22685 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  22687 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  22689 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  22692 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  22695 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  22701 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  22707 */     GIR_RootConstrainSelectedInstOperands,
     /*  22708 */     // GIR_Coverage, 5473,
     /*  22708 */     GIR_EraseRootFromParent_Done,
     /*  22709 */   // Label 449: @22709
     /*  22709 */   GIM_Try, /*On fail goto*//*Label 450*/ GIMT_Encode4(22786), // Rule ID 5472 //
     /*  22714 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /*  22717 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  22721 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  22725 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  22729 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  22733 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  22737 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  22741 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, uint8_t(-1),
     /*  22745 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  22749 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  22753 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_t2_so_imm),
     /*  22757 */     // MIs[2] Operand 1
     /*  22757 */     // No operand predicates
     /*  22757 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  22759 */     // (or:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, (xor:{ *:[i32] } -1:{ *:[i32] }, (imm:{ *:[i32] })<<P:Predicate_t2_so_imm>>:$imm))  =>  (t2ORNri:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  22759 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2ORNri),
     /*  22762 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  22764 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  22766 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  22769 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  22772 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  22778 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  22784 */     GIR_RootConstrainSelectedInstOperands,
     /*  22785 */     // GIR_Coverage, 5472,
     /*  22785 */     GIR_EraseRootFromParent_Done,
     /*  22786 */   // Label 450: @22786
     /*  22786 */   GIM_Try, /*On fail goto*//*Label 451*/ GIMT_Encode4(22863), // Rule ID 496 //
     /*  22791 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /*  22794 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  22798 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  22802 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  22806 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  22810 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  22814 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  22818 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  22822 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  22826 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_t2_so_imm),
     /*  22830 */     // MIs[2] Operand 1
     /*  22830 */     // No operand predicates
     /*  22830 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  22834 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  22836 */     // (or:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, (xor:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_t2_so_imm>>:$imm, -1:{ *:[i32] }))  =>  (t2ORNri:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  22836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2ORNri),
     /*  22839 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  22841 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  22843 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  22846 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  22849 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  22855 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  22861 */     GIR_RootConstrainSelectedInstOperands,
     /*  22862 */     // GIR_Coverage, 496,
     /*  22862 */     GIR_EraseRootFromParent_Done,
     /*  22863 */   // Label 451: @22863
     /*  22863 */   GIM_Try, /*On fail goto*//*Label 452*/ GIMT_Encode4(22934), // Rule ID 5475 //
     /*  22868 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /*  22871 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  22875 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  22879 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  22883 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  22887 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  22891 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  22896 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  22900 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  22904 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  22906 */     // (or:{ *:[i32] } (xor:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, -1:{ *:[i32] }), rGPR:{ *:[i32] }:$Rn)  =>  (t2ORNrr:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  22906 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2ORNrr),
     /*  22909 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  22911 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  22913 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  22917 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  22920 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  22926 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  22932 */     GIR_RootConstrainSelectedInstOperands,
     /*  22933 */     // GIR_Coverage, 5475,
     /*  22933 */     GIR_EraseRootFromParent_Done,
     /*  22934 */   // Label 452: @22934
     /*  22934 */   GIM_Try, /*On fail goto*//*Label 453*/ GIMT_Encode4(23005), // Rule ID 497 //
     /*  22939 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /*  22942 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  22946 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  22950 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  22954 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  22958 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  22962 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  22966 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  22971 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  22975 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  22977 */     // (or:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, (xor:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, -1:{ *:[i32] }))  =>  (t2ORNrr:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  22977 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2ORNrr),
     /*  22980 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  22982 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  22984 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  22988 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  22991 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  22997 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  23003 */     GIR_RootConstrainSelectedInstOperands,
     /*  23004 */     // GIR_Coverage, 497,
     /*  23004 */     GIR_EraseRootFromParent_Done,
     /*  23005 */   // Label 453: @23005
     /*  23005 */   GIM_Try, /*On fail goto*//*Label 454*/ GIMT_Encode4(23060), // Rule ID 1845 //
     /*  23010 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6T2_IsARM),
     /*  23013 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  23017 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  23021 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(4294901760),
     /*  23032 */     // (or:{ *:[i32] } GPR:{ *:[i32] }:$src, 4294901760:{ *:[i32] })  =>  (MOVTi16:{ *:[i32] } GPR:{ *:[i32] }:$src, 65535:{ *:[i32] })
     /*  23032 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MOVTi16),
     /*  23035 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  23037 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  23039 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(65535),
     /*  23049 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  23052 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  23058 */     GIR_RootConstrainSelectedInstOperands,
     /*  23059 */     // GIR_Coverage, 1845,
     /*  23059 */     GIR_EraseRootFromParent_Done,
     /*  23060 */   // Label 454: @23060
     /*  23060 */   GIM_Try, /*On fail goto*//*Label 455*/ GIMT_Encode4(23115), // Rule ID 2091 //
     /*  23065 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /*  23068 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  23072 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  23076 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(4294901760),
     /*  23087 */     // (or:{ *:[i32] } rGPR:{ *:[i32] }:$src, 4294901760:{ *:[i32] })  =>  (t2MOVTi16:{ *:[i32] } rGPR:{ *:[i32] }:$src, 65535:{ *:[i32] })
     /*  23087 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2MOVTi16),
     /*  23090 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  23092 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  23094 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(65535),
     /*  23104 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  23107 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  23113 */     GIR_RootConstrainSelectedInstOperands,
     /*  23114 */     // GIR_Coverage, 2091,
     /*  23114 */     GIR_EraseRootFromParent_Done,
     /*  23115 */   // Label 455: @23115
     /*  23115 */   GIM_Try, /*On fail goto*//*Label 456*/ GIMT_Encode4(23172), // Rule ID 151 //
     /*  23120 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  23123 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  23127 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  23131 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  23135 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  23139 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_mod_imm),
     /*  23143 */     // MIs[1] Operand 1
     /*  23143 */     // No operand predicates
     /*  23143 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  23145 */     // (or:{ *:[i32] } GPR:{ *:[i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_mod_imm>>:$imm)  =>  (ORRri:{ *:[i32] } GPR:{ *:[i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  23145 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::ORRri),
     /*  23148 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  23150 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  23152 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  23155 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  23158 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  23164 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  23170 */     GIR_RootConstrainSelectedInstOperands,
     /*  23171 */     // GIR_Coverage, 151,
     /*  23171 */     GIR_EraseRootFromParent_Done,
     /*  23172 */   // Label 456: @23172
     /*  23172 */   GIM_Try, /*On fail goto*//*Label 457*/ GIMT_Encode4(23229), // Rule ID 484 //
     /*  23177 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /*  23180 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  23184 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  23188 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  23192 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  23196 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_t2_so_imm),
     /*  23200 */     // MIs[1] Operand 1
     /*  23200 */     // No operand predicates
     /*  23200 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  23202 */     // (or:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_t2_so_imm>>:$imm)  =>  (t2ORRri:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  23202 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2ORRri),
     /*  23205 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  23207 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  23209 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  23212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  23215 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  23221 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  23227 */     GIR_RootConstrainSelectedInstOperands,
     /*  23228 */     // GIR_Coverage, 484,
     /*  23228 */     GIR_EraseRootFromParent_Done,
     /*  23229 */   // Label 457: @23229
     /*  23229 */   GIM_Try, /*On fail goto*//*Label 458*/ GIMT_Encode4(23275), // Rule ID 152 //
     /*  23234 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  23237 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  23241 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  23245 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  23249 */     // (or:{ *:[i32] } GPR:{ *:[i32] }:$Rn, GPR:{ *:[i32] }:$Rm)  =>  (ORRrr:{ *:[i32] } GPR:{ *:[i32] }:$Rn, GPR:{ *:[i32] }:$Rm)
     /*  23249 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::ORRrr),
     /*  23252 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  23254 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  23256 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /*  23258 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  23261 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  23267 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  23273 */     GIR_RootConstrainSelectedInstOperands,
     /*  23274 */     // GIR_Coverage, 152,
     /*  23274 */     GIR_EraseRootFromParent_Done,
     /*  23275 */   // Label 458: @23275
     /*  23275 */   GIM_Try, /*On fail goto*//*Label 459*/ GIMT_Encode4(23321), // Rule ID 325 //
     /*  23280 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb_IsThumb1Only),
     /*  23283 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /*  23287 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /*  23291 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /*  23295 */     // (or:{ *:[i32] } tGPR:{ *:[i32] }:$Rn, tGPR:{ *:[i32] }:$Rm)  =>  (tORR:{ *:[i32] } tGPR:{ *:[i32] }:$Rn, tGPR:{ *:[i32] }:$Rm)
     /*  23295 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::tORR),
     /*  23298 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /*  23300 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::CPSR), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define | RegState::Dead),
     /*  23306 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  23308 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /*  23310 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  23313 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  23319 */     GIR_RootConstrainSelectedInstOperands,
     /*  23320 */     // GIR_Coverage, 325,
     /*  23320 */     GIR_EraseRootFromParent_Done,
     /*  23321 */   // Label 459: @23321
     /*  23321 */   GIM_Try, /*On fail goto*//*Label 460*/ GIMT_Encode4(23367), // Rule ID 485 //
     /*  23326 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /*  23329 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  23333 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  23337 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  23341 */     // (or:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2ORRrr:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  23341 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2ORRrr),
     /*  23344 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  23346 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  23348 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /*  23350 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  23353 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  23359 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  23365 */     GIR_RootConstrainSelectedInstOperands,
     /*  23366 */     // GIR_Coverage, 485,
     /*  23366 */     GIR_EraseRootFromParent_Done,
     /*  23367 */   // Label 460: @23367
     /*  23367 */   GIM_Reject,
     /*  23368 */ // Label 415: @23368
     /*  23368 */ GIM_Reject,
     /*  23369 */ // Label 402: @23369
     /*  23369 */ GIM_Try, /*On fail goto*//*Label 461*/ GIMT_Encode4(23415), // Rule ID 2529 //
     /*  23374 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  23377 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  23380 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  23383 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  23387 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  23391 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  23395 */   // (or:{ *:[v1i64] } DPR:{ *:[v1i64] }:$LHS, DPR:{ *:[v1i64] }:$RHS)  =>  (VORRd:{ *:[v1i64] } DPR:{ *:[v1i64] }:$LHS, DPR:{ *:[v1i64] }:$RHS)
     /*  23395 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VORRd),
     /*  23398 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  23400 */   GIR_RootToRootCopy, /*OpIdx*/1, // LHS
     /*  23402 */   GIR_RootToRootCopy, /*OpIdx*/2, // RHS
     /*  23404 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  23407 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  23413 */   GIR_RootConstrainSelectedInstOperands,
     /*  23414 */   // GIR_Coverage, 2529,
     /*  23414 */   GIR_EraseRootFromParent_Done,
     /*  23415 */ // Label 461: @23415
     /*  23415 */ GIM_Reject,
     /*  23416 */ // Label 403: @23416
     /*  23416 */ GIM_Try, /*On fail goto*//*Label 462*/ GIMT_Encode4(23533), // Rule ID 1831 //
     /*  23421 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  23424 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s1,
     /*  23427 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s1,
     /*  23430 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::VCCRRegClassID),
     /*  23434 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::VCCRRegClassID),
     /*  23438 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::VCCRRegClassID),
     /*  23442 */   // (or:{ *:[v2i1] } VCCR:{ *:[v2i1] }:$p1, VCCR:{ *:[v2i1] }:$p2)  =>  (COPY_TO_REGCLASS:{ *:[v2i1] } (t2ORRrr:{ *:[i32] } (COPY_TO_REGCLASS:{ *:[i32] } VCCR:{ *:[v2i1] }:$p1, rGPR:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[i32] } VCCR:{ *:[v2i1] }:$p2, rGPR:{ *:[i32] })), VCCR:{ *:[i32] })
     /*  23442 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /*  23445 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  23449 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  23454 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // p2
     /*  23458 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(ARM::rGPRRegClassID),
     /*  23463 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  23466 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  23470 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  23475 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // p1
     /*  23479 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(ARM::rGPRRegClassID),
     /*  23484 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  23487 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::t2ORRrr),
     /*  23491 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  23496 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  23499 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  23502 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/14,
     /*  23505 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  23511 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  23517 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  23519 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  23522 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  23524 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  23527 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::VCCRRegClassID),
     /*  23532 */   // GIR_Coverage, 1831,
     /*  23532 */   GIR_EraseRootFromParent_Done,
     /*  23533 */ // Label 462: @23533
     /*  23533 */ GIM_Reject,
     /*  23534 */ // Label 404: @23534
     /*  23534 */ GIM_Try, /*On fail goto*//*Label 463*/ GIMT_Encode4(23580), // Rule ID 1134 //
     /*  23539 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  23542 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  23545 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  23548 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  23552 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  23556 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  23560 */   // (or:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)  =>  (VORRd:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /*  23560 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VORRd),
     /*  23563 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  23565 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*  23567 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  23569 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  23572 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  23578 */   GIR_RootConstrainSelectedInstOperands,
     /*  23579 */   // GIR_Coverage, 1134,
     /*  23579 */   GIR_EraseRootFromParent_Done,
     /*  23580 */ // Label 463: @23580
     /*  23580 */ GIM_Reject,
     /*  23581 */ // Label 405: @23581
     /*  23581 */ GIM_Try, /*On fail goto*//*Label 464*/ GIMT_Encode4(23694),
     /*  23586 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  23589 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  23592 */   GIM_Try, /*On fail goto*//*Label 465*/ GIMT_Encode4(23632), // Rule ID 2532 //
     /*  23597 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  23600 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  23604 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  23608 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  23612 */     // (or:{ *:[v2i64] } QPR:{ *:[v2i64] }:$LHS, QPR:{ *:[v2i64] }:$RHS)  =>  (VORRq:{ *:[v2i64] } QPR:{ *:[v2i64] }:$LHS, QPR:{ *:[v2i64] }:$RHS)
     /*  23612 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VORRq),
     /*  23615 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  23617 */     GIR_RootToRootCopy, /*OpIdx*/1, // LHS
     /*  23619 */     GIR_RootToRootCopy, /*OpIdx*/2, // RHS
     /*  23621 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  23624 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  23630 */     GIR_RootConstrainSelectedInstOperands,
     /*  23631 */     // GIR_Coverage, 2532,
     /*  23631 */     GIR_EraseRootFromParent_Done,
     /*  23632 */   // Label 465: @23632
     /*  23632 */   GIM_Try, /*On fail goto*//*Label 466*/ GIMT_Encode4(23693), // Rule ID 3381 //
     /*  23637 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  23640 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  23644 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  23648 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  23652 */     // (or:{ *:[v2i64] } MQPR:{ *:[v2i64] }:$Qm, MQPR:{ *:[v2i64] }:$Qn)  =>  (MVE_VORR:{ *:[v2i64] } MQPR:{ *:[v2i64] }:$Qm, MQPR:{ *:[v2i64] }:$Qn)
     /*  23652 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  23655 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  23659 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  23664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VORR),
     /*  23667 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  23669 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /*  23671 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /*  23673 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  23676 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  23682 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  23688 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  23691 */     GIR_RootConstrainSelectedInstOperands,
     /*  23692 */     // GIR_Coverage, 3381,
     /*  23692 */     GIR_EraseRootFromParent_Done,
     /*  23693 */   // Label 466: @23693
     /*  23693 */   GIM_Reject,
     /*  23694 */ // Label 464: @23694
     /*  23694 */ GIM_Reject,
     /*  23695 */ // Label 406: @23695
     /*  23695 */ GIM_Try, /*On fail goto*//*Label 467*/ GIMT_Encode4(23812), // Rule ID 1832 //
     /*  23700 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  23703 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s1,
     /*  23706 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s1,
     /*  23709 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::VCCRRegClassID),
     /*  23713 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::VCCRRegClassID),
     /*  23717 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::VCCRRegClassID),
     /*  23721 */   // (or:{ *:[v4i1] } VCCR:{ *:[v4i1] }:$p1, VCCR:{ *:[v4i1] }:$p2)  =>  (COPY_TO_REGCLASS:{ *:[v4i1] } (t2ORRrr:{ *:[i32] } (COPY_TO_REGCLASS:{ *:[i32] } VCCR:{ *:[v4i1] }:$p1, rGPR:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[i32] } VCCR:{ *:[v4i1] }:$p2, rGPR:{ *:[i32] })), VCCR:{ *:[i32] })
     /*  23721 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /*  23724 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  23728 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  23733 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // p2
     /*  23737 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(ARM::rGPRRegClassID),
     /*  23742 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  23745 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  23749 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  23754 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // p1
     /*  23758 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(ARM::rGPRRegClassID),
     /*  23763 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  23766 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::t2ORRrr),
     /*  23770 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  23775 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  23778 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  23781 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/14,
     /*  23784 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  23790 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  23796 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  23798 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  23801 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  23803 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  23806 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::VCCRRegClassID),
     /*  23811 */   // GIR_Coverage, 1832,
     /*  23811 */   GIR_EraseRootFromParent_Done,
     /*  23812 */ // Label 467: @23812
     /*  23812 */ GIM_Reject,
     /*  23813 */ // Label 407: @23813
     /*  23813 */ GIM_Try, /*On fail goto*//*Label 468*/ GIMT_Encode4(23859), // Rule ID 2528 //
     /*  23818 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  23821 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  23824 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  23827 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  23831 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  23835 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  23839 */   // (or:{ *:[v4i16] } DPR:{ *:[v4i16] }:$LHS, DPR:{ *:[v4i16] }:$RHS)  =>  (VORRd:{ *:[v4i16] } DPR:{ *:[v4i16] }:$LHS, DPR:{ *:[v4i16] }:$RHS)
     /*  23839 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VORRd),
     /*  23842 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  23844 */   GIR_RootToRootCopy, /*OpIdx*/1, // LHS
     /*  23846 */   GIR_RootToRootCopy, /*OpIdx*/2, // RHS
     /*  23848 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  23851 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  23857 */   GIR_RootConstrainSelectedInstOperands,
     /*  23858 */   // GIR_Coverage, 2528,
     /*  23858 */   GIR_EraseRootFromParent_Done,
     /*  23859 */ // Label 468: @23859
     /*  23859 */ GIM_Reject,
     /*  23860 */ // Label 408: @23860
     /*  23860 */ GIM_Try, /*On fail goto*//*Label 469*/ GIMT_Encode4(23973),
     /*  23865 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  23868 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  23871 */   GIM_Try, /*On fail goto*//*Label 470*/ GIMT_Encode4(23911), // Rule ID 1135 //
     /*  23876 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  23879 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  23883 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  23887 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  23891 */     // (or:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)  =>  (VORRq:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)
     /*  23891 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VORRq),
     /*  23894 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  23896 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*  23898 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  23900 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  23903 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  23909 */     GIR_RootConstrainSelectedInstOperands,
     /*  23910 */     // GIR_Coverage, 1135,
     /*  23910 */     GIR_EraseRootFromParent_Done,
     /*  23911 */   // Label 470: @23911
     /*  23911 */   GIM_Try, /*On fail goto*//*Label 471*/ GIMT_Encode4(23972), // Rule ID 3377 //
     /*  23916 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  23919 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  23923 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  23927 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  23931 */     // (or:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)  =>  (MVE_VORR:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)
     /*  23931 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  23934 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  23938 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  23943 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VORR),
     /*  23946 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  23948 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /*  23950 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /*  23952 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  23955 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  23961 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  23967 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  23970 */     GIR_RootConstrainSelectedInstOperands,
     /*  23971 */     // GIR_Coverage, 3377,
     /*  23971 */     GIR_EraseRootFromParent_Done,
     /*  23972 */   // Label 471: @23972
     /*  23972 */   GIM_Reject,
     /*  23973 */ // Label 469: @23973
     /*  23973 */ GIM_Reject,
     /*  23974 */ // Label 409: @23974
     /*  23974 */ GIM_Try, /*On fail goto*//*Label 472*/ GIMT_Encode4(24091), // Rule ID 1833 //
     /*  23979 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  23982 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s1,
     /*  23985 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s1,
     /*  23988 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::VCCRRegClassID),
     /*  23992 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::VCCRRegClassID),
     /*  23996 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::VCCRRegClassID),
     /*  24000 */   // (or:{ *:[v8i1] } VCCR:{ *:[v8i1] }:$p1, VCCR:{ *:[v8i1] }:$p2)  =>  (COPY_TO_REGCLASS:{ *:[v8i1] } (t2ORRrr:{ *:[i32] } (COPY_TO_REGCLASS:{ *:[i32] } VCCR:{ *:[v8i1] }:$p1, rGPR:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[i32] } VCCR:{ *:[v8i1] }:$p2, rGPR:{ *:[i32] })), VCCR:{ *:[i32] })
     /*  24000 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /*  24003 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  24007 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  24012 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // p2
     /*  24016 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(ARM::rGPRRegClassID),
     /*  24021 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  24024 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  24028 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  24033 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // p1
     /*  24037 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(ARM::rGPRRegClassID),
     /*  24042 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  24045 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::t2ORRrr),
     /*  24049 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  24054 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  24057 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  24060 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/14,
     /*  24063 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  24069 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  24075 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  24077 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  24080 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  24082 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  24085 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::VCCRRegClassID),
     /*  24090 */   // GIR_Coverage, 1833,
     /*  24090 */   GIR_EraseRootFromParent_Done,
     /*  24091 */ // Label 472: @24091
     /*  24091 */ GIM_Reject,
     /*  24092 */ // Label 410: @24092
     /*  24092 */ GIM_Try, /*On fail goto*//*Label 473*/ GIMT_Encode4(24138), // Rule ID 2527 //
     /*  24097 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  24100 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  24103 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  24106 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  24110 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  24114 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  24118 */   // (or:{ *:[v8i8] } DPR:{ *:[v8i8] }:$LHS, DPR:{ *:[v8i8] }:$RHS)  =>  (VORRd:{ *:[v8i8] } DPR:{ *:[v8i8] }:$LHS, DPR:{ *:[v8i8] }:$RHS)
     /*  24118 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VORRd),
     /*  24121 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  24123 */   GIR_RootToRootCopy, /*OpIdx*/1, // LHS
     /*  24125 */   GIR_RootToRootCopy, /*OpIdx*/2, // RHS
     /*  24127 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  24130 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  24136 */   GIR_RootConstrainSelectedInstOperands,
     /*  24137 */   // GIR_Coverage, 2527,
     /*  24137 */   GIR_EraseRootFromParent_Done,
     /*  24138 */ // Label 473: @24138
     /*  24138 */ GIM_Reject,
     /*  24139 */ // Label 411: @24139
     /*  24139 */ GIM_Try, /*On fail goto*//*Label 474*/ GIMT_Encode4(24252),
     /*  24144 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  24147 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  24150 */   GIM_Try, /*On fail goto*//*Label 475*/ GIMT_Encode4(24190), // Rule ID 2531 //
     /*  24155 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  24158 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  24162 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  24166 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  24170 */     // (or:{ *:[v8i16] } QPR:{ *:[v8i16] }:$LHS, QPR:{ *:[v8i16] }:$RHS)  =>  (VORRq:{ *:[v8i16] } QPR:{ *:[v8i16] }:$LHS, QPR:{ *:[v8i16] }:$RHS)
     /*  24170 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VORRq),
     /*  24173 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  24175 */     GIR_RootToRootCopy, /*OpIdx*/1, // LHS
     /*  24177 */     GIR_RootToRootCopy, /*OpIdx*/2, // RHS
     /*  24179 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  24182 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  24188 */     GIR_RootConstrainSelectedInstOperands,
     /*  24189 */     // GIR_Coverage, 2531,
     /*  24189 */     GIR_EraseRootFromParent_Done,
     /*  24190 */   // Label 475: @24190
     /*  24190 */   GIM_Try, /*On fail goto*//*Label 476*/ GIMT_Encode4(24251), // Rule ID 3373 //
     /*  24195 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  24198 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  24202 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  24206 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  24210 */     // (or:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)  =>  (MVE_VORR:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)
     /*  24210 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  24213 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  24217 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  24222 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VORR),
     /*  24225 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  24227 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /*  24229 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /*  24231 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  24234 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  24240 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  24246 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  24249 */     GIR_RootConstrainSelectedInstOperands,
     /*  24250 */     // GIR_Coverage, 3373,
     /*  24250 */     GIR_EraseRootFromParent_Done,
     /*  24251 */   // Label 476: @24251
     /*  24251 */   GIM_Reject,
     /*  24252 */ // Label 474: @24252
     /*  24252 */ GIM_Reject,
     /*  24253 */ // Label 412: @24253
     /*  24253 */ GIM_Try, /*On fail goto*//*Label 477*/ GIMT_Encode4(24370), // Rule ID 1834 //
     /*  24258 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  24261 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s1,
     /*  24264 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s1,
     /*  24267 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::VCCRRegClassID),
     /*  24271 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::VCCRRegClassID),
     /*  24275 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::VCCRRegClassID),
     /*  24279 */   // (or:{ *:[v16i1] } VCCR:{ *:[v16i1] }:$p1, VCCR:{ *:[v16i1] }:$p2)  =>  (COPY_TO_REGCLASS:{ *:[v16i1] } (t2ORRrr:{ *:[i32] } (COPY_TO_REGCLASS:{ *:[i32] } VCCR:{ *:[v16i1] }:$p1, rGPR:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[i32] } VCCR:{ *:[v16i1] }:$p2, rGPR:{ *:[i32] })), VCCR:{ *:[i32] })
     /*  24279 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /*  24282 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  24286 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  24291 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // p2
     /*  24295 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(ARM::rGPRRegClassID),
     /*  24300 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  24303 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  24307 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  24312 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // p1
     /*  24316 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(ARM::rGPRRegClassID),
     /*  24321 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  24324 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::t2ORRrr),
     /*  24328 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  24333 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  24336 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  24339 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/14,
     /*  24342 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  24348 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  24354 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  24356 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  24359 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  24361 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  24364 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::VCCRRegClassID),
     /*  24369 */   // GIR_Coverage, 1834,
     /*  24369 */   GIR_EraseRootFromParent_Done,
     /*  24370 */ // Label 477: @24370
     /*  24370 */ GIM_Reject,
     /*  24371 */ // Label 413: @24371
     /*  24371 */ GIM_Try, /*On fail goto*//*Label 478*/ GIMT_Encode4(24484),
     /*  24376 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  24379 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  24382 */   GIM_Try, /*On fail goto*//*Label 479*/ GIMT_Encode4(24422), // Rule ID 2530 //
     /*  24387 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  24390 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  24394 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  24398 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  24402 */     // (or:{ *:[v16i8] } QPR:{ *:[v16i8] }:$LHS, QPR:{ *:[v16i8] }:$RHS)  =>  (VORRq:{ *:[v16i8] } QPR:{ *:[v16i8] }:$LHS, QPR:{ *:[v16i8] }:$RHS)
     /*  24402 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VORRq),
     /*  24405 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  24407 */     GIR_RootToRootCopy, /*OpIdx*/1, // LHS
     /*  24409 */     GIR_RootToRootCopy, /*OpIdx*/2, // RHS
     /*  24411 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  24414 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  24420 */     GIR_RootConstrainSelectedInstOperands,
     /*  24421 */     // GIR_Coverage, 2530,
     /*  24421 */     GIR_EraseRootFromParent_Done,
     /*  24422 */   // Label 479: @24422
     /*  24422 */   GIM_Try, /*On fail goto*//*Label 480*/ GIMT_Encode4(24483), // Rule ID 3369 //
     /*  24427 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  24430 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  24434 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  24438 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  24442 */     // (or:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)  =>  (MVE_VORR:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)
     /*  24442 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  24445 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  24449 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  24454 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VORR),
     /*  24457 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  24459 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /*  24461 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /*  24463 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  24466 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  24472 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  24478 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  24481 */     GIR_RootConstrainSelectedInstOperands,
     /*  24482 */     // GIR_Coverage, 3369,
     /*  24482 */     GIR_EraseRootFromParent_Done,
     /*  24483 */   // Label 480: @24483
     /*  24483 */   GIM_Reject,
     /*  24484 */ // Label 478: @24484
     /*  24484 */ GIM_Reject,
     /*  24485 */ // Label 414: @24485
     /*  24485 */ GIM_Reject,
     /*  24486 */ // Label 7: @24486
     /*  24486 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(16), /*)*//*default:*//*Label 494*/ GIMT_Encode4(26180),
     /*  24497 */ /*GILLT_s32*//*Label 481*/ GIMT_Encode4(24557),
     /*  24501 */ /*GILLT_s64*//*Label 482*/ GIMT_Encode4(25064),
     /*  24505 */ /*GILLT_v2s1*//*Label 483*/ GIMT_Encode4(25111),
     /*  24509 */ /*GILLT_v2s32*//*Label 484*/ GIMT_Encode4(25229),
     /*  24513 */ /*GILLT_v2s64*//*Label 485*/ GIMT_Encode4(25276),
     /*  24517 */ /*GILLT_v4s1*//*Label 486*/ GIMT_Encode4(25390),
     /*  24521 */ /*GILLT_v4s16*//*Label 487*/ GIMT_Encode4(25508),
     /*  24525 */ /*GILLT_v4s32*//*Label 488*/ GIMT_Encode4(25555), GIMT_Encode4(0),
     /*  24533 */ /*GILLT_v8s1*//*Label 489*/ GIMT_Encode4(25669),
     /*  24537 */ /*GILLT_v8s8*//*Label 490*/ GIMT_Encode4(25787),
     /*  24541 */ /*GILLT_v8s16*//*Label 491*/ GIMT_Encode4(25834), GIMT_Encode4(0),
     /*  24549 */ /*GILLT_v16s1*//*Label 492*/ GIMT_Encode4(25948),
     /*  24553 */ /*GILLT_v16s8*//*Label 493*/ GIMT_Encode4(26066),
     /*  24557 */ // Label 481: @24557
     /*  24557 */ GIM_Try, /*On fail goto*//*Label 495*/ GIMT_Encode4(25063),
     /*  24562 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  24565 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  24568 */   GIM_Try, /*On fail goto*//*Label 496*/ GIMT_Encode4(24623), // Rule ID 5477 //
     /*  24573 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /*  24576 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  24580 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/1, uint8_t(-1),
     /*  24584 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  24588 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  24592 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_t2_so_imm),
     /*  24596 */     // MIs[1] Operand 1
     /*  24596 */     // No operand predicates
     /*  24596 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  24598 */     // (xor:{ *:[i32] } -1:{ *:[i32] }, (imm:{ *:[i32] })<<P:Predicate_t2_so_imm>>:$imm)  =>  (t2MVNi:{ *:[i32] } (imm:{ *:[i32] }):$imm)
     /*  24598 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2MVNi),
     /*  24601 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  24603 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  24606 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  24609 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  24615 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  24621 */     GIR_RootConstrainSelectedInstOperands,
     /*  24622 */     // GIR_Coverage, 5477,
     /*  24622 */     GIR_EraseRootFromParent_Done,
     /*  24623 */   // Label 496: @24623
     /*  24623 */   GIM_Try, /*On fail goto*//*Label 497*/ GIMT_Encode4(24678), // Rule ID 499 //
     /*  24628 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /*  24631 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  24635 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  24639 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  24643 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_t2_so_imm),
     /*  24647 */     // MIs[1] Operand 1
     /*  24647 */     // No operand predicates
     /*  24647 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  24651 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  24653 */     // (xor:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_t2_so_imm>>:$imm, -1:{ *:[i32] })  =>  (t2MVNi:{ *:[i32] } (imm:{ *:[i32] }):$imm)
     /*  24653 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2MVNi),
     /*  24656 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  24658 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  24661 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  24664 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  24670 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  24676 */     GIR_RootConstrainSelectedInstOperands,
     /*  24677 */     // GIR_Coverage, 499,
     /*  24677 */     GIR_EraseRootFromParent_Done,
     /*  24678 */   // Label 497: @24678
     /*  24678 */   GIM_Try, /*On fail goto*//*Label 498*/ GIMT_Encode4(24722), // Rule ID 500 //
     /*  24683 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /*  24686 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  24690 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  24694 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  24698 */     // (xor:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, -1:{ *:[i32] })  =>  (t2MVNr:{ *:[i32] } rGPR:{ *:[i32] }:$Rm)
     /*  24698 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2MVNr),
     /*  24701 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  24703 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /*  24705 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  24708 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  24714 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  24720 */     GIR_RootConstrainSelectedInstOperands,
     /*  24721 */     // GIR_Coverage, 500,
     /*  24721 */     GIR_EraseRootFromParent_Done,
     /*  24722 */   // Label 498: @24722
     /*  24722 */   GIM_Try, /*On fail goto*//*Label 499*/ GIMT_Encode4(24766), // Rule ID 165 //
     /*  24727 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  24730 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  24734 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  24738 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  24742 */     // (xor:{ *:[i32] } GPR:{ *:[i32] }:$Rm, -1:{ *:[i32] })  =>  (MVNr:{ *:[i32] } GPR:{ *:[i32] }:$Rm)
     /*  24742 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVNr),
     /*  24745 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  24747 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /*  24749 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  24752 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  24758 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  24764 */     GIR_RootConstrainSelectedInstOperands,
     /*  24765 */     // GIR_Coverage, 165,
     /*  24765 */     GIR_EraseRootFromParent_Done,
     /*  24766 */   // Label 499: @24766
     /*  24766 */   GIM_Try, /*On fail goto*//*Label 500*/ GIMT_Encode4(24810), // Rule ID 324 //
     /*  24771 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb_IsThumb1Only),
     /*  24774 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /*  24778 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /*  24782 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  24786 */     // (xor:{ *:[i32] } tGPR:{ *:[i32] }:$Rn, -1:{ *:[i32] })  =>  (tMVN:{ *:[i32] } tGPR:{ *:[i32] }:$Rn)
     /*  24786 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::tMVN),
     /*  24789 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  24791 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::CPSR), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define | RegState::Dead),
     /*  24797 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  24799 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  24802 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  24808 */     GIR_RootConstrainSelectedInstOperands,
     /*  24809 */     // GIR_Coverage, 324,
     /*  24809 */     GIR_EraseRootFromParent_Done,
     /*  24810 */   // Label 500: @24810
     /*  24810 */   GIM_Try, /*On fail goto*//*Label 501*/ GIMT_Encode4(24867), // Rule ID 155 //
     /*  24815 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  24818 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  24822 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  24826 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  24830 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  24834 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_mod_imm),
     /*  24838 */     // MIs[1] Operand 1
     /*  24838 */     // No operand predicates
     /*  24838 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  24840 */     // (xor:{ *:[i32] } GPR:{ *:[i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_mod_imm>>:$imm)  =>  (EORri:{ *:[i32] } GPR:{ *:[i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  24840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::EORri),
     /*  24843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  24845 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  24847 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  24850 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  24853 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  24859 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  24865 */     GIR_RootConstrainSelectedInstOperands,
     /*  24866 */     // GIR_Coverage, 155,
     /*  24866 */     GIR_EraseRootFromParent_Done,
     /*  24867 */   // Label 501: @24867
     /*  24867 */   GIM_Try, /*On fail goto*//*Label 502*/ GIMT_Encode4(24924), // Rule ID 487 //
     /*  24872 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /*  24875 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  24879 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  24883 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  24887 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  24891 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_t2_so_imm),
     /*  24895 */     // MIs[1] Operand 1
     /*  24895 */     // No operand predicates
     /*  24895 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  24897 */     // (xor:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_t2_so_imm>>:$imm)  =>  (t2EORri:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  24897 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2EORri),
     /*  24900 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  24902 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  24904 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  24907 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  24910 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  24916 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  24922 */     GIR_RootConstrainSelectedInstOperands,
     /*  24923 */     // GIR_Coverage, 487,
     /*  24923 */     GIR_EraseRootFromParent_Done,
     /*  24924 */   // Label 502: @24924
     /*  24924 */   GIM_Try, /*On fail goto*//*Label 503*/ GIMT_Encode4(24970), // Rule ID 156 //
     /*  24929 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  24932 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  24936 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  24940 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  24944 */     // (xor:{ *:[i32] } GPR:{ *:[i32] }:$Rn, GPR:{ *:[i32] }:$Rm)  =>  (EORrr:{ *:[i32] } GPR:{ *:[i32] }:$Rn, GPR:{ *:[i32] }:$Rm)
     /*  24944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::EORrr),
     /*  24947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  24949 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  24951 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /*  24953 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  24956 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  24962 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  24968 */     GIR_RootConstrainSelectedInstOperands,
     /*  24969 */     // GIR_Coverage, 156,
     /*  24969 */     GIR_EraseRootFromParent_Done,
     /*  24970 */   // Label 503: @24970
     /*  24970 */   GIM_Try, /*On fail goto*//*Label 504*/ GIMT_Encode4(25016), // Rule ID 317 //
     /*  24975 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb_IsThumb1Only),
     /*  24978 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /*  24982 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /*  24986 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /*  24990 */     // (xor:{ *:[i32] } tGPR:{ *:[i32] }:$Rn, tGPR:{ *:[i32] }:$Rm)  =>  (tEOR:{ *:[i32] } tGPR:{ *:[i32] }:$Rn, tGPR:{ *:[i32] }:$Rm)
     /*  24990 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::tEOR),
     /*  24993 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /*  24995 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::CPSR), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define | RegState::Dead),
     /*  25001 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  25003 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /*  25005 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  25008 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  25014 */     GIR_RootConstrainSelectedInstOperands,
     /*  25015 */     // GIR_Coverage, 317,
     /*  25015 */     GIR_EraseRootFromParent_Done,
     /*  25016 */   // Label 504: @25016
     /*  25016 */   GIM_Try, /*On fail goto*//*Label 505*/ GIMT_Encode4(25062), // Rule ID 488 //
     /*  25021 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /*  25024 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  25028 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  25032 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  25036 */     // (xor:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2EORrr:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  25036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2EORrr),
     /*  25039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  25041 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  25043 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /*  25045 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  25048 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  25054 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  25060 */     GIR_RootConstrainSelectedInstOperands,
     /*  25061 */     // GIR_Coverage, 488,
     /*  25061 */     GIR_EraseRootFromParent_Done,
     /*  25062 */   // Label 505: @25062
     /*  25062 */   GIM_Reject,
     /*  25063 */ // Label 495: @25063
     /*  25063 */ GIM_Reject,
     /*  25064 */ // Label 482: @25064
     /*  25064 */ GIM_Try, /*On fail goto*//*Label 506*/ GIMT_Encode4(25110), // Rule ID 2535 //
     /*  25069 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  25072 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  25075 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  25078 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  25082 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  25086 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  25090 */   // (xor:{ *:[v1i64] } DPR:{ *:[v1i64] }:$LHS, DPR:{ *:[v1i64] }:$RHS)  =>  (VEORd:{ *:[v1i64] } DPR:{ *:[v1i64] }:$LHS, DPR:{ *:[v1i64] }:$RHS)
     /*  25090 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VEORd),
     /*  25093 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  25095 */   GIR_RootToRootCopy, /*OpIdx*/1, // LHS
     /*  25097 */   GIR_RootToRootCopy, /*OpIdx*/2, // RHS
     /*  25099 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  25102 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  25108 */   GIR_RootConstrainSelectedInstOperands,
     /*  25109 */   // GIR_Coverage, 2535,
     /*  25109 */   GIR_EraseRootFromParent_Done,
     /*  25110 */ // Label 506: @25110
     /*  25110 */ GIM_Reject,
     /*  25111 */ // Label 483: @25111
     /*  25111 */ GIM_Try, /*On fail goto*//*Label 507*/ GIMT_Encode4(25228), // Rule ID 1827 //
     /*  25116 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  25119 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s1,
     /*  25122 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s1,
     /*  25125 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::VCCRRegClassID),
     /*  25129 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::VCCRRegClassID),
     /*  25133 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::VCCRRegClassID),
     /*  25137 */   // (xor:{ *:[v2i1] } VCCR:{ *:[v2i1] }:$p1, VCCR:{ *:[v2i1] }:$p2)  =>  (COPY_TO_REGCLASS:{ *:[v2i1] } (t2EORrr:{ *:[i32] } (COPY_TO_REGCLASS:{ *:[i32] } VCCR:{ *:[v2i1] }:$p1, rGPR:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[i32] } VCCR:{ *:[v2i1] }:$p2, rGPR:{ *:[i32] })), VCCR:{ *:[i32] })
     /*  25137 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /*  25140 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  25144 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  25149 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // p2
     /*  25153 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(ARM::rGPRRegClassID),
     /*  25158 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  25161 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  25165 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  25170 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // p1
     /*  25174 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(ARM::rGPRRegClassID),
     /*  25179 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  25182 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::t2EORrr),
     /*  25186 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  25191 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  25194 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  25197 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/14,
     /*  25200 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  25206 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  25212 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  25214 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  25217 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  25219 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  25222 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::VCCRRegClassID),
     /*  25227 */   // GIR_Coverage, 1827,
     /*  25227 */   GIR_EraseRootFromParent_Done,
     /*  25228 */ // Label 507: @25228
     /*  25228 */ GIM_Reject,
     /*  25229 */ // Label 484: @25229
     /*  25229 */ GIM_Try, /*On fail goto*//*Label 508*/ GIMT_Encode4(25275), // Rule ID 1132 //
     /*  25234 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  25237 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  25240 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  25243 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  25247 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  25251 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  25255 */   // (xor:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)  =>  (VEORd:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /*  25255 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VEORd),
     /*  25258 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  25260 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*  25262 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  25264 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  25267 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  25273 */   GIR_RootConstrainSelectedInstOperands,
     /*  25274 */   // GIR_Coverage, 1132,
     /*  25274 */   GIR_EraseRootFromParent_Done,
     /*  25275 */ // Label 508: @25275
     /*  25275 */ GIM_Reject,
     /*  25276 */ // Label 485: @25276
     /*  25276 */ GIM_Try, /*On fail goto*//*Label 509*/ GIMT_Encode4(25389),
     /*  25281 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  25284 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  25287 */   GIM_Try, /*On fail goto*//*Label 510*/ GIMT_Encode4(25327), // Rule ID 2538 //
     /*  25292 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  25295 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  25299 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  25303 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  25307 */     // (xor:{ *:[v2i64] } QPR:{ *:[v2i64] }:$LHS, QPR:{ *:[v2i64] }:$RHS)  =>  (VEORq:{ *:[v2i64] } QPR:{ *:[v2i64] }:$LHS, QPR:{ *:[v2i64] }:$RHS)
     /*  25307 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VEORq),
     /*  25310 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  25312 */     GIR_RootToRootCopy, /*OpIdx*/1, // LHS
     /*  25314 */     GIR_RootToRootCopy, /*OpIdx*/2, // RHS
     /*  25316 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  25319 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  25325 */     GIR_RootConstrainSelectedInstOperands,
     /*  25326 */     // GIR_Coverage, 2538,
     /*  25326 */     GIR_EraseRootFromParent_Done,
     /*  25327 */   // Label 510: @25327
     /*  25327 */   GIM_Try, /*On fail goto*//*Label 511*/ GIMT_Encode4(25388), // Rule ID 3395 //
     /*  25332 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  25335 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  25339 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  25343 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  25347 */     // (xor:{ *:[v2i64] } MQPR:{ *:[v2i64] }:$Qm, MQPR:{ *:[v2i64] }:$Qn)  =>  (MVE_VEOR:{ *:[v2i64] } MQPR:{ *:[v2i64] }:$Qm, MQPR:{ *:[v2i64] }:$Qn)
     /*  25347 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  25350 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  25354 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  25359 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VEOR),
     /*  25362 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  25364 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /*  25366 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /*  25368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  25371 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  25377 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  25383 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  25386 */     GIR_RootConstrainSelectedInstOperands,
     /*  25387 */     // GIR_Coverage, 3395,
     /*  25387 */     GIR_EraseRootFromParent_Done,
     /*  25388 */   // Label 511: @25388
     /*  25388 */   GIM_Reject,
     /*  25389 */ // Label 509: @25389
     /*  25389 */ GIM_Reject,
     /*  25390 */ // Label 486: @25390
     /*  25390 */ GIM_Try, /*On fail goto*//*Label 512*/ GIMT_Encode4(25507), // Rule ID 1828 //
     /*  25395 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  25398 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s1,
     /*  25401 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s1,
     /*  25404 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::VCCRRegClassID),
     /*  25408 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::VCCRRegClassID),
     /*  25412 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::VCCRRegClassID),
     /*  25416 */   // (xor:{ *:[v4i1] } VCCR:{ *:[v4i1] }:$p1, VCCR:{ *:[v4i1] }:$p2)  =>  (COPY_TO_REGCLASS:{ *:[v4i1] } (t2EORrr:{ *:[i32] } (COPY_TO_REGCLASS:{ *:[i32] } VCCR:{ *:[v4i1] }:$p1, rGPR:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[i32] } VCCR:{ *:[v4i1] }:$p2, rGPR:{ *:[i32] })), VCCR:{ *:[i32] })
     /*  25416 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /*  25419 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  25423 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  25428 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // p2
     /*  25432 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(ARM::rGPRRegClassID),
     /*  25437 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  25440 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  25444 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  25449 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // p1
     /*  25453 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(ARM::rGPRRegClassID),
     /*  25458 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  25461 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::t2EORrr),
     /*  25465 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  25470 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  25473 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  25476 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/14,
     /*  25479 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  25485 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  25491 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  25493 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  25496 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  25498 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  25501 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::VCCRRegClassID),
     /*  25506 */   // GIR_Coverage, 1828,
     /*  25506 */   GIR_EraseRootFromParent_Done,
     /*  25507 */ // Label 512: @25507
     /*  25507 */ GIM_Reject,
     /*  25508 */ // Label 487: @25508
     /*  25508 */ GIM_Try, /*On fail goto*//*Label 513*/ GIMT_Encode4(25554), // Rule ID 2534 //
     /*  25513 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  25516 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  25519 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  25522 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  25526 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  25530 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  25534 */   // (xor:{ *:[v4i16] } DPR:{ *:[v4i16] }:$LHS, DPR:{ *:[v4i16] }:$RHS)  =>  (VEORd:{ *:[v4i16] } DPR:{ *:[v4i16] }:$LHS, DPR:{ *:[v4i16] }:$RHS)
     /*  25534 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VEORd),
     /*  25537 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  25539 */   GIR_RootToRootCopy, /*OpIdx*/1, // LHS
     /*  25541 */   GIR_RootToRootCopy, /*OpIdx*/2, // RHS
     /*  25543 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  25546 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  25552 */   GIR_RootConstrainSelectedInstOperands,
     /*  25553 */   // GIR_Coverage, 2534,
     /*  25553 */   GIR_EraseRootFromParent_Done,
     /*  25554 */ // Label 513: @25554
     /*  25554 */ GIM_Reject,
     /*  25555 */ // Label 488: @25555
     /*  25555 */ GIM_Try, /*On fail goto*//*Label 514*/ GIMT_Encode4(25668),
     /*  25560 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  25563 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  25566 */   GIM_Try, /*On fail goto*//*Label 515*/ GIMT_Encode4(25606), // Rule ID 1133 //
     /*  25571 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  25574 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  25578 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  25582 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  25586 */     // (xor:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)  =>  (VEORq:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)
     /*  25586 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VEORq),
     /*  25589 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  25591 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*  25593 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  25595 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  25598 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  25604 */     GIR_RootConstrainSelectedInstOperands,
     /*  25605 */     // GIR_Coverage, 1133,
     /*  25605 */     GIR_EraseRootFromParent_Done,
     /*  25606 */   // Label 515: @25606
     /*  25606 */   GIM_Try, /*On fail goto*//*Label 516*/ GIMT_Encode4(25667), // Rule ID 3391 //
     /*  25611 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  25614 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  25618 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  25622 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  25626 */     // (xor:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)  =>  (MVE_VEOR:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)
     /*  25626 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  25629 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  25633 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  25638 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VEOR),
     /*  25641 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  25643 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /*  25645 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /*  25647 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  25650 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  25656 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  25662 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  25665 */     GIR_RootConstrainSelectedInstOperands,
     /*  25666 */     // GIR_Coverage, 3391,
     /*  25666 */     GIR_EraseRootFromParent_Done,
     /*  25667 */   // Label 516: @25667
     /*  25667 */   GIM_Reject,
     /*  25668 */ // Label 514: @25668
     /*  25668 */ GIM_Reject,
     /*  25669 */ // Label 489: @25669
     /*  25669 */ GIM_Try, /*On fail goto*//*Label 517*/ GIMT_Encode4(25786), // Rule ID 1829 //
     /*  25674 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  25677 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s1,
     /*  25680 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s1,
     /*  25683 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::VCCRRegClassID),
     /*  25687 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::VCCRRegClassID),
     /*  25691 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::VCCRRegClassID),
     /*  25695 */   // (xor:{ *:[v8i1] } VCCR:{ *:[v8i1] }:$p1, VCCR:{ *:[v8i1] }:$p2)  =>  (COPY_TO_REGCLASS:{ *:[v8i1] } (t2EORrr:{ *:[i32] } (COPY_TO_REGCLASS:{ *:[i32] } VCCR:{ *:[v8i1] }:$p1, rGPR:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[i32] } VCCR:{ *:[v8i1] }:$p2, rGPR:{ *:[i32] })), VCCR:{ *:[i32] })
     /*  25695 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /*  25698 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  25702 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  25707 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // p2
     /*  25711 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(ARM::rGPRRegClassID),
     /*  25716 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  25719 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  25723 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  25728 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // p1
     /*  25732 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(ARM::rGPRRegClassID),
     /*  25737 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  25740 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::t2EORrr),
     /*  25744 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  25749 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  25752 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  25755 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/14,
     /*  25758 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  25764 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  25770 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  25772 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  25775 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  25777 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  25780 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::VCCRRegClassID),
     /*  25785 */   // GIR_Coverage, 1829,
     /*  25785 */   GIR_EraseRootFromParent_Done,
     /*  25786 */ // Label 517: @25786
     /*  25786 */ GIM_Reject,
     /*  25787 */ // Label 490: @25787
     /*  25787 */ GIM_Try, /*On fail goto*//*Label 518*/ GIMT_Encode4(25833), // Rule ID 2533 //
     /*  25792 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  25795 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  25798 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  25801 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  25805 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  25809 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  25813 */   // (xor:{ *:[v8i8] } DPR:{ *:[v8i8] }:$LHS, DPR:{ *:[v8i8] }:$RHS)  =>  (VEORd:{ *:[v8i8] } DPR:{ *:[v8i8] }:$LHS, DPR:{ *:[v8i8] }:$RHS)
     /*  25813 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VEORd),
     /*  25816 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  25818 */   GIR_RootToRootCopy, /*OpIdx*/1, // LHS
     /*  25820 */   GIR_RootToRootCopy, /*OpIdx*/2, // RHS
     /*  25822 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  25825 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  25831 */   GIR_RootConstrainSelectedInstOperands,
     /*  25832 */   // GIR_Coverage, 2533,
     /*  25832 */   GIR_EraseRootFromParent_Done,
     /*  25833 */ // Label 518: @25833
     /*  25833 */ GIM_Reject,
     /*  25834 */ // Label 491: @25834
     /*  25834 */ GIM_Try, /*On fail goto*//*Label 519*/ GIMT_Encode4(25947),
     /*  25839 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  25842 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  25845 */   GIM_Try, /*On fail goto*//*Label 520*/ GIMT_Encode4(25885), // Rule ID 2537 //
     /*  25850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  25853 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  25857 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  25861 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  25865 */     // (xor:{ *:[v8i16] } QPR:{ *:[v8i16] }:$LHS, QPR:{ *:[v8i16] }:$RHS)  =>  (VEORq:{ *:[v8i16] } QPR:{ *:[v8i16] }:$LHS, QPR:{ *:[v8i16] }:$RHS)
     /*  25865 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VEORq),
     /*  25868 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  25870 */     GIR_RootToRootCopy, /*OpIdx*/1, // LHS
     /*  25872 */     GIR_RootToRootCopy, /*OpIdx*/2, // RHS
     /*  25874 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  25877 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  25883 */     GIR_RootConstrainSelectedInstOperands,
     /*  25884 */     // GIR_Coverage, 2537,
     /*  25884 */     GIR_EraseRootFromParent_Done,
     /*  25885 */   // Label 520: @25885
     /*  25885 */   GIM_Try, /*On fail goto*//*Label 521*/ GIMT_Encode4(25946), // Rule ID 3387 //
     /*  25890 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  25893 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  25897 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  25901 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  25905 */     // (xor:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)  =>  (MVE_VEOR:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)
     /*  25905 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  25908 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  25912 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  25917 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VEOR),
     /*  25920 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  25922 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /*  25924 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /*  25926 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  25929 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  25935 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  25941 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  25944 */     GIR_RootConstrainSelectedInstOperands,
     /*  25945 */     // GIR_Coverage, 3387,
     /*  25945 */     GIR_EraseRootFromParent_Done,
     /*  25946 */   // Label 521: @25946
     /*  25946 */   GIM_Reject,
     /*  25947 */ // Label 519: @25947
     /*  25947 */ GIM_Reject,
     /*  25948 */ // Label 492: @25948
     /*  25948 */ GIM_Try, /*On fail goto*//*Label 522*/ GIMT_Encode4(26065), // Rule ID 1830 //
     /*  25953 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  25956 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s1,
     /*  25959 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s1,
     /*  25962 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::VCCRRegClassID),
     /*  25966 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::VCCRRegClassID),
     /*  25970 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::VCCRRegClassID),
     /*  25974 */   // (xor:{ *:[v16i1] } VCCR:{ *:[v16i1] }:$p1, VCCR:{ *:[v16i1] }:$p2)  =>  (COPY_TO_REGCLASS:{ *:[v16i1] } (t2EORrr:{ *:[i32] } (COPY_TO_REGCLASS:{ *:[i32] } VCCR:{ *:[v16i1] }:$p1, rGPR:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[i32] } VCCR:{ *:[v16i1] }:$p2, rGPR:{ *:[i32] })), VCCR:{ *:[i32] })
     /*  25974 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /*  25977 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  25981 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  25986 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // p2
     /*  25990 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(ARM::rGPRRegClassID),
     /*  25995 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  25998 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  26002 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  26007 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // p1
     /*  26011 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(ARM::rGPRRegClassID),
     /*  26016 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  26019 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::t2EORrr),
     /*  26023 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  26028 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  26031 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  26034 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/14,
     /*  26037 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  26043 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  26049 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  26051 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  26054 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  26056 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  26059 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::VCCRRegClassID),
     /*  26064 */   // GIR_Coverage, 1830,
     /*  26064 */   GIR_EraseRootFromParent_Done,
     /*  26065 */ // Label 522: @26065
     /*  26065 */ GIM_Reject,
     /*  26066 */ // Label 493: @26066
     /*  26066 */ GIM_Try, /*On fail goto*//*Label 523*/ GIMT_Encode4(26179),
     /*  26071 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  26074 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  26077 */   GIM_Try, /*On fail goto*//*Label 524*/ GIMT_Encode4(26117), // Rule ID 2536 //
     /*  26082 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  26085 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  26089 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  26093 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  26097 */     // (xor:{ *:[v16i8] } QPR:{ *:[v16i8] }:$LHS, QPR:{ *:[v16i8] }:$RHS)  =>  (VEORq:{ *:[v16i8] } QPR:{ *:[v16i8] }:$LHS, QPR:{ *:[v16i8] }:$RHS)
     /*  26097 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VEORq),
     /*  26100 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  26102 */     GIR_RootToRootCopy, /*OpIdx*/1, // LHS
     /*  26104 */     GIR_RootToRootCopy, /*OpIdx*/2, // RHS
     /*  26106 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  26109 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  26115 */     GIR_RootConstrainSelectedInstOperands,
     /*  26116 */     // GIR_Coverage, 2536,
     /*  26116 */     GIR_EraseRootFromParent_Done,
     /*  26117 */   // Label 524: @26117
     /*  26117 */   GIM_Try, /*On fail goto*//*Label 525*/ GIMT_Encode4(26178), // Rule ID 3383 //
     /*  26122 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  26125 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  26129 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  26133 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  26137 */     // (xor:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)  =>  (MVE_VEOR:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)
     /*  26137 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  26140 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  26144 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  26149 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VEOR),
     /*  26152 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  26154 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /*  26156 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /*  26158 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  26161 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  26167 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  26173 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  26176 */     GIR_RootConstrainSelectedInstOperands,
     /*  26177 */     // GIR_Coverage, 3383,
     /*  26177 */     GIR_EraseRootFromParent_Done,
     /*  26178 */   // Label 525: @26178
     /*  26178 */   GIM_Reject,
     /*  26179 */ // Label 523: @26179
     /*  26179 */ GIM_Reject,
     /*  26180 */ // Label 494: @26180
     /*  26180 */ GIM_Reject,
     /*  26181 */ // Label 8: @26181
     /*  26181 */ GIM_Try, /*On fail goto*//*Label 526*/ GIMT_Encode4(26567),
     /*  26186 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/3,
     /*  26189 */   GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(5), GIMT_Encode2(16), /*)*//*default:*//*Label 531*/ GIMT_Encode4(26566),
     /*  26200 */   /*GILLT_v2s64*//*Label 527*/ GIMT_Encode4(26244), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  26212 */   /*GILLT_v4s32*//*Label 528*/ GIMT_Encode4(26302), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  26228 */   /*GILLT_v8s16*//*Label 529*/ GIMT_Encode4(26405), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  26240 */   /*GILLT_v16s8*//*Label 530*/ GIMT_Encode4(26508),
     /*  26244 */   // Label 527: @26244
     /*  26244 */   GIM_Try, /*On fail goto*//*Label 532*/ GIMT_Encode4(26301), // Rule ID 3021 //
     /*  26249 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  26252 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  26255 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  26258 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  26262 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  26266 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  26270 */     // (concat_vectors:{ *:[v2i64] } DPR:{ *:[v1i64] }:$Dn, DPR:{ *:[v1i64] }:$Dm)  =>  (REG_SEQUENCE:{ *:[v2i64] } QPR:{ *:[i32] }, DPR:{ *:[v1i64] }:$Dn, dsub_0:{ *:[i32] }, DPR:{ *:[v1i64] }:$Dm, dsub_1:{ *:[i32] })
     /*  26270 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /*  26273 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  26275 */     GIR_RootToRootCopy, /*OpIdx*/1, // Dn
     /*  26277 */     GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/1,
     /*  26280 */     GIR_RootToRootCopy, /*OpIdx*/2, // Dm
     /*  26282 */     GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/2,
     /*  26285 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  26290 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(ARM::DPRRegClassID),
     /*  26295 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/3, GIMT_Encode2(ARM::DPRRegClassID),
     /*  26300 */     // GIR_Coverage, 3021,
     /*  26300 */     GIR_EraseRootFromParent_Done,
     /*  26301 */   // Label 532: @26301
     /*  26301 */   GIM_Reject,
     /*  26302 */   // Label 528: @26302
     /*  26302 */   GIM_Try, /*On fail goto*//*Label 533*/ GIMT_Encode4(26404),
     /*  26307 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  26310 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  26313 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  26317 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  26321 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  26325 */     GIM_Try, /*On fail goto*//*Label 534*/ GIMT_Encode4(26364), // Rule ID 3022 //
     /*  26330 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  26333 */       // (concat_vectors:{ *:[v4i32] } DPR:{ *:[v2i32] }:$Dn, DPR:{ *:[v2i32] }:$Dm)  =>  (REG_SEQUENCE:{ *:[v4i32] } QPR:{ *:[i32] }, DPR:{ *:[v2i32] }:$Dn, dsub_0:{ *:[i32] }, DPR:{ *:[v2i32] }:$Dm, dsub_1:{ *:[i32] })
     /*  26333 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /*  26336 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  26338 */       GIR_RootToRootCopy, /*OpIdx*/1, // Dn
     /*  26340 */       GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/1,
     /*  26343 */       GIR_RootToRootCopy, /*OpIdx*/2, // Dm
     /*  26345 */       GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/2,
     /*  26348 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  26353 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(ARM::DPRRegClassID),
     /*  26358 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/3, GIMT_Encode2(ARM::DPRRegClassID),
     /*  26363 */       // GIR_Coverage, 3022,
     /*  26363 */       GIR_EraseRootFromParent_Done,
     /*  26364 */     // Label 534: @26364
     /*  26364 */     GIM_Try, /*On fail goto*//*Label 535*/ GIMT_Encode4(26403), // Rule ID 3025 //
     /*  26369 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  26372 */       // (concat_vectors:{ *:[v4f32] } DPR:{ *:[v2f32] }:$Dn, DPR:{ *:[v2f32] }:$Dm)  =>  (REG_SEQUENCE:{ *:[v4f32] } QPR:{ *:[i32] }, DPR:{ *:[v2f32] }:$Dn, dsub_0:{ *:[i32] }, DPR:{ *:[v2f32] }:$Dm, dsub_1:{ *:[i32] })
     /*  26372 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /*  26375 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  26377 */       GIR_RootToRootCopy, /*OpIdx*/1, // Dn
     /*  26379 */       GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/1,
     /*  26382 */       GIR_RootToRootCopy, /*OpIdx*/2, // Dm
     /*  26384 */       GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/2,
     /*  26387 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  26392 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(ARM::DPRRegClassID),
     /*  26397 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/3, GIMT_Encode2(ARM::DPRRegClassID),
     /*  26402 */       // GIR_Coverage, 3025,
     /*  26402 */       GIR_EraseRootFromParent_Done,
     /*  26403 */     // Label 535: @26403
     /*  26403 */     GIM_Reject,
     /*  26404 */   // Label 533: @26404
     /*  26404 */   GIM_Reject,
     /*  26405 */   // Label 529: @26405
     /*  26405 */   GIM_Try, /*On fail goto*//*Label 536*/ GIMT_Encode4(26507),
     /*  26410 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  26413 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  26416 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  26420 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  26424 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  26428 */     GIM_Try, /*On fail goto*//*Label 537*/ GIMT_Encode4(26467), // Rule ID 3023 //
     /*  26433 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  26436 */       // (concat_vectors:{ *:[v8i16] } DPR:{ *:[v4i16] }:$Dn, DPR:{ *:[v4i16] }:$Dm)  =>  (REG_SEQUENCE:{ *:[v8i16] } QPR:{ *:[i32] }, DPR:{ *:[v4i16] }:$Dn, dsub_0:{ *:[i32] }, DPR:{ *:[v4i16] }:$Dm, dsub_1:{ *:[i32] })
     /*  26436 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /*  26439 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  26441 */       GIR_RootToRootCopy, /*OpIdx*/1, // Dn
     /*  26443 */       GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/1,
     /*  26446 */       GIR_RootToRootCopy, /*OpIdx*/2, // Dm
     /*  26448 */       GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/2,
     /*  26451 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  26456 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(ARM::DPRRegClassID),
     /*  26461 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/3, GIMT_Encode2(ARM::DPRRegClassID),
     /*  26466 */       // GIR_Coverage, 3023,
     /*  26466 */       GIR_EraseRootFromParent_Done,
     /*  26467 */     // Label 537: @26467
     /*  26467 */     GIM_Try, /*On fail goto*//*Label 538*/ GIMT_Encode4(26506), // Rule ID 3026 //
     /*  26472 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  26475 */       // (concat_vectors:{ *:[v8f16] } DPR:{ *:[v4f16] }:$Dn, DPR:{ *:[v4f16] }:$Dm)  =>  (REG_SEQUENCE:{ *:[v8f16] } QPR:{ *:[i32] }, DPR:{ *:[v4f16] }:$Dn, dsub_0:{ *:[i32] }, DPR:{ *:[v4f16] }:$Dm, dsub_1:{ *:[i32] })
     /*  26475 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /*  26478 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  26480 */       GIR_RootToRootCopy, /*OpIdx*/1, // Dn
     /*  26482 */       GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/1,
     /*  26485 */       GIR_RootToRootCopy, /*OpIdx*/2, // Dm
     /*  26487 */       GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/2,
     /*  26490 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  26495 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(ARM::DPRRegClassID),
     /*  26500 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/3, GIMT_Encode2(ARM::DPRRegClassID),
     /*  26505 */       // GIR_Coverage, 3026,
     /*  26505 */       GIR_EraseRootFromParent_Done,
     /*  26506 */     // Label 538: @26506
     /*  26506 */     GIM_Reject,
     /*  26507 */   // Label 536: @26507
     /*  26507 */   GIM_Reject,
     /*  26508 */   // Label 530: @26508
     /*  26508 */   GIM_Try, /*On fail goto*//*Label 539*/ GIMT_Encode4(26565), // Rule ID 3024 //
     /*  26513 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  26516 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  26519 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  26522 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  26526 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  26530 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  26534 */     // (concat_vectors:{ *:[v16i8] } DPR:{ *:[v8i8] }:$Dn, DPR:{ *:[v8i8] }:$Dm)  =>  (REG_SEQUENCE:{ *:[v16i8] } QPR:{ *:[i32] }, DPR:{ *:[v8i8] }:$Dn, dsub_0:{ *:[i32] }, DPR:{ *:[v8i8] }:$Dm, dsub_1:{ *:[i32] })
     /*  26534 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /*  26537 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  26539 */     GIR_RootToRootCopy, /*OpIdx*/1, // Dn
     /*  26541 */     GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/1,
     /*  26544 */     GIR_RootToRootCopy, /*OpIdx*/2, // Dm
     /*  26546 */     GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/2,
     /*  26549 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  26554 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(ARM::DPRRegClassID),
     /*  26559 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/3, GIMT_Encode2(ARM::DPRRegClassID),
     /*  26564 */     // GIR_Coverage, 3024,
     /*  26564 */     GIR_EraseRootFromParent_Done,
     /*  26565 */   // Label 539: @26565
     /*  26565 */   GIM_Reject,
     /*  26566 */   // Label 531: @26566
     /*  26566 */   GIM_Reject,
     /*  26567 */ // Label 526: @26567
     /*  26567 */ GIM_Reject,
     /*  26568 */ // Label 9: @26568
     /*  26568 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(16), /*)*//*default:*//*Label 549*/ GIMT_Encode4(35579),
     /*  26579 */ /*GILLT_s32*//*Label 540*/ GIMT_Encode4(26639),
     /*  26583 */ /*GILLT_s64*//*Label 541*/ GIMT_Encode4(26787), GIMT_Encode4(0),
     /*  26591 */ /*GILLT_v2s32*//*Label 542*/ GIMT_Encode4(27542),
     /*  26595 */ /*GILLT_v2s64*//*Label 543*/ GIMT_Encode4(28297), GIMT_Encode4(0),
     /*  26603 */ /*GILLT_v4s16*//*Label 544*/ GIMT_Encode4(30016),
     /*  26607 */ /*GILLT_v4s32*//*Label 545*/ GIMT_Encode4(30771), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  26619 */ /*GILLT_v8s8*//*Label 546*/ GIMT_Encode4(32490),
     /*  26623 */ /*GILLT_v8s16*//*Label 547*/ GIMT_Encode4(32905), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  26635 */ /*GILLT_v16s8*//*Label 548*/ GIMT_Encode4(34624),
     /*  26639 */ // Label 540: @26639
     /*  26639 */ GIM_Try, /*On fail goto*//*Label 550*/ GIMT_Encode4(26786),
     /*  26644 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  26647 */   GIM_Try, /*On fail goto*//*Label 551*/ GIMT_Encode4(26681), // Rule ID 689 //
     /*  26652 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPRegs),
     /*  26655 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  26659 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /*  26663 */     // (bitconvert:{ *:[i32] } SPR:{ *:[f32] }:$Sn)  =>  (VMOVRS:{ *:[i32] } SPR:{ *:[f32] }:$Sn)
     /*  26663 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMOVRS),
     /*  26666 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  26668 */     GIR_RootToRootCopy, /*OpIdx*/1, // Sn
     /*  26670 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  26673 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  26679 */     GIR_RootConstrainSelectedInstOperands,
     /*  26680 */     // GIR_Coverage, 689,
     /*  26680 */     GIR_EraseRootFromParent_Done,
     /*  26681 */   // Label 551: @26681
     /*  26681 */   GIM_Try, /*On fail goto*//*Label 552*/ GIMT_Encode4(26715), // Rule ID 690 //
     /*  26686 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPRegs_UseVMOVSR),
     /*  26689 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /*  26693 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  26697 */     // (bitconvert:{ *:[f32] } GPR:{ *:[i32] }:$Rt)  =>  (VMOVSR:{ *:[f32] } GPR:{ *:[i32] }:$Rt)
     /*  26697 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMOVSR),
     /*  26700 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sn]
     /*  26702 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rt
     /*  26704 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  26707 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  26713 */     GIR_RootConstrainSelectedInstOperands,
     /*  26714 */     // GIR_Coverage, 690,
     /*  26714 */     GIR_EraseRootFromParent_Done,
     /*  26715 */   // Label 552: @26715
     /*  26715 */   GIM_Try, /*On fail goto*//*Label 553*/ GIMT_Encode4(26785), // Rule ID 2715 //
     /*  26720 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_DontUseVMOVSR_HasNEON),
     /*  26723 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /*  26727 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  26731 */     // (bitconvert:{ *:[f32] } GPR:{ *:[i32] }:$a)  =>  (EXTRACT_SUBREG:{ *:[f32] } (VMOVDRR:{ *:[f64] } GPR:{ *:[i32] }:$a, GPR:{ *:[i32] }:$a), ssub_0:{ *:[i32] })
     /*  26731 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  26734 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::VMOVDRR),
     /*  26738 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  26743 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // a
     /*  26747 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // a
     /*  26751 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/14,
     /*  26754 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  26760 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  26762 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  26765 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  26767 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(ARM::ssub_0),
     /*  26774 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::SPRRegClassID),
     /*  26779 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /*  26784 */     // GIR_Coverage, 2715,
     /*  26784 */     GIR_EraseRootFromParent_Done,
     /*  26785 */   // Label 553: @26785
     /*  26785 */   GIM_Reject,
     /*  26786 */ // Label 550: @26786
     /*  26786 */ GIM_Reject,
     /*  26787 */ // Label 541: @26787
     /*  26787 */ GIM_Try, /*On fail goto*//*Label 554*/ GIMT_Encode4(26819), // Rule ID 2717 //
     /*  26792 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  26795 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  26798 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  26802 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  26806 */   // (bitconvert:{ *:[f64] } DPR:{ *:[v1i64] }:$src)  =>  DPR:{ *:[f64] }:$src
     /*  26806 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  26809 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  26811 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  26813 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::DPRRegClassID),
     /*  26818 */   // GIR_Coverage, 2717,
     /*  26818 */   GIR_EraseRootFromParent_Done,
     /*  26819 */ // Label 554: @26819
     /*  26819 */ GIM_Try, /*On fail goto*//*Label 555*/ GIMT_Encode4(26851), // Rule ID 2718 //
     /*  26824 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  26827 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  26830 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  26834 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  26838 */   // (bitconvert:{ *:[v1i64] } DPR:{ *:[f64] }:$src)  =>  DPR:{ *:[v1i64] }:$src
     /*  26838 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  26841 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  26843 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  26845 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::DPRRegClassID),
     /*  26850 */   // GIR_Coverage, 2718,
     /*  26850 */   GIR_EraseRootFromParent_Done,
     /*  26851 */ // Label 555: @26851
     /*  26851 */ GIM_Try, /*On fail goto*//*Label 556*/ GIMT_Encode4(26883), // Rule ID 2729 //
     /*  26856 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  26859 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  26862 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  26866 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  26870 */   // (bitconvert:{ *:[f64] } DPR:{ *:[v2f32] }:$src)  =>  DPR:{ *:[f64] }:$src
     /*  26870 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  26873 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  26875 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  26877 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::DPRRegClassID),
     /*  26882 */   // GIR_Coverage, 2729,
     /*  26882 */   GIR_EraseRootFromParent_Done,
     /*  26883 */ // Label 556: @26883
     /*  26883 */ GIM_Try, /*On fail goto*//*Label 557*/ GIMT_Encode4(26915), // Rule ID 2730 //
     /*  26888 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  26891 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  26894 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  26898 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  26902 */   // (bitconvert:{ *:[f64] } DPR:{ *:[v2i32] }:$src)  =>  DPR:{ *:[f64] }:$src
     /*  26902 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  26905 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  26907 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  26909 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::DPRRegClassID),
     /*  26914 */   // GIR_Coverage, 2730,
     /*  26914 */   GIR_EraseRootFromParent_Done,
     /*  26915 */ // Label 557: @26915
     /*  26915 */ GIM_Try, /*On fail goto*//*Label 558*/ GIMT_Encode4(26947), // Rule ID 2731 //
     /*  26920 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  26923 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  26926 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  26930 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  26934 */   // (bitconvert:{ *:[f64] } DPR:{ *:[v4f16] }:$src)  =>  DPR:{ *:[f64] }:$src
     /*  26934 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  26937 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  26939 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  26941 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::DPRRegClassID),
     /*  26946 */   // GIR_Coverage, 2731,
     /*  26946 */   GIR_EraseRootFromParent_Done,
     /*  26947 */ // Label 558: @26947
     /*  26947 */ GIM_Try, /*On fail goto*//*Label 559*/ GIMT_Encode4(26979), // Rule ID 2732 //
     /*  26952 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  26955 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  26958 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  26962 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  26966 */   // (bitconvert:{ *:[f64] } DPR:{ *:[v4i16] }:$src)  =>  DPR:{ *:[f64] }:$src
     /*  26966 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  26969 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  26971 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  26973 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::DPRRegClassID),
     /*  26978 */   // GIR_Coverage, 2732,
     /*  26978 */   GIR_EraseRootFromParent_Done,
     /*  26979 */ // Label 559: @26979
     /*  26979 */ GIM_Try, /*On fail goto*//*Label 560*/ GIMT_Encode4(27011), // Rule ID 2733 //
     /*  26984 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  26987 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  26990 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  26994 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  26998 */   // (bitconvert:{ *:[f64] } DPR:{ *:[v8i8] }:$src)  =>  DPR:{ *:[f64] }:$src
     /*  26998 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  27001 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  27003 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  27005 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::DPRRegClassID),
     /*  27010 */   // GIR_Coverage, 2733,
     /*  27010 */   GIR_EraseRootFromParent_Done,
     /*  27011 */ // Label 560: @27011
     /*  27011 */ GIM_Try, /*On fail goto*//*Label 561*/ GIMT_Encode4(27043), // Rule ID 2734 //
     /*  27016 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  27019 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  27022 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27026 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27030 */   // (bitconvert:{ *:[v1i64] } DPR:{ *:[v2f32] }:$src)  =>  DPR:{ *:[v1i64] }:$src
     /*  27030 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  27033 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  27035 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  27037 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::DPRRegClassID),
     /*  27042 */   // GIR_Coverage, 2734,
     /*  27042 */   GIR_EraseRootFromParent_Done,
     /*  27043 */ // Label 561: @27043
     /*  27043 */ GIM_Try, /*On fail goto*//*Label 562*/ GIMT_Encode4(27075), // Rule ID 2735 //
     /*  27048 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  27051 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  27054 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27058 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27062 */   // (bitconvert:{ *:[v1i64] } DPR:{ *:[v2i32] }:$src)  =>  DPR:{ *:[v1i64] }:$src
     /*  27062 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  27065 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  27067 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  27069 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::DPRRegClassID),
     /*  27074 */   // GIR_Coverage, 2735,
     /*  27074 */   GIR_EraseRootFromParent_Done,
     /*  27075 */ // Label 562: @27075
     /*  27075 */ GIM_Try, /*On fail goto*//*Label 563*/ GIMT_Encode4(27107), // Rule ID 2736 //
     /*  27080 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  27083 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  27086 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27090 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27094 */   // (bitconvert:{ *:[v1i64] } DPR:{ *:[v4f16] }:$src)  =>  DPR:{ *:[v1i64] }:$src
     /*  27094 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  27097 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  27099 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  27101 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::DPRRegClassID),
     /*  27106 */   // GIR_Coverage, 2736,
     /*  27106 */   GIR_EraseRootFromParent_Done,
     /*  27107 */ // Label 563: @27107
     /*  27107 */ GIM_Try, /*On fail goto*//*Label 564*/ GIMT_Encode4(27139), // Rule ID 2737 //
     /*  27112 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  27115 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  27118 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27122 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27126 */   // (bitconvert:{ *:[v1i64] } DPR:{ *:[v4i16] }:$src)  =>  DPR:{ *:[v1i64] }:$src
     /*  27126 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  27129 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  27131 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  27133 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::DPRRegClassID),
     /*  27138 */   // GIR_Coverage, 2737,
     /*  27138 */   GIR_EraseRootFromParent_Done,
     /*  27139 */ // Label 564: @27139
     /*  27139 */ GIM_Try, /*On fail goto*//*Label 565*/ GIMT_Encode4(27171), // Rule ID 2738 //
     /*  27144 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  27147 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  27150 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27154 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27158 */   // (bitconvert:{ *:[v1i64] } DPR:{ *:[v8i8] }:$src)  =>  DPR:{ *:[v1i64] }:$src
     /*  27158 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  27161 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  27163 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  27165 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::DPRRegClassID),
     /*  27170 */   // GIR_Coverage, 2738,
     /*  27170 */   GIR_EraseRootFromParent_Done,
     /*  27171 */ // Label 565: @27171
     /*  27171 */ GIM_Try, /*On fail goto*//*Label 566*/ GIMT_Encode4(27208), // Rule ID 2801 //
     /*  27176 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  27179 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  27182 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27186 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27190 */   // (bitconvert:{ *:[f64] } DPR:{ *:[v2f32] }:$src)  =>  (VREV64d32:{ *:[f64] } DPR:{ *:[v2f32] }:$src)
     /*  27190 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV64d32),
     /*  27193 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  27195 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  27197 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  27200 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  27206 */   GIR_RootConstrainSelectedInstOperands,
     /*  27207 */   // GIR_Coverage, 2801,
     /*  27207 */   GIR_EraseRootFromParent_Done,
     /*  27208 */ // Label 566: @27208
     /*  27208 */ GIM_Try, /*On fail goto*//*Label 567*/ GIMT_Encode4(27245), // Rule ID 2802 //
     /*  27213 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  27216 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  27219 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27223 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27227 */   // (bitconvert:{ *:[f64] } DPR:{ *:[v2i32] }:$src)  =>  (VREV64d32:{ *:[f64] } DPR:{ *:[v2i32] }:$src)
     /*  27227 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV64d32),
     /*  27230 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  27232 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  27234 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  27237 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  27243 */   GIR_RootConstrainSelectedInstOperands,
     /*  27244 */   // GIR_Coverage, 2802,
     /*  27244 */   GIR_EraseRootFromParent_Done,
     /*  27245 */ // Label 567: @27245
     /*  27245 */ GIM_Try, /*On fail goto*//*Label 568*/ GIMT_Encode4(27282), // Rule ID 2803 //
     /*  27250 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  27253 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  27256 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27260 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27264 */   // (bitconvert:{ *:[f64] } DPR:{ *:[v4f16] }:$src)  =>  (VREV64d16:{ *:[f64] } DPR:{ *:[v4f16] }:$src)
     /*  27264 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV64d16),
     /*  27267 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  27269 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  27271 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  27274 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  27280 */   GIR_RootConstrainSelectedInstOperands,
     /*  27281 */   // GIR_Coverage, 2803,
     /*  27281 */   GIR_EraseRootFromParent_Done,
     /*  27282 */ // Label 568: @27282
     /*  27282 */ GIM_Try, /*On fail goto*//*Label 569*/ GIMT_Encode4(27319), // Rule ID 2804 //
     /*  27287 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  27290 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  27293 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27297 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27301 */   // (bitconvert:{ *:[f64] } DPR:{ *:[v4i16] }:$src)  =>  (VREV64d16:{ *:[f64] } DPR:{ *:[v4i16] }:$src)
     /*  27301 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV64d16),
     /*  27304 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  27306 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  27308 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  27311 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  27317 */   GIR_RootConstrainSelectedInstOperands,
     /*  27318 */   // GIR_Coverage, 2804,
     /*  27318 */   GIR_EraseRootFromParent_Done,
     /*  27319 */ // Label 569: @27319
     /*  27319 */ GIM_Try, /*On fail goto*//*Label 570*/ GIMT_Encode4(27356), // Rule ID 2805 //
     /*  27324 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  27327 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  27330 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27334 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27338 */   // (bitconvert:{ *:[f64] } DPR:{ *:[v8i8] }:$src)  =>  (VREV64d8:{ *:[f64] } DPR:{ *:[v8i8] }:$src)
     /*  27338 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV64d8),
     /*  27341 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  27343 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  27345 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  27348 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  27354 */   GIR_RootConstrainSelectedInstOperands,
     /*  27355 */   // GIR_Coverage, 2805,
     /*  27355 */   GIR_EraseRootFromParent_Done,
     /*  27356 */ // Label 570: @27356
     /*  27356 */ GIM_Try, /*On fail goto*//*Label 571*/ GIMT_Encode4(27393), // Rule ID 2806 //
     /*  27361 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  27364 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  27367 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27371 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27375 */   // (bitconvert:{ *:[v1i64] } DPR:{ *:[v2f32] }:$src)  =>  (VREV64d32:{ *:[v1i64] } DPR:{ *:[v2f32] }:$src)
     /*  27375 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV64d32),
     /*  27378 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  27380 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  27382 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  27385 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  27391 */   GIR_RootConstrainSelectedInstOperands,
     /*  27392 */   // GIR_Coverage, 2806,
     /*  27392 */   GIR_EraseRootFromParent_Done,
     /*  27393 */ // Label 571: @27393
     /*  27393 */ GIM_Try, /*On fail goto*//*Label 572*/ GIMT_Encode4(27430), // Rule ID 2807 //
     /*  27398 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  27401 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  27404 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27408 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27412 */   // (bitconvert:{ *:[v1i64] } DPR:{ *:[v2i32] }:$src)  =>  (VREV64d32:{ *:[v1i64] } DPR:{ *:[v2i32] }:$src)
     /*  27412 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV64d32),
     /*  27415 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  27417 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  27419 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  27422 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  27428 */   GIR_RootConstrainSelectedInstOperands,
     /*  27429 */   // GIR_Coverage, 2807,
     /*  27429 */   GIR_EraseRootFromParent_Done,
     /*  27430 */ // Label 572: @27430
     /*  27430 */ GIM_Try, /*On fail goto*//*Label 573*/ GIMT_Encode4(27467), // Rule ID 2808 //
     /*  27435 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  27438 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  27441 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27445 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27449 */   // (bitconvert:{ *:[v1i64] } DPR:{ *:[v4f16] }:$src)  =>  (VREV64d16:{ *:[v1i64] } DPR:{ *:[v4f16] }:$src)
     /*  27449 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV64d16),
     /*  27452 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  27454 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  27456 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  27459 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  27465 */   GIR_RootConstrainSelectedInstOperands,
     /*  27466 */   // GIR_Coverage, 2808,
     /*  27466 */   GIR_EraseRootFromParent_Done,
     /*  27467 */ // Label 573: @27467
     /*  27467 */ GIM_Try, /*On fail goto*//*Label 574*/ GIMT_Encode4(27504), // Rule ID 2809 //
     /*  27472 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  27475 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  27478 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27482 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27486 */   // (bitconvert:{ *:[v1i64] } DPR:{ *:[v4i16] }:$src)  =>  (VREV64d16:{ *:[v1i64] } DPR:{ *:[v4i16] }:$src)
     /*  27486 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV64d16),
     /*  27489 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  27491 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  27493 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  27496 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  27502 */   GIR_RootConstrainSelectedInstOperands,
     /*  27503 */   // GIR_Coverage, 2809,
     /*  27503 */   GIR_EraseRootFromParent_Done,
     /*  27504 */ // Label 574: @27504
     /*  27504 */ GIM_Try, /*On fail goto*//*Label 575*/ GIMT_Encode4(27541), // Rule ID 2810 //
     /*  27509 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  27512 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  27515 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27519 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27523 */   // (bitconvert:{ *:[v1i64] } DPR:{ *:[v8i8] }:$src)  =>  (VREV64d8:{ *:[v1i64] } DPR:{ *:[v8i8] }:$src)
     /*  27523 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV64d8),
     /*  27526 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  27528 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  27530 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  27533 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  27539 */   GIR_RootConstrainSelectedInstOperands,
     /*  27540 */   // GIR_Coverage, 2810,
     /*  27540 */   GIR_EraseRootFromParent_Done,
     /*  27541 */ // Label 575: @27541
     /*  27541 */ GIM_Reject,
     /*  27542 */ // Label 542: @27542
     /*  27542 */ GIM_Try, /*On fail goto*//*Label 576*/ GIMT_Encode4(27574), // Rule ID 2719 //
     /*  27547 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  27550 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  27553 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27557 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27561 */   // (bitconvert:{ *:[v2f32] } DPR:{ *:[v2i32] }:$src)  =>  DPR:{ *:[v2f32] }:$src
     /*  27561 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  27564 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  27566 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  27568 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::DPRRegClassID),
     /*  27573 */   // GIR_Coverage, 2719,
     /*  27573 */   GIR_EraseRootFromParent_Done,
     /*  27574 */ // Label 576: @27574
     /*  27574 */ GIM_Try, /*On fail goto*//*Label 577*/ GIMT_Encode4(27606), // Rule ID 2720 //
     /*  27579 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  27582 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  27585 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27589 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27593 */   // (bitconvert:{ *:[v2i32] } DPR:{ *:[v2f32] }:$src)  =>  DPR:{ *:[v2i32] }:$src
     /*  27593 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  27596 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  27598 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  27600 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::DPRRegClassID),
     /*  27605 */   // GIR_Coverage, 2720,
     /*  27605 */   GIR_EraseRootFromParent_Done,
     /*  27606 */ // Label 577: @27606
     /*  27606 */ GIM_Try, /*On fail goto*//*Label 578*/ GIMT_Encode4(27638), // Rule ID 2739 //
     /*  27611 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  27614 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  27617 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27621 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27625 */   // (bitconvert:{ *:[v2f32] } DPR:{ *:[f64] }:$src)  =>  DPR:{ *:[v2f32] }:$src
     /*  27625 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  27628 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  27630 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  27632 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::DPRRegClassID),
     /*  27637 */   // GIR_Coverage, 2739,
     /*  27637 */   GIR_EraseRootFromParent_Done,
     /*  27638 */ // Label 578: @27638
     /*  27638 */ GIM_Try, /*On fail goto*//*Label 579*/ GIMT_Encode4(27670), // Rule ID 2740 //
     /*  27643 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  27646 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  27649 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27653 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27657 */   // (bitconvert:{ *:[v2f32] } DPR:{ *:[v1i64] }:$src)  =>  DPR:{ *:[v2f32] }:$src
     /*  27657 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  27660 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  27662 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  27664 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::DPRRegClassID),
     /*  27669 */   // GIR_Coverage, 2740,
     /*  27669 */   GIR_EraseRootFromParent_Done,
     /*  27670 */ // Label 579: @27670
     /*  27670 */ GIM_Try, /*On fail goto*//*Label 580*/ GIMT_Encode4(27702), // Rule ID 2741 //
     /*  27675 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  27678 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  27681 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27685 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27689 */   // (bitconvert:{ *:[v2f32] } DPR:{ *:[v4f16] }:$src)  =>  DPR:{ *:[v2f32] }:$src
     /*  27689 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  27692 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  27694 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  27696 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::DPRRegClassID),
     /*  27701 */   // GIR_Coverage, 2741,
     /*  27701 */   GIR_EraseRootFromParent_Done,
     /*  27702 */ // Label 580: @27702
     /*  27702 */ GIM_Try, /*On fail goto*//*Label 581*/ GIMT_Encode4(27734), // Rule ID 2742 //
     /*  27707 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  27710 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  27713 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27717 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27721 */   // (bitconvert:{ *:[v2f32] } DPR:{ *:[v4i16] }:$src)  =>  DPR:{ *:[v2f32] }:$src
     /*  27721 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  27724 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  27726 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  27728 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::DPRRegClassID),
     /*  27733 */   // GIR_Coverage, 2742,
     /*  27733 */   GIR_EraseRootFromParent_Done,
     /*  27734 */ // Label 581: @27734
     /*  27734 */ GIM_Try, /*On fail goto*//*Label 582*/ GIMT_Encode4(27766), // Rule ID 2743 //
     /*  27739 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  27742 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  27745 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27749 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27753 */   // (bitconvert:{ *:[v2f32] } DPR:{ *:[v8i8] }:$src)  =>  DPR:{ *:[v2f32] }:$src
     /*  27753 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  27756 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  27758 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  27760 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::DPRRegClassID),
     /*  27765 */   // GIR_Coverage, 2743,
     /*  27765 */   GIR_EraseRootFromParent_Done,
     /*  27766 */ // Label 582: @27766
     /*  27766 */ GIM_Try, /*On fail goto*//*Label 583*/ GIMT_Encode4(27798), // Rule ID 2744 //
     /*  27771 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  27774 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  27777 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27781 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27785 */   // (bitconvert:{ *:[v2i32] } DPR:{ *:[f64] }:$src)  =>  DPR:{ *:[v2i32] }:$src
     /*  27785 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  27788 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  27790 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  27792 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::DPRRegClassID),
     /*  27797 */   // GIR_Coverage, 2744,
     /*  27797 */   GIR_EraseRootFromParent_Done,
     /*  27798 */ // Label 583: @27798
     /*  27798 */ GIM_Try, /*On fail goto*//*Label 584*/ GIMT_Encode4(27830), // Rule ID 2745 //
     /*  27803 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  27806 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  27809 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27813 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27817 */   // (bitconvert:{ *:[v2i32] } DPR:{ *:[v1i64] }:$src)  =>  DPR:{ *:[v2i32] }:$src
     /*  27817 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  27820 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  27822 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  27824 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::DPRRegClassID),
     /*  27829 */   // GIR_Coverage, 2745,
     /*  27829 */   GIR_EraseRootFromParent_Done,
     /*  27830 */ // Label 584: @27830
     /*  27830 */ GIM_Try, /*On fail goto*//*Label 585*/ GIMT_Encode4(27862), // Rule ID 2746 //
     /*  27835 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  27838 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  27841 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27845 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27849 */   // (bitconvert:{ *:[v2i32] } DPR:{ *:[v4f16] }:$src)  =>  DPR:{ *:[v2i32] }:$src
     /*  27849 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  27852 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  27854 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  27856 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::DPRRegClassID),
     /*  27861 */   // GIR_Coverage, 2746,
     /*  27861 */   GIR_EraseRootFromParent_Done,
     /*  27862 */ // Label 585: @27862
     /*  27862 */ GIM_Try, /*On fail goto*//*Label 586*/ GIMT_Encode4(27894), // Rule ID 2747 //
     /*  27867 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  27870 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  27873 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27877 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27881 */   // (bitconvert:{ *:[v2i32] } DPR:{ *:[v4i16] }:$src)  =>  DPR:{ *:[v2i32] }:$src
     /*  27881 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  27884 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  27886 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  27888 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::DPRRegClassID),
     /*  27893 */   // GIR_Coverage, 2747,
     /*  27893 */   GIR_EraseRootFromParent_Done,
     /*  27894 */ // Label 586: @27894
     /*  27894 */ GIM_Try, /*On fail goto*//*Label 587*/ GIMT_Encode4(27926), // Rule ID 2748 //
     /*  27899 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  27902 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  27905 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27909 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27913 */   // (bitconvert:{ *:[v2i32] } DPR:{ *:[v8i8] }:$src)  =>  DPR:{ *:[v2i32] }:$src
     /*  27913 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  27916 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  27918 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  27920 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::DPRRegClassID),
     /*  27925 */   // GIR_Coverage, 2748,
     /*  27925 */   GIR_EraseRootFromParent_Done,
     /*  27926 */ // Label 587: @27926
     /*  27926 */ GIM_Try, /*On fail goto*//*Label 588*/ GIMT_Encode4(27963), // Rule ID 2811 //
     /*  27931 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  27934 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  27937 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27941 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27945 */   // (bitconvert:{ *:[v2f32] } DPR:{ *:[f64] }:$src)  =>  (VREV64d32:{ *:[v2f32] } DPR:{ *:[f64] }:$src)
     /*  27945 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV64d32),
     /*  27948 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  27950 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  27952 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  27955 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  27961 */   GIR_RootConstrainSelectedInstOperands,
     /*  27962 */   // GIR_Coverage, 2811,
     /*  27962 */   GIR_EraseRootFromParent_Done,
     /*  27963 */ // Label 588: @27963
     /*  27963 */ GIM_Try, /*On fail goto*//*Label 589*/ GIMT_Encode4(28000), // Rule ID 2812 //
     /*  27968 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  27971 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  27974 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27978 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27982 */   // (bitconvert:{ *:[v2f32] } DPR:{ *:[v1i64] }:$src)  =>  (VREV64d32:{ *:[v2f32] } DPR:{ *:[v1i64] }:$src)
     /*  27982 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV64d32),
     /*  27985 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  27987 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  27989 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  27992 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  27998 */   GIR_RootConstrainSelectedInstOperands,
     /*  27999 */   // GIR_Coverage, 2812,
     /*  27999 */   GIR_EraseRootFromParent_Done,
     /*  28000 */ // Label 589: @28000
     /*  28000 */ GIM_Try, /*On fail goto*//*Label 590*/ GIMT_Encode4(28037), // Rule ID 2813 //
     /*  28005 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  28008 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  28011 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  28015 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  28019 */   // (bitconvert:{ *:[v2f32] } DPR:{ *:[v4f16] }:$src)  =>  (VREV32d16:{ *:[v2f32] } DPR:{ *:[v4f16] }:$src)
     /*  28019 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV32d16),
     /*  28022 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  28024 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  28026 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  28029 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  28035 */   GIR_RootConstrainSelectedInstOperands,
     /*  28036 */   // GIR_Coverage, 2813,
     /*  28036 */   GIR_EraseRootFromParent_Done,
     /*  28037 */ // Label 590: @28037
     /*  28037 */ GIM_Try, /*On fail goto*//*Label 591*/ GIMT_Encode4(28074), // Rule ID 2814 //
     /*  28042 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  28045 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  28048 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  28052 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  28056 */   // (bitconvert:{ *:[v2f32] } DPR:{ *:[v4i16] }:$src)  =>  (VREV32d16:{ *:[v2f32] } DPR:{ *:[v4i16] }:$src)
     /*  28056 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV32d16),
     /*  28059 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  28061 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  28063 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  28066 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  28072 */   GIR_RootConstrainSelectedInstOperands,
     /*  28073 */   // GIR_Coverage, 2814,
     /*  28073 */   GIR_EraseRootFromParent_Done,
     /*  28074 */ // Label 591: @28074
     /*  28074 */ GIM_Try, /*On fail goto*//*Label 592*/ GIMT_Encode4(28111), // Rule ID 2815 //
     /*  28079 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  28082 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  28085 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  28089 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  28093 */   // (bitconvert:{ *:[v2f32] } DPR:{ *:[v8i8] }:$src)  =>  (VREV32d8:{ *:[v2f32] } DPR:{ *:[v8i8] }:$src)
     /*  28093 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV32d8),
     /*  28096 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  28098 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  28100 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  28103 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  28109 */   GIR_RootConstrainSelectedInstOperands,
     /*  28110 */   // GIR_Coverage, 2815,
     /*  28110 */   GIR_EraseRootFromParent_Done,
     /*  28111 */ // Label 592: @28111
     /*  28111 */ GIM_Try, /*On fail goto*//*Label 593*/ GIMT_Encode4(28148), // Rule ID 2816 //
     /*  28116 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  28119 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  28122 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  28126 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  28130 */   // (bitconvert:{ *:[v2i32] } DPR:{ *:[f64] }:$src)  =>  (VREV64d32:{ *:[v2i32] } DPR:{ *:[f64] }:$src)
     /*  28130 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV64d32),
     /*  28133 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  28135 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  28137 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  28140 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  28146 */   GIR_RootConstrainSelectedInstOperands,
     /*  28147 */   // GIR_Coverage, 2816,
     /*  28147 */   GIR_EraseRootFromParent_Done,
     /*  28148 */ // Label 593: @28148
     /*  28148 */ GIM_Try, /*On fail goto*//*Label 594*/ GIMT_Encode4(28185), // Rule ID 2817 //
     /*  28153 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  28156 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  28159 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  28163 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  28167 */   // (bitconvert:{ *:[v2i32] } DPR:{ *:[v1i64] }:$src)  =>  (VREV64d32:{ *:[v2i32] } DPR:{ *:[v1i64] }:$src)
     /*  28167 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV64d32),
     /*  28170 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  28172 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  28174 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  28177 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  28183 */   GIR_RootConstrainSelectedInstOperands,
     /*  28184 */   // GIR_Coverage, 2817,
     /*  28184 */   GIR_EraseRootFromParent_Done,
     /*  28185 */ // Label 594: @28185
     /*  28185 */ GIM_Try, /*On fail goto*//*Label 595*/ GIMT_Encode4(28222), // Rule ID 2818 //
     /*  28190 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  28193 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  28196 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  28200 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  28204 */   // (bitconvert:{ *:[v2i32] } DPR:{ *:[v4f16] }:$src)  =>  (VREV32d16:{ *:[v2i32] } DPR:{ *:[v4f16] }:$src)
     /*  28204 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV32d16),
     /*  28207 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  28209 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  28211 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  28214 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  28220 */   GIR_RootConstrainSelectedInstOperands,
     /*  28221 */   // GIR_Coverage, 2818,
     /*  28221 */   GIR_EraseRootFromParent_Done,
     /*  28222 */ // Label 595: @28222
     /*  28222 */ GIM_Try, /*On fail goto*//*Label 596*/ GIMT_Encode4(28259), // Rule ID 2819 //
     /*  28227 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  28230 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  28233 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  28237 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  28241 */   // (bitconvert:{ *:[v2i32] } DPR:{ *:[v4i16] }:$src)  =>  (VREV32d16:{ *:[v2i32] } DPR:{ *:[v4i16] }:$src)
     /*  28241 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV32d16),
     /*  28244 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  28246 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  28248 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  28251 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  28257 */   GIR_RootConstrainSelectedInstOperands,
     /*  28258 */   // GIR_Coverage, 2819,
     /*  28258 */   GIR_EraseRootFromParent_Done,
     /*  28259 */ // Label 596: @28259
     /*  28259 */ GIM_Try, /*On fail goto*//*Label 597*/ GIMT_Encode4(28296), // Rule ID 2820 //
     /*  28264 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  28267 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  28270 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  28274 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  28278 */   // (bitconvert:{ *:[v2i32] } DPR:{ *:[v8i8] }:$src)  =>  (VREV32d8:{ *:[v2i32] } DPR:{ *:[v8i8] }:$src)
     /*  28278 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV32d8),
     /*  28281 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  28283 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  28285 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  28288 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  28294 */   GIR_RootConstrainSelectedInstOperands,
     /*  28295 */   // GIR_Coverage, 2820,
     /*  28295 */   GIR_EraseRootFromParent_Done,
     /*  28296 */ // Label 597: @28296
     /*  28296 */ GIM_Reject,
     /*  28297 */ // Label 543: @28297
     /*  28297 */ GIM_Try, /*On fail goto*//*Label 598*/ GIMT_Encode4(28329), // Rule ID 2723 //
     /*  28302 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  28305 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  28308 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  28312 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  28316 */   // (bitconvert:{ *:[v2f64] } QPR:{ *:[v2i64] }:$src)  =>  QPR:{ *:[v2f64] }:$src
     /*  28316 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  28319 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  28321 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  28323 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  28328 */   // GIR_Coverage, 2723,
     /*  28328 */   GIR_EraseRootFromParent_Done,
     /*  28329 */ // Label 598: @28329
     /*  28329 */ GIM_Try, /*On fail goto*//*Label 599*/ GIMT_Encode4(28361), // Rule ID 2724 //
     /*  28334 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  28337 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  28340 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  28344 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  28348 */   // (bitconvert:{ *:[v2i64] } QPR:{ *:[v2f64] }:$src)  =>  QPR:{ *:[v2i64] }:$src
     /*  28348 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  28351 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  28353 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  28355 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  28360 */   // GIR_Coverage, 2724,
     /*  28360 */   GIR_EraseRootFromParent_Done,
     /*  28361 */ // Label 599: @28361
     /*  28361 */ GIM_Try, /*On fail goto*//*Label 600*/ GIMT_Encode4(28393), // Rule ID 2765 //
     /*  28366 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  28369 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  28372 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  28376 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  28380 */   // (bitconvert:{ *:[v2f64] } QPR:{ *:[v4f32] }:$src)  =>  QPR:{ *:[v2f64] }:$src
     /*  28380 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  28383 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  28385 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  28387 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  28392 */   // GIR_Coverage, 2765,
     /*  28392 */   GIR_EraseRootFromParent_Done,
     /*  28393 */ // Label 600: @28393
     /*  28393 */ GIM_Try, /*On fail goto*//*Label 601*/ GIMT_Encode4(28425), // Rule ID 2766 //
     /*  28398 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  28401 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  28404 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  28408 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  28412 */   // (bitconvert:{ *:[v2f64] } QPR:{ *:[v4i32] }:$src)  =>  QPR:{ *:[v2f64] }:$src
     /*  28412 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  28415 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  28417 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  28419 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  28424 */   // GIR_Coverage, 2766,
     /*  28424 */   GIR_EraseRootFromParent_Done,
     /*  28425 */ // Label 601: @28425
     /*  28425 */ GIM_Try, /*On fail goto*//*Label 602*/ GIMT_Encode4(28457), // Rule ID 2767 //
     /*  28430 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  28433 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  28436 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  28440 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  28444 */   // (bitconvert:{ *:[v2f64] } QPR:{ *:[v8f16] }:$src)  =>  QPR:{ *:[v2f64] }:$src
     /*  28444 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  28447 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  28449 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  28451 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  28456 */   // GIR_Coverage, 2767,
     /*  28456 */   GIR_EraseRootFromParent_Done,
     /*  28457 */ // Label 602: @28457
     /*  28457 */ GIM_Try, /*On fail goto*//*Label 603*/ GIMT_Encode4(28489), // Rule ID 2768 //
     /*  28462 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  28465 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  28468 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  28472 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  28476 */   // (bitconvert:{ *:[v2f64] } QPR:{ *:[v8i16] }:$src)  =>  QPR:{ *:[v2f64] }:$src
     /*  28476 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  28479 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  28481 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  28483 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  28488 */   // GIR_Coverage, 2768,
     /*  28488 */   GIR_EraseRootFromParent_Done,
     /*  28489 */ // Label 603: @28489
     /*  28489 */ GIM_Try, /*On fail goto*//*Label 604*/ GIMT_Encode4(28521), // Rule ID 2769 //
     /*  28494 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  28497 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  28500 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  28504 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  28508 */   // (bitconvert:{ *:[v2f64] } QPR:{ *:[v16i8] }:$src)  =>  QPR:{ *:[v2f64] }:$src
     /*  28508 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  28511 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  28513 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  28515 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  28520 */   // GIR_Coverage, 2769,
     /*  28520 */   GIR_EraseRootFromParent_Done,
     /*  28521 */ // Label 604: @28521
     /*  28521 */ GIM_Try, /*On fail goto*//*Label 605*/ GIMT_Encode4(28553), // Rule ID 2770 //
     /*  28526 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  28529 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  28532 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  28536 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  28540 */   // (bitconvert:{ *:[v2i64] } QPR:{ *:[v4f32] }:$src)  =>  QPR:{ *:[v2i64] }:$src
     /*  28540 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  28543 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  28545 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  28547 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  28552 */   // GIR_Coverage, 2770,
     /*  28552 */   GIR_EraseRootFromParent_Done,
     /*  28553 */ // Label 605: @28553
     /*  28553 */ GIM_Try, /*On fail goto*//*Label 606*/ GIMT_Encode4(28585), // Rule ID 2771 //
     /*  28558 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  28561 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  28564 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  28568 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  28572 */   // (bitconvert:{ *:[v2i64] } QPR:{ *:[v4i32] }:$src)  =>  QPR:{ *:[v2i64] }:$src
     /*  28572 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  28575 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  28577 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  28579 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  28584 */   // GIR_Coverage, 2771,
     /*  28584 */   GIR_EraseRootFromParent_Done,
     /*  28585 */ // Label 606: @28585
     /*  28585 */ GIM_Try, /*On fail goto*//*Label 607*/ GIMT_Encode4(28617), // Rule ID 2772 //
     /*  28590 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  28593 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  28596 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  28600 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  28604 */   // (bitconvert:{ *:[v2i64] } QPR:{ *:[v8f16] }:$src)  =>  QPR:{ *:[v2i64] }:$src
     /*  28604 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  28607 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  28609 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  28611 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  28616 */   // GIR_Coverage, 2772,
     /*  28616 */   GIR_EraseRootFromParent_Done,
     /*  28617 */ // Label 607: @28617
     /*  28617 */ GIM_Try, /*On fail goto*//*Label 608*/ GIMT_Encode4(28649), // Rule ID 2773 //
     /*  28622 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  28625 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  28628 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  28632 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  28636 */   // (bitconvert:{ *:[v2i64] } QPR:{ *:[v8i16] }:$src)  =>  QPR:{ *:[v2i64] }:$src
     /*  28636 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  28639 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  28641 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  28643 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  28648 */   // GIR_Coverage, 2773,
     /*  28648 */   GIR_EraseRootFromParent_Done,
     /*  28649 */ // Label 608: @28649
     /*  28649 */ GIM_Try, /*On fail goto*//*Label 609*/ GIMT_Encode4(28681), // Rule ID 2774 //
     /*  28654 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  28657 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  28660 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  28664 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  28668 */   // (bitconvert:{ *:[v2i64] } QPR:{ *:[v16i8] }:$src)  =>  QPR:{ *:[v2i64] }:$src
     /*  28668 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  28671 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  28673 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  28675 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  28680 */   // GIR_Coverage, 2774,
     /*  28680 */   GIR_EraseRootFromParent_Done,
     /*  28681 */ // Label 609: @28681
     /*  28681 */ GIM_Try, /*On fail goto*//*Label 610*/ GIMT_Encode4(28718), // Rule ID 2837 //
     /*  28686 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  28689 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  28692 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  28696 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  28700 */   // (bitconvert:{ *:[v2f64] } QPR:{ *:[v4f32] }:$src)  =>  (VREV64q32:{ *:[v2f64] } QPR:{ *:[v4f32] }:$src)
     /*  28700 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV64q32),
     /*  28703 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  28705 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  28707 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  28710 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  28716 */   GIR_RootConstrainSelectedInstOperands,
     /*  28717 */   // GIR_Coverage, 2837,
     /*  28717 */   GIR_EraseRootFromParent_Done,
     /*  28718 */ // Label 610: @28718
     /*  28718 */ GIM_Try, /*On fail goto*//*Label 611*/ GIMT_Encode4(28755), // Rule ID 2838 //
     /*  28723 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  28726 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  28729 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  28733 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  28737 */   // (bitconvert:{ *:[v2f64] } QPR:{ *:[v4i32] }:$src)  =>  (VREV64q32:{ *:[v2f64] } QPR:{ *:[v4i32] }:$src)
     /*  28737 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV64q32),
     /*  28740 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  28742 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  28744 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  28747 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  28753 */   GIR_RootConstrainSelectedInstOperands,
     /*  28754 */   // GIR_Coverage, 2838,
     /*  28754 */   GIR_EraseRootFromParent_Done,
     /*  28755 */ // Label 611: @28755
     /*  28755 */ GIM_Try, /*On fail goto*//*Label 612*/ GIMT_Encode4(28792), // Rule ID 2839 //
     /*  28760 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  28763 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  28766 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  28770 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  28774 */   // (bitconvert:{ *:[v2f64] } QPR:{ *:[v8f16] }:$src)  =>  (VREV64q16:{ *:[v2f64] } QPR:{ *:[v8f16] }:$src)
     /*  28774 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV64q16),
     /*  28777 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  28779 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  28781 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  28784 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  28790 */   GIR_RootConstrainSelectedInstOperands,
     /*  28791 */   // GIR_Coverage, 2839,
     /*  28791 */   GIR_EraseRootFromParent_Done,
     /*  28792 */ // Label 612: @28792
     /*  28792 */ GIM_Try, /*On fail goto*//*Label 613*/ GIMT_Encode4(28829), // Rule ID 2840 //
     /*  28797 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  28800 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  28803 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  28807 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  28811 */   // (bitconvert:{ *:[v2f64] } QPR:{ *:[v8i16] }:$src)  =>  (VREV64q16:{ *:[v2f64] } QPR:{ *:[v8i16] }:$src)
     /*  28811 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV64q16),
     /*  28814 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  28816 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  28818 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  28821 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  28827 */   GIR_RootConstrainSelectedInstOperands,
     /*  28828 */   // GIR_Coverage, 2840,
     /*  28828 */   GIR_EraseRootFromParent_Done,
     /*  28829 */ // Label 613: @28829
     /*  28829 */ GIM_Try, /*On fail goto*//*Label 614*/ GIMT_Encode4(28866), // Rule ID 2841 //
     /*  28834 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  28837 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  28840 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  28844 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  28848 */   // (bitconvert:{ *:[v2f64] } QPR:{ *:[v16i8] }:$src)  =>  (VREV64q8:{ *:[v2f64] } QPR:{ *:[v16i8] }:$src)
     /*  28848 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV64q8),
     /*  28851 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  28853 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  28855 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  28858 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  28864 */   GIR_RootConstrainSelectedInstOperands,
     /*  28865 */   // GIR_Coverage, 2841,
     /*  28865 */   GIR_EraseRootFromParent_Done,
     /*  28866 */ // Label 614: @28866
     /*  28866 */ GIM_Try, /*On fail goto*//*Label 615*/ GIMT_Encode4(28903), // Rule ID 2842 //
     /*  28871 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  28874 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  28877 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  28881 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  28885 */   // (bitconvert:{ *:[v2i64] } QPR:{ *:[v4f32] }:$src)  =>  (VREV64q32:{ *:[v2i64] } QPR:{ *:[v4f32] }:$src)
     /*  28885 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV64q32),
     /*  28888 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  28890 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  28892 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  28895 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  28901 */   GIR_RootConstrainSelectedInstOperands,
     /*  28902 */   // GIR_Coverage, 2842,
     /*  28902 */   GIR_EraseRootFromParent_Done,
     /*  28903 */ // Label 615: @28903
     /*  28903 */ GIM_Try, /*On fail goto*//*Label 616*/ GIMT_Encode4(28940), // Rule ID 2843 //
     /*  28908 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  28911 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  28914 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  28918 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  28922 */   // (bitconvert:{ *:[v2i64] } QPR:{ *:[v4i32] }:$src)  =>  (VREV64q32:{ *:[v2i64] } QPR:{ *:[v4i32] }:$src)
     /*  28922 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV64q32),
     /*  28925 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  28927 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  28929 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  28932 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  28938 */   GIR_RootConstrainSelectedInstOperands,
     /*  28939 */   // GIR_Coverage, 2843,
     /*  28939 */   GIR_EraseRootFromParent_Done,
     /*  28940 */ // Label 616: @28940
     /*  28940 */ GIM_Try, /*On fail goto*//*Label 617*/ GIMT_Encode4(28977), // Rule ID 2844 //
     /*  28945 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  28948 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  28951 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  28955 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  28959 */   // (bitconvert:{ *:[v2i64] } QPR:{ *:[v8f16] }:$src)  =>  (VREV64q16:{ *:[v2i64] } QPR:{ *:[v8f16] }:$src)
     /*  28959 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV64q16),
     /*  28962 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  28964 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  28966 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  28969 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  28975 */   GIR_RootConstrainSelectedInstOperands,
     /*  28976 */   // GIR_Coverage, 2844,
     /*  28976 */   GIR_EraseRootFromParent_Done,
     /*  28977 */ // Label 617: @28977
     /*  28977 */ GIM_Try, /*On fail goto*//*Label 618*/ GIMT_Encode4(29014), // Rule ID 2845 //
     /*  28982 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  28985 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  28988 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  28992 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  28996 */   // (bitconvert:{ *:[v2i64] } QPR:{ *:[v8i16] }:$src)  =>  (VREV64q16:{ *:[v2i64] } QPR:{ *:[v8i16] }:$src)
     /*  28996 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV64q16),
     /*  28999 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  29001 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  29003 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  29006 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  29012 */   GIR_RootConstrainSelectedInstOperands,
     /*  29013 */   // GIR_Coverage, 2845,
     /*  29013 */   GIR_EraseRootFromParent_Done,
     /*  29014 */ // Label 618: @29014
     /*  29014 */ GIM_Try, /*On fail goto*//*Label 619*/ GIMT_Encode4(29051), // Rule ID 2846 //
     /*  29019 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  29022 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  29025 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  29029 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  29033 */   // (bitconvert:{ *:[v2i64] } QPR:{ *:[v16i8] }:$src)  =>  (VREV64q8:{ *:[v2i64] } QPR:{ *:[v16i8] }:$src)
     /*  29033 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV64q8),
     /*  29036 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  29038 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  29040 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  29043 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  29049 */   GIR_RootConstrainSelectedInstOperands,
     /*  29050 */   // GIR_Coverage, 2846,
     /*  29050 */   GIR_EraseRootFromParent_Done,
     /*  29051 */ // Label 619: @29051
     /*  29051 */ GIM_Try, /*On fail goto*//*Label 620*/ GIMT_Encode4(29083), // Rule ID 5280 //
     /*  29056 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  29059 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  29062 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29066 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29070 */   // (bitconvert:{ *:[v2f64] } MQPR:{ *:[v2i64] }:$src)  =>  MQPR:{ *:[v2f64] }:$src
     /*  29070 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  29073 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  29075 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  29077 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29082 */   // GIR_Coverage, 5280,
     /*  29082 */   GIR_EraseRootFromParent_Done,
     /*  29083 */ // Label 620: @29083
     /*  29083 */ GIM_Try, /*On fail goto*//*Label 621*/ GIMT_Encode4(29115), // Rule ID 5281 //
     /*  29088 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  29091 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  29094 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29098 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29102 */   // (bitconvert:{ *:[v2i64] } MQPR:{ *:[v2f64] }:$src)  =>  MQPR:{ *:[v2i64] }:$src
     /*  29102 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  29105 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  29107 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  29109 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29114 */   // GIR_Coverage, 5281,
     /*  29114 */   GIR_EraseRootFromParent_Done,
     /*  29115 */ // Label 621: @29115
     /*  29115 */ GIM_Try, /*On fail goto*//*Label 622*/ GIMT_Encode4(29147), // Rule ID 5286 //
     /*  29120 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsLE),
     /*  29123 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  29126 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29130 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29134 */   // (bitconvert:{ *:[v2f64] } MQPR:{ *:[v4f32] }:$src)  =>  MQPR:{ *:[v2f64] }:$src
     /*  29134 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  29137 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  29139 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  29141 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29146 */   // GIR_Coverage, 5286,
     /*  29146 */   GIR_EraseRootFromParent_Done,
     /*  29147 */ // Label 622: @29147
     /*  29147 */ GIM_Try, /*On fail goto*//*Label 623*/ GIMT_Encode4(29179), // Rule ID 5287 //
     /*  29152 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsLE),
     /*  29155 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  29158 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29162 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29166 */   // (bitconvert:{ *:[v2f64] } MQPR:{ *:[v4i32] }:$src)  =>  MQPR:{ *:[v2f64] }:$src
     /*  29166 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  29169 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  29171 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  29173 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29178 */   // GIR_Coverage, 5287,
     /*  29178 */   GIR_EraseRootFromParent_Done,
     /*  29179 */ // Label 623: @29179
     /*  29179 */ GIM_Try, /*On fail goto*//*Label 624*/ GIMT_Encode4(29211), // Rule ID 5288 //
     /*  29184 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsLE),
     /*  29187 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  29190 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29194 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29198 */   // (bitconvert:{ *:[v2f64] } MQPR:{ *:[v8f16] }:$src)  =>  MQPR:{ *:[v2f64] }:$src
     /*  29198 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  29201 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  29203 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  29205 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29210 */   // GIR_Coverage, 5288,
     /*  29210 */   GIR_EraseRootFromParent_Done,
     /*  29211 */ // Label 624: @29211
     /*  29211 */ GIM_Try, /*On fail goto*//*Label 625*/ GIMT_Encode4(29243), // Rule ID 5289 //
     /*  29216 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsLE),
     /*  29219 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  29222 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29226 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29230 */   // (bitconvert:{ *:[v2f64] } MQPR:{ *:[v8i16] }:$src)  =>  MQPR:{ *:[v2f64] }:$src
     /*  29230 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  29233 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  29235 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  29237 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29242 */   // GIR_Coverage, 5289,
     /*  29242 */   GIR_EraseRootFromParent_Done,
     /*  29243 */ // Label 625: @29243
     /*  29243 */ GIM_Try, /*On fail goto*//*Label 626*/ GIMT_Encode4(29275), // Rule ID 5290 //
     /*  29248 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsLE),
     /*  29251 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  29254 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29258 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29262 */   // (bitconvert:{ *:[v2f64] } MQPR:{ *:[v16i8] }:$src)  =>  MQPR:{ *:[v2f64] }:$src
     /*  29262 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  29265 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  29267 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  29269 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29274 */   // GIR_Coverage, 5290,
     /*  29274 */   GIR_EraseRootFromParent_Done,
     /*  29275 */ // Label 626: @29275
     /*  29275 */ GIM_Try, /*On fail goto*//*Label 627*/ GIMT_Encode4(29307), // Rule ID 5291 //
     /*  29280 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsLE),
     /*  29283 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  29286 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29290 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29294 */   // (bitconvert:{ *:[v2i64] } MQPR:{ *:[v4f32] }:$src)  =>  MQPR:{ *:[v2i64] }:$src
     /*  29294 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  29297 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  29299 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  29301 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29306 */   // GIR_Coverage, 5291,
     /*  29306 */   GIR_EraseRootFromParent_Done,
     /*  29307 */ // Label 627: @29307
     /*  29307 */ GIM_Try, /*On fail goto*//*Label 628*/ GIMT_Encode4(29339), // Rule ID 5292 //
     /*  29312 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsLE),
     /*  29315 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  29318 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29322 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29326 */   // (bitconvert:{ *:[v2i64] } MQPR:{ *:[v4i32] }:$src)  =>  MQPR:{ *:[v2i64] }:$src
     /*  29326 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  29329 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  29331 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  29333 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29338 */   // GIR_Coverage, 5292,
     /*  29338 */   GIR_EraseRootFromParent_Done,
     /*  29339 */ // Label 628: @29339
     /*  29339 */ GIM_Try, /*On fail goto*//*Label 629*/ GIMT_Encode4(29371), // Rule ID 5293 //
     /*  29344 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsLE),
     /*  29347 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  29350 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29354 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29358 */   // (bitconvert:{ *:[v2i64] } MQPR:{ *:[v8f16] }:$src)  =>  MQPR:{ *:[v2i64] }:$src
     /*  29358 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  29361 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  29363 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  29365 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29370 */   // GIR_Coverage, 5293,
     /*  29370 */   GIR_EraseRootFromParent_Done,
     /*  29371 */ // Label 629: @29371
     /*  29371 */ GIM_Try, /*On fail goto*//*Label 630*/ GIMT_Encode4(29403), // Rule ID 5294 //
     /*  29376 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsLE),
     /*  29379 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  29382 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29386 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29390 */   // (bitconvert:{ *:[v2i64] } MQPR:{ *:[v8i16] }:$src)  =>  MQPR:{ *:[v2i64] }:$src
     /*  29390 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  29393 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  29395 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  29397 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29402 */   // GIR_Coverage, 5294,
     /*  29402 */   GIR_EraseRootFromParent_Done,
     /*  29403 */ // Label 630: @29403
     /*  29403 */ GIM_Try, /*On fail goto*//*Label 631*/ GIMT_Encode4(29435), // Rule ID 5295 //
     /*  29408 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsLE),
     /*  29411 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  29414 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29418 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29422 */   // (bitconvert:{ *:[v2i64] } MQPR:{ *:[v16i8] }:$src)  =>  MQPR:{ *:[v2i64] }:$src
     /*  29422 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  29425 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  29427 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  29429 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29434 */   // GIR_Coverage, 5295,
     /*  29434 */   GIR_EraseRootFromParent_Done,
     /*  29435 */ // Label 631: @29435
     /*  29435 */ GIM_Try, /*On fail goto*//*Label 632*/ GIMT_Encode4(29493), // Rule ID 5322 //
     /*  29440 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsBE),
     /*  29443 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  29446 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29450 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29454 */   // (bitconvert:{ *:[v2f64] } MQPR:{ *:[v4f32] }:$src)  =>  (MVE_VREV64_32:{ *:[v2f64] } MQPR:{ *:[v4f32] }:$src)
     /*  29454 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  29457 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  29461 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  29466 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VREV64_32),
     /*  29469 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  29471 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  29473 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  29476 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  29482 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  29488 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  29491 */   GIR_RootConstrainSelectedInstOperands,
     /*  29492 */   // GIR_Coverage, 5322,
     /*  29492 */   GIR_EraseRootFromParent_Done,
     /*  29493 */ // Label 632: @29493
     /*  29493 */ GIM_Try, /*On fail goto*//*Label 633*/ GIMT_Encode4(29551), // Rule ID 5323 //
     /*  29498 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsBE),
     /*  29501 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  29504 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29508 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29512 */   // (bitconvert:{ *:[v2f64] } MQPR:{ *:[v4i32] }:$src)  =>  (MVE_VREV64_32:{ *:[v2f64] } MQPR:{ *:[v4i32] }:$src)
     /*  29512 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  29515 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  29519 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  29524 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VREV64_32),
     /*  29527 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  29529 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  29531 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  29534 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  29540 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  29546 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  29549 */   GIR_RootConstrainSelectedInstOperands,
     /*  29550 */   // GIR_Coverage, 5323,
     /*  29550 */   GIR_EraseRootFromParent_Done,
     /*  29551 */ // Label 633: @29551
     /*  29551 */ GIM_Try, /*On fail goto*//*Label 634*/ GIMT_Encode4(29609), // Rule ID 5324 //
     /*  29556 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsBE),
     /*  29559 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  29562 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29566 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29570 */   // (bitconvert:{ *:[v2f64] } MQPR:{ *:[v8f16] }:$src)  =>  (MVE_VREV64_16:{ *:[v2f64] } MQPR:{ *:[v8f16] }:$src)
     /*  29570 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  29573 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  29577 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  29582 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VREV64_16),
     /*  29585 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  29587 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  29589 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  29592 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  29598 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  29604 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  29607 */   GIR_RootConstrainSelectedInstOperands,
     /*  29608 */   // GIR_Coverage, 5324,
     /*  29608 */   GIR_EraseRootFromParent_Done,
     /*  29609 */ // Label 634: @29609
     /*  29609 */ GIM_Try, /*On fail goto*//*Label 635*/ GIMT_Encode4(29667), // Rule ID 5325 //
     /*  29614 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsBE),
     /*  29617 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  29620 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29624 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29628 */   // (bitconvert:{ *:[v2f64] } MQPR:{ *:[v8i16] }:$src)  =>  (MVE_VREV64_16:{ *:[v2f64] } MQPR:{ *:[v8i16] }:$src)
     /*  29628 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  29631 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  29635 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  29640 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VREV64_16),
     /*  29643 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  29645 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  29647 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  29650 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  29656 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  29662 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  29665 */   GIR_RootConstrainSelectedInstOperands,
     /*  29666 */   // GIR_Coverage, 5325,
     /*  29666 */   GIR_EraseRootFromParent_Done,
     /*  29667 */ // Label 635: @29667
     /*  29667 */ GIM_Try, /*On fail goto*//*Label 636*/ GIMT_Encode4(29725), // Rule ID 5326 //
     /*  29672 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsBE),
     /*  29675 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  29678 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29682 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29686 */   // (bitconvert:{ *:[v2f64] } MQPR:{ *:[v16i8] }:$src)  =>  (MVE_VREV64_8:{ *:[v2f64] } MQPR:{ *:[v16i8] }:$src)
     /*  29686 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  29689 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  29693 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  29698 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VREV64_8),
     /*  29701 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  29703 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  29705 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  29708 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  29714 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  29720 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  29723 */   GIR_RootConstrainSelectedInstOperands,
     /*  29724 */   // GIR_Coverage, 5326,
     /*  29724 */   GIR_EraseRootFromParent_Done,
     /*  29725 */ // Label 636: @29725
     /*  29725 */ GIM_Try, /*On fail goto*//*Label 637*/ GIMT_Encode4(29783), // Rule ID 5327 //
     /*  29730 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsBE),
     /*  29733 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  29736 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29740 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29744 */   // (bitconvert:{ *:[v2i64] } MQPR:{ *:[v4f32] }:$src)  =>  (MVE_VREV64_32:{ *:[v2i64] } MQPR:{ *:[v4f32] }:$src)
     /*  29744 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  29747 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  29751 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  29756 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VREV64_32),
     /*  29759 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  29761 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  29763 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  29766 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  29772 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  29778 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  29781 */   GIR_RootConstrainSelectedInstOperands,
     /*  29782 */   // GIR_Coverage, 5327,
     /*  29782 */   GIR_EraseRootFromParent_Done,
     /*  29783 */ // Label 637: @29783
     /*  29783 */ GIM_Try, /*On fail goto*//*Label 638*/ GIMT_Encode4(29841), // Rule ID 5328 //
     /*  29788 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsBE),
     /*  29791 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  29794 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29798 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29802 */   // (bitconvert:{ *:[v2i64] } MQPR:{ *:[v4i32] }:$src)  =>  (MVE_VREV64_32:{ *:[v2i64] } MQPR:{ *:[v4i32] }:$src)
     /*  29802 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  29805 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  29809 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  29814 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VREV64_32),
     /*  29817 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  29819 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  29821 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  29824 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  29830 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  29836 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  29839 */   GIR_RootConstrainSelectedInstOperands,
     /*  29840 */   // GIR_Coverage, 5328,
     /*  29840 */   GIR_EraseRootFromParent_Done,
     /*  29841 */ // Label 638: @29841
     /*  29841 */ GIM_Try, /*On fail goto*//*Label 639*/ GIMT_Encode4(29899), // Rule ID 5329 //
     /*  29846 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsBE),
     /*  29849 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  29852 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29856 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29860 */   // (bitconvert:{ *:[v2i64] } MQPR:{ *:[v8f16] }:$src)  =>  (MVE_VREV64_16:{ *:[v2i64] } MQPR:{ *:[v8f16] }:$src)
     /*  29860 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  29863 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  29867 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  29872 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VREV64_16),
     /*  29875 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  29877 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  29879 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  29882 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  29888 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  29894 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  29897 */   GIR_RootConstrainSelectedInstOperands,
     /*  29898 */   // GIR_Coverage, 5329,
     /*  29898 */   GIR_EraseRootFromParent_Done,
     /*  29899 */ // Label 639: @29899
     /*  29899 */ GIM_Try, /*On fail goto*//*Label 640*/ GIMT_Encode4(29957), // Rule ID 5330 //
     /*  29904 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsBE),
     /*  29907 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  29910 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29914 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29918 */   // (bitconvert:{ *:[v2i64] } MQPR:{ *:[v8i16] }:$src)  =>  (MVE_VREV64_16:{ *:[v2i64] } MQPR:{ *:[v8i16] }:$src)
     /*  29918 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  29921 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  29925 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  29930 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VREV64_16),
     /*  29933 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  29935 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  29937 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  29940 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  29946 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  29952 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  29955 */   GIR_RootConstrainSelectedInstOperands,
     /*  29956 */   // GIR_Coverage, 5330,
     /*  29956 */   GIR_EraseRootFromParent_Done,
     /*  29957 */ // Label 640: @29957
     /*  29957 */ GIM_Try, /*On fail goto*//*Label 641*/ GIMT_Encode4(30015), // Rule ID 5331 //
     /*  29962 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsBE),
     /*  29965 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  29968 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29972 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29976 */   // (bitconvert:{ *:[v2i64] } MQPR:{ *:[v16i8] }:$src)  =>  (MVE_VREV64_8:{ *:[v2i64] } MQPR:{ *:[v16i8] }:$src)
     /*  29976 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  29979 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  29983 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  29988 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VREV64_8),
     /*  29991 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  29993 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  29995 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  29998 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  30004 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  30010 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  30013 */   GIR_RootConstrainSelectedInstOperands,
     /*  30014 */   // GIR_Coverage, 5331,
     /*  30014 */   GIR_EraseRootFromParent_Done,
     /*  30015 */ // Label 641: @30015
     /*  30015 */ GIM_Reject,
     /*  30016 */ // Label 544: @30016
     /*  30016 */ GIM_Try, /*On fail goto*//*Label 642*/ GIMT_Encode4(30048), // Rule ID 2721 //
     /*  30021 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  30024 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  30027 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  30031 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  30035 */   // (bitconvert:{ *:[v4i16] } DPR:{ *:[v4f16] }:$src)  =>  DPR:{ *:[v4i16] }:$src
     /*  30035 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  30038 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  30040 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  30042 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::DPRRegClassID),
     /*  30047 */   // GIR_Coverage, 2721,
     /*  30047 */   GIR_EraseRootFromParent_Done,
     /*  30048 */ // Label 642: @30048
     /*  30048 */ GIM_Try, /*On fail goto*//*Label 643*/ GIMT_Encode4(30080), // Rule ID 2722 //
     /*  30053 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  30056 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  30059 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  30063 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  30067 */   // (bitconvert:{ *:[v4f16] } DPR:{ *:[v4i16] }:$src)  =>  DPR:{ *:[v4f16] }:$src
     /*  30067 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  30070 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  30072 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  30074 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::DPRRegClassID),
     /*  30079 */   // GIR_Coverage, 2722,
     /*  30079 */   GIR_EraseRootFromParent_Done,
     /*  30080 */ // Label 643: @30080
     /*  30080 */ GIM_Try, /*On fail goto*//*Label 644*/ GIMT_Encode4(30112), // Rule ID 2749 //
     /*  30085 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  30088 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  30091 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  30095 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  30099 */   // (bitconvert:{ *:[v4f16] } DPR:{ *:[f64] }:$src)  =>  DPR:{ *:[v4f16] }:$src
     /*  30099 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  30102 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  30104 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  30106 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::DPRRegClassID),
     /*  30111 */   // GIR_Coverage, 2749,
     /*  30111 */   GIR_EraseRootFromParent_Done,
     /*  30112 */ // Label 644: @30112
     /*  30112 */ GIM_Try, /*On fail goto*//*Label 645*/ GIMT_Encode4(30144), // Rule ID 2750 //
     /*  30117 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  30120 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  30123 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  30127 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  30131 */   // (bitconvert:{ *:[v4f16] } DPR:{ *:[v1i64] }:$src)  =>  DPR:{ *:[v4f16] }:$src
     /*  30131 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  30134 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  30136 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  30138 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::DPRRegClassID),
     /*  30143 */   // GIR_Coverage, 2750,
     /*  30143 */   GIR_EraseRootFromParent_Done,
     /*  30144 */ // Label 645: @30144
     /*  30144 */ GIM_Try, /*On fail goto*//*Label 646*/ GIMT_Encode4(30176), // Rule ID 2751 //
     /*  30149 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  30152 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  30155 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  30159 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  30163 */   // (bitconvert:{ *:[v4f16] } DPR:{ *:[v2f32] }:$src)  =>  DPR:{ *:[v4f16] }:$src
     /*  30163 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  30166 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  30168 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  30170 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::DPRRegClassID),
     /*  30175 */   // GIR_Coverage, 2751,
     /*  30175 */   GIR_EraseRootFromParent_Done,
     /*  30176 */ // Label 646: @30176
     /*  30176 */ GIM_Try, /*On fail goto*//*Label 647*/ GIMT_Encode4(30208), // Rule ID 2752 //
     /*  30181 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  30184 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  30187 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  30191 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  30195 */   // (bitconvert:{ *:[v4f16] } DPR:{ *:[v2i32] }:$src)  =>  DPR:{ *:[v4f16] }:$src
     /*  30195 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  30198 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  30200 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  30202 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::DPRRegClassID),
     /*  30207 */   // GIR_Coverage, 2752,
     /*  30207 */   GIR_EraseRootFromParent_Done,
     /*  30208 */ // Label 647: @30208
     /*  30208 */ GIM_Try, /*On fail goto*//*Label 648*/ GIMT_Encode4(30240), // Rule ID 2753 //
     /*  30213 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  30216 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  30219 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  30223 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  30227 */   // (bitconvert:{ *:[v4f16] } DPR:{ *:[v8i8] }:$src)  =>  DPR:{ *:[v4f16] }:$src
     /*  30227 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  30230 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  30232 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  30234 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::DPRRegClassID),
     /*  30239 */   // GIR_Coverage, 2753,
     /*  30239 */   GIR_EraseRootFromParent_Done,
     /*  30240 */ // Label 648: @30240
     /*  30240 */ GIM_Try, /*On fail goto*//*Label 649*/ GIMT_Encode4(30272), // Rule ID 2754 //
     /*  30245 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  30248 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  30251 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  30255 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  30259 */   // (bitconvert:{ *:[v4i16] } DPR:{ *:[f64] }:$src)  =>  DPR:{ *:[v4i16] }:$src
     /*  30259 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  30262 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  30264 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  30266 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::DPRRegClassID),
     /*  30271 */   // GIR_Coverage, 2754,
     /*  30271 */   GIR_EraseRootFromParent_Done,
     /*  30272 */ // Label 649: @30272
     /*  30272 */ GIM_Try, /*On fail goto*//*Label 650*/ GIMT_Encode4(30304), // Rule ID 2755 //
     /*  30277 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  30280 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  30283 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  30287 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  30291 */   // (bitconvert:{ *:[v4i16] } DPR:{ *:[v1i64] }:$src)  =>  DPR:{ *:[v4i16] }:$src
     /*  30291 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  30294 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  30296 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  30298 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::DPRRegClassID),
     /*  30303 */   // GIR_Coverage, 2755,
     /*  30303 */   GIR_EraseRootFromParent_Done,
     /*  30304 */ // Label 650: @30304
     /*  30304 */ GIM_Try, /*On fail goto*//*Label 651*/ GIMT_Encode4(30336), // Rule ID 2756 //
     /*  30309 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  30312 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  30315 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  30319 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  30323 */   // (bitconvert:{ *:[v4i16] } DPR:{ *:[v2f32] }:$src)  =>  DPR:{ *:[v4i16] }:$src
     /*  30323 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  30326 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  30328 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  30330 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::DPRRegClassID),
     /*  30335 */   // GIR_Coverage, 2756,
     /*  30335 */   GIR_EraseRootFromParent_Done,
     /*  30336 */ // Label 651: @30336
     /*  30336 */ GIM_Try, /*On fail goto*//*Label 652*/ GIMT_Encode4(30368), // Rule ID 2757 //
     /*  30341 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  30344 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  30347 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  30351 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  30355 */   // (bitconvert:{ *:[v4i16] } DPR:{ *:[v2i32] }:$src)  =>  DPR:{ *:[v4i16] }:$src
     /*  30355 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  30358 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  30360 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  30362 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::DPRRegClassID),
     /*  30367 */   // GIR_Coverage, 2757,
     /*  30367 */   GIR_EraseRootFromParent_Done,
     /*  30368 */ // Label 652: @30368
     /*  30368 */ GIM_Try, /*On fail goto*//*Label 653*/ GIMT_Encode4(30400), // Rule ID 2758 //
     /*  30373 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  30376 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  30379 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  30383 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  30387 */   // (bitconvert:{ *:[v4i16] } DPR:{ *:[v8i8] }:$src)  =>  DPR:{ *:[v4i16] }:$src
     /*  30387 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  30390 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  30392 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  30394 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::DPRRegClassID),
     /*  30399 */   // GIR_Coverage, 2758,
     /*  30399 */   GIR_EraseRootFromParent_Done,
     /*  30400 */ // Label 653: @30400
     /*  30400 */ GIM_Try, /*On fail goto*//*Label 654*/ GIMT_Encode4(30437), // Rule ID 2821 //
     /*  30405 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  30408 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  30411 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  30415 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  30419 */   // (bitconvert:{ *:[v4f16] } DPR:{ *:[f64] }:$src)  =>  (VREV64d16:{ *:[v4f16] } DPR:{ *:[f64] }:$src)
     /*  30419 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV64d16),
     /*  30422 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  30424 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  30426 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  30429 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  30435 */   GIR_RootConstrainSelectedInstOperands,
     /*  30436 */   // GIR_Coverage, 2821,
     /*  30436 */   GIR_EraseRootFromParent_Done,
     /*  30437 */ // Label 654: @30437
     /*  30437 */ GIM_Try, /*On fail goto*//*Label 655*/ GIMT_Encode4(30474), // Rule ID 2822 //
     /*  30442 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  30445 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  30448 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  30452 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  30456 */   // (bitconvert:{ *:[v4f16] } DPR:{ *:[v1i64] }:$src)  =>  (VREV64d16:{ *:[v4f16] } DPR:{ *:[v1i64] }:$src)
     /*  30456 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV64d16),
     /*  30459 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  30461 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  30463 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  30466 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  30472 */   GIR_RootConstrainSelectedInstOperands,
     /*  30473 */   // GIR_Coverage, 2822,
     /*  30473 */   GIR_EraseRootFromParent_Done,
     /*  30474 */ // Label 655: @30474
     /*  30474 */ GIM_Try, /*On fail goto*//*Label 656*/ GIMT_Encode4(30511), // Rule ID 2823 //
     /*  30479 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  30482 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  30485 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  30489 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  30493 */   // (bitconvert:{ *:[v4f16] } DPR:{ *:[v2f32] }:$src)  =>  (VREV32d16:{ *:[v4f16] } DPR:{ *:[v2f32] }:$src)
     /*  30493 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV32d16),
     /*  30496 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  30498 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  30500 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  30503 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  30509 */   GIR_RootConstrainSelectedInstOperands,
     /*  30510 */   // GIR_Coverage, 2823,
     /*  30510 */   GIR_EraseRootFromParent_Done,
     /*  30511 */ // Label 656: @30511
     /*  30511 */ GIM_Try, /*On fail goto*//*Label 657*/ GIMT_Encode4(30548), // Rule ID 2824 //
     /*  30516 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  30519 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  30522 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  30526 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  30530 */   // (bitconvert:{ *:[v4f16] } DPR:{ *:[v2i32] }:$src)  =>  (VREV32d16:{ *:[v4f16] } DPR:{ *:[v2i32] }:$src)
     /*  30530 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV32d16),
     /*  30533 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  30535 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  30537 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  30540 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  30546 */   GIR_RootConstrainSelectedInstOperands,
     /*  30547 */   // GIR_Coverage, 2824,
     /*  30547 */   GIR_EraseRootFromParent_Done,
     /*  30548 */ // Label 657: @30548
     /*  30548 */ GIM_Try, /*On fail goto*//*Label 658*/ GIMT_Encode4(30585), // Rule ID 2825 //
     /*  30553 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  30556 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  30559 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  30563 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  30567 */   // (bitconvert:{ *:[v4f16] } DPR:{ *:[v8i8] }:$src)  =>  (VREV16d8:{ *:[v4f16] } DPR:{ *:[v8i8] }:$src)
     /*  30567 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV16d8),
     /*  30570 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  30572 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  30574 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  30577 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  30583 */   GIR_RootConstrainSelectedInstOperands,
     /*  30584 */   // GIR_Coverage, 2825,
     /*  30584 */   GIR_EraseRootFromParent_Done,
     /*  30585 */ // Label 658: @30585
     /*  30585 */ GIM_Try, /*On fail goto*//*Label 659*/ GIMT_Encode4(30622), // Rule ID 2826 //
     /*  30590 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  30593 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  30596 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  30600 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  30604 */   // (bitconvert:{ *:[v4i16] } DPR:{ *:[f64] }:$src)  =>  (VREV64d16:{ *:[v4i16] } DPR:{ *:[f64] }:$src)
     /*  30604 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV64d16),
     /*  30607 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  30609 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  30611 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  30614 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  30620 */   GIR_RootConstrainSelectedInstOperands,
     /*  30621 */   // GIR_Coverage, 2826,
     /*  30621 */   GIR_EraseRootFromParent_Done,
     /*  30622 */ // Label 659: @30622
     /*  30622 */ GIM_Try, /*On fail goto*//*Label 660*/ GIMT_Encode4(30659), // Rule ID 2827 //
     /*  30627 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  30630 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  30633 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  30637 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  30641 */   // (bitconvert:{ *:[v4i16] } DPR:{ *:[v1i64] }:$src)  =>  (VREV64d16:{ *:[v4i16] } DPR:{ *:[v1i64] }:$src)
     /*  30641 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV64d16),
     /*  30644 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  30646 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  30648 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  30651 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  30657 */   GIR_RootConstrainSelectedInstOperands,
     /*  30658 */   // GIR_Coverage, 2827,
     /*  30658 */   GIR_EraseRootFromParent_Done,
     /*  30659 */ // Label 660: @30659
     /*  30659 */ GIM_Try, /*On fail goto*//*Label 661*/ GIMT_Encode4(30696), // Rule ID 2828 //
     /*  30664 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  30667 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  30670 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  30674 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  30678 */   // (bitconvert:{ *:[v4i16] } DPR:{ *:[v2f32] }:$src)  =>  (VREV32d16:{ *:[v4i16] } DPR:{ *:[v2f32] }:$src)
     /*  30678 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV32d16),
     /*  30681 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  30683 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  30685 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  30688 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  30694 */   GIR_RootConstrainSelectedInstOperands,
     /*  30695 */   // GIR_Coverage, 2828,
     /*  30695 */   GIR_EraseRootFromParent_Done,
     /*  30696 */ // Label 661: @30696
     /*  30696 */ GIM_Try, /*On fail goto*//*Label 662*/ GIMT_Encode4(30733), // Rule ID 2829 //
     /*  30701 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  30704 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  30707 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  30711 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  30715 */   // (bitconvert:{ *:[v4i16] } DPR:{ *:[v2i32] }:$src)  =>  (VREV32d16:{ *:[v4i16] } DPR:{ *:[v2i32] }:$src)
     /*  30715 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV32d16),
     /*  30718 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  30720 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  30722 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  30725 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  30731 */   GIR_RootConstrainSelectedInstOperands,
     /*  30732 */   // GIR_Coverage, 2829,
     /*  30732 */   GIR_EraseRootFromParent_Done,
     /*  30733 */ // Label 662: @30733
     /*  30733 */ GIM_Try, /*On fail goto*//*Label 663*/ GIMT_Encode4(30770), // Rule ID 2830 //
     /*  30738 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  30741 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  30744 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  30748 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  30752 */   // (bitconvert:{ *:[v4i16] } DPR:{ *:[v8i8] }:$src)  =>  (VREV16d8:{ *:[v4i16] } DPR:{ *:[v8i8] }:$src)
     /*  30752 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV16d8),
     /*  30755 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  30757 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  30759 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  30762 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  30768 */   GIR_RootConstrainSelectedInstOperands,
     /*  30769 */   // GIR_Coverage, 2830,
     /*  30769 */   GIR_EraseRootFromParent_Done,
     /*  30770 */ // Label 663: @30770
     /*  30770 */ GIM_Reject,
     /*  30771 */ // Label 545: @30771
     /*  30771 */ GIM_Try, /*On fail goto*//*Label 664*/ GIMT_Encode4(30803), // Rule ID 2725 //
     /*  30776 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  30779 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  30782 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  30786 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  30790 */   // (bitconvert:{ *:[v4i32] } QPR:{ *:[v4f32] }:$src)  =>  QPR:{ *:[v4i32] }:$src
     /*  30790 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  30793 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  30795 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  30797 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  30802 */   // GIR_Coverage, 2725,
     /*  30802 */   GIR_EraseRootFromParent_Done,
     /*  30803 */ // Label 664: @30803
     /*  30803 */ GIM_Try, /*On fail goto*//*Label 665*/ GIMT_Encode4(30835), // Rule ID 2726 //
     /*  30808 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  30811 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  30814 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  30818 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  30822 */   // (bitconvert:{ *:[v4f32] } QPR:{ *:[v4i32] }:$src)  =>  QPR:{ *:[v4f32] }:$src
     /*  30822 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  30825 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  30827 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  30829 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  30834 */   // GIR_Coverage, 2726,
     /*  30834 */   GIR_EraseRootFromParent_Done,
     /*  30835 */ // Label 665: @30835
     /*  30835 */ GIM_Try, /*On fail goto*//*Label 666*/ GIMT_Encode4(30867), // Rule ID 2775 //
     /*  30840 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  30843 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  30846 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  30850 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  30854 */   // (bitconvert:{ *:[v4f32] } QPR:{ *:[v2f64] }:$src)  =>  QPR:{ *:[v4f32] }:$src
     /*  30854 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  30857 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  30859 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  30861 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  30866 */   // GIR_Coverage, 2775,
     /*  30866 */   GIR_EraseRootFromParent_Done,
     /*  30867 */ // Label 666: @30867
     /*  30867 */ GIM_Try, /*On fail goto*//*Label 667*/ GIMT_Encode4(30899), // Rule ID 2776 //
     /*  30872 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  30875 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  30878 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  30882 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  30886 */   // (bitconvert:{ *:[v4f32] } QPR:{ *:[v2i64] }:$src)  =>  QPR:{ *:[v4f32] }:$src
     /*  30886 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  30889 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  30891 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  30893 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  30898 */   // GIR_Coverage, 2776,
     /*  30898 */   GIR_EraseRootFromParent_Done,
     /*  30899 */ // Label 667: @30899
     /*  30899 */ GIM_Try, /*On fail goto*//*Label 668*/ GIMT_Encode4(30931), // Rule ID 2777 //
     /*  30904 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  30907 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  30910 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  30914 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  30918 */   // (bitconvert:{ *:[v4f32] } QPR:{ *:[v8f16] }:$src)  =>  QPR:{ *:[v4f32] }:$src
     /*  30918 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  30921 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  30923 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  30925 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  30930 */   // GIR_Coverage, 2777,
     /*  30930 */   GIR_EraseRootFromParent_Done,
     /*  30931 */ // Label 668: @30931
     /*  30931 */ GIM_Try, /*On fail goto*//*Label 669*/ GIMT_Encode4(30963), // Rule ID 2778 //
     /*  30936 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  30939 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  30942 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  30946 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  30950 */   // (bitconvert:{ *:[v4f32] } QPR:{ *:[v8i16] }:$src)  =>  QPR:{ *:[v4f32] }:$src
     /*  30950 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  30953 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  30955 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  30957 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  30962 */   // GIR_Coverage, 2778,
     /*  30962 */   GIR_EraseRootFromParent_Done,
     /*  30963 */ // Label 669: @30963
     /*  30963 */ GIM_Try, /*On fail goto*//*Label 670*/ GIMT_Encode4(30995), // Rule ID 2779 //
     /*  30968 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  30971 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  30974 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  30978 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  30982 */   // (bitconvert:{ *:[v4f32] } QPR:{ *:[v16i8] }:$src)  =>  QPR:{ *:[v4f32] }:$src
     /*  30982 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  30985 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  30987 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  30989 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  30994 */   // GIR_Coverage, 2779,
     /*  30994 */   GIR_EraseRootFromParent_Done,
     /*  30995 */ // Label 670: @30995
     /*  30995 */ GIM_Try, /*On fail goto*//*Label 671*/ GIMT_Encode4(31027), // Rule ID 2780 //
     /*  31000 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  31003 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  31006 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  31010 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  31014 */   // (bitconvert:{ *:[v4i32] } QPR:{ *:[v2f64] }:$src)  =>  QPR:{ *:[v4i32] }:$src
     /*  31014 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  31017 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  31019 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  31021 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  31026 */   // GIR_Coverage, 2780,
     /*  31026 */   GIR_EraseRootFromParent_Done,
     /*  31027 */ // Label 671: @31027
     /*  31027 */ GIM_Try, /*On fail goto*//*Label 672*/ GIMT_Encode4(31059), // Rule ID 2781 //
     /*  31032 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  31035 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  31038 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  31042 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  31046 */   // (bitconvert:{ *:[v4i32] } QPR:{ *:[v2i64] }:$src)  =>  QPR:{ *:[v4i32] }:$src
     /*  31046 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  31049 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  31051 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  31053 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  31058 */   // GIR_Coverage, 2781,
     /*  31058 */   GIR_EraseRootFromParent_Done,
     /*  31059 */ // Label 672: @31059
     /*  31059 */ GIM_Try, /*On fail goto*//*Label 673*/ GIMT_Encode4(31091), // Rule ID 2782 //
     /*  31064 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  31067 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  31070 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  31074 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  31078 */   // (bitconvert:{ *:[v4i32] } QPR:{ *:[v8f16] }:$src)  =>  QPR:{ *:[v4i32] }:$src
     /*  31078 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  31081 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  31083 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  31085 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  31090 */   // GIR_Coverage, 2782,
     /*  31090 */   GIR_EraseRootFromParent_Done,
     /*  31091 */ // Label 673: @31091
     /*  31091 */ GIM_Try, /*On fail goto*//*Label 674*/ GIMT_Encode4(31123), // Rule ID 2783 //
     /*  31096 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  31099 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  31102 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  31106 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  31110 */   // (bitconvert:{ *:[v4i32] } QPR:{ *:[v8i16] }:$src)  =>  QPR:{ *:[v4i32] }:$src
     /*  31110 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  31113 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  31115 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  31117 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  31122 */   // GIR_Coverage, 2783,
     /*  31122 */   GIR_EraseRootFromParent_Done,
     /*  31123 */ // Label 674: @31123
     /*  31123 */ GIM_Try, /*On fail goto*//*Label 675*/ GIMT_Encode4(31155), // Rule ID 2784 //
     /*  31128 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  31131 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  31134 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  31138 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  31142 */   // (bitconvert:{ *:[v4i32] } QPR:{ *:[v16i8] }:$src)  =>  QPR:{ *:[v4i32] }:$src
     /*  31142 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  31145 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  31147 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  31149 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  31154 */   // GIR_Coverage, 2784,
     /*  31154 */   GIR_EraseRootFromParent_Done,
     /*  31155 */ // Label 675: @31155
     /*  31155 */ GIM_Try, /*On fail goto*//*Label 676*/ GIMT_Encode4(31192), // Rule ID 2847 //
     /*  31160 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  31163 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  31166 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  31170 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  31174 */   // (bitconvert:{ *:[v4f32] } QPR:{ *:[v2f64] }:$src)  =>  (VREV64q32:{ *:[v4f32] } QPR:{ *:[v2f64] }:$src)
     /*  31174 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV64q32),
     /*  31177 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  31179 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  31181 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  31184 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  31190 */   GIR_RootConstrainSelectedInstOperands,
     /*  31191 */   // GIR_Coverage, 2847,
     /*  31191 */   GIR_EraseRootFromParent_Done,
     /*  31192 */ // Label 676: @31192
     /*  31192 */ GIM_Try, /*On fail goto*//*Label 677*/ GIMT_Encode4(31229), // Rule ID 2848 //
     /*  31197 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  31200 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  31203 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  31207 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  31211 */   // (bitconvert:{ *:[v4f32] } QPR:{ *:[v2i64] }:$src)  =>  (VREV64q32:{ *:[v4f32] } QPR:{ *:[v2i64] }:$src)
     /*  31211 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV64q32),
     /*  31214 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  31216 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  31218 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  31221 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  31227 */   GIR_RootConstrainSelectedInstOperands,
     /*  31228 */   // GIR_Coverage, 2848,
     /*  31228 */   GIR_EraseRootFromParent_Done,
     /*  31229 */ // Label 677: @31229
     /*  31229 */ GIM_Try, /*On fail goto*//*Label 678*/ GIMT_Encode4(31266), // Rule ID 2849 //
     /*  31234 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  31237 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  31240 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  31244 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  31248 */   // (bitconvert:{ *:[v4f32] } QPR:{ *:[v8f16] }:$src)  =>  (VREV32q16:{ *:[v4f32] } QPR:{ *:[v8f16] }:$src)
     /*  31248 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV32q16),
     /*  31251 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  31253 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  31255 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  31258 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  31264 */   GIR_RootConstrainSelectedInstOperands,
     /*  31265 */   // GIR_Coverage, 2849,
     /*  31265 */   GIR_EraseRootFromParent_Done,
     /*  31266 */ // Label 678: @31266
     /*  31266 */ GIM_Try, /*On fail goto*//*Label 679*/ GIMT_Encode4(31303), // Rule ID 2850 //
     /*  31271 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  31274 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  31277 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  31281 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  31285 */   // (bitconvert:{ *:[v4f32] } QPR:{ *:[v8i16] }:$src)  =>  (VREV32q16:{ *:[v4f32] } QPR:{ *:[v8i16] }:$src)
     /*  31285 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV32q16),
     /*  31288 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  31290 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  31292 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  31295 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  31301 */   GIR_RootConstrainSelectedInstOperands,
     /*  31302 */   // GIR_Coverage, 2850,
     /*  31302 */   GIR_EraseRootFromParent_Done,
     /*  31303 */ // Label 679: @31303
     /*  31303 */ GIM_Try, /*On fail goto*//*Label 680*/ GIMT_Encode4(31340), // Rule ID 2851 //
     /*  31308 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  31311 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  31314 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  31318 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  31322 */   // (bitconvert:{ *:[v4f32] } QPR:{ *:[v16i8] }:$src)  =>  (VREV32q8:{ *:[v4f32] } QPR:{ *:[v16i8] }:$src)
     /*  31322 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV32q8),
     /*  31325 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  31327 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  31329 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  31332 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  31338 */   GIR_RootConstrainSelectedInstOperands,
     /*  31339 */   // GIR_Coverage, 2851,
     /*  31339 */   GIR_EraseRootFromParent_Done,
     /*  31340 */ // Label 680: @31340
     /*  31340 */ GIM_Try, /*On fail goto*//*Label 681*/ GIMT_Encode4(31377), // Rule ID 2852 //
     /*  31345 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  31348 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  31351 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  31355 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  31359 */   // (bitconvert:{ *:[v4i32] } QPR:{ *:[v2f64] }:$src)  =>  (VREV64q32:{ *:[v4i32] } QPR:{ *:[v2f64] }:$src)
     /*  31359 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV64q32),
     /*  31362 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  31364 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  31366 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  31369 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  31375 */   GIR_RootConstrainSelectedInstOperands,
     /*  31376 */   // GIR_Coverage, 2852,
     /*  31376 */   GIR_EraseRootFromParent_Done,
     /*  31377 */ // Label 681: @31377
     /*  31377 */ GIM_Try, /*On fail goto*//*Label 682*/ GIMT_Encode4(31414), // Rule ID 2853 //
     /*  31382 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  31385 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  31388 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  31392 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  31396 */   // (bitconvert:{ *:[v4i32] } QPR:{ *:[v2i64] }:$src)  =>  (VREV64q32:{ *:[v4i32] } QPR:{ *:[v2i64] }:$src)
     /*  31396 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV64q32),
     /*  31399 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  31401 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  31403 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  31406 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  31412 */   GIR_RootConstrainSelectedInstOperands,
     /*  31413 */   // GIR_Coverage, 2853,
     /*  31413 */   GIR_EraseRootFromParent_Done,
     /*  31414 */ // Label 682: @31414
     /*  31414 */ GIM_Try, /*On fail goto*//*Label 683*/ GIMT_Encode4(31451), // Rule ID 2854 //
     /*  31419 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  31422 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  31425 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  31429 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  31433 */   // (bitconvert:{ *:[v4i32] } QPR:{ *:[v8f16] }:$src)  =>  (VREV32q16:{ *:[v4i32] } QPR:{ *:[v8f16] }:$src)
     /*  31433 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV32q16),
     /*  31436 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  31438 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  31440 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  31443 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  31449 */   GIR_RootConstrainSelectedInstOperands,
     /*  31450 */   // GIR_Coverage, 2854,
     /*  31450 */   GIR_EraseRootFromParent_Done,
     /*  31451 */ // Label 683: @31451
     /*  31451 */ GIM_Try, /*On fail goto*//*Label 684*/ GIMT_Encode4(31488), // Rule ID 2855 //
     /*  31456 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  31459 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  31462 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  31466 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  31470 */   // (bitconvert:{ *:[v4i32] } QPR:{ *:[v8i16] }:$src)  =>  (VREV32q16:{ *:[v4i32] } QPR:{ *:[v8i16] }:$src)
     /*  31470 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV32q16),
     /*  31473 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  31475 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  31477 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  31480 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  31486 */   GIR_RootConstrainSelectedInstOperands,
     /*  31487 */   // GIR_Coverage, 2855,
     /*  31487 */   GIR_EraseRootFromParent_Done,
     /*  31488 */ // Label 684: @31488
     /*  31488 */ GIM_Try, /*On fail goto*//*Label 685*/ GIMT_Encode4(31525), // Rule ID 2856 //
     /*  31493 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  31496 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  31499 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  31503 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  31507 */   // (bitconvert:{ *:[v4i32] } QPR:{ *:[v16i8] }:$src)  =>  (VREV32q8:{ *:[v4i32] } QPR:{ *:[v16i8] }:$src)
     /*  31507 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV32q8),
     /*  31510 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  31512 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  31514 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  31517 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  31523 */   GIR_RootConstrainSelectedInstOperands,
     /*  31524 */   // GIR_Coverage, 2856,
     /*  31524 */   GIR_EraseRootFromParent_Done,
     /*  31525 */ // Label 685: @31525
     /*  31525 */ GIM_Try, /*On fail goto*//*Label 686*/ GIMT_Encode4(31557), // Rule ID 5282 //
     /*  31530 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  31533 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  31536 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  31540 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  31544 */   // (bitconvert:{ *:[v4i32] } MQPR:{ *:[v4f32] }:$src)  =>  MQPR:{ *:[v4i32] }:$src
     /*  31544 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  31547 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  31549 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  31551 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::MQPRRegClassID),
     /*  31556 */   // GIR_Coverage, 5282,
     /*  31556 */   GIR_EraseRootFromParent_Done,
     /*  31557 */ // Label 686: @31557
     /*  31557 */ GIM_Try, /*On fail goto*//*Label 687*/ GIMT_Encode4(31589), // Rule ID 5283 //
     /*  31562 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  31565 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  31568 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  31572 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  31576 */   // (bitconvert:{ *:[v4f32] } MQPR:{ *:[v4i32] }:$src)  =>  MQPR:{ *:[v4f32] }:$src
     /*  31576 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  31579 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  31581 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  31583 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::MQPRRegClassID),
     /*  31588 */   // GIR_Coverage, 5283,
     /*  31588 */   GIR_EraseRootFromParent_Done,
     /*  31589 */ // Label 687: @31589
     /*  31589 */ GIM_Try, /*On fail goto*//*Label 688*/ GIMT_Encode4(31621), // Rule ID 5296 //
     /*  31594 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsLE),
     /*  31597 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  31600 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  31604 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  31608 */   // (bitconvert:{ *:[v4f32] } MQPR:{ *:[v2f64] }:$src)  =>  MQPR:{ *:[v4f32] }:$src
     /*  31608 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  31611 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  31613 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  31615 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::MQPRRegClassID),
     /*  31620 */   // GIR_Coverage, 5296,
     /*  31620 */   GIR_EraseRootFromParent_Done,
     /*  31621 */ // Label 688: @31621
     /*  31621 */ GIM_Try, /*On fail goto*//*Label 689*/ GIMT_Encode4(31653), // Rule ID 5297 //
     /*  31626 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsLE),
     /*  31629 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  31632 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  31636 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  31640 */   // (bitconvert:{ *:[v4f32] } MQPR:{ *:[v2i64] }:$src)  =>  MQPR:{ *:[v4f32] }:$src
     /*  31640 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  31643 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  31645 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  31647 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::MQPRRegClassID),
     /*  31652 */   // GIR_Coverage, 5297,
     /*  31652 */   GIR_EraseRootFromParent_Done,
     /*  31653 */ // Label 689: @31653
     /*  31653 */ GIM_Try, /*On fail goto*//*Label 690*/ GIMT_Encode4(31685), // Rule ID 5298 //
     /*  31658 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsLE),
     /*  31661 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  31664 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  31668 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  31672 */   // (bitconvert:{ *:[v4f32] } MQPR:{ *:[v8f16] }:$src)  =>  MQPR:{ *:[v4f32] }:$src
     /*  31672 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  31675 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  31677 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  31679 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::MQPRRegClassID),
     /*  31684 */   // GIR_Coverage, 5298,
     /*  31684 */   GIR_EraseRootFromParent_Done,
     /*  31685 */ // Label 690: @31685
     /*  31685 */ GIM_Try, /*On fail goto*//*Label 691*/ GIMT_Encode4(31717), // Rule ID 5299 //
     /*  31690 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsLE),
     /*  31693 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  31696 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  31700 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  31704 */   // (bitconvert:{ *:[v4f32] } MQPR:{ *:[v8i16] }:$src)  =>  MQPR:{ *:[v4f32] }:$src
     /*  31704 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  31707 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  31709 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  31711 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::MQPRRegClassID),
     /*  31716 */   // GIR_Coverage, 5299,
     /*  31716 */   GIR_EraseRootFromParent_Done,
     /*  31717 */ // Label 691: @31717
     /*  31717 */ GIM_Try, /*On fail goto*//*Label 692*/ GIMT_Encode4(31749), // Rule ID 5300 //
     /*  31722 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsLE),
     /*  31725 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  31728 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  31732 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  31736 */   // (bitconvert:{ *:[v4f32] } MQPR:{ *:[v16i8] }:$src)  =>  MQPR:{ *:[v4f32] }:$src
     /*  31736 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  31739 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  31741 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  31743 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::MQPRRegClassID),
     /*  31748 */   // GIR_Coverage, 5300,
     /*  31748 */   GIR_EraseRootFromParent_Done,
     /*  31749 */ // Label 692: @31749
     /*  31749 */ GIM_Try, /*On fail goto*//*Label 693*/ GIMT_Encode4(31781), // Rule ID 5301 //
     /*  31754 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsLE),
     /*  31757 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  31760 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  31764 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  31768 */   // (bitconvert:{ *:[v4i32] } MQPR:{ *:[v2f64] }:$src)  =>  MQPR:{ *:[v4i32] }:$src
     /*  31768 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  31771 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  31773 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  31775 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::MQPRRegClassID),
     /*  31780 */   // GIR_Coverage, 5301,
     /*  31780 */   GIR_EraseRootFromParent_Done,
     /*  31781 */ // Label 693: @31781
     /*  31781 */ GIM_Try, /*On fail goto*//*Label 694*/ GIMT_Encode4(31813), // Rule ID 5302 //
     /*  31786 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsLE),
     /*  31789 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  31792 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  31796 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  31800 */   // (bitconvert:{ *:[v4i32] } MQPR:{ *:[v2i64] }:$src)  =>  MQPR:{ *:[v4i32] }:$src
     /*  31800 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  31803 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  31805 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  31807 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::MQPRRegClassID),
     /*  31812 */   // GIR_Coverage, 5302,
     /*  31812 */   GIR_EraseRootFromParent_Done,
     /*  31813 */ // Label 694: @31813
     /*  31813 */ GIM_Try, /*On fail goto*//*Label 695*/ GIMT_Encode4(31845), // Rule ID 5303 //
     /*  31818 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsLE),
     /*  31821 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  31824 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  31828 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  31832 */   // (bitconvert:{ *:[v4i32] } MQPR:{ *:[v8f16] }:$src)  =>  MQPR:{ *:[v4i32] }:$src
     /*  31832 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  31835 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  31837 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  31839 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::MQPRRegClassID),
     /*  31844 */   // GIR_Coverage, 5303,
     /*  31844 */   GIR_EraseRootFromParent_Done,
     /*  31845 */ // Label 695: @31845
     /*  31845 */ GIM_Try, /*On fail goto*//*Label 696*/ GIMT_Encode4(31877), // Rule ID 5304 //
     /*  31850 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsLE),
     /*  31853 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  31856 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  31860 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  31864 */   // (bitconvert:{ *:[v4i32] } MQPR:{ *:[v8i16] }:$src)  =>  MQPR:{ *:[v4i32] }:$src
     /*  31864 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  31867 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  31869 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  31871 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::MQPRRegClassID),
     /*  31876 */   // GIR_Coverage, 5304,
     /*  31876 */   GIR_EraseRootFromParent_Done,
     /*  31877 */ // Label 696: @31877
     /*  31877 */ GIM_Try, /*On fail goto*//*Label 697*/ GIMT_Encode4(31909), // Rule ID 5305 //
     /*  31882 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsLE),
     /*  31885 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  31888 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  31892 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  31896 */   // (bitconvert:{ *:[v4i32] } MQPR:{ *:[v16i8] }:$src)  =>  MQPR:{ *:[v4i32] }:$src
     /*  31896 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  31899 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  31901 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  31903 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::MQPRRegClassID),
     /*  31908 */   // GIR_Coverage, 5305,
     /*  31908 */   GIR_EraseRootFromParent_Done,
     /*  31909 */ // Label 697: @31909
     /*  31909 */ GIM_Try, /*On fail goto*//*Label 698*/ GIMT_Encode4(31967), // Rule ID 5332 //
     /*  31914 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsBE),
     /*  31917 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  31920 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  31924 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  31928 */   // (bitconvert:{ *:[v4f32] } MQPR:{ *:[v2f64] }:$src)  =>  (MVE_VREV64_32:{ *:[v4f32] } MQPR:{ *:[v2f64] }:$src)
     /*  31928 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  31931 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  31935 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  31940 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VREV64_32),
     /*  31943 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  31945 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  31947 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  31950 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  31956 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  31962 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  31965 */   GIR_RootConstrainSelectedInstOperands,
     /*  31966 */   // GIR_Coverage, 5332,
     /*  31966 */   GIR_EraseRootFromParent_Done,
     /*  31967 */ // Label 698: @31967
     /*  31967 */ GIM_Try, /*On fail goto*//*Label 699*/ GIMT_Encode4(32025), // Rule ID 5333 //
     /*  31972 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsBE),
     /*  31975 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  31978 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  31982 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  31986 */   // (bitconvert:{ *:[v4f32] } MQPR:{ *:[v2i64] }:$src)  =>  (MVE_VREV64_32:{ *:[v4f32] } MQPR:{ *:[v2i64] }:$src)
     /*  31986 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  31989 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  31993 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  31998 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VREV64_32),
     /*  32001 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  32003 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  32005 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  32008 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  32014 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  32020 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  32023 */   GIR_RootConstrainSelectedInstOperands,
     /*  32024 */   // GIR_Coverage, 5333,
     /*  32024 */   GIR_EraseRootFromParent_Done,
     /*  32025 */ // Label 699: @32025
     /*  32025 */ GIM_Try, /*On fail goto*//*Label 700*/ GIMT_Encode4(32083), // Rule ID 5334 //
     /*  32030 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsBE),
     /*  32033 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  32036 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  32040 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  32044 */   // (bitconvert:{ *:[v4f32] } MQPR:{ *:[v8f16] }:$src)  =>  (MVE_VREV32_16:{ *:[v4f32] } MQPR:{ *:[v8f16] }:$src)
     /*  32044 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  32047 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  32051 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  32056 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VREV32_16),
     /*  32059 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  32061 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  32063 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  32066 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  32072 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  32078 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  32081 */   GIR_RootConstrainSelectedInstOperands,
     /*  32082 */   // GIR_Coverage, 5334,
     /*  32082 */   GIR_EraseRootFromParent_Done,
     /*  32083 */ // Label 700: @32083
     /*  32083 */ GIM_Try, /*On fail goto*//*Label 701*/ GIMT_Encode4(32141), // Rule ID 5335 //
     /*  32088 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsBE),
     /*  32091 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  32094 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  32098 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  32102 */   // (bitconvert:{ *:[v4f32] } MQPR:{ *:[v8i16] }:$src)  =>  (MVE_VREV32_16:{ *:[v4f32] } MQPR:{ *:[v8i16] }:$src)
     /*  32102 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  32105 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  32109 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  32114 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VREV32_16),
     /*  32117 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  32119 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  32121 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  32124 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  32130 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  32136 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  32139 */   GIR_RootConstrainSelectedInstOperands,
     /*  32140 */   // GIR_Coverage, 5335,
     /*  32140 */   GIR_EraseRootFromParent_Done,
     /*  32141 */ // Label 701: @32141
     /*  32141 */ GIM_Try, /*On fail goto*//*Label 702*/ GIMT_Encode4(32199), // Rule ID 5336 //
     /*  32146 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsBE),
     /*  32149 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  32152 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  32156 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  32160 */   // (bitconvert:{ *:[v4f32] } MQPR:{ *:[v16i8] }:$src)  =>  (MVE_VREV32_8:{ *:[v4f32] } MQPR:{ *:[v16i8] }:$src)
     /*  32160 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  32163 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  32167 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  32172 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VREV32_8),
     /*  32175 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  32177 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  32179 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  32182 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  32188 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  32194 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  32197 */   GIR_RootConstrainSelectedInstOperands,
     /*  32198 */   // GIR_Coverage, 5336,
     /*  32198 */   GIR_EraseRootFromParent_Done,
     /*  32199 */ // Label 702: @32199
     /*  32199 */ GIM_Try, /*On fail goto*//*Label 703*/ GIMT_Encode4(32257), // Rule ID 5337 //
     /*  32204 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsBE),
     /*  32207 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  32210 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  32214 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  32218 */   // (bitconvert:{ *:[v4i32] } MQPR:{ *:[v2f64] }:$src)  =>  (MVE_VREV64_32:{ *:[v4i32] } MQPR:{ *:[v2f64] }:$src)
     /*  32218 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  32221 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  32225 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  32230 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VREV64_32),
     /*  32233 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  32235 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  32237 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  32240 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  32246 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  32252 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  32255 */   GIR_RootConstrainSelectedInstOperands,
     /*  32256 */   // GIR_Coverage, 5337,
     /*  32256 */   GIR_EraseRootFromParent_Done,
     /*  32257 */ // Label 703: @32257
     /*  32257 */ GIM_Try, /*On fail goto*//*Label 704*/ GIMT_Encode4(32315), // Rule ID 5338 //
     /*  32262 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsBE),
     /*  32265 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  32268 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  32272 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  32276 */   // (bitconvert:{ *:[v4i32] } MQPR:{ *:[v2i64] }:$src)  =>  (MVE_VREV64_32:{ *:[v4i32] } MQPR:{ *:[v2i64] }:$src)
     /*  32276 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  32279 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  32283 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  32288 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VREV64_32),
     /*  32291 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  32293 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  32295 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  32298 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  32304 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  32310 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  32313 */   GIR_RootConstrainSelectedInstOperands,
     /*  32314 */   // GIR_Coverage, 5338,
     /*  32314 */   GIR_EraseRootFromParent_Done,
     /*  32315 */ // Label 704: @32315
     /*  32315 */ GIM_Try, /*On fail goto*//*Label 705*/ GIMT_Encode4(32373), // Rule ID 5339 //
     /*  32320 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsBE),
     /*  32323 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  32326 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  32330 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  32334 */   // (bitconvert:{ *:[v4i32] } MQPR:{ *:[v8f16] }:$src)  =>  (MVE_VREV32_16:{ *:[v4i32] } MQPR:{ *:[v8f16] }:$src)
     /*  32334 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  32337 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  32341 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  32346 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VREV32_16),
     /*  32349 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  32351 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  32353 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  32356 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  32362 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  32368 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  32371 */   GIR_RootConstrainSelectedInstOperands,
     /*  32372 */   // GIR_Coverage, 5339,
     /*  32372 */   GIR_EraseRootFromParent_Done,
     /*  32373 */ // Label 705: @32373
     /*  32373 */ GIM_Try, /*On fail goto*//*Label 706*/ GIMT_Encode4(32431), // Rule ID 5340 //
     /*  32378 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsBE),
     /*  32381 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  32384 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  32388 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  32392 */   // (bitconvert:{ *:[v4i32] } MQPR:{ *:[v8i16] }:$src)  =>  (MVE_VREV32_16:{ *:[v4i32] } MQPR:{ *:[v8i16] }:$src)
     /*  32392 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  32395 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  32399 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  32404 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VREV32_16),
     /*  32407 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  32409 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  32411 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  32414 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  32420 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  32426 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  32429 */   GIR_RootConstrainSelectedInstOperands,
     /*  32430 */   // GIR_Coverage, 5340,
     /*  32430 */   GIR_EraseRootFromParent_Done,
     /*  32431 */ // Label 706: @32431
     /*  32431 */ GIM_Try, /*On fail goto*//*Label 707*/ GIMT_Encode4(32489), // Rule ID 5341 //
     /*  32436 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsBE),
     /*  32439 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  32442 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  32446 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  32450 */   // (bitconvert:{ *:[v4i32] } MQPR:{ *:[v16i8] }:$src)  =>  (MVE_VREV32_8:{ *:[v4i32] } MQPR:{ *:[v16i8] }:$src)
     /*  32450 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  32453 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  32457 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  32462 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VREV32_8),
     /*  32465 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  32467 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  32469 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  32472 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  32478 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  32484 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  32487 */   GIR_RootConstrainSelectedInstOperands,
     /*  32488 */   // GIR_Coverage, 5341,
     /*  32488 */   GIR_EraseRootFromParent_Done,
     /*  32489 */ // Label 707: @32489
     /*  32489 */ GIM_Reject,
     /*  32490 */ // Label 546: @32490
     /*  32490 */ GIM_Try, /*On fail goto*//*Label 708*/ GIMT_Encode4(32522), // Rule ID 2759 //
     /*  32495 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  32498 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  32501 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  32505 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  32509 */   // (bitconvert:{ *:[v8i8] } DPR:{ *:[f64] }:$src)  =>  DPR:{ *:[v8i8] }:$src
     /*  32509 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  32512 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  32514 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  32516 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::DPRRegClassID),
     /*  32521 */   // GIR_Coverage, 2759,
     /*  32521 */   GIR_EraseRootFromParent_Done,
     /*  32522 */ // Label 708: @32522
     /*  32522 */ GIM_Try, /*On fail goto*//*Label 709*/ GIMT_Encode4(32554), // Rule ID 2760 //
     /*  32527 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  32530 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  32533 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  32537 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  32541 */   // (bitconvert:{ *:[v8i8] } DPR:{ *:[v1i64] }:$src)  =>  DPR:{ *:[v8i8] }:$src
     /*  32541 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  32544 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  32546 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  32548 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::DPRRegClassID),
     /*  32553 */   // GIR_Coverage, 2760,
     /*  32553 */   GIR_EraseRootFromParent_Done,
     /*  32554 */ // Label 709: @32554
     /*  32554 */ GIM_Try, /*On fail goto*//*Label 710*/ GIMT_Encode4(32586), // Rule ID 2761 //
     /*  32559 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  32562 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  32565 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  32569 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  32573 */   // (bitconvert:{ *:[v8i8] } DPR:{ *:[v2f32] }:$src)  =>  DPR:{ *:[v8i8] }:$src
     /*  32573 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  32576 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  32578 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  32580 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::DPRRegClassID),
     /*  32585 */   // GIR_Coverage, 2761,
     /*  32585 */   GIR_EraseRootFromParent_Done,
     /*  32586 */ // Label 710: @32586
     /*  32586 */ GIM_Try, /*On fail goto*//*Label 711*/ GIMT_Encode4(32618), // Rule ID 2762 //
     /*  32591 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  32594 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  32597 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  32601 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  32605 */   // (bitconvert:{ *:[v8i8] } DPR:{ *:[v2i32] }:$src)  =>  DPR:{ *:[v8i8] }:$src
     /*  32605 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  32608 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  32610 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  32612 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::DPRRegClassID),
     /*  32617 */   // GIR_Coverage, 2762,
     /*  32617 */   GIR_EraseRootFromParent_Done,
     /*  32618 */ // Label 711: @32618
     /*  32618 */ GIM_Try, /*On fail goto*//*Label 712*/ GIMT_Encode4(32650), // Rule ID 2763 //
     /*  32623 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  32626 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  32629 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  32633 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  32637 */   // (bitconvert:{ *:[v8i8] } DPR:{ *:[v4f16] }:$src)  =>  DPR:{ *:[v8i8] }:$src
     /*  32637 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  32640 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  32642 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  32644 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::DPRRegClassID),
     /*  32649 */   // GIR_Coverage, 2763,
     /*  32649 */   GIR_EraseRootFromParent_Done,
     /*  32650 */ // Label 712: @32650
     /*  32650 */ GIM_Try, /*On fail goto*//*Label 713*/ GIMT_Encode4(32682), // Rule ID 2764 //
     /*  32655 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  32658 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  32661 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  32665 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  32669 */   // (bitconvert:{ *:[v8i8] } DPR:{ *:[v4i16] }:$src)  =>  DPR:{ *:[v8i8] }:$src
     /*  32669 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  32672 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  32674 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  32676 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::DPRRegClassID),
     /*  32681 */   // GIR_Coverage, 2764,
     /*  32681 */   GIR_EraseRootFromParent_Done,
     /*  32682 */ // Label 713: @32682
     /*  32682 */ GIM_Try, /*On fail goto*//*Label 714*/ GIMT_Encode4(32719), // Rule ID 2831 //
     /*  32687 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  32690 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  32693 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  32697 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  32701 */   // (bitconvert:{ *:[v8i8] } DPR:{ *:[f64] }:$src)  =>  (VREV64d8:{ *:[v8i8] } DPR:{ *:[f64] }:$src)
     /*  32701 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV64d8),
     /*  32704 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  32706 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  32708 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  32711 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  32717 */   GIR_RootConstrainSelectedInstOperands,
     /*  32718 */   // GIR_Coverage, 2831,
     /*  32718 */   GIR_EraseRootFromParent_Done,
     /*  32719 */ // Label 714: @32719
     /*  32719 */ GIM_Try, /*On fail goto*//*Label 715*/ GIMT_Encode4(32756), // Rule ID 2832 //
     /*  32724 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  32727 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  32730 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  32734 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  32738 */   // (bitconvert:{ *:[v8i8] } DPR:{ *:[v1i64] }:$src)  =>  (VREV64d8:{ *:[v8i8] } DPR:{ *:[v1i64] }:$src)
     /*  32738 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV64d8),
     /*  32741 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  32743 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  32745 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  32748 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  32754 */   GIR_RootConstrainSelectedInstOperands,
     /*  32755 */   // GIR_Coverage, 2832,
     /*  32755 */   GIR_EraseRootFromParent_Done,
     /*  32756 */ // Label 715: @32756
     /*  32756 */ GIM_Try, /*On fail goto*//*Label 716*/ GIMT_Encode4(32793), // Rule ID 2833 //
     /*  32761 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  32764 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  32767 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  32771 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  32775 */   // (bitconvert:{ *:[v8i8] } DPR:{ *:[v2f32] }:$src)  =>  (VREV32d8:{ *:[v8i8] } DPR:{ *:[v2f32] }:$src)
     /*  32775 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV32d8),
     /*  32778 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  32780 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  32782 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  32785 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  32791 */   GIR_RootConstrainSelectedInstOperands,
     /*  32792 */   // GIR_Coverage, 2833,
     /*  32792 */   GIR_EraseRootFromParent_Done,
     /*  32793 */ // Label 716: @32793
     /*  32793 */ GIM_Try, /*On fail goto*//*Label 717*/ GIMT_Encode4(32830), // Rule ID 2834 //
     /*  32798 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  32801 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  32804 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  32808 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  32812 */   // (bitconvert:{ *:[v8i8] } DPR:{ *:[v2i32] }:$src)  =>  (VREV32d8:{ *:[v8i8] } DPR:{ *:[v2i32] }:$src)
     /*  32812 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV32d8),
     /*  32815 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  32817 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  32819 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  32822 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  32828 */   GIR_RootConstrainSelectedInstOperands,
     /*  32829 */   // GIR_Coverage, 2834,
     /*  32829 */   GIR_EraseRootFromParent_Done,
     /*  32830 */ // Label 717: @32830
     /*  32830 */ GIM_Try, /*On fail goto*//*Label 718*/ GIMT_Encode4(32867), // Rule ID 2835 //
     /*  32835 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  32838 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  32841 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  32845 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  32849 */   // (bitconvert:{ *:[v8i8] } DPR:{ *:[v4f16] }:$src)  =>  (VREV16d8:{ *:[v8i8] } DPR:{ *:[v4f16] }:$src)
     /*  32849 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV16d8),
     /*  32852 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  32854 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  32856 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  32859 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  32865 */   GIR_RootConstrainSelectedInstOperands,
     /*  32866 */   // GIR_Coverage, 2835,
     /*  32866 */   GIR_EraseRootFromParent_Done,
     /*  32867 */ // Label 718: @32867
     /*  32867 */ GIM_Try, /*On fail goto*//*Label 719*/ GIMT_Encode4(32904), // Rule ID 2836 //
     /*  32872 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  32875 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  32878 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  32882 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  32886 */   // (bitconvert:{ *:[v8i8] } DPR:{ *:[v4i16] }:$src)  =>  (VREV16d8:{ *:[v8i8] } DPR:{ *:[v4i16] }:$src)
     /*  32886 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV16d8),
     /*  32889 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  32891 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  32893 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  32896 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  32902 */   GIR_RootConstrainSelectedInstOperands,
     /*  32903 */   // GIR_Coverage, 2836,
     /*  32903 */   GIR_EraseRootFromParent_Done,
     /*  32904 */ // Label 719: @32904
     /*  32904 */ GIM_Reject,
     /*  32905 */ // Label 547: @32905
     /*  32905 */ GIM_Try, /*On fail goto*//*Label 720*/ GIMT_Encode4(32937), // Rule ID 2727 //
     /*  32910 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  32913 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  32916 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  32920 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  32924 */   // (bitconvert:{ *:[v8i16] } QPR:{ *:[v8f16] }:$src)  =>  QPR:{ *:[v8i16] }:$src
     /*  32924 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  32927 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  32929 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  32931 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  32936 */   // GIR_Coverage, 2727,
     /*  32936 */   GIR_EraseRootFromParent_Done,
     /*  32937 */ // Label 720: @32937
     /*  32937 */ GIM_Try, /*On fail goto*//*Label 721*/ GIMT_Encode4(32969), // Rule ID 2728 //
     /*  32942 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  32945 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  32948 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  32952 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  32956 */   // (bitconvert:{ *:[v8f16] } QPR:{ *:[v8i16] }:$src)  =>  QPR:{ *:[v8f16] }:$src
     /*  32956 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  32959 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  32961 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  32963 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  32968 */   // GIR_Coverage, 2728,
     /*  32968 */   GIR_EraseRootFromParent_Done,
     /*  32969 */ // Label 721: @32969
     /*  32969 */ GIM_Try, /*On fail goto*//*Label 722*/ GIMT_Encode4(33001), // Rule ID 2785 //
     /*  32974 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  32977 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  32980 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  32984 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  32988 */   // (bitconvert:{ *:[v8f16] } QPR:{ *:[v2f64] }:$src)  =>  QPR:{ *:[v8f16] }:$src
     /*  32988 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  32991 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  32993 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  32995 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  33000 */   // GIR_Coverage, 2785,
     /*  33000 */   GIR_EraseRootFromParent_Done,
     /*  33001 */ // Label 722: @33001
     /*  33001 */ GIM_Try, /*On fail goto*//*Label 723*/ GIMT_Encode4(33033), // Rule ID 2786 //
     /*  33006 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  33009 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  33012 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  33016 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  33020 */   // (bitconvert:{ *:[v8f16] } QPR:{ *:[v2i64] }:$src)  =>  QPR:{ *:[v8f16] }:$src
     /*  33020 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  33023 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  33025 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  33027 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  33032 */   // GIR_Coverage, 2786,
     /*  33032 */   GIR_EraseRootFromParent_Done,
     /*  33033 */ // Label 723: @33033
     /*  33033 */ GIM_Try, /*On fail goto*//*Label 724*/ GIMT_Encode4(33065), // Rule ID 2787 //
     /*  33038 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  33041 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  33044 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  33048 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  33052 */   // (bitconvert:{ *:[v8f16] } QPR:{ *:[v4f32] }:$src)  =>  QPR:{ *:[v8f16] }:$src
     /*  33052 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  33055 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  33057 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  33059 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  33064 */   // GIR_Coverage, 2787,
     /*  33064 */   GIR_EraseRootFromParent_Done,
     /*  33065 */ // Label 724: @33065
     /*  33065 */ GIM_Try, /*On fail goto*//*Label 725*/ GIMT_Encode4(33097), // Rule ID 2788 //
     /*  33070 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  33073 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  33076 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  33080 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  33084 */   // (bitconvert:{ *:[v8f16] } QPR:{ *:[v4i32] }:$src)  =>  QPR:{ *:[v8f16] }:$src
     /*  33084 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  33087 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  33089 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  33091 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  33096 */   // GIR_Coverage, 2788,
     /*  33096 */   GIR_EraseRootFromParent_Done,
     /*  33097 */ // Label 725: @33097
     /*  33097 */ GIM_Try, /*On fail goto*//*Label 726*/ GIMT_Encode4(33129), // Rule ID 2789 //
     /*  33102 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  33105 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  33108 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  33112 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  33116 */   // (bitconvert:{ *:[v8f16] } QPR:{ *:[v16i8] }:$src)  =>  QPR:{ *:[v8f16] }:$src
     /*  33116 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  33119 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  33121 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  33123 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  33128 */   // GIR_Coverage, 2789,
     /*  33128 */   GIR_EraseRootFromParent_Done,
     /*  33129 */ // Label 726: @33129
     /*  33129 */ GIM_Try, /*On fail goto*//*Label 727*/ GIMT_Encode4(33161), // Rule ID 2790 //
     /*  33134 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  33137 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  33140 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  33144 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  33148 */   // (bitconvert:{ *:[v8i16] } QPR:{ *:[v2f64] }:$src)  =>  QPR:{ *:[v8i16] }:$src
     /*  33148 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  33151 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  33153 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  33155 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  33160 */   // GIR_Coverage, 2790,
     /*  33160 */   GIR_EraseRootFromParent_Done,
     /*  33161 */ // Label 727: @33161
     /*  33161 */ GIM_Try, /*On fail goto*//*Label 728*/ GIMT_Encode4(33193), // Rule ID 2791 //
     /*  33166 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  33169 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  33172 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  33176 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  33180 */   // (bitconvert:{ *:[v8i16] } QPR:{ *:[v2i64] }:$src)  =>  QPR:{ *:[v8i16] }:$src
     /*  33180 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  33183 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  33185 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  33187 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  33192 */   // GIR_Coverage, 2791,
     /*  33192 */   GIR_EraseRootFromParent_Done,
     /*  33193 */ // Label 728: @33193
     /*  33193 */ GIM_Try, /*On fail goto*//*Label 729*/ GIMT_Encode4(33225), // Rule ID 2792 //
     /*  33198 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  33201 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  33204 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  33208 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  33212 */   // (bitconvert:{ *:[v8i16] } QPR:{ *:[v4f32] }:$src)  =>  QPR:{ *:[v8i16] }:$src
     /*  33212 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  33215 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  33217 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  33219 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  33224 */   // GIR_Coverage, 2792,
     /*  33224 */   GIR_EraseRootFromParent_Done,
     /*  33225 */ // Label 729: @33225
     /*  33225 */ GIM_Try, /*On fail goto*//*Label 730*/ GIMT_Encode4(33257), // Rule ID 2793 //
     /*  33230 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  33233 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  33236 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  33240 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  33244 */   // (bitconvert:{ *:[v8i16] } QPR:{ *:[v4i32] }:$src)  =>  QPR:{ *:[v8i16] }:$src
     /*  33244 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  33247 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  33249 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  33251 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  33256 */   // GIR_Coverage, 2793,
     /*  33256 */   GIR_EraseRootFromParent_Done,
     /*  33257 */ // Label 730: @33257
     /*  33257 */ GIM_Try, /*On fail goto*//*Label 731*/ GIMT_Encode4(33289), // Rule ID 2794 //
     /*  33262 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  33265 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  33268 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  33272 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  33276 */   // (bitconvert:{ *:[v8i16] } QPR:{ *:[v16i8] }:$src)  =>  QPR:{ *:[v8i16] }:$src
     /*  33276 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  33279 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  33281 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  33283 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  33288 */   // GIR_Coverage, 2794,
     /*  33288 */   GIR_EraseRootFromParent_Done,
     /*  33289 */ // Label 731: @33289
     /*  33289 */ GIM_Try, /*On fail goto*//*Label 732*/ GIMT_Encode4(33326), // Rule ID 2857 //
     /*  33294 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  33297 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  33300 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  33304 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  33308 */   // (bitconvert:{ *:[v8f16] } QPR:{ *:[v2f64] }:$src)  =>  (VREV64q16:{ *:[v8f16] } QPR:{ *:[v2f64] }:$src)
     /*  33308 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV64q16),
     /*  33311 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  33313 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  33315 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  33318 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  33324 */   GIR_RootConstrainSelectedInstOperands,
     /*  33325 */   // GIR_Coverage, 2857,
     /*  33325 */   GIR_EraseRootFromParent_Done,
     /*  33326 */ // Label 732: @33326
     /*  33326 */ GIM_Try, /*On fail goto*//*Label 733*/ GIMT_Encode4(33363), // Rule ID 2858 //
     /*  33331 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  33334 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  33337 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  33341 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  33345 */   // (bitconvert:{ *:[v8f16] } QPR:{ *:[v2i64] }:$src)  =>  (VREV64q16:{ *:[v8f16] } QPR:{ *:[v2i64] }:$src)
     /*  33345 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV64q16),
     /*  33348 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  33350 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  33352 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  33355 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  33361 */   GIR_RootConstrainSelectedInstOperands,
     /*  33362 */   // GIR_Coverage, 2858,
     /*  33362 */   GIR_EraseRootFromParent_Done,
     /*  33363 */ // Label 733: @33363
     /*  33363 */ GIM_Try, /*On fail goto*//*Label 734*/ GIMT_Encode4(33400), // Rule ID 2859 //
     /*  33368 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  33371 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  33374 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  33378 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  33382 */   // (bitconvert:{ *:[v8f16] } QPR:{ *:[v4f32] }:$src)  =>  (VREV32q16:{ *:[v8f16] } QPR:{ *:[v4f32] }:$src)
     /*  33382 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV32q16),
     /*  33385 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  33387 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  33389 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  33392 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  33398 */   GIR_RootConstrainSelectedInstOperands,
     /*  33399 */   // GIR_Coverage, 2859,
     /*  33399 */   GIR_EraseRootFromParent_Done,
     /*  33400 */ // Label 734: @33400
     /*  33400 */ GIM_Try, /*On fail goto*//*Label 735*/ GIMT_Encode4(33437), // Rule ID 2860 //
     /*  33405 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  33408 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  33411 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  33415 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  33419 */   // (bitconvert:{ *:[v8f16] } QPR:{ *:[v4i32] }:$src)  =>  (VREV32q16:{ *:[v8f16] } QPR:{ *:[v4i32] }:$src)
     /*  33419 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV32q16),
     /*  33422 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  33424 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  33426 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  33429 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  33435 */   GIR_RootConstrainSelectedInstOperands,
     /*  33436 */   // GIR_Coverage, 2860,
     /*  33436 */   GIR_EraseRootFromParent_Done,
     /*  33437 */ // Label 735: @33437
     /*  33437 */ GIM_Try, /*On fail goto*//*Label 736*/ GIMT_Encode4(33474), // Rule ID 2861 //
     /*  33442 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  33445 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  33448 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  33452 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  33456 */   // (bitconvert:{ *:[v8f16] } QPR:{ *:[v16i8] }:$src)  =>  (VREV16q8:{ *:[v8f16] } QPR:{ *:[v16i8] }:$src)
     /*  33456 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV16q8),
     /*  33459 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  33461 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  33463 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  33466 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  33472 */   GIR_RootConstrainSelectedInstOperands,
     /*  33473 */   // GIR_Coverage, 2861,
     /*  33473 */   GIR_EraseRootFromParent_Done,
     /*  33474 */ // Label 736: @33474
     /*  33474 */ GIM_Try, /*On fail goto*//*Label 737*/ GIMT_Encode4(33511), // Rule ID 2862 //
     /*  33479 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  33482 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  33485 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  33489 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  33493 */   // (bitconvert:{ *:[v8i16] } QPR:{ *:[v2f64] }:$src)  =>  (VREV64q16:{ *:[v8i16] } QPR:{ *:[v2f64] }:$src)
     /*  33493 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV64q16),
     /*  33496 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  33498 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  33500 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  33503 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  33509 */   GIR_RootConstrainSelectedInstOperands,
     /*  33510 */   // GIR_Coverage, 2862,
     /*  33510 */   GIR_EraseRootFromParent_Done,
     /*  33511 */ // Label 737: @33511
     /*  33511 */ GIM_Try, /*On fail goto*//*Label 738*/ GIMT_Encode4(33548), // Rule ID 2863 //
     /*  33516 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  33519 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  33522 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  33526 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  33530 */   // (bitconvert:{ *:[v8i16] } QPR:{ *:[v2i64] }:$src)  =>  (VREV64q16:{ *:[v8i16] } QPR:{ *:[v2i64] }:$src)
     /*  33530 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV64q16),
     /*  33533 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  33535 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  33537 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  33540 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  33546 */   GIR_RootConstrainSelectedInstOperands,
     /*  33547 */   // GIR_Coverage, 2863,
     /*  33547 */   GIR_EraseRootFromParent_Done,
     /*  33548 */ // Label 738: @33548
     /*  33548 */ GIM_Try, /*On fail goto*//*Label 739*/ GIMT_Encode4(33585), // Rule ID 2864 //
     /*  33553 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  33556 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  33559 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  33563 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  33567 */   // (bitconvert:{ *:[v8i16] } QPR:{ *:[v4f32] }:$src)  =>  (VREV32q16:{ *:[v8i16] } QPR:{ *:[v4f32] }:$src)
     /*  33567 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV32q16),
     /*  33570 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  33572 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  33574 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  33577 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  33583 */   GIR_RootConstrainSelectedInstOperands,
     /*  33584 */   // GIR_Coverage, 2864,
     /*  33584 */   GIR_EraseRootFromParent_Done,
     /*  33585 */ // Label 739: @33585
     /*  33585 */ GIM_Try, /*On fail goto*//*Label 740*/ GIMT_Encode4(33622), // Rule ID 2865 //
     /*  33590 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  33593 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  33596 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  33600 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  33604 */   // (bitconvert:{ *:[v8i16] } QPR:{ *:[v4i32] }:$src)  =>  (VREV32q16:{ *:[v8i16] } QPR:{ *:[v4i32] }:$src)
     /*  33604 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV32q16),
     /*  33607 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  33609 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  33611 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  33614 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  33620 */   GIR_RootConstrainSelectedInstOperands,
     /*  33621 */   // GIR_Coverage, 2865,
     /*  33621 */   GIR_EraseRootFromParent_Done,
     /*  33622 */ // Label 740: @33622
     /*  33622 */ GIM_Try, /*On fail goto*//*Label 741*/ GIMT_Encode4(33659), // Rule ID 2866 //
     /*  33627 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  33630 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  33633 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  33637 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  33641 */   // (bitconvert:{ *:[v8i16] } QPR:{ *:[v16i8] }:$src)  =>  (VREV16q8:{ *:[v8i16] } QPR:{ *:[v16i8] }:$src)
     /*  33641 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV16q8),
     /*  33644 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  33646 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  33648 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  33651 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  33657 */   GIR_RootConstrainSelectedInstOperands,
     /*  33658 */   // GIR_Coverage, 2866,
     /*  33658 */   GIR_EraseRootFromParent_Done,
     /*  33659 */ // Label 741: @33659
     /*  33659 */ GIM_Try, /*On fail goto*//*Label 742*/ GIMT_Encode4(33691), // Rule ID 5284 //
     /*  33664 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  33667 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  33670 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  33674 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  33678 */   // (bitconvert:{ *:[v8i16] } MQPR:{ *:[v8f16] }:$src)  =>  MQPR:{ *:[v8i16] }:$src
     /*  33678 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  33681 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  33683 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  33685 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::MQPRRegClassID),
     /*  33690 */   // GIR_Coverage, 5284,
     /*  33690 */   GIR_EraseRootFromParent_Done,
     /*  33691 */ // Label 742: @33691
     /*  33691 */ GIM_Try, /*On fail goto*//*Label 743*/ GIMT_Encode4(33723), // Rule ID 5285 //
     /*  33696 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  33699 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  33702 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  33706 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  33710 */   // (bitconvert:{ *:[v8f16] } MQPR:{ *:[v8i16] }:$src)  =>  MQPR:{ *:[v8f16] }:$src
     /*  33710 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  33713 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  33715 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  33717 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::MQPRRegClassID),
     /*  33722 */   // GIR_Coverage, 5285,
     /*  33722 */   GIR_EraseRootFromParent_Done,
     /*  33723 */ // Label 743: @33723
     /*  33723 */ GIM_Try, /*On fail goto*//*Label 744*/ GIMT_Encode4(33755), // Rule ID 5306 //
     /*  33728 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsLE),
     /*  33731 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  33734 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  33738 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  33742 */   // (bitconvert:{ *:[v8f16] } MQPR:{ *:[v2f64] }:$src)  =>  MQPR:{ *:[v8f16] }:$src
     /*  33742 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  33745 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  33747 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  33749 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::MQPRRegClassID),
     /*  33754 */   // GIR_Coverage, 5306,
     /*  33754 */   GIR_EraseRootFromParent_Done,
     /*  33755 */ // Label 744: @33755
     /*  33755 */ GIM_Try, /*On fail goto*//*Label 745*/ GIMT_Encode4(33787), // Rule ID 5307 //
     /*  33760 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsLE),
     /*  33763 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  33766 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  33770 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  33774 */   // (bitconvert:{ *:[v8f16] } MQPR:{ *:[v2i64] }:$src)  =>  MQPR:{ *:[v8f16] }:$src
     /*  33774 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  33777 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  33779 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  33781 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::MQPRRegClassID),
     /*  33786 */   // GIR_Coverage, 5307,
     /*  33786 */   GIR_EraseRootFromParent_Done,
     /*  33787 */ // Label 745: @33787
     /*  33787 */ GIM_Try, /*On fail goto*//*Label 746*/ GIMT_Encode4(33819), // Rule ID 5308 //
     /*  33792 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsLE),
     /*  33795 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  33798 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  33802 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  33806 */   // (bitconvert:{ *:[v8f16] } MQPR:{ *:[v4f32] }:$src)  =>  MQPR:{ *:[v8f16] }:$src
     /*  33806 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  33809 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  33811 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  33813 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::MQPRRegClassID),
     /*  33818 */   // GIR_Coverage, 5308,
     /*  33818 */   GIR_EraseRootFromParent_Done,
     /*  33819 */ // Label 746: @33819
     /*  33819 */ GIM_Try, /*On fail goto*//*Label 747*/ GIMT_Encode4(33851), // Rule ID 5309 //
     /*  33824 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsLE),
     /*  33827 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  33830 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  33834 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  33838 */   // (bitconvert:{ *:[v8f16] } MQPR:{ *:[v4i32] }:$src)  =>  MQPR:{ *:[v8f16] }:$src
     /*  33838 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  33841 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  33843 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  33845 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::MQPRRegClassID),
     /*  33850 */   // GIR_Coverage, 5309,
     /*  33850 */   GIR_EraseRootFromParent_Done,
     /*  33851 */ // Label 747: @33851
     /*  33851 */ GIM_Try, /*On fail goto*//*Label 748*/ GIMT_Encode4(33883), // Rule ID 5310 //
     /*  33856 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsLE),
     /*  33859 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  33862 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  33866 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  33870 */   // (bitconvert:{ *:[v8f16] } MQPR:{ *:[v16i8] }:$src)  =>  MQPR:{ *:[v8f16] }:$src
     /*  33870 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  33873 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  33875 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  33877 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::MQPRRegClassID),
     /*  33882 */   // GIR_Coverage, 5310,
     /*  33882 */   GIR_EraseRootFromParent_Done,
     /*  33883 */ // Label 748: @33883
     /*  33883 */ GIM_Try, /*On fail goto*//*Label 749*/ GIMT_Encode4(33915), // Rule ID 5311 //
     /*  33888 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsLE),
     /*  33891 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  33894 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  33898 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  33902 */   // (bitconvert:{ *:[v8i16] } MQPR:{ *:[v2f64] }:$src)  =>  MQPR:{ *:[v8i16] }:$src
     /*  33902 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  33905 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  33907 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  33909 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::MQPRRegClassID),
     /*  33914 */   // GIR_Coverage, 5311,
     /*  33914 */   GIR_EraseRootFromParent_Done,
     /*  33915 */ // Label 749: @33915
     /*  33915 */ GIM_Try, /*On fail goto*//*Label 750*/ GIMT_Encode4(33947), // Rule ID 5312 //
     /*  33920 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsLE),
     /*  33923 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  33926 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  33930 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  33934 */   // (bitconvert:{ *:[v8i16] } MQPR:{ *:[v2i64] }:$src)  =>  MQPR:{ *:[v8i16] }:$src
     /*  33934 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  33937 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  33939 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  33941 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::MQPRRegClassID),
     /*  33946 */   // GIR_Coverage, 5312,
     /*  33946 */   GIR_EraseRootFromParent_Done,
     /*  33947 */ // Label 750: @33947
     /*  33947 */ GIM_Try, /*On fail goto*//*Label 751*/ GIMT_Encode4(33979), // Rule ID 5313 //
     /*  33952 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsLE),
     /*  33955 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  33958 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  33962 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  33966 */   // (bitconvert:{ *:[v8i16] } MQPR:{ *:[v4f32] }:$src)  =>  MQPR:{ *:[v8i16] }:$src
     /*  33966 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  33969 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  33971 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  33973 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::MQPRRegClassID),
     /*  33978 */   // GIR_Coverage, 5313,
     /*  33978 */   GIR_EraseRootFromParent_Done,
     /*  33979 */ // Label 751: @33979
     /*  33979 */ GIM_Try, /*On fail goto*//*Label 752*/ GIMT_Encode4(34011), // Rule ID 5314 //
     /*  33984 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsLE),
     /*  33987 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  33990 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  33994 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  33998 */   // (bitconvert:{ *:[v8i16] } MQPR:{ *:[v4i32] }:$src)  =>  MQPR:{ *:[v8i16] }:$src
     /*  33998 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  34001 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  34003 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  34005 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::MQPRRegClassID),
     /*  34010 */   // GIR_Coverage, 5314,
     /*  34010 */   GIR_EraseRootFromParent_Done,
     /*  34011 */ // Label 752: @34011
     /*  34011 */ GIM_Try, /*On fail goto*//*Label 753*/ GIMT_Encode4(34043), // Rule ID 5315 //
     /*  34016 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsLE),
     /*  34019 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  34022 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  34026 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  34030 */   // (bitconvert:{ *:[v8i16] } MQPR:{ *:[v16i8] }:$src)  =>  MQPR:{ *:[v8i16] }:$src
     /*  34030 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  34033 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  34035 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  34037 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::MQPRRegClassID),
     /*  34042 */   // GIR_Coverage, 5315,
     /*  34042 */   GIR_EraseRootFromParent_Done,
     /*  34043 */ // Label 753: @34043
     /*  34043 */ GIM_Try, /*On fail goto*//*Label 754*/ GIMT_Encode4(34101), // Rule ID 5342 //
     /*  34048 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsBE),
     /*  34051 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  34054 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  34058 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  34062 */   // (bitconvert:{ *:[v8f16] } MQPR:{ *:[v2f64] }:$src)  =>  (MVE_VREV64_16:{ *:[v8f16] } MQPR:{ *:[v2f64] }:$src)
     /*  34062 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  34065 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  34069 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  34074 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VREV64_16),
     /*  34077 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  34079 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  34081 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  34084 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  34090 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  34096 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  34099 */   GIR_RootConstrainSelectedInstOperands,
     /*  34100 */   // GIR_Coverage, 5342,
     /*  34100 */   GIR_EraseRootFromParent_Done,
     /*  34101 */ // Label 754: @34101
     /*  34101 */ GIM_Try, /*On fail goto*//*Label 755*/ GIMT_Encode4(34159), // Rule ID 5343 //
     /*  34106 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsBE),
     /*  34109 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  34112 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  34116 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  34120 */   // (bitconvert:{ *:[v8f16] } MQPR:{ *:[v2i64] }:$src)  =>  (MVE_VREV64_16:{ *:[v8f16] } MQPR:{ *:[v2i64] }:$src)
     /*  34120 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  34123 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  34127 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  34132 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VREV64_16),
     /*  34135 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  34137 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  34139 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  34142 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  34148 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  34154 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  34157 */   GIR_RootConstrainSelectedInstOperands,
     /*  34158 */   // GIR_Coverage, 5343,
     /*  34158 */   GIR_EraseRootFromParent_Done,
     /*  34159 */ // Label 755: @34159
     /*  34159 */ GIM_Try, /*On fail goto*//*Label 756*/ GIMT_Encode4(34217), // Rule ID 5344 //
     /*  34164 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsBE),
     /*  34167 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  34170 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  34174 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  34178 */   // (bitconvert:{ *:[v8f16] } MQPR:{ *:[v4f32] }:$src)  =>  (MVE_VREV32_16:{ *:[v8f16] } MQPR:{ *:[v4f32] }:$src)
     /*  34178 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  34181 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  34185 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  34190 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VREV32_16),
     /*  34193 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  34195 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  34197 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  34200 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  34206 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  34212 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  34215 */   GIR_RootConstrainSelectedInstOperands,
     /*  34216 */   // GIR_Coverage, 5344,
     /*  34216 */   GIR_EraseRootFromParent_Done,
     /*  34217 */ // Label 756: @34217
     /*  34217 */ GIM_Try, /*On fail goto*//*Label 757*/ GIMT_Encode4(34275), // Rule ID 5345 //
     /*  34222 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsBE),
     /*  34225 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  34228 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  34232 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  34236 */   // (bitconvert:{ *:[v8f16] } MQPR:{ *:[v4i32] }:$src)  =>  (MVE_VREV32_16:{ *:[v8f16] } MQPR:{ *:[v4i32] }:$src)
     /*  34236 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  34239 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  34243 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  34248 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VREV32_16),
     /*  34251 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  34253 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  34255 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  34258 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  34264 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  34270 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  34273 */   GIR_RootConstrainSelectedInstOperands,
     /*  34274 */   // GIR_Coverage, 5345,
     /*  34274 */   GIR_EraseRootFromParent_Done,
     /*  34275 */ // Label 757: @34275
     /*  34275 */ GIM_Try, /*On fail goto*//*Label 758*/ GIMT_Encode4(34333), // Rule ID 5346 //
     /*  34280 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsBE),
     /*  34283 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  34286 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  34290 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  34294 */   // (bitconvert:{ *:[v8f16] } MQPR:{ *:[v16i8] }:$src)  =>  (MVE_VREV16_8:{ *:[v8f16] } MQPR:{ *:[v16i8] }:$src)
     /*  34294 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  34297 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  34301 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  34306 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VREV16_8),
     /*  34309 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  34311 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  34313 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  34316 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  34322 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  34328 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  34331 */   GIR_RootConstrainSelectedInstOperands,
     /*  34332 */   // GIR_Coverage, 5346,
     /*  34332 */   GIR_EraseRootFromParent_Done,
     /*  34333 */ // Label 758: @34333
     /*  34333 */ GIM_Try, /*On fail goto*//*Label 759*/ GIMT_Encode4(34391), // Rule ID 5347 //
     /*  34338 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsBE),
     /*  34341 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  34344 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  34348 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  34352 */   // (bitconvert:{ *:[v8i16] } MQPR:{ *:[v2f64] }:$src)  =>  (MVE_VREV64_16:{ *:[v8i16] } MQPR:{ *:[v2f64] }:$src)
     /*  34352 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  34355 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  34359 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  34364 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VREV64_16),
     /*  34367 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  34369 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  34371 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  34374 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  34380 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  34386 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  34389 */   GIR_RootConstrainSelectedInstOperands,
     /*  34390 */   // GIR_Coverage, 5347,
     /*  34390 */   GIR_EraseRootFromParent_Done,
     /*  34391 */ // Label 759: @34391
     /*  34391 */ GIM_Try, /*On fail goto*//*Label 760*/ GIMT_Encode4(34449), // Rule ID 5348 //
     /*  34396 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsBE),
     /*  34399 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  34402 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  34406 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  34410 */   // (bitconvert:{ *:[v8i16] } MQPR:{ *:[v2i64] }:$src)  =>  (MVE_VREV64_16:{ *:[v8i16] } MQPR:{ *:[v2i64] }:$src)
     /*  34410 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  34413 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  34417 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  34422 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VREV64_16),
     /*  34425 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  34427 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  34429 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  34432 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  34438 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  34444 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  34447 */   GIR_RootConstrainSelectedInstOperands,
     /*  34448 */   // GIR_Coverage, 5348,
     /*  34448 */   GIR_EraseRootFromParent_Done,
     /*  34449 */ // Label 760: @34449
     /*  34449 */ GIM_Try, /*On fail goto*//*Label 761*/ GIMT_Encode4(34507), // Rule ID 5349 //
     /*  34454 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsBE),
     /*  34457 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  34460 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  34464 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  34468 */   // (bitconvert:{ *:[v8i16] } MQPR:{ *:[v4f32] }:$src)  =>  (MVE_VREV32_16:{ *:[v8i16] } MQPR:{ *:[v4f32] }:$src)
     /*  34468 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  34471 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  34475 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  34480 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VREV32_16),
     /*  34483 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  34485 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  34487 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  34490 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  34496 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  34502 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  34505 */   GIR_RootConstrainSelectedInstOperands,
     /*  34506 */   // GIR_Coverage, 5349,
     /*  34506 */   GIR_EraseRootFromParent_Done,
     /*  34507 */ // Label 761: @34507
     /*  34507 */ GIM_Try, /*On fail goto*//*Label 762*/ GIMT_Encode4(34565), // Rule ID 5350 //
     /*  34512 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsBE),
     /*  34515 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  34518 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  34522 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  34526 */   // (bitconvert:{ *:[v8i16] } MQPR:{ *:[v4i32] }:$src)  =>  (MVE_VREV32_16:{ *:[v8i16] } MQPR:{ *:[v4i32] }:$src)
     /*  34526 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  34529 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  34533 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  34538 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VREV32_16),
     /*  34541 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  34543 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  34545 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  34548 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  34554 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  34560 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  34563 */   GIR_RootConstrainSelectedInstOperands,
     /*  34564 */   // GIR_Coverage, 5350,
     /*  34564 */   GIR_EraseRootFromParent_Done,
     /*  34565 */ // Label 762: @34565
     /*  34565 */ GIM_Try, /*On fail goto*//*Label 763*/ GIMT_Encode4(34623), // Rule ID 5351 //
     /*  34570 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsBE),
     /*  34573 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  34576 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  34580 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  34584 */   // (bitconvert:{ *:[v8i16] } MQPR:{ *:[v16i8] }:$src)  =>  (MVE_VREV16_8:{ *:[v8i16] } MQPR:{ *:[v16i8] }:$src)
     /*  34584 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  34587 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  34591 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  34596 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VREV16_8),
     /*  34599 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  34601 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  34603 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  34606 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  34612 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  34618 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  34621 */   GIR_RootConstrainSelectedInstOperands,
     /*  34622 */   // GIR_Coverage, 5351,
     /*  34622 */   GIR_EraseRootFromParent_Done,
     /*  34623 */ // Label 763: @34623
     /*  34623 */ GIM_Reject,
     /*  34624 */ // Label 548: @34624
     /*  34624 */ GIM_Try, /*On fail goto*//*Label 764*/ GIMT_Encode4(34656), // Rule ID 2795 //
     /*  34629 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  34632 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  34635 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  34639 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  34643 */   // (bitconvert:{ *:[v16i8] } QPR:{ *:[v2f64] }:$src)  =>  QPR:{ *:[v16i8] }:$src
     /*  34643 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  34646 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  34648 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  34650 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  34655 */   // GIR_Coverage, 2795,
     /*  34655 */   GIR_EraseRootFromParent_Done,
     /*  34656 */ // Label 764: @34656
     /*  34656 */ GIM_Try, /*On fail goto*//*Label 765*/ GIMT_Encode4(34688), // Rule ID 2796 //
     /*  34661 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  34664 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  34667 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  34671 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  34675 */   // (bitconvert:{ *:[v16i8] } QPR:{ *:[v2i64] }:$src)  =>  QPR:{ *:[v16i8] }:$src
     /*  34675 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  34678 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  34680 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  34682 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  34687 */   // GIR_Coverage, 2796,
     /*  34687 */   GIR_EraseRootFromParent_Done,
     /*  34688 */ // Label 765: @34688
     /*  34688 */ GIM_Try, /*On fail goto*//*Label 766*/ GIMT_Encode4(34720), // Rule ID 2797 //
     /*  34693 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  34696 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  34699 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  34703 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  34707 */   // (bitconvert:{ *:[v16i8] } QPR:{ *:[v4f32] }:$src)  =>  QPR:{ *:[v16i8] }:$src
     /*  34707 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  34710 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  34712 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  34714 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  34719 */   // GIR_Coverage, 2797,
     /*  34719 */   GIR_EraseRootFromParent_Done,
     /*  34720 */ // Label 766: @34720
     /*  34720 */ GIM_Try, /*On fail goto*//*Label 767*/ GIMT_Encode4(34752), // Rule ID 2798 //
     /*  34725 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  34728 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  34731 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  34735 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  34739 */   // (bitconvert:{ *:[v16i8] } QPR:{ *:[v4i32] }:$src)  =>  QPR:{ *:[v16i8] }:$src
     /*  34739 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  34742 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  34744 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  34746 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  34751 */   // GIR_Coverage, 2798,
     /*  34751 */   GIR_EraseRootFromParent_Done,
     /*  34752 */ // Label 767: @34752
     /*  34752 */ GIM_Try, /*On fail goto*//*Label 768*/ GIMT_Encode4(34784), // Rule ID 2799 //
     /*  34757 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  34760 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  34763 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  34767 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  34771 */   // (bitconvert:{ *:[v16i8] } QPR:{ *:[v8f16] }:$src)  =>  QPR:{ *:[v16i8] }:$src
     /*  34771 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  34774 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  34776 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  34778 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  34783 */   // GIR_Coverage, 2799,
     /*  34783 */   GIR_EraseRootFromParent_Done,
     /*  34784 */ // Label 768: @34784
     /*  34784 */ GIM_Try, /*On fail goto*//*Label 769*/ GIMT_Encode4(34816), // Rule ID 2800 //
     /*  34789 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  34792 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  34795 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  34799 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  34803 */   // (bitconvert:{ *:[v16i8] } QPR:{ *:[v8i16] }:$src)  =>  QPR:{ *:[v16i8] }:$src
     /*  34803 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  34806 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  34808 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  34810 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  34815 */   // GIR_Coverage, 2800,
     /*  34815 */   GIR_EraseRootFromParent_Done,
     /*  34816 */ // Label 769: @34816
     /*  34816 */ GIM_Try, /*On fail goto*//*Label 770*/ GIMT_Encode4(34853), // Rule ID 2867 //
     /*  34821 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  34824 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  34827 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  34831 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  34835 */   // (bitconvert:{ *:[v16i8] } QPR:{ *:[v2f64] }:$src)  =>  (VREV64q8:{ *:[v16i8] } QPR:{ *:[v2f64] }:$src)
     /*  34835 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV64q8),
     /*  34838 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  34840 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  34842 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  34845 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  34851 */   GIR_RootConstrainSelectedInstOperands,
     /*  34852 */   // GIR_Coverage, 2867,
     /*  34852 */   GIR_EraseRootFromParent_Done,
     /*  34853 */ // Label 770: @34853
     /*  34853 */ GIM_Try, /*On fail goto*//*Label 771*/ GIMT_Encode4(34890), // Rule ID 2868 //
     /*  34858 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  34861 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  34864 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  34868 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  34872 */   // (bitconvert:{ *:[v16i8] } QPR:{ *:[v2i64] }:$src)  =>  (VREV64q8:{ *:[v16i8] } QPR:{ *:[v2i64] }:$src)
     /*  34872 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV64q8),
     /*  34875 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  34877 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  34879 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  34882 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  34888 */   GIR_RootConstrainSelectedInstOperands,
     /*  34889 */   // GIR_Coverage, 2868,
     /*  34889 */   GIR_EraseRootFromParent_Done,
     /*  34890 */ // Label 771: @34890
     /*  34890 */ GIM_Try, /*On fail goto*//*Label 772*/ GIMT_Encode4(34927), // Rule ID 2869 //
     /*  34895 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  34898 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  34901 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  34905 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  34909 */   // (bitconvert:{ *:[v16i8] } QPR:{ *:[v4f32] }:$src)  =>  (VREV32q8:{ *:[v16i8] } QPR:{ *:[v4f32] }:$src)
     /*  34909 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV32q8),
     /*  34912 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  34914 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  34916 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  34919 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  34925 */   GIR_RootConstrainSelectedInstOperands,
     /*  34926 */   // GIR_Coverage, 2869,
     /*  34926 */   GIR_EraseRootFromParent_Done,
     /*  34927 */ // Label 772: @34927
     /*  34927 */ GIM_Try, /*On fail goto*//*Label 773*/ GIMT_Encode4(34964), // Rule ID 2870 //
     /*  34932 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  34935 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  34938 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  34942 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  34946 */   // (bitconvert:{ *:[v16i8] } QPR:{ *:[v4i32] }:$src)  =>  (VREV32q8:{ *:[v16i8] } QPR:{ *:[v4i32] }:$src)
     /*  34946 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV32q8),
     /*  34949 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  34951 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  34953 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  34956 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  34962 */   GIR_RootConstrainSelectedInstOperands,
     /*  34963 */   // GIR_Coverage, 2870,
     /*  34963 */   GIR_EraseRootFromParent_Done,
     /*  34964 */ // Label 773: @34964
     /*  34964 */ GIM_Try, /*On fail goto*//*Label 774*/ GIMT_Encode4(35001), // Rule ID 2871 //
     /*  34969 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  34972 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  34975 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  34979 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  34983 */   // (bitconvert:{ *:[v16i8] } QPR:{ *:[v8f16] }:$src)  =>  (VREV16q8:{ *:[v16i8] } QPR:{ *:[v8f16] }:$src)
     /*  34983 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV16q8),
     /*  34986 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  34988 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  34990 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  34993 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  34999 */   GIR_RootConstrainSelectedInstOperands,
     /*  35000 */   // GIR_Coverage, 2871,
     /*  35000 */   GIR_EraseRootFromParent_Done,
     /*  35001 */ // Label 774: @35001
     /*  35001 */ GIM_Try, /*On fail goto*//*Label 775*/ GIMT_Encode4(35038), // Rule ID 2872 //
     /*  35006 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  35009 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  35012 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  35016 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  35020 */   // (bitconvert:{ *:[v16i8] } QPR:{ *:[v8i16] }:$src)  =>  (VREV16q8:{ *:[v16i8] } QPR:{ *:[v8i16] }:$src)
     /*  35020 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV16q8),
     /*  35023 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  35025 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  35027 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  35030 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  35036 */   GIR_RootConstrainSelectedInstOperands,
     /*  35037 */   // GIR_Coverage, 2872,
     /*  35037 */   GIR_EraseRootFromParent_Done,
     /*  35038 */ // Label 775: @35038
     /*  35038 */ GIM_Try, /*On fail goto*//*Label 776*/ GIMT_Encode4(35070), // Rule ID 5316 //
     /*  35043 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsLE),
     /*  35046 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  35049 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  35053 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  35057 */   // (bitconvert:{ *:[v16i8] } MQPR:{ *:[v2f64] }:$src)  =>  MQPR:{ *:[v16i8] }:$src
     /*  35057 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  35060 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  35062 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  35064 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::MQPRRegClassID),
     /*  35069 */   // GIR_Coverage, 5316,
     /*  35069 */   GIR_EraseRootFromParent_Done,
     /*  35070 */ // Label 776: @35070
     /*  35070 */ GIM_Try, /*On fail goto*//*Label 777*/ GIMT_Encode4(35102), // Rule ID 5317 //
     /*  35075 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsLE),
     /*  35078 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  35081 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  35085 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  35089 */   // (bitconvert:{ *:[v16i8] } MQPR:{ *:[v2i64] }:$src)  =>  MQPR:{ *:[v16i8] }:$src
     /*  35089 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  35092 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  35094 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  35096 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::MQPRRegClassID),
     /*  35101 */   // GIR_Coverage, 5317,
     /*  35101 */   GIR_EraseRootFromParent_Done,
     /*  35102 */ // Label 777: @35102
     /*  35102 */ GIM_Try, /*On fail goto*//*Label 778*/ GIMT_Encode4(35134), // Rule ID 5318 //
     /*  35107 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsLE),
     /*  35110 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  35113 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  35117 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  35121 */   // (bitconvert:{ *:[v16i8] } MQPR:{ *:[v4f32] }:$src)  =>  MQPR:{ *:[v16i8] }:$src
     /*  35121 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  35124 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  35126 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  35128 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::MQPRRegClassID),
     /*  35133 */   // GIR_Coverage, 5318,
     /*  35133 */   GIR_EraseRootFromParent_Done,
     /*  35134 */ // Label 778: @35134
     /*  35134 */ GIM_Try, /*On fail goto*//*Label 779*/ GIMT_Encode4(35166), // Rule ID 5319 //
     /*  35139 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsLE),
     /*  35142 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  35145 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  35149 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  35153 */   // (bitconvert:{ *:[v16i8] } MQPR:{ *:[v4i32] }:$src)  =>  MQPR:{ *:[v16i8] }:$src
     /*  35153 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  35156 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  35158 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  35160 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::MQPRRegClassID),
     /*  35165 */   // GIR_Coverage, 5319,
     /*  35165 */   GIR_EraseRootFromParent_Done,
     /*  35166 */ // Label 779: @35166
     /*  35166 */ GIM_Try, /*On fail goto*//*Label 780*/ GIMT_Encode4(35198), // Rule ID 5320 //
     /*  35171 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsLE),
     /*  35174 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  35177 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  35181 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  35185 */   // (bitconvert:{ *:[v16i8] } MQPR:{ *:[v8f16] }:$src)  =>  MQPR:{ *:[v16i8] }:$src
     /*  35185 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  35188 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  35190 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  35192 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::MQPRRegClassID),
     /*  35197 */   // GIR_Coverage, 5320,
     /*  35197 */   GIR_EraseRootFromParent_Done,
     /*  35198 */ // Label 780: @35198
     /*  35198 */ GIM_Try, /*On fail goto*//*Label 781*/ GIMT_Encode4(35230), // Rule ID 5321 //
     /*  35203 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsLE),
     /*  35206 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  35209 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  35213 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  35217 */   // (bitconvert:{ *:[v16i8] } MQPR:{ *:[v8i16] }:$src)  =>  MQPR:{ *:[v16i8] }:$src
     /*  35217 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  35220 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  35222 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  35224 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::MQPRRegClassID),
     /*  35229 */   // GIR_Coverage, 5321,
     /*  35229 */   GIR_EraseRootFromParent_Done,
     /*  35230 */ // Label 781: @35230
     /*  35230 */ GIM_Try, /*On fail goto*//*Label 782*/ GIMT_Encode4(35288), // Rule ID 5352 //
     /*  35235 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsBE),
     /*  35238 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  35241 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  35245 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  35249 */   // (bitconvert:{ *:[v16i8] } MQPR:{ *:[v2f64] }:$src)  =>  (MVE_VREV64_8:{ *:[v16i8] } MQPR:{ *:[v2f64] }:$src)
     /*  35249 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  35252 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  35256 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  35261 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VREV64_8),
     /*  35264 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  35266 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  35268 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  35271 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  35277 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  35283 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  35286 */   GIR_RootConstrainSelectedInstOperands,
     /*  35287 */   // GIR_Coverage, 5352,
     /*  35287 */   GIR_EraseRootFromParent_Done,
     /*  35288 */ // Label 782: @35288
     /*  35288 */ GIM_Try, /*On fail goto*//*Label 783*/ GIMT_Encode4(35346), // Rule ID 5353 //
     /*  35293 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsBE),
     /*  35296 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  35299 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  35303 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  35307 */   // (bitconvert:{ *:[v16i8] } MQPR:{ *:[v2i64] }:$src)  =>  (MVE_VREV64_8:{ *:[v16i8] } MQPR:{ *:[v2i64] }:$src)
     /*  35307 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  35310 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  35314 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  35319 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VREV64_8),
     /*  35322 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  35324 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  35326 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  35329 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  35335 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  35341 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  35344 */   GIR_RootConstrainSelectedInstOperands,
     /*  35345 */   // GIR_Coverage, 5353,
     /*  35345 */   GIR_EraseRootFromParent_Done,
     /*  35346 */ // Label 783: @35346
     /*  35346 */ GIM_Try, /*On fail goto*//*Label 784*/ GIMT_Encode4(35404), // Rule ID 5354 //
     /*  35351 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsBE),
     /*  35354 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  35357 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  35361 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  35365 */   // (bitconvert:{ *:[v16i8] } MQPR:{ *:[v4f32] }:$src)  =>  (MVE_VREV32_8:{ *:[v16i8] } MQPR:{ *:[v4f32] }:$src)
     /*  35365 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  35368 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  35372 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  35377 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VREV32_8),
     /*  35380 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  35382 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  35384 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  35387 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  35393 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  35399 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  35402 */   GIR_RootConstrainSelectedInstOperands,
     /*  35403 */   // GIR_Coverage, 5354,
     /*  35403 */   GIR_EraseRootFromParent_Done,
     /*  35404 */ // Label 784: @35404
     /*  35404 */ GIM_Try, /*On fail goto*//*Label 785*/ GIMT_Encode4(35462), // Rule ID 5355 //
     /*  35409 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsBE),
     /*  35412 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  35415 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  35419 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  35423 */   // (bitconvert:{ *:[v16i8] } MQPR:{ *:[v4i32] }:$src)  =>  (MVE_VREV32_8:{ *:[v16i8] } MQPR:{ *:[v4i32] }:$src)
     /*  35423 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  35426 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  35430 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  35435 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VREV32_8),
     /*  35438 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  35440 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  35442 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  35445 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  35451 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  35457 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  35460 */   GIR_RootConstrainSelectedInstOperands,
     /*  35461 */   // GIR_Coverage, 5355,
     /*  35461 */   GIR_EraseRootFromParent_Done,
     /*  35462 */ // Label 785: @35462
     /*  35462 */ GIM_Try, /*On fail goto*//*Label 786*/ GIMT_Encode4(35520), // Rule ID 5356 //
     /*  35467 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsBE),
     /*  35470 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  35473 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  35477 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  35481 */   // (bitconvert:{ *:[v16i8] } MQPR:{ *:[v8f16] }:$src)  =>  (MVE_VREV16_8:{ *:[v16i8] } MQPR:{ *:[v8f16] }:$src)
     /*  35481 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  35484 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  35488 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  35493 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VREV16_8),
     /*  35496 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  35498 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  35500 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  35503 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  35509 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  35515 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  35518 */   GIR_RootConstrainSelectedInstOperands,
     /*  35519 */   // GIR_Coverage, 5356,
     /*  35519 */   GIR_EraseRootFromParent_Done,
     /*  35520 */ // Label 786: @35520
     /*  35520 */ GIM_Try, /*On fail goto*//*Label 787*/ GIMT_Encode4(35578), // Rule ID 5357 //
     /*  35525 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsBE),
     /*  35528 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  35531 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  35535 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  35539 */   // (bitconvert:{ *:[v16i8] } MQPR:{ *:[v8i16] }:$src)  =>  (MVE_VREV16_8:{ *:[v16i8] } MQPR:{ *:[v8i16] }:$src)
     /*  35539 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  35542 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  35546 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  35551 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VREV16_8),
     /*  35554 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  35556 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  35558 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  35561 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  35567 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  35573 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  35576 */   GIR_RootConstrainSelectedInstOperands,
     /*  35577 */   // GIR_Coverage, 5357,
     /*  35577 */   GIR_EraseRootFromParent_Done,
     /*  35578 */ // Label 787: @35578
     /*  35578 */ GIM_Reject,
     /*  35579 */ // Label 549: @35579
     /*  35579 */ GIM_Reject,
     /*  35580 */ // Label 10: @35580
     /*  35580 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(13), /*)*//*default:*//*Label 795*/ GIMT_Encode4(35987),
     /*  35591 */ /*GILLT_s16*//*Label 788*/ GIMT_Encode4(35643),
     /*  35595 */ /*GILLT_s32*//*Label 789*/ GIMT_Encode4(35681),
     /*  35599 */ /*GILLT_s64*//*Label 790*/ GIMT_Encode4(35719), GIMT_Encode4(0),
     /*  35607 */ /*GILLT_v2s32*//*Label 791*/ GIMT_Encode4(35757), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  35619 */ /*GILLT_v4s16*//*Label 792*/ GIMT_Encode4(35784),
     /*  35623 */ /*GILLT_v4s32*//*Label 793*/ GIMT_Encode4(35811), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  35639 */ /*GILLT_v8s16*//*Label 794*/ GIMT_Encode4(35899),
     /*  35643 */ // Label 788: @35643
     /*  35643 */ GIM_Try, /*On fail goto*//*Label 796*/ GIMT_Encode4(35680), // Rule ID 665 //
     /*  35648 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /*  35651 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /*  35654 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /*  35658 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /*  35662 */   // (ftrunc:{ *:[f16] } HPR:{ *:[f16] }:$Sm)  =>  (VRINTZH:{ *:[f16] } HPR:{ *:[f16] }:$Sm)
     /*  35662 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRINTZH),
     /*  35665 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /*  35667 */   GIR_RootToRootCopy, /*OpIdx*/1, // Sm
     /*  35669 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  35672 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  35678 */   GIR_RootConstrainSelectedInstOperands,
     /*  35679 */   // GIR_Coverage, 665,
     /*  35679 */   GIR_EraseRootFromParent_Done,
     /*  35680 */ // Label 796: @35680
     /*  35680 */ GIM_Reject,
     /*  35681 */ // Label 789: @35681
     /*  35681 */ GIM_Try, /*On fail goto*//*Label 797*/ GIMT_Encode4(35718), // Rule ID 666 //
     /*  35686 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /*  35689 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  35692 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /*  35696 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /*  35700 */   // (ftrunc:{ *:[f32] } SPR:{ *:[f32] }:$Sm)  =>  (VRINTZS:{ *:[f32] } SPR:{ *:[f32] }:$Sm)
     /*  35700 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRINTZS),
     /*  35703 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /*  35705 */   GIR_RootToRootCopy, /*OpIdx*/1, // Sm
     /*  35707 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  35710 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  35716 */   GIR_RootConstrainSelectedInstOperands,
     /*  35717 */   // GIR_Coverage, 666,
     /*  35717 */   GIR_EraseRootFromParent_Done,
     /*  35718 */ // Label 797: @35718
     /*  35718 */ GIM_Reject,
     /*  35719 */ // Label 790: @35719
     /*  35719 */ GIM_Try, /*On fail goto*//*Label 798*/ GIMT_Encode4(35756), // Rule ID 667 //
     /*  35724 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDPVFP_HasFPARMv8),
     /*  35727 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  35730 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  35734 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  35738 */   // (ftrunc:{ *:[f64] } DPR:{ *:[f64] }:$Dm)  =>  (VRINTZD:{ *:[f64] } DPR:{ *:[f64] }:$Dm)
     /*  35738 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRINTZD),
     /*  35741 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Dd]
     /*  35743 */   GIR_RootToRootCopy, /*OpIdx*/1, // Dm
     /*  35745 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  35748 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  35754 */   GIR_RootConstrainSelectedInstOperands,
     /*  35755 */   // GIR_Coverage, 667,
     /*  35755 */   GIR_EraseRootFromParent_Done,
     /*  35756 */ // Label 798: @35756
     /*  35756 */ GIM_Reject,
     /*  35757 */ // Label 791: @35757
     /*  35757 */ GIM_Try, /*On fail goto*//*Label 799*/ GIMT_Encode4(35783), // Rule ID 1700 //
     /*  35762 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasV8),
     /*  35765 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  35768 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  35772 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  35776 */   // (ftrunc:{ *:[v2f32] } DPR:{ *:[v2f32] }:$Vm)  =>  (VRINTZNDf:{ *:[v2f32] } DPR:{ *:[v2f32] }:$Vm)
     /*  35776 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(ARM::VRINTZNDf),
     /*  35781 */   GIR_RootConstrainSelectedInstOperands,
     /*  35782 */   // GIR_Coverage, 1700,
     /*  35782 */   GIR_Done,
     /*  35783 */ // Label 799: @35783
     /*  35783 */ GIM_Reject,
     /*  35784 */ // Label 792: @35784
     /*  35784 */ GIM_Try, /*On fail goto*//*Label 800*/ GIMT_Encode4(35810), // Rule ID 1702 //
     /*  35789 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON_HasV8),
     /*  35792 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  35795 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  35799 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  35803 */   // (ftrunc:{ *:[v4f16] } DPR:{ *:[v4f16] }:$Vm)  =>  (VRINTZNDh:{ *:[v4f16] } DPR:{ *:[v4f16] }:$Vm)
     /*  35803 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(ARM::VRINTZNDh),
     /*  35808 */   GIR_RootConstrainSelectedInstOperands,
     /*  35809 */   // GIR_Coverage, 1702,
     /*  35809 */   GIR_Done,
     /*  35810 */ // Label 800: @35810
     /*  35810 */ GIM_Reject,
     /*  35811 */ // Label 793: @35811
     /*  35811 */ GIM_Try, /*On fail goto*//*Label 801*/ GIMT_Encode4(35898),
     /*  35816 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  35819 */   GIM_Try, /*On fail goto*//*Label 802*/ GIMT_Encode4(35842), // Rule ID 1701 //
     /*  35824 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasV8),
     /*  35827 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  35831 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  35835 */     // (ftrunc:{ *:[v4f32] } QPR:{ *:[v4f32] }:$Vm)  =>  (VRINTZNQf:{ *:[v4f32] } QPR:{ *:[v4f32] }:$Vm)
     /*  35835 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(ARM::VRINTZNQf),
     /*  35840 */     GIR_RootConstrainSelectedInstOperands,
     /*  35841 */     // GIR_Coverage, 1701,
     /*  35841 */     GIR_Done,
     /*  35842 */   // Label 802: @35842
     /*  35842 */   GIM_Try, /*On fail goto*//*Label 803*/ GIMT_Encode4(35897), // Rule ID 3979 //
     /*  35847 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  35850 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  35854 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  35858 */     // (ftrunc:{ *:[v4f32] } MQPR:{ *:[v4f32] }:$val)  =>  (MVE_VRINTf32Z:{ *:[v4f32] } MQPR:{ *:[v4f32] }:$val)
     /*  35858 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  35861 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  35865 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  35870 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRINTf32Z),
     /*  35873 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  35875 */     GIR_RootToRootCopy, /*OpIdx*/1, // val
     /*  35877 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  35880 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  35886 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  35892 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  35895 */     GIR_RootConstrainSelectedInstOperands,
     /*  35896 */     // GIR_Coverage, 3979,
     /*  35896 */     GIR_EraseRootFromParent_Done,
     /*  35897 */   // Label 803: @35897
     /*  35897 */   GIM_Reject,
     /*  35898 */ // Label 801: @35898
     /*  35898 */ GIM_Reject,
     /*  35899 */ // Label 794: @35899
     /*  35899 */ GIM_Try, /*On fail goto*//*Label 804*/ GIMT_Encode4(35986),
     /*  35904 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  35907 */   GIM_Try, /*On fail goto*//*Label 805*/ GIMT_Encode4(35930), // Rule ID 1703 //
     /*  35912 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON_HasV8),
     /*  35915 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  35919 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  35923 */     // (ftrunc:{ *:[v8f16] } QPR:{ *:[v8f16] }:$Vm)  =>  (VRINTZNQh:{ *:[v8f16] } QPR:{ *:[v8f16] }:$Vm)
     /*  35923 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(ARM::VRINTZNQh),
     /*  35928 */     GIR_RootConstrainSelectedInstOperands,
     /*  35929 */     // GIR_Coverage, 1703,
     /*  35929 */     GIR_Done,
     /*  35930 */   // Label 805: @35930
     /*  35930 */   GIM_Try, /*On fail goto*//*Label 806*/ GIMT_Encode4(35985), // Rule ID 3967 //
     /*  35935 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  35938 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  35942 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  35946 */     // (ftrunc:{ *:[v8f16] } MQPR:{ *:[v8f16] }:$val)  =>  (MVE_VRINTf16Z:{ *:[v8f16] } MQPR:{ *:[v8f16] }:$val)
     /*  35946 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  35949 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  35953 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  35958 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRINTf16Z),
     /*  35961 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  35963 */     GIR_RootToRootCopy, /*OpIdx*/1, // val
     /*  35965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  35968 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  35974 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  35980 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  35983 */     GIR_RootConstrainSelectedInstOperands,
     /*  35984 */     // GIR_Coverage, 3967,
     /*  35984 */     GIR_EraseRootFromParent_Done,
     /*  35985 */   // Label 806: @35985
     /*  35985 */   GIM_Reject,
     /*  35986 */ // Label 804: @35986
     /*  35986 */ GIM_Reject,
     /*  35987 */ // Label 795: @35987
     /*  35987 */ GIM_Reject,
     /*  35988 */ // Label 11: @35988
     /*  35988 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(13), /*)*//*default:*//*Label 814*/ GIMT_Encode4(36362),
     /*  35999 */ /*GILLT_s16*//*Label 807*/ GIMT_Encode4(36051),
     /*  36003 */ /*GILLT_s32*//*Label 808*/ GIMT_Encode4(36078),
     /*  36007 */ /*GILLT_s64*//*Label 809*/ GIMT_Encode4(36105), GIMT_Encode4(0),
     /*  36015 */ /*GILLT_v2s32*//*Label 810*/ GIMT_Encode4(36132), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  36027 */ /*GILLT_v4s16*//*Label 811*/ GIMT_Encode4(36159),
     /*  36031 */ /*GILLT_v4s32*//*Label 812*/ GIMT_Encode4(36186), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  36047 */ /*GILLT_v8s16*//*Label 813*/ GIMT_Encode4(36274),
     /*  36051 */ // Label 807: @36051
     /*  36051 */ GIM_Try, /*On fail goto*//*Label 815*/ GIMT_Encode4(36077), // Rule ID 674 //
     /*  36056 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /*  36059 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /*  36062 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /*  36066 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /*  36070 */   // (fround:{ *:[f16] } HPR:{ *:[f16] }:$Sm)  =>  (VRINTAH:{ *:[f16] } HPR:{ *:[f16] }:$Sm)
     /*  36070 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(ARM::VRINTAH),
     /*  36075 */   GIR_RootConstrainSelectedInstOperands,
     /*  36076 */   // GIR_Coverage, 674,
     /*  36076 */   GIR_Done,
     /*  36077 */ // Label 815: @36077
     /*  36077 */ GIM_Reject,
     /*  36078 */ // Label 808: @36078
     /*  36078 */ GIM_Try, /*On fail goto*//*Label 816*/ GIMT_Encode4(36104), // Rule ID 675 //
     /*  36083 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /*  36086 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  36089 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /*  36093 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /*  36097 */   // (fround:{ *:[f32] } SPR:{ *:[f32] }:$Sm)  =>  (VRINTAS:{ *:[f32] } SPR:{ *:[f32] }:$Sm)
     /*  36097 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(ARM::VRINTAS),
     /*  36102 */   GIR_RootConstrainSelectedInstOperands,
     /*  36103 */   // GIR_Coverage, 675,
     /*  36103 */   GIR_Done,
     /*  36104 */ // Label 816: @36104
     /*  36104 */ GIM_Reject,
     /*  36105 */ // Label 809: @36105
     /*  36105 */ GIM_Try, /*On fail goto*//*Label 817*/ GIMT_Encode4(36131), // Rule ID 676 //
     /*  36110 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDPVFP_HasFPARMv8),
     /*  36113 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  36116 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  36120 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  36124 */   // (fround:{ *:[f64] } DPR:{ *:[f64] }:$Dm)  =>  (VRINTAD:{ *:[f64] } DPR:{ *:[f64] }:$Dm)
     /*  36124 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(ARM::VRINTAD),
     /*  36129 */   GIR_RootConstrainSelectedInstOperands,
     /*  36130 */   // GIR_Coverage, 676,
     /*  36130 */   GIR_Done,
     /*  36131 */ // Label 817: @36131
     /*  36131 */ GIM_Reject,
     /*  36132 */ // Label 810: @36132
     /*  36132 */ GIM_Try, /*On fail goto*//*Label 818*/ GIMT_Encode4(36158), // Rule ID 1696 //
     /*  36137 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasV8),
     /*  36140 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  36143 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  36147 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  36151 */   // (fround:{ *:[v2f32] } DPR:{ *:[v2f32] }:$Vm)  =>  (VRINTANDf:{ *:[v2f32] } DPR:{ *:[v2f32] }:$Vm)
     /*  36151 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(ARM::VRINTANDf),
     /*  36156 */   GIR_RootConstrainSelectedInstOperands,
     /*  36157 */   // GIR_Coverage, 1696,
     /*  36157 */   GIR_Done,
     /*  36158 */ // Label 818: @36158
     /*  36158 */ GIM_Reject,
     /*  36159 */ // Label 811: @36159
     /*  36159 */ GIM_Try, /*On fail goto*//*Label 819*/ GIMT_Encode4(36185), // Rule ID 1698 //
     /*  36164 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON_HasV8),
     /*  36167 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  36170 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  36174 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  36178 */   // (fround:{ *:[v4f16] } DPR:{ *:[v4f16] }:$Vm)  =>  (VRINTANDh:{ *:[v4f16] } DPR:{ *:[v4f16] }:$Vm)
     /*  36178 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(ARM::VRINTANDh),
     /*  36183 */   GIR_RootConstrainSelectedInstOperands,
     /*  36184 */   // GIR_Coverage, 1698,
     /*  36184 */   GIR_Done,
     /*  36185 */ // Label 819: @36185
     /*  36185 */ GIM_Reject,
     /*  36186 */ // Label 812: @36186
     /*  36186 */ GIM_Try, /*On fail goto*//*Label 820*/ GIMT_Encode4(36273),
     /*  36191 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  36194 */   GIM_Try, /*On fail goto*//*Label 821*/ GIMT_Encode4(36217), // Rule ID 1697 //
     /*  36199 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasV8),
     /*  36202 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  36206 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  36210 */     // (fround:{ *:[v4f32] } QPR:{ *:[v4f32] }:$Vm)  =>  (VRINTANQf:{ *:[v4f32] } QPR:{ *:[v4f32] }:$Vm)
     /*  36210 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(ARM::VRINTANQf),
     /*  36215 */     GIR_RootConstrainSelectedInstOperands,
     /*  36216 */     // GIR_Coverage, 1697,
     /*  36216 */     GIR_Done,
     /*  36217 */   // Label 821: @36217
     /*  36217 */   GIM_Try, /*On fail goto*//*Label 822*/ GIMT_Encode4(36272), // Rule ID 3977 //
     /*  36222 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  36225 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  36229 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  36233 */     // (fround:{ *:[v4f32] } MQPR:{ *:[v4f32] }:$val)  =>  (MVE_VRINTf32A:{ *:[v4f32] } MQPR:{ *:[v4f32] }:$val)
     /*  36233 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  36236 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  36240 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  36245 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRINTf32A),
     /*  36248 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  36250 */     GIR_RootToRootCopy, /*OpIdx*/1, // val
     /*  36252 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  36255 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  36261 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  36267 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  36270 */     GIR_RootConstrainSelectedInstOperands,
     /*  36271 */     // GIR_Coverage, 3977,
     /*  36271 */     GIR_EraseRootFromParent_Done,
     /*  36272 */   // Label 822: @36272
     /*  36272 */   GIM_Reject,
     /*  36273 */ // Label 820: @36273
     /*  36273 */ GIM_Reject,
     /*  36274 */ // Label 813: @36274
     /*  36274 */ GIM_Try, /*On fail goto*//*Label 823*/ GIMT_Encode4(36361),
     /*  36279 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  36282 */   GIM_Try, /*On fail goto*//*Label 824*/ GIMT_Encode4(36305), // Rule ID 1699 //
     /*  36287 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON_HasV8),
     /*  36290 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  36294 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  36298 */     // (fround:{ *:[v8f16] } QPR:{ *:[v8f16] }:$Vm)  =>  (VRINTANQh:{ *:[v8f16] } QPR:{ *:[v8f16] }:$Vm)
     /*  36298 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(ARM::VRINTANQh),
     /*  36303 */     GIR_RootConstrainSelectedInstOperands,
     /*  36304 */     // GIR_Coverage, 1699,
     /*  36304 */     GIR_Done,
     /*  36305 */   // Label 824: @36305
     /*  36305 */   GIM_Try, /*On fail goto*//*Label 825*/ GIMT_Encode4(36360), // Rule ID 3965 //
     /*  36310 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  36313 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  36317 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  36321 */     // (fround:{ *:[v8f16] } MQPR:{ *:[v8f16] }:$val)  =>  (MVE_VRINTf16A:{ *:[v8f16] } MQPR:{ *:[v8f16] }:$val)
     /*  36321 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  36324 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  36328 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  36333 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRINTf16A),
     /*  36336 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  36338 */     GIR_RootToRootCopy, /*OpIdx*/1, // val
     /*  36340 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  36343 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  36349 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  36355 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  36358 */     GIR_RootConstrainSelectedInstOperands,
     /*  36359 */     // GIR_Coverage, 3965,
     /*  36359 */     GIR_EraseRootFromParent_Done,
     /*  36360 */   // Label 825: @36360
     /*  36360 */   GIM_Reject,
     /*  36361 */ // Label 823: @36361
     /*  36361 */ GIM_Reject,
     /*  36362 */ // Label 814: @36362
     /*  36362 */ GIM_Reject,
     /*  36363 */ // Label 12: @36363
     /*  36363 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(13), /*)*//*default:*//*Label 833*/ GIMT_Encode4(36737),
     /*  36374 */ /*GILLT_s16*//*Label 826*/ GIMT_Encode4(36426),
     /*  36378 */ /*GILLT_s32*//*Label 827*/ GIMT_Encode4(36453),
     /*  36382 */ /*GILLT_s64*//*Label 828*/ GIMT_Encode4(36480), GIMT_Encode4(0),
     /*  36390 */ /*GILLT_v2s32*//*Label 829*/ GIMT_Encode4(36507), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  36402 */ /*GILLT_v4s16*//*Label 830*/ GIMT_Encode4(36534),
     /*  36406 */ /*GILLT_v4s32*//*Label 831*/ GIMT_Encode4(36561), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  36422 */ /*GILLT_v8s16*//*Label 832*/ GIMT_Encode4(36649),
     /*  36426 */ // Label 826: @36426
     /*  36426 */ GIM_Try, /*On fail goto*//*Label 834*/ GIMT_Encode4(36452), // Rule ID 677 //
     /*  36431 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /*  36434 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /*  36437 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /*  36441 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /*  36445 */   // (froundeven:{ *:[f16] } HPR:{ *:[f16] }:$Sm)  =>  (VRINTNH:{ *:[f16] } HPR:{ *:[f16] }:$Sm)
     /*  36445 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(ARM::VRINTNH),
     /*  36450 */   GIR_RootConstrainSelectedInstOperands,
     /*  36451 */   // GIR_Coverage, 677,
     /*  36451 */   GIR_Done,
     /*  36452 */ // Label 834: @36452
     /*  36452 */ GIM_Reject,
     /*  36453 */ // Label 827: @36453
     /*  36453 */ GIM_Try, /*On fail goto*//*Label 835*/ GIMT_Encode4(36479), // Rule ID 678 //
     /*  36458 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /*  36461 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  36464 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /*  36468 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /*  36472 */   // (froundeven:{ *:[f32] } SPR:{ *:[f32] }:$Sm)  =>  (VRINTNS:{ *:[f32] } SPR:{ *:[f32] }:$Sm)
     /*  36472 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(ARM::VRINTNS),
     /*  36477 */   GIR_RootConstrainSelectedInstOperands,
     /*  36478 */   // GIR_Coverage, 678,
     /*  36478 */   GIR_Done,
     /*  36479 */ // Label 835: @36479
     /*  36479 */ GIM_Reject,
     /*  36480 */ // Label 828: @36480
     /*  36480 */ GIM_Try, /*On fail goto*//*Label 836*/ GIMT_Encode4(36506), // Rule ID 679 //
     /*  36485 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDPVFP_HasFPARMv8),
     /*  36488 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  36491 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  36495 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  36499 */   // (froundeven:{ *:[f64] } DPR:{ *:[f64] }:$Dm)  =>  (VRINTND:{ *:[f64] } DPR:{ *:[f64] }:$Dm)
     /*  36499 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(ARM::VRINTND),
     /*  36504 */   GIR_RootConstrainSelectedInstOperands,
     /*  36505 */   // GIR_Coverage, 679,
     /*  36505 */   GIR_Done,
     /*  36506 */ // Label 836: @36506
     /*  36506 */ GIM_Reject,
     /*  36507 */ // Label 829: @36507
     /*  36507 */ GIM_Try, /*On fail goto*//*Label 837*/ GIMT_Encode4(36533), // Rule ID 1688 //
     /*  36512 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasV8),
     /*  36515 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  36518 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  36522 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  36526 */   // (froundeven:{ *:[v2f32] } DPR:{ *:[v2f32] }:$Vm)  =>  (VRINTNNDf:{ *:[v2f32] } DPR:{ *:[v2f32] }:$Vm)
     /*  36526 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(ARM::VRINTNNDf),
     /*  36531 */   GIR_RootConstrainSelectedInstOperands,
     /*  36532 */   // GIR_Coverage, 1688,
     /*  36532 */   GIR_Done,
     /*  36533 */ // Label 837: @36533
     /*  36533 */ GIM_Reject,
     /*  36534 */ // Label 830: @36534
     /*  36534 */ GIM_Try, /*On fail goto*//*Label 838*/ GIMT_Encode4(36560), // Rule ID 1690 //
     /*  36539 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON_HasV8),
     /*  36542 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  36545 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  36549 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  36553 */   // (froundeven:{ *:[v4f16] } DPR:{ *:[v4f16] }:$Vm)  =>  (VRINTNNDh:{ *:[v4f16] } DPR:{ *:[v4f16] }:$Vm)
     /*  36553 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(ARM::VRINTNNDh),
     /*  36558 */   GIR_RootConstrainSelectedInstOperands,
     /*  36559 */   // GIR_Coverage, 1690,
     /*  36559 */   GIR_Done,
     /*  36560 */ // Label 838: @36560
     /*  36560 */ GIM_Reject,
     /*  36561 */ // Label 831: @36561
     /*  36561 */ GIM_Try, /*On fail goto*//*Label 839*/ GIMT_Encode4(36648),
     /*  36566 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  36569 */   GIM_Try, /*On fail goto*//*Label 840*/ GIMT_Encode4(36592), // Rule ID 1689 //
     /*  36574 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasV8),
     /*  36577 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  36581 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  36585 */     // (froundeven:{ *:[v4f32] } QPR:{ *:[v4f32] }:$Vm)  =>  (VRINTNNQf:{ *:[v4f32] } QPR:{ *:[v4f32] }:$Vm)
     /*  36585 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(ARM::VRINTNNQf),
     /*  36590 */     GIR_RootConstrainSelectedInstOperands,
     /*  36591 */     // GIR_Coverage, 1689,
     /*  36591 */     GIR_Done,
     /*  36592 */   // Label 840: @36592
     /*  36592 */   GIM_Try, /*On fail goto*//*Label 841*/ GIMT_Encode4(36647), // Rule ID 3973 //
     /*  36597 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  36600 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  36604 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  36608 */     // (froundeven:{ *:[v4f32] } MQPR:{ *:[v4f32] }:$val)  =>  (MVE_VRINTf32N:{ *:[v4f32] } MQPR:{ *:[v4f32] }:$val)
     /*  36608 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  36611 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  36615 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  36620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRINTf32N),
     /*  36623 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  36625 */     GIR_RootToRootCopy, /*OpIdx*/1, // val
     /*  36627 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  36630 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  36636 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  36642 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  36645 */     GIR_RootConstrainSelectedInstOperands,
     /*  36646 */     // GIR_Coverage, 3973,
     /*  36646 */     GIR_EraseRootFromParent_Done,
     /*  36647 */   // Label 841: @36647
     /*  36647 */   GIM_Reject,
     /*  36648 */ // Label 839: @36648
     /*  36648 */ GIM_Reject,
     /*  36649 */ // Label 832: @36649
     /*  36649 */ GIM_Try, /*On fail goto*//*Label 842*/ GIMT_Encode4(36736),
     /*  36654 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  36657 */   GIM_Try, /*On fail goto*//*Label 843*/ GIMT_Encode4(36680), // Rule ID 1691 //
     /*  36662 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON_HasV8),
     /*  36665 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  36669 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  36673 */     // (froundeven:{ *:[v8f16] } QPR:{ *:[v8f16] }:$Vm)  =>  (VRINTNNQh:{ *:[v8f16] } QPR:{ *:[v8f16] }:$Vm)
     /*  36673 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(ARM::VRINTNNQh),
     /*  36678 */     GIR_RootConstrainSelectedInstOperands,
     /*  36679 */     // GIR_Coverage, 1691,
     /*  36679 */     GIR_Done,
     /*  36680 */   // Label 843: @36680
     /*  36680 */   GIM_Try, /*On fail goto*//*Label 844*/ GIMT_Encode4(36735), // Rule ID 3961 //
     /*  36685 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  36688 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  36692 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  36696 */     // (froundeven:{ *:[v8f16] } MQPR:{ *:[v8f16] }:$val)  =>  (MVE_VRINTf16N:{ *:[v8f16] } MQPR:{ *:[v8f16] }:$val)
     /*  36696 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  36699 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  36703 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  36708 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRINTf16N),
     /*  36711 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  36713 */     GIR_RootToRootCopy, /*OpIdx*/1, // val
     /*  36715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  36718 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  36724 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  36730 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  36733 */     GIR_RootConstrainSelectedInstOperands,
     /*  36734 */     // GIR_Coverage, 3961,
     /*  36734 */     GIR_EraseRootFromParent_Done,
     /*  36735 */   // Label 844: @36735
     /*  36735 */   GIM_Reject,
     /*  36736 */ // Label 842: @36736
     /*  36736 */ GIM_Reject,
     /*  36737 */ // Label 833: @36737
     /*  36737 */ GIM_Reject,
     /*  36738 */ // Label 13: @36738
     /*  36738 */ GIM_Try, /*On fail goto*//*Label 845*/ GIMT_Encode4(36900),
     /*  36743 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  36746 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  36749 */   GIM_Try, /*On fail goto*//*Label 846*/ GIMT_Encode4(36824), // Rule ID 2050 //
     /*  36754 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsThumb_IsThumb1Only),
     /*  36757 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  36764 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /*  36768 */     // MIs[0] Rn
     /*  36768 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  36772 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /*  36776 */     // (ld:{ *:[i32] } tGPR:{ *:[i32] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>>  =>  (tLDRSB:{ *:[i32] } tGPR:{ *:[i32] }:$Rn, (tMOVi8:{ *:[i32] } 0:{ *:[i32] }))
     /*  36776 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  36779 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::tMOVi8),
     /*  36783 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  36788 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::CPSR), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define | RegState::Dead),
     /*  36794 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /*  36797 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/14,
     /*  36800 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  36806 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  36808 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::tLDRSB),
     /*  36811 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  36813 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  36815 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  36818 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  36822 */     GIR_RootConstrainSelectedInstOperands,
     /*  36823 */     // GIR_Coverage, 2050,
     /*  36823 */     GIR_EraseRootFromParent_Done,
     /*  36824 */   // Label 846: @36824
     /*  36824 */   GIM_Try, /*On fail goto*//*Label 847*/ GIMT_Encode4(36899), // Rule ID 2051 //
     /*  36829 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsThumb_IsThumb1Only),
     /*  36832 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  36839 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /*  36843 */     // MIs[0] Rn
     /*  36843 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  36847 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /*  36851 */     // (ld:{ *:[i32] } tGPR:{ *:[i32] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>>  =>  (tLDRSH:{ *:[i32] } tGPR:{ *:[i32] }:$Rn, (tMOVi8:{ *:[i32] } 0:{ *:[i32] }))
     /*  36851 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  36854 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::tMOVi8),
     /*  36858 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  36863 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::CPSR), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define | RegState::Dead),
     /*  36869 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /*  36872 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/14,
     /*  36875 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  36881 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  36883 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::tLDRSH),
     /*  36886 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  36888 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  36890 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  36893 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  36897 */     GIR_RootConstrainSelectedInstOperands,
     /*  36898 */     // GIR_Coverage, 2051,
     /*  36898 */     GIR_EraseRootFromParent_Done,
     /*  36899 */   // Label 847: @36899
     /*  36899 */   GIM_Reject,
     /*  36900 */ // Label 845: @36900
     /*  36900 */ GIM_Reject,
     /*  36901 */ // Label 14: @36901
     /*  36901 */ GIM_Try, /*On fail goto*//*Label 848*/ GIMT_Encode4(36921), // Rule ID 5418 //
     /*  36906 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  36909 */   // MIs[0] Operand 0
     /*  36909 */   GIM_CheckIsImm, /*MI*/0, /*Op*/0,
     /*  36912 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/1, 0,
     /*  36916 */   // (atomic_fence (timm:{ *:[i32] }), 0:{ *:[i32] })  =>  (MEMBARRIER)
     /*  36916 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::MEMBARRIER),
     /*  36919 */   GIR_RootConstrainSelectedInstOperands,
     /*  36920 */   // GIR_Coverage, 5418,
     /*  36920 */   GIR_EraseRootFromParent_Done,
     /*  36921 */ // Label 848: @36921
     /*  36921 */ GIM_Reject,
     /*  36922 */ // Label 15: @36922
     /*  36922 */ GIM_Try, /*On fail goto*//*Label 849*/ GIMT_Encode4(41633),
     /*  36927 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/3,
     /*  36930 */   GIM_Try, /*On fail goto*//*Label 850*/ GIMT_Encode4(36978), // Rule ID 1853 //
     /*  36935 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*  36938 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_uxtb16),
     /*  36943 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  36946 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  36949 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  36953 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  36957 */     // (intrinsic_wo_chain:{ *:[i32] } 3947:{ *:[iPTR] }, GPR:{ *:[i32] }:$Src)  =>  (UXTB16:{ *:[i32] } GPR:{ *:[i32] }:$Src, 0:{ *:[i32] })
     /*  36957 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::UXTB16),
     /*  36960 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  36962 */     GIR_RootToRootCopy, /*OpIdx*/2, // Src
     /*  36964 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  36967 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  36970 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  36976 */     GIR_RootConstrainSelectedInstOperands,
     /*  36977 */     // GIR_Coverage, 1853,
     /*  36977 */     GIR_EraseRootFromParent_Done,
     /*  36978 */   // Label 850: @36978
     /*  36978 */   GIM_Try, /*On fail goto*//*Label 851*/ GIMT_Encode4(37026), // Rule ID 2107 //
     /*  36983 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  36986 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_uxtb16),
     /*  36991 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  36994 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  36997 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  37001 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  37005 */     // (intrinsic_wo_chain:{ *:[i32] } 3947:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rm)  =>  (t2UXTB16:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, 0:{ *:[i32] })
     /*  37005 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2UXTB16),
     /*  37008 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  37010 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /*  37012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  37015 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  37018 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  37024 */     GIR_RootConstrainSelectedInstOperands,
     /*  37025 */     // GIR_Coverage, 2107,
     /*  37025 */     GIR_EraseRootFromParent_Done,
     /*  37026 */   // Label 851: @37026
     /*  37026 */   GIM_Try, /*On fail goto*//*Label 852*/ GIMT_Encode4(37071), // Rule ID 693 //
     /*  37031 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDPVFP_HasVFP2),
     /*  37034 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_vcvtr),
     /*  37039 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  37042 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  37045 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /*  37049 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  37053 */     // (intrinsic_wo_chain:{ *:[f32] } 3948:{ *:[iPTR] }, DPR:{ *:[f64] }:$Dm)  =>  (VTOSIRD:{ *:[f32] } DPR:{ *:[f64] }:$Dm)
     /*  37053 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VTOSIRD),
     /*  37056 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /*  37058 */     GIR_RootToRootCopy, /*OpIdx*/2, // Dm
     /*  37060 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  37063 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  37069 */     GIR_RootConstrainSelectedInstOperands,
     /*  37070 */     // GIR_Coverage, 693,
     /*  37070 */     GIR_EraseRootFromParent_Done,
     /*  37071 */   // Label 852: @37071
     /*  37071 */   GIM_Try, /*On fail goto*//*Label 853*/ GIMT_Encode4(37116), // Rule ID 694 //
     /*  37076 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_DontUseNEONForFP_HasVFP2),
     /*  37079 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_vcvtr),
     /*  37084 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  37087 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  37090 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /*  37094 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /*  37098 */     // (intrinsic_wo_chain:{ *:[f32] } 3948:{ *:[iPTR] }, SPR:{ *:[f32] }:$Sm)  =>  (VTOSIRS:{ *:[f32] } SPR:{ *:[f32] }:$Sm)
     /*  37098 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VTOSIRS),
     /*  37101 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /*  37103 */     GIR_RootToRootCopy, /*OpIdx*/2, // Sm
     /*  37105 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  37108 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  37114 */     GIR_RootConstrainSelectedInstOperands,
     /*  37115 */     // GIR_Coverage, 694,
     /*  37115 */     GIR_EraseRootFromParent_Done,
     /*  37116 */   // Label 853: @37116
     /*  37116 */   GIM_Try, /*On fail goto*//*Label 854*/ GIMT_Encode4(37161), // Rule ID 695 //
     /*  37121 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDPVFP_HasVFP2),
     /*  37124 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_vcvtru),
     /*  37129 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  37132 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  37135 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /*  37139 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  37143 */     // (intrinsic_wo_chain:{ *:[f32] } 3949:{ *:[iPTR] }, DPR:{ *:[f64] }:$Dm)  =>  (VTOUIRD:{ *:[f32] } DPR:{ *:[f64] }:$Dm)
     /*  37143 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VTOUIRD),
     /*  37146 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /*  37148 */     GIR_RootToRootCopy, /*OpIdx*/2, // Dm
     /*  37150 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  37153 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  37159 */     GIR_RootConstrainSelectedInstOperands,
     /*  37160 */     // GIR_Coverage, 695,
     /*  37160 */     GIR_EraseRootFromParent_Done,
     /*  37161 */   // Label 854: @37161
     /*  37161 */   GIM_Try, /*On fail goto*//*Label 855*/ GIMT_Encode4(37206), // Rule ID 696 //
     /*  37166 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_DontUseNEONForFP_HasVFP2),
     /*  37169 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_vcvtru),
     /*  37174 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  37177 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  37180 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /*  37184 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /*  37188 */     // (intrinsic_wo_chain:{ *:[f32] } 3949:{ *:[iPTR] }, SPR:{ *:[f32] }:$Sm)  =>  (VTOUIRS:{ *:[f32] } SPR:{ *:[f32] }:$Sm)
     /*  37188 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VTOUIRS),
     /*  37191 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /*  37193 */     GIR_RootToRootCopy, /*OpIdx*/2, // Sm
     /*  37195 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  37198 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  37204 */     GIR_RootConstrainSelectedInstOperands,
     /*  37205 */     // GIR_Coverage, 696,
     /*  37205 */     GIR_EraseRootFromParent_Done,
     /*  37206 */   // Label 855: @37206
     /*  37206 */   GIM_Try, /*On fail goto*//*Label 856*/ GIMT_Encode4(37251), // Rule ID 1239 //
     /*  37211 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  37214 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vpaddls),
     /*  37219 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  37222 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  37225 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  37229 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  37233 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3805:{ *:[iPTR] }, DPR:{ *:[v8i8] }:$Vm)  =>  (VPADDLsv8i8:{ *:[v4i16] } DPR:{ *:[v8i8] }:$Vm)
     /*  37233 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VPADDLsv8i8),
     /*  37236 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  37238 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  37240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  37243 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  37249 */     GIR_RootConstrainSelectedInstOperands,
     /*  37250 */     // GIR_Coverage, 1239,
     /*  37250 */     GIR_EraseRootFromParent_Done,
     /*  37251 */   // Label 856: @37251
     /*  37251 */   GIM_Try, /*On fail goto*//*Label 857*/ GIMT_Encode4(37296), // Rule ID 1240 //
     /*  37256 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  37259 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vpaddls),
     /*  37264 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  37267 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  37270 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  37274 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  37278 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3805:{ *:[iPTR] }, DPR:{ *:[v4i16] }:$Vm)  =>  (VPADDLsv4i16:{ *:[v2i32] } DPR:{ *:[v4i16] }:$Vm)
     /*  37278 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VPADDLsv4i16),
     /*  37281 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  37283 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  37285 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  37288 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  37294 */     GIR_RootConstrainSelectedInstOperands,
     /*  37295 */     // GIR_Coverage, 1240,
     /*  37295 */     GIR_EraseRootFromParent_Done,
     /*  37296 */   // Label 857: @37296
     /*  37296 */   GIM_Try, /*On fail goto*//*Label 858*/ GIMT_Encode4(37341), // Rule ID 1241 //
     /*  37301 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  37304 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vpaddls),
     /*  37309 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  37312 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  37315 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  37319 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  37323 */     // (intrinsic_wo_chain:{ *:[v1i64] } 3805:{ *:[iPTR] }, DPR:{ *:[v2i32] }:$Vm)  =>  (VPADDLsv2i32:{ *:[v1i64] } DPR:{ *:[v2i32] }:$Vm)
     /*  37323 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VPADDLsv2i32),
     /*  37326 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  37328 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  37330 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  37333 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  37339 */     GIR_RootConstrainSelectedInstOperands,
     /*  37340 */     // GIR_Coverage, 1241,
     /*  37340 */     GIR_EraseRootFromParent_Done,
     /*  37341 */   // Label 858: @37341
     /*  37341 */   GIM_Try, /*On fail goto*//*Label 859*/ GIMT_Encode4(37386), // Rule ID 1242 //
     /*  37346 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  37349 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vpaddls),
     /*  37354 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  37357 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  37360 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  37364 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  37368 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3805:{ *:[iPTR] }, QPR:{ *:[v16i8] }:$Vm)  =>  (VPADDLsv16i8:{ *:[v8i16] } QPR:{ *:[v16i8] }:$Vm)
     /*  37368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VPADDLsv16i8),
     /*  37371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  37373 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  37375 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  37378 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  37384 */     GIR_RootConstrainSelectedInstOperands,
     /*  37385 */     // GIR_Coverage, 1242,
     /*  37385 */     GIR_EraseRootFromParent_Done,
     /*  37386 */   // Label 859: @37386
     /*  37386 */   GIM_Try, /*On fail goto*//*Label 860*/ GIMT_Encode4(37431), // Rule ID 1243 //
     /*  37391 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  37394 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vpaddls),
     /*  37399 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  37402 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  37405 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  37409 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  37413 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3805:{ *:[iPTR] }, QPR:{ *:[v8i16] }:$Vm)  =>  (VPADDLsv8i16:{ *:[v4i32] } QPR:{ *:[v8i16] }:$Vm)
     /*  37413 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VPADDLsv8i16),
     /*  37416 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  37418 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  37420 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  37423 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  37429 */     GIR_RootConstrainSelectedInstOperands,
     /*  37430 */     // GIR_Coverage, 1243,
     /*  37430 */     GIR_EraseRootFromParent_Done,
     /*  37431 */   // Label 860: @37431
     /*  37431 */   GIM_Try, /*On fail goto*//*Label 861*/ GIMT_Encode4(37476), // Rule ID 1244 //
     /*  37436 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  37439 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vpaddls),
     /*  37444 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  37447 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  37450 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  37454 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  37458 */     // (intrinsic_wo_chain:{ *:[v2i64] } 3805:{ *:[iPTR] }, QPR:{ *:[v4i32] }:$Vm)  =>  (VPADDLsv4i32:{ *:[v2i64] } QPR:{ *:[v4i32] }:$Vm)
     /*  37458 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VPADDLsv4i32),
     /*  37461 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  37463 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  37465 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  37468 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  37474 */     GIR_RootConstrainSelectedInstOperands,
     /*  37475 */     // GIR_Coverage, 1244,
     /*  37475 */     GIR_EraseRootFromParent_Done,
     /*  37476 */   // Label 861: @37476
     /*  37476 */   GIM_Try, /*On fail goto*//*Label 862*/ GIMT_Encode4(37521), // Rule ID 1245 //
     /*  37481 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  37484 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vpaddlu),
     /*  37489 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  37492 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  37495 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  37499 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  37503 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3806:{ *:[iPTR] }, DPR:{ *:[v8i8] }:$Vm)  =>  (VPADDLuv8i8:{ *:[v4i16] } DPR:{ *:[v8i8] }:$Vm)
     /*  37503 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VPADDLuv8i8),
     /*  37506 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  37508 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  37510 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  37513 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  37519 */     GIR_RootConstrainSelectedInstOperands,
     /*  37520 */     // GIR_Coverage, 1245,
     /*  37520 */     GIR_EraseRootFromParent_Done,
     /*  37521 */   // Label 862: @37521
     /*  37521 */   GIM_Try, /*On fail goto*//*Label 863*/ GIMT_Encode4(37566), // Rule ID 1246 //
     /*  37526 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  37529 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vpaddlu),
     /*  37534 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  37537 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  37540 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  37544 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  37548 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3806:{ *:[iPTR] }, DPR:{ *:[v4i16] }:$Vm)  =>  (VPADDLuv4i16:{ *:[v2i32] } DPR:{ *:[v4i16] }:$Vm)
     /*  37548 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VPADDLuv4i16),
     /*  37551 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  37553 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  37555 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  37558 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  37564 */     GIR_RootConstrainSelectedInstOperands,
     /*  37565 */     // GIR_Coverage, 1246,
     /*  37565 */     GIR_EraseRootFromParent_Done,
     /*  37566 */   // Label 863: @37566
     /*  37566 */   GIM_Try, /*On fail goto*//*Label 864*/ GIMT_Encode4(37611), // Rule ID 1247 //
     /*  37571 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  37574 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vpaddlu),
     /*  37579 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  37582 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  37585 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  37589 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  37593 */     // (intrinsic_wo_chain:{ *:[v1i64] } 3806:{ *:[iPTR] }, DPR:{ *:[v2i32] }:$Vm)  =>  (VPADDLuv2i32:{ *:[v1i64] } DPR:{ *:[v2i32] }:$Vm)
     /*  37593 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VPADDLuv2i32),
     /*  37596 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  37598 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  37600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  37603 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  37609 */     GIR_RootConstrainSelectedInstOperands,
     /*  37610 */     // GIR_Coverage, 1247,
     /*  37610 */     GIR_EraseRootFromParent_Done,
     /*  37611 */   // Label 864: @37611
     /*  37611 */   GIM_Try, /*On fail goto*//*Label 865*/ GIMT_Encode4(37656), // Rule ID 1248 //
     /*  37616 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  37619 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vpaddlu),
     /*  37624 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  37627 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  37630 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  37634 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  37638 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3806:{ *:[iPTR] }, QPR:{ *:[v16i8] }:$Vm)  =>  (VPADDLuv16i8:{ *:[v8i16] } QPR:{ *:[v16i8] }:$Vm)
     /*  37638 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VPADDLuv16i8),
     /*  37641 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  37643 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  37645 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  37648 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  37654 */     GIR_RootConstrainSelectedInstOperands,
     /*  37655 */     // GIR_Coverage, 1248,
     /*  37655 */     GIR_EraseRootFromParent_Done,
     /*  37656 */   // Label 865: @37656
     /*  37656 */   GIM_Try, /*On fail goto*//*Label 866*/ GIMT_Encode4(37701), // Rule ID 1249 //
     /*  37661 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  37664 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vpaddlu),
     /*  37669 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  37672 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  37675 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  37679 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  37683 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3806:{ *:[iPTR] }, QPR:{ *:[v8i16] }:$Vm)  =>  (VPADDLuv8i16:{ *:[v4i32] } QPR:{ *:[v8i16] }:$Vm)
     /*  37683 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VPADDLuv8i16),
     /*  37686 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  37688 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  37690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  37693 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  37699 */     GIR_RootConstrainSelectedInstOperands,
     /*  37700 */     // GIR_Coverage, 1249,
     /*  37700 */     GIR_EraseRootFromParent_Done,
     /*  37701 */   // Label 866: @37701
     /*  37701 */   GIM_Try, /*On fail goto*//*Label 867*/ GIMT_Encode4(37746), // Rule ID 1250 //
     /*  37706 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  37709 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vpaddlu),
     /*  37714 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  37717 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  37720 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  37724 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  37728 */     // (intrinsic_wo_chain:{ *:[v2i64] } 3806:{ *:[iPTR] }, QPR:{ *:[v4i32] }:$Vm)  =>  (VPADDLuv4i32:{ *:[v2i64] } QPR:{ *:[v4i32] }:$Vm)
     /*  37728 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VPADDLuv4i32),
     /*  37731 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  37733 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  37735 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  37738 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  37744 */     GIR_RootConstrainSelectedInstOperands,
     /*  37745 */     // GIR_Coverage, 1250,
     /*  37745 */     GIR_EraseRootFromParent_Done,
     /*  37746 */   // Label 867: @37746
     /*  37746 */   GIM_Try, /*On fail goto*//*Label 868*/ GIMT_Encode4(37791), // Rule ID 1279 //
     /*  37751 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  37754 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrecpe),
     /*  37759 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  37762 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  37765 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  37769 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  37773 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3833:{ *:[iPTR] }, DPR:{ *:[v2i32] }:$Vm)  =>  (VRECPEd:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vm)
     /*  37773 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRECPEd),
     /*  37776 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  37778 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  37780 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  37783 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  37789 */     GIR_RootConstrainSelectedInstOperands,
     /*  37790 */     // GIR_Coverage, 1279,
     /*  37790 */     GIR_EraseRootFromParent_Done,
     /*  37791 */   // Label 868: @37791
     /*  37791 */   GIM_Try, /*On fail goto*//*Label 869*/ GIMT_Encode4(37836), // Rule ID 1280 //
     /*  37796 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  37799 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrecpe),
     /*  37804 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  37807 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  37810 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  37814 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  37818 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3833:{ *:[iPTR] }, QPR:{ *:[v4i32] }:$Vm)  =>  (VRECPEq:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vm)
     /*  37818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRECPEq),
     /*  37821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  37823 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  37825 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  37828 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  37834 */     GIR_RootConstrainSelectedInstOperands,
     /*  37835 */     // GIR_Coverage, 1280,
     /*  37835 */     GIR_EraseRootFromParent_Done,
     /*  37836 */   // Label 869: @37836
     /*  37836 */   GIM_Try, /*On fail goto*//*Label 870*/ GIMT_Encode4(37881), // Rule ID 1281 //
     /*  37841 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  37844 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrecpe),
     /*  37849 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  37852 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  37855 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  37859 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  37863 */     // (intrinsic_wo_chain:{ *:[v2f32] } 3833:{ *:[iPTR] }, DPR:{ *:[v2f32] }:$Vm)  =>  (VRECPEfd:{ *:[v2f32] } DPR:{ *:[v2f32] }:$Vm)
     /*  37863 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRECPEfd),
     /*  37866 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  37868 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  37870 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  37873 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  37879 */     GIR_RootConstrainSelectedInstOperands,
     /*  37880 */     // GIR_Coverage, 1281,
     /*  37880 */     GIR_EraseRootFromParent_Done,
     /*  37881 */   // Label 870: @37881
     /*  37881 */   GIM_Try, /*On fail goto*//*Label 871*/ GIMT_Encode4(37926), // Rule ID 1282 //
     /*  37886 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  37889 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrecpe),
     /*  37894 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  37897 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  37900 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  37904 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  37908 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3833:{ *:[iPTR] }, QPR:{ *:[v4f32] }:$Vm)  =>  (VRECPEfq:{ *:[v4f32] } QPR:{ *:[v4f32] }:$Vm)
     /*  37908 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRECPEfq),
     /*  37911 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  37913 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  37915 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  37918 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  37924 */     GIR_RootConstrainSelectedInstOperands,
     /*  37925 */     // GIR_Coverage, 1282,
     /*  37925 */     GIR_EraseRootFromParent_Done,
     /*  37926 */   // Label 871: @37926
     /*  37926 */   GIM_Try, /*On fail goto*//*Label 872*/ GIMT_Encode4(37971), // Rule ID 1283 //
     /*  37931 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /*  37934 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrecpe),
     /*  37939 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  37942 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  37945 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  37949 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  37953 */     // (intrinsic_wo_chain:{ *:[v4f16] } 3833:{ *:[iPTR] }, DPR:{ *:[v4f16] }:$Vm)  =>  (VRECPEhd:{ *:[v4f16] } DPR:{ *:[v4f16] }:$Vm)
     /*  37953 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRECPEhd),
     /*  37956 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  37958 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  37960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  37963 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  37969 */     GIR_RootConstrainSelectedInstOperands,
     /*  37970 */     // GIR_Coverage, 1283,
     /*  37970 */     GIR_EraseRootFromParent_Done,
     /*  37971 */   // Label 872: @37971
     /*  37971 */   GIM_Try, /*On fail goto*//*Label 873*/ GIMT_Encode4(38016), // Rule ID 1284 //
     /*  37976 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /*  37979 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrecpe),
     /*  37984 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  37987 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  37990 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  37994 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  37998 */     // (intrinsic_wo_chain:{ *:[v8f16] } 3833:{ *:[iPTR] }, QPR:{ *:[v8f16] }:$Vm)  =>  (VRECPEhq:{ *:[v8f16] } QPR:{ *:[v8f16] }:$Vm)
     /*  37998 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRECPEhq),
     /*  38001 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  38003 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  38005 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  38008 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  38014 */     GIR_RootConstrainSelectedInstOperands,
     /*  38015 */     // GIR_Coverage, 1284,
     /*  38015 */     GIR_EraseRootFromParent_Done,
     /*  38016 */   // Label 873: @38016
     /*  38016 */   GIM_Try, /*On fail goto*//*Label 874*/ GIMT_Encode4(38061), // Rule ID 1289 //
     /*  38021 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  38024 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrsqrte),
     /*  38029 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  38032 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  38035 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  38039 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  38043 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3840:{ *:[iPTR] }, DPR:{ *:[v2i32] }:$Vm)  =>  (VRSQRTEd:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vm)
     /*  38043 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRSQRTEd),
     /*  38046 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  38048 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  38050 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  38053 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  38059 */     GIR_RootConstrainSelectedInstOperands,
     /*  38060 */     // GIR_Coverage, 1289,
     /*  38060 */     GIR_EraseRootFromParent_Done,
     /*  38061 */   // Label 874: @38061
     /*  38061 */   GIM_Try, /*On fail goto*//*Label 875*/ GIMT_Encode4(38106), // Rule ID 1290 //
     /*  38066 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  38069 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrsqrte),
     /*  38074 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  38077 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  38080 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  38084 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  38088 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3840:{ *:[iPTR] }, QPR:{ *:[v4i32] }:$Vm)  =>  (VRSQRTEq:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vm)
     /*  38088 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRSQRTEq),
     /*  38091 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  38093 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  38095 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  38098 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  38104 */     GIR_RootConstrainSelectedInstOperands,
     /*  38105 */     // GIR_Coverage, 1290,
     /*  38105 */     GIR_EraseRootFromParent_Done,
     /*  38106 */   // Label 875: @38106
     /*  38106 */   GIM_Try, /*On fail goto*//*Label 876*/ GIMT_Encode4(38151), // Rule ID 1291 //
     /*  38111 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  38114 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrsqrte),
     /*  38119 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  38122 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  38125 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  38129 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  38133 */     // (intrinsic_wo_chain:{ *:[v2f32] } 3840:{ *:[iPTR] }, DPR:{ *:[v2f32] }:$Vm)  =>  (VRSQRTEfd:{ *:[v2f32] } DPR:{ *:[v2f32] }:$Vm)
     /*  38133 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRSQRTEfd),
     /*  38136 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  38138 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  38140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  38143 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  38149 */     GIR_RootConstrainSelectedInstOperands,
     /*  38150 */     // GIR_Coverage, 1291,
     /*  38150 */     GIR_EraseRootFromParent_Done,
     /*  38151 */   // Label 876: @38151
     /*  38151 */   GIM_Try, /*On fail goto*//*Label 877*/ GIMT_Encode4(38196), // Rule ID 1292 //
     /*  38156 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  38159 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrsqrte),
     /*  38164 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  38167 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  38170 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  38174 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  38178 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3840:{ *:[iPTR] }, QPR:{ *:[v4f32] }:$Vm)  =>  (VRSQRTEfq:{ *:[v4f32] } QPR:{ *:[v4f32] }:$Vm)
     /*  38178 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRSQRTEfq),
     /*  38181 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  38183 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  38185 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  38188 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  38194 */     GIR_RootConstrainSelectedInstOperands,
     /*  38195 */     // GIR_Coverage, 1292,
     /*  38195 */     GIR_EraseRootFromParent_Done,
     /*  38196 */   // Label 877: @38196
     /*  38196 */   GIM_Try, /*On fail goto*//*Label 878*/ GIMT_Encode4(38241), // Rule ID 1293 //
     /*  38201 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /*  38204 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrsqrte),
     /*  38209 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  38212 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  38215 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  38219 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  38223 */     // (intrinsic_wo_chain:{ *:[v4f16] } 3840:{ *:[iPTR] }, DPR:{ *:[v4f16] }:$Vm)  =>  (VRSQRTEhd:{ *:[v4f16] } DPR:{ *:[v4f16] }:$Vm)
     /*  38223 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRSQRTEhd),
     /*  38226 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  38228 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  38230 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  38233 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  38239 */     GIR_RootConstrainSelectedInstOperands,
     /*  38240 */     // GIR_Coverage, 1293,
     /*  38240 */     GIR_EraseRootFromParent_Done,
     /*  38241 */   // Label 878: @38241
     /*  38241 */   GIM_Try, /*On fail goto*//*Label 879*/ GIMT_Encode4(38286), // Rule ID 1294 //
     /*  38246 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /*  38249 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrsqrte),
     /*  38254 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  38257 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  38260 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  38264 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  38268 */     // (intrinsic_wo_chain:{ *:[v8f16] } 3840:{ *:[iPTR] }, QPR:{ *:[v8f16] }:$Vm)  =>  (VRSQRTEhq:{ *:[v8f16] } QPR:{ *:[v8f16] }:$Vm)
     /*  38268 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRSQRTEhq),
     /*  38271 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  38273 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  38275 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  38278 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  38284 */     GIR_RootConstrainSelectedInstOperands,
     /*  38285 */     // GIR_Coverage, 1294,
     /*  38285 */     GIR_EraseRootFromParent_Done,
     /*  38286 */   // Label 879: @38286
     /*  38286 */   GIM_Try, /*On fail goto*//*Label 880*/ GIMT_Encode4(38331), // Rule ID 1515 //
     /*  38291 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  38294 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqabs),
     /*  38299 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /*  38302 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  38305 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  38309 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  38313 */     // (intrinsic_wo_chain:{ *:[v8i8] } 3811:{ *:[iPTR] }, DPR:{ *:[v8i8] }:$Vm)  =>  (VQABSv8i8:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vm)
     /*  38313 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQABSv8i8),
     /*  38316 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  38318 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  38320 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  38323 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  38329 */     GIR_RootConstrainSelectedInstOperands,
     /*  38330 */     // GIR_Coverage, 1515,
     /*  38330 */     GIR_EraseRootFromParent_Done,
     /*  38331 */   // Label 880: @38331
     /*  38331 */   GIM_Try, /*On fail goto*//*Label 881*/ GIMT_Encode4(38376), // Rule ID 1516 //
     /*  38336 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  38339 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqabs),
     /*  38344 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  38347 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  38350 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  38354 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  38358 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3811:{ *:[iPTR] }, DPR:{ *:[v4i16] }:$Vm)  =>  (VQABSv4i16:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vm)
     /*  38358 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQABSv4i16),
     /*  38361 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  38363 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  38365 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  38368 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  38374 */     GIR_RootConstrainSelectedInstOperands,
     /*  38375 */     // GIR_Coverage, 1516,
     /*  38375 */     GIR_EraseRootFromParent_Done,
     /*  38376 */   // Label 881: @38376
     /*  38376 */   GIM_Try, /*On fail goto*//*Label 882*/ GIMT_Encode4(38421), // Rule ID 1517 //
     /*  38381 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  38384 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqabs),
     /*  38389 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  38392 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  38395 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  38399 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  38403 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3811:{ *:[iPTR] }, DPR:{ *:[v2i32] }:$Vm)  =>  (VQABSv2i32:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vm)
     /*  38403 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQABSv2i32),
     /*  38406 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  38408 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  38410 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  38413 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  38419 */     GIR_RootConstrainSelectedInstOperands,
     /*  38420 */     // GIR_Coverage, 1517,
     /*  38420 */     GIR_EraseRootFromParent_Done,
     /*  38421 */   // Label 882: @38421
     /*  38421 */   GIM_Try, /*On fail goto*//*Label 883*/ GIMT_Encode4(38466), // Rule ID 1518 //
     /*  38426 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  38429 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqabs),
     /*  38434 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  38437 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  38440 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  38444 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  38448 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3811:{ *:[iPTR] }, QPR:{ *:[v16i8] }:$Vm)  =>  (VQABSv16i8:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vm)
     /*  38448 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQABSv16i8),
     /*  38451 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  38453 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  38455 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  38458 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  38464 */     GIR_RootConstrainSelectedInstOperands,
     /*  38465 */     // GIR_Coverage, 1518,
     /*  38465 */     GIR_EraseRootFromParent_Done,
     /*  38466 */   // Label 883: @38466
     /*  38466 */   GIM_Try, /*On fail goto*//*Label 884*/ GIMT_Encode4(38511), // Rule ID 1519 //
     /*  38471 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  38474 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqabs),
     /*  38479 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  38482 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  38485 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  38489 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  38493 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3811:{ *:[iPTR] }, QPR:{ *:[v8i16] }:$Vm)  =>  (VQABSv8i16:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vm)
     /*  38493 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQABSv8i16),
     /*  38496 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  38498 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  38500 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  38503 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  38509 */     GIR_RootConstrainSelectedInstOperands,
     /*  38510 */     // GIR_Coverage, 1519,
     /*  38510 */     GIR_EraseRootFromParent_Done,
     /*  38511 */   // Label 884: @38511
     /*  38511 */   GIM_Try, /*On fail goto*//*Label 885*/ GIMT_Encode4(38556), // Rule ID 1520 //
     /*  38516 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  38519 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqabs),
     /*  38524 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  38527 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  38530 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  38534 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  38538 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3811:{ *:[iPTR] }, QPR:{ *:[v4i32] }:$Vm)  =>  (VQABSv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vm)
     /*  38538 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQABSv4i32),
     /*  38541 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  38543 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  38545 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  38548 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  38554 */     GIR_RootConstrainSelectedInstOperands,
     /*  38555 */     // GIR_Coverage, 1520,
     /*  38555 */     GIR_EraseRootFromParent_Done,
     /*  38556 */   // Label 885: @38556
     /*  38556 */   GIM_Try, /*On fail goto*//*Label 886*/ GIMT_Encode4(38601), // Rule ID 1531 //
     /*  38561 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  38564 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqneg),
     /*  38569 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /*  38572 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  38575 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  38579 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  38583 */     // (intrinsic_wo_chain:{ *:[v8i8] } 3817:{ *:[iPTR] }, DPR:{ *:[v8i8] }:$Vm)  =>  (VQNEGv8i8:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vm)
     /*  38583 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQNEGv8i8),
     /*  38586 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  38588 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  38590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  38593 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  38599 */     GIR_RootConstrainSelectedInstOperands,
     /*  38600 */     // GIR_Coverage, 1531,
     /*  38600 */     GIR_EraseRootFromParent_Done,
     /*  38601 */   // Label 886: @38601
     /*  38601 */   GIM_Try, /*On fail goto*//*Label 887*/ GIMT_Encode4(38646), // Rule ID 1532 //
     /*  38606 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  38609 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqneg),
     /*  38614 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  38617 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  38620 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  38624 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  38628 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3817:{ *:[iPTR] }, DPR:{ *:[v4i16] }:$Vm)  =>  (VQNEGv4i16:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vm)
     /*  38628 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQNEGv4i16),
     /*  38631 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  38633 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  38635 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  38638 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  38644 */     GIR_RootConstrainSelectedInstOperands,
     /*  38645 */     // GIR_Coverage, 1532,
     /*  38645 */     GIR_EraseRootFromParent_Done,
     /*  38646 */   // Label 887: @38646
     /*  38646 */   GIM_Try, /*On fail goto*//*Label 888*/ GIMT_Encode4(38691), // Rule ID 1533 //
     /*  38651 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  38654 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqneg),
     /*  38659 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  38662 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  38665 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  38669 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  38673 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3817:{ *:[iPTR] }, DPR:{ *:[v2i32] }:$Vm)  =>  (VQNEGv2i32:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vm)
     /*  38673 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQNEGv2i32),
     /*  38676 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  38678 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  38680 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  38683 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  38689 */     GIR_RootConstrainSelectedInstOperands,
     /*  38690 */     // GIR_Coverage, 1533,
     /*  38690 */     GIR_EraseRootFromParent_Done,
     /*  38691 */   // Label 888: @38691
     /*  38691 */   GIM_Try, /*On fail goto*//*Label 889*/ GIMT_Encode4(38736), // Rule ID 1534 //
     /*  38696 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  38699 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqneg),
     /*  38704 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  38707 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  38710 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  38714 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  38718 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3817:{ *:[iPTR] }, QPR:{ *:[v16i8] }:$Vm)  =>  (VQNEGv16i8:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vm)
     /*  38718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQNEGv16i8),
     /*  38721 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  38723 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  38725 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  38728 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  38734 */     GIR_RootConstrainSelectedInstOperands,
     /*  38735 */     // GIR_Coverage, 1534,
     /*  38735 */     GIR_EraseRootFromParent_Done,
     /*  38736 */   // Label 889: @38736
     /*  38736 */   GIM_Try, /*On fail goto*//*Label 890*/ GIMT_Encode4(38781), // Rule ID 1535 //
     /*  38741 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  38744 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqneg),
     /*  38749 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  38752 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  38755 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  38759 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  38763 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3817:{ *:[iPTR] }, QPR:{ *:[v8i16] }:$Vm)  =>  (VQNEGv8i16:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vm)
     /*  38763 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQNEGv8i16),
     /*  38766 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  38768 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  38770 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  38773 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  38779 */     GIR_RootConstrainSelectedInstOperands,
     /*  38780 */     // GIR_Coverage, 1535,
     /*  38780 */     GIR_EraseRootFromParent_Done,
     /*  38781 */   // Label 890: @38781
     /*  38781 */   GIM_Try, /*On fail goto*//*Label 891*/ GIMT_Encode4(38826), // Rule ID 1536 //
     /*  38786 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  38789 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqneg),
     /*  38794 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  38797 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  38800 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  38804 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  38808 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3817:{ *:[iPTR] }, QPR:{ *:[v4i32] }:$Vm)  =>  (VQNEGv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vm)
     /*  38808 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQNEGv4i32),
     /*  38811 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  38813 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  38815 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  38818 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  38824 */     GIR_RootConstrainSelectedInstOperands,
     /*  38825 */     // GIR_Coverage, 1536,
     /*  38825 */     GIR_EraseRootFromParent_Done,
     /*  38826 */   // Label 891: @38826
     /*  38826 */   GIM_Try, /*On fail goto*//*Label 892*/ GIMT_Encode4(38871), // Rule ID 1537 //
     /*  38831 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  38834 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcls),
     /*  38839 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /*  38842 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  38845 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  38849 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  38853 */     // (intrinsic_wo_chain:{ *:[v8i8] } 3758:{ *:[iPTR] }, DPR:{ *:[v8i8] }:$Vm)  =>  (VCLSv8i8:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vm)
     /*  38853 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCLSv8i8),
     /*  38856 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  38858 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  38860 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  38863 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  38869 */     GIR_RootConstrainSelectedInstOperands,
     /*  38870 */     // GIR_Coverage, 1537,
     /*  38870 */     GIR_EraseRootFromParent_Done,
     /*  38871 */   // Label 892: @38871
     /*  38871 */   GIM_Try, /*On fail goto*//*Label 893*/ GIMT_Encode4(38916), // Rule ID 1538 //
     /*  38876 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  38879 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcls),
     /*  38884 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  38887 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  38890 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  38894 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  38898 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3758:{ *:[iPTR] }, DPR:{ *:[v4i16] }:$Vm)  =>  (VCLSv4i16:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vm)
     /*  38898 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCLSv4i16),
     /*  38901 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  38903 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  38905 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  38908 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  38914 */     GIR_RootConstrainSelectedInstOperands,
     /*  38915 */     // GIR_Coverage, 1538,
     /*  38915 */     GIR_EraseRootFromParent_Done,
     /*  38916 */   // Label 893: @38916
     /*  38916 */   GIM_Try, /*On fail goto*//*Label 894*/ GIMT_Encode4(38961), // Rule ID 1539 //
     /*  38921 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  38924 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcls),
     /*  38929 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  38932 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  38935 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  38939 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  38943 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3758:{ *:[iPTR] }, DPR:{ *:[v2i32] }:$Vm)  =>  (VCLSv2i32:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vm)
     /*  38943 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCLSv2i32),
     /*  38946 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  38948 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  38950 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  38953 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  38959 */     GIR_RootConstrainSelectedInstOperands,
     /*  38960 */     // GIR_Coverage, 1539,
     /*  38960 */     GIR_EraseRootFromParent_Done,
     /*  38961 */   // Label 894: @38961
     /*  38961 */   GIM_Try, /*On fail goto*//*Label 895*/ GIMT_Encode4(39006), // Rule ID 1540 //
     /*  38966 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  38969 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcls),
     /*  38974 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  38977 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  38980 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  38984 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  38988 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3758:{ *:[iPTR] }, QPR:{ *:[v16i8] }:$Vm)  =>  (VCLSv16i8:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vm)
     /*  38988 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCLSv16i8),
     /*  38991 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  38993 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  38995 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  38998 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  39004 */     GIR_RootConstrainSelectedInstOperands,
     /*  39005 */     // GIR_Coverage, 1540,
     /*  39005 */     GIR_EraseRootFromParent_Done,
     /*  39006 */   // Label 895: @39006
     /*  39006 */   GIM_Try, /*On fail goto*//*Label 896*/ GIMT_Encode4(39051), // Rule ID 1541 //
     /*  39011 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  39014 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcls),
     /*  39019 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  39022 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  39025 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  39029 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  39033 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3758:{ *:[iPTR] }, QPR:{ *:[v8i16] }:$Vm)  =>  (VCLSv8i16:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vm)
     /*  39033 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCLSv8i16),
     /*  39036 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  39038 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  39040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  39043 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  39049 */     GIR_RootConstrainSelectedInstOperands,
     /*  39050 */     // GIR_Coverage, 1541,
     /*  39050 */     GIR_EraseRootFromParent_Done,
     /*  39051 */   // Label 896: @39051
     /*  39051 */   GIM_Try, /*On fail goto*//*Label 897*/ GIMT_Encode4(39096), // Rule ID 1542 //
     /*  39056 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  39059 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcls),
     /*  39064 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  39067 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  39070 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  39074 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  39078 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3758:{ *:[iPTR] }, QPR:{ *:[v4i32] }:$Vm)  =>  (VCLSv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vm)
     /*  39078 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCLSv4i32),
     /*  39081 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  39083 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  39085 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  39088 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  39094 */     GIR_RootConstrainSelectedInstOperands,
     /*  39095 */     // GIR_Coverage, 1542,
     /*  39095 */     GIR_EraseRootFromParent_Done,
     /*  39096 */   // Label 897: @39096
     /*  39096 */   GIM_Try, /*On fail goto*//*Label 898*/ GIMT_Encode4(39141), // Rule ID 1586 //
     /*  39101 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  39104 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqmovns),
     /*  39109 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /*  39112 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  39115 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  39119 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  39123 */     // (intrinsic_wo_chain:{ *:[v8i8] } 3814:{ *:[iPTR] }, QPR:{ *:[v8i16] }:$Vm)  =>  (VQMOVNsv8i8:{ *:[v8i8] } QPR:{ *:[v8i16] }:$Vm)
     /*  39123 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQMOVNsv8i8),
     /*  39126 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  39128 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  39130 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  39133 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  39139 */     GIR_RootConstrainSelectedInstOperands,
     /*  39140 */     // GIR_Coverage, 1586,
     /*  39140 */     GIR_EraseRootFromParent_Done,
     /*  39141 */   // Label 898: @39141
     /*  39141 */   GIM_Try, /*On fail goto*//*Label 899*/ GIMT_Encode4(39186), // Rule ID 1587 //
     /*  39146 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  39149 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqmovns),
     /*  39154 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  39157 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  39160 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  39164 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  39168 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3814:{ *:[iPTR] }, QPR:{ *:[v4i32] }:$Vm)  =>  (VQMOVNsv4i16:{ *:[v4i16] } QPR:{ *:[v4i32] }:$Vm)
     /*  39168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQMOVNsv4i16),
     /*  39171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  39173 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  39175 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  39178 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  39184 */     GIR_RootConstrainSelectedInstOperands,
     /*  39185 */     // GIR_Coverage, 1587,
     /*  39185 */     GIR_EraseRootFromParent_Done,
     /*  39186 */   // Label 899: @39186
     /*  39186 */   GIM_Try, /*On fail goto*//*Label 900*/ GIMT_Encode4(39231), // Rule ID 1588 //
     /*  39191 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  39194 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqmovns),
     /*  39199 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  39202 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  39205 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  39209 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  39213 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3814:{ *:[iPTR] }, QPR:{ *:[v2i64] }:$Vm)  =>  (VQMOVNsv2i32:{ *:[v2i32] } QPR:{ *:[v2i64] }:$Vm)
     /*  39213 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQMOVNsv2i32),
     /*  39216 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  39218 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  39220 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  39223 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  39229 */     GIR_RootConstrainSelectedInstOperands,
     /*  39230 */     // GIR_Coverage, 1588,
     /*  39230 */     GIR_EraseRootFromParent_Done,
     /*  39231 */   // Label 900: @39231
     /*  39231 */   GIM_Try, /*On fail goto*//*Label 901*/ GIMT_Encode4(39276), // Rule ID 1589 //
     /*  39236 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  39239 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqmovnu),
     /*  39244 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /*  39247 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  39250 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  39254 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  39258 */     // (intrinsic_wo_chain:{ *:[v8i8] } 3816:{ *:[iPTR] }, QPR:{ *:[v8i16] }:$Vm)  =>  (VQMOVNuv8i8:{ *:[v8i8] } QPR:{ *:[v8i16] }:$Vm)
     /*  39258 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQMOVNuv8i8),
     /*  39261 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  39263 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  39265 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  39268 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  39274 */     GIR_RootConstrainSelectedInstOperands,
     /*  39275 */     // GIR_Coverage, 1589,
     /*  39275 */     GIR_EraseRootFromParent_Done,
     /*  39276 */   // Label 901: @39276
     /*  39276 */   GIM_Try, /*On fail goto*//*Label 902*/ GIMT_Encode4(39321), // Rule ID 1590 //
     /*  39281 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  39284 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqmovnu),
     /*  39289 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  39292 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  39295 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  39299 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  39303 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3816:{ *:[iPTR] }, QPR:{ *:[v4i32] }:$Vm)  =>  (VQMOVNuv4i16:{ *:[v4i16] } QPR:{ *:[v4i32] }:$Vm)
     /*  39303 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQMOVNuv4i16),
     /*  39306 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  39308 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  39310 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  39313 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  39319 */     GIR_RootConstrainSelectedInstOperands,
     /*  39320 */     // GIR_Coverage, 1590,
     /*  39320 */     GIR_EraseRootFromParent_Done,
     /*  39321 */   // Label 902: @39321
     /*  39321 */   GIM_Try, /*On fail goto*//*Label 903*/ GIMT_Encode4(39366), // Rule ID 1591 //
     /*  39326 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  39329 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqmovnu),
     /*  39334 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  39337 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  39340 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  39344 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  39348 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3816:{ *:[iPTR] }, QPR:{ *:[v2i64] }:$Vm)  =>  (VQMOVNuv2i32:{ *:[v2i32] } QPR:{ *:[v2i64] }:$Vm)
     /*  39348 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQMOVNuv2i32),
     /*  39351 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  39353 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  39355 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  39358 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  39364 */     GIR_RootConstrainSelectedInstOperands,
     /*  39365 */     // GIR_Coverage, 1591,
     /*  39365 */     GIR_EraseRootFromParent_Done,
     /*  39366 */   // Label 903: @39366
     /*  39366 */   GIM_Try, /*On fail goto*//*Label 904*/ GIMT_Encode4(39411), // Rule ID 1592 //
     /*  39371 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  39374 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqmovnsu),
     /*  39379 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /*  39382 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  39385 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  39389 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  39393 */     // (intrinsic_wo_chain:{ *:[v8i8] } 3815:{ *:[iPTR] }, QPR:{ *:[v8i16] }:$Vm)  =>  (VQMOVNsuv8i8:{ *:[v8i8] } QPR:{ *:[v8i16] }:$Vm)
     /*  39393 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQMOVNsuv8i8),
     /*  39396 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  39398 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  39400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  39403 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  39409 */     GIR_RootConstrainSelectedInstOperands,
     /*  39410 */     // GIR_Coverage, 1592,
     /*  39410 */     GIR_EraseRootFromParent_Done,
     /*  39411 */   // Label 904: @39411
     /*  39411 */   GIM_Try, /*On fail goto*//*Label 905*/ GIMT_Encode4(39456), // Rule ID 1593 //
     /*  39416 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  39419 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqmovnsu),
     /*  39424 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  39427 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  39430 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  39434 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  39438 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3815:{ *:[iPTR] }, QPR:{ *:[v4i32] }:$Vm)  =>  (VQMOVNsuv4i16:{ *:[v4i16] } QPR:{ *:[v4i32] }:$Vm)
     /*  39438 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQMOVNsuv4i16),
     /*  39441 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  39443 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  39445 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  39448 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  39454 */     GIR_RootConstrainSelectedInstOperands,
     /*  39455 */     // GIR_Coverage, 1593,
     /*  39455 */     GIR_EraseRootFromParent_Done,
     /*  39456 */   // Label 905: @39456
     /*  39456 */   GIM_Try, /*On fail goto*//*Label 906*/ GIMT_Encode4(39501), // Rule ID 1594 //
     /*  39461 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  39464 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqmovnsu),
     /*  39469 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  39472 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  39475 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  39479 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  39483 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3815:{ *:[iPTR] }, QPR:{ *:[v2i64] }:$Vm)  =>  (VQMOVNsuv2i32:{ *:[v2i32] } QPR:{ *:[v2i64] }:$Vm)
     /*  39483 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQMOVNsuv2i32),
     /*  39486 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  39488 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  39490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  39493 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  39499 */     GIR_RootConstrainSelectedInstOperands,
     /*  39500 */     // GIR_Coverage, 1594,
     /*  39500 */     GIR_EraseRootFromParent_Done,
     /*  39501 */   // Label 906: @39501
     /*  39501 */   GIM_Try, /*On fail goto*//*Label 907*/ GIMT_Encode4(39537), // Rule ID 1617 //
     /*  39506 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasV8),
     /*  39509 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtas),
     /*  39514 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  39517 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  39520 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  39524 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  39528 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3759:{ *:[iPTR] }, DPR:{ *:[v2f32] }:$Vm)  =>  (VCVTANSDf:{ *:[v2i32] } DPR:{ *:[v2f32] }:$Vm)
     /*  39528 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTANSDf),
     /*  39531 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  39533 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  39535 */     GIR_RootConstrainSelectedInstOperands,
     /*  39536 */     // GIR_Coverage, 1617,
     /*  39536 */     GIR_EraseRootFromParent_Done,
     /*  39537 */   // Label 907: @39537
     /*  39537 */   GIM_Try, /*On fail goto*//*Label 908*/ GIMT_Encode4(39573), // Rule ID 1618 //
     /*  39542 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasV8),
     /*  39545 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtas),
     /*  39550 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  39553 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  39556 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  39560 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  39564 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3759:{ *:[iPTR] }, QPR:{ *:[v4f32] }:$Vm)  =>  (VCVTANSQf:{ *:[v4i32] } QPR:{ *:[v4f32] }:$Vm)
     /*  39564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTANSQf),
     /*  39567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  39569 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  39571 */     GIR_RootConstrainSelectedInstOperands,
     /*  39572 */     // GIR_Coverage, 1618,
     /*  39572 */     GIR_EraseRootFromParent_Done,
     /*  39573 */   // Label 908: @39573
     /*  39573 */   GIM_Try, /*On fail goto*//*Label 909*/ GIMT_Encode4(39609), // Rule ID 1619 //
     /*  39578 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasV8),
     /*  39581 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtau),
     /*  39586 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  39589 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  39592 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  39596 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  39600 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3760:{ *:[iPTR] }, DPR:{ *:[v2f32] }:$Vm)  =>  (VCVTANUDf:{ *:[v2i32] } DPR:{ *:[v2f32] }:$Vm)
     /*  39600 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTANUDf),
     /*  39603 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  39605 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  39607 */     GIR_RootConstrainSelectedInstOperands,
     /*  39608 */     // GIR_Coverage, 1619,
     /*  39608 */     GIR_EraseRootFromParent_Done,
     /*  39609 */   // Label 909: @39609
     /*  39609 */   GIM_Try, /*On fail goto*//*Label 910*/ GIMT_Encode4(39645), // Rule ID 1620 //
     /*  39614 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasV8),
     /*  39617 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtau),
     /*  39622 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  39625 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  39628 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  39632 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  39636 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3760:{ *:[iPTR] }, QPR:{ *:[v4f32] }:$Vm)  =>  (VCVTANUQf:{ *:[v4i32] } QPR:{ *:[v4f32] }:$Vm)
     /*  39636 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTANUQf),
     /*  39639 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  39641 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  39643 */     GIR_RootConstrainSelectedInstOperands,
     /*  39644 */     // GIR_Coverage, 1620,
     /*  39644 */     GIR_EraseRootFromParent_Done,
     /*  39645 */   // Label 910: @39645
     /*  39645 */   GIM_Try, /*On fail goto*//*Label 911*/ GIMT_Encode4(39681), // Rule ID 1621 //
     /*  39650 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON_HasV8),
     /*  39653 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtas),
     /*  39658 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  39661 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  39664 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  39668 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  39672 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3759:{ *:[iPTR] }, DPR:{ *:[v4f16] }:$Vm)  =>  (VCVTANSDh:{ *:[v4i16] } DPR:{ *:[v4f16] }:$Vm)
     /*  39672 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTANSDh),
     /*  39675 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  39677 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  39679 */     GIR_RootConstrainSelectedInstOperands,
     /*  39680 */     // GIR_Coverage, 1621,
     /*  39680 */     GIR_EraseRootFromParent_Done,
     /*  39681 */   // Label 911: @39681
     /*  39681 */   GIM_Try, /*On fail goto*//*Label 912*/ GIMT_Encode4(39717), // Rule ID 1622 //
     /*  39686 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON_HasV8),
     /*  39689 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtas),
     /*  39694 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  39697 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  39700 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  39704 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  39708 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3759:{ *:[iPTR] }, QPR:{ *:[v8f16] }:$Vm)  =>  (VCVTANSQh:{ *:[v8i16] } QPR:{ *:[v8f16] }:$Vm)
     /*  39708 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTANSQh),
     /*  39711 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  39713 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  39715 */     GIR_RootConstrainSelectedInstOperands,
     /*  39716 */     // GIR_Coverage, 1622,
     /*  39716 */     GIR_EraseRootFromParent_Done,
     /*  39717 */   // Label 912: @39717
     /*  39717 */   GIM_Try, /*On fail goto*//*Label 913*/ GIMT_Encode4(39753), // Rule ID 1623 //
     /*  39722 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON_HasV8),
     /*  39725 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtau),
     /*  39730 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  39733 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  39736 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  39740 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  39744 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3760:{ *:[iPTR] }, DPR:{ *:[v4f16] }:$Vm)  =>  (VCVTANUDh:{ *:[v4i16] } DPR:{ *:[v4f16] }:$Vm)
     /*  39744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTANUDh),
     /*  39747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  39749 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  39751 */     GIR_RootConstrainSelectedInstOperands,
     /*  39752 */     // GIR_Coverage, 1623,
     /*  39752 */     GIR_EraseRootFromParent_Done,
     /*  39753 */   // Label 913: @39753
     /*  39753 */   GIM_Try, /*On fail goto*//*Label 914*/ GIMT_Encode4(39789), // Rule ID 1624 //
     /*  39758 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON_HasV8),
     /*  39761 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtau),
     /*  39766 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  39769 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  39772 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  39776 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  39780 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3760:{ *:[iPTR] }, QPR:{ *:[v8f16] }:$Vm)  =>  (VCVTANUQh:{ *:[v8i16] } QPR:{ *:[v8f16] }:$Vm)
     /*  39780 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTANUQh),
     /*  39783 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  39785 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  39787 */     GIR_RootConstrainSelectedInstOperands,
     /*  39788 */     // GIR_Coverage, 1624,
     /*  39788 */     GIR_EraseRootFromParent_Done,
     /*  39789 */   // Label 914: @39789
     /*  39789 */   GIM_Try, /*On fail goto*//*Label 915*/ GIMT_Encode4(39825), // Rule ID 1625 //
     /*  39794 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasV8),
     /*  39797 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtns),
     /*  39802 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  39805 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  39808 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  39812 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  39816 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3771:{ *:[iPTR] }, DPR:{ *:[v2f32] }:$Vm)  =>  (VCVTNNSDf:{ *:[v2i32] } DPR:{ *:[v2f32] }:$Vm)
     /*  39816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTNNSDf),
     /*  39819 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  39821 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  39823 */     GIR_RootConstrainSelectedInstOperands,
     /*  39824 */     // GIR_Coverage, 1625,
     /*  39824 */     GIR_EraseRootFromParent_Done,
     /*  39825 */   // Label 915: @39825
     /*  39825 */   GIM_Try, /*On fail goto*//*Label 916*/ GIMT_Encode4(39861), // Rule ID 1626 //
     /*  39830 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasV8),
     /*  39833 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtns),
     /*  39838 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  39841 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  39844 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  39848 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  39852 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3771:{ *:[iPTR] }, QPR:{ *:[v4f32] }:$Vm)  =>  (VCVTNNSQf:{ *:[v4i32] } QPR:{ *:[v4f32] }:$Vm)
     /*  39852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTNNSQf),
     /*  39855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  39857 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  39859 */     GIR_RootConstrainSelectedInstOperands,
     /*  39860 */     // GIR_Coverage, 1626,
     /*  39860 */     GIR_EraseRootFromParent_Done,
     /*  39861 */   // Label 916: @39861
     /*  39861 */   GIM_Try, /*On fail goto*//*Label 917*/ GIMT_Encode4(39897), // Rule ID 1627 //
     /*  39866 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasV8),
     /*  39869 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtnu),
     /*  39874 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  39877 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  39880 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  39884 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  39888 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3772:{ *:[iPTR] }, DPR:{ *:[v2f32] }:$Vm)  =>  (VCVTNNUDf:{ *:[v2i32] } DPR:{ *:[v2f32] }:$Vm)
     /*  39888 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTNNUDf),
     /*  39891 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  39893 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  39895 */     GIR_RootConstrainSelectedInstOperands,
     /*  39896 */     // GIR_Coverage, 1627,
     /*  39896 */     GIR_EraseRootFromParent_Done,
     /*  39897 */   // Label 917: @39897
     /*  39897 */   GIM_Try, /*On fail goto*//*Label 918*/ GIMT_Encode4(39933), // Rule ID 1628 //
     /*  39902 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasV8),
     /*  39905 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtnu),
     /*  39910 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  39913 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  39916 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  39920 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  39924 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3772:{ *:[iPTR] }, QPR:{ *:[v4f32] }:$Vm)  =>  (VCVTNNUQf:{ *:[v4i32] } QPR:{ *:[v4f32] }:$Vm)
     /*  39924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTNNUQf),
     /*  39927 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  39929 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  39931 */     GIR_RootConstrainSelectedInstOperands,
     /*  39932 */     // GIR_Coverage, 1628,
     /*  39932 */     GIR_EraseRootFromParent_Done,
     /*  39933 */   // Label 918: @39933
     /*  39933 */   GIM_Try, /*On fail goto*//*Label 919*/ GIMT_Encode4(39969), // Rule ID 1629 //
     /*  39938 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON_HasV8),
     /*  39941 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtns),
     /*  39946 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  39949 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  39952 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  39956 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  39960 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3771:{ *:[iPTR] }, DPR:{ *:[v4f16] }:$Vm)  =>  (VCVTNNSDh:{ *:[v4i16] } DPR:{ *:[v4f16] }:$Vm)
     /*  39960 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTNNSDh),
     /*  39963 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  39965 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  39967 */     GIR_RootConstrainSelectedInstOperands,
     /*  39968 */     // GIR_Coverage, 1629,
     /*  39968 */     GIR_EraseRootFromParent_Done,
     /*  39969 */   // Label 919: @39969
     /*  39969 */   GIM_Try, /*On fail goto*//*Label 920*/ GIMT_Encode4(40005), // Rule ID 1630 //
     /*  39974 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON_HasV8),
     /*  39977 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtns),
     /*  39982 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  39985 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  39988 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  39992 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  39996 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3771:{ *:[iPTR] }, QPR:{ *:[v8f16] }:$Vm)  =>  (VCVTNNSQh:{ *:[v8i16] } QPR:{ *:[v8f16] }:$Vm)
     /*  39996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTNNSQh),
     /*  39999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  40001 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  40003 */     GIR_RootConstrainSelectedInstOperands,
     /*  40004 */     // GIR_Coverage, 1630,
     /*  40004 */     GIR_EraseRootFromParent_Done,
     /*  40005 */   // Label 920: @40005
     /*  40005 */   GIM_Try, /*On fail goto*//*Label 921*/ GIMT_Encode4(40041), // Rule ID 1631 //
     /*  40010 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON_HasV8),
     /*  40013 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtnu),
     /*  40018 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  40021 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  40024 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  40028 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  40032 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3772:{ *:[iPTR] }, DPR:{ *:[v4f16] }:$Vm)  =>  (VCVTNNUDh:{ *:[v4i16] } DPR:{ *:[v4f16] }:$Vm)
     /*  40032 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTNNUDh),
     /*  40035 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  40037 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  40039 */     GIR_RootConstrainSelectedInstOperands,
     /*  40040 */     // GIR_Coverage, 1631,
     /*  40040 */     GIR_EraseRootFromParent_Done,
     /*  40041 */   // Label 921: @40041
     /*  40041 */   GIM_Try, /*On fail goto*//*Label 922*/ GIMT_Encode4(40077), // Rule ID 1632 //
     /*  40046 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON_HasV8),
     /*  40049 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtnu),
     /*  40054 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  40057 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  40060 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  40064 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  40068 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3772:{ *:[iPTR] }, QPR:{ *:[v8f16] }:$Vm)  =>  (VCVTNNUQh:{ *:[v8i16] } QPR:{ *:[v8f16] }:$Vm)
     /*  40068 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTNNUQh),
     /*  40071 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  40073 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  40075 */     GIR_RootConstrainSelectedInstOperands,
     /*  40076 */     // GIR_Coverage, 1632,
     /*  40076 */     GIR_EraseRootFromParent_Done,
     /*  40077 */   // Label 922: @40077
     /*  40077 */   GIM_Try, /*On fail goto*//*Label 923*/ GIMT_Encode4(40113), // Rule ID 1633 //
     /*  40082 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasV8),
     /*  40085 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtps),
     /*  40090 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  40093 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  40096 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  40100 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  40104 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3773:{ *:[iPTR] }, DPR:{ *:[v2f32] }:$Vm)  =>  (VCVTPNSDf:{ *:[v2i32] } DPR:{ *:[v2f32] }:$Vm)
     /*  40104 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTPNSDf),
     /*  40107 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  40109 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  40111 */     GIR_RootConstrainSelectedInstOperands,
     /*  40112 */     // GIR_Coverage, 1633,
     /*  40112 */     GIR_EraseRootFromParent_Done,
     /*  40113 */   // Label 923: @40113
     /*  40113 */   GIM_Try, /*On fail goto*//*Label 924*/ GIMT_Encode4(40149), // Rule ID 1634 //
     /*  40118 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasV8),
     /*  40121 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtps),
     /*  40126 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  40129 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  40132 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  40136 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  40140 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3773:{ *:[iPTR] }, QPR:{ *:[v4f32] }:$Vm)  =>  (VCVTPNSQf:{ *:[v4i32] } QPR:{ *:[v4f32] }:$Vm)
     /*  40140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTPNSQf),
     /*  40143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  40145 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  40147 */     GIR_RootConstrainSelectedInstOperands,
     /*  40148 */     // GIR_Coverage, 1634,
     /*  40148 */     GIR_EraseRootFromParent_Done,
     /*  40149 */   // Label 924: @40149
     /*  40149 */   GIM_Try, /*On fail goto*//*Label 925*/ GIMT_Encode4(40185), // Rule ID 1635 //
     /*  40154 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasV8),
     /*  40157 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtpu),
     /*  40162 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  40165 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  40168 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  40172 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  40176 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3774:{ *:[iPTR] }, DPR:{ *:[v2f32] }:$Vm)  =>  (VCVTPNUDf:{ *:[v2i32] } DPR:{ *:[v2f32] }:$Vm)
     /*  40176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTPNUDf),
     /*  40179 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  40181 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  40183 */     GIR_RootConstrainSelectedInstOperands,
     /*  40184 */     // GIR_Coverage, 1635,
     /*  40184 */     GIR_EraseRootFromParent_Done,
     /*  40185 */   // Label 925: @40185
     /*  40185 */   GIM_Try, /*On fail goto*//*Label 926*/ GIMT_Encode4(40221), // Rule ID 1636 //
     /*  40190 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasV8),
     /*  40193 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtpu),
     /*  40198 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  40201 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  40204 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  40208 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  40212 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3774:{ *:[iPTR] }, QPR:{ *:[v4f32] }:$Vm)  =>  (VCVTPNUQf:{ *:[v4i32] } QPR:{ *:[v4f32] }:$Vm)
     /*  40212 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTPNUQf),
     /*  40215 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  40217 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  40219 */     GIR_RootConstrainSelectedInstOperands,
     /*  40220 */     // GIR_Coverage, 1636,
     /*  40220 */     GIR_EraseRootFromParent_Done,
     /*  40221 */   // Label 926: @40221
     /*  40221 */   GIM_Try, /*On fail goto*//*Label 927*/ GIMT_Encode4(40257), // Rule ID 1637 //
     /*  40226 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON_HasV8),
     /*  40229 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtps),
     /*  40234 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  40237 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  40240 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  40244 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  40248 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3773:{ *:[iPTR] }, DPR:{ *:[v4f16] }:$Vm)  =>  (VCVTPNSDh:{ *:[v4i16] } DPR:{ *:[v4f16] }:$Vm)
     /*  40248 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTPNSDh),
     /*  40251 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  40253 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  40255 */     GIR_RootConstrainSelectedInstOperands,
     /*  40256 */     // GIR_Coverage, 1637,
     /*  40256 */     GIR_EraseRootFromParent_Done,
     /*  40257 */   // Label 927: @40257
     /*  40257 */   GIM_Try, /*On fail goto*//*Label 928*/ GIMT_Encode4(40293), // Rule ID 1638 //
     /*  40262 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON_HasV8),
     /*  40265 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtps),
     /*  40270 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  40273 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  40276 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  40280 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  40284 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3773:{ *:[iPTR] }, QPR:{ *:[v8f16] }:$Vm)  =>  (VCVTPNSQh:{ *:[v8i16] } QPR:{ *:[v8f16] }:$Vm)
     /*  40284 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTPNSQh),
     /*  40287 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  40289 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  40291 */     GIR_RootConstrainSelectedInstOperands,
     /*  40292 */     // GIR_Coverage, 1638,
     /*  40292 */     GIR_EraseRootFromParent_Done,
     /*  40293 */   // Label 928: @40293
     /*  40293 */   GIM_Try, /*On fail goto*//*Label 929*/ GIMT_Encode4(40329), // Rule ID 1639 //
     /*  40298 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON_HasV8),
     /*  40301 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtpu),
     /*  40306 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  40309 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  40312 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  40316 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  40320 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3774:{ *:[iPTR] }, DPR:{ *:[v4f16] }:$Vm)  =>  (VCVTPNUDh:{ *:[v4i16] } DPR:{ *:[v4f16] }:$Vm)
     /*  40320 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTPNUDh),
     /*  40323 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  40325 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  40327 */     GIR_RootConstrainSelectedInstOperands,
     /*  40328 */     // GIR_Coverage, 1639,
     /*  40328 */     GIR_EraseRootFromParent_Done,
     /*  40329 */   // Label 929: @40329
     /*  40329 */   GIM_Try, /*On fail goto*//*Label 930*/ GIMT_Encode4(40365), // Rule ID 1640 //
     /*  40334 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON_HasV8),
     /*  40337 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtpu),
     /*  40342 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  40345 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  40348 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  40352 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  40356 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3774:{ *:[iPTR] }, QPR:{ *:[v8f16] }:$Vm)  =>  (VCVTPNUQh:{ *:[v8i16] } QPR:{ *:[v8f16] }:$Vm)
     /*  40356 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTPNUQh),
     /*  40359 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  40361 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  40363 */     GIR_RootConstrainSelectedInstOperands,
     /*  40364 */     // GIR_Coverage, 1640,
     /*  40364 */     GIR_EraseRootFromParent_Done,
     /*  40365 */   // Label 930: @40365
     /*  40365 */   GIM_Try, /*On fail goto*//*Label 931*/ GIMT_Encode4(40401), // Rule ID 1641 //
     /*  40370 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasV8),
     /*  40373 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtms),
     /*  40378 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  40381 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  40384 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  40388 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  40392 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3769:{ *:[iPTR] }, DPR:{ *:[v2f32] }:$Vm)  =>  (VCVTMNSDf:{ *:[v2i32] } DPR:{ *:[v2f32] }:$Vm)
     /*  40392 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTMNSDf),
     /*  40395 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  40397 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  40399 */     GIR_RootConstrainSelectedInstOperands,
     /*  40400 */     // GIR_Coverage, 1641,
     /*  40400 */     GIR_EraseRootFromParent_Done,
     /*  40401 */   // Label 931: @40401
     /*  40401 */   GIM_Try, /*On fail goto*//*Label 932*/ GIMT_Encode4(40437), // Rule ID 1642 //
     /*  40406 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasV8),
     /*  40409 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtms),
     /*  40414 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  40417 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  40420 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  40424 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  40428 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3769:{ *:[iPTR] }, QPR:{ *:[v4f32] }:$Vm)  =>  (VCVTMNSQf:{ *:[v4i32] } QPR:{ *:[v4f32] }:$Vm)
     /*  40428 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTMNSQf),
     /*  40431 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  40433 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  40435 */     GIR_RootConstrainSelectedInstOperands,
     /*  40436 */     // GIR_Coverage, 1642,
     /*  40436 */     GIR_EraseRootFromParent_Done,
     /*  40437 */   // Label 932: @40437
     /*  40437 */   GIM_Try, /*On fail goto*//*Label 933*/ GIMT_Encode4(40473), // Rule ID 1643 //
     /*  40442 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasV8),
     /*  40445 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtmu),
     /*  40450 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  40453 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  40456 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  40460 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  40464 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3770:{ *:[iPTR] }, DPR:{ *:[v2f32] }:$Vm)  =>  (VCVTMNUDf:{ *:[v2i32] } DPR:{ *:[v2f32] }:$Vm)
     /*  40464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTMNUDf),
     /*  40467 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  40469 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  40471 */     GIR_RootConstrainSelectedInstOperands,
     /*  40472 */     // GIR_Coverage, 1643,
     /*  40472 */     GIR_EraseRootFromParent_Done,
     /*  40473 */   // Label 933: @40473
     /*  40473 */   GIM_Try, /*On fail goto*//*Label 934*/ GIMT_Encode4(40509), // Rule ID 1644 //
     /*  40478 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasV8),
     /*  40481 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtmu),
     /*  40486 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  40489 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  40492 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  40496 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  40500 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3770:{ *:[iPTR] }, QPR:{ *:[v4f32] }:$Vm)  =>  (VCVTMNUQf:{ *:[v4i32] } QPR:{ *:[v4f32] }:$Vm)
     /*  40500 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTMNUQf),
     /*  40503 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  40505 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  40507 */     GIR_RootConstrainSelectedInstOperands,
     /*  40508 */     // GIR_Coverage, 1644,
     /*  40508 */     GIR_EraseRootFromParent_Done,
     /*  40509 */   // Label 934: @40509
     /*  40509 */   GIM_Try, /*On fail goto*//*Label 935*/ GIMT_Encode4(40545), // Rule ID 1645 //
     /*  40514 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON_HasV8),
     /*  40517 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtms),
     /*  40522 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  40525 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  40528 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  40532 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  40536 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3769:{ *:[iPTR] }, DPR:{ *:[v4f16] }:$Vm)  =>  (VCVTMNSDh:{ *:[v4i16] } DPR:{ *:[v4f16] }:$Vm)
     /*  40536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTMNSDh),
     /*  40539 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  40541 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  40543 */     GIR_RootConstrainSelectedInstOperands,
     /*  40544 */     // GIR_Coverage, 1645,
     /*  40544 */     GIR_EraseRootFromParent_Done,
     /*  40545 */   // Label 935: @40545
     /*  40545 */   GIM_Try, /*On fail goto*//*Label 936*/ GIMT_Encode4(40581), // Rule ID 1646 //
     /*  40550 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON_HasV8),
     /*  40553 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtms),
     /*  40558 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  40561 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  40564 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  40568 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  40572 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3769:{ *:[iPTR] }, QPR:{ *:[v8f16] }:$Vm)  =>  (VCVTMNSQh:{ *:[v8i16] } QPR:{ *:[v8f16] }:$Vm)
     /*  40572 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTMNSQh),
     /*  40575 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  40577 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  40579 */     GIR_RootConstrainSelectedInstOperands,
     /*  40580 */     // GIR_Coverage, 1646,
     /*  40580 */     GIR_EraseRootFromParent_Done,
     /*  40581 */   // Label 936: @40581
     /*  40581 */   GIM_Try, /*On fail goto*//*Label 937*/ GIMT_Encode4(40617), // Rule ID 1647 //
     /*  40586 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON_HasV8),
     /*  40589 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtmu),
     /*  40594 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  40597 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  40600 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  40604 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  40608 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3770:{ *:[iPTR] }, DPR:{ *:[v4f16] }:$Vm)  =>  (VCVTMNUDh:{ *:[v4i16] } DPR:{ *:[v4f16] }:$Vm)
     /*  40608 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTMNUDh),
     /*  40611 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  40613 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  40615 */     GIR_RootConstrainSelectedInstOperands,
     /*  40616 */     // GIR_Coverage, 1647,
     /*  40616 */     GIR_EraseRootFromParent_Done,
     /*  40617 */   // Label 937: @40617
     /*  40617 */   GIM_Try, /*On fail goto*//*Label 938*/ GIMT_Encode4(40653), // Rule ID 1648 //
     /*  40622 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON_HasV8),
     /*  40625 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtmu),
     /*  40630 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  40633 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  40636 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  40640 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  40644 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3770:{ *:[iPTR] }, QPR:{ *:[v8f16] }:$Vm)  =>  (VCVTMNUQh:{ *:[v8i16] } QPR:{ *:[v8f16] }:$Vm)
     /*  40644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTMNUQh),
     /*  40647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  40649 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  40651 */     GIR_RootConstrainSelectedInstOperands,
     /*  40652 */     // GIR_Coverage, 1648,
     /*  40652 */     GIR_EraseRootFromParent_Done,
     /*  40653 */   // Label 938: @40653
     /*  40653 */   GIM_Try, /*On fail goto*//*Label 939*/ GIMT_Encode4(40698), // Rule ID 1665 //
     /*  40658 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasNEON),
     /*  40661 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtfp2hf),
     /*  40666 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  40669 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  40672 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  40676 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  40680 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3765:{ *:[iPTR] }, QPR:{ *:[v4f32] }:$Vm)  =>  (VCVTf2h:{ *:[v4i16] } QPR:{ *:[v4f32] }:$Vm)
     /*  40680 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTf2h),
     /*  40683 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  40685 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  40687 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  40690 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  40696 */     GIR_RootConstrainSelectedInstOperands,
     /*  40697 */     // GIR_Coverage, 1665,
     /*  40697 */     GIR_EraseRootFromParent_Done,
     /*  40698 */   // Label 939: @40698
     /*  40698 */   GIM_Try, /*On fail goto*//*Label 940*/ GIMT_Encode4(40743), // Rule ID 1666 //
     /*  40703 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasNEON),
     /*  40706 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvthf2fp),
     /*  40711 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  40714 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  40717 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  40721 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  40725 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3768:{ *:[iPTR] }, DPR:{ *:[v4i16] }:$Vm)  =>  (VCVTh2f:{ *:[v4f32] } DPR:{ *:[v4i16] }:$Vm)
     /*  40725 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTh2f),
     /*  40728 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  40730 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  40732 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  40735 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  40741 */     GIR_RootConstrainSelectedInstOperands,
     /*  40742 */     // GIR_Coverage, 1666,
     /*  40742 */     GIR_EraseRootFromParent_Done,
     /*  40743 */   // Label 940: @40743
     /*  40743 */   GIM_Try, /*On fail goto*//*Label 941*/ GIMT_Encode4(40779), // Rule ID 1714 //
     /*  40748 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAES_HasV8),
     /*  40751 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_aesimc),
     /*  40756 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  40759 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  40762 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  40766 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  40770 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3728:{ *:[iPTR] }, QPR:{ *:[v16i8] }:$Vm)  =>  (AESIMC:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vm)
     /*  40770 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::AESIMC),
     /*  40773 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  40775 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  40777 */     GIR_RootConstrainSelectedInstOperands,
     /*  40778 */     // GIR_Coverage, 1714,
     /*  40778 */     GIR_EraseRootFromParent_Done,
     /*  40779 */   // Label 941: @40779
     /*  40779 */   GIM_Try, /*On fail goto*//*Label 942*/ GIMT_Encode4(40815), // Rule ID 1715 //
     /*  40784 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAES_HasV8),
     /*  40787 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_aesmc),
     /*  40792 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  40795 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  40798 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  40802 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  40806 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3729:{ *:[iPTR] }, QPR:{ *:[v16i8] }:$Vm)  =>  (AESMC:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vm)
     /*  40806 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::AESMC),
     /*  40809 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  40811 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  40813 */     GIR_RootConstrainSelectedInstOperands,
     /*  40814 */     // GIR_Coverage, 1715,
     /*  40814 */     GIR_EraseRootFromParent_Done,
     /*  40815 */   // Label 942: @40815
     /*  40815 */   GIM_Try, /*On fail goto*//*Label 943*/ GIMT_Encode4(40863), // Rule ID 1848 //
     /*  40820 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*  40823 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_sxtb16),
     /*  40828 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  40831 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  40834 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  40838 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  40842 */     // (intrinsic_wo_chain:{ *:[i32] } 3922:{ *:[iPTR] }, GPR:{ *:[i32] }:$Src)  =>  (SXTB16:{ *:[i32] } GPR:{ *:[i32] }:$Src, 0:{ *:[i32] })
     /*  40842 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SXTB16),
     /*  40845 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  40847 */     GIR_RootToRootCopy, /*OpIdx*/2, // Src
     /*  40849 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  40852 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  40855 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  40861 */     GIR_RootConstrainSelectedInstOperands,
     /*  40862 */     // GIR_Coverage, 1848,
     /*  40862 */     GIR_EraseRootFromParent_Done,
     /*  40863 */   // Label 943: @40863
     /*  40863 */   GIM_Try, /*On fail goto*//*Label 944*/ GIMT_Encode4(40911), // Rule ID 2096 //
     /*  40868 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  40871 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_sxtb16),
     /*  40876 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  40879 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  40882 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  40886 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  40890 */     // (intrinsic_wo_chain:{ *:[i32] } 3922:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn)  =>  (t2SXTB16:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, 0:{ *:[i32] })
     /*  40890 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SXTB16),
     /*  40893 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  40895 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  40897 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  40900 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  40903 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  40909 */     GIR_RootConstrainSelectedInstOperands,
     /*  40910 */     // GIR_Coverage, 2096,
     /*  40910 */     GIR_EraseRootFromParent_Done,
     /*  40911 */   // Label 944: @40911
     /*  40911 */   GIM_Try, /*On fail goto*//*Label 945*/ GIMT_Encode4(40977), // Rule ID 3645 //
     /*  40916 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  40919 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vcls),
     /*  40924 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  40927 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  40930 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  40934 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  40938 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3611:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$val)  =>  (MVE_VCLSs8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$val)
     /*  40938 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  40941 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  40945 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  40950 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCLSs8),
     /*  40953 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  40955 */     GIR_RootToRootCopy, /*OpIdx*/2, // val
     /*  40957 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  40960 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  40966 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  40972 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  40975 */     GIR_RootConstrainSelectedInstOperands,
     /*  40976 */     // GIR_Coverage, 3645,
     /*  40976 */     GIR_EraseRootFromParent_Done,
     /*  40977 */   // Label 945: @40977
     /*  40977 */   GIM_Try, /*On fail goto*//*Label 946*/ GIMT_Encode4(41043), // Rule ID 3647 //
     /*  40982 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  40985 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vcls),
     /*  40990 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  40993 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  40996 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  41000 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  41004 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3611:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$val)  =>  (MVE_VCLSs16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$val)
     /*  41004 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  41007 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  41011 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  41016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCLSs16),
     /*  41019 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  41021 */     GIR_RootToRootCopy, /*OpIdx*/2, // val
     /*  41023 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  41026 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  41032 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  41038 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  41041 */     GIR_RootConstrainSelectedInstOperands,
     /*  41042 */     // GIR_Coverage, 3647,
     /*  41042 */     GIR_EraseRootFromParent_Done,
     /*  41043 */   // Label 946: @41043
     /*  41043 */   GIM_Try, /*On fail goto*//*Label 947*/ GIMT_Encode4(41109), // Rule ID 3649 //
     /*  41048 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  41051 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vcls),
     /*  41056 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  41059 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  41062 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  41066 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  41070 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3611:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$val)  =>  (MVE_VCLSs32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$val)
     /*  41070 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  41073 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  41077 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  41082 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCLSs32),
     /*  41085 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  41087 */     GIR_RootToRootCopy, /*OpIdx*/2, // val
     /*  41089 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  41092 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  41098 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  41104 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  41107 */     GIR_RootConstrainSelectedInstOperands,
     /*  41108 */     // GIR_Coverage, 3649,
     /*  41108 */     GIR_EraseRootFromParent_Done,
     /*  41109 */   // Label 947: @41109
     /*  41109 */   GIM_Try, /*On fail goto*//*Label 948*/ GIMT_Encode4(41160), // Rule ID 4861 //
     /*  41114 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  41117 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vctp8),
     /*  41122 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s1,
     /*  41125 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  41128 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::VCCRRegClassID),
     /*  41132 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  41136 */     // (intrinsic_wo_chain:{ *:[v16i1] } 3619:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn)  =>  (MVE_VCTP8:{ *:[v16i1] } rGPR:{ *:[i32] }:$Rn)
     /*  41136 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCTP8),
     /*  41139 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[P0]
     /*  41141 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  41143 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  41146 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  41152 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  41158 */     GIR_RootConstrainSelectedInstOperands,
     /*  41159 */     // GIR_Coverage, 4861,
     /*  41159 */     GIR_EraseRootFromParent_Done,
     /*  41160 */   // Label 948: @41160
     /*  41160 */   GIM_Try, /*On fail goto*//*Label 949*/ GIMT_Encode4(41211), // Rule ID 4863 //
     /*  41165 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  41168 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vctp16),
     /*  41173 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s1,
     /*  41176 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  41179 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::VCCRRegClassID),
     /*  41183 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  41187 */     // (intrinsic_wo_chain:{ *:[v8i1] } 3616:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn)  =>  (MVE_VCTP16:{ *:[v8i1] } rGPR:{ *:[i32] }:$Rn)
     /*  41187 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCTP16),
     /*  41190 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[P0]
     /*  41192 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  41194 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  41197 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  41203 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  41209 */     GIR_RootConstrainSelectedInstOperands,
     /*  41210 */     // GIR_Coverage, 4863,
     /*  41210 */     GIR_EraseRootFromParent_Done,
     /*  41211 */   // Label 949: @41211
     /*  41211 */   GIM_Try, /*On fail goto*//*Label 950*/ GIMT_Encode4(41262), // Rule ID 4865 //
     /*  41216 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  41219 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vctp32),
     /*  41224 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s1,
     /*  41227 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  41230 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::VCCRRegClassID),
     /*  41234 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  41238 */     // (intrinsic_wo_chain:{ *:[v4i1] } 3617:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn)  =>  (MVE_VCTP32:{ *:[v4i1] } rGPR:{ *:[i32] }:$Rn)
     /*  41238 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCTP32),
     /*  41241 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[P0]
     /*  41243 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  41245 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  41248 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  41254 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  41260 */     GIR_RootConstrainSelectedInstOperands,
     /*  41261 */     // GIR_Coverage, 4865,
     /*  41261 */     GIR_EraseRootFromParent_Done,
     /*  41262 */   // Label 950: @41262
     /*  41262 */   GIM_Try, /*On fail goto*//*Label 951*/ GIMT_Encode4(41313), // Rule ID 4867 //
     /*  41267 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  41270 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vctp64),
     /*  41275 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s1,
     /*  41278 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  41281 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::VCCRRegClassID),
     /*  41285 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  41289 */     // (intrinsic_wo_chain:{ *:[v2i1] } 3618:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn)  =>  (MVE_VCTP64:{ *:[v2i1] } rGPR:{ *:[i32] }:$Rn)
     /*  41289 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCTP64),
     /*  41292 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[P0]
     /*  41294 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  41296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  41299 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  41305 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  41311 */     GIR_RootConstrainSelectedInstOperands,
     /*  41312 */     // GIR_Coverage, 4867,
     /*  41312 */     GIR_EraseRootFromParent_Done,
     /*  41313 */   // Label 951: @41313
     /*  41313 */   GIM_Try, /*On fail goto*//*Label 952*/ GIMT_Encode4(41359), // Rule ID 600 //
     /*  41318 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has8MSecExt_IsThumb),
     /*  41321 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_cmse_tt),
     /*  41326 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  41329 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  41333 */     // MIs[0] Rn
     /*  41333 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/32,
     /*  41337 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  41341 */     // (intrinsic_wo_chain:{ *:[i32] } 3501:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn)  =>  (t2TT:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn)
     /*  41341 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2TT),
     /*  41344 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  41346 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  41348 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  41351 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  41357 */     GIR_RootConstrainSelectedInstOperands,
     /*  41358 */     // GIR_Coverage, 600,
     /*  41358 */     GIR_EraseRootFromParent_Done,
     /*  41359 */   // Label 952: @41359
     /*  41359 */   GIM_Try, /*On fail goto*//*Label 953*/ GIMT_Encode4(41405), // Rule ID 601 //
     /*  41364 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has8MSecExt_IsThumb),
     /*  41367 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_cmse_ttt),
     /*  41372 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  41375 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  41379 */     // MIs[0] Rn
     /*  41379 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/32,
     /*  41383 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  41387 */     // (intrinsic_wo_chain:{ *:[i32] } 3504:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn)  =>  (t2TTT:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn)
     /*  41387 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2TTT),
     /*  41390 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  41392 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  41394 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  41397 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  41403 */     GIR_RootConstrainSelectedInstOperands,
     /*  41404 */     // GIR_Coverage, 601,
     /*  41404 */     GIR_EraseRootFromParent_Done,
     /*  41405 */   // Label 953: @41405
     /*  41405 */   GIM_Try, /*On fail goto*//*Label 954*/ GIMT_Encode4(41451), // Rule ID 602 //
     /*  41410 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has8MSecExt_IsThumb),
     /*  41413 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_cmse_tta),
     /*  41418 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  41421 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  41425 */     // MIs[0] Rn
     /*  41425 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/32,
     /*  41429 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  41433 */     // (intrinsic_wo_chain:{ *:[i32] } 3502:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn)  =>  (t2TTA:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn)
     /*  41433 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2TTA),
     /*  41436 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  41438 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  41440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  41443 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  41449 */     GIR_RootConstrainSelectedInstOperands,
     /*  41450 */     // GIR_Coverage, 602,
     /*  41450 */     GIR_EraseRootFromParent_Done,
     /*  41451 */   // Label 954: @41451
     /*  41451 */   GIM_Try, /*On fail goto*//*Label 955*/ GIMT_Encode4(41497), // Rule ID 603 //
     /*  41456 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has8MSecExt_IsThumb),
     /*  41459 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_cmse_ttat),
     /*  41464 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  41467 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  41471 */     // MIs[0] Rn
     /*  41471 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/32,
     /*  41475 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  41479 */     // (intrinsic_wo_chain:{ *:[i32] } 3503:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn)  =>  (t2TTAT:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn)
     /*  41479 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2TTAT),
     /*  41482 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  41484 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  41486 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  41489 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  41495 */     GIR_RootConstrainSelectedInstOperands,
     /*  41496 */     // GIR_Coverage, 603,
     /*  41496 */     GIR_EraseRootFromParent_Done,
     /*  41497 */   // Label 955: @41497
     /*  41497 */   GIM_Try, /*On fail goto*//*Label 956*/ GIMT_Encode4(41632), // Rule ID 2690 //
     /*  41502 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  41505 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_sha1h),
     /*  41510 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  41513 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  41516 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  41520 */     // (intrinsic_wo_chain:{ *:[i32] } 3736:{ *:[iPTR] }, i32:{ *:[i32] }:$Rn)  =>  (COPY_TO_REGCLASS:{ *:[i32] } (EXTRACT_SUBREG:{ *:[f32] } (SHA1H:{ *:[v16i8] } (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i64] }, (COPY_TO_REGCLASS:{ *:[f32] } i32:{ *:[i32] }:$Rn, SPR:{ *:[i32] }), ssub_0:{ *:[i32] })), ssub_0:{ *:[i32] }), GPR:{ *:[i32] })
     /*  41520 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /*  41523 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  41527 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  41532 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /*  41536 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(ARM::SPRRegClassID),
     /*  41541 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s8,
     /*  41544 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  41548 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  41553 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /*  41556 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /*  41559 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/17,
     /*  41562 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(ARM::DPair_with_ssub_0RegClassID),
     /*  41567 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(ARM::SPRRegClassID),
     /*  41572 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /*  41575 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(ARM::SHA1H),
     /*  41579 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  41584 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  41587 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  41589 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  41592 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  41596 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  41601 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(ARM::ssub_0),
     /*  41608 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(ARM::SPRRegClassID),
     /*  41613 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(ARM::MQPRRegClassID),
     /*  41618 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  41621 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  41623 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  41626 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::GPRRegClassID),
     /*  41631 */     // GIR_Coverage, 2690,
     /*  41631 */     GIR_EraseRootFromParent_Done,
     /*  41632 */   // Label 956: @41632
     /*  41632 */   GIM_Reject,
     /*  41633 */ // Label 849: @41633
     /*  41633 */ GIM_Try, /*On fail goto*//*Label 957*/ GIMT_Encode4(62187),
     /*  41638 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/4,
     /*  41641 */   GIM_Try, /*On fail goto*//*Label 958*/ GIMT_Encode4(41698), // Rule ID 2114 //
     /*  41646 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  41649 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_uxtab16),
     /*  41654 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  41657 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  41660 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  41663 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  41667 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  41671 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  41675 */     // (intrinsic_wo_chain:{ *:[i32] } 3946:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2UXTAB16:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm, 0:{ *:[i32] })
     /*  41675 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2UXTAB16),
     /*  41678 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  41680 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  41682 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  41684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  41687 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  41690 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  41696 */     GIR_RootConstrainSelectedInstOperands,
     /*  41697 */     // GIR_Coverage, 2114,
     /*  41697 */     GIR_EraseRootFromParent_Done,
     /*  41698 */   // Label 958: @41698
     /*  41698 */   GIM_Try, /*On fail goto*//*Label 959*/ GIMT_Encode4(41797), // Rule ID 1885 //
     /*  41703 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*  41706 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_usat),
     /*  41711 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  41714 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  41717 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  41720 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  41724 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  41728 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  41732 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  41736 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  41740 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  41745 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  41749 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  41753 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_31),
     /*  41757 */     // MIs[2] Operand 1
     /*  41757 */     // No operand predicates
     /*  41757 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /*  41761 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  41765 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_31),
     /*  41769 */     // MIs[3] Operand 1
     /*  41769 */     // No operand predicates
     /*  41769 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  41771 */     // (intrinsic_wo_chain:{ *:[i32] } 3941:{ *:[iPTR] }, (shl:{ *:[i32] } GPRnopc:{ *:[i32] }:$a, (imm:{ *:[i32] })<<P:Predicate_imm0_31>>:$shft), (imm:{ *:[i32] })<<P:Predicate_imm0_31>>:$pos)  =>  (USAT:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_imm0_31>>:$pos, GPRnopc:{ *:[i32] }:$a, (imm:{ *:[i32] })<<P:Predicate_imm0_31>>:$shft)
     /*  41771 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::USAT),
     /*  41774 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  41776 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // pos
     /*  41779 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // a
     /*  41783 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // shft
     /*  41786 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  41789 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  41795 */     GIR_RootConstrainSelectedInstOperands,
     /*  41796 */     // GIR_Coverage, 1885,
     /*  41796 */     GIR_EraseRootFromParent_Done,
     /*  41797 */   // Label 959: @41797
     /*  41797 */   GIM_Try, /*On fail goto*//*Label 960*/ GIMT_Encode4(41896), // Rule ID 2151 //
     /*  41802 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /*  41805 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_usat),
     /*  41810 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  41813 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  41816 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  41819 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  41823 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  41827 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  41831 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  41835 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  41839 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  41844 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  41848 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  41852 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_31),
     /*  41856 */     // MIs[2] Operand 1
     /*  41856 */     // No operand predicates
     /*  41856 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /*  41860 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  41864 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_31),
     /*  41868 */     // MIs[3] Operand 1
     /*  41868 */     // No operand predicates
     /*  41868 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  41870 */     // (intrinsic_wo_chain:{ *:[i32] } 3941:{ *:[iPTR] }, (shl:{ *:[i32] } GPRnopc:{ *:[i32] }:$a, (imm:{ *:[i32] })<<P:Predicate_imm0_31>>:$shft), (imm:{ *:[i32] })<<P:Predicate_imm0_31>>:$pos)  =>  (t2USAT:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_imm0_31>>:$pos, GPRnopc:{ *:[i32] }:$a, (imm:{ *:[i32] })<<P:Predicate_imm0_31>>:$shft)
     /*  41870 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2USAT),
     /*  41873 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  41875 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // pos
     /*  41878 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // a
     /*  41882 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // shft
     /*  41885 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  41888 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  41894 */     GIR_RootConstrainSelectedInstOperands,
     /*  41895 */     // GIR_Coverage, 2151,
     /*  41895 */     GIR_EraseRootFromParent_Done,
     /*  41896 */   // Label 960: @41896
     /*  41896 */   GIM_Try, /*On fail goto*//*Label 961*/ GIMT_Encode4(41980), // Rule ID 5427 //
     /*  41901 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  41904 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_qadd),
     /*  41909 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  41912 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  41915 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  41918 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  41922 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  41926 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  41930 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  41933 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::arm_qadd),
     /*  41938 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  41942 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  41947 */     // MIs[1] Rn
     /*  41947 */     GIM_CheckIsSameOperand, /*MI*/1, /*OpIdx*/3, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  41952 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  41956 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  41958 */     // (intrinsic_wo_chain:{ *:[i32] } 3864:{ *:[iPTR] }, (intrinsic_wo_chain:{ *:[i32] } 3864:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rn), GPRnopc:{ *:[i32] }:$Rm)  =>  (QDADD:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rm, GPRnopc:{ *:[i32] }:$Rn)
     /*  41958 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::QDADD),
     /*  41961 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  41963 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  41965 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  41969 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  41972 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  41978 */     GIR_RootConstrainSelectedInstOperands,
     /*  41979 */     // GIR_Coverage, 5427,
     /*  41979 */     GIR_EraseRootFromParent_Done,
     /*  41980 */   // Label 961: @41980
     /*  41980 */   GIM_Try, /*On fail goto*//*Label 962*/ GIMT_Encode4(42064), // Rule ID 5684 //
     /*  41985 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  41988 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_qadd),
     /*  41993 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  41996 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  41999 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  42002 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  42006 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  42010 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  42014 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  42017 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::arm_qadd),
     /*  42022 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  42026 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  42031 */     // MIs[1] Rn
     /*  42031 */     GIM_CheckIsSameOperand, /*MI*/1, /*OpIdx*/3, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  42036 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  42040 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  42042 */     // (intrinsic_wo_chain:{ *:[i32] } 3864:{ *:[iPTR] }, (intrinsic_wo_chain:{ *:[i32] } 3864:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rn), rGPR:{ *:[i32] }:$Rm)  =>  (t2QDADD:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, rGPR:{ *:[i32] }:$Rn)
     /*  42042 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2QDADD),
     /*  42045 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  42047 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  42049 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  42053 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  42056 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  42062 */     GIR_RootConstrainSelectedInstOperands,
     /*  42063 */     // GIR_Coverage, 5684,
     /*  42063 */     GIR_EraseRootFromParent_Done,
     /*  42064 */   // Label 962: @42064
     /*  42064 */   GIM_Try, /*On fail goto*//*Label 963*/ GIMT_Encode4(42148), // Rule ID 109 //
     /*  42069 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  42072 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_qadd),
     /*  42077 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  42080 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  42083 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  42086 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  42090 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  42094 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  42098 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  42102 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  42105 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::arm_qadd),
     /*  42110 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  42114 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  42119 */     // MIs[1] Rn
     /*  42119 */     GIM_CheckIsSameOperand, /*MI*/1, /*OpIdx*/3, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  42124 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  42126 */     // (intrinsic_wo_chain:{ *:[i32] } 3864:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rm, (intrinsic_wo_chain:{ *:[i32] } 3864:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rn))  =>  (QDADD:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rm, GPRnopc:{ *:[i32] }:$Rn)
     /*  42126 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::QDADD),
     /*  42129 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  42131 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /*  42133 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  42137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  42140 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  42146 */     GIR_RootConstrainSelectedInstOperands,
     /*  42147 */     // GIR_Coverage, 109,
     /*  42147 */     GIR_EraseRootFromParent_Done,
     /*  42148 */   // Label 963: @42148
     /*  42148 */   GIM_Try, /*On fail goto*//*Label 964*/ GIMT_Encode4(42232), // Rule ID 110 //
     /*  42153 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  42156 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_qsub),
     /*  42161 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  42164 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  42167 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  42170 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  42174 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  42178 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  42182 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  42186 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  42189 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::arm_qadd),
     /*  42194 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  42198 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  42203 */     // MIs[1] Rn
     /*  42203 */     GIM_CheckIsSameOperand, /*MI*/1, /*OpIdx*/3, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  42208 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  42210 */     // (intrinsic_wo_chain:{ *:[i32] } 3869:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rm, (intrinsic_wo_chain:{ *:[i32] } 3864:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rn))  =>  (QDSUB:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rm, GPRnopc:{ *:[i32] }:$Rn)
     /*  42210 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::QDSUB),
     /*  42213 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  42215 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /*  42217 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  42221 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  42224 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  42230 */     GIR_RootConstrainSelectedInstOperands,
     /*  42231 */     // GIR_Coverage, 110,
     /*  42231 */     GIR_EraseRootFromParent_Done,
     /*  42232 */   // Label 964: @42232
     /*  42232 */   GIM_Try, /*On fail goto*//*Label 965*/ GIMT_Encode4(42316), // Rule ID 2129 //
     /*  42237 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  42240 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_qadd),
     /*  42245 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  42248 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  42251 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  42254 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  42258 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  42262 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  42266 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  42270 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  42273 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::arm_qadd),
     /*  42278 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  42282 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  42287 */     // MIs[1] Rn
     /*  42287 */     GIM_CheckIsSameOperand, /*MI*/1, /*OpIdx*/3, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  42292 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  42294 */     // (intrinsic_wo_chain:{ *:[i32] } 3864:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rm, (intrinsic_wo_chain:{ *:[i32] } 3864:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rn))  =>  (t2QDADD:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, rGPR:{ *:[i32] }:$Rn)
     /*  42294 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2QDADD),
     /*  42297 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  42299 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /*  42301 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  42305 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  42308 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  42314 */     GIR_RootConstrainSelectedInstOperands,
     /*  42315 */     // GIR_Coverage, 2129,
     /*  42315 */     GIR_EraseRootFromParent_Done,
     /*  42316 */   // Label 965: @42316
     /*  42316 */   GIM_Try, /*On fail goto*//*Label 966*/ GIMT_Encode4(42400), // Rule ID 2130 //
     /*  42321 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  42324 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_qsub),
     /*  42329 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  42332 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  42335 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  42338 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  42342 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  42346 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  42350 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  42354 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  42357 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::arm_qadd),
     /*  42362 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  42366 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  42371 */     // MIs[1] Rn
     /*  42371 */     GIM_CheckIsSameOperand, /*MI*/1, /*OpIdx*/3, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  42376 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  42378 */     // (intrinsic_wo_chain:{ *:[i32] } 3869:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rm, (intrinsic_wo_chain:{ *:[i32] } 3864:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rn))  =>  (t2QDSUB:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, rGPR:{ *:[i32] }:$Rn)
     /*  42378 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2QDSUB),
     /*  42381 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  42383 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /*  42385 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  42389 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  42392 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  42398 */     GIR_RootConstrainSelectedInstOperands,
     /*  42399 */     // GIR_Coverage, 2130,
     /*  42399 */     GIR_EraseRootFromParent_Done,
     /*  42400 */   // Label 966: @42400
     /*  42400 */   GIM_Try, /*On fail goto*//*Label 967*/ GIMT_Encode4(42473), // Rule ID 4055 //
     /*  42405 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  42408 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vcvta),
     /*  42413 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  42416 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  42419 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  42422 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  42426 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /*  42430 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  42434 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3627:{ *:[iPTR] }, 0:{ *:[i32] }, MQPR:{ *:[v8f16] }:$in)  =>  (MVE_VCVTs16f16a:{ *:[v8i16] } MQPR:{ *:[v8f16] }:$in)
     /*  42434 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  42437 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  42441 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  42446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCVTs16f16a),
     /*  42449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  42451 */     GIR_RootToRootCopy, /*OpIdx*/3, // in
     /*  42453 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  42456 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  42462 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  42468 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  42471 */     GIR_RootConstrainSelectedInstOperands,
     /*  42472 */     // GIR_Coverage, 4055,
     /*  42472 */     GIR_EraseRootFromParent_Done,
     /*  42473 */   // Label 967: @42473
     /*  42473 */   GIM_Try, /*On fail goto*//*Label 968*/ GIMT_Encode4(42546), // Rule ID 4057 //
     /*  42478 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  42481 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vcvtn),
     /*  42486 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  42489 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  42492 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  42495 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  42499 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /*  42503 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  42507 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3631:{ *:[iPTR] }, 0:{ *:[i32] }, MQPR:{ *:[v8f16] }:$in)  =>  (MVE_VCVTs16f16n:{ *:[v8i16] } MQPR:{ *:[v8f16] }:$in)
     /*  42507 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  42510 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  42514 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  42519 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCVTs16f16n),
     /*  42522 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  42524 */     GIR_RootToRootCopy, /*OpIdx*/3, // in
     /*  42526 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  42529 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  42535 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  42541 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  42544 */     GIR_RootConstrainSelectedInstOperands,
     /*  42545 */     // GIR_Coverage, 4057,
     /*  42545 */     GIR_EraseRootFromParent_Done,
     /*  42546 */   // Label 968: @42546
     /*  42546 */   GIM_Try, /*On fail goto*//*Label 969*/ GIMT_Encode4(42619), // Rule ID 4059 //
     /*  42551 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  42554 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vcvtp),
     /*  42559 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  42562 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  42565 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  42568 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  42572 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /*  42576 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  42580 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3633:{ *:[iPTR] }, 0:{ *:[i32] }, MQPR:{ *:[v8f16] }:$in)  =>  (MVE_VCVTs16f16p:{ *:[v8i16] } MQPR:{ *:[v8f16] }:$in)
     /*  42580 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  42583 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  42587 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  42592 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCVTs16f16p),
     /*  42595 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  42597 */     GIR_RootToRootCopy, /*OpIdx*/3, // in
     /*  42599 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  42602 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  42608 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  42614 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  42617 */     GIR_RootConstrainSelectedInstOperands,
     /*  42618 */     // GIR_Coverage, 4059,
     /*  42618 */     GIR_EraseRootFromParent_Done,
     /*  42619 */   // Label 969: @42619
     /*  42619 */   GIM_Try, /*On fail goto*//*Label 970*/ GIMT_Encode4(42692), // Rule ID 4061 //
     /*  42624 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  42627 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vcvtm),
     /*  42632 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  42635 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  42638 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  42641 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  42645 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /*  42649 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  42653 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3629:{ *:[iPTR] }, 0:{ *:[i32] }, MQPR:{ *:[v8f16] }:$in)  =>  (MVE_VCVTs16f16m:{ *:[v8i16] } MQPR:{ *:[v8f16] }:$in)
     /*  42653 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  42656 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  42660 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  42665 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCVTs16f16m),
     /*  42668 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  42670 */     GIR_RootToRootCopy, /*OpIdx*/3, // in
     /*  42672 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  42675 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  42681 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  42687 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  42690 */     GIR_RootConstrainSelectedInstOperands,
     /*  42691 */     // GIR_Coverage, 4061,
     /*  42691 */     GIR_EraseRootFromParent_Done,
     /*  42692 */   // Label 970: @42692
     /*  42692 */   GIM_Try, /*On fail goto*//*Label 971*/ GIMT_Encode4(42765), // Rule ID 4063 //
     /*  42697 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  42700 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vcvta),
     /*  42705 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  42708 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  42711 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  42714 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  42718 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 1,
     /*  42722 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  42726 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3627:{ *:[iPTR] }, 1:{ *:[i32] }, MQPR:{ *:[v8f16] }:$in)  =>  (MVE_VCVTu16f16a:{ *:[v8i16] } MQPR:{ *:[v8f16] }:$in)
     /*  42726 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  42729 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  42733 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  42738 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCVTu16f16a),
     /*  42741 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  42743 */     GIR_RootToRootCopy, /*OpIdx*/3, // in
     /*  42745 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  42748 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  42754 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  42760 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  42763 */     GIR_RootConstrainSelectedInstOperands,
     /*  42764 */     // GIR_Coverage, 4063,
     /*  42764 */     GIR_EraseRootFromParent_Done,
     /*  42765 */   // Label 971: @42765
     /*  42765 */   GIM_Try, /*On fail goto*//*Label 972*/ GIMT_Encode4(42838), // Rule ID 4065 //
     /*  42770 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  42773 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vcvtn),
     /*  42778 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  42781 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  42784 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  42787 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  42791 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 1,
     /*  42795 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  42799 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3631:{ *:[iPTR] }, 1:{ *:[i32] }, MQPR:{ *:[v8f16] }:$in)  =>  (MVE_VCVTu16f16n:{ *:[v8i16] } MQPR:{ *:[v8f16] }:$in)
     /*  42799 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  42802 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  42806 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  42811 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCVTu16f16n),
     /*  42814 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  42816 */     GIR_RootToRootCopy, /*OpIdx*/3, // in
     /*  42818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  42821 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  42827 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  42833 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  42836 */     GIR_RootConstrainSelectedInstOperands,
     /*  42837 */     // GIR_Coverage, 4065,
     /*  42837 */     GIR_EraseRootFromParent_Done,
     /*  42838 */   // Label 972: @42838
     /*  42838 */   GIM_Try, /*On fail goto*//*Label 973*/ GIMT_Encode4(42911), // Rule ID 4067 //
     /*  42843 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  42846 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vcvtp),
     /*  42851 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  42854 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  42857 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  42860 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  42864 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 1,
     /*  42868 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  42872 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3633:{ *:[iPTR] }, 1:{ *:[i32] }, MQPR:{ *:[v8f16] }:$in)  =>  (MVE_VCVTu16f16p:{ *:[v8i16] } MQPR:{ *:[v8f16] }:$in)
     /*  42872 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  42875 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  42879 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  42884 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCVTu16f16p),
     /*  42887 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  42889 */     GIR_RootToRootCopy, /*OpIdx*/3, // in
     /*  42891 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  42894 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  42900 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  42906 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  42909 */     GIR_RootConstrainSelectedInstOperands,
     /*  42910 */     // GIR_Coverage, 4067,
     /*  42910 */     GIR_EraseRootFromParent_Done,
     /*  42911 */   // Label 973: @42911
     /*  42911 */   GIM_Try, /*On fail goto*//*Label 974*/ GIMT_Encode4(42984), // Rule ID 4069 //
     /*  42916 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  42919 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vcvtm),
     /*  42924 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  42927 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  42930 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  42933 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  42937 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 1,
     /*  42941 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  42945 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3629:{ *:[iPTR] }, 1:{ *:[i32] }, MQPR:{ *:[v8f16] }:$in)  =>  (MVE_VCVTu16f16m:{ *:[v8i16] } MQPR:{ *:[v8f16] }:$in)
     /*  42945 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  42948 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  42952 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  42957 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCVTu16f16m),
     /*  42960 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  42962 */     GIR_RootToRootCopy, /*OpIdx*/3, // in
     /*  42964 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  42967 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  42973 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  42979 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  42982 */     GIR_RootConstrainSelectedInstOperands,
     /*  42983 */     // GIR_Coverage, 4069,
     /*  42983 */     GIR_EraseRootFromParent_Done,
     /*  42984 */   // Label 974: @42984
     /*  42984 */   GIM_Try, /*On fail goto*//*Label 975*/ GIMT_Encode4(43057), // Rule ID 4071 //
     /*  42989 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  42992 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vcvta),
     /*  42997 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  43000 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  43003 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  43006 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  43010 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /*  43014 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  43018 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3627:{ *:[iPTR] }, 0:{ *:[i32] }, MQPR:{ *:[v4f32] }:$in)  =>  (MVE_VCVTs32f32a:{ *:[v4i32] } MQPR:{ *:[v4f32] }:$in)
     /*  43018 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  43021 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  43025 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  43030 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCVTs32f32a),
     /*  43033 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  43035 */     GIR_RootToRootCopy, /*OpIdx*/3, // in
     /*  43037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  43040 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  43046 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  43052 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  43055 */     GIR_RootConstrainSelectedInstOperands,
     /*  43056 */     // GIR_Coverage, 4071,
     /*  43056 */     GIR_EraseRootFromParent_Done,
     /*  43057 */   // Label 975: @43057
     /*  43057 */   GIM_Try, /*On fail goto*//*Label 976*/ GIMT_Encode4(43130), // Rule ID 4073 //
     /*  43062 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  43065 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vcvtn),
     /*  43070 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  43073 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  43076 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  43079 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  43083 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /*  43087 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  43091 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3631:{ *:[iPTR] }, 0:{ *:[i32] }, MQPR:{ *:[v4f32] }:$in)  =>  (MVE_VCVTs32f32n:{ *:[v4i32] } MQPR:{ *:[v4f32] }:$in)
     /*  43091 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  43094 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  43098 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  43103 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCVTs32f32n),
     /*  43106 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  43108 */     GIR_RootToRootCopy, /*OpIdx*/3, // in
     /*  43110 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  43113 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  43119 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  43125 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  43128 */     GIR_RootConstrainSelectedInstOperands,
     /*  43129 */     // GIR_Coverage, 4073,
     /*  43129 */     GIR_EraseRootFromParent_Done,
     /*  43130 */   // Label 976: @43130
     /*  43130 */   GIM_Try, /*On fail goto*//*Label 977*/ GIMT_Encode4(43203), // Rule ID 4075 //
     /*  43135 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  43138 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vcvtp),
     /*  43143 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  43146 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  43149 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  43152 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  43156 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /*  43160 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  43164 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3633:{ *:[iPTR] }, 0:{ *:[i32] }, MQPR:{ *:[v4f32] }:$in)  =>  (MVE_VCVTs32f32p:{ *:[v4i32] } MQPR:{ *:[v4f32] }:$in)
     /*  43164 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  43167 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  43171 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  43176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCVTs32f32p),
     /*  43179 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  43181 */     GIR_RootToRootCopy, /*OpIdx*/3, // in
     /*  43183 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  43186 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  43192 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  43198 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  43201 */     GIR_RootConstrainSelectedInstOperands,
     /*  43202 */     // GIR_Coverage, 4075,
     /*  43202 */     GIR_EraseRootFromParent_Done,
     /*  43203 */   // Label 977: @43203
     /*  43203 */   GIM_Try, /*On fail goto*//*Label 978*/ GIMT_Encode4(43276), // Rule ID 4077 //
     /*  43208 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  43211 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vcvtm),
     /*  43216 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  43219 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  43222 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  43225 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  43229 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /*  43233 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  43237 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3629:{ *:[iPTR] }, 0:{ *:[i32] }, MQPR:{ *:[v4f32] }:$in)  =>  (MVE_VCVTs32f32m:{ *:[v4i32] } MQPR:{ *:[v4f32] }:$in)
     /*  43237 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  43240 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  43244 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  43249 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCVTs32f32m),
     /*  43252 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  43254 */     GIR_RootToRootCopy, /*OpIdx*/3, // in
     /*  43256 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  43259 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  43265 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  43271 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  43274 */     GIR_RootConstrainSelectedInstOperands,
     /*  43275 */     // GIR_Coverage, 4077,
     /*  43275 */     GIR_EraseRootFromParent_Done,
     /*  43276 */   // Label 978: @43276
     /*  43276 */   GIM_Try, /*On fail goto*//*Label 979*/ GIMT_Encode4(43349), // Rule ID 4079 //
     /*  43281 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  43284 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vcvta),
     /*  43289 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  43292 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  43295 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  43298 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  43302 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 1,
     /*  43306 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  43310 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3627:{ *:[iPTR] }, 1:{ *:[i32] }, MQPR:{ *:[v4f32] }:$in)  =>  (MVE_VCVTu32f32a:{ *:[v4i32] } MQPR:{ *:[v4f32] }:$in)
     /*  43310 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  43313 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  43317 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  43322 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCVTu32f32a),
     /*  43325 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  43327 */     GIR_RootToRootCopy, /*OpIdx*/3, // in
     /*  43329 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  43332 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  43338 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  43344 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  43347 */     GIR_RootConstrainSelectedInstOperands,
     /*  43348 */     // GIR_Coverage, 4079,
     /*  43348 */     GIR_EraseRootFromParent_Done,
     /*  43349 */   // Label 979: @43349
     /*  43349 */   GIM_Try, /*On fail goto*//*Label 980*/ GIMT_Encode4(43422), // Rule ID 4081 //
     /*  43354 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  43357 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vcvtn),
     /*  43362 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  43365 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  43368 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  43371 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  43375 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 1,
     /*  43379 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  43383 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3631:{ *:[iPTR] }, 1:{ *:[i32] }, MQPR:{ *:[v4f32] }:$in)  =>  (MVE_VCVTu32f32n:{ *:[v4i32] } MQPR:{ *:[v4f32] }:$in)
     /*  43383 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  43386 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  43390 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  43395 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCVTu32f32n),
     /*  43398 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  43400 */     GIR_RootToRootCopy, /*OpIdx*/3, // in
     /*  43402 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  43405 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  43411 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  43417 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  43420 */     GIR_RootConstrainSelectedInstOperands,
     /*  43421 */     // GIR_Coverage, 4081,
     /*  43421 */     GIR_EraseRootFromParent_Done,
     /*  43422 */   // Label 980: @43422
     /*  43422 */   GIM_Try, /*On fail goto*//*Label 981*/ GIMT_Encode4(43495), // Rule ID 4083 //
     /*  43427 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  43430 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vcvtp),
     /*  43435 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  43438 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  43441 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  43444 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  43448 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 1,
     /*  43452 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  43456 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3633:{ *:[iPTR] }, 1:{ *:[i32] }, MQPR:{ *:[v4f32] }:$in)  =>  (MVE_VCVTu32f32p:{ *:[v4i32] } MQPR:{ *:[v4f32] }:$in)
     /*  43456 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  43459 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  43463 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  43468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCVTu32f32p),
     /*  43471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  43473 */     GIR_RootToRootCopy, /*OpIdx*/3, // in
     /*  43475 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  43478 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  43484 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  43490 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  43493 */     GIR_RootConstrainSelectedInstOperands,
     /*  43494 */     // GIR_Coverage, 4083,
     /*  43494 */     GIR_EraseRootFromParent_Done,
     /*  43495 */   // Label 981: @43495
     /*  43495 */   GIM_Try, /*On fail goto*//*Label 982*/ GIMT_Encode4(43568), // Rule ID 4085 //
     /*  43500 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  43503 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vcvtm),
     /*  43508 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  43511 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  43514 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  43517 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  43521 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 1,
     /*  43525 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  43529 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3629:{ *:[iPTR] }, 1:{ *:[i32] }, MQPR:{ *:[v4f32] }:$in)  =>  (MVE_VCVTu32f32m:{ *:[v4i32] } MQPR:{ *:[v4f32] }:$in)
     /*  43529 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  43532 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  43536 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  43541 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCVTu32f32m),
     /*  43544 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  43546 */     GIR_RootToRootCopy, /*OpIdx*/3, // in
     /*  43548 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  43551 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  43557 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  43563 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  43566 */     GIR_RootConstrainSelectedInstOperands,
     /*  43567 */     // GIR_Coverage, 4085,
     /*  43567 */     GIR_EraseRootFromParent_Done,
     /*  43568 */   // Label 982: @43568
     /*  43568 */   GIM_Try, /*On fail goto*//*Label 983*/ GIMT_Encode4(43641), // Rule ID 4529 //
     /*  43573 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  43576 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vcvt_widen),
     /*  43581 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  43584 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  43587 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  43590 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  43594 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  43598 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /*  43602 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3625:{ *:[iPTR] }, MQPR:{ *:[v8f16] }:$Qm, 0:{ *:[i32] })  =>  (MVE_VCVTf32f16bh:{ *:[v4f32] } MQPR:{ *:[v8f16] }:$Qm)
     /*  43602 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  43605 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  43609 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  43614 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCVTf32f16bh),
     /*  43617 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  43619 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  43621 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  43624 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  43630 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  43636 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  43639 */     GIR_RootConstrainSelectedInstOperands,
     /*  43640 */     // GIR_Coverage, 4529,
     /*  43640 */     GIR_EraseRootFromParent_Done,
     /*  43641 */   // Label 983: @43641
     /*  43641 */   GIM_Try, /*On fail goto*//*Label 984*/ GIMT_Encode4(43714), // Rule ID 4535 //
     /*  43646 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  43649 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vcvt_widen),
     /*  43654 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  43657 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  43660 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  43663 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  43667 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  43671 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 1,
     /*  43675 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3625:{ *:[iPTR] }, MQPR:{ *:[v8f16] }:$Qm, 1:{ *:[i32] })  =>  (MVE_VCVTf32f16th:{ *:[v4f32] } MQPR:{ *:[v8f16] }:$Qm)
     /*  43675 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  43678 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  43682 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  43687 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCVTf32f16th),
     /*  43690 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  43692 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  43694 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  43697 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  43703 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  43709 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  43712 */     GIR_RootConstrainSelectedInstOperands,
     /*  43713 */     // GIR_Coverage, 4535,
     /*  43713 */     GIR_EraseRootFromParent_Done,
     /*  43714 */   // Label 984: @43714
     /*  43714 */   GIM_Try, /*On fail goto*//*Label 985*/ GIMT_Encode4(43782), // Rule ID 1878 //
     /*  43719 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*  43722 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_usat),
     /*  43727 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  43730 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  43733 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  43736 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  43740 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  43744 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  43748 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  43752 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_31),
     /*  43756 */     // MIs[1] Operand 1
     /*  43756 */     // No operand predicates
     /*  43756 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  43758 */     // (intrinsic_wo_chain:{ *:[i32] } 3941:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$a, (imm:{ *:[i32] })<<P:Predicate_imm0_31>>:$pos)  =>  (USAT:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_imm0_31>>:$pos, GPRnopc:{ *:[i32] }:$a, 0:{ *:[i32] })
     /*  43758 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::USAT),
     /*  43761 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  43763 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // pos
     /*  43766 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  43768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  43771 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  43774 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  43780 */     GIR_RootConstrainSelectedInstOperands,
     /*  43781 */     // GIR_Coverage, 1878,
     /*  43781 */     GIR_EraseRootFromParent_Done,
     /*  43782 */   // Label 985: @43782
     /*  43782 */   GIM_Try, /*On fail goto*//*Label 986*/ GIMT_Encode4(43847), // Rule ID 1882 //
     /*  43787 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*  43790 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_usat16),
     /*  43795 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  43798 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  43801 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  43804 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  43808 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  43812 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  43816 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  43820 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_15),
     /*  43824 */     // MIs[1] Operand 1
     /*  43824 */     // No operand predicates
     /*  43824 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  43826 */     // (intrinsic_wo_chain:{ *:[i32] } 3942:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$a, (imm:{ *:[i32] })<<P:Predicate_imm0_15>>:$pos)  =>  (USAT16:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_imm0_15>>:$pos, GPRnopc:{ *:[i32] }:$a)
     /*  43826 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::USAT16),
     /*  43829 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  43831 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // pos
     /*  43834 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  43836 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  43839 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  43845 */     GIR_RootConstrainSelectedInstOperands,
     /*  43846 */     // GIR_Coverage, 1882,
     /*  43846 */     GIR_EraseRootFromParent_Done,
     /*  43847 */   // Label 986: @43847
     /*  43847 */   GIM_Try, /*On fail goto*//*Label 987*/ GIMT_Encode4(43915), // Rule ID 2146 //
     /*  43852 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /*  43855 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_usat),
     /*  43860 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  43863 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  43866 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  43869 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  43873 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  43877 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  43881 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  43885 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_31),
     /*  43889 */     // MIs[1] Operand 1
     /*  43889 */     // No operand predicates
     /*  43889 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  43891 */     // (intrinsic_wo_chain:{ *:[i32] } 3941:{ *:[iPTR] }, GPR:{ *:[i32] }:$a, (imm:{ *:[i32] })<<P:Predicate_imm0_31>>:$pos)  =>  (t2USAT:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_imm0_31>>:$pos, GPR:{ *:[i32] }:$a, 0:{ *:[i32] })
     /*  43891 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2USAT),
     /*  43894 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  43896 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // pos
     /*  43899 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  43901 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  43904 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  43907 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  43913 */     GIR_RootConstrainSelectedInstOperands,
     /*  43914 */     // GIR_Coverage, 2146,
     /*  43914 */     GIR_EraseRootFromParent_Done,
     /*  43915 */   // Label 987: @43915
     /*  43915 */   GIM_Try, /*On fail goto*//*Label 988*/ GIMT_Encode4(43980), // Rule ID 2148 //
     /*  43920 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /*  43923 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_usat16),
     /*  43928 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  43931 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  43934 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  43937 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  43941 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  43945 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  43949 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  43953 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_15),
     /*  43957 */     // MIs[1] Operand 1
     /*  43957 */     // No operand predicates
     /*  43957 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  43959 */     // (intrinsic_wo_chain:{ *:[i32] } 3942:{ *:[iPTR] }, GPR:{ *:[i32] }:$a, (imm:{ *:[i32] })<<P:Predicate_imm0_15>>:$pos)  =>  (t2USAT16:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_imm0_15>>:$pos, GPR:{ *:[i32] }:$a)
     /*  43959 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2USAT16),
     /*  43962 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  43964 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // pos
     /*  43967 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  43969 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  43972 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  43978 */     GIR_RootConstrainSelectedInstOperands,
     /*  43979 */     // GIR_Coverage, 2148,
     /*  43979 */     GIR_EraseRootFromParent_Done,
     /*  43980 */   // Label 988: @43980
     /*  43980 */   GIM_Try, /*On fail goto*//*Label 989*/ GIMT_Encode4(44063), // Rule ID 3925 //
     /*  43985 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqshlu_imm),
     /*  43990 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  43993 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  43996 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  43999 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  44003 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  44007 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  44011 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  44015 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_7),
     /*  44019 */     // MIs[1] Operand 1
     /*  44019 */     // No operand predicates
     /*  44019 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  44021 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3686:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$src, (imm:{ *:[i32] })<<P:Predicate_imm0_7>>:$imm)  =>  (MVE_VQSHLU_imms8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$src, (imm:{ *:[i32] })<<P:Predicate_imm0_7>>:$imm)
     /*  44021 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  44024 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  44028 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  44033 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQSHLU_imms8),
     /*  44036 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  44038 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  44040 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  44043 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  44046 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  44052 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  44058 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  44061 */     GIR_RootConstrainSelectedInstOperands,
     /*  44062 */     // GIR_Coverage, 3925,
     /*  44062 */     GIR_EraseRootFromParent_Done,
     /*  44063 */   // Label 989: @44063
     /*  44063 */   GIM_Try, /*On fail goto*//*Label 990*/ GIMT_Encode4(44146), // Rule ID 3927 //
     /*  44068 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqshlu_imm),
     /*  44073 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  44076 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  44079 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  44082 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  44086 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  44090 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  44094 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  44098 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_15),
     /*  44102 */     // MIs[1] Operand 1
     /*  44102 */     // No operand predicates
     /*  44102 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  44104 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3686:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$src, (imm:{ *:[i32] })<<P:Predicate_imm0_15>>:$imm)  =>  (MVE_VQSHLU_imms16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$src, (imm:{ *:[i32] })<<P:Predicate_imm0_15>>:$imm)
     /*  44104 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  44107 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  44111 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  44116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQSHLU_imms16),
     /*  44119 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  44121 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  44123 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  44126 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  44129 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  44135 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  44141 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  44144 */     GIR_RootConstrainSelectedInstOperands,
     /*  44145 */     // GIR_Coverage, 3927,
     /*  44145 */     GIR_EraseRootFromParent_Done,
     /*  44146 */   // Label 990: @44146
     /*  44146 */   GIM_Try, /*On fail goto*//*Label 991*/ GIMT_Encode4(44229), // Rule ID 3929 //
     /*  44151 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqshlu_imm),
     /*  44156 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  44159 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  44162 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  44165 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  44169 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  44173 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  44177 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  44181 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_31),
     /*  44185 */     // MIs[1] Operand 1
     /*  44185 */     // No operand predicates
     /*  44185 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  44187 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3686:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$src, (imm:{ *:[i32] })<<P:Predicate_imm0_31>>:$imm)  =>  (MVE_VQSHLU_imms32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$src, (imm:{ *:[i32] })<<P:Predicate_imm0_31>>:$imm)
     /*  44187 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  44190 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  44194 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  44199 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQSHLU_imms32),
     /*  44202 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  44204 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  44206 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  44209 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  44212 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  44218 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  44224 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  44227 */     GIR_RootConstrainSelectedInstOperands,
     /*  44228 */     // GIR_Coverage, 3929,
     /*  44228 */     GIR_EraseRootFromParent_Done,
     /*  44229 */   // Label 991: @44229
     /*  44229 */   GIM_Try, /*On fail goto*//*Label 992*/ GIMT_Encode4(44290), // Rule ID 1649 //
     /*  44234 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  44237 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtfp2fxs),
     /*  44242 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  44245 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  44248 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  44251 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  44255 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  44259 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  44263 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  44267 */     // MIs[1] Operand 1
     /*  44267 */     // No operand predicates
     /*  44267 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  44269 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3763:{ *:[iPTR] }, DPR:{ *:[v2f32] }:$Vm, (imm:{ *:[i32] }):$SIMM)  =>  (VCVTf2xsd:{ *:[v2i32] } DPR:{ *:[v2f32] }:$Vm, (imm:{ *:[i32] }):$SIMM)
     /*  44269 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTf2xsd),
     /*  44272 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  44274 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  44276 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // SIMM
     /*  44279 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  44282 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  44288 */     GIR_RootConstrainSelectedInstOperands,
     /*  44289 */     // GIR_Coverage, 1649,
     /*  44289 */     GIR_EraseRootFromParent_Done,
     /*  44290 */   // Label 992: @44290
     /*  44290 */   GIM_Try, /*On fail goto*//*Label 993*/ GIMT_Encode4(44351), // Rule ID 1650 //
     /*  44295 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  44298 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtfp2fxu),
     /*  44303 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  44306 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  44309 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  44312 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  44316 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  44320 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  44324 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  44328 */     // MIs[1] Operand 1
     /*  44328 */     // No operand predicates
     /*  44328 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  44330 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3764:{ *:[iPTR] }, DPR:{ *:[v2f32] }:$Vm, (imm:{ *:[i32] }):$SIMM)  =>  (VCVTf2xud:{ *:[v2i32] } DPR:{ *:[v2f32] }:$Vm, (imm:{ *:[i32] }):$SIMM)
     /*  44330 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTf2xud),
     /*  44333 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  44335 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  44337 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // SIMM
     /*  44340 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  44343 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  44349 */     GIR_RootConstrainSelectedInstOperands,
     /*  44350 */     // GIR_Coverage, 1650,
     /*  44350 */     GIR_EraseRootFromParent_Done,
     /*  44351 */   // Label 993: @44351
     /*  44351 */   GIM_Try, /*On fail goto*//*Label 994*/ GIMT_Encode4(44412), // Rule ID 1651 //
     /*  44356 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  44359 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtfxs2fp),
     /*  44364 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  44367 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  44370 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  44373 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  44377 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  44381 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  44385 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  44389 */     // MIs[1] Operand 1
     /*  44389 */     // No operand predicates
     /*  44389 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  44391 */     // (intrinsic_wo_chain:{ *:[v2f32] } 3766:{ *:[iPTR] }, DPR:{ *:[v2i32] }:$Vm, (imm:{ *:[i32] }):$SIMM)  =>  (VCVTxs2fd:{ *:[v2f32] } DPR:{ *:[v2i32] }:$Vm, (imm:{ *:[i32] }):$SIMM)
     /*  44391 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTxs2fd),
     /*  44394 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  44396 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  44398 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // SIMM
     /*  44401 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  44404 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  44410 */     GIR_RootConstrainSelectedInstOperands,
     /*  44411 */     // GIR_Coverage, 1651,
     /*  44411 */     GIR_EraseRootFromParent_Done,
     /*  44412 */   // Label 994: @44412
     /*  44412 */   GIM_Try, /*On fail goto*//*Label 995*/ GIMT_Encode4(44473), // Rule ID 1652 //
     /*  44417 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  44420 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtfxu2fp),
     /*  44425 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  44428 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  44431 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  44434 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  44438 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  44442 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  44446 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  44450 */     // MIs[1] Operand 1
     /*  44450 */     // No operand predicates
     /*  44450 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  44452 */     // (intrinsic_wo_chain:{ *:[v2f32] } 3767:{ *:[iPTR] }, DPR:{ *:[v2i32] }:$Vm, (imm:{ *:[i32] }):$SIMM)  =>  (VCVTxu2fd:{ *:[v2f32] } DPR:{ *:[v2i32] }:$Vm, (imm:{ *:[i32] }):$SIMM)
     /*  44452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTxu2fd),
     /*  44455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  44457 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  44459 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // SIMM
     /*  44462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  44465 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  44471 */     GIR_RootConstrainSelectedInstOperands,
     /*  44472 */     // GIR_Coverage, 1652,
     /*  44472 */     GIR_EraseRootFromParent_Done,
     /*  44473 */   // Label 995: @44473
     /*  44473 */   GIM_Try, /*On fail goto*//*Label 996*/ GIMT_Encode4(44534), // Rule ID 1653 //
     /*  44478 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /*  44481 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtfp2fxs),
     /*  44486 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  44489 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  44492 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  44495 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  44499 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  44503 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  44507 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  44511 */     // MIs[1] Operand 1
     /*  44511 */     // No operand predicates
     /*  44511 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  44513 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3763:{ *:[iPTR] }, DPR:{ *:[v4f16] }:$Vm, (imm:{ *:[i32] }):$SIMM)  =>  (VCVTh2xsd:{ *:[v4i16] } DPR:{ *:[v4f16] }:$Vm, (imm:{ *:[i32] }):$SIMM)
     /*  44513 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTh2xsd),
     /*  44516 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  44518 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  44520 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // SIMM
     /*  44523 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  44526 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  44532 */     GIR_RootConstrainSelectedInstOperands,
     /*  44533 */     // GIR_Coverage, 1653,
     /*  44533 */     GIR_EraseRootFromParent_Done,
     /*  44534 */   // Label 996: @44534
     /*  44534 */   GIM_Try, /*On fail goto*//*Label 997*/ GIMT_Encode4(44595), // Rule ID 1654 //
     /*  44539 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /*  44542 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtfp2fxu),
     /*  44547 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  44550 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  44553 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  44556 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  44560 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  44564 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  44568 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  44572 */     // MIs[1] Operand 1
     /*  44572 */     // No operand predicates
     /*  44572 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  44574 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3764:{ *:[iPTR] }, DPR:{ *:[v4f16] }:$Vm, (imm:{ *:[i32] }):$SIMM)  =>  (VCVTh2xud:{ *:[v4i16] } DPR:{ *:[v4f16] }:$Vm, (imm:{ *:[i32] }):$SIMM)
     /*  44574 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTh2xud),
     /*  44577 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  44579 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  44581 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // SIMM
     /*  44584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  44587 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  44593 */     GIR_RootConstrainSelectedInstOperands,
     /*  44594 */     // GIR_Coverage, 1654,
     /*  44594 */     GIR_EraseRootFromParent_Done,
     /*  44595 */   // Label 997: @44595
     /*  44595 */   GIM_Try, /*On fail goto*//*Label 998*/ GIMT_Encode4(44656), // Rule ID 1655 //
     /*  44600 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /*  44603 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtfxs2fp),
     /*  44608 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  44611 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  44614 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  44617 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  44621 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  44625 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  44629 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  44633 */     // MIs[1] Operand 1
     /*  44633 */     // No operand predicates
     /*  44633 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  44635 */     // (intrinsic_wo_chain:{ *:[v4f16] } 3766:{ *:[iPTR] }, DPR:{ *:[v4i16] }:$Vm, (imm:{ *:[i32] }):$SIMM)  =>  (VCVTxs2hd:{ *:[v4f16] } DPR:{ *:[v4i16] }:$Vm, (imm:{ *:[i32] }):$SIMM)
     /*  44635 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTxs2hd),
     /*  44638 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  44640 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  44642 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // SIMM
     /*  44645 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  44648 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  44654 */     GIR_RootConstrainSelectedInstOperands,
     /*  44655 */     // GIR_Coverage, 1655,
     /*  44655 */     GIR_EraseRootFromParent_Done,
     /*  44656 */   // Label 998: @44656
     /*  44656 */   GIM_Try, /*On fail goto*//*Label 999*/ GIMT_Encode4(44717), // Rule ID 1656 //
     /*  44661 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /*  44664 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtfxu2fp),
     /*  44669 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  44672 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  44675 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  44678 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  44682 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  44686 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  44690 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  44694 */     // MIs[1] Operand 1
     /*  44694 */     // No operand predicates
     /*  44694 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  44696 */     // (intrinsic_wo_chain:{ *:[v4f16] } 3767:{ *:[iPTR] }, DPR:{ *:[v4i16] }:$Vm, (imm:{ *:[i32] }):$SIMM)  =>  (VCVTxu2hd:{ *:[v4f16] } DPR:{ *:[v4i16] }:$Vm, (imm:{ *:[i32] }):$SIMM)
     /*  44696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTxu2hd),
     /*  44699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  44701 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  44703 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // SIMM
     /*  44706 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  44709 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  44715 */     GIR_RootConstrainSelectedInstOperands,
     /*  44716 */     // GIR_Coverage, 1656,
     /*  44716 */     GIR_EraseRootFromParent_Done,
     /*  44717 */   // Label 999: @44717
     /*  44717 */   GIM_Try, /*On fail goto*//*Label 1000*/ GIMT_Encode4(44778), // Rule ID 1657 //
     /*  44722 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  44725 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtfp2fxs),
     /*  44730 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  44733 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  44736 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  44739 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  44743 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  44747 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  44751 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  44755 */     // MIs[1] Operand 1
     /*  44755 */     // No operand predicates
     /*  44755 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  44757 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3763:{ *:[iPTR] }, QPR:{ *:[v4f32] }:$Vm, (imm:{ *:[i32] }):$SIMM)  =>  (VCVTf2xsq:{ *:[v4i32] } QPR:{ *:[v4f32] }:$Vm, (imm:{ *:[i32] }):$SIMM)
     /*  44757 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTf2xsq),
     /*  44760 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  44762 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  44764 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // SIMM
     /*  44767 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  44770 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  44776 */     GIR_RootConstrainSelectedInstOperands,
     /*  44777 */     // GIR_Coverage, 1657,
     /*  44777 */     GIR_EraseRootFromParent_Done,
     /*  44778 */   // Label 1000: @44778
     /*  44778 */   GIM_Try, /*On fail goto*//*Label 1001*/ GIMT_Encode4(44839), // Rule ID 1658 //
     /*  44783 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  44786 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtfp2fxu),
     /*  44791 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  44794 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  44797 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  44800 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  44804 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  44808 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  44812 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  44816 */     // MIs[1] Operand 1
     /*  44816 */     // No operand predicates
     /*  44816 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  44818 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3764:{ *:[iPTR] }, QPR:{ *:[v4f32] }:$Vm, (imm:{ *:[i32] }):$SIMM)  =>  (VCVTf2xuq:{ *:[v4i32] } QPR:{ *:[v4f32] }:$Vm, (imm:{ *:[i32] }):$SIMM)
     /*  44818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTf2xuq),
     /*  44821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  44823 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  44825 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // SIMM
     /*  44828 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  44831 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  44837 */     GIR_RootConstrainSelectedInstOperands,
     /*  44838 */     // GIR_Coverage, 1658,
     /*  44838 */     GIR_EraseRootFromParent_Done,
     /*  44839 */   // Label 1001: @44839
     /*  44839 */   GIM_Try, /*On fail goto*//*Label 1002*/ GIMT_Encode4(44900), // Rule ID 1659 //
     /*  44844 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  44847 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtfxs2fp),
     /*  44852 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  44855 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  44858 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  44861 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  44865 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  44869 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  44873 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  44877 */     // MIs[1] Operand 1
     /*  44877 */     // No operand predicates
     /*  44877 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  44879 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3766:{ *:[iPTR] }, QPR:{ *:[v4i32] }:$Vm, (imm:{ *:[i32] }):$SIMM)  =>  (VCVTxs2fq:{ *:[v4f32] } QPR:{ *:[v4i32] }:$Vm, (imm:{ *:[i32] }):$SIMM)
     /*  44879 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTxs2fq),
     /*  44882 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  44884 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  44886 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // SIMM
     /*  44889 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  44892 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  44898 */     GIR_RootConstrainSelectedInstOperands,
     /*  44899 */     // GIR_Coverage, 1659,
     /*  44899 */     GIR_EraseRootFromParent_Done,
     /*  44900 */   // Label 1002: @44900
     /*  44900 */   GIM_Try, /*On fail goto*//*Label 1003*/ GIMT_Encode4(44961), // Rule ID 1660 //
     /*  44905 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  44908 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtfxu2fp),
     /*  44913 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  44916 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  44919 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  44922 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  44926 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  44930 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  44934 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  44938 */     // MIs[1] Operand 1
     /*  44938 */     // No operand predicates
     /*  44938 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  44940 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3767:{ *:[iPTR] }, QPR:{ *:[v4i32] }:$Vm, (imm:{ *:[i32] }):$SIMM)  =>  (VCVTxu2fq:{ *:[v4f32] } QPR:{ *:[v4i32] }:$Vm, (imm:{ *:[i32] }):$SIMM)
     /*  44940 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTxu2fq),
     /*  44943 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  44945 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  44947 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // SIMM
     /*  44950 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  44953 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  44959 */     GIR_RootConstrainSelectedInstOperands,
     /*  44960 */     // GIR_Coverage, 1660,
     /*  44960 */     GIR_EraseRootFromParent_Done,
     /*  44961 */   // Label 1003: @44961
     /*  44961 */   GIM_Try, /*On fail goto*//*Label 1004*/ GIMT_Encode4(45022), // Rule ID 1661 //
     /*  44966 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /*  44969 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtfp2fxs),
     /*  44974 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  44977 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  44980 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  44983 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  44987 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  44991 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  44995 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  44999 */     // MIs[1] Operand 1
     /*  44999 */     // No operand predicates
     /*  44999 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  45001 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3763:{ *:[iPTR] }, QPR:{ *:[v8f16] }:$Vm, (imm:{ *:[i32] }):$SIMM)  =>  (VCVTh2xsq:{ *:[v8i16] } QPR:{ *:[v8f16] }:$Vm, (imm:{ *:[i32] }):$SIMM)
     /*  45001 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTh2xsq),
     /*  45004 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  45006 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  45008 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // SIMM
     /*  45011 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  45014 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  45020 */     GIR_RootConstrainSelectedInstOperands,
     /*  45021 */     // GIR_Coverage, 1661,
     /*  45021 */     GIR_EraseRootFromParent_Done,
     /*  45022 */   // Label 1004: @45022
     /*  45022 */   GIM_Try, /*On fail goto*//*Label 1005*/ GIMT_Encode4(45083), // Rule ID 1662 //
     /*  45027 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /*  45030 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtfp2fxu),
     /*  45035 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  45038 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  45041 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  45044 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  45048 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  45052 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  45056 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  45060 */     // MIs[1] Operand 1
     /*  45060 */     // No operand predicates
     /*  45060 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  45062 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3764:{ *:[iPTR] }, QPR:{ *:[v8f16] }:$Vm, (imm:{ *:[i32] }):$SIMM)  =>  (VCVTh2xuq:{ *:[v8i16] } QPR:{ *:[v8f16] }:$Vm, (imm:{ *:[i32] }):$SIMM)
     /*  45062 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTh2xuq),
     /*  45065 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  45067 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  45069 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // SIMM
     /*  45072 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  45075 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  45081 */     GIR_RootConstrainSelectedInstOperands,
     /*  45082 */     // GIR_Coverage, 1662,
     /*  45082 */     GIR_EraseRootFromParent_Done,
     /*  45083 */   // Label 1005: @45083
     /*  45083 */   GIM_Try, /*On fail goto*//*Label 1006*/ GIMT_Encode4(45144), // Rule ID 1663 //
     /*  45088 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /*  45091 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtfxs2fp),
     /*  45096 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  45099 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  45102 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  45105 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  45109 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  45113 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  45117 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  45121 */     // MIs[1] Operand 1
     /*  45121 */     // No operand predicates
     /*  45121 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  45123 */     // (intrinsic_wo_chain:{ *:[v8f16] } 3766:{ *:[iPTR] }, QPR:{ *:[v8i16] }:$Vm, (imm:{ *:[i32] }):$SIMM)  =>  (VCVTxs2hq:{ *:[v8f16] } QPR:{ *:[v8i16] }:$Vm, (imm:{ *:[i32] }):$SIMM)
     /*  45123 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTxs2hq),
     /*  45126 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  45128 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  45130 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // SIMM
     /*  45133 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  45136 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  45142 */     GIR_RootConstrainSelectedInstOperands,
     /*  45143 */     // GIR_Coverage, 1663,
     /*  45143 */     GIR_EraseRootFromParent_Done,
     /*  45144 */   // Label 1006: @45144
     /*  45144 */   GIM_Try, /*On fail goto*//*Label 1007*/ GIMT_Encode4(45205), // Rule ID 1664 //
     /*  45149 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /*  45152 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtfxu2fp),
     /*  45157 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  45160 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  45163 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  45166 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  45170 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  45174 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  45178 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  45182 */     // MIs[1] Operand 1
     /*  45182 */     // No operand predicates
     /*  45182 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  45184 */     // (intrinsic_wo_chain:{ *:[v8f16] } 3767:{ *:[iPTR] }, QPR:{ *:[v8i16] }:$Vm, (imm:{ *:[i32] }):$SIMM)  =>  (VCVTxu2hq:{ *:[v8f16] } QPR:{ *:[v8i16] }:$Vm, (imm:{ *:[i32] }):$SIMM)
     /*  45184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTxu2hq),
     /*  45187 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  45189 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  45191 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // SIMM
     /*  45194 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  45197 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  45203 */     GIR_RootConstrainSelectedInstOperands,
     /*  45204 */     // GIR_Coverage, 1664,
     /*  45204 */     GIR_EraseRootFromParent_Done,
     /*  45205 */   // Label 1007: @45205
     /*  45205 */   GIM_Try, /*On fail goto*//*Label 1008*/ GIMT_Encode4(45266), // Rule ID 1722 //
     /*  45210 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_HasV8_1MMainline),
     /*  45213 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_sqshl),
     /*  45218 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  45221 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  45224 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  45227 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  45231 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  45235 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  45239 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  45243 */     // MIs[1] Operand 1
     /*  45243 */     // No operand predicates
     /*  45243 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  45245 */     // (intrinsic_wo_chain:{ *:[i32] } 3591:{ *:[iPTR] }, rGPR:{ *:[i32] }:$RdaSrc, (imm:{ *:[i32] }):$imm)  =>  (MVE_SQSHL:{ *:[i32] } rGPR:{ *:[i32] }:$RdaSrc, (imm:{ *:[i32] }):$imm)
     /*  45245 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_SQSHL),
     /*  45248 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  45250 */     GIR_RootToRootCopy, /*OpIdx*/2, // RdaSrc
     /*  45252 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  45255 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  45258 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  45264 */     GIR_RootConstrainSelectedInstOperands,
     /*  45265 */     // GIR_Coverage, 1722,
     /*  45265 */     GIR_EraseRootFromParent_Done,
     /*  45266 */   // Label 1008: @45266
     /*  45266 */   GIM_Try, /*On fail goto*//*Label 1009*/ GIMT_Encode4(45327), // Rule ID 1723 //
     /*  45271 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_HasV8_1MMainline),
     /*  45274 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_srshr),
     /*  45279 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  45282 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  45285 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  45288 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  45292 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  45296 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  45300 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  45304 */     // MIs[1] Operand 1
     /*  45304 */     // No operand predicates
     /*  45304 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  45306 */     // (intrinsic_wo_chain:{ *:[i32] } 3593:{ *:[iPTR] }, rGPR:{ *:[i32] }:$RdaSrc, (imm:{ *:[i32] }):$imm)  =>  (MVE_SRSHR:{ *:[i32] } rGPR:{ *:[i32] }:$RdaSrc, (imm:{ *:[i32] }):$imm)
     /*  45306 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_SRSHR),
     /*  45309 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  45311 */     GIR_RootToRootCopy, /*OpIdx*/2, // RdaSrc
     /*  45313 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  45316 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  45319 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  45325 */     GIR_RootConstrainSelectedInstOperands,
     /*  45326 */     // GIR_Coverage, 1723,
     /*  45326 */     GIR_EraseRootFromParent_Done,
     /*  45327 */   // Label 1009: @45327
     /*  45327 */   GIM_Try, /*On fail goto*//*Label 1010*/ GIMT_Encode4(45388), // Rule ID 1724 //
     /*  45332 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_HasV8_1MMainline),
     /*  45335 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_uqshl),
     /*  45340 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  45343 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  45346 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  45349 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  45353 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  45357 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  45361 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  45365 */     // MIs[1] Operand 1
     /*  45365 */     // No operand predicates
     /*  45365 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  45367 */     // (intrinsic_wo_chain:{ *:[i32] } 3598:{ *:[iPTR] }, rGPR:{ *:[i32] }:$RdaSrc, (imm:{ *:[i32] }):$imm)  =>  (MVE_UQSHL:{ *:[i32] } rGPR:{ *:[i32] }:$RdaSrc, (imm:{ *:[i32] }):$imm)
     /*  45367 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_UQSHL),
     /*  45370 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  45372 */     GIR_RootToRootCopy, /*OpIdx*/2, // RdaSrc
     /*  45374 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  45377 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  45380 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  45386 */     GIR_RootConstrainSelectedInstOperands,
     /*  45387 */     // GIR_Coverage, 1724,
     /*  45387 */     GIR_EraseRootFromParent_Done,
     /*  45388 */   // Label 1010: @45388
     /*  45388 */   GIM_Try, /*On fail goto*//*Label 1011*/ GIMT_Encode4(45449), // Rule ID 1725 //
     /*  45393 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_HasV8_1MMainline),
     /*  45396 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_urshr),
     /*  45401 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  45404 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  45407 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  45410 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  45414 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  45418 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  45422 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  45426 */     // MIs[1] Operand 1
     /*  45426 */     // No operand predicates
     /*  45426 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  45428 */     // (intrinsic_wo_chain:{ *:[i32] } 3600:{ *:[iPTR] }, rGPR:{ *:[i32] }:$RdaSrc, (imm:{ *:[i32] }):$imm)  =>  (MVE_URSHR:{ *:[i32] } rGPR:{ *:[i32] }:$RdaSrc, (imm:{ *:[i32] }):$imm)
     /*  45428 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_URSHR),
     /*  45431 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  45433 */     GIR_RootToRootCopy, /*OpIdx*/2, // RdaSrc
     /*  45435 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  45438 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  45441 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  45447 */     GIR_RootConstrainSelectedInstOperands,
     /*  45448 */     // GIR_Coverage, 1725,
     /*  45448 */     GIR_EraseRootFromParent_Done,
     /*  45449 */   // Label 1011: @45449
     /*  45449 */   GIM_Try, /*On fail goto*//*Label 1012*/ GIMT_Encode4(45503), // Rule ID 105 //
     /*  45454 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  45457 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_qadd8),
     /*  45462 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  45465 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  45468 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  45471 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  45475 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  45479 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  45483 */     // (intrinsic_wo_chain:{ *:[i32] } 3866:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (QADD8:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  45483 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::QADD8),
     /*  45486 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  45488 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  45490 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  45492 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  45495 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  45501 */     GIR_RootConstrainSelectedInstOperands,
     /*  45502 */     // GIR_Coverage, 105,
     /*  45502 */     GIR_EraseRootFromParent_Done,
     /*  45503 */   // Label 1012: @45503
     /*  45503 */   GIM_Try, /*On fail goto*//*Label 1013*/ GIMT_Encode4(45557), // Rule ID 106 //
     /*  45508 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  45511 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_qadd16),
     /*  45516 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  45519 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  45522 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  45525 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  45529 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  45533 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  45537 */     // (intrinsic_wo_chain:{ *:[i32] } 3865:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (QADD16:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  45537 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::QADD16),
     /*  45540 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  45542 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  45544 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  45546 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  45549 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  45555 */     GIR_RootConstrainSelectedInstOperands,
     /*  45556 */     // GIR_Coverage, 106,
     /*  45556 */     GIR_EraseRootFromParent_Done,
     /*  45557 */   // Label 1013: @45557
     /*  45557 */   GIM_Try, /*On fail goto*//*Label 1014*/ GIMT_Encode4(45611), // Rule ID 107 //
     /*  45562 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  45565 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_qsub16),
     /*  45570 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  45573 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  45576 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  45579 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  45583 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  45587 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  45591 */     // (intrinsic_wo_chain:{ *:[i32] } 3870:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (QSUB16:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  45591 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::QSUB16),
     /*  45594 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  45596 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  45598 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  45600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  45603 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  45609 */     GIR_RootConstrainSelectedInstOperands,
     /*  45610 */     // GIR_Coverage, 107,
     /*  45610 */     GIR_EraseRootFromParent_Done,
     /*  45611 */   // Label 1014: @45611
     /*  45611 */   GIM_Try, /*On fail goto*//*Label 1015*/ GIMT_Encode4(45665), // Rule ID 108 //
     /*  45616 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  45619 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_qsub8),
     /*  45624 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  45627 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  45630 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  45633 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  45637 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  45641 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  45645 */     // (intrinsic_wo_chain:{ *:[i32] } 3871:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (QSUB8:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  45645 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::QSUB8),
     /*  45648 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  45650 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  45652 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  45654 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  45657 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  45663 */     GIR_RootConstrainSelectedInstOperands,
     /*  45664 */     // GIR_Coverage, 108,
     /*  45664 */     GIR_EraseRootFromParent_Done,
     /*  45665 */   // Label 1015: @45665
     /*  45665 */   GIM_Try, /*On fail goto*//*Label 1016*/ GIMT_Encode4(45719), // Rule ID 111 //
     /*  45670 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  45673 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_qsub),
     /*  45678 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  45681 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  45684 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  45687 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  45691 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  45695 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  45699 */     // (intrinsic_wo_chain:{ *:[i32] } 3869:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rm, GPRnopc:{ *:[i32] }:$Rn)  =>  (QSUB:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rm, GPRnopc:{ *:[i32] }:$Rn)
     /*  45699 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::QSUB),
     /*  45702 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  45704 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /*  45706 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /*  45708 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  45711 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  45717 */     GIR_RootConstrainSelectedInstOperands,
     /*  45718 */     // GIR_Coverage, 111,
     /*  45718 */     GIR_EraseRootFromParent_Done,
     /*  45719 */   // Label 1016: @45719
     /*  45719 */   GIM_Try, /*On fail goto*//*Label 1017*/ GIMT_Encode4(45773), // Rule ID 112 //
     /*  45724 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  45727 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_qadd),
     /*  45732 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  45735 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  45738 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  45741 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  45745 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  45749 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  45753 */     // (intrinsic_wo_chain:{ *:[i32] } 3864:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rm, GPRnopc:{ *:[i32] }:$Rn)  =>  (QADD:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rm, GPRnopc:{ *:[i32] }:$Rn)
     /*  45753 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::QADD),
     /*  45756 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  45758 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /*  45760 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /*  45762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  45765 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  45771 */     GIR_RootConstrainSelectedInstOperands,
     /*  45772 */     // GIR_Coverage, 112,
     /*  45772 */     GIR_EraseRootFromParent_Done,
     /*  45773 */   // Label 1017: @45773
     /*  45773 */   GIM_Try, /*On fail goto*//*Label 1018*/ GIMT_Encode4(45827), // Rule ID 113 //
     /*  45778 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  45781 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_uqadd16),
     /*  45786 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  45789 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  45792 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  45795 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  45799 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  45803 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  45807 */     // (intrinsic_wo_chain:{ *:[i32] } 3933:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (UQADD16:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  45807 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::UQADD16),
     /*  45810 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  45812 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  45814 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  45816 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  45819 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  45825 */     GIR_RootConstrainSelectedInstOperands,
     /*  45826 */     // GIR_Coverage, 113,
     /*  45826 */     GIR_EraseRootFromParent_Done,
     /*  45827 */   // Label 1018: @45827
     /*  45827 */   GIM_Try, /*On fail goto*//*Label 1019*/ GIMT_Encode4(45881), // Rule ID 114 //
     /*  45832 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  45835 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_uqadd8),
     /*  45840 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  45843 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  45846 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  45849 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  45853 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  45857 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  45861 */     // (intrinsic_wo_chain:{ *:[i32] } 3934:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (UQADD8:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  45861 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::UQADD8),
     /*  45864 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  45866 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  45868 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  45870 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  45873 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  45879 */     GIR_RootConstrainSelectedInstOperands,
     /*  45880 */     // GIR_Coverage, 114,
     /*  45880 */     GIR_EraseRootFromParent_Done,
     /*  45881 */   // Label 1019: @45881
     /*  45881 */   GIM_Try, /*On fail goto*//*Label 1020*/ GIMT_Encode4(45935), // Rule ID 115 //
     /*  45886 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  45889 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_uqsub16),
     /*  45894 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  45897 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  45900 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  45903 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  45907 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  45911 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  45915 */     // (intrinsic_wo_chain:{ *:[i32] } 3937:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (UQSUB16:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  45915 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::UQSUB16),
     /*  45918 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  45920 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  45922 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  45924 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  45927 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  45933 */     GIR_RootConstrainSelectedInstOperands,
     /*  45934 */     // GIR_Coverage, 115,
     /*  45934 */     GIR_EraseRootFromParent_Done,
     /*  45935 */   // Label 1020: @45935
     /*  45935 */   GIM_Try, /*On fail goto*//*Label 1021*/ GIMT_Encode4(45989), // Rule ID 116 //
     /*  45940 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  45943 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_uqsub8),
     /*  45948 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  45951 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  45954 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  45957 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  45961 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  45965 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  45969 */     // (intrinsic_wo_chain:{ *:[i32] } 3938:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (UQSUB8:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  45969 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::UQSUB8),
     /*  45972 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  45974 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  45976 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  45978 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  45981 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  45987 */     GIR_RootConstrainSelectedInstOperands,
     /*  45988 */     // GIR_Coverage, 116,
     /*  45988 */     GIR_EraseRootFromParent_Done,
     /*  45989 */   // Label 1021: @45989
     /*  45989 */   GIM_Try, /*On fail goto*//*Label 1022*/ GIMT_Encode4(46043), // Rule ID 117 //
     /*  45994 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  45997 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_qasx),
     /*  46002 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  46005 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  46008 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  46011 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46015 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46019 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46023 */     // (intrinsic_wo_chain:{ *:[i32] } 3867:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (QASX:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  46023 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::QASX),
     /*  46026 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  46028 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  46030 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  46032 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  46035 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  46041 */     GIR_RootConstrainSelectedInstOperands,
     /*  46042 */     // GIR_Coverage, 117,
     /*  46042 */     GIR_EraseRootFromParent_Done,
     /*  46043 */   // Label 1022: @46043
     /*  46043 */   GIM_Try, /*On fail goto*//*Label 1023*/ GIMT_Encode4(46097), // Rule ID 118 //
     /*  46048 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  46051 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_qsax),
     /*  46056 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  46059 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  46062 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  46065 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46069 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46073 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46077 */     // (intrinsic_wo_chain:{ *:[i32] } 3868:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (QSAX:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  46077 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::QSAX),
     /*  46080 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  46082 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  46084 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  46086 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  46089 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  46095 */     GIR_RootConstrainSelectedInstOperands,
     /*  46096 */     // GIR_Coverage, 118,
     /*  46096 */     GIR_EraseRootFromParent_Done,
     /*  46097 */   // Label 1023: @46097
     /*  46097 */   GIM_Try, /*On fail goto*//*Label 1024*/ GIMT_Encode4(46151), // Rule ID 119 //
     /*  46102 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  46105 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_uqasx),
     /*  46110 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  46113 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  46116 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  46119 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46123 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46127 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46131 */     // (intrinsic_wo_chain:{ *:[i32] } 3935:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (UQASX:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  46131 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::UQASX),
     /*  46134 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  46136 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  46138 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  46140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  46143 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  46149 */     GIR_RootConstrainSelectedInstOperands,
     /*  46150 */     // GIR_Coverage, 119,
     /*  46150 */     GIR_EraseRootFromParent_Done,
     /*  46151 */   // Label 1024: @46151
     /*  46151 */   GIM_Try, /*On fail goto*//*Label 1025*/ GIMT_Encode4(46205), // Rule ID 120 //
     /*  46156 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  46159 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_uqsax),
     /*  46164 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  46167 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  46170 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  46173 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46177 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46181 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46185 */     // (intrinsic_wo_chain:{ *:[i32] } 3936:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (UQSAX:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  46185 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::UQSAX),
     /*  46188 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  46190 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  46192 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  46194 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  46197 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  46203 */     GIR_RootConstrainSelectedInstOperands,
     /*  46204 */     // GIR_Coverage, 120,
     /*  46204 */     GIR_EraseRootFromParent_Done,
     /*  46205 */   // Label 1025: @46205
     /*  46205 */   GIM_Try, /*On fail goto*//*Label 1026*/ GIMT_Encode4(46259), // Rule ID 133 //
     /*  46210 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  46213 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_shasx),
     /*  46218 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  46221 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  46224 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  46227 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46231 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46235 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46239 */     // (intrinsic_wo_chain:{ *:[i32] } 3879:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (SHASX:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  46239 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SHASX),
     /*  46242 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  46244 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  46246 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  46248 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  46251 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  46257 */     GIR_RootConstrainSelectedInstOperands,
     /*  46258 */     // GIR_Coverage, 133,
     /*  46258 */     GIR_EraseRootFromParent_Done,
     /*  46259 */   // Label 1026: @46259
     /*  46259 */   GIM_Try, /*On fail goto*//*Label 1027*/ GIMT_Encode4(46313), // Rule ID 134 //
     /*  46264 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  46267 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_shadd16),
     /*  46272 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  46275 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  46278 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  46281 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46285 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46289 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46293 */     // (intrinsic_wo_chain:{ *:[i32] } 3877:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (SHADD16:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  46293 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SHADD16),
     /*  46296 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  46298 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  46300 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  46302 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  46305 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  46311 */     GIR_RootConstrainSelectedInstOperands,
     /*  46312 */     // GIR_Coverage, 134,
     /*  46312 */     GIR_EraseRootFromParent_Done,
     /*  46313 */   // Label 1027: @46313
     /*  46313 */   GIM_Try, /*On fail goto*//*Label 1028*/ GIMT_Encode4(46367), // Rule ID 135 //
     /*  46318 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  46321 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_shadd8),
     /*  46326 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  46329 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  46332 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  46335 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46339 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46343 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46347 */     // (intrinsic_wo_chain:{ *:[i32] } 3878:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (SHADD8:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  46347 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SHADD8),
     /*  46350 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  46352 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  46354 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  46356 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  46359 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  46365 */     GIR_RootConstrainSelectedInstOperands,
     /*  46366 */     // GIR_Coverage, 135,
     /*  46366 */     GIR_EraseRootFromParent_Done,
     /*  46367 */   // Label 1028: @46367
     /*  46367 */   GIM_Try, /*On fail goto*//*Label 1029*/ GIMT_Encode4(46421), // Rule ID 136 //
     /*  46372 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  46375 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_shsax),
     /*  46380 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  46383 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  46386 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  46389 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46393 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46397 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46401 */     // (intrinsic_wo_chain:{ *:[i32] } 3880:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (SHSAX:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  46401 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SHSAX),
     /*  46404 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  46406 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  46408 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  46410 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  46413 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  46419 */     GIR_RootConstrainSelectedInstOperands,
     /*  46420 */     // GIR_Coverage, 136,
     /*  46420 */     GIR_EraseRootFromParent_Done,
     /*  46421 */   // Label 1029: @46421
     /*  46421 */   GIM_Try, /*On fail goto*//*Label 1030*/ GIMT_Encode4(46475), // Rule ID 137 //
     /*  46426 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  46429 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_shsub16),
     /*  46434 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  46437 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  46440 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  46443 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46447 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46451 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46455 */     // (intrinsic_wo_chain:{ *:[i32] } 3881:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (SHSUB16:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  46455 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SHSUB16),
     /*  46458 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  46460 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  46462 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  46464 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  46467 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  46473 */     GIR_RootConstrainSelectedInstOperands,
     /*  46474 */     // GIR_Coverage, 137,
     /*  46474 */     GIR_EraseRootFromParent_Done,
     /*  46475 */   // Label 1030: @46475
     /*  46475 */   GIM_Try, /*On fail goto*//*Label 1031*/ GIMT_Encode4(46529), // Rule ID 138 //
     /*  46480 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  46483 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_shsub8),
     /*  46488 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  46491 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  46494 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  46497 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46501 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46505 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46509 */     // (intrinsic_wo_chain:{ *:[i32] } 3882:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (SHSUB8:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  46509 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SHSUB8),
     /*  46512 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  46514 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  46516 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  46518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  46521 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  46527 */     GIR_RootConstrainSelectedInstOperands,
     /*  46528 */     // GIR_Coverage, 138,
     /*  46528 */     GIR_EraseRootFromParent_Done,
     /*  46529 */   // Label 1031: @46529
     /*  46529 */   GIM_Try, /*On fail goto*//*Label 1032*/ GIMT_Encode4(46583), // Rule ID 139 //
     /*  46534 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  46537 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_uhasx),
     /*  46542 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  46545 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  46548 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  46551 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46555 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46559 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46563 */     // (intrinsic_wo_chain:{ *:[i32] } 3928:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (UHASX:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  46563 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::UHASX),
     /*  46566 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  46568 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  46570 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  46572 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  46575 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  46581 */     GIR_RootConstrainSelectedInstOperands,
     /*  46582 */     // GIR_Coverage, 139,
     /*  46582 */     GIR_EraseRootFromParent_Done,
     /*  46583 */   // Label 1032: @46583
     /*  46583 */   GIM_Try, /*On fail goto*//*Label 1033*/ GIMT_Encode4(46637), // Rule ID 140 //
     /*  46588 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  46591 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_uhadd16),
     /*  46596 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  46599 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  46602 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  46605 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46609 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46613 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46617 */     // (intrinsic_wo_chain:{ *:[i32] } 3926:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (UHADD16:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  46617 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::UHADD16),
     /*  46620 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  46622 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  46624 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  46626 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  46629 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  46635 */     GIR_RootConstrainSelectedInstOperands,
     /*  46636 */     // GIR_Coverage, 140,
     /*  46636 */     GIR_EraseRootFromParent_Done,
     /*  46637 */   // Label 1033: @46637
     /*  46637 */   GIM_Try, /*On fail goto*//*Label 1034*/ GIMT_Encode4(46691), // Rule ID 141 //
     /*  46642 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  46645 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_uhadd8),
     /*  46650 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  46653 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  46656 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  46659 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46663 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46667 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46671 */     // (intrinsic_wo_chain:{ *:[i32] } 3927:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (UHADD8:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  46671 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::UHADD8),
     /*  46674 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  46676 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  46678 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  46680 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  46683 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  46689 */     GIR_RootConstrainSelectedInstOperands,
     /*  46690 */     // GIR_Coverage, 141,
     /*  46690 */     GIR_EraseRootFromParent_Done,
     /*  46691 */   // Label 1034: @46691
     /*  46691 */   GIM_Try, /*On fail goto*//*Label 1035*/ GIMT_Encode4(46745), // Rule ID 142 //
     /*  46696 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  46699 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_uhsax),
     /*  46704 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  46707 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  46710 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  46713 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46717 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46721 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46725 */     // (intrinsic_wo_chain:{ *:[i32] } 3929:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (UHSAX:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  46725 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::UHSAX),
     /*  46728 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  46730 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  46732 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  46734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  46737 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  46743 */     GIR_RootConstrainSelectedInstOperands,
     /*  46744 */     // GIR_Coverage, 142,
     /*  46744 */     GIR_EraseRootFromParent_Done,
     /*  46745 */   // Label 1035: @46745
     /*  46745 */   GIM_Try, /*On fail goto*//*Label 1036*/ GIMT_Encode4(46799), // Rule ID 143 //
     /*  46750 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  46753 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_uhsub16),
     /*  46758 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  46761 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  46764 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  46767 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46771 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46775 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46779 */     // (intrinsic_wo_chain:{ *:[i32] } 3930:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (UHSUB16:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  46779 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::UHSUB16),
     /*  46782 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  46784 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  46786 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  46788 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  46791 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  46797 */     GIR_RootConstrainSelectedInstOperands,
     /*  46798 */     // GIR_Coverage, 143,
     /*  46798 */     GIR_EraseRootFromParent_Done,
     /*  46799 */   // Label 1036: @46799
     /*  46799 */   GIM_Try, /*On fail goto*//*Label 1037*/ GIMT_Encode4(46853), // Rule ID 144 //
     /*  46804 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  46807 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_uhsub8),
     /*  46812 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  46815 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  46818 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  46821 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46825 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46829 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46833 */     // (intrinsic_wo_chain:{ *:[i32] } 3931:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (UHSUB8:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  46833 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::UHSUB8),
     /*  46836 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  46838 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  46840 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  46842 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  46845 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  46851 */     GIR_RootConstrainSelectedInstOperands,
     /*  46852 */     // GIR_Coverage, 144,
     /*  46852 */     GIR_EraseRootFromParent_Done,
     /*  46853 */   // Label 1037: @46853
     /*  46853 */   GIM_Try, /*On fail goto*//*Label 1038*/ GIMT_Encode4(46907), // Rule ID 145 //
     /*  46858 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*  46861 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_usad8),
     /*  46866 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  46869 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  46872 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  46875 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  46879 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  46883 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  46887 */     // (intrinsic_wo_chain:{ *:[i32] } 3939:{ *:[iPTR] }, GPR:{ *:[i32] }:$Rn, GPR:{ *:[i32] }:$Rm)  =>  (USAD8:{ *:[i32] } GPR:{ *:[i32] }:$Rn, GPR:{ *:[i32] }:$Rm)
     /*  46887 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::USAD8),
     /*  46890 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  46892 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  46894 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  46896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  46899 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  46905 */     GIR_RootConstrainSelectedInstOperands,
     /*  46906 */     // GIR_Coverage, 145,
     /*  46906 */     GIR_EraseRootFromParent_Done,
     /*  46907 */   // Label 1038: @46907
     /*  46907 */   GIM_Try, /*On fail goto*//*Label 1039*/ GIMT_Encode4(46952), // Rule ID 204 //
     /*  46912 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCRC_IsARM),
     /*  46915 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_crc32b),
     /*  46920 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  46923 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  46926 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  46929 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46933 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46937 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46941 */     // (intrinsic_wo_chain:{ *:[i32] } 3505:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (CRC32B:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  46941 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::CRC32B),
     /*  46944 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  46946 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  46948 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  46950 */     GIR_RootConstrainSelectedInstOperands,
     /*  46951 */     // GIR_Coverage, 204,
     /*  46951 */     GIR_EraseRootFromParent_Done,
     /*  46952 */   // Label 1039: @46952
     /*  46952 */   GIM_Try, /*On fail goto*//*Label 1040*/ GIMT_Encode4(46997), // Rule ID 205 //
     /*  46957 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCRC_IsARM),
     /*  46960 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_crc32cb),
     /*  46965 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  46968 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  46971 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  46974 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46978 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46982 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46986 */     // (intrinsic_wo_chain:{ *:[i32] } 3506:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (CRC32CB:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  46986 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::CRC32CB),
     /*  46989 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  46991 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  46993 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  46995 */     GIR_RootConstrainSelectedInstOperands,
     /*  46996 */     // GIR_Coverage, 205,
     /*  46996 */     GIR_EraseRootFromParent_Done,
     /*  46997 */   // Label 1040: @46997
     /*  46997 */   GIM_Try, /*On fail goto*//*Label 1041*/ GIMT_Encode4(47042), // Rule ID 206 //
     /*  47002 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCRC_IsARM),
     /*  47005 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_crc32h),
     /*  47010 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  47013 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  47016 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  47019 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  47023 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  47027 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  47031 */     // (intrinsic_wo_chain:{ *:[i32] } 3509:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (CRC32H:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  47031 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::CRC32H),
     /*  47034 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  47036 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  47038 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  47040 */     GIR_RootConstrainSelectedInstOperands,
     /*  47041 */     // GIR_Coverage, 206,
     /*  47041 */     GIR_EraseRootFromParent_Done,
     /*  47042 */   // Label 1041: @47042
     /*  47042 */   GIM_Try, /*On fail goto*//*Label 1042*/ GIMT_Encode4(47087), // Rule ID 207 //
     /*  47047 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCRC_IsARM),
     /*  47050 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_crc32ch),
     /*  47055 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  47058 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  47061 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  47064 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  47068 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  47072 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  47076 */     // (intrinsic_wo_chain:{ *:[i32] } 3507:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (CRC32CH:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  47076 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::CRC32CH),
     /*  47079 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  47081 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  47083 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  47085 */     GIR_RootConstrainSelectedInstOperands,
     /*  47086 */     // GIR_Coverage, 207,
     /*  47086 */     GIR_EraseRootFromParent_Done,
     /*  47087 */   // Label 1042: @47087
     /*  47087 */   GIM_Try, /*On fail goto*//*Label 1043*/ GIMT_Encode4(47132), // Rule ID 208 //
     /*  47092 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCRC_IsARM),
     /*  47095 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_crc32w),
     /*  47100 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  47103 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  47106 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  47109 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  47113 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  47117 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  47121 */     // (intrinsic_wo_chain:{ *:[i32] } 3510:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (CRC32W:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  47121 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::CRC32W),
     /*  47124 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  47126 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  47128 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  47130 */     GIR_RootConstrainSelectedInstOperands,
     /*  47131 */     // GIR_Coverage, 208,
     /*  47131 */     GIR_EraseRootFromParent_Done,
     /*  47132 */   // Label 1043: @47132
     /*  47132 */   GIM_Try, /*On fail goto*//*Label 1044*/ GIMT_Encode4(47177), // Rule ID 209 //
     /*  47137 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCRC_IsARM),
     /*  47140 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_crc32cw),
     /*  47145 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  47148 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  47151 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  47154 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  47158 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  47162 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  47166 */     // (intrinsic_wo_chain:{ *:[i32] } 3508:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (CRC32CW:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  47166 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::CRC32CW),
     /*  47169 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  47171 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  47173 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  47175 */     GIR_RootConstrainSelectedInstOperands,
     /*  47176 */     // GIR_Coverage, 209,
     /*  47176 */     GIR_EraseRootFromParent_Done,
     /*  47177 */   // Label 1044: @47177
     /*  47177 */   GIM_Try, /*On fail goto*//*Label 1045*/ GIMT_Encode4(47231), // Rule ID 432 //
     /*  47182 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  47185 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_qadd16),
     /*  47190 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  47193 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  47196 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  47199 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  47203 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  47207 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  47211 */     // (intrinsic_wo_chain:{ *:[i32] } 3865:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2QADD16:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  47211 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2QADD16),
     /*  47214 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  47216 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  47218 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  47220 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  47223 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  47229 */     GIR_RootConstrainSelectedInstOperands,
     /*  47230 */     // GIR_Coverage, 432,
     /*  47230 */     GIR_EraseRootFromParent_Done,
     /*  47231 */   // Label 1045: @47231
     /*  47231 */   GIM_Try, /*On fail goto*//*Label 1046*/ GIMT_Encode4(47285), // Rule ID 433 //
     /*  47236 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  47239 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_qadd8),
     /*  47244 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  47247 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  47250 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  47253 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  47257 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  47261 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  47265 */     // (intrinsic_wo_chain:{ *:[i32] } 3866:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2QADD8:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  47265 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2QADD8),
     /*  47268 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  47270 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  47272 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  47274 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  47277 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  47283 */     GIR_RootConstrainSelectedInstOperands,
     /*  47284 */     // GIR_Coverage, 433,
     /*  47284 */     GIR_EraseRootFromParent_Done,
     /*  47285 */   // Label 1046: @47285
     /*  47285 */   GIM_Try, /*On fail goto*//*Label 1047*/ GIMT_Encode4(47339), // Rule ID 434 //
     /*  47290 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  47293 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_qasx),
     /*  47298 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  47301 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  47304 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  47307 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  47311 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  47315 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  47319 */     // (intrinsic_wo_chain:{ *:[i32] } 3867:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2QASX:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  47319 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2QASX),
     /*  47322 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  47324 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  47326 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  47328 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  47331 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  47337 */     GIR_RootConstrainSelectedInstOperands,
     /*  47338 */     // GIR_Coverage, 434,
     /*  47338 */     GIR_EraseRootFromParent_Done,
     /*  47339 */   // Label 1047: @47339
     /*  47339 */   GIM_Try, /*On fail goto*//*Label 1048*/ GIMT_Encode4(47393), // Rule ID 435 //
     /*  47344 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  47347 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_uqsub8),
     /*  47352 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  47355 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  47358 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  47361 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  47365 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  47369 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  47373 */     // (intrinsic_wo_chain:{ *:[i32] } 3938:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2UQSUB8:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  47373 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2UQSUB8),
     /*  47376 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  47378 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  47380 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  47382 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  47385 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  47391 */     GIR_RootConstrainSelectedInstOperands,
     /*  47392 */     // GIR_Coverage, 435,
     /*  47392 */     GIR_EraseRootFromParent_Done,
     /*  47393 */   // Label 1048: @47393
     /*  47393 */   GIM_Try, /*On fail goto*//*Label 1049*/ GIMT_Encode4(47447), // Rule ID 436 //
     /*  47398 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  47401 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_qsax),
     /*  47406 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  47409 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  47412 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  47415 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  47419 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  47423 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  47427 */     // (intrinsic_wo_chain:{ *:[i32] } 3868:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2QSAX:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  47427 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2QSAX),
     /*  47430 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  47432 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  47434 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  47436 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  47439 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  47445 */     GIR_RootConstrainSelectedInstOperands,
     /*  47446 */     // GIR_Coverage, 436,
     /*  47446 */     GIR_EraseRootFromParent_Done,
     /*  47447 */   // Label 1049: @47447
     /*  47447 */   GIM_Try, /*On fail goto*//*Label 1050*/ GIMT_Encode4(47501), // Rule ID 437 //
     /*  47452 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  47455 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_qsub16),
     /*  47460 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  47463 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  47466 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  47469 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  47473 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  47477 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  47481 */     // (intrinsic_wo_chain:{ *:[i32] } 3870:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2QSUB16:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  47481 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2QSUB16),
     /*  47484 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  47486 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  47488 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  47490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  47493 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  47499 */     GIR_RootConstrainSelectedInstOperands,
     /*  47500 */     // GIR_Coverage, 437,
     /*  47500 */     GIR_EraseRootFromParent_Done,
     /*  47501 */   // Label 1050: @47501
     /*  47501 */   GIM_Try, /*On fail goto*//*Label 1051*/ GIMT_Encode4(47555), // Rule ID 438 //
     /*  47506 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  47509 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_qsub8),
     /*  47514 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  47517 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  47520 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  47523 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  47527 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  47531 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  47535 */     // (intrinsic_wo_chain:{ *:[i32] } 3871:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2QSUB8:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  47535 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2QSUB8),
     /*  47538 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  47540 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  47542 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  47544 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  47547 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  47553 */     GIR_RootConstrainSelectedInstOperands,
     /*  47554 */     // GIR_Coverage, 438,
     /*  47554 */     GIR_EraseRootFromParent_Done,
     /*  47555 */   // Label 1051: @47555
     /*  47555 */   GIM_Try, /*On fail goto*//*Label 1052*/ GIMT_Encode4(47609), // Rule ID 439 //
     /*  47560 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  47563 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_uqadd16),
     /*  47568 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  47571 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  47574 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  47577 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  47581 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  47585 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  47589 */     // (intrinsic_wo_chain:{ *:[i32] } 3933:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2UQADD16:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  47589 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2UQADD16),
     /*  47592 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  47594 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  47596 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  47598 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  47601 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  47607 */     GIR_RootConstrainSelectedInstOperands,
     /*  47608 */     // GIR_Coverage, 439,
     /*  47608 */     GIR_EraseRootFromParent_Done,
     /*  47609 */   // Label 1052: @47609
     /*  47609 */   GIM_Try, /*On fail goto*//*Label 1053*/ GIMT_Encode4(47663), // Rule ID 440 //
     /*  47614 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  47617 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_uqadd8),
     /*  47622 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  47625 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  47628 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  47631 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  47635 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  47639 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  47643 */     // (intrinsic_wo_chain:{ *:[i32] } 3934:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2UQADD8:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  47643 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2UQADD8),
     /*  47646 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  47648 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  47650 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  47652 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  47655 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  47661 */     GIR_RootConstrainSelectedInstOperands,
     /*  47662 */     // GIR_Coverage, 440,
     /*  47662 */     GIR_EraseRootFromParent_Done,
     /*  47663 */   // Label 1053: @47663
     /*  47663 */   GIM_Try, /*On fail goto*//*Label 1054*/ GIMT_Encode4(47717), // Rule ID 441 //
     /*  47668 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  47671 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_uqasx),
     /*  47676 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  47679 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  47682 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  47685 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  47689 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  47693 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  47697 */     // (intrinsic_wo_chain:{ *:[i32] } 3935:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2UQASX:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  47697 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2UQASX),
     /*  47700 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  47702 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  47704 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  47706 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  47709 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  47715 */     GIR_RootConstrainSelectedInstOperands,
     /*  47716 */     // GIR_Coverage, 441,
     /*  47716 */     GIR_EraseRootFromParent_Done,
     /*  47717 */   // Label 1054: @47717
     /*  47717 */   GIM_Try, /*On fail goto*//*Label 1055*/ GIMT_Encode4(47771), // Rule ID 442 //
     /*  47722 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  47725 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_uqsax),
     /*  47730 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  47733 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  47736 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  47739 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  47743 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  47747 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  47751 */     // (intrinsic_wo_chain:{ *:[i32] } 3936:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2UQSAX:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  47751 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2UQSAX),
     /*  47754 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  47756 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  47758 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  47760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  47763 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  47769 */     GIR_RootConstrainSelectedInstOperands,
     /*  47770 */     // GIR_Coverage, 442,
     /*  47770 */     GIR_EraseRootFromParent_Done,
     /*  47771 */   // Label 1055: @47771
     /*  47771 */   GIM_Try, /*On fail goto*//*Label 1056*/ GIMT_Encode4(47825), // Rule ID 443 //
     /*  47776 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  47779 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_uqsub16),
     /*  47784 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  47787 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  47790 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  47793 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  47797 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  47801 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  47805 */     // (intrinsic_wo_chain:{ *:[i32] } 3937:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2UQSUB16:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  47805 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2UQSUB16),
     /*  47808 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  47810 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  47812 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  47814 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  47817 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  47823 */     GIR_RootConstrainSelectedInstOperands,
     /*  47824 */     // GIR_Coverage, 443,
     /*  47824 */     GIR_EraseRootFromParent_Done,
     /*  47825 */   // Label 1056: @47825
     /*  47825 */   GIM_Try, /*On fail goto*//*Label 1057*/ GIMT_Encode4(47879), // Rule ID 456 //
     /*  47830 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  47833 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_shasx),
     /*  47838 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  47841 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  47844 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  47847 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  47851 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  47855 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  47859 */     // (intrinsic_wo_chain:{ *:[i32] } 3879:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2SHASX:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  47859 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SHASX),
     /*  47862 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  47864 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  47866 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  47868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  47871 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  47877 */     GIR_RootConstrainSelectedInstOperands,
     /*  47878 */     // GIR_Coverage, 456,
     /*  47878 */     GIR_EraseRootFromParent_Done,
     /*  47879 */   // Label 1057: @47879
     /*  47879 */   GIM_Try, /*On fail goto*//*Label 1058*/ GIMT_Encode4(47933), // Rule ID 457 //
     /*  47884 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  47887 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_shadd16),
     /*  47892 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  47895 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  47898 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  47901 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  47905 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  47909 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  47913 */     // (intrinsic_wo_chain:{ *:[i32] } 3877:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2SHADD16:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  47913 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SHADD16),
     /*  47916 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  47918 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  47920 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  47922 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  47925 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  47931 */     GIR_RootConstrainSelectedInstOperands,
     /*  47932 */     // GIR_Coverage, 457,
     /*  47932 */     GIR_EraseRootFromParent_Done,
     /*  47933 */   // Label 1058: @47933
     /*  47933 */   GIM_Try, /*On fail goto*//*Label 1059*/ GIMT_Encode4(47987), // Rule ID 458 //
     /*  47938 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  47941 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_shadd8),
     /*  47946 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  47949 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  47952 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  47955 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  47959 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  47963 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  47967 */     // (intrinsic_wo_chain:{ *:[i32] } 3878:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2SHADD8:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  47967 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SHADD8),
     /*  47970 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  47972 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  47974 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  47976 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  47979 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  47985 */     GIR_RootConstrainSelectedInstOperands,
     /*  47986 */     // GIR_Coverage, 458,
     /*  47986 */     GIR_EraseRootFromParent_Done,
     /*  47987 */   // Label 1059: @47987
     /*  47987 */   GIM_Try, /*On fail goto*//*Label 1060*/ GIMT_Encode4(48041), // Rule ID 459 //
     /*  47992 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  47995 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_shsax),
     /*  48000 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  48003 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  48006 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  48009 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48013 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48017 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48021 */     // (intrinsic_wo_chain:{ *:[i32] } 3880:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2SHSAX:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  48021 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SHSAX),
     /*  48024 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  48026 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  48028 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  48030 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  48033 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  48039 */     GIR_RootConstrainSelectedInstOperands,
     /*  48040 */     // GIR_Coverage, 459,
     /*  48040 */     GIR_EraseRootFromParent_Done,
     /*  48041 */   // Label 1060: @48041
     /*  48041 */   GIM_Try, /*On fail goto*//*Label 1061*/ GIMT_Encode4(48095), // Rule ID 460 //
     /*  48046 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  48049 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_shsub16),
     /*  48054 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  48057 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  48060 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  48063 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48067 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48071 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48075 */     // (intrinsic_wo_chain:{ *:[i32] } 3881:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2SHSUB16:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  48075 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SHSUB16),
     /*  48078 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  48080 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  48082 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  48084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  48087 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  48093 */     GIR_RootConstrainSelectedInstOperands,
     /*  48094 */     // GIR_Coverage, 460,
     /*  48094 */     GIR_EraseRootFromParent_Done,
     /*  48095 */   // Label 1061: @48095
     /*  48095 */   GIM_Try, /*On fail goto*//*Label 1062*/ GIMT_Encode4(48149), // Rule ID 461 //
     /*  48100 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  48103 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_shsub8),
     /*  48108 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  48111 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  48114 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  48117 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48121 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48125 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48129 */     // (intrinsic_wo_chain:{ *:[i32] } 3882:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2SHSUB8:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  48129 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SHSUB8),
     /*  48132 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  48134 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  48136 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  48138 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  48141 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  48147 */     GIR_RootConstrainSelectedInstOperands,
     /*  48148 */     // GIR_Coverage, 461,
     /*  48148 */     GIR_EraseRootFromParent_Done,
     /*  48149 */   // Label 1062: @48149
     /*  48149 */   GIM_Try, /*On fail goto*//*Label 1063*/ GIMT_Encode4(48203), // Rule ID 462 //
     /*  48154 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  48157 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_uhasx),
     /*  48162 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  48165 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  48168 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  48171 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48175 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48179 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48183 */     // (intrinsic_wo_chain:{ *:[i32] } 3928:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2UHASX:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  48183 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2UHASX),
     /*  48186 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  48188 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  48190 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  48192 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  48195 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  48201 */     GIR_RootConstrainSelectedInstOperands,
     /*  48202 */     // GIR_Coverage, 462,
     /*  48202 */     GIR_EraseRootFromParent_Done,
     /*  48203 */   // Label 1063: @48203
     /*  48203 */   GIM_Try, /*On fail goto*//*Label 1064*/ GIMT_Encode4(48257), // Rule ID 463 //
     /*  48208 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  48211 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_uhadd16),
     /*  48216 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  48219 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  48222 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  48225 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48229 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48233 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48237 */     // (intrinsic_wo_chain:{ *:[i32] } 3926:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2UHADD16:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  48237 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2UHADD16),
     /*  48240 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  48242 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  48244 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  48246 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  48249 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  48255 */     GIR_RootConstrainSelectedInstOperands,
     /*  48256 */     // GIR_Coverage, 463,
     /*  48256 */     GIR_EraseRootFromParent_Done,
     /*  48257 */   // Label 1064: @48257
     /*  48257 */   GIM_Try, /*On fail goto*//*Label 1065*/ GIMT_Encode4(48311), // Rule ID 464 //
     /*  48262 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  48265 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_uhadd8),
     /*  48270 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  48273 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  48276 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  48279 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48283 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48287 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48291 */     // (intrinsic_wo_chain:{ *:[i32] } 3927:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2UHADD8:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  48291 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2UHADD8),
     /*  48294 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  48296 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  48298 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  48300 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  48303 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  48309 */     GIR_RootConstrainSelectedInstOperands,
     /*  48310 */     // GIR_Coverage, 464,
     /*  48310 */     GIR_EraseRootFromParent_Done,
     /*  48311 */   // Label 1065: @48311
     /*  48311 */   GIM_Try, /*On fail goto*//*Label 1066*/ GIMT_Encode4(48365), // Rule ID 465 //
     /*  48316 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  48319 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_uhsax),
     /*  48324 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  48327 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  48330 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  48333 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48337 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48341 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48345 */     // (intrinsic_wo_chain:{ *:[i32] } 3929:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2UHSAX:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  48345 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2UHSAX),
     /*  48348 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  48350 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  48352 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  48354 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  48357 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  48363 */     GIR_RootConstrainSelectedInstOperands,
     /*  48364 */     // GIR_Coverage, 465,
     /*  48364 */     GIR_EraseRootFromParent_Done,
     /*  48365 */   // Label 1066: @48365
     /*  48365 */   GIM_Try, /*On fail goto*//*Label 1067*/ GIMT_Encode4(48419), // Rule ID 466 //
     /*  48370 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  48373 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_uhsub16),
     /*  48378 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  48381 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  48384 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  48387 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48391 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48395 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48399 */     // (intrinsic_wo_chain:{ *:[i32] } 3930:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2UHSUB16:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  48399 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2UHSUB16),
     /*  48402 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  48404 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  48406 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  48408 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  48411 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  48417 */     GIR_RootConstrainSelectedInstOperands,
     /*  48418 */     // GIR_Coverage, 466,
     /*  48418 */     GIR_EraseRootFromParent_Done,
     /*  48419 */   // Label 1067: @48419
     /*  48419 */   GIM_Try, /*On fail goto*//*Label 1068*/ GIMT_Encode4(48473), // Rule ID 467 //
     /*  48424 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  48427 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_uhsub8),
     /*  48432 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  48435 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  48438 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  48441 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48445 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48449 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48453 */     // (intrinsic_wo_chain:{ *:[i32] } 3931:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2UHSUB8:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  48453 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2UHSUB8),
     /*  48456 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  48458 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  48460 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  48462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  48465 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  48471 */     GIR_RootConstrainSelectedInstOperands,
     /*  48472 */     // GIR_Coverage, 467,
     /*  48472 */     GIR_EraseRootFromParent_Done,
     /*  48473 */   // Label 1068: @48473
     /*  48473 */   GIM_Try, /*On fail goto*//*Label 1069*/ GIMT_Encode4(48527), // Rule ID 468 //
     /*  48478 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  48481 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_usad8),
     /*  48486 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  48489 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  48492 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  48495 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48499 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48503 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48507 */     // (intrinsic_wo_chain:{ *:[i32] } 3939:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2USAD8:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  48507 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2USAD8),
     /*  48510 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  48512 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  48514 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  48516 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  48519 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  48525 */     GIR_RootConstrainSelectedInstOperands,
     /*  48526 */     // GIR_Coverage, 468,
     /*  48526 */     GIR_EraseRootFromParent_Done,
     /*  48527 */   // Label 1069: @48527
     /*  48527 */   GIM_Try, /*On fail goto*//*Label 1070*/ GIMT_Encode4(48581), // Rule ID 524 //
     /*  48532 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  48535 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_smuad),
     /*  48540 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  48543 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  48546 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  48549 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48553 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48557 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48561 */     // (intrinsic_wo_chain:{ *:[i32] } 3897:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2SMUAD:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  48561 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SMUAD),
     /*  48564 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  48566 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  48568 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  48570 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  48573 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  48579 */     GIR_RootConstrainSelectedInstOperands,
     /*  48580 */     // GIR_Coverage, 524,
     /*  48580 */     GIR_EraseRootFromParent_Done,
     /*  48581 */   // Label 1070: @48581
     /*  48581 */   GIM_Try, /*On fail goto*//*Label 1071*/ GIMT_Encode4(48635), // Rule ID 525 //
     /*  48586 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  48589 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_smuadx),
     /*  48594 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  48597 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  48600 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  48603 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48607 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48611 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48615 */     // (intrinsic_wo_chain:{ *:[i32] } 3898:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2SMUADX:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  48615 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SMUADX),
     /*  48618 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  48620 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  48622 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  48624 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  48627 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  48633 */     GIR_RootConstrainSelectedInstOperands,
     /*  48634 */     // GIR_Coverage, 525,
     /*  48634 */     GIR_EraseRootFromParent_Done,
     /*  48635 */   // Label 1071: @48635
     /*  48635 */   GIM_Try, /*On fail goto*//*Label 1072*/ GIMT_Encode4(48689), // Rule ID 526 //
     /*  48640 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  48643 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_smusd),
     /*  48648 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  48651 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  48654 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  48657 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48661 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48665 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48669 */     // (intrinsic_wo_chain:{ *:[i32] } 3905:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2SMUSD:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  48669 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SMUSD),
     /*  48672 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  48674 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  48676 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  48678 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  48681 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  48687 */     GIR_RootConstrainSelectedInstOperands,
     /*  48688 */     // GIR_Coverage, 526,
     /*  48688 */     GIR_EraseRootFromParent_Done,
     /*  48689 */   // Label 1072: @48689
     /*  48689 */   GIM_Try, /*On fail goto*//*Label 1073*/ GIMT_Encode4(48743), // Rule ID 527 //
     /*  48694 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  48697 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_smusdx),
     /*  48702 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  48705 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  48708 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  48711 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48715 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48719 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48723 */     // (intrinsic_wo_chain:{ *:[i32] } 3906:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2SMUSDX:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  48723 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SMUSDX),
     /*  48726 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  48728 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  48730 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  48732 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  48735 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  48741 */     GIR_RootConstrainSelectedInstOperands,
     /*  48742 */     // GIR_Coverage, 527,
     /*  48742 */     GIR_EraseRootFromParent_Done,
     /*  48743 */   // Label 1073: @48743
     /*  48743 */   GIM_Try, /*On fail goto*//*Label 1074*/ GIMT_Encode4(48788), // Rule ID 541 //
     /*  48748 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCRC_IsThumb2),
     /*  48751 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_crc32b),
     /*  48756 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  48759 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  48762 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  48765 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48769 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48773 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48777 */     // (intrinsic_wo_chain:{ *:[i32] } 3505:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2CRC32B:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  48777 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2CRC32B),
     /*  48780 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  48782 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  48784 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  48786 */     GIR_RootConstrainSelectedInstOperands,
     /*  48787 */     // GIR_Coverage, 541,
     /*  48787 */     GIR_EraseRootFromParent_Done,
     /*  48788 */   // Label 1074: @48788
     /*  48788 */   GIM_Try, /*On fail goto*//*Label 1075*/ GIMT_Encode4(48833), // Rule ID 542 //
     /*  48793 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCRC_IsThumb2),
     /*  48796 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_crc32cb),
     /*  48801 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  48804 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  48807 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  48810 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48814 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48818 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48822 */     // (intrinsic_wo_chain:{ *:[i32] } 3506:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2CRC32CB:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  48822 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2CRC32CB),
     /*  48825 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  48827 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  48829 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  48831 */     GIR_RootConstrainSelectedInstOperands,
     /*  48832 */     // GIR_Coverage, 542,
     /*  48832 */     GIR_EraseRootFromParent_Done,
     /*  48833 */   // Label 1075: @48833
     /*  48833 */   GIM_Try, /*On fail goto*//*Label 1076*/ GIMT_Encode4(48878), // Rule ID 543 //
     /*  48838 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCRC_IsThumb2),
     /*  48841 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_crc32h),
     /*  48846 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  48849 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  48852 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  48855 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48859 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48863 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48867 */     // (intrinsic_wo_chain:{ *:[i32] } 3509:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2CRC32H:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  48867 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2CRC32H),
     /*  48870 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  48872 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  48874 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  48876 */     GIR_RootConstrainSelectedInstOperands,
     /*  48877 */     // GIR_Coverage, 543,
     /*  48877 */     GIR_EraseRootFromParent_Done,
     /*  48878 */   // Label 1076: @48878
     /*  48878 */   GIM_Try, /*On fail goto*//*Label 1077*/ GIMT_Encode4(48923), // Rule ID 544 //
     /*  48883 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCRC_IsThumb2),
     /*  48886 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_crc32ch),
     /*  48891 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  48894 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  48897 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  48900 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48904 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48908 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48912 */     // (intrinsic_wo_chain:{ *:[i32] } 3507:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2CRC32CH:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  48912 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2CRC32CH),
     /*  48915 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  48917 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  48919 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  48921 */     GIR_RootConstrainSelectedInstOperands,
     /*  48922 */     // GIR_Coverage, 544,
     /*  48922 */     GIR_EraseRootFromParent_Done,
     /*  48923 */   // Label 1077: @48923
     /*  48923 */   GIM_Try, /*On fail goto*//*Label 1078*/ GIMT_Encode4(48968), // Rule ID 545 //
     /*  48928 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCRC_IsThumb2),
     /*  48931 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_crc32w),
     /*  48936 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  48939 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  48942 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  48945 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48949 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48953 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48957 */     // (intrinsic_wo_chain:{ *:[i32] } 3510:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2CRC32W:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  48957 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2CRC32W),
     /*  48960 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  48962 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  48964 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  48966 */     GIR_RootConstrainSelectedInstOperands,
     /*  48967 */     // GIR_Coverage, 545,
     /*  48967 */     GIR_EraseRootFromParent_Done,
     /*  48968 */   // Label 1078: @48968
     /*  48968 */   GIM_Try, /*On fail goto*//*Label 1079*/ GIMT_Encode4(49013), // Rule ID 546 //
     /*  48973 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCRC_IsThumb2),
     /*  48976 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_crc32cw),
     /*  48981 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  48984 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  48987 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  48990 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48994 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48998 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  49002 */     // (intrinsic_wo_chain:{ *:[i32] } 3508:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2CRC32CW:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  49002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2CRC32CW),
     /*  49005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  49007 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  49009 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  49011 */     GIR_RootConstrainSelectedInstOperands,
     /*  49012 */     // GIR_Coverage, 546,
     /*  49012 */     GIR_EraseRootFromParent_Done,
     /*  49013 */   // Label 1079: @49013
     /*  49013 */   GIM_Try, /*On fail goto*//*Label 1080*/ GIMT_Encode4(49067), // Rule ID 789 //
     /*  49018 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  49021 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vhadds),
     /*  49026 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  49029 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  49032 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  49035 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  49039 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  49043 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  49047 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3775:{ *:[iPTR] }, DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)  =>  (VHADDsv4i16:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /*  49047 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VHADDsv4i16),
     /*  49050 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  49052 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  49054 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  49056 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  49059 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  49065 */     GIR_RootConstrainSelectedInstOperands,
     /*  49066 */     // GIR_Coverage, 789,
     /*  49066 */     GIR_EraseRootFromParent_Done,
     /*  49067 */   // Label 1080: @49067
     /*  49067 */   GIM_Try, /*On fail goto*//*Label 1081*/ GIMT_Encode4(49121), // Rule ID 790 //
     /*  49072 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  49075 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vhadds),
     /*  49080 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  49083 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  49086 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  49089 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  49093 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  49097 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  49101 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3775:{ *:[iPTR] }, DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)  =>  (VHADDsv2i32:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /*  49101 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VHADDsv2i32),
     /*  49104 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  49106 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  49108 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  49110 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  49113 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  49119 */     GIR_RootConstrainSelectedInstOperands,
     /*  49120 */     // GIR_Coverage, 790,
     /*  49120 */     GIR_EraseRootFromParent_Done,
     /*  49121 */   // Label 1081: @49121
     /*  49121 */   GIM_Try, /*On fail goto*//*Label 1082*/ GIMT_Encode4(49175), // Rule ID 791 //
     /*  49126 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  49129 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vhadds),
     /*  49134 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  49137 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  49140 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  49143 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  49147 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  49151 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  49155 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3775:{ *:[iPTR] }, QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)  =>  (VHADDsv8i16:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)
     /*  49155 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VHADDsv8i16),
     /*  49158 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  49160 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  49162 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  49164 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  49167 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  49173 */     GIR_RootConstrainSelectedInstOperands,
     /*  49174 */     // GIR_Coverage, 791,
     /*  49174 */     GIR_EraseRootFromParent_Done,
     /*  49175 */   // Label 1082: @49175
     /*  49175 */   GIM_Try, /*On fail goto*//*Label 1083*/ GIMT_Encode4(49229), // Rule ID 792 //
     /*  49180 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  49183 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vhadds),
     /*  49188 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  49191 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  49194 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  49197 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  49201 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  49205 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  49209 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3775:{ *:[iPTR] }, QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)  =>  (VHADDsv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)
     /*  49209 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VHADDsv4i32),
     /*  49212 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  49214 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  49216 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  49218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  49221 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  49227 */     GIR_RootConstrainSelectedInstOperands,
     /*  49228 */     // GIR_Coverage, 792,
     /*  49228 */     GIR_EraseRootFromParent_Done,
     /*  49229 */   // Label 1083: @49229
     /*  49229 */   GIM_Try, /*On fail goto*//*Label 1084*/ GIMT_Encode4(49283), // Rule ID 793 //
     /*  49234 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  49237 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vhadds),
     /*  49242 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /*  49245 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  49248 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  49251 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  49255 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  49259 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  49263 */     // (intrinsic_wo_chain:{ *:[v8i8] } 3775:{ *:[iPTR] }, DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)  =>  (VHADDsv8i8:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /*  49263 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VHADDsv8i8),
     /*  49266 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  49268 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  49270 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  49272 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  49275 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  49281 */     GIR_RootConstrainSelectedInstOperands,
     /*  49282 */     // GIR_Coverage, 793,
     /*  49282 */     GIR_EraseRootFromParent_Done,
     /*  49283 */   // Label 1084: @49283
     /*  49283 */   GIM_Try, /*On fail goto*//*Label 1085*/ GIMT_Encode4(49337), // Rule ID 794 //
     /*  49288 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  49291 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vhadds),
     /*  49296 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  49299 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  49302 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  49305 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  49309 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  49313 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  49317 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3775:{ *:[iPTR] }, QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)  =>  (VHADDsv16i8:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)
     /*  49317 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VHADDsv16i8),
     /*  49320 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  49322 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  49324 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  49326 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  49329 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  49335 */     GIR_RootConstrainSelectedInstOperands,
     /*  49336 */     // GIR_Coverage, 794,
     /*  49336 */     GIR_EraseRootFromParent_Done,
     /*  49337 */   // Label 1085: @49337
     /*  49337 */   GIM_Try, /*On fail goto*//*Label 1086*/ GIMT_Encode4(49391), // Rule ID 795 //
     /*  49342 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  49345 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vhaddu),
     /*  49350 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  49353 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  49356 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  49359 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  49363 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  49367 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  49371 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3776:{ *:[iPTR] }, DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)  =>  (VHADDuv4i16:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /*  49371 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VHADDuv4i16),
     /*  49374 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  49376 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  49378 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  49380 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  49383 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  49389 */     GIR_RootConstrainSelectedInstOperands,
     /*  49390 */     // GIR_Coverage, 795,
     /*  49390 */     GIR_EraseRootFromParent_Done,
     /*  49391 */   // Label 1086: @49391
     /*  49391 */   GIM_Try, /*On fail goto*//*Label 1087*/ GIMT_Encode4(49445), // Rule ID 796 //
     /*  49396 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  49399 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vhaddu),
     /*  49404 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  49407 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  49410 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  49413 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  49417 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  49421 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  49425 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3776:{ *:[iPTR] }, DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)  =>  (VHADDuv2i32:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /*  49425 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VHADDuv2i32),
     /*  49428 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  49430 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  49432 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  49434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  49437 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  49443 */     GIR_RootConstrainSelectedInstOperands,
     /*  49444 */     // GIR_Coverage, 796,
     /*  49444 */     GIR_EraseRootFromParent_Done,
     /*  49445 */   // Label 1087: @49445
     /*  49445 */   GIM_Try, /*On fail goto*//*Label 1088*/ GIMT_Encode4(49499), // Rule ID 797 //
     /*  49450 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  49453 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vhaddu),
     /*  49458 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  49461 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  49464 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  49467 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  49471 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  49475 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  49479 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3776:{ *:[iPTR] }, QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)  =>  (VHADDuv8i16:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)
     /*  49479 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VHADDuv8i16),
     /*  49482 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  49484 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  49486 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  49488 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  49491 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  49497 */     GIR_RootConstrainSelectedInstOperands,
     /*  49498 */     // GIR_Coverage, 797,
     /*  49498 */     GIR_EraseRootFromParent_Done,
     /*  49499 */   // Label 1088: @49499
     /*  49499 */   GIM_Try, /*On fail goto*//*Label 1089*/ GIMT_Encode4(49553), // Rule ID 798 //
     /*  49504 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  49507 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vhaddu),
     /*  49512 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  49515 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  49518 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  49521 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  49525 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  49529 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  49533 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3776:{ *:[iPTR] }, QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)  =>  (VHADDuv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)
     /*  49533 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VHADDuv4i32),
     /*  49536 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  49538 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  49540 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  49542 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  49545 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  49551 */     GIR_RootConstrainSelectedInstOperands,
     /*  49552 */     // GIR_Coverage, 798,
     /*  49552 */     GIR_EraseRootFromParent_Done,
     /*  49553 */   // Label 1089: @49553
     /*  49553 */   GIM_Try, /*On fail goto*//*Label 1090*/ GIMT_Encode4(49607), // Rule ID 799 //
     /*  49558 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  49561 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vhaddu),
     /*  49566 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /*  49569 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  49572 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  49575 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  49579 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  49583 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  49587 */     // (intrinsic_wo_chain:{ *:[v8i8] } 3776:{ *:[iPTR] }, DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)  =>  (VHADDuv8i8:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /*  49587 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VHADDuv8i8),
     /*  49590 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  49592 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  49594 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  49596 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  49599 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  49605 */     GIR_RootConstrainSelectedInstOperands,
     /*  49606 */     // GIR_Coverage, 799,
     /*  49606 */     GIR_EraseRootFromParent_Done,
     /*  49607 */   // Label 1090: @49607
     /*  49607 */   GIM_Try, /*On fail goto*//*Label 1091*/ GIMT_Encode4(49661), // Rule ID 800 //
     /*  49612 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  49615 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vhaddu),
     /*  49620 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  49623 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  49626 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  49629 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  49633 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  49637 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  49641 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3776:{ *:[iPTR] }, QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)  =>  (VHADDuv16i8:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)
     /*  49641 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VHADDuv16i8),
     /*  49644 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  49646 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  49648 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  49650 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  49653 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  49659 */     GIR_RootConstrainSelectedInstOperands,
     /*  49660 */     // GIR_Coverage, 800,
     /*  49660 */     GIR_EraseRootFromParent_Done,
     /*  49661 */   // Label 1091: @49661
     /*  49661 */   GIM_Try, /*On fail goto*//*Label 1092*/ GIMT_Encode4(49715), // Rule ID 801 //
     /*  49666 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  49669 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrhadds),
     /*  49674 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  49677 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  49680 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  49683 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  49687 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  49691 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  49695 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3835:{ *:[iPTR] }, DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)  =>  (VRHADDsv4i16:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /*  49695 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRHADDsv4i16),
     /*  49698 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  49700 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  49702 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  49704 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  49707 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  49713 */     GIR_RootConstrainSelectedInstOperands,
     /*  49714 */     // GIR_Coverage, 801,
     /*  49714 */     GIR_EraseRootFromParent_Done,
     /*  49715 */   // Label 1092: @49715
     /*  49715 */   GIM_Try, /*On fail goto*//*Label 1093*/ GIMT_Encode4(49769), // Rule ID 802 //
     /*  49720 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  49723 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrhadds),
     /*  49728 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  49731 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  49734 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  49737 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  49741 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  49745 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  49749 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3835:{ *:[iPTR] }, DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)  =>  (VRHADDsv2i32:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /*  49749 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRHADDsv2i32),
     /*  49752 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  49754 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  49756 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  49758 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  49761 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  49767 */     GIR_RootConstrainSelectedInstOperands,
     /*  49768 */     // GIR_Coverage, 802,
     /*  49768 */     GIR_EraseRootFromParent_Done,
     /*  49769 */   // Label 1093: @49769
     /*  49769 */   GIM_Try, /*On fail goto*//*Label 1094*/ GIMT_Encode4(49823), // Rule ID 803 //
     /*  49774 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  49777 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrhadds),
     /*  49782 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  49785 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  49788 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  49791 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  49795 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  49799 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  49803 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3835:{ *:[iPTR] }, QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)  =>  (VRHADDsv8i16:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)
     /*  49803 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRHADDsv8i16),
     /*  49806 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  49808 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  49810 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  49812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  49815 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  49821 */     GIR_RootConstrainSelectedInstOperands,
     /*  49822 */     // GIR_Coverage, 803,
     /*  49822 */     GIR_EraseRootFromParent_Done,
     /*  49823 */   // Label 1094: @49823
     /*  49823 */   GIM_Try, /*On fail goto*//*Label 1095*/ GIMT_Encode4(49877), // Rule ID 804 //
     /*  49828 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  49831 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrhadds),
     /*  49836 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  49839 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  49842 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  49845 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  49849 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  49853 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  49857 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3835:{ *:[iPTR] }, QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)  =>  (VRHADDsv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)
     /*  49857 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRHADDsv4i32),
     /*  49860 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  49862 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  49864 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  49866 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  49869 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  49875 */     GIR_RootConstrainSelectedInstOperands,
     /*  49876 */     // GIR_Coverage, 804,
     /*  49876 */     GIR_EraseRootFromParent_Done,
     /*  49877 */   // Label 1095: @49877
     /*  49877 */   GIM_Try, /*On fail goto*//*Label 1096*/ GIMT_Encode4(49931), // Rule ID 805 //
     /*  49882 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  49885 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrhadds),
     /*  49890 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /*  49893 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  49896 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  49899 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  49903 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  49907 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  49911 */     // (intrinsic_wo_chain:{ *:[v8i8] } 3835:{ *:[iPTR] }, DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)  =>  (VRHADDsv8i8:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /*  49911 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRHADDsv8i8),
     /*  49914 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  49916 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  49918 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  49920 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  49923 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  49929 */     GIR_RootConstrainSelectedInstOperands,
     /*  49930 */     // GIR_Coverage, 805,
     /*  49930 */     GIR_EraseRootFromParent_Done,
     /*  49931 */   // Label 1096: @49931
     /*  49931 */   GIM_Try, /*On fail goto*//*Label 1097*/ GIMT_Encode4(49985), // Rule ID 806 //
     /*  49936 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  49939 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrhadds),
     /*  49944 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  49947 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  49950 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  49953 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  49957 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  49961 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  49965 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3835:{ *:[iPTR] }, QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)  =>  (VRHADDsv16i8:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)
     /*  49965 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRHADDsv16i8),
     /*  49968 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  49970 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  49972 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  49974 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  49977 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  49983 */     GIR_RootConstrainSelectedInstOperands,
     /*  49984 */     // GIR_Coverage, 806,
     /*  49984 */     GIR_EraseRootFromParent_Done,
     /*  49985 */   // Label 1097: @49985
     /*  49985 */   GIM_Try, /*On fail goto*//*Label 1098*/ GIMT_Encode4(50039), // Rule ID 807 //
     /*  49990 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  49993 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrhaddu),
     /*  49998 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  50001 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  50004 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  50007 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  50011 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  50015 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  50019 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3836:{ *:[iPTR] }, DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)  =>  (VRHADDuv4i16:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /*  50019 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRHADDuv4i16),
     /*  50022 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  50024 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  50026 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  50028 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  50031 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  50037 */     GIR_RootConstrainSelectedInstOperands,
     /*  50038 */     // GIR_Coverage, 807,
     /*  50038 */     GIR_EraseRootFromParent_Done,
     /*  50039 */   // Label 1098: @50039
     /*  50039 */   GIM_Try, /*On fail goto*//*Label 1099*/ GIMT_Encode4(50093), // Rule ID 808 //
     /*  50044 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  50047 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrhaddu),
     /*  50052 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  50055 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  50058 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  50061 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  50065 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  50069 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  50073 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3836:{ *:[iPTR] }, DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)  =>  (VRHADDuv2i32:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /*  50073 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRHADDuv2i32),
     /*  50076 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  50078 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  50080 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  50082 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  50085 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  50091 */     GIR_RootConstrainSelectedInstOperands,
     /*  50092 */     // GIR_Coverage, 808,
     /*  50092 */     GIR_EraseRootFromParent_Done,
     /*  50093 */   // Label 1099: @50093
     /*  50093 */   GIM_Try, /*On fail goto*//*Label 1100*/ GIMT_Encode4(50147), // Rule ID 809 //
     /*  50098 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  50101 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrhaddu),
     /*  50106 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  50109 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  50112 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  50115 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  50119 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  50123 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  50127 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3836:{ *:[iPTR] }, QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)  =>  (VRHADDuv8i16:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)
     /*  50127 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRHADDuv8i16),
     /*  50130 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  50132 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  50134 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  50136 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  50139 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  50145 */     GIR_RootConstrainSelectedInstOperands,
     /*  50146 */     // GIR_Coverage, 809,
     /*  50146 */     GIR_EraseRootFromParent_Done,
     /*  50147 */   // Label 1100: @50147
     /*  50147 */   GIM_Try, /*On fail goto*//*Label 1101*/ GIMT_Encode4(50201), // Rule ID 810 //
     /*  50152 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  50155 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrhaddu),
     /*  50160 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  50163 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  50166 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  50169 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  50173 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  50177 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  50181 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3836:{ *:[iPTR] }, QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)  =>  (VRHADDuv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)
     /*  50181 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRHADDuv4i32),
     /*  50184 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  50186 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  50188 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  50190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  50193 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  50199 */     GIR_RootConstrainSelectedInstOperands,
     /*  50200 */     // GIR_Coverage, 810,
     /*  50200 */     GIR_EraseRootFromParent_Done,
     /*  50201 */   // Label 1101: @50201
     /*  50201 */   GIM_Try, /*On fail goto*//*Label 1102*/ GIMT_Encode4(50255), // Rule ID 811 //
     /*  50206 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  50209 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrhaddu),
     /*  50214 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /*  50217 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  50220 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  50223 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  50227 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  50231 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  50235 */     // (intrinsic_wo_chain:{ *:[v8i8] } 3836:{ *:[iPTR] }, DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)  =>  (VRHADDuv8i8:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /*  50235 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRHADDuv8i8),
     /*  50238 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  50240 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  50242 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  50244 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  50247 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  50253 */     GIR_RootConstrainSelectedInstOperands,
     /*  50254 */     // GIR_Coverage, 811,
     /*  50254 */     GIR_EraseRootFromParent_Done,
     /*  50255 */   // Label 1102: @50255
     /*  50255 */   GIM_Try, /*On fail goto*//*Label 1103*/ GIMT_Encode4(50309), // Rule ID 812 //
     /*  50260 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  50263 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrhaddu),
     /*  50268 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  50271 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  50274 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  50277 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  50281 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  50285 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  50289 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3836:{ *:[iPTR] }, QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)  =>  (VRHADDuv16i8:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)
     /*  50289 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRHADDuv16i8),
     /*  50292 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  50294 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  50296 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  50298 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  50301 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  50307 */     GIR_RootConstrainSelectedInstOperands,
     /*  50308 */     // GIR_Coverage, 812,
     /*  50308 */     GIR_EraseRootFromParent_Done,
     /*  50309 */   // Label 1103: @50309
     /*  50309 */   GIM_Try, /*On fail goto*//*Label 1104*/ GIMT_Encode4(50363), // Rule ID 829 //
     /*  50314 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  50317 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vraddhn),
     /*  50322 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /*  50325 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  50328 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  50331 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  50335 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  50339 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  50343 */     // (intrinsic_wo_chain:{ *:[v8i8] } 3832:{ *:[iPTR] }, QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)  =>  (VRADDHNv8i8:{ *:[v8i8] } QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)
     /*  50343 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRADDHNv8i8),
     /*  50346 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  50348 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  50350 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  50352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  50355 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  50361 */     GIR_RootConstrainSelectedInstOperands,
     /*  50362 */     // GIR_Coverage, 829,
     /*  50362 */     GIR_EraseRootFromParent_Done,
     /*  50363 */   // Label 1104: @50363
     /*  50363 */   GIM_Try, /*On fail goto*//*Label 1105*/ GIMT_Encode4(50417), // Rule ID 830 //
     /*  50368 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  50371 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vraddhn),
     /*  50376 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  50379 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  50382 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  50385 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  50389 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  50393 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  50397 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3832:{ *:[iPTR] }, QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)  =>  (VRADDHNv4i16:{ *:[v4i16] } QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)
     /*  50397 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRADDHNv4i16),
     /*  50400 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  50402 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  50404 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  50406 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  50409 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  50415 */     GIR_RootConstrainSelectedInstOperands,
     /*  50416 */     // GIR_Coverage, 830,
     /*  50416 */     GIR_EraseRootFromParent_Done,
     /*  50417 */   // Label 1105: @50417
     /*  50417 */   GIM_Try, /*On fail goto*//*Label 1106*/ GIMT_Encode4(50471), // Rule ID 831 //
     /*  50422 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  50425 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vraddhn),
     /*  50430 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  50433 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  50436 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  50439 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  50443 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  50447 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  50451 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3832:{ *:[iPTR] }, QPR:{ *:[v2i64] }:$Vn, QPR:{ *:[v2i64] }:$Vm)  =>  (VRADDHNv2i32:{ *:[v2i32] } QPR:{ *:[v2i64] }:$Vn, QPR:{ *:[v2i64] }:$Vm)
     /*  50451 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRADDHNv2i32),
     /*  50454 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  50456 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  50458 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  50460 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  50463 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  50469 */     GIR_RootConstrainSelectedInstOperands,
     /*  50470 */     // GIR_Coverage, 831,
     /*  50470 */     GIR_EraseRootFromParent_Done,
     /*  50471 */   // Label 1106: @50471
     /*  50471 */   GIM_Try, /*On fail goto*//*Label 1107*/ GIMT_Encode4(50525), // Rule ID 838 //
     /*  50476 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  50479 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vmulp),
     /*  50484 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /*  50487 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  50490 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  50493 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  50497 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  50501 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  50505 */     // (intrinsic_wo_chain:{ *:[v8i8] } 3801:{ *:[iPTR] }, DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)  =>  (VMULpd:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /*  50505 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMULpd),
     /*  50508 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  50510 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  50512 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  50514 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  50517 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  50523 */     GIR_RootConstrainSelectedInstOperands,
     /*  50524 */     // GIR_Coverage, 838,
     /*  50524 */     GIR_EraseRootFromParent_Done,
     /*  50525 */   // Label 1107: @50525
     /*  50525 */   GIM_Try, /*On fail goto*//*Label 1108*/ GIMT_Encode4(50579), // Rule ID 839 //
     /*  50530 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  50533 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vmulp),
     /*  50538 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  50541 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  50544 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  50547 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  50551 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  50555 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  50559 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3801:{ *:[iPTR] }, QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)  =>  (VMULpq:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)
     /*  50559 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMULpq),
     /*  50562 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  50564 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  50566 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  50568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  50571 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  50577 */     GIR_RootConstrainSelectedInstOperands,
     /*  50578 */     // GIR_Coverage, 839,
     /*  50578 */     GIR_EraseRootFromParent_Done,
     /*  50579 */   // Label 1108: @50579
     /*  50579 */   GIM_Try, /*On fail goto*//*Label 1109*/ GIMT_Encode4(50633), // Rule ID 852 //
     /*  50584 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  50587 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqdmulh),
     /*  50592 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  50595 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  50598 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  50601 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  50605 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  50609 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  50613 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3812:{ *:[iPTR] }, DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)  =>  (VQDMULHv4i16:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /*  50613 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQDMULHv4i16),
     /*  50616 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  50618 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  50620 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  50622 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  50625 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  50631 */     GIR_RootConstrainSelectedInstOperands,
     /*  50632 */     // GIR_Coverage, 852,
     /*  50632 */     GIR_EraseRootFromParent_Done,
     /*  50633 */   // Label 1109: @50633
     /*  50633 */   GIM_Try, /*On fail goto*//*Label 1110*/ GIMT_Encode4(50687), // Rule ID 853 //
     /*  50638 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  50641 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqdmulh),
     /*  50646 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  50649 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  50652 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  50655 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  50659 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  50663 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  50667 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3812:{ *:[iPTR] }, DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)  =>  (VQDMULHv2i32:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /*  50667 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQDMULHv2i32),
     /*  50670 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  50672 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  50674 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  50676 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  50679 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  50685 */     GIR_RootConstrainSelectedInstOperands,
     /*  50686 */     // GIR_Coverage, 853,
     /*  50686 */     GIR_EraseRootFromParent_Done,
     /*  50687 */   // Label 1110: @50687
     /*  50687 */   GIM_Try, /*On fail goto*//*Label 1111*/ GIMT_Encode4(50741), // Rule ID 854 //
     /*  50692 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  50695 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqdmulh),
     /*  50700 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  50703 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  50706 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  50709 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  50713 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  50717 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  50721 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3812:{ *:[iPTR] }, QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)  =>  (VQDMULHv8i16:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)
     /*  50721 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQDMULHv8i16),
     /*  50724 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  50726 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  50728 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  50730 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  50733 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  50739 */     GIR_RootConstrainSelectedInstOperands,
     /*  50740 */     // GIR_Coverage, 854,
     /*  50740 */     GIR_EraseRootFromParent_Done,
     /*  50741 */   // Label 1111: @50741
     /*  50741 */   GIM_Try, /*On fail goto*//*Label 1112*/ GIMT_Encode4(50795), // Rule ID 855 //
     /*  50746 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  50749 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqdmulh),
     /*  50754 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  50757 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  50760 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  50763 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  50767 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  50771 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  50775 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3812:{ *:[iPTR] }, QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)  =>  (VQDMULHv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)
     /*  50775 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQDMULHv4i32),
     /*  50778 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  50780 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  50782 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  50784 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  50787 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  50793 */     GIR_RootConstrainSelectedInstOperands,
     /*  50794 */     // GIR_Coverage, 855,
     /*  50794 */     GIR_EraseRootFromParent_Done,
     /*  50795 */   // Label 1112: @50795
     /*  50795 */   GIM_Try, /*On fail goto*//*Label 1113*/ GIMT_Encode4(50849), // Rule ID 860 //
     /*  50800 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  50803 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqrdmulh),
     /*  50808 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  50811 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  50814 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  50817 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  50821 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  50825 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  50829 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3820:{ *:[iPTR] }, DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)  =>  (VQRDMULHv4i16:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /*  50829 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQRDMULHv4i16),
     /*  50832 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  50834 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  50836 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  50838 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  50841 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  50847 */     GIR_RootConstrainSelectedInstOperands,
     /*  50848 */     // GIR_Coverage, 860,
     /*  50848 */     GIR_EraseRootFromParent_Done,
     /*  50849 */   // Label 1113: @50849
     /*  50849 */   GIM_Try, /*On fail goto*//*Label 1114*/ GIMT_Encode4(50903), // Rule ID 861 //
     /*  50854 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  50857 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqrdmulh),
     /*  50862 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  50865 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  50868 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  50871 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  50875 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  50879 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  50883 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3820:{ *:[iPTR] }, DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)  =>  (VQRDMULHv2i32:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /*  50883 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQRDMULHv2i32),
     /*  50886 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  50888 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  50890 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  50892 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  50895 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  50901 */     GIR_RootConstrainSelectedInstOperands,
     /*  50902 */     // GIR_Coverage, 861,
     /*  50902 */     GIR_EraseRootFromParent_Done,
     /*  50903 */   // Label 1114: @50903
     /*  50903 */   GIM_Try, /*On fail goto*//*Label 1115*/ GIMT_Encode4(50957), // Rule ID 862 //
     /*  50908 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  50911 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqrdmulh),
     /*  50916 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  50919 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  50922 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  50925 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  50929 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  50933 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  50937 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3820:{ *:[iPTR] }, QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)  =>  (VQRDMULHv8i16:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)
     /*  50937 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQRDMULHv8i16),
     /*  50940 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  50942 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  50944 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  50946 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  50949 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  50955 */     GIR_RootConstrainSelectedInstOperands,
     /*  50956 */     // GIR_Coverage, 862,
     /*  50956 */     GIR_EraseRootFromParent_Done,
     /*  50957 */   // Label 1115: @50957
     /*  50957 */   GIM_Try, /*On fail goto*//*Label 1116*/ GIMT_Encode4(51011), // Rule ID 863 //
     /*  50962 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  50965 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqrdmulh),
     /*  50970 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  50973 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  50976 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  50979 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  50983 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  50987 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  50991 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3820:{ *:[iPTR] }, QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)  =>  (VQRDMULHv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)
     /*  50991 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQRDMULHv4i32),
     /*  50994 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  50996 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  50998 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  51000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  51003 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  51009 */     GIR_RootConstrainSelectedInstOperands,
     /*  51010 */     // GIR_Coverage, 863,
     /*  51010 */     GIR_EraseRootFromParent_Done,
     /*  51011 */   // Label 1116: @51011
     /*  51011 */   GIM_Try, /*On fail goto*//*Label 1117*/ GIMT_Encode4(51065), // Rule ID 874 //
     /*  51016 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  51019 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vmullp),
     /*  51024 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  51027 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  51030 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  51033 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  51037 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  51041 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  51045 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3798:{ *:[iPTR] }, DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)  =>  (VMULLp8:{ *:[v8i16] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /*  51045 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMULLp8),
     /*  51048 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  51050 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  51052 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  51054 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  51057 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  51063 */     GIR_RootConstrainSelectedInstOperands,
     /*  51064 */     // GIR_Coverage, 874,
     /*  51064 */     GIR_EraseRootFromParent_Done,
     /*  51065 */   // Label 1117: @51065
     /*  51065 */   GIM_Try, /*On fail goto*//*Label 1118*/ GIMT_Encode4(51110), // Rule ID 875 //
     /*  51070 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAES_HasV8),
     /*  51073 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vmullp),
     /*  51078 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  51081 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  51084 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  51087 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  51091 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  51095 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  51099 */     // (intrinsic_wo_chain:{ *:[v2i64] } 3798:{ *:[iPTR] }, DPR:{ *:[v1i64] }:$Vn, DPR:{ *:[v1i64] }:$Vm)  =>  (VMULLp64:{ *:[v2i64] } DPR:{ *:[v1i64] }:$Vn, DPR:{ *:[v1i64] }:$Vm)
     /*  51099 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMULLp64),
     /*  51102 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  51104 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  51106 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  51108 */     GIR_RootConstrainSelectedInstOperands,
     /*  51109 */     // GIR_Coverage, 875,
     /*  51109 */     GIR_EraseRootFromParent_Done,
     /*  51110 */   // Label 1118: @51110
     /*  51110 */   GIM_Try, /*On fail goto*//*Label 1119*/ GIMT_Encode4(51164), // Rule ID 880 //
     /*  51115 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  51118 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqdmull),
     /*  51123 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  51126 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  51129 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  51132 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  51136 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  51140 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  51144 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3813:{ *:[iPTR] }, DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)  =>  (VQDMULLv4i32:{ *:[v4i32] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /*  51144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQDMULLv4i32),
     /*  51147 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  51149 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  51151 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  51153 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  51156 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  51162 */     GIR_RootConstrainSelectedInstOperands,
     /*  51163 */     // GIR_Coverage, 880,
     /*  51163 */     GIR_EraseRootFromParent_Done,
     /*  51164 */   // Label 1119: @51164
     /*  51164 */   GIM_Try, /*On fail goto*//*Label 1120*/ GIMT_Encode4(51218), // Rule ID 881 //
     /*  51169 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  51172 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqdmull),
     /*  51177 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  51180 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  51183 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  51186 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  51190 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  51194 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  51198 */     // (intrinsic_wo_chain:{ *:[v2i64] } 3813:{ *:[iPTR] }, DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)  =>  (VQDMULLv2i64:{ *:[v2i64] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /*  51198 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQDMULLv2i64),
     /*  51201 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  51203 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  51205 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  51207 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  51210 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  51216 */     GIR_RootConstrainSelectedInstOperands,
     /*  51217 */     // GIR_Coverage, 881,
     /*  51217 */     GIR_EraseRootFromParent_Done,
     /*  51218 */   // Label 1120: @51218
     /*  51218 */   GIM_Try, /*On fail goto*//*Label 1121*/ GIMT_Encode4(51272), // Rule ID 993 //
     /*  51223 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  51226 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vhsubs),
     /*  51231 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  51234 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  51237 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  51240 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  51244 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  51248 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  51252 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3777:{ *:[iPTR] }, DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)  =>  (VHSUBsv4i16:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /*  51252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VHSUBsv4i16),
     /*  51255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  51257 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  51259 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  51261 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  51264 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  51270 */     GIR_RootConstrainSelectedInstOperands,
     /*  51271 */     // GIR_Coverage, 993,
     /*  51271 */     GIR_EraseRootFromParent_Done,
     /*  51272 */   // Label 1121: @51272
     /*  51272 */   GIM_Try, /*On fail goto*//*Label 1122*/ GIMT_Encode4(51326), // Rule ID 994 //
     /*  51277 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  51280 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vhsubs),
     /*  51285 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  51288 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  51291 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  51294 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  51298 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  51302 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  51306 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3777:{ *:[iPTR] }, DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)  =>  (VHSUBsv2i32:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /*  51306 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VHSUBsv2i32),
     /*  51309 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  51311 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  51313 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  51315 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  51318 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  51324 */     GIR_RootConstrainSelectedInstOperands,
     /*  51325 */     // GIR_Coverage, 994,
     /*  51325 */     GIR_EraseRootFromParent_Done,
     /*  51326 */   // Label 1122: @51326
     /*  51326 */   GIM_Try, /*On fail goto*//*Label 1123*/ GIMT_Encode4(51380), // Rule ID 995 //
     /*  51331 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  51334 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vhsubs),
     /*  51339 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  51342 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  51345 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  51348 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  51352 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  51356 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  51360 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3777:{ *:[iPTR] }, QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)  =>  (VHSUBsv8i16:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)
     /*  51360 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VHSUBsv8i16),
     /*  51363 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  51365 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  51367 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  51369 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  51372 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  51378 */     GIR_RootConstrainSelectedInstOperands,
     /*  51379 */     // GIR_Coverage, 995,
     /*  51379 */     GIR_EraseRootFromParent_Done,
     /*  51380 */   // Label 1123: @51380
     /*  51380 */   GIM_Try, /*On fail goto*//*Label 1124*/ GIMT_Encode4(51434), // Rule ID 996 //
     /*  51385 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  51388 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vhsubs),
     /*  51393 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  51396 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  51399 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  51402 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  51406 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  51410 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  51414 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3777:{ *:[iPTR] }, QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)  =>  (VHSUBsv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)
     /*  51414 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VHSUBsv4i32),
     /*  51417 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  51419 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  51421 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  51423 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  51426 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  51432 */     GIR_RootConstrainSelectedInstOperands,
     /*  51433 */     // GIR_Coverage, 996,
     /*  51433 */     GIR_EraseRootFromParent_Done,
     /*  51434 */   // Label 1124: @51434
     /*  51434 */   GIM_Try, /*On fail goto*//*Label 1125*/ GIMT_Encode4(51488), // Rule ID 997 //
     /*  51439 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  51442 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vhsubs),
     /*  51447 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /*  51450 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  51453 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  51456 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  51460 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  51464 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  51468 */     // (intrinsic_wo_chain:{ *:[v8i8] } 3777:{ *:[iPTR] }, DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)  =>  (VHSUBsv8i8:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /*  51468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VHSUBsv8i8),
     /*  51471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  51473 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  51475 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  51477 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  51480 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  51486 */     GIR_RootConstrainSelectedInstOperands,
     /*  51487 */     // GIR_Coverage, 997,
     /*  51487 */     GIR_EraseRootFromParent_Done,
     /*  51488 */   // Label 1125: @51488
     /*  51488 */   GIM_Try, /*On fail goto*//*Label 1126*/ GIMT_Encode4(51542), // Rule ID 998 //
     /*  51493 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  51496 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vhsubs),
     /*  51501 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  51504 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  51507 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  51510 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  51514 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  51518 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  51522 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3777:{ *:[iPTR] }, QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)  =>  (VHSUBsv16i8:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)
     /*  51522 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VHSUBsv16i8),
     /*  51525 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  51527 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  51529 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  51531 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  51534 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  51540 */     GIR_RootConstrainSelectedInstOperands,
     /*  51541 */     // GIR_Coverage, 998,
     /*  51541 */     GIR_EraseRootFromParent_Done,
     /*  51542 */   // Label 1126: @51542
     /*  51542 */   GIM_Try, /*On fail goto*//*Label 1127*/ GIMT_Encode4(51596), // Rule ID 999 //
     /*  51547 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  51550 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vhsubu),
     /*  51555 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  51558 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  51561 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  51564 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  51568 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  51572 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  51576 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3778:{ *:[iPTR] }, DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)  =>  (VHSUBuv4i16:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /*  51576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VHSUBuv4i16),
     /*  51579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  51581 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  51583 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  51585 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  51588 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  51594 */     GIR_RootConstrainSelectedInstOperands,
     /*  51595 */     // GIR_Coverage, 999,
     /*  51595 */     GIR_EraseRootFromParent_Done,
     /*  51596 */   // Label 1127: @51596
     /*  51596 */   GIM_Try, /*On fail goto*//*Label 1128*/ GIMT_Encode4(51650), // Rule ID 1000 //
     /*  51601 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  51604 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vhsubu),
     /*  51609 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  51612 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  51615 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  51618 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  51622 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  51626 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  51630 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3778:{ *:[iPTR] }, DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)  =>  (VHSUBuv2i32:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /*  51630 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VHSUBuv2i32),
     /*  51633 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  51635 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  51637 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  51639 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  51642 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  51648 */     GIR_RootConstrainSelectedInstOperands,
     /*  51649 */     // GIR_Coverage, 1000,
     /*  51649 */     GIR_EraseRootFromParent_Done,
     /*  51650 */   // Label 1128: @51650
     /*  51650 */   GIM_Try, /*On fail goto*//*Label 1129*/ GIMT_Encode4(51704), // Rule ID 1001 //
     /*  51655 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  51658 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vhsubu),
     /*  51663 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  51666 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  51669 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  51672 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  51676 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  51680 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  51684 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3778:{ *:[iPTR] }, QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)  =>  (VHSUBuv8i16:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)
     /*  51684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VHSUBuv8i16),
     /*  51687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  51689 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  51691 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  51693 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  51696 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  51702 */     GIR_RootConstrainSelectedInstOperands,
     /*  51703 */     // GIR_Coverage, 1001,
     /*  51703 */     GIR_EraseRootFromParent_Done,
     /*  51704 */   // Label 1129: @51704
     /*  51704 */   GIM_Try, /*On fail goto*//*Label 1130*/ GIMT_Encode4(51758), // Rule ID 1002 //
     /*  51709 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  51712 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vhsubu),
     /*  51717 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  51720 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  51723 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  51726 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  51730 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  51734 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  51738 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3778:{ *:[iPTR] }, QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)  =>  (VHSUBuv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)
     /*  51738 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VHSUBuv4i32),
     /*  51741 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  51743 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  51745 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  51747 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  51750 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  51756 */     GIR_RootConstrainSelectedInstOperands,
     /*  51757 */     // GIR_Coverage, 1002,
     /*  51757 */     GIR_EraseRootFromParent_Done,
     /*  51758 */   // Label 1130: @51758
     /*  51758 */   GIM_Try, /*On fail goto*//*Label 1131*/ GIMT_Encode4(51812), // Rule ID 1003 //
     /*  51763 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  51766 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vhsubu),
     /*  51771 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /*  51774 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  51777 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  51780 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  51784 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  51788 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  51792 */     // (intrinsic_wo_chain:{ *:[v8i8] } 3778:{ *:[iPTR] }, DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)  =>  (VHSUBuv8i8:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /*  51792 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VHSUBuv8i8),
     /*  51795 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  51797 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  51799 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  51801 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  51804 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  51810 */     GIR_RootConstrainSelectedInstOperands,
     /*  51811 */     // GIR_Coverage, 1003,
     /*  51811 */     GIR_EraseRootFromParent_Done,
     /*  51812 */   // Label 1131: @51812
     /*  51812 */   GIM_Try, /*On fail goto*//*Label 1132*/ GIMT_Encode4(51866), // Rule ID 1004 //
     /*  51817 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  51820 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vhsubu),
     /*  51825 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  51828 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  51831 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  51834 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  51838 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  51842 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  51846 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3778:{ *:[iPTR] }, QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)  =>  (VHSUBuv16i8:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)
     /*  51846 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VHSUBuv16i8),
     /*  51849 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  51851 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  51853 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  51855 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  51858 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  51864 */     GIR_RootConstrainSelectedInstOperands,
     /*  51865 */     // GIR_Coverage, 1004,
     /*  51865 */     GIR_EraseRootFromParent_Done,
     /*  51866 */   // Label 1132: @51866
     /*  51866 */   GIM_Try, /*On fail goto*//*Label 1133*/ GIMT_Encode4(51920), // Rule ID 1021 //
     /*  51871 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  51874 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrsubhn),
     /*  51879 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /*  51882 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  51885 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  51888 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  51892 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  51896 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  51900 */     // (intrinsic_wo_chain:{ *:[v8i8] } 3842:{ *:[iPTR] }, QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)  =>  (VRSUBHNv8i8:{ *:[v8i8] } QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)
     /*  51900 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRSUBHNv8i8),
     /*  51903 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  51905 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  51907 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  51909 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  51912 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  51918 */     GIR_RootConstrainSelectedInstOperands,
     /*  51919 */     // GIR_Coverage, 1021,
     /*  51919 */     GIR_EraseRootFromParent_Done,
     /*  51920 */   // Label 1133: @51920
     /*  51920 */   GIM_Try, /*On fail goto*//*Label 1134*/ GIMT_Encode4(51974), // Rule ID 1022 //
     /*  51925 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  51928 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrsubhn),
     /*  51933 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  51936 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  51939 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  51942 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  51946 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  51950 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  51954 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3842:{ *:[iPTR] }, QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)  =>  (VRSUBHNv4i16:{ *:[v4i16] } QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)
     /*  51954 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRSUBHNv4i16),
     /*  51957 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  51959 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  51961 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  51963 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  51966 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  51972 */     GIR_RootConstrainSelectedInstOperands,
     /*  51973 */     // GIR_Coverage, 1022,
     /*  51973 */     GIR_EraseRootFromParent_Done,
     /*  51974 */   // Label 1134: @51974
     /*  51974 */   GIM_Try, /*On fail goto*//*Label 1135*/ GIMT_Encode4(52028), // Rule ID 1023 //
     /*  51979 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  51982 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrsubhn),
     /*  51987 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  51990 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  51993 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  51996 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  52000 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  52004 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  52008 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3842:{ *:[iPTR] }, QPR:{ *:[v2i64] }:$Vn, QPR:{ *:[v2i64] }:$Vm)  =>  (VRSUBHNv2i32:{ *:[v2i32] } QPR:{ *:[v2i64] }:$Vn, QPR:{ *:[v2i64] }:$Vm)
     /*  52008 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRSUBHNv2i32),
     /*  52011 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  52013 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  52015 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  52017 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  52020 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  52026 */     GIR_RootConstrainSelectedInstOperands,
     /*  52027 */     // GIR_Coverage, 1023,
     /*  52027 */     GIR_EraseRootFromParent_Done,
     /*  52028 */   // Label 1135: @52028
     /*  52028 */   GIM_Try, /*On fail goto*//*Label 1136*/ GIMT_Encode4(52082), // Rule ID 1116 //
     /*  52033 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  52036 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vacge),
     /*  52041 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  52044 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  52047 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  52050 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  52054 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  52058 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  52062 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3753:{ *:[iPTR] }, DPR:{ *:[v2f32] }:$Vn, DPR:{ *:[v2f32] }:$Vm)  =>  (VACGEfd:{ *:[v2i32] } DPR:{ *:[v2f32] }:$Vn, DPR:{ *:[v2f32] }:$Vm)
     /*  52062 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VACGEfd),
     /*  52065 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  52067 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  52069 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  52071 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  52074 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  52080 */     GIR_RootConstrainSelectedInstOperands,
     /*  52081 */     // GIR_Coverage, 1116,
     /*  52081 */     GIR_EraseRootFromParent_Done,
     /*  52082 */   // Label 1136: @52082
     /*  52082 */   GIM_Try, /*On fail goto*//*Label 1137*/ GIMT_Encode4(52136), // Rule ID 1117 //
     /*  52087 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  52090 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vacge),
     /*  52095 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  52098 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  52101 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  52104 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  52108 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  52112 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  52116 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3753:{ *:[iPTR] }, QPR:{ *:[v4f32] }:$Vn, QPR:{ *:[v4f32] }:$Vm)  =>  (VACGEfq:{ *:[v4i32] } QPR:{ *:[v4f32] }:$Vn, QPR:{ *:[v4f32] }:$Vm)
     /*  52116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VACGEfq),
     /*  52119 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  52121 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  52123 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  52125 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  52128 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  52134 */     GIR_RootConstrainSelectedInstOperands,
     /*  52135 */     // GIR_Coverage, 1117,
     /*  52135 */     GIR_EraseRootFromParent_Done,
     /*  52136 */   // Label 1137: @52136
     /*  52136 */   GIM_Try, /*On fail goto*//*Label 1138*/ GIMT_Encode4(52190), // Rule ID 1118 //
     /*  52141 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /*  52144 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vacge),
     /*  52149 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  52152 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  52155 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  52158 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  52162 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  52166 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  52170 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3753:{ *:[iPTR] }, DPR:{ *:[v4f16] }:$Vn, DPR:{ *:[v4f16] }:$Vm)  =>  (VACGEhd:{ *:[v4i16] } DPR:{ *:[v4f16] }:$Vn, DPR:{ *:[v4f16] }:$Vm)
     /*  52170 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VACGEhd),
     /*  52173 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  52175 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  52177 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  52179 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  52182 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  52188 */     GIR_RootConstrainSelectedInstOperands,
     /*  52189 */     // GIR_Coverage, 1118,
     /*  52189 */     GIR_EraseRootFromParent_Done,
     /*  52190 */   // Label 1138: @52190
     /*  52190 */   GIM_Try, /*On fail goto*//*Label 1139*/ GIMT_Encode4(52244), // Rule ID 1119 //
     /*  52195 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /*  52198 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vacge),
     /*  52203 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  52206 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  52209 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  52212 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  52216 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  52220 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  52224 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3753:{ *:[iPTR] }, QPR:{ *:[v8f16] }:$Vn, QPR:{ *:[v8f16] }:$Vm)  =>  (VACGEhq:{ *:[v8i16] } QPR:{ *:[v8f16] }:$Vn, QPR:{ *:[v8f16] }:$Vm)
     /*  52224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VACGEhq),
     /*  52227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  52229 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  52231 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  52233 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  52236 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  52242 */     GIR_RootConstrainSelectedInstOperands,
     /*  52243 */     // GIR_Coverage, 1119,
     /*  52243 */     GIR_EraseRootFromParent_Done,
     /*  52244 */   // Label 1139: @52244
     /*  52244 */   GIM_Try, /*On fail goto*//*Label 1140*/ GIMT_Encode4(52298), // Rule ID 1120 //
     /*  52249 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  52252 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vacgt),
     /*  52257 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  52260 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  52263 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  52266 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  52270 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  52274 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  52278 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3754:{ *:[iPTR] }, DPR:{ *:[v2f32] }:$Vn, DPR:{ *:[v2f32] }:$Vm)  =>  (VACGTfd:{ *:[v2i32] } DPR:{ *:[v2f32] }:$Vn, DPR:{ *:[v2f32] }:$Vm)
     /*  52278 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VACGTfd),
     /*  52281 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  52283 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  52285 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  52287 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  52290 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  52296 */     GIR_RootConstrainSelectedInstOperands,
     /*  52297 */     // GIR_Coverage, 1120,
     /*  52297 */     GIR_EraseRootFromParent_Done,
     /*  52298 */   // Label 1140: @52298
     /*  52298 */   GIM_Try, /*On fail goto*//*Label 1141*/ GIMT_Encode4(52352), // Rule ID 1121 //
     /*  52303 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  52306 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vacgt),
     /*  52311 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  52314 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  52317 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  52320 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  52324 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  52328 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  52332 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3754:{ *:[iPTR] }, QPR:{ *:[v4f32] }:$Vn, QPR:{ *:[v4f32] }:$Vm)  =>  (VACGTfq:{ *:[v4i32] } QPR:{ *:[v4f32] }:$Vn, QPR:{ *:[v4f32] }:$Vm)
     /*  52332 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VACGTfq),
     /*  52335 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  52337 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  52339 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  52341 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  52344 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  52350 */     GIR_RootConstrainSelectedInstOperands,
     /*  52351 */     // GIR_Coverage, 1121,
     /*  52351 */     GIR_EraseRootFromParent_Done,
     /*  52352 */   // Label 1141: @52352
     /*  52352 */   GIM_Try, /*On fail goto*//*Label 1142*/ GIMT_Encode4(52406), // Rule ID 1122 //
     /*  52357 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /*  52360 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vacgt),
     /*  52365 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  52368 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  52371 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  52374 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  52378 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  52382 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  52386 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3754:{ *:[iPTR] }, DPR:{ *:[v4f16] }:$Vn, DPR:{ *:[v4f16] }:$Vm)  =>  (VACGThd:{ *:[v4i16] } DPR:{ *:[v4f16] }:$Vn, DPR:{ *:[v4f16] }:$Vm)
     /*  52386 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VACGThd),
     /*  52389 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  52391 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  52393 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  52395 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  52398 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  52404 */     GIR_RootConstrainSelectedInstOperands,
     /*  52405 */     // GIR_Coverage, 1122,
     /*  52405 */     GIR_EraseRootFromParent_Done,
     /*  52406 */   // Label 1142: @52406
     /*  52406 */   GIM_Try, /*On fail goto*//*Label 1143*/ GIMT_Encode4(52460), // Rule ID 1123 //
     /*  52411 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /*  52414 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vacgt),
     /*  52419 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  52422 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  52425 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  52428 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  52432 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  52436 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  52440 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3754:{ *:[iPTR] }, QPR:{ *:[v8f16] }:$Vn, QPR:{ *:[v8f16] }:$Vm)  =>  (VACGThq:{ *:[v8i16] } QPR:{ *:[v8f16] }:$Vn, QPR:{ *:[v8f16] }:$Vm)
     /*  52440 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VACGThq),
     /*  52443 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  52445 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  52447 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  52449 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  52452 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  52458 */     GIR_RootConstrainSelectedInstOperands,
     /*  52459 */     // GIR_Coverage, 1123,
     /*  52459 */     GIR_EraseRootFromParent_Done,
     /*  52460 */   // Label 1143: @52460
     /*  52460 */   GIM_Try, /*On fail goto*//*Label 1144*/ GIMT_Encode4(52514), // Rule ID 1166 //
     /*  52465 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  52468 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vabds),
     /*  52473 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  52476 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  52479 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  52482 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  52486 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  52490 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  52494 */     // (intrinsic_wo_chain:{ *:[v2f32] } 3750:{ *:[iPTR] }, DPR:{ *:[v2f32] }:$Vn, DPR:{ *:[v2f32] }:$Vm)  =>  (VABDfd:{ *:[v2f32] } DPR:{ *:[v2f32] }:$Vn, DPR:{ *:[v2f32] }:$Vm)
     /*  52494 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VABDfd),
     /*  52497 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  52499 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  52501 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  52503 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  52506 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  52512 */     GIR_RootConstrainSelectedInstOperands,
     /*  52513 */     // GIR_Coverage, 1166,
     /*  52513 */     GIR_EraseRootFromParent_Done,
     /*  52514 */   // Label 1144: @52514
     /*  52514 */   GIM_Try, /*On fail goto*//*Label 1145*/ GIMT_Encode4(52568), // Rule ID 1167 //
     /*  52519 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  52522 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vabds),
     /*  52527 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  52530 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  52533 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  52536 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  52540 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  52544 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  52548 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3750:{ *:[iPTR] }, QPR:{ *:[v4f32] }:$Vn, QPR:{ *:[v4f32] }:$Vm)  =>  (VABDfq:{ *:[v4f32] } QPR:{ *:[v4f32] }:$Vn, QPR:{ *:[v4f32] }:$Vm)
     /*  52548 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VABDfq),
     /*  52551 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  52553 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  52555 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  52557 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  52560 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  52566 */     GIR_RootConstrainSelectedInstOperands,
     /*  52567 */     // GIR_Coverage, 1167,
     /*  52567 */     GIR_EraseRootFromParent_Done,
     /*  52568 */   // Label 1145: @52568
     /*  52568 */   GIM_Try, /*On fail goto*//*Label 1146*/ GIMT_Encode4(52622), // Rule ID 1168 //
     /*  52573 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /*  52576 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vabds),
     /*  52581 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  52584 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  52587 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  52590 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  52594 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  52598 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  52602 */     // (intrinsic_wo_chain:{ *:[v4f16] } 3750:{ *:[iPTR] }, DPR:{ *:[v4f16] }:$Vn, DPR:{ *:[v4f16] }:$Vm)  =>  (VABDhd:{ *:[v4f16] } DPR:{ *:[v4f16] }:$Vn, DPR:{ *:[v4f16] }:$Vm)
     /*  52602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VABDhd),
     /*  52605 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  52607 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  52609 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  52611 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  52614 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  52620 */     GIR_RootConstrainSelectedInstOperands,
     /*  52621 */     // GIR_Coverage, 1168,
     /*  52621 */     GIR_EraseRootFromParent_Done,
     /*  52622 */   // Label 1146: @52622
     /*  52622 */   GIM_Try, /*On fail goto*//*Label 1147*/ GIMT_Encode4(52676), // Rule ID 1169 //
     /*  52627 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /*  52630 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vabds),
     /*  52635 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  52638 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  52641 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  52644 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  52648 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  52652 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  52656 */     // (intrinsic_wo_chain:{ *:[v8f16] } 3750:{ *:[iPTR] }, QPR:{ *:[v8f16] }:$Vn, QPR:{ *:[v8f16] }:$Vm)  =>  (VABDhq:{ *:[v8f16] } QPR:{ *:[v8f16] }:$Vn, QPR:{ *:[v8f16] }:$Vm)
     /*  52656 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VABDhq),
     /*  52659 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  52661 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  52663 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  52665 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  52668 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  52674 */     GIR_RootConstrainSelectedInstOperands,
     /*  52675 */     // GIR_Coverage, 1169,
     /*  52675 */     GIR_EraseRootFromParent_Done,
     /*  52676 */   // Label 1147: @52676
     /*  52676 */   GIM_Try, /*On fail goto*//*Label 1148*/ GIMT_Encode4(52730), // Rule ID 1234 //
     /*  52681 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  52684 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vpadd),
     /*  52689 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /*  52692 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  52695 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  52698 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  52702 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  52706 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  52710 */     // (intrinsic_wo_chain:{ *:[v8i8] } 3804:{ *:[iPTR] }, DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)  =>  (VPADDi8:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /*  52710 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VPADDi8),
     /*  52713 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  52715 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  52717 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  52719 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  52722 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  52728 */     GIR_RootConstrainSelectedInstOperands,
     /*  52729 */     // GIR_Coverage, 1234,
     /*  52729 */     GIR_EraseRootFromParent_Done,
     /*  52730 */   // Label 1148: @52730
     /*  52730 */   GIM_Try, /*On fail goto*//*Label 1149*/ GIMT_Encode4(52784), // Rule ID 1235 //
     /*  52735 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  52738 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vpadd),
     /*  52743 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  52746 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  52749 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  52752 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  52756 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  52760 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  52764 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3804:{ *:[iPTR] }, DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)  =>  (VPADDi16:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /*  52764 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VPADDi16),
     /*  52767 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  52769 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  52771 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  52773 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  52776 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  52782 */     GIR_RootConstrainSelectedInstOperands,
     /*  52783 */     // GIR_Coverage, 1235,
     /*  52783 */     GIR_EraseRootFromParent_Done,
     /*  52784 */   // Label 1149: @52784
     /*  52784 */   GIM_Try, /*On fail goto*//*Label 1150*/ GIMT_Encode4(52838), // Rule ID 1236 //
     /*  52789 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  52792 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vpadd),
     /*  52797 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  52800 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  52803 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  52806 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  52810 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  52814 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  52818 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3804:{ *:[iPTR] }, DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)  =>  (VPADDi32:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /*  52818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VPADDi32),
     /*  52821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  52823 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  52825 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  52827 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  52830 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  52836 */     GIR_RootConstrainSelectedInstOperands,
     /*  52837 */     // GIR_Coverage, 1236,
     /*  52837 */     GIR_EraseRootFromParent_Done,
     /*  52838 */   // Label 1150: @52838
     /*  52838 */   GIM_Try, /*On fail goto*//*Label 1151*/ GIMT_Encode4(52892), // Rule ID 1237 //
     /*  52843 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  52846 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vpadd),
     /*  52851 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  52854 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  52857 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  52860 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  52864 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  52868 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  52872 */     // (intrinsic_wo_chain:{ *:[v2f32] } 3804:{ *:[iPTR] }, DPR:{ *:[v2f32] }:$Vn, DPR:{ *:[v2f32] }:$Vm)  =>  (VPADDf:{ *:[v2f32] } DPR:{ *:[v2f32] }:$Vn, DPR:{ *:[v2f32] }:$Vm)
     /*  52872 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VPADDf),
     /*  52875 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  52877 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  52879 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  52881 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  52884 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  52890 */     GIR_RootConstrainSelectedInstOperands,
     /*  52891 */     // GIR_Coverage, 1237,
     /*  52891 */     GIR_EraseRootFromParent_Done,
     /*  52892 */   // Label 1151: @52892
     /*  52892 */   GIM_Try, /*On fail goto*//*Label 1152*/ GIMT_Encode4(52946), // Rule ID 1238 //
     /*  52897 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /*  52900 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vpadd),
     /*  52905 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  52908 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  52911 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  52914 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  52918 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  52922 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  52926 */     // (intrinsic_wo_chain:{ *:[v4f16] } 3804:{ *:[iPTR] }, DPR:{ *:[v4f16] }:$Vn, DPR:{ *:[v4f16] }:$Vm)  =>  (VPADDh:{ *:[v4f16] } DPR:{ *:[v4f16] }:$Vn, DPR:{ *:[v4f16] }:$Vm)
     /*  52926 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VPADDh),
     /*  52929 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  52931 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  52933 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  52935 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  52938 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  52944 */     GIR_RootConstrainSelectedInstOperands,
     /*  52945 */     // GIR_Coverage, 1238,
     /*  52945 */     GIR_EraseRootFromParent_Done,
     /*  52946 */   // Label 1152: @52946
     /*  52946 */   GIM_Try, /*On fail goto*//*Label 1153*/ GIMT_Encode4(53000), // Rule ID 1251 //
     /*  52951 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  52954 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vpadals),
     /*  52959 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  52962 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  52965 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  52968 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  52972 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  52976 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  52980 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3802:{ *:[iPTR] }, DPR:{ *:[v4i16] }:$src1, DPR:{ *:[v8i8] }:$Vm)  =>  (VPADALsv8i8:{ *:[v4i16] } DPR:{ *:[v4i16] }:$src1, DPR:{ *:[v8i8] }:$Vm)
     /*  52980 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VPADALsv8i8),
     /*  52983 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  52985 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  52987 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  52989 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  52992 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  52998 */     GIR_RootConstrainSelectedInstOperands,
     /*  52999 */     // GIR_Coverage, 1251,
     /*  52999 */     GIR_EraseRootFromParent_Done,
     /*  53000 */   // Label 1153: @53000
     /*  53000 */   GIM_Try, /*On fail goto*//*Label 1154*/ GIMT_Encode4(53054), // Rule ID 1252 //
     /*  53005 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  53008 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vpadals),
     /*  53013 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  53016 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  53019 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  53022 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  53026 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  53030 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  53034 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3802:{ *:[iPTR] }, DPR:{ *:[v2i32] }:$src1, DPR:{ *:[v4i16] }:$Vm)  =>  (VPADALsv4i16:{ *:[v2i32] } DPR:{ *:[v2i32] }:$src1, DPR:{ *:[v4i16] }:$Vm)
     /*  53034 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VPADALsv4i16),
     /*  53037 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  53039 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  53041 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  53043 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  53046 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  53052 */     GIR_RootConstrainSelectedInstOperands,
     /*  53053 */     // GIR_Coverage, 1252,
     /*  53053 */     GIR_EraseRootFromParent_Done,
     /*  53054 */   // Label 1154: @53054
     /*  53054 */   GIM_Try, /*On fail goto*//*Label 1155*/ GIMT_Encode4(53108), // Rule ID 1253 //
     /*  53059 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  53062 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vpadals),
     /*  53067 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  53070 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  53073 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  53076 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  53080 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  53084 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  53088 */     // (intrinsic_wo_chain:{ *:[v1i64] } 3802:{ *:[iPTR] }, DPR:{ *:[v1i64] }:$src1, DPR:{ *:[v2i32] }:$Vm)  =>  (VPADALsv2i32:{ *:[v1i64] } DPR:{ *:[v1i64] }:$src1, DPR:{ *:[v2i32] }:$Vm)
     /*  53088 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VPADALsv2i32),
     /*  53091 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  53093 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  53095 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  53097 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  53100 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  53106 */     GIR_RootConstrainSelectedInstOperands,
     /*  53107 */     // GIR_Coverage, 1253,
     /*  53107 */     GIR_EraseRootFromParent_Done,
     /*  53108 */   // Label 1155: @53108
     /*  53108 */   GIM_Try, /*On fail goto*//*Label 1156*/ GIMT_Encode4(53162), // Rule ID 1254 //
     /*  53113 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  53116 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vpadals),
     /*  53121 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  53124 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  53127 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  53130 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  53134 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  53138 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  53142 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3802:{ *:[iPTR] }, QPR:{ *:[v8i16] }:$src1, QPR:{ *:[v16i8] }:$Vm)  =>  (VPADALsv16i8:{ *:[v8i16] } QPR:{ *:[v8i16] }:$src1, QPR:{ *:[v16i8] }:$Vm)
     /*  53142 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VPADALsv16i8),
     /*  53145 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  53147 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  53149 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  53151 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  53154 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  53160 */     GIR_RootConstrainSelectedInstOperands,
     /*  53161 */     // GIR_Coverage, 1254,
     /*  53161 */     GIR_EraseRootFromParent_Done,
     /*  53162 */   // Label 1156: @53162
     /*  53162 */   GIM_Try, /*On fail goto*//*Label 1157*/ GIMT_Encode4(53216), // Rule ID 1255 //
     /*  53167 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  53170 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vpadals),
     /*  53175 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  53178 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  53181 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  53184 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  53188 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  53192 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  53196 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3802:{ *:[iPTR] }, QPR:{ *:[v4i32] }:$src1, QPR:{ *:[v8i16] }:$Vm)  =>  (VPADALsv8i16:{ *:[v4i32] } QPR:{ *:[v4i32] }:$src1, QPR:{ *:[v8i16] }:$Vm)
     /*  53196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VPADALsv8i16),
     /*  53199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  53201 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  53203 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  53205 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  53208 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  53214 */     GIR_RootConstrainSelectedInstOperands,
     /*  53215 */     // GIR_Coverage, 1255,
     /*  53215 */     GIR_EraseRootFromParent_Done,
     /*  53216 */   // Label 1157: @53216
     /*  53216 */   GIM_Try, /*On fail goto*//*Label 1158*/ GIMT_Encode4(53270), // Rule ID 1256 //
     /*  53221 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  53224 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vpadals),
     /*  53229 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  53232 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  53235 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  53238 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  53242 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  53246 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  53250 */     // (intrinsic_wo_chain:{ *:[v2i64] } 3802:{ *:[iPTR] }, QPR:{ *:[v2i64] }:$src1, QPR:{ *:[v4i32] }:$Vm)  =>  (VPADALsv4i32:{ *:[v2i64] } QPR:{ *:[v2i64] }:$src1, QPR:{ *:[v4i32] }:$Vm)
     /*  53250 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VPADALsv4i32),
     /*  53253 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  53255 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  53257 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  53259 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  53262 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  53268 */     GIR_RootConstrainSelectedInstOperands,
     /*  53269 */     // GIR_Coverage, 1256,
     /*  53269 */     GIR_EraseRootFromParent_Done,
     /*  53270 */   // Label 1158: @53270
     /*  53270 */   GIM_Try, /*On fail goto*//*Label 1159*/ GIMT_Encode4(53324), // Rule ID 1257 //
     /*  53275 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  53278 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vpadalu),
     /*  53283 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  53286 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  53289 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  53292 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  53296 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  53300 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  53304 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3803:{ *:[iPTR] }, DPR:{ *:[v4i16] }:$src1, DPR:{ *:[v8i8] }:$Vm)  =>  (VPADALuv8i8:{ *:[v4i16] } DPR:{ *:[v4i16] }:$src1, DPR:{ *:[v8i8] }:$Vm)
     /*  53304 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VPADALuv8i8),
     /*  53307 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  53309 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  53311 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  53313 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  53316 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  53322 */     GIR_RootConstrainSelectedInstOperands,
     /*  53323 */     // GIR_Coverage, 1257,
     /*  53323 */     GIR_EraseRootFromParent_Done,
     /*  53324 */   // Label 1159: @53324
     /*  53324 */   GIM_Try, /*On fail goto*//*Label 1160*/ GIMT_Encode4(53378), // Rule ID 1258 //
     /*  53329 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  53332 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vpadalu),
     /*  53337 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  53340 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  53343 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  53346 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  53350 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  53354 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  53358 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3803:{ *:[iPTR] }, DPR:{ *:[v2i32] }:$src1, DPR:{ *:[v4i16] }:$Vm)  =>  (VPADALuv4i16:{ *:[v2i32] } DPR:{ *:[v2i32] }:$src1, DPR:{ *:[v4i16] }:$Vm)
     /*  53358 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VPADALuv4i16),
     /*  53361 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  53363 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  53365 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  53367 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  53370 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  53376 */     GIR_RootConstrainSelectedInstOperands,
     /*  53377 */     // GIR_Coverage, 1258,
     /*  53377 */     GIR_EraseRootFromParent_Done,
     /*  53378 */   // Label 1160: @53378
     /*  53378 */   GIM_Try, /*On fail goto*//*Label 1161*/ GIMT_Encode4(53432), // Rule ID 1259 //
     /*  53383 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  53386 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vpadalu),
     /*  53391 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  53394 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  53397 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  53400 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  53404 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  53408 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  53412 */     // (intrinsic_wo_chain:{ *:[v1i64] } 3803:{ *:[iPTR] }, DPR:{ *:[v1i64] }:$src1, DPR:{ *:[v2i32] }:$Vm)  =>  (VPADALuv2i32:{ *:[v1i64] } DPR:{ *:[v1i64] }:$src1, DPR:{ *:[v2i32] }:$Vm)
     /*  53412 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VPADALuv2i32),
     /*  53415 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  53417 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  53419 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  53421 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  53424 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  53430 */     GIR_RootConstrainSelectedInstOperands,
     /*  53431 */     // GIR_Coverage, 1259,
     /*  53431 */     GIR_EraseRootFromParent_Done,
     /*  53432 */   // Label 1161: @53432
     /*  53432 */   GIM_Try, /*On fail goto*//*Label 1162*/ GIMT_Encode4(53486), // Rule ID 1260 //
     /*  53437 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  53440 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vpadalu),
     /*  53445 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  53448 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  53451 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  53454 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  53458 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  53462 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  53466 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3803:{ *:[iPTR] }, QPR:{ *:[v8i16] }:$src1, QPR:{ *:[v16i8] }:$Vm)  =>  (VPADALuv16i8:{ *:[v8i16] } QPR:{ *:[v8i16] }:$src1, QPR:{ *:[v16i8] }:$Vm)
     /*  53466 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VPADALuv16i8),
     /*  53469 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  53471 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  53473 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  53475 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  53478 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  53484 */     GIR_RootConstrainSelectedInstOperands,
     /*  53485 */     // GIR_Coverage, 1260,
     /*  53485 */     GIR_EraseRootFromParent_Done,
     /*  53486 */   // Label 1162: @53486
     /*  53486 */   GIM_Try, /*On fail goto*//*Label 1163*/ GIMT_Encode4(53540), // Rule ID 1261 //
     /*  53491 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  53494 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vpadalu),
     /*  53499 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  53502 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  53505 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  53508 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  53512 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  53516 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  53520 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3803:{ *:[iPTR] }, QPR:{ *:[v4i32] }:$src1, QPR:{ *:[v8i16] }:$Vm)  =>  (VPADALuv8i16:{ *:[v4i32] } QPR:{ *:[v4i32] }:$src1, QPR:{ *:[v8i16] }:$Vm)
     /*  53520 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VPADALuv8i16),
     /*  53523 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  53525 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  53527 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  53529 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  53532 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  53538 */     GIR_RootConstrainSelectedInstOperands,
     /*  53539 */     // GIR_Coverage, 1261,
     /*  53539 */     GIR_EraseRootFromParent_Done,
     /*  53540 */   // Label 1163: @53540
     /*  53540 */   GIM_Try, /*On fail goto*//*Label 1164*/ GIMT_Encode4(53594), // Rule ID 1262 //
     /*  53545 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  53548 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vpadalu),
     /*  53553 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  53556 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  53559 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  53562 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  53566 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  53570 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  53574 */     // (intrinsic_wo_chain:{ *:[v2i64] } 3803:{ *:[iPTR] }, QPR:{ *:[v2i64] }:$src1, QPR:{ *:[v4i32] }:$Vm)  =>  (VPADALuv4i32:{ *:[v2i64] } QPR:{ *:[v2i64] }:$src1, QPR:{ *:[v4i32] }:$Vm)
     /*  53574 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VPADALuv4i32),
     /*  53577 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  53579 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  53581 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  53583 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  53586 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  53592 */     GIR_RootConstrainSelectedInstOperands,
     /*  53593 */     // GIR_Coverage, 1262,
     /*  53593 */     GIR_EraseRootFromParent_Done,
     /*  53594 */   // Label 1164: @53594
     /*  53594 */   GIM_Try, /*On fail goto*//*Label 1165*/ GIMT_Encode4(53648), // Rule ID 1263 //
     /*  53599 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  53602 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vpmaxs),
     /*  53607 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /*  53610 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  53613 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  53616 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  53620 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  53624 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  53628 */     // (intrinsic_wo_chain:{ *:[v8i8] } 3807:{ *:[iPTR] }, DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)  =>  (VPMAXs8:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /*  53628 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VPMAXs8),
     /*  53631 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  53633 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  53635 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  53637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  53640 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  53646 */     GIR_RootConstrainSelectedInstOperands,
     /*  53647 */     // GIR_Coverage, 1263,
     /*  53647 */     GIR_EraseRootFromParent_Done,
     /*  53648 */   // Label 1165: @53648
     /*  53648 */   GIM_Try, /*On fail goto*//*Label 1166*/ GIMT_Encode4(53702), // Rule ID 1264 //
     /*  53653 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  53656 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vpmaxs),
     /*  53661 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  53664 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  53667 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  53670 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  53674 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  53678 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  53682 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3807:{ *:[iPTR] }, DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)  =>  (VPMAXs16:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /*  53682 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VPMAXs16),
     /*  53685 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  53687 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  53689 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  53691 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  53694 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  53700 */     GIR_RootConstrainSelectedInstOperands,
     /*  53701 */     // GIR_Coverage, 1264,
     /*  53701 */     GIR_EraseRootFromParent_Done,
     /*  53702 */   // Label 1166: @53702
     /*  53702 */   GIM_Try, /*On fail goto*//*Label 1167*/ GIMT_Encode4(53756), // Rule ID 1265 //
     /*  53707 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  53710 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vpmaxs),
     /*  53715 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  53718 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  53721 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  53724 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  53728 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  53732 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  53736 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3807:{ *:[iPTR] }, DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)  =>  (VPMAXs32:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /*  53736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VPMAXs32),
     /*  53739 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  53741 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  53743 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  53745 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  53748 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  53754 */     GIR_RootConstrainSelectedInstOperands,
     /*  53755 */     // GIR_Coverage, 1265,
     /*  53755 */     GIR_EraseRootFromParent_Done,
     /*  53756 */   // Label 1167: @53756
     /*  53756 */   GIM_Try, /*On fail goto*//*Label 1168*/ GIMT_Encode4(53810), // Rule ID 1266 //
     /*  53761 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  53764 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vpmaxu),
     /*  53769 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /*  53772 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  53775 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  53778 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  53782 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  53786 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  53790 */     // (intrinsic_wo_chain:{ *:[v8i8] } 3808:{ *:[iPTR] }, DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)  =>  (VPMAXu8:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /*  53790 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VPMAXu8),
     /*  53793 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  53795 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  53797 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  53799 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  53802 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  53808 */     GIR_RootConstrainSelectedInstOperands,
     /*  53809 */     // GIR_Coverage, 1266,
     /*  53809 */     GIR_EraseRootFromParent_Done,
     /*  53810 */   // Label 1168: @53810
     /*  53810 */   GIM_Try, /*On fail goto*//*Label 1169*/ GIMT_Encode4(53864), // Rule ID 1267 //
     /*  53815 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  53818 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vpmaxu),
     /*  53823 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  53826 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  53829 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  53832 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  53836 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  53840 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  53844 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3808:{ *:[iPTR] }, DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)  =>  (VPMAXu16:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /*  53844 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VPMAXu16),
     /*  53847 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  53849 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  53851 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  53853 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  53856 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  53862 */     GIR_RootConstrainSelectedInstOperands,
     /*  53863 */     // GIR_Coverage, 1267,
     /*  53863 */     GIR_EraseRootFromParent_Done,
     /*  53864 */   // Label 1169: @53864
     /*  53864 */   GIM_Try, /*On fail goto*//*Label 1170*/ GIMT_Encode4(53918), // Rule ID 1268 //
     /*  53869 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  53872 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vpmaxu),
     /*  53877 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  53880 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  53883 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  53886 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  53890 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  53894 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  53898 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3808:{ *:[iPTR] }, DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)  =>  (VPMAXu32:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /*  53898 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VPMAXu32),
     /*  53901 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  53903 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  53905 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  53907 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  53910 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  53916 */     GIR_RootConstrainSelectedInstOperands,
     /*  53917 */     // GIR_Coverage, 1268,
     /*  53917 */     GIR_EraseRootFromParent_Done,
     /*  53918 */   // Label 1170: @53918
     /*  53918 */   GIM_Try, /*On fail goto*//*Label 1171*/ GIMT_Encode4(53972), // Rule ID 1269 //
     /*  53923 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  53926 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vpmaxs),
     /*  53931 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  53934 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  53937 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  53940 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  53944 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  53948 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  53952 */     // (intrinsic_wo_chain:{ *:[v2f32] } 3807:{ *:[iPTR] }, DPR:{ *:[v2f32] }:$Vn, DPR:{ *:[v2f32] }:$Vm)  =>  (VPMAXf:{ *:[v2f32] } DPR:{ *:[v2f32] }:$Vn, DPR:{ *:[v2f32] }:$Vm)
     /*  53952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VPMAXf),
     /*  53955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  53957 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  53959 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  53961 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  53964 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  53970 */     GIR_RootConstrainSelectedInstOperands,
     /*  53971 */     // GIR_Coverage, 1269,
     /*  53971 */     GIR_EraseRootFromParent_Done,
     /*  53972 */   // Label 1171: @53972
     /*  53972 */   GIM_Try, /*On fail goto*//*Label 1172*/ GIMT_Encode4(54026), // Rule ID 1270 //
     /*  53977 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /*  53980 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vpmaxs),
     /*  53985 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  53988 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  53991 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  53994 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  53998 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54002 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54006 */     // (intrinsic_wo_chain:{ *:[v4f16] } 3807:{ *:[iPTR] }, DPR:{ *:[v4f16] }:$Vn, DPR:{ *:[v4f16] }:$Vm)  =>  (VPMAXh:{ *:[v4f16] } DPR:{ *:[v4f16] }:$Vn, DPR:{ *:[v4f16] }:$Vm)
     /*  54006 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VPMAXh),
     /*  54009 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  54011 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  54013 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  54015 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  54018 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  54024 */     GIR_RootConstrainSelectedInstOperands,
     /*  54025 */     // GIR_Coverage, 1270,
     /*  54025 */     GIR_EraseRootFromParent_Done,
     /*  54026 */   // Label 1172: @54026
     /*  54026 */   GIM_Try, /*On fail goto*//*Label 1173*/ GIMT_Encode4(54080), // Rule ID 1271 //
     /*  54031 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  54034 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vpmins),
     /*  54039 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /*  54042 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  54045 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  54048 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54052 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54056 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54060 */     // (intrinsic_wo_chain:{ *:[v8i8] } 3809:{ *:[iPTR] }, DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)  =>  (VPMINs8:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /*  54060 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VPMINs8),
     /*  54063 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  54065 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  54067 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  54069 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  54072 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  54078 */     GIR_RootConstrainSelectedInstOperands,
     /*  54079 */     // GIR_Coverage, 1271,
     /*  54079 */     GIR_EraseRootFromParent_Done,
     /*  54080 */   // Label 1173: @54080
     /*  54080 */   GIM_Try, /*On fail goto*//*Label 1174*/ GIMT_Encode4(54134), // Rule ID 1272 //
     /*  54085 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  54088 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vpmins),
     /*  54093 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  54096 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  54099 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  54102 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54106 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54110 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54114 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3809:{ *:[iPTR] }, DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)  =>  (VPMINs16:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /*  54114 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VPMINs16),
     /*  54117 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  54119 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  54121 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  54123 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  54126 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  54132 */     GIR_RootConstrainSelectedInstOperands,
     /*  54133 */     // GIR_Coverage, 1272,
     /*  54133 */     GIR_EraseRootFromParent_Done,
     /*  54134 */   // Label 1174: @54134
     /*  54134 */   GIM_Try, /*On fail goto*//*Label 1175*/ GIMT_Encode4(54188), // Rule ID 1273 //
     /*  54139 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  54142 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vpmins),
     /*  54147 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  54150 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  54153 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  54156 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54160 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54164 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54168 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3809:{ *:[iPTR] }, DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)  =>  (VPMINs32:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /*  54168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VPMINs32),
     /*  54171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  54173 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  54175 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  54177 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  54180 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  54186 */     GIR_RootConstrainSelectedInstOperands,
     /*  54187 */     // GIR_Coverage, 1273,
     /*  54187 */     GIR_EraseRootFromParent_Done,
     /*  54188 */   // Label 1175: @54188
     /*  54188 */   GIM_Try, /*On fail goto*//*Label 1176*/ GIMT_Encode4(54242), // Rule ID 1274 //
     /*  54193 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  54196 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vpminu),
     /*  54201 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /*  54204 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  54207 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  54210 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54214 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54218 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54222 */     // (intrinsic_wo_chain:{ *:[v8i8] } 3810:{ *:[iPTR] }, DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)  =>  (VPMINu8:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /*  54222 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VPMINu8),
     /*  54225 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  54227 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  54229 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  54231 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  54234 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  54240 */     GIR_RootConstrainSelectedInstOperands,
     /*  54241 */     // GIR_Coverage, 1274,
     /*  54241 */     GIR_EraseRootFromParent_Done,
     /*  54242 */   // Label 1176: @54242
     /*  54242 */   GIM_Try, /*On fail goto*//*Label 1177*/ GIMT_Encode4(54296), // Rule ID 1275 //
     /*  54247 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  54250 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vpminu),
     /*  54255 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  54258 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  54261 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  54264 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54268 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54272 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54276 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3810:{ *:[iPTR] }, DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)  =>  (VPMINu16:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /*  54276 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VPMINu16),
     /*  54279 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  54281 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  54283 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  54285 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  54288 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  54294 */     GIR_RootConstrainSelectedInstOperands,
     /*  54295 */     // GIR_Coverage, 1275,
     /*  54295 */     GIR_EraseRootFromParent_Done,
     /*  54296 */   // Label 1177: @54296
     /*  54296 */   GIM_Try, /*On fail goto*//*Label 1178*/ GIMT_Encode4(54350), // Rule ID 1276 //
     /*  54301 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  54304 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vpminu),
     /*  54309 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  54312 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  54315 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  54318 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54322 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54326 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54330 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3810:{ *:[iPTR] }, DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)  =>  (VPMINu32:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /*  54330 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VPMINu32),
     /*  54333 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  54335 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  54337 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  54339 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  54342 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  54348 */     GIR_RootConstrainSelectedInstOperands,
     /*  54349 */     // GIR_Coverage, 1276,
     /*  54349 */     GIR_EraseRootFromParent_Done,
     /*  54350 */   // Label 1178: @54350
     /*  54350 */   GIM_Try, /*On fail goto*//*Label 1179*/ GIMT_Encode4(54404), // Rule ID 1277 //
     /*  54355 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  54358 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vpmins),
     /*  54363 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  54366 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  54369 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  54372 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54376 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54380 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54384 */     // (intrinsic_wo_chain:{ *:[v2f32] } 3809:{ *:[iPTR] }, DPR:{ *:[v2f32] }:$Vn, DPR:{ *:[v2f32] }:$Vm)  =>  (VPMINf:{ *:[v2f32] } DPR:{ *:[v2f32] }:$Vn, DPR:{ *:[v2f32] }:$Vm)
     /*  54384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VPMINf),
     /*  54387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  54389 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  54391 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  54393 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  54396 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  54402 */     GIR_RootConstrainSelectedInstOperands,
     /*  54403 */     // GIR_Coverage, 1277,
     /*  54403 */     GIR_EraseRootFromParent_Done,
     /*  54404 */   // Label 1179: @54404
     /*  54404 */   GIM_Try, /*On fail goto*//*Label 1180*/ GIMT_Encode4(54458), // Rule ID 1278 //
     /*  54409 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /*  54412 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vpmins),
     /*  54417 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  54420 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  54423 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  54426 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54430 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54434 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54438 */     // (intrinsic_wo_chain:{ *:[v4f16] } 3809:{ *:[iPTR] }, DPR:{ *:[v4f16] }:$Vn, DPR:{ *:[v4f16] }:$Vm)  =>  (VPMINh:{ *:[v4f16] } DPR:{ *:[v4f16] }:$Vn, DPR:{ *:[v4f16] }:$Vm)
     /*  54438 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VPMINh),
     /*  54441 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  54443 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  54445 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  54447 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  54450 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  54456 */     GIR_RootConstrainSelectedInstOperands,
     /*  54457 */     // GIR_Coverage, 1278,
     /*  54457 */     GIR_EraseRootFromParent_Done,
     /*  54458 */   // Label 1180: @54458
     /*  54458 */   GIM_Try, /*On fail goto*//*Label 1181*/ GIMT_Encode4(54512), // Rule ID 1285 //
     /*  54463 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  54466 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrecps),
     /*  54471 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  54474 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  54477 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  54480 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54484 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54488 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54492 */     // (intrinsic_wo_chain:{ *:[v2f32] } 3834:{ *:[iPTR] }, DPR:{ *:[v2f32] }:$Vn, DPR:{ *:[v2f32] }:$Vm)  =>  (VRECPSfd:{ *:[v2f32] } DPR:{ *:[v2f32] }:$Vn, DPR:{ *:[v2f32] }:$Vm)
     /*  54492 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRECPSfd),
     /*  54495 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  54497 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  54499 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  54501 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  54504 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  54510 */     GIR_RootConstrainSelectedInstOperands,
     /*  54511 */     // GIR_Coverage, 1285,
     /*  54511 */     GIR_EraseRootFromParent_Done,
     /*  54512 */   // Label 1181: @54512
     /*  54512 */   GIM_Try, /*On fail goto*//*Label 1182*/ GIMT_Encode4(54566), // Rule ID 1286 //
     /*  54517 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  54520 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrecps),
     /*  54525 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  54528 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  54531 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  54534 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  54538 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  54542 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  54546 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3834:{ *:[iPTR] }, QPR:{ *:[v4f32] }:$Vn, QPR:{ *:[v4f32] }:$Vm)  =>  (VRECPSfq:{ *:[v4f32] } QPR:{ *:[v4f32] }:$Vn, QPR:{ *:[v4f32] }:$Vm)
     /*  54546 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRECPSfq),
     /*  54549 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  54551 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  54553 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  54555 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  54558 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  54564 */     GIR_RootConstrainSelectedInstOperands,
     /*  54565 */     // GIR_Coverage, 1286,
     /*  54565 */     GIR_EraseRootFromParent_Done,
     /*  54566 */   // Label 1182: @54566
     /*  54566 */   GIM_Try, /*On fail goto*//*Label 1183*/ GIMT_Encode4(54620), // Rule ID 1287 //
     /*  54571 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /*  54574 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrecps),
     /*  54579 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  54582 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  54585 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  54588 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54592 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54596 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54600 */     // (intrinsic_wo_chain:{ *:[v4f16] } 3834:{ *:[iPTR] }, DPR:{ *:[v4f16] }:$Vn, DPR:{ *:[v4f16] }:$Vm)  =>  (VRECPShd:{ *:[v4f16] } DPR:{ *:[v4f16] }:$Vn, DPR:{ *:[v4f16] }:$Vm)
     /*  54600 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRECPShd),
     /*  54603 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  54605 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  54607 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  54609 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  54612 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  54618 */     GIR_RootConstrainSelectedInstOperands,
     /*  54619 */     // GIR_Coverage, 1287,
     /*  54619 */     GIR_EraseRootFromParent_Done,
     /*  54620 */   // Label 1183: @54620
     /*  54620 */   GIM_Try, /*On fail goto*//*Label 1184*/ GIMT_Encode4(54674), // Rule ID 1288 //
     /*  54625 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /*  54628 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrecps),
     /*  54633 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  54636 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  54639 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  54642 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  54646 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  54650 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  54654 */     // (intrinsic_wo_chain:{ *:[v8f16] } 3834:{ *:[iPTR] }, QPR:{ *:[v8f16] }:$Vn, QPR:{ *:[v8f16] }:$Vm)  =>  (VRECPShq:{ *:[v8f16] } QPR:{ *:[v8f16] }:$Vn, QPR:{ *:[v8f16] }:$Vm)
     /*  54654 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRECPShq),
     /*  54657 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  54659 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  54661 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  54663 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  54666 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  54672 */     GIR_RootConstrainSelectedInstOperands,
     /*  54673 */     // GIR_Coverage, 1288,
     /*  54673 */     GIR_EraseRootFromParent_Done,
     /*  54674 */   // Label 1184: @54674
     /*  54674 */   GIM_Try, /*On fail goto*//*Label 1185*/ GIMT_Encode4(54728), // Rule ID 1295 //
     /*  54679 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  54682 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrsqrts),
     /*  54687 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  54690 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  54693 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  54696 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54700 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54704 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54708 */     // (intrinsic_wo_chain:{ *:[v2f32] } 3841:{ *:[iPTR] }, DPR:{ *:[v2f32] }:$Vn, DPR:{ *:[v2f32] }:$Vm)  =>  (VRSQRTSfd:{ *:[v2f32] } DPR:{ *:[v2f32] }:$Vn, DPR:{ *:[v2f32] }:$Vm)
     /*  54708 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRSQRTSfd),
     /*  54711 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  54713 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  54715 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  54717 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  54720 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  54726 */     GIR_RootConstrainSelectedInstOperands,
     /*  54727 */     // GIR_Coverage, 1295,
     /*  54727 */     GIR_EraseRootFromParent_Done,
     /*  54728 */   // Label 1185: @54728
     /*  54728 */   GIM_Try, /*On fail goto*//*Label 1186*/ GIMT_Encode4(54782), // Rule ID 1296 //
     /*  54733 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  54736 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrsqrts),
     /*  54741 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  54744 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  54747 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  54750 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  54754 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  54758 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  54762 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3841:{ *:[iPTR] }, QPR:{ *:[v4f32] }:$Vn, QPR:{ *:[v4f32] }:$Vm)  =>  (VRSQRTSfq:{ *:[v4f32] } QPR:{ *:[v4f32] }:$Vn, QPR:{ *:[v4f32] }:$Vm)
     /*  54762 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRSQRTSfq),
     /*  54765 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  54767 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  54769 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  54771 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  54774 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  54780 */     GIR_RootConstrainSelectedInstOperands,
     /*  54781 */     // GIR_Coverage, 1296,
     /*  54781 */     GIR_EraseRootFromParent_Done,
     /*  54782 */   // Label 1186: @54782
     /*  54782 */   GIM_Try, /*On fail goto*//*Label 1187*/ GIMT_Encode4(54836), // Rule ID 1297 //
     /*  54787 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /*  54790 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrsqrts),
     /*  54795 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  54798 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  54801 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  54804 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54808 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54812 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54816 */     // (intrinsic_wo_chain:{ *:[v4f16] } 3841:{ *:[iPTR] }, DPR:{ *:[v4f16] }:$Vn, DPR:{ *:[v4f16] }:$Vm)  =>  (VRSQRTShd:{ *:[v4f16] } DPR:{ *:[v4f16] }:$Vn, DPR:{ *:[v4f16] }:$Vm)
     /*  54816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRSQRTShd),
     /*  54819 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  54821 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  54823 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  54825 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  54828 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  54834 */     GIR_RootConstrainSelectedInstOperands,
     /*  54835 */     // GIR_Coverage, 1297,
     /*  54835 */     GIR_EraseRootFromParent_Done,
     /*  54836 */   // Label 1187: @54836
     /*  54836 */   GIM_Try, /*On fail goto*//*Label 1188*/ GIMT_Encode4(54890), // Rule ID 1298 //
     /*  54841 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /*  54844 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrsqrts),
     /*  54849 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  54852 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  54855 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  54858 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  54862 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  54866 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  54870 */     // (intrinsic_wo_chain:{ *:[v8f16] } 3841:{ *:[iPTR] }, QPR:{ *:[v8f16] }:$Vn, QPR:{ *:[v8f16] }:$Vm)  =>  (VRSQRTShq:{ *:[v8f16] } QPR:{ *:[v8f16] }:$Vn, QPR:{ *:[v8f16] }:$Vm)
     /*  54870 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRSQRTShq),
     /*  54873 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  54875 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  54877 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  54879 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  54882 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  54888 */     GIR_RootConstrainSelectedInstOperands,
     /*  54889 */     // GIR_Coverage, 1298,
     /*  54889 */     GIR_EraseRootFromParent_Done,
     /*  54890 */   // Label 1188: @54890
     /*  54890 */   GIM_Try, /*On fail goto*//*Label 1189*/ GIMT_Encode4(54944), // Rule ID 1299 //
     /*  54895 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  54898 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vshifts),
     /*  54903 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  54906 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  54909 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  54912 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54916 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54920 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54924 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3844:{ *:[iPTR] }, DPR:{ *:[v4i16] }:$Vm, DPR:{ *:[v4i16] }:$Vn)  =>  (VSHLsv4i16:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vm, DPR:{ *:[v4i16] }:$Vn)
     /*  54924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSHLsv4i16),
     /*  54927 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  54929 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  54931 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  54933 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  54936 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  54942 */     GIR_RootConstrainSelectedInstOperands,
     /*  54943 */     // GIR_Coverage, 1299,
     /*  54943 */     GIR_EraseRootFromParent_Done,
     /*  54944 */   // Label 1189: @54944
     /*  54944 */   GIM_Try, /*On fail goto*//*Label 1190*/ GIMT_Encode4(54998), // Rule ID 1300 //
     /*  54949 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  54952 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vshifts),
     /*  54957 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  54960 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  54963 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  54966 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54970 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54974 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54978 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3844:{ *:[iPTR] }, DPR:{ *:[v2i32] }:$Vm, DPR:{ *:[v2i32] }:$Vn)  =>  (VSHLsv2i32:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vm, DPR:{ *:[v2i32] }:$Vn)
     /*  54978 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSHLsv2i32),
     /*  54981 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  54983 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  54985 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  54987 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  54990 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  54996 */     GIR_RootConstrainSelectedInstOperands,
     /*  54997 */     // GIR_Coverage, 1300,
     /*  54997 */     GIR_EraseRootFromParent_Done,
     /*  54998 */   // Label 1190: @54998
     /*  54998 */   GIM_Try, /*On fail goto*//*Label 1191*/ GIMT_Encode4(55052), // Rule ID 1301 //
     /*  55003 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  55006 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vshifts),
     /*  55011 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  55014 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  55017 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  55020 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  55024 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  55028 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  55032 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3844:{ *:[iPTR] }, QPR:{ *:[v8i16] }:$Vm, QPR:{ *:[v8i16] }:$Vn)  =>  (VSHLsv8i16:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vm, QPR:{ *:[v8i16] }:$Vn)
     /*  55032 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSHLsv8i16),
     /*  55035 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  55037 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  55039 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  55041 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  55044 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  55050 */     GIR_RootConstrainSelectedInstOperands,
     /*  55051 */     // GIR_Coverage, 1301,
     /*  55051 */     GIR_EraseRootFromParent_Done,
     /*  55052 */   // Label 1191: @55052
     /*  55052 */   GIM_Try, /*On fail goto*//*Label 1192*/ GIMT_Encode4(55106), // Rule ID 1302 //
     /*  55057 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  55060 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vshifts),
     /*  55065 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  55068 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  55071 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  55074 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  55078 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  55082 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  55086 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3844:{ *:[iPTR] }, QPR:{ *:[v4i32] }:$Vm, QPR:{ *:[v4i32] }:$Vn)  =>  (VSHLsv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vm, QPR:{ *:[v4i32] }:$Vn)
     /*  55086 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSHLsv4i32),
     /*  55089 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  55091 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  55093 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  55095 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  55098 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  55104 */     GIR_RootConstrainSelectedInstOperands,
     /*  55105 */     // GIR_Coverage, 1302,
     /*  55105 */     GIR_EraseRootFromParent_Done,
     /*  55106 */   // Label 1192: @55106
     /*  55106 */   GIM_Try, /*On fail goto*//*Label 1193*/ GIMT_Encode4(55160), // Rule ID 1303 //
     /*  55111 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  55114 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vshifts),
     /*  55119 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /*  55122 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  55125 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  55128 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  55132 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  55136 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  55140 */     // (intrinsic_wo_chain:{ *:[v8i8] } 3844:{ *:[iPTR] }, DPR:{ *:[v8i8] }:$Vm, DPR:{ *:[v8i8] }:$Vn)  =>  (VSHLsv8i8:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vm, DPR:{ *:[v8i8] }:$Vn)
     /*  55140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSHLsv8i8),
     /*  55143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  55145 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  55147 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  55149 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  55152 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  55158 */     GIR_RootConstrainSelectedInstOperands,
     /*  55159 */     // GIR_Coverage, 1303,
     /*  55159 */     GIR_EraseRootFromParent_Done,
     /*  55160 */   // Label 1193: @55160
     /*  55160 */   GIM_Try, /*On fail goto*//*Label 1194*/ GIMT_Encode4(55214), // Rule ID 1304 //
     /*  55165 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  55168 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vshifts),
     /*  55173 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  55176 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  55179 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  55182 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  55186 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  55190 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  55194 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3844:{ *:[iPTR] }, QPR:{ *:[v16i8] }:$Vm, QPR:{ *:[v16i8] }:$Vn)  =>  (VSHLsv16i8:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vm, QPR:{ *:[v16i8] }:$Vn)
     /*  55194 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSHLsv16i8),
     /*  55197 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  55199 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  55201 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  55203 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  55206 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  55212 */     GIR_RootConstrainSelectedInstOperands,
     /*  55213 */     // GIR_Coverage, 1304,
     /*  55213 */     GIR_EraseRootFromParent_Done,
     /*  55214 */   // Label 1194: @55214
     /*  55214 */   GIM_Try, /*On fail goto*//*Label 1195*/ GIMT_Encode4(55268), // Rule ID 1305 //
     /*  55219 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  55222 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vshifts),
     /*  55227 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  55230 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  55233 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  55236 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  55240 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  55244 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  55248 */     // (intrinsic_wo_chain:{ *:[v1i64] } 3844:{ *:[iPTR] }, DPR:{ *:[v1i64] }:$Vm, DPR:{ *:[v1i64] }:$Vn)  =>  (VSHLsv1i64:{ *:[v1i64] } DPR:{ *:[v1i64] }:$Vm, DPR:{ *:[v1i64] }:$Vn)
     /*  55248 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSHLsv1i64),
     /*  55251 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  55253 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  55255 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  55257 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  55260 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  55266 */     GIR_RootConstrainSelectedInstOperands,
     /*  55267 */     // GIR_Coverage, 1305,
     /*  55267 */     GIR_EraseRootFromParent_Done,
     /*  55268 */   // Label 1195: @55268
     /*  55268 */   GIM_Try, /*On fail goto*//*Label 1196*/ GIMT_Encode4(55322), // Rule ID 1306 //
     /*  55273 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  55276 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vshifts),
     /*  55281 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  55284 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  55287 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  55290 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  55294 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  55298 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  55302 */     // (intrinsic_wo_chain:{ *:[v2i64] } 3844:{ *:[iPTR] }, QPR:{ *:[v2i64] }:$Vm, QPR:{ *:[v2i64] }:$Vn)  =>  (VSHLsv2i64:{ *:[v2i64] } QPR:{ *:[v2i64] }:$Vm, QPR:{ *:[v2i64] }:$Vn)
     /*  55302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSHLsv2i64),
     /*  55305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  55307 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  55309 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  55311 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  55314 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  55320 */     GIR_RootConstrainSelectedInstOperands,
     /*  55321 */     // GIR_Coverage, 1306,
     /*  55321 */     GIR_EraseRootFromParent_Done,
     /*  55322 */   // Label 1196: @55322
     /*  55322 */   GIM_Try, /*On fail goto*//*Label 1197*/ GIMT_Encode4(55376), // Rule ID 1307 //
     /*  55327 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  55330 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vshiftu),
     /*  55335 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  55338 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  55341 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  55344 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  55348 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  55352 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  55356 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3845:{ *:[iPTR] }, DPR:{ *:[v4i16] }:$Vm, DPR:{ *:[v4i16] }:$Vn)  =>  (VSHLuv4i16:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vm, DPR:{ *:[v4i16] }:$Vn)
     /*  55356 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSHLuv4i16),
     /*  55359 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  55361 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  55363 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  55365 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  55368 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  55374 */     GIR_RootConstrainSelectedInstOperands,
     /*  55375 */     // GIR_Coverage, 1307,
     /*  55375 */     GIR_EraseRootFromParent_Done,
     /*  55376 */   // Label 1197: @55376
     /*  55376 */   GIM_Try, /*On fail goto*//*Label 1198*/ GIMT_Encode4(55430), // Rule ID 1308 //
     /*  55381 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  55384 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vshiftu),
     /*  55389 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  55392 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  55395 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  55398 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  55402 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  55406 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  55410 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3845:{ *:[iPTR] }, DPR:{ *:[v2i32] }:$Vm, DPR:{ *:[v2i32] }:$Vn)  =>  (VSHLuv2i32:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vm, DPR:{ *:[v2i32] }:$Vn)
     /*  55410 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSHLuv2i32),
     /*  55413 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  55415 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  55417 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  55419 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  55422 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  55428 */     GIR_RootConstrainSelectedInstOperands,
     /*  55429 */     // GIR_Coverage, 1308,
     /*  55429 */     GIR_EraseRootFromParent_Done,
     /*  55430 */   // Label 1198: @55430
     /*  55430 */   GIM_Try, /*On fail goto*//*Label 1199*/ GIMT_Encode4(55484), // Rule ID 1309 //
     /*  55435 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  55438 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vshiftu),
     /*  55443 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  55446 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  55449 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  55452 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  55456 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  55460 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  55464 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3845:{ *:[iPTR] }, QPR:{ *:[v8i16] }:$Vm, QPR:{ *:[v8i16] }:$Vn)  =>  (VSHLuv8i16:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vm, QPR:{ *:[v8i16] }:$Vn)
     /*  55464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSHLuv8i16),
     /*  55467 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  55469 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  55471 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  55473 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  55476 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  55482 */     GIR_RootConstrainSelectedInstOperands,
     /*  55483 */     // GIR_Coverage, 1309,
     /*  55483 */     GIR_EraseRootFromParent_Done,
     /*  55484 */   // Label 1199: @55484
     /*  55484 */   GIM_Try, /*On fail goto*//*Label 1200*/ GIMT_Encode4(55538), // Rule ID 1310 //
     /*  55489 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  55492 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vshiftu),
     /*  55497 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  55500 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  55503 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  55506 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  55510 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  55514 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  55518 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3845:{ *:[iPTR] }, QPR:{ *:[v4i32] }:$Vm, QPR:{ *:[v4i32] }:$Vn)  =>  (VSHLuv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vm, QPR:{ *:[v4i32] }:$Vn)
     /*  55518 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSHLuv4i32),
     /*  55521 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  55523 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  55525 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  55527 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  55530 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  55536 */     GIR_RootConstrainSelectedInstOperands,
     /*  55537 */     // GIR_Coverage, 1310,
     /*  55537 */     GIR_EraseRootFromParent_Done,
     /*  55538 */   // Label 1200: @55538
     /*  55538 */   GIM_Try, /*On fail goto*//*Label 1201*/ GIMT_Encode4(55592), // Rule ID 1311 //
     /*  55543 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  55546 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vshiftu),
     /*  55551 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /*  55554 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  55557 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  55560 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  55564 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  55568 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  55572 */     // (intrinsic_wo_chain:{ *:[v8i8] } 3845:{ *:[iPTR] }, DPR:{ *:[v8i8] }:$Vm, DPR:{ *:[v8i8] }:$Vn)  =>  (VSHLuv8i8:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vm, DPR:{ *:[v8i8] }:$Vn)
     /*  55572 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSHLuv8i8),
     /*  55575 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  55577 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  55579 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  55581 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  55584 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  55590 */     GIR_RootConstrainSelectedInstOperands,
     /*  55591 */     // GIR_Coverage, 1311,
     /*  55591 */     GIR_EraseRootFromParent_Done,
     /*  55592 */   // Label 1201: @55592
     /*  55592 */   GIM_Try, /*On fail goto*//*Label 1202*/ GIMT_Encode4(55646), // Rule ID 1312 //
     /*  55597 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  55600 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vshiftu),
     /*  55605 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  55608 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  55611 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  55614 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  55618 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  55622 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  55626 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3845:{ *:[iPTR] }, QPR:{ *:[v16i8] }:$Vm, QPR:{ *:[v16i8] }:$Vn)  =>  (VSHLuv16i8:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vm, QPR:{ *:[v16i8] }:$Vn)
     /*  55626 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSHLuv16i8),
     /*  55629 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  55631 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  55633 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  55635 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  55638 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  55644 */     GIR_RootConstrainSelectedInstOperands,
     /*  55645 */     // GIR_Coverage, 1312,
     /*  55645 */     GIR_EraseRootFromParent_Done,
     /*  55646 */   // Label 1202: @55646
     /*  55646 */   GIM_Try, /*On fail goto*//*Label 1203*/ GIMT_Encode4(55700), // Rule ID 1313 //
     /*  55651 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  55654 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vshiftu),
     /*  55659 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  55662 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  55665 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  55668 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  55672 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  55676 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  55680 */     // (intrinsic_wo_chain:{ *:[v1i64] } 3845:{ *:[iPTR] }, DPR:{ *:[v1i64] }:$Vm, DPR:{ *:[v1i64] }:$Vn)  =>  (VSHLuv1i64:{ *:[v1i64] } DPR:{ *:[v1i64] }:$Vm, DPR:{ *:[v1i64] }:$Vn)
     /*  55680 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSHLuv1i64),
     /*  55683 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  55685 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  55687 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  55689 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  55692 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  55698 */     GIR_RootConstrainSelectedInstOperands,
     /*  55699 */     // GIR_Coverage, 1313,
     /*  55699 */     GIR_EraseRootFromParent_Done,
     /*  55700 */   // Label 1203: @55700
     /*  55700 */   GIM_Try, /*On fail goto*//*Label 1204*/ GIMT_Encode4(55754), // Rule ID 1314 //
     /*  55705 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  55708 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vshiftu),
     /*  55713 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  55716 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  55719 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  55722 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  55726 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  55730 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  55734 */     // (intrinsic_wo_chain:{ *:[v2i64] } 3845:{ *:[iPTR] }, QPR:{ *:[v2i64] }:$Vm, QPR:{ *:[v2i64] }:$Vn)  =>  (VSHLuv2i64:{ *:[v2i64] } QPR:{ *:[v2i64] }:$Vm, QPR:{ *:[v2i64] }:$Vn)
     /*  55734 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSHLuv2i64),
     /*  55737 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  55739 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  55741 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  55743 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  55746 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  55752 */     GIR_RootConstrainSelectedInstOperands,
     /*  55753 */     // GIR_Coverage, 1314,
     /*  55753 */     GIR_EraseRootFromParent_Done,
     /*  55754 */   // Label 1204: @55754
     /*  55754 */   GIM_Try, /*On fail goto*//*Label 1205*/ GIMT_Encode4(55808), // Rule ID 1348 //
     /*  55759 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  55762 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrshifts),
     /*  55767 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  55770 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  55773 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  55776 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  55780 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  55784 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  55788 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3838:{ *:[iPTR] }, DPR:{ *:[v4i16] }:$Vm, DPR:{ *:[v4i16] }:$Vn)  =>  (VRSHLsv4i16:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vm, DPR:{ *:[v4i16] }:$Vn)
     /*  55788 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRSHLsv4i16),
     /*  55791 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  55793 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  55795 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  55797 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  55800 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  55806 */     GIR_RootConstrainSelectedInstOperands,
     /*  55807 */     // GIR_Coverage, 1348,
     /*  55807 */     GIR_EraseRootFromParent_Done,
     /*  55808 */   // Label 1205: @55808
     /*  55808 */   GIM_Try, /*On fail goto*//*Label 1206*/ GIMT_Encode4(55862), // Rule ID 1349 //
     /*  55813 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  55816 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrshifts),
     /*  55821 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  55824 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  55827 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  55830 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  55834 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  55838 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  55842 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3838:{ *:[iPTR] }, DPR:{ *:[v2i32] }:$Vm, DPR:{ *:[v2i32] }:$Vn)  =>  (VRSHLsv2i32:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vm, DPR:{ *:[v2i32] }:$Vn)
     /*  55842 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRSHLsv2i32),
     /*  55845 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  55847 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  55849 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  55851 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  55854 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  55860 */     GIR_RootConstrainSelectedInstOperands,
     /*  55861 */     // GIR_Coverage, 1349,
     /*  55861 */     GIR_EraseRootFromParent_Done,
     /*  55862 */   // Label 1206: @55862
     /*  55862 */   GIM_Try, /*On fail goto*//*Label 1207*/ GIMT_Encode4(55916), // Rule ID 1350 //
     /*  55867 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  55870 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrshifts),
     /*  55875 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  55878 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  55881 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  55884 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  55888 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  55892 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  55896 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3838:{ *:[iPTR] }, QPR:{ *:[v8i16] }:$Vm, QPR:{ *:[v8i16] }:$Vn)  =>  (VRSHLsv8i16:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vm, QPR:{ *:[v8i16] }:$Vn)
     /*  55896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRSHLsv8i16),
     /*  55899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  55901 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  55903 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  55905 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  55908 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  55914 */     GIR_RootConstrainSelectedInstOperands,
     /*  55915 */     // GIR_Coverage, 1350,
     /*  55915 */     GIR_EraseRootFromParent_Done,
     /*  55916 */   // Label 1207: @55916
     /*  55916 */   GIM_Try, /*On fail goto*//*Label 1208*/ GIMT_Encode4(55970), // Rule ID 1351 //
     /*  55921 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  55924 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrshifts),
     /*  55929 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  55932 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  55935 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  55938 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  55942 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  55946 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  55950 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3838:{ *:[iPTR] }, QPR:{ *:[v4i32] }:$Vm, QPR:{ *:[v4i32] }:$Vn)  =>  (VRSHLsv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vm, QPR:{ *:[v4i32] }:$Vn)
     /*  55950 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRSHLsv4i32),
     /*  55953 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  55955 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  55957 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  55959 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  55962 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  55968 */     GIR_RootConstrainSelectedInstOperands,
     /*  55969 */     // GIR_Coverage, 1351,
     /*  55969 */     GIR_EraseRootFromParent_Done,
     /*  55970 */   // Label 1208: @55970
     /*  55970 */   GIM_Try, /*On fail goto*//*Label 1209*/ GIMT_Encode4(56024), // Rule ID 1352 //
     /*  55975 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  55978 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrshifts),
     /*  55983 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /*  55986 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  55989 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  55992 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  55996 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  56000 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  56004 */     // (intrinsic_wo_chain:{ *:[v8i8] } 3838:{ *:[iPTR] }, DPR:{ *:[v8i8] }:$Vm, DPR:{ *:[v8i8] }:$Vn)  =>  (VRSHLsv8i8:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vm, DPR:{ *:[v8i8] }:$Vn)
     /*  56004 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRSHLsv8i8),
     /*  56007 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  56009 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  56011 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  56013 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  56016 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  56022 */     GIR_RootConstrainSelectedInstOperands,
     /*  56023 */     // GIR_Coverage, 1352,
     /*  56023 */     GIR_EraseRootFromParent_Done,
     /*  56024 */   // Label 1209: @56024
     /*  56024 */   GIM_Try, /*On fail goto*//*Label 1210*/ GIMT_Encode4(56078), // Rule ID 1353 //
     /*  56029 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  56032 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrshifts),
     /*  56037 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  56040 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  56043 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  56046 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  56050 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  56054 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  56058 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3838:{ *:[iPTR] }, QPR:{ *:[v16i8] }:$Vm, QPR:{ *:[v16i8] }:$Vn)  =>  (VRSHLsv16i8:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vm, QPR:{ *:[v16i8] }:$Vn)
     /*  56058 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRSHLsv16i8),
     /*  56061 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  56063 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  56065 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  56067 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  56070 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  56076 */     GIR_RootConstrainSelectedInstOperands,
     /*  56077 */     // GIR_Coverage, 1353,
     /*  56077 */     GIR_EraseRootFromParent_Done,
     /*  56078 */   // Label 1210: @56078
     /*  56078 */   GIM_Try, /*On fail goto*//*Label 1211*/ GIMT_Encode4(56132), // Rule ID 1354 //
     /*  56083 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  56086 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrshifts),
     /*  56091 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  56094 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  56097 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  56100 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  56104 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  56108 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  56112 */     // (intrinsic_wo_chain:{ *:[v1i64] } 3838:{ *:[iPTR] }, DPR:{ *:[v1i64] }:$Vm, DPR:{ *:[v1i64] }:$Vn)  =>  (VRSHLsv1i64:{ *:[v1i64] } DPR:{ *:[v1i64] }:$Vm, DPR:{ *:[v1i64] }:$Vn)
     /*  56112 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRSHLsv1i64),
     /*  56115 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  56117 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  56119 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  56121 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  56124 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  56130 */     GIR_RootConstrainSelectedInstOperands,
     /*  56131 */     // GIR_Coverage, 1354,
     /*  56131 */     GIR_EraseRootFromParent_Done,
     /*  56132 */   // Label 1211: @56132
     /*  56132 */   GIM_Try, /*On fail goto*//*Label 1212*/ GIMT_Encode4(56186), // Rule ID 1355 //
     /*  56137 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  56140 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrshifts),
     /*  56145 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  56148 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  56151 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  56154 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  56158 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  56162 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  56166 */     // (intrinsic_wo_chain:{ *:[v2i64] } 3838:{ *:[iPTR] }, QPR:{ *:[v2i64] }:$Vm, QPR:{ *:[v2i64] }:$Vn)  =>  (VRSHLsv2i64:{ *:[v2i64] } QPR:{ *:[v2i64] }:$Vm, QPR:{ *:[v2i64] }:$Vn)
     /*  56166 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRSHLsv2i64),
     /*  56169 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  56171 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  56173 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  56175 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  56178 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  56184 */     GIR_RootConstrainSelectedInstOperands,
     /*  56185 */     // GIR_Coverage, 1355,
     /*  56185 */     GIR_EraseRootFromParent_Done,
     /*  56186 */   // Label 1212: @56186
     /*  56186 */   GIM_Try, /*On fail goto*//*Label 1213*/ GIMT_Encode4(56240), // Rule ID 1356 //
     /*  56191 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  56194 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrshiftu),
     /*  56199 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  56202 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  56205 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  56208 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  56212 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  56216 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  56220 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3839:{ *:[iPTR] }, DPR:{ *:[v4i16] }:$Vm, DPR:{ *:[v4i16] }:$Vn)  =>  (VRSHLuv4i16:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vm, DPR:{ *:[v4i16] }:$Vn)
     /*  56220 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRSHLuv4i16),
     /*  56223 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  56225 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  56227 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  56229 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  56232 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  56238 */     GIR_RootConstrainSelectedInstOperands,
     /*  56239 */     // GIR_Coverage, 1356,
     /*  56239 */     GIR_EraseRootFromParent_Done,
     /*  56240 */   // Label 1213: @56240
     /*  56240 */   GIM_Try, /*On fail goto*//*Label 1214*/ GIMT_Encode4(56294), // Rule ID 1357 //
     /*  56245 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  56248 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrshiftu),
     /*  56253 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  56256 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  56259 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  56262 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  56266 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  56270 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  56274 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3839:{ *:[iPTR] }, DPR:{ *:[v2i32] }:$Vm, DPR:{ *:[v2i32] }:$Vn)  =>  (VRSHLuv2i32:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vm, DPR:{ *:[v2i32] }:$Vn)
     /*  56274 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRSHLuv2i32),
     /*  56277 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  56279 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  56281 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  56283 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  56286 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  56292 */     GIR_RootConstrainSelectedInstOperands,
     /*  56293 */     // GIR_Coverage, 1357,
     /*  56293 */     GIR_EraseRootFromParent_Done,
     /*  56294 */   // Label 1214: @56294
     /*  56294 */   GIM_Try, /*On fail goto*//*Label 1215*/ GIMT_Encode4(56348), // Rule ID 1358 //
     /*  56299 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  56302 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrshiftu),
     /*  56307 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  56310 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  56313 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  56316 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  56320 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  56324 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  56328 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3839:{ *:[iPTR] }, QPR:{ *:[v8i16] }:$Vm, QPR:{ *:[v8i16] }:$Vn)  =>  (VRSHLuv8i16:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vm, QPR:{ *:[v8i16] }:$Vn)
     /*  56328 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRSHLuv8i16),
     /*  56331 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  56333 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  56335 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  56337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  56340 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  56346 */     GIR_RootConstrainSelectedInstOperands,
     /*  56347 */     // GIR_Coverage, 1358,
     /*  56347 */     GIR_EraseRootFromParent_Done,
     /*  56348 */   // Label 1215: @56348
     /*  56348 */   GIM_Try, /*On fail goto*//*Label 1216*/ GIMT_Encode4(56402), // Rule ID 1359 //
     /*  56353 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  56356 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrshiftu),
     /*  56361 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  56364 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  56367 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  56370 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  56374 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  56378 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  56382 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3839:{ *:[iPTR] }, QPR:{ *:[v4i32] }:$Vm, QPR:{ *:[v4i32] }:$Vn)  =>  (VRSHLuv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vm, QPR:{ *:[v4i32] }:$Vn)
     /*  56382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRSHLuv4i32),
     /*  56385 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  56387 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  56389 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  56391 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  56394 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  56400 */     GIR_RootConstrainSelectedInstOperands,
     /*  56401 */     // GIR_Coverage, 1359,
     /*  56401 */     GIR_EraseRootFromParent_Done,
     /*  56402 */   // Label 1216: @56402
     /*  56402 */   GIM_Try, /*On fail goto*//*Label 1217*/ GIMT_Encode4(56456), // Rule ID 1360 //
     /*  56407 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  56410 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrshiftu),
     /*  56415 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /*  56418 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  56421 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  56424 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  56428 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  56432 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  56436 */     // (intrinsic_wo_chain:{ *:[v8i8] } 3839:{ *:[iPTR] }, DPR:{ *:[v8i8] }:$Vm, DPR:{ *:[v8i8] }:$Vn)  =>  (VRSHLuv8i8:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vm, DPR:{ *:[v8i8] }:$Vn)
     /*  56436 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRSHLuv8i8),
     /*  56439 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  56441 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  56443 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  56445 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  56448 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  56454 */     GIR_RootConstrainSelectedInstOperands,
     /*  56455 */     // GIR_Coverage, 1360,
     /*  56455 */     GIR_EraseRootFromParent_Done,
     /*  56456 */   // Label 1217: @56456
     /*  56456 */   GIM_Try, /*On fail goto*//*Label 1218*/ GIMT_Encode4(56510), // Rule ID 1361 //
     /*  56461 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  56464 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrshiftu),
     /*  56469 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  56472 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  56475 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  56478 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  56482 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  56486 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  56490 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3839:{ *:[iPTR] }, QPR:{ *:[v16i8] }:$Vm, QPR:{ *:[v16i8] }:$Vn)  =>  (VRSHLuv16i8:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vm, QPR:{ *:[v16i8] }:$Vn)
     /*  56490 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRSHLuv16i8),
     /*  56493 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  56495 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  56497 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  56499 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  56502 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  56508 */     GIR_RootConstrainSelectedInstOperands,
     /*  56509 */     // GIR_Coverage, 1361,
     /*  56509 */     GIR_EraseRootFromParent_Done,
     /*  56510 */   // Label 1218: @56510
     /*  56510 */   GIM_Try, /*On fail goto*//*Label 1219*/ GIMT_Encode4(56564), // Rule ID 1362 //
     /*  56515 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  56518 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrshiftu),
     /*  56523 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  56526 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  56529 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  56532 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  56536 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  56540 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  56544 */     // (intrinsic_wo_chain:{ *:[v1i64] } 3839:{ *:[iPTR] }, DPR:{ *:[v1i64] }:$Vm, DPR:{ *:[v1i64] }:$Vn)  =>  (VRSHLuv1i64:{ *:[v1i64] } DPR:{ *:[v1i64] }:$Vm, DPR:{ *:[v1i64] }:$Vn)
     /*  56544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRSHLuv1i64),
     /*  56547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  56549 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  56551 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  56553 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  56556 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  56562 */     GIR_RootConstrainSelectedInstOperands,
     /*  56563 */     // GIR_Coverage, 1362,
     /*  56563 */     GIR_EraseRootFromParent_Done,
     /*  56564 */   // Label 1219: @56564
     /*  56564 */   GIM_Try, /*On fail goto*//*Label 1220*/ GIMT_Encode4(56618), // Rule ID 1363 //
     /*  56569 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  56572 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrshiftu),
     /*  56577 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  56580 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  56583 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  56586 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  56590 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  56594 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  56598 */     // (intrinsic_wo_chain:{ *:[v2i64] } 3839:{ *:[iPTR] }, QPR:{ *:[v2i64] }:$Vm, QPR:{ *:[v2i64] }:$Vn)  =>  (VRSHLuv2i64:{ *:[v2i64] } QPR:{ *:[v2i64] }:$Vm, QPR:{ *:[v2i64] }:$Vn)
     /*  56598 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRSHLuv2i64),
     /*  56601 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  56603 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  56605 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  56607 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  56610 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  56616 */     GIR_RootConstrainSelectedInstOperands,
     /*  56617 */     // GIR_Coverage, 1363,
     /*  56617 */     GIR_EraseRootFromParent_Done,
     /*  56618 */   // Label 1220: @56618
     /*  56618 */   GIM_Try, /*On fail goto*//*Label 1221*/ GIMT_Encode4(56672), // Rule ID 1383 //
     /*  56623 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  56626 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqshifts),
     /*  56631 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  56634 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  56637 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  56640 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  56644 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  56648 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  56652 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3829:{ *:[iPTR] }, DPR:{ *:[v4i16] }:$Vm, DPR:{ *:[v4i16] }:$Vn)  =>  (VQSHLsv4i16:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vm, DPR:{ *:[v4i16] }:$Vn)
     /*  56652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQSHLsv4i16),
     /*  56655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  56657 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  56659 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  56661 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  56664 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  56670 */     GIR_RootConstrainSelectedInstOperands,
     /*  56671 */     // GIR_Coverage, 1383,
     /*  56671 */     GIR_EraseRootFromParent_Done,
     /*  56672 */   // Label 1221: @56672
     /*  56672 */   GIM_Try, /*On fail goto*//*Label 1222*/ GIMT_Encode4(56726), // Rule ID 1384 //
     /*  56677 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  56680 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqshifts),
     /*  56685 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  56688 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  56691 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  56694 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  56698 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  56702 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  56706 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3829:{ *:[iPTR] }, DPR:{ *:[v2i32] }:$Vm, DPR:{ *:[v2i32] }:$Vn)  =>  (VQSHLsv2i32:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vm, DPR:{ *:[v2i32] }:$Vn)
     /*  56706 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQSHLsv2i32),
     /*  56709 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  56711 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  56713 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  56715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  56718 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  56724 */     GIR_RootConstrainSelectedInstOperands,
     /*  56725 */     // GIR_Coverage, 1384,
     /*  56725 */     GIR_EraseRootFromParent_Done,
     /*  56726 */   // Label 1222: @56726
     /*  56726 */   GIM_Try, /*On fail goto*//*Label 1223*/ GIMT_Encode4(56780), // Rule ID 1385 //
     /*  56731 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  56734 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqshifts),
     /*  56739 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  56742 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  56745 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  56748 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  56752 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  56756 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  56760 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3829:{ *:[iPTR] }, QPR:{ *:[v8i16] }:$Vm, QPR:{ *:[v8i16] }:$Vn)  =>  (VQSHLsv8i16:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vm, QPR:{ *:[v8i16] }:$Vn)
     /*  56760 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQSHLsv8i16),
     /*  56763 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  56765 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  56767 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  56769 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  56772 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  56778 */     GIR_RootConstrainSelectedInstOperands,
     /*  56779 */     // GIR_Coverage, 1385,
     /*  56779 */     GIR_EraseRootFromParent_Done,
     /*  56780 */   // Label 1223: @56780
     /*  56780 */   GIM_Try, /*On fail goto*//*Label 1224*/ GIMT_Encode4(56834), // Rule ID 1386 //
     /*  56785 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  56788 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqshifts),
     /*  56793 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  56796 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  56799 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  56802 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  56806 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  56810 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  56814 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3829:{ *:[iPTR] }, QPR:{ *:[v4i32] }:$Vm, QPR:{ *:[v4i32] }:$Vn)  =>  (VQSHLsv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vm, QPR:{ *:[v4i32] }:$Vn)
     /*  56814 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQSHLsv4i32),
     /*  56817 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  56819 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  56821 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  56823 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  56826 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  56832 */     GIR_RootConstrainSelectedInstOperands,
     /*  56833 */     // GIR_Coverage, 1386,
     /*  56833 */     GIR_EraseRootFromParent_Done,
     /*  56834 */   // Label 1224: @56834
     /*  56834 */   GIM_Try, /*On fail goto*//*Label 1225*/ GIMT_Encode4(56888), // Rule ID 1387 //
     /*  56839 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  56842 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqshifts),
     /*  56847 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /*  56850 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  56853 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  56856 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  56860 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  56864 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  56868 */     // (intrinsic_wo_chain:{ *:[v8i8] } 3829:{ *:[iPTR] }, DPR:{ *:[v8i8] }:$Vm, DPR:{ *:[v8i8] }:$Vn)  =>  (VQSHLsv8i8:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vm, DPR:{ *:[v8i8] }:$Vn)
     /*  56868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQSHLsv8i8),
     /*  56871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  56873 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  56875 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  56877 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  56880 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  56886 */     GIR_RootConstrainSelectedInstOperands,
     /*  56887 */     // GIR_Coverage, 1387,
     /*  56887 */     GIR_EraseRootFromParent_Done,
     /*  56888 */   // Label 1225: @56888
     /*  56888 */   GIM_Try, /*On fail goto*//*Label 1226*/ GIMT_Encode4(56942), // Rule ID 1388 //
     /*  56893 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  56896 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqshifts),
     /*  56901 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  56904 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  56907 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  56910 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  56914 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  56918 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  56922 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3829:{ *:[iPTR] }, QPR:{ *:[v16i8] }:$Vm, QPR:{ *:[v16i8] }:$Vn)  =>  (VQSHLsv16i8:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vm, QPR:{ *:[v16i8] }:$Vn)
     /*  56922 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQSHLsv16i8),
     /*  56925 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  56927 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  56929 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  56931 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  56934 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  56940 */     GIR_RootConstrainSelectedInstOperands,
     /*  56941 */     // GIR_Coverage, 1388,
     /*  56941 */     GIR_EraseRootFromParent_Done,
     /*  56942 */   // Label 1226: @56942
     /*  56942 */   GIM_Try, /*On fail goto*//*Label 1227*/ GIMT_Encode4(56996), // Rule ID 1389 //
     /*  56947 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  56950 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqshifts),
     /*  56955 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  56958 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  56961 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  56964 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  56968 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  56972 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  56976 */     // (intrinsic_wo_chain:{ *:[v1i64] } 3829:{ *:[iPTR] }, DPR:{ *:[v1i64] }:$Vm, DPR:{ *:[v1i64] }:$Vn)  =>  (VQSHLsv1i64:{ *:[v1i64] } DPR:{ *:[v1i64] }:$Vm, DPR:{ *:[v1i64] }:$Vn)
     /*  56976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQSHLsv1i64),
     /*  56979 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  56981 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  56983 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  56985 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  56988 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  56994 */     GIR_RootConstrainSelectedInstOperands,
     /*  56995 */     // GIR_Coverage, 1389,
     /*  56995 */     GIR_EraseRootFromParent_Done,
     /*  56996 */   // Label 1227: @56996
     /*  56996 */   GIM_Try, /*On fail goto*//*Label 1228*/ GIMT_Encode4(57050), // Rule ID 1390 //
     /*  57001 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  57004 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqshifts),
     /*  57009 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  57012 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  57015 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  57018 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  57022 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  57026 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  57030 */     // (intrinsic_wo_chain:{ *:[v2i64] } 3829:{ *:[iPTR] }, QPR:{ *:[v2i64] }:$Vm, QPR:{ *:[v2i64] }:$Vn)  =>  (VQSHLsv2i64:{ *:[v2i64] } QPR:{ *:[v2i64] }:$Vm, QPR:{ *:[v2i64] }:$Vn)
     /*  57030 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQSHLsv2i64),
     /*  57033 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  57035 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  57037 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  57039 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  57042 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  57048 */     GIR_RootConstrainSelectedInstOperands,
     /*  57049 */     // GIR_Coverage, 1390,
     /*  57049 */     GIR_EraseRootFromParent_Done,
     /*  57050 */   // Label 1228: @57050
     /*  57050 */   GIM_Try, /*On fail goto*//*Label 1229*/ GIMT_Encode4(57104), // Rule ID 1391 //
     /*  57055 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  57058 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqshiftu),
     /*  57063 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  57066 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  57069 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  57072 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  57076 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  57080 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  57084 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3831:{ *:[iPTR] }, DPR:{ *:[v4i16] }:$Vm, DPR:{ *:[v4i16] }:$Vn)  =>  (VQSHLuv4i16:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vm, DPR:{ *:[v4i16] }:$Vn)
     /*  57084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQSHLuv4i16),
     /*  57087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  57089 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  57091 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  57093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  57096 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  57102 */     GIR_RootConstrainSelectedInstOperands,
     /*  57103 */     // GIR_Coverage, 1391,
     /*  57103 */     GIR_EraseRootFromParent_Done,
     /*  57104 */   // Label 1229: @57104
     /*  57104 */   GIM_Try, /*On fail goto*//*Label 1230*/ GIMT_Encode4(57158), // Rule ID 1392 //
     /*  57109 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  57112 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqshiftu),
     /*  57117 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  57120 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  57123 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  57126 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  57130 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  57134 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  57138 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3831:{ *:[iPTR] }, DPR:{ *:[v2i32] }:$Vm, DPR:{ *:[v2i32] }:$Vn)  =>  (VQSHLuv2i32:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vm, DPR:{ *:[v2i32] }:$Vn)
     /*  57138 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQSHLuv2i32),
     /*  57141 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  57143 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  57145 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  57147 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  57150 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  57156 */     GIR_RootConstrainSelectedInstOperands,
     /*  57157 */     // GIR_Coverage, 1392,
     /*  57157 */     GIR_EraseRootFromParent_Done,
     /*  57158 */   // Label 1230: @57158
     /*  57158 */   GIM_Try, /*On fail goto*//*Label 1231*/ GIMT_Encode4(57212), // Rule ID 1393 //
     /*  57163 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  57166 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqshiftu),
     /*  57171 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  57174 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  57177 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  57180 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  57184 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  57188 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  57192 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3831:{ *:[iPTR] }, QPR:{ *:[v8i16] }:$Vm, QPR:{ *:[v8i16] }:$Vn)  =>  (VQSHLuv8i16:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vm, QPR:{ *:[v8i16] }:$Vn)
     /*  57192 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQSHLuv8i16),
     /*  57195 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  57197 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  57199 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  57201 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  57204 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  57210 */     GIR_RootConstrainSelectedInstOperands,
     /*  57211 */     // GIR_Coverage, 1393,
     /*  57211 */     GIR_EraseRootFromParent_Done,
     /*  57212 */   // Label 1231: @57212
     /*  57212 */   GIM_Try, /*On fail goto*//*Label 1232*/ GIMT_Encode4(57266), // Rule ID 1394 //
     /*  57217 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  57220 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqshiftu),
     /*  57225 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  57228 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  57231 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  57234 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  57238 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  57242 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  57246 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3831:{ *:[iPTR] }, QPR:{ *:[v4i32] }:$Vm, QPR:{ *:[v4i32] }:$Vn)  =>  (VQSHLuv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vm, QPR:{ *:[v4i32] }:$Vn)
     /*  57246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQSHLuv4i32),
     /*  57249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  57251 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  57253 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  57255 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  57258 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  57264 */     GIR_RootConstrainSelectedInstOperands,
     /*  57265 */     // GIR_Coverage, 1394,
     /*  57265 */     GIR_EraseRootFromParent_Done,
     /*  57266 */   // Label 1232: @57266
     /*  57266 */   GIM_Try, /*On fail goto*//*Label 1233*/ GIMT_Encode4(57320), // Rule ID 1395 //
     /*  57271 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  57274 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqshiftu),
     /*  57279 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /*  57282 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  57285 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  57288 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  57292 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  57296 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  57300 */     // (intrinsic_wo_chain:{ *:[v8i8] } 3831:{ *:[iPTR] }, DPR:{ *:[v8i8] }:$Vm, DPR:{ *:[v8i8] }:$Vn)  =>  (VQSHLuv8i8:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vm, DPR:{ *:[v8i8] }:$Vn)
     /*  57300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQSHLuv8i8),
     /*  57303 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  57305 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  57307 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  57309 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  57312 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  57318 */     GIR_RootConstrainSelectedInstOperands,
     /*  57319 */     // GIR_Coverage, 1395,
     /*  57319 */     GIR_EraseRootFromParent_Done,
     /*  57320 */   // Label 1233: @57320
     /*  57320 */   GIM_Try, /*On fail goto*//*Label 1234*/ GIMT_Encode4(57374), // Rule ID 1396 //
     /*  57325 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  57328 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqshiftu),
     /*  57333 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  57336 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  57339 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  57342 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  57346 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  57350 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  57354 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3831:{ *:[iPTR] }, QPR:{ *:[v16i8] }:$Vm, QPR:{ *:[v16i8] }:$Vn)  =>  (VQSHLuv16i8:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vm, QPR:{ *:[v16i8] }:$Vn)
     /*  57354 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQSHLuv16i8),
     /*  57357 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  57359 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  57361 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  57363 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  57366 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  57372 */     GIR_RootConstrainSelectedInstOperands,
     /*  57373 */     // GIR_Coverage, 1396,
     /*  57373 */     GIR_EraseRootFromParent_Done,
     /*  57374 */   // Label 1234: @57374
     /*  57374 */   GIM_Try, /*On fail goto*//*Label 1235*/ GIMT_Encode4(57428), // Rule ID 1397 //
     /*  57379 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  57382 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqshiftu),
     /*  57387 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  57390 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  57393 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  57396 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  57400 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  57404 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  57408 */     // (intrinsic_wo_chain:{ *:[v1i64] } 3831:{ *:[iPTR] }, DPR:{ *:[v1i64] }:$Vm, DPR:{ *:[v1i64] }:$Vn)  =>  (VQSHLuv1i64:{ *:[v1i64] } DPR:{ *:[v1i64] }:$Vm, DPR:{ *:[v1i64] }:$Vn)
     /*  57408 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQSHLuv1i64),
     /*  57411 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  57413 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  57415 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  57417 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  57420 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  57426 */     GIR_RootConstrainSelectedInstOperands,
     /*  57427 */     // GIR_Coverage, 1397,
     /*  57427 */     GIR_EraseRootFromParent_Done,
     /*  57428 */   // Label 1235: @57428
     /*  57428 */   GIM_Try, /*On fail goto*//*Label 1236*/ GIMT_Encode4(57482), // Rule ID 1398 //
     /*  57433 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  57436 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqshiftu),
     /*  57441 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  57444 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  57447 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  57450 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  57454 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  57458 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  57462 */     // (intrinsic_wo_chain:{ *:[v2i64] } 3831:{ *:[iPTR] }, QPR:{ *:[v2i64] }:$Vm, QPR:{ *:[v2i64] }:$Vn)  =>  (VQSHLuv2i64:{ *:[v2i64] } QPR:{ *:[v2i64] }:$Vm, QPR:{ *:[v2i64] }:$Vn)
     /*  57462 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQSHLuv2i64),
     /*  57465 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  57467 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  57469 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  57471 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  57474 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  57480 */     GIR_RootConstrainSelectedInstOperands,
     /*  57481 */     // GIR_Coverage, 1398,
     /*  57481 */     GIR_EraseRootFromParent_Done,
     /*  57482 */   // Label 1236: @57482
     /*  57482 */   GIM_Try, /*On fail goto*//*Label 1237*/ GIMT_Encode4(57536), // Rule ID 1432 //
     /*  57487 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  57490 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqrshifts),
     /*  57495 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  57498 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  57501 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  57504 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  57508 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  57512 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  57516 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3824:{ *:[iPTR] }, DPR:{ *:[v4i16] }:$Vm, DPR:{ *:[v4i16] }:$Vn)  =>  (VQRSHLsv4i16:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vm, DPR:{ *:[v4i16] }:$Vn)
     /*  57516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQRSHLsv4i16),
     /*  57519 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  57521 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  57523 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  57525 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  57528 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  57534 */     GIR_RootConstrainSelectedInstOperands,
     /*  57535 */     // GIR_Coverage, 1432,
     /*  57535 */     GIR_EraseRootFromParent_Done,
     /*  57536 */   // Label 1237: @57536
     /*  57536 */   GIM_Try, /*On fail goto*//*Label 1238*/ GIMT_Encode4(57590), // Rule ID 1433 //
     /*  57541 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  57544 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqrshifts),
     /*  57549 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  57552 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  57555 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  57558 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  57562 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  57566 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  57570 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3824:{ *:[iPTR] }, DPR:{ *:[v2i32] }:$Vm, DPR:{ *:[v2i32] }:$Vn)  =>  (VQRSHLsv2i32:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vm, DPR:{ *:[v2i32] }:$Vn)
     /*  57570 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQRSHLsv2i32),
     /*  57573 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  57575 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  57577 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  57579 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  57582 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  57588 */     GIR_RootConstrainSelectedInstOperands,
     /*  57589 */     // GIR_Coverage, 1433,
     /*  57589 */     GIR_EraseRootFromParent_Done,
     /*  57590 */   // Label 1238: @57590
     /*  57590 */   GIM_Try, /*On fail goto*//*Label 1239*/ GIMT_Encode4(57644), // Rule ID 1434 //
     /*  57595 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  57598 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqrshifts),
     /*  57603 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  57606 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  57609 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  57612 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  57616 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  57620 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  57624 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3824:{ *:[iPTR] }, QPR:{ *:[v8i16] }:$Vm, QPR:{ *:[v8i16] }:$Vn)  =>  (VQRSHLsv8i16:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vm, QPR:{ *:[v8i16] }:$Vn)
     /*  57624 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQRSHLsv8i16),
     /*  57627 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  57629 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  57631 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  57633 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  57636 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  57642 */     GIR_RootConstrainSelectedInstOperands,
     /*  57643 */     // GIR_Coverage, 1434,
     /*  57643 */     GIR_EraseRootFromParent_Done,
     /*  57644 */   // Label 1239: @57644
     /*  57644 */   GIM_Try, /*On fail goto*//*Label 1240*/ GIMT_Encode4(57698), // Rule ID 1435 //
     /*  57649 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  57652 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqrshifts),
     /*  57657 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  57660 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  57663 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  57666 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  57670 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  57674 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  57678 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3824:{ *:[iPTR] }, QPR:{ *:[v4i32] }:$Vm, QPR:{ *:[v4i32] }:$Vn)  =>  (VQRSHLsv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vm, QPR:{ *:[v4i32] }:$Vn)
     /*  57678 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQRSHLsv4i32),
     /*  57681 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  57683 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  57685 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  57687 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  57690 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  57696 */     GIR_RootConstrainSelectedInstOperands,
     /*  57697 */     // GIR_Coverage, 1435,
     /*  57697 */     GIR_EraseRootFromParent_Done,
     /*  57698 */   // Label 1240: @57698
     /*  57698 */   GIM_Try, /*On fail goto*//*Label 1241*/ GIMT_Encode4(57752), // Rule ID 1436 //
     /*  57703 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  57706 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqrshifts),
     /*  57711 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /*  57714 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  57717 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  57720 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  57724 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  57728 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  57732 */     // (intrinsic_wo_chain:{ *:[v8i8] } 3824:{ *:[iPTR] }, DPR:{ *:[v8i8] }:$Vm, DPR:{ *:[v8i8] }:$Vn)  =>  (VQRSHLsv8i8:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vm, DPR:{ *:[v8i8] }:$Vn)
     /*  57732 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQRSHLsv8i8),
     /*  57735 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  57737 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  57739 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  57741 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  57744 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  57750 */     GIR_RootConstrainSelectedInstOperands,
     /*  57751 */     // GIR_Coverage, 1436,
     /*  57751 */     GIR_EraseRootFromParent_Done,
     /*  57752 */   // Label 1241: @57752
     /*  57752 */   GIM_Try, /*On fail goto*//*Label 1242*/ GIMT_Encode4(57806), // Rule ID 1437 //
     /*  57757 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  57760 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqrshifts),
     /*  57765 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  57768 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  57771 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  57774 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  57778 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  57782 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  57786 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3824:{ *:[iPTR] }, QPR:{ *:[v16i8] }:$Vm, QPR:{ *:[v16i8] }:$Vn)  =>  (VQRSHLsv16i8:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vm, QPR:{ *:[v16i8] }:$Vn)
     /*  57786 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQRSHLsv16i8),
     /*  57789 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  57791 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  57793 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  57795 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  57798 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  57804 */     GIR_RootConstrainSelectedInstOperands,
     /*  57805 */     // GIR_Coverage, 1437,
     /*  57805 */     GIR_EraseRootFromParent_Done,
     /*  57806 */   // Label 1242: @57806
     /*  57806 */   GIM_Try, /*On fail goto*//*Label 1243*/ GIMT_Encode4(57860), // Rule ID 1438 //
     /*  57811 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  57814 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqrshifts),
     /*  57819 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  57822 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  57825 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  57828 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  57832 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  57836 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  57840 */     // (intrinsic_wo_chain:{ *:[v1i64] } 3824:{ *:[iPTR] }, DPR:{ *:[v1i64] }:$Vm, DPR:{ *:[v1i64] }:$Vn)  =>  (VQRSHLsv1i64:{ *:[v1i64] } DPR:{ *:[v1i64] }:$Vm, DPR:{ *:[v1i64] }:$Vn)
     /*  57840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQRSHLsv1i64),
     /*  57843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  57845 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  57847 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  57849 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  57852 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  57858 */     GIR_RootConstrainSelectedInstOperands,
     /*  57859 */     // GIR_Coverage, 1438,
     /*  57859 */     GIR_EraseRootFromParent_Done,
     /*  57860 */   // Label 1243: @57860
     /*  57860 */   GIM_Try, /*On fail goto*//*Label 1244*/ GIMT_Encode4(57914), // Rule ID 1439 //
     /*  57865 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  57868 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqrshifts),
     /*  57873 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  57876 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  57879 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  57882 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  57886 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  57890 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  57894 */     // (intrinsic_wo_chain:{ *:[v2i64] } 3824:{ *:[iPTR] }, QPR:{ *:[v2i64] }:$Vm, QPR:{ *:[v2i64] }:$Vn)  =>  (VQRSHLsv2i64:{ *:[v2i64] } QPR:{ *:[v2i64] }:$Vm, QPR:{ *:[v2i64] }:$Vn)
     /*  57894 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQRSHLsv2i64),
     /*  57897 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  57899 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  57901 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  57903 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  57906 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  57912 */     GIR_RootConstrainSelectedInstOperands,
     /*  57913 */     // GIR_Coverage, 1439,
     /*  57913 */     GIR_EraseRootFromParent_Done,
     /*  57914 */   // Label 1244: @57914
     /*  57914 */   GIM_Try, /*On fail goto*//*Label 1245*/ GIMT_Encode4(57968), // Rule ID 1440 //
     /*  57919 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  57922 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqrshiftu),
     /*  57927 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  57930 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  57933 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  57936 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  57940 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  57944 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  57948 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3825:{ *:[iPTR] }, DPR:{ *:[v4i16] }:$Vm, DPR:{ *:[v4i16] }:$Vn)  =>  (VQRSHLuv4i16:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vm, DPR:{ *:[v4i16] }:$Vn)
     /*  57948 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQRSHLuv4i16),
     /*  57951 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  57953 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  57955 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  57957 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  57960 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  57966 */     GIR_RootConstrainSelectedInstOperands,
     /*  57967 */     // GIR_Coverage, 1440,
     /*  57967 */     GIR_EraseRootFromParent_Done,
     /*  57968 */   // Label 1245: @57968
     /*  57968 */   GIM_Try, /*On fail goto*//*Label 1246*/ GIMT_Encode4(58022), // Rule ID 1441 //
     /*  57973 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  57976 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqrshiftu),
     /*  57981 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  57984 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  57987 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  57990 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  57994 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  57998 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  58002 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3825:{ *:[iPTR] }, DPR:{ *:[v2i32] }:$Vm, DPR:{ *:[v2i32] }:$Vn)  =>  (VQRSHLuv2i32:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vm, DPR:{ *:[v2i32] }:$Vn)
     /*  58002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQRSHLuv2i32),
     /*  58005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  58007 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  58009 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  58011 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  58014 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  58020 */     GIR_RootConstrainSelectedInstOperands,
     /*  58021 */     // GIR_Coverage, 1441,
     /*  58021 */     GIR_EraseRootFromParent_Done,
     /*  58022 */   // Label 1246: @58022
     /*  58022 */   GIM_Try, /*On fail goto*//*Label 1247*/ GIMT_Encode4(58076), // Rule ID 1442 //
     /*  58027 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  58030 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqrshiftu),
     /*  58035 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  58038 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  58041 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  58044 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  58048 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  58052 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  58056 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3825:{ *:[iPTR] }, QPR:{ *:[v8i16] }:$Vm, QPR:{ *:[v8i16] }:$Vn)  =>  (VQRSHLuv8i16:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vm, QPR:{ *:[v8i16] }:$Vn)
     /*  58056 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQRSHLuv8i16),
     /*  58059 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  58061 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  58063 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  58065 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  58068 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  58074 */     GIR_RootConstrainSelectedInstOperands,
     /*  58075 */     // GIR_Coverage, 1442,
     /*  58075 */     GIR_EraseRootFromParent_Done,
     /*  58076 */   // Label 1247: @58076
     /*  58076 */   GIM_Try, /*On fail goto*//*Label 1248*/ GIMT_Encode4(58130), // Rule ID 1443 //
     /*  58081 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  58084 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqrshiftu),
     /*  58089 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  58092 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  58095 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  58098 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  58102 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  58106 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  58110 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3825:{ *:[iPTR] }, QPR:{ *:[v4i32] }:$Vm, QPR:{ *:[v4i32] }:$Vn)  =>  (VQRSHLuv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vm, QPR:{ *:[v4i32] }:$Vn)
     /*  58110 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQRSHLuv4i32),
     /*  58113 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  58115 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  58117 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  58119 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  58122 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  58128 */     GIR_RootConstrainSelectedInstOperands,
     /*  58129 */     // GIR_Coverage, 1443,
     /*  58129 */     GIR_EraseRootFromParent_Done,
     /*  58130 */   // Label 1248: @58130
     /*  58130 */   GIM_Try, /*On fail goto*//*Label 1249*/ GIMT_Encode4(58184), // Rule ID 1444 //
     /*  58135 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  58138 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqrshiftu),
     /*  58143 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /*  58146 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  58149 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  58152 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  58156 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  58160 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  58164 */     // (intrinsic_wo_chain:{ *:[v8i8] } 3825:{ *:[iPTR] }, DPR:{ *:[v8i8] }:$Vm, DPR:{ *:[v8i8] }:$Vn)  =>  (VQRSHLuv8i8:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vm, DPR:{ *:[v8i8] }:$Vn)
     /*  58164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQRSHLuv8i8),
     /*  58167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  58169 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  58171 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  58173 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  58176 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  58182 */     GIR_RootConstrainSelectedInstOperands,
     /*  58183 */     // GIR_Coverage, 1444,
     /*  58183 */     GIR_EraseRootFromParent_Done,
     /*  58184 */   // Label 1249: @58184
     /*  58184 */   GIM_Try, /*On fail goto*//*Label 1250*/ GIMT_Encode4(58238), // Rule ID 1445 //
     /*  58189 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  58192 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqrshiftu),
     /*  58197 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  58200 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  58203 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  58206 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  58210 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  58214 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  58218 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3825:{ *:[iPTR] }, QPR:{ *:[v16i8] }:$Vm, QPR:{ *:[v16i8] }:$Vn)  =>  (VQRSHLuv16i8:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vm, QPR:{ *:[v16i8] }:$Vn)
     /*  58218 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQRSHLuv16i8),
     /*  58221 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  58223 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  58225 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  58227 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  58230 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  58236 */     GIR_RootConstrainSelectedInstOperands,
     /*  58237 */     // GIR_Coverage, 1445,
     /*  58237 */     GIR_EraseRootFromParent_Done,
     /*  58238 */   // Label 1250: @58238
     /*  58238 */   GIM_Try, /*On fail goto*//*Label 1251*/ GIMT_Encode4(58292), // Rule ID 1446 //
     /*  58243 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  58246 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqrshiftu),
     /*  58251 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  58254 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  58257 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  58260 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  58264 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  58268 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  58272 */     // (intrinsic_wo_chain:{ *:[v1i64] } 3825:{ *:[iPTR] }, DPR:{ *:[v1i64] }:$Vm, DPR:{ *:[v1i64] }:$Vn)  =>  (VQRSHLuv1i64:{ *:[v1i64] } DPR:{ *:[v1i64] }:$Vm, DPR:{ *:[v1i64] }:$Vn)
     /*  58272 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQRSHLuv1i64),
     /*  58275 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  58277 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  58279 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  58281 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  58284 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  58290 */     GIR_RootConstrainSelectedInstOperands,
     /*  58291 */     // GIR_Coverage, 1446,
     /*  58291 */     GIR_EraseRootFromParent_Done,
     /*  58292 */   // Label 1251: @58292
     /*  58292 */   GIM_Try, /*On fail goto*//*Label 1252*/ GIMT_Encode4(58346), // Rule ID 1447 //
     /*  58297 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  58300 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqrshiftu),
     /*  58305 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  58308 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  58311 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  58314 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  58318 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  58322 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  58326 */     // (intrinsic_wo_chain:{ *:[v2i64] } 3825:{ *:[iPTR] }, QPR:{ *:[v2i64] }:$Vm, QPR:{ *:[v2i64] }:$Vn)  =>  (VQRSHLuv2i64:{ *:[v2i64] } QPR:{ *:[v2i64] }:$Vm, QPR:{ *:[v2i64] }:$Vn)
     /*  58326 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQRSHLuv2i64),
     /*  58329 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  58331 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  58333 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  58335 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  58338 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  58344 */     GIR_RootConstrainSelectedInstOperands,
     /*  58345 */     // GIR_Coverage, 1447,
     /*  58345 */     GIR_EraseRootFromParent_Done,
     /*  58346 */   // Label 1252: @58346
     /*  58346 */   GIM_Try, /*On fail goto*//*Label 1253*/ GIMT_Encode4(58391), // Rule ID 1712 //
     /*  58351 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAES_HasV8),
     /*  58354 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_aesd),
     /*  58359 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  58362 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  58365 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  58368 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  58372 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  58376 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  58380 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3726:{ *:[iPTR] }, QPR:{ *:[v16i8] }:$src, QPR:{ *:[v16i8] }:$Vm)  =>  (AESD:{ *:[v16i8] } QPR:{ *:[v16i8] }:$src, QPR:{ *:[v16i8] }:$Vm)
     /*  58380 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::AESD),
     /*  58383 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  58385 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  58387 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  58389 */     GIR_RootConstrainSelectedInstOperands,
     /*  58390 */     // GIR_Coverage, 1712,
     /*  58390 */     GIR_EraseRootFromParent_Done,
     /*  58391 */   // Label 1253: @58391
     /*  58391 */   GIM_Try, /*On fail goto*//*Label 1254*/ GIMT_Encode4(58436), // Rule ID 1713 //
     /*  58396 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAES_HasV8),
     /*  58399 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_aese),
     /*  58404 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  58407 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  58410 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  58413 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  58417 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  58421 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  58425 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3727:{ *:[iPTR] }, QPR:{ *:[v16i8] }:$src, QPR:{ *:[v16i8] }:$Vm)  =>  (AESE:{ *:[v16i8] } QPR:{ *:[v16i8] }:$src, QPR:{ *:[v16i8] }:$Vm)
     /*  58425 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::AESE),
     /*  58428 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  58430 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  58432 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  58434 */     GIR_RootConstrainSelectedInstOperands,
     /*  58435 */     // GIR_Coverage, 1713,
     /*  58435 */     GIR_EraseRootFromParent_Done,
     /*  58436 */   // Label 1254: @58436
     /*  58436 */   GIM_Try, /*On fail goto*//*Label 1255*/ GIMT_Encode4(58481), // Rule ID 1716 //
     /*  58441 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA2_HasV8),
     /*  58444 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_sha1su1),
     /*  58449 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  58452 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  58455 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  58458 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  58462 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  58466 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  58470 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3740:{ *:[iPTR] }, QPR:{ *:[v4i32] }:$src, QPR:{ *:[v4i32] }:$Vm)  =>  (SHA1SU1:{ *:[v4i32] } QPR:{ *:[v4i32] }:$src, QPR:{ *:[v4i32] }:$Vm)
     /*  58470 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SHA1SU1),
     /*  58473 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  58475 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  58477 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  58479 */     GIR_RootConstrainSelectedInstOperands,
     /*  58480 */     // GIR_Coverage, 1716,
     /*  58480 */     GIR_EraseRootFromParent_Done,
     /*  58481 */   // Label 1255: @58481
     /*  58481 */   GIM_Try, /*On fail goto*//*Label 1256*/ GIMT_Encode4(58526), // Rule ID 1717 //
     /*  58486 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA2_HasV8),
     /*  58489 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_sha256su0),
     /*  58494 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  58497 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  58500 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  58503 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  58507 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  58511 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  58515 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3743:{ *:[iPTR] }, QPR:{ *:[v4i32] }:$src, QPR:{ *:[v4i32] }:$Vm)  =>  (SHA256SU0:{ *:[v4i32] } QPR:{ *:[v4i32] }:$src, QPR:{ *:[v4i32] }:$Vm)
     /*  58515 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SHA256SU0),
     /*  58518 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  58520 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  58522 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  58524 */     GIR_RootConstrainSelectedInstOperands,
     /*  58525 */     // GIR_Coverage, 1717,
     /*  58525 */     GIR_EraseRootFromParent_Done,
     /*  58526 */   // Label 1256: @58526
     /*  58526 */   GIM_Try, /*On fail goto*//*Label 1257*/ GIMT_Encode4(58580), // Rule ID 1726 //
     /*  58531 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_HasV8_1MMainline),
     /*  58534 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_sqrshr),
     /*  58539 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  58542 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  58545 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  58548 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  58552 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  58556 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  58560 */     // (intrinsic_wo_chain:{ *:[i32] } 3589:{ *:[iPTR] }, rGPR:{ *:[i32] }:$RdaSrc, rGPR:{ *:[i32] }:$Rm)  =>  (MVE_SQRSHR:{ *:[i32] } rGPR:{ *:[i32] }:$RdaSrc, rGPR:{ *:[i32] }:$Rm)
     /*  58560 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_SQRSHR),
     /*  58563 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  58565 */     GIR_RootToRootCopy, /*OpIdx*/2, // RdaSrc
     /*  58567 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  58569 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  58572 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  58578 */     GIR_RootConstrainSelectedInstOperands,
     /*  58579 */     // GIR_Coverage, 1726,
     /*  58579 */     GIR_EraseRootFromParent_Done,
     /*  58580 */   // Label 1257: @58580
     /*  58580 */   GIM_Try, /*On fail goto*//*Label 1258*/ GIMT_Encode4(58634), // Rule ID 1727 //
     /*  58585 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_HasV8_1MMainline),
     /*  58588 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_uqrshl),
     /*  58593 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  58596 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  58599 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  58602 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  58606 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  58610 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  58614 */     // (intrinsic_wo_chain:{ *:[i32] } 3596:{ *:[iPTR] }, rGPR:{ *:[i32] }:$RdaSrc, rGPR:{ *:[i32] }:$Rm)  =>  (MVE_UQRSHL:{ *:[i32] } rGPR:{ *:[i32] }:$RdaSrc, rGPR:{ *:[i32] }:$Rm)
     /*  58614 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_UQRSHL),
     /*  58617 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  58619 */     GIR_RootToRootCopy, /*OpIdx*/2, // RdaSrc
     /*  58621 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  58623 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  58626 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  58632 */     GIR_RootConstrainSelectedInstOperands,
     /*  58633 */     // GIR_Coverage, 1727,
     /*  58633 */     GIR_EraseRootFromParent_Done,
     /*  58634 */   // Label 1258: @58634
     /*  58634 */   GIM_Try, /*On fail goto*//*Label 1259*/ GIMT_Encode4(58691), // Rule ID 1850 //
     /*  58639 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*  58642 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_sxtab16),
     /*  58647 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  58650 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  58653 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  58656 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  58660 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  58664 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  58668 */     // (intrinsic_wo_chain:{ *:[i32] } 3921:{ *:[iPTR] }, GPR:{ *:[i32] }:$LHS, GPR:{ *:[i32] }:$RHS)  =>  (SXTAB16:{ *:[i32] } GPR:{ *:[i32] }:$LHS, GPR:{ *:[i32] }:$RHS, 0:{ *:[i32] })
     /*  58668 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SXTAB16),
     /*  58671 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  58673 */     GIR_RootToRootCopy, /*OpIdx*/2, // LHS
     /*  58675 */     GIR_RootToRootCopy, /*OpIdx*/3, // RHS
     /*  58677 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  58680 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  58683 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  58689 */     GIR_RootConstrainSelectedInstOperands,
     /*  58690 */     // GIR_Coverage, 1850,
     /*  58690 */     GIR_EraseRootFromParent_Done,
     /*  58691 */   // Label 1259: @58691
     /*  58691 */   GIM_Try, /*On fail goto*//*Label 1260*/ GIMT_Encode4(58748), // Rule ID 1857 //
     /*  58696 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*  58699 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_uxtab16),
     /*  58704 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  58707 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  58710 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  58713 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  58717 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  58721 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  58725 */     // (intrinsic_wo_chain:{ *:[i32] } 3946:{ *:[iPTR] }, GPR:{ *:[i32] }:$LHS, GPR:{ *:[i32] }:$RHS)  =>  (UXTAB16:{ *:[i32] } GPR:{ *:[i32] }:$LHS, GPR:{ *:[i32] }:$RHS, 0:{ *:[i32] })
     /*  58725 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::UXTAB16),
     /*  58728 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  58730 */     GIR_RootToRootCopy, /*OpIdx*/2, // LHS
     /*  58732 */     GIR_RootToRootCopy, /*OpIdx*/3, // RHS
     /*  58734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  58737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  58740 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  58746 */     GIR_RootConstrainSelectedInstOperands,
     /*  58747 */     // GIR_Coverage, 1857,
     /*  58747 */     GIR_EraseRootFromParent_Done,
     /*  58748 */   // Label 1260: @58748
     /*  58748 */   GIM_Try, /*On fail goto*//*Label 1261*/ GIMT_Encode4(58802), // Rule ID 1904 //
     /*  58753 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*  58756 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_smuad),
     /*  58761 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  58764 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  58767 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  58770 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  58774 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  58778 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  58782 */     // (intrinsic_wo_chain:{ *:[i32] } 3897:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (SMUAD:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  58782 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SMUAD),
     /*  58785 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  58787 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  58789 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  58791 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  58794 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  58800 */     GIR_RootConstrainSelectedInstOperands,
     /*  58801 */     // GIR_Coverage, 1904,
     /*  58801 */     GIR_EraseRootFromParent_Done,
     /*  58802 */   // Label 1261: @58802
     /*  58802 */   GIM_Try, /*On fail goto*//*Label 1262*/ GIMT_Encode4(58856), // Rule ID 1905 //
     /*  58807 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*  58810 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_smuadx),
     /*  58815 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  58818 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  58821 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  58824 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  58828 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  58832 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  58836 */     // (intrinsic_wo_chain:{ *:[i32] } 3898:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (SMUADX:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  58836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SMUADX),
     /*  58839 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  58841 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  58843 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  58845 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  58848 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  58854 */     GIR_RootConstrainSelectedInstOperands,
     /*  58855 */     // GIR_Coverage, 1905,
     /*  58855 */     GIR_EraseRootFromParent_Done,
     /*  58856 */   // Label 1262: @58856
     /*  58856 */   GIM_Try, /*On fail goto*//*Label 1263*/ GIMT_Encode4(58910), // Rule ID 1906 //
     /*  58861 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*  58864 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_smusd),
     /*  58869 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  58872 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  58875 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  58878 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  58882 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  58886 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  58890 */     // (intrinsic_wo_chain:{ *:[i32] } 3905:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (SMUSD:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  58890 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SMUSD),
     /*  58893 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  58895 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  58897 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  58899 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  58902 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  58908 */     GIR_RootConstrainSelectedInstOperands,
     /*  58909 */     // GIR_Coverage, 1906,
     /*  58909 */     GIR_EraseRootFromParent_Done,
     /*  58910 */   // Label 1263: @58910
     /*  58910 */   GIM_Try, /*On fail goto*//*Label 1264*/ GIMT_Encode4(58964), // Rule ID 1907 //
     /*  58915 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*  58918 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_smusdx),
     /*  58923 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  58926 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  58929 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  58932 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  58936 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  58940 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  58944 */     // (intrinsic_wo_chain:{ *:[i32] } 3906:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (SMUSDX:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  58944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SMUSDX),
     /*  58947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  58949 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  58951 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  58953 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  58956 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  58962 */     GIR_RootConstrainSelectedInstOperands,
     /*  58963 */     // GIR_Coverage, 1907,
     /*  58963 */     GIR_EraseRootFromParent_Done,
     /*  58964 */   // Label 1264: @58964
     /*  58964 */   GIM_Try, /*On fail goto*//*Label 1265*/ GIMT_Encode4(59018), // Rule ID 1981 //
     /*  58969 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV5TE_IsARM),
     /*  58972 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_smulbb),
     /*  58977 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  58980 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  58983 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  58986 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  58990 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  58994 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  58998 */     // (intrinsic_wo_chain:{ *:[i32] } 3899:{ *:[iPTR] }, GPR:{ *:[i32] }:$a, GPR:{ *:[i32] }:$b)  =>  (SMULBB:{ *:[i32] } GPR:{ *:[i32] }:$a, GPR:{ *:[i32] }:$b)
     /*  58998 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SMULBB),
     /*  59001 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  59003 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  59005 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /*  59007 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  59010 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  59016 */     GIR_RootConstrainSelectedInstOperands,
     /*  59017 */     // GIR_Coverage, 1981,
     /*  59017 */     GIR_EraseRootFromParent_Done,
     /*  59018 */   // Label 1265: @59018
     /*  59018 */   GIM_Try, /*On fail goto*//*Label 1266*/ GIMT_Encode4(59072), // Rule ID 1982 //
     /*  59023 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV5TE_IsARM),
     /*  59026 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_smulbt),
     /*  59031 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  59034 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  59037 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  59040 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  59044 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  59048 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  59052 */     // (intrinsic_wo_chain:{ *:[i32] } 3900:{ *:[iPTR] }, GPR:{ *:[i32] }:$a, GPR:{ *:[i32] }:$b)  =>  (SMULBT:{ *:[i32] } GPR:{ *:[i32] }:$a, GPR:{ *:[i32] }:$b)
     /*  59052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SMULBT),
     /*  59055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  59057 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  59059 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /*  59061 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  59064 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  59070 */     GIR_RootConstrainSelectedInstOperands,
     /*  59071 */     // GIR_Coverage, 1982,
     /*  59071 */     GIR_EraseRootFromParent_Done,
     /*  59072 */   // Label 1266: @59072
     /*  59072 */   GIM_Try, /*On fail goto*//*Label 1267*/ GIMT_Encode4(59126), // Rule ID 1983 //
     /*  59077 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV5TE_IsARM),
     /*  59080 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_smultb),
     /*  59085 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  59088 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  59091 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  59094 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  59098 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  59102 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  59106 */     // (intrinsic_wo_chain:{ *:[i32] } 3901:{ *:[iPTR] }, GPR:{ *:[i32] }:$a, GPR:{ *:[i32] }:$b)  =>  (SMULTB:{ *:[i32] } GPR:{ *:[i32] }:$a, GPR:{ *:[i32] }:$b)
     /*  59106 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SMULTB),
     /*  59109 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  59111 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  59113 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /*  59115 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  59118 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  59124 */     GIR_RootConstrainSelectedInstOperands,
     /*  59125 */     // GIR_Coverage, 1983,
     /*  59125 */     GIR_EraseRootFromParent_Done,
     /*  59126 */   // Label 1267: @59126
     /*  59126 */   GIM_Try, /*On fail goto*//*Label 1268*/ GIMT_Encode4(59180), // Rule ID 1984 //
     /*  59131 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV5TE_IsARM),
     /*  59134 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_smultt),
     /*  59139 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  59142 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  59145 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  59148 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  59152 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  59156 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  59160 */     // (intrinsic_wo_chain:{ *:[i32] } 3902:{ *:[iPTR] }, GPR:{ *:[i32] }:$a, GPR:{ *:[i32] }:$b)  =>  (SMULTT:{ *:[i32] } GPR:{ *:[i32] }:$a, GPR:{ *:[i32] }:$b)
     /*  59160 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SMULTT),
     /*  59163 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  59165 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  59167 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /*  59169 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  59172 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  59178 */     GIR_RootConstrainSelectedInstOperands,
     /*  59179 */     // GIR_Coverage, 1984,
     /*  59179 */     GIR_EraseRootFromParent_Done,
     /*  59180 */   // Label 1268: @59180
     /*  59180 */   GIM_Try, /*On fail goto*//*Label 1269*/ GIMT_Encode4(59234), // Rule ID 1985 //
     /*  59185 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV5TE_IsARM),
     /*  59188 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_smulwb),
     /*  59193 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  59196 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  59199 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  59202 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  59206 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  59210 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  59214 */     // (intrinsic_wo_chain:{ *:[i32] } 3903:{ *:[iPTR] }, GPR:{ *:[i32] }:$a, GPR:{ *:[i32] }:$b)  =>  (SMULWB:{ *:[i32] } GPR:{ *:[i32] }:$a, GPR:{ *:[i32] }:$b)
     /*  59214 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SMULWB),
     /*  59217 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  59219 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  59221 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /*  59223 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  59226 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  59232 */     GIR_RootConstrainSelectedInstOperands,
     /*  59233 */     // GIR_Coverage, 1985,
     /*  59233 */     GIR_EraseRootFromParent_Done,
     /*  59234 */   // Label 1269: @59234
     /*  59234 */   GIM_Try, /*On fail goto*//*Label 1270*/ GIMT_Encode4(59288), // Rule ID 1986 //
     /*  59239 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV5TE_IsARM),
     /*  59242 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_smulwt),
     /*  59247 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  59250 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  59253 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  59256 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  59260 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  59264 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  59268 */     // (intrinsic_wo_chain:{ *:[i32] } 3904:{ *:[iPTR] }, GPR:{ *:[i32] }:$a, GPR:{ *:[i32] }:$b)  =>  (SMULWT:{ *:[i32] } GPR:{ *:[i32] }:$a, GPR:{ *:[i32] }:$b)
     /*  59268 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SMULWT),
     /*  59271 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  59273 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  59275 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /*  59277 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  59280 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  59286 */     GIR_RootConstrainSelectedInstOperands,
     /*  59287 */     // GIR_Coverage, 1986,
     /*  59287 */     GIR_EraseRootFromParent_Done,
     /*  59288 */   // Label 1270: @59288
     /*  59288 */   GIM_Try, /*On fail goto*//*Label 1271*/ GIMT_Encode4(59345), // Rule ID 2097 //
     /*  59293 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  59296 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_sxtab16),
     /*  59301 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  59304 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  59307 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  59310 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  59314 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  59318 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  59322 */     // (intrinsic_wo_chain:{ *:[i32] } 3921:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2SXTAB16:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm, 0:{ *:[i32] })
     /*  59322 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SXTAB16),
     /*  59325 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  59327 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  59329 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  59331 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  59334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  59337 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  59343 */     GIR_RootConstrainSelectedInstOperands,
     /*  59344 */     // GIR_Coverage, 2097,
     /*  59344 */     GIR_EraseRootFromParent_Done,
     /*  59345 */   // Label 1271: @59345
     /*  59345 */   GIM_Try, /*On fail goto*//*Label 1272*/ GIMT_Encode4(59399), // Rule ID 2127 //
     /*  59350 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  59353 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_qadd),
     /*  59358 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  59361 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  59364 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  59367 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  59371 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  59375 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  59379 */     // (intrinsic_wo_chain:{ *:[i32] } 3864:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rm, rGPR:{ *:[i32] }:$Rn)  =>  (t2QADD:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, rGPR:{ *:[i32] }:$Rn)
     /*  59379 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2QADD),
     /*  59382 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  59384 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /*  59386 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /*  59388 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  59391 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  59397 */     GIR_RootConstrainSelectedInstOperands,
     /*  59398 */     // GIR_Coverage, 2127,
     /*  59398 */     GIR_EraseRootFromParent_Done,
     /*  59399 */   // Label 1272: @59399
     /*  59399 */   GIM_Try, /*On fail goto*//*Label 1273*/ GIMT_Encode4(59453), // Rule ID 2128 //
     /*  59404 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  59407 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_qsub),
     /*  59412 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  59415 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  59418 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  59421 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  59425 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  59429 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  59433 */     // (intrinsic_wo_chain:{ *:[i32] } 3869:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rm, rGPR:{ *:[i32] }:$Rn)  =>  (t2QSUB:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, rGPR:{ *:[i32] }:$Rn)
     /*  59433 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2QSUB),
     /*  59436 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  59438 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /*  59440 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /*  59442 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  59445 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  59451 */     GIR_RootConstrainSelectedInstOperands,
     /*  59452 */     // GIR_Coverage, 2128,
     /*  59452 */     GIR_EraseRootFromParent_Done,
     /*  59453 */   // Label 1273: @59453
     /*  59453 */   GIM_Try, /*On fail goto*//*Label 1274*/ GIMT_Encode4(59507), // Rule ID 2168 //
     /*  59458 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  59461 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_smulbb),
     /*  59466 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  59469 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  59472 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  59475 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  59479 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  59483 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  59487 */     // (intrinsic_wo_chain:{ *:[i32] } 3899:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2SMULBB:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  59487 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SMULBB),
     /*  59490 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  59492 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  59494 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  59496 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  59499 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  59505 */     GIR_RootConstrainSelectedInstOperands,
     /*  59506 */     // GIR_Coverage, 2168,
     /*  59506 */     GIR_EraseRootFromParent_Done,
     /*  59507 */   // Label 1274: @59507
     /*  59507 */   GIM_Try, /*On fail goto*//*Label 1275*/ GIMT_Encode4(59561), // Rule ID 2169 //
     /*  59512 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  59515 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_smulbt),
     /*  59520 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  59523 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  59526 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  59529 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  59533 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  59537 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  59541 */     // (intrinsic_wo_chain:{ *:[i32] } 3900:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2SMULBT:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  59541 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SMULBT),
     /*  59544 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  59546 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  59548 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  59550 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  59553 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  59559 */     GIR_RootConstrainSelectedInstOperands,
     /*  59560 */     // GIR_Coverage, 2169,
     /*  59560 */     GIR_EraseRootFromParent_Done,
     /*  59561 */   // Label 1275: @59561
     /*  59561 */   GIM_Try, /*On fail goto*//*Label 1276*/ GIMT_Encode4(59615), // Rule ID 2170 //
     /*  59566 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  59569 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_smultb),
     /*  59574 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  59577 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  59580 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  59583 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  59587 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  59591 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  59595 */     // (intrinsic_wo_chain:{ *:[i32] } 3901:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2SMULTB:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  59595 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SMULTB),
     /*  59598 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  59600 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  59602 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  59604 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  59607 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  59613 */     GIR_RootConstrainSelectedInstOperands,
     /*  59614 */     // GIR_Coverage, 2170,
     /*  59614 */     GIR_EraseRootFromParent_Done,
     /*  59615 */   // Label 1276: @59615
     /*  59615 */   GIM_Try, /*On fail goto*//*Label 1277*/ GIMT_Encode4(59669), // Rule ID 2171 //
     /*  59620 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  59623 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_smultt),
     /*  59628 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  59631 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  59634 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  59637 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  59641 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  59645 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  59649 */     // (intrinsic_wo_chain:{ *:[i32] } 3902:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2SMULTT:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  59649 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SMULTT),
     /*  59652 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  59654 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  59656 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  59658 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  59661 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  59667 */     GIR_RootConstrainSelectedInstOperands,
     /*  59668 */     // GIR_Coverage, 2171,
     /*  59668 */     GIR_EraseRootFromParent_Done,
     /*  59669 */   // Label 1277: @59669
     /*  59669 */   GIM_Try, /*On fail goto*//*Label 1278*/ GIMT_Encode4(59723), // Rule ID 2172 //
     /*  59674 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  59677 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_smulwb),
     /*  59682 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  59685 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  59688 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  59691 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  59695 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  59699 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  59703 */     // (intrinsic_wo_chain:{ *:[i32] } 3903:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2SMULWB:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  59703 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SMULWB),
     /*  59706 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  59708 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  59710 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  59712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  59715 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  59721 */     GIR_RootConstrainSelectedInstOperands,
     /*  59722 */     // GIR_Coverage, 2172,
     /*  59722 */     GIR_EraseRootFromParent_Done,
     /*  59723 */   // Label 1278: @59723
     /*  59723 */   GIM_Try, /*On fail goto*//*Label 1279*/ GIMT_Encode4(59777), // Rule ID 2173 //
     /*  59728 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  59731 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_smulwt),
     /*  59736 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  59739 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  59742 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  59745 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  59749 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  59753 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  59757 */     // (intrinsic_wo_chain:{ *:[i32] } 3904:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2SMULWT:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  59757 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SMULWT),
     /*  59760 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  59762 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  59764 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  59766 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  59769 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  59775 */     GIR_RootConstrainSelectedInstOperands,
     /*  59776 */     // GIR_Coverage, 2173,
     /*  59776 */     GIR_EraseRootFromParent_Done,
     /*  59777 */   // Label 1279: @59777
     /*  59777 */   GIM_Try, /*On fail goto*//*Label 1280*/ GIMT_Encode4(59825), // Rule ID 2510 //
     /*  59782 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON_HasV8_3a),
     /*  59785 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcadd_rot90),
     /*  59790 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  59793 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  59796 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  59799 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  59803 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  59807 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  59811 */     // (intrinsic_wo_chain:{ *:[v4f16] } 3757:{ *:[iPTR] }, DPR:{ *:[v4f16] }:$Rn, DPR:{ *:[v4f16] }:$Rm)  =>  (VCADDv4f16:{ *:[v4f16] } DPR:{ *:[v4f16] }:$Rn, DPR:{ *:[v4f16] }:$Rm, 0:{ *:[i32] })
     /*  59811 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCADDv4f16),
     /*  59814 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  59816 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  59818 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  59820 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  59823 */     GIR_RootConstrainSelectedInstOperands,
     /*  59824 */     // GIR_Coverage, 2510,
     /*  59824 */     GIR_EraseRootFromParent_Done,
     /*  59825 */   // Label 1280: @59825
     /*  59825 */   GIM_Try, /*On fail goto*//*Label 1281*/ GIMT_Encode4(59873), // Rule ID 2511 //
     /*  59830 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON_HasV8_3a),
     /*  59833 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcadd_rot270),
     /*  59838 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  59841 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  59844 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  59847 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  59851 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  59855 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  59859 */     // (intrinsic_wo_chain:{ *:[v4f16] } 3756:{ *:[iPTR] }, DPR:{ *:[v4f16] }:$Rn, DPR:{ *:[v4f16] }:$Rm)  =>  (VCADDv4f16:{ *:[v4f16] } DPR:{ *:[v4f16] }:$Rn, DPR:{ *:[v4f16] }:$Rm, 1:{ *:[i32] })
     /*  59859 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCADDv4f16),
     /*  59862 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  59864 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  59866 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  59868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  59871 */     GIR_RootConstrainSelectedInstOperands,
     /*  59872 */     // GIR_Coverage, 2511,
     /*  59872 */     GIR_EraseRootFromParent_Done,
     /*  59873 */   // Label 1281: @59873
     /*  59873 */   GIM_Try, /*On fail goto*//*Label 1282*/ GIMT_Encode4(59921), // Rule ID 2512 //
     /*  59878 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON_HasV8_3a),
     /*  59881 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcadd_rot90),
     /*  59886 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  59889 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  59892 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  59895 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  59899 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  59903 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  59907 */     // (intrinsic_wo_chain:{ *:[v8f16] } 3757:{ *:[iPTR] }, QPR:{ *:[v8f16] }:$Rn, QPR:{ *:[v8f16] }:$Rm)  =>  (VCADDv8f16:{ *:[v8f16] } QPR:{ *:[v8f16] }:$Rn, QPR:{ *:[v8f16] }:$Rm, 0:{ *:[i32] })
     /*  59907 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCADDv8f16),
     /*  59910 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  59912 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  59914 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  59916 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  59919 */     GIR_RootConstrainSelectedInstOperands,
     /*  59920 */     // GIR_Coverage, 2512,
     /*  59920 */     GIR_EraseRootFromParent_Done,
     /*  59921 */   // Label 1282: @59921
     /*  59921 */   GIM_Try, /*On fail goto*//*Label 1283*/ GIMT_Encode4(59969), // Rule ID 2513 //
     /*  59926 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON_HasV8_3a),
     /*  59929 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcadd_rot270),
     /*  59934 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  59937 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  59940 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  59943 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  59947 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  59951 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  59955 */     // (intrinsic_wo_chain:{ *:[v8f16] } 3756:{ *:[iPTR] }, QPR:{ *:[v8f16] }:$Rn, QPR:{ *:[v8f16] }:$Rm)  =>  (VCADDv8f16:{ *:[v8f16] } QPR:{ *:[v8f16] }:$Rn, QPR:{ *:[v8f16] }:$Rm, 1:{ *:[i32] })
     /*  59955 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCADDv8f16),
     /*  59958 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  59960 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  59962 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  59964 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  59967 */     GIR_RootConstrainSelectedInstOperands,
     /*  59968 */     // GIR_Coverage, 2513,
     /*  59968 */     GIR_EraseRootFromParent_Done,
     /*  59969 */   // Label 1283: @59969
     /*  59969 */   GIM_Try, /*On fail goto*//*Label 1284*/ GIMT_Encode4(60017), // Rule ID 2514 //
     /*  59974 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasV8_3a),
     /*  59977 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcadd_rot90),
     /*  59982 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  59985 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  59988 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  59991 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  59995 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  59999 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  60003 */     // (intrinsic_wo_chain:{ *:[v2f32] } 3757:{ *:[iPTR] }, DPR:{ *:[v2f32] }:$Rn, DPR:{ *:[v2f32] }:$Rm)  =>  (VCADDv2f32:{ *:[v2f32] } DPR:{ *:[v2f32] }:$Rn, DPR:{ *:[v2f32] }:$Rm, 0:{ *:[i32] })
     /*  60003 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCADDv2f32),
     /*  60006 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  60008 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  60010 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  60012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  60015 */     GIR_RootConstrainSelectedInstOperands,
     /*  60016 */     // GIR_Coverage, 2514,
     /*  60016 */     GIR_EraseRootFromParent_Done,
     /*  60017 */   // Label 1284: @60017
     /*  60017 */   GIM_Try, /*On fail goto*//*Label 1285*/ GIMT_Encode4(60065), // Rule ID 2515 //
     /*  60022 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasV8_3a),
     /*  60025 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcadd_rot270),
     /*  60030 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  60033 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  60036 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  60039 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  60043 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  60047 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  60051 */     // (intrinsic_wo_chain:{ *:[v2f32] } 3756:{ *:[iPTR] }, DPR:{ *:[v2f32] }:$Rn, DPR:{ *:[v2f32] }:$Rm)  =>  (VCADDv2f32:{ *:[v2f32] } DPR:{ *:[v2f32] }:$Rn, DPR:{ *:[v2f32] }:$Rm, 1:{ *:[i32] })
     /*  60051 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCADDv2f32),
     /*  60054 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  60056 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  60058 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  60060 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  60063 */     GIR_RootConstrainSelectedInstOperands,
     /*  60064 */     // GIR_Coverage, 2515,
     /*  60064 */     GIR_EraseRootFromParent_Done,
     /*  60065 */   // Label 1285: @60065
     /*  60065 */   GIM_Try, /*On fail goto*//*Label 1286*/ GIMT_Encode4(60113), // Rule ID 2516 //
     /*  60070 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasV8_3a),
     /*  60073 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcadd_rot90),
     /*  60078 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  60081 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  60084 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  60087 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  60091 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  60095 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  60099 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3757:{ *:[iPTR] }, QPR:{ *:[v4f32] }:$Rn, QPR:{ *:[v4f32] }:$Rm)  =>  (VCADDv4f32:{ *:[v4f32] } QPR:{ *:[v4f32] }:$Rn, QPR:{ *:[v4f32] }:$Rm, 0:{ *:[i32] })
     /*  60099 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCADDv4f32),
     /*  60102 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  60104 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  60106 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  60108 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  60111 */     GIR_RootConstrainSelectedInstOperands,
     /*  60112 */     // GIR_Coverage, 2516,
     /*  60112 */     GIR_EraseRootFromParent_Done,
     /*  60113 */   // Label 1286: @60113
     /*  60113 */   GIM_Try, /*On fail goto*//*Label 1287*/ GIMT_Encode4(60161), // Rule ID 2517 //
     /*  60118 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasV8_3a),
     /*  60121 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcadd_rot270),
     /*  60126 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  60129 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  60132 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  60135 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  60139 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  60143 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  60147 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3756:{ *:[iPTR] }, QPR:{ *:[v4f32] }:$Rn, QPR:{ *:[v4f32] }:$Rm)  =>  (VCADDv4f32:{ *:[v4f32] } QPR:{ *:[v4f32] }:$Rn, QPR:{ *:[v4f32] }:$Rm, 1:{ *:[i32] })
     /*  60147 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCADDv4f32),
     /*  60150 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  60152 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  60154 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  60156 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  60159 */     GIR_RootConstrainSelectedInstOperands,
     /*  60160 */     // GIR_Coverage, 2517,
     /*  60160 */     GIR_EraseRootFromParent_Done,
     /*  60161 */   // Label 1287: @60161
     /*  60161 */   GIM_Try, /*On fail goto*//*Label 1288*/ GIMT_Encode4(60266), // Rule ID 3102 //
     /*  60166 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  60169 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_minnmv),
     /*  60174 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  60177 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  60180 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  60183 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /*  60187 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /*  60191 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  60195 */     // (intrinsic_wo_chain:{ *:[f32] } 3565:{ *:[iPTR] }, SPR:{ *:[f32] }:$prev, MQPR:{ *:[v4f32] }:$vec)  =>  (COPY_TO_REGCLASS:{ *:[f32] } (MVE_VMINNMVf32:{ *:[i32] } (COPY_TO_REGCLASS:{ *:[i32] } SPR:{ *:[f32] }:$prev, rGPR:{ *:[i32] }), MQPR:{ *:[v4f32] }:$vec), SPR:{ *:[i32] })
     /*  60195 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  60198 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  60202 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  60207 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // prev
     /*  60211 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(ARM::rGPRRegClassID),
     /*  60216 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  60219 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::MVE_VMINNMVf32),
     /*  60223 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  60228 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  60231 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vec
     /*  60235 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /*  60238 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  60244 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  60250 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  60252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  60255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  60257 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  60260 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::SPRRegClassID),
     /*  60265 */     // GIR_Coverage, 3102,
     /*  60265 */     GIR_EraseRootFromParent_Done,
     /*  60266 */   // Label 1288: @60266
     /*  60266 */   GIM_Try, /*On fail goto*//*Label 1289*/ GIMT_Encode4(60371), // Rule ID 3104 //
     /*  60271 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  60274 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_minnmv),
     /*  60279 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /*  60282 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /*  60285 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  60288 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /*  60292 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /*  60296 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  60300 */     // (intrinsic_wo_chain:{ *:[f16] } 3565:{ *:[iPTR] }, HPR:{ *:[f16] }:$prev, MQPR:{ *:[v8f16] }:$vec)  =>  (COPY_TO_REGCLASS:{ *:[f16] } (MVE_VMINNMVf16:{ *:[i32] } (COPY_TO_REGCLASS:{ *:[i32] } HPR:{ *:[f16] }:$prev, rGPR:{ *:[i32] }), MQPR:{ *:[v8f16] }:$vec), HPR:{ *:[i32] })
     /*  60300 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  60303 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  60307 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  60312 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // prev
     /*  60316 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(ARM::rGPRRegClassID),
     /*  60321 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  60324 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::MVE_VMINNMVf16),
     /*  60328 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  60333 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  60336 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vec
     /*  60340 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /*  60343 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  60349 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  60355 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  60357 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  60360 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  60362 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  60365 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::HPRRegClassID),
     /*  60370 */     // GIR_Coverage, 3104,
     /*  60370 */     GIR_EraseRootFromParent_Done,
     /*  60371 */   // Label 1289: @60371
     /*  60371 */   GIM_Try, /*On fail goto*//*Label 1290*/ GIMT_Encode4(60476), // Rule ID 3106 //
     /*  60376 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  60379 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_maxnmv),
     /*  60384 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  60387 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  60390 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  60393 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /*  60397 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /*  60401 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  60405 */     // (intrinsic_wo_chain:{ *:[f32] } 3556:{ *:[iPTR] }, SPR:{ *:[f32] }:$prev, MQPR:{ *:[v4f32] }:$vec)  =>  (COPY_TO_REGCLASS:{ *:[f32] } (MVE_VMAXNMVf32:{ *:[i32] } (COPY_TO_REGCLASS:{ *:[i32] } SPR:{ *:[f32] }:$prev, rGPR:{ *:[i32] }), MQPR:{ *:[v4f32] }:$vec), SPR:{ *:[i32] })
     /*  60405 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  60408 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  60412 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  60417 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // prev
     /*  60421 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(ARM::rGPRRegClassID),
     /*  60426 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  60429 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::MVE_VMAXNMVf32),
     /*  60433 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  60438 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  60441 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vec
     /*  60445 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /*  60448 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  60454 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  60460 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  60462 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  60465 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  60467 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  60470 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::SPRRegClassID),
     /*  60475 */     // GIR_Coverage, 3106,
     /*  60475 */     GIR_EraseRootFromParent_Done,
     /*  60476 */   // Label 1290: @60476
     /*  60476 */   GIM_Try, /*On fail goto*//*Label 1291*/ GIMT_Encode4(60581), // Rule ID 3108 //
     /*  60481 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  60484 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_maxnmv),
     /*  60489 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /*  60492 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /*  60495 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  60498 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /*  60502 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /*  60506 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  60510 */     // (intrinsic_wo_chain:{ *:[f16] } 3556:{ *:[iPTR] }, HPR:{ *:[f16] }:$prev, MQPR:{ *:[v8f16] }:$vec)  =>  (COPY_TO_REGCLASS:{ *:[f16] } (MVE_VMAXNMVf16:{ *:[i32] } (COPY_TO_REGCLASS:{ *:[i32] } HPR:{ *:[f16] }:$prev, rGPR:{ *:[i32] }), MQPR:{ *:[v8f16] }:$vec), HPR:{ *:[i32] })
     /*  60510 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  60513 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  60517 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  60522 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // prev
     /*  60526 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(ARM::rGPRRegClassID),
     /*  60531 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  60534 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::MVE_VMAXNMVf16),
     /*  60538 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  60543 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  60546 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vec
     /*  60550 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /*  60553 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  60559 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  60565 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  60567 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  60570 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  60572 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  60575 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::HPRRegClassID),
     /*  60580 */     // GIR_Coverage, 3108,
     /*  60580 */     GIR_EraseRootFromParent_Done,
     /*  60581 */   // Label 1291: @60581
     /*  60581 */   GIM_Try, /*On fail goto*//*Label 1292*/ GIMT_Encode4(60686), // Rule ID 3110 //
     /*  60586 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  60589 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_minnmav),
     /*  60594 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  60597 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  60600 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  60603 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /*  60607 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /*  60611 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  60615 */     // (intrinsic_wo_chain:{ *:[f32] } 3563:{ *:[iPTR] }, SPR:{ *:[f32] }:$prev, MQPR:{ *:[v4f32] }:$vec)  =>  (COPY_TO_REGCLASS:{ *:[f32] } (MVE_VMINNMAVf32:{ *:[i32] } (COPY_TO_REGCLASS:{ *:[i32] } SPR:{ *:[f32] }:$prev, rGPR:{ *:[i32] }), MQPR:{ *:[v4f32] }:$vec), SPR:{ *:[i32] })
     /*  60615 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  60618 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  60622 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  60627 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // prev
     /*  60631 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(ARM::rGPRRegClassID),
     /*  60636 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  60639 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::MVE_VMINNMAVf32),
     /*  60643 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  60648 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  60651 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vec
     /*  60655 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /*  60658 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  60664 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  60670 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  60672 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  60675 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  60677 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  60680 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::SPRRegClassID),
     /*  60685 */     // GIR_Coverage, 3110,
     /*  60685 */     GIR_EraseRootFromParent_Done,
     /*  60686 */   // Label 1292: @60686
     /*  60686 */   GIM_Try, /*On fail goto*//*Label 1293*/ GIMT_Encode4(60791), // Rule ID 3112 //
     /*  60691 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  60694 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_minnmav),
     /*  60699 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /*  60702 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /*  60705 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  60708 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /*  60712 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /*  60716 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  60720 */     // (intrinsic_wo_chain:{ *:[f16] } 3563:{ *:[iPTR] }, HPR:{ *:[f16] }:$prev, MQPR:{ *:[v8f16] }:$vec)  =>  (COPY_TO_REGCLASS:{ *:[f16] } (MVE_VMINNMAVf16:{ *:[i32] } (COPY_TO_REGCLASS:{ *:[i32] } HPR:{ *:[f16] }:$prev, rGPR:{ *:[i32] }), MQPR:{ *:[v8f16] }:$vec), HPR:{ *:[i32] })
     /*  60720 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  60723 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  60727 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  60732 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // prev
     /*  60736 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(ARM::rGPRRegClassID),
     /*  60741 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  60744 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::MVE_VMINNMAVf16),
     /*  60748 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  60753 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  60756 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vec
     /*  60760 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /*  60763 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  60769 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  60775 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  60777 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  60780 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  60782 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  60785 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::HPRRegClassID),
     /*  60790 */     // GIR_Coverage, 3112,
     /*  60790 */     GIR_EraseRootFromParent_Done,
     /*  60791 */   // Label 1293: @60791
     /*  60791 */   GIM_Try, /*On fail goto*//*Label 1294*/ GIMT_Encode4(60896), // Rule ID 3114 //
     /*  60796 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  60799 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_maxnmav),
     /*  60804 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  60807 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  60810 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  60813 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /*  60817 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /*  60821 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  60825 */     // (intrinsic_wo_chain:{ *:[f32] } 3554:{ *:[iPTR] }, SPR:{ *:[f32] }:$prev, MQPR:{ *:[v4f32] }:$vec)  =>  (COPY_TO_REGCLASS:{ *:[f32] } (MVE_VMAXNMAVf32:{ *:[i32] } (COPY_TO_REGCLASS:{ *:[i32] } SPR:{ *:[f32] }:$prev, rGPR:{ *:[i32] }), MQPR:{ *:[v4f32] }:$vec), SPR:{ *:[i32] })
     /*  60825 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  60828 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  60832 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  60837 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // prev
     /*  60841 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(ARM::rGPRRegClassID),
     /*  60846 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  60849 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::MVE_VMAXNMAVf32),
     /*  60853 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  60858 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  60861 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vec
     /*  60865 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /*  60868 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  60874 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  60880 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  60882 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  60885 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  60887 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  60890 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::SPRRegClassID),
     /*  60895 */     // GIR_Coverage, 3114,
     /*  60895 */     GIR_EraseRootFromParent_Done,
     /*  60896 */   // Label 1294: @60896
     /*  60896 */   GIM_Try, /*On fail goto*//*Label 1295*/ GIMT_Encode4(61001), // Rule ID 3116 //
     /*  60901 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  60904 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_maxnmav),
     /*  60909 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /*  60912 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /*  60915 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  60918 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /*  60922 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /*  60926 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  60930 */     // (intrinsic_wo_chain:{ *:[f16] } 3554:{ *:[iPTR] }, HPR:{ *:[f16] }:$prev, MQPR:{ *:[v8f16] }:$vec)  =>  (COPY_TO_REGCLASS:{ *:[f16] } (MVE_VMAXNMAVf16:{ *:[i32] } (COPY_TO_REGCLASS:{ *:[i32] } HPR:{ *:[f16] }:$prev, rGPR:{ *:[i32] }), MQPR:{ *:[v8f16] }:$vec), HPR:{ *:[i32] })
     /*  60930 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  60933 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  60937 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  60942 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // prev
     /*  60946 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(ARM::rGPRRegClassID),
     /*  60951 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  60954 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::MVE_VMAXNMAVf16),
     /*  60958 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  60963 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  60966 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vec
     /*  60970 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /*  60973 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  60979 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  60985 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  60987 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  60990 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  60992 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  60995 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::HPRRegClassID),
     /*  61000 */     // GIR_Coverage, 3116,
     /*  61000 */     GIR_EraseRootFromParent_Done,
     /*  61001 */   // Label 1295: @61001
     /*  61001 */   GIM_Try, /*On fail goto*//*Label 1296*/ GIMT_Encode4(61061), // Rule ID 3166 //
     /*  61006 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  61009 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_minav),
     /*  61014 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  61017 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  61020 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  61023 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  61027 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  61031 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  61035 */     // (intrinsic_wo_chain:{ *:[i32] } 3561:{ *:[iPTR] }, rGPR:{ *:[i32] }:$prev, MQPR:{ *:[v16i8] }:$vec)  =>  (MVE_VMINAVs8:{ *:[i32] } rGPR:{ *:[i32] }:$prev, MQPR:{ *:[v16i8] }:$vec)
     /*  61035 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMINAVs8),
     /*  61038 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  61040 */     GIR_RootToRootCopy, /*OpIdx*/2, // prev
     /*  61042 */     GIR_RootToRootCopy, /*OpIdx*/3, // vec
     /*  61044 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  61047 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  61053 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  61059 */     GIR_RootConstrainSelectedInstOperands,
     /*  61060 */     // GIR_Coverage, 3166,
     /*  61060 */     GIR_EraseRootFromParent_Done,
     /*  61061 */   // Label 1296: @61061
     /*  61061 */   GIM_Try, /*On fail goto*//*Label 1297*/ GIMT_Encode4(61121), // Rule ID 3168 //
     /*  61066 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  61069 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_minav),
     /*  61074 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  61077 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  61080 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  61083 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  61087 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  61091 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  61095 */     // (intrinsic_wo_chain:{ *:[i32] } 3561:{ *:[iPTR] }, rGPR:{ *:[i32] }:$prev, MQPR:{ *:[v8i16] }:$vec)  =>  (MVE_VMINAVs16:{ *:[i32] } rGPR:{ *:[i32] }:$prev, MQPR:{ *:[v8i16] }:$vec)
     /*  61095 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMINAVs16),
     /*  61098 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  61100 */     GIR_RootToRootCopy, /*OpIdx*/2, // prev
     /*  61102 */     GIR_RootToRootCopy, /*OpIdx*/3, // vec
     /*  61104 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  61107 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  61113 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  61119 */     GIR_RootConstrainSelectedInstOperands,
     /*  61120 */     // GIR_Coverage, 3168,
     /*  61120 */     GIR_EraseRootFromParent_Done,
     /*  61121 */   // Label 1297: @61121
     /*  61121 */   GIM_Try, /*On fail goto*//*Label 1298*/ GIMT_Encode4(61181), // Rule ID 3170 //
     /*  61126 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  61129 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_minav),
     /*  61134 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  61137 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  61140 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  61143 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  61147 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  61151 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  61155 */     // (intrinsic_wo_chain:{ *:[i32] } 3561:{ *:[iPTR] }, rGPR:{ *:[i32] }:$prev, MQPR:{ *:[v4i32] }:$vec)  =>  (MVE_VMINAVs32:{ *:[i32] } rGPR:{ *:[i32] }:$prev, MQPR:{ *:[v4i32] }:$vec)
     /*  61155 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMINAVs32),
     /*  61158 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  61160 */     GIR_RootToRootCopy, /*OpIdx*/2, // prev
     /*  61162 */     GIR_RootToRootCopy, /*OpIdx*/3, // vec
     /*  61164 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  61167 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  61173 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  61179 */     GIR_RootConstrainSelectedInstOperands,
     /*  61180 */     // GIR_Coverage, 3170,
     /*  61180 */     GIR_EraseRootFromParent_Done,
     /*  61181 */   // Label 1298: @61181
     /*  61181 */   GIM_Try, /*On fail goto*//*Label 1299*/ GIMT_Encode4(61241), // Rule ID 3172 //
     /*  61186 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  61189 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_maxav),
     /*  61194 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  61197 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  61200 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  61203 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  61207 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  61211 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  61215 */     // (intrinsic_wo_chain:{ *:[i32] } 3552:{ *:[iPTR] }, rGPR:{ *:[i32] }:$prev, MQPR:{ *:[v16i8] }:$vec)  =>  (MVE_VMAXAVs8:{ *:[i32] } rGPR:{ *:[i32] }:$prev, MQPR:{ *:[v16i8] }:$vec)
     /*  61215 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMAXAVs8),
     /*  61218 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  61220 */     GIR_RootToRootCopy, /*OpIdx*/2, // prev
     /*  61222 */     GIR_RootToRootCopy, /*OpIdx*/3, // vec
     /*  61224 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  61227 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  61233 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  61239 */     GIR_RootConstrainSelectedInstOperands,
     /*  61240 */     // GIR_Coverage, 3172,
     /*  61240 */     GIR_EraseRootFromParent_Done,
     /*  61241 */   // Label 1299: @61241
     /*  61241 */   GIM_Try, /*On fail goto*//*Label 1300*/ GIMT_Encode4(61301), // Rule ID 3174 //
     /*  61246 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  61249 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_maxav),
     /*  61254 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  61257 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  61260 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  61263 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  61267 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  61271 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  61275 */     // (intrinsic_wo_chain:{ *:[i32] } 3552:{ *:[iPTR] }, rGPR:{ *:[i32] }:$prev, MQPR:{ *:[v8i16] }:$vec)  =>  (MVE_VMAXAVs16:{ *:[i32] } rGPR:{ *:[i32] }:$prev, MQPR:{ *:[v8i16] }:$vec)
     /*  61275 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMAXAVs16),
     /*  61278 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  61280 */     GIR_RootToRootCopy, /*OpIdx*/2, // prev
     /*  61282 */     GIR_RootToRootCopy, /*OpIdx*/3, // vec
     /*  61284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  61287 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  61293 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  61299 */     GIR_RootConstrainSelectedInstOperands,
     /*  61300 */     // GIR_Coverage, 3174,
     /*  61300 */     GIR_EraseRootFromParent_Done,
     /*  61301 */   // Label 1300: @61301
     /*  61301 */   GIM_Try, /*On fail goto*//*Label 1301*/ GIMT_Encode4(61361), // Rule ID 3176 //
     /*  61306 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  61309 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_maxav),
     /*  61314 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  61317 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  61320 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  61323 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  61327 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  61331 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  61335 */     // (intrinsic_wo_chain:{ *:[i32] } 3552:{ *:[iPTR] }, rGPR:{ *:[i32] }:$prev, MQPR:{ *:[v4i32] }:$vec)  =>  (MVE_VMAXAVs32:{ *:[i32] } rGPR:{ *:[i32] }:$prev, MQPR:{ *:[v4i32] }:$vec)
     /*  61335 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMAXAVs32),
     /*  61338 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  61340 */     GIR_RootToRootCopy, /*OpIdx*/2, // prev
     /*  61342 */     GIR_RootToRootCopy, /*OpIdx*/3, // vec
     /*  61344 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  61347 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  61353 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  61359 */     GIR_RootConstrainSelectedInstOperands,
     /*  61360 */     // GIR_Coverage, 3176,
     /*  61360 */     GIR_EraseRootFromParent_Done,
     /*  61361 */   // Label 1301: @61361
     /*  61361 */   GIM_Try, /*On fail goto*//*Label 1302*/ GIMT_Encode4(61436), // Rule ID 3467 //
     /*  61366 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  61369 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqdmulh),
     /*  61374 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  61377 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  61380 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  61383 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  61387 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  61391 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  61395 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3674:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)  =>  (MVE_VQDMULHi8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)
     /*  61395 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  61398 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  61402 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  61407 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQDMULHi8),
     /*  61410 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  61412 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  61414 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  61416 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  61419 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  61425 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  61431 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  61434 */     GIR_RootConstrainSelectedInstOperands,
     /*  61435 */     // GIR_Coverage, 3467,
     /*  61435 */     GIR_EraseRootFromParent_Done,
     /*  61436 */   // Label 1302: @61436
     /*  61436 */   GIM_Try, /*On fail goto*//*Label 1303*/ GIMT_Encode4(61511), // Rule ID 3474 //
     /*  61441 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  61444 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqdmulh),
     /*  61449 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  61452 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  61455 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  61458 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  61462 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  61466 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  61470 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3674:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)  =>  (MVE_VQDMULHi16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)
     /*  61470 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  61473 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  61477 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  61482 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQDMULHi16),
     /*  61485 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  61487 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  61489 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  61491 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  61494 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  61500 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  61506 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  61509 */     GIR_RootConstrainSelectedInstOperands,
     /*  61510 */     // GIR_Coverage, 3474,
     /*  61510 */     GIR_EraseRootFromParent_Done,
     /*  61511 */   // Label 1303: @61511
     /*  61511 */   GIM_Try, /*On fail goto*//*Label 1304*/ GIMT_Encode4(61586), // Rule ID 3478 //
     /*  61516 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  61519 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqdmulh),
     /*  61524 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  61527 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  61530 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  61533 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  61537 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  61541 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  61545 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3674:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)  =>  (MVE_VQDMULHi32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)
     /*  61545 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  61548 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  61552 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  61557 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQDMULHi32),
     /*  61560 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  61562 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  61564 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  61566 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  61569 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  61575 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  61581 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  61584 */     GIR_RootConstrainSelectedInstOperands,
     /*  61585 */     // GIR_Coverage, 3478,
     /*  61585 */     GIR_EraseRootFromParent_Done,
     /*  61586 */   // Label 1304: @61586
     /*  61586 */   GIM_Try, /*On fail goto*//*Label 1305*/ GIMT_Encode4(61661), // Rule ID 3480 //
     /*  61591 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  61594 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqrdmulh),
     /*  61599 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  61602 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  61605 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  61608 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  61612 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  61616 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  61620 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3683:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)  =>  (MVE_VQRDMULHi8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)
     /*  61620 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  61623 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  61627 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  61632 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQRDMULHi8),
     /*  61635 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  61637 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  61639 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  61641 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  61644 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  61650 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  61656 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  61659 */     GIR_RootConstrainSelectedInstOperands,
     /*  61660 */     // GIR_Coverage, 3480,
     /*  61660 */     GIR_EraseRootFromParent_Done,
     /*  61661 */   // Label 1305: @61661
     /*  61661 */   GIM_Try, /*On fail goto*//*Label 1306*/ GIMT_Encode4(61736), // Rule ID 3482 //
     /*  61666 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  61669 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqrdmulh),
     /*  61674 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  61677 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  61680 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  61683 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  61687 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  61691 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  61695 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3683:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)  =>  (MVE_VQRDMULHi16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)
     /*  61695 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  61698 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  61702 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  61707 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQRDMULHi16),
     /*  61710 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  61712 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  61714 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  61716 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  61719 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  61725 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  61731 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  61734 */     GIR_RootConstrainSelectedInstOperands,
     /*  61735 */     // GIR_Coverage, 3482,
     /*  61735 */     GIR_EraseRootFromParent_Done,
     /*  61736 */   // Label 1306: @61736
     /*  61736 */   GIM_Try, /*On fail goto*//*Label 1307*/ GIMT_Encode4(61811), // Rule ID 3484 //
     /*  61741 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  61744 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqrdmulh),
     /*  61749 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  61752 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  61755 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  61758 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  61762 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  61766 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  61770 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3683:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)  =>  (MVE_VQRDMULHi32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)
     /*  61770 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  61773 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  61777 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  61782 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQRDMULHi32),
     /*  61785 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  61787 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  61789 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  61791 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  61794 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  61800 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  61806 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  61809 */     GIR_RootConstrainSelectedInstOperands,
     /*  61810 */     // GIR_Coverage, 3484,
     /*  61810 */     GIR_EraseRootFromParent_Done,
     /*  61811 */   // Label 1307: @61811
     /*  61811 */   GIM_Try, /*On fail goto*//*Label 1308*/ GIMT_Encode4(61886), // Rule ID 4752 //
     /*  61816 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  61819 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vbrsr),
     /*  61824 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  61827 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  61830 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  61833 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  61837 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  61841 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  61845 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3607:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$Qn, rGPR:{ *:[i32] }:$Rm)  =>  (MVE_VBRSR8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qn, rGPR:{ *:[i32] }:$Rm)
     /*  61845 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  61848 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  61852 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  61857 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VBRSR8),
     /*  61860 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  61862 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /*  61864 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  61866 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  61869 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  61875 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  61881 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  61884 */     GIR_RootConstrainSelectedInstOperands,
     /*  61885 */     // GIR_Coverage, 4752,
     /*  61885 */     GIR_EraseRootFromParent_Done,
     /*  61886 */   // Label 1308: @61886
     /*  61886 */   GIM_Try, /*On fail goto*//*Label 1309*/ GIMT_Encode4(61961), // Rule ID 4757 //
     /*  61891 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  61894 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vbrsr),
     /*  61899 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  61902 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  61905 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  61908 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  61912 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  61916 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  61920 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3607:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$Qn, rGPR:{ *:[i32] }:$Rm)  =>  (MVE_VBRSR16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qn, rGPR:{ *:[i32] }:$Rm)
     /*  61920 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  61923 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  61927 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  61932 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VBRSR16),
     /*  61935 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  61937 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /*  61939 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  61941 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  61944 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  61950 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  61956 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  61959 */     GIR_RootConstrainSelectedInstOperands,
     /*  61960 */     // GIR_Coverage, 4757,
     /*  61960 */     GIR_EraseRootFromParent_Done,
     /*  61961 */   // Label 1309: @61961
     /*  61961 */   GIM_Try, /*On fail goto*//*Label 1310*/ GIMT_Encode4(62036), // Rule ID 4759 //
     /*  61966 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  61969 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vbrsr),
     /*  61974 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  61977 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  61980 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  61983 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  61987 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  61991 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  61995 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3607:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$Qn, rGPR:{ *:[i32] }:$Rm)  =>  (MVE_VBRSR32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qn, rGPR:{ *:[i32] }:$Rm)
     /*  61995 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  61998 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  62002 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  62007 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VBRSR32),
     /*  62010 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  62012 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /*  62014 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  62016 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  62019 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  62025 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  62031 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  62034 */     GIR_RootConstrainSelectedInstOperands,
     /*  62035 */     // GIR_Coverage, 4759,
     /*  62035 */     GIR_EraseRootFromParent_Done,
     /*  62036 */   // Label 1310: @62036
     /*  62036 */   GIM_Try, /*On fail goto*//*Label 1311*/ GIMT_Encode4(62111), // Rule ID 4761 //
     /*  62041 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  62044 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vbrsr),
     /*  62049 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  62052 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  62055 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  62058 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  62062 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  62066 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  62070 */     // (intrinsic_wo_chain:{ *:[v8f16] } 3607:{ *:[iPTR] }, MQPR:{ *:[v8f16] }:$Qn, rGPR:{ *:[i32] }:$Rm)  =>  (MVE_VBRSR16:{ *:[v8f16] } MQPR:{ *:[v8f16] }:$Qn, rGPR:{ *:[i32] }:$Rm)
     /*  62070 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  62073 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  62077 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  62082 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VBRSR16),
     /*  62085 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  62087 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /*  62089 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  62091 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  62094 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  62100 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  62106 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  62109 */     GIR_RootConstrainSelectedInstOperands,
     /*  62110 */     // GIR_Coverage, 4761,
     /*  62110 */     GIR_EraseRootFromParent_Done,
     /*  62111 */   // Label 1311: @62111
     /*  62111 */   GIM_Try, /*On fail goto*//*Label 1312*/ GIMT_Encode4(62186), // Rule ID 4763 //
     /*  62116 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  62119 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vbrsr),
     /*  62124 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  62127 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  62130 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  62133 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  62137 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  62141 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  62145 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3607:{ *:[iPTR] }, MQPR:{ *:[v4f32] }:$Qn, rGPR:{ *:[i32] }:$Rm)  =>  (MVE_VBRSR32:{ *:[v4f32] } MQPR:{ *:[v4f32] }:$Qn, rGPR:{ *:[i32] }:$Rm)
     /*  62145 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  62148 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  62152 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  62157 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VBRSR32),
     /*  62160 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  62162 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /*  62164 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  62166 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  62169 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  62175 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  62181 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  62184 */     GIR_RootConstrainSelectedInstOperands,
     /*  62185 */     // GIR_Coverage, 4763,
     /*  62185 */     GIR_EraseRootFromParent_Done,
     /*  62186 */   // Label 1312: @62186
     /*  62186 */   GIM_Reject,
     /*  62187 */ // Label 957: @62187
     /*  62187 */ GIM_Try, /*On fail goto*//*Label 1313*/ GIMT_Encode4(73110),
     /*  62192 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/5,
     /*  62195 */   GIM_Try, /*On fail goto*//*Label 1314*/ GIMT_Encode4(62285), // Rule ID 3913 //
     /*  62200 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqshl_imm),
     /*  62205 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  62208 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  62211 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  62214 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  62217 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  62221 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  62225 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  62229 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  62233 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_7),
     /*  62237 */     // MIs[1] Operand 1
     /*  62237 */     // No operand predicates
     /*  62237 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  62241 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  62243 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3684:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$src, (imm:{ *:[i32] })<<P:Predicate_imm0_7>>:$imm, 0:{ *:[i32] })  =>  (MVE_VQSHLimms8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$src, (imm:{ *:[i32] })<<P:Predicate_imm0_7>>:$imm)
     /*  62243 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  62246 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  62250 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  62255 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQSHLimms8),
     /*  62258 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  62260 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  62262 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  62265 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  62268 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  62274 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  62280 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  62283 */     GIR_RootConstrainSelectedInstOperands,
     /*  62284 */     // GIR_Coverage, 3913,
     /*  62284 */     GIR_EraseRootFromParent_Done,
     /*  62285 */   // Label 1314: @62285
     /*  62285 */   GIM_Try, /*On fail goto*//*Label 1315*/ GIMT_Encode4(62375), // Rule ID 3915 //
     /*  62290 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqshl_imm),
     /*  62295 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  62298 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  62301 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  62304 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  62307 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  62311 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  62315 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  62319 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  62323 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_7),
     /*  62327 */     // MIs[1] Operand 1
     /*  62327 */     // No operand predicates
     /*  62327 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  62331 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  62333 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3684:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$src, (imm:{ *:[i32] })<<P:Predicate_imm0_7>>:$imm, 1:{ *:[i32] })  =>  (MVE_VQSHLimmu8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$src, (imm:{ *:[i32] })<<P:Predicate_imm0_7>>:$imm)
     /*  62333 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  62336 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  62340 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  62345 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQSHLimmu8),
     /*  62348 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  62350 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  62352 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  62355 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  62358 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  62364 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  62370 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  62373 */     GIR_RootConstrainSelectedInstOperands,
     /*  62374 */     // GIR_Coverage, 3915,
     /*  62374 */     GIR_EraseRootFromParent_Done,
     /*  62375 */   // Label 1315: @62375
     /*  62375 */   GIM_Try, /*On fail goto*//*Label 1316*/ GIMT_Encode4(62465), // Rule ID 3917 //
     /*  62380 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqshl_imm),
     /*  62385 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  62388 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  62391 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  62394 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  62397 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  62401 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  62405 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  62409 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  62413 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_15),
     /*  62417 */     // MIs[1] Operand 1
     /*  62417 */     // No operand predicates
     /*  62417 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  62421 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  62423 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3684:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$src, (imm:{ *:[i32] })<<P:Predicate_imm0_15>>:$imm, 0:{ *:[i32] })  =>  (MVE_VQSHLimms16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$src, (imm:{ *:[i32] })<<P:Predicate_imm0_15>>:$imm)
     /*  62423 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  62426 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  62430 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  62435 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQSHLimms16),
     /*  62438 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  62440 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  62442 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  62445 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  62448 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  62454 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  62460 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  62463 */     GIR_RootConstrainSelectedInstOperands,
     /*  62464 */     // GIR_Coverage, 3917,
     /*  62464 */     GIR_EraseRootFromParent_Done,
     /*  62465 */   // Label 1316: @62465
     /*  62465 */   GIM_Try, /*On fail goto*//*Label 1317*/ GIMT_Encode4(62555), // Rule ID 3919 //
     /*  62470 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqshl_imm),
     /*  62475 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  62478 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  62481 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  62484 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  62487 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  62491 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  62495 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  62499 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  62503 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_15),
     /*  62507 */     // MIs[1] Operand 1
     /*  62507 */     // No operand predicates
     /*  62507 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  62511 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  62513 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3684:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$src, (imm:{ *:[i32] })<<P:Predicate_imm0_15>>:$imm, 1:{ *:[i32] })  =>  (MVE_VQSHLimmu16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$src, (imm:{ *:[i32] })<<P:Predicate_imm0_15>>:$imm)
     /*  62513 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  62516 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  62520 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  62525 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQSHLimmu16),
     /*  62528 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  62530 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  62532 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  62535 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  62538 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  62544 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  62550 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  62553 */     GIR_RootConstrainSelectedInstOperands,
     /*  62554 */     // GIR_Coverage, 3919,
     /*  62554 */     GIR_EraseRootFromParent_Done,
     /*  62555 */   // Label 1317: @62555
     /*  62555 */   GIM_Try, /*On fail goto*//*Label 1318*/ GIMT_Encode4(62645), // Rule ID 3921 //
     /*  62560 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqshl_imm),
     /*  62565 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  62568 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  62571 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  62574 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  62577 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  62581 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  62585 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  62589 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  62593 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_31),
     /*  62597 */     // MIs[1] Operand 1
     /*  62597 */     // No operand predicates
     /*  62597 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  62601 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  62603 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3684:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$src, (imm:{ *:[i32] })<<P:Predicate_imm0_31>>:$imm, 0:{ *:[i32] })  =>  (MVE_VQSHLimms32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$src, (imm:{ *:[i32] })<<P:Predicate_imm0_31>>:$imm)
     /*  62603 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  62606 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  62610 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  62615 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQSHLimms32),
     /*  62618 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  62620 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  62622 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  62625 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  62628 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  62634 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  62640 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  62643 */     GIR_RootConstrainSelectedInstOperands,
     /*  62644 */     // GIR_Coverage, 3921,
     /*  62644 */     GIR_EraseRootFromParent_Done,
     /*  62645 */   // Label 1318: @62645
     /*  62645 */   GIM_Try, /*On fail goto*//*Label 1319*/ GIMT_Encode4(62735), // Rule ID 3923 //
     /*  62650 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqshl_imm),
     /*  62655 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  62658 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  62661 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  62664 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  62667 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  62671 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  62675 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  62679 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  62683 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_31),
     /*  62687 */     // MIs[1] Operand 1
     /*  62687 */     // No operand predicates
     /*  62687 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  62691 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  62693 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3684:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$src, (imm:{ *:[i32] })<<P:Predicate_imm0_31>>:$imm, 1:{ *:[i32] })  =>  (MVE_VQSHLimmu32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$src, (imm:{ *:[i32] })<<P:Predicate_imm0_31>>:$imm)
     /*  62693 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  62696 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  62700 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  62705 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQSHLimmu32),
     /*  62708 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  62710 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  62712 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  62715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  62718 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  62724 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  62730 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  62733 */     GIR_RootConstrainSelectedInstOperands,
     /*  62734 */     // GIR_Coverage, 3923,
     /*  62734 */     GIR_EraseRootFromParent_Done,
     /*  62735 */   // Label 1319: @62735
     /*  62735 */   GIM_Try, /*On fail goto*//*Label 1320*/ GIMT_Encode4(62825), // Rule ID 3931 //
     /*  62740 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vrshr_imm),
     /*  62745 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  62748 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  62751 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  62754 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  62757 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  62761 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  62765 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  62769 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  62773 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm8),
     /*  62777 */     // MIs[1] Operand 1
     /*  62777 */     // No operand predicates
     /*  62777 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  62781 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  62783 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3700:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$src, (imm:{ *:[i32] })<<P:Predicate_shr_imm8>>:$imm, 0:{ *:[i32] })  =>  (MVE_VRSHR_imms8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$src, (imm:{ *:[i32] })<<P:Predicate_shr_imm8>>:$imm)
     /*  62783 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  62786 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  62790 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  62795 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRSHR_imms8),
     /*  62798 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  62800 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  62802 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  62805 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  62808 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  62814 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  62820 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  62823 */     GIR_RootConstrainSelectedInstOperands,
     /*  62824 */     // GIR_Coverage, 3931,
     /*  62824 */     GIR_EraseRootFromParent_Done,
     /*  62825 */   // Label 1320: @62825
     /*  62825 */   GIM_Try, /*On fail goto*//*Label 1321*/ GIMT_Encode4(62915), // Rule ID 3933 //
     /*  62830 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vrshr_imm),
     /*  62835 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  62838 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  62841 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  62844 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  62847 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  62851 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  62855 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  62859 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  62863 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm8),
     /*  62867 */     // MIs[1] Operand 1
     /*  62867 */     // No operand predicates
     /*  62867 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  62871 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  62873 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3700:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$src, (imm:{ *:[i32] })<<P:Predicate_shr_imm8>>:$imm, 1:{ *:[i32] })  =>  (MVE_VRSHR_immu8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$src, (imm:{ *:[i32] })<<P:Predicate_shr_imm8>>:$imm)
     /*  62873 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  62876 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  62880 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  62885 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRSHR_immu8),
     /*  62888 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  62890 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  62892 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  62895 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  62898 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  62904 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  62910 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  62913 */     GIR_RootConstrainSelectedInstOperands,
     /*  62914 */     // GIR_Coverage, 3933,
     /*  62914 */     GIR_EraseRootFromParent_Done,
     /*  62915 */   // Label 1321: @62915
     /*  62915 */   GIM_Try, /*On fail goto*//*Label 1322*/ GIMT_Encode4(63005), // Rule ID 3935 //
     /*  62920 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vrshr_imm),
     /*  62925 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  62928 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  62931 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  62934 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  62937 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  62941 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  62945 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  62949 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  62953 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm16),
     /*  62957 */     // MIs[1] Operand 1
     /*  62957 */     // No operand predicates
     /*  62957 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  62961 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  62963 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3700:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$src, (imm:{ *:[i32] })<<P:Predicate_shr_imm16>>:$imm, 0:{ *:[i32] })  =>  (MVE_VRSHR_imms16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$src, (imm:{ *:[i32] })<<P:Predicate_shr_imm16>>:$imm)
     /*  62963 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  62966 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  62970 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  62975 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRSHR_imms16),
     /*  62978 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  62980 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  62982 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  62985 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  62988 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  62994 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  63000 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  63003 */     GIR_RootConstrainSelectedInstOperands,
     /*  63004 */     // GIR_Coverage, 3935,
     /*  63004 */     GIR_EraseRootFromParent_Done,
     /*  63005 */   // Label 1322: @63005
     /*  63005 */   GIM_Try, /*On fail goto*//*Label 1323*/ GIMT_Encode4(63095), // Rule ID 3937 //
     /*  63010 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vrshr_imm),
     /*  63015 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  63018 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  63021 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  63024 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  63027 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  63031 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  63035 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  63039 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  63043 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm16),
     /*  63047 */     // MIs[1] Operand 1
     /*  63047 */     // No operand predicates
     /*  63047 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  63051 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  63053 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3700:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$src, (imm:{ *:[i32] })<<P:Predicate_shr_imm16>>:$imm, 1:{ *:[i32] })  =>  (MVE_VRSHR_immu16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$src, (imm:{ *:[i32] })<<P:Predicate_shr_imm16>>:$imm)
     /*  63053 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  63056 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  63060 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  63065 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRSHR_immu16),
     /*  63068 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  63070 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  63072 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  63075 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  63078 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  63084 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  63090 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  63093 */     GIR_RootConstrainSelectedInstOperands,
     /*  63094 */     // GIR_Coverage, 3937,
     /*  63094 */     GIR_EraseRootFromParent_Done,
     /*  63095 */   // Label 1323: @63095
     /*  63095 */   GIM_Try, /*On fail goto*//*Label 1324*/ GIMT_Encode4(63185), // Rule ID 3939 //
     /*  63100 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vrshr_imm),
     /*  63105 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  63108 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  63111 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  63114 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  63117 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  63121 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  63125 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  63129 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  63133 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm32),
     /*  63137 */     // MIs[1] Operand 1
     /*  63137 */     // No operand predicates
     /*  63137 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  63141 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  63143 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3700:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$src, (imm:{ *:[i32] })<<P:Predicate_shr_imm32>>:$imm, 0:{ *:[i32] })  =>  (MVE_VRSHR_imms32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$src, (imm:{ *:[i32] })<<P:Predicate_shr_imm32>>:$imm)
     /*  63143 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  63146 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  63150 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  63155 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRSHR_imms32),
     /*  63158 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  63160 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  63162 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  63165 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  63168 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  63174 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  63180 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  63183 */     GIR_RootConstrainSelectedInstOperands,
     /*  63184 */     // GIR_Coverage, 3939,
     /*  63184 */     GIR_EraseRootFromParent_Done,
     /*  63185 */   // Label 1324: @63185
     /*  63185 */   GIM_Try, /*On fail goto*//*Label 1325*/ GIMT_Encode4(63275), // Rule ID 3941 //
     /*  63190 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vrshr_imm),
     /*  63195 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  63198 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  63201 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  63204 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  63207 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  63211 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  63215 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  63219 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  63223 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm32),
     /*  63227 */     // MIs[1] Operand 1
     /*  63227 */     // No operand predicates
     /*  63227 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  63231 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  63233 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3700:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$src, (imm:{ *:[i32] })<<P:Predicate_shr_imm32>>:$imm, 1:{ *:[i32] })  =>  (MVE_VRSHR_immu32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$src, (imm:{ *:[i32] })<<P:Predicate_shr_imm32>>:$imm)
     /*  63233 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  63236 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  63240 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  63245 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRSHR_immu32),
     /*  63248 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  63250 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  63252 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  63255 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  63258 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  63264 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  63270 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  63273 */     GIR_RootConstrainSelectedInstOperands,
     /*  63274 */     // GIR_Coverage, 3941,
     /*  63274 */     GIR_EraseRootFromParent_Done,
     /*  63275 */   // Label 1325: @63275
     /*  63275 */   GIM_Try, /*On fail goto*//*Label 1326*/ GIMT_Encode4(63364), // Rule ID 4039 //
     /*  63280 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  63283 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vcvt_fix),
     /*  63288 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  63291 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  63294 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  63297 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  63300 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  63304 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /*  63308 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  63312 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  63316 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  63320 */     // MIs[1] Operand 1
     /*  63320 */     // No operand predicates
     /*  63320 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  63322 */     // (intrinsic_wo_chain:{ *:[v8f16] } 3620:{ *:[iPTR] }, 0:{ *:[i32] }, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] }):$scale)  =>  (MVE_VCVTf16s16_fix:{ *:[v8f16] } MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] }):$scale)
     /*  63322 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  63325 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  63329 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  63334 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCVTf16s16_fix),
     /*  63337 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  63339 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  63341 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // scale
     /*  63344 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  63347 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  63353 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  63359 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  63362 */     GIR_RootConstrainSelectedInstOperands,
     /*  63363 */     // GIR_Coverage, 4039,
     /*  63363 */     GIR_EraseRootFromParent_Done,
     /*  63364 */   // Label 1326: @63364
     /*  63364 */   GIM_Try, /*On fail goto*//*Label 1327*/ GIMT_Encode4(63453), // Rule ID 4041 //
     /*  63369 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  63372 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vcvt_fix),
     /*  63377 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  63380 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  63383 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  63386 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  63389 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  63393 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /*  63397 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  63401 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  63405 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  63409 */     // MIs[1] Operand 1
     /*  63409 */     // No operand predicates
     /*  63409 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  63411 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3620:{ *:[iPTR] }, 0:{ *:[i32] }, MQPR:{ *:[v8f16] }:$Qm, (imm:{ *:[i32] }):$scale)  =>  (MVE_VCVTs16f16_fix:{ *:[v8i16] } MQPR:{ *:[v8f16] }:$Qm, (imm:{ *:[i32] }):$scale)
     /*  63411 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  63414 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  63418 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  63423 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCVTs16f16_fix),
     /*  63426 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  63428 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  63430 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // scale
     /*  63433 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  63436 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  63442 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  63448 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  63451 */     GIR_RootConstrainSelectedInstOperands,
     /*  63452 */     // GIR_Coverage, 4041,
     /*  63452 */     GIR_EraseRootFromParent_Done,
     /*  63453 */   // Label 1327: @63453
     /*  63453 */   GIM_Try, /*On fail goto*//*Label 1328*/ GIMT_Encode4(63542), // Rule ID 4043 //
     /*  63458 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  63461 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vcvt_fix),
     /*  63466 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  63469 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  63472 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  63475 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  63478 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  63482 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 1,
     /*  63486 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  63490 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  63494 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  63498 */     // MIs[1] Operand 1
     /*  63498 */     // No operand predicates
     /*  63498 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  63500 */     // (intrinsic_wo_chain:{ *:[v8f16] } 3620:{ *:[iPTR] }, 1:{ *:[i32] }, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] }):$scale)  =>  (MVE_VCVTf16u16_fix:{ *:[v8f16] } MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] }):$scale)
     /*  63500 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  63503 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  63507 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  63512 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCVTf16u16_fix),
     /*  63515 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  63517 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  63519 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // scale
     /*  63522 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  63525 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  63531 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  63537 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  63540 */     GIR_RootConstrainSelectedInstOperands,
     /*  63541 */     // GIR_Coverage, 4043,
     /*  63541 */     GIR_EraseRootFromParent_Done,
     /*  63542 */   // Label 1328: @63542
     /*  63542 */   GIM_Try, /*On fail goto*//*Label 1329*/ GIMT_Encode4(63631), // Rule ID 4045 //
     /*  63547 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  63550 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vcvt_fix),
     /*  63555 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  63558 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  63561 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  63564 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  63567 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  63571 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 1,
     /*  63575 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  63579 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  63583 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  63587 */     // MIs[1] Operand 1
     /*  63587 */     // No operand predicates
     /*  63587 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  63589 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3620:{ *:[iPTR] }, 1:{ *:[i32] }, MQPR:{ *:[v8f16] }:$Qm, (imm:{ *:[i32] }):$scale)  =>  (MVE_VCVTu16f16_fix:{ *:[v8i16] } MQPR:{ *:[v8f16] }:$Qm, (imm:{ *:[i32] }):$scale)
     /*  63589 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  63592 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  63596 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  63601 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCVTu16f16_fix),
     /*  63604 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  63606 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  63608 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // scale
     /*  63611 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  63614 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  63620 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  63626 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  63629 */     GIR_RootConstrainSelectedInstOperands,
     /*  63630 */     // GIR_Coverage, 4045,
     /*  63630 */     GIR_EraseRootFromParent_Done,
     /*  63631 */   // Label 1329: @63631
     /*  63631 */   GIM_Try, /*On fail goto*//*Label 1330*/ GIMT_Encode4(63720), // Rule ID 4047 //
     /*  63636 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  63639 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vcvt_fix),
     /*  63644 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  63647 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  63650 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  63653 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  63656 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  63660 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /*  63664 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  63668 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  63672 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  63676 */     // MIs[1] Operand 1
     /*  63676 */     // No operand predicates
     /*  63676 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  63678 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3620:{ *:[iPTR] }, 0:{ *:[i32] }, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] }):$scale)  =>  (MVE_VCVTf32s32_fix:{ *:[v4f32] } MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] }):$scale)
     /*  63678 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  63681 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  63685 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  63690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCVTf32s32_fix),
     /*  63693 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  63695 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  63697 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // scale
     /*  63700 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  63703 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  63709 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  63715 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  63718 */     GIR_RootConstrainSelectedInstOperands,
     /*  63719 */     // GIR_Coverage, 4047,
     /*  63719 */     GIR_EraseRootFromParent_Done,
     /*  63720 */   // Label 1330: @63720
     /*  63720 */   GIM_Try, /*On fail goto*//*Label 1331*/ GIMT_Encode4(63809), // Rule ID 4049 //
     /*  63725 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  63728 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vcvt_fix),
     /*  63733 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  63736 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  63739 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  63742 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  63745 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  63749 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /*  63753 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  63757 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  63761 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  63765 */     // MIs[1] Operand 1
     /*  63765 */     // No operand predicates
     /*  63765 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  63767 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3620:{ *:[iPTR] }, 0:{ *:[i32] }, MQPR:{ *:[v4f32] }:$Qm, (imm:{ *:[i32] }):$scale)  =>  (MVE_VCVTs32f32_fix:{ *:[v4i32] } MQPR:{ *:[v4f32] }:$Qm, (imm:{ *:[i32] }):$scale)
     /*  63767 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  63770 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  63774 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  63779 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCVTs32f32_fix),
     /*  63782 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  63784 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  63786 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // scale
     /*  63789 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  63792 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  63798 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  63804 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  63807 */     GIR_RootConstrainSelectedInstOperands,
     /*  63808 */     // GIR_Coverage, 4049,
     /*  63808 */     GIR_EraseRootFromParent_Done,
     /*  63809 */   // Label 1331: @63809
     /*  63809 */   GIM_Try, /*On fail goto*//*Label 1332*/ GIMT_Encode4(63898), // Rule ID 4051 //
     /*  63814 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  63817 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vcvt_fix),
     /*  63822 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  63825 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  63828 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  63831 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  63834 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  63838 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 1,
     /*  63842 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  63846 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  63850 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  63854 */     // MIs[1] Operand 1
     /*  63854 */     // No operand predicates
     /*  63854 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  63856 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3620:{ *:[iPTR] }, 1:{ *:[i32] }, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] }):$scale)  =>  (MVE_VCVTf32u32_fix:{ *:[v4f32] } MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] }):$scale)
     /*  63856 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  63859 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  63863 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  63868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCVTf32u32_fix),
     /*  63871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  63873 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  63875 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // scale
     /*  63878 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  63881 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  63887 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  63893 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  63896 */     GIR_RootConstrainSelectedInstOperands,
     /*  63897 */     // GIR_Coverage, 4051,
     /*  63897 */     GIR_EraseRootFromParent_Done,
     /*  63898 */   // Label 1332: @63898
     /*  63898 */   GIM_Try, /*On fail goto*//*Label 1333*/ GIMT_Encode4(63987), // Rule ID 4053 //
     /*  63903 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  63906 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vcvt_fix),
     /*  63911 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  63914 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  63917 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  63920 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  63923 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  63927 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 1,
     /*  63931 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  63935 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  63939 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  63943 */     // MIs[1] Operand 1
     /*  63943 */     // No operand predicates
     /*  63943 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  63945 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3620:{ *:[iPTR] }, 1:{ *:[i32] }, MQPR:{ *:[v4f32] }:$Qm, (imm:{ *:[i32] }):$scale)  =>  (MVE_VCVTu32f32_fix:{ *:[v4i32] } MQPR:{ *:[v4f32] }:$Qm, (imm:{ *:[i32] }):$scale)
     /*  63945 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  63948 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  63952 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  63957 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCVTu32f32_fix),
     /*  63960 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  63962 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  63964 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // scale
     /*  63967 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  63970 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  63976 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  63982 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  63985 */     GIR_RootConstrainSelectedInstOperands,
     /*  63986 */     // GIR_Coverage, 4053,
     /*  63986 */     GIR_EraseRootFromParent_Done,
     /*  63987 */   // Label 1333: @63987
     /*  63987 */   GIM_Try, /*On fail goto*//*Label 1334*/ GIMT_Encode4(64054), // Rule ID 3118 //
     /*  63992 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  63995 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_minv),
     /*  64000 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  64003 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  64006 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  64009 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  64012 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  64016 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  64020 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  64024 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  64028 */     // (intrinsic_wo_chain:{ *:[i32] } 3567:{ *:[iPTR] }, rGPR:{ *:[i32] }:$prev, MQPR:{ *:[v16i8] }:$vec, 0:{ *:[i32] })  =>  (MVE_VMINVs8:{ *:[i32] } rGPR:{ *:[i32] }:$prev, MQPR:{ *:[v16i8] }:$vec)
     /*  64028 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMINVs8),
     /*  64031 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  64033 */     GIR_RootToRootCopy, /*OpIdx*/2, // prev
     /*  64035 */     GIR_RootToRootCopy, /*OpIdx*/3, // vec
     /*  64037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  64040 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  64046 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  64052 */     GIR_RootConstrainSelectedInstOperands,
     /*  64053 */     // GIR_Coverage, 3118,
     /*  64053 */     GIR_EraseRootFromParent_Done,
     /*  64054 */   // Label 1334: @64054
     /*  64054 */   GIM_Try, /*On fail goto*//*Label 1335*/ GIMT_Encode4(64121), // Rule ID 3120 //
     /*  64059 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  64062 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_minv),
     /*  64067 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  64070 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  64073 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  64076 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  64079 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  64083 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  64087 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  64091 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  64095 */     // (intrinsic_wo_chain:{ *:[i32] } 3567:{ *:[iPTR] }, rGPR:{ *:[i32] }:$prev, MQPR:{ *:[v8i16] }:$vec, 0:{ *:[i32] })  =>  (MVE_VMINVs16:{ *:[i32] } rGPR:{ *:[i32] }:$prev, MQPR:{ *:[v8i16] }:$vec)
     /*  64095 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMINVs16),
     /*  64098 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  64100 */     GIR_RootToRootCopy, /*OpIdx*/2, // prev
     /*  64102 */     GIR_RootToRootCopy, /*OpIdx*/3, // vec
     /*  64104 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  64107 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  64113 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  64119 */     GIR_RootConstrainSelectedInstOperands,
     /*  64120 */     // GIR_Coverage, 3120,
     /*  64120 */     GIR_EraseRootFromParent_Done,
     /*  64121 */   // Label 1335: @64121
     /*  64121 */   GIM_Try, /*On fail goto*//*Label 1336*/ GIMT_Encode4(64188), // Rule ID 3122 //
     /*  64126 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  64129 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_minv),
     /*  64134 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  64137 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  64140 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  64143 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  64146 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  64150 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  64154 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  64158 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  64162 */     // (intrinsic_wo_chain:{ *:[i32] } 3567:{ *:[iPTR] }, rGPR:{ *:[i32] }:$prev, MQPR:{ *:[v4i32] }:$vec, 0:{ *:[i32] })  =>  (MVE_VMINVs32:{ *:[i32] } rGPR:{ *:[i32] }:$prev, MQPR:{ *:[v4i32] }:$vec)
     /*  64162 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMINVs32),
     /*  64165 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  64167 */     GIR_RootToRootCopy, /*OpIdx*/2, // prev
     /*  64169 */     GIR_RootToRootCopy, /*OpIdx*/3, // vec
     /*  64171 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  64174 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  64180 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  64186 */     GIR_RootConstrainSelectedInstOperands,
     /*  64187 */     // GIR_Coverage, 3122,
     /*  64187 */     GIR_EraseRootFromParent_Done,
     /*  64188 */   // Label 1336: @64188
     /*  64188 */   GIM_Try, /*On fail goto*//*Label 1337*/ GIMT_Encode4(64255), // Rule ID 3124 //
     /*  64193 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  64196 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_minv),
     /*  64201 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  64204 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  64207 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  64210 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  64213 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  64217 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  64221 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  64225 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  64229 */     // (intrinsic_wo_chain:{ *:[i32] } 3567:{ *:[iPTR] }, rGPR:{ *:[i32] }:$prev, MQPR:{ *:[v16i8] }:$vec, 1:{ *:[i32] })  =>  (MVE_VMINVu8:{ *:[i32] } rGPR:{ *:[i32] }:$prev, MQPR:{ *:[v16i8] }:$vec)
     /*  64229 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMINVu8),
     /*  64232 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  64234 */     GIR_RootToRootCopy, /*OpIdx*/2, // prev
     /*  64236 */     GIR_RootToRootCopy, /*OpIdx*/3, // vec
     /*  64238 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  64241 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  64247 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  64253 */     GIR_RootConstrainSelectedInstOperands,
     /*  64254 */     // GIR_Coverage, 3124,
     /*  64254 */     GIR_EraseRootFromParent_Done,
     /*  64255 */   // Label 1337: @64255
     /*  64255 */   GIM_Try, /*On fail goto*//*Label 1338*/ GIMT_Encode4(64322), // Rule ID 3126 //
     /*  64260 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  64263 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_minv),
     /*  64268 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  64271 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  64274 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  64277 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  64280 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  64284 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  64288 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  64292 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  64296 */     // (intrinsic_wo_chain:{ *:[i32] } 3567:{ *:[iPTR] }, rGPR:{ *:[i32] }:$prev, MQPR:{ *:[v8i16] }:$vec, 1:{ *:[i32] })  =>  (MVE_VMINVu16:{ *:[i32] } rGPR:{ *:[i32] }:$prev, MQPR:{ *:[v8i16] }:$vec)
     /*  64296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMINVu16),
     /*  64299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  64301 */     GIR_RootToRootCopy, /*OpIdx*/2, // prev
     /*  64303 */     GIR_RootToRootCopy, /*OpIdx*/3, // vec
     /*  64305 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  64308 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  64314 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  64320 */     GIR_RootConstrainSelectedInstOperands,
     /*  64321 */     // GIR_Coverage, 3126,
     /*  64321 */     GIR_EraseRootFromParent_Done,
     /*  64322 */   // Label 1338: @64322
     /*  64322 */   GIM_Try, /*On fail goto*//*Label 1339*/ GIMT_Encode4(64389), // Rule ID 3128 //
     /*  64327 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  64330 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_minv),
     /*  64335 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  64338 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  64341 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  64344 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  64347 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  64351 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  64355 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  64359 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  64363 */     // (intrinsic_wo_chain:{ *:[i32] } 3567:{ *:[iPTR] }, rGPR:{ *:[i32] }:$prev, MQPR:{ *:[v4i32] }:$vec, 1:{ *:[i32] })  =>  (MVE_VMINVu32:{ *:[i32] } rGPR:{ *:[i32] }:$prev, MQPR:{ *:[v4i32] }:$vec)
     /*  64363 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMINVu32),
     /*  64366 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  64368 */     GIR_RootToRootCopy, /*OpIdx*/2, // prev
     /*  64370 */     GIR_RootToRootCopy, /*OpIdx*/3, // vec
     /*  64372 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  64375 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  64381 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  64387 */     GIR_RootConstrainSelectedInstOperands,
     /*  64388 */     // GIR_Coverage, 3128,
     /*  64388 */     GIR_EraseRootFromParent_Done,
     /*  64389 */   // Label 1339: @64389
     /*  64389 */   GIM_Try, /*On fail goto*//*Label 1340*/ GIMT_Encode4(64456), // Rule ID 3130 //
     /*  64394 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  64397 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_maxv),
     /*  64402 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  64405 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  64408 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  64411 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  64414 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  64418 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  64422 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  64426 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  64430 */     // (intrinsic_wo_chain:{ *:[i32] } 3558:{ *:[iPTR] }, rGPR:{ *:[i32] }:$prev, MQPR:{ *:[v16i8] }:$vec, 0:{ *:[i32] })  =>  (MVE_VMAXVs8:{ *:[i32] } rGPR:{ *:[i32] }:$prev, MQPR:{ *:[v16i8] }:$vec)
     /*  64430 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMAXVs8),
     /*  64433 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  64435 */     GIR_RootToRootCopy, /*OpIdx*/2, // prev
     /*  64437 */     GIR_RootToRootCopy, /*OpIdx*/3, // vec
     /*  64439 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  64442 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  64448 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  64454 */     GIR_RootConstrainSelectedInstOperands,
     /*  64455 */     // GIR_Coverage, 3130,
     /*  64455 */     GIR_EraseRootFromParent_Done,
     /*  64456 */   // Label 1340: @64456
     /*  64456 */   GIM_Try, /*On fail goto*//*Label 1341*/ GIMT_Encode4(64523), // Rule ID 3132 //
     /*  64461 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  64464 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_maxv),
     /*  64469 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  64472 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  64475 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  64478 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  64481 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  64485 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  64489 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  64493 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  64497 */     // (intrinsic_wo_chain:{ *:[i32] } 3558:{ *:[iPTR] }, rGPR:{ *:[i32] }:$prev, MQPR:{ *:[v8i16] }:$vec, 0:{ *:[i32] })  =>  (MVE_VMAXVs16:{ *:[i32] } rGPR:{ *:[i32] }:$prev, MQPR:{ *:[v8i16] }:$vec)
     /*  64497 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMAXVs16),
     /*  64500 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  64502 */     GIR_RootToRootCopy, /*OpIdx*/2, // prev
     /*  64504 */     GIR_RootToRootCopy, /*OpIdx*/3, // vec
     /*  64506 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  64509 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  64515 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  64521 */     GIR_RootConstrainSelectedInstOperands,
     /*  64522 */     // GIR_Coverage, 3132,
     /*  64522 */     GIR_EraseRootFromParent_Done,
     /*  64523 */   // Label 1341: @64523
     /*  64523 */   GIM_Try, /*On fail goto*//*Label 1342*/ GIMT_Encode4(64590), // Rule ID 3134 //
     /*  64528 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  64531 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_maxv),
     /*  64536 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  64539 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  64542 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  64545 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  64548 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  64552 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  64556 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  64560 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  64564 */     // (intrinsic_wo_chain:{ *:[i32] } 3558:{ *:[iPTR] }, rGPR:{ *:[i32] }:$prev, MQPR:{ *:[v4i32] }:$vec, 0:{ *:[i32] })  =>  (MVE_VMAXVs32:{ *:[i32] } rGPR:{ *:[i32] }:$prev, MQPR:{ *:[v4i32] }:$vec)
     /*  64564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMAXVs32),
     /*  64567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  64569 */     GIR_RootToRootCopy, /*OpIdx*/2, // prev
     /*  64571 */     GIR_RootToRootCopy, /*OpIdx*/3, // vec
     /*  64573 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  64576 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  64582 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  64588 */     GIR_RootConstrainSelectedInstOperands,
     /*  64589 */     // GIR_Coverage, 3134,
     /*  64589 */     GIR_EraseRootFromParent_Done,
     /*  64590 */   // Label 1342: @64590
     /*  64590 */   GIM_Try, /*On fail goto*//*Label 1343*/ GIMT_Encode4(64657), // Rule ID 3136 //
     /*  64595 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  64598 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_maxv),
     /*  64603 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  64606 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  64609 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  64612 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  64615 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  64619 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  64623 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  64627 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  64631 */     // (intrinsic_wo_chain:{ *:[i32] } 3558:{ *:[iPTR] }, rGPR:{ *:[i32] }:$prev, MQPR:{ *:[v16i8] }:$vec, 1:{ *:[i32] })  =>  (MVE_VMAXVu8:{ *:[i32] } rGPR:{ *:[i32] }:$prev, MQPR:{ *:[v16i8] }:$vec)
     /*  64631 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMAXVu8),
     /*  64634 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  64636 */     GIR_RootToRootCopy, /*OpIdx*/2, // prev
     /*  64638 */     GIR_RootToRootCopy, /*OpIdx*/3, // vec
     /*  64640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  64643 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  64649 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  64655 */     GIR_RootConstrainSelectedInstOperands,
     /*  64656 */     // GIR_Coverage, 3136,
     /*  64656 */     GIR_EraseRootFromParent_Done,
     /*  64657 */   // Label 1343: @64657
     /*  64657 */   GIM_Try, /*On fail goto*//*Label 1344*/ GIMT_Encode4(64724), // Rule ID 3138 //
     /*  64662 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  64665 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_maxv),
     /*  64670 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  64673 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  64676 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  64679 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  64682 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  64686 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  64690 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  64694 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  64698 */     // (intrinsic_wo_chain:{ *:[i32] } 3558:{ *:[iPTR] }, rGPR:{ *:[i32] }:$prev, MQPR:{ *:[v8i16] }:$vec, 1:{ *:[i32] })  =>  (MVE_VMAXVu16:{ *:[i32] } rGPR:{ *:[i32] }:$prev, MQPR:{ *:[v8i16] }:$vec)
     /*  64698 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMAXVu16),
     /*  64701 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  64703 */     GIR_RootToRootCopy, /*OpIdx*/2, // prev
     /*  64705 */     GIR_RootToRootCopy, /*OpIdx*/3, // vec
     /*  64707 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  64710 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  64716 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  64722 */     GIR_RootConstrainSelectedInstOperands,
     /*  64723 */     // GIR_Coverage, 3138,
     /*  64723 */     GIR_EraseRootFromParent_Done,
     /*  64724 */   // Label 1344: @64724
     /*  64724 */   GIM_Try, /*On fail goto*//*Label 1345*/ GIMT_Encode4(64791), // Rule ID 3140 //
     /*  64729 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  64732 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_maxv),
     /*  64737 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  64740 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  64743 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  64746 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  64749 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  64753 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  64757 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  64761 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  64765 */     // (intrinsic_wo_chain:{ *:[i32] } 3558:{ *:[iPTR] }, rGPR:{ *:[i32] }:$prev, MQPR:{ *:[v4i32] }:$vec, 1:{ *:[i32] })  =>  (MVE_VMAXVu32:{ *:[i32] } rGPR:{ *:[i32] }:$prev, MQPR:{ *:[v4i32] }:$vec)
     /*  64765 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMAXVu32),
     /*  64768 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  64770 */     GIR_RootToRootCopy, /*OpIdx*/2, // prev
     /*  64772 */     GIR_RootToRootCopy, /*OpIdx*/3, // vec
     /*  64774 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  64777 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  64783 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  64789 */     GIR_RootConstrainSelectedInstOperands,
     /*  64790 */     // GIR_Coverage, 3140,
     /*  64790 */     GIR_EraseRootFromParent_Done,
     /*  64791 */   // Label 1345: @64791
     /*  64791 */   GIM_Try, /*On fail goto*//*Label 1346*/ GIMT_Encode4(64873), // Rule ID 3545 //
     /*  64796 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  64799 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vabd),
     /*  64804 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  64807 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  64810 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  64813 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  64816 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  64820 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  64824 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  64828 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  64832 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3604:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn, 0:{ *:[i32] })  =>  (MVE_VABDs8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)
     /*  64832 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  64835 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  64839 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  64844 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VABDs8),
     /*  64847 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  64849 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  64851 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  64853 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  64856 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  64862 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  64868 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  64871 */     GIR_RootConstrainSelectedInstOperands,
     /*  64872 */     // GIR_Coverage, 3545,
     /*  64872 */     GIR_EraseRootFromParent_Done,
     /*  64873 */   // Label 1346: @64873
     /*  64873 */   GIM_Try, /*On fail goto*//*Label 1347*/ GIMT_Encode4(64955), // Rule ID 3552 //
     /*  64878 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  64881 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vabd),
     /*  64886 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  64889 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  64892 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  64895 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  64898 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  64902 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  64906 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  64910 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  64914 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3604:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn, 0:{ *:[i32] })  =>  (MVE_VABDs16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)
     /*  64914 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  64917 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  64921 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  64926 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VABDs16),
     /*  64929 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  64931 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  64933 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  64935 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  64938 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  64944 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  64950 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  64953 */     GIR_RootConstrainSelectedInstOperands,
     /*  64954 */     // GIR_Coverage, 3552,
     /*  64954 */     GIR_EraseRootFromParent_Done,
     /*  64955 */   // Label 1347: @64955
     /*  64955 */   GIM_Try, /*On fail goto*//*Label 1348*/ GIMT_Encode4(65037), // Rule ID 3556 //
     /*  64960 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  64963 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vabd),
     /*  64968 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  64971 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  64974 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  64977 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  64980 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  64984 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  64988 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  64992 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  64996 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3604:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn, 0:{ *:[i32] })  =>  (MVE_VABDs32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)
     /*  64996 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  64999 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  65003 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  65008 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VABDs32),
     /*  65011 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  65013 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  65015 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  65017 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  65020 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  65026 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  65032 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  65035 */     GIR_RootConstrainSelectedInstOperands,
     /*  65036 */     // GIR_Coverage, 3556,
     /*  65036 */     GIR_EraseRootFromParent_Done,
     /*  65037 */   // Label 1348: @65037
     /*  65037 */   GIM_Try, /*On fail goto*//*Label 1349*/ GIMT_Encode4(65119), // Rule ID 3560 //
     /*  65042 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  65045 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vabd),
     /*  65050 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  65053 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  65056 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  65059 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  65062 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  65066 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  65070 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  65074 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  65078 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3604:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn, 1:{ *:[i32] })  =>  (MVE_VABDu8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)
     /*  65078 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  65081 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  65085 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  65090 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VABDu8),
     /*  65093 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  65095 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  65097 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  65099 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  65102 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  65108 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  65114 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  65117 */     GIR_RootConstrainSelectedInstOperands,
     /*  65118 */     // GIR_Coverage, 3560,
     /*  65118 */     GIR_EraseRootFromParent_Done,
     /*  65119 */   // Label 1349: @65119
     /*  65119 */   GIM_Try, /*On fail goto*//*Label 1350*/ GIMT_Encode4(65201), // Rule ID 3564 //
     /*  65124 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  65127 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vabd),
     /*  65132 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  65135 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  65138 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  65141 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  65144 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  65148 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  65152 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  65156 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  65160 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3604:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn, 1:{ *:[i32] })  =>  (MVE_VABDu16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)
     /*  65160 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  65163 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  65167 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  65172 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VABDu16),
     /*  65175 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  65177 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  65179 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  65181 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  65184 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  65190 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  65196 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  65199 */     GIR_RootConstrainSelectedInstOperands,
     /*  65200 */     // GIR_Coverage, 3564,
     /*  65200 */     GIR_EraseRootFromParent_Done,
     /*  65201 */   // Label 1350: @65201
     /*  65201 */   GIM_Try, /*On fail goto*//*Label 1351*/ GIMT_Encode4(65283), // Rule ID 3568 //
     /*  65206 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  65209 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vabd),
     /*  65214 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  65217 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  65220 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  65223 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  65226 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  65230 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  65234 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  65238 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  65242 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3604:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn, 1:{ *:[i32] })  =>  (MVE_VABDu32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)
     /*  65242 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  65245 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  65249 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  65254 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VABDu32),
     /*  65257 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  65259 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  65261 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  65263 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  65266 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  65272 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  65278 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  65281 */     GIR_RootConstrainSelectedInstOperands,
     /*  65282 */     // GIR_Coverage, 3568,
     /*  65282 */     GIR_EraseRootFromParent_Done,
     /*  65283 */   // Label 1351: @65283
     /*  65283 */   GIM_Try, /*On fail goto*//*Label 1352*/ GIMT_Encode4(65365), // Rule ID 3569 //
     /*  65288 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  65291 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vrhadd),
     /*  65296 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  65299 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  65302 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  65305 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  65308 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  65312 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  65316 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  65320 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  65324 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3690:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn, 0:{ *:[i32] })  =>  (MVE_VRHADDs8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)
     /*  65324 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  65327 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  65331 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  65336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRHADDs8),
     /*  65339 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  65341 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  65343 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  65345 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  65348 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  65354 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  65360 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  65363 */     GIR_RootConstrainSelectedInstOperands,
     /*  65364 */     // GIR_Coverage, 3569,
     /*  65364 */     GIR_EraseRootFromParent_Done,
     /*  65365 */   // Label 1352: @65365
     /*  65365 */   GIM_Try, /*On fail goto*//*Label 1353*/ GIMT_Encode4(65447), // Rule ID 3576 //
     /*  65370 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  65373 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vrhadd),
     /*  65378 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  65381 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  65384 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  65387 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  65390 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  65394 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  65398 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  65402 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  65406 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3690:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn, 0:{ *:[i32] })  =>  (MVE_VRHADDs16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)
     /*  65406 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  65409 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  65413 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  65418 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRHADDs16),
     /*  65421 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  65423 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  65425 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  65427 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  65430 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  65436 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  65442 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  65445 */     GIR_RootConstrainSelectedInstOperands,
     /*  65446 */     // GIR_Coverage, 3576,
     /*  65446 */     GIR_EraseRootFromParent_Done,
     /*  65447 */   // Label 1353: @65447
     /*  65447 */   GIM_Try, /*On fail goto*//*Label 1354*/ GIMT_Encode4(65529), // Rule ID 3580 //
     /*  65452 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  65455 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vrhadd),
     /*  65460 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  65463 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  65466 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  65469 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  65472 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  65476 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  65480 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  65484 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  65488 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3690:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn, 0:{ *:[i32] })  =>  (MVE_VRHADDs32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)
     /*  65488 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  65491 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  65495 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  65500 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRHADDs32),
     /*  65503 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  65505 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  65507 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  65509 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  65512 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  65518 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  65524 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  65527 */     GIR_RootConstrainSelectedInstOperands,
     /*  65528 */     // GIR_Coverage, 3580,
     /*  65528 */     GIR_EraseRootFromParent_Done,
     /*  65529 */   // Label 1354: @65529
     /*  65529 */   GIM_Try, /*On fail goto*//*Label 1355*/ GIMT_Encode4(65611), // Rule ID 3584 //
     /*  65534 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  65537 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vrhadd),
     /*  65542 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  65545 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  65548 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  65551 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  65554 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  65558 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  65562 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  65566 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  65570 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3690:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn, 1:{ *:[i32] })  =>  (MVE_VRHADDu8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)
     /*  65570 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  65573 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  65577 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  65582 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRHADDu8),
     /*  65585 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  65587 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  65589 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  65591 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  65594 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  65600 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  65606 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  65609 */     GIR_RootConstrainSelectedInstOperands,
     /*  65610 */     // GIR_Coverage, 3584,
     /*  65610 */     GIR_EraseRootFromParent_Done,
     /*  65611 */   // Label 1355: @65611
     /*  65611 */   GIM_Try, /*On fail goto*//*Label 1356*/ GIMT_Encode4(65693), // Rule ID 3588 //
     /*  65616 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  65619 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vrhadd),
     /*  65624 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  65627 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  65630 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  65633 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  65636 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  65640 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  65644 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  65648 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  65652 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3690:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn, 1:{ *:[i32] })  =>  (MVE_VRHADDu16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)
     /*  65652 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  65655 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  65659 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  65664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRHADDu16),
     /*  65667 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  65669 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  65671 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  65673 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  65676 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  65682 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  65688 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  65691 */     GIR_RootConstrainSelectedInstOperands,
     /*  65692 */     // GIR_Coverage, 3588,
     /*  65692 */     GIR_EraseRootFromParent_Done,
     /*  65693 */   // Label 1356: @65693
     /*  65693 */   GIM_Try, /*On fail goto*//*Label 1357*/ GIMT_Encode4(65775), // Rule ID 3592 //
     /*  65698 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  65701 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vrhadd),
     /*  65706 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  65709 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  65712 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  65715 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  65718 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  65722 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  65726 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  65730 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  65734 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3690:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn, 1:{ *:[i32] })  =>  (MVE_VRHADDu32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)
     /*  65734 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  65737 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  65741 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  65746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRHADDu32),
     /*  65749 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  65751 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  65753 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  65755 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  65758 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  65764 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  65770 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  65773 */     GIR_RootConstrainSelectedInstOperands,
     /*  65774 */     // GIR_Coverage, 3592,
     /*  65774 */     GIR_EraseRootFromParent_Done,
     /*  65775 */   // Label 1357: @65775
     /*  65775 */   GIM_Try, /*On fail goto*//*Label 1358*/ GIMT_Encode4(65857), // Rule ID 3593 //
     /*  65780 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  65783 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vhadd),
     /*  65788 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  65791 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  65794 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  65797 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  65800 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  65804 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  65808 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  65812 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  65816 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3639:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn, 0:{ *:[i32] })  =>  (MVE_VHADDs8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)
     /*  65816 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  65819 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  65823 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  65828 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VHADDs8),
     /*  65831 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  65833 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  65835 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  65837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  65840 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  65846 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  65852 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  65855 */     GIR_RootConstrainSelectedInstOperands,
     /*  65856 */     // GIR_Coverage, 3593,
     /*  65856 */     GIR_EraseRootFromParent_Done,
     /*  65857 */   // Label 1358: @65857
     /*  65857 */   GIM_Try, /*On fail goto*//*Label 1359*/ GIMT_Encode4(65939), // Rule ID 3600 //
     /*  65862 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  65865 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vhadd),
     /*  65870 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  65873 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  65876 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  65879 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  65882 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  65886 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  65890 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  65894 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  65898 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3639:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn, 0:{ *:[i32] })  =>  (MVE_VHADDs16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)
     /*  65898 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  65901 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  65905 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  65910 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VHADDs16),
     /*  65913 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  65915 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  65917 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  65919 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  65922 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  65928 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  65934 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  65937 */     GIR_RootConstrainSelectedInstOperands,
     /*  65938 */     // GIR_Coverage, 3600,
     /*  65938 */     GIR_EraseRootFromParent_Done,
     /*  65939 */   // Label 1359: @65939
     /*  65939 */   GIM_Try, /*On fail goto*//*Label 1360*/ GIMT_Encode4(66021), // Rule ID 3604 //
     /*  65944 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  65947 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vhadd),
     /*  65952 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  65955 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  65958 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  65961 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  65964 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  65968 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  65972 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  65976 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  65980 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3639:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn, 0:{ *:[i32] })  =>  (MVE_VHADDs32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)
     /*  65980 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  65983 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  65987 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  65992 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VHADDs32),
     /*  65995 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  65997 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  65999 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  66001 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  66004 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  66010 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  66016 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  66019 */     GIR_RootConstrainSelectedInstOperands,
     /*  66020 */     // GIR_Coverage, 3604,
     /*  66020 */     GIR_EraseRootFromParent_Done,
     /*  66021 */   // Label 1360: @66021
     /*  66021 */   GIM_Try, /*On fail goto*//*Label 1361*/ GIMT_Encode4(66103), // Rule ID 3608 //
     /*  66026 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  66029 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vhadd),
     /*  66034 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  66037 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  66040 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  66043 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  66046 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  66050 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  66054 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  66058 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  66062 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3639:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn, 1:{ *:[i32] })  =>  (MVE_VHADDu8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)
     /*  66062 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  66065 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  66069 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  66074 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VHADDu8),
     /*  66077 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  66079 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  66081 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  66083 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  66086 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  66092 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  66098 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  66101 */     GIR_RootConstrainSelectedInstOperands,
     /*  66102 */     // GIR_Coverage, 3608,
     /*  66102 */     GIR_EraseRootFromParent_Done,
     /*  66103 */   // Label 1361: @66103
     /*  66103 */   GIM_Try, /*On fail goto*//*Label 1362*/ GIMT_Encode4(66185), // Rule ID 3612 //
     /*  66108 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  66111 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vhadd),
     /*  66116 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  66119 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  66122 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  66125 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  66128 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  66132 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  66136 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  66140 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  66144 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3639:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn, 1:{ *:[i32] })  =>  (MVE_VHADDu16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)
     /*  66144 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  66147 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  66151 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  66156 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VHADDu16),
     /*  66159 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  66161 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  66163 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  66165 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  66168 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  66174 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  66180 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  66183 */     GIR_RootConstrainSelectedInstOperands,
     /*  66184 */     // GIR_Coverage, 3612,
     /*  66184 */     GIR_EraseRootFromParent_Done,
     /*  66185 */   // Label 1362: @66185
     /*  66185 */   GIM_Try, /*On fail goto*//*Label 1363*/ GIMT_Encode4(66267), // Rule ID 3616 //
     /*  66190 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  66193 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vhadd),
     /*  66198 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  66201 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  66204 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  66207 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  66210 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  66214 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  66218 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  66222 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  66226 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3639:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn, 1:{ *:[i32] })  =>  (MVE_VHADDu32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)
     /*  66226 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  66229 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  66233 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  66238 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VHADDu32),
     /*  66241 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  66243 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  66245 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  66247 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  66250 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  66256 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  66262 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  66265 */     GIR_RootConstrainSelectedInstOperands,
     /*  66266 */     // GIR_Coverage, 3616,
     /*  66266 */     GIR_EraseRootFromParent_Done,
     /*  66267 */   // Label 1363: @66267
     /*  66267 */   GIM_Try, /*On fail goto*//*Label 1364*/ GIMT_Encode4(66349), // Rule ID 3617 //
     /*  66272 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  66275 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vhsub),
     /*  66280 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  66283 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  66286 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  66289 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  66292 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  66296 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  66300 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  66304 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  66308 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3640:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn, 0:{ *:[i32] })  =>  (MVE_VHSUBs8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)
     /*  66308 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  66311 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  66315 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  66320 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VHSUBs8),
     /*  66323 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  66325 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  66327 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  66329 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  66332 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  66338 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  66344 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  66347 */     GIR_RootConstrainSelectedInstOperands,
     /*  66348 */     // GIR_Coverage, 3617,
     /*  66348 */     GIR_EraseRootFromParent_Done,
     /*  66349 */   // Label 1364: @66349
     /*  66349 */   GIM_Try, /*On fail goto*//*Label 1365*/ GIMT_Encode4(66431), // Rule ID 3620 //
     /*  66354 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  66357 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vhsub),
     /*  66362 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  66365 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  66368 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  66371 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  66374 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  66378 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  66382 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  66386 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  66390 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3640:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn, 0:{ *:[i32] })  =>  (MVE_VHSUBs16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)
     /*  66390 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  66393 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  66397 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  66402 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VHSUBs16),
     /*  66405 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  66407 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  66409 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  66411 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  66414 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  66420 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  66426 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  66429 */     GIR_RootConstrainSelectedInstOperands,
     /*  66430 */     // GIR_Coverage, 3620,
     /*  66430 */     GIR_EraseRootFromParent_Done,
     /*  66431 */   // Label 1365: @66431
     /*  66431 */   GIM_Try, /*On fail goto*//*Label 1366*/ GIMT_Encode4(66513), // Rule ID 3623 //
     /*  66436 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  66439 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vhsub),
     /*  66444 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  66447 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  66450 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  66453 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  66456 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  66460 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  66464 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  66468 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  66472 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3640:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn, 0:{ *:[i32] })  =>  (MVE_VHSUBs32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)
     /*  66472 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  66475 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  66479 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  66484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VHSUBs32),
     /*  66487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  66489 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  66491 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  66493 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  66496 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  66502 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  66508 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  66511 */     GIR_RootConstrainSelectedInstOperands,
     /*  66512 */     // GIR_Coverage, 3623,
     /*  66512 */     GIR_EraseRootFromParent_Done,
     /*  66513 */   // Label 1366: @66513
     /*  66513 */   GIM_Try, /*On fail goto*//*Label 1367*/ GIMT_Encode4(66595), // Rule ID 3626 //
     /*  66518 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  66521 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vhsub),
     /*  66526 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  66529 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  66532 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  66535 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  66538 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  66542 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  66546 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  66550 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  66554 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3640:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn, 1:{ *:[i32] })  =>  (MVE_VHSUBu8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)
     /*  66554 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  66557 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  66561 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  66566 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VHSUBu8),
     /*  66569 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  66571 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  66573 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  66575 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  66578 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  66584 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  66590 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  66593 */     GIR_RootConstrainSelectedInstOperands,
     /*  66594 */     // GIR_Coverage, 3626,
     /*  66594 */     GIR_EraseRootFromParent_Done,
     /*  66595 */   // Label 1367: @66595
     /*  66595 */   GIM_Try, /*On fail goto*//*Label 1368*/ GIMT_Encode4(66677), // Rule ID 3629 //
     /*  66600 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  66603 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vhsub),
     /*  66608 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  66611 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  66614 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  66617 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  66620 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  66624 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  66628 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  66632 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  66636 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3640:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn, 1:{ *:[i32] })  =>  (MVE_VHSUBu16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)
     /*  66636 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  66639 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  66643 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  66648 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VHSUBu16),
     /*  66651 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  66653 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  66655 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  66657 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  66660 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  66666 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  66672 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  66675 */     GIR_RootConstrainSelectedInstOperands,
     /*  66676 */     // GIR_Coverage, 3629,
     /*  66676 */     GIR_EraseRootFromParent_Done,
     /*  66677 */   // Label 1368: @66677
     /*  66677 */   GIM_Try, /*On fail goto*//*Label 1369*/ GIMT_Encode4(66759), // Rule ID 3632 //
     /*  66682 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  66685 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vhsub),
     /*  66690 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  66693 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  66696 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  66699 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  66702 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  66706 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  66710 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  66714 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  66718 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3640:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn, 1:{ *:[i32] })  =>  (MVE_VHSUBu32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)
     /*  66718 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  66721 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  66725 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  66730 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VHSUBu32),
     /*  66733 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  66735 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  66737 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  66739 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  66742 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  66748 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  66754 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  66757 */     GIR_RootConstrainSelectedInstOperands,
     /*  66758 */     // GIR_Coverage, 3632,
     /*  66758 */     GIR_EraseRootFromParent_Done,
     /*  66759 */   // Label 1369: @66759
     /*  66759 */   GIM_Try, /*On fail goto*//*Label 1370*/ GIMT_Encode4(66841), // Rule ID 4033 //
     /*  66764 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  66767 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vabd),
     /*  66772 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  66775 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  66778 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  66781 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  66784 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  66788 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  66792 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  66796 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  66800 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3604:{ *:[iPTR] }, MQPR:{ *:[v4f32] }:$Qm, MQPR:{ *:[v4f32] }:$Qn, 0:{ *:[i32] })  =>  (MVE_VABDf32:{ *:[v4f32] } MQPR:{ *:[v4f32] }:$Qm, MQPR:{ *:[v4f32] }:$Qn)
     /*  66800 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  66803 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  66807 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  66812 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VABDf32),
     /*  66815 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  66817 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  66819 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  66821 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  66824 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  66830 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  66836 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  66839 */     GIR_RootConstrainSelectedInstOperands,
     /*  66840 */     // GIR_Coverage, 4033,
     /*  66840 */     GIR_EraseRootFromParent_Done,
     /*  66841 */   // Label 1370: @66841
     /*  66841 */   GIM_Try, /*On fail goto*//*Label 1371*/ GIMT_Encode4(66923), // Rule ID 4035 //
     /*  66846 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  66849 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vabd),
     /*  66854 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  66857 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  66860 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  66863 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  66866 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  66870 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  66874 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  66878 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  66882 */     // (intrinsic_wo_chain:{ *:[v8f16] } 3604:{ *:[iPTR] }, MQPR:{ *:[v8f16] }:$Qm, MQPR:{ *:[v8f16] }:$Qn, 0:{ *:[i32] })  =>  (MVE_VABDf16:{ *:[v8f16] } MQPR:{ *:[v8f16] }:$Qm, MQPR:{ *:[v8f16] }:$Qn)
     /*  66882 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  66885 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  66889 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  66894 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VABDf16),
     /*  66897 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  66899 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  66901 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  66903 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  66906 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  66912 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  66918 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  66921 */     GIR_RootConstrainSelectedInstOperands,
     /*  66922 */     // GIR_Coverage, 4035,
     /*  66922 */     GIR_EraseRootFromParent_Done,
     /*  66923 */   // Label 1371: @66923
     /*  66923 */   GIM_Try, /*On fail goto*//*Label 1372*/ GIMT_Encode4(67005), // Rule ID 4408 //
     /*  66928 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  66931 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmull_poly),
     /*  66936 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  66939 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  66942 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  66945 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  66948 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  66952 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  66956 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  66960 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  66964 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3667:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn, 0:{ *:[i32] })  =>  (MVE_VMULLBp8:{ *:[v8i16] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)
     /*  66964 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  66967 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  66971 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  66976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMULLBp8),
     /*  66979 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  66981 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  66983 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  66985 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  66988 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  66994 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  67000 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  67003 */     GIR_RootConstrainSelectedInstOperands,
     /*  67004 */     // GIR_Coverage, 4408,
     /*  67004 */     GIR_EraseRootFromParent_Done,
     /*  67005 */   // Label 1372: @67005
     /*  67005 */   GIM_Try, /*On fail goto*//*Label 1373*/ GIMT_Encode4(67087), // Rule ID 4410 //
     /*  67010 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  67013 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmull_poly),
     /*  67018 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  67021 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  67024 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  67027 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  67030 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  67034 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  67038 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  67042 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  67046 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3667:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn, 1:{ *:[i32] })  =>  (MVE_VMULLTp8:{ *:[v8i16] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)
     /*  67046 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  67049 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  67053 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  67058 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMULLTp8),
     /*  67061 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  67063 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  67065 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  67067 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  67070 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  67076 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  67082 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  67085 */     GIR_RootConstrainSelectedInstOperands,
     /*  67086 */     // GIR_Coverage, 4410,
     /*  67086 */     GIR_EraseRootFromParent_Done,
     /*  67087 */   // Label 1373: @67087
     /*  67087 */   GIM_Try, /*On fail goto*//*Label 1374*/ GIMT_Encode4(67169), // Rule ID 4412 //
     /*  67092 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  67095 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmull_poly),
     /*  67100 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  67103 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  67106 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  67109 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  67112 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  67116 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  67120 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  67124 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  67128 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3667:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn, 0:{ *:[i32] })  =>  (MVE_VMULLBp16:{ *:[v4i32] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)
     /*  67128 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  67131 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  67135 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  67140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMULLBp16),
     /*  67143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  67145 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  67147 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  67149 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  67152 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  67158 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  67164 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  67167 */     GIR_RootConstrainSelectedInstOperands,
     /*  67168 */     // GIR_Coverage, 4412,
     /*  67168 */     GIR_EraseRootFromParent_Done,
     /*  67169 */   // Label 1374: @67169
     /*  67169 */   GIM_Try, /*On fail goto*//*Label 1375*/ GIMT_Encode4(67251), // Rule ID 4414 //
     /*  67174 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  67177 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmull_poly),
     /*  67182 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  67185 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  67188 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  67191 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  67194 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  67198 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  67202 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  67206 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  67210 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3667:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn, 1:{ *:[i32] })  =>  (MVE_VMULLTp16:{ *:[v4i32] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)
     /*  67210 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  67213 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  67217 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  67222 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMULLTp16),
     /*  67225 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  67227 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  67229 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  67231 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  67234 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  67240 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  67246 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  67249 */     GIR_RootConstrainSelectedInstOperands,
     /*  67250 */     // GIR_Coverage, 4414,
     /*  67250 */     GIR_EraseRootFromParent_Done,
     /*  67251 */   // Label 1375: @67251
     /*  67251 */   GIM_Try, /*On fail goto*//*Label 1376*/ GIMT_Encode4(67333), // Rule ID 4441 //
     /*  67256 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  67259 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmulh),
     /*  67264 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  67267 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  67270 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  67273 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  67276 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  67280 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  67284 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  67288 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  67292 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3665:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn, 0:{ *:[i32] })  =>  (MVE_VMULHs8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)
     /*  67292 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  67295 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  67299 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  67304 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMULHs8),
     /*  67307 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  67309 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  67311 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  67313 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  67316 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  67322 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  67328 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  67331 */     GIR_RootConstrainSelectedInstOperands,
     /*  67332 */     // GIR_Coverage, 4441,
     /*  67332 */     GIR_EraseRootFromParent_Done,
     /*  67333 */   // Label 1376: @67333
     /*  67333 */   GIM_Try, /*On fail goto*//*Label 1377*/ GIMT_Encode4(67415), // Rule ID 4448 //
     /*  67338 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  67341 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmulh),
     /*  67346 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  67349 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  67352 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  67355 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  67358 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  67362 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  67366 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  67370 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  67374 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3665:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn, 0:{ *:[i32] })  =>  (MVE_VMULHs16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)
     /*  67374 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  67377 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  67381 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  67386 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMULHs16),
     /*  67389 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  67391 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  67393 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  67395 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  67398 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  67404 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  67410 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  67413 */     GIR_RootConstrainSelectedInstOperands,
     /*  67414 */     // GIR_Coverage, 4448,
     /*  67414 */     GIR_EraseRootFromParent_Done,
     /*  67415 */   // Label 1377: @67415
     /*  67415 */   GIM_Try, /*On fail goto*//*Label 1378*/ GIMT_Encode4(67497), // Rule ID 4452 //
     /*  67420 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  67423 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmulh),
     /*  67428 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  67431 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  67434 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  67437 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  67440 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  67444 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  67448 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  67452 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  67456 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3665:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn, 0:{ *:[i32] })  =>  (MVE_VMULHs32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)
     /*  67456 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  67459 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  67463 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  67468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMULHs32),
     /*  67471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  67473 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  67475 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  67477 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  67480 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  67486 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  67492 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  67495 */     GIR_RootConstrainSelectedInstOperands,
     /*  67496 */     // GIR_Coverage, 4452,
     /*  67496 */     GIR_EraseRootFromParent_Done,
     /*  67497 */   // Label 1378: @67497
     /*  67497 */   GIM_Try, /*On fail goto*//*Label 1379*/ GIMT_Encode4(67579), // Rule ID 4456 //
     /*  67502 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  67505 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmulh),
     /*  67510 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  67513 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  67516 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  67519 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  67522 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  67526 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  67530 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  67534 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  67538 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3665:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn, 1:{ *:[i32] })  =>  (MVE_VMULHu8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)
     /*  67538 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  67541 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  67545 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  67550 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMULHu8),
     /*  67553 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  67555 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  67557 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  67559 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  67562 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  67568 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  67574 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  67577 */     GIR_RootConstrainSelectedInstOperands,
     /*  67578 */     // GIR_Coverage, 4456,
     /*  67578 */     GIR_EraseRootFromParent_Done,
     /*  67579 */   // Label 1379: @67579
     /*  67579 */   GIM_Try, /*On fail goto*//*Label 1380*/ GIMT_Encode4(67661), // Rule ID 4460 //
     /*  67584 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  67587 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmulh),
     /*  67592 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  67595 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  67598 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  67601 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  67604 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  67608 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  67612 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  67616 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  67620 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3665:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn, 1:{ *:[i32] })  =>  (MVE_VMULHu16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)
     /*  67620 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  67623 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  67627 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  67632 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMULHu16),
     /*  67635 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  67637 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  67639 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  67641 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  67644 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  67650 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  67656 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  67659 */     GIR_RootConstrainSelectedInstOperands,
     /*  67660 */     // GIR_Coverage, 4460,
     /*  67660 */     GIR_EraseRootFromParent_Done,
     /*  67661 */   // Label 1380: @67661
     /*  67661 */   GIM_Try, /*On fail goto*//*Label 1381*/ GIMT_Encode4(67743), // Rule ID 4464 //
     /*  67666 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  67669 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmulh),
     /*  67674 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  67677 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  67680 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  67683 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  67686 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  67690 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  67694 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  67698 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  67702 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3665:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn, 1:{ *:[i32] })  =>  (MVE_VMULHu32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)
     /*  67702 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  67705 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  67709 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  67714 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMULHu32),
     /*  67717 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  67719 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  67721 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  67723 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  67726 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  67732 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  67738 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  67741 */     GIR_RootConstrainSelectedInstOperands,
     /*  67742 */     // GIR_Coverage, 4464,
     /*  67742 */     GIR_EraseRootFromParent_Done,
     /*  67743 */   // Label 1381: @67743
     /*  67743 */   GIM_Try, /*On fail goto*//*Label 1382*/ GIMT_Encode4(67825), // Rule ID 4465 //
     /*  67748 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  67751 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vrmulh),
     /*  67756 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  67759 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  67762 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  67765 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  67768 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  67772 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  67776 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  67780 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  67784 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3699:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn, 0:{ *:[i32] })  =>  (MVE_VRMULHs8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)
     /*  67784 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  67787 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  67791 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  67796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRMULHs8),
     /*  67799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  67801 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  67803 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  67805 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  67808 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  67814 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  67820 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  67823 */     GIR_RootConstrainSelectedInstOperands,
     /*  67824 */     // GIR_Coverage, 4465,
     /*  67824 */     GIR_EraseRootFromParent_Done,
     /*  67825 */   // Label 1382: @67825
     /*  67825 */   GIM_Try, /*On fail goto*//*Label 1383*/ GIMT_Encode4(67907), // Rule ID 4467 //
     /*  67830 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  67833 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vrmulh),
     /*  67838 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  67841 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  67844 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  67847 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  67850 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  67854 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  67858 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  67862 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  67866 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3699:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn, 0:{ *:[i32] })  =>  (MVE_VRMULHs16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)
     /*  67866 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  67869 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  67873 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  67878 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRMULHs16),
     /*  67881 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  67883 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  67885 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  67887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  67890 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  67896 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  67902 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  67905 */     GIR_RootConstrainSelectedInstOperands,
     /*  67906 */     // GIR_Coverage, 4467,
     /*  67906 */     GIR_EraseRootFromParent_Done,
     /*  67907 */   // Label 1383: @67907
     /*  67907 */   GIM_Try, /*On fail goto*//*Label 1384*/ GIMT_Encode4(67989), // Rule ID 4469 //
     /*  67912 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  67915 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vrmulh),
     /*  67920 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  67923 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  67926 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  67929 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  67932 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  67936 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  67940 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  67944 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  67948 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3699:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn, 0:{ *:[i32] })  =>  (MVE_VRMULHs32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)
     /*  67948 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  67951 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  67955 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  67960 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRMULHs32),
     /*  67963 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  67965 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  67967 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  67969 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  67972 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  67978 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  67984 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  67987 */     GIR_RootConstrainSelectedInstOperands,
     /*  67988 */     // GIR_Coverage, 4469,
     /*  67988 */     GIR_EraseRootFromParent_Done,
     /*  67989 */   // Label 1384: @67989
     /*  67989 */   GIM_Try, /*On fail goto*//*Label 1385*/ GIMT_Encode4(68071), // Rule ID 4471 //
     /*  67994 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  67997 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vrmulh),
     /*  68002 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  68005 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  68008 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  68011 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  68014 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  68018 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  68022 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  68026 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  68030 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3699:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn, 1:{ *:[i32] })  =>  (MVE_VRMULHu8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)
     /*  68030 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  68033 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  68037 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  68042 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRMULHu8),
     /*  68045 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  68047 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  68049 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  68051 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  68054 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  68060 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  68066 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  68069 */     GIR_RootConstrainSelectedInstOperands,
     /*  68070 */     // GIR_Coverage, 4471,
     /*  68070 */     GIR_EraseRootFromParent_Done,
     /*  68071 */   // Label 1385: @68071
     /*  68071 */   GIM_Try, /*On fail goto*//*Label 1386*/ GIMT_Encode4(68153), // Rule ID 4473 //
     /*  68076 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  68079 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vrmulh),
     /*  68084 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  68087 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  68090 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  68093 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  68096 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  68100 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  68104 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  68108 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  68112 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3699:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn, 1:{ *:[i32] })  =>  (MVE_VRMULHu16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)
     /*  68112 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  68115 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  68119 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  68124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRMULHu16),
     /*  68127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  68129 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  68131 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  68133 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  68136 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  68142 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  68148 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  68151 */     GIR_RootConstrainSelectedInstOperands,
     /*  68152 */     // GIR_Coverage, 4473,
     /*  68152 */     GIR_EraseRootFromParent_Done,
     /*  68153 */   // Label 1386: @68153
     /*  68153 */   GIM_Try, /*On fail goto*//*Label 1387*/ GIMT_Encode4(68235), // Rule ID 4475 //
     /*  68158 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  68161 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vrmulh),
     /*  68166 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  68169 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  68172 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  68175 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  68178 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  68182 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  68186 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  68190 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  68194 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3699:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn, 1:{ *:[i32] })  =>  (MVE_VRMULHu32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)
     /*  68194 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  68197 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  68201 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  68206 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRMULHu32),
     /*  68209 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  68211 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  68213 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  68215 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  68218 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  68224 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  68230 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  68233 */     GIR_RootConstrainSelectedInstOperands,
     /*  68234 */     // GIR_Coverage, 4475,
     /*  68234 */     GIR_EraseRootFromParent_Done,
     /*  68235 */   // Label 1387: @68235
     /*  68235 */   GIM_Try, /*On fail goto*//*Label 1388*/ GIMT_Encode4(68302), // Rule ID 4526 //
     /*  68240 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  68243 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vcvt_narrow),
     /*  68248 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  68251 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  68254 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  68257 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  68260 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  68264 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  68268 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  68272 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  68276 */     // (intrinsic_wo_chain:{ *:[v8f16] } 3623:{ *:[iPTR] }, MQPR:{ *:[v8f16] }:$Qd_src, MQPR:{ *:[v4f32] }:$Qm, 0:{ *:[i32] })  =>  (MVE_VCVTf16f32bh:{ *:[v8f16] } MQPR:{ *:[v8f16] }:$Qd_src, MQPR:{ *:[v4f32] }:$Qm)
     /*  68276 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCVTf16f32bh),
     /*  68279 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  68281 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qd_src
     /*  68283 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  68285 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  68288 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  68294 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  68300 */     GIR_RootConstrainSelectedInstOperands,
     /*  68301 */     // GIR_Coverage, 4526,
     /*  68301 */     GIR_EraseRootFromParent_Done,
     /*  68302 */   // Label 1388: @68302
     /*  68302 */   GIM_Try, /*On fail goto*//*Label 1389*/ GIMT_Encode4(68369), // Rule ID 4532 //
     /*  68307 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  68310 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vcvt_narrow),
     /*  68315 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  68318 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  68321 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  68324 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  68327 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  68331 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  68335 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  68339 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  68343 */     // (intrinsic_wo_chain:{ *:[v8f16] } 3623:{ *:[iPTR] }, MQPR:{ *:[v8f16] }:$Qd_src, MQPR:{ *:[v4f32] }:$Qm, 1:{ *:[i32] })  =>  (MVE_VCVTf16f32th:{ *:[v8f16] } MQPR:{ *:[v8f16] }:$Qd_src, MQPR:{ *:[v4f32] }:$Qm)
     /*  68343 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCVTf16f32th),
     /*  68346 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  68348 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qd_src
     /*  68350 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  68352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  68355 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  68361 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  68367 */     GIR_RootConstrainSelectedInstOperands,
     /*  68368 */     // GIR_Coverage, 4532,
     /*  68368 */     GIR_EraseRootFromParent_Done,
     /*  68369 */   // Label 1389: @68369
     /*  68369 */   GIM_Try, /*On fail goto*//*Label 1390*/ GIMT_Encode4(68451), // Rule ID 4550 //
     /*  68374 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  68377 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqdmull),
     /*  68382 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  68385 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  68388 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  68391 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  68394 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  68398 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  68402 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  68406 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  68410 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3675:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn, 0:{ *:[i32] })  =>  (MVE_VQDMULLs16bh:{ *:[v4i32] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)
     /*  68410 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  68413 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  68417 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  68422 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQDMULLs16bh),
     /*  68425 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  68427 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  68429 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  68431 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  68434 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  68440 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  68446 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  68449 */     GIR_RootConstrainSelectedInstOperands,
     /*  68450 */     // GIR_Coverage, 4550,
     /*  68450 */     GIR_EraseRootFromParent_Done,
     /*  68451 */   // Label 1390: @68451
     /*  68451 */   GIM_Try, /*On fail goto*//*Label 1391*/ GIMT_Encode4(68533), // Rule ID 4552 //
     /*  68456 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  68459 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqdmull),
     /*  68464 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  68467 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  68470 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  68473 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  68476 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  68480 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  68484 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  68488 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  68492 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3675:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn, 1:{ *:[i32] })  =>  (MVE_VQDMULLs16th:{ *:[v4i32] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)
     /*  68492 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  68495 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  68499 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  68504 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQDMULLs16th),
     /*  68507 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  68509 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  68511 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  68513 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  68516 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  68522 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  68528 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  68531 */     GIR_RootConstrainSelectedInstOperands,
     /*  68532 */     // GIR_Coverage, 4552,
     /*  68532 */     GIR_EraseRootFromParent_Done,
     /*  68533 */   // Label 1391: @68533
     /*  68533 */   GIM_Try, /*On fail goto*//*Label 1392*/ GIMT_Encode4(68615), // Rule ID 4554 //
     /*  68538 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  68541 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqdmull),
     /*  68546 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  68549 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  68552 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  68555 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  68558 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  68562 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  68566 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  68570 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  68574 */     // (intrinsic_wo_chain:{ *:[v2i64] } 3675:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn, 0:{ *:[i32] })  =>  (MVE_VQDMULLs32bh:{ *:[v2i64] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)
     /*  68574 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  68577 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  68581 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  68586 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQDMULLs32bh),
     /*  68589 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  68591 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  68593 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  68595 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  68598 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  68604 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  68610 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  68613 */     GIR_RootConstrainSelectedInstOperands,
     /*  68614 */     // GIR_Coverage, 4554,
     /*  68614 */     GIR_EraseRootFromParent_Done,
     /*  68615 */   // Label 1392: @68615
     /*  68615 */   GIM_Try, /*On fail goto*//*Label 1393*/ GIMT_Encode4(68697), // Rule ID 4556 //
     /*  68620 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  68623 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqdmull),
     /*  68628 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  68631 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  68634 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  68637 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  68640 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  68644 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  68648 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  68652 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  68656 */     // (intrinsic_wo_chain:{ *:[v2i64] } 3675:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn, 1:{ *:[i32] })  =>  (MVE_VQDMULLs32th:{ *:[v2i64] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)
     /*  68656 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  68659 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  68663 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  68668 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQDMULLs32th),
     /*  68671 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  68673 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  68675 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  68677 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  68680 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  68686 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  68692 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  68695 */     GIR_RootConstrainSelectedInstOperands,
     /*  68696 */     // GIR_Coverage, 4556,
     /*  68696 */     GIR_EraseRootFromParent_Done,
     /*  68697 */   // Label 1393: @68697
     /*  68697 */   GIM_Try, /*On fail goto*//*Label 1394*/ GIMT_Encode4(68774), // Rule ID 3901 //
     /*  68702 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vsli),
     /*  68707 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  68710 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  68713 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  68716 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  68719 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  68723 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  68727 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  68731 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  68735 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  68739 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_7),
     /*  68743 */     // MIs[1] Operand 1
     /*  68743 */     // No operand predicates
     /*  68743 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  68745 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3714:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$QdSrc, MQPR:{ *:[v16i8] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_imm0_7>>:$imm)  =>  (MVE_VSLIimm8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$QdSrc, MQPR:{ *:[v16i8] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_imm0_7>>:$imm)
     /*  68745 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSLIimm8),
     /*  68748 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  68750 */     GIR_RootToRootCopy, /*OpIdx*/2, // QdSrc
     /*  68752 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  68754 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  68757 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  68760 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  68766 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  68772 */     GIR_RootConstrainSelectedInstOperands,
     /*  68773 */     // GIR_Coverage, 3901,
     /*  68773 */     GIR_EraseRootFromParent_Done,
     /*  68774 */   // Label 1394: @68774
     /*  68774 */   GIM_Try, /*On fail goto*//*Label 1395*/ GIMT_Encode4(68851), // Rule ID 3903 //
     /*  68779 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vsli),
     /*  68784 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  68787 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  68790 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  68793 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  68796 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  68800 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  68804 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  68808 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  68812 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  68816 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_15),
     /*  68820 */     // MIs[1] Operand 1
     /*  68820 */     // No operand predicates
     /*  68820 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  68822 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3714:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$QdSrc, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_imm0_15>>:$imm)  =>  (MVE_VSLIimm16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$QdSrc, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_imm0_15>>:$imm)
     /*  68822 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSLIimm16),
     /*  68825 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  68827 */     GIR_RootToRootCopy, /*OpIdx*/2, // QdSrc
     /*  68829 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  68831 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  68834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  68837 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  68843 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  68849 */     GIR_RootConstrainSelectedInstOperands,
     /*  68850 */     // GIR_Coverage, 3903,
     /*  68850 */     GIR_EraseRootFromParent_Done,
     /*  68851 */   // Label 1395: @68851
     /*  68851 */   GIM_Try, /*On fail goto*//*Label 1396*/ GIMT_Encode4(68928), // Rule ID 3905 //
     /*  68856 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vsli),
     /*  68861 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  68864 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  68867 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  68870 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  68873 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  68877 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  68881 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  68885 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  68889 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  68893 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_31),
     /*  68897 */     // MIs[1] Operand 1
     /*  68897 */     // No operand predicates
     /*  68897 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  68899 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3714:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$QdSrc, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_imm0_31>>:$imm)  =>  (MVE_VSLIimm32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$QdSrc, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_imm0_31>>:$imm)
     /*  68899 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSLIimm32),
     /*  68902 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  68904 */     GIR_RootToRootCopy, /*OpIdx*/2, // QdSrc
     /*  68906 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  68908 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  68911 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  68914 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  68920 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  68926 */     GIR_RootConstrainSelectedInstOperands,
     /*  68927 */     // GIR_Coverage, 3905,
     /*  68927 */     GIR_EraseRootFromParent_Done,
     /*  68928 */   // Label 1396: @68928
     /*  68928 */   GIM_Try, /*On fail goto*//*Label 1397*/ GIMT_Encode4(69005), // Rule ID 3907 //
     /*  68933 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vsri),
     /*  68938 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  68941 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  68944 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  68947 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  68950 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  68954 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  68958 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  68962 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  68966 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  68970 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm8),
     /*  68974 */     // MIs[1] Operand 1
     /*  68974 */     // No operand predicates
     /*  68974 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  68976 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3716:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$QdSrc, MQPR:{ *:[v16i8] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_shr_imm8>>:$imm)  =>  (MVE_VSRIimm8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$QdSrc, MQPR:{ *:[v16i8] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_shr_imm8>>:$imm)
     /*  68976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSRIimm8),
     /*  68979 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  68981 */     GIR_RootToRootCopy, /*OpIdx*/2, // QdSrc
     /*  68983 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  68985 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  68988 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  68991 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  68997 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  69003 */     GIR_RootConstrainSelectedInstOperands,
     /*  69004 */     // GIR_Coverage, 3907,
     /*  69004 */     GIR_EraseRootFromParent_Done,
     /*  69005 */   // Label 1397: @69005
     /*  69005 */   GIM_Try, /*On fail goto*//*Label 1398*/ GIMT_Encode4(69082), // Rule ID 3909 //
     /*  69010 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vsri),
     /*  69015 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  69018 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  69021 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  69024 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  69027 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  69031 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  69035 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  69039 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  69043 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  69047 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm16),
     /*  69051 */     // MIs[1] Operand 1
     /*  69051 */     // No operand predicates
     /*  69051 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  69053 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3716:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$QdSrc, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_shr_imm16>>:$imm)  =>  (MVE_VSRIimm16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$QdSrc, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_shr_imm16>>:$imm)
     /*  69053 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSRIimm16),
     /*  69056 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  69058 */     GIR_RootToRootCopy, /*OpIdx*/2, // QdSrc
     /*  69060 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  69062 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  69065 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  69068 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  69074 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  69080 */     GIR_RootConstrainSelectedInstOperands,
     /*  69081 */     // GIR_Coverage, 3909,
     /*  69081 */     GIR_EraseRootFromParent_Done,
     /*  69082 */   // Label 1398: @69082
     /*  69082 */   GIM_Try, /*On fail goto*//*Label 1399*/ GIMT_Encode4(69159), // Rule ID 3911 //
     /*  69087 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vsri),
     /*  69092 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  69095 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  69098 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  69101 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  69104 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  69108 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  69112 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  69116 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  69120 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  69124 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm32),
     /*  69128 */     // MIs[1] Operand 1
     /*  69128 */     // No operand predicates
     /*  69128 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  69130 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3716:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$QdSrc, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_shr_imm32>>:$imm)  =>  (MVE_VSRIimm32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$QdSrc, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_shr_imm32>>:$imm)
     /*  69130 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSRIimm32),
     /*  69133 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  69135 */     GIR_RootToRootCopy, /*OpIdx*/2, // QdSrc
     /*  69137 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  69139 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  69142 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  69145 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  69151 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  69157 */     GIR_RootConstrainSelectedInstOperands,
     /*  69158 */     // GIR_Coverage, 3911,
     /*  69158 */     GIR_EraseRootFromParent_Done,
     /*  69159 */   // Label 1399: @69159
     /*  69159 */   GIM_Try, /*On fail goto*//*Label 1400*/ GIMT_Encode4(69250), // Rule ID 4380 //
     /*  69164 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  69167 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vcmulq),
     /*  69172 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  69175 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  69178 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  69181 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /*  69184 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  69188 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  69192 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  69196 */     // MIs[1] Operand 1
     /*  69196 */     // No operand predicates
     /*  69196 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  69200 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  69204 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  69206 */     // (intrinsic_wo_chain:{ *:[v8f16] } 3614:{ *:[iPTR] }, (imm:{ *:[i32] }):$rot, MQPR:{ *:[v8f16] }:$Qn, MQPR:{ *:[v8f16] }:$Qm)  =>  (MVE_VCMULf16:{ *:[v8f16] } MQPR:{ *:[v8f16] }:$Qn, MQPR:{ *:[v8f16] }:$Qm, (imm:{ *:[i32] }):$rot)
     /*  69206 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  69209 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  69213 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  69218 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCMULf16),
     /*  69221 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  69223 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  69225 */     GIR_RootToRootCopy, /*OpIdx*/4, // Qm
     /*  69227 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rot
     /*  69230 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  69233 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  69239 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  69245 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  69248 */     GIR_RootConstrainSelectedInstOperands,
     /*  69249 */     // GIR_Coverage, 4380,
     /*  69249 */     GIR_EraseRootFromParent_Done,
     /*  69250 */   // Label 1400: @69250
     /*  69250 */   GIM_Try, /*On fail goto*//*Label 1401*/ GIMT_Encode4(69341), // Rule ID 4382 //
     /*  69255 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  69258 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vcmulq),
     /*  69263 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  69266 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  69269 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  69272 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /*  69275 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  69279 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  69283 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  69287 */     // MIs[1] Operand 1
     /*  69287 */     // No operand predicates
     /*  69287 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  69291 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  69295 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  69297 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3614:{ *:[iPTR] }, (imm:{ *:[i32] }):$rot, MQPR:{ *:[v4f32] }:$Qn, MQPR:{ *:[v4f32] }:$Qm)  =>  (MVE_VCMULf32:{ *:[v4f32] } MQPR:{ *:[v4f32] }:$Qn, MQPR:{ *:[v4f32] }:$Qm, (imm:{ *:[i32] }):$rot)
     /*  69297 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  69300 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  69304 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  69309 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCMULf32),
     /*  69312 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  69314 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  69316 */     GIR_RootToRootCopy, /*OpIdx*/4, // Qm
     /*  69318 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rot
     /*  69321 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  69324 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  69330 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  69336 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  69339 */     GIR_RootConstrainSelectedInstOperands,
     /*  69340 */     // GIR_Coverage, 4382,
     /*  69340 */     GIR_EraseRootFromParent_Done,
     /*  69341 */   // Label 1401: @69341
     /*  69341 */   GIM_Try, /*On fail goto*//*Label 1402*/ GIMT_Encode4(69404), // Rule ID 146 //
     /*  69346 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*  69349 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_usada8),
     /*  69354 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  69357 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  69360 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  69363 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  69366 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  69370 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  69374 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  69378 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  69382 */     // (intrinsic_wo_chain:{ *:[i32] } 3940:{ *:[iPTR] }, GPR:{ *:[i32] }:$Rn, GPR:{ *:[i32] }:$Rm, GPR:{ *:[i32] }:$Ra)  =>  (USADA8:{ *:[i32] } GPR:{ *:[i32] }:$Rn, GPR:{ *:[i32] }:$Rm, GPR:{ *:[i32] }:$Ra)
     /*  69382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::USADA8),
     /*  69385 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  69387 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  69389 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  69391 */     GIR_RootToRootCopy, /*OpIdx*/4, // Ra
     /*  69393 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  69396 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  69402 */     GIR_RootConstrainSelectedInstOperands,
     /*  69403 */     // GIR_Coverage, 146,
     /*  69403 */     GIR_EraseRootFromParent_Done,
     /*  69404 */   // Label 1402: @69404
     /*  69404 */   GIM_Try, /*On fail goto*//*Label 1403*/ GIMT_Encode4(69467), // Rule ID 469 //
     /*  69409 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  69412 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_usada8),
     /*  69417 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  69420 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  69423 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  69426 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  69429 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  69433 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  69437 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  69441 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  69445 */     // (intrinsic_wo_chain:{ *:[i32] } 3940:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm, rGPR:{ *:[i32] }:$Ra)  =>  (t2USADA8:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm, rGPR:{ *:[i32] }:$Ra)
     /*  69445 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2USADA8),
     /*  69448 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  69450 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  69452 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  69454 */     GIR_RootToRootCopy, /*OpIdx*/4, // Ra
     /*  69456 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  69459 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  69465 */     GIR_RootConstrainSelectedInstOperands,
     /*  69466 */     // GIR_Coverage, 469,
     /*  69466 */     GIR_EraseRootFromParent_Done,
     /*  69467 */   // Label 1403: @69467
     /*  69467 */   GIM_Try, /*On fail goto*//*Label 1404*/ GIMT_Encode4(69530), // Rule ID 528 //
     /*  69472 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  69475 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_smlad),
     /*  69480 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  69483 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  69486 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  69489 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  69492 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  69496 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  69500 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  69504 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  69508 */     // (intrinsic_wo_chain:{ *:[i32] } 3885:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm, rGPR:{ *:[i32] }:$Ra)  =>  (t2SMLAD:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm, rGPR:{ *:[i32] }:$Ra)
     /*  69508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SMLAD),
     /*  69511 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  69513 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  69515 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  69517 */     GIR_RootToRootCopy, /*OpIdx*/4, // Ra
     /*  69519 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  69522 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  69528 */     GIR_RootConstrainSelectedInstOperands,
     /*  69529 */     // GIR_Coverage, 528,
     /*  69529 */     GIR_EraseRootFromParent_Done,
     /*  69530 */   // Label 1404: @69530
     /*  69530 */   GIM_Try, /*On fail goto*//*Label 1405*/ GIMT_Encode4(69593), // Rule ID 529 //
     /*  69535 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  69538 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_smladx),
     /*  69543 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  69546 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  69549 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  69552 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  69555 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  69559 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  69563 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  69567 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  69571 */     // (intrinsic_wo_chain:{ *:[i32] } 3886:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm, rGPR:{ *:[i32] }:$Ra)  =>  (t2SMLADX:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm, rGPR:{ *:[i32] }:$Ra)
     /*  69571 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SMLADX),
     /*  69574 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  69576 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  69578 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  69580 */     GIR_RootToRootCopy, /*OpIdx*/4, // Ra
     /*  69582 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  69585 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  69591 */     GIR_RootConstrainSelectedInstOperands,
     /*  69592 */     // GIR_Coverage, 529,
     /*  69592 */     GIR_EraseRootFromParent_Done,
     /*  69593 */   // Label 1405: @69593
     /*  69593 */   GIM_Try, /*On fail goto*//*Label 1406*/ GIMT_Encode4(69656), // Rule ID 530 //
     /*  69598 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  69601 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_smlsd),
     /*  69606 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  69609 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  69612 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  69615 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  69618 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  69622 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  69626 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  69630 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  69634 */     // (intrinsic_wo_chain:{ *:[i32] } 3893:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm, rGPR:{ *:[i32] }:$Ra)  =>  (t2SMLSD:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm, rGPR:{ *:[i32] }:$Ra)
     /*  69634 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SMLSD),
     /*  69637 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  69639 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  69641 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  69643 */     GIR_RootToRootCopy, /*OpIdx*/4, // Ra
     /*  69645 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  69648 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  69654 */     GIR_RootConstrainSelectedInstOperands,
     /*  69655 */     // GIR_Coverage, 530,
     /*  69655 */     GIR_EraseRootFromParent_Done,
     /*  69656 */   // Label 1406: @69656
     /*  69656 */   GIM_Try, /*On fail goto*//*Label 1407*/ GIMT_Encode4(69719), // Rule ID 531 //
     /*  69661 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  69664 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_smlsdx),
     /*  69669 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  69672 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  69675 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  69678 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  69681 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  69685 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  69689 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  69693 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  69697 */     // (intrinsic_wo_chain:{ *:[i32] } 3894:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm, rGPR:{ *:[i32] }:$Ra)  =>  (t2SMLSDX:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm, rGPR:{ *:[i32] }:$Ra)
     /*  69697 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SMLSDX),
     /*  69700 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  69702 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  69704 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  69706 */     GIR_RootToRootCopy, /*OpIdx*/4, // Ra
     /*  69708 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  69711 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  69717 */     GIR_RootConstrainSelectedInstOperands,
     /*  69718 */     // GIR_Coverage, 531,
     /*  69718 */     GIR_EraseRootFromParent_Done,
     /*  69719 */   // Label 1407: @69719
     /*  69719 */   GIM_Try, /*On fail goto*//*Label 1408*/ GIMT_Encode4(69773), // Rule ID 948 //
     /*  69724 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDotProd),
     /*  69727 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_udot),
     /*  69732 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  69735 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  69738 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  69741 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s8,
     /*  69744 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  69748 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  69752 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  69756 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  69760 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3746:{ *:[iPTR] }, DPR:{ *:[v2i32] }:$Vd, DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)  =>  (VUDOTD:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vd, DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /*  69760 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VUDOTD),
     /*  69763 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  69765 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /*  69767 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  69769 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /*  69771 */     GIR_RootConstrainSelectedInstOperands,
     /*  69772 */     // GIR_Coverage, 948,
     /*  69772 */     GIR_EraseRootFromParent_Done,
     /*  69773 */   // Label 1408: @69773
     /*  69773 */   GIM_Try, /*On fail goto*//*Label 1409*/ GIMT_Encode4(69827), // Rule ID 949 //
     /*  69778 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDotProd),
     /*  69781 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_sdot),
     /*  69786 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  69789 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  69792 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  69795 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s8,
     /*  69798 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  69802 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  69806 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  69810 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  69814 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3734:{ *:[iPTR] }, DPR:{ *:[v2i32] }:$Vd, DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)  =>  (VSDOTD:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vd, DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /*  69814 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSDOTD),
     /*  69817 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  69819 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /*  69821 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  69823 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /*  69825 */     GIR_RootConstrainSelectedInstOperands,
     /*  69826 */     // GIR_Coverage, 949,
     /*  69826 */     GIR_EraseRootFromParent_Done,
     /*  69827 */   // Label 1409: @69827
     /*  69827 */   GIM_Try, /*On fail goto*//*Label 1410*/ GIMT_Encode4(69881), // Rule ID 950 //
     /*  69832 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDotProd),
     /*  69835 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_udot),
     /*  69840 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  69843 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  69846 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  69849 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  69852 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  69856 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  69860 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  69864 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  69868 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3746:{ *:[iPTR] }, QPR:{ *:[v4i32] }:$Vd, QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)  =>  (VUDOTQ:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vd, QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)
     /*  69868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VUDOTQ),
     /*  69871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  69873 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /*  69875 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  69877 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /*  69879 */     GIR_RootConstrainSelectedInstOperands,
     /*  69880 */     // GIR_Coverage, 950,
     /*  69880 */     GIR_EraseRootFromParent_Done,
     /*  69881 */   // Label 1410: @69881
     /*  69881 */   GIM_Try, /*On fail goto*//*Label 1411*/ GIMT_Encode4(69935), // Rule ID 951 //
     /*  69886 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDotProd),
     /*  69889 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_sdot),
     /*  69894 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  69897 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  69900 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  69903 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  69906 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  69910 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  69914 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  69918 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  69922 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3734:{ *:[iPTR] }, QPR:{ *:[v4i32] }:$Vd, QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)  =>  (VSDOTQ:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vd, QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)
     /*  69922 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSDOTQ),
     /*  69925 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  69927 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /*  69929 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  69931 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /*  69933 */     GIR_RootConstrainSelectedInstOperands,
     /*  69934 */     // GIR_Coverage, 951,
     /*  69934 */     GIR_EraseRootFromParent_Done,
     /*  69935 */   // Label 1411: @69935
     /*  69935 */   GIM_Try, /*On fail goto*//*Label 1412*/ GIMT_Encode4(69989), // Rule ID 952 //
     /*  69940 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulInt8),
     /*  69943 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_smmla),
     /*  69948 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  69951 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  69954 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  69957 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  69960 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  69964 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  69968 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  69972 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  69976 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3745:{ *:[iPTR] }, QPR:{ *:[v4i32] }:$Vd, QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)  =>  (VSMMLA:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vd, QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)
     /*  69976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSMMLA),
     /*  69979 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  69981 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /*  69983 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  69985 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /*  69987 */     GIR_RootConstrainSelectedInstOperands,
     /*  69988 */     // GIR_Coverage, 952,
     /*  69988 */     GIR_EraseRootFromParent_Done,
     /*  69989 */   // Label 1412: @69989
     /*  69989 */   GIM_Try, /*On fail goto*//*Label 1413*/ GIMT_Encode4(70043), // Rule ID 953 //
     /*  69994 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulInt8),
     /*  69997 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_ummla),
     /*  70002 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  70005 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  70008 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  70011 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  70014 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  70018 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  70022 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  70026 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  70030 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3747:{ *:[iPTR] }, QPR:{ *:[v4i32] }:$Vd, QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)  =>  (VUMMLA:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vd, QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)
     /*  70030 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VUMMLA),
     /*  70033 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  70035 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /*  70037 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  70039 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /*  70041 */     GIR_RootConstrainSelectedInstOperands,
     /*  70042 */     // GIR_Coverage, 953,
     /*  70042 */     GIR_EraseRootFromParent_Done,
     /*  70043 */   // Label 1413: @70043
     /*  70043 */   GIM_Try, /*On fail goto*//*Label 1414*/ GIMT_Encode4(70097), // Rule ID 954 //
     /*  70048 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulInt8),
     /*  70051 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_usmmla),
     /*  70056 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  70059 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  70062 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  70065 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  70068 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  70072 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  70076 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  70080 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  70084 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3749:{ *:[iPTR] }, QPR:{ *:[v4i32] }:$Vd, QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)  =>  (VUSMMLA:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vd, QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)
     /*  70084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VUSMMLA),
     /*  70087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  70089 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /*  70091 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  70093 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /*  70095 */     GIR_RootConstrainSelectedInstOperands,
     /*  70096 */     // GIR_Coverage, 954,
     /*  70096 */     GIR_EraseRootFromParent_Done,
     /*  70097 */   // Label 1414: @70097
     /*  70097 */   GIM_Try, /*On fail goto*//*Label 1415*/ GIMT_Encode4(70151), // Rule ID 955 //
     /*  70102 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulInt8),
     /*  70105 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_usdot),
     /*  70110 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  70113 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  70116 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  70119 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s8,
     /*  70122 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  70126 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  70130 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  70134 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  70138 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3748:{ *:[iPTR] }, DPR:{ *:[v2i32] }:$Vd, DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)  =>  (VUSDOTD:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vd, DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /*  70138 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VUSDOTD),
     /*  70141 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  70143 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /*  70145 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  70147 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /*  70149 */     GIR_RootConstrainSelectedInstOperands,
     /*  70150 */     // GIR_Coverage, 955,
     /*  70150 */     GIR_EraseRootFromParent_Done,
     /*  70151 */   // Label 1415: @70151
     /*  70151 */   GIM_Try, /*On fail goto*//*Label 1416*/ GIMT_Encode4(70205), // Rule ID 956 //
     /*  70156 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulInt8),
     /*  70159 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_usdot),
     /*  70164 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  70167 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  70170 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  70173 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  70176 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  70180 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  70184 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  70188 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  70192 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3748:{ *:[iPTR] }, QPR:{ *:[v4i32] }:$Vd, QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)  =>  (VUSDOTQ:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vd, QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)
     /*  70192 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VUSDOTQ),
     /*  70195 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  70197 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /*  70199 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  70201 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /*  70203 */     GIR_RootConstrainSelectedInstOperands,
     /*  70204 */     // GIR_Coverage, 956,
     /*  70204 */     GIR_EraseRootFromParent_Done,
     /*  70205 */   // Label 1416: @70205
     /*  70205 */   GIM_Try, /*On fail goto*//*Label 1417*/ GIMT_Encode4(70268), // Rule ID 1687 //
     /*  70210 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  70213 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vtbx1),
     /*  70218 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /*  70221 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  70224 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  70227 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s8,
     /*  70230 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  70234 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  70238 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  70242 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  70246 */     // (intrinsic_wo_chain:{ *:[v8i8] } 3860:{ *:[iPTR] }, DPR:{ *:[v8i8] }:$orig, VecListOneD:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)  =>  (VTBX1:{ *:[v8i8] } DPR:{ *:[v8i8] }:$orig, VecListOneD:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /*  70246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VTBX1),
     /*  70249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  70251 */     GIR_RootToRootCopy, /*OpIdx*/2, // orig
     /*  70253 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  70255 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /*  70257 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  70260 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  70266 */     GIR_RootConstrainSelectedInstOperands,
     /*  70267 */     // GIR_Coverage, 1687,
     /*  70267 */     GIR_EraseRootFromParent_Done,
     /*  70268 */   // Label 1417: @70268
     /*  70268 */   GIM_Try, /*On fail goto*//*Label 1418*/ GIMT_Encode4(70322), // Rule ID 1718 //
     /*  70273 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA2_HasV8),
     /*  70276 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_sha1su0),
     /*  70281 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  70284 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  70287 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  70290 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /*  70293 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  70297 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  70301 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  70305 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  70309 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3739:{ *:[iPTR] }, QPR:{ *:[v4i32] }:$src, QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)  =>  (SHA1SU0:{ *:[v4i32] } QPR:{ *:[v4i32] }:$src, QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)
     /*  70309 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SHA1SU0),
     /*  70312 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  70314 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  70316 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  70318 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /*  70320 */     GIR_RootConstrainSelectedInstOperands,
     /*  70321 */     // GIR_Coverage, 1718,
     /*  70321 */     GIR_EraseRootFromParent_Done,
     /*  70322 */   // Label 1418: @70322
     /*  70322 */   GIM_Try, /*On fail goto*//*Label 1419*/ GIMT_Encode4(70376), // Rule ID 1719 //
     /*  70327 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA2_HasV8),
     /*  70330 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_sha256h),
     /*  70335 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  70338 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  70341 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  70344 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /*  70347 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  70351 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  70355 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  70359 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  70363 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3741:{ *:[iPTR] }, QPR:{ *:[v4i32] }:$src, QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)  =>  (SHA256H:{ *:[v4i32] } QPR:{ *:[v4i32] }:$src, QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)
     /*  70363 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SHA256H),
     /*  70366 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  70368 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  70370 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  70372 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /*  70374 */     GIR_RootConstrainSelectedInstOperands,
     /*  70375 */     // GIR_Coverage, 1719,
     /*  70375 */     GIR_EraseRootFromParent_Done,
     /*  70376 */   // Label 1419: @70376
     /*  70376 */   GIM_Try, /*On fail goto*//*Label 1420*/ GIMT_Encode4(70430), // Rule ID 1720 //
     /*  70381 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA2_HasV8),
     /*  70384 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_sha256h2),
     /*  70389 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  70392 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  70395 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  70398 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /*  70401 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  70405 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  70409 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  70413 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  70417 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3742:{ *:[iPTR] }, QPR:{ *:[v4i32] }:$src, QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)  =>  (SHA256H2:{ *:[v4i32] } QPR:{ *:[v4i32] }:$src, QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)
     /*  70417 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SHA256H2),
     /*  70420 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  70422 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  70424 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  70426 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /*  70428 */     GIR_RootConstrainSelectedInstOperands,
     /*  70429 */     // GIR_Coverage, 1720,
     /*  70429 */     GIR_EraseRootFromParent_Done,
     /*  70430 */   // Label 1420: @70430
     /*  70430 */   GIM_Try, /*On fail goto*//*Label 1421*/ GIMT_Encode4(70484), // Rule ID 1721 //
     /*  70435 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA2_HasV8),
     /*  70438 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_sha256su1),
     /*  70443 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  70446 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  70449 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  70452 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /*  70455 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  70459 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  70463 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  70467 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  70471 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3744:{ *:[iPTR] }, QPR:{ *:[v4i32] }:$src, QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)  =>  (SHA256SU1:{ *:[v4i32] } QPR:{ *:[v4i32] }:$src, QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)
     /*  70471 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SHA256SU1),
     /*  70474 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  70476 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  70478 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  70480 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /*  70482 */     GIR_RootConstrainSelectedInstOperands,
     /*  70483 */     // GIR_Coverage, 1721,
     /*  70483 */     GIR_EraseRootFromParent_Done,
     /*  70484 */   // Label 1421: @70484
     /*  70484 */   GIM_Try, /*On fail goto*//*Label 1422*/ GIMT_Encode4(70547), // Rule ID 1896 //
     /*  70489 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*  70492 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_smlad),
     /*  70497 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  70500 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  70503 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  70506 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  70509 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  70513 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  70517 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  70521 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  70525 */     // (intrinsic_wo_chain:{ *:[i32] } 3885:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm, GPR:{ *:[i32] }:$Ra)  =>  (SMLAD:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm, GPRnopc:{ *:[i32] }:$Ra)
     /*  70525 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SMLAD),
     /*  70528 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  70530 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  70532 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  70534 */     GIR_RootToRootCopy, /*OpIdx*/4, // Ra
     /*  70536 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  70539 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  70545 */     GIR_RootConstrainSelectedInstOperands,
     /*  70546 */     // GIR_Coverage, 1896,
     /*  70546 */     GIR_EraseRootFromParent_Done,
     /*  70547 */   // Label 1422: @70547
     /*  70547 */   GIM_Try, /*On fail goto*//*Label 1423*/ GIMT_Encode4(70610), // Rule ID 1897 //
     /*  70552 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*  70555 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_smladx),
     /*  70560 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  70563 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  70566 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  70569 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  70572 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  70576 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  70580 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  70584 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  70588 */     // (intrinsic_wo_chain:{ *:[i32] } 3886:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm, GPR:{ *:[i32] }:$Ra)  =>  (SMLADX:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm, GPRnopc:{ *:[i32] }:$Ra)
     /*  70588 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SMLADX),
     /*  70591 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  70593 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  70595 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  70597 */     GIR_RootToRootCopy, /*OpIdx*/4, // Ra
     /*  70599 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  70602 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  70608 */     GIR_RootConstrainSelectedInstOperands,
     /*  70609 */     // GIR_Coverage, 1897,
     /*  70609 */     GIR_EraseRootFromParent_Done,
     /*  70610 */   // Label 1423: @70610
     /*  70610 */   GIM_Try, /*On fail goto*//*Label 1424*/ GIMT_Encode4(70673), // Rule ID 1898 //
     /*  70615 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*  70618 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_smlsd),
     /*  70623 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  70626 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  70629 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  70632 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  70635 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  70639 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  70643 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  70647 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  70651 */     // (intrinsic_wo_chain:{ *:[i32] } 3893:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm, GPR:{ *:[i32] }:$Ra)  =>  (SMLSD:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm, GPRnopc:{ *:[i32] }:$Ra)
     /*  70651 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SMLSD),
     /*  70654 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  70656 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  70658 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  70660 */     GIR_RootToRootCopy, /*OpIdx*/4, // Ra
     /*  70662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  70665 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  70671 */     GIR_RootConstrainSelectedInstOperands,
     /*  70672 */     // GIR_Coverage, 1898,
     /*  70672 */     GIR_EraseRootFromParent_Done,
     /*  70673 */   // Label 1424: @70673
     /*  70673 */   GIM_Try, /*On fail goto*//*Label 1425*/ GIMT_Encode4(70736), // Rule ID 1899 //
     /*  70678 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*  70681 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_smlsdx),
     /*  70686 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  70689 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  70692 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  70695 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  70698 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  70702 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  70706 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  70710 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  70714 */     // (intrinsic_wo_chain:{ *:[i32] } 3894:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm, GPR:{ *:[i32] }:$Ra)  =>  (SMLSDX:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm, GPRnopc:{ *:[i32] }:$Ra)
     /*  70714 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SMLSDX),
     /*  70717 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  70719 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  70721 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  70723 */     GIR_RootToRootCopy, /*OpIdx*/4, // Ra
     /*  70725 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  70728 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  70734 */     GIR_RootConstrainSelectedInstOperands,
     /*  70735 */     // GIR_Coverage, 1899,
     /*  70735 */     GIR_EraseRootFromParent_Done,
     /*  70736 */   // Label 1425: @70736
     /*  70736 */   GIM_Try, /*On fail goto*//*Label 1426*/ GIMT_Encode4(70799), // Rule ID 1987 //
     /*  70741 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV5TE_IsARM),
     /*  70744 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_smlabb),
     /*  70749 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  70752 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  70755 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  70758 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  70761 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  70765 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  70769 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  70773 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  70777 */     // (intrinsic_wo_chain:{ *:[i32] } 3883:{ *:[iPTR] }, GPR:{ *:[i32] }:$a, GPR:{ *:[i32] }:$b, GPR:{ *:[i32] }:$acc)  =>  (SMLABB:{ *:[i32] } GPR:{ *:[i32] }:$a, GPR:{ *:[i32] }:$b, GPR:{ *:[i32] }:$acc)
     /*  70777 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SMLABB),
     /*  70780 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  70782 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  70784 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /*  70786 */     GIR_RootToRootCopy, /*OpIdx*/4, // acc
     /*  70788 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  70791 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  70797 */     GIR_RootConstrainSelectedInstOperands,
     /*  70798 */     // GIR_Coverage, 1987,
     /*  70798 */     GIR_EraseRootFromParent_Done,
     /*  70799 */   // Label 1426: @70799
     /*  70799 */   GIM_Try, /*On fail goto*//*Label 1427*/ GIMT_Encode4(70862), // Rule ID 1988 //
     /*  70804 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV5TE_IsARM),
     /*  70807 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_smlabt),
     /*  70812 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  70815 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  70818 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  70821 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  70824 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  70828 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  70832 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  70836 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  70840 */     // (intrinsic_wo_chain:{ *:[i32] } 3884:{ *:[iPTR] }, GPR:{ *:[i32] }:$a, GPR:{ *:[i32] }:$b, GPR:{ *:[i32] }:$acc)  =>  (SMLABT:{ *:[i32] } GPR:{ *:[i32] }:$a, GPR:{ *:[i32] }:$b, GPR:{ *:[i32] }:$acc)
     /*  70840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SMLABT),
     /*  70843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  70845 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  70847 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /*  70849 */     GIR_RootToRootCopy, /*OpIdx*/4, // acc
     /*  70851 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  70854 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  70860 */     GIR_RootConstrainSelectedInstOperands,
     /*  70861 */     // GIR_Coverage, 1988,
     /*  70861 */     GIR_EraseRootFromParent_Done,
     /*  70862 */   // Label 1427: @70862
     /*  70862 */   GIM_Try, /*On fail goto*//*Label 1428*/ GIMT_Encode4(70925), // Rule ID 1989 //
     /*  70867 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV5TE_IsARM),
     /*  70870 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_smlatb),
     /*  70875 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  70878 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  70881 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  70884 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  70887 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  70891 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  70895 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  70899 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  70903 */     // (intrinsic_wo_chain:{ *:[i32] } 3889:{ *:[iPTR] }, GPR:{ *:[i32] }:$a, GPR:{ *:[i32] }:$b, GPR:{ *:[i32] }:$acc)  =>  (SMLATB:{ *:[i32] } GPR:{ *:[i32] }:$a, GPR:{ *:[i32] }:$b, GPR:{ *:[i32] }:$acc)
     /*  70903 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SMLATB),
     /*  70906 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  70908 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  70910 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /*  70912 */     GIR_RootToRootCopy, /*OpIdx*/4, // acc
     /*  70914 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  70917 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  70923 */     GIR_RootConstrainSelectedInstOperands,
     /*  70924 */     // GIR_Coverage, 1989,
     /*  70924 */     GIR_EraseRootFromParent_Done,
     /*  70925 */   // Label 1428: @70925
     /*  70925 */   GIM_Try, /*On fail goto*//*Label 1429*/ GIMT_Encode4(70988), // Rule ID 1990 //
     /*  70930 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV5TE_IsARM),
     /*  70933 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_smlatt),
     /*  70938 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  70941 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  70944 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  70947 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  70950 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  70954 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  70958 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  70962 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  70966 */     // (intrinsic_wo_chain:{ *:[i32] } 3890:{ *:[iPTR] }, GPR:{ *:[i32] }:$a, GPR:{ *:[i32] }:$b, GPR:{ *:[i32] }:$acc)  =>  (SMLATT:{ *:[i32] } GPR:{ *:[i32] }:$a, GPR:{ *:[i32] }:$b, GPR:{ *:[i32] }:$acc)
     /*  70966 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SMLATT),
     /*  70969 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  70971 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  70973 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /*  70975 */     GIR_RootToRootCopy, /*OpIdx*/4, // acc
     /*  70977 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  70980 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  70986 */     GIR_RootConstrainSelectedInstOperands,
     /*  70987 */     // GIR_Coverage, 1990,
     /*  70987 */     GIR_EraseRootFromParent_Done,
     /*  70988 */   // Label 1429: @70988
     /*  70988 */   GIM_Try, /*On fail goto*//*Label 1430*/ GIMT_Encode4(71051), // Rule ID 1991 //
     /*  70993 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV5TE_IsARM),
     /*  70996 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_smlawb),
     /*  71001 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  71004 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  71007 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  71010 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  71013 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  71017 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  71021 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  71025 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  71029 */     // (intrinsic_wo_chain:{ *:[i32] } 3891:{ *:[iPTR] }, GPR:{ *:[i32] }:$a, GPR:{ *:[i32] }:$b, GPR:{ *:[i32] }:$acc)  =>  (SMLAWB:{ *:[i32] } GPR:{ *:[i32] }:$a, GPR:{ *:[i32] }:$b, GPR:{ *:[i32] }:$acc)
     /*  71029 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SMLAWB),
     /*  71032 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  71034 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  71036 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /*  71038 */     GIR_RootToRootCopy, /*OpIdx*/4, // acc
     /*  71040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  71043 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  71049 */     GIR_RootConstrainSelectedInstOperands,
     /*  71050 */     // GIR_Coverage, 1991,
     /*  71050 */     GIR_EraseRootFromParent_Done,
     /*  71051 */   // Label 1430: @71051
     /*  71051 */   GIM_Try, /*On fail goto*//*Label 1431*/ GIMT_Encode4(71114), // Rule ID 1992 //
     /*  71056 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV5TE_IsARM),
     /*  71059 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_smlawt),
     /*  71064 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  71067 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  71070 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  71073 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  71076 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  71080 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  71084 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  71088 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  71092 */     // (intrinsic_wo_chain:{ *:[i32] } 3892:{ *:[iPTR] }, GPR:{ *:[i32] }:$a, GPR:{ *:[i32] }:$b, GPR:{ *:[i32] }:$acc)  =>  (SMLAWT:{ *:[i32] } GPR:{ *:[i32] }:$a, GPR:{ *:[i32] }:$b, GPR:{ *:[i32] }:$acc)
     /*  71092 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SMLAWT),
     /*  71095 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  71097 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  71099 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /*  71101 */     GIR_RootToRootCopy, /*OpIdx*/4, // acc
     /*  71103 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  71106 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  71112 */     GIR_RootConstrainSelectedInstOperands,
     /*  71113 */     // GIR_Coverage, 1992,
     /*  71113 */     GIR_EraseRootFromParent_Done,
     /*  71114 */   // Label 1431: @71114
     /*  71114 */   GIM_Try, /*On fail goto*//*Label 1432*/ GIMT_Encode4(71177), // Rule ID 2178 //
     /*  71119 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  71122 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_smlabb),
     /*  71127 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  71130 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  71133 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  71136 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  71139 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  71143 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  71147 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  71151 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  71155 */     // (intrinsic_wo_chain:{ *:[i32] } 3883:{ *:[iPTR] }, GPR:{ *:[i32] }:$a, GPR:{ *:[i32] }:$b, GPR:{ *:[i32] }:$acc)  =>  (t2SMLABB:{ *:[i32] } GPR:{ *:[i32] }:$a, GPR:{ *:[i32] }:$b, GPR:{ *:[i32] }:$acc)
     /*  71155 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SMLABB),
     /*  71158 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  71160 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  71162 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /*  71164 */     GIR_RootToRootCopy, /*OpIdx*/4, // acc
     /*  71166 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  71169 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  71175 */     GIR_RootConstrainSelectedInstOperands,
     /*  71176 */     // GIR_Coverage, 2178,
     /*  71176 */     GIR_EraseRootFromParent_Done,
     /*  71177 */   // Label 1432: @71177
     /*  71177 */   GIM_Try, /*On fail goto*//*Label 1433*/ GIMT_Encode4(71240), // Rule ID 2179 //
     /*  71182 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  71185 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_smlabt),
     /*  71190 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  71193 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  71196 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  71199 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  71202 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  71206 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  71210 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  71214 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  71218 */     // (intrinsic_wo_chain:{ *:[i32] } 3884:{ *:[iPTR] }, GPR:{ *:[i32] }:$a, GPR:{ *:[i32] }:$b, GPR:{ *:[i32] }:$acc)  =>  (t2SMLABT:{ *:[i32] } GPR:{ *:[i32] }:$a, GPR:{ *:[i32] }:$b, GPR:{ *:[i32] }:$acc)
     /*  71218 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SMLABT),
     /*  71221 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  71223 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  71225 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /*  71227 */     GIR_RootToRootCopy, /*OpIdx*/4, // acc
     /*  71229 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  71232 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  71238 */     GIR_RootConstrainSelectedInstOperands,
     /*  71239 */     // GIR_Coverage, 2179,
     /*  71239 */     GIR_EraseRootFromParent_Done,
     /*  71240 */   // Label 1433: @71240
     /*  71240 */   GIM_Try, /*On fail goto*//*Label 1434*/ GIMT_Encode4(71303), // Rule ID 2180 //
     /*  71245 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  71248 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_smlatb),
     /*  71253 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  71256 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  71259 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  71262 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  71265 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  71269 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  71273 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  71277 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  71281 */     // (intrinsic_wo_chain:{ *:[i32] } 3889:{ *:[iPTR] }, GPR:{ *:[i32] }:$a, GPR:{ *:[i32] }:$b, GPR:{ *:[i32] }:$acc)  =>  (t2SMLATB:{ *:[i32] } GPR:{ *:[i32] }:$a, GPR:{ *:[i32] }:$b, GPR:{ *:[i32] }:$acc)
     /*  71281 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SMLATB),
     /*  71284 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  71286 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  71288 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /*  71290 */     GIR_RootToRootCopy, /*OpIdx*/4, // acc
     /*  71292 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  71295 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  71301 */     GIR_RootConstrainSelectedInstOperands,
     /*  71302 */     // GIR_Coverage, 2180,
     /*  71302 */     GIR_EraseRootFromParent_Done,
     /*  71303 */   // Label 1434: @71303
     /*  71303 */   GIM_Try, /*On fail goto*//*Label 1435*/ GIMT_Encode4(71366), // Rule ID 2181 //
     /*  71308 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  71311 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_smlatt),
     /*  71316 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  71319 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  71322 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  71325 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  71328 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  71332 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  71336 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  71340 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  71344 */     // (intrinsic_wo_chain:{ *:[i32] } 3890:{ *:[iPTR] }, GPR:{ *:[i32] }:$a, GPR:{ *:[i32] }:$b, GPR:{ *:[i32] }:$acc)  =>  (t2SMLATT:{ *:[i32] } GPR:{ *:[i32] }:$a, GPR:{ *:[i32] }:$b, GPR:{ *:[i32] }:$acc)
     /*  71344 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SMLATT),
     /*  71347 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  71349 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  71351 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /*  71353 */     GIR_RootToRootCopy, /*OpIdx*/4, // acc
     /*  71355 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  71358 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  71364 */     GIR_RootConstrainSelectedInstOperands,
     /*  71365 */     // GIR_Coverage, 2181,
     /*  71365 */     GIR_EraseRootFromParent_Done,
     /*  71366 */   // Label 1435: @71366
     /*  71366 */   GIM_Try, /*On fail goto*//*Label 1436*/ GIMT_Encode4(71429), // Rule ID 2182 //
     /*  71371 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  71374 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_smlawb),
     /*  71379 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  71382 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  71385 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  71388 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  71391 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  71395 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  71399 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  71403 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  71407 */     // (intrinsic_wo_chain:{ *:[i32] } 3891:{ *:[iPTR] }, GPR:{ *:[i32] }:$a, GPR:{ *:[i32] }:$b, GPR:{ *:[i32] }:$acc)  =>  (t2SMLAWB:{ *:[i32] } GPR:{ *:[i32] }:$a, GPR:{ *:[i32] }:$b, GPR:{ *:[i32] }:$acc)
     /*  71407 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SMLAWB),
     /*  71410 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  71412 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  71414 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /*  71416 */     GIR_RootToRootCopy, /*OpIdx*/4, // acc
     /*  71418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  71421 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  71427 */     GIR_RootConstrainSelectedInstOperands,
     /*  71428 */     // GIR_Coverage, 2182,
     /*  71428 */     GIR_EraseRootFromParent_Done,
     /*  71429 */   // Label 1436: @71429
     /*  71429 */   GIM_Try, /*On fail goto*//*Label 1437*/ GIMT_Encode4(71492), // Rule ID 2183 //
     /*  71434 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  71437 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_smlawt),
     /*  71442 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  71445 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  71448 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  71451 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  71454 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  71458 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  71462 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  71466 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  71470 */     // (intrinsic_wo_chain:{ *:[i32] } 3892:{ *:[iPTR] }, GPR:{ *:[i32] }:$a, GPR:{ *:[i32] }:$b, GPR:{ *:[i32] }:$acc)  =>  (t2SMLAWT:{ *:[i32] } GPR:{ *:[i32] }:$a, GPR:{ *:[i32] }:$b, GPR:{ *:[i32] }:$acc)
     /*  71470 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SMLAWT),
     /*  71473 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  71475 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  71477 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /*  71479 */     GIR_RootToRootCopy, /*OpIdx*/4, // acc
     /*  71481 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  71484 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  71490 */     GIR_RootConstrainSelectedInstOperands,
     /*  71491 */     // GIR_Coverage, 2183,
     /*  71491 */     GIR_EraseRootFromParent_Done,
     /*  71492 */   // Label 1437: @71492
     /*  71492 */   GIM_Try, /*On fail goto*//*Label 1438*/ GIMT_Encode4(71555), // Rule ID 2469 //
     /*  71497 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasV8_1a),
     /*  71500 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqrdmlah),
     /*  71505 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  71508 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  71511 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  71514 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
     /*  71517 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  71521 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  71525 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  71529 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  71533 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3818:{ *:[iPTR] }, DPR:{ *:[v4i16] }:$src1, DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)  =>  (VQRDMLAHv4i16:{ *:[v4i16] } DPR:{ *:[v4i16] }:$src1, DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /*  71533 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQRDMLAHv4i16),
     /*  71536 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  71538 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  71540 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  71542 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /*  71544 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  71547 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  71553 */     GIR_RootConstrainSelectedInstOperands,
     /*  71554 */     // GIR_Coverage, 2469,
     /*  71554 */     GIR_EraseRootFromParent_Done,
     /*  71555 */   // Label 1438: @71555
     /*  71555 */   GIM_Try, /*On fail goto*//*Label 1439*/ GIMT_Encode4(71618), // Rule ID 2470 //
     /*  71560 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasV8_1a),
     /*  71563 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqrdmlah),
     /*  71568 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  71571 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  71574 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  71577 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s32,
     /*  71580 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  71584 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  71588 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  71592 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  71596 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3818:{ *:[iPTR] }, DPR:{ *:[v2i32] }:$src1, DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)  =>  (VQRDMLAHv2i32:{ *:[v2i32] } DPR:{ *:[v2i32] }:$src1, DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /*  71596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQRDMLAHv2i32),
     /*  71599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  71601 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  71603 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  71605 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /*  71607 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  71610 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  71616 */     GIR_RootConstrainSelectedInstOperands,
     /*  71617 */     // GIR_Coverage, 2470,
     /*  71617 */     GIR_EraseRootFromParent_Done,
     /*  71618 */   // Label 1439: @71618
     /*  71618 */   GIM_Try, /*On fail goto*//*Label 1440*/ GIMT_Encode4(71681), // Rule ID 2471 //
     /*  71623 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasV8_1a),
     /*  71626 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqrdmlah),
     /*  71631 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  71634 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  71637 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  71640 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /*  71643 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  71647 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  71651 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  71655 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  71659 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3818:{ *:[iPTR] }, QPR:{ *:[v8i16] }:$src1, QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)  =>  (VQRDMLAHv8i16:{ *:[v8i16] } QPR:{ *:[v8i16] }:$src1, QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)
     /*  71659 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQRDMLAHv8i16),
     /*  71662 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  71664 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  71666 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  71668 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /*  71670 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  71673 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  71679 */     GIR_RootConstrainSelectedInstOperands,
     /*  71680 */     // GIR_Coverage, 2471,
     /*  71680 */     GIR_EraseRootFromParent_Done,
     /*  71681 */   // Label 1440: @71681
     /*  71681 */   GIM_Try, /*On fail goto*//*Label 1441*/ GIMT_Encode4(71744), // Rule ID 2472 //
     /*  71686 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasV8_1a),
     /*  71689 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqrdmlah),
     /*  71694 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  71697 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  71700 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  71703 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /*  71706 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  71710 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  71714 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  71718 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  71722 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3818:{ *:[iPTR] }, QPR:{ *:[v4i32] }:$src1, QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)  =>  (VQRDMLAHv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$src1, QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)
     /*  71722 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQRDMLAHv4i32),
     /*  71725 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  71727 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  71729 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  71731 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /*  71733 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  71736 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  71742 */     GIR_RootConstrainSelectedInstOperands,
     /*  71743 */     // GIR_Coverage, 2472,
     /*  71743 */     GIR_EraseRootFromParent_Done,
     /*  71744 */   // Label 1441: @71744
     /*  71744 */   GIM_Try, /*On fail goto*//*Label 1442*/ GIMT_Encode4(71807), // Rule ID 2477 //
     /*  71749 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasV8_1a),
     /*  71752 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqrdmlsh),
     /*  71757 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  71760 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  71763 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  71766 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
     /*  71769 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  71773 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  71777 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  71781 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  71785 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3819:{ *:[iPTR] }, DPR:{ *:[v4i16] }:$src1, DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)  =>  (VQRDMLSHv4i16:{ *:[v4i16] } DPR:{ *:[v4i16] }:$src1, DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /*  71785 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQRDMLSHv4i16),
     /*  71788 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  71790 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  71792 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  71794 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /*  71796 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  71799 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  71805 */     GIR_RootConstrainSelectedInstOperands,
     /*  71806 */     // GIR_Coverage, 2477,
     /*  71806 */     GIR_EraseRootFromParent_Done,
     /*  71807 */   // Label 1442: @71807
     /*  71807 */   GIM_Try, /*On fail goto*//*Label 1443*/ GIMT_Encode4(71870), // Rule ID 2478 //
     /*  71812 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasV8_1a),
     /*  71815 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqrdmlsh),
     /*  71820 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  71823 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  71826 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  71829 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s32,
     /*  71832 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  71836 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  71840 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  71844 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  71848 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3819:{ *:[iPTR] }, DPR:{ *:[v2i32] }:$src1, DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)  =>  (VQRDMLSHv2i32:{ *:[v2i32] } DPR:{ *:[v2i32] }:$src1, DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /*  71848 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQRDMLSHv2i32),
     /*  71851 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  71853 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  71855 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  71857 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /*  71859 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  71862 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  71868 */     GIR_RootConstrainSelectedInstOperands,
     /*  71869 */     // GIR_Coverage, 2478,
     /*  71869 */     GIR_EraseRootFromParent_Done,
     /*  71870 */   // Label 1443: @71870
     /*  71870 */   GIM_Try, /*On fail goto*//*Label 1444*/ GIMT_Encode4(71933), // Rule ID 2479 //
     /*  71875 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasV8_1a),
     /*  71878 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqrdmlsh),
     /*  71883 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  71886 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  71889 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  71892 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /*  71895 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  71899 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  71903 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  71907 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  71911 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3819:{ *:[iPTR] }, QPR:{ *:[v8i16] }:$src1, QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)  =>  (VQRDMLSHv8i16:{ *:[v8i16] } QPR:{ *:[v8i16] }:$src1, QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)
     /*  71911 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQRDMLSHv8i16),
     /*  71914 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  71916 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  71918 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  71920 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /*  71922 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  71925 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  71931 */     GIR_RootConstrainSelectedInstOperands,
     /*  71932 */     // GIR_Coverage, 2479,
     /*  71932 */     GIR_EraseRootFromParent_Done,
     /*  71933 */   // Label 1444: @71933
     /*  71933 */   GIM_Try, /*On fail goto*//*Label 1445*/ GIMT_Encode4(71996), // Rule ID 2480 //
     /*  71938 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasV8_1a),
     /*  71941 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqrdmlsh),
     /*  71946 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  71949 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  71952 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  71955 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /*  71958 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  71962 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  71966 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  71970 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  71974 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3819:{ *:[iPTR] }, QPR:{ *:[v4i32] }:$src1, QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)  =>  (VQRDMLSHv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$src1, QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)
     /*  71974 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQRDMLSHv4i32),
     /*  71977 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  71979 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  71981 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  71983 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /*  71985 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  71988 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  71994 */     GIR_RootConstrainSelectedInstOperands,
     /*  71995 */     // GIR_Coverage, 2480,
     /*  71995 */     GIR_EraseRootFromParent_Done,
     /*  71996 */   // Label 1445: @71996
     /*  71996 */   GIM_Try, /*On fail goto*//*Label 1446*/ GIMT_Encode4(72065), // Rule ID 4837 //
     /*  72001 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  72004 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqdmlah),
     /*  72009 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  72012 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  72015 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  72018 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  72021 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  72025 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  72029 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  72033 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  72037 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3670:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$v1, MQPR:{ *:[v16i8] }:$v2, rGPR:{ *:[i32] }:$s)  =>  (MVE_VQDMLAH_qrs8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$v1, MQPR:{ *:[v16i8] }:$v2, rGPR:{ *:[i32] }:$s)
     /*  72037 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQDMLAH_qrs8),
     /*  72040 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  72042 */     GIR_RootToRootCopy, /*OpIdx*/2, // v1
     /*  72044 */     GIR_RootToRootCopy, /*OpIdx*/3, // v2
     /*  72046 */     GIR_RootToRootCopy, /*OpIdx*/4, // s
     /*  72048 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  72051 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  72057 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  72063 */     GIR_RootConstrainSelectedInstOperands,
     /*  72064 */     // GIR_Coverage, 4837,
     /*  72064 */     GIR_EraseRootFromParent_Done,
     /*  72065 */   // Label 1446: @72065
     /*  72065 */   GIM_Try, /*On fail goto*//*Label 1447*/ GIMT_Encode4(72134), // Rule ID 4839 //
     /*  72070 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  72073 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqdmlah),
     /*  72078 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  72081 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  72084 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  72087 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  72090 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  72094 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  72098 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  72102 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  72106 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3670:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$v1, MQPR:{ *:[v8i16] }:$v2, rGPR:{ *:[i32] }:$s)  =>  (MVE_VQDMLAH_qrs16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$v1, MQPR:{ *:[v8i16] }:$v2, rGPR:{ *:[i32] }:$s)
     /*  72106 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQDMLAH_qrs16),
     /*  72109 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  72111 */     GIR_RootToRootCopy, /*OpIdx*/2, // v1
     /*  72113 */     GIR_RootToRootCopy, /*OpIdx*/3, // v2
     /*  72115 */     GIR_RootToRootCopy, /*OpIdx*/4, // s
     /*  72117 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  72120 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  72126 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  72132 */     GIR_RootConstrainSelectedInstOperands,
     /*  72133 */     // GIR_Coverage, 4839,
     /*  72133 */     GIR_EraseRootFromParent_Done,
     /*  72134 */   // Label 1447: @72134
     /*  72134 */   GIM_Try, /*On fail goto*//*Label 1448*/ GIMT_Encode4(72203), // Rule ID 4841 //
     /*  72139 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  72142 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqdmlah),
     /*  72147 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  72150 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  72153 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  72156 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  72159 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  72163 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  72167 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  72171 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  72175 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3670:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$v1, MQPR:{ *:[v4i32] }:$v2, rGPR:{ *:[i32] }:$s)  =>  (MVE_VQDMLAH_qrs32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$v1, MQPR:{ *:[v4i32] }:$v2, rGPR:{ *:[i32] }:$s)
     /*  72175 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQDMLAH_qrs32),
     /*  72178 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  72180 */     GIR_RootToRootCopy, /*OpIdx*/2, // v1
     /*  72182 */     GIR_RootToRootCopy, /*OpIdx*/3, // v2
     /*  72184 */     GIR_RootToRootCopy, /*OpIdx*/4, // s
     /*  72186 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  72189 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  72195 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  72201 */     GIR_RootConstrainSelectedInstOperands,
     /*  72202 */     // GIR_Coverage, 4841,
     /*  72202 */     GIR_EraseRootFromParent_Done,
     /*  72203 */   // Label 1448: @72203
     /*  72203 */   GIM_Try, /*On fail goto*//*Label 1449*/ GIMT_Encode4(72272), // Rule ID 4843 //
     /*  72208 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  72211 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqrdmlah),
     /*  72216 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  72219 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  72222 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  72225 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  72228 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  72232 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  72236 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  72240 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  72244 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3679:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$v1, MQPR:{ *:[v16i8] }:$v2, rGPR:{ *:[i32] }:$s)  =>  (MVE_VQRDMLAH_qrs8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$v1, MQPR:{ *:[v16i8] }:$v2, rGPR:{ *:[i32] }:$s)
     /*  72244 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQRDMLAH_qrs8),
     /*  72247 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  72249 */     GIR_RootToRootCopy, /*OpIdx*/2, // v1
     /*  72251 */     GIR_RootToRootCopy, /*OpIdx*/3, // v2
     /*  72253 */     GIR_RootToRootCopy, /*OpIdx*/4, // s
     /*  72255 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  72258 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  72264 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  72270 */     GIR_RootConstrainSelectedInstOperands,
     /*  72271 */     // GIR_Coverage, 4843,
     /*  72271 */     GIR_EraseRootFromParent_Done,
     /*  72272 */   // Label 1449: @72272
     /*  72272 */   GIM_Try, /*On fail goto*//*Label 1450*/ GIMT_Encode4(72341), // Rule ID 4845 //
     /*  72277 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  72280 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqrdmlah),
     /*  72285 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  72288 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  72291 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  72294 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  72297 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  72301 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  72305 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  72309 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  72313 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3679:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$v1, MQPR:{ *:[v8i16] }:$v2, rGPR:{ *:[i32] }:$s)  =>  (MVE_VQRDMLAH_qrs16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$v1, MQPR:{ *:[v8i16] }:$v2, rGPR:{ *:[i32] }:$s)
     /*  72313 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQRDMLAH_qrs16),
     /*  72316 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  72318 */     GIR_RootToRootCopy, /*OpIdx*/2, // v1
     /*  72320 */     GIR_RootToRootCopy, /*OpIdx*/3, // v2
     /*  72322 */     GIR_RootToRootCopy, /*OpIdx*/4, // s
     /*  72324 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  72327 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  72333 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  72339 */     GIR_RootConstrainSelectedInstOperands,
     /*  72340 */     // GIR_Coverage, 4845,
     /*  72340 */     GIR_EraseRootFromParent_Done,
     /*  72341 */   // Label 1450: @72341
     /*  72341 */   GIM_Try, /*On fail goto*//*Label 1451*/ GIMT_Encode4(72410), // Rule ID 4847 //
     /*  72346 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  72349 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqrdmlah),
     /*  72354 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  72357 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  72360 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  72363 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  72366 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  72370 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  72374 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  72378 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  72382 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3679:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$v1, MQPR:{ *:[v4i32] }:$v2, rGPR:{ *:[i32] }:$s)  =>  (MVE_VQRDMLAH_qrs32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$v1, MQPR:{ *:[v4i32] }:$v2, rGPR:{ *:[i32] }:$s)
     /*  72382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQRDMLAH_qrs32),
     /*  72385 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  72387 */     GIR_RootToRootCopy, /*OpIdx*/2, // v1
     /*  72389 */     GIR_RootToRootCopy, /*OpIdx*/3, // v2
     /*  72391 */     GIR_RootToRootCopy, /*OpIdx*/4, // s
     /*  72393 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  72396 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  72402 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  72408 */     GIR_RootConstrainSelectedInstOperands,
     /*  72409 */     // GIR_Coverage, 4847,
     /*  72409 */     GIR_EraseRootFromParent_Done,
     /*  72410 */   // Label 1451: @72410
     /*  72410 */   GIM_Try, /*On fail goto*//*Label 1452*/ GIMT_Encode4(72479), // Rule ID 4849 //
     /*  72415 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  72418 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqdmlash),
     /*  72423 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  72426 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  72429 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  72432 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  72435 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  72439 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  72443 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  72447 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  72451 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3672:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$v1, MQPR:{ *:[v16i8] }:$v2, rGPR:{ *:[i32] }:$s)  =>  (MVE_VQDMLASH_qrs8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$v1, MQPR:{ *:[v16i8] }:$v2, rGPR:{ *:[i32] }:$s)
     /*  72451 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQDMLASH_qrs8),
     /*  72454 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  72456 */     GIR_RootToRootCopy, /*OpIdx*/2, // v1
     /*  72458 */     GIR_RootToRootCopy, /*OpIdx*/3, // v2
     /*  72460 */     GIR_RootToRootCopy, /*OpIdx*/4, // s
     /*  72462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  72465 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  72471 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  72477 */     GIR_RootConstrainSelectedInstOperands,
     /*  72478 */     // GIR_Coverage, 4849,
     /*  72478 */     GIR_EraseRootFromParent_Done,
     /*  72479 */   // Label 1452: @72479
     /*  72479 */   GIM_Try, /*On fail goto*//*Label 1453*/ GIMT_Encode4(72548), // Rule ID 4851 //
     /*  72484 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  72487 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqdmlash),
     /*  72492 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  72495 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  72498 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  72501 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  72504 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  72508 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  72512 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  72516 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  72520 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3672:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$v1, MQPR:{ *:[v8i16] }:$v2, rGPR:{ *:[i32] }:$s)  =>  (MVE_VQDMLASH_qrs16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$v1, MQPR:{ *:[v8i16] }:$v2, rGPR:{ *:[i32] }:$s)
     /*  72520 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQDMLASH_qrs16),
     /*  72523 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  72525 */     GIR_RootToRootCopy, /*OpIdx*/2, // v1
     /*  72527 */     GIR_RootToRootCopy, /*OpIdx*/3, // v2
     /*  72529 */     GIR_RootToRootCopy, /*OpIdx*/4, // s
     /*  72531 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  72534 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  72540 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  72546 */     GIR_RootConstrainSelectedInstOperands,
     /*  72547 */     // GIR_Coverage, 4851,
     /*  72547 */     GIR_EraseRootFromParent_Done,
     /*  72548 */   // Label 1453: @72548
     /*  72548 */   GIM_Try, /*On fail goto*//*Label 1454*/ GIMT_Encode4(72617), // Rule ID 4853 //
     /*  72553 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  72556 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqdmlash),
     /*  72561 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  72564 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  72567 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  72570 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  72573 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  72577 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  72581 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  72585 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  72589 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3672:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$v1, MQPR:{ *:[v4i32] }:$v2, rGPR:{ *:[i32] }:$s)  =>  (MVE_VQDMLASH_qrs32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$v1, MQPR:{ *:[v4i32] }:$v2, rGPR:{ *:[i32] }:$s)
     /*  72589 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQDMLASH_qrs32),
     /*  72592 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  72594 */     GIR_RootToRootCopy, /*OpIdx*/2, // v1
     /*  72596 */     GIR_RootToRootCopy, /*OpIdx*/3, // v2
     /*  72598 */     GIR_RootToRootCopy, /*OpIdx*/4, // s
     /*  72600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  72603 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  72609 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  72615 */     GIR_RootConstrainSelectedInstOperands,
     /*  72616 */     // GIR_Coverage, 4853,
     /*  72616 */     GIR_EraseRootFromParent_Done,
     /*  72617 */   // Label 1454: @72617
     /*  72617 */   GIM_Try, /*On fail goto*//*Label 1455*/ GIMT_Encode4(72686), // Rule ID 4855 //
     /*  72622 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  72625 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqrdmlash),
     /*  72630 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  72633 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  72636 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  72639 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  72642 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  72646 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  72650 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  72654 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  72658 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3681:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$v1, MQPR:{ *:[v16i8] }:$v2, rGPR:{ *:[i32] }:$s)  =>  (MVE_VQRDMLASH_qrs8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$v1, MQPR:{ *:[v16i8] }:$v2, rGPR:{ *:[i32] }:$s)
     /*  72658 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQRDMLASH_qrs8),
     /*  72661 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  72663 */     GIR_RootToRootCopy, /*OpIdx*/2, // v1
     /*  72665 */     GIR_RootToRootCopy, /*OpIdx*/3, // v2
     /*  72667 */     GIR_RootToRootCopy, /*OpIdx*/4, // s
     /*  72669 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  72672 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  72678 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  72684 */     GIR_RootConstrainSelectedInstOperands,
     /*  72685 */     // GIR_Coverage, 4855,
     /*  72685 */     GIR_EraseRootFromParent_Done,
     /*  72686 */   // Label 1455: @72686
     /*  72686 */   GIM_Try, /*On fail goto*//*Label 1456*/ GIMT_Encode4(72755), // Rule ID 4857 //
     /*  72691 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  72694 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqrdmlash),
     /*  72699 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  72702 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  72705 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  72708 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  72711 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  72715 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  72719 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  72723 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  72727 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3681:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$v1, MQPR:{ *:[v8i16] }:$v2, rGPR:{ *:[i32] }:$s)  =>  (MVE_VQRDMLASH_qrs16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$v1, MQPR:{ *:[v8i16] }:$v2, rGPR:{ *:[i32] }:$s)
     /*  72727 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQRDMLASH_qrs16),
     /*  72730 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  72732 */     GIR_RootToRootCopy, /*OpIdx*/2, // v1
     /*  72734 */     GIR_RootToRootCopy, /*OpIdx*/3, // v2
     /*  72736 */     GIR_RootToRootCopy, /*OpIdx*/4, // s
     /*  72738 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  72741 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  72747 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  72753 */     GIR_RootConstrainSelectedInstOperands,
     /*  72754 */     // GIR_Coverage, 4857,
     /*  72754 */     GIR_EraseRootFromParent_Done,
     /*  72755 */   // Label 1456: @72755
     /*  72755 */   GIM_Try, /*On fail goto*//*Label 1457*/ GIMT_Encode4(72824), // Rule ID 4859 //
     /*  72760 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  72763 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqrdmlash),
     /*  72768 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  72771 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  72774 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  72777 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  72780 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  72784 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  72788 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  72792 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  72796 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3681:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$v1, MQPR:{ *:[v4i32] }:$v2, rGPR:{ *:[i32] }:$s)  =>  (MVE_VQRDMLASH_qrs32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$v1, MQPR:{ *:[v4i32] }:$v2, rGPR:{ *:[i32] }:$s)
     /*  72796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQRDMLASH_qrs32),
     /*  72799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  72801 */     GIR_RootToRootCopy, /*OpIdx*/2, // v1
     /*  72803 */     GIR_RootToRootCopy, /*OpIdx*/3, // v2
     /*  72805 */     GIR_RootToRootCopy, /*OpIdx*/4, // s
     /*  72807 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  72810 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  72816 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  72822 */     GIR_RootConstrainSelectedInstOperands,
     /*  72823 */     // GIR_Coverage, 4859,
     /*  72823 */     GIR_EraseRootFromParent_Done,
     /*  72824 */   // Label 1457: @72824
     /*  72824 */   GIM_Try, /*On fail goto*//*Label 1458*/ GIMT_Encode4(72919), // Rule ID 2691 //
     /*  72829 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  72832 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_sha1c),
     /*  72837 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  72840 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  72843 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  72846 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /*  72849 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  72853 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3735:{ *:[iPTR] }, v4i32:{ *:[v4i32] }:$hash_abcd, i32:{ *:[i32] }:$hash_e, v4i32:{ *:[v4i32] }:$wk)  =>  (SHA1C:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$hash_abcd, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i64] }, (COPY_TO_REGCLASS:{ *:[f32] } i32:{ *:[i32] }:$hash_e, SPR:{ *:[i32] }), ssub_0:{ *:[i32] }), v4i32:{ *:[v4i32] }:$wk)
     /*  72853 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  72856 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  72860 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  72865 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // hash_e
     /*  72869 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(ARM::SPRRegClassID),
     /*  72874 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /*  72877 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  72881 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  72886 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /*  72889 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  72892 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/17,
     /*  72895 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(ARM::DPair_with_ssub_0RegClassID),
     /*  72900 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(ARM::SPRRegClassID),
     /*  72905 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SHA1C),
     /*  72908 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  72910 */     GIR_RootToRootCopy, /*OpIdx*/2, // hash_abcd
     /*  72912 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  72915 */     GIR_RootToRootCopy, /*OpIdx*/4, // wk
     /*  72917 */     GIR_RootConstrainSelectedInstOperands,
     /*  72918 */     // GIR_Coverage, 2691,
     /*  72918 */     GIR_EraseRootFromParent_Done,
     /*  72919 */   // Label 1458: @72919
     /*  72919 */   GIM_Try, /*On fail goto*//*Label 1459*/ GIMT_Encode4(73014), // Rule ID 2692 //
     /*  72924 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  72927 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_sha1m),
     /*  72932 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  72935 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  72938 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  72941 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /*  72944 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  72948 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3737:{ *:[iPTR] }, v4i32:{ *:[v4i32] }:$hash_abcd, i32:{ *:[i32] }:$hash_e, v4i32:{ *:[v4i32] }:$wk)  =>  (SHA1M:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$hash_abcd, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i64] }, (COPY_TO_REGCLASS:{ *:[f32] } i32:{ *:[i32] }:$hash_e, SPR:{ *:[i32] }), ssub_0:{ *:[i32] }), v4i32:{ *:[v4i32] }:$wk)
     /*  72948 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  72951 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  72955 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  72960 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // hash_e
     /*  72964 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(ARM::SPRRegClassID),
     /*  72969 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /*  72972 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  72976 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  72981 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /*  72984 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  72987 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/17,
     /*  72990 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(ARM::DPair_with_ssub_0RegClassID),
     /*  72995 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(ARM::SPRRegClassID),
     /*  73000 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SHA1M),
     /*  73003 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  73005 */     GIR_RootToRootCopy, /*OpIdx*/2, // hash_abcd
     /*  73007 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  73010 */     GIR_RootToRootCopy, /*OpIdx*/4, // wk
     /*  73012 */     GIR_RootConstrainSelectedInstOperands,
     /*  73013 */     // GIR_Coverage, 2692,
     /*  73013 */     GIR_EraseRootFromParent_Done,
     /*  73014 */   // Label 1459: @73014
     /*  73014 */   GIM_Try, /*On fail goto*//*Label 1460*/ GIMT_Encode4(73109), // Rule ID 2693 //
     /*  73019 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  73022 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_sha1p),
     /*  73027 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  73030 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  73033 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  73036 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /*  73039 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  73043 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3738:{ *:[iPTR] }, v4i32:{ *:[v4i32] }:$hash_abcd, i32:{ *:[i32] }:$hash_e, v4i32:{ *:[v4i32] }:$wk)  =>  (SHA1P:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$hash_abcd, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i64] }, (COPY_TO_REGCLASS:{ *:[f32] } i32:{ *:[i32] }:$hash_e, SPR:{ *:[i32] }), ssub_0:{ *:[i32] }), v4i32:{ *:[v4i32] }:$wk)
     /*  73043 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  73046 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  73050 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  73055 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // hash_e
     /*  73059 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(ARM::SPRRegClassID),
     /*  73064 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /*  73067 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  73071 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  73076 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /*  73079 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  73082 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/17,
     /*  73085 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(ARM::DPair_with_ssub_0RegClassID),
     /*  73090 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(ARM::SPRRegClassID),
     /*  73095 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SHA1P),
     /*  73098 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  73100 */     GIR_RootToRootCopy, /*OpIdx*/2, // hash_abcd
     /*  73102 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  73105 */     GIR_RootToRootCopy, /*OpIdx*/4, // wk
     /*  73107 */     GIR_RootConstrainSelectedInstOperands,
     /*  73108 */     // GIR_Coverage, 2693,
     /*  73108 */     GIR_EraseRootFromParent_Done,
     /*  73109 */   // Label 1460: @73109
     /*  73109 */   GIM_Reject,
     /*  73110 */ // Label 1313: @73110
     /*  73110 */ GIM_Try, /*On fail goto*//*Label 1461*/ GIMT_Encode4(76496),
     /*  73115 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/6,
     /*  73118 */   GIM_Try, /*On fail goto*//*Label 1462*/ GIMT_Encode4(73202), // Rule ID 3724 //
     /*  73123 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshll_imm),
     /*  73128 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  73131 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  73134 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  73137 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  73140 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  73143 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  73147 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  73151 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 8,
     /*  73155 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  73159 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  73163 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3710:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$src, 8:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VSHLL_lws8bh:{ *:[v8i16] } MQPR:{ *:[v16i8] }:$src)
     /*  73163 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  73166 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  73170 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  73175 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSHLL_lws8bh),
     /*  73178 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  73180 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  73182 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  73185 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  73191 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  73197 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  73200 */     GIR_RootConstrainSelectedInstOperands,
     /*  73201 */     // GIR_Coverage, 3724,
     /*  73201 */     GIR_EraseRootFromParent_Done,
     /*  73202 */   // Label 1462: @73202
     /*  73202 */   GIM_Try, /*On fail goto*//*Label 1463*/ GIMT_Encode4(73286), // Rule ID 3728 //
     /*  73207 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshll_imm),
     /*  73212 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  73215 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  73218 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  73221 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  73224 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  73227 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  73231 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  73235 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 8,
     /*  73239 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  73243 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  73247 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3710:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$src, 8:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VSHLL_lws8th:{ *:[v8i16] } MQPR:{ *:[v16i8] }:$src)
     /*  73247 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  73250 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  73254 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  73259 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSHLL_lws8th),
     /*  73262 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  73264 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  73266 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  73269 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  73275 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  73281 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  73284 */     GIR_RootConstrainSelectedInstOperands,
     /*  73285 */     // GIR_Coverage, 3728,
     /*  73285 */     GIR_EraseRootFromParent_Done,
     /*  73286 */   // Label 1463: @73286
     /*  73286 */   GIM_Try, /*On fail goto*//*Label 1464*/ GIMT_Encode4(73370), // Rule ID 3732 //
     /*  73291 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshll_imm),
     /*  73296 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  73299 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  73302 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  73305 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  73308 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  73311 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  73315 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  73319 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 16,
     /*  73323 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  73327 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  73331 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3710:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$src, 16:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VSHLL_lws16bh:{ *:[v4i32] } MQPR:{ *:[v8i16] }:$src)
     /*  73331 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  73334 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  73338 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  73343 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSHLL_lws16bh),
     /*  73346 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  73348 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  73350 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  73353 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  73359 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  73365 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  73368 */     GIR_RootConstrainSelectedInstOperands,
     /*  73369 */     // GIR_Coverage, 3732,
     /*  73369 */     GIR_EraseRootFromParent_Done,
     /*  73370 */   // Label 1464: @73370
     /*  73370 */   GIM_Try, /*On fail goto*//*Label 1465*/ GIMT_Encode4(73454), // Rule ID 3736 //
     /*  73375 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshll_imm),
     /*  73380 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  73383 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  73386 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  73389 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  73392 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  73395 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  73399 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  73403 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 16,
     /*  73407 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  73411 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  73415 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3710:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$src, 16:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VSHLL_lws16th:{ *:[v4i32] } MQPR:{ *:[v8i16] }:$src)
     /*  73415 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  73418 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  73422 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  73427 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSHLL_lws16th),
     /*  73430 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  73432 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  73434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  73437 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  73443 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  73449 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  73452 */     GIR_RootConstrainSelectedInstOperands,
     /*  73453 */     // GIR_Coverage, 3736,
     /*  73453 */     GIR_EraseRootFromParent_Done,
     /*  73454 */   // Label 1465: @73454
     /*  73454 */   GIM_Try, /*On fail goto*//*Label 1466*/ GIMT_Encode4(73538), // Rule ID 3740 //
     /*  73459 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshll_imm),
     /*  73464 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  73467 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  73470 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  73473 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  73476 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  73479 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  73483 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  73487 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 8,
     /*  73491 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  73495 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  73499 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3710:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$src, 8:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VSHLL_lwu8bh:{ *:[v8i16] } MQPR:{ *:[v16i8] }:$src)
     /*  73499 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  73502 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  73506 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  73511 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSHLL_lwu8bh),
     /*  73514 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  73516 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  73518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  73521 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  73527 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  73533 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  73536 */     GIR_RootConstrainSelectedInstOperands,
     /*  73537 */     // GIR_Coverage, 3740,
     /*  73537 */     GIR_EraseRootFromParent_Done,
     /*  73538 */   // Label 1466: @73538
     /*  73538 */   GIM_Try, /*On fail goto*//*Label 1467*/ GIMT_Encode4(73622), // Rule ID 3744 //
     /*  73543 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshll_imm),
     /*  73548 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  73551 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  73554 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  73557 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  73560 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  73563 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  73567 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  73571 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 8,
     /*  73575 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  73579 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  73583 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3710:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$src, 8:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VSHLL_lwu8th:{ *:[v8i16] } MQPR:{ *:[v16i8] }:$src)
     /*  73583 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  73586 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  73590 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  73595 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSHLL_lwu8th),
     /*  73598 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  73600 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  73602 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  73605 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  73611 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  73617 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  73620 */     GIR_RootConstrainSelectedInstOperands,
     /*  73621 */     // GIR_Coverage, 3744,
     /*  73621 */     GIR_EraseRootFromParent_Done,
     /*  73622 */   // Label 1467: @73622
     /*  73622 */   GIM_Try, /*On fail goto*//*Label 1468*/ GIMT_Encode4(73706), // Rule ID 3748 //
     /*  73627 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshll_imm),
     /*  73632 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  73635 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  73638 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  73641 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  73644 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  73647 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  73651 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  73655 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 16,
     /*  73659 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  73663 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  73667 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3710:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$src, 16:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VSHLL_lwu16bh:{ *:[v4i32] } MQPR:{ *:[v8i16] }:$src)
     /*  73667 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  73670 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  73674 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  73679 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSHLL_lwu16bh),
     /*  73682 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  73684 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  73686 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  73689 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  73695 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  73701 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  73704 */     GIR_RootConstrainSelectedInstOperands,
     /*  73705 */     // GIR_Coverage, 3748,
     /*  73705 */     GIR_EraseRootFromParent_Done,
     /*  73706 */   // Label 1468: @73706
     /*  73706 */   GIM_Try, /*On fail goto*//*Label 1469*/ GIMT_Encode4(73790), // Rule ID 3752 //
     /*  73711 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshll_imm),
     /*  73716 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  73719 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  73722 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  73725 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  73728 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  73731 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  73735 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  73739 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 16,
     /*  73743 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  73747 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  73751 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3710:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$src, 16:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VSHLL_lwu16th:{ *:[v4i32] } MQPR:{ *:[v8i16] }:$src)
     /*  73751 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  73754 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  73758 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  73763 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSHLL_lwu16th),
     /*  73766 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  73768 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  73770 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  73773 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  73779 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  73785 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  73788 */     GIR_RootConstrainSelectedInstOperands,
     /*  73789 */     // GIR_Coverage, 3752,
     /*  73789 */     GIR_EraseRootFromParent_Done,
     /*  73790 */   // Label 1469: @73790
     /*  73790 */   GIM_Try, /*On fail goto*//*Label 1470*/ GIMT_Encode4(73879), // Rule ID 4384 //
     /*  73795 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  73798 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmull),
     /*  73803 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  73806 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  73809 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  73812 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  73815 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  73818 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  73822 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  73826 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  73830 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  73834 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  73838 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3666:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VMULLBs8:{ *:[v8i16] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)
     /*  73838 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  73841 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  73845 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  73850 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMULLBs8),
     /*  73853 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  73855 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  73857 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  73859 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  73862 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  73868 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  73874 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  73877 */     GIR_RootConstrainSelectedInstOperands,
     /*  73878 */     // GIR_Coverage, 4384,
     /*  73878 */     GIR_EraseRootFromParent_Done,
     /*  73879 */   // Label 1470: @73879
     /*  73879 */   GIM_Try, /*On fail goto*//*Label 1471*/ GIMT_Encode4(73968), // Rule ID 4386 //
     /*  73884 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  73887 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmull),
     /*  73892 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  73895 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  73898 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  73901 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  73904 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  73907 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  73911 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  73915 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  73919 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  73923 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  73927 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3666:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VMULLTs8:{ *:[v8i16] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)
     /*  73927 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  73930 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  73934 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  73939 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMULLTs8),
     /*  73942 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  73944 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  73946 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  73948 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  73951 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  73957 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  73963 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  73966 */     GIR_RootConstrainSelectedInstOperands,
     /*  73967 */     // GIR_Coverage, 4386,
     /*  73967 */     GIR_EraseRootFromParent_Done,
     /*  73968 */   // Label 1471: @73968
     /*  73968 */   GIM_Try, /*On fail goto*//*Label 1472*/ GIMT_Encode4(74057), // Rule ID 4388 //
     /*  73973 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  73976 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmull),
     /*  73981 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  73984 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  73987 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  73990 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  73993 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  73996 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  74000 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  74004 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  74008 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  74012 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  74016 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3666:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VMULLBs16:{ *:[v4i32] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)
     /*  74016 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  74019 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  74023 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  74028 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMULLBs16),
     /*  74031 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  74033 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  74035 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  74037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  74040 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  74046 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  74052 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  74055 */     GIR_RootConstrainSelectedInstOperands,
     /*  74056 */     // GIR_Coverage, 4388,
     /*  74056 */     GIR_EraseRootFromParent_Done,
     /*  74057 */   // Label 1472: @74057
     /*  74057 */   GIM_Try, /*On fail goto*//*Label 1473*/ GIMT_Encode4(74146), // Rule ID 4390 //
     /*  74062 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  74065 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmull),
     /*  74070 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  74073 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  74076 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  74079 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  74082 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  74085 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  74089 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  74093 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  74097 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  74101 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  74105 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3666:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VMULLTs16:{ *:[v4i32] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)
     /*  74105 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  74108 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  74112 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  74117 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMULLTs16),
     /*  74120 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  74122 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  74124 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  74126 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  74129 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  74135 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  74141 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  74144 */     GIR_RootConstrainSelectedInstOperands,
     /*  74145 */     // GIR_Coverage, 4390,
     /*  74145 */     GIR_EraseRootFromParent_Done,
     /*  74146 */   // Label 1473: @74146
     /*  74146 */   GIM_Try, /*On fail goto*//*Label 1474*/ GIMT_Encode4(74235), // Rule ID 4392 //
     /*  74151 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  74154 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmull),
     /*  74159 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  74162 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  74165 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  74168 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  74171 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  74174 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  74178 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  74182 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  74186 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  74190 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  74194 */     // (intrinsic_wo_chain:{ *:[v2i64] } 3666:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VMULLBs32:{ *:[v2i64] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)
     /*  74194 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  74197 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  74201 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  74206 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMULLBs32),
     /*  74209 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  74211 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  74213 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  74215 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  74218 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  74224 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  74230 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  74233 */     GIR_RootConstrainSelectedInstOperands,
     /*  74234 */     // GIR_Coverage, 4392,
     /*  74234 */     GIR_EraseRootFromParent_Done,
     /*  74235 */   // Label 1474: @74235
     /*  74235 */   GIM_Try, /*On fail goto*//*Label 1475*/ GIMT_Encode4(74324), // Rule ID 4394 //
     /*  74240 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  74243 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmull),
     /*  74248 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  74251 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  74254 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  74257 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  74260 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  74263 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  74267 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  74271 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  74275 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  74279 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  74283 */     // (intrinsic_wo_chain:{ *:[v2i64] } 3666:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VMULLTs32:{ *:[v2i64] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)
     /*  74283 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  74286 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  74290 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  74295 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMULLTs32),
     /*  74298 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  74300 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  74302 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  74304 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  74307 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  74313 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  74319 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  74322 */     GIR_RootConstrainSelectedInstOperands,
     /*  74323 */     // GIR_Coverage, 4394,
     /*  74323 */     GIR_EraseRootFromParent_Done,
     /*  74324 */   // Label 1475: @74324
     /*  74324 */   GIM_Try, /*On fail goto*//*Label 1476*/ GIMT_Encode4(74413), // Rule ID 4396 //
     /*  74329 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  74332 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmull),
     /*  74337 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  74340 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  74343 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  74346 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  74349 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  74352 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  74356 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  74360 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  74364 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  74368 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  74372 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3666:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn, 1:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VMULLBu8:{ *:[v8i16] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)
     /*  74372 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  74375 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  74379 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  74384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMULLBu8),
     /*  74387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  74389 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  74391 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  74393 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  74396 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  74402 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  74408 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  74411 */     GIR_RootConstrainSelectedInstOperands,
     /*  74412 */     // GIR_Coverage, 4396,
     /*  74412 */     GIR_EraseRootFromParent_Done,
     /*  74413 */   // Label 1476: @74413
     /*  74413 */   GIM_Try, /*On fail goto*//*Label 1477*/ GIMT_Encode4(74502), // Rule ID 4398 //
     /*  74418 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  74421 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmull),
     /*  74426 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  74429 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  74432 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  74435 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  74438 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  74441 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  74445 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  74449 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  74453 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  74457 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  74461 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3666:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn, 1:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VMULLTu8:{ *:[v8i16] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)
     /*  74461 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  74464 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  74468 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  74473 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMULLTu8),
     /*  74476 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  74478 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  74480 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  74482 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  74485 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  74491 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  74497 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  74500 */     GIR_RootConstrainSelectedInstOperands,
     /*  74501 */     // GIR_Coverage, 4398,
     /*  74501 */     GIR_EraseRootFromParent_Done,
     /*  74502 */   // Label 1477: @74502
     /*  74502 */   GIM_Try, /*On fail goto*//*Label 1478*/ GIMT_Encode4(74591), // Rule ID 4400 //
     /*  74507 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  74510 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmull),
     /*  74515 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  74518 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  74521 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  74524 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  74527 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  74530 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  74534 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  74538 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  74542 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  74546 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  74550 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3666:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn, 1:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VMULLBu16:{ *:[v4i32] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)
     /*  74550 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  74553 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  74557 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  74562 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMULLBu16),
     /*  74565 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  74567 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  74569 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  74571 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  74574 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  74580 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  74586 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  74589 */     GIR_RootConstrainSelectedInstOperands,
     /*  74590 */     // GIR_Coverage, 4400,
     /*  74590 */     GIR_EraseRootFromParent_Done,
     /*  74591 */   // Label 1478: @74591
     /*  74591 */   GIM_Try, /*On fail goto*//*Label 1479*/ GIMT_Encode4(74680), // Rule ID 4402 //
     /*  74596 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  74599 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmull),
     /*  74604 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  74607 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  74610 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  74613 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  74616 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  74619 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  74623 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  74627 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  74631 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  74635 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  74639 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3666:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn, 1:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VMULLTu16:{ *:[v4i32] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)
     /*  74639 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  74642 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  74646 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  74651 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMULLTu16),
     /*  74654 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  74656 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  74658 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  74660 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  74663 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  74669 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  74675 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  74678 */     GIR_RootConstrainSelectedInstOperands,
     /*  74679 */     // GIR_Coverage, 4402,
     /*  74679 */     GIR_EraseRootFromParent_Done,
     /*  74680 */   // Label 1479: @74680
     /*  74680 */   GIM_Try, /*On fail goto*//*Label 1480*/ GIMT_Encode4(74769), // Rule ID 4404 //
     /*  74685 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  74688 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmull),
     /*  74693 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  74696 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  74699 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  74702 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  74705 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  74708 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  74712 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  74716 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  74720 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  74724 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  74728 */     // (intrinsic_wo_chain:{ *:[v2i64] } 3666:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn, 1:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VMULLBu32:{ *:[v2i64] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)
     /*  74728 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  74731 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  74735 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  74740 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMULLBu32),
     /*  74743 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  74745 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  74747 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  74749 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  74752 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  74758 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  74764 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  74767 */     GIR_RootConstrainSelectedInstOperands,
     /*  74768 */     // GIR_Coverage, 4404,
     /*  74768 */     GIR_EraseRootFromParent_Done,
     /*  74769 */   // Label 1480: @74769
     /*  74769 */   GIM_Try, /*On fail goto*//*Label 1481*/ GIMT_Encode4(74858), // Rule ID 4406 //
     /*  74774 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  74777 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmull),
     /*  74782 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  74785 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  74788 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  74791 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  74794 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  74797 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  74801 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  74805 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  74809 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  74813 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  74817 */     // (intrinsic_wo_chain:{ *:[v2i64] } 3666:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn, 1:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VMULLTu32:{ *:[v2i64] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)
     /*  74817 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  74820 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  74824 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  74829 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMULLTu32),
     /*  74832 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  74834 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  74836 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  74838 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  74841 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  74847 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  74853 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  74856 */     GIR_RootConstrainSelectedInstOperands,
     /*  74857 */     // GIR_Coverage, 4406,
     /*  74857 */     GIR_EraseRootFromParent_Done,
     /*  74858 */   // Label 1481: @74858
     /*  74858 */   GIM_Try, /*On fail goto*//*Label 1482*/ GIMT_Encode4(74956), // Rule ID 4029 //
     /*  74863 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  74866 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vcaddq),
     /*  74871 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  74874 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  74877 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  74880 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /*  74883 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_v8s16,
     /*  74886 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  74890 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 1,
     /*  74894 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  74898 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  74902 */     // MIs[1] Operand 1
     /*  74902 */     // No operand predicates
     /*  74902 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  74906 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  74910 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  74912 */     // (intrinsic_wo_chain:{ *:[v8f16] } 3609:{ *:[iPTR] }, 1:{ *:[i32] }, (imm:{ *:[i32] }):$rot, MQPR:{ *:[v8f16] }:$Qn, MQPR:{ *:[v8f16] }:$Qm)  =>  (MVE_VCADDf16:{ *:[v8f16] } MQPR:{ *:[v8f16] }:$Qn, MQPR:{ *:[v8f16] }:$Qm, (imm:{ *:[i32] }):$rot)
     /*  74912 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  74915 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  74919 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  74924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCADDf16),
     /*  74927 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  74929 */     GIR_RootToRootCopy, /*OpIdx*/4, // Qn
     /*  74931 */     GIR_RootToRootCopy, /*OpIdx*/5, // Qm
     /*  74933 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rot
     /*  74936 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  74939 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  74945 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  74951 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  74954 */     GIR_RootConstrainSelectedInstOperands,
     /*  74955 */     // GIR_Coverage, 4029,
     /*  74955 */     GIR_EraseRootFromParent_Done,
     /*  74956 */   // Label 1482: @74956
     /*  74956 */   GIM_Try, /*On fail goto*//*Label 1483*/ GIMT_Encode4(75054), // Rule ID 4031 //
     /*  74961 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  74964 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vcaddq),
     /*  74969 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  74972 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  74975 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  74978 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /*  74981 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_v4s32,
     /*  74984 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  74988 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 1,
     /*  74992 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  74996 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  75000 */     // MIs[1] Operand 1
     /*  75000 */     // No operand predicates
     /*  75000 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  75004 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  75008 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  75010 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3609:{ *:[iPTR] }, 1:{ *:[i32] }, (imm:{ *:[i32] }):$rot, MQPR:{ *:[v4f32] }:$Qn, MQPR:{ *:[v4f32] }:$Qm)  =>  (MVE_VCADDf32:{ *:[v4f32] } MQPR:{ *:[v4f32] }:$Qn, MQPR:{ *:[v4f32] }:$Qm, (imm:{ *:[i32] }):$rot)
     /*  75010 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  75013 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  75017 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  75022 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCADDf32),
     /*  75025 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  75027 */     GIR_RootToRootCopy, /*OpIdx*/4, // Qn
     /*  75029 */     GIR_RootToRootCopy, /*OpIdx*/5, // Qm
     /*  75031 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rot
     /*  75034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  75037 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  75043 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  75049 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  75052 */     GIR_RootConstrainSelectedInstOperands,
     /*  75053 */     // GIR_Coverage, 4031,
     /*  75053 */     GIR_EraseRootFromParent_Done,
     /*  75054 */   // Label 1483: @75054
     /*  75054 */   GIM_Try, /*On fail goto*//*Label 1484*/ GIMT_Encode4(75152), // Rule ID 4538 //
     /*  75059 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  75062 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vcaddq),
     /*  75067 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  75070 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  75073 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  75076 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  75079 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_v16s8,
     /*  75082 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  75086 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 1,
     /*  75090 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  75094 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  75098 */     // MIs[1] Operand 1
     /*  75098 */     // No operand predicates
     /*  75098 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  75102 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  75106 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  75108 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3609:{ *:[iPTR] }, 1:{ *:[i32] }, (imm:{ *:[i32] }):$rot, MQPR:{ *:[v16i8] }:$Qn, MQPR:{ *:[v16i8] }:$Qm)  =>  (MVE_VCADDi8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qn, MQPR:{ *:[v16i8] }:$Qm, (imm:{ *:[i32] }):$rot)
     /*  75108 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  75111 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  75115 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  75120 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCADDi8),
     /*  75123 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  75125 */     GIR_RootToRootCopy, /*OpIdx*/4, // Qn
     /*  75127 */     GIR_RootToRootCopy, /*OpIdx*/5, // Qm
     /*  75129 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rot
     /*  75132 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  75135 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  75141 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  75147 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  75150 */     GIR_RootConstrainSelectedInstOperands,
     /*  75151 */     // GIR_Coverage, 4538,
     /*  75151 */     GIR_EraseRootFromParent_Done,
     /*  75152 */   // Label 1484: @75152
     /*  75152 */   GIM_Try, /*On fail goto*//*Label 1485*/ GIMT_Encode4(75250), // Rule ID 4540 //
     /*  75157 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  75160 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vcaddq),
     /*  75165 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  75168 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  75171 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  75174 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /*  75177 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_v8s16,
     /*  75180 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  75184 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 1,
     /*  75188 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  75192 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  75196 */     // MIs[1] Operand 1
     /*  75196 */     // No operand predicates
     /*  75196 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  75200 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  75204 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  75206 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3609:{ *:[iPTR] }, 1:{ *:[i32] }, (imm:{ *:[i32] }):$rot, MQPR:{ *:[v8i16] }:$Qn, MQPR:{ *:[v8i16] }:$Qm)  =>  (MVE_VCADDi16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qn, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] }):$rot)
     /*  75206 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  75209 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  75213 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  75218 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCADDi16),
     /*  75221 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  75223 */     GIR_RootToRootCopy, /*OpIdx*/4, // Qn
     /*  75225 */     GIR_RootToRootCopy, /*OpIdx*/5, // Qm
     /*  75227 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rot
     /*  75230 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  75233 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  75239 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  75245 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  75248 */     GIR_RootConstrainSelectedInstOperands,
     /*  75249 */     // GIR_Coverage, 4540,
     /*  75249 */     GIR_EraseRootFromParent_Done,
     /*  75250 */   // Label 1485: @75250
     /*  75250 */   GIM_Try, /*On fail goto*//*Label 1486*/ GIMT_Encode4(75348), // Rule ID 4542 //
     /*  75255 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  75258 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vcaddq),
     /*  75263 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  75266 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  75269 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  75272 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /*  75275 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_v4s32,
     /*  75278 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  75282 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 1,
     /*  75286 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  75290 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  75294 */     // MIs[1] Operand 1
     /*  75294 */     // No operand predicates
     /*  75294 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  75298 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  75302 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  75304 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3609:{ *:[iPTR] }, 1:{ *:[i32] }, (imm:{ *:[i32] }):$rot, MQPR:{ *:[v4i32] }:$Qn, MQPR:{ *:[v4i32] }:$Qm)  =>  (MVE_VCADDi32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qn, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] }):$rot)
     /*  75304 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  75307 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  75311 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  75316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCADDi32),
     /*  75319 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  75321 */     GIR_RootToRootCopy, /*OpIdx*/4, // Qn
     /*  75323 */     GIR_RootToRootCopy, /*OpIdx*/5, // Qm
     /*  75325 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rot
     /*  75328 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  75331 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  75337 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  75343 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  75346 */     GIR_RootConstrainSelectedInstOperands,
     /*  75347 */     // GIR_Coverage, 4542,
     /*  75347 */     GIR_EraseRootFromParent_Done,
     /*  75348 */   // Label 1486: @75348
     /*  75348 */   GIM_Try, /*On fail goto*//*Label 1487*/ GIMT_Encode4(75446), // Rule ID 4544 //
     /*  75353 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  75356 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vcaddq),
     /*  75361 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  75364 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  75367 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  75370 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  75373 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_v16s8,
     /*  75376 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  75380 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /*  75384 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  75388 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  75392 */     // MIs[1] Operand 1
     /*  75392 */     // No operand predicates
     /*  75392 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  75396 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  75400 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  75402 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3609:{ *:[iPTR] }, 0:{ *:[i32] }, (imm:{ *:[i32] }):$rot, MQPR:{ *:[v16i8] }:$Qn, MQPR:{ *:[v16i8] }:$Qm)  =>  (MVE_VHCADDs8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qn, MQPR:{ *:[v16i8] }:$Qm, (imm:{ *:[i32] }):$rot)
     /*  75402 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  75405 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  75409 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  75414 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VHCADDs8),
     /*  75417 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  75419 */     GIR_RootToRootCopy, /*OpIdx*/4, // Qn
     /*  75421 */     GIR_RootToRootCopy, /*OpIdx*/5, // Qm
     /*  75423 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rot
     /*  75426 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  75429 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  75435 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  75441 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  75444 */     GIR_RootConstrainSelectedInstOperands,
     /*  75445 */     // GIR_Coverage, 4544,
     /*  75445 */     GIR_EraseRootFromParent_Done,
     /*  75446 */   // Label 1487: @75446
     /*  75446 */   GIM_Try, /*On fail goto*//*Label 1488*/ GIMT_Encode4(75544), // Rule ID 4546 //
     /*  75451 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  75454 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vcaddq),
     /*  75459 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  75462 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  75465 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  75468 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /*  75471 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_v8s16,
     /*  75474 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  75478 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /*  75482 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  75486 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  75490 */     // MIs[1] Operand 1
     /*  75490 */     // No operand predicates
     /*  75490 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  75494 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  75498 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  75500 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3609:{ *:[iPTR] }, 0:{ *:[i32] }, (imm:{ *:[i32] }):$rot, MQPR:{ *:[v8i16] }:$Qn, MQPR:{ *:[v8i16] }:$Qm)  =>  (MVE_VHCADDs16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qn, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] }):$rot)
     /*  75500 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  75503 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  75507 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  75512 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VHCADDs16),
     /*  75515 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  75517 */     GIR_RootToRootCopy, /*OpIdx*/4, // Qn
     /*  75519 */     GIR_RootToRootCopy, /*OpIdx*/5, // Qm
     /*  75521 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rot
     /*  75524 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  75527 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  75533 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  75539 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  75542 */     GIR_RootConstrainSelectedInstOperands,
     /*  75543 */     // GIR_Coverage, 4546,
     /*  75543 */     GIR_EraseRootFromParent_Done,
     /*  75544 */   // Label 1488: @75544
     /*  75544 */   GIM_Try, /*On fail goto*//*Label 1489*/ GIMT_Encode4(75642), // Rule ID 4548 //
     /*  75549 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  75552 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vcaddq),
     /*  75557 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  75560 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  75563 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  75566 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /*  75569 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_v4s32,
     /*  75572 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  75576 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /*  75580 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  75584 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  75588 */     // MIs[1] Operand 1
     /*  75588 */     // No operand predicates
     /*  75588 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  75592 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  75596 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  75598 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3609:{ *:[iPTR] }, 0:{ *:[i32] }, (imm:{ *:[i32] }):$rot, MQPR:{ *:[v4i32] }:$Qn, MQPR:{ *:[v4i32] }:$Qm)  =>  (MVE_VHCADDs32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qn, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] }):$rot)
     /*  75598 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  75601 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  75605 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  75610 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VHCADDs32),
     /*  75613 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  75615 */     GIR_RootToRootCopy, /*OpIdx*/4, // Qn
     /*  75617 */     GIR_RootToRootCopy, /*OpIdx*/5, // Qm
     /*  75619 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rot
     /*  75622 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  75625 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  75631 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  75637 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  75640 */     GIR_RootConstrainSelectedInstOperands,
     /*  75641 */     // GIR_Coverage, 4548,
     /*  75641 */     GIR_EraseRootFromParent_Done,
     /*  75642 */   // Label 1489: @75642
     /*  75642 */   GIM_Try, /*On fail goto*//*Label 1490*/ GIMT_Encode4(75718), // Rule ID 3034 //
     /*  75647 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  75650 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vabav),
     /*  75655 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  75658 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  75661 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  75664 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  75667 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_v16s8,
     /*  75670 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  75674 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /*  75678 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  75682 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  75686 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  75690 */     // (intrinsic_wo_chain:{ *:[i32] } 3602:{ *:[iPTR] }, 0:{ *:[i32] }, rGPR:{ *:[i32] }:$Rda_src, MQPR:{ *:[v16i8] }:$Qn, MQPR:{ *:[v16i8] }:$Qm)  =>  (MVE_VABAVs8:{ *:[i32] } rGPR:{ *:[i32] }:$Rda_src, MQPR:{ *:[v16i8] }:$Qn, MQPR:{ *:[v16i8] }:$Qm)
     /*  75690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VABAVs8),
     /*  75693 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rda]
     /*  75695 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rda_src
     /*  75697 */     GIR_RootToRootCopy, /*OpIdx*/4, // Qn
     /*  75699 */     GIR_RootToRootCopy, /*OpIdx*/5, // Qm
     /*  75701 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  75704 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  75710 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  75716 */     GIR_RootConstrainSelectedInstOperands,
     /*  75717 */     // GIR_Coverage, 3034,
     /*  75717 */     GIR_EraseRootFromParent_Done,
     /*  75718 */   // Label 1490: @75718
     /*  75718 */   GIM_Try, /*On fail goto*//*Label 1491*/ GIMT_Encode4(75794), // Rule ID 3036 //
     /*  75723 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  75726 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vabav),
     /*  75731 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  75734 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  75737 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  75740 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /*  75743 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_v8s16,
     /*  75746 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  75750 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /*  75754 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  75758 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  75762 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  75766 */     // (intrinsic_wo_chain:{ *:[i32] } 3602:{ *:[iPTR] }, 0:{ *:[i32] }, rGPR:{ *:[i32] }:$Rda_src, MQPR:{ *:[v8i16] }:$Qn, MQPR:{ *:[v8i16] }:$Qm)  =>  (MVE_VABAVs16:{ *:[i32] } rGPR:{ *:[i32] }:$Rda_src, MQPR:{ *:[v8i16] }:$Qn, MQPR:{ *:[v8i16] }:$Qm)
     /*  75766 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VABAVs16),
     /*  75769 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rda]
     /*  75771 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rda_src
     /*  75773 */     GIR_RootToRootCopy, /*OpIdx*/4, // Qn
     /*  75775 */     GIR_RootToRootCopy, /*OpIdx*/5, // Qm
     /*  75777 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  75780 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  75786 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  75792 */     GIR_RootConstrainSelectedInstOperands,
     /*  75793 */     // GIR_Coverage, 3036,
     /*  75793 */     GIR_EraseRootFromParent_Done,
     /*  75794 */   // Label 1491: @75794
     /*  75794 */   GIM_Try, /*On fail goto*//*Label 1492*/ GIMT_Encode4(75870), // Rule ID 3038 //
     /*  75799 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  75802 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vabav),
     /*  75807 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  75810 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  75813 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  75816 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /*  75819 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_v4s32,
     /*  75822 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  75826 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /*  75830 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  75834 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  75838 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  75842 */     // (intrinsic_wo_chain:{ *:[i32] } 3602:{ *:[iPTR] }, 0:{ *:[i32] }, rGPR:{ *:[i32] }:$Rda_src, MQPR:{ *:[v4i32] }:$Qn, MQPR:{ *:[v4i32] }:$Qm)  =>  (MVE_VABAVs32:{ *:[i32] } rGPR:{ *:[i32] }:$Rda_src, MQPR:{ *:[v4i32] }:$Qn, MQPR:{ *:[v4i32] }:$Qm)
     /*  75842 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VABAVs32),
     /*  75845 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rda]
     /*  75847 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rda_src
     /*  75849 */     GIR_RootToRootCopy, /*OpIdx*/4, // Qn
     /*  75851 */     GIR_RootToRootCopy, /*OpIdx*/5, // Qm
     /*  75853 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  75856 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  75862 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  75868 */     GIR_RootConstrainSelectedInstOperands,
     /*  75869 */     // GIR_Coverage, 3038,
     /*  75869 */     GIR_EraseRootFromParent_Done,
     /*  75870 */   // Label 1492: @75870
     /*  75870 */   GIM_Try, /*On fail goto*//*Label 1493*/ GIMT_Encode4(75946), // Rule ID 3040 //
     /*  75875 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  75878 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vabav),
     /*  75883 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  75886 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  75889 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  75892 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  75895 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_v16s8,
     /*  75898 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  75902 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 1,
     /*  75906 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  75910 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  75914 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  75918 */     // (intrinsic_wo_chain:{ *:[i32] } 3602:{ *:[iPTR] }, 1:{ *:[i32] }, rGPR:{ *:[i32] }:$Rda_src, MQPR:{ *:[v16i8] }:$Qn, MQPR:{ *:[v16i8] }:$Qm)  =>  (MVE_VABAVu8:{ *:[i32] } rGPR:{ *:[i32] }:$Rda_src, MQPR:{ *:[v16i8] }:$Qn, MQPR:{ *:[v16i8] }:$Qm)
     /*  75918 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VABAVu8),
     /*  75921 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rda]
     /*  75923 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rda_src
     /*  75925 */     GIR_RootToRootCopy, /*OpIdx*/4, // Qn
     /*  75927 */     GIR_RootToRootCopy, /*OpIdx*/5, // Qm
     /*  75929 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  75932 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  75938 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  75944 */     GIR_RootConstrainSelectedInstOperands,
     /*  75945 */     // GIR_Coverage, 3040,
     /*  75945 */     GIR_EraseRootFromParent_Done,
     /*  75946 */   // Label 1493: @75946
     /*  75946 */   GIM_Try, /*On fail goto*//*Label 1494*/ GIMT_Encode4(76022), // Rule ID 3042 //
     /*  75951 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  75954 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vabav),
     /*  75959 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  75962 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  75965 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  75968 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /*  75971 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_v8s16,
     /*  75974 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  75978 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 1,
     /*  75982 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  75986 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  75990 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  75994 */     // (intrinsic_wo_chain:{ *:[i32] } 3602:{ *:[iPTR] }, 1:{ *:[i32] }, rGPR:{ *:[i32] }:$Rda_src, MQPR:{ *:[v8i16] }:$Qn, MQPR:{ *:[v8i16] }:$Qm)  =>  (MVE_VABAVu16:{ *:[i32] } rGPR:{ *:[i32] }:$Rda_src, MQPR:{ *:[v8i16] }:$Qn, MQPR:{ *:[v8i16] }:$Qm)
     /*  75994 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VABAVu16),
     /*  75997 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rda]
     /*  75999 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rda_src
     /*  76001 */     GIR_RootToRootCopy, /*OpIdx*/4, // Qn
     /*  76003 */     GIR_RootToRootCopy, /*OpIdx*/5, // Qm
     /*  76005 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  76008 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  76014 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  76020 */     GIR_RootConstrainSelectedInstOperands,
     /*  76021 */     // GIR_Coverage, 3042,
     /*  76021 */     GIR_EraseRootFromParent_Done,
     /*  76022 */   // Label 1494: @76022
     /*  76022 */   GIM_Try, /*On fail goto*//*Label 1495*/ GIMT_Encode4(76098), // Rule ID 3044 //
     /*  76027 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  76030 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vabav),
     /*  76035 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  76038 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  76041 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  76044 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /*  76047 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_v4s32,
     /*  76050 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  76054 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 1,
     /*  76058 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  76062 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  76066 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  76070 */     // (intrinsic_wo_chain:{ *:[i32] } 3602:{ *:[iPTR] }, 1:{ *:[i32] }, rGPR:{ *:[i32] }:$Rda_src, MQPR:{ *:[v4i32] }:$Qn, MQPR:{ *:[v4i32] }:$Qm)  =>  (MVE_VABAVu32:{ *:[i32] } rGPR:{ *:[i32] }:$Rda_src, MQPR:{ *:[v4i32] }:$Qn, MQPR:{ *:[v4i32] }:$Qm)
     /*  76070 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VABAVu32),
     /*  76073 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rda]
     /*  76075 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rda_src
     /*  76077 */     GIR_RootToRootCopy, /*OpIdx*/4, // Qn
     /*  76079 */     GIR_RootToRootCopy, /*OpIdx*/5, // Qm
     /*  76081 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  76084 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  76090 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  76096 */     GIR_RootConstrainSelectedInstOperands,
     /*  76097 */     // GIR_Coverage, 3044,
     /*  76097 */     GIR_EraseRootFromParent_Done,
     /*  76098 */   // Label 1495: @76098
     /*  76098 */   GIM_Try, /*On fail goto*//*Label 1496*/ GIMT_Encode4(76183), // Rule ID 3993 //
     /*  76103 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  76106 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vcmlaq),
     /*  76111 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  76114 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  76117 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  76120 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /*  76123 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_v8s16,
     /*  76126 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  76130 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  76134 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  76138 */     // MIs[1] Operand 1
     /*  76138 */     // No operand predicates
     /*  76138 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  76142 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  76146 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  76150 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  76152 */     // (intrinsic_wo_chain:{ *:[v8f16] } 3612:{ *:[iPTR] }, (imm:{ *:[i32] }):$rot, MQPR:{ *:[v8f16] }:$Qd_src, MQPR:{ *:[v8f16] }:$Qn, MQPR:{ *:[v8f16] }:$Qm)  =>  (MVE_VCMLAf16:{ *:[v8f16] } MQPR:{ *:[v8f16] }:$Qd_src, MQPR:{ *:[v8f16] }:$Qn, MQPR:{ *:[v8f16] }:$Qm, (imm:{ *:[i32] }):$rot)
     /*  76152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCMLAf16),
     /*  76155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  76157 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qd_src
     /*  76159 */     GIR_RootToRootCopy, /*OpIdx*/4, // Qn
     /*  76161 */     GIR_RootToRootCopy, /*OpIdx*/5, // Qm
     /*  76163 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rot
     /*  76166 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  76169 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  76175 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  76181 */     GIR_RootConstrainSelectedInstOperands,
     /*  76182 */     // GIR_Coverage, 3993,
     /*  76182 */     GIR_EraseRootFromParent_Done,
     /*  76183 */   // Label 1496: @76183
     /*  76183 */   GIM_Try, /*On fail goto*//*Label 1497*/ GIMT_Encode4(76268), // Rule ID 3996 //
     /*  76188 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  76191 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vcmlaq),
     /*  76196 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  76199 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  76202 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  76205 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /*  76208 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_v4s32,
     /*  76211 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  76215 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  76219 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  76223 */     // MIs[1] Operand 1
     /*  76223 */     // No operand predicates
     /*  76223 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  76227 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  76231 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  76235 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  76237 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3612:{ *:[iPTR] }, (imm:{ *:[i32] }):$rot, MQPR:{ *:[v4f32] }:$Qd_src, MQPR:{ *:[v4f32] }:$Qn, MQPR:{ *:[v4f32] }:$Qm)  =>  (MVE_VCMLAf32:{ *:[v4f32] } MQPR:{ *:[v4f32] }:$Qd_src, MQPR:{ *:[v4f32] }:$Qn, MQPR:{ *:[v4f32] }:$Qm, (imm:{ *:[i32] }):$rot)
     /*  76237 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCMLAf32),
     /*  76240 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  76242 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qd_src
     /*  76244 */     GIR_RootToRootCopy, /*OpIdx*/4, // Qn
     /*  76246 */     GIR_RootToRootCopy, /*OpIdx*/5, // Qm
     /*  76248 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rot
     /*  76251 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  76254 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  76260 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  76266 */     GIR_RootConstrainSelectedInstOperands,
     /*  76267 */     // GIR_Coverage, 3996,
     /*  76267 */     GIR_EraseRootFromParent_Done,
     /*  76268 */   // Label 1497: @76268
     /*  76268 */   GIM_Try, /*On fail goto*//*Label 1498*/ GIMT_Encode4(76364), // Rule ID 2685 //
     /*  76273 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  76276 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vtbx2),
     /*  76281 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /*  76284 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  76287 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  76290 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s8,
     /*  76293 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_v8s8,
     /*  76296 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  76300 */     // (intrinsic_wo_chain:{ *:[v8i8] } 3861:{ *:[iPTR] }, v8i8:{ *:[v8i8] }:$orig, v8i8:{ *:[v8i8] }:$Vn0, v8i8:{ *:[v8i8] }:$Vn1, v8i8:{ *:[v8i8] }:$Vm)  =>  (VTBX2:{ *:[v8i8] } v8i8:{ *:[v8i8] }:$orig, (REG_SEQUENCE:{ *:[v16i8] } DPair:{ *:[i32] }, v8i8:{ *:[v8i8] }:$Vn0, dsub_0:{ *:[i32] }, v8i8:{ *:[v8i8] }:$Vn1, dsub_1:{ *:[i32] }), v8i8:{ *:[v8i8] }:$Vm)
     /*  76300 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /*  76303 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /*  76307 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  76312 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // Vn0
     /*  76316 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/1,
     /*  76319 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // Vn1
     /*  76323 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/2,
     /*  76326 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(ARM::DPairRegClassID),
     /*  76331 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(ARM::DPRRegClassID),
     /*  76336 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(ARM::DPRRegClassID),
     /*  76341 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VTBX2),
     /*  76344 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  76346 */     GIR_RootToRootCopy, /*OpIdx*/2, // orig
     /*  76348 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  76351 */     GIR_RootToRootCopy, /*OpIdx*/5, // Vm
     /*  76353 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  76356 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  76362 */     GIR_RootConstrainSelectedInstOperands,
     /*  76363 */     // GIR_Coverage, 2685,
     /*  76363 */     GIR_EraseRootFromParent_Done,
     /*  76364 */   // Label 1498: @76364
     /*  76364 */   GIM_Try, /*On fail goto*//*Label 1499*/ GIMT_Encode4(76495), // Rule ID 2686 //
     /*  76369 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  76372 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vtbl3),
     /*  76377 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /*  76380 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  76383 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  76386 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s8,
     /*  76389 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_v8s8,
     /*  76392 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  76396 */     // (intrinsic_wo_chain:{ *:[v8i8] } 3858:{ *:[iPTR] }, v8i8:{ *:[v8i8] }:$Vn0, v8i8:{ *:[v8i8] }:$Vn1, v8i8:{ *:[v8i8] }:$Vn2, v8i8:{ *:[v8i8] }:$Vm)  =>  (VTBL3Pseudo:{ *:[v8i8] } (REG_SEQUENCE:{ *:[v4i64] } QQPR:{ *:[i32] }, v8i8:{ *:[v8i8] }:$Vn0, dsub_0:{ *:[i32] }, v8i8:{ *:[v8i8] }:$Vn1, dsub_1:{ *:[i32] }, v8i8:{ *:[v8i8] }:$Vn2, dsub_2:{ *:[i32] }, (IMPLICIT_DEF:{ *:[v8i8] }), dsub_3:{ *:[i32] }), v8i8:{ *:[v8i8] }:$Vm)
     /*  76396 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s8,
     /*  76399 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  76403 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  76408 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  76410 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s64,
     /*  76413 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /*  76417 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  76422 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Vn0
     /*  76426 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/1,
     /*  76429 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // Vn1
     /*  76433 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/2,
     /*  76436 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // Vn2
     /*  76440 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /*  76443 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  76446 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/4,
     /*  76449 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(ARM::QQPRRegClassID),
     /*  76454 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(ARM::DPRRegClassID),
     /*  76459 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(ARM::DPRRegClassID),
     /*  76464 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/5, GIMT_Encode2(ARM::DPRRegClassID),
     /*  76469 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/7, GIMT_Encode2(ARM::DPRRegClassID),
     /*  76474 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VTBL3Pseudo),
     /*  76477 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  76479 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  76482 */     GIR_RootToRootCopy, /*OpIdx*/5, // Vm
     /*  76484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  76487 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  76493 */     GIR_RootConstrainSelectedInstOperands,
     /*  76494 */     // GIR_Coverage, 2686,
     /*  76494 */     GIR_EraseRootFromParent_Done,
     /*  76495 */   // Label 1499: @76495
     /*  76495 */   GIM_Reject,
     /*  76496 */ // Label 1461: @76496
     /*  76496 */ GIM_Try, /*On fail goto*//*Label 1500*/ GIMT_Encode4(81802),
     /*  76501 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/7,
     /*  76504 */   GIM_Try, /*On fail goto*//*Label 1501*/ GIMT_Encode4(76597), // Rule ID 3835 //
     /*  76509 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_vector),
     /*  76514 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  76517 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  76520 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  76523 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  76526 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  76529 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  76532 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  76536 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  76540 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  76544 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  76548 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  76552 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  76556 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3706:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$in, MQPR:{ *:[v16i8] }:$sh, 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VSHL_by_vecs8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$in, MQPR:{ *:[v16i8] }:$sh)
     /*  76556 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  76559 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  76563 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  76568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSHL_by_vecs8),
     /*  76571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  76573 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  76575 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  76577 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  76580 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  76586 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  76592 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  76595 */     GIR_RootConstrainSelectedInstOperands,
     /*  76596 */     // GIR_Coverage, 3835,
     /*  76596 */     GIR_EraseRootFromParent_Done,
     /*  76597 */   // Label 1501: @76597
     /*  76597 */   GIM_Try, /*On fail goto*//*Label 1502*/ GIMT_Encode4(76690), // Rule ID 3837 //
     /*  76602 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_vector),
     /*  76607 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  76610 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  76613 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  76616 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  76619 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  76622 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  76625 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  76629 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  76633 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  76637 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  76641 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  76645 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  76649 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3706:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$in, MQPR:{ *:[v8i16] }:$sh, 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VSHL_by_vecs16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$in, MQPR:{ *:[v8i16] }:$sh)
     /*  76649 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  76652 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  76656 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  76661 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSHL_by_vecs16),
     /*  76664 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  76666 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  76668 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  76670 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  76673 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  76679 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  76685 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  76688 */     GIR_RootConstrainSelectedInstOperands,
     /*  76689 */     // GIR_Coverage, 3837,
     /*  76689 */     GIR_EraseRootFromParent_Done,
     /*  76690 */   // Label 1502: @76690
     /*  76690 */   GIM_Try, /*On fail goto*//*Label 1503*/ GIMT_Encode4(76783), // Rule ID 3839 //
     /*  76695 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_vector),
     /*  76700 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  76703 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  76706 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  76709 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  76712 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  76715 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  76718 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  76722 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  76726 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  76730 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  76734 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  76738 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  76742 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3706:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$in, MQPR:{ *:[v4i32] }:$sh, 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VSHL_by_vecs32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$in, MQPR:{ *:[v4i32] }:$sh)
     /*  76742 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  76745 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  76749 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  76754 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSHL_by_vecs32),
     /*  76757 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  76759 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  76761 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  76763 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  76766 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  76772 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  76778 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  76781 */     GIR_RootConstrainSelectedInstOperands,
     /*  76782 */     // GIR_Coverage, 3839,
     /*  76782 */     GIR_EraseRootFromParent_Done,
     /*  76783 */   // Label 1503: @76783
     /*  76783 */   GIM_Try, /*On fail goto*//*Label 1504*/ GIMT_Encode4(76876), // Rule ID 3841 //
     /*  76788 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_vector),
     /*  76793 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  76796 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  76799 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  76802 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  76805 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  76808 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  76811 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  76815 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  76819 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  76823 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  76827 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  76831 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  76835 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3706:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$in, MQPR:{ *:[v16i8] }:$sh, 0:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VSHL_by_vecu8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$in, MQPR:{ *:[v16i8] }:$sh)
     /*  76835 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  76838 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  76842 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  76847 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSHL_by_vecu8),
     /*  76850 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  76852 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  76854 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  76856 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  76859 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  76865 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  76871 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  76874 */     GIR_RootConstrainSelectedInstOperands,
     /*  76875 */     // GIR_Coverage, 3841,
     /*  76875 */     GIR_EraseRootFromParent_Done,
     /*  76876 */   // Label 1504: @76876
     /*  76876 */   GIM_Try, /*On fail goto*//*Label 1505*/ GIMT_Encode4(76969), // Rule ID 3843 //
     /*  76881 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_vector),
     /*  76886 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  76889 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  76892 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  76895 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  76898 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  76901 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  76904 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  76908 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  76912 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  76916 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  76920 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  76924 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  76928 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3706:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$in, MQPR:{ *:[v8i16] }:$sh, 0:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VSHL_by_vecu16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$in, MQPR:{ *:[v8i16] }:$sh)
     /*  76928 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  76931 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  76935 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  76940 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSHL_by_vecu16),
     /*  76943 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  76945 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  76947 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  76949 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  76952 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  76958 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  76964 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  76967 */     GIR_RootConstrainSelectedInstOperands,
     /*  76968 */     // GIR_Coverage, 3843,
     /*  76968 */     GIR_EraseRootFromParent_Done,
     /*  76969 */   // Label 1505: @76969
     /*  76969 */   GIM_Try, /*On fail goto*//*Label 1506*/ GIMT_Encode4(77062), // Rule ID 3845 //
     /*  76974 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_vector),
     /*  76979 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  76982 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  76985 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  76988 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  76991 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  76994 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  76997 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  77001 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  77005 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  77009 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  77013 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  77017 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  77021 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3706:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$in, MQPR:{ *:[v4i32] }:$sh, 0:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VSHL_by_vecu32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$in, MQPR:{ *:[v4i32] }:$sh)
     /*  77021 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  77024 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  77028 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  77033 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSHL_by_vecu32),
     /*  77036 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  77038 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  77040 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  77042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  77045 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  77051 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  77057 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  77060 */     GIR_RootConstrainSelectedInstOperands,
     /*  77061 */     // GIR_Coverage, 3845,
     /*  77061 */     GIR_EraseRootFromParent_Done,
     /*  77062 */   // Label 1506: @77062
     /*  77062 */   GIM_Try, /*On fail goto*//*Label 1507*/ GIMT_Encode4(77155), // Rule ID 3847 //
     /*  77067 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_vector),
     /*  77072 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  77075 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  77078 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  77081 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  77084 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  77087 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  77090 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  77094 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  77098 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  77102 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  77106 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  77110 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  77114 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3706:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$in, MQPR:{ *:[v16i8] }:$sh, 1:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VQSHL_by_vecs8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$in, MQPR:{ *:[v16i8] }:$sh)
     /*  77114 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  77117 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  77121 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  77126 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQSHL_by_vecs8),
     /*  77129 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  77131 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  77133 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  77135 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  77138 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  77144 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  77150 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  77153 */     GIR_RootConstrainSelectedInstOperands,
     /*  77154 */     // GIR_Coverage, 3847,
     /*  77154 */     GIR_EraseRootFromParent_Done,
     /*  77155 */   // Label 1507: @77155
     /*  77155 */   GIM_Try, /*On fail goto*//*Label 1508*/ GIMT_Encode4(77248), // Rule ID 3849 //
     /*  77160 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_vector),
     /*  77165 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  77168 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  77171 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  77174 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  77177 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  77180 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  77183 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  77187 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  77191 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  77195 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  77199 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  77203 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  77207 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3706:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$in, MQPR:{ *:[v8i16] }:$sh, 1:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VQSHL_by_vecs16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$in, MQPR:{ *:[v8i16] }:$sh)
     /*  77207 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  77210 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  77214 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  77219 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQSHL_by_vecs16),
     /*  77222 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  77224 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  77226 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  77228 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  77231 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  77237 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  77243 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  77246 */     GIR_RootConstrainSelectedInstOperands,
     /*  77247 */     // GIR_Coverage, 3849,
     /*  77247 */     GIR_EraseRootFromParent_Done,
     /*  77248 */   // Label 1508: @77248
     /*  77248 */   GIM_Try, /*On fail goto*//*Label 1509*/ GIMT_Encode4(77341), // Rule ID 3851 //
     /*  77253 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_vector),
     /*  77258 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  77261 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  77264 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  77267 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  77270 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  77273 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  77276 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  77280 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  77284 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  77288 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  77292 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  77296 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  77300 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3706:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$in, MQPR:{ *:[v4i32] }:$sh, 1:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VQSHL_by_vecs32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$in, MQPR:{ *:[v4i32] }:$sh)
     /*  77300 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  77303 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  77307 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  77312 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQSHL_by_vecs32),
     /*  77315 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  77317 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  77319 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  77321 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  77324 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  77330 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  77336 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  77339 */     GIR_RootConstrainSelectedInstOperands,
     /*  77340 */     // GIR_Coverage, 3851,
     /*  77340 */     GIR_EraseRootFromParent_Done,
     /*  77341 */   // Label 1509: @77341
     /*  77341 */   GIM_Try, /*On fail goto*//*Label 1510*/ GIMT_Encode4(77434), // Rule ID 3853 //
     /*  77346 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_vector),
     /*  77351 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  77354 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  77357 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  77360 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  77363 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  77366 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  77369 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  77373 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  77377 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  77381 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  77385 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  77389 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  77393 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3706:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$in, MQPR:{ *:[v16i8] }:$sh, 1:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VQSHL_by_vecu8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$in, MQPR:{ *:[v16i8] }:$sh)
     /*  77393 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  77396 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  77400 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  77405 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQSHL_by_vecu8),
     /*  77408 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  77410 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  77412 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  77414 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  77417 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  77423 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  77429 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  77432 */     GIR_RootConstrainSelectedInstOperands,
     /*  77433 */     // GIR_Coverage, 3853,
     /*  77433 */     GIR_EraseRootFromParent_Done,
     /*  77434 */   // Label 1510: @77434
     /*  77434 */   GIM_Try, /*On fail goto*//*Label 1511*/ GIMT_Encode4(77527), // Rule ID 3855 //
     /*  77439 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_vector),
     /*  77444 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  77447 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  77450 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  77453 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  77456 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  77459 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  77462 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  77466 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  77470 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  77474 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  77478 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  77482 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  77486 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3706:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$in, MQPR:{ *:[v8i16] }:$sh, 1:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VQSHL_by_vecu16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$in, MQPR:{ *:[v8i16] }:$sh)
     /*  77486 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  77489 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  77493 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  77498 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQSHL_by_vecu16),
     /*  77501 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  77503 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  77505 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  77507 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  77510 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  77516 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  77522 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  77525 */     GIR_RootConstrainSelectedInstOperands,
     /*  77526 */     // GIR_Coverage, 3855,
     /*  77526 */     GIR_EraseRootFromParent_Done,
     /*  77527 */   // Label 1511: @77527
     /*  77527 */   GIM_Try, /*On fail goto*//*Label 1512*/ GIMT_Encode4(77620), // Rule ID 3857 //
     /*  77532 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_vector),
     /*  77537 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  77540 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  77543 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  77546 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  77549 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  77552 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  77555 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  77559 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  77563 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  77567 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  77571 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  77575 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  77579 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3706:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$in, MQPR:{ *:[v4i32] }:$sh, 1:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VQSHL_by_vecu32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$in, MQPR:{ *:[v4i32] }:$sh)
     /*  77579 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  77582 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  77586 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  77591 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQSHL_by_vecu32),
     /*  77594 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  77596 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  77598 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  77600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  77603 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  77609 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  77615 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  77618 */     GIR_RootConstrainSelectedInstOperands,
     /*  77619 */     // GIR_Coverage, 3857,
     /*  77619 */     GIR_EraseRootFromParent_Done,
     /*  77620 */   // Label 1512: @77620
     /*  77620 */   GIM_Try, /*On fail goto*//*Label 1513*/ GIMT_Encode4(77713), // Rule ID 3859 //
     /*  77625 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_vector),
     /*  77630 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  77633 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  77636 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  77639 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  77642 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  77645 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  77648 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  77652 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  77656 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  77660 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  77664 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  77668 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  77672 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3706:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$in, MQPR:{ *:[v16i8] }:$sh, 1:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VQRSHL_by_vecs8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$in, MQPR:{ *:[v16i8] }:$sh)
     /*  77672 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  77675 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  77679 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  77684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQRSHL_by_vecs8),
     /*  77687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  77689 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  77691 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  77693 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  77696 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  77702 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  77708 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  77711 */     GIR_RootConstrainSelectedInstOperands,
     /*  77712 */     // GIR_Coverage, 3859,
     /*  77712 */     GIR_EraseRootFromParent_Done,
     /*  77713 */   // Label 1513: @77713
     /*  77713 */   GIM_Try, /*On fail goto*//*Label 1514*/ GIMT_Encode4(77806), // Rule ID 3861 //
     /*  77718 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_vector),
     /*  77723 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  77726 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  77729 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  77732 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  77735 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  77738 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  77741 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  77745 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  77749 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  77753 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  77757 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  77761 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  77765 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3706:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$in, MQPR:{ *:[v8i16] }:$sh, 1:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VQRSHL_by_vecs16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$in, MQPR:{ *:[v8i16] }:$sh)
     /*  77765 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  77768 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  77772 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  77777 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQRSHL_by_vecs16),
     /*  77780 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  77782 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  77784 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  77786 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  77789 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  77795 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  77801 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  77804 */     GIR_RootConstrainSelectedInstOperands,
     /*  77805 */     // GIR_Coverage, 3861,
     /*  77805 */     GIR_EraseRootFromParent_Done,
     /*  77806 */   // Label 1514: @77806
     /*  77806 */   GIM_Try, /*On fail goto*//*Label 1515*/ GIMT_Encode4(77899), // Rule ID 3863 //
     /*  77811 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_vector),
     /*  77816 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  77819 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  77822 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  77825 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  77828 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  77831 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  77834 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  77838 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  77842 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  77846 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  77850 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  77854 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  77858 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3706:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$in, MQPR:{ *:[v4i32] }:$sh, 1:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VQRSHL_by_vecs32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$in, MQPR:{ *:[v4i32] }:$sh)
     /*  77858 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  77861 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  77865 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  77870 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQRSHL_by_vecs32),
     /*  77873 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  77875 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  77877 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  77879 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  77882 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  77888 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  77894 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  77897 */     GIR_RootConstrainSelectedInstOperands,
     /*  77898 */     // GIR_Coverage, 3863,
     /*  77898 */     GIR_EraseRootFromParent_Done,
     /*  77899 */   // Label 1515: @77899
     /*  77899 */   GIM_Try, /*On fail goto*//*Label 1516*/ GIMT_Encode4(77992), // Rule ID 3865 //
     /*  77904 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_vector),
     /*  77909 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  77912 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  77915 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  77918 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  77921 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  77924 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  77927 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  77931 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  77935 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  77939 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  77943 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  77947 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  77951 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3706:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$in, MQPR:{ *:[v16i8] }:$sh, 1:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VQRSHL_by_vecu8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$in, MQPR:{ *:[v16i8] }:$sh)
     /*  77951 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  77954 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  77958 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  77963 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQRSHL_by_vecu8),
     /*  77966 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  77968 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  77970 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  77972 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  77975 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  77981 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  77987 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  77990 */     GIR_RootConstrainSelectedInstOperands,
     /*  77991 */     // GIR_Coverage, 3865,
     /*  77991 */     GIR_EraseRootFromParent_Done,
     /*  77992 */   // Label 1516: @77992
     /*  77992 */   GIM_Try, /*On fail goto*//*Label 1517*/ GIMT_Encode4(78085), // Rule ID 3867 //
     /*  77997 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_vector),
     /*  78002 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  78005 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  78008 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  78011 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  78014 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  78017 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  78020 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  78024 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  78028 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  78032 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  78036 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  78040 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  78044 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3706:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$in, MQPR:{ *:[v8i16] }:$sh, 1:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VQRSHL_by_vecu16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$in, MQPR:{ *:[v8i16] }:$sh)
     /*  78044 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  78047 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  78051 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  78056 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQRSHL_by_vecu16),
     /*  78059 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  78061 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  78063 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  78065 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  78068 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  78074 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  78080 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  78083 */     GIR_RootConstrainSelectedInstOperands,
     /*  78084 */     // GIR_Coverage, 3867,
     /*  78084 */     GIR_EraseRootFromParent_Done,
     /*  78085 */   // Label 1517: @78085
     /*  78085 */   GIM_Try, /*On fail goto*//*Label 1518*/ GIMT_Encode4(78178), // Rule ID 3869 //
     /*  78090 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_vector),
     /*  78095 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  78098 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  78101 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  78104 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  78107 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  78110 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  78113 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  78117 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  78121 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  78125 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  78129 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  78133 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  78137 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3706:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$in, MQPR:{ *:[v4i32] }:$sh, 1:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VQRSHL_by_vecu32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$in, MQPR:{ *:[v4i32] }:$sh)
     /*  78137 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  78140 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  78144 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  78149 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQRSHL_by_vecu32),
     /*  78152 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  78154 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  78156 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  78158 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  78161 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  78167 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  78173 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  78176 */     GIR_RootConstrainSelectedInstOperands,
     /*  78177 */     // GIR_Coverage, 3869,
     /*  78177 */     GIR_EraseRootFromParent_Done,
     /*  78178 */   // Label 1518: @78178
     /*  78178 */   GIM_Try, /*On fail goto*//*Label 1519*/ GIMT_Encode4(78271), // Rule ID 3871 //
     /*  78183 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_vector),
     /*  78188 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  78191 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  78194 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  78197 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  78200 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  78203 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  78206 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  78210 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  78214 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  78218 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  78222 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  78226 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  78230 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3706:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$in, MQPR:{ *:[v16i8] }:$sh, 0:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VRSHL_by_vecs8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$in, MQPR:{ *:[v16i8] }:$sh)
     /*  78230 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  78233 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  78237 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  78242 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRSHL_by_vecs8),
     /*  78245 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  78247 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  78249 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  78251 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  78254 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  78260 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  78266 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  78269 */     GIR_RootConstrainSelectedInstOperands,
     /*  78270 */     // GIR_Coverage, 3871,
     /*  78270 */     GIR_EraseRootFromParent_Done,
     /*  78271 */   // Label 1519: @78271
     /*  78271 */   GIM_Try, /*On fail goto*//*Label 1520*/ GIMT_Encode4(78364), // Rule ID 3873 //
     /*  78276 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_vector),
     /*  78281 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  78284 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  78287 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  78290 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  78293 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  78296 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  78299 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  78303 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  78307 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  78311 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  78315 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  78319 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  78323 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3706:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$in, MQPR:{ *:[v8i16] }:$sh, 0:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VRSHL_by_vecs16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$in, MQPR:{ *:[v8i16] }:$sh)
     /*  78323 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  78326 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  78330 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  78335 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRSHL_by_vecs16),
     /*  78338 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  78340 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  78342 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  78344 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  78347 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  78353 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  78359 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  78362 */     GIR_RootConstrainSelectedInstOperands,
     /*  78363 */     // GIR_Coverage, 3873,
     /*  78363 */     GIR_EraseRootFromParent_Done,
     /*  78364 */   // Label 1520: @78364
     /*  78364 */   GIM_Try, /*On fail goto*//*Label 1521*/ GIMT_Encode4(78457), // Rule ID 3875 //
     /*  78369 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_vector),
     /*  78374 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  78377 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  78380 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  78383 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  78386 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  78389 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  78392 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  78396 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  78400 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  78404 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  78408 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  78412 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  78416 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3706:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$in, MQPR:{ *:[v4i32] }:$sh, 0:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VRSHL_by_vecs32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$in, MQPR:{ *:[v4i32] }:$sh)
     /*  78416 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  78419 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  78423 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  78428 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRSHL_by_vecs32),
     /*  78431 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  78433 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  78435 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  78437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  78440 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  78446 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  78452 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  78455 */     GIR_RootConstrainSelectedInstOperands,
     /*  78456 */     // GIR_Coverage, 3875,
     /*  78456 */     GIR_EraseRootFromParent_Done,
     /*  78457 */   // Label 1521: @78457
     /*  78457 */   GIM_Try, /*On fail goto*//*Label 1522*/ GIMT_Encode4(78550), // Rule ID 3877 //
     /*  78462 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_vector),
     /*  78467 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  78470 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  78473 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  78476 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  78479 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  78482 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  78485 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  78489 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  78493 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  78497 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  78501 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  78505 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  78509 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3706:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$in, MQPR:{ *:[v16i8] }:$sh, 0:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VRSHL_by_vecu8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$in, MQPR:{ *:[v16i8] }:$sh)
     /*  78509 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  78512 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  78516 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  78521 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRSHL_by_vecu8),
     /*  78524 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  78526 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  78528 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  78530 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  78533 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  78539 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  78545 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  78548 */     GIR_RootConstrainSelectedInstOperands,
     /*  78549 */     // GIR_Coverage, 3877,
     /*  78549 */     GIR_EraseRootFromParent_Done,
     /*  78550 */   // Label 1522: @78550
     /*  78550 */   GIM_Try, /*On fail goto*//*Label 1523*/ GIMT_Encode4(78643), // Rule ID 3879 //
     /*  78555 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_vector),
     /*  78560 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  78563 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  78566 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  78569 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  78572 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  78575 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  78578 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  78582 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  78586 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  78590 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  78594 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  78598 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  78602 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3706:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$in, MQPR:{ *:[v8i16] }:$sh, 0:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VRSHL_by_vecu16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$in, MQPR:{ *:[v8i16] }:$sh)
     /*  78602 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  78605 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  78609 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  78614 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRSHL_by_vecu16),
     /*  78617 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  78619 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  78621 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  78623 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  78626 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  78632 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  78638 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  78641 */     GIR_RootConstrainSelectedInstOperands,
     /*  78642 */     // GIR_Coverage, 3879,
     /*  78642 */     GIR_EraseRootFromParent_Done,
     /*  78643 */   // Label 1523: @78643
     /*  78643 */   GIM_Try, /*On fail goto*//*Label 1524*/ GIMT_Encode4(78736), // Rule ID 3881 //
     /*  78648 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_vector),
     /*  78653 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  78656 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  78659 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  78662 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  78665 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  78668 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  78671 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  78675 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  78679 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  78683 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  78687 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  78691 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  78695 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3706:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$in, MQPR:{ *:[v4i32] }:$sh, 0:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VRSHL_by_vecu32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$in, MQPR:{ *:[v4i32] }:$sh)
     /*  78695 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  78698 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  78702 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  78707 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRSHL_by_vecu32),
     /*  78710 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  78712 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  78714 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  78716 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  78719 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  78725 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  78731 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  78734 */     GIR_RootConstrainSelectedInstOperands,
     /*  78735 */     // GIR_Coverage, 3881,
     /*  78735 */     GIR_EraseRootFromParent_Done,
     /*  78736 */   // Label 1524: @78736
     /*  78736 */   GIM_Try, /*On fail goto*//*Label 1525*/ GIMT_Encode4(78814), // Rule ID 4486 //
     /*  78741 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqmovn),
     /*  78746 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  78749 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  78752 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  78755 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  78758 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  78761 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  78764 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  78768 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  78772 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  78776 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  78780 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  78784 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  78788 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3677:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$Qd_src, MQPR:{ *:[v4i32] }:$Qm, 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VQMOVNs32bh:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qd_src, MQPR:{ *:[v4i32] }:$Qm)
     /*  78788 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQMOVNs32bh),
     /*  78791 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  78793 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qd_src
     /*  78795 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  78797 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  78800 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  78806 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  78812 */     GIR_RootConstrainSelectedInstOperands,
     /*  78813 */     // GIR_Coverage, 4486,
     /*  78813 */     GIR_EraseRootFromParent_Done,
     /*  78814 */   // Label 1525: @78814
     /*  78814 */   GIM_Try, /*On fail goto*//*Label 1526*/ GIMT_Encode4(78892), // Rule ID 4488 //
     /*  78819 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqmovn),
     /*  78824 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  78827 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  78830 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  78833 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  78836 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  78839 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  78842 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  78846 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  78850 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  78854 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  78858 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  78862 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  78866 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3677:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$Qd_src, MQPR:{ *:[v4i32] }:$Qm, 0:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VQMOVNs32th:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qd_src, MQPR:{ *:[v4i32] }:$Qm)
     /*  78866 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQMOVNs32th),
     /*  78869 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  78871 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qd_src
     /*  78873 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  78875 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  78878 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  78884 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  78890 */     GIR_RootConstrainSelectedInstOperands,
     /*  78891 */     // GIR_Coverage, 4488,
     /*  78891 */     GIR_EraseRootFromParent_Done,
     /*  78892 */   // Label 1526: @78892
     /*  78892 */   GIM_Try, /*On fail goto*//*Label 1527*/ GIMT_Encode4(78970), // Rule ID 4490 //
     /*  78897 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqmovn),
     /*  78902 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  78905 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  78908 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  78911 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  78914 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  78917 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  78920 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  78924 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  78928 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  78932 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  78936 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  78940 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  78944 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3677:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$Qd_src, MQPR:{ *:[v8i16] }:$Qm, 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VQMOVNs16bh:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qd_src, MQPR:{ *:[v8i16] }:$Qm)
     /*  78944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQMOVNs16bh),
     /*  78947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  78949 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qd_src
     /*  78951 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  78953 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  78956 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  78962 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  78968 */     GIR_RootConstrainSelectedInstOperands,
     /*  78969 */     // GIR_Coverage, 4490,
     /*  78969 */     GIR_EraseRootFromParent_Done,
     /*  78970 */   // Label 1527: @78970
     /*  78970 */   GIM_Try, /*On fail goto*//*Label 1528*/ GIMT_Encode4(79048), // Rule ID 4492 //
     /*  78975 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqmovn),
     /*  78980 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  78983 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  78986 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  78989 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  78992 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  78995 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  78998 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  79002 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  79006 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  79010 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  79014 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  79018 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  79022 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3677:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$Qd_src, MQPR:{ *:[v8i16] }:$Qm, 0:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VQMOVNs16th:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qd_src, MQPR:{ *:[v8i16] }:$Qm)
     /*  79022 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQMOVNs16th),
     /*  79025 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  79027 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qd_src
     /*  79029 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  79031 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  79034 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  79040 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  79046 */     GIR_RootConstrainSelectedInstOperands,
     /*  79047 */     // GIR_Coverage, 4492,
     /*  79047 */     GIR_EraseRootFromParent_Done,
     /*  79048 */   // Label 1528: @79048
     /*  79048 */   GIM_Try, /*On fail goto*//*Label 1529*/ GIMT_Encode4(79126), // Rule ID 4494 //
     /*  79053 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqmovn),
     /*  79058 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  79061 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  79064 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  79067 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  79070 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  79073 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  79076 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  79080 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  79084 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  79088 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  79092 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  79096 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  79100 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3677:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$Qd_src, MQPR:{ *:[v4i32] }:$Qm, 1:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VQMOVNu32bh:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qd_src, MQPR:{ *:[v4i32] }:$Qm)
     /*  79100 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQMOVNu32bh),
     /*  79103 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  79105 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qd_src
     /*  79107 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  79109 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  79112 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  79118 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  79124 */     GIR_RootConstrainSelectedInstOperands,
     /*  79125 */     // GIR_Coverage, 4494,
     /*  79125 */     GIR_EraseRootFromParent_Done,
     /*  79126 */   // Label 1529: @79126
     /*  79126 */   GIM_Try, /*On fail goto*//*Label 1530*/ GIMT_Encode4(79204), // Rule ID 4496 //
     /*  79131 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqmovn),
     /*  79136 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  79139 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  79142 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  79145 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  79148 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  79151 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  79154 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  79158 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  79162 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  79166 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  79170 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  79174 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  79178 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3677:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$Qd_src, MQPR:{ *:[v4i32] }:$Qm, 1:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VQMOVNu32th:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qd_src, MQPR:{ *:[v4i32] }:$Qm)
     /*  79178 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQMOVNu32th),
     /*  79181 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  79183 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qd_src
     /*  79185 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  79187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  79190 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  79196 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  79202 */     GIR_RootConstrainSelectedInstOperands,
     /*  79203 */     // GIR_Coverage, 4496,
     /*  79203 */     GIR_EraseRootFromParent_Done,
     /*  79204 */   // Label 1530: @79204
     /*  79204 */   GIM_Try, /*On fail goto*//*Label 1531*/ GIMT_Encode4(79282), // Rule ID 4498 //
     /*  79209 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqmovn),
     /*  79214 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  79217 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  79220 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  79223 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  79226 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  79229 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  79232 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  79236 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  79240 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  79244 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  79248 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  79252 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  79256 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3677:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$Qd_src, MQPR:{ *:[v8i16] }:$Qm, 1:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VQMOVNu16bh:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qd_src, MQPR:{ *:[v8i16] }:$Qm)
     /*  79256 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQMOVNu16bh),
     /*  79259 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  79261 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qd_src
     /*  79263 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  79265 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  79268 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  79274 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  79280 */     GIR_RootConstrainSelectedInstOperands,
     /*  79281 */     // GIR_Coverage, 4498,
     /*  79281 */     GIR_EraseRootFromParent_Done,
     /*  79282 */   // Label 1531: @79282
     /*  79282 */   GIM_Try, /*On fail goto*//*Label 1532*/ GIMT_Encode4(79360), // Rule ID 4500 //
     /*  79287 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqmovn),
     /*  79292 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  79295 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  79298 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  79301 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  79304 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  79307 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  79310 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  79314 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  79318 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  79322 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  79326 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  79330 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  79334 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3677:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$Qd_src, MQPR:{ *:[v8i16] }:$Qm, 1:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VQMOVNu16th:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qd_src, MQPR:{ *:[v8i16] }:$Qm)
     /*  79334 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQMOVNu16th),
     /*  79337 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  79339 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qd_src
     /*  79341 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  79343 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  79346 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  79352 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  79358 */     GIR_RootConstrainSelectedInstOperands,
     /*  79359 */     // GIR_Coverage, 4500,
     /*  79359 */     GIR_EraseRootFromParent_Done,
     /*  79360 */   // Label 1532: @79360
     /*  79360 */   GIM_Try, /*On fail goto*//*Label 1533*/ GIMT_Encode4(79438), // Rule ID 4502 //
     /*  79365 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqmovn),
     /*  79370 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  79373 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  79376 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  79379 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  79382 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  79385 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  79388 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  79392 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  79396 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  79400 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  79404 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  79408 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  79412 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3677:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$Qd_src, MQPR:{ *:[v4i32] }:$Qm, 1:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VQMOVUNs32bh:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qd_src, MQPR:{ *:[v4i32] }:$Qm)
     /*  79412 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQMOVUNs32bh),
     /*  79415 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  79417 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qd_src
     /*  79419 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  79421 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  79424 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  79430 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  79436 */     GIR_RootConstrainSelectedInstOperands,
     /*  79437 */     // GIR_Coverage, 4502,
     /*  79437 */     GIR_EraseRootFromParent_Done,
     /*  79438 */   // Label 1533: @79438
     /*  79438 */   GIM_Try, /*On fail goto*//*Label 1534*/ GIMT_Encode4(79516), // Rule ID 4504 //
     /*  79443 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqmovn),
     /*  79448 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  79451 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  79454 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  79457 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  79460 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  79463 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  79466 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  79470 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  79474 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  79478 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  79482 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  79486 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  79490 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3677:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$Qd_src, MQPR:{ *:[v4i32] }:$Qm, 1:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VQMOVUNs32th:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qd_src, MQPR:{ *:[v4i32] }:$Qm)
     /*  79490 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQMOVUNs32th),
     /*  79493 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  79495 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qd_src
     /*  79497 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  79499 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  79502 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  79508 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  79514 */     GIR_RootConstrainSelectedInstOperands,
     /*  79515 */     // GIR_Coverage, 4504,
     /*  79515 */     GIR_EraseRootFromParent_Done,
     /*  79516 */   // Label 1534: @79516
     /*  79516 */   GIM_Try, /*On fail goto*//*Label 1535*/ GIMT_Encode4(79594), // Rule ID 4506 //
     /*  79521 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqmovn),
     /*  79526 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  79529 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  79532 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  79535 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  79538 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  79541 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  79544 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  79548 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  79552 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  79556 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  79560 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  79564 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  79568 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3677:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$Qd_src, MQPR:{ *:[v8i16] }:$Qm, 1:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VQMOVUNs16bh:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qd_src, MQPR:{ *:[v8i16] }:$Qm)
     /*  79568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQMOVUNs16bh),
     /*  79571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  79573 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qd_src
     /*  79575 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  79577 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  79580 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  79586 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  79592 */     GIR_RootConstrainSelectedInstOperands,
     /*  79593 */     // GIR_Coverage, 4506,
     /*  79593 */     GIR_EraseRootFromParent_Done,
     /*  79594 */   // Label 1535: @79594
     /*  79594 */   GIM_Try, /*On fail goto*//*Label 1536*/ GIMT_Encode4(79672), // Rule ID 4508 //
     /*  79599 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqmovn),
     /*  79604 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  79607 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  79610 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  79613 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  79616 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  79619 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  79622 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  79626 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  79630 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  79634 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  79638 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  79642 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  79646 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3677:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$Qd_src, MQPR:{ *:[v8i16] }:$Qm, 1:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VQMOVUNs16th:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qd_src, MQPR:{ *:[v8i16] }:$Qm)
     /*  79646 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQMOVUNs16th),
     /*  79649 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  79651 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qd_src
     /*  79653 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  79655 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  79658 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  79664 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  79670 */     GIR_RootConstrainSelectedInstOperands,
     /*  79671 */     // GIR_Coverage, 4508,
     /*  79671 */     GIR_EraseRootFromParent_Done,
     /*  79672 */   // Label 1536: @79672
     /*  79672 */   GIM_Try, /*On fail goto*//*Label 1537*/ GIMT_Encode4(79750), // Rule ID 4698 //
     /*  79677 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_scalar),
     /*  79682 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  79685 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  79688 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  79691 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  79694 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  79697 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  79700 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  79704 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  79708 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  79712 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  79716 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  79720 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  79724 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3704:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$in, rGPR:{ *:[i32] }:$sh, 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VSHL_qrs8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$in, rGPR:{ *:[i32] }:$sh)
     /*  79724 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSHL_qrs8),
     /*  79727 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  79729 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  79731 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  79733 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  79736 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  79742 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  79748 */     GIR_RootConstrainSelectedInstOperands,
     /*  79749 */     // GIR_Coverage, 4698,
     /*  79749 */     GIR_EraseRootFromParent_Done,
     /*  79750 */   // Label 1537: @79750
     /*  79750 */   GIM_Try, /*On fail goto*//*Label 1538*/ GIMT_Encode4(79828), // Rule ID 4700 //
     /*  79755 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_scalar),
     /*  79760 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  79763 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  79766 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  79769 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  79772 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  79775 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  79778 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  79782 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  79786 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  79790 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  79794 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  79798 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  79802 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3704:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$in, rGPR:{ *:[i32] }:$sh, 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VSHL_qrs16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$in, rGPR:{ *:[i32] }:$sh)
     /*  79802 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSHL_qrs16),
     /*  79805 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  79807 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  79809 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  79811 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  79814 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  79820 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  79826 */     GIR_RootConstrainSelectedInstOperands,
     /*  79827 */     // GIR_Coverage, 4700,
     /*  79827 */     GIR_EraseRootFromParent_Done,
     /*  79828 */   // Label 1538: @79828
     /*  79828 */   GIM_Try, /*On fail goto*//*Label 1539*/ GIMT_Encode4(79906), // Rule ID 4702 //
     /*  79833 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_scalar),
     /*  79838 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  79841 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  79844 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  79847 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  79850 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  79853 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  79856 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  79860 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  79864 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  79868 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  79872 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  79876 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  79880 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3704:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$in, rGPR:{ *:[i32] }:$sh, 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VSHL_qrs32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$in, rGPR:{ *:[i32] }:$sh)
     /*  79880 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSHL_qrs32),
     /*  79883 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  79885 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  79887 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  79889 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  79892 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  79898 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  79904 */     GIR_RootConstrainSelectedInstOperands,
     /*  79905 */     // GIR_Coverage, 4702,
     /*  79905 */     GIR_EraseRootFromParent_Done,
     /*  79906 */   // Label 1539: @79906
     /*  79906 */   GIM_Try, /*On fail goto*//*Label 1540*/ GIMT_Encode4(79984), // Rule ID 4704 //
     /*  79911 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_scalar),
     /*  79916 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  79919 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  79922 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  79925 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  79928 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  79931 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  79934 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  79938 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  79942 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  79946 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  79950 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  79954 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  79958 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3704:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$in, rGPR:{ *:[i32] }:$sh, 0:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VSHL_qru8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$in, rGPR:{ *:[i32] }:$sh)
     /*  79958 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSHL_qru8),
     /*  79961 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  79963 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  79965 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  79967 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  79970 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  79976 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  79982 */     GIR_RootConstrainSelectedInstOperands,
     /*  79983 */     // GIR_Coverage, 4704,
     /*  79983 */     GIR_EraseRootFromParent_Done,
     /*  79984 */   // Label 1540: @79984
     /*  79984 */   GIM_Try, /*On fail goto*//*Label 1541*/ GIMT_Encode4(80062), // Rule ID 4706 //
     /*  79989 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_scalar),
     /*  79994 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  79997 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  80000 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  80003 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  80006 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  80009 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  80012 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  80016 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  80020 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  80024 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  80028 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  80032 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  80036 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3704:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$in, rGPR:{ *:[i32] }:$sh, 0:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VSHL_qru16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$in, rGPR:{ *:[i32] }:$sh)
     /*  80036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSHL_qru16),
     /*  80039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  80041 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  80043 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  80045 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  80048 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  80054 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  80060 */     GIR_RootConstrainSelectedInstOperands,
     /*  80061 */     // GIR_Coverage, 4706,
     /*  80061 */     GIR_EraseRootFromParent_Done,
     /*  80062 */   // Label 1541: @80062
     /*  80062 */   GIM_Try, /*On fail goto*//*Label 1542*/ GIMT_Encode4(80140), // Rule ID 4708 //
     /*  80067 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_scalar),
     /*  80072 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  80075 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  80078 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  80081 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  80084 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  80087 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  80090 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  80094 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  80098 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  80102 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  80106 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  80110 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  80114 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3704:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$in, rGPR:{ *:[i32] }:$sh, 0:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VSHL_qru32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$in, rGPR:{ *:[i32] }:$sh)
     /*  80114 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSHL_qru32),
     /*  80117 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  80119 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  80121 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  80123 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  80126 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  80132 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  80138 */     GIR_RootConstrainSelectedInstOperands,
     /*  80139 */     // GIR_Coverage, 4708,
     /*  80139 */     GIR_EraseRootFromParent_Done,
     /*  80140 */   // Label 1542: @80140
     /*  80140 */   GIM_Try, /*On fail goto*//*Label 1543*/ GIMT_Encode4(80218), // Rule ID 4710 //
     /*  80145 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_scalar),
     /*  80150 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  80153 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  80156 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  80159 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  80162 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  80165 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  80168 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  80172 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  80176 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  80180 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  80184 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  80188 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  80192 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3704:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$in, rGPR:{ *:[i32] }:$sh, 0:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VRSHL_qrs8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$in, rGPR:{ *:[i32] }:$sh)
     /*  80192 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRSHL_qrs8),
     /*  80195 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  80197 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  80199 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  80201 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  80204 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  80210 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  80216 */     GIR_RootConstrainSelectedInstOperands,
     /*  80217 */     // GIR_Coverage, 4710,
     /*  80217 */     GIR_EraseRootFromParent_Done,
     /*  80218 */   // Label 1543: @80218
     /*  80218 */   GIM_Try, /*On fail goto*//*Label 1544*/ GIMT_Encode4(80296), // Rule ID 4712 //
     /*  80223 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_scalar),
     /*  80228 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  80231 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  80234 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  80237 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  80240 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  80243 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  80246 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  80250 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  80254 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  80258 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  80262 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  80266 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  80270 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3704:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$in, rGPR:{ *:[i32] }:$sh, 0:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VRSHL_qrs16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$in, rGPR:{ *:[i32] }:$sh)
     /*  80270 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRSHL_qrs16),
     /*  80273 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  80275 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  80277 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  80279 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  80282 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  80288 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  80294 */     GIR_RootConstrainSelectedInstOperands,
     /*  80295 */     // GIR_Coverage, 4712,
     /*  80295 */     GIR_EraseRootFromParent_Done,
     /*  80296 */   // Label 1544: @80296
     /*  80296 */   GIM_Try, /*On fail goto*//*Label 1545*/ GIMT_Encode4(80374), // Rule ID 4714 //
     /*  80301 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_scalar),
     /*  80306 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  80309 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  80312 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  80315 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  80318 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  80321 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  80324 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  80328 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  80332 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  80336 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  80340 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  80344 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  80348 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3704:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$in, rGPR:{ *:[i32] }:$sh, 0:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VRSHL_qrs32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$in, rGPR:{ *:[i32] }:$sh)
     /*  80348 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRSHL_qrs32),
     /*  80351 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  80353 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  80355 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  80357 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  80360 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  80366 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  80372 */     GIR_RootConstrainSelectedInstOperands,
     /*  80373 */     // GIR_Coverage, 4714,
     /*  80373 */     GIR_EraseRootFromParent_Done,
     /*  80374 */   // Label 1545: @80374
     /*  80374 */   GIM_Try, /*On fail goto*//*Label 1546*/ GIMT_Encode4(80452), // Rule ID 4716 //
     /*  80379 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_scalar),
     /*  80384 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  80387 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  80390 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  80393 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  80396 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  80399 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  80402 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  80406 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  80410 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  80414 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  80418 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  80422 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  80426 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3704:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$in, rGPR:{ *:[i32] }:$sh, 0:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VRSHL_qru8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$in, rGPR:{ *:[i32] }:$sh)
     /*  80426 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRSHL_qru8),
     /*  80429 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  80431 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  80433 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  80435 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  80438 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  80444 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  80450 */     GIR_RootConstrainSelectedInstOperands,
     /*  80451 */     // GIR_Coverage, 4716,
     /*  80451 */     GIR_EraseRootFromParent_Done,
     /*  80452 */   // Label 1546: @80452
     /*  80452 */   GIM_Try, /*On fail goto*//*Label 1547*/ GIMT_Encode4(80530), // Rule ID 4718 //
     /*  80457 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_scalar),
     /*  80462 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  80465 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  80468 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  80471 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  80474 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  80477 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  80480 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  80484 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  80488 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  80492 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  80496 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  80500 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  80504 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3704:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$in, rGPR:{ *:[i32] }:$sh, 0:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VRSHL_qru16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$in, rGPR:{ *:[i32] }:$sh)
     /*  80504 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRSHL_qru16),
     /*  80507 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  80509 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  80511 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  80513 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  80516 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  80522 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  80528 */     GIR_RootConstrainSelectedInstOperands,
     /*  80529 */     // GIR_Coverage, 4718,
     /*  80529 */     GIR_EraseRootFromParent_Done,
     /*  80530 */   // Label 1547: @80530
     /*  80530 */   GIM_Try, /*On fail goto*//*Label 1548*/ GIMT_Encode4(80608), // Rule ID 4720 //
     /*  80535 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_scalar),
     /*  80540 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  80543 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  80546 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  80549 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  80552 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  80555 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  80558 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  80562 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  80566 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  80570 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  80574 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  80578 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  80582 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3704:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$in, rGPR:{ *:[i32] }:$sh, 0:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VRSHL_qru32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$in, rGPR:{ *:[i32] }:$sh)
     /*  80582 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRSHL_qru32),
     /*  80585 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  80587 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  80589 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  80591 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  80594 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  80600 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  80606 */     GIR_RootConstrainSelectedInstOperands,
     /*  80607 */     // GIR_Coverage, 4720,
     /*  80607 */     GIR_EraseRootFromParent_Done,
     /*  80608 */   // Label 1548: @80608
     /*  80608 */   GIM_Try, /*On fail goto*//*Label 1549*/ GIMT_Encode4(80686), // Rule ID 4722 //
     /*  80613 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_scalar),
     /*  80618 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  80621 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  80624 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  80627 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  80630 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  80633 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  80636 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  80640 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  80644 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  80648 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  80652 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  80656 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  80660 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3704:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$in, rGPR:{ *:[i32] }:$sh, 1:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VQSHL_qrs8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$in, rGPR:{ *:[i32] }:$sh)
     /*  80660 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQSHL_qrs8),
     /*  80663 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  80665 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  80667 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  80669 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  80672 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  80678 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  80684 */     GIR_RootConstrainSelectedInstOperands,
     /*  80685 */     // GIR_Coverage, 4722,
     /*  80685 */     GIR_EraseRootFromParent_Done,
     /*  80686 */   // Label 1549: @80686
     /*  80686 */   GIM_Try, /*On fail goto*//*Label 1550*/ GIMT_Encode4(80764), // Rule ID 4724 //
     /*  80691 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_scalar),
     /*  80696 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  80699 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  80702 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  80705 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  80708 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  80711 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  80714 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  80718 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  80722 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  80726 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  80730 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  80734 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  80738 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3704:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$in, rGPR:{ *:[i32] }:$sh, 1:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VQSHL_qrs16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$in, rGPR:{ *:[i32] }:$sh)
     /*  80738 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQSHL_qrs16),
     /*  80741 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  80743 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  80745 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  80747 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  80750 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  80756 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  80762 */     GIR_RootConstrainSelectedInstOperands,
     /*  80763 */     // GIR_Coverage, 4724,
     /*  80763 */     GIR_EraseRootFromParent_Done,
     /*  80764 */   // Label 1550: @80764
     /*  80764 */   GIM_Try, /*On fail goto*//*Label 1551*/ GIMT_Encode4(80842), // Rule ID 4726 //
     /*  80769 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_scalar),
     /*  80774 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  80777 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  80780 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  80783 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  80786 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  80789 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  80792 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  80796 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  80800 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  80804 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  80808 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  80812 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  80816 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3704:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$in, rGPR:{ *:[i32] }:$sh, 1:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VQSHL_qrs32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$in, rGPR:{ *:[i32] }:$sh)
     /*  80816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQSHL_qrs32),
     /*  80819 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  80821 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  80823 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  80825 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  80828 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  80834 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  80840 */     GIR_RootConstrainSelectedInstOperands,
     /*  80841 */     // GIR_Coverage, 4726,
     /*  80841 */     GIR_EraseRootFromParent_Done,
     /*  80842 */   // Label 1551: @80842
     /*  80842 */   GIM_Try, /*On fail goto*//*Label 1552*/ GIMT_Encode4(80920), // Rule ID 4728 //
     /*  80847 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_scalar),
     /*  80852 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  80855 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  80858 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  80861 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  80864 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  80867 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  80870 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  80874 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  80878 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  80882 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  80886 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  80890 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  80894 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3704:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$in, rGPR:{ *:[i32] }:$sh, 1:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VQSHL_qru8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$in, rGPR:{ *:[i32] }:$sh)
     /*  80894 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQSHL_qru8),
     /*  80897 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  80899 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  80901 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  80903 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  80906 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  80912 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  80918 */     GIR_RootConstrainSelectedInstOperands,
     /*  80919 */     // GIR_Coverage, 4728,
     /*  80919 */     GIR_EraseRootFromParent_Done,
     /*  80920 */   // Label 1552: @80920
     /*  80920 */   GIM_Try, /*On fail goto*//*Label 1553*/ GIMT_Encode4(80998), // Rule ID 4730 //
     /*  80925 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_scalar),
     /*  80930 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  80933 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  80936 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  80939 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  80942 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  80945 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  80948 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  80952 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  80956 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  80960 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  80964 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  80968 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  80972 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3704:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$in, rGPR:{ *:[i32] }:$sh, 1:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VQSHL_qru16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$in, rGPR:{ *:[i32] }:$sh)
     /*  80972 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQSHL_qru16),
     /*  80975 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  80977 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  80979 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  80981 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  80984 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  80990 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  80996 */     GIR_RootConstrainSelectedInstOperands,
     /*  80997 */     // GIR_Coverage, 4730,
     /*  80997 */     GIR_EraseRootFromParent_Done,
     /*  80998 */   // Label 1553: @80998
     /*  80998 */   GIM_Try, /*On fail goto*//*Label 1554*/ GIMT_Encode4(81076), // Rule ID 4732 //
     /*  81003 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_scalar),
     /*  81008 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  81011 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  81014 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  81017 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  81020 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  81023 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  81026 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  81030 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  81034 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  81038 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  81042 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  81046 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  81050 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3704:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$in, rGPR:{ *:[i32] }:$sh, 1:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VQSHL_qru32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$in, rGPR:{ *:[i32] }:$sh)
     /*  81050 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQSHL_qru32),
     /*  81053 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  81055 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  81057 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  81059 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  81062 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  81068 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  81074 */     GIR_RootConstrainSelectedInstOperands,
     /*  81075 */     // GIR_Coverage, 4732,
     /*  81075 */     GIR_EraseRootFromParent_Done,
     /*  81076 */   // Label 1554: @81076
     /*  81076 */   GIM_Try, /*On fail goto*//*Label 1555*/ GIMT_Encode4(81154), // Rule ID 4734 //
     /*  81081 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_scalar),
     /*  81086 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  81089 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  81092 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  81095 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  81098 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  81101 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  81104 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  81108 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  81112 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  81116 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  81120 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  81124 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  81128 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3704:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$in, rGPR:{ *:[i32] }:$sh, 1:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VQRSHL_qrs8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$in, rGPR:{ *:[i32] }:$sh)
     /*  81128 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQRSHL_qrs8),
     /*  81131 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  81133 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  81135 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  81137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  81140 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  81146 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  81152 */     GIR_RootConstrainSelectedInstOperands,
     /*  81153 */     // GIR_Coverage, 4734,
     /*  81153 */     GIR_EraseRootFromParent_Done,
     /*  81154 */   // Label 1555: @81154
     /*  81154 */   GIM_Try, /*On fail goto*//*Label 1556*/ GIMT_Encode4(81232), // Rule ID 4736 //
     /*  81159 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_scalar),
     /*  81164 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  81167 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  81170 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  81173 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  81176 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  81179 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  81182 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  81186 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  81190 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  81194 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  81198 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  81202 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  81206 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3704:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$in, rGPR:{ *:[i32] }:$sh, 1:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VQRSHL_qrs16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$in, rGPR:{ *:[i32] }:$sh)
     /*  81206 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQRSHL_qrs16),
     /*  81209 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  81211 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  81213 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  81215 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  81218 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  81224 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  81230 */     GIR_RootConstrainSelectedInstOperands,
     /*  81231 */     // GIR_Coverage, 4736,
     /*  81231 */     GIR_EraseRootFromParent_Done,
     /*  81232 */   // Label 1556: @81232
     /*  81232 */   GIM_Try, /*On fail goto*//*Label 1557*/ GIMT_Encode4(81310), // Rule ID 4738 //
     /*  81237 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_scalar),
     /*  81242 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  81245 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  81248 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  81251 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  81254 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  81257 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  81260 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  81264 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  81268 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  81272 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  81276 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  81280 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  81284 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3704:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$in, rGPR:{ *:[i32] }:$sh, 1:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VQRSHL_qrs32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$in, rGPR:{ *:[i32] }:$sh)
     /*  81284 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQRSHL_qrs32),
     /*  81287 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  81289 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  81291 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  81293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  81296 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  81302 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  81308 */     GIR_RootConstrainSelectedInstOperands,
     /*  81309 */     // GIR_Coverage, 4738,
     /*  81309 */     GIR_EraseRootFromParent_Done,
     /*  81310 */   // Label 1557: @81310
     /*  81310 */   GIM_Try, /*On fail goto*//*Label 1558*/ GIMT_Encode4(81388), // Rule ID 4740 //
     /*  81315 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_scalar),
     /*  81320 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  81323 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  81326 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  81329 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  81332 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  81335 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  81338 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  81342 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  81346 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  81350 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  81354 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  81358 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  81362 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3704:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$in, rGPR:{ *:[i32] }:$sh, 1:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VQRSHL_qru8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$in, rGPR:{ *:[i32] }:$sh)
     /*  81362 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQRSHL_qru8),
     /*  81365 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  81367 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  81369 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  81371 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  81374 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  81380 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  81386 */     GIR_RootConstrainSelectedInstOperands,
     /*  81387 */     // GIR_Coverage, 4740,
     /*  81387 */     GIR_EraseRootFromParent_Done,
     /*  81388 */   // Label 1558: @81388
     /*  81388 */   GIM_Try, /*On fail goto*//*Label 1559*/ GIMT_Encode4(81466), // Rule ID 4742 //
     /*  81393 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_scalar),
     /*  81398 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  81401 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  81404 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  81407 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  81410 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  81413 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  81416 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  81420 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  81424 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  81428 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  81432 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  81436 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  81440 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3704:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$in, rGPR:{ *:[i32] }:$sh, 1:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VQRSHL_qru16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$in, rGPR:{ *:[i32] }:$sh)
     /*  81440 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQRSHL_qru16),
     /*  81443 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  81445 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  81447 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  81449 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  81452 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  81458 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  81464 */     GIR_RootConstrainSelectedInstOperands,
     /*  81465 */     // GIR_Coverage, 4742,
     /*  81465 */     GIR_EraseRootFromParent_Done,
     /*  81466 */   // Label 1559: @81466
     /*  81466 */   GIM_Try, /*On fail goto*//*Label 1560*/ GIMT_Encode4(81544), // Rule ID 4744 //
     /*  81471 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_scalar),
     /*  81476 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  81479 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  81482 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  81485 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  81488 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  81491 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  81494 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  81498 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  81502 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  81506 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  81510 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  81514 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  81518 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3704:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$in, rGPR:{ *:[i32] }:$sh, 1:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VQRSHL_qru32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$in, rGPR:{ *:[i32] }:$sh)
     /*  81518 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQRSHL_qru32),
     /*  81521 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  81523 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  81525 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  81527 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  81530 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  81536 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  81542 */     GIR_RootConstrainSelectedInstOperands,
     /*  81543 */     // GIR_Coverage, 4744,
     /*  81543 */     GIR_EraseRootFromParent_Done,
     /*  81544 */   // Label 1560: @81544
     /*  81544 */   GIM_Try, /*On fail goto*//*Label 1561*/ GIMT_Encode4(81680), // Rule ID 2687 //
     /*  81549 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  81552 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vtbx3),
     /*  81557 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /*  81560 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  81563 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  81566 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s8,
     /*  81569 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_v8s8,
     /*  81572 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_v8s8,
     /*  81575 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  81579 */     // (intrinsic_wo_chain:{ *:[v8i8] } 3862:{ *:[iPTR] }, v8i8:{ *:[v8i8] }:$orig, v8i8:{ *:[v8i8] }:$Vn0, v8i8:{ *:[v8i8] }:$Vn1, v8i8:{ *:[v8i8] }:$Vn2, v8i8:{ *:[v8i8] }:$Vm)  =>  (VTBX3Pseudo:{ *:[v8i8] } v8i8:{ *:[v8i8] }:$orig, (REG_SEQUENCE:{ *:[v4i64] } QQPR:{ *:[i32] }, v8i8:{ *:[v8i8] }:$Vn0, dsub_0:{ *:[i32] }, v8i8:{ *:[v8i8] }:$Vn1, dsub_1:{ *:[i32] }, v8i8:{ *:[v8i8] }:$Vn2, dsub_2:{ *:[i32] }, (IMPLICIT_DEF:{ *:[v8i8] }), dsub_3:{ *:[i32] }), v8i8:{ *:[v8i8] }:$Vm)
     /*  81579 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s8,
     /*  81582 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  81586 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  81591 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  81593 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s64,
     /*  81596 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /*  81600 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  81605 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // Vn0
     /*  81609 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/1,
     /*  81612 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // Vn1
     /*  81616 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/2,
     /*  81619 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // Vn2
     /*  81623 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /*  81626 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  81629 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/4,
     /*  81632 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(ARM::QQPRRegClassID),
     /*  81637 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(ARM::DPRRegClassID),
     /*  81642 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(ARM::DPRRegClassID),
     /*  81647 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/5, GIMT_Encode2(ARM::DPRRegClassID),
     /*  81652 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/7, GIMT_Encode2(ARM::DPRRegClassID),
     /*  81657 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VTBX3Pseudo),
     /*  81660 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  81662 */     GIR_RootToRootCopy, /*OpIdx*/2, // orig
     /*  81664 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  81667 */     GIR_RootToRootCopy, /*OpIdx*/6, // Vm
     /*  81669 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  81672 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  81678 */     GIR_RootConstrainSelectedInstOperands,
     /*  81679 */     // GIR_Coverage, 2687,
     /*  81679 */     GIR_EraseRootFromParent_Done,
     /*  81680 */   // Label 1561: @81680
     /*  81680 */   GIM_Try, /*On fail goto*//*Label 1562*/ GIMT_Encode4(81801), // Rule ID 2688 //
     /*  81685 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  81688 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vtbl4),
     /*  81693 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /*  81696 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  81699 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  81702 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s8,
     /*  81705 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_v8s8,
     /*  81708 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_v8s8,
     /*  81711 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  81715 */     // (intrinsic_wo_chain:{ *:[v8i8] } 3859:{ *:[iPTR] }, v8i8:{ *:[v8i8] }:$Vn0, v8i8:{ *:[v8i8] }:$Vn1, v8i8:{ *:[v8i8] }:$Vn2, v8i8:{ *:[v8i8] }:$Vn3, v8i8:{ *:[v8i8] }:$Vm)  =>  (VTBL4Pseudo:{ *:[v8i8] } (REG_SEQUENCE:{ *:[v4i64] } QQPR:{ *:[i32] }, v8i8:{ *:[v8i8] }:$Vn0, dsub_0:{ *:[i32] }, v8i8:{ *:[v8i8] }:$Vn1, dsub_1:{ *:[i32] }, v8i8:{ *:[v8i8] }:$Vn2, dsub_2:{ *:[i32] }, v8i8:{ *:[v8i8] }:$Vn3, dsub_3:{ *:[i32] }), v8i8:{ *:[v8i8] }:$Vm)
     /*  81715 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s64,
     /*  81718 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /*  81722 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  81727 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Vn0
     /*  81731 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/1,
     /*  81734 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // Vn1
     /*  81738 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/2,
     /*  81741 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // Vn2
     /*  81745 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /*  81748 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // Vn3
     /*  81752 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/4,
     /*  81755 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(ARM::QQPRRegClassID),
     /*  81760 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(ARM::DPRRegClassID),
     /*  81765 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(ARM::DPRRegClassID),
     /*  81770 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/5, GIMT_Encode2(ARM::DPRRegClassID),
     /*  81775 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/7, GIMT_Encode2(ARM::DPRRegClassID),
     /*  81780 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VTBL4Pseudo),
     /*  81783 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  81785 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  81788 */     GIR_RootToRootCopy, /*OpIdx*/6, // Vm
     /*  81790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  81793 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  81799 */     GIR_RootConstrainSelectedInstOperands,
     /*  81800 */     // GIR_Coverage, 2688,
     /*  81800 */     GIR_EraseRootFromParent_Done,
     /*  81801 */   // Label 1562: @81801
     /*  81801 */   GIM_Reject,
     /*  81802 */ // Label 1500: @81802
     /*  81802 */ GIM_Try, /*On fail goto*//*Label 1563*/ GIMT_Encode4(86695),
     /*  81807 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/8,
     /*  81810 */   GIM_Try, /*On fail goto*//*Label 1564*/ GIMT_Encode4(81898), // Rule ID 3178 //
     /*  81815 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  81818 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmldava),
     /*  81823 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  81826 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  81829 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  81832 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  81835 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  81838 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_v16s8,
     /*  81841 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_v16s8,
     /*  81844 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*  81848 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /*  81852 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /*  81856 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  81860 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  81864 */     GIM_RootCheckRegBankForClass, /*Op*/6, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  81868 */     GIM_RootCheckRegBankForClass, /*Op*/7, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  81872 */     // (intrinsic_wo_chain:{ *:[i32] } 3659:{ *:[iPTR] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, MQPR:{ *:[v16i8] }:$Qn, MQPR:{ *:[v16i8] }:$Qm)  =>  (MVE_VMLADAVs8:{ *:[i32] } MQPR:{ *:[v16i8] }:$Qn, MQPR:{ *:[v16i8] }:$Qm)
     /*  81872 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMLADAVs8),
     /*  81875 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  81877 */     GIR_RootToRootCopy, /*OpIdx*/6, // Qn
     /*  81879 */     GIR_RootToRootCopy, /*OpIdx*/7, // Qm
     /*  81881 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  81884 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  81890 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  81896 */     GIR_RootConstrainSelectedInstOperands,
     /*  81897 */     // GIR_Coverage, 3178,
     /*  81897 */     GIR_EraseRootFromParent_Done,
     /*  81898 */   // Label 1564: @81898
     /*  81898 */   GIM_Try, /*On fail goto*//*Label 1565*/ GIMT_Encode4(81986), // Rule ID 3182 //
     /*  81903 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  81906 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmldava),
     /*  81911 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  81914 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  81917 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  81920 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  81923 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  81926 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_v16s8,
     /*  81929 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_v16s8,
     /*  81932 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*  81936 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /*  81940 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /*  81944 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  81948 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  81952 */     GIM_RootCheckRegBankForClass, /*Op*/6, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  81956 */     GIM_RootCheckRegBankForClass, /*Op*/7, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  81960 */     // (intrinsic_wo_chain:{ *:[i32] } 3659:{ *:[iPTR] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] }, MQPR:{ *:[v16i8] }:$Qn, MQPR:{ *:[v16i8] }:$Qm)  =>  (MVE_VMLADAVxs8:{ *:[i32] } MQPR:{ *:[v16i8] }:$Qn, MQPR:{ *:[v16i8] }:$Qm)
     /*  81960 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMLADAVxs8),
     /*  81963 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  81965 */     GIR_RootToRootCopy, /*OpIdx*/6, // Qn
     /*  81967 */     GIR_RootToRootCopy, /*OpIdx*/7, // Qm
     /*  81969 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  81972 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  81978 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  81984 */     GIR_RootConstrainSelectedInstOperands,
     /*  81985 */     // GIR_Coverage, 3182,
     /*  81985 */     GIR_EraseRootFromParent_Done,
     /*  81986 */   // Label 1565: @81986
     /*  81986 */   GIM_Try, /*On fail goto*//*Label 1566*/ GIMT_Encode4(82074), // Rule ID 3186 //
     /*  81991 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  81994 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmldava),
     /*  81999 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  82002 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  82005 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  82008 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  82011 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  82014 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_v16s8,
     /*  82017 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_v16s8,
     /*  82020 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*  82024 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 1,
     /*  82028 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /*  82032 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  82036 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  82040 */     GIM_RootCheckRegBankForClass, /*Op*/6, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  82044 */     GIM_RootCheckRegBankForClass, /*Op*/7, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  82048 */     // (intrinsic_wo_chain:{ *:[i32] } 3659:{ *:[iPTR] }, 1:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, MQPR:{ *:[v16i8] }:$Qn, MQPR:{ *:[v16i8] }:$Qm)  =>  (MVE_VMLADAVu8:{ *:[i32] } MQPR:{ *:[v16i8] }:$Qn, MQPR:{ *:[v16i8] }:$Qm)
     /*  82048 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMLADAVu8),
     /*  82051 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  82053 */     GIR_RootToRootCopy, /*OpIdx*/6, // Qn
     /*  82055 */     GIR_RootToRootCopy, /*OpIdx*/7, // Qm
     /*  82057 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  82060 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  82066 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  82072 */     GIR_RootConstrainSelectedInstOperands,
     /*  82073 */     // GIR_Coverage, 3186,
     /*  82073 */     GIR_EraseRootFromParent_Done,
     /*  82074 */   // Label 1566: @82074
     /*  82074 */   GIM_Try, /*On fail goto*//*Label 1567*/ GIMT_Encode4(82162), // Rule ID 3190 //
     /*  82079 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  82082 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmldava),
     /*  82087 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  82090 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  82093 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  82096 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  82099 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  82102 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_v8s16,
     /*  82105 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_v8s16,
     /*  82108 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*  82112 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /*  82116 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /*  82120 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  82124 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  82128 */     GIM_RootCheckRegBankForClass, /*Op*/6, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  82132 */     GIM_RootCheckRegBankForClass, /*Op*/7, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  82136 */     // (intrinsic_wo_chain:{ *:[i32] } 3659:{ *:[iPTR] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, MQPR:{ *:[v8i16] }:$Qn, MQPR:{ *:[v8i16] }:$Qm)  =>  (MVE_VMLADAVs16:{ *:[i32] } MQPR:{ *:[v8i16] }:$Qn, MQPR:{ *:[v8i16] }:$Qm)
     /*  82136 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMLADAVs16),
     /*  82139 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  82141 */     GIR_RootToRootCopy, /*OpIdx*/6, // Qn
     /*  82143 */     GIR_RootToRootCopy, /*OpIdx*/7, // Qm
     /*  82145 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  82148 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  82154 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  82160 */     GIR_RootConstrainSelectedInstOperands,
     /*  82161 */     // GIR_Coverage, 3190,
     /*  82161 */     GIR_EraseRootFromParent_Done,
     /*  82162 */   // Label 1567: @82162
     /*  82162 */   GIM_Try, /*On fail goto*//*Label 1568*/ GIMT_Encode4(82250), // Rule ID 3194 //
     /*  82167 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  82170 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmldava),
     /*  82175 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  82178 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  82181 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  82184 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  82187 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  82190 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_v8s16,
     /*  82193 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_v8s16,
     /*  82196 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*  82200 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /*  82204 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /*  82208 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  82212 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  82216 */     GIM_RootCheckRegBankForClass, /*Op*/6, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  82220 */     GIM_RootCheckRegBankForClass, /*Op*/7, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  82224 */     // (intrinsic_wo_chain:{ *:[i32] } 3659:{ *:[iPTR] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] }, MQPR:{ *:[v8i16] }:$Qn, MQPR:{ *:[v8i16] }:$Qm)  =>  (MVE_VMLADAVxs16:{ *:[i32] } MQPR:{ *:[v8i16] }:$Qn, MQPR:{ *:[v8i16] }:$Qm)
     /*  82224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMLADAVxs16),
     /*  82227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  82229 */     GIR_RootToRootCopy, /*OpIdx*/6, // Qn
     /*  82231 */     GIR_RootToRootCopy, /*OpIdx*/7, // Qm
     /*  82233 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  82236 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  82242 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  82248 */     GIR_RootConstrainSelectedInstOperands,
     /*  82249 */     // GIR_Coverage, 3194,
     /*  82249 */     GIR_EraseRootFromParent_Done,
     /*  82250 */   // Label 1568: @82250
     /*  82250 */   GIM_Try, /*On fail goto*//*Label 1569*/ GIMT_Encode4(82338), // Rule ID 3198 //
     /*  82255 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  82258 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmldava),
     /*  82263 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  82266 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  82269 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  82272 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  82275 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  82278 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_v8s16,
     /*  82281 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_v8s16,
     /*  82284 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*  82288 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 1,
     /*  82292 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /*  82296 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  82300 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  82304 */     GIM_RootCheckRegBankForClass, /*Op*/6, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  82308 */     GIM_RootCheckRegBankForClass, /*Op*/7, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  82312 */     // (intrinsic_wo_chain:{ *:[i32] } 3659:{ *:[iPTR] }, 1:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, MQPR:{ *:[v8i16] }:$Qn, MQPR:{ *:[v8i16] }:$Qm)  =>  (MVE_VMLADAVu16:{ *:[i32] } MQPR:{ *:[v8i16] }:$Qn, MQPR:{ *:[v8i16] }:$Qm)
     /*  82312 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMLADAVu16),
     /*  82315 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  82317 */     GIR_RootToRootCopy, /*OpIdx*/6, // Qn
     /*  82319 */     GIR_RootToRootCopy, /*OpIdx*/7, // Qm
     /*  82321 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  82324 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  82330 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  82336 */     GIR_RootConstrainSelectedInstOperands,
     /*  82337 */     // GIR_Coverage, 3198,
     /*  82337 */     GIR_EraseRootFromParent_Done,
     /*  82338 */   // Label 1569: @82338
     /*  82338 */   GIM_Try, /*On fail goto*//*Label 1570*/ GIMT_Encode4(82426), // Rule ID 3202 //
     /*  82343 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  82346 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmldava),
     /*  82351 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  82354 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  82357 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  82360 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  82363 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  82366 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_v4s32,
     /*  82369 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_v4s32,
     /*  82372 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*  82376 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /*  82380 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /*  82384 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  82388 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  82392 */     GIM_RootCheckRegBankForClass, /*Op*/6, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  82396 */     GIM_RootCheckRegBankForClass, /*Op*/7, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  82400 */     // (intrinsic_wo_chain:{ *:[i32] } 3659:{ *:[iPTR] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, MQPR:{ *:[v4i32] }:$Qn, MQPR:{ *:[v4i32] }:$Qm)  =>  (MVE_VMLADAVs32:{ *:[i32] } MQPR:{ *:[v4i32] }:$Qn, MQPR:{ *:[v4i32] }:$Qm)
     /*  82400 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMLADAVs32),
     /*  82403 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  82405 */     GIR_RootToRootCopy, /*OpIdx*/6, // Qn
     /*  82407 */     GIR_RootToRootCopy, /*OpIdx*/7, // Qm
     /*  82409 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  82412 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  82418 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  82424 */     GIR_RootConstrainSelectedInstOperands,
     /*  82425 */     // GIR_Coverage, 3202,
     /*  82425 */     GIR_EraseRootFromParent_Done,
     /*  82426 */   // Label 1570: @82426
     /*  82426 */   GIM_Try, /*On fail goto*//*Label 1571*/ GIMT_Encode4(82514), // Rule ID 3206 //
     /*  82431 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  82434 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmldava),
     /*  82439 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  82442 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  82445 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  82448 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  82451 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  82454 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_v4s32,
     /*  82457 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_v4s32,
     /*  82460 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*  82464 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /*  82468 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /*  82472 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  82476 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  82480 */     GIM_RootCheckRegBankForClass, /*Op*/6, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  82484 */     GIM_RootCheckRegBankForClass, /*Op*/7, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  82488 */     // (intrinsic_wo_chain:{ *:[i32] } 3659:{ *:[iPTR] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] }, MQPR:{ *:[v4i32] }:$Qn, MQPR:{ *:[v4i32] }:$Qm)  =>  (MVE_VMLADAVxs32:{ *:[i32] } MQPR:{ *:[v4i32] }:$Qn, MQPR:{ *:[v4i32] }:$Qm)
     /*  82488 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMLADAVxs32),
     /*  82491 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  82493 */     GIR_RootToRootCopy, /*OpIdx*/6, // Qn
     /*  82495 */     GIR_RootToRootCopy, /*OpIdx*/7, // Qm
     /*  82497 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  82500 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  82506 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  82512 */     GIR_RootConstrainSelectedInstOperands,
     /*  82513 */     // GIR_Coverage, 3206,
     /*  82513 */     GIR_EraseRootFromParent_Done,
     /*  82514 */   // Label 1571: @82514
     /*  82514 */   GIM_Try, /*On fail goto*//*Label 1572*/ GIMT_Encode4(82602), // Rule ID 3210 //
     /*  82519 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  82522 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmldava),
     /*  82527 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  82530 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  82533 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  82536 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  82539 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  82542 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_v4s32,
     /*  82545 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_v4s32,
     /*  82548 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*  82552 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 1,
     /*  82556 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /*  82560 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  82564 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  82568 */     GIM_RootCheckRegBankForClass, /*Op*/6, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  82572 */     GIM_RootCheckRegBankForClass, /*Op*/7, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  82576 */     // (intrinsic_wo_chain:{ *:[i32] } 3659:{ *:[iPTR] }, 1:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, MQPR:{ *:[v4i32] }:$Qn, MQPR:{ *:[v4i32] }:$Qm)  =>  (MVE_VMLADAVu32:{ *:[i32] } MQPR:{ *:[v4i32] }:$Qn, MQPR:{ *:[v4i32] }:$Qm)
     /*  82576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMLADAVu32),
     /*  82579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  82581 */     GIR_RootToRootCopy, /*OpIdx*/6, // Qn
     /*  82583 */     GIR_RootToRootCopy, /*OpIdx*/7, // Qm
     /*  82585 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  82588 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  82594 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  82600 */     GIR_RootConstrainSelectedInstOperands,
     /*  82601 */     // GIR_Coverage, 3210,
     /*  82601 */     GIR_EraseRootFromParent_Done,
     /*  82602 */   // Label 1572: @82602
     /*  82602 */   GIM_Try, /*On fail goto*//*Label 1573*/ GIMT_Encode4(82690), // Rule ID 3214 //
     /*  82607 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  82610 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmldava),
     /*  82615 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  82618 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  82621 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  82624 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  82627 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  82630 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_v16s8,
     /*  82633 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_v16s8,
     /*  82636 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*  82640 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /*  82644 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 1,
     /*  82648 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  82652 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  82656 */     GIM_RootCheckRegBankForClass, /*Op*/6, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  82660 */     GIM_RootCheckRegBankForClass, /*Op*/7, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  82664 */     // (intrinsic_wo_chain:{ *:[i32] } 3659:{ *:[iPTR] }, 0:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, MQPR:{ *:[v16i8] }:$Qn, MQPR:{ *:[v16i8] }:$Qm)  =>  (MVE_VMLSDAVs8:{ *:[i32] } MQPR:{ *:[v16i8] }:$Qn, MQPR:{ *:[v16i8] }:$Qm)
     /*  82664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMLSDAVs8),
     /*  82667 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  82669 */     GIR_RootToRootCopy, /*OpIdx*/6, // Qn
     /*  82671 */     GIR_RootToRootCopy, /*OpIdx*/7, // Qm
     /*  82673 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  82676 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  82682 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  82688 */     GIR_RootConstrainSelectedInstOperands,
     /*  82689 */     // GIR_Coverage, 3214,
     /*  82689 */     GIR_EraseRootFromParent_Done,
     /*  82690 */   // Label 1573: @82690
     /*  82690 */   GIM_Try, /*On fail goto*//*Label 1574*/ GIMT_Encode4(82778), // Rule ID 3218 //
     /*  82695 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  82698 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmldava),
     /*  82703 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  82706 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  82709 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  82712 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  82715 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  82718 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_v16s8,
     /*  82721 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_v16s8,
     /*  82724 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*  82728 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /*  82732 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 1,
     /*  82736 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  82740 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  82744 */     GIM_RootCheckRegBankForClass, /*Op*/6, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  82748 */     GIM_RootCheckRegBankForClass, /*Op*/7, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  82752 */     // (intrinsic_wo_chain:{ *:[i32] } 3659:{ *:[iPTR] }, 0:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] }, MQPR:{ *:[v16i8] }:$Qn, MQPR:{ *:[v16i8] }:$Qm)  =>  (MVE_VMLSDAVxs8:{ *:[i32] } MQPR:{ *:[v16i8] }:$Qn, MQPR:{ *:[v16i8] }:$Qm)
     /*  82752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMLSDAVxs8),
     /*  82755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  82757 */     GIR_RootToRootCopy, /*OpIdx*/6, // Qn
     /*  82759 */     GIR_RootToRootCopy, /*OpIdx*/7, // Qm
     /*  82761 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  82764 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  82770 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  82776 */     GIR_RootConstrainSelectedInstOperands,
     /*  82777 */     // GIR_Coverage, 3218,
     /*  82777 */     GIR_EraseRootFromParent_Done,
     /*  82778 */   // Label 1574: @82778
     /*  82778 */   GIM_Try, /*On fail goto*//*Label 1575*/ GIMT_Encode4(82866), // Rule ID 3222 //
     /*  82783 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  82786 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmldava),
     /*  82791 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  82794 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  82797 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  82800 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  82803 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  82806 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_v8s16,
     /*  82809 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_v8s16,
     /*  82812 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*  82816 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /*  82820 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 1,
     /*  82824 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  82828 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  82832 */     GIM_RootCheckRegBankForClass, /*Op*/6, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  82836 */     GIM_RootCheckRegBankForClass, /*Op*/7, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  82840 */     // (intrinsic_wo_chain:{ *:[i32] } 3659:{ *:[iPTR] }, 0:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, MQPR:{ *:[v8i16] }:$Qn, MQPR:{ *:[v8i16] }:$Qm)  =>  (MVE_VMLSDAVs16:{ *:[i32] } MQPR:{ *:[v8i16] }:$Qn, MQPR:{ *:[v8i16] }:$Qm)
     /*  82840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMLSDAVs16),
     /*  82843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  82845 */     GIR_RootToRootCopy, /*OpIdx*/6, // Qn
     /*  82847 */     GIR_RootToRootCopy, /*OpIdx*/7, // Qm
     /*  82849 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  82852 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  82858 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  82864 */     GIR_RootConstrainSelectedInstOperands,
     /*  82865 */     // GIR_Coverage, 3222,
     /*  82865 */     GIR_EraseRootFromParent_Done,
     /*  82866 */   // Label 1575: @82866
     /*  82866 */   GIM_Try, /*On fail goto*//*Label 1576*/ GIMT_Encode4(82954), // Rule ID 3226 //
     /*  82871 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  82874 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmldava),
     /*  82879 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  82882 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  82885 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  82888 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  82891 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  82894 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_v8s16,
     /*  82897 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_v8s16,
     /*  82900 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*  82904 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /*  82908 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 1,
     /*  82912 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  82916 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  82920 */     GIM_RootCheckRegBankForClass, /*Op*/6, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  82924 */     GIM_RootCheckRegBankForClass, /*Op*/7, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  82928 */     // (intrinsic_wo_chain:{ *:[i32] } 3659:{ *:[iPTR] }, 0:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] }, MQPR:{ *:[v8i16] }:$Qn, MQPR:{ *:[v8i16] }:$Qm)  =>  (MVE_VMLSDAVxs16:{ *:[i32] } MQPR:{ *:[v8i16] }:$Qn, MQPR:{ *:[v8i16] }:$Qm)
     /*  82928 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMLSDAVxs16),
     /*  82931 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  82933 */     GIR_RootToRootCopy, /*OpIdx*/6, // Qn
     /*  82935 */     GIR_RootToRootCopy, /*OpIdx*/7, // Qm
     /*  82937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  82940 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  82946 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  82952 */     GIR_RootConstrainSelectedInstOperands,
     /*  82953 */     // GIR_Coverage, 3226,
     /*  82953 */     GIR_EraseRootFromParent_Done,
     /*  82954 */   // Label 1576: @82954
     /*  82954 */   GIM_Try, /*On fail goto*//*Label 1577*/ GIMT_Encode4(83042), // Rule ID 3230 //
     /*  82959 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  82962 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmldava),
     /*  82967 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  82970 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  82973 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  82976 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  82979 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  82982 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_v4s32,
     /*  82985 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_v4s32,
     /*  82988 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*  82992 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /*  82996 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 1,
     /*  83000 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  83004 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  83008 */     GIM_RootCheckRegBankForClass, /*Op*/6, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  83012 */     GIM_RootCheckRegBankForClass, /*Op*/7, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  83016 */     // (intrinsic_wo_chain:{ *:[i32] } 3659:{ *:[iPTR] }, 0:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, MQPR:{ *:[v4i32] }:$Qn, MQPR:{ *:[v4i32] }:$Qm)  =>  (MVE_VMLSDAVs32:{ *:[i32] } MQPR:{ *:[v4i32] }:$Qn, MQPR:{ *:[v4i32] }:$Qm)
     /*  83016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMLSDAVs32),
     /*  83019 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  83021 */     GIR_RootToRootCopy, /*OpIdx*/6, // Qn
     /*  83023 */     GIR_RootToRootCopy, /*OpIdx*/7, // Qm
     /*  83025 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  83028 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  83034 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  83040 */     GIR_RootConstrainSelectedInstOperands,
     /*  83041 */     // GIR_Coverage, 3230,
     /*  83041 */     GIR_EraseRootFromParent_Done,
     /*  83042 */   // Label 1577: @83042
     /*  83042 */   GIM_Try, /*On fail goto*//*Label 1578*/ GIMT_Encode4(83130), // Rule ID 3234 //
     /*  83047 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  83050 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmldava),
     /*  83055 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  83058 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  83061 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  83064 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  83067 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  83070 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_v4s32,
     /*  83073 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_v4s32,
     /*  83076 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*  83080 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /*  83084 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 1,
     /*  83088 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  83092 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  83096 */     GIM_RootCheckRegBankForClass, /*Op*/6, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  83100 */     GIM_RootCheckRegBankForClass, /*Op*/7, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  83104 */     // (intrinsic_wo_chain:{ *:[i32] } 3659:{ *:[iPTR] }, 0:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] }, MQPR:{ *:[v4i32] }:$Qn, MQPR:{ *:[v4i32] }:$Qm)  =>  (MVE_VMLSDAVxs32:{ *:[i32] } MQPR:{ *:[v4i32] }:$Qn, MQPR:{ *:[v4i32] }:$Qm)
     /*  83104 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMLSDAVxs32),
     /*  83107 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  83109 */     GIR_RootToRootCopy, /*OpIdx*/6, // Qn
     /*  83111 */     GIR_RootToRootCopy, /*OpIdx*/7, // Qm
     /*  83113 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  83116 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  83122 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  83128 */     GIR_RootConstrainSelectedInstOperands,
     /*  83129 */     // GIR_Coverage, 3234,
     /*  83129 */     GIR_EraseRootFromParent_Done,
     /*  83130 */   // Label 1578: @83130
     /*  83130 */   GIM_Try, /*On fail goto*//*Label 1579*/ GIMT_Encode4(83220), // Rule ID 3180 //
     /*  83135 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  83138 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmldava),
     /*  83143 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  83146 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  83149 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  83152 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  83155 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  83158 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_v16s8,
     /*  83161 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_v16s8,
     /*  83164 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*  83168 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /*  83172 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /*  83176 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  83180 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*  83184 */     GIM_RootCheckRegBankForClass, /*Op*/6, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  83188 */     GIM_RootCheckRegBankForClass, /*Op*/7, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  83192 */     // (intrinsic_wo_chain:{ *:[i32] } 3659:{ *:[iPTR] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, tGPREven:{ *:[i32] }:$RdaSrc, MQPR:{ *:[v16i8] }:$Qn, MQPR:{ *:[v16i8] }:$Qm)  =>  (MVE_VMLADAVas8:{ *:[i32] } tGPREven:{ *:[i32] }:$RdaSrc, MQPR:{ *:[v16i8] }:$Qn, MQPR:{ *:[v16i8] }:$Qm)
     /*  83192 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMLADAVas8),
     /*  83195 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  83197 */     GIR_RootToRootCopy, /*OpIdx*/5, // RdaSrc
     /*  83199 */     GIR_RootToRootCopy, /*OpIdx*/6, // Qn
     /*  83201 */     GIR_RootToRootCopy, /*OpIdx*/7, // Qm
     /*  83203 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  83206 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  83212 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  83218 */     GIR_RootConstrainSelectedInstOperands,
     /*  83219 */     // GIR_Coverage, 3180,
     /*  83219 */     GIR_EraseRootFromParent_Done,
     /*  83220 */   // Label 1579: @83220
     /*  83220 */   GIM_Try, /*On fail goto*//*Label 1580*/ GIMT_Encode4(83310), // Rule ID 3184 //
     /*  83225 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  83228 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmldava),
     /*  83233 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  83236 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  83239 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  83242 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  83245 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  83248 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_v16s8,
     /*  83251 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_v16s8,
     /*  83254 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*  83258 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /*  83262 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /*  83266 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  83270 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*  83274 */     GIM_RootCheckRegBankForClass, /*Op*/6, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  83278 */     GIM_RootCheckRegBankForClass, /*Op*/7, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  83282 */     // (intrinsic_wo_chain:{ *:[i32] } 3659:{ *:[iPTR] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] }, tGPREven:{ *:[i32] }:$RdaSrc, MQPR:{ *:[v16i8] }:$Qn, MQPR:{ *:[v16i8] }:$Qm)  =>  (MVE_VMLADAVaxs8:{ *:[i32] } tGPREven:{ *:[i32] }:$RdaSrc, MQPR:{ *:[v16i8] }:$Qn, MQPR:{ *:[v16i8] }:$Qm)
     /*  83282 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMLADAVaxs8),
     /*  83285 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  83287 */     GIR_RootToRootCopy, /*OpIdx*/5, // RdaSrc
     /*  83289 */     GIR_RootToRootCopy, /*OpIdx*/6, // Qn
     /*  83291 */     GIR_RootToRootCopy, /*OpIdx*/7, // Qm
     /*  83293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  83296 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  83302 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  83308 */     GIR_RootConstrainSelectedInstOperands,
     /*  83309 */     // GIR_Coverage, 3184,
     /*  83309 */     GIR_EraseRootFromParent_Done,
     /*  83310 */   // Label 1580: @83310
     /*  83310 */   GIM_Try, /*On fail goto*//*Label 1581*/ GIMT_Encode4(83400), // Rule ID 3188 //
     /*  83315 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  83318 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmldava),
     /*  83323 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  83326 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  83329 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  83332 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  83335 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  83338 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_v16s8,
     /*  83341 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_v16s8,
     /*  83344 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*  83348 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 1,
     /*  83352 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /*  83356 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  83360 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*  83364 */     GIM_RootCheckRegBankForClass, /*Op*/6, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  83368 */     GIM_RootCheckRegBankForClass, /*Op*/7, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  83372 */     // (intrinsic_wo_chain:{ *:[i32] } 3659:{ *:[iPTR] }, 1:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, tGPREven:{ *:[i32] }:$RdaSrc, MQPR:{ *:[v16i8] }:$Qn, MQPR:{ *:[v16i8] }:$Qm)  =>  (MVE_VMLADAVau8:{ *:[i32] } tGPREven:{ *:[i32] }:$RdaSrc, MQPR:{ *:[v16i8] }:$Qn, MQPR:{ *:[v16i8] }:$Qm)
     /*  83372 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMLADAVau8),
     /*  83375 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  83377 */     GIR_RootToRootCopy, /*OpIdx*/5, // RdaSrc
     /*  83379 */     GIR_RootToRootCopy, /*OpIdx*/6, // Qn
     /*  83381 */     GIR_RootToRootCopy, /*OpIdx*/7, // Qm
     /*  83383 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  83386 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  83392 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  83398 */     GIR_RootConstrainSelectedInstOperands,
     /*  83399 */     // GIR_Coverage, 3188,
     /*  83399 */     GIR_EraseRootFromParent_Done,
     /*  83400 */   // Label 1581: @83400
     /*  83400 */   GIM_Try, /*On fail goto*//*Label 1582*/ GIMT_Encode4(83490), // Rule ID 3192 //
     /*  83405 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  83408 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmldava),
     /*  83413 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  83416 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  83419 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  83422 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  83425 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  83428 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_v8s16,
     /*  83431 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_v8s16,
     /*  83434 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*  83438 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /*  83442 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /*  83446 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  83450 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*  83454 */     GIM_RootCheckRegBankForClass, /*Op*/6, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  83458 */     GIM_RootCheckRegBankForClass, /*Op*/7, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  83462 */     // (intrinsic_wo_chain:{ *:[i32] } 3659:{ *:[iPTR] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, tGPREven:{ *:[i32] }:$RdaSrc, MQPR:{ *:[v8i16] }:$Qn, MQPR:{ *:[v8i16] }:$Qm)  =>  (MVE_VMLADAVas16:{ *:[i32] } tGPREven:{ *:[i32] }:$RdaSrc, MQPR:{ *:[v8i16] }:$Qn, MQPR:{ *:[v8i16] }:$Qm)
     /*  83462 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMLADAVas16),
     /*  83465 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  83467 */     GIR_RootToRootCopy, /*OpIdx*/5, // RdaSrc
     /*  83469 */     GIR_RootToRootCopy, /*OpIdx*/6, // Qn
     /*  83471 */     GIR_RootToRootCopy, /*OpIdx*/7, // Qm
     /*  83473 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  83476 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  83482 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  83488 */     GIR_RootConstrainSelectedInstOperands,
     /*  83489 */     // GIR_Coverage, 3192,
     /*  83489 */     GIR_EraseRootFromParent_Done,
     /*  83490 */   // Label 1582: @83490
     /*  83490 */   GIM_Try, /*On fail goto*//*Label 1583*/ GIMT_Encode4(83580), // Rule ID 3196 //
     /*  83495 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  83498 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmldava),
     /*  83503 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  83506 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  83509 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  83512 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  83515 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  83518 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_v8s16,
     /*  83521 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_v8s16,
     /*  83524 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*  83528 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /*  83532 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /*  83536 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  83540 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*  83544 */     GIM_RootCheckRegBankForClass, /*Op*/6, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  83548 */     GIM_RootCheckRegBankForClass, /*Op*/7, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  83552 */     // (intrinsic_wo_chain:{ *:[i32] } 3659:{ *:[iPTR] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] }, tGPREven:{ *:[i32] }:$RdaSrc, MQPR:{ *:[v8i16] }:$Qn, MQPR:{ *:[v8i16] }:$Qm)  =>  (MVE_VMLADAVaxs16:{ *:[i32] } tGPREven:{ *:[i32] }:$RdaSrc, MQPR:{ *:[v8i16] }:$Qn, MQPR:{ *:[v8i16] }:$Qm)
     /*  83552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMLADAVaxs16),
     /*  83555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  83557 */     GIR_RootToRootCopy, /*OpIdx*/5, // RdaSrc
     /*  83559 */     GIR_RootToRootCopy, /*OpIdx*/6, // Qn
     /*  83561 */     GIR_RootToRootCopy, /*OpIdx*/7, // Qm
     /*  83563 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  83566 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  83572 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  83578 */     GIR_RootConstrainSelectedInstOperands,
     /*  83579 */     // GIR_Coverage, 3196,
     /*  83579 */     GIR_EraseRootFromParent_Done,
     /*  83580 */   // Label 1583: @83580
     /*  83580 */   GIM_Try, /*On fail goto*//*Label 1584*/ GIMT_Encode4(83670), // Rule ID 3200 //
     /*  83585 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  83588 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmldava),
     /*  83593 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  83596 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  83599 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  83602 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  83605 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  83608 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_v8s16,
     /*  83611 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_v8s16,
     /*  83614 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*  83618 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 1,
     /*  83622 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /*  83626 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  83630 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*  83634 */     GIM_RootCheckRegBankForClass, /*Op*/6, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  83638 */     GIM_RootCheckRegBankForClass, /*Op*/7, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  83642 */     // (intrinsic_wo_chain:{ *:[i32] } 3659:{ *:[iPTR] }, 1:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, tGPREven:{ *:[i32] }:$RdaSrc, MQPR:{ *:[v8i16] }:$Qn, MQPR:{ *:[v8i16] }:$Qm)  =>  (MVE_VMLADAVau16:{ *:[i32] } tGPREven:{ *:[i32] }:$RdaSrc, MQPR:{ *:[v8i16] }:$Qn, MQPR:{ *:[v8i16] }:$Qm)
     /*  83642 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMLADAVau16),
     /*  83645 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  83647 */     GIR_RootToRootCopy, /*OpIdx*/5, // RdaSrc
     /*  83649 */     GIR_RootToRootCopy, /*OpIdx*/6, // Qn
     /*  83651 */     GIR_RootToRootCopy, /*OpIdx*/7, // Qm
     /*  83653 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  83656 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  83662 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  83668 */     GIR_RootConstrainSelectedInstOperands,
     /*  83669 */     // GIR_Coverage, 3200,
     /*  83669 */     GIR_EraseRootFromParent_Done,
     /*  83670 */   // Label 1584: @83670
     /*  83670 */   GIM_Try, /*On fail goto*//*Label 1585*/ GIMT_Encode4(83760), // Rule ID 3204 //
     /*  83675 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  83678 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmldava),
     /*  83683 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  83686 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  83689 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  83692 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  83695 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  83698 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_v4s32,
     /*  83701 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_v4s32,
     /*  83704 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*  83708 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /*  83712 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /*  83716 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  83720 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*  83724 */     GIM_RootCheckRegBankForClass, /*Op*/6, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  83728 */     GIM_RootCheckRegBankForClass, /*Op*/7, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  83732 */     // (intrinsic_wo_chain:{ *:[i32] } 3659:{ *:[iPTR] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, tGPREven:{ *:[i32] }:$RdaSrc, MQPR:{ *:[v4i32] }:$Qn, MQPR:{ *:[v4i32] }:$Qm)  =>  (MVE_VMLADAVas32:{ *:[i32] } tGPREven:{ *:[i32] }:$RdaSrc, MQPR:{ *:[v4i32] }:$Qn, MQPR:{ *:[v4i32] }:$Qm)
     /*  83732 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMLADAVas32),
     /*  83735 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  83737 */     GIR_RootToRootCopy, /*OpIdx*/5, // RdaSrc
     /*  83739 */     GIR_RootToRootCopy, /*OpIdx*/6, // Qn
     /*  83741 */     GIR_RootToRootCopy, /*OpIdx*/7, // Qm
     /*  83743 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  83746 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  83752 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  83758 */     GIR_RootConstrainSelectedInstOperands,
     /*  83759 */     // GIR_Coverage, 3204,
     /*  83759 */     GIR_EraseRootFromParent_Done,
     /*  83760 */   // Label 1585: @83760
     /*  83760 */   GIM_Try, /*On fail goto*//*Label 1586*/ GIMT_Encode4(83850), // Rule ID 3208 //
     /*  83765 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  83768 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmldava),
     /*  83773 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  83776 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  83779 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  83782 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  83785 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  83788 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_v4s32,
     /*  83791 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_v4s32,
     /*  83794 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*  83798 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /*  83802 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /*  83806 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  83810 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*  83814 */     GIM_RootCheckRegBankForClass, /*Op*/6, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  83818 */     GIM_RootCheckRegBankForClass, /*Op*/7, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  83822 */     // (intrinsic_wo_chain:{ *:[i32] } 3659:{ *:[iPTR] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] }, tGPREven:{ *:[i32] }:$RdaSrc, MQPR:{ *:[v4i32] }:$Qn, MQPR:{ *:[v4i32] }:$Qm)  =>  (MVE_VMLADAVaxs32:{ *:[i32] } tGPREven:{ *:[i32] }:$RdaSrc, MQPR:{ *:[v4i32] }:$Qn, MQPR:{ *:[v4i32] }:$Qm)
     /*  83822 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMLADAVaxs32),
     /*  83825 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  83827 */     GIR_RootToRootCopy, /*OpIdx*/5, // RdaSrc
     /*  83829 */     GIR_RootToRootCopy, /*OpIdx*/6, // Qn
     /*  83831 */     GIR_RootToRootCopy, /*OpIdx*/7, // Qm
     /*  83833 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  83836 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  83842 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  83848 */     GIR_RootConstrainSelectedInstOperands,
     /*  83849 */     // GIR_Coverage, 3208,
     /*  83849 */     GIR_EraseRootFromParent_Done,
     /*  83850 */   // Label 1586: @83850
     /*  83850 */   GIM_Try, /*On fail goto*//*Label 1587*/ GIMT_Encode4(83940), // Rule ID 3212 //
     /*  83855 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  83858 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmldava),
     /*  83863 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  83866 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  83869 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  83872 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  83875 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  83878 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_v4s32,
     /*  83881 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_v4s32,
     /*  83884 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*  83888 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 1,
     /*  83892 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /*  83896 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  83900 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*  83904 */     GIM_RootCheckRegBankForClass, /*Op*/6, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  83908 */     GIM_RootCheckRegBankForClass, /*Op*/7, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  83912 */     // (intrinsic_wo_chain:{ *:[i32] } 3659:{ *:[iPTR] }, 1:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, tGPREven:{ *:[i32] }:$RdaSrc, MQPR:{ *:[v4i32] }:$Qn, MQPR:{ *:[v4i32] }:$Qm)  =>  (MVE_VMLADAVau32:{ *:[i32] } tGPREven:{ *:[i32] }:$RdaSrc, MQPR:{ *:[v4i32] }:$Qn, MQPR:{ *:[v4i32] }:$Qm)
     /*  83912 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMLADAVau32),
     /*  83915 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  83917 */     GIR_RootToRootCopy, /*OpIdx*/5, // RdaSrc
     /*  83919 */     GIR_RootToRootCopy, /*OpIdx*/6, // Qn
     /*  83921 */     GIR_RootToRootCopy, /*OpIdx*/7, // Qm
     /*  83923 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  83926 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  83932 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  83938 */     GIR_RootConstrainSelectedInstOperands,
     /*  83939 */     // GIR_Coverage, 3212,
     /*  83939 */     GIR_EraseRootFromParent_Done,
     /*  83940 */   // Label 1587: @83940
     /*  83940 */   GIM_Try, /*On fail goto*//*Label 1588*/ GIMT_Encode4(84030), // Rule ID 3216 //
     /*  83945 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  83948 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmldava),
     /*  83953 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  83956 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  83959 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  83962 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  83965 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  83968 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_v16s8,
     /*  83971 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_v16s8,
     /*  83974 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*  83978 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /*  83982 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 1,
     /*  83986 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  83990 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*  83994 */     GIM_RootCheckRegBankForClass, /*Op*/6, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  83998 */     GIM_RootCheckRegBankForClass, /*Op*/7, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  84002 */     // (intrinsic_wo_chain:{ *:[i32] } 3659:{ *:[iPTR] }, 0:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] }, tGPREven:{ *:[i32] }:$RdaSrc, MQPR:{ *:[v16i8] }:$Qn, MQPR:{ *:[v16i8] }:$Qm)  =>  (MVE_VMLSDAVas8:{ *:[i32] } tGPREven:{ *:[i32] }:$RdaSrc, MQPR:{ *:[v16i8] }:$Qn, MQPR:{ *:[v16i8] }:$Qm)
     /*  84002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMLSDAVas8),
     /*  84005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  84007 */     GIR_RootToRootCopy, /*OpIdx*/5, // RdaSrc
     /*  84009 */     GIR_RootToRootCopy, /*OpIdx*/6, // Qn
     /*  84011 */     GIR_RootToRootCopy, /*OpIdx*/7, // Qm
     /*  84013 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  84016 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  84022 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  84028 */     GIR_RootConstrainSelectedInstOperands,
     /*  84029 */     // GIR_Coverage, 3216,
     /*  84029 */     GIR_EraseRootFromParent_Done,
     /*  84030 */   // Label 1588: @84030
     /*  84030 */   GIM_Try, /*On fail goto*//*Label 1589*/ GIMT_Encode4(84120), // Rule ID 3220 //
     /*  84035 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  84038 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmldava),
     /*  84043 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  84046 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  84049 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  84052 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  84055 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  84058 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_v16s8,
     /*  84061 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_v16s8,
     /*  84064 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*  84068 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /*  84072 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 1,
     /*  84076 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  84080 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*  84084 */     GIM_RootCheckRegBankForClass, /*Op*/6, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  84088 */     GIM_RootCheckRegBankForClass, /*Op*/7, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  84092 */     // (intrinsic_wo_chain:{ *:[i32] } 3659:{ *:[iPTR] }, 0:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] }, tGPREven:{ *:[i32] }:$RdaSrc, MQPR:{ *:[v16i8] }:$Qn, MQPR:{ *:[v16i8] }:$Qm)  =>  (MVE_VMLSDAVaxs8:{ *:[i32] } tGPREven:{ *:[i32] }:$RdaSrc, MQPR:{ *:[v16i8] }:$Qn, MQPR:{ *:[v16i8] }:$Qm)
     /*  84092 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMLSDAVaxs8),
     /*  84095 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  84097 */     GIR_RootToRootCopy, /*OpIdx*/5, // RdaSrc
     /*  84099 */     GIR_RootToRootCopy, /*OpIdx*/6, // Qn
     /*  84101 */     GIR_RootToRootCopy, /*OpIdx*/7, // Qm
     /*  84103 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  84106 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  84112 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  84118 */     GIR_RootConstrainSelectedInstOperands,
     /*  84119 */     // GIR_Coverage, 3220,
     /*  84119 */     GIR_EraseRootFromParent_Done,
     /*  84120 */   // Label 1589: @84120
     /*  84120 */   GIM_Try, /*On fail goto*//*Label 1590*/ GIMT_Encode4(84210), // Rule ID 3224 //
     /*  84125 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  84128 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmldava),
     /*  84133 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  84136 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  84139 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  84142 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  84145 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  84148 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_v8s16,
     /*  84151 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_v8s16,
     /*  84154 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*  84158 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /*  84162 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 1,
     /*  84166 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  84170 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*  84174 */     GIM_RootCheckRegBankForClass, /*Op*/6, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  84178 */     GIM_RootCheckRegBankForClass, /*Op*/7, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  84182 */     // (intrinsic_wo_chain:{ *:[i32] } 3659:{ *:[iPTR] }, 0:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] }, tGPREven:{ *:[i32] }:$RdaSrc, MQPR:{ *:[v8i16] }:$Qn, MQPR:{ *:[v8i16] }:$Qm)  =>  (MVE_VMLSDAVas16:{ *:[i32] } tGPREven:{ *:[i32] }:$RdaSrc, MQPR:{ *:[v8i16] }:$Qn, MQPR:{ *:[v8i16] }:$Qm)
     /*  84182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMLSDAVas16),
     /*  84185 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  84187 */     GIR_RootToRootCopy, /*OpIdx*/5, // RdaSrc
     /*  84189 */     GIR_RootToRootCopy, /*OpIdx*/6, // Qn
     /*  84191 */     GIR_RootToRootCopy, /*OpIdx*/7, // Qm
     /*  84193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  84196 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  84202 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  84208 */     GIR_RootConstrainSelectedInstOperands,
     /*  84209 */     // GIR_Coverage, 3224,
     /*  84209 */     GIR_EraseRootFromParent_Done,
     /*  84210 */   // Label 1590: @84210
     /*  84210 */   GIM_Try, /*On fail goto*//*Label 1591*/ GIMT_Encode4(84300), // Rule ID 3228 //
     /*  84215 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  84218 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmldava),
     /*  84223 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  84226 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  84229 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  84232 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  84235 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  84238 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_v8s16,
     /*  84241 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_v8s16,
     /*  84244 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*  84248 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /*  84252 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 1,
     /*  84256 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  84260 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*  84264 */     GIM_RootCheckRegBankForClass, /*Op*/6, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  84268 */     GIM_RootCheckRegBankForClass, /*Op*/7, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  84272 */     // (intrinsic_wo_chain:{ *:[i32] } 3659:{ *:[iPTR] }, 0:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] }, tGPREven:{ *:[i32] }:$RdaSrc, MQPR:{ *:[v8i16] }:$Qn, MQPR:{ *:[v8i16] }:$Qm)  =>  (MVE_VMLSDAVaxs16:{ *:[i32] } tGPREven:{ *:[i32] }:$RdaSrc, MQPR:{ *:[v8i16] }:$Qn, MQPR:{ *:[v8i16] }:$Qm)
     /*  84272 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMLSDAVaxs16),
     /*  84275 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  84277 */     GIR_RootToRootCopy, /*OpIdx*/5, // RdaSrc
     /*  84279 */     GIR_RootToRootCopy, /*OpIdx*/6, // Qn
     /*  84281 */     GIR_RootToRootCopy, /*OpIdx*/7, // Qm
     /*  84283 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  84286 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  84292 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  84298 */     GIR_RootConstrainSelectedInstOperands,
     /*  84299 */     // GIR_Coverage, 3228,
     /*  84299 */     GIR_EraseRootFromParent_Done,
     /*  84300 */   // Label 1591: @84300
     /*  84300 */   GIM_Try, /*On fail goto*//*Label 1592*/ GIMT_Encode4(84390), // Rule ID 3232 //
     /*  84305 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  84308 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmldava),
     /*  84313 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  84316 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  84319 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  84322 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  84325 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  84328 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_v4s32,
     /*  84331 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_v4s32,
     /*  84334 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*  84338 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /*  84342 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 1,
     /*  84346 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  84350 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*  84354 */     GIM_RootCheckRegBankForClass, /*Op*/6, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  84358 */     GIM_RootCheckRegBankForClass, /*Op*/7, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  84362 */     // (intrinsic_wo_chain:{ *:[i32] } 3659:{ *:[iPTR] }, 0:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] }, tGPREven:{ *:[i32] }:$RdaSrc, MQPR:{ *:[v4i32] }:$Qn, MQPR:{ *:[v4i32] }:$Qm)  =>  (MVE_VMLSDAVas32:{ *:[i32] } tGPREven:{ *:[i32] }:$RdaSrc, MQPR:{ *:[v4i32] }:$Qn, MQPR:{ *:[v4i32] }:$Qm)
     /*  84362 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMLSDAVas32),
     /*  84365 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  84367 */     GIR_RootToRootCopy, /*OpIdx*/5, // RdaSrc
     /*  84369 */     GIR_RootToRootCopy, /*OpIdx*/6, // Qn
     /*  84371 */     GIR_RootToRootCopy, /*OpIdx*/7, // Qm
     /*  84373 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  84376 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  84382 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  84388 */     GIR_RootConstrainSelectedInstOperands,
     /*  84389 */     // GIR_Coverage, 3232,
     /*  84389 */     GIR_EraseRootFromParent_Done,
     /*  84390 */   // Label 1592: @84390
     /*  84390 */   GIM_Try, /*On fail goto*//*Label 1593*/ GIMT_Encode4(84480), // Rule ID 3236 //
     /*  84395 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  84398 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmldava),
     /*  84403 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  84406 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  84409 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  84412 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  84415 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  84418 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_v4s32,
     /*  84421 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_v4s32,
     /*  84424 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*  84428 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /*  84432 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 1,
     /*  84436 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  84440 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*  84444 */     GIM_RootCheckRegBankForClass, /*Op*/6, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  84448 */     GIM_RootCheckRegBankForClass, /*Op*/7, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  84452 */     // (intrinsic_wo_chain:{ *:[i32] } 3659:{ *:[iPTR] }, 0:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] }, tGPREven:{ *:[i32] }:$RdaSrc, MQPR:{ *:[v4i32] }:$Qn, MQPR:{ *:[v4i32] }:$Qm)  =>  (MVE_VMLSDAVaxs32:{ *:[i32] } tGPREven:{ *:[i32] }:$RdaSrc, MQPR:{ *:[v4i32] }:$Qn, MQPR:{ *:[v4i32] }:$Qm)
     /*  84452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMLSDAVaxs32),
     /*  84455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  84457 */     GIR_RootToRootCopy, /*OpIdx*/5, // RdaSrc
     /*  84459 */     GIR_RootToRootCopy, /*OpIdx*/6, // Qn
     /*  84461 */     GIR_RootToRootCopy, /*OpIdx*/7, // Qm
     /*  84463 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  84466 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  84472 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  84478 */     GIR_RootConstrainSelectedInstOperands,
     /*  84479 */     // GIR_Coverage, 3236,
     /*  84479 */     GIR_EraseRootFromParent_Done,
     /*  84480 */   // Label 1593: @84480
     /*  84480 */   GIM_Try, /*On fail goto*//*Label 1594*/ GIMT_Encode4(84567), // Rule ID 4332 //
     /*  84485 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqdmlad),
     /*  84490 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  84493 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  84496 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  84499 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  84502 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  84505 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  84508 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  84511 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  84515 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  84519 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  84523 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  84527 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  84531 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  84535 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 0,
     /*  84539 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3668:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$a, MQPR:{ *:[v16i8] }:$b, MQPR:{ *:[v16i8] }:$c, 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VQDMLADHs8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$a, MQPR:{ *:[v16i8] }:$b, MQPR:{ *:[v16i8] }:$c)
     /*  84539 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQDMLADHs8),
     /*  84542 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  84544 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  84546 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /*  84548 */     GIR_RootToRootCopy, /*OpIdx*/4, // c
     /*  84550 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  84553 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  84559 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  84565 */     GIR_RootConstrainSelectedInstOperands,
     /*  84566 */     // GIR_Coverage, 4332,
     /*  84566 */     GIR_EraseRootFromParent_Done,
     /*  84567 */   // Label 1594: @84567
     /*  84567 */   GIM_Try, /*On fail goto*//*Label 1595*/ GIMT_Encode4(84654), // Rule ID 4334 //
     /*  84572 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqdmlad),
     /*  84577 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  84580 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  84583 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  84586 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /*  84589 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  84592 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  84595 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  84598 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  84602 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  84606 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  84610 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  84614 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  84618 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  84622 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 0,
     /*  84626 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3668:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$a, MQPR:{ *:[v8i16] }:$b, MQPR:{ *:[v8i16] }:$c, 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VQDMLADHs16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$a, MQPR:{ *:[v8i16] }:$b, MQPR:{ *:[v8i16] }:$c)
     /*  84626 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQDMLADHs16),
     /*  84629 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  84631 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  84633 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /*  84635 */     GIR_RootToRootCopy, /*OpIdx*/4, // c
     /*  84637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  84640 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  84646 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  84652 */     GIR_RootConstrainSelectedInstOperands,
     /*  84653 */     // GIR_Coverage, 4334,
     /*  84653 */     GIR_EraseRootFromParent_Done,
     /*  84654 */   // Label 1595: @84654
     /*  84654 */   GIM_Try, /*On fail goto*//*Label 1596*/ GIMT_Encode4(84741), // Rule ID 4336 //
     /*  84659 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqdmlad),
     /*  84664 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  84667 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  84670 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  84673 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /*  84676 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  84679 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  84682 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  84685 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  84689 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  84693 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  84697 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  84701 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  84705 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  84709 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 0,
     /*  84713 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3668:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$a, MQPR:{ *:[v4i32] }:$b, MQPR:{ *:[v4i32] }:$c, 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VQDMLADHs32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$a, MQPR:{ *:[v4i32] }:$b, MQPR:{ *:[v4i32] }:$c)
     /*  84713 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQDMLADHs32),
     /*  84716 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  84718 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  84720 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /*  84722 */     GIR_RootToRootCopy, /*OpIdx*/4, // c
     /*  84724 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  84727 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  84733 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  84739 */     GIR_RootConstrainSelectedInstOperands,
     /*  84740 */     // GIR_Coverage, 4336,
     /*  84740 */     GIR_EraseRootFromParent_Done,
     /*  84741 */   // Label 1596: @84741
     /*  84741 */   GIM_Try, /*On fail goto*//*Label 1597*/ GIMT_Encode4(84828), // Rule ID 4338 //
     /*  84746 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqdmlad),
     /*  84751 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  84754 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  84757 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  84760 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  84763 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  84766 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  84769 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  84772 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  84776 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  84780 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  84784 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  84788 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  84792 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  84796 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 0,
     /*  84800 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3668:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$a, MQPR:{ *:[v16i8] }:$b, MQPR:{ *:[v16i8] }:$c, 1:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VQDMLADHXs8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$a, MQPR:{ *:[v16i8] }:$b, MQPR:{ *:[v16i8] }:$c)
     /*  84800 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQDMLADHXs8),
     /*  84803 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  84805 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  84807 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /*  84809 */     GIR_RootToRootCopy, /*OpIdx*/4, // c
     /*  84811 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  84814 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  84820 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  84826 */     GIR_RootConstrainSelectedInstOperands,
     /*  84827 */     // GIR_Coverage, 4338,
     /*  84827 */     GIR_EraseRootFromParent_Done,
     /*  84828 */   // Label 1597: @84828
     /*  84828 */   GIM_Try, /*On fail goto*//*Label 1598*/ GIMT_Encode4(84915), // Rule ID 4340 //
     /*  84833 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqdmlad),
     /*  84838 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  84841 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  84844 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  84847 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /*  84850 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  84853 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  84856 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  84859 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  84863 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  84867 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  84871 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  84875 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  84879 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  84883 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 0,
     /*  84887 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3668:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$a, MQPR:{ *:[v8i16] }:$b, MQPR:{ *:[v8i16] }:$c, 1:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VQDMLADHXs16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$a, MQPR:{ *:[v8i16] }:$b, MQPR:{ *:[v8i16] }:$c)
     /*  84887 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQDMLADHXs16),
     /*  84890 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  84892 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  84894 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /*  84896 */     GIR_RootToRootCopy, /*OpIdx*/4, // c
     /*  84898 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  84901 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  84907 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  84913 */     GIR_RootConstrainSelectedInstOperands,
     /*  84914 */     // GIR_Coverage, 4340,
     /*  84914 */     GIR_EraseRootFromParent_Done,
     /*  84915 */   // Label 1598: @84915
     /*  84915 */   GIM_Try, /*On fail goto*//*Label 1599*/ GIMT_Encode4(85002), // Rule ID 4342 //
     /*  84920 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqdmlad),
     /*  84925 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  84928 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  84931 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  84934 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /*  84937 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  84940 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  84943 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  84946 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  84950 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  84954 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  84958 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  84962 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  84966 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  84970 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 0,
     /*  84974 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3668:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$a, MQPR:{ *:[v4i32] }:$b, MQPR:{ *:[v4i32] }:$c, 1:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VQDMLADHXs32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$a, MQPR:{ *:[v4i32] }:$b, MQPR:{ *:[v4i32] }:$c)
     /*  84974 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQDMLADHXs32),
     /*  84977 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  84979 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  84981 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /*  84983 */     GIR_RootToRootCopy, /*OpIdx*/4, // c
     /*  84985 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  84988 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  84994 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  85000 */     GIR_RootConstrainSelectedInstOperands,
     /*  85001 */     // GIR_Coverage, 4342,
     /*  85001 */     GIR_EraseRootFromParent_Done,
     /*  85002 */   // Label 1599: @85002
     /*  85002 */   GIM_Try, /*On fail goto*//*Label 1600*/ GIMT_Encode4(85089), // Rule ID 4344 //
     /*  85007 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqdmlad),
     /*  85012 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  85015 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  85018 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  85021 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  85024 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  85027 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  85030 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  85033 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  85037 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  85041 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  85045 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  85049 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  85053 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  85057 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 0,
     /*  85061 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3668:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$a, MQPR:{ *:[v16i8] }:$b, MQPR:{ *:[v16i8] }:$c, 0:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VQRDMLADHs8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$a, MQPR:{ *:[v16i8] }:$b, MQPR:{ *:[v16i8] }:$c)
     /*  85061 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQRDMLADHs8),
     /*  85064 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  85066 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  85068 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /*  85070 */     GIR_RootToRootCopy, /*OpIdx*/4, // c
     /*  85072 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  85075 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  85081 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  85087 */     GIR_RootConstrainSelectedInstOperands,
     /*  85088 */     // GIR_Coverage, 4344,
     /*  85088 */     GIR_EraseRootFromParent_Done,
     /*  85089 */   // Label 1600: @85089
     /*  85089 */   GIM_Try, /*On fail goto*//*Label 1601*/ GIMT_Encode4(85176), // Rule ID 4346 //
     /*  85094 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqdmlad),
     /*  85099 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  85102 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  85105 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  85108 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /*  85111 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  85114 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  85117 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  85120 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  85124 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  85128 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  85132 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  85136 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  85140 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  85144 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 0,
     /*  85148 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3668:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$a, MQPR:{ *:[v8i16] }:$b, MQPR:{ *:[v8i16] }:$c, 0:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VQRDMLADHs16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$a, MQPR:{ *:[v8i16] }:$b, MQPR:{ *:[v8i16] }:$c)
     /*  85148 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQRDMLADHs16),
     /*  85151 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  85153 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  85155 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /*  85157 */     GIR_RootToRootCopy, /*OpIdx*/4, // c
     /*  85159 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  85162 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  85168 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  85174 */     GIR_RootConstrainSelectedInstOperands,
     /*  85175 */     // GIR_Coverage, 4346,
     /*  85175 */     GIR_EraseRootFromParent_Done,
     /*  85176 */   // Label 1601: @85176
     /*  85176 */   GIM_Try, /*On fail goto*//*Label 1602*/ GIMT_Encode4(85263), // Rule ID 4348 //
     /*  85181 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqdmlad),
     /*  85186 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  85189 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  85192 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  85195 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /*  85198 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  85201 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  85204 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  85207 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  85211 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  85215 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  85219 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  85223 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  85227 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  85231 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 0,
     /*  85235 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3668:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$a, MQPR:{ *:[v4i32] }:$b, MQPR:{ *:[v4i32] }:$c, 0:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VQRDMLADHs32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$a, MQPR:{ *:[v4i32] }:$b, MQPR:{ *:[v4i32] }:$c)
     /*  85235 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQRDMLADHs32),
     /*  85238 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  85240 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  85242 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /*  85244 */     GIR_RootToRootCopy, /*OpIdx*/4, // c
     /*  85246 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  85249 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  85255 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  85261 */     GIR_RootConstrainSelectedInstOperands,
     /*  85262 */     // GIR_Coverage, 4348,
     /*  85262 */     GIR_EraseRootFromParent_Done,
     /*  85263 */   // Label 1602: @85263
     /*  85263 */   GIM_Try, /*On fail goto*//*Label 1603*/ GIMT_Encode4(85350), // Rule ID 4350 //
     /*  85268 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqdmlad),
     /*  85273 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  85276 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  85279 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  85282 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  85285 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  85288 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  85291 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  85294 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  85298 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  85302 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  85306 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  85310 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  85314 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  85318 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 0,
     /*  85322 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3668:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$a, MQPR:{ *:[v16i8] }:$b, MQPR:{ *:[v16i8] }:$c, 1:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VQRDMLADHXs8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$a, MQPR:{ *:[v16i8] }:$b, MQPR:{ *:[v16i8] }:$c)
     /*  85322 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQRDMLADHXs8),
     /*  85325 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  85327 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  85329 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /*  85331 */     GIR_RootToRootCopy, /*OpIdx*/4, // c
     /*  85333 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  85336 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  85342 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  85348 */     GIR_RootConstrainSelectedInstOperands,
     /*  85349 */     // GIR_Coverage, 4350,
     /*  85349 */     GIR_EraseRootFromParent_Done,
     /*  85350 */   // Label 1603: @85350
     /*  85350 */   GIM_Try, /*On fail goto*//*Label 1604*/ GIMT_Encode4(85437), // Rule ID 4352 //
     /*  85355 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqdmlad),
     /*  85360 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  85363 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  85366 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  85369 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /*  85372 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  85375 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  85378 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  85381 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  85385 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  85389 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  85393 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  85397 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  85401 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  85405 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 0,
     /*  85409 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3668:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$a, MQPR:{ *:[v8i16] }:$b, MQPR:{ *:[v8i16] }:$c, 1:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VQRDMLADHXs16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$a, MQPR:{ *:[v8i16] }:$b, MQPR:{ *:[v8i16] }:$c)
     /*  85409 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQRDMLADHXs16),
     /*  85412 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  85414 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  85416 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /*  85418 */     GIR_RootToRootCopy, /*OpIdx*/4, // c
     /*  85420 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  85423 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  85429 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  85435 */     GIR_RootConstrainSelectedInstOperands,
     /*  85436 */     // GIR_Coverage, 4352,
     /*  85436 */     GIR_EraseRootFromParent_Done,
     /*  85437 */   // Label 1604: @85437
     /*  85437 */   GIM_Try, /*On fail goto*//*Label 1605*/ GIMT_Encode4(85524), // Rule ID 4354 //
     /*  85442 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqdmlad),
     /*  85447 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  85450 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  85453 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  85456 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /*  85459 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  85462 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  85465 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  85468 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  85472 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  85476 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  85480 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  85484 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  85488 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  85492 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 0,
     /*  85496 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3668:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$a, MQPR:{ *:[v4i32] }:$b, MQPR:{ *:[v4i32] }:$c, 1:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VQRDMLADHXs32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$a, MQPR:{ *:[v4i32] }:$b, MQPR:{ *:[v4i32] }:$c)
     /*  85496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQRDMLADHXs32),
     /*  85499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  85501 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  85503 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /*  85505 */     GIR_RootToRootCopy, /*OpIdx*/4, // c
     /*  85507 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  85510 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  85516 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  85522 */     GIR_RootConstrainSelectedInstOperands,
     /*  85523 */     // GIR_Coverage, 4354,
     /*  85523 */     GIR_EraseRootFromParent_Done,
     /*  85524 */   // Label 1605: @85524
     /*  85524 */   GIM_Try, /*On fail goto*//*Label 1606*/ GIMT_Encode4(85611), // Rule ID 4356 //
     /*  85529 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqdmlad),
     /*  85534 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  85537 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  85540 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  85543 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  85546 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  85549 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  85552 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  85555 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  85559 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  85563 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  85567 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  85571 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  85575 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  85579 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 1,
     /*  85583 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3668:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$a, MQPR:{ *:[v16i8] }:$b, MQPR:{ *:[v16i8] }:$c, 0:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VQDMLSDHs8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$a, MQPR:{ *:[v16i8] }:$b, MQPR:{ *:[v16i8] }:$c)
     /*  85583 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQDMLSDHs8),
     /*  85586 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  85588 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  85590 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /*  85592 */     GIR_RootToRootCopy, /*OpIdx*/4, // c
     /*  85594 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  85597 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  85603 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  85609 */     GIR_RootConstrainSelectedInstOperands,
     /*  85610 */     // GIR_Coverage, 4356,
     /*  85610 */     GIR_EraseRootFromParent_Done,
     /*  85611 */   // Label 1606: @85611
     /*  85611 */   GIM_Try, /*On fail goto*//*Label 1607*/ GIMT_Encode4(85698), // Rule ID 4358 //
     /*  85616 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqdmlad),
     /*  85621 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  85624 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  85627 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  85630 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /*  85633 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  85636 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  85639 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  85642 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  85646 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  85650 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  85654 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  85658 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  85662 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  85666 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 1,
     /*  85670 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3668:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$a, MQPR:{ *:[v8i16] }:$b, MQPR:{ *:[v8i16] }:$c, 0:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VQDMLSDHs16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$a, MQPR:{ *:[v8i16] }:$b, MQPR:{ *:[v8i16] }:$c)
     /*  85670 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQDMLSDHs16),
     /*  85673 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  85675 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  85677 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /*  85679 */     GIR_RootToRootCopy, /*OpIdx*/4, // c
     /*  85681 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  85684 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  85690 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  85696 */     GIR_RootConstrainSelectedInstOperands,
     /*  85697 */     // GIR_Coverage, 4358,
     /*  85697 */     GIR_EraseRootFromParent_Done,
     /*  85698 */   // Label 1607: @85698
     /*  85698 */   GIM_Try, /*On fail goto*//*Label 1608*/ GIMT_Encode4(85785), // Rule ID 4360 //
     /*  85703 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqdmlad),
     /*  85708 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  85711 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  85714 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  85717 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /*  85720 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  85723 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  85726 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  85729 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  85733 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  85737 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  85741 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  85745 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  85749 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  85753 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 1,
     /*  85757 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3668:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$a, MQPR:{ *:[v4i32] }:$b, MQPR:{ *:[v4i32] }:$c, 0:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VQDMLSDHs32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$a, MQPR:{ *:[v4i32] }:$b, MQPR:{ *:[v4i32] }:$c)
     /*  85757 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQDMLSDHs32),
     /*  85760 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  85762 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  85764 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /*  85766 */     GIR_RootToRootCopy, /*OpIdx*/4, // c
     /*  85768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  85771 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  85777 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  85783 */     GIR_RootConstrainSelectedInstOperands,
     /*  85784 */     // GIR_Coverage, 4360,
     /*  85784 */     GIR_EraseRootFromParent_Done,
     /*  85785 */   // Label 1608: @85785
     /*  85785 */   GIM_Try, /*On fail goto*//*Label 1609*/ GIMT_Encode4(85872), // Rule ID 4362 //
     /*  85790 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqdmlad),
     /*  85795 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  85798 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  85801 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  85804 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  85807 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  85810 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  85813 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  85816 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  85820 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  85824 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  85828 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  85832 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  85836 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  85840 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 1,
     /*  85844 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3668:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$a, MQPR:{ *:[v16i8] }:$b, MQPR:{ *:[v16i8] }:$c, 1:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VQDMLSDHXs8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$a, MQPR:{ *:[v16i8] }:$b, MQPR:{ *:[v16i8] }:$c)
     /*  85844 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQDMLSDHXs8),
     /*  85847 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  85849 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  85851 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /*  85853 */     GIR_RootToRootCopy, /*OpIdx*/4, // c
     /*  85855 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  85858 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  85864 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  85870 */     GIR_RootConstrainSelectedInstOperands,
     /*  85871 */     // GIR_Coverage, 4362,
     /*  85871 */     GIR_EraseRootFromParent_Done,
     /*  85872 */   // Label 1609: @85872
     /*  85872 */   GIM_Try, /*On fail goto*//*Label 1610*/ GIMT_Encode4(85959), // Rule ID 4364 //
     /*  85877 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqdmlad),
     /*  85882 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  85885 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  85888 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  85891 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /*  85894 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  85897 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  85900 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  85903 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  85907 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  85911 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  85915 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  85919 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  85923 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  85927 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 1,
     /*  85931 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3668:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$a, MQPR:{ *:[v8i16] }:$b, MQPR:{ *:[v8i16] }:$c, 1:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VQDMLSDHXs16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$a, MQPR:{ *:[v8i16] }:$b, MQPR:{ *:[v8i16] }:$c)
     /*  85931 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQDMLSDHXs16),
     /*  85934 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  85936 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  85938 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /*  85940 */     GIR_RootToRootCopy, /*OpIdx*/4, // c
     /*  85942 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  85945 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  85951 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  85957 */     GIR_RootConstrainSelectedInstOperands,
     /*  85958 */     // GIR_Coverage, 4364,
     /*  85958 */     GIR_EraseRootFromParent_Done,
     /*  85959 */   // Label 1610: @85959
     /*  85959 */   GIM_Try, /*On fail goto*//*Label 1611*/ GIMT_Encode4(86046), // Rule ID 4366 //
     /*  85964 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqdmlad),
     /*  85969 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  85972 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  85975 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  85978 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /*  85981 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  85984 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  85987 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  85990 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  85994 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  85998 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  86002 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  86006 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  86010 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  86014 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 1,
     /*  86018 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3668:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$a, MQPR:{ *:[v4i32] }:$b, MQPR:{ *:[v4i32] }:$c, 1:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VQDMLSDHXs32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$a, MQPR:{ *:[v4i32] }:$b, MQPR:{ *:[v4i32] }:$c)
     /*  86018 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQDMLSDHXs32),
     /*  86021 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  86023 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  86025 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /*  86027 */     GIR_RootToRootCopy, /*OpIdx*/4, // c
     /*  86029 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  86032 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  86038 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  86044 */     GIR_RootConstrainSelectedInstOperands,
     /*  86045 */     // GIR_Coverage, 4366,
     /*  86045 */     GIR_EraseRootFromParent_Done,
     /*  86046 */   // Label 1611: @86046
     /*  86046 */   GIM_Try, /*On fail goto*//*Label 1612*/ GIMT_Encode4(86133), // Rule ID 4368 //
     /*  86051 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqdmlad),
     /*  86056 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  86059 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  86062 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  86065 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  86068 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  86071 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  86074 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  86077 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  86081 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  86085 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  86089 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  86093 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  86097 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  86101 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 1,
     /*  86105 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3668:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$a, MQPR:{ *:[v16i8] }:$b, MQPR:{ *:[v16i8] }:$c, 0:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VQRDMLSDHs8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$a, MQPR:{ *:[v16i8] }:$b, MQPR:{ *:[v16i8] }:$c)
     /*  86105 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQRDMLSDHs8),
     /*  86108 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  86110 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  86112 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /*  86114 */     GIR_RootToRootCopy, /*OpIdx*/4, // c
     /*  86116 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  86119 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  86125 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  86131 */     GIR_RootConstrainSelectedInstOperands,
     /*  86132 */     // GIR_Coverage, 4368,
     /*  86132 */     GIR_EraseRootFromParent_Done,
     /*  86133 */   // Label 1612: @86133
     /*  86133 */   GIM_Try, /*On fail goto*//*Label 1613*/ GIMT_Encode4(86220), // Rule ID 4370 //
     /*  86138 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqdmlad),
     /*  86143 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  86146 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  86149 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  86152 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /*  86155 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  86158 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  86161 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  86164 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  86168 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  86172 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  86176 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  86180 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  86184 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  86188 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 1,
     /*  86192 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3668:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$a, MQPR:{ *:[v8i16] }:$b, MQPR:{ *:[v8i16] }:$c, 0:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VQRDMLSDHs16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$a, MQPR:{ *:[v8i16] }:$b, MQPR:{ *:[v8i16] }:$c)
     /*  86192 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQRDMLSDHs16),
     /*  86195 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  86197 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  86199 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /*  86201 */     GIR_RootToRootCopy, /*OpIdx*/4, // c
     /*  86203 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  86206 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  86212 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  86218 */     GIR_RootConstrainSelectedInstOperands,
     /*  86219 */     // GIR_Coverage, 4370,
     /*  86219 */     GIR_EraseRootFromParent_Done,
     /*  86220 */   // Label 1613: @86220
     /*  86220 */   GIM_Try, /*On fail goto*//*Label 1614*/ GIMT_Encode4(86307), // Rule ID 4372 //
     /*  86225 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqdmlad),
     /*  86230 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  86233 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  86236 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  86239 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /*  86242 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  86245 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  86248 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  86251 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  86255 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  86259 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  86263 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  86267 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  86271 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  86275 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 1,
     /*  86279 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3668:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$a, MQPR:{ *:[v4i32] }:$b, MQPR:{ *:[v4i32] }:$c, 0:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VQRDMLSDHs32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$a, MQPR:{ *:[v4i32] }:$b, MQPR:{ *:[v4i32] }:$c)
     /*  86279 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQRDMLSDHs32),
     /*  86282 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  86284 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  86286 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /*  86288 */     GIR_RootToRootCopy, /*OpIdx*/4, // c
     /*  86290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  86293 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  86299 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  86305 */     GIR_RootConstrainSelectedInstOperands,
     /*  86306 */     // GIR_Coverage, 4372,
     /*  86306 */     GIR_EraseRootFromParent_Done,
     /*  86307 */   // Label 1614: @86307
     /*  86307 */   GIM_Try, /*On fail goto*//*Label 1615*/ GIMT_Encode4(86394), // Rule ID 4374 //
     /*  86312 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqdmlad),
     /*  86317 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  86320 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  86323 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  86326 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  86329 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  86332 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  86335 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  86338 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  86342 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  86346 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  86350 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  86354 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  86358 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  86362 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 1,
     /*  86366 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3668:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$a, MQPR:{ *:[v16i8] }:$b, MQPR:{ *:[v16i8] }:$c, 1:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VQRDMLSDHXs8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$a, MQPR:{ *:[v16i8] }:$b, MQPR:{ *:[v16i8] }:$c)
     /*  86366 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQRDMLSDHXs8),
     /*  86369 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  86371 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  86373 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /*  86375 */     GIR_RootToRootCopy, /*OpIdx*/4, // c
     /*  86377 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  86380 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  86386 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  86392 */     GIR_RootConstrainSelectedInstOperands,
     /*  86393 */     // GIR_Coverage, 4374,
     /*  86393 */     GIR_EraseRootFromParent_Done,
     /*  86394 */   // Label 1615: @86394
     /*  86394 */   GIM_Try, /*On fail goto*//*Label 1616*/ GIMT_Encode4(86481), // Rule ID 4376 //
     /*  86399 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqdmlad),
     /*  86404 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  86407 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  86410 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  86413 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /*  86416 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  86419 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  86422 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  86425 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  86429 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  86433 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  86437 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  86441 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  86445 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  86449 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 1,
     /*  86453 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3668:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$a, MQPR:{ *:[v8i16] }:$b, MQPR:{ *:[v8i16] }:$c, 1:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VQRDMLSDHXs16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$a, MQPR:{ *:[v8i16] }:$b, MQPR:{ *:[v8i16] }:$c)
     /*  86453 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQRDMLSDHXs16),
     /*  86456 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  86458 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  86460 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /*  86462 */     GIR_RootToRootCopy, /*OpIdx*/4, // c
     /*  86464 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  86467 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  86473 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  86479 */     GIR_RootConstrainSelectedInstOperands,
     /*  86480 */     // GIR_Coverage, 4376,
     /*  86480 */     GIR_EraseRootFromParent_Done,
     /*  86481 */   // Label 1616: @86481
     /*  86481 */   GIM_Try, /*On fail goto*//*Label 1617*/ GIMT_Encode4(86568), // Rule ID 4378 //
     /*  86486 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqdmlad),
     /*  86491 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  86494 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  86497 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  86500 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /*  86503 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  86506 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  86509 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  86512 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  86516 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  86520 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  86524 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  86528 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  86532 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  86536 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 1,
     /*  86540 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3668:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$a, MQPR:{ *:[v4i32] }:$b, MQPR:{ *:[v4i32] }:$c, 1:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VQRDMLSDHXs32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$a, MQPR:{ *:[v4i32] }:$b, MQPR:{ *:[v4i32] }:$c)
     /*  86540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQRDMLSDHXs32),
     /*  86543 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  86545 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  86547 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /*  86549 */     GIR_RootToRootCopy, /*OpIdx*/4, // c
     /*  86551 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  86554 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  86560 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  86566 */     GIR_RootConstrainSelectedInstOperands,
     /*  86567 */     // GIR_Coverage, 4378,
     /*  86567 */     GIR_EraseRootFromParent_Done,
     /*  86568 */   // Label 1617: @86568
     /*  86568 */   GIM_Try, /*On fail goto*//*Label 1618*/ GIMT_Encode4(86694), // Rule ID 2689 //
     /*  86573 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  86576 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vtbx4),
     /*  86581 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /*  86584 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  86587 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  86590 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s8,
     /*  86593 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_v8s8,
     /*  86596 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_v8s8,
     /*  86599 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_v8s8,
     /*  86602 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  86606 */     // (intrinsic_wo_chain:{ *:[v8i8] } 3863:{ *:[iPTR] }, v8i8:{ *:[v8i8] }:$orig, v8i8:{ *:[v8i8] }:$Vn0, v8i8:{ *:[v8i8] }:$Vn1, v8i8:{ *:[v8i8] }:$Vn2, v8i8:{ *:[v8i8] }:$Vn3, v8i8:{ *:[v8i8] }:$Vm)  =>  (VTBX4Pseudo:{ *:[v8i8] } v8i8:{ *:[v8i8] }:$orig, (REG_SEQUENCE:{ *:[v4i64] } QQPR:{ *:[i32] }, v8i8:{ *:[v8i8] }:$Vn0, dsub_0:{ *:[i32] }, v8i8:{ *:[v8i8] }:$Vn1, dsub_1:{ *:[i32] }, v8i8:{ *:[v8i8] }:$Vn2, dsub_2:{ *:[i32] }, v8i8:{ *:[v8i8] }:$Vn3, dsub_3:{ *:[i32] }), v8i8:{ *:[v8i8] }:$Vm)
     /*  86606 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s64,
     /*  86609 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /*  86613 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  86618 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // Vn0
     /*  86622 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/1,
     /*  86625 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // Vn1
     /*  86629 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/2,
     /*  86632 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // Vn2
     /*  86636 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /*  86639 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/6, // Vn3
     /*  86643 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/4,
     /*  86646 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(ARM::QQPRRegClassID),
     /*  86651 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(ARM::DPRRegClassID),
     /*  86656 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(ARM::DPRRegClassID),
     /*  86661 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/5, GIMT_Encode2(ARM::DPRRegClassID),
     /*  86666 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/7, GIMT_Encode2(ARM::DPRRegClassID),
     /*  86671 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VTBX4Pseudo),
     /*  86674 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  86676 */     GIR_RootToRootCopy, /*OpIdx*/2, // orig
     /*  86678 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  86681 */     GIR_RootToRootCopy, /*OpIdx*/7, // Vm
     /*  86683 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  86686 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  86692 */     GIR_RootConstrainSelectedInstOperands,
     /*  86693 */     // GIR_Coverage, 2689,
     /*  86693 */     GIR_EraseRootFromParent_Done,
     /*  86694 */   // Label 1618: @86694
     /*  86694 */   GIM_Reject,
     /*  86695 */ // Label 1563: @86695
     /*  86695 */ GIM_Try, /*On fail goto*//*Label 1619*/ GIMT_Encode4(90989),
     /*  86700 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/10,
     /*  86703 */   GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshrn),
     /*  86708 */   GIM_Try, /*On fail goto*//*Label 1620*/ GIMT_Encode4(86815), // Rule ID 3755 //
     /*  86713 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  86716 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  86719 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  86722 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  86725 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  86728 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  86731 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  86734 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /*  86737 */     GIM_RootCheckType, /*Op*/9, /*Type*/GILLT_s32,
     /*  86740 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  86744 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  86748 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  86752 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  86756 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  86760 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm8),
     /*  86764 */     // MIs[1] Operand 1
     /*  86764 */     // No operand predicates
     /*  86764 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  86768 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  86772 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 0,
     /*  86776 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 0,
     /*  86780 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/9, 0,
     /*  86784 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  86786 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3712:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$QdSrc, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_shr_imm8>>:$imm, 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VSHRNi16bh:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$QdSrc, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] }):$imm)
     /*  86786 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSHRNi16bh),
     /*  86789 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  86791 */     GIR_RootToRootCopy, /*OpIdx*/2, // QdSrc
     /*  86793 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  86795 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  86798 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  86801 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  86807 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  86813 */     GIR_RootConstrainSelectedInstOperands,
     /*  86814 */     // GIR_Coverage, 3755,
     /*  86814 */     GIR_EraseRootFromParent_Done,
     /*  86815 */   // Label 1620: @86815
     /*  86815 */   GIM_Try, /*On fail goto*//*Label 1621*/ GIMT_Encode4(86922), // Rule ID 3757 //
     /*  86820 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  86823 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  86826 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  86829 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  86832 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  86835 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  86838 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  86841 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /*  86844 */     GIM_RootCheckType, /*Op*/9, /*Type*/GILLT_s32,
     /*  86847 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  86851 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  86855 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  86859 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  86863 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  86867 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm8),
     /*  86871 */     // MIs[1] Operand 1
     /*  86871 */     // No operand predicates
     /*  86871 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  86875 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  86879 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 0,
     /*  86883 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 0,
     /*  86887 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/9, 1,
     /*  86891 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  86893 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3712:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$QdSrc, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_shr_imm8>>:$imm, 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VSHRNi16th:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$QdSrc, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] }):$imm)
     /*  86893 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSHRNi16th),
     /*  86896 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  86898 */     GIR_RootToRootCopy, /*OpIdx*/2, // QdSrc
     /*  86900 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  86902 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  86905 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  86908 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  86914 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  86920 */     GIR_RootConstrainSelectedInstOperands,
     /*  86921 */     // GIR_Coverage, 3757,
     /*  86921 */     GIR_EraseRootFromParent_Done,
     /*  86922 */   // Label 1621: @86922
     /*  86922 */   GIM_Try, /*On fail goto*//*Label 1622*/ GIMT_Encode4(87029), // Rule ID 3759 //
     /*  86927 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  86930 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  86933 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  86936 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  86939 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  86942 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  86945 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  86948 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /*  86951 */     GIM_RootCheckType, /*Op*/9, /*Type*/GILLT_s32,
     /*  86954 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  86958 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  86962 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  86966 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  86970 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  86974 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm16),
     /*  86978 */     // MIs[1] Operand 1
     /*  86978 */     // No operand predicates
     /*  86978 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  86982 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  86986 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 0,
     /*  86990 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 0,
     /*  86994 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/9, 0,
     /*  86998 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  87000 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3712:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$QdSrc, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_shr_imm16>>:$imm, 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VSHRNi32bh:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$QdSrc, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] }):$imm)
     /*  87000 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSHRNi32bh),
     /*  87003 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  87005 */     GIR_RootToRootCopy, /*OpIdx*/2, // QdSrc
     /*  87007 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  87009 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  87012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  87015 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  87021 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  87027 */     GIR_RootConstrainSelectedInstOperands,
     /*  87028 */     // GIR_Coverage, 3759,
     /*  87028 */     GIR_EraseRootFromParent_Done,
     /*  87029 */   // Label 1622: @87029
     /*  87029 */   GIM_Try, /*On fail goto*//*Label 1623*/ GIMT_Encode4(87136), // Rule ID 3761 //
     /*  87034 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  87037 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  87040 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  87043 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  87046 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  87049 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  87052 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  87055 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /*  87058 */     GIM_RootCheckType, /*Op*/9, /*Type*/GILLT_s32,
     /*  87061 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  87065 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  87069 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  87073 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  87077 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  87081 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm16),
     /*  87085 */     // MIs[1] Operand 1
     /*  87085 */     // No operand predicates
     /*  87085 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  87089 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  87093 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 0,
     /*  87097 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 0,
     /*  87101 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/9, 1,
     /*  87105 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  87107 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3712:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$QdSrc, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_shr_imm16>>:$imm, 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VSHRNi32th:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$QdSrc, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] }):$imm)
     /*  87107 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSHRNi32th),
     /*  87110 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  87112 */     GIR_RootToRootCopy, /*OpIdx*/2, // QdSrc
     /*  87114 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  87116 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  87119 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  87122 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  87128 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  87134 */     GIR_RootConstrainSelectedInstOperands,
     /*  87135 */     // GIR_Coverage, 3761,
     /*  87135 */     GIR_EraseRootFromParent_Done,
     /*  87136 */   // Label 1623: @87136
     /*  87136 */   GIM_Try, /*On fail goto*//*Label 1624*/ GIMT_Encode4(87243), // Rule ID 3763 //
     /*  87141 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  87144 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  87147 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  87150 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  87153 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  87156 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  87159 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  87162 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /*  87165 */     GIM_RootCheckType, /*Op*/9, /*Type*/GILLT_s32,
     /*  87168 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  87172 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  87176 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  87180 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  87184 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  87188 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm8),
     /*  87192 */     // MIs[1] Operand 1
     /*  87192 */     // No operand predicates
     /*  87192 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  87196 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  87200 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 1,
     /*  87204 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 1,
     /*  87208 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/9, 0,
     /*  87212 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  87214 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3712:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$QdSrc, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_shr_imm8>>:$imm, 0:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VSHRNi16bh:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$QdSrc, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] }):$imm)
     /*  87214 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSHRNi16bh),
     /*  87217 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  87219 */     GIR_RootToRootCopy, /*OpIdx*/2, // QdSrc
     /*  87221 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  87223 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  87226 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  87229 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  87235 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  87241 */     GIR_RootConstrainSelectedInstOperands,
     /*  87242 */     // GIR_Coverage, 3763,
     /*  87242 */     GIR_EraseRootFromParent_Done,
     /*  87243 */   // Label 1624: @87243
     /*  87243 */   GIM_Try, /*On fail goto*//*Label 1625*/ GIMT_Encode4(87350), // Rule ID 3765 //
     /*  87248 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  87251 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  87254 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  87257 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  87260 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  87263 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  87266 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  87269 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /*  87272 */     GIM_RootCheckType, /*Op*/9, /*Type*/GILLT_s32,
     /*  87275 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  87279 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  87283 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  87287 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  87291 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  87295 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm8),
     /*  87299 */     // MIs[1] Operand 1
     /*  87299 */     // No operand predicates
     /*  87299 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  87303 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  87307 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 1,
     /*  87311 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 1,
     /*  87315 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/9, 1,
     /*  87319 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  87321 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3712:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$QdSrc, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_shr_imm8>>:$imm, 0:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VSHRNi16th:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$QdSrc, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] }):$imm)
     /*  87321 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSHRNi16th),
     /*  87324 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  87326 */     GIR_RootToRootCopy, /*OpIdx*/2, // QdSrc
     /*  87328 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  87330 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  87333 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  87336 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  87342 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  87348 */     GIR_RootConstrainSelectedInstOperands,
     /*  87349 */     // GIR_Coverage, 3765,
     /*  87349 */     GIR_EraseRootFromParent_Done,
     /*  87350 */   // Label 1625: @87350
     /*  87350 */   GIM_Try, /*On fail goto*//*Label 1626*/ GIMT_Encode4(87457), // Rule ID 3767 //
     /*  87355 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  87358 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  87361 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  87364 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  87367 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  87370 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  87373 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  87376 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /*  87379 */     GIM_RootCheckType, /*Op*/9, /*Type*/GILLT_s32,
     /*  87382 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  87386 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  87390 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  87394 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  87398 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  87402 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm16),
     /*  87406 */     // MIs[1] Operand 1
     /*  87406 */     // No operand predicates
     /*  87406 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  87410 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  87414 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 1,
     /*  87418 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 1,
     /*  87422 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/9, 0,
     /*  87426 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  87428 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3712:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$QdSrc, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_shr_imm16>>:$imm, 0:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VSHRNi32bh:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$QdSrc, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] }):$imm)
     /*  87428 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSHRNi32bh),
     /*  87431 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  87433 */     GIR_RootToRootCopy, /*OpIdx*/2, // QdSrc
     /*  87435 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  87437 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  87440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  87443 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  87449 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  87455 */     GIR_RootConstrainSelectedInstOperands,
     /*  87456 */     // GIR_Coverage, 3767,
     /*  87456 */     GIR_EraseRootFromParent_Done,
     /*  87457 */   // Label 1626: @87457
     /*  87457 */   GIM_Try, /*On fail goto*//*Label 1627*/ GIMT_Encode4(87564), // Rule ID 3769 //
     /*  87462 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  87465 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  87468 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  87471 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  87474 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  87477 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  87480 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  87483 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /*  87486 */     GIM_RootCheckType, /*Op*/9, /*Type*/GILLT_s32,
     /*  87489 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  87493 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  87497 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  87501 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  87505 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  87509 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm16),
     /*  87513 */     // MIs[1] Operand 1
     /*  87513 */     // No operand predicates
     /*  87513 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  87517 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  87521 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 1,
     /*  87525 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 1,
     /*  87529 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/9, 1,
     /*  87533 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  87535 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3712:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$QdSrc, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_shr_imm16>>:$imm, 0:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VSHRNi32th:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$QdSrc, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] }):$imm)
     /*  87535 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSHRNi32th),
     /*  87538 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  87540 */     GIR_RootToRootCopy, /*OpIdx*/2, // QdSrc
     /*  87542 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  87544 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  87547 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  87550 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  87556 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  87562 */     GIR_RootConstrainSelectedInstOperands,
     /*  87563 */     // GIR_Coverage, 3769,
     /*  87563 */     GIR_EraseRootFromParent_Done,
     /*  87564 */   // Label 1627: @87564
     /*  87564 */   GIM_Try, /*On fail goto*//*Label 1628*/ GIMT_Encode4(87671), // Rule ID 3771 //
     /*  87569 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  87572 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  87575 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  87578 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  87581 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  87584 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  87587 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  87590 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /*  87593 */     GIM_RootCheckType, /*Op*/9, /*Type*/GILLT_s32,
     /*  87596 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  87600 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  87604 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  87608 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  87612 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  87616 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm8),
     /*  87620 */     // MIs[1] Operand 1
     /*  87620 */     // No operand predicates
     /*  87620 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  87624 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  87628 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 0,
     /*  87632 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 0,
     /*  87636 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/9, 0,
     /*  87640 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  87642 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3712:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$QdSrc, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_shr_imm8>>:$imm, 0:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VRSHRNi16bh:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$QdSrc, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] }):$imm)
     /*  87642 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRSHRNi16bh),
     /*  87645 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  87647 */     GIR_RootToRootCopy, /*OpIdx*/2, // QdSrc
     /*  87649 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  87651 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  87654 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  87657 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  87663 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  87669 */     GIR_RootConstrainSelectedInstOperands,
     /*  87670 */     // GIR_Coverage, 3771,
     /*  87670 */     GIR_EraseRootFromParent_Done,
     /*  87671 */   // Label 1628: @87671
     /*  87671 */   GIM_Try, /*On fail goto*//*Label 1629*/ GIMT_Encode4(87778), // Rule ID 3773 //
     /*  87676 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  87679 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  87682 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  87685 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  87688 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  87691 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  87694 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  87697 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /*  87700 */     GIM_RootCheckType, /*Op*/9, /*Type*/GILLT_s32,
     /*  87703 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  87707 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  87711 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  87715 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  87719 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  87723 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm8),
     /*  87727 */     // MIs[1] Operand 1
     /*  87727 */     // No operand predicates
     /*  87727 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  87731 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  87735 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 0,
     /*  87739 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 0,
     /*  87743 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/9, 1,
     /*  87747 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  87749 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3712:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$QdSrc, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_shr_imm8>>:$imm, 0:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VRSHRNi16th:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$QdSrc, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] }):$imm)
     /*  87749 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRSHRNi16th),
     /*  87752 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  87754 */     GIR_RootToRootCopy, /*OpIdx*/2, // QdSrc
     /*  87756 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  87758 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  87761 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  87764 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  87770 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  87776 */     GIR_RootConstrainSelectedInstOperands,
     /*  87777 */     // GIR_Coverage, 3773,
     /*  87777 */     GIR_EraseRootFromParent_Done,
     /*  87778 */   // Label 1629: @87778
     /*  87778 */   GIM_Try, /*On fail goto*//*Label 1630*/ GIMT_Encode4(87885), // Rule ID 3775 //
     /*  87783 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  87786 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  87789 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  87792 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  87795 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  87798 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  87801 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  87804 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /*  87807 */     GIM_RootCheckType, /*Op*/9, /*Type*/GILLT_s32,
     /*  87810 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  87814 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  87818 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  87822 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  87826 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  87830 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm16),
     /*  87834 */     // MIs[1] Operand 1
     /*  87834 */     // No operand predicates
     /*  87834 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  87838 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  87842 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 0,
     /*  87846 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 0,
     /*  87850 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/9, 0,
     /*  87854 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  87856 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3712:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$QdSrc, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_shr_imm16>>:$imm, 0:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VRSHRNi32bh:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$QdSrc, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] }):$imm)
     /*  87856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRSHRNi32bh),
     /*  87859 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  87861 */     GIR_RootToRootCopy, /*OpIdx*/2, // QdSrc
     /*  87863 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  87865 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  87868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  87871 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  87877 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  87883 */     GIR_RootConstrainSelectedInstOperands,
     /*  87884 */     // GIR_Coverage, 3775,
     /*  87884 */     GIR_EraseRootFromParent_Done,
     /*  87885 */   // Label 1630: @87885
     /*  87885 */   GIM_Try, /*On fail goto*//*Label 1631*/ GIMT_Encode4(87992), // Rule ID 3777 //
     /*  87890 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  87893 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  87896 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  87899 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  87902 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  87905 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  87908 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  87911 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /*  87914 */     GIM_RootCheckType, /*Op*/9, /*Type*/GILLT_s32,
     /*  87917 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  87921 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  87925 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  87929 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  87933 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  87937 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm16),
     /*  87941 */     // MIs[1] Operand 1
     /*  87941 */     // No operand predicates
     /*  87941 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  87945 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  87949 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 0,
     /*  87953 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 0,
     /*  87957 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/9, 1,
     /*  87961 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  87963 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3712:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$QdSrc, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_shr_imm16>>:$imm, 0:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VRSHRNi32th:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$QdSrc, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] }):$imm)
     /*  87963 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRSHRNi32th),
     /*  87966 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  87968 */     GIR_RootToRootCopy, /*OpIdx*/2, // QdSrc
     /*  87970 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  87972 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  87975 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  87978 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  87984 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  87990 */     GIR_RootConstrainSelectedInstOperands,
     /*  87991 */     // GIR_Coverage, 3777,
     /*  87991 */     GIR_EraseRootFromParent_Done,
     /*  87992 */   // Label 1631: @87992
     /*  87992 */   GIM_Try, /*On fail goto*//*Label 1632*/ GIMT_Encode4(88099), // Rule ID 3779 //
     /*  87997 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  88000 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  88003 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  88006 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  88009 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  88012 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  88015 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  88018 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /*  88021 */     GIM_RootCheckType, /*Op*/9, /*Type*/GILLT_s32,
     /*  88024 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  88028 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  88032 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  88036 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  88040 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  88044 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm8),
     /*  88048 */     // MIs[1] Operand 1
     /*  88048 */     // No operand predicates
     /*  88048 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  88052 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  88056 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 1,
     /*  88060 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 1,
     /*  88064 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/9, 0,
     /*  88068 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  88070 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3712:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$QdSrc, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_shr_imm8>>:$imm, 0:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VRSHRNi16bh:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$QdSrc, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] }):$imm)
     /*  88070 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRSHRNi16bh),
     /*  88073 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  88075 */     GIR_RootToRootCopy, /*OpIdx*/2, // QdSrc
     /*  88077 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  88079 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  88082 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  88085 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  88091 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  88097 */     GIR_RootConstrainSelectedInstOperands,
     /*  88098 */     // GIR_Coverage, 3779,
     /*  88098 */     GIR_EraseRootFromParent_Done,
     /*  88099 */   // Label 1632: @88099
     /*  88099 */   GIM_Try, /*On fail goto*//*Label 1633*/ GIMT_Encode4(88206), // Rule ID 3781 //
     /*  88104 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  88107 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  88110 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  88113 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  88116 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  88119 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  88122 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  88125 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /*  88128 */     GIM_RootCheckType, /*Op*/9, /*Type*/GILLT_s32,
     /*  88131 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  88135 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  88139 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  88143 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  88147 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  88151 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm8),
     /*  88155 */     // MIs[1] Operand 1
     /*  88155 */     // No operand predicates
     /*  88155 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  88159 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  88163 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 1,
     /*  88167 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 1,
     /*  88171 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/9, 1,
     /*  88175 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  88177 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3712:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$QdSrc, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_shr_imm8>>:$imm, 0:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VRSHRNi16th:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$QdSrc, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] }):$imm)
     /*  88177 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRSHRNi16th),
     /*  88180 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  88182 */     GIR_RootToRootCopy, /*OpIdx*/2, // QdSrc
     /*  88184 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  88186 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  88189 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  88192 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  88198 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  88204 */     GIR_RootConstrainSelectedInstOperands,
     /*  88205 */     // GIR_Coverage, 3781,
     /*  88205 */     GIR_EraseRootFromParent_Done,
     /*  88206 */   // Label 1633: @88206
     /*  88206 */   GIM_Try, /*On fail goto*//*Label 1634*/ GIMT_Encode4(88313), // Rule ID 3783 //
     /*  88211 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  88214 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  88217 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  88220 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  88223 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  88226 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  88229 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  88232 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /*  88235 */     GIM_RootCheckType, /*Op*/9, /*Type*/GILLT_s32,
     /*  88238 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  88242 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  88246 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  88250 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  88254 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  88258 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm16),
     /*  88262 */     // MIs[1] Operand 1
     /*  88262 */     // No operand predicates
     /*  88262 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  88266 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  88270 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 1,
     /*  88274 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 1,
     /*  88278 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/9, 0,
     /*  88282 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  88284 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3712:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$QdSrc, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_shr_imm16>>:$imm, 0:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VRSHRNi32bh:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$QdSrc, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] }):$imm)
     /*  88284 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRSHRNi32bh),
     /*  88287 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  88289 */     GIR_RootToRootCopy, /*OpIdx*/2, // QdSrc
     /*  88291 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  88293 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  88296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  88299 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  88305 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  88311 */     GIR_RootConstrainSelectedInstOperands,
     /*  88312 */     // GIR_Coverage, 3783,
     /*  88312 */     GIR_EraseRootFromParent_Done,
     /*  88313 */   // Label 1634: @88313
     /*  88313 */   GIM_Try, /*On fail goto*//*Label 1635*/ GIMT_Encode4(88420), // Rule ID 3785 //
     /*  88318 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  88321 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  88324 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  88327 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  88330 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  88333 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  88336 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  88339 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /*  88342 */     GIM_RootCheckType, /*Op*/9, /*Type*/GILLT_s32,
     /*  88345 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  88349 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  88353 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  88357 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  88361 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  88365 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm16),
     /*  88369 */     // MIs[1] Operand 1
     /*  88369 */     // No operand predicates
     /*  88369 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  88373 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  88377 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 1,
     /*  88381 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 1,
     /*  88385 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/9, 1,
     /*  88389 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  88391 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3712:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$QdSrc, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_shr_imm16>>:$imm, 0:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VRSHRNi32th:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$QdSrc, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] }):$imm)
     /*  88391 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRSHRNi32th),
     /*  88394 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  88396 */     GIR_RootToRootCopy, /*OpIdx*/2, // QdSrc
     /*  88398 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  88400 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  88403 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  88406 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  88412 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  88418 */     GIR_RootConstrainSelectedInstOperands,
     /*  88419 */     // GIR_Coverage, 3785,
     /*  88419 */     GIR_EraseRootFromParent_Done,
     /*  88420 */   // Label 1635: @88420
     /*  88420 */   GIM_Try, /*On fail goto*//*Label 1636*/ GIMT_Encode4(88527), // Rule ID 3787 //
     /*  88425 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  88428 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  88431 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  88434 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  88437 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  88440 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  88443 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  88446 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /*  88449 */     GIM_RootCheckType, /*Op*/9, /*Type*/GILLT_s32,
     /*  88452 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  88456 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  88460 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  88464 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  88468 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  88472 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm8),
     /*  88476 */     // MIs[1] Operand 1
     /*  88476 */     // No operand predicates
     /*  88476 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  88480 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  88484 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 0,
     /*  88488 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 0,
     /*  88492 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/9, 0,
     /*  88496 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  88498 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3712:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$QdSrc, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_shr_imm8>>:$imm, 1:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VQSHRNbhs16:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$QdSrc, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] }):$imm)
     /*  88498 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQSHRNbhs16),
     /*  88501 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  88503 */     GIR_RootToRootCopy, /*OpIdx*/2, // QdSrc
     /*  88505 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  88507 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  88510 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  88513 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  88519 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  88525 */     GIR_RootConstrainSelectedInstOperands,
     /*  88526 */     // GIR_Coverage, 3787,
     /*  88526 */     GIR_EraseRootFromParent_Done,
     /*  88527 */   // Label 1636: @88527
     /*  88527 */   GIM_Try, /*On fail goto*//*Label 1637*/ GIMT_Encode4(88634), // Rule ID 3789 //
     /*  88532 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  88535 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  88538 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  88541 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  88544 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  88547 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  88550 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  88553 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /*  88556 */     GIM_RootCheckType, /*Op*/9, /*Type*/GILLT_s32,
     /*  88559 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  88563 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  88567 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  88571 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  88575 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  88579 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm8),
     /*  88583 */     // MIs[1] Operand 1
     /*  88583 */     // No operand predicates
     /*  88583 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  88587 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  88591 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 0,
     /*  88595 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 0,
     /*  88599 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/9, 1,
     /*  88603 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  88605 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3712:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$QdSrc, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_shr_imm8>>:$imm, 1:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VQSHRNths16:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$QdSrc, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] }):$imm)
     /*  88605 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQSHRNths16),
     /*  88608 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  88610 */     GIR_RootToRootCopy, /*OpIdx*/2, // QdSrc
     /*  88612 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  88614 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  88617 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  88620 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  88626 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  88632 */     GIR_RootConstrainSelectedInstOperands,
     /*  88633 */     // GIR_Coverage, 3789,
     /*  88633 */     GIR_EraseRootFromParent_Done,
     /*  88634 */   // Label 1637: @88634
     /*  88634 */   GIM_Try, /*On fail goto*//*Label 1638*/ GIMT_Encode4(88741), // Rule ID 3791 //
     /*  88639 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  88642 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  88645 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  88648 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  88651 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  88654 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  88657 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  88660 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /*  88663 */     GIM_RootCheckType, /*Op*/9, /*Type*/GILLT_s32,
     /*  88666 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  88670 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  88674 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  88678 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  88682 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  88686 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm16),
     /*  88690 */     // MIs[1] Operand 1
     /*  88690 */     // No operand predicates
     /*  88690 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  88694 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  88698 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 0,
     /*  88702 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 0,
     /*  88706 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/9, 0,
     /*  88710 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  88712 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3712:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$QdSrc, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_shr_imm16>>:$imm, 1:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VQSHRNbhs32:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$QdSrc, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] }):$imm)
     /*  88712 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQSHRNbhs32),
     /*  88715 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  88717 */     GIR_RootToRootCopy, /*OpIdx*/2, // QdSrc
     /*  88719 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  88721 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  88724 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  88727 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  88733 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  88739 */     GIR_RootConstrainSelectedInstOperands,
     /*  88740 */     // GIR_Coverage, 3791,
     /*  88740 */     GIR_EraseRootFromParent_Done,
     /*  88741 */   // Label 1638: @88741
     /*  88741 */   GIM_Try, /*On fail goto*//*Label 1639*/ GIMT_Encode4(88848), // Rule ID 3793 //
     /*  88746 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  88749 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  88752 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  88755 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  88758 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  88761 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  88764 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  88767 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /*  88770 */     GIM_RootCheckType, /*Op*/9, /*Type*/GILLT_s32,
     /*  88773 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  88777 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  88781 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  88785 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  88789 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  88793 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm16),
     /*  88797 */     // MIs[1] Operand 1
     /*  88797 */     // No operand predicates
     /*  88797 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  88801 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  88805 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 0,
     /*  88809 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 0,
     /*  88813 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/9, 1,
     /*  88817 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  88819 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3712:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$QdSrc, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_shr_imm16>>:$imm, 1:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VQSHRNths32:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$QdSrc, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] }):$imm)
     /*  88819 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQSHRNths32),
     /*  88822 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  88824 */     GIR_RootToRootCopy, /*OpIdx*/2, // QdSrc
     /*  88826 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  88828 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  88831 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  88834 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  88840 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  88846 */     GIR_RootConstrainSelectedInstOperands,
     /*  88847 */     // GIR_Coverage, 3793,
     /*  88847 */     GIR_EraseRootFromParent_Done,
     /*  88848 */   // Label 1639: @88848
     /*  88848 */   GIM_Try, /*On fail goto*//*Label 1640*/ GIMT_Encode4(88955), // Rule ID 3795 //
     /*  88853 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  88856 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  88859 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  88862 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  88865 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  88868 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  88871 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  88874 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /*  88877 */     GIM_RootCheckType, /*Op*/9, /*Type*/GILLT_s32,
     /*  88880 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  88884 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  88888 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  88892 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  88896 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  88900 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm8),
     /*  88904 */     // MIs[1] Operand 1
     /*  88904 */     // No operand predicates
     /*  88904 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  88908 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  88912 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 1,
     /*  88916 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 1,
     /*  88920 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/9, 0,
     /*  88924 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  88926 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3712:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$QdSrc, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_shr_imm8>>:$imm, 1:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VQSHRNbhu16:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$QdSrc, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] }):$imm)
     /*  88926 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQSHRNbhu16),
     /*  88929 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  88931 */     GIR_RootToRootCopy, /*OpIdx*/2, // QdSrc
     /*  88933 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  88935 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  88938 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  88941 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  88947 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  88953 */     GIR_RootConstrainSelectedInstOperands,
     /*  88954 */     // GIR_Coverage, 3795,
     /*  88954 */     GIR_EraseRootFromParent_Done,
     /*  88955 */   // Label 1640: @88955
     /*  88955 */   GIM_Try, /*On fail goto*//*Label 1641*/ GIMT_Encode4(89062), // Rule ID 3797 //
     /*  88960 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  88963 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  88966 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  88969 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  88972 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  88975 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  88978 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  88981 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /*  88984 */     GIM_RootCheckType, /*Op*/9, /*Type*/GILLT_s32,
     /*  88987 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  88991 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  88995 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  88999 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  89003 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  89007 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm8),
     /*  89011 */     // MIs[1] Operand 1
     /*  89011 */     // No operand predicates
     /*  89011 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  89015 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  89019 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 1,
     /*  89023 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 1,
     /*  89027 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/9, 1,
     /*  89031 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  89033 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3712:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$QdSrc, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_shr_imm8>>:$imm, 1:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VQSHRNthu16:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$QdSrc, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] }):$imm)
     /*  89033 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQSHRNthu16),
     /*  89036 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  89038 */     GIR_RootToRootCopy, /*OpIdx*/2, // QdSrc
     /*  89040 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  89042 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  89045 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  89048 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  89054 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  89060 */     GIR_RootConstrainSelectedInstOperands,
     /*  89061 */     // GIR_Coverage, 3797,
     /*  89061 */     GIR_EraseRootFromParent_Done,
     /*  89062 */   // Label 1641: @89062
     /*  89062 */   GIM_Try, /*On fail goto*//*Label 1642*/ GIMT_Encode4(89169), // Rule ID 3799 //
     /*  89067 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  89070 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  89073 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  89076 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  89079 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  89082 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  89085 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  89088 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /*  89091 */     GIM_RootCheckType, /*Op*/9, /*Type*/GILLT_s32,
     /*  89094 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  89098 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  89102 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  89106 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  89110 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  89114 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm16),
     /*  89118 */     // MIs[1] Operand 1
     /*  89118 */     // No operand predicates
     /*  89118 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  89122 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  89126 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 1,
     /*  89130 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 1,
     /*  89134 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/9, 0,
     /*  89138 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  89140 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3712:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$QdSrc, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_shr_imm16>>:$imm, 1:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VQSHRNbhu32:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$QdSrc, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] }):$imm)
     /*  89140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQSHRNbhu32),
     /*  89143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  89145 */     GIR_RootToRootCopy, /*OpIdx*/2, // QdSrc
     /*  89147 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  89149 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  89152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  89155 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  89161 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  89167 */     GIR_RootConstrainSelectedInstOperands,
     /*  89168 */     // GIR_Coverage, 3799,
     /*  89168 */     GIR_EraseRootFromParent_Done,
     /*  89169 */   // Label 1642: @89169
     /*  89169 */   GIM_Try, /*On fail goto*//*Label 1643*/ GIMT_Encode4(89276), // Rule ID 3801 //
     /*  89174 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  89177 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  89180 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  89183 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  89186 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  89189 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  89192 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  89195 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /*  89198 */     GIM_RootCheckType, /*Op*/9, /*Type*/GILLT_s32,
     /*  89201 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  89205 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  89209 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  89213 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  89217 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  89221 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm16),
     /*  89225 */     // MIs[1] Operand 1
     /*  89225 */     // No operand predicates
     /*  89225 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  89229 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  89233 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 1,
     /*  89237 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 1,
     /*  89241 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/9, 1,
     /*  89245 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  89247 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3712:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$QdSrc, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_shr_imm16>>:$imm, 1:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VQSHRNthu32:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$QdSrc, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] }):$imm)
     /*  89247 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQSHRNthu32),
     /*  89250 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  89252 */     GIR_RootToRootCopy, /*OpIdx*/2, // QdSrc
     /*  89254 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  89256 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  89259 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  89262 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  89268 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  89274 */     GIR_RootConstrainSelectedInstOperands,
     /*  89275 */     // GIR_Coverage, 3801,
     /*  89275 */     GIR_EraseRootFromParent_Done,
     /*  89276 */   // Label 1643: @89276
     /*  89276 */   GIM_Try, /*On fail goto*//*Label 1644*/ GIMT_Encode4(89383), // Rule ID 3803 //
     /*  89281 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  89284 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  89287 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  89290 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  89293 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  89296 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  89299 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  89302 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /*  89305 */     GIM_RootCheckType, /*Op*/9, /*Type*/GILLT_s32,
     /*  89308 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  89312 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  89316 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  89320 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  89324 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  89328 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm8),
     /*  89332 */     // MIs[1] Operand 1
     /*  89332 */     // No operand predicates
     /*  89332 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  89336 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  89340 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 0,
     /*  89344 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 0,
     /*  89348 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/9, 0,
     /*  89352 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  89354 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3712:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$QdSrc, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_shr_imm8>>:$imm, 1:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VQRSHRNbhs16:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$QdSrc, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] }):$imm)
     /*  89354 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQRSHRNbhs16),
     /*  89357 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  89359 */     GIR_RootToRootCopy, /*OpIdx*/2, // QdSrc
     /*  89361 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  89363 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  89366 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  89369 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  89375 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  89381 */     GIR_RootConstrainSelectedInstOperands,
     /*  89382 */     // GIR_Coverage, 3803,
     /*  89382 */     GIR_EraseRootFromParent_Done,
     /*  89383 */   // Label 1644: @89383
     /*  89383 */   GIM_Try, /*On fail goto*//*Label 1645*/ GIMT_Encode4(89490), // Rule ID 3805 //
     /*  89388 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  89391 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  89394 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  89397 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  89400 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  89403 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  89406 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  89409 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /*  89412 */     GIM_RootCheckType, /*Op*/9, /*Type*/GILLT_s32,
     /*  89415 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  89419 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  89423 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  89427 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  89431 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  89435 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm8),
     /*  89439 */     // MIs[1] Operand 1
     /*  89439 */     // No operand predicates
     /*  89439 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  89443 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  89447 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 0,
     /*  89451 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 0,
     /*  89455 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/9, 1,
     /*  89459 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  89461 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3712:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$QdSrc, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_shr_imm8>>:$imm, 1:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VQRSHRNths16:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$QdSrc, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] }):$imm)
     /*  89461 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQRSHRNths16),
     /*  89464 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  89466 */     GIR_RootToRootCopy, /*OpIdx*/2, // QdSrc
     /*  89468 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  89470 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  89473 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  89476 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  89482 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  89488 */     GIR_RootConstrainSelectedInstOperands,
     /*  89489 */     // GIR_Coverage, 3805,
     /*  89489 */     GIR_EraseRootFromParent_Done,
     /*  89490 */   // Label 1645: @89490
     /*  89490 */   GIM_Try, /*On fail goto*//*Label 1646*/ GIMT_Encode4(89597), // Rule ID 3807 //
     /*  89495 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  89498 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  89501 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  89504 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  89507 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  89510 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  89513 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  89516 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /*  89519 */     GIM_RootCheckType, /*Op*/9, /*Type*/GILLT_s32,
     /*  89522 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  89526 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  89530 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  89534 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  89538 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  89542 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm16),
     /*  89546 */     // MIs[1] Operand 1
     /*  89546 */     // No operand predicates
     /*  89546 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  89550 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  89554 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 0,
     /*  89558 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 0,
     /*  89562 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/9, 0,
     /*  89566 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  89568 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3712:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$QdSrc, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_shr_imm16>>:$imm, 1:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VQRSHRNbhs32:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$QdSrc, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] }):$imm)
     /*  89568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQRSHRNbhs32),
     /*  89571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  89573 */     GIR_RootToRootCopy, /*OpIdx*/2, // QdSrc
     /*  89575 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  89577 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  89580 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  89583 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  89589 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  89595 */     GIR_RootConstrainSelectedInstOperands,
     /*  89596 */     // GIR_Coverage, 3807,
     /*  89596 */     GIR_EraseRootFromParent_Done,
     /*  89597 */   // Label 1646: @89597
     /*  89597 */   GIM_Try, /*On fail goto*//*Label 1647*/ GIMT_Encode4(89704), // Rule ID 3809 //
     /*  89602 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  89605 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  89608 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  89611 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  89614 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  89617 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  89620 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  89623 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /*  89626 */     GIM_RootCheckType, /*Op*/9, /*Type*/GILLT_s32,
     /*  89629 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  89633 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  89637 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  89641 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  89645 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  89649 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm16),
     /*  89653 */     // MIs[1] Operand 1
     /*  89653 */     // No operand predicates
     /*  89653 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  89657 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  89661 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 0,
     /*  89665 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 0,
     /*  89669 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/9, 1,
     /*  89673 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  89675 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3712:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$QdSrc, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_shr_imm16>>:$imm, 1:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VQRSHRNths32:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$QdSrc, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] }):$imm)
     /*  89675 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQRSHRNths32),
     /*  89678 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  89680 */     GIR_RootToRootCopy, /*OpIdx*/2, // QdSrc
     /*  89682 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  89684 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  89687 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  89690 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  89696 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  89702 */     GIR_RootConstrainSelectedInstOperands,
     /*  89703 */     // GIR_Coverage, 3809,
     /*  89703 */     GIR_EraseRootFromParent_Done,
     /*  89704 */   // Label 1647: @89704
     /*  89704 */   GIM_Try, /*On fail goto*//*Label 1648*/ GIMT_Encode4(89811), // Rule ID 3811 //
     /*  89709 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  89712 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  89715 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  89718 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  89721 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  89724 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  89727 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  89730 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /*  89733 */     GIM_RootCheckType, /*Op*/9, /*Type*/GILLT_s32,
     /*  89736 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  89740 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  89744 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  89748 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  89752 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  89756 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm8),
     /*  89760 */     // MIs[1] Operand 1
     /*  89760 */     // No operand predicates
     /*  89760 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  89764 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  89768 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 1,
     /*  89772 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 1,
     /*  89776 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/9, 0,
     /*  89780 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  89782 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3712:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$QdSrc, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_shr_imm8>>:$imm, 1:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VQRSHRNbhu16:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$QdSrc, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] }):$imm)
     /*  89782 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQRSHRNbhu16),
     /*  89785 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  89787 */     GIR_RootToRootCopy, /*OpIdx*/2, // QdSrc
     /*  89789 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  89791 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  89794 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  89797 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  89803 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  89809 */     GIR_RootConstrainSelectedInstOperands,
     /*  89810 */     // GIR_Coverage, 3811,
     /*  89810 */     GIR_EraseRootFromParent_Done,
     /*  89811 */   // Label 1648: @89811
     /*  89811 */   GIM_Try, /*On fail goto*//*Label 1649*/ GIMT_Encode4(89918), // Rule ID 3813 //
     /*  89816 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  89819 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  89822 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  89825 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  89828 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  89831 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  89834 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  89837 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /*  89840 */     GIM_RootCheckType, /*Op*/9, /*Type*/GILLT_s32,
     /*  89843 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  89847 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  89851 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  89855 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  89859 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  89863 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm8),
     /*  89867 */     // MIs[1] Operand 1
     /*  89867 */     // No operand predicates
     /*  89867 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  89871 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  89875 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 1,
     /*  89879 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 1,
     /*  89883 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/9, 1,
     /*  89887 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  89889 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3712:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$QdSrc, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_shr_imm8>>:$imm, 1:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VQRSHRNthu16:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$QdSrc, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] }):$imm)
     /*  89889 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQRSHRNthu16),
     /*  89892 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  89894 */     GIR_RootToRootCopy, /*OpIdx*/2, // QdSrc
     /*  89896 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  89898 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  89901 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  89904 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  89910 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  89916 */     GIR_RootConstrainSelectedInstOperands,
     /*  89917 */     // GIR_Coverage, 3813,
     /*  89917 */     GIR_EraseRootFromParent_Done,
     /*  89918 */   // Label 1649: @89918
     /*  89918 */   GIM_Try, /*On fail goto*//*Label 1650*/ GIMT_Encode4(90025), // Rule ID 3815 //
     /*  89923 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  89926 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  89929 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  89932 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  89935 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  89938 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  89941 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  89944 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /*  89947 */     GIM_RootCheckType, /*Op*/9, /*Type*/GILLT_s32,
     /*  89950 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  89954 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  89958 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  89962 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  89966 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  89970 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm16),
     /*  89974 */     // MIs[1] Operand 1
     /*  89974 */     // No operand predicates
     /*  89974 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  89978 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  89982 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 1,
     /*  89986 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 1,
     /*  89990 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/9, 0,
     /*  89994 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  89996 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3712:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$QdSrc, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_shr_imm16>>:$imm, 1:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VQRSHRNbhu32:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$QdSrc, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] }):$imm)
     /*  89996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQRSHRNbhu32),
     /*  89999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  90001 */     GIR_RootToRootCopy, /*OpIdx*/2, // QdSrc
     /*  90003 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  90005 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  90008 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  90011 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  90017 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  90023 */     GIR_RootConstrainSelectedInstOperands,
     /*  90024 */     // GIR_Coverage, 3815,
     /*  90024 */     GIR_EraseRootFromParent_Done,
     /*  90025 */   // Label 1650: @90025
     /*  90025 */   GIM_Try, /*On fail goto*//*Label 1651*/ GIMT_Encode4(90132), // Rule ID 3817 //
     /*  90030 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  90033 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  90036 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  90039 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  90042 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  90045 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  90048 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  90051 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /*  90054 */     GIM_RootCheckType, /*Op*/9, /*Type*/GILLT_s32,
     /*  90057 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  90061 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  90065 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  90069 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  90073 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  90077 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm16),
     /*  90081 */     // MIs[1] Operand 1
     /*  90081 */     // No operand predicates
     /*  90081 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  90085 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  90089 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 1,
     /*  90093 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 1,
     /*  90097 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/9, 1,
     /*  90101 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  90103 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3712:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$QdSrc, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_shr_imm16>>:$imm, 1:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VQRSHRNthu32:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$QdSrc, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] }):$imm)
     /*  90103 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQRSHRNthu32),
     /*  90106 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  90108 */     GIR_RootToRootCopy, /*OpIdx*/2, // QdSrc
     /*  90110 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  90112 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  90115 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  90118 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  90124 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  90130 */     GIR_RootConstrainSelectedInstOperands,
     /*  90131 */     // GIR_Coverage, 3817,
     /*  90131 */     GIR_EraseRootFromParent_Done,
     /*  90132 */   // Label 1651: @90132
     /*  90132 */   GIM_Try, /*On fail goto*//*Label 1652*/ GIMT_Encode4(90239), // Rule ID 3819 //
     /*  90137 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  90140 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  90143 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  90146 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  90149 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  90152 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  90155 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  90158 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /*  90161 */     GIM_RootCheckType, /*Op*/9, /*Type*/GILLT_s32,
     /*  90164 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  90168 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  90172 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  90176 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  90180 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  90184 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm8),
     /*  90188 */     // MIs[1] Operand 1
     /*  90188 */     // No operand predicates
     /*  90188 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  90192 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  90196 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 1,
     /*  90200 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 0,
     /*  90204 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/9, 0,
     /*  90208 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  90210 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3712:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$QdSrc, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_shr_imm8>>:$imm, 1:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VQSHRUNs16bh:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$QdSrc, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] }):$imm)
     /*  90210 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQSHRUNs16bh),
     /*  90213 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  90215 */     GIR_RootToRootCopy, /*OpIdx*/2, // QdSrc
     /*  90217 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  90219 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  90222 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  90225 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  90231 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  90237 */     GIR_RootConstrainSelectedInstOperands,
     /*  90238 */     // GIR_Coverage, 3819,
     /*  90238 */     GIR_EraseRootFromParent_Done,
     /*  90239 */   // Label 1652: @90239
     /*  90239 */   GIM_Try, /*On fail goto*//*Label 1653*/ GIMT_Encode4(90346), // Rule ID 3821 //
     /*  90244 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  90247 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  90250 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  90253 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  90256 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  90259 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  90262 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  90265 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /*  90268 */     GIM_RootCheckType, /*Op*/9, /*Type*/GILLT_s32,
     /*  90271 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  90275 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  90279 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  90283 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  90287 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  90291 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm8),
     /*  90295 */     // MIs[1] Operand 1
     /*  90295 */     // No operand predicates
     /*  90295 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  90299 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  90303 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 1,
     /*  90307 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 0,
     /*  90311 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/9, 1,
     /*  90315 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  90317 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3712:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$QdSrc, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_shr_imm8>>:$imm, 1:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VQSHRUNs16th:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$QdSrc, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] }):$imm)
     /*  90317 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQSHRUNs16th),
     /*  90320 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  90322 */     GIR_RootToRootCopy, /*OpIdx*/2, // QdSrc
     /*  90324 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  90326 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  90329 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  90332 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  90338 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  90344 */     GIR_RootConstrainSelectedInstOperands,
     /*  90345 */     // GIR_Coverage, 3821,
     /*  90345 */     GIR_EraseRootFromParent_Done,
     /*  90346 */   // Label 1653: @90346
     /*  90346 */   GIM_Try, /*On fail goto*//*Label 1654*/ GIMT_Encode4(90453), // Rule ID 3823 //
     /*  90351 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  90354 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  90357 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  90360 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  90363 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  90366 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  90369 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  90372 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /*  90375 */     GIM_RootCheckType, /*Op*/9, /*Type*/GILLT_s32,
     /*  90378 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  90382 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  90386 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  90390 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  90394 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  90398 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm16),
     /*  90402 */     // MIs[1] Operand 1
     /*  90402 */     // No operand predicates
     /*  90402 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  90406 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  90410 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 1,
     /*  90414 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 0,
     /*  90418 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/9, 0,
     /*  90422 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  90424 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3712:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$QdSrc, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_shr_imm16>>:$imm, 1:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VQSHRUNs32bh:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$QdSrc, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] }):$imm)
     /*  90424 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQSHRUNs32bh),
     /*  90427 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  90429 */     GIR_RootToRootCopy, /*OpIdx*/2, // QdSrc
     /*  90431 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  90433 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  90436 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  90439 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  90445 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  90451 */     GIR_RootConstrainSelectedInstOperands,
     /*  90452 */     // GIR_Coverage, 3823,
     /*  90452 */     GIR_EraseRootFromParent_Done,
     /*  90453 */   // Label 1654: @90453
     /*  90453 */   GIM_Try, /*On fail goto*//*Label 1655*/ GIMT_Encode4(90560), // Rule ID 3825 //
     /*  90458 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  90461 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  90464 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  90467 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  90470 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  90473 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  90476 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  90479 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /*  90482 */     GIM_RootCheckType, /*Op*/9, /*Type*/GILLT_s32,
     /*  90485 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  90489 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  90493 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  90497 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  90501 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  90505 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm16),
     /*  90509 */     // MIs[1] Operand 1
     /*  90509 */     // No operand predicates
     /*  90509 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  90513 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  90517 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 1,
     /*  90521 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 0,
     /*  90525 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/9, 1,
     /*  90529 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  90531 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3712:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$QdSrc, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_shr_imm16>>:$imm, 1:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VQSHRUNs32th:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$QdSrc, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] }):$imm)
     /*  90531 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQSHRUNs32th),
     /*  90534 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  90536 */     GIR_RootToRootCopy, /*OpIdx*/2, // QdSrc
     /*  90538 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  90540 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  90543 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  90546 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  90552 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  90558 */     GIR_RootConstrainSelectedInstOperands,
     /*  90559 */     // GIR_Coverage, 3825,
     /*  90559 */     GIR_EraseRootFromParent_Done,
     /*  90560 */   // Label 1655: @90560
     /*  90560 */   GIM_Try, /*On fail goto*//*Label 1656*/ GIMT_Encode4(90667), // Rule ID 3827 //
     /*  90565 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  90568 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  90571 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  90574 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  90577 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  90580 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  90583 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  90586 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /*  90589 */     GIM_RootCheckType, /*Op*/9, /*Type*/GILLT_s32,
     /*  90592 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  90596 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  90600 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  90604 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  90608 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  90612 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm8),
     /*  90616 */     // MIs[1] Operand 1
     /*  90616 */     // No operand predicates
     /*  90616 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  90620 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  90624 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 1,
     /*  90628 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 0,
     /*  90632 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/9, 0,
     /*  90636 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  90638 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3712:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$QdSrc, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_shr_imm8>>:$imm, 1:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VQRSHRUNs16bh:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$QdSrc, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] }):$imm)
     /*  90638 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQRSHRUNs16bh),
     /*  90641 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  90643 */     GIR_RootToRootCopy, /*OpIdx*/2, // QdSrc
     /*  90645 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  90647 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  90650 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  90653 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  90659 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  90665 */     GIR_RootConstrainSelectedInstOperands,
     /*  90666 */     // GIR_Coverage, 3827,
     /*  90666 */     GIR_EraseRootFromParent_Done,
     /*  90667 */   // Label 1656: @90667
     /*  90667 */   GIM_Try, /*On fail goto*//*Label 1657*/ GIMT_Encode4(90774), // Rule ID 3829 //
     /*  90672 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  90675 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  90678 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  90681 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  90684 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  90687 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  90690 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  90693 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /*  90696 */     GIM_RootCheckType, /*Op*/9, /*Type*/GILLT_s32,
     /*  90699 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  90703 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  90707 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  90711 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  90715 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  90719 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm8),
     /*  90723 */     // MIs[1] Operand 1
     /*  90723 */     // No operand predicates
     /*  90723 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  90727 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  90731 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 1,
     /*  90735 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 0,
     /*  90739 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/9, 1,
     /*  90743 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  90745 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3712:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$QdSrc, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_shr_imm8>>:$imm, 1:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VQRSHRUNs16th:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$QdSrc, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] }):$imm)
     /*  90745 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQRSHRUNs16th),
     /*  90748 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  90750 */     GIR_RootToRootCopy, /*OpIdx*/2, // QdSrc
     /*  90752 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  90754 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  90757 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  90760 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  90766 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  90772 */     GIR_RootConstrainSelectedInstOperands,
     /*  90773 */     // GIR_Coverage, 3829,
     /*  90773 */     GIR_EraseRootFromParent_Done,
     /*  90774 */   // Label 1657: @90774
     /*  90774 */   GIM_Try, /*On fail goto*//*Label 1658*/ GIMT_Encode4(90881), // Rule ID 3831 //
     /*  90779 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  90782 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  90785 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  90788 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  90791 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  90794 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  90797 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  90800 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /*  90803 */     GIM_RootCheckType, /*Op*/9, /*Type*/GILLT_s32,
     /*  90806 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  90810 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  90814 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  90818 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  90822 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  90826 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm16),
     /*  90830 */     // MIs[1] Operand 1
     /*  90830 */     // No operand predicates
     /*  90830 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  90834 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  90838 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 1,
     /*  90842 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 0,
     /*  90846 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/9, 0,
     /*  90850 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  90852 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3712:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$QdSrc, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_shr_imm16>>:$imm, 1:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VQRSHRUNs32bh:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$QdSrc, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] }):$imm)
     /*  90852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQRSHRUNs32bh),
     /*  90855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  90857 */     GIR_RootToRootCopy, /*OpIdx*/2, // QdSrc
     /*  90859 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  90861 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  90864 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  90867 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  90873 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  90879 */     GIR_RootConstrainSelectedInstOperands,
     /*  90880 */     // GIR_Coverage, 3831,
     /*  90880 */     GIR_EraseRootFromParent_Done,
     /*  90881 */   // Label 1658: @90881
     /*  90881 */   GIM_Try, /*On fail goto*//*Label 1659*/ GIMT_Encode4(90988), // Rule ID 3833 //
     /*  90886 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  90889 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  90892 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  90895 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  90898 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  90901 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  90904 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  90907 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /*  90910 */     GIM_RootCheckType, /*Op*/9, /*Type*/GILLT_s32,
     /*  90913 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  90917 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  90921 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  90925 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  90929 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  90933 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm16),
     /*  90937 */     // MIs[1] Operand 1
     /*  90937 */     // No operand predicates
     /*  90937 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  90941 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  90945 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 1,
     /*  90949 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 0,
     /*  90953 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/9, 1,
     /*  90957 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  90959 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3712:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$QdSrc, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_shr_imm16>>:$imm, 1:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VQRSHRUNs32th:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$QdSrc, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] }):$imm)
     /*  90959 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQRSHRUNs32th),
     /*  90962 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  90964 */     GIR_RootToRootCopy, /*OpIdx*/2, // QdSrc
     /*  90966 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  90968 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  90971 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  90974 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  90980 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  90986 */     GIR_RootConstrainSelectedInstOperands,
     /*  90987 */     // GIR_Coverage, 3833,
     /*  90987 */     GIR_EraseRootFromParent_Done,
     /*  90988 */   // Label 1659: @90988
     /*  90988 */   GIM_Reject,
     /*  90989 */ // Label 1619: @90989
     /*  90989 */ GIM_Reject,
     /*  90990 */ // Label 16: @90990
     /*  90990 */ GIM_Try, /*On fail goto*//*Label 1660*/ GIMT_Encode4(91047),
     /*  90995 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/1,
     /*  90998 */   GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_clrex),
     /*  91003 */   GIM_Try, /*On fail goto*//*Label 1661*/ GIMT_Encode4(91020), // Rule ID 245 //
     /*  91008 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6K_IsARM),
     /*  91011 */     // (intrinsic_void 3498:{ *:[iPTR] })  =>  (CLREX)
     /*  91011 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::CLREX),
     /*  91014 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  91018 */     GIR_RootConstrainSelectedInstOperands,
     /*  91019 */     // GIR_Coverage, 245,
     /*  91019 */     GIR_EraseRootFromParent_Done,
     /*  91020 */   // Label 1661: @91020
     /*  91020 */   GIM_Try, /*On fail goto*//*Label 1662*/ GIMT_Encode4(91046), // Rule ID 574 //
     /*  91025 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV7Clrex_IsThumb),
     /*  91028 */     // (intrinsic_void 3498:{ *:[iPTR] })  =>  (t2CLREX)
     /*  91028 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2CLREX),
     /*  91031 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  91034 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  91040 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  91044 */     GIR_RootConstrainSelectedInstOperands,
     /*  91045 */     // GIR_Coverage, 574,
     /*  91045 */     GIR_EraseRootFromParent_Done,
     /*  91046 */   // Label 1662: @91046
     /*  91046 */   GIM_Reject,
     /*  91047 */ // Label 1660: @91047
     /*  91047 */ GIM_Try, /*On fail goto*//*Label 1663*/ GIMT_Encode4(91849),
     /*  91052 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/2,
     /*  91055 */   GIM_Try, /*On fail goto*//*Label 1664*/ GIMT_Encode4(91091), // Rule ID 344 //
     /*  91060 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb_IsWindows),
     /*  91063 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_undefined),
     /*  91068 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  91071 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/1, GIMT_Encode8(249),
     /*  91082 */     // (intrinsic_void 3932:{ *:[iPTR] }, 249:{ *:[i32] })  =>  (t__brkdiv0)
     /*  91082 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t__brkdiv0),
     /*  91085 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  91089 */     GIR_RootConstrainSelectedInstOperands,
     /*  91090 */     // GIR_Coverage, 344,
     /*  91090 */     GIR_EraseRootFromParent_Done,
     /*  91091 */   // Label 1664: @91091
     /*  91091 */   GIM_Try, /*On fail goto*//*Label 1665*/ GIMT_Encode4(91143), // Rule ID 2 //
     /*  91096 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*  91099 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_hint),
     /*  91104 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  91107 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  91111 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  91115 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_239),
     /*  91119 */     // MIs[1] Operand 1
     /*  91119 */     // No operand predicates
     /*  91119 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  91121 */     // (intrinsic_void 3516:{ *:[iPTR] }, (imm:{ *:[i32] })<<P:Predicate_imm0_239>>:$imm)  =>  (HINT (imm:{ *:[i32] }):$imm)
     /*  91121 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::HINT),
     /*  91124 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  91127 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  91130 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  91136 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  91141 */     GIR_RootConstrainSelectedInstOperands,
     /*  91142 */     // GIR_Coverage, 2,
     /*  91142 */     GIR_EraseRootFromParent_Done,
     /*  91143 */   // Label 1665: @91143
     /*  91143 */   GIM_Try, /*On fail goto*//*Label 1666*/ GIMT_Encode4(91195), // Rule ID 10 //
     /*  91148 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV7_IsARM),
     /*  91151 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_dbg),
     /*  91156 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  91159 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  91163 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  91167 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_15),
     /*  91171 */     // MIs[1] Operand 1
     /*  91171 */     // No operand predicates
     /*  91171 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  91173 */     // (intrinsic_void 3511:{ *:[iPTR] }, (imm:{ *:[i32] })<<P:Predicate_imm0_15>>:$opt)  =>  (DBG (imm:{ *:[i32] }):$opt)
     /*  91173 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::DBG),
     /*  91176 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // opt
     /*  91179 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  91182 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  91188 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  91193 */     GIR_RootConstrainSelectedInstOperands,
     /*  91194 */     // GIR_Coverage, 10,
     /*  91194 */     GIR_EraseRootFromParent_Done,
     /*  91195 */   // Label 1666: @91195
     /*  91195 */   GIM_Try, /*On fail goto*//*Label 1667*/ GIMT_Encode4(91238), // Rule ID 11 //
     /*  91200 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  91203 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_undefined),
     /*  91208 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  91211 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  91215 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  91219 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_65535),
     /*  91223 */     // MIs[1] Operand 1
     /*  91223 */     // No operand predicates
     /*  91223 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  91225 */     // (intrinsic_void 3932:{ *:[iPTR] }, (imm:{ *:[i32] })<<P:Predicate_imm0_65535>>:$imm16)  =>  (UDF (imm:{ *:[i32] }):$imm16)
     /*  91225 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::UDF),
     /*  91228 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm16
     /*  91231 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  91236 */     GIR_RootConstrainSelectedInstOperands,
     /*  91237 */     // GIR_Coverage, 11,
     /*  91237 */     GIR_EraseRootFromParent_Done,
     /*  91238 */   // Label 1667: @91238
     /*  91238 */   GIM_Try, /*On fail goto*//*Label 1668*/ GIMT_Encode4(91281), // Rule ID 228 //
     /*  91243 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDB_IsARM),
     /*  91246 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_dmb),
     /*  91251 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  91254 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  91258 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  91262 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_15),
     /*  91266 */     // MIs[1] Operand 1
     /*  91266 */     // No operand predicates
     /*  91266 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  91268 */     // (intrinsic_void 3512:{ *:[iPTR] }, (imm:{ *:[i32] })<<P:Predicate_imm0_15>>:$opt)  =>  (DMB (imm:{ *:[i32] }):$opt)
     /*  91268 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::DMB),
     /*  91271 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // opt
     /*  91274 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  91279 */     GIR_RootConstrainSelectedInstOperands,
     /*  91280 */     // GIR_Coverage, 228,
     /*  91280 */     GIR_EraseRootFromParent_Done,
     /*  91281 */   // Label 1668: @91281
     /*  91281 */   GIM_Try, /*On fail goto*//*Label 1669*/ GIMT_Encode4(91324), // Rule ID 229 //
     /*  91286 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDB_IsARM),
     /*  91289 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_dsb),
     /*  91294 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  91297 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  91301 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  91305 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_15),
     /*  91309 */     // MIs[1] Operand 1
     /*  91309 */     // No operand predicates
     /*  91309 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  91311 */     // (intrinsic_void 3513:{ *:[iPTR] }, (imm:{ *:[i32] })<<P:Predicate_imm0_15>>:$opt)  =>  (DSB (imm:{ *:[i32] }):$opt)
     /*  91311 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::DSB),
     /*  91314 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // opt
     /*  91317 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  91322 */     GIR_RootConstrainSelectedInstOperands,
     /*  91323 */     // GIR_Coverage, 229,
     /*  91323 */     GIR_EraseRootFromParent_Done,
     /*  91324 */   // Label 1669: @91324
     /*  91324 */   GIM_Try, /*On fail goto*//*Label 1670*/ GIMT_Encode4(91367), // Rule ID 230 //
     /*  91329 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDB_IsARM),
     /*  91332 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_isb),
     /*  91337 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  91340 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  91344 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  91348 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_15),
     /*  91352 */     // MIs[1] Operand 1
     /*  91352 */     // No operand predicates
     /*  91352 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  91354 */     // (intrinsic_void 3517:{ *:[iPTR] }, (imm:{ *:[i32] })<<P:Predicate_imm0_15>>:$opt)  =>  (ISB (imm:{ *:[i32] }):$opt)
     /*  91354 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::ISB),
     /*  91357 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // opt
     /*  91360 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  91365 */     GIR_RootConstrainSelectedInstOperands,
     /*  91366 */     // GIR_Coverage, 230,
     /*  91366 */     GIR_EraseRootFromParent_Done,
     /*  91367 */   // Label 1670: @91367
     /*  91367 */   GIM_Try, /*On fail goto*//*Label 1671*/ GIMT_Encode4(91419), // Rule ID 276 //
     /*  91372 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6M_IsThumb),
     /*  91375 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_hint),
     /*  91380 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  91383 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  91387 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  91391 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_15),
     /*  91395 */     // MIs[1] Operand 1
     /*  91395 */     // No operand predicates
     /*  91395 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  91397 */     // (intrinsic_void 3516:{ *:[iPTR] }, (imm:{ *:[i32] })<<P:Predicate_imm0_15>>:$imm)  =>  (tHINT (imm:{ *:[i32] }):$imm)
     /*  91397 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::tHINT),
     /*  91400 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  91403 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  91406 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  91412 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  91417 */     GIR_RootConstrainSelectedInstOperands,
     /*  91418 */     // GIR_Coverage, 276,
     /*  91418 */     GIR_EraseRootFromParent_Done,
     /*  91419 */   // Label 1671: @91419
     /*  91419 */   GIM_Try, /*On fail goto*//*Label 1672*/ GIMT_Encode4(91462), // Rule ID 343 //
     /*  91424 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb),
     /*  91427 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_undefined),
     /*  91432 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  91435 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  91439 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  91443 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_255),
     /*  91447 */     // MIs[1] Operand 1
     /*  91447 */     // No operand predicates
     /*  91447 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  91449 */     // (intrinsic_void 3932:{ *:[iPTR] }, (imm:{ *:[i32] })<<P:Predicate_imm0_255>>:$imm8)  =>  (tUDF (imm:{ *:[i32] }):$imm8)
     /*  91449 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::tUDF),
     /*  91452 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm8
     /*  91455 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  91460 */     GIR_RootConstrainSelectedInstOperands,
     /*  91461 */     // GIR_Coverage, 343,
     /*  91461 */     GIR_EraseRootFromParent_Done,
     /*  91462 */   // Label 1672: @91462
     /*  91462 */   GIM_Try, /*On fail goto*//*Label 1673*/ GIMT_Encode4(91505), // Rule ID 494 //
     /*  91467 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /*  91470 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_undefined),
     /*  91475 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  91478 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  91482 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  91486 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_65535),
     /*  91490 */     // MIs[1] Operand 1
     /*  91490 */     // No operand predicates
     /*  91490 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  91492 */     // (intrinsic_void 3932:{ *:[iPTR] }, (imm:{ *:[i32] })<<P:Predicate_imm0_65535>>:$imm16)  =>  (t2UDF (imm:{ *:[i32] }):$imm16)
     /*  91492 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2UDF),
     /*  91495 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm16
     /*  91498 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  91503 */     GIR_RootConstrainSelectedInstOperands,
     /*  91504 */     // GIR_Coverage, 494,
     /*  91504 */     GIR_EraseRootFromParent_Done,
     /*  91505 */   // Label 1673: @91505
     /*  91505 */   GIM_Try, /*On fail goto*//*Label 1674*/ GIMT_Encode4(91557), // Rule ID 559 //
     /*  91510 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDB_IsThumb),
     /*  91513 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_dmb),
     /*  91518 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  91521 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  91525 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  91529 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_15),
     /*  91533 */     // MIs[1] Operand 1
     /*  91533 */     // No operand predicates
     /*  91533 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  91535 */     // (intrinsic_void 3512:{ *:[iPTR] }, (imm:{ *:[i32] })<<P:Predicate_imm0_15>>:$opt)  =>  (t2DMB (imm:{ *:[i32] }):$opt)
     /*  91535 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2DMB),
     /*  91538 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // opt
     /*  91541 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  91544 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  91550 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  91555 */     GIR_RootConstrainSelectedInstOperands,
     /*  91556 */     // GIR_Coverage, 559,
     /*  91556 */     GIR_EraseRootFromParent_Done,
     /*  91557 */   // Label 1674: @91557
     /*  91557 */   GIM_Try, /*On fail goto*//*Label 1675*/ GIMT_Encode4(91609), // Rule ID 560 //
     /*  91562 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDB_IsThumb),
     /*  91565 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_dsb),
     /*  91570 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  91573 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  91577 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  91581 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_15),
     /*  91585 */     // MIs[1] Operand 1
     /*  91585 */     // No operand predicates
     /*  91585 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  91587 */     // (intrinsic_void 3513:{ *:[iPTR] }, (imm:{ *:[i32] })<<P:Predicate_imm0_15>>:$opt)  =>  (t2DSB (imm:{ *:[i32] }):$opt)
     /*  91587 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2DSB),
     /*  91590 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // opt
     /*  91593 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  91596 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  91602 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  91607 */     GIR_RootConstrainSelectedInstOperands,
     /*  91608 */     // GIR_Coverage, 560,
     /*  91608 */     GIR_EraseRootFromParent_Done,
     /*  91609 */   // Label 1675: @91609
     /*  91609 */   GIM_Try, /*On fail goto*//*Label 1676*/ GIMT_Encode4(91661), // Rule ID 561 //
     /*  91614 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDB_IsThumb),
     /*  91617 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_isb),
     /*  91622 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  91625 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  91629 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  91633 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_15),
     /*  91637 */     // MIs[1] Operand 1
     /*  91637 */     // No operand predicates
     /*  91637 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  91639 */     // (intrinsic_void 3517:{ *:[iPTR] }, (imm:{ *:[i32] })<<P:Predicate_imm0_15>>:$opt)  =>  (t2ISB (imm:{ *:[i32] }):$opt)
     /*  91639 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2ISB),
     /*  91642 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // opt
     /*  91645 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  91648 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  91654 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  91659 */     GIR_RootConstrainSelectedInstOperands,
     /*  91660 */     // GIR_Coverage, 561,
     /*  91660 */     GIR_EraseRootFromParent_Done,
     /*  91661 */   // Label 1676: @91661
     /*  91661 */   GIM_Try, /*On fail goto*//*Label 1677*/ GIMT_Encode4(91713), // Rule ID 579 //
     /*  91666 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /*  91669 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_hint),
     /*  91674 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  91677 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  91681 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  91685 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_239),
     /*  91689 */     // MIs[1] Operand 1
     /*  91689 */     // No operand predicates
     /*  91689 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  91691 */     // (intrinsic_void 3516:{ *:[iPTR] }, (imm:{ *:[i32] })<<P:Predicate_imm0_239>>:$imm)  =>  (t2HINT (imm:{ *:[i32] }):$imm)
     /*  91691 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2HINT),
     /*  91694 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  91697 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  91700 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  91706 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  91711 */     GIR_RootConstrainSelectedInstOperands,
     /*  91712 */     // GIR_Coverage, 579,
     /*  91712 */     GIR_EraseRootFromParent_Done,
     /*  91713 */   // Label 1677: @91713
     /*  91713 */   GIM_Try, /*On fail goto*//*Label 1678*/ GIMT_Encode4(91765), // Rule ID 580 //
     /*  91718 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /*  91721 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_dbg),
     /*  91726 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  91729 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  91733 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  91737 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_15),
     /*  91741 */     // MIs[1] Operand 1
     /*  91741 */     // No operand predicates
     /*  91741 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  91743 */     // (intrinsic_void 3511:{ *:[iPTR] }, (imm:{ *:[i32] })<<P:Predicate_imm0_15>>:$opt)  =>  (t2DBG (imm:{ *:[i32] }):$opt)
     /*  91743 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2DBG),
     /*  91746 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // opt
     /*  91749 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  91752 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  91758 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  91763 */     GIR_RootConstrainSelectedInstOperands,
     /*  91764 */     // GIR_Coverage, 580,
     /*  91764 */     GIR_EraseRootFromParent_Done,
     /*  91765 */   // Label 1678: @91765
     /*  91765 */   GIM_Try, /*On fail goto*//*Label 1679*/ GIMT_Encode4(91805), // Rule ID 722 //
     /*  91770 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPRegs),
     /*  91773 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_get_fpscr),
     /*  91778 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  91781 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  91785 */     // (intrinsic_w_chain:{ *:[i32] } 3514:{ *:[iPTR] })  =>  (VMRS:{ *:[i32] })
     /*  91785 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMRS),
     /*  91788 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  91790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  91793 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  91799 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  91803 */     GIR_RootConstrainSelectedInstOperands,
     /*  91804 */     // GIR_Coverage, 722,
     /*  91804 */     GIR_EraseRootFromParent_Done,
     /*  91805 */   // Label 1679: @91805
     /*  91805 */   GIM_Try, /*On fail goto*//*Label 1680*/ GIMT_Encode4(91848), // Rule ID 723 //
     /*  91810 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPRegs),
     /*  91813 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_set_fpscr),
     /*  91818 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  91821 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  91825 */     // (intrinsic_void 3876:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rt)  =>  (VMSR:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rt)
     /*  91825 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMSR),
     /*  91828 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rt
     /*  91830 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  91833 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  91839 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for ARM::FPSCR*/0,
     /*  91842 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  91846 */     GIR_RootConstrainSelectedInstOperands,
     /*  91847 */     // GIR_Coverage, 723,
     /*  91847 */     GIR_EraseRootFromParent_Done,
     /*  91848 */   // Label 1680: @91848
     /*  91848 */   GIM_Reject,
     /*  91849 */ // Label 1663: @91849
     /*  91849 */ GIM_Try, /*On fail goto*//*Label 1681*/ GIMT_Encode4(91892), // Rule ID 604 //
     /*  91854 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLOB_HasV8_1MMainline_IsThumb2),
     /*  91857 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/3,
     /*  91860 */   GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::start_loop_iterations),
     /*  91865 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  91868 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  91871 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRlrRegClassID),
     /*  91875 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  91879 */   // (intrinsic_w_chain:{ *:[i32] } 348:{ *:[iPTR] }, rGPR:{ *:[i32] }:$tc)  =>  (t2DoLoopStart:{ *:[i32] } rGPR:{ *:[i32] }:$tc)
     /*  91879 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2DoLoopStart),
     /*  91882 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[X]
     /*  91884 */   GIR_RootToRootCopy, /*OpIdx*/2, // tc
     /*  91886 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  91890 */   GIR_RootConstrainSelectedInstOperands,
     /*  91891 */   // GIR_Coverage, 604,
     /*  91891 */   GIR_EraseRootFromParent_Done,
     /*  91892 */ // Label 1681: @91892
     /*  91892 */ GIM_Try, /*On fail goto*//*Label 1682*/ GIMT_Encode4(93883),
     /*  91897 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/4,
     /*  91900 */   GIM_Try, /*On fail goto*//*Label 1683*/ GIMT_Encode4(91954), // Rule ID 5048 //
     /*  91905 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vldr_gather_base),
     /*  91910 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  91913 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  91916 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  91919 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  91923 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  91927 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  91931 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  91935 */     // MIs[1] Operand 1
     /*  91935 */     // No operand predicates
     /*  91935 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  91937 */     // (intrinsic_w_chain:{ *:[v4i32] } 3647:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$addr, (imm:{ *:[i32] }):$offset)  =>  (MVE_VLDRWU32_qi:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$addr, (imm:{ *:[i32] }):$offset)
     /*  91937 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VLDRWU32_qi),
     /*  91940 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  91942 */     GIR_RootToRootCopy, /*OpIdx*/2, // addr
     /*  91944 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // offset
     /*  91947 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  91952 */     GIR_RootConstrainSelectedInstOperands,
     /*  91953 */     // GIR_Coverage, 5048,
     /*  91953 */     GIR_EraseRootFromParent_Done,
     /*  91954 */   // Label 1683: @91954
     /*  91954 */   GIM_Try, /*On fail goto*//*Label 1684*/ GIMT_Encode4(92008), // Rule ID 5054 //
     /*  91959 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vldr_gather_base),
     /*  91964 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  91967 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  91970 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  91973 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  91977 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  91981 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  91985 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  91989 */     // MIs[1] Operand 1
     /*  91989 */     // No operand predicates
     /*  91989 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  91991 */     // (intrinsic_w_chain:{ *:[v4f32] } 3647:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$addr, (imm:{ *:[i32] }):$offset)  =>  (MVE_VLDRWU32_qi:{ *:[v4f32] } MQPR:{ *:[v4i32] }:$addr, (imm:{ *:[i32] }):$offset)
     /*  91991 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VLDRWU32_qi),
     /*  91994 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  91996 */     GIR_RootToRootCopy, /*OpIdx*/2, // addr
     /*  91998 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // offset
     /*  92001 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  92006 */     GIR_RootConstrainSelectedInstOperands,
     /*  92007 */     // GIR_Coverage, 5054,
     /*  92007 */     GIR_EraseRootFromParent_Done,
     /*  92008 */   // Label 1684: @92008
     /*  92008 */   GIM_Try, /*On fail goto*//*Label 1685*/ GIMT_Encode4(92062), // Rule ID 5056 //
     /*  92013 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vldr_gather_base),
     /*  92018 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  92021 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  92024 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  92027 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  92031 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  92035 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  92039 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  92043 */     // MIs[1] Operand 1
     /*  92043 */     // No operand predicates
     /*  92043 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  92045 */     // (intrinsic_w_chain:{ *:[v2i64] } 3647:{ *:[iPTR] }, MQPR:{ *:[v2i64] }:$addr, (imm:{ *:[i32] }):$offset)  =>  (MVE_VLDRDU64_qi:{ *:[v2i64] } MQPR:{ *:[v2i64] }:$addr, (imm:{ *:[i32] }):$offset)
     /*  92045 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VLDRDU64_qi),
     /*  92048 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  92050 */     GIR_RootToRootCopy, /*OpIdx*/2, // addr
     /*  92052 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // offset
     /*  92055 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  92060 */     GIR_RootConstrainSelectedInstOperands,
     /*  92061 */     // GIR_Coverage, 5056,
     /*  92061 */     GIR_EraseRootFromParent_Done,
     /*  92062 */   // Label 1685: @92062
     /*  92062 */   GIM_Try, /*On fail goto*//*Label 1686*/ GIMT_Encode4(92116), // Rule ID 5058 //
     /*  92067 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vldr_gather_base),
     /*  92072 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  92075 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  92078 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  92081 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  92085 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  92089 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  92093 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  92097 */     // MIs[1] Operand 1
     /*  92097 */     // No operand predicates
     /*  92097 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  92099 */     // (intrinsic_w_chain:{ *:[v2f64] } 3647:{ *:[iPTR] }, MQPR:{ *:[v2i64] }:$addr, (imm:{ *:[i32] }):$offset)  =>  (MVE_VLDRDU64_qi:{ *:[v2f64] } MQPR:{ *:[v2i64] }:$addr, (imm:{ *:[i32] }):$offset)
     /*  92099 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VLDRDU64_qi),
     /*  92102 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  92104 */     GIR_RootToRootCopy, /*OpIdx*/2, // addr
     /*  92106 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // offset
     /*  92109 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  92114 */     GIR_RootConstrainSelectedInstOperands,
     /*  92115 */     // GIR_Coverage, 5058,
     /*  92115 */     GIR_EraseRootFromParent_Done,
     /*  92116 */   // Label 1686: @92116
     /*  92116 */   GIM_Try, /*On fail goto*//*Label 1687*/ GIMT_Encode4(92158), // Rule ID 1738 //
     /*  92121 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_space),
     /*  92126 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  92129 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  92132 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  92136 */     // MIs[0] size
     /*  92136 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  92139 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  92143 */     // (intrinsic_w_chain:{ *:[i32] } 3907:{ *:[iPTR] }, (timm:{ *:[i32] }):$size, GPR:{ *:[i32] }:$Rn)  =>  (SPACE:{ *:[i32] } (timm:{ *:[i32] }):$size, GPR:{ *:[i32] }:$Rn)
     /*  92143 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SPACE),
     /*  92146 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  92148 */     GIR_RootToRootCopy, /*OpIdx*/2, // size
     /*  92150 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /*  92152 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  92156 */     GIR_RootConstrainSelectedInstOperands,
     /*  92157 */     // GIR_Coverage, 1738,
     /*  92157 */     GIR_EraseRootFromParent_Done,
     /*  92158 */   // Label 1687: @92158
     /*  92158 */   GIM_Try, /*On fail goto*//*Label 1688*/ GIMT_Encode4(92212), // Rule ID 5050 //
     /*  92163 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_mve_vstr_scatter_base),
     /*  92168 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  92171 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  92174 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  92177 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  92181 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  92185 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  92189 */     // MIs[1] Operand 1
     /*  92189 */     // No operand predicates
     /*  92189 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  92193 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  92195 */     // (intrinsic_void 3720:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$addr, (imm:{ *:[i32] }):$offset, MQPR:{ *:[v4i32] }:$data)  =>  (MVE_VSTRW32_qi MQPR:{ *:[v4i32] }:$data, MQPR:{ *:[v4i32] }:$addr, (imm:{ *:[i32] }):$offset)
     /*  92195 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSTRW32_qi),
     /*  92198 */     GIR_RootToRootCopy, /*OpIdx*/3, // data
     /*  92200 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  92202 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // offset
     /*  92205 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  92210 */     GIR_RootConstrainSelectedInstOperands,
     /*  92211 */     // GIR_Coverage, 5050,
     /*  92211 */     GIR_EraseRootFromParent_Done,
     /*  92212 */   // Label 1688: @92212
     /*  92212 */   GIM_Try, /*On fail goto*//*Label 1689*/ GIMT_Encode4(92266), // Rule ID 5060 //
     /*  92217 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_mve_vstr_scatter_base),
     /*  92222 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  92225 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  92228 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  92231 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  92235 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  92239 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  92243 */     // MIs[1] Operand 1
     /*  92243 */     // No operand predicates
     /*  92243 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  92247 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  92249 */     // (intrinsic_void 3720:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$addr, (imm:{ *:[i32] }):$offset, MQPR:{ *:[v4f32] }:$data)  =>  (MVE_VSTRW32_qi MQPR:{ *:[v4f32] }:$data, MQPR:{ *:[v4i32] }:$addr, (imm:{ *:[i32] }):$offset)
     /*  92249 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSTRW32_qi),
     /*  92252 */     GIR_RootToRootCopy, /*OpIdx*/3, // data
     /*  92254 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  92256 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // offset
     /*  92259 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  92264 */     GIR_RootConstrainSelectedInstOperands,
     /*  92265 */     // GIR_Coverage, 5060,
     /*  92265 */     GIR_EraseRootFromParent_Done,
     /*  92266 */   // Label 1689: @92266
     /*  92266 */   GIM_Try, /*On fail goto*//*Label 1690*/ GIMT_Encode4(92320), // Rule ID 5064 //
     /*  92271 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_mve_vstr_scatter_base),
     /*  92276 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  92279 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  92282 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  92285 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  92289 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  92293 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  92297 */     // MIs[1] Operand 1
     /*  92297 */     // No operand predicates
     /*  92297 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  92301 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  92303 */     // (intrinsic_void 3720:{ *:[iPTR] }, MQPR:{ *:[v2i64] }:$addr, (imm:{ *:[i32] }):$offset, MQPR:{ *:[v2i64] }:$data)  =>  (MVE_VSTRD64_qi MQPR:{ *:[v2i64] }:$data, MQPR:{ *:[v2i64] }:$addr, (imm:{ *:[i32] }):$offset)
     /*  92303 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSTRD64_qi),
     /*  92306 */     GIR_RootToRootCopy, /*OpIdx*/3, // data
     /*  92308 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  92310 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // offset
     /*  92313 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  92318 */     GIR_RootConstrainSelectedInstOperands,
     /*  92319 */     // GIR_Coverage, 5064,
     /*  92319 */     GIR_EraseRootFromParent_Done,
     /*  92320 */   // Label 1690: @92320
     /*  92320 */   GIM_Try, /*On fail goto*//*Label 1691*/ GIMT_Encode4(92374), // Rule ID 5068 //
     /*  92325 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_mve_vstr_scatter_base),
     /*  92330 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  92333 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  92336 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  92339 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  92343 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  92347 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  92351 */     // MIs[1] Operand 1
     /*  92351 */     // No operand predicates
     /*  92351 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  92355 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  92357 */     // (intrinsic_void 3720:{ *:[iPTR] }, MQPR:{ *:[v2i64] }:$addr, (imm:{ *:[i32] }):$offset, MQPR:{ *:[v2f64] }:$data)  =>  (MVE_VSTRD64_qi MQPR:{ *:[v2f64] }:$data, MQPR:{ *:[v2i64] }:$addr, (imm:{ *:[i32] }):$offset)
     /*  92357 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSTRD64_qi),
     /*  92360 */     GIR_RootToRootCopy, /*OpIdx*/3, // data
     /*  92362 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  92364 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // offset
     /*  92367 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  92372 */     GIR_RootConstrainSelectedInstOperands,
     /*  92373 */     // GIR_Coverage, 5068,
     /*  92373 */     GIR_EraseRootFromParent_Done,
     /*  92374 */   // Label 1691: @92374
     /*  92374 */   GIM_Try, /*On fail goto*//*Label 1692*/ GIMT_Encode4(92432), // Rule ID 3 //
     /*  92379 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*  92382 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_sel),
     /*  92387 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  92390 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  92393 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  92396 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  92400 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  92404 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  92408 */     // (intrinsic_w_chain:{ *:[i32] } 3875:{ *:[iPTR] }, GPR:{ *:[i32] }:$Rn, GPR:{ *:[i32] }:$Rm)  =>  (SEL:{ *:[i32] } GPR:{ *:[i32] }:$Rn, GPR:{ *:[i32] }:$Rm)
     /*  92408 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SEL),
     /*  92411 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  92413 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  92415 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  92417 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  92420 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  92426 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  92430 */     GIR_RootConstrainSelectedInstOperands,
     /*  92431 */     // GIR_Coverage, 3,
     /*  92431 */     GIR_EraseRootFromParent_Done,
     /*  92432 */   // Label 1692: @92432
     /*  92432 */   GIM_Try, /*On fail goto*//*Label 1693*/ GIMT_Encode4(92490), // Rule ID 121 //
     /*  92437 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  92440 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_sasx),
     /*  92445 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  92448 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  92451 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  92454 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  92458 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  92462 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  92466 */     // (intrinsic_w_chain:{ *:[i32] } 3874:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (SASX:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  92466 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SASX),
     /*  92469 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  92471 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  92473 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  92475 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  92478 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  92484 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  92488 */     GIR_RootConstrainSelectedInstOperands,
     /*  92489 */     // GIR_Coverage, 121,
     /*  92489 */     GIR_EraseRootFromParent_Done,
     /*  92490 */   // Label 1693: @92490
     /*  92490 */   GIM_Try, /*On fail goto*//*Label 1694*/ GIMT_Encode4(92548), // Rule ID 122 //
     /*  92495 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  92498 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_sadd16),
     /*  92503 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  92506 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  92509 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  92512 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  92516 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  92520 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  92524 */     // (intrinsic_w_chain:{ *:[i32] } 3872:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (SADD16:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  92524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SADD16),
     /*  92527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  92529 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  92531 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  92533 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  92536 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  92542 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  92546 */     GIR_RootConstrainSelectedInstOperands,
     /*  92547 */     // GIR_Coverage, 122,
     /*  92547 */     GIR_EraseRootFromParent_Done,
     /*  92548 */   // Label 1694: @92548
     /*  92548 */   GIM_Try, /*On fail goto*//*Label 1695*/ GIMT_Encode4(92606), // Rule ID 123 //
     /*  92553 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  92556 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_sadd8),
     /*  92561 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  92564 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  92567 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  92570 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  92574 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  92578 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  92582 */     // (intrinsic_w_chain:{ *:[i32] } 3873:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (SADD8:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  92582 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SADD8),
     /*  92585 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  92587 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  92589 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  92591 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  92594 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  92600 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  92604 */     GIR_RootConstrainSelectedInstOperands,
     /*  92605 */     // GIR_Coverage, 123,
     /*  92605 */     GIR_EraseRootFromParent_Done,
     /*  92606 */   // Label 1695: @92606
     /*  92606 */   GIM_Try, /*On fail goto*//*Label 1696*/ GIMT_Encode4(92664), // Rule ID 124 //
     /*  92611 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  92614 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_ssax),
     /*  92619 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  92622 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  92625 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  92628 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  92632 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  92636 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  92640 */     // (intrinsic_w_chain:{ *:[i32] } 3910:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (SSAX:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  92640 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SSAX),
     /*  92643 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  92645 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  92647 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  92649 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  92652 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  92658 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  92662 */     GIR_RootConstrainSelectedInstOperands,
     /*  92663 */     // GIR_Coverage, 124,
     /*  92663 */     GIR_EraseRootFromParent_Done,
     /*  92664 */   // Label 1696: @92664
     /*  92664 */   GIM_Try, /*On fail goto*//*Label 1697*/ GIMT_Encode4(92722), // Rule ID 125 //
     /*  92669 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  92672 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_ssub16),
     /*  92677 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  92680 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  92683 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  92686 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  92690 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  92694 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  92698 */     // (intrinsic_w_chain:{ *:[i32] } 3911:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (SSUB16:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  92698 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SSUB16),
     /*  92701 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  92703 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  92705 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  92707 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  92710 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  92716 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  92720 */     GIR_RootConstrainSelectedInstOperands,
     /*  92721 */     // GIR_Coverage, 125,
     /*  92721 */     GIR_EraseRootFromParent_Done,
     /*  92722 */   // Label 1697: @92722
     /*  92722 */   GIM_Try, /*On fail goto*//*Label 1698*/ GIMT_Encode4(92780), // Rule ID 126 //
     /*  92727 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  92730 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_ssub8),
     /*  92735 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  92738 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  92741 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  92744 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  92748 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  92752 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  92756 */     // (intrinsic_w_chain:{ *:[i32] } 3912:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (SSUB8:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  92756 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SSUB8),
     /*  92759 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  92761 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  92763 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  92765 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  92768 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  92774 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  92778 */     GIR_RootConstrainSelectedInstOperands,
     /*  92779 */     // GIR_Coverage, 126,
     /*  92779 */     GIR_EraseRootFromParent_Done,
     /*  92780 */   // Label 1698: @92780
     /*  92780 */   GIM_Try, /*On fail goto*//*Label 1699*/ GIMT_Encode4(92838), // Rule ID 127 //
     /*  92785 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  92788 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_uasx),
     /*  92793 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  92796 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  92799 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  92802 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  92806 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  92810 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  92814 */     // (intrinsic_w_chain:{ *:[i32] } 3925:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (UASX:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  92814 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::UASX),
     /*  92817 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  92819 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  92821 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  92823 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  92826 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  92832 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  92836 */     GIR_RootConstrainSelectedInstOperands,
     /*  92837 */     // GIR_Coverage, 127,
     /*  92837 */     GIR_EraseRootFromParent_Done,
     /*  92838 */   // Label 1699: @92838
     /*  92838 */   GIM_Try, /*On fail goto*//*Label 1700*/ GIMT_Encode4(92896), // Rule ID 128 //
     /*  92843 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  92846 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_uadd16),
     /*  92851 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  92854 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  92857 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  92860 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  92864 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  92868 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  92872 */     // (intrinsic_w_chain:{ *:[i32] } 3923:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (UADD16:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  92872 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::UADD16),
     /*  92875 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  92877 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  92879 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  92881 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  92884 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  92890 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  92894 */     GIR_RootConstrainSelectedInstOperands,
     /*  92895 */     // GIR_Coverage, 128,
     /*  92895 */     GIR_EraseRootFromParent_Done,
     /*  92896 */   // Label 1700: @92896
     /*  92896 */   GIM_Try, /*On fail goto*//*Label 1701*/ GIMT_Encode4(92954), // Rule ID 129 //
     /*  92901 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  92904 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_uadd8),
     /*  92909 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  92912 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  92915 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  92918 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  92922 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  92926 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  92930 */     // (intrinsic_w_chain:{ *:[i32] } 3924:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (UADD8:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  92930 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::UADD8),
     /*  92933 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  92935 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  92937 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  92939 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  92942 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  92948 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  92952 */     GIR_RootConstrainSelectedInstOperands,
     /*  92953 */     // GIR_Coverage, 129,
     /*  92953 */     GIR_EraseRootFromParent_Done,
     /*  92954 */   // Label 1701: @92954
     /*  92954 */   GIM_Try, /*On fail goto*//*Label 1702*/ GIMT_Encode4(93012), // Rule ID 130 //
     /*  92959 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  92962 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_usax),
     /*  92967 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  92970 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  92973 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  92976 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  92980 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  92984 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  92988 */     // (intrinsic_w_chain:{ *:[i32] } 3943:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (USAX:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  92988 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::USAX),
     /*  92991 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  92993 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  92995 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  92997 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  93000 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  93006 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  93010 */     GIR_RootConstrainSelectedInstOperands,
     /*  93011 */     // GIR_Coverage, 130,
     /*  93011 */     GIR_EraseRootFromParent_Done,
     /*  93012 */   // Label 1702: @93012
     /*  93012 */   GIM_Try, /*On fail goto*//*Label 1703*/ GIMT_Encode4(93070), // Rule ID 131 //
     /*  93017 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  93020 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_usub16),
     /*  93025 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  93028 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  93031 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  93034 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  93038 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  93042 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  93046 */     // (intrinsic_w_chain:{ *:[i32] } 3944:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (USUB16:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  93046 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::USUB16),
     /*  93049 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  93051 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  93053 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  93055 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  93058 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  93064 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  93068 */     GIR_RootConstrainSelectedInstOperands,
     /*  93069 */     // GIR_Coverage, 131,
     /*  93069 */     GIR_EraseRootFromParent_Done,
     /*  93070 */   // Label 1703: @93070
     /*  93070 */   GIM_Try, /*On fail goto*//*Label 1704*/ GIMT_Encode4(93128), // Rule ID 132 //
     /*  93075 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  93078 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_usub8),
     /*  93083 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  93086 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  93089 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  93092 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  93096 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  93100 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  93104 */     // (intrinsic_w_chain:{ *:[i32] } 3945:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (USUB8:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  93104 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::USUB8),
     /*  93107 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  93109 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  93111 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  93113 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  93116 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  93122 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  93126 */     GIR_RootConstrainSelectedInstOperands,
     /*  93127 */     // GIR_Coverage, 132,
     /*  93127 */     GIR_EraseRootFromParent_Done,
     /*  93128 */   // Label 1704: @93128
     /*  93128 */   GIM_Try, /*On fail goto*//*Label 1705*/ GIMT_Encode4(93186), // Rule ID 431 //
     /*  93133 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  93136 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_sel),
     /*  93141 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  93144 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  93147 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  93150 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  93154 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  93158 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  93162 */     // (intrinsic_w_chain:{ *:[i32] } 3875:{ *:[iPTR] }, GPR:{ *:[i32] }:$Rn, GPR:{ *:[i32] }:$Rm)  =>  (t2SEL:{ *:[i32] } GPR:{ *:[i32] }:$Rn, GPR:{ *:[i32] }:$Rm)
     /*  93162 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SEL),
     /*  93165 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  93167 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  93169 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  93171 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  93174 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  93180 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  93184 */     GIR_RootConstrainSelectedInstOperands,
     /*  93185 */     // GIR_Coverage, 431,
     /*  93185 */     GIR_EraseRootFromParent_Done,
     /*  93186 */   // Label 1705: @93186
     /*  93186 */   GIM_Try, /*On fail goto*//*Label 1706*/ GIMT_Encode4(93244), // Rule ID 444 //
     /*  93191 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  93194 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_sasx),
     /*  93199 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  93202 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  93205 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  93208 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  93212 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  93216 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  93220 */     // (intrinsic_w_chain:{ *:[i32] } 3874:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2SASX:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  93220 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SASX),
     /*  93223 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  93225 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  93227 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  93229 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  93232 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  93238 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  93242 */     GIR_RootConstrainSelectedInstOperands,
     /*  93243 */     // GIR_Coverage, 444,
     /*  93243 */     GIR_EraseRootFromParent_Done,
     /*  93244 */   // Label 1706: @93244
     /*  93244 */   GIM_Try, /*On fail goto*//*Label 1707*/ GIMT_Encode4(93302), // Rule ID 445 //
     /*  93249 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  93252 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_sadd16),
     /*  93257 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  93260 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  93263 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  93266 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  93270 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  93274 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  93278 */     // (intrinsic_w_chain:{ *:[i32] } 3872:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2SADD16:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  93278 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SADD16),
     /*  93281 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  93283 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  93285 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  93287 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  93290 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  93296 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  93300 */     GIR_RootConstrainSelectedInstOperands,
     /*  93301 */     // GIR_Coverage, 445,
     /*  93301 */     GIR_EraseRootFromParent_Done,
     /*  93302 */   // Label 1707: @93302
     /*  93302 */   GIM_Try, /*On fail goto*//*Label 1708*/ GIMT_Encode4(93360), // Rule ID 446 //
     /*  93307 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  93310 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_sadd8),
     /*  93315 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  93318 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  93321 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  93324 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  93328 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  93332 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  93336 */     // (intrinsic_w_chain:{ *:[i32] } 3873:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2SADD8:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  93336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SADD8),
     /*  93339 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  93341 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  93343 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  93345 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  93348 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  93354 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  93358 */     GIR_RootConstrainSelectedInstOperands,
     /*  93359 */     // GIR_Coverage, 446,
     /*  93359 */     GIR_EraseRootFromParent_Done,
     /*  93360 */   // Label 1708: @93360
     /*  93360 */   GIM_Try, /*On fail goto*//*Label 1709*/ GIMT_Encode4(93418), // Rule ID 447 //
     /*  93365 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  93368 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_ssax),
     /*  93373 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  93376 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  93379 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  93382 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  93386 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  93390 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  93394 */     // (intrinsic_w_chain:{ *:[i32] } 3910:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2SSAX:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  93394 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SSAX),
     /*  93397 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  93399 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  93401 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  93403 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  93406 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  93412 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  93416 */     GIR_RootConstrainSelectedInstOperands,
     /*  93417 */     // GIR_Coverage, 447,
     /*  93417 */     GIR_EraseRootFromParent_Done,
     /*  93418 */   // Label 1709: @93418
     /*  93418 */   GIM_Try, /*On fail goto*//*Label 1710*/ GIMT_Encode4(93476), // Rule ID 448 //
     /*  93423 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  93426 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_ssub16),
     /*  93431 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  93434 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  93437 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  93440 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  93444 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  93448 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  93452 */     // (intrinsic_w_chain:{ *:[i32] } 3911:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2SSUB16:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  93452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SSUB16),
     /*  93455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  93457 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  93459 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  93461 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  93464 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  93470 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  93474 */     GIR_RootConstrainSelectedInstOperands,
     /*  93475 */     // GIR_Coverage, 448,
     /*  93475 */     GIR_EraseRootFromParent_Done,
     /*  93476 */   // Label 1710: @93476
     /*  93476 */   GIM_Try, /*On fail goto*//*Label 1711*/ GIMT_Encode4(93534), // Rule ID 449 //
     /*  93481 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  93484 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_ssub8),
     /*  93489 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  93492 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  93495 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  93498 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  93502 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  93506 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  93510 */     // (intrinsic_w_chain:{ *:[i32] } 3912:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2SSUB8:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  93510 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SSUB8),
     /*  93513 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  93515 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  93517 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  93519 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  93522 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  93528 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  93532 */     GIR_RootConstrainSelectedInstOperands,
     /*  93533 */     // GIR_Coverage, 449,
     /*  93533 */     GIR_EraseRootFromParent_Done,
     /*  93534 */   // Label 1711: @93534
     /*  93534 */   GIM_Try, /*On fail goto*//*Label 1712*/ GIMT_Encode4(93592), // Rule ID 450 //
     /*  93539 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  93542 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_uasx),
     /*  93547 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  93550 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  93553 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  93556 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  93560 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  93564 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  93568 */     // (intrinsic_w_chain:{ *:[i32] } 3925:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2UASX:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  93568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2UASX),
     /*  93571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  93573 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  93575 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  93577 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  93580 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  93586 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  93590 */     GIR_RootConstrainSelectedInstOperands,
     /*  93591 */     // GIR_Coverage, 450,
     /*  93591 */     GIR_EraseRootFromParent_Done,
     /*  93592 */   // Label 1712: @93592
     /*  93592 */   GIM_Try, /*On fail goto*//*Label 1713*/ GIMT_Encode4(93650), // Rule ID 451 //
     /*  93597 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  93600 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_uadd16),
     /*  93605 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  93608 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  93611 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  93614 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  93618 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  93622 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  93626 */     // (intrinsic_w_chain:{ *:[i32] } 3923:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2UADD16:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  93626 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2UADD16),
     /*  93629 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  93631 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  93633 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  93635 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  93638 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  93644 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  93648 */     GIR_RootConstrainSelectedInstOperands,
     /*  93649 */     // GIR_Coverage, 451,
     /*  93649 */     GIR_EraseRootFromParent_Done,
     /*  93650 */   // Label 1713: @93650
     /*  93650 */   GIM_Try, /*On fail goto*//*Label 1714*/ GIMT_Encode4(93708), // Rule ID 452 //
     /*  93655 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  93658 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_uadd8),
     /*  93663 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  93666 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  93669 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  93672 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  93676 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  93680 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  93684 */     // (intrinsic_w_chain:{ *:[i32] } 3924:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2UADD8:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  93684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2UADD8),
     /*  93687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  93689 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  93691 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  93693 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  93696 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  93702 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  93706 */     GIR_RootConstrainSelectedInstOperands,
     /*  93707 */     // GIR_Coverage, 452,
     /*  93707 */     GIR_EraseRootFromParent_Done,
     /*  93708 */   // Label 1714: @93708
     /*  93708 */   GIM_Try, /*On fail goto*//*Label 1715*/ GIMT_Encode4(93766), // Rule ID 453 //
     /*  93713 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  93716 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_usax),
     /*  93721 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  93724 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  93727 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  93730 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  93734 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  93738 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  93742 */     // (intrinsic_w_chain:{ *:[i32] } 3943:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2USAX:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  93742 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2USAX),
     /*  93745 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  93747 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  93749 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  93751 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  93754 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  93760 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  93764 */     GIR_RootConstrainSelectedInstOperands,
     /*  93765 */     // GIR_Coverage, 453,
     /*  93765 */     GIR_EraseRootFromParent_Done,
     /*  93766 */   // Label 1715: @93766
     /*  93766 */   GIM_Try, /*On fail goto*//*Label 1716*/ GIMT_Encode4(93824), // Rule ID 454 //
     /*  93771 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  93774 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_usub16),
     /*  93779 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  93782 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  93785 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  93788 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  93792 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  93796 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  93800 */     // (intrinsic_w_chain:{ *:[i32] } 3944:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2USUB16:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  93800 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2USUB16),
     /*  93803 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  93805 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  93807 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  93809 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  93812 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  93818 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  93822 */     GIR_RootConstrainSelectedInstOperands,
     /*  93823 */     // GIR_Coverage, 454,
     /*  93823 */     GIR_EraseRootFromParent_Done,
     /*  93824 */   // Label 1716: @93824
     /*  93824 */   GIM_Try, /*On fail goto*//*Label 1717*/ GIMT_Encode4(93882), // Rule ID 455 //
     /*  93829 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  93832 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_usub8),
     /*  93837 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  93840 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  93843 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  93846 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  93850 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  93854 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  93858 */     // (intrinsic_w_chain:{ *:[i32] } 3945:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2USUB8:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  93858 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2USUB8),
     /*  93861 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  93863 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  93865 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  93867 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  93870 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  93876 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  93880 */     GIR_RootConstrainSelectedInstOperands,
     /*  93881 */     // GIR_Coverage, 455,
     /*  93881 */     GIR_EraseRootFromParent_Done,
     /*  93882 */   // Label 1717: @93882
     /*  93882 */   GIM_Reject,
     /*  93883 */ // Label 1682: @93883
     /*  93883 */ GIM_Try, /*On fail goto*//*Label 1718*/ GIMT_Encode4(94129),
     /*  93888 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/5,
     /*  93891 */   GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vstr_scatter_base_wb),
     /*  93896 */   GIM_Try, /*On fail goto*//*Label 1719*/ GIMT_Encode4(93954), // Rule ID 5052 //
     /*  93901 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  93904 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  93907 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  93910 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /*  93913 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  93917 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  93921 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  93925 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  93929 */     // MIs[1] Operand 1
     /*  93929 */     // No operand predicates
     /*  93929 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  93933 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  93935 */     // (intrinsic_w_chain:{ *:[v4i32] } 3722:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$addr, (imm:{ *:[i32] }):$offset, MQPR:{ *:[v4i32] }:$data)  =>  (MVE_VSTRW32_qi_pre:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$data, MQPR:{ *:[v4i32] }:$addr, (imm:{ *:[i32] }):$offset)
     /*  93935 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSTRW32_qi_pre),
     /*  93938 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wb]
     /*  93940 */     GIR_RootToRootCopy, /*OpIdx*/4, // data
     /*  93942 */     GIR_RootToRootCopy, /*OpIdx*/2, // addr
     /*  93944 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // offset
     /*  93947 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  93952 */     GIR_RootConstrainSelectedInstOperands,
     /*  93953 */     // GIR_Coverage, 5052,
     /*  93953 */     GIR_EraseRootFromParent_Done,
     /*  93954 */   // Label 1719: @93954
     /*  93954 */   GIM_Try, /*On fail goto*//*Label 1720*/ GIMT_Encode4(94012), // Rule ID 5062 //
     /*  93959 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  93962 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  93965 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  93968 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /*  93971 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  93975 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  93979 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  93983 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  93987 */     // MIs[1] Operand 1
     /*  93987 */     // No operand predicates
     /*  93987 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  93991 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  93993 */     // (intrinsic_w_chain:{ *:[v4i32] } 3722:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$addr, (imm:{ *:[i32] }):$offset, MQPR:{ *:[v4f32] }:$data)  =>  (MVE_VSTRW32_qi_pre:{ *:[v4i32] } MQPR:{ *:[v4f32] }:$data, MQPR:{ *:[v4i32] }:$addr, (imm:{ *:[i32] }):$offset)
     /*  93993 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSTRW32_qi_pre),
     /*  93996 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wb]
     /*  93998 */     GIR_RootToRootCopy, /*OpIdx*/4, // data
     /*  94000 */     GIR_RootToRootCopy, /*OpIdx*/2, // addr
     /*  94002 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // offset
     /*  94005 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  94010 */     GIR_RootConstrainSelectedInstOperands,
     /*  94011 */     // GIR_Coverage, 5062,
     /*  94011 */     GIR_EraseRootFromParent_Done,
     /*  94012 */   // Label 1720: @94012
     /*  94012 */   GIM_Try, /*On fail goto*//*Label 1721*/ GIMT_Encode4(94070), // Rule ID 5066 //
     /*  94017 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  94020 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  94023 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  94026 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s64,
     /*  94029 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  94033 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  94037 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  94041 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  94045 */     // MIs[1] Operand 1
     /*  94045 */     // No operand predicates
     /*  94045 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  94049 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  94051 */     // (intrinsic_w_chain:{ *:[v2i64] } 3722:{ *:[iPTR] }, MQPR:{ *:[v2i64] }:$addr, (imm:{ *:[i32] }):$offset, MQPR:{ *:[v2i64] }:$data)  =>  (MVE_VSTRD64_qi_pre:{ *:[v2i64] } MQPR:{ *:[v2i64] }:$data, MQPR:{ *:[v2i64] }:$addr, (imm:{ *:[i32] }):$offset)
     /*  94051 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSTRD64_qi_pre),
     /*  94054 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wb]
     /*  94056 */     GIR_RootToRootCopy, /*OpIdx*/4, // data
     /*  94058 */     GIR_RootToRootCopy, /*OpIdx*/2, // addr
     /*  94060 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // offset
     /*  94063 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  94068 */     GIR_RootConstrainSelectedInstOperands,
     /*  94069 */     // GIR_Coverage, 5066,
     /*  94069 */     GIR_EraseRootFromParent_Done,
     /*  94070 */   // Label 1721: @94070
     /*  94070 */   GIM_Try, /*On fail goto*//*Label 1722*/ GIMT_Encode4(94128), // Rule ID 5070 //
     /*  94075 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  94078 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  94081 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  94084 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s64,
     /*  94087 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  94091 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  94095 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  94099 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  94103 */     // MIs[1] Operand 1
     /*  94103 */     // No operand predicates
     /*  94103 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  94107 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  94109 */     // (intrinsic_w_chain:{ *:[v2i64] } 3722:{ *:[iPTR] }, MQPR:{ *:[v2i64] }:$addr, (imm:{ *:[i32] }):$offset, MQPR:{ *:[v2f64] }:$data)  =>  (MVE_VSTRD64_qi_pre:{ *:[v2i64] } MQPR:{ *:[v2f64] }:$data, MQPR:{ *:[v2i64] }:$addr, (imm:{ *:[i32] }):$offset)
     /*  94109 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSTRD64_qi_pre),
     /*  94112 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wb]
     /*  94114 */     GIR_RootToRootCopy, /*OpIdx*/4, // data
     /*  94116 */     GIR_RootToRootCopy, /*OpIdx*/2, // addr
     /*  94118 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // offset
     /*  94121 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  94126 */     GIR_RootConstrainSelectedInstOperands,
     /*  94127 */     // GIR_Coverage, 5070,
     /*  94127 */     GIR_EraseRootFromParent_Done,
     /*  94128 */   // Label 1722: @94128
     /*  94128 */   GIM_Reject,
     /*  94129 */ // Label 1718: @94129
     /*  94129 */ GIM_Try, /*On fail goto*//*Label 1723*/ GIMT_Encode4(95300),
     /*  94134 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/6,
     /*  94137 */   GIM_Try, /*On fail goto*//*Label 1724*/ GIMT_Encode4(94198), // Rule ID 4940 //
     /*  94142 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_mve_vstr_scatter_offset),
     /*  94147 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  94150 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  94153 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  94156 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  94159 */     // MIs[0] base
     /*  94159 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  94163 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  94167 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  94171 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  94175 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 16,
     /*  94179 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  94183 */     // (intrinsic_void 3724:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v8i16] }:$offsets, MQPR:{ *:[v8i16] }:$data, 16:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VSTRH16_rq_u MQPR:{ *:[v8i16] }:$data, GPR:{ *:[i32] }:$base, MQPR:{ *:[v8i16] }:$offsets)
     /*  94183 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSTRH16_rq_u),
     /*  94186 */     GIR_RootToRootCopy, /*OpIdx*/3, // data
     /*  94188 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /*  94190 */     GIR_RootToRootCopy, /*OpIdx*/2, // offsets
     /*  94192 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  94196 */     GIR_RootConstrainSelectedInstOperands,
     /*  94197 */     // GIR_Coverage, 4940,
     /*  94197 */     GIR_EraseRootFromParent_Done,
     /*  94198 */   // Label 1724: @94198
     /*  94198 */   GIM_Try, /*On fail goto*//*Label 1725*/ GIMT_Encode4(94259), // Rule ID 4941 //
     /*  94203 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_mve_vstr_scatter_offset),
     /*  94208 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  94211 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  94214 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  94217 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  94220 */     // MIs[0] base
     /*  94220 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  94224 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  94228 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  94232 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  94236 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 16,
     /*  94240 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  94244 */     // (intrinsic_void 3724:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v8i16] }:$offsets, MQPR:{ *:[v8i16] }:$data, 16:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VSTRH16_rq MQPR:{ *:[v8i16] }:$data, GPR:{ *:[i32] }:$base, MQPR:{ *:[v8i16] }:$offsets)
     /*  94244 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSTRH16_rq),
     /*  94247 */     GIR_RootToRootCopy, /*OpIdx*/3, // data
     /*  94249 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /*  94251 */     GIR_RootToRootCopy, /*OpIdx*/2, // offsets
     /*  94253 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  94257 */     GIR_RootConstrainSelectedInstOperands,
     /*  94258 */     // GIR_Coverage, 4941,
     /*  94258 */     GIR_EraseRootFromParent_Done,
     /*  94259 */   // Label 1725: @94259
     /*  94259 */   GIM_Try, /*On fail goto*//*Label 1726*/ GIMT_Encode4(94320), // Rule ID 4944 //
     /*  94264 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_mve_vstr_scatter_offset),
     /*  94269 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  94272 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  94275 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  94278 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  94281 */     // MIs[0] base
     /*  94281 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  94285 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  94289 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  94293 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  94297 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 8,
     /*  94301 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  94305 */     // (intrinsic_void 3724:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v16i8] }:$offsets, MQPR:{ *:[v16i8] }:$data, 8:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VSTRB8_rq MQPR:{ *:[v16i8] }:$data, GPR:{ *:[i32] }:$base, MQPR:{ *:[v16i8] }:$offsets)
     /*  94305 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSTRB8_rq),
     /*  94308 */     GIR_RootToRootCopy, /*OpIdx*/3, // data
     /*  94310 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /*  94312 */     GIR_RootToRootCopy, /*OpIdx*/2, // offsets
     /*  94314 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  94318 */     GIR_RootConstrainSelectedInstOperands,
     /*  94319 */     // GIR_Coverage, 4944,
     /*  94319 */     GIR_EraseRootFromParent_Done,
     /*  94320 */   // Label 1726: @94320
     /*  94320 */   GIM_Try, /*On fail goto*//*Label 1727*/ GIMT_Encode4(94381), // Rule ID 5024 //
     /*  94325 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_mve_vstr_scatter_offset),
     /*  94330 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  94333 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  94336 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  94339 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  94342 */     // MIs[0] base
     /*  94342 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  94346 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  94350 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  94354 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  94358 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 8,
     /*  94362 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  94366 */     // (intrinsic_void 3724:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v8i16] }:$offsets, MQPR:{ *:[v8i16] }:$data, 8:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VSTRB16_rq MQPR:{ *:[v8i16] }:$data, GPR:{ *:[i32] }:$base, MQPR:{ *:[v8i16] }:$offsets)
     /*  94366 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSTRB16_rq),
     /*  94369 */     GIR_RootToRootCopy, /*OpIdx*/3, // data
     /*  94371 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /*  94373 */     GIR_RootToRootCopy, /*OpIdx*/2, // offsets
     /*  94375 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  94379 */     GIR_RootConstrainSelectedInstOperands,
     /*  94380 */     // GIR_Coverage, 5024,
     /*  94380 */     GIR_EraseRootFromParent_Done,
     /*  94381 */   // Label 1727: @94381
     /*  94381 */   GIM_Try, /*On fail goto*//*Label 1728*/ GIMT_Encode4(94442), // Rule ID 5026 //
     /*  94386 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_mve_vstr_scatter_offset),
     /*  94391 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  94394 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  94397 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  94400 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  94403 */     // MIs[0] base
     /*  94403 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  94407 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  94411 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  94415 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  94419 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 8,
     /*  94423 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  94427 */     // (intrinsic_void 3724:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets, MQPR:{ *:[v4i32] }:$data, 8:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VSTRB32_rq MQPR:{ *:[v4i32] }:$data, GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets)
     /*  94427 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSTRB32_rq),
     /*  94430 */     GIR_RootToRootCopy, /*OpIdx*/3, // data
     /*  94432 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /*  94434 */     GIR_RootToRootCopy, /*OpIdx*/2, // offsets
     /*  94436 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  94440 */     GIR_RootConstrainSelectedInstOperands,
     /*  94441 */     // GIR_Coverage, 5026,
     /*  94441 */     GIR_EraseRootFromParent_Done,
     /*  94442 */   // Label 1728: @94442
     /*  94442 */   GIM_Try, /*On fail goto*//*Label 1729*/ GIMT_Encode4(94503), // Rule ID 5028 //
     /*  94447 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_mve_vstr_scatter_offset),
     /*  94452 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  94455 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  94458 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  94461 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  94464 */     // MIs[0] base
     /*  94464 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  94468 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  94472 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  94476 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  94480 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 16,
     /*  94484 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  94488 */     // (intrinsic_void 3724:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v8i16] }:$offsets, MQPR:{ *:[v8f16] }:$data, 16:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VSTRH16_rq_u MQPR:{ *:[v8f16] }:$data, GPR:{ *:[i32] }:$base, MQPR:{ *:[v8i16] }:$offsets)
     /*  94488 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSTRH16_rq_u),
     /*  94491 */     GIR_RootToRootCopy, /*OpIdx*/3, // data
     /*  94493 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /*  94495 */     GIR_RootToRootCopy, /*OpIdx*/2, // offsets
     /*  94497 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  94501 */     GIR_RootConstrainSelectedInstOperands,
     /*  94502 */     // GIR_Coverage, 5028,
     /*  94502 */     GIR_EraseRootFromParent_Done,
     /*  94503 */   // Label 1729: @94503
     /*  94503 */   GIM_Try, /*On fail goto*//*Label 1730*/ GIMT_Encode4(94564), // Rule ID 5029 //
     /*  94508 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_mve_vstr_scatter_offset),
     /*  94513 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  94516 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  94519 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  94522 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  94525 */     // MIs[0] base
     /*  94525 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  94529 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  94533 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  94537 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  94541 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 16,
     /*  94545 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  94549 */     // (intrinsic_void 3724:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v8i16] }:$offsets, MQPR:{ *:[v8f16] }:$data, 16:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VSTRH16_rq MQPR:{ *:[v8f16] }:$data, GPR:{ *:[i32] }:$base, MQPR:{ *:[v8i16] }:$offsets)
     /*  94549 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSTRH16_rq),
     /*  94552 */     GIR_RootToRootCopy, /*OpIdx*/3, // data
     /*  94554 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /*  94556 */     GIR_RootToRootCopy, /*OpIdx*/2, // offsets
     /*  94558 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  94562 */     GIR_RootConstrainSelectedInstOperands,
     /*  94563 */     // GIR_Coverage, 5029,
     /*  94563 */     GIR_EraseRootFromParent_Done,
     /*  94564 */   // Label 1730: @94564
     /*  94564 */   GIM_Try, /*On fail goto*//*Label 1731*/ GIMT_Encode4(94625), // Rule ID 5032 //
     /*  94569 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_mve_vstr_scatter_offset),
     /*  94574 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  94577 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  94580 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  94583 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  94586 */     // MIs[0] base
     /*  94586 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  94590 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  94594 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  94598 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  94602 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 16,
     /*  94606 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  94610 */     // (intrinsic_void 3724:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets, MQPR:{ *:[v4i32] }:$data, 16:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VSTRH32_rq_u MQPR:{ *:[v4i32] }:$data, GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets)
     /*  94610 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSTRH32_rq_u),
     /*  94613 */     GIR_RootToRootCopy, /*OpIdx*/3, // data
     /*  94615 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /*  94617 */     GIR_RootToRootCopy, /*OpIdx*/2, // offsets
     /*  94619 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  94623 */     GIR_RootConstrainSelectedInstOperands,
     /*  94624 */     // GIR_Coverage, 5032,
     /*  94624 */     GIR_EraseRootFromParent_Done,
     /*  94625 */   // Label 1731: @94625
     /*  94625 */   GIM_Try, /*On fail goto*//*Label 1732*/ GIMT_Encode4(94686), // Rule ID 5033 //
     /*  94630 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_mve_vstr_scatter_offset),
     /*  94635 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  94638 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  94641 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  94644 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  94647 */     // MIs[0] base
     /*  94647 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  94651 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  94655 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  94659 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  94663 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 16,
     /*  94667 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  94671 */     // (intrinsic_void 3724:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets, MQPR:{ *:[v4i32] }:$data, 16:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VSTRH32_rq MQPR:{ *:[v4i32] }:$data, GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets)
     /*  94671 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSTRH32_rq),
     /*  94674 */     GIR_RootToRootCopy, /*OpIdx*/3, // data
     /*  94676 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /*  94678 */     GIR_RootToRootCopy, /*OpIdx*/2, // offsets
     /*  94680 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  94684 */     GIR_RootConstrainSelectedInstOperands,
     /*  94685 */     // GIR_Coverage, 5033,
     /*  94685 */     GIR_EraseRootFromParent_Done,
     /*  94686 */   // Label 1732: @94686
     /*  94686 */   GIM_Try, /*On fail goto*//*Label 1733*/ GIMT_Encode4(94747), // Rule ID 5036 //
     /*  94691 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_mve_vstr_scatter_offset),
     /*  94696 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  94699 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  94702 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  94705 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  94708 */     // MIs[0] base
     /*  94708 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  94712 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  94716 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  94720 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  94724 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 32,
     /*  94728 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  94732 */     // (intrinsic_void 3724:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets, MQPR:{ *:[v4i32] }:$data, 32:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VSTRW32_rq_u MQPR:{ *:[v4i32] }:$data, GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets)
     /*  94732 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSTRW32_rq_u),
     /*  94735 */     GIR_RootToRootCopy, /*OpIdx*/3, // data
     /*  94737 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /*  94739 */     GIR_RootToRootCopy, /*OpIdx*/2, // offsets
     /*  94741 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  94745 */     GIR_RootConstrainSelectedInstOperands,
     /*  94746 */     // GIR_Coverage, 5036,
     /*  94746 */     GIR_EraseRootFromParent_Done,
     /*  94747 */   // Label 1733: @94747
     /*  94747 */   GIM_Try, /*On fail goto*//*Label 1734*/ GIMT_Encode4(94808), // Rule ID 5037 //
     /*  94752 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_mve_vstr_scatter_offset),
     /*  94757 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  94760 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  94763 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  94766 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  94769 */     // MIs[0] base
     /*  94769 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  94773 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  94777 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  94781 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  94785 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 32,
     /*  94789 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 2,
     /*  94793 */     // (intrinsic_void 3724:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets, MQPR:{ *:[v4i32] }:$data, 32:{ *:[i32] }, 2:{ *:[i32] })  =>  (MVE_VSTRW32_rq MQPR:{ *:[v4i32] }:$data, GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets)
     /*  94793 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSTRW32_rq),
     /*  94796 */     GIR_RootToRootCopy, /*OpIdx*/3, // data
     /*  94798 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /*  94800 */     GIR_RootToRootCopy, /*OpIdx*/2, // offsets
     /*  94802 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  94806 */     GIR_RootConstrainSelectedInstOperands,
     /*  94807 */     // GIR_Coverage, 5037,
     /*  94807 */     GIR_EraseRootFromParent_Done,
     /*  94808 */   // Label 1734: @94808
     /*  94808 */   GIM_Try, /*On fail goto*//*Label 1735*/ GIMT_Encode4(94869), // Rule ID 5040 //
     /*  94813 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_mve_vstr_scatter_offset),
     /*  94818 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  94821 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  94824 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  94827 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  94830 */     // MIs[0] base
     /*  94830 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  94834 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  94838 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  94842 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  94846 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 32,
     /*  94850 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  94854 */     // (intrinsic_void 3724:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets, MQPR:{ *:[v4f32] }:$data, 32:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VSTRW32_rq_u MQPR:{ *:[v4f32] }:$data, GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets)
     /*  94854 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSTRW32_rq_u),
     /*  94857 */     GIR_RootToRootCopy, /*OpIdx*/3, // data
     /*  94859 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /*  94861 */     GIR_RootToRootCopy, /*OpIdx*/2, // offsets
     /*  94863 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  94867 */     GIR_RootConstrainSelectedInstOperands,
     /*  94868 */     // GIR_Coverage, 5040,
     /*  94868 */     GIR_EraseRootFromParent_Done,
     /*  94869 */   // Label 1735: @94869
     /*  94869 */   GIM_Try, /*On fail goto*//*Label 1736*/ GIMT_Encode4(94930), // Rule ID 5041 //
     /*  94874 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_mve_vstr_scatter_offset),
     /*  94879 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  94882 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  94885 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  94888 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  94891 */     // MIs[0] base
     /*  94891 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  94895 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  94899 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  94903 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  94907 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 32,
     /*  94911 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 2,
     /*  94915 */     // (intrinsic_void 3724:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets, MQPR:{ *:[v4f32] }:$data, 32:{ *:[i32] }, 2:{ *:[i32] })  =>  (MVE_VSTRW32_rq MQPR:{ *:[v4f32] }:$data, GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets)
     /*  94915 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSTRW32_rq),
     /*  94918 */     GIR_RootToRootCopy, /*OpIdx*/3, // data
     /*  94920 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /*  94922 */     GIR_RootToRootCopy, /*OpIdx*/2, // offsets
     /*  94924 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  94928 */     GIR_RootConstrainSelectedInstOperands,
     /*  94929 */     // GIR_Coverage, 5041,
     /*  94929 */     GIR_EraseRootFromParent_Done,
     /*  94930 */   // Label 1736: @94930
     /*  94930 */   GIM_Try, /*On fail goto*//*Label 1737*/ GIMT_Encode4(94991), // Rule ID 5044 //
     /*  94935 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_mve_vstr_scatter_offset),
     /*  94940 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  94943 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  94946 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  94949 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  94952 */     // MIs[0] base
     /*  94952 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  94956 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  94960 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  94964 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  94968 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 64,
     /*  94972 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  94976 */     // (intrinsic_void 3724:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v2i64] }:$offsets, MQPR:{ *:[v2i64] }:$data, 64:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VSTRD64_rq_u MQPR:{ *:[v2i64] }:$data, GPR:{ *:[i32] }:$base, MQPR:{ *:[v2i64] }:$offsets)
     /*  94976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSTRD64_rq_u),
     /*  94979 */     GIR_RootToRootCopy, /*OpIdx*/3, // data
     /*  94981 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /*  94983 */     GIR_RootToRootCopy, /*OpIdx*/2, // offsets
     /*  94985 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  94989 */     GIR_RootConstrainSelectedInstOperands,
     /*  94990 */     // GIR_Coverage, 5044,
     /*  94990 */     GIR_EraseRootFromParent_Done,
     /*  94991 */   // Label 1737: @94991
     /*  94991 */   GIM_Try, /*On fail goto*//*Label 1738*/ GIMT_Encode4(95052), // Rule ID 5045 //
     /*  94996 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_mve_vstr_scatter_offset),
     /*  95001 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  95004 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  95007 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  95010 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  95013 */     // MIs[0] base
     /*  95013 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  95017 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  95021 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  95025 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  95029 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 64,
     /*  95033 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 3,
     /*  95037 */     // (intrinsic_void 3724:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v2i64] }:$offsets, MQPR:{ *:[v2i64] }:$data, 64:{ *:[i32] }, 3:{ *:[i32] })  =>  (MVE_VSTRD64_rq MQPR:{ *:[v2i64] }:$data, GPR:{ *:[i32] }:$base, MQPR:{ *:[v2i64] }:$offsets)
     /*  95037 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSTRD64_rq),
     /*  95040 */     GIR_RootToRootCopy, /*OpIdx*/3, // data
     /*  95042 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /*  95044 */     GIR_RootToRootCopy, /*OpIdx*/2, // offsets
     /*  95046 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  95050 */     GIR_RootConstrainSelectedInstOperands,
     /*  95051 */     // GIR_Coverage, 5045,
     /*  95051 */     GIR_EraseRootFromParent_Done,
     /*  95052 */   // Label 1738: @95052
     /*  95052 */   GIM_Try, /*On fail goto*//*Label 1739*/ GIMT_Encode4(95116), // Rule ID 258 //
     /*  95057 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  95060 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_mcrr),
     /*  95065 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  95068 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  95071 */     // MIs[0] cop
     /*  95071 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /*  95074 */     // MIs[0] opc1
     /*  95074 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  95077 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  95081 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  95085 */     // MIs[0] CRm
     /*  95085 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  95088 */     // (intrinsic_void 3528:{ *:[iPTR] }, (timm:{ *:[i32] }):$cop, (timm:{ *:[i32] }):$opc1, GPRnopc:{ *:[i32] }:$Rt, GPRnopc:{ *:[i32] }:$Rt2, (timm:{ *:[i32] }):$CRm)  =>  (MCRR (timm:{ *:[i32] }):$cop, (timm:{ *:[i32] }):$opc1, GPRnopc:{ *:[i32] }:$Rt, GPRnopc:{ *:[i32] }:$Rt2, (timm:{ *:[i32] }):$CRm)
     /*  95088 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MCRR),
     /*  95091 */     GIR_RootToRootCopy, /*OpIdx*/1, // cop
     /*  95093 */     GIR_RootToRootCopy, /*OpIdx*/2, // opc1
     /*  95095 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rt
     /*  95097 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rt2
     /*  95099 */     GIR_RootToRootCopy, /*OpIdx*/5, // CRm
     /*  95101 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  95104 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  95110 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  95114 */     GIR_RootConstrainSelectedInstOperands,
     /*  95115 */     // GIR_Coverage, 258,
     /*  95115 */     GIR_EraseRootFromParent_Done,
     /*  95116 */   // Label 1739: @95116
     /*  95116 */   GIM_Try, /*On fail goto*//*Label 1740*/ GIMT_Encode4(95171), // Rule ID 259 //
     /*  95121 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM_PreV8),
     /*  95124 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_mcrr2),
     /*  95129 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  95132 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  95135 */     // MIs[0] cop
     /*  95135 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /*  95138 */     // MIs[0] opc1
     /*  95138 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  95141 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  95145 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  95149 */     // MIs[0] CRm
     /*  95149 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  95152 */     // (intrinsic_void 3529:{ *:[iPTR] }, (timm:{ *:[i32] }):$cop, (timm:{ *:[i32] }):$opc1, GPRnopc:{ *:[i32] }:$Rt, GPRnopc:{ *:[i32] }:$Rt2, (timm:{ *:[i32] }):$CRm)  =>  (MCRR2 (timm:{ *:[i32] }):$cop, (timm:{ *:[i32] }):$opc1, GPRnopc:{ *:[i32] }:$Rt, GPRnopc:{ *:[i32] }:$Rt2, (timm:{ *:[i32] }):$CRm)
     /*  95152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MCRR2),
     /*  95155 */     GIR_RootToRootCopy, /*OpIdx*/1, // cop
     /*  95157 */     GIR_RootToRootCopy, /*OpIdx*/2, // opc1
     /*  95159 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rt
     /*  95161 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rt2
     /*  95163 */     GIR_RootToRootCopy, /*OpIdx*/5, // CRm
     /*  95165 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  95169 */     GIR_RootConstrainSelectedInstOperands,
     /*  95170 */     // GIR_Coverage, 259,
     /*  95170 */     GIR_EraseRootFromParent_Done,
     /*  95171 */   // Label 1740: @95171
     /*  95171 */   GIM_Try, /*On fail goto*//*Label 1741*/ GIMT_Encode4(95235), // Rule ID 596 //
     /*  95176 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /*  95179 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_mcrr),
     /*  95184 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  95187 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  95190 */     // MIs[0] cop
     /*  95190 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /*  95193 */     // MIs[0] opc1
     /*  95193 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  95196 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  95200 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  95204 */     // MIs[0] CRm
     /*  95204 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  95207 */     // (intrinsic_void 3528:{ *:[iPTR] }, (timm:{ *:[i32] }):$cop, (timm:{ *:[i32] }):$opc1, GPR:{ *:[i32] }:$Rt, GPR:{ *:[i32] }:$Rt2, (timm:{ *:[i32] }):$CRm)  =>  (t2MCRR (timm:{ *:[i32] }):$cop, (timm:{ *:[i32] }):$opc1, GPR:{ *:[i32] }:$Rt, GPR:{ *:[i32] }:$Rt2, (timm:{ *:[i32] }):$CRm)
     /*  95207 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2MCRR),
     /*  95210 */     GIR_RootToRootCopy, /*OpIdx*/1, // cop
     /*  95212 */     GIR_RootToRootCopy, /*OpIdx*/2, // opc1
     /*  95214 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rt
     /*  95216 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rt2
     /*  95218 */     GIR_RootToRootCopy, /*OpIdx*/5, // CRm
     /*  95220 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  95223 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  95229 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  95233 */     GIR_RootConstrainSelectedInstOperands,
     /*  95234 */     // GIR_Coverage, 596,
     /*  95234 */     GIR_EraseRootFromParent_Done,
     /*  95235 */   // Label 1741: @95235
     /*  95235 */   GIM_Try, /*On fail goto*//*Label 1742*/ GIMT_Encode4(95299), // Rule ID 597 //
     /*  95240 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2_PreV8),
     /*  95243 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_mcrr2),
     /*  95248 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  95251 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  95254 */     // MIs[0] cop
     /*  95254 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /*  95257 */     // MIs[0] opc1
     /*  95257 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  95260 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  95264 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  95268 */     // MIs[0] CRm
     /*  95268 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  95271 */     // (intrinsic_void 3529:{ *:[iPTR] }, (timm:{ *:[i32] }):$cop, (timm:{ *:[i32] }):$opc1, GPR:{ *:[i32] }:$Rt, GPR:{ *:[i32] }:$Rt2, (timm:{ *:[i32] }):$CRm)  =>  (t2MCRR2 (timm:{ *:[i32] }):$cop, (timm:{ *:[i32] }):$opc1, GPR:{ *:[i32] }:$Rt, GPR:{ *:[i32] }:$Rt2, (timm:{ *:[i32] }):$CRm)
     /*  95271 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2MCRR2),
     /*  95274 */     GIR_RootToRootCopy, /*OpIdx*/1, // cop
     /*  95276 */     GIR_RootToRootCopy, /*OpIdx*/2, // opc1
     /*  95278 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rt
     /*  95280 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rt2
     /*  95282 */     GIR_RootToRootCopy, /*OpIdx*/5, // CRm
     /*  95284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  95287 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  95293 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  95297 */     GIR_RootConstrainSelectedInstOperands,
     /*  95298 */     // GIR_Coverage, 597,
     /*  95298 */     GIR_EraseRootFromParent_Done,
     /*  95299 */   // Label 1742: @95299
     /*  95299 */   GIM_Reject,
     /*  95300 */ // Label 1723: @95300
     /*  95300 */ GIM_Try, /*On fail goto*//*Label 1743*/ GIMT_Encode4(98651),
     /*  95305 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/7,
     /*  95308 */   GIM_Try, /*On fail goto*//*Label 1744*/ GIMT_Encode4(95369), // Rule ID 246 //
     /*  95313 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM_PreV8),
     /*  95316 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_cdp),
     /*  95321 */     // MIs[0] cop
     /*  95321 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /*  95324 */     // MIs[0] opc1
     /*  95324 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  95327 */     // MIs[0] CRd
     /*  95327 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  95330 */     // MIs[0] CRn
     /*  95330 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  95333 */     // MIs[0] CRm
     /*  95333 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  95336 */     // MIs[0] opc2
     /*  95336 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  95339 */     // (intrinsic_void 3496:{ *:[iPTR] }, (timm:{ *:[i32] }):$cop, (timm:{ *:[i32] }):$opc1, (timm:{ *:[i32] }):$CRd, (timm:{ *:[i32] }):$CRn, (timm:{ *:[i32] }):$CRm, (timm:{ *:[i32] }):$opc2)  =>  (CDP (timm:{ *:[i32] }):$cop, (timm:{ *:[i32] }):$opc1, (timm:{ *:[i32] }):$CRd, (timm:{ *:[i32] }):$CRn, (timm:{ *:[i32] }):$CRm, (timm:{ *:[i32] }):$opc2)
     /*  95339 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::CDP),
     /*  95342 */     GIR_RootToRootCopy, /*OpIdx*/1, // cop
     /*  95344 */     GIR_RootToRootCopy, /*OpIdx*/2, // opc1
     /*  95346 */     GIR_RootToRootCopy, /*OpIdx*/3, // CRd
     /*  95348 */     GIR_RootToRootCopy, /*OpIdx*/4, // CRn
     /*  95350 */     GIR_RootToRootCopy, /*OpIdx*/5, // CRm
     /*  95352 */     GIR_RootToRootCopy, /*OpIdx*/6, // opc2
     /*  95354 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  95357 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  95363 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  95367 */     GIR_RootConstrainSelectedInstOperands,
     /*  95368 */     // GIR_Coverage, 246,
     /*  95368 */     GIR_EraseRootFromParent_Done,
     /*  95369 */   // Label 1744: @95369
     /*  95369 */   GIM_Try, /*On fail goto*//*Label 1745*/ GIMT_Encode4(95421), // Rule ID 247 //
     /*  95374 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM_PreV8),
     /*  95377 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_cdp2),
     /*  95382 */     // MIs[0] cop
     /*  95382 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /*  95385 */     // MIs[0] opc1
     /*  95385 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  95388 */     // MIs[0] CRd
     /*  95388 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  95391 */     // MIs[0] CRn
     /*  95391 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  95394 */     // MIs[0] CRm
     /*  95394 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  95397 */     // MIs[0] opc2
     /*  95397 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  95400 */     // (intrinsic_void 3497:{ *:[iPTR] }, (timm:{ *:[i32] }):$cop, (timm:{ *:[i32] }):$opc1, (timm:{ *:[i32] }):$CRd, (timm:{ *:[i32] }):$CRn, (timm:{ *:[i32] }):$CRm, (timm:{ *:[i32] }):$opc2)  =>  (CDP2 (timm:{ *:[i32] }):$cop, (timm:{ *:[i32] }):$opc1, (timm:{ *:[i32] }):$CRd, (timm:{ *:[i32] }):$CRn, (timm:{ *:[i32] }):$CRm, (timm:{ *:[i32] }):$opc2)
     /*  95400 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::CDP2),
     /*  95403 */     GIR_RootToRootCopy, /*OpIdx*/1, // cop
     /*  95405 */     GIR_RootToRootCopy, /*OpIdx*/2, // opc1
     /*  95407 */     GIR_RootToRootCopy, /*OpIdx*/3, // CRd
     /*  95409 */     GIR_RootToRootCopy, /*OpIdx*/4, // CRn
     /*  95411 */     GIR_RootToRootCopy, /*OpIdx*/5, // CRm
     /*  95413 */     GIR_RootToRootCopy, /*OpIdx*/6, // opc2
     /*  95415 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  95419 */     GIR_RootConstrainSelectedInstOperands,
     /*  95420 */     // GIR_Coverage, 247,
     /*  95420 */     GIR_EraseRootFromParent_Done,
     /*  95421 */   // Label 1745: @95421
     /*  95421 */   GIM_Try, /*On fail goto*//*Label 1746*/ GIMT_Encode4(95482), // Rule ID 598 //
     /*  95426 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2_PreV8),
     /*  95429 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_cdp),
     /*  95434 */     // MIs[0] cop
     /*  95434 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /*  95437 */     // MIs[0] opc1
     /*  95437 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  95440 */     // MIs[0] CRd
     /*  95440 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  95443 */     // MIs[0] CRn
     /*  95443 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  95446 */     // MIs[0] CRm
     /*  95446 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  95449 */     // MIs[0] opc2
     /*  95449 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  95452 */     // (intrinsic_void 3496:{ *:[iPTR] }, (timm:{ *:[i32] }):$cop, (timm:{ *:[i32] }):$opc1, (timm:{ *:[i32] }):$CRd, (timm:{ *:[i32] }):$CRn, (timm:{ *:[i32] }):$CRm, (timm:{ *:[i32] }):$opc2)  =>  (t2CDP (timm:{ *:[i32] }):$cop, (timm:{ *:[i32] }):$opc1, (timm:{ *:[i32] }):$CRd, (timm:{ *:[i32] }):$CRn, (timm:{ *:[i32] }):$CRm, (timm:{ *:[i32] }):$opc2)
     /*  95452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2CDP),
     /*  95455 */     GIR_RootToRootCopy, /*OpIdx*/1, // cop
     /*  95457 */     GIR_RootToRootCopy, /*OpIdx*/2, // opc1
     /*  95459 */     GIR_RootToRootCopy, /*OpIdx*/3, // CRd
     /*  95461 */     GIR_RootToRootCopy, /*OpIdx*/4, // CRn
     /*  95463 */     GIR_RootToRootCopy, /*OpIdx*/5, // CRm
     /*  95465 */     GIR_RootToRootCopy, /*OpIdx*/6, // opc2
     /*  95467 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  95470 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  95476 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  95480 */     GIR_RootConstrainSelectedInstOperands,
     /*  95481 */     // GIR_Coverage, 598,
     /*  95481 */     GIR_EraseRootFromParent_Done,
     /*  95482 */   // Label 1746: @95482
     /*  95482 */   GIM_Try, /*On fail goto*//*Label 1747*/ GIMT_Encode4(95543), // Rule ID 599 //
     /*  95487 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2_PreV8),
     /*  95490 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_cdp2),
     /*  95495 */     // MIs[0] cop
     /*  95495 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /*  95498 */     // MIs[0] opc1
     /*  95498 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  95501 */     // MIs[0] CRd
     /*  95501 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  95504 */     // MIs[0] CRn
     /*  95504 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  95507 */     // MIs[0] CRm
     /*  95507 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  95510 */     // MIs[0] opc2
     /*  95510 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  95513 */     // (intrinsic_void 3497:{ *:[iPTR] }, (timm:{ *:[i32] }):$cop, (timm:{ *:[i32] }):$opc1, (timm:{ *:[i32] }):$CRd, (timm:{ *:[i32] }):$CRn, (timm:{ *:[i32] }):$CRm, (timm:{ *:[i32] }):$opc2)  =>  (t2CDP2 (timm:{ *:[i32] }):$cop, (timm:{ *:[i32] }):$opc1, (timm:{ *:[i32] }):$CRd, (timm:{ *:[i32] }):$CRn, (timm:{ *:[i32] }):$CRm, (timm:{ *:[i32] }):$opc2)
     /*  95513 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2CDP2),
     /*  95516 */     GIR_RootToRootCopy, /*OpIdx*/1, // cop
     /*  95518 */     GIR_RootToRootCopy, /*OpIdx*/2, // opc1
     /*  95520 */     GIR_RootToRootCopy, /*OpIdx*/3, // CRd
     /*  95522 */     GIR_RootToRootCopy, /*OpIdx*/4, // CRn
     /*  95524 */     GIR_RootToRootCopy, /*OpIdx*/5, // CRm
     /*  95526 */     GIR_RootToRootCopy, /*OpIdx*/6, // opc2
     /*  95528 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  95531 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  95537 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  95541 */     GIR_RootConstrainSelectedInstOperands,
     /*  95542 */     // GIR_Coverage, 599,
     /*  95542 */     GIR_EraseRootFromParent_Done,
     /*  95543 */   // Label 1747: @95543
     /*  95543 */   GIM_Try, /*On fail goto*//*Label 1748*/ GIMT_Encode4(95611), // Rule ID 4934 //
     /*  95548 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vldr_gather_offset),
     /*  95553 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  95556 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  95559 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  95562 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  95565 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  95568 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  95572 */     // MIs[0] base
     /*  95572 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/32,
     /*  95576 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  95580 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  95584 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 16,
     /*  95588 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  95592 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  95596 */     // (intrinsic_w_chain:{ *:[v8i16] } 3651:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v8i16] }:$offsets, 16:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VLDRHU16_rq_u:{ *:[v8i16] } GPR:{ *:[i32] }:$base, MQPR:{ *:[v8i16] }:$offsets)
     /*  95596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VLDRHU16_rq_u),
     /*  95599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  95601 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /*  95603 */     GIR_RootToRootCopy, /*OpIdx*/3, // offsets
     /*  95605 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  95609 */     GIR_RootConstrainSelectedInstOperands,
     /*  95610 */     // GIR_Coverage, 4934,
     /*  95610 */     GIR_EraseRootFromParent_Done,
     /*  95611 */   // Label 1748: @95611
     /*  95611 */   GIM_Try, /*On fail goto*//*Label 1749*/ GIMT_Encode4(95679), // Rule ID 4935 //
     /*  95616 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vldr_gather_offset),
     /*  95621 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  95624 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  95627 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  95630 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  95633 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  95636 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  95640 */     // MIs[0] base
     /*  95640 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/32,
     /*  95644 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  95648 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  95652 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 16,
     /*  95656 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  95660 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  95664 */     // (intrinsic_w_chain:{ *:[v8i16] } 3651:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v8i16] }:$offsets, 16:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VLDRHU16_rq:{ *:[v8i16] } GPR:{ *:[i32] }:$base, MQPR:{ *:[v8i16] }:$offsets)
     /*  95664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VLDRHU16_rq),
     /*  95667 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  95669 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /*  95671 */     GIR_RootToRootCopy, /*OpIdx*/3, // offsets
     /*  95673 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  95677 */     GIR_RootConstrainSelectedInstOperands,
     /*  95678 */     // GIR_Coverage, 4935,
     /*  95678 */     GIR_EraseRootFromParent_Done,
     /*  95679 */   // Label 1749: @95679
     /*  95679 */   GIM_Try, /*On fail goto*//*Label 1750*/ GIMT_Encode4(95747), // Rule ID 4938 //
     /*  95684 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vldr_gather_offset),
     /*  95689 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  95692 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  95695 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  95698 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  95701 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  95704 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  95708 */     // MIs[0] base
     /*  95708 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/32,
     /*  95712 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  95716 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  95720 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 8,
     /*  95724 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  95728 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  95732 */     // (intrinsic_w_chain:{ *:[v16i8] } 3651:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v16i8] }:$offsets, 8:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VLDRBU8_rq:{ *:[v16i8] } GPR:{ *:[i32] }:$base, MQPR:{ *:[v16i8] }:$offsets)
     /*  95732 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VLDRBU8_rq),
     /*  95735 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  95737 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /*  95739 */     GIR_RootToRootCopy, /*OpIdx*/3, // offsets
     /*  95741 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  95745 */     GIR_RootConstrainSelectedInstOperands,
     /*  95746 */     // GIR_Coverage, 4938,
     /*  95746 */     GIR_EraseRootFromParent_Done,
     /*  95747 */   // Label 1750: @95747
     /*  95747 */   GIM_Try, /*On fail goto*//*Label 1751*/ GIMT_Encode4(95815), // Rule ID 4946 //
     /*  95752 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vldr_gather_offset),
     /*  95757 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  95760 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  95763 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  95766 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  95769 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  95772 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  95776 */     // MIs[0] base
     /*  95776 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/32,
     /*  95780 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  95784 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  95788 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 8,
     /*  95792 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  95796 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  95800 */     // (intrinsic_w_chain:{ *:[v16i8] } 3651:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v16i8] }:$offsets, 8:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VLDRBU8_rq:{ *:[v16i8] } GPR:{ *:[i32] }:$base, MQPR:{ *:[v16i8] }:$offsets)
     /*  95800 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VLDRBU8_rq),
     /*  95803 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  95805 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /*  95807 */     GIR_RootToRootCopy, /*OpIdx*/3, // offsets
     /*  95809 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  95813 */     GIR_RootConstrainSelectedInstOperands,
     /*  95814 */     // GIR_Coverage, 4946,
     /*  95814 */     GIR_EraseRootFromParent_Done,
     /*  95815 */   // Label 1751: @95815
     /*  95815 */   GIM_Try, /*On fail goto*//*Label 1752*/ GIMT_Encode4(95883), // Rule ID 4948 //
     /*  95820 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vldr_gather_offset),
     /*  95825 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  95828 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  95831 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  95834 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  95837 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  95840 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  95844 */     // MIs[0] base
     /*  95844 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/32,
     /*  95848 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  95852 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  95856 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 8,
     /*  95860 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  95864 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  95868 */     // (intrinsic_w_chain:{ *:[v8i16] } 3651:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v8i16] }:$offsets, 8:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VLDRBU16_rq:{ *:[v8i16] } GPR:{ *:[i32] }:$base, MQPR:{ *:[v8i16] }:$offsets)
     /*  95868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VLDRBU16_rq),
     /*  95871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  95873 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /*  95875 */     GIR_RootToRootCopy, /*OpIdx*/3, // offsets
     /*  95877 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  95881 */     GIR_RootConstrainSelectedInstOperands,
     /*  95882 */     // GIR_Coverage, 4948,
     /*  95882 */     GIR_EraseRootFromParent_Done,
     /*  95883 */   // Label 1752: @95883
     /*  95883 */   GIM_Try, /*On fail goto*//*Label 1753*/ GIMT_Encode4(95951), // Rule ID 4950 //
     /*  95888 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vldr_gather_offset),
     /*  95893 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  95896 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  95899 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  95902 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  95905 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  95908 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  95912 */     // MIs[0] base
     /*  95912 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/32,
     /*  95916 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  95920 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  95924 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 8,
     /*  95928 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  95932 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  95936 */     // (intrinsic_w_chain:{ *:[v8i16] } 3651:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v8i16] }:$offsets, 8:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VLDRBS16_rq:{ *:[v8i16] } GPR:{ *:[i32] }:$base, MQPR:{ *:[v8i16] }:$offsets)
     /*  95936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VLDRBS16_rq),
     /*  95939 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  95941 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /*  95943 */     GIR_RootToRootCopy, /*OpIdx*/3, // offsets
     /*  95945 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  95949 */     GIR_RootConstrainSelectedInstOperands,
     /*  95950 */     // GIR_Coverage, 4950,
     /*  95950 */     GIR_EraseRootFromParent_Done,
     /*  95951 */   // Label 1753: @95951
     /*  95951 */   GIM_Try, /*On fail goto*//*Label 1754*/ GIMT_Encode4(96019), // Rule ID 4952 //
     /*  95956 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vldr_gather_offset),
     /*  95961 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  95964 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  95967 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  95970 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  95973 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  95976 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  95980 */     // MIs[0] base
     /*  95980 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/32,
     /*  95984 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  95988 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  95992 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 8,
     /*  95996 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  96000 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  96004 */     // (intrinsic_w_chain:{ *:[v4i32] } 3651:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets, 8:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VLDRBU32_rq:{ *:[v4i32] } GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets)
     /*  96004 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VLDRBU32_rq),
     /*  96007 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  96009 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /*  96011 */     GIR_RootToRootCopy, /*OpIdx*/3, // offsets
     /*  96013 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  96017 */     GIR_RootConstrainSelectedInstOperands,
     /*  96018 */     // GIR_Coverage, 4952,
     /*  96018 */     GIR_EraseRootFromParent_Done,
     /*  96019 */   // Label 1754: @96019
     /*  96019 */   GIM_Try, /*On fail goto*//*Label 1755*/ GIMT_Encode4(96087), // Rule ID 4954 //
     /*  96024 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vldr_gather_offset),
     /*  96029 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  96032 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  96035 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  96038 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  96041 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  96044 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  96048 */     // MIs[0] base
     /*  96048 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/32,
     /*  96052 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  96056 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  96060 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 8,
     /*  96064 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  96068 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  96072 */     // (intrinsic_w_chain:{ *:[v4i32] } 3651:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets, 8:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VLDRBS32_rq:{ *:[v4i32] } GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets)
     /*  96072 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VLDRBS32_rq),
     /*  96075 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  96077 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /*  96079 */     GIR_RootToRootCopy, /*OpIdx*/3, // offsets
     /*  96081 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  96085 */     GIR_RootConstrainSelectedInstOperands,
     /*  96086 */     // GIR_Coverage, 4954,
     /*  96086 */     GIR_EraseRootFromParent_Done,
     /*  96087 */   // Label 1755: @96087
     /*  96087 */   GIM_Try, /*On fail goto*//*Label 1756*/ GIMT_Encode4(96155), // Rule ID 4956 //
     /*  96092 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vldr_gather_offset),
     /*  96097 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  96100 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  96103 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  96106 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  96109 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  96112 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  96116 */     // MIs[0] base
     /*  96116 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/32,
     /*  96120 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  96124 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  96128 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 16,
     /*  96132 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  96136 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  96140 */     // (intrinsic_w_chain:{ *:[v8i16] } 3651:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v8i16] }:$offsets, 16:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VLDRHU16_rq_u:{ *:[v8i16] } GPR:{ *:[i32] }:$base, MQPR:{ *:[v8i16] }:$offsets)
     /*  96140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VLDRHU16_rq_u),
     /*  96143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  96145 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /*  96147 */     GIR_RootToRootCopy, /*OpIdx*/3, // offsets
     /*  96149 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  96153 */     GIR_RootConstrainSelectedInstOperands,
     /*  96154 */     // GIR_Coverage, 4956,
     /*  96154 */     GIR_EraseRootFromParent_Done,
     /*  96155 */   // Label 1756: @96155
     /*  96155 */   GIM_Try, /*On fail goto*//*Label 1757*/ GIMT_Encode4(96223), // Rule ID 4957 //
     /*  96160 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vldr_gather_offset),
     /*  96165 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  96168 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  96171 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  96174 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  96177 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  96180 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  96184 */     // MIs[0] base
     /*  96184 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/32,
     /*  96188 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  96192 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  96196 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 16,
     /*  96200 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  96204 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  96208 */     // (intrinsic_w_chain:{ *:[v8i16] } 3651:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v8i16] }:$offsets, 16:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VLDRHU16_rq:{ *:[v8i16] } GPR:{ *:[i32] }:$base, MQPR:{ *:[v8i16] }:$offsets)
     /*  96208 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VLDRHU16_rq),
     /*  96211 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  96213 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /*  96215 */     GIR_RootToRootCopy, /*OpIdx*/3, // offsets
     /*  96217 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  96221 */     GIR_RootConstrainSelectedInstOperands,
     /*  96222 */     // GIR_Coverage, 4957,
     /*  96222 */     GIR_EraseRootFromParent_Done,
     /*  96223 */   // Label 1757: @96223
     /*  96223 */   GIM_Try, /*On fail goto*//*Label 1758*/ GIMT_Encode4(96291), // Rule ID 4960 //
     /*  96228 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vldr_gather_offset),
     /*  96233 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  96236 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  96239 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  96242 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  96245 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  96248 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  96252 */     // MIs[0] base
     /*  96252 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/32,
     /*  96256 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  96260 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  96264 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 16,
     /*  96268 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  96272 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  96276 */     // (intrinsic_w_chain:{ *:[v8i16] } 3651:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v8i16] }:$offsets, 16:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VLDRHU16_rq_u:{ *:[v8i16] } GPR:{ *:[i32] }:$base, MQPR:{ *:[v8i16] }:$offsets)
     /*  96276 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VLDRHU16_rq_u),
     /*  96279 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  96281 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /*  96283 */     GIR_RootToRootCopy, /*OpIdx*/3, // offsets
     /*  96285 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  96289 */     GIR_RootConstrainSelectedInstOperands,
     /*  96290 */     // GIR_Coverage, 4960,
     /*  96290 */     GIR_EraseRootFromParent_Done,
     /*  96291 */   // Label 1758: @96291
     /*  96291 */   GIM_Try, /*On fail goto*//*Label 1759*/ GIMT_Encode4(96359), // Rule ID 4961 //
     /*  96296 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vldr_gather_offset),
     /*  96301 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  96304 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  96307 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  96310 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  96313 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  96316 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  96320 */     // MIs[0] base
     /*  96320 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/32,
     /*  96324 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  96328 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  96332 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 16,
     /*  96336 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  96340 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  96344 */     // (intrinsic_w_chain:{ *:[v8i16] } 3651:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v8i16] }:$offsets, 16:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VLDRHU16_rq:{ *:[v8i16] } GPR:{ *:[i32] }:$base, MQPR:{ *:[v8i16] }:$offsets)
     /*  96344 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VLDRHU16_rq),
     /*  96347 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  96349 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /*  96351 */     GIR_RootToRootCopy, /*OpIdx*/3, // offsets
     /*  96353 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  96357 */     GIR_RootConstrainSelectedInstOperands,
     /*  96358 */     // GIR_Coverage, 4961,
     /*  96358 */     GIR_EraseRootFromParent_Done,
     /*  96359 */   // Label 1759: @96359
     /*  96359 */   GIM_Try, /*On fail goto*//*Label 1760*/ GIMT_Encode4(96427), // Rule ID 4964 //
     /*  96364 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vldr_gather_offset),
     /*  96369 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  96372 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  96375 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  96378 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  96381 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  96384 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  96388 */     // MIs[0] base
     /*  96388 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/32,
     /*  96392 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  96396 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  96400 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 16,
     /*  96404 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  96408 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  96412 */     // (intrinsic_w_chain:{ *:[v8i16] } 3651:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v8i16] }:$offsets, 16:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VLDRHU16_rq_u:{ *:[v8i16] } GPR:{ *:[i32] }:$base, MQPR:{ *:[v8i16] }:$offsets)
     /*  96412 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VLDRHU16_rq_u),
     /*  96415 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  96417 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /*  96419 */     GIR_RootToRootCopy, /*OpIdx*/3, // offsets
     /*  96421 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  96425 */     GIR_RootConstrainSelectedInstOperands,
     /*  96426 */     // GIR_Coverage, 4964,
     /*  96426 */     GIR_EraseRootFromParent_Done,
     /*  96427 */   // Label 1760: @96427
     /*  96427 */   GIM_Try, /*On fail goto*//*Label 1761*/ GIMT_Encode4(96495), // Rule ID 4965 //
     /*  96432 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vldr_gather_offset),
     /*  96437 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  96440 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  96443 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  96446 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  96449 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  96452 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  96456 */     // MIs[0] base
     /*  96456 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/32,
     /*  96460 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  96464 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  96468 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 16,
     /*  96472 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  96476 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  96480 */     // (intrinsic_w_chain:{ *:[v8i16] } 3651:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v8i16] }:$offsets, 16:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VLDRHU16_rq:{ *:[v8i16] } GPR:{ *:[i32] }:$base, MQPR:{ *:[v8i16] }:$offsets)
     /*  96480 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VLDRHU16_rq),
     /*  96483 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  96485 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /*  96487 */     GIR_RootToRootCopy, /*OpIdx*/3, // offsets
     /*  96489 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  96493 */     GIR_RootConstrainSelectedInstOperands,
     /*  96494 */     // GIR_Coverage, 4965,
     /*  96494 */     GIR_EraseRootFromParent_Done,
     /*  96495 */   // Label 1761: @96495
     /*  96495 */   GIM_Try, /*On fail goto*//*Label 1762*/ GIMT_Encode4(96563), // Rule ID 4968 //
     /*  96500 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vldr_gather_offset),
     /*  96505 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  96508 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  96511 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  96514 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  96517 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  96520 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  96524 */     // MIs[0] base
     /*  96524 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/32,
     /*  96528 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  96532 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  96536 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 16,
     /*  96540 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  96544 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  96548 */     // (intrinsic_w_chain:{ *:[v8f16] } 3651:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v8i16] }:$offsets, 16:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VLDRHU16_rq_u:{ *:[v8f16] } GPR:{ *:[i32] }:$base, MQPR:{ *:[v8i16] }:$offsets)
     /*  96548 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VLDRHU16_rq_u),
     /*  96551 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  96553 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /*  96555 */     GIR_RootToRootCopy, /*OpIdx*/3, // offsets
     /*  96557 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  96561 */     GIR_RootConstrainSelectedInstOperands,
     /*  96562 */     // GIR_Coverage, 4968,
     /*  96562 */     GIR_EraseRootFromParent_Done,
     /*  96563 */   // Label 1762: @96563
     /*  96563 */   GIM_Try, /*On fail goto*//*Label 1763*/ GIMT_Encode4(96631), // Rule ID 4969 //
     /*  96568 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vldr_gather_offset),
     /*  96573 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  96576 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  96579 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  96582 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  96585 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  96588 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  96592 */     // MIs[0] base
     /*  96592 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/32,
     /*  96596 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  96600 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  96604 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 16,
     /*  96608 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  96612 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  96616 */     // (intrinsic_w_chain:{ *:[v8f16] } 3651:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v8i16] }:$offsets, 16:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VLDRHU16_rq:{ *:[v8f16] } GPR:{ *:[i32] }:$base, MQPR:{ *:[v8i16] }:$offsets)
     /*  96616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VLDRHU16_rq),
     /*  96619 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  96621 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /*  96623 */     GIR_RootToRootCopy, /*OpIdx*/3, // offsets
     /*  96625 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  96629 */     GIR_RootConstrainSelectedInstOperands,
     /*  96630 */     // GIR_Coverage, 4969,
     /*  96630 */     GIR_EraseRootFromParent_Done,
     /*  96631 */   // Label 1763: @96631
     /*  96631 */   GIM_Try, /*On fail goto*//*Label 1764*/ GIMT_Encode4(96699), // Rule ID 4972 //
     /*  96636 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vldr_gather_offset),
     /*  96641 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  96644 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  96647 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  96650 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  96653 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  96656 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  96660 */     // MIs[0] base
     /*  96660 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/32,
     /*  96664 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  96668 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  96672 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 16,
     /*  96676 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  96680 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  96684 */     // (intrinsic_w_chain:{ *:[v8f16] } 3651:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v8i16] }:$offsets, 16:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VLDRHU16_rq_u:{ *:[v8f16] } GPR:{ *:[i32] }:$base, MQPR:{ *:[v8i16] }:$offsets)
     /*  96684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VLDRHU16_rq_u),
     /*  96687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  96689 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /*  96691 */     GIR_RootToRootCopy, /*OpIdx*/3, // offsets
     /*  96693 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  96697 */     GIR_RootConstrainSelectedInstOperands,
     /*  96698 */     // GIR_Coverage, 4972,
     /*  96698 */     GIR_EraseRootFromParent_Done,
     /*  96699 */   // Label 1764: @96699
     /*  96699 */   GIM_Try, /*On fail goto*//*Label 1765*/ GIMT_Encode4(96767), // Rule ID 4973 //
     /*  96704 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vldr_gather_offset),
     /*  96709 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  96712 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  96715 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  96718 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  96721 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  96724 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  96728 */     // MIs[0] base
     /*  96728 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/32,
     /*  96732 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  96736 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  96740 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 16,
     /*  96744 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  96748 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  96752 */     // (intrinsic_w_chain:{ *:[v8f16] } 3651:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v8i16] }:$offsets, 16:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VLDRHU16_rq:{ *:[v8f16] } GPR:{ *:[i32] }:$base, MQPR:{ *:[v8i16] }:$offsets)
     /*  96752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VLDRHU16_rq),
     /*  96755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  96757 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /*  96759 */     GIR_RootToRootCopy, /*OpIdx*/3, // offsets
     /*  96761 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  96765 */     GIR_RootConstrainSelectedInstOperands,
     /*  96766 */     // GIR_Coverage, 4973,
     /*  96766 */     GIR_EraseRootFromParent_Done,
     /*  96767 */   // Label 1765: @96767
     /*  96767 */   GIM_Try, /*On fail goto*//*Label 1766*/ GIMT_Encode4(96835), // Rule ID 4976 //
     /*  96772 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vldr_gather_offset),
     /*  96777 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  96780 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  96783 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  96786 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  96789 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  96792 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  96796 */     // MIs[0] base
     /*  96796 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/32,
     /*  96800 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  96804 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  96808 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 16,
     /*  96812 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  96816 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  96820 */     // (intrinsic_w_chain:{ *:[v4i32] } 3651:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets, 16:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VLDRHU32_rq_u:{ *:[v4i32] } GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets)
     /*  96820 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VLDRHU32_rq_u),
     /*  96823 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  96825 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /*  96827 */     GIR_RootToRootCopy, /*OpIdx*/3, // offsets
     /*  96829 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  96833 */     GIR_RootConstrainSelectedInstOperands,
     /*  96834 */     // GIR_Coverage, 4976,
     /*  96834 */     GIR_EraseRootFromParent_Done,
     /*  96835 */   // Label 1766: @96835
     /*  96835 */   GIM_Try, /*On fail goto*//*Label 1767*/ GIMT_Encode4(96903), // Rule ID 4977 //
     /*  96840 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vldr_gather_offset),
     /*  96845 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  96848 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  96851 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  96854 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  96857 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  96860 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  96864 */     // MIs[0] base
     /*  96864 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/32,
     /*  96868 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  96872 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  96876 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 16,
     /*  96880 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  96884 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  96888 */     // (intrinsic_w_chain:{ *:[v4i32] } 3651:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets, 16:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VLDRHU32_rq:{ *:[v4i32] } GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets)
     /*  96888 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VLDRHU32_rq),
     /*  96891 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  96893 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /*  96895 */     GIR_RootToRootCopy, /*OpIdx*/3, // offsets
     /*  96897 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  96901 */     GIR_RootConstrainSelectedInstOperands,
     /*  96902 */     // GIR_Coverage, 4977,
     /*  96902 */     GIR_EraseRootFromParent_Done,
     /*  96903 */   // Label 1767: @96903
     /*  96903 */   GIM_Try, /*On fail goto*//*Label 1768*/ GIMT_Encode4(96971), // Rule ID 4980 //
     /*  96908 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vldr_gather_offset),
     /*  96913 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  96916 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  96919 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  96922 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  96925 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  96928 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  96932 */     // MIs[0] base
     /*  96932 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/32,
     /*  96936 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  96940 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  96944 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 16,
     /*  96948 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  96952 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  96956 */     // (intrinsic_w_chain:{ *:[v4i32] } 3651:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets, 16:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VLDRHS32_rq_u:{ *:[v4i32] } GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets)
     /*  96956 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VLDRHS32_rq_u),
     /*  96959 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  96961 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /*  96963 */     GIR_RootToRootCopy, /*OpIdx*/3, // offsets
     /*  96965 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  96969 */     GIR_RootConstrainSelectedInstOperands,
     /*  96970 */     // GIR_Coverage, 4980,
     /*  96970 */     GIR_EraseRootFromParent_Done,
     /*  96971 */   // Label 1768: @96971
     /*  96971 */   GIM_Try, /*On fail goto*//*Label 1769*/ GIMT_Encode4(97039), // Rule ID 4981 //
     /*  96976 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vldr_gather_offset),
     /*  96981 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  96984 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  96987 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  96990 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  96993 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  96996 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  97000 */     // MIs[0] base
     /*  97000 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/32,
     /*  97004 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  97008 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  97012 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 16,
     /*  97016 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  97020 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  97024 */     // (intrinsic_w_chain:{ *:[v4i32] } 3651:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets, 16:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VLDRHS32_rq:{ *:[v4i32] } GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets)
     /*  97024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VLDRHS32_rq),
     /*  97027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  97029 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /*  97031 */     GIR_RootToRootCopy, /*OpIdx*/3, // offsets
     /*  97033 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  97037 */     GIR_RootConstrainSelectedInstOperands,
     /*  97038 */     // GIR_Coverage, 4981,
     /*  97038 */     GIR_EraseRootFromParent_Done,
     /*  97039 */   // Label 1769: @97039
     /*  97039 */   GIM_Try, /*On fail goto*//*Label 1770*/ GIMT_Encode4(97107), // Rule ID 4984 //
     /*  97044 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vldr_gather_offset),
     /*  97049 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  97052 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  97055 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  97058 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  97061 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  97064 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  97068 */     // MIs[0] base
     /*  97068 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/32,
     /*  97072 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  97076 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  97080 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 32,
     /*  97084 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  97088 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  97092 */     // (intrinsic_w_chain:{ *:[v4i32] } 3651:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets, 32:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VLDRWU32_rq_u:{ *:[v4i32] } GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets)
     /*  97092 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VLDRWU32_rq_u),
     /*  97095 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  97097 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /*  97099 */     GIR_RootToRootCopy, /*OpIdx*/3, // offsets
     /*  97101 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  97105 */     GIR_RootConstrainSelectedInstOperands,
     /*  97106 */     // GIR_Coverage, 4984,
     /*  97106 */     GIR_EraseRootFromParent_Done,
     /*  97107 */   // Label 1770: @97107
     /*  97107 */   GIM_Try, /*On fail goto*//*Label 1771*/ GIMT_Encode4(97175), // Rule ID 4985 //
     /*  97112 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vldr_gather_offset),
     /*  97117 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  97120 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  97123 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  97126 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  97129 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  97132 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  97136 */     // MIs[0] base
     /*  97136 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/32,
     /*  97140 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  97144 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  97148 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 32,
     /*  97152 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 2,
     /*  97156 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  97160 */     // (intrinsic_w_chain:{ *:[v4i32] } 3651:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets, 32:{ *:[i32] }, 2:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VLDRWU32_rq:{ *:[v4i32] } GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets)
     /*  97160 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VLDRWU32_rq),
     /*  97163 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  97165 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /*  97167 */     GIR_RootToRootCopy, /*OpIdx*/3, // offsets
     /*  97169 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  97173 */     GIR_RootConstrainSelectedInstOperands,
     /*  97174 */     // GIR_Coverage, 4985,
     /*  97174 */     GIR_EraseRootFromParent_Done,
     /*  97175 */   // Label 1771: @97175
     /*  97175 */   GIM_Try, /*On fail goto*//*Label 1772*/ GIMT_Encode4(97243), // Rule ID 4988 //
     /*  97180 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vldr_gather_offset),
     /*  97185 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  97188 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  97191 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  97194 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  97197 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  97200 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  97204 */     // MIs[0] base
     /*  97204 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/32,
     /*  97208 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  97212 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  97216 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 32,
     /*  97220 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  97224 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  97228 */     // (intrinsic_w_chain:{ *:[v4i32] } 3651:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets, 32:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VLDRWU32_rq_u:{ *:[v4i32] } GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets)
     /*  97228 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VLDRWU32_rq_u),
     /*  97231 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  97233 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /*  97235 */     GIR_RootToRootCopy, /*OpIdx*/3, // offsets
     /*  97237 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  97241 */     GIR_RootConstrainSelectedInstOperands,
     /*  97242 */     // GIR_Coverage, 4988,
     /*  97242 */     GIR_EraseRootFromParent_Done,
     /*  97243 */   // Label 1772: @97243
     /*  97243 */   GIM_Try, /*On fail goto*//*Label 1773*/ GIMT_Encode4(97311), // Rule ID 4989 //
     /*  97248 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vldr_gather_offset),
     /*  97253 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  97256 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  97259 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  97262 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  97265 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  97268 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  97272 */     // MIs[0] base
     /*  97272 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/32,
     /*  97276 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  97280 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  97284 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 32,
     /*  97288 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 2,
     /*  97292 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  97296 */     // (intrinsic_w_chain:{ *:[v4i32] } 3651:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets, 32:{ *:[i32] }, 2:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VLDRWU32_rq:{ *:[v4i32] } GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets)
     /*  97296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VLDRWU32_rq),
     /*  97299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  97301 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /*  97303 */     GIR_RootToRootCopy, /*OpIdx*/3, // offsets
     /*  97305 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  97309 */     GIR_RootConstrainSelectedInstOperands,
     /*  97310 */     // GIR_Coverage, 4989,
     /*  97310 */     GIR_EraseRootFromParent_Done,
     /*  97311 */   // Label 1773: @97311
     /*  97311 */   GIM_Try, /*On fail goto*//*Label 1774*/ GIMT_Encode4(97379), // Rule ID 4992 //
     /*  97316 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vldr_gather_offset),
     /*  97321 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  97324 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  97327 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  97330 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  97333 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  97336 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  97340 */     // MIs[0] base
     /*  97340 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/32,
     /*  97344 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  97348 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  97352 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 32,
     /*  97356 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  97360 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  97364 */     // (intrinsic_w_chain:{ *:[v4i32] } 3651:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets, 32:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VLDRWU32_rq_u:{ *:[v4i32] } GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets)
     /*  97364 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VLDRWU32_rq_u),
     /*  97367 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  97369 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /*  97371 */     GIR_RootToRootCopy, /*OpIdx*/3, // offsets
     /*  97373 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  97377 */     GIR_RootConstrainSelectedInstOperands,
     /*  97378 */     // GIR_Coverage, 4992,
     /*  97378 */     GIR_EraseRootFromParent_Done,
     /*  97379 */   // Label 1774: @97379
     /*  97379 */   GIM_Try, /*On fail goto*//*Label 1775*/ GIMT_Encode4(97447), // Rule ID 4993 //
     /*  97384 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vldr_gather_offset),
     /*  97389 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  97392 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  97395 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  97398 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  97401 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  97404 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  97408 */     // MIs[0] base
     /*  97408 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/32,
     /*  97412 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  97416 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  97420 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 32,
     /*  97424 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 2,
     /*  97428 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  97432 */     // (intrinsic_w_chain:{ *:[v4i32] } 3651:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets, 32:{ *:[i32] }, 2:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VLDRWU32_rq:{ *:[v4i32] } GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets)
     /*  97432 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VLDRWU32_rq),
     /*  97435 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  97437 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /*  97439 */     GIR_RootToRootCopy, /*OpIdx*/3, // offsets
     /*  97441 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  97445 */     GIR_RootConstrainSelectedInstOperands,
     /*  97446 */     // GIR_Coverage, 4993,
     /*  97446 */     GIR_EraseRootFromParent_Done,
     /*  97447 */   // Label 1775: @97447
     /*  97447 */   GIM_Try, /*On fail goto*//*Label 1776*/ GIMT_Encode4(97515), // Rule ID 4996 //
     /*  97452 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vldr_gather_offset),
     /*  97457 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  97460 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  97463 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  97466 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  97469 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  97472 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  97476 */     // MIs[0] base
     /*  97476 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/32,
     /*  97480 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  97484 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  97488 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 32,
     /*  97492 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  97496 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  97500 */     // (intrinsic_w_chain:{ *:[v4i32] } 3651:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets, 32:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VLDRWU32_rq_u:{ *:[v4i32] } GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets)
     /*  97500 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VLDRWU32_rq_u),
     /*  97503 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  97505 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /*  97507 */     GIR_RootToRootCopy, /*OpIdx*/3, // offsets
     /*  97509 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  97513 */     GIR_RootConstrainSelectedInstOperands,
     /*  97514 */     // GIR_Coverage, 4996,
     /*  97514 */     GIR_EraseRootFromParent_Done,
     /*  97515 */   // Label 1776: @97515
     /*  97515 */   GIM_Try, /*On fail goto*//*Label 1777*/ GIMT_Encode4(97583), // Rule ID 4997 //
     /*  97520 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vldr_gather_offset),
     /*  97525 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  97528 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  97531 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  97534 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  97537 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  97540 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  97544 */     // MIs[0] base
     /*  97544 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/32,
     /*  97548 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  97552 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  97556 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 32,
     /*  97560 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 2,
     /*  97564 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  97568 */     // (intrinsic_w_chain:{ *:[v4i32] } 3651:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets, 32:{ *:[i32] }, 2:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VLDRWU32_rq:{ *:[v4i32] } GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets)
     /*  97568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VLDRWU32_rq),
     /*  97571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  97573 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /*  97575 */     GIR_RootToRootCopy, /*OpIdx*/3, // offsets
     /*  97577 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  97581 */     GIR_RootConstrainSelectedInstOperands,
     /*  97582 */     // GIR_Coverage, 4997,
     /*  97582 */     GIR_EraseRootFromParent_Done,
     /*  97583 */   // Label 1777: @97583
     /*  97583 */   GIM_Try, /*On fail goto*//*Label 1778*/ GIMT_Encode4(97651), // Rule ID 5000 //
     /*  97588 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vldr_gather_offset),
     /*  97593 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  97596 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  97599 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  97602 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  97605 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  97608 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  97612 */     // MIs[0] base
     /*  97612 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/32,
     /*  97616 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  97620 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  97624 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 32,
     /*  97628 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  97632 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  97636 */     // (intrinsic_w_chain:{ *:[v4f32] } 3651:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets, 32:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VLDRWU32_rq_u:{ *:[v4f32] } GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets)
     /*  97636 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VLDRWU32_rq_u),
     /*  97639 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  97641 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /*  97643 */     GIR_RootToRootCopy, /*OpIdx*/3, // offsets
     /*  97645 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  97649 */     GIR_RootConstrainSelectedInstOperands,
     /*  97650 */     // GIR_Coverage, 5000,
     /*  97650 */     GIR_EraseRootFromParent_Done,
     /*  97651 */   // Label 1778: @97651
     /*  97651 */   GIM_Try, /*On fail goto*//*Label 1779*/ GIMT_Encode4(97719), // Rule ID 5001 //
     /*  97656 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vldr_gather_offset),
     /*  97661 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  97664 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  97667 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  97670 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  97673 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  97676 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  97680 */     // MIs[0] base
     /*  97680 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/32,
     /*  97684 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  97688 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  97692 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 32,
     /*  97696 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 2,
     /*  97700 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  97704 */     // (intrinsic_w_chain:{ *:[v4f32] } 3651:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets, 32:{ *:[i32] }, 2:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VLDRWU32_rq:{ *:[v4f32] } GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets)
     /*  97704 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VLDRWU32_rq),
     /*  97707 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  97709 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /*  97711 */     GIR_RootToRootCopy, /*OpIdx*/3, // offsets
     /*  97713 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  97717 */     GIR_RootConstrainSelectedInstOperands,
     /*  97718 */     // GIR_Coverage, 5001,
     /*  97718 */     GIR_EraseRootFromParent_Done,
     /*  97719 */   // Label 1779: @97719
     /*  97719 */   GIM_Try, /*On fail goto*//*Label 1780*/ GIMT_Encode4(97787), // Rule ID 5004 //
     /*  97724 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vldr_gather_offset),
     /*  97729 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  97732 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  97735 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  97738 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  97741 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  97744 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  97748 */     // MIs[0] base
     /*  97748 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/32,
     /*  97752 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  97756 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  97760 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 32,
     /*  97764 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  97768 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  97772 */     // (intrinsic_w_chain:{ *:[v4f32] } 3651:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets, 32:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VLDRWU32_rq_u:{ *:[v4f32] } GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets)
     /*  97772 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VLDRWU32_rq_u),
     /*  97775 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  97777 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /*  97779 */     GIR_RootToRootCopy, /*OpIdx*/3, // offsets
     /*  97781 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  97785 */     GIR_RootConstrainSelectedInstOperands,
     /*  97786 */     // GIR_Coverage, 5004,
     /*  97786 */     GIR_EraseRootFromParent_Done,
     /*  97787 */   // Label 1780: @97787
     /*  97787 */   GIM_Try, /*On fail goto*//*Label 1781*/ GIMT_Encode4(97855), // Rule ID 5005 //
     /*  97792 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vldr_gather_offset),
     /*  97797 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  97800 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  97803 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  97806 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  97809 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  97812 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  97816 */     // MIs[0] base
     /*  97816 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/32,
     /*  97820 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  97824 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  97828 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 32,
     /*  97832 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 2,
     /*  97836 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  97840 */     // (intrinsic_w_chain:{ *:[v4f32] } 3651:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets, 32:{ *:[i32] }, 2:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VLDRWU32_rq:{ *:[v4f32] } GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets)
     /*  97840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VLDRWU32_rq),
     /*  97843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  97845 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /*  97847 */     GIR_RootToRootCopy, /*OpIdx*/3, // offsets
     /*  97849 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  97853 */     GIR_RootConstrainSelectedInstOperands,
     /*  97854 */     // GIR_Coverage, 5005,
     /*  97854 */     GIR_EraseRootFromParent_Done,
     /*  97855 */   // Label 1781: @97855
     /*  97855 */   GIM_Try, /*On fail goto*//*Label 1782*/ GIMT_Encode4(97923), // Rule ID 5008 //
     /*  97860 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vldr_gather_offset),
     /*  97865 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  97868 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  97871 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  97874 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  97877 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  97880 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  97884 */     // MIs[0] base
     /*  97884 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/32,
     /*  97888 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  97892 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  97896 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 64,
     /*  97900 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  97904 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  97908 */     // (intrinsic_w_chain:{ *:[v2i64] } 3651:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v2i64] }:$offsets, 64:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VLDRDU64_rq_u:{ *:[v2i64] } GPR:{ *:[i32] }:$base, MQPR:{ *:[v2i64] }:$offsets)
     /*  97908 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VLDRDU64_rq_u),
     /*  97911 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  97913 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /*  97915 */     GIR_RootToRootCopy, /*OpIdx*/3, // offsets
     /*  97917 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  97921 */     GIR_RootConstrainSelectedInstOperands,
     /*  97922 */     // GIR_Coverage, 5008,
     /*  97922 */     GIR_EraseRootFromParent_Done,
     /*  97923 */   // Label 1782: @97923
     /*  97923 */   GIM_Try, /*On fail goto*//*Label 1783*/ GIMT_Encode4(97991), // Rule ID 5009 //
     /*  97928 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vldr_gather_offset),
     /*  97933 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  97936 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  97939 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  97942 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  97945 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  97948 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  97952 */     // MIs[0] base
     /*  97952 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/32,
     /*  97956 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  97960 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  97964 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 64,
     /*  97968 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 3,
     /*  97972 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  97976 */     // (intrinsic_w_chain:{ *:[v2i64] } 3651:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v2i64] }:$offsets, 64:{ *:[i32] }, 3:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VLDRDU64_rq:{ *:[v2i64] } GPR:{ *:[i32] }:$base, MQPR:{ *:[v2i64] }:$offsets)
     /*  97976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VLDRDU64_rq),
     /*  97979 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  97981 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /*  97983 */     GIR_RootToRootCopy, /*OpIdx*/3, // offsets
     /*  97985 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  97989 */     GIR_RootConstrainSelectedInstOperands,
     /*  97990 */     // GIR_Coverage, 5009,
     /*  97990 */     GIR_EraseRootFromParent_Done,
     /*  97991 */   // Label 1783: @97991
     /*  97991 */   GIM_Try, /*On fail goto*//*Label 1784*/ GIMT_Encode4(98059), // Rule ID 5012 //
     /*  97996 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vldr_gather_offset),
     /*  98001 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  98004 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  98007 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  98010 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  98013 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  98016 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  98020 */     // MIs[0] base
     /*  98020 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/32,
     /*  98024 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  98028 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  98032 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 64,
     /*  98036 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  98040 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  98044 */     // (intrinsic_w_chain:{ *:[v2i64] } 3651:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v2i64] }:$offsets, 64:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VLDRDU64_rq_u:{ *:[v2i64] } GPR:{ *:[i32] }:$base, MQPR:{ *:[v2i64] }:$offsets)
     /*  98044 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VLDRDU64_rq_u),
     /*  98047 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  98049 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /*  98051 */     GIR_RootToRootCopy, /*OpIdx*/3, // offsets
     /*  98053 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  98057 */     GIR_RootConstrainSelectedInstOperands,
     /*  98058 */     // GIR_Coverage, 5012,
     /*  98058 */     GIR_EraseRootFromParent_Done,
     /*  98059 */   // Label 1784: @98059
     /*  98059 */   GIM_Try, /*On fail goto*//*Label 1785*/ GIMT_Encode4(98127), // Rule ID 5013 //
     /*  98064 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vldr_gather_offset),
     /*  98069 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  98072 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  98075 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  98078 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  98081 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  98084 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  98088 */     // MIs[0] base
     /*  98088 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/32,
     /*  98092 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  98096 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  98100 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 64,
     /*  98104 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 3,
     /*  98108 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  98112 */     // (intrinsic_w_chain:{ *:[v2i64] } 3651:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v2i64] }:$offsets, 64:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VLDRDU64_rq:{ *:[v2i64] } GPR:{ *:[i32] }:$base, MQPR:{ *:[v2i64] }:$offsets)
     /*  98112 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VLDRDU64_rq),
     /*  98115 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  98117 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /*  98119 */     GIR_RootToRootCopy, /*OpIdx*/3, // offsets
     /*  98121 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  98125 */     GIR_RootConstrainSelectedInstOperands,
     /*  98126 */     // GIR_Coverage, 5013,
     /*  98126 */     GIR_EraseRootFromParent_Done,
     /*  98127 */   // Label 1785: @98127
     /*  98127 */   GIM_Try, /*On fail goto*//*Label 1786*/ GIMT_Encode4(98195), // Rule ID 5016 //
     /*  98132 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vldr_gather_offset),
     /*  98137 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  98140 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  98143 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  98146 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  98149 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  98152 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  98156 */     // MIs[0] base
     /*  98156 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/32,
     /*  98160 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  98164 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  98168 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 64,
     /*  98172 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  98176 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  98180 */     // (intrinsic_w_chain:{ *:[v2i64] } 3651:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v2i64] }:$offsets, 64:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VLDRDU64_rq_u:{ *:[v2i64] } GPR:{ *:[i32] }:$base, MQPR:{ *:[v2i64] }:$offsets)
     /*  98180 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VLDRDU64_rq_u),
     /*  98183 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  98185 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /*  98187 */     GIR_RootToRootCopy, /*OpIdx*/3, // offsets
     /*  98189 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  98193 */     GIR_RootConstrainSelectedInstOperands,
     /*  98194 */     // GIR_Coverage, 5016,
     /*  98194 */     GIR_EraseRootFromParent_Done,
     /*  98195 */   // Label 1786: @98195
     /*  98195 */   GIM_Try, /*On fail goto*//*Label 1787*/ GIMT_Encode4(98263), // Rule ID 5017 //
     /*  98200 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vldr_gather_offset),
     /*  98205 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  98208 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  98211 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  98214 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  98217 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  98220 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  98224 */     // MIs[0] base
     /*  98224 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/32,
     /*  98228 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  98232 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  98236 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 64,
     /*  98240 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 3,
     /*  98244 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  98248 */     // (intrinsic_w_chain:{ *:[v2i64] } 3651:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v2i64] }:$offsets, 64:{ *:[i32] }, 3:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VLDRDU64_rq:{ *:[v2i64] } GPR:{ *:[i32] }:$base, MQPR:{ *:[v2i64] }:$offsets)
     /*  98248 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VLDRDU64_rq),
     /*  98251 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  98253 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /*  98255 */     GIR_RootToRootCopy, /*OpIdx*/3, // offsets
     /*  98257 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  98261 */     GIR_RootConstrainSelectedInstOperands,
     /*  98262 */     // GIR_Coverage, 5017,
     /*  98262 */     GIR_EraseRootFromParent_Done,
     /*  98263 */   // Label 1787: @98263
     /*  98263 */   GIM_Try, /*On fail goto*//*Label 1788*/ GIMT_Encode4(98331), // Rule ID 5020 //
     /*  98268 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vldr_gather_offset),
     /*  98273 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  98276 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  98279 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  98282 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  98285 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  98288 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  98292 */     // MIs[0] base
     /*  98292 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/32,
     /*  98296 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  98300 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  98304 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 64,
     /*  98308 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  98312 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  98316 */     // (intrinsic_w_chain:{ *:[v2i64] } 3651:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v2i64] }:$offsets, 64:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VLDRDU64_rq_u:{ *:[v2i64] } GPR:{ *:[i32] }:$base, MQPR:{ *:[v2i64] }:$offsets)
     /*  98316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VLDRDU64_rq_u),
     /*  98319 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  98321 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /*  98323 */     GIR_RootToRootCopy, /*OpIdx*/3, // offsets
     /*  98325 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  98329 */     GIR_RootConstrainSelectedInstOperands,
     /*  98330 */     // GIR_Coverage, 5020,
     /*  98330 */     GIR_EraseRootFromParent_Done,
     /*  98331 */   // Label 1788: @98331
     /*  98331 */   GIM_Try, /*On fail goto*//*Label 1789*/ GIMT_Encode4(98399), // Rule ID 5021 //
     /*  98336 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vldr_gather_offset),
     /*  98341 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  98344 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  98347 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  98350 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  98353 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  98356 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  98360 */     // MIs[0] base
     /*  98360 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/32,
     /*  98364 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  98368 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  98372 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 64,
     /*  98376 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 3,
     /*  98380 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  98384 */     // (intrinsic_w_chain:{ *:[v2i64] } 3651:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v2i64] }:$offsets, 64:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VLDRDU64_rq:{ *:[v2i64] } GPR:{ *:[i32] }:$base, MQPR:{ *:[v2i64] }:$offsets)
     /*  98384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VLDRDU64_rq),
     /*  98387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  98389 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /*  98391 */     GIR_RootToRootCopy, /*OpIdx*/3, // offsets
     /*  98393 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  98397 */     GIR_RootConstrainSelectedInstOperands,
     /*  98398 */     // GIR_Coverage, 5021,
     /*  98398 */     GIR_EraseRootFromParent_Done,
     /*  98399 */   // Label 1789: @98399
     /*  98399 */   GIM_Try, /*On fail goto*//*Label 1790*/ GIMT_Encode4(98464), // Rule ID 256 //
     /*  98404 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  98407 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_mcr),
     /*  98412 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  98415 */     // MIs[0] cop
     /*  98415 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /*  98418 */     // MIs[0] opc1
     /*  98418 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  98421 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  98425 */     // MIs[0] CRn
     /*  98425 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  98428 */     // MIs[0] CRm
     /*  98428 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  98431 */     // MIs[0] opc2
     /*  98431 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  98434 */     // (intrinsic_void 3526:{ *:[iPTR] }, (timm:{ *:[i32] }):$cop, (timm:{ *:[i32] }):$opc1, GPR:{ *:[i32] }:$Rt, (timm:{ *:[i32] }):$CRn, (timm:{ *:[i32] }):$CRm, (timm:{ *:[i32] }):$opc2)  =>  (MCR (timm:{ *:[i32] }):$cop, (timm:{ *:[i32] }):$opc1, GPR:{ *:[i32] }:$Rt, (timm:{ *:[i32] }):$CRn, (timm:{ *:[i32] }):$CRm, (timm:{ *:[i32] }):$opc2)
     /*  98434 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MCR),
     /*  98437 */     GIR_RootToRootCopy, /*OpIdx*/1, // cop
     /*  98439 */     GIR_RootToRootCopy, /*OpIdx*/2, // opc1
     /*  98441 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rt
     /*  98443 */     GIR_RootToRootCopy, /*OpIdx*/4, // CRn
     /*  98445 */     GIR_RootToRootCopy, /*OpIdx*/5, // CRm
     /*  98447 */     GIR_RootToRootCopy, /*OpIdx*/6, // opc2
     /*  98449 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  98452 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  98458 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  98462 */     GIR_RootConstrainSelectedInstOperands,
     /*  98463 */     // GIR_Coverage, 256,
     /*  98463 */     GIR_EraseRootFromParent_Done,
     /*  98464 */   // Label 1790: @98464
     /*  98464 */   GIM_Try, /*On fail goto*//*Label 1791*/ GIMT_Encode4(98520), // Rule ID 257 //
     /*  98469 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM_PreV8),
     /*  98472 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_mcr2),
     /*  98477 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  98480 */     // MIs[0] cop
     /*  98480 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /*  98483 */     // MIs[0] opc1
     /*  98483 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  98486 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  98490 */     // MIs[0] CRn
     /*  98490 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  98493 */     // MIs[0] CRm
     /*  98493 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  98496 */     // MIs[0] opc2
     /*  98496 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  98499 */     // (intrinsic_void 3527:{ *:[iPTR] }, (timm:{ *:[i32] }):$cop, (timm:{ *:[i32] }):$opc1, GPR:{ *:[i32] }:$Rt, (timm:{ *:[i32] }):$CRn, (timm:{ *:[i32] }):$CRm, (timm:{ *:[i32] }):$opc2)  =>  (MCR2 (timm:{ *:[i32] }):$cop, (timm:{ *:[i32] }):$opc1, GPR:{ *:[i32] }:$Rt, (timm:{ *:[i32] }):$CRn, (timm:{ *:[i32] }):$CRm, (timm:{ *:[i32] }):$opc2)
     /*  98499 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MCR2),
     /*  98502 */     GIR_RootToRootCopy, /*OpIdx*/1, // cop
     /*  98504 */     GIR_RootToRootCopy, /*OpIdx*/2, // opc1
     /*  98506 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rt
     /*  98508 */     GIR_RootToRootCopy, /*OpIdx*/4, // CRn
     /*  98510 */     GIR_RootToRootCopy, /*OpIdx*/5, // CRm
     /*  98512 */     GIR_RootToRootCopy, /*OpIdx*/6, // opc2
     /*  98514 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  98518 */     GIR_RootConstrainSelectedInstOperands,
     /*  98519 */     // GIR_Coverage, 257,
     /*  98519 */     GIR_EraseRootFromParent_Done,
     /*  98520 */   // Label 1791: @98520
     /*  98520 */   GIM_Try, /*On fail goto*//*Label 1792*/ GIMT_Encode4(98585), // Rule ID 594 //
     /*  98525 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /*  98528 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_mcr),
     /*  98533 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  98536 */     // MIs[0] cop
     /*  98536 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /*  98539 */     // MIs[0] opc1
     /*  98539 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  98542 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  98546 */     // MIs[0] CRn
     /*  98546 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  98549 */     // MIs[0] CRm
     /*  98549 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  98552 */     // MIs[0] opc2
     /*  98552 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  98555 */     // (intrinsic_void 3526:{ *:[iPTR] }, (timm:{ *:[i32] }):$cop, (timm:{ *:[i32] }):$opc1, GPR:{ *:[i32] }:$Rt, (timm:{ *:[i32] }):$CRn, (timm:{ *:[i32] }):$CRm, (timm:{ *:[i32] }):$opc2)  =>  (t2MCR (timm:{ *:[i32] }):$cop, (timm:{ *:[i32] }):$opc1, GPR:{ *:[i32] }:$Rt, (timm:{ *:[i32] }):$CRn, (timm:{ *:[i32] }):$CRm, (timm:{ *:[i32] }):$opc2)
     /*  98555 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2MCR),
     /*  98558 */     GIR_RootToRootCopy, /*OpIdx*/1, // cop
     /*  98560 */     GIR_RootToRootCopy, /*OpIdx*/2, // opc1
     /*  98562 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rt
     /*  98564 */     GIR_RootToRootCopy, /*OpIdx*/4, // CRn
     /*  98566 */     GIR_RootToRootCopy, /*OpIdx*/5, // CRm
     /*  98568 */     GIR_RootToRootCopy, /*OpIdx*/6, // opc2
     /*  98570 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  98573 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  98579 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  98583 */     GIR_RootConstrainSelectedInstOperands,
     /*  98584 */     // GIR_Coverage, 594,
     /*  98584 */     GIR_EraseRootFromParent_Done,
     /*  98585 */   // Label 1792: @98585
     /*  98585 */   GIM_Try, /*On fail goto*//*Label 1793*/ GIMT_Encode4(98650), // Rule ID 595 //
     /*  98590 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2_PreV8),
     /*  98593 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_mcr2),
     /*  98598 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  98601 */     // MIs[0] cop
     /*  98601 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /*  98604 */     // MIs[0] opc1
     /*  98604 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  98607 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  98611 */     // MIs[0] CRn
     /*  98611 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  98614 */     // MIs[0] CRm
     /*  98614 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  98617 */     // MIs[0] opc2
     /*  98617 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  98620 */     // (intrinsic_void 3527:{ *:[iPTR] }, (timm:{ *:[i32] }):$cop, (timm:{ *:[i32] }):$opc1, GPR:{ *:[i32] }:$Rt, (timm:{ *:[i32] }):$CRn, (timm:{ *:[i32] }):$CRm, (timm:{ *:[i32] }):$opc2)  =>  (t2MCR2 (timm:{ *:[i32] }):$cop, (timm:{ *:[i32] }):$opc1, GPR:{ *:[i32] }:$Rt, (timm:{ *:[i32] }):$CRn, (timm:{ *:[i32] }):$CRm, (timm:{ *:[i32] }):$opc2)
     /*  98620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2MCR2),
     /*  98623 */     GIR_RootToRootCopy, /*OpIdx*/1, // cop
     /*  98625 */     GIR_RootToRootCopy, /*OpIdx*/2, // opc1
     /*  98627 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rt
     /*  98629 */     GIR_RootToRootCopy, /*OpIdx*/4, // CRn
     /*  98631 */     GIR_RootToRootCopy, /*OpIdx*/5, // CRm
     /*  98633 */     GIR_RootToRootCopy, /*OpIdx*/6, // opc2
     /*  98635 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  98638 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  98644 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  98648 */     GIR_RootConstrainSelectedInstOperands,
     /*  98649 */     // GIR_Coverage, 595,
     /*  98649 */     GIR_EraseRootFromParent_Done,
     /*  98650 */   // Label 1793: @98650
     /*  98650 */   GIM_Reject,
     /*  98651 */ // Label 1743: @98651
     /*  98651 */ GIM_Reject,
     /*  98652 */ // Label 17: @98652
     /*  98652 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(5), GIMT_Encode2(13), /*)*//*default:*//*Label 1797*/ GIMT_Encode4(98809),
     /*  98663 */ /*GILLT_v2s64*//*Label 1794*/ GIMT_Encode4(98695), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  98675 */ /*GILLT_v4s32*//*Label 1795*/ GIMT_Encode4(98733), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  98691 */ /*GILLT_v8s16*//*Label 1796*/ GIMT_Encode4(98771),
     /*  98695 */ // Label 1794: @98695
     /*  98695 */ GIM_Try, /*On fail goto*//*Label 1798*/ GIMT_Encode4(98732), // Rule ID 2665 //
     /*  98700 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  98703 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  98706 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  98710 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  98714 */   // (anyext:{ *:[v2i64] } DPR:{ *:[v2i32] }:$Vm)  =>  (VMOVLuv2i64:{ *:[v2i64] } DPR:{ *:[v2i32] }:$Vm)
     /*  98714 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMOVLuv2i64),
     /*  98717 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  98719 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /*  98721 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  98724 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  98730 */   GIR_RootConstrainSelectedInstOperands,
     /*  98731 */   // GIR_Coverage, 2665,
     /*  98731 */   GIR_EraseRootFromParent_Done,
     /*  98732 */ // Label 1798: @98732
     /*  98732 */ GIM_Reject,
     /*  98733 */ // Label 1795: @98733
     /*  98733 */ GIM_Try, /*On fail goto*//*Label 1799*/ GIMT_Encode4(98770), // Rule ID 2664 //
     /*  98738 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  98741 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  98744 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  98748 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  98752 */   // (anyext:{ *:[v4i32] } DPR:{ *:[v4i16] }:$Vm)  =>  (VMOVLuv4i32:{ *:[v4i32] } DPR:{ *:[v4i16] }:$Vm)
     /*  98752 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMOVLuv4i32),
     /*  98755 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  98757 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /*  98759 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  98762 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  98768 */   GIR_RootConstrainSelectedInstOperands,
     /*  98769 */   // GIR_Coverage, 2664,
     /*  98769 */   GIR_EraseRootFromParent_Done,
     /*  98770 */ // Label 1799: @98770
     /*  98770 */ GIM_Reject,
     /*  98771 */ // Label 1796: @98771
     /*  98771 */ GIM_Try, /*On fail goto*//*Label 1800*/ GIMT_Encode4(98808), // Rule ID 2663 //
     /*  98776 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  98779 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  98782 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  98786 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  98790 */   // (anyext:{ *:[v8i16] } DPR:{ *:[v8i8] }:$Vm)  =>  (VMOVLuv8i16:{ *:[v8i16] } DPR:{ *:[v8i8] }:$Vm)
     /*  98790 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMOVLuv8i16),
     /*  98793 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  98795 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /*  98797 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  98800 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  98806 */   GIR_RootConstrainSelectedInstOperands,
     /*  98807 */   // GIR_Coverage, 2663,
     /*  98807 */   GIR_EraseRootFromParent_Done,
     /*  98808 */ // Label 1800: @98808
     /*  98808 */ GIM_Reject,
     /*  98809 */ // Label 1797: @98809
     /*  98809 */ GIM_Reject,
     /*  98810 */ // Label 18: @98810
     /*  98810 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(4), GIMT_Encode2(12), /*)*//*default:*//*Label 1804*/ GIMT_Encode4(98967),
     /*  98821 */ /*GILLT_v2s32*//*Label 1801*/ GIMT_Encode4(98853), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  98833 */ /*GILLT_v4s16*//*Label 1802*/ GIMT_Encode4(98891), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  98849 */ /*GILLT_v8s8*//*Label 1803*/ GIMT_Encode4(98929),
     /*  98853 */ // Label 1801: @98853
     /*  98853 */ GIM_Try, /*On fail goto*//*Label 1805*/ GIMT_Encode4(98890), // Rule ID 1585 //
     /*  98858 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  98861 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  98864 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  98868 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  98872 */   // (trunc:{ *:[v2i32] } QPR:{ *:[v2i64] }:$Vm)  =>  (VMOVNv2i32:{ *:[v2i32] } QPR:{ *:[v2i64] }:$Vm)
     /*  98872 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMOVNv2i32),
     /*  98875 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  98877 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /*  98879 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  98882 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  98888 */   GIR_RootConstrainSelectedInstOperands,
     /*  98889 */   // GIR_Coverage, 1585,
     /*  98889 */   GIR_EraseRootFromParent_Done,
     /*  98890 */ // Label 1805: @98890
     /*  98890 */ GIM_Reject,
     /*  98891 */ // Label 1802: @98891
     /*  98891 */ GIM_Try, /*On fail goto*//*Label 1806*/ GIMT_Encode4(98928), // Rule ID 1584 //
     /*  98896 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  98899 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  98902 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  98906 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  98910 */   // (trunc:{ *:[v4i16] } QPR:{ *:[v4i32] }:$Vm)  =>  (VMOVNv4i16:{ *:[v4i16] } QPR:{ *:[v4i32] }:$Vm)
     /*  98910 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMOVNv4i16),
     /*  98913 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  98915 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /*  98917 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  98920 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  98926 */   GIR_RootConstrainSelectedInstOperands,
     /*  98927 */   // GIR_Coverage, 1584,
     /*  98927 */   GIR_EraseRootFromParent_Done,
     /*  98928 */ // Label 1806: @98928
     /*  98928 */ GIM_Reject,
     /*  98929 */ // Label 1803: @98929
     /*  98929 */ GIM_Try, /*On fail goto*//*Label 1807*/ GIMT_Encode4(98966), // Rule ID 1583 //
     /*  98934 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  98937 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  98940 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  98944 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  98948 */   // (trunc:{ *:[v8i8] } QPR:{ *:[v8i16] }:$Vm)  =>  (VMOVNv8i8:{ *:[v8i8] } QPR:{ *:[v8i16] }:$Vm)
     /*  98948 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMOVNv8i8),
     /*  98951 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  98953 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /*  98955 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  98958 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  98964 */   GIR_RootConstrainSelectedInstOperands,
     /*  98965 */   // GIR_Coverage, 1583,
     /*  98965 */   GIR_EraseRootFromParent_Done,
     /*  98966 */ // Label 1807: @98966
     /*  98966 */ GIM_Reject,
     /*  98967 */ // Label 1804: @98967
     /*  98967 */ GIM_Reject,
     /*  98968 */ // Label 19: @98968
     /*  98968 */ GIM_Try, /*On fail goto*//*Label 1808*/ GIMT_Encode4(99288),
     /*  98973 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  98976 */   GIM_Try, /*On fail goto*//*Label 1809*/ GIMT_Encode4(99017), // Rule ID 404 //
     /*  98981 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /*  98984 */     GIM_CheckI64ImmPredicate, /*MI*/0, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_t2_so_imm),
     /*  98988 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  98992 */     // MIs[0] Operand 1
     /*  98992 */     // No operand predicates
     /*  98992 */     // (imm:{ *:[i32] })<<P:Predicate_t2_so_imm>>:$imm  =>  (t2MOVi:{ *:[i32] } (imm:{ *:[i32] }):$imm)
     /*  98992 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2MOVi),
     /*  98995 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  98997 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/0, // imm
     /*  99000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  99003 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  99009 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  99015 */     GIR_RootConstrainSelectedInstOperands,
     /*  99016 */     // GIR_Coverage, 404,
     /*  99016 */     GIR_EraseRootFromParent_Done,
     /*  99017 */   // Label 1809: @99017
     /*  99017 */   GIM_Try, /*On fail goto*//*Label 1810*/ GIMT_Encode4(99058), // Rule ID 57 //
     /*  99022 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  99025 */     GIM_CheckI64ImmPredicate, /*MI*/0, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_mod_imm),
     /*  99029 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  99033 */     // MIs[0] Operand 1
     /*  99033 */     // No operand predicates
     /*  99033 */     // (imm:{ *:[i32] })<<P:Predicate_mod_imm>>:$imm  =>  (MOVi:{ *:[i32] } (imm:{ *:[i32] }):$imm)
     /*  99033 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MOVi),
     /*  99036 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  99038 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/0, // imm
     /*  99041 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  99044 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  99050 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  99056 */     GIR_RootConstrainSelectedInstOperands,
     /*  99057 */     // GIR_Coverage, 57,
     /*  99057 */     GIR_EraseRootFromParent_Done,
     /*  99058 */   // Label 1810: @99058
     /*  99058 */   GIM_Try, /*On fail goto*//*Label 1811*/ GIMT_Encode4(99093), // Rule ID 58 //
     /*  99063 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6T2_IsARM),
     /*  99066 */     GIM_CheckI64ImmPredicate, /*MI*/0, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_65535),
     /*  99070 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  99074 */     // MIs[0] Operand 1
     /*  99074 */     // No operand predicates
     /*  99074 */     // (imm:{ *:[i32] })<<P:Predicate_imm0_65535>>:$imm  =>  (MOVi16:{ *:[i32] } (imm:{ *:[i32] }):$imm)
     /*  99074 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MOVi16),
     /*  99077 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  99079 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/0, // imm
     /*  99082 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  99085 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  99091 */     GIR_RootConstrainSelectedInstOperands,
     /*  99092 */     // GIR_Coverage, 58,
     /*  99092 */     GIR_EraseRootFromParent_Done,
     /*  99093 */   // Label 1811: @99093
     /*  99093 */   GIM_Try, /*On fail goto*//*Label 1812*/ GIMT_Encode4(99136), // Rule ID 168 //
     /*  99098 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  99101 */     GIM_CheckI64ImmPredicate, /*MI*/0, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_mod_imm_not),
     /*  99105 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  99109 */     // MIs[0] Operand 1
     /*  99109 */     // No operand predicates
     /*  99109 */     // (imm:{ *:[i32] })<<P:Predicate_mod_imm_not>><<X:imm_not_XFORM>>:$imm  =>  (MVNi:{ *:[i32] } (imm_not_XFORM:{ *:[i32] } (imm:{ *:[i32] }):$imm))
     /*  99109 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVNi),
     /*  99112 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  99114 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/0, /*Renderer*/GIMT_Encode2(GICR_renderInvertedImm), // imm
     /*  99119 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  99122 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  99128 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  99134 */     GIR_RootConstrainSelectedInstOperands,
     /*  99135 */     // GIR_Coverage, 168,
     /*  99135 */     GIR_EraseRootFromParent_Done,
     /*  99136 */   // Label 1812: @99136
     /*  99136 */   GIM_Try, /*On fail goto*//*Label 1813*/ GIMT_Encode4(99162), // Rule ID 268 //
     /*  99141 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  99144 */     GIM_CheckAPIntImmPredicate, /*MI*/0, /*Predicate*/GIMT_Encode2(GICXXPred_APInt_Predicate_arm_i32imm),
     /*  99148 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  99152 */     // MIs[0] Operand 1
     /*  99152 */     // No operand predicates
     /*  99152 */     // (imm:{ *:[i32] })<<P:Predicate_arm_i32imm>>:$src  =>  (MOVi32imm:{ *:[i32] } (imm:{ *:[i32] }):$src)
     /*  99152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MOVi32imm),
     /*  99155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  99157 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/0, // src
     /*  99160 */     GIR_RootConstrainSelectedInstOperands,
     /*  99161 */     // GIR_Coverage, 268,
     /*  99161 */     GIR_EraseRootFromParent_Done,
     /*  99162 */   // Label 1813: @99162
     /*  99162 */   GIM_Try, /*On fail goto*//*Label 1814*/ GIMT_Encode4(99203), // Rule ID 322 //
     /*  99167 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb_IsThumb1Only),
     /*  99170 */     GIM_CheckI64ImmPredicate, /*MI*/0, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_255_expr),
     /*  99174 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /*  99178 */     // MIs[0] Operand 1
     /*  99178 */     // No operand predicates
     /*  99178 */     // (imm:{ *:[i32] })<<P:Predicate_imm0_255_expr>>:$imm8  =>  (tMOVi8:{ *:[i32] } (imm:{ *:[i32] }):$imm8)
     /*  99178 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::tMOVi8),
     /*  99181 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  99183 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::CPSR), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define | RegState::Dead),
     /*  99189 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/0, // imm8
     /*  99192 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  99195 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  99201 */     GIR_RootConstrainSelectedInstOperands,
     /*  99202 */     // GIR_Coverage, 322,
     /*  99202 */     GIR_EraseRootFromParent_Done,
     /*  99203 */   // Label 1814: @99203
     /*  99203 */   GIM_Try, /*On fail goto*//*Label 1815*/ GIMT_Encode4(99238), // Rule ID 405 //
     /*  99208 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV8MBaseline_IsThumb),
     /*  99211 */     GIM_CheckI64ImmPredicate, /*MI*/0, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_65535),
     /*  99215 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  99219 */     // MIs[0] Operand 1
     /*  99219 */     // No operand predicates
     /*  99219 */     // (imm:{ *:[i32] })<<P:Predicate_imm0_65535>>:$imm  =>  (t2MOVi16:{ *:[i32] } (imm:{ *:[i32] }):$imm)
     /*  99219 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2MOVi16),
     /*  99222 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  99224 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/0, // imm
     /*  99227 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  99230 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  99236 */     GIR_RootConstrainSelectedInstOperands,
     /*  99237 */     // GIR_Coverage, 405,
     /*  99237 */     GIR_EraseRootFromParent_Done,
     /*  99238 */   // Label 1815: @99238
     /*  99238 */   GIM_Try, /*On fail goto*//*Label 1816*/ GIMT_Encode4(99287),
     /*  99243 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  99247 */     GIM_Try, /*On fail goto*//*Label 1817*/ GIMT_Encode4(99268), // Rule ID 353 //
     /*  99252 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_DontUseMovt_GenExecuteOnly_IsThumb1Only),
     /*  99255 */       // MIs[0] Operand 1
     /*  99255 */       // No operand predicates
     /*  99255 */       // (imm:{ *:[i32] }):$src  =>  (tMOVi32imm:{ *:[i32] }:{ *:[i32] } (imm:{ *:[i32] }):$src)
     /*  99255 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::tMOVi32imm),
     /*  99258 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  99260 */       GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/0, // src
     /*  99263 */       GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for ARM::CPSR*/0,
     /*  99266 */       GIR_RootConstrainSelectedInstOperands,
     /*  99267 */       // GIR_Coverage, 353,
     /*  99267 */       GIR_EraseRootFromParent_Done,
     /*  99268 */     // Label 1817: @99268
     /*  99268 */     GIM_Try, /*On fail goto*//*Label 1818*/ GIMT_Encode4(99286), // Rule ID 582 //
     /*  99273 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb_UseMovt),
     /*  99276 */       // MIs[0] Operand 1
     /*  99276 */       // No operand predicates
     /*  99276 */       // (imm:{ *:[i32] }):$src  =>  (t2MOVi32imm:{ *:[i32] } (imm:{ *:[i32] }):$src)
     /*  99276 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2MOVi32imm),
     /*  99279 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  99281 */       GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/0, // src
     /*  99284 */       GIR_RootConstrainSelectedInstOperands,
     /*  99285 */       // GIR_Coverage, 582,
     /*  99285 */       GIR_EraseRootFromParent_Done,
     /*  99286 */     // Label 1818: @99286
     /*  99286 */     GIM_Reject,
     /*  99287 */   // Label 1816: @99287
     /*  99287 */   GIM_Reject,
     /*  99288 */ // Label 1808: @99288
     /*  99288 */ GIM_Reject,
     /*  99289 */ // Label 20: @99289
     /*  99289 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(3), /*)*//*default:*//*Label 1821*/ GIMT_Encode4(99384),
     /*  99300 */ /*GILLT_s32*//*Label 1819*/ GIMT_Encode4(99308),
     /*  99304 */ /*GILLT_s64*//*Label 1820*/ GIMT_Encode4(99346),
     /*  99308 */ // Label 1819: @99308
     /*  99308 */ GIM_Try, /*On fail goto*//*Label 1822*/ GIMT_Encode4(99345), // Rule ID 725 //
     /*  99313 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVFP3),
     /*  99316 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /*  99320 */   // MIs[0] Operand 1
     /*  99320 */   // No operand predicates
     /*  99320 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_vfp_f32imm),
     /*  99324 */   // (fpimm:{ *:[f32] })<<P:Predicate_vfp_f32imm>><<X:vfp_f32imm_xform>>:$imm  =>  (FCONSTS:{ *:[f32] } (vfp_f32imm_xform:{ *:[f32] } (fpimm:{ *:[f32] }):$imm))
     /*  99324 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::FCONSTS),
     /*  99327 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /*  99329 */   GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/0, /*Renderer*/GIMT_Encode2(GICR_renderVFPF32Imm), // imm
     /*  99334 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  99337 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  99343 */   GIR_RootConstrainSelectedInstOperands,
     /*  99344 */   // GIR_Coverage, 725,
     /*  99344 */   GIR_EraseRootFromParent_Done,
     /*  99345 */ // Label 1822: @99345
     /*  99345 */ GIM_Reject,
     /*  99346 */ // Label 1820: @99346
     /*  99346 */ GIM_Try, /*On fail goto*//*Label 1823*/ GIMT_Encode4(99383), // Rule ID 724 //
     /*  99351 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDPVFP_HasVFP3),
     /*  99354 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  99358 */   // MIs[0] Operand 1
     /*  99358 */   // No operand predicates
     /*  99358 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_vfp_f64imm),
     /*  99362 */   // (fpimm:{ *:[f64] })<<P:Predicate_vfp_f64imm>><<X:vfp_f64imm_xform>>:$imm  =>  (FCONSTD:{ *:[f64] } (vfp_f64imm_xform:{ *:[f64] } (fpimm:{ *:[f64] }):$imm))
     /*  99362 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::FCONSTD),
     /*  99365 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Dd]
     /*  99367 */   GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/0, /*Renderer*/GIMT_Encode2(GICR_renderVFPF64Imm), // imm
     /*  99372 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  99375 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  99381 */   GIR_RootConstrainSelectedInstOperands,
     /*  99382 */   // GIR_Coverage, 724,
     /*  99382 */   GIR_EraseRootFromParent_Done,
     /*  99383 */ // Label 1823: @99383
     /*  99383 */ GIM_Reject,
     /*  99384 */ // Label 1821: @99384
     /*  99384 */ GIM_Reject,
     /*  99385 */ // Label 21: @99385
     /*  99385 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(5), GIMT_Encode2(13), /*)*//*default:*//*Label 1827*/ GIMT_Encode4(99542),
     /*  99396 */ /*GILLT_v2s64*//*Label 1824*/ GIMT_Encode4(99428), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  99408 */ /*GILLT_v4s32*//*Label 1825*/ GIMT_Encode4(99466), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  99424 */ /*GILLT_v8s16*//*Label 1826*/ GIMT_Encode4(99504),
     /*  99428 */ // Label 1824: @99428
     /*  99428 */ GIM_Try, /*On fail goto*//*Label 1828*/ GIMT_Encode4(99465), // Rule ID 1597 //
     /*  99433 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  99436 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  99439 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  99443 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  99447 */   // (sext:{ *:[v2i64] } DPR:{ *:[v2i32] }:$Vm)  =>  (VMOVLsv2i64:{ *:[v2i64] } DPR:{ *:[v2i32] }:$Vm)
     /*  99447 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMOVLsv2i64),
     /*  99450 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  99452 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /*  99454 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  99457 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  99463 */   GIR_RootConstrainSelectedInstOperands,
     /*  99464 */   // GIR_Coverage, 1597,
     /*  99464 */   GIR_EraseRootFromParent_Done,
     /*  99465 */ // Label 1828: @99465
     /*  99465 */ GIM_Reject,
     /*  99466 */ // Label 1825: @99466
     /*  99466 */ GIM_Try, /*On fail goto*//*Label 1829*/ GIMT_Encode4(99503), // Rule ID 1596 //
     /*  99471 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  99474 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  99477 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  99481 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  99485 */   // (sext:{ *:[v4i32] } DPR:{ *:[v4i16] }:$Vm)  =>  (VMOVLsv4i32:{ *:[v4i32] } DPR:{ *:[v4i16] }:$Vm)
     /*  99485 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMOVLsv4i32),
     /*  99488 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  99490 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /*  99492 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  99495 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  99501 */   GIR_RootConstrainSelectedInstOperands,
     /*  99502 */   // GIR_Coverage, 1596,
     /*  99502 */   GIR_EraseRootFromParent_Done,
     /*  99503 */ // Label 1829: @99503
     /*  99503 */ GIM_Reject,
     /*  99504 */ // Label 1826: @99504
     /*  99504 */ GIM_Try, /*On fail goto*//*Label 1830*/ GIMT_Encode4(99541), // Rule ID 1595 //
     /*  99509 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  99512 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  99515 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  99519 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  99523 */   // (sext:{ *:[v8i16] } DPR:{ *:[v8i8] }:$Vm)  =>  (VMOVLsv8i16:{ *:[v8i16] } DPR:{ *:[v8i8] }:$Vm)
     /*  99523 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMOVLsv8i16),
     /*  99526 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  99528 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /*  99530 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  99533 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  99539 */   GIR_RootConstrainSelectedInstOperands,
     /*  99540 */   // GIR_Coverage, 1595,
     /*  99540 */   GIR_EraseRootFromParent_Done,
     /*  99541 */ // Label 1830: @99541
     /*  99541 */ GIM_Reject,
     /*  99542 */ // Label 1827: @99542
     /*  99542 */ GIM_Reject,
     /*  99543 */ // Label 22: @99543
     /*  99543 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(13), /*)*//*default:*//*Label 1834*/ GIMT_Encode4(100147),
     /*  99554 */ /*GILLT_s32*//*Label 1831*/ GIMT_Encode4(99602), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  99582 */ /*GILLT_v4s32*//*Label 1832*/ GIMT_Encode4(99894), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  99598 */ /*GILLT_v8s16*//*Label 1833*/ GIMT_Encode4(100077),
     /*  99602 */ // Label 1831: @99602
     /*  99602 */ GIM_Try, /*On fail goto*//*Label 1835*/ GIMT_Encode4(99893),
     /*  99607 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  99610 */   GIM_Try, /*On fail goto*//*Label 1836*/ GIMT_Encode4(99655), // Rule ID 340 //
     /*  99615 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsThumb_IsThumb1Only),
     /*  99618 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /*  99622 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /*  99626 */     // MIs[0] Operand 2
     /*  99626 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
     /*  99637 */     // (sext_inreg:{ *:[i32] } tGPR:{ *:[i32] }:$Rm, i8:{ *:[Other] })  =>  (tSXTB:{ *:[i32] } tGPR:{ *:[i32] }:$Rm)
     /*  99637 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::tSXTB),
     /*  99640 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  99642 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /*  99644 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  99647 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  99653 */     GIR_RootConstrainSelectedInstOperands,
     /*  99654 */     // GIR_Coverage, 340,
     /*  99654 */     GIR_EraseRootFromParent_Done,
     /*  99655 */   // Label 1836: @99655
     /*  99655 */   GIM_Try, /*On fail goto*//*Label 1837*/ GIMT_Encode4(99700), // Rule ID 341 //
     /*  99660 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsThumb_IsThumb1Only),
     /*  99663 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /*  99667 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /*  99671 */     // MIs[0] Operand 2
     /*  99671 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(16),
     /*  99682 */     // (sext_inreg:{ *:[i32] } tGPR:{ *:[i32] }:$Rm, i16:{ *:[Other] })  =>  (tSXTH:{ *:[i32] } tGPR:{ *:[i32] }:$Rm)
     /*  99682 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::tSXTH),
     /*  99685 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  99687 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /*  99689 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  99692 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  99698 */     GIR_RootConstrainSelectedInstOperands,
     /*  99699 */     // GIR_Coverage, 341,
     /*  99699 */     GIR_EraseRootFromParent_Done,
     /*  99700 */   // Label 1837: @99700
     /*  99700 */   GIM_Try, /*On fail goto*//*Label 1838*/ GIMT_Encode4(99748), // Rule ID 1999 //
     /*  99705 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*  99708 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  99712 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  99716 */     // MIs[0] Operand 2
     /*  99716 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
     /*  99727 */     // (sext_inreg:{ *:[i32] } GPR:{ *:[i32] }:$Src, i8:{ *:[Other] })  =>  (SXTB:{ *:[i32] } GPR:{ *:[i32] }:$Src, 0:{ *:[i32] })
     /*  99727 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SXTB),
     /*  99730 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  99732 */     GIR_RootToRootCopy, /*OpIdx*/1, // Src
     /*  99734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  99737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  99740 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  99746 */     GIR_RootConstrainSelectedInstOperands,
     /*  99747 */     // GIR_Coverage, 1999,
     /*  99747 */     GIR_EraseRootFromParent_Done,
     /*  99748 */   // Label 1838: @99748
     /*  99748 */   GIM_Try, /*On fail goto*//*Label 1839*/ GIMT_Encode4(99796), // Rule ID 2000 //
     /*  99753 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*  99756 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  99760 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  99764 */     // MIs[0] Operand 2
     /*  99764 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(16),
     /*  99775 */     // (sext_inreg:{ *:[i32] } GPR:{ *:[i32] }:$Src, i16:{ *:[Other] })  =>  (SXTH:{ *:[i32] } GPR:{ *:[i32] }:$Src, 0:{ *:[i32] })
     /*  99775 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SXTH),
     /*  99778 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  99780 */     GIR_RootToRootCopy, /*OpIdx*/1, // Src
     /*  99782 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  99785 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  99788 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  99794 */     GIR_RootConstrainSelectedInstOperands,
     /*  99795 */     // GIR_Coverage, 2000,
     /*  99795 */     GIR_EraseRootFromParent_Done,
     /*  99796 */   // Label 1839: @99796
     /*  99796 */   GIM_Try, /*On fail goto*//*Label 1840*/ GIMT_Encode4(99844), // Rule ID 2238 //
     /*  99801 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /*  99804 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  99808 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  99812 */     // MIs[0] Operand 2
     /*  99812 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
     /*  99823 */     // (sext_inreg:{ *:[i32] } rGPR:{ *:[i32] }:$Src, i8:{ *:[Other] })  =>  (t2SXTB:{ *:[i32] } rGPR:{ *:[i32] }:$Src, 0:{ *:[i32] })
     /*  99823 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SXTB),
     /*  99826 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  99828 */     GIR_RootToRootCopy, /*OpIdx*/1, // Src
     /*  99830 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  99833 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  99836 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  99842 */     GIR_RootConstrainSelectedInstOperands,
     /*  99843 */     // GIR_Coverage, 2238,
     /*  99843 */     GIR_EraseRootFromParent_Done,
     /*  99844 */   // Label 1840: @99844
     /*  99844 */   GIM_Try, /*On fail goto*//*Label 1841*/ GIMT_Encode4(99892), // Rule ID 2239 //
     /*  99849 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /*  99852 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  99856 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  99860 */     // MIs[0] Operand 2
     /*  99860 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(16),
     /*  99871 */     // (sext_inreg:{ *:[i32] } rGPR:{ *:[i32] }:$Src, i16:{ *:[Other] })  =>  (t2SXTH:{ *:[i32] } rGPR:{ *:[i32] }:$Src, 0:{ *:[i32] })
     /*  99871 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SXTH),
     /*  99874 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  99876 */     GIR_RootToRootCopy, /*OpIdx*/1, // Src
     /*  99878 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  99881 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  99884 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  99890 */     GIR_RootConstrainSelectedInstOperands,
     /*  99891 */     // GIR_Coverage, 2239,
     /*  99891 */     GIR_EraseRootFromParent_Done,
     /*  99892 */   // Label 1841: @99892
     /*  99892 */   GIM_Reject,
     /*  99893 */ // Label 1835: @99893
     /*  99893 */ GIM_Reject,
     /*  99894 */ // Label 1832: @99894
     /*  99894 */ GIM_Try, /*On fail goto*//*Label 1842*/ GIMT_Encode4(100076),
     /*  99899 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  99902 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  99906 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  99910 */   GIM_Try, /*On fail goto*//*Label 1843*/ GIMT_Encode4(99968), // Rule ID 3710 //
     /*  99915 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  99918 */     // MIs[0] Operand 2
     /*  99918 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(16),
     /*  99929 */     // (sext_inreg:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$src, v4i16:{ *:[Other] })  =>  (MVE_VMOVLs16bh:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$src)
     /*  99929 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  99932 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  99936 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  99941 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMOVLs16bh),
     /*  99944 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  99946 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  99948 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  99951 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  99957 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  99963 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  99966 */     GIR_RootConstrainSelectedInstOperands,
     /*  99967 */     // GIR_Coverage, 3710,
     /*  99967 */     GIR_EraseRootFromParent_Done,
     /*  99968 */   // Label 1843: @99968
     /*  99968 */   GIM_Try, /*On fail goto*//*Label 1844*/ GIMT_Encode4(100075), // Rule ID 3712 //
     /*  99973 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  99976 */     // MIs[0] Operand 2
     /*  99976 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
     /*  99987 */     // (sext_inreg:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$src, v4i8:{ *:[Other] })  =>  (MVE_VMOVLs16bh:{ *:[v4i32] } (MVE_VMOVLs8bh:{ *:[v16i8] } MQPR:{ *:[v4i32] }:$src))
     /*  99987 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  99990 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  99994 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  99999 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
     /* 100002 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 100006 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 100011 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 100014 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::MVE_VMOVLs8bh),
     /* 100018 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 100023 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 100027 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 100030 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 100036 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 100042 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 100045 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 100047 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMOVLs16bh),
     /* 100050 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 100052 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 100055 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 100058 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 100064 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 100070 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 100073 */     GIR_RootConstrainSelectedInstOperands,
     /* 100074 */     // GIR_Coverage, 3712,
     /* 100074 */     GIR_EraseRootFromParent_Done,
     /* 100075 */   // Label 1844: @100075
     /* 100075 */   GIM_Reject,
     /* 100076 */ // Label 1842: @100076
     /* 100076 */ GIM_Reject,
     /* 100077 */ // Label 1833: @100077
     /* 100077 */ GIM_Try, /*On fail goto*//*Label 1845*/ GIMT_Encode4(100146), // Rule ID 3711 //
     /* 100082 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 100085 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 100088 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 100092 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 100096 */   // MIs[0] Operand 2
     /* 100096 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
     /* 100107 */   // (sext_inreg:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$src, v8i8:{ *:[Other] })  =>  (MVE_VMOVLs8bh:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$src)
     /* 100107 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 100110 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 100114 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 100119 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMOVLs8bh),
     /* 100122 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 100124 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 100126 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 100129 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 100135 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 100141 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 100144 */   GIR_RootConstrainSelectedInstOperands,
     /* 100145 */   // GIR_Coverage, 3711,
     /* 100145 */   GIR_EraseRootFromParent_Done,
     /* 100146 */ // Label 1845: @100146
     /* 100146 */ GIM_Reject,
     /* 100147 */ // Label 1834: @100147
     /* 100147 */ GIM_Reject,
     /* 100148 */ // Label 23: @100148
     /* 100148 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(5), GIMT_Encode2(13), /*)*//*default:*//*Label 1849*/ GIMT_Encode4(100305),
     /* 100159 */ /*GILLT_v2s64*//*Label 1846*/ GIMT_Encode4(100191), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 100171 */ /*GILLT_v4s32*//*Label 1847*/ GIMT_Encode4(100229), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 100187 */ /*GILLT_v8s16*//*Label 1848*/ GIMT_Encode4(100267),
     /* 100191 */ // Label 1846: @100191
     /* 100191 */ GIM_Try, /*On fail goto*//*Label 1850*/ GIMT_Encode4(100228), // Rule ID 1600 //
     /* 100196 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 100199 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 100202 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 100206 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 100210 */   // (zext:{ *:[v2i64] } DPR:{ *:[v2i32] }:$Vm)  =>  (VMOVLuv2i64:{ *:[v2i64] } DPR:{ *:[v2i32] }:$Vm)
     /* 100210 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMOVLuv2i64),
     /* 100213 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 100215 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /* 100217 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 100220 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 100226 */   GIR_RootConstrainSelectedInstOperands,
     /* 100227 */   // GIR_Coverage, 1600,
     /* 100227 */   GIR_EraseRootFromParent_Done,
     /* 100228 */ // Label 1850: @100228
     /* 100228 */ GIM_Reject,
     /* 100229 */ // Label 1847: @100229
     /* 100229 */ GIM_Try, /*On fail goto*//*Label 1851*/ GIMT_Encode4(100266), // Rule ID 1599 //
     /* 100234 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 100237 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 100240 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 100244 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 100248 */   // (zext:{ *:[v4i32] } DPR:{ *:[v4i16] }:$Vm)  =>  (VMOVLuv4i32:{ *:[v4i32] } DPR:{ *:[v4i16] }:$Vm)
     /* 100248 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMOVLuv4i32),
     /* 100251 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 100253 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /* 100255 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 100258 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 100264 */   GIR_RootConstrainSelectedInstOperands,
     /* 100265 */   // GIR_Coverage, 1599,
     /* 100265 */   GIR_EraseRootFromParent_Done,
     /* 100266 */ // Label 1851: @100266
     /* 100266 */ GIM_Reject,
     /* 100267 */ // Label 1848: @100267
     /* 100267 */ GIM_Try, /*On fail goto*//*Label 1852*/ GIMT_Encode4(100304), // Rule ID 1598 //
     /* 100272 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 100275 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 100278 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 100282 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 100286 */   // (zext:{ *:[v8i16] } DPR:{ *:[v8i8] }:$Vm)  =>  (VMOVLuv8i16:{ *:[v8i16] } DPR:{ *:[v8i8] }:$Vm)
     /* 100286 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMOVLuv8i16),
     /* 100289 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 100291 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /* 100293 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 100296 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 100302 */   GIR_RootConstrainSelectedInstOperands,
     /* 100303 */   // GIR_Coverage, 1598,
     /* 100303 */   GIR_EraseRootFromParent_Done,
     /* 100304 */ // Label 1852: @100304
     /* 100304 */ GIM_Reject,
     /* 100305 */ // Label 1849: @100305
     /* 100305 */ GIM_Reject,
     /* 100306 */ // Label 24: @100306
     /* 100306 */ GIM_Try, /*On fail goto*//*Label 1853*/ GIMT_Encode4(100521),
     /* 100311 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 100314 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 100317 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 100320 */   GIM_Try, /*On fail goto*//*Label 1854*/ GIMT_Encode4(100377), // Rule ID 470 //
     /* 100325 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /* 100328 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 100332 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 100336 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 100340 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 100344 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm1_31),
     /* 100348 */     // MIs[1] Operand 1
     /* 100348 */     // No operand predicates
     /* 100348 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 100350 */     // (shl:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, (imm:{ *:[i32] })<<P:Predicate_imm1_31>>:$imm)  =>  (t2LSLri:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, (imm:{ *:[i32] }):$imm)
     /* 100350 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2LSLri),
     /* 100353 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 100355 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /* 100357 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 100360 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 100363 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 100369 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 100375 */     GIR_RootConstrainSelectedInstOperands,
     /* 100376 */     // GIR_Coverage, 470,
     /* 100376 */     GIR_EraseRootFromParent_Done,
     /* 100377 */   // Label 1854: @100377
     /* 100377 */   GIM_Try, /*On fail goto*//*Label 1855*/ GIMT_Encode4(100474),
     /* 100382 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /* 100386 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /* 100390 */     GIM_Try, /*On fail goto*//*Label 1856*/ GIMT_Encode4(100435), // Rule ID 318 //
     /* 100395 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb_IsThumb1Only),
     /* 100398 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 100402 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 100406 */       // MIs[1] Operand 1
     /* 100406 */       // No operand predicates
     /* 100406 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 100408 */       // (shl:{ *:[i32] } tGPR:{ *:[i32] }:$Rm, (imm:{ *:[i32] }):$imm5)  =>  (tLSLri:{ *:[i32] } tGPR:{ *:[i32] }:$Rm, (imm:{ *:[i32] }):$imm5)
     /* 100408 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::tLSLri),
     /* 100411 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 100413 */       GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::CPSR), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define | RegState::Dead),
     /* 100419 */       GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /* 100421 */       GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm5
     /* 100424 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 100427 */       GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 100433 */       GIR_RootConstrainSelectedInstOperands,
     /* 100434 */       // GIR_Coverage, 318,
     /* 100434 */       GIR_EraseRootFromParent_Done,
     /* 100435 */     // Label 1856: @100435
     /* 100435 */     GIM_Try, /*On fail goto*//*Label 1857*/ GIMT_Encode4(100473), // Rule ID 319 //
     /* 100440 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb_IsThumb1Only),
     /* 100443 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /* 100447 */       // (shl:{ *:[i32] } tGPR:{ *:[i32] }:$Rn, tGPR:{ *:[i32] }:$Rm)  =>  (tLSLrr:{ *:[i32] } tGPR:{ *:[i32] }:$Rn, tGPR:{ *:[i32] }:$Rm)
     /* 100447 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::tLSLrr),
     /* 100450 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 100452 */       GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::CPSR), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define | RegState::Dead),
     /* 100458 */       GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 100460 */       GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 100462 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 100465 */       GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 100471 */       GIR_RootConstrainSelectedInstOperands,
     /* 100472 */       // GIR_Coverage, 319,
     /* 100472 */       GIR_EraseRootFromParent_Done,
     /* 100473 */     // Label 1857: @100473
     /* 100473 */     GIM_Reject,
     /* 100474 */   // Label 1855: @100474
     /* 100474 */   GIM_Try, /*On fail goto*//*Label 1858*/ GIMT_Encode4(100520), // Rule ID 471 //
     /* 100479 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /* 100482 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 100486 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 100490 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 100494 */     // (shl:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2LSLrr:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /* 100494 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2LSLrr),
     /* 100497 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 100499 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 100501 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 100503 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 100506 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 100512 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 100518 */     GIR_RootConstrainSelectedInstOperands,
     /* 100519 */     // GIR_Coverage, 471,
     /* 100519 */     GIR_EraseRootFromParent_Done,
     /* 100520 */   // Label 1858: @100520
     /* 100520 */   GIM_Reject,
     /* 100521 */ // Label 1853: @100521
     /* 100521 */ GIM_Reject,
     /* 100522 */ // Label 25: @100522
     /* 100522 */ GIM_Try, /*On fail goto*//*Label 1859*/ GIMT_Encode4(100629),
     /* 100527 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 100530 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 100533 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 100536 */   GIM_Try, /*On fail goto*//*Label 1860*/ GIMT_Encode4(100582), // Rule ID 321 //
     /* 100541 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb_IsThumb1Only),
     /* 100544 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /* 100548 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /* 100552 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /* 100556 */     // (srl:{ *:[i32] } tGPR:{ *:[i32] }:$Rn, tGPR:{ *:[i32] }:$Rm)  =>  (tLSRrr:{ *:[i32] } tGPR:{ *:[i32] }:$Rn, tGPR:{ *:[i32] }:$Rm)
     /* 100556 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::tLSRrr),
     /* 100559 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 100561 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::CPSR), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define | RegState::Dead),
     /* 100567 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 100569 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 100571 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 100574 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 100580 */     GIR_RootConstrainSelectedInstOperands,
     /* 100581 */     // GIR_Coverage, 321,
     /* 100581 */     GIR_EraseRootFromParent_Done,
     /* 100582 */   // Label 1860: @100582
     /* 100582 */   GIM_Try, /*On fail goto*//*Label 1861*/ GIMT_Encode4(100628), // Rule ID 473 //
     /* 100587 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /* 100590 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 100594 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 100598 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 100602 */     // (srl:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2LSRrr:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /* 100602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2LSRrr),
     /* 100605 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 100607 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 100609 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 100611 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 100614 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 100620 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 100626 */     GIR_RootConstrainSelectedInstOperands,
     /* 100627 */     // GIR_Coverage, 473,
     /* 100627 */     GIR_EraseRootFromParent_Done,
     /* 100628 */   // Label 1861: @100628
     /* 100628 */   GIM_Reject,
     /* 100629 */ // Label 1859: @100629
     /* 100629 */ GIM_Reject,
     /* 100630 */ // Label 26: @100630
     /* 100630 */ GIM_Try, /*On fail goto*//*Label 1862*/ GIMT_Encode4(100902),
     /* 100635 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 100638 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 100641 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 100644 */   GIM_Try, /*On fail goto*//*Label 1863*/ GIMT_Encode4(100699), // Rule ID 201 //
     /* 100649 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /* 100652 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 100656 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 100660 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BSWAP),
     /* 100664 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 100668 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 100673 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 16,
     /* 100677 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 100679 */     // (sra:{ *:[i32] } (bswap:{ *:[i32] } GPR:{ *:[i32] }:$Rm), 16:{ *:[i32] })  =>  (REVSH:{ *:[i32] } GPR:{ *:[i32] }:$Rm)
     /* 100679 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::REVSH),
     /* 100682 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 100684 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 100688 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 100691 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 100697 */     GIR_RootConstrainSelectedInstOperands,
     /* 100698 */     // GIR_Coverage, 201,
     /* 100698 */     GIR_EraseRootFromParent_Done,
     /* 100699 */   // Label 1863: @100699
     /* 100699 */   GIM_Try, /*On fail goto*//*Label 1864*/ GIMT_Encode4(100754), // Rule ID 328 //
     /* 100704 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsThumb_IsThumb1Only),
     /* 100707 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /* 100711 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 100715 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BSWAP),
     /* 100719 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 100723 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /* 100728 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 16,
     /* 100732 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 100734 */     // (sra:{ *:[i32] } (bswap:{ *:[i32] } tGPR:{ *:[i32] }:$Rm), 16:{ *:[i32] })  =>  (tREVSH:{ *:[i32] } tGPR:{ *:[i32] }:$Rm)
     /* 100734 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::tREVSH),
     /* 100737 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 100739 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 100743 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 100746 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 100752 */     GIR_RootConstrainSelectedInstOperands,
     /* 100753 */     // GIR_Coverage, 328,
     /* 100753 */     GIR_EraseRootFromParent_Done,
     /* 100754 */   // Label 1864: @100754
     /* 100754 */   GIM_Try, /*On fail goto*//*Label 1865*/ GIMT_Encode4(100809), // Rule ID 538 //
     /* 100759 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /* 100762 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 100766 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 100770 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BSWAP),
     /* 100774 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 100778 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 100783 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 16,
     /* 100787 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 100789 */     // (sra:{ *:[i32] } (bswap:{ *:[i32] } rGPR:{ *:[i32] }:$Rm), 16:{ *:[i32] })  =>  (t2REVSH:{ *:[i32] } rGPR:{ *:[i32] }:$Rm)
     /* 100789 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2REVSH),
     /* 100792 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 100794 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 100798 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 100801 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 100807 */     GIR_RootConstrainSelectedInstOperands,
     /* 100808 */     // GIR_Coverage, 538,
     /* 100808 */     GIR_EraseRootFromParent_Done,
     /* 100809 */   // Label 1865: @100809
     /* 100809 */   GIM_Try, /*On fail goto*//*Label 1866*/ GIMT_Encode4(100855), // Rule ID 312 //
     /* 100814 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb_IsThumb1Only),
     /* 100817 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /* 100821 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /* 100825 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /* 100829 */     // (sra:{ *:[i32] } tGPR:{ *:[i32] }:$Rn, tGPR:{ *:[i32] }:$Rm)  =>  (tASRrr:{ *:[i32] } tGPR:{ *:[i32] }:$Rn, tGPR:{ *:[i32] }:$Rm)
     /* 100829 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::tASRrr),
     /* 100832 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 100834 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::CPSR), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define | RegState::Dead),
     /* 100840 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 100842 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 100844 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 100847 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 100853 */     GIR_RootConstrainSelectedInstOperands,
     /* 100854 */     // GIR_Coverage, 312,
     /* 100854 */     GIR_EraseRootFromParent_Done,
     /* 100855 */   // Label 1866: @100855
     /* 100855 */   GIM_Try, /*On fail goto*//*Label 1867*/ GIMT_Encode4(100901), // Rule ID 475 //
     /* 100860 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /* 100863 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 100867 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 100871 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 100875 */     // (sra:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2ASRrr:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /* 100875 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2ASRrr),
     /* 100878 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 100880 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 100882 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 100884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 100887 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 100893 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 100899 */     GIR_RootConstrainSelectedInstOperands,
     /* 100900 */     // GIR_Coverage, 475,
     /* 100900 */     GIR_EraseRootFromParent_Done,
     /* 100901 */   // Label 1867: @100901
     /* 100901 */   GIM_Reject,
     /* 100902 */ // Label 1862: @100902
     /* 100902 */ GIM_Reject,
     /* 100903 */ // Label 27: @100903
     /* 100903 */ GIM_Try, /*On fail goto*//*Label 1868*/ GIMT_Encode4(101234),
     /* 100908 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 100911 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 100914 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 100917 */   GIM_Try, /*On fail goto*//*Label 1869*/ GIMT_Encode4(100972), // Rule ID 200 //
     /* 100922 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /* 100925 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 100929 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 100933 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BSWAP),
     /* 100937 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 100941 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 100946 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 16,
     /* 100950 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 100952 */     // (rotr:{ *:[i32] } (bswap:{ *:[i32] } GPR:{ *:[i32] }:$Rm), 16:{ *:[i32] })  =>  (REV16:{ *:[i32] } GPR:{ *:[i32] }:$Rm)
     /* 100952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::REV16),
     /* 100955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 100957 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 100961 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 100964 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 100970 */     GIR_RootConstrainSelectedInstOperands,
     /* 100971 */     // GIR_Coverage, 200,
     /* 100971 */     GIR_EraseRootFromParent_Done,
     /* 100972 */   // Label 1869: @100972
     /* 100972 */   GIM_Try, /*On fail goto*//*Label 1870*/ GIMT_Encode4(101027), // Rule ID 327 //
     /* 100977 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsThumb_IsThumb1Only),
     /* 100980 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /* 100984 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 100988 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BSWAP),
     /* 100992 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 100996 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /* 101001 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 16,
     /* 101005 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 101007 */     // (rotr:{ *:[i32] } (bswap:{ *:[i32] } tGPR:{ *:[i32] }:$Rm), 16:{ *:[i32] })  =>  (tREV16:{ *:[i32] } tGPR:{ *:[i32] }:$Rm)
     /* 101007 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::tREV16),
     /* 101010 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 101012 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 101016 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 101019 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 101025 */     GIR_RootConstrainSelectedInstOperands,
     /* 101026 */     // GIR_Coverage, 327,
     /* 101026 */     GIR_EraseRootFromParent_Done,
     /* 101027 */   // Label 1870: @101027
     /* 101027 */   GIM_Try, /*On fail goto*//*Label 1871*/ GIMT_Encode4(101141),
     /* 101032 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 101036 */     GIM_Try, /*On fail goto*//*Label 1872*/ GIMT_Encode4(101087), // Rule ID 537 //
     /* 101041 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /* 101044 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 101048 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BSWAP),
     /* 101052 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 101056 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 101061 */       GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 16,
     /* 101065 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 101067 */       // (rotr:{ *:[i32] } (bswap:{ *:[i32] } rGPR:{ *:[i32] }:$Rm), 16:{ *:[i32] })  =>  (t2REV16:{ *:[i32] } rGPR:{ *:[i32] }:$Rm)
     /* 101067 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2REV16),
     /* 101070 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 101072 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 101076 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 101079 */       GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 101085 */       GIR_RootConstrainSelectedInstOperands,
     /* 101086 */       // GIR_Coverage, 537,
     /* 101086 */       GIR_EraseRootFromParent_Done,
     /* 101087 */     // Label 1872: @101087
     /* 101087 */     GIM_Try, /*On fail goto*//*Label 1873*/ GIMT_Encode4(101140), // Rule ID 476 //
     /* 101092 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /* 101095 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 101099 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 101103 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 101107 */       GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm1_31),
     /* 101111 */       // MIs[1] Operand 1
     /* 101111 */       // No operand predicates
     /* 101111 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 101113 */       // (rotr:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, (imm:{ *:[i32] })<<P:Predicate_imm1_31>>:$imm)  =>  (t2RORri:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, (imm:{ *:[i32] }):$imm)
     /* 101113 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2RORri),
     /* 101116 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 101118 */       GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /* 101120 */       GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 101123 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 101126 */       GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 101132 */       GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 101138 */       GIR_RootConstrainSelectedInstOperands,
     /* 101139 */       // GIR_Coverage, 476,
     /* 101139 */       GIR_EraseRootFromParent_Done,
     /* 101140 */     // Label 1873: @101140
     /* 101140 */     GIM_Reject,
     /* 101141 */   // Label 1871: @101141
     /* 101141 */   GIM_Try, /*On fail goto*//*Label 1874*/ GIMT_Encode4(101187), // Rule ID 329 //
     /* 101146 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb_IsThumb1Only),
     /* 101149 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /* 101153 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /* 101157 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /* 101161 */     // (rotr:{ *:[i32] } tGPR:{ *:[i32] }:$Rn, tGPR:{ *:[i32] }:$Rm)  =>  (tROR:{ *:[i32] } tGPR:{ *:[i32] }:$Rn, tGPR:{ *:[i32] }:$Rm)
     /* 101161 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::tROR),
     /* 101164 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 101166 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::CPSR), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define | RegState::Dead),
     /* 101172 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 101174 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 101176 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 101179 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 101185 */     GIR_RootConstrainSelectedInstOperands,
     /* 101186 */     // GIR_Coverage, 329,
     /* 101186 */     GIR_EraseRootFromParent_Done,
     /* 101187 */   // Label 1874: @101187
     /* 101187 */   GIM_Try, /*On fail goto*//*Label 1875*/ GIMT_Encode4(101233), // Rule ID 477 //
     /* 101192 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /* 101195 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 101199 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 101203 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 101207 */     // (rotr:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2RORrr:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /* 101207 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2RORrr),
     /* 101210 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 101212 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 101214 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 101216 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 101219 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 101225 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 101231 */     GIR_RootConstrainSelectedInstOperands,
     /* 101232 */     // GIR_Coverage, 477,
     /* 101232 */     GIR_EraseRootFromParent_Done,
     /* 101233 */   // Label 1875: @101233
     /* 101233 */   GIM_Reject,
     /* 101234 */ // Label 1868: @101234
     /* 101234 */ GIM_Reject,
     /* 101235 */ // Label 28: @101235
     /* 101235 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(8), GIMT_Encode2(16), /*)*//*default:*//*Label 1879*/ GIMT_Encode4(101482),
     /* 101246 */ /*GILLT_v4s32*//*Label 1876*/ GIMT_Encode4(101278), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 101262 */ /*GILLT_v8s16*//*Label 1877*/ GIMT_Encode4(101346), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 101274 */ /*GILLT_v16s8*//*Label 1878*/ GIMT_Encode4(101414),
     /* 101278 */ // Label 1876: @101278
     /* 101278 */ GIM_Try, /*On fail goto*//*Label 1880*/ GIMT_Encode4(101345), // Rule ID 4461 //
     /* 101283 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 101286 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 101289 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 101292 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 101296 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 101300 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 101304 */   // (mulhu:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)  =>  (MVE_VMULHu32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)
     /* 101304 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 101307 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 101311 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 101316 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMULHu32),
     /* 101319 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 101321 */   GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /* 101323 */   GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /* 101325 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 101328 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 101334 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 101340 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 101343 */   GIR_RootConstrainSelectedInstOperands,
     /* 101344 */   // GIR_Coverage, 4461,
     /* 101344 */   GIR_EraseRootFromParent_Done,
     /* 101345 */ // Label 1880: @101345
     /* 101345 */ GIM_Reject,
     /* 101346 */ // Label 1877: @101346
     /* 101346 */ GIM_Try, /*On fail goto*//*Label 1881*/ GIMT_Encode4(101413), // Rule ID 4457 //
     /* 101351 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 101354 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 101357 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 101360 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 101364 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 101368 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 101372 */   // (mulhu:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)  =>  (MVE_VMULHu16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)
     /* 101372 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 101375 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 101379 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 101384 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMULHu16),
     /* 101387 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 101389 */   GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /* 101391 */   GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /* 101393 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 101396 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 101402 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 101408 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 101411 */   GIR_RootConstrainSelectedInstOperands,
     /* 101412 */   // GIR_Coverage, 4457,
     /* 101412 */   GIR_EraseRootFromParent_Done,
     /* 101413 */ // Label 1881: @101413
     /* 101413 */ GIM_Reject,
     /* 101414 */ // Label 1878: @101414
     /* 101414 */ GIM_Try, /*On fail goto*//*Label 1882*/ GIMT_Encode4(101481), // Rule ID 4453 //
     /* 101419 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 101422 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 101425 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 101428 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 101432 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 101436 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 101440 */   // (mulhu:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)  =>  (MVE_VMULHu8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)
     /* 101440 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 101443 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 101447 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 101452 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMULHu8),
     /* 101455 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 101457 */   GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /* 101459 */   GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /* 101461 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 101464 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 101470 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 101476 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 101479 */   GIR_RootConstrainSelectedInstOperands,
     /* 101480 */   // GIR_Coverage, 4453,
     /* 101480 */   GIR_EraseRootFromParent_Done,
     /* 101481 */ // Label 1882: @101481
     /* 101481 */ GIM_Reject,
     /* 101482 */ // Label 1879: @101482
     /* 101482 */ GIM_Reject,
     /* 101483 */ // Label 29: @101483
     /* 101483 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(16), /*)*//*default:*//*Label 1887*/ GIMT_Encode4(101851),
     /* 101494 */ /*GILLT_s32*//*Label 1883*/ GIMT_Encode4(101554), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 101522 */ /*GILLT_v4s32*//*Label 1884*/ GIMT_Encode4(101647), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 101538 */ /*GILLT_v8s16*//*Label 1885*/ GIMT_Encode4(101715), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 101550 */ /*GILLT_v16s8*//*Label 1886*/ GIMT_Encode4(101783),
     /* 101554 */ // Label 1883: @101554
     /* 101554 */ GIM_Try, /*On fail goto*//*Label 1888*/ GIMT_Encode4(101646),
     /* 101559 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 101562 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 101565 */   GIM_Try, /*On fail goto*//*Label 1889*/ GIMT_Encode4(101605), // Rule ID 178 //
     /* 101570 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /* 101573 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 101577 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 101581 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 101585 */     // (mulhs:{ *:[i32] } GPR:{ *:[i32] }:$Rn, GPR:{ *:[i32] }:$Rm)  =>  (SMMUL:{ *:[i32] } GPR:{ *:[i32] }:$Rn, GPR:{ *:[i32] }:$Rm)
     /* 101585 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SMMUL),
     /* 101588 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 101590 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 101592 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 101594 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 101597 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 101603 */     GIR_RootConstrainSelectedInstOperands,
     /* 101604 */     // GIR_Coverage, 178,
     /* 101604 */     GIR_EraseRootFromParent_Done,
     /* 101605 */   // Label 1889: @101605
     /* 101605 */   GIM_Try, /*On fail goto*//*Label 1890*/ GIMT_Encode4(101645), // Rule ID 507 //
     /* 101610 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /* 101613 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 101617 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 101621 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 101625 */     // (mulhs:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2SMMUL:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /* 101625 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SMMUL),
     /* 101628 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 101630 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 101632 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 101634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 101637 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 101643 */     GIR_RootConstrainSelectedInstOperands,
     /* 101644 */     // GIR_Coverage, 507,
     /* 101644 */     GIR_EraseRootFromParent_Done,
     /* 101645 */   // Label 1890: @101645
     /* 101645 */   GIM_Reject,
     /* 101646 */ // Label 1888: @101646
     /* 101646 */ GIM_Reject,
     /* 101647 */ // Label 1884: @101647
     /* 101647 */ GIM_Try, /*On fail goto*//*Label 1891*/ GIMT_Encode4(101714), // Rule ID 4449 //
     /* 101652 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 101655 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 101658 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 101661 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 101665 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 101669 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 101673 */   // (mulhs:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)  =>  (MVE_VMULHs32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)
     /* 101673 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 101676 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 101680 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 101685 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMULHs32),
     /* 101688 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 101690 */   GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /* 101692 */   GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /* 101694 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 101697 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 101703 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 101709 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 101712 */   GIR_RootConstrainSelectedInstOperands,
     /* 101713 */   // GIR_Coverage, 4449,
     /* 101713 */   GIR_EraseRootFromParent_Done,
     /* 101714 */ // Label 1891: @101714
     /* 101714 */ GIM_Reject,
     /* 101715 */ // Label 1885: @101715
     /* 101715 */ GIM_Try, /*On fail goto*//*Label 1892*/ GIMT_Encode4(101782), // Rule ID 4445 //
     /* 101720 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 101723 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 101726 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 101729 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 101733 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 101737 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 101741 */   // (mulhs:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)  =>  (MVE_VMULHs16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)
     /* 101741 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 101744 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 101748 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 101753 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMULHs16),
     /* 101756 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 101758 */   GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /* 101760 */   GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /* 101762 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 101765 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 101771 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 101777 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 101780 */   GIR_RootConstrainSelectedInstOperands,
     /* 101781 */   // GIR_Coverage, 4445,
     /* 101781 */   GIR_EraseRootFromParent_Done,
     /* 101782 */ // Label 1892: @101782
     /* 101782 */ GIM_Reject,
     /* 101783 */ // Label 1886: @101783
     /* 101783 */ GIM_Try, /*On fail goto*//*Label 1893*/ GIMT_Encode4(101850), // Rule ID 4442 //
     /* 101788 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 101791 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 101794 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 101797 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 101801 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 101805 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 101809 */   // (mulhs:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)  =>  (MVE_VMULHs8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)
     /* 101809 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 101812 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 101816 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 101821 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMULHs8),
     /* 101824 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 101826 */   GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /* 101828 */   GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /* 101830 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 101833 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 101839 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 101845 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 101848 */   GIR_RootConstrainSelectedInstOperands,
     /* 101849 */   // GIR_Coverage, 4442,
     /* 101849 */   GIR_EraseRootFromParent_Done,
     /* 101850 */ // Label 1893: @101850
     /* 101850 */ GIM_Reject,
     /* 101851 */ // Label 1887: @101851
     /* 101851 */ GIM_Reject,
     /* 101852 */ // Label 30: @101852
     /* 101852 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(16), /*)*//*default:*//*Label 1902*/ GIMT_Encode4(102496),
     /* 101863 */ /*GILLT_s64*//*Label 1894*/ GIMT_Encode4(101919), GIMT_Encode4(0),
     /* 101871 */ /*GILLT_v2s32*//*Label 1895*/ GIMT_Encode4(101966),
     /* 101875 */ /*GILLT_v2s64*//*Label 1896*/ GIMT_Encode4(102013), GIMT_Encode4(0),
     /* 101883 */ /*GILLT_v4s16*//*Label 1897*/ GIMT_Encode4(102060),
     /* 101887 */ /*GILLT_v4s32*//*Label 1898*/ GIMT_Encode4(102107), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 101899 */ /*GILLT_v8s8*//*Label 1899*/ GIMT_Encode4(102221),
     /* 101903 */ /*GILLT_v8s16*//*Label 1900*/ GIMT_Encode4(102268), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 101915 */ /*GILLT_v16s8*//*Label 1901*/ GIMT_Encode4(102382),
     /* 101919 */ // Label 1894: @101919
     /* 101919 */ GIM_Try, /*On fail goto*//*Label 1903*/ GIMT_Encode4(101965), // Rule ID 827 //
     /* 101924 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 101927 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 101930 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 101933 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 101937 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 101941 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 101945 */   // (uaddsat:{ *:[v1i64] } DPR:{ *:[v1i64] }:$Vn, DPR:{ *:[v1i64] }:$Vm)  =>  (VQADDuv1i64:{ *:[v1i64] } DPR:{ *:[v1i64] }:$Vn, DPR:{ *:[v1i64] }:$Vm)
     /* 101945 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQADDuv1i64),
     /* 101948 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 101950 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 101952 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 101954 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 101957 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 101963 */   GIR_RootConstrainSelectedInstOperands,
     /* 101964 */   // GIR_Coverage, 827,
     /* 101964 */   GIR_EraseRootFromParent_Done,
     /* 101965 */ // Label 1903: @101965
     /* 101965 */ GIM_Reject,
     /* 101966 */ // Label 1895: @101966
     /* 101966 */ GIM_Try, /*On fail goto*//*Label 1904*/ GIMT_Encode4(102012), // Rule ID 822 //
     /* 101971 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 101974 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 101977 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 101980 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 101984 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 101988 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 101992 */   // (uaddsat:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)  =>  (VQADDuv2i32:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /* 101992 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQADDuv2i32),
     /* 101995 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 101997 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 101999 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 102001 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 102004 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 102010 */   GIR_RootConstrainSelectedInstOperands,
     /* 102011 */   // GIR_Coverage, 822,
     /* 102011 */   GIR_EraseRootFromParent_Done,
     /* 102012 */ // Label 1904: @102012
     /* 102012 */ GIM_Reject,
     /* 102013 */ // Label 1896: @102013
     /* 102013 */ GIM_Try, /*On fail goto*//*Label 1905*/ GIMT_Encode4(102059), // Rule ID 828 //
     /* 102018 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 102021 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 102024 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 102027 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 102031 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 102035 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 102039 */   // (uaddsat:{ *:[v2i64] } QPR:{ *:[v2i64] }:$Vn, QPR:{ *:[v2i64] }:$Vm)  =>  (VQADDuv2i64:{ *:[v2i64] } QPR:{ *:[v2i64] }:$Vn, QPR:{ *:[v2i64] }:$Vm)
     /* 102039 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQADDuv2i64),
     /* 102042 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 102044 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 102046 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 102048 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 102051 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 102057 */   GIR_RootConstrainSelectedInstOperands,
     /* 102058 */   // GIR_Coverage, 828,
     /* 102058 */   GIR_EraseRootFromParent_Done,
     /* 102059 */ // Label 1905: @102059
     /* 102059 */ GIM_Reject,
     /* 102060 */ // Label 1897: @102060
     /* 102060 */ GIM_Try, /*On fail goto*//*Label 1906*/ GIMT_Encode4(102106), // Rule ID 821 //
     /* 102065 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 102068 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 102071 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 102074 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 102078 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 102082 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 102086 */   // (uaddsat:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)  =>  (VQADDuv4i16:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /* 102086 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQADDuv4i16),
     /* 102089 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 102091 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 102093 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 102095 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 102098 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 102104 */   GIR_RootConstrainSelectedInstOperands,
     /* 102105 */   // GIR_Coverage, 821,
     /* 102105 */   GIR_EraseRootFromParent_Done,
     /* 102106 */ // Label 1906: @102106
     /* 102106 */ GIM_Reject,
     /* 102107 */ // Label 1898: @102107
     /* 102107 */ GIM_Try, /*On fail goto*//*Label 1907*/ GIMT_Encode4(102220),
     /* 102112 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 102115 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 102118 */   GIM_Try, /*On fail goto*//*Label 1908*/ GIMT_Encode4(102158), // Rule ID 824 //
     /* 102123 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 102126 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 102130 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 102134 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 102138 */     // (uaddsat:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)  =>  (VQADDuv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)
     /* 102138 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQADDuv4i32),
     /* 102141 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 102143 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 102145 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 102147 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 102150 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 102156 */     GIR_RootConstrainSelectedInstOperands,
     /* 102157 */     // GIR_Coverage, 824,
     /* 102157 */     GIR_EraseRootFromParent_Done,
     /* 102158 */   // Label 1908: @102158
     /* 102158 */   GIM_Try, /*On fail goto*//*Label 1909*/ GIMT_Encode4(102219), // Rule ID 3524 //
     /* 102163 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 102166 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 102170 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 102174 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 102178 */     // (uaddsat:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)  =>  (MVE_VQADDu32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)
     /* 102178 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 102181 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 102185 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 102190 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQADDu32),
     /* 102193 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 102195 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /* 102197 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /* 102199 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 102202 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 102208 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 102214 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 102217 */     GIR_RootConstrainSelectedInstOperands,
     /* 102218 */     // GIR_Coverage, 3524,
     /* 102218 */     GIR_EraseRootFromParent_Done,
     /* 102219 */   // Label 1909: @102219
     /* 102219 */   GIM_Reject,
     /* 102220 */ // Label 1907: @102220
     /* 102220 */ GIM_Reject,
     /* 102221 */ // Label 1899: @102221
     /* 102221 */ GIM_Try, /*On fail goto*//*Label 1910*/ GIMT_Encode4(102267), // Rule ID 825 //
     /* 102226 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 102229 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 102232 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 102235 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 102239 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 102243 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 102247 */   // (uaddsat:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)  =>  (VQADDuv8i8:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /* 102247 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQADDuv8i8),
     /* 102250 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 102252 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 102254 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 102256 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 102259 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 102265 */   GIR_RootConstrainSelectedInstOperands,
     /* 102266 */   // GIR_Coverage, 825,
     /* 102266 */   GIR_EraseRootFromParent_Done,
     /* 102267 */ // Label 1910: @102267
     /* 102267 */ GIM_Reject,
     /* 102268 */ // Label 1900: @102268
     /* 102268 */ GIM_Try, /*On fail goto*//*Label 1911*/ GIMT_Encode4(102381),
     /* 102273 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 102276 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 102279 */   GIM_Try, /*On fail goto*//*Label 1912*/ GIMT_Encode4(102319), // Rule ID 823 //
     /* 102284 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 102287 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 102291 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 102295 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 102299 */     // (uaddsat:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)  =>  (VQADDuv8i16:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)
     /* 102299 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQADDuv8i16),
     /* 102302 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 102304 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 102306 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 102308 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 102311 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 102317 */     GIR_RootConstrainSelectedInstOperands,
     /* 102318 */     // GIR_Coverage, 823,
     /* 102318 */     GIR_EraseRootFromParent_Done,
     /* 102319 */   // Label 1912: @102319
     /* 102319 */   GIM_Try, /*On fail goto*//*Label 1913*/ GIMT_Encode4(102380), // Rule ID 3521 //
     /* 102324 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 102327 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 102331 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 102335 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 102339 */     // (uaddsat:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)  =>  (MVE_VQADDu16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)
     /* 102339 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 102342 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 102346 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 102351 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQADDu16),
     /* 102354 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 102356 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /* 102358 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /* 102360 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 102363 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 102369 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 102375 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 102378 */     GIR_RootConstrainSelectedInstOperands,
     /* 102379 */     // GIR_Coverage, 3521,
     /* 102379 */     GIR_EraseRootFromParent_Done,
     /* 102380 */   // Label 1913: @102380
     /* 102380 */   GIM_Reject,
     /* 102381 */ // Label 1911: @102381
     /* 102381 */ GIM_Reject,
     /* 102382 */ // Label 1901: @102382
     /* 102382 */ GIM_Try, /*On fail goto*//*Label 1914*/ GIMT_Encode4(102495),
     /* 102387 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 102390 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 102393 */   GIM_Try, /*On fail goto*//*Label 1915*/ GIMT_Encode4(102433), // Rule ID 826 //
     /* 102398 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 102401 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 102405 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 102409 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 102413 */     // (uaddsat:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)  =>  (VQADDuv16i8:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)
     /* 102413 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQADDuv16i8),
     /* 102416 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 102418 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 102420 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 102422 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 102425 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 102431 */     GIR_RootConstrainSelectedInstOperands,
     /* 102432 */     // GIR_Coverage, 826,
     /* 102432 */     GIR_EraseRootFromParent_Done,
     /* 102433 */   // Label 1915: @102433
     /* 102433 */   GIM_Try, /*On fail goto*//*Label 1916*/ GIMT_Encode4(102494), // Rule ID 3518 //
     /* 102438 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 102441 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 102445 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 102449 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 102453 */     // (uaddsat:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)  =>  (MVE_VQADDu8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)
     /* 102453 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 102456 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 102460 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 102465 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQADDu8),
     /* 102468 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 102470 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /* 102472 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /* 102474 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 102477 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 102483 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 102489 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 102492 */     GIR_RootConstrainSelectedInstOperands,
     /* 102493 */     // GIR_Coverage, 3518,
     /* 102493 */     GIR_EraseRootFromParent_Done,
     /* 102494 */   // Label 1916: @102494
     /* 102494 */   GIM_Reject,
     /* 102495 */ // Label 1914: @102495
     /* 102495 */ GIM_Reject,
     /* 102496 */ // Label 1902: @102496
     /* 102496 */ GIM_Reject,
     /* 102497 */ // Label 31: @102497
     /* 102497 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(16), /*)*//*default:*//*Label 1926*/ GIMT_Encode4(103796),
     /* 102508 */ /*GILLT_s32*//*Label 1917*/ GIMT_Encode4(102568),
     /* 102512 */ /*GILLT_s64*//*Label 1918*/ GIMT_Encode4(102909), GIMT_Encode4(0),
     /* 102520 */ /*GILLT_v2s32*//*Label 1919*/ GIMT_Encode4(102956),
     /* 102524 */ /*GILLT_v2s64*//*Label 1920*/ GIMT_Encode4(103003), GIMT_Encode4(0),
     /* 102532 */ /*GILLT_v4s16*//*Label 1921*/ GIMT_Encode4(103204),
     /* 102536 */ /*GILLT_v4s32*//*Label 1922*/ GIMT_Encode4(103251), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 102548 */ /*GILLT_v8s8*//*Label 1923*/ GIMT_Encode4(103521),
     /* 102552 */ /*GILLT_v8s16*//*Label 1924*/ GIMT_Encode4(103568), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 102564 */ /*GILLT_v16s8*//*Label 1925*/ GIMT_Encode4(103682),
     /* 102568 */ // Label 1917: @102568
     /* 102568 */ GIM_Try, /*On fail goto*//*Label 1927*/ GIMT_Encode4(102908),
     /* 102573 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 102576 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 102579 */   GIM_Try, /*On fail goto*//*Label 1928*/ GIMT_Encode4(102641), // Rule ID 5651 //
     /* 102584 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV5TE_IsARM),
     /* 102587 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /* 102591 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 102595 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SADDSAT),
     /* 102599 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 102603 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 102608 */     // MIs[1] Rn
     /* 102608 */     GIM_CheckIsSameOperand, /*MI*/1, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 102613 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 102617 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 102619 */     // (saddsat:{ *:[i32] } (saddsat:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rn), rGPR:{ *:[i32] }:$Rm)  =>  (QDADD:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, rGPR:{ *:[i32] }:$Rn)
     /* 102619 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::QDADD),
     /* 102622 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 102624 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 102626 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 102630 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 102633 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 102639 */     GIR_RootConstrainSelectedInstOperands,
     /* 102640 */     // GIR_Coverage, 5651,
     /* 102640 */     GIR_EraseRootFromParent_Done,
     /* 102641 */   // Label 1928: @102641
     /* 102641 */   GIM_Try, /*On fail goto*//*Label 1929*/ GIMT_Encode4(102703), // Rule ID 5685 //
     /* 102646 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /* 102649 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 102653 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 102657 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SADDSAT),
     /* 102661 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 102665 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 102670 */     // MIs[1] Rn
     /* 102670 */     GIM_CheckIsSameOperand, /*MI*/1, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 102675 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 102679 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 102681 */     // (saddsat:{ *:[i32] } (saddsat:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rn), rGPR:{ *:[i32] }:$Rm)  =>  (t2QDADD:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, rGPR:{ *:[i32] }:$Rn)
     /* 102681 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2QDADD),
     /* 102684 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 102686 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 102688 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 102692 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 102695 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 102701 */     GIR_RootConstrainSelectedInstOperands,
     /* 102702 */     // GIR_Coverage, 5685,
     /* 102702 */     GIR_EraseRootFromParent_Done,
     /* 102703 */   // Label 1929: @102703
     /* 102703 */   GIM_Try, /*On fail goto*//*Label 1930*/ GIMT_Encode4(102765), // Rule ID 1867 //
     /* 102708 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV5TE_IsARM),
     /* 102711 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /* 102715 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 102719 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 102723 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SADDSAT),
     /* 102727 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 102731 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 102736 */     // MIs[1] Rn
     /* 102736 */     GIM_CheckIsSameOperand, /*MI*/1, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 102741 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 102743 */     // (saddsat:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, (saddsat:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rn))  =>  (QDADD:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, rGPR:{ *:[i32] }:$Rn)
     /* 102743 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::QDADD),
     /* 102746 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 102748 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /* 102750 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 102754 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 102757 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 102763 */     GIR_RootConstrainSelectedInstOperands,
     /* 102764 */     // GIR_Coverage, 1867,
     /* 102764 */     GIR_EraseRootFromParent_Done,
     /* 102765 */   // Label 1930: @102765
     /* 102765 */   GIM_Try, /*On fail goto*//*Label 1931*/ GIMT_Encode4(102827), // Rule ID 2133 //
     /* 102770 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /* 102773 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 102777 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 102781 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 102785 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SADDSAT),
     /* 102789 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 102793 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 102798 */     // MIs[1] Rn
     /* 102798 */     GIM_CheckIsSameOperand, /*MI*/1, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 102803 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 102805 */     // (saddsat:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, (saddsat:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rn))  =>  (t2QDADD:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, rGPR:{ *:[i32] }:$Rn)
     /* 102805 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2QDADD),
     /* 102808 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 102810 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /* 102812 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 102816 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 102819 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 102825 */     GIR_RootConstrainSelectedInstOperands,
     /* 102826 */     // GIR_Coverage, 2133,
     /* 102826 */     GIR_EraseRootFromParent_Done,
     /* 102827 */   // Label 1931: @102827
     /* 102827 */   GIM_Try, /*On fail goto*//*Label 1932*/ GIMT_Encode4(102867), // Rule ID 1865 //
     /* 102832 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV5TE_IsARM),
     /* 102835 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /* 102839 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 102843 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 102847 */     // (saddsat:{ *:[i32] } GPR:{ *:[i32] }:$a, GPR:{ *:[i32] }:$b)  =>  (QADD:{ *:[i32] } GPR:{ *:[i32] }:$a, GPR:{ *:[i32] }:$b)
     /* 102847 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::QADD),
     /* 102850 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 102852 */     GIR_RootToRootCopy, /*OpIdx*/1, // a
     /* 102854 */     GIR_RootToRootCopy, /*OpIdx*/2, // b
     /* 102856 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 102859 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 102865 */     GIR_RootConstrainSelectedInstOperands,
     /* 102866 */     // GIR_Coverage, 1865,
     /* 102866 */     GIR_EraseRootFromParent_Done,
     /* 102867 */   // Label 1932: @102867
     /* 102867 */   GIM_Try, /*On fail goto*//*Label 1933*/ GIMT_Encode4(102907), // Rule ID 2131 //
     /* 102872 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /* 102875 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 102879 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 102883 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 102887 */     // (saddsat:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, rGPR:{ *:[i32] }:$Rn)  =>  (t2QADD:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, rGPR:{ *:[i32] }:$Rn)
     /* 102887 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2QADD),
     /* 102890 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 102892 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /* 102894 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 102896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 102899 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 102905 */     GIR_RootConstrainSelectedInstOperands,
     /* 102906 */     // GIR_Coverage, 2131,
     /* 102906 */     GIR_EraseRootFromParent_Done,
     /* 102907 */   // Label 1933: @102907
     /* 102907 */   GIM_Reject,
     /* 102908 */ // Label 1927: @102908
     /* 102908 */ GIM_Reject,
     /* 102909 */ // Label 1918: @102909
     /* 102909 */ GIM_Try, /*On fail goto*//*Label 1934*/ GIMT_Encode4(102955), // Rule ID 819 //
     /* 102914 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 102917 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 102920 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 102923 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 102927 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 102931 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 102935 */   // (saddsat:{ *:[v1i64] } DPR:{ *:[v1i64] }:$Vn, DPR:{ *:[v1i64] }:$Vm)  =>  (VQADDsv1i64:{ *:[v1i64] } DPR:{ *:[v1i64] }:$Vn, DPR:{ *:[v1i64] }:$Vm)
     /* 102935 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQADDsv1i64),
     /* 102938 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 102940 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 102942 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 102944 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 102947 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 102953 */   GIR_RootConstrainSelectedInstOperands,
     /* 102954 */   // GIR_Coverage, 819,
     /* 102954 */   GIR_EraseRootFromParent_Done,
     /* 102955 */ // Label 1934: @102955
     /* 102955 */ GIM_Reject,
     /* 102956 */ // Label 1919: @102956
     /* 102956 */ GIM_Try, /*On fail goto*//*Label 1935*/ GIMT_Encode4(103002), // Rule ID 814 //
     /* 102961 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 102964 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 102967 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 102970 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 102974 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 102978 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 102982 */   // (saddsat:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)  =>  (VQADDsv2i32:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /* 102982 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQADDsv2i32),
     /* 102985 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 102987 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 102989 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 102991 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 102994 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 103000 */   GIR_RootConstrainSelectedInstOperands,
     /* 103001 */   // GIR_Coverage, 814,
     /* 103001 */   GIR_EraseRootFromParent_Done,
     /* 103002 */ // Label 1935: @103002
     /* 103002 */ GIM_Reject,
     /* 103003 */ // Label 1920: @103003
     /* 103003 */ GIM_Try, /*On fail goto*//*Label 1936*/ GIMT_Encode4(103203),
     /* 103008 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 103011 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 103014 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 103018 */   GIM_Try, /*On fail goto*//*Label 1937*/ GIMT_Encode4(103092), // Rule ID 5742 //
     /* 103023 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 103026 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 103030 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 103034 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 103037 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqdmull),
     /* 103042 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 103046 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 103050 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 103055 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 103060 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 103064 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 103066 */     // (saddsat:{ *:[v2i64] } (intrinsic_wo_chain:{ *:[v2i64] } 3813:{ *:[iPTR] }, DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm), QPR:{ *:[v2i64] }:$src1)  =>  (VQDMLALv2i64:{ *:[v2i64] } QPR:{ *:[v2i64] }:$src1, DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /* 103066 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQDMLALv2i64),
     /* 103069 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 103071 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 103073 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vn
     /* 103077 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Vm
     /* 103081 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 103084 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 103090 */     GIR_RootConstrainSelectedInstOperands,
     /* 103091 */     // GIR_Coverage, 5742,
     /* 103091 */     GIR_EraseRootFromParent_Done,
     /* 103092 */   // Label 1937: @103092
     /* 103092 */   GIM_Try, /*On fail goto*//*Label 1938*/ GIMT_Encode4(103166), // Rule ID 2486 //
     /* 103097 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 103100 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 103104 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 103108 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 103112 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 103115 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqdmull),
     /* 103120 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 103124 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 103128 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 103133 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 103138 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 103140 */     // (saddsat:{ *:[v2i64] } QPR:{ *:[v2i64] }:$src1, (intrinsic_wo_chain:{ *:[v2i64] } 3813:{ *:[iPTR] }, DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm))  =>  (VQDMLALv2i64:{ *:[v2i64] } QPR:{ *:[v2i64] }:$src1, DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /* 103140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQDMLALv2i64),
     /* 103143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 103145 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 103147 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vn
     /* 103151 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Vm
     /* 103155 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 103158 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 103164 */     GIR_RootConstrainSelectedInstOperands,
     /* 103165 */     // GIR_Coverage, 2486,
     /* 103165 */     GIR_EraseRootFromParent_Done,
     /* 103166 */   // Label 1938: @103166
     /* 103166 */   GIM_Try, /*On fail goto*//*Label 1939*/ GIMT_Encode4(103202), // Rule ID 820 //
     /* 103171 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 103174 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 103178 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 103182 */     // (saddsat:{ *:[v2i64] } QPR:{ *:[v2i64] }:$Vn, QPR:{ *:[v2i64] }:$Vm)  =>  (VQADDsv2i64:{ *:[v2i64] } QPR:{ *:[v2i64] }:$Vn, QPR:{ *:[v2i64] }:$Vm)
     /* 103182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQADDsv2i64),
     /* 103185 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 103187 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 103189 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 103191 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 103194 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 103200 */     GIR_RootConstrainSelectedInstOperands,
     /* 103201 */     // GIR_Coverage, 820,
     /* 103201 */     GIR_EraseRootFromParent_Done,
     /* 103202 */   // Label 1939: @103202
     /* 103202 */   GIM_Reject,
     /* 103203 */ // Label 1936: @103203
     /* 103203 */ GIM_Reject,
     /* 103204 */ // Label 1921: @103204
     /* 103204 */ GIM_Try, /*On fail goto*//*Label 1940*/ GIMT_Encode4(103250), // Rule ID 813 //
     /* 103209 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 103212 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 103215 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 103218 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 103222 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 103226 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 103230 */   // (saddsat:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)  =>  (VQADDsv4i16:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /* 103230 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQADDsv4i16),
     /* 103233 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 103235 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 103237 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 103239 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 103242 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 103248 */   GIR_RootConstrainSelectedInstOperands,
     /* 103249 */   // GIR_Coverage, 813,
     /* 103249 */   GIR_EraseRootFromParent_Done,
     /* 103250 */ // Label 1940: @103250
     /* 103250 */ GIM_Reject,
     /* 103251 */ // Label 1922: @103251
     /* 103251 */ GIM_Try, /*On fail goto*//*Label 1941*/ GIMT_Encode4(103520),
     /* 103256 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 103259 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 103262 */   GIM_Try, /*On fail goto*//*Label 1942*/ GIMT_Encode4(103340), // Rule ID 5741 //
     /* 103267 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 103270 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 103274 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 103278 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 103282 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 103285 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqdmull),
     /* 103290 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 103294 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 103298 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 103303 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 103308 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 103312 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 103314 */     // (saddsat:{ *:[v4i32] } (intrinsic_wo_chain:{ *:[v4i32] } 3813:{ *:[iPTR] }, DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm), QPR:{ *:[v4i32] }:$src1)  =>  (VQDMLALv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$src1, DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /* 103314 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQDMLALv4i32),
     /* 103317 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 103319 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 103321 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vn
     /* 103325 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Vm
     /* 103329 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 103332 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 103338 */     GIR_RootConstrainSelectedInstOperands,
     /* 103339 */     // GIR_Coverage, 5741,
     /* 103339 */     GIR_EraseRootFromParent_Done,
     /* 103340 */   // Label 1942: @103340
     /* 103340 */   GIM_Try, /*On fail goto*//*Label 1943*/ GIMT_Encode4(103418), // Rule ID 2485 //
     /* 103345 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 103348 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 103352 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 103356 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 103360 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 103364 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 103367 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqdmull),
     /* 103372 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 103376 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 103380 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 103385 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 103390 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 103392 */     // (saddsat:{ *:[v4i32] } QPR:{ *:[v4i32] }:$src1, (intrinsic_wo_chain:{ *:[v4i32] } 3813:{ *:[iPTR] }, DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm))  =>  (VQDMLALv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$src1, DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /* 103392 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQDMLALv4i32),
     /* 103395 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 103397 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 103399 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vn
     /* 103403 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Vm
     /* 103407 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 103410 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 103416 */     GIR_RootConstrainSelectedInstOperands,
     /* 103417 */     // GIR_Coverage, 2485,
     /* 103417 */     GIR_EraseRootFromParent_Done,
     /* 103418 */   // Label 1943: @103418
     /* 103418 */   GIM_Try, /*On fail goto*//*Label 1944*/ GIMT_Encode4(103458), // Rule ID 816 //
     /* 103423 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 103426 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 103430 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 103434 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 103438 */     // (saddsat:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)  =>  (VQADDsv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)
     /* 103438 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQADDsv4i32),
     /* 103441 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 103443 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 103445 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 103447 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 103450 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 103456 */     GIR_RootConstrainSelectedInstOperands,
     /* 103457 */     // GIR_Coverage, 816,
     /* 103457 */     GIR_EraseRootFromParent_Done,
     /* 103458 */   // Label 1944: @103458
     /* 103458 */   GIM_Try, /*On fail goto*//*Label 1945*/ GIMT_Encode4(103519), // Rule ID 3515 //
     /* 103463 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 103466 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 103470 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 103474 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 103478 */     // (saddsat:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)  =>  (MVE_VQADDs32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)
     /* 103478 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 103481 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 103485 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 103490 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQADDs32),
     /* 103493 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 103495 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /* 103497 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /* 103499 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 103502 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 103508 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 103514 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 103517 */     GIR_RootConstrainSelectedInstOperands,
     /* 103518 */     // GIR_Coverage, 3515,
     /* 103518 */     GIR_EraseRootFromParent_Done,
     /* 103519 */   // Label 1945: @103519
     /* 103519 */   GIM_Reject,
     /* 103520 */ // Label 1941: @103520
     /* 103520 */ GIM_Reject,
     /* 103521 */ // Label 1923: @103521
     /* 103521 */ GIM_Try, /*On fail goto*//*Label 1946*/ GIMT_Encode4(103567), // Rule ID 817 //
     /* 103526 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 103529 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 103532 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 103535 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 103539 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 103543 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 103547 */   // (saddsat:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)  =>  (VQADDsv8i8:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /* 103547 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQADDsv8i8),
     /* 103550 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 103552 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 103554 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 103556 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 103559 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 103565 */   GIR_RootConstrainSelectedInstOperands,
     /* 103566 */   // GIR_Coverage, 817,
     /* 103566 */   GIR_EraseRootFromParent_Done,
     /* 103567 */ // Label 1946: @103567
     /* 103567 */ GIM_Reject,
     /* 103568 */ // Label 1924: @103568
     /* 103568 */ GIM_Try, /*On fail goto*//*Label 1947*/ GIMT_Encode4(103681),
     /* 103573 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 103576 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 103579 */   GIM_Try, /*On fail goto*//*Label 1948*/ GIMT_Encode4(103619), // Rule ID 815 //
     /* 103584 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 103587 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 103591 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 103595 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 103599 */     // (saddsat:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)  =>  (VQADDsv8i16:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)
     /* 103599 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQADDsv8i16),
     /* 103602 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 103604 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 103606 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 103608 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 103611 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 103617 */     GIR_RootConstrainSelectedInstOperands,
     /* 103618 */     // GIR_Coverage, 815,
     /* 103618 */     GIR_EraseRootFromParent_Done,
     /* 103619 */   // Label 1948: @103619
     /* 103619 */   GIM_Try, /*On fail goto*//*Label 1949*/ GIMT_Encode4(103680), // Rule ID 3512 //
     /* 103624 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 103627 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 103631 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 103635 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 103639 */     // (saddsat:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)  =>  (MVE_VQADDs16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)
     /* 103639 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 103642 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 103646 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 103651 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQADDs16),
     /* 103654 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 103656 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /* 103658 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /* 103660 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 103663 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 103669 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 103675 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 103678 */     GIR_RootConstrainSelectedInstOperands,
     /* 103679 */     // GIR_Coverage, 3512,
     /* 103679 */     GIR_EraseRootFromParent_Done,
     /* 103680 */   // Label 1949: @103680
     /* 103680 */   GIM_Reject,
     /* 103681 */ // Label 1947: @103681
     /* 103681 */ GIM_Reject,
     /* 103682 */ // Label 1925: @103682
     /* 103682 */ GIM_Try, /*On fail goto*//*Label 1950*/ GIMT_Encode4(103795),
     /* 103687 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 103690 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 103693 */   GIM_Try, /*On fail goto*//*Label 1951*/ GIMT_Encode4(103733), // Rule ID 818 //
     /* 103698 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 103701 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 103705 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 103709 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 103713 */     // (saddsat:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)  =>  (VQADDsv16i8:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)
     /* 103713 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQADDsv16i8),
     /* 103716 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 103718 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 103720 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 103722 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 103725 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 103731 */     GIR_RootConstrainSelectedInstOperands,
     /* 103732 */     // GIR_Coverage, 818,
     /* 103732 */     GIR_EraseRootFromParent_Done,
     /* 103733 */   // Label 1951: @103733
     /* 103733 */   GIM_Try, /*On fail goto*//*Label 1952*/ GIMT_Encode4(103794), // Rule ID 3509 //
     /* 103738 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 103741 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 103745 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 103749 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 103753 */     // (saddsat:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)  =>  (MVE_VQADDs8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)
     /* 103753 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 103756 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 103760 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 103765 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQADDs8),
     /* 103768 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 103770 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /* 103772 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /* 103774 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 103777 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 103783 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 103789 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 103792 */     GIR_RootConstrainSelectedInstOperands,
     /* 103793 */     // GIR_Coverage, 3509,
     /* 103793 */     GIR_EraseRootFromParent_Done,
     /* 103794 */   // Label 1952: @103794
     /* 103794 */   GIM_Reject,
     /* 103795 */ // Label 1950: @103795
     /* 103795 */ GIM_Reject,
     /* 103796 */ // Label 1926: @103796
     /* 103796 */ GIM_Reject,
     /* 103797 */ // Label 32: @103797
     /* 103797 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(16), /*)*//*default:*//*Label 1961*/ GIMT_Encode4(104441),
     /* 103808 */ /*GILLT_s64*//*Label 1953*/ GIMT_Encode4(103864), GIMT_Encode4(0),
     /* 103816 */ /*GILLT_v2s32*//*Label 1954*/ GIMT_Encode4(103911),
     /* 103820 */ /*GILLT_v2s64*//*Label 1955*/ GIMT_Encode4(103958), GIMT_Encode4(0),
     /* 103828 */ /*GILLT_v4s16*//*Label 1956*/ GIMT_Encode4(104005),
     /* 103832 */ /*GILLT_v4s32*//*Label 1957*/ GIMT_Encode4(104052), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 103844 */ /*GILLT_v8s8*//*Label 1958*/ GIMT_Encode4(104166),
     /* 103848 */ /*GILLT_v8s16*//*Label 1959*/ GIMT_Encode4(104213), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 103860 */ /*GILLT_v16s8*//*Label 1960*/ GIMT_Encode4(104327),
     /* 103864 */ // Label 1953: @103864
     /* 103864 */ GIM_Try, /*On fail goto*//*Label 1962*/ GIMT_Encode4(103910), // Rule ID 1019 //
     /* 103869 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 103872 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 103875 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 103878 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 103882 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 103886 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 103890 */   // (usubsat:{ *:[v1i64] } DPR:{ *:[v1i64] }:$Vn, DPR:{ *:[v1i64] }:$Vm)  =>  (VQSUBuv1i64:{ *:[v1i64] } DPR:{ *:[v1i64] }:$Vn, DPR:{ *:[v1i64] }:$Vm)
     /* 103890 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQSUBuv1i64),
     /* 103893 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 103895 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 103897 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 103899 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 103902 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 103908 */   GIR_RootConstrainSelectedInstOperands,
     /* 103909 */   // GIR_Coverage, 1019,
     /* 103909 */   GIR_EraseRootFromParent_Done,
     /* 103910 */ // Label 1962: @103910
     /* 103910 */ GIM_Reject,
     /* 103911 */ // Label 1954: @103911
     /* 103911 */ GIM_Try, /*On fail goto*//*Label 1963*/ GIMT_Encode4(103957), // Rule ID 1014 //
     /* 103916 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 103919 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 103922 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 103925 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 103929 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 103933 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 103937 */   // (usubsat:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)  =>  (VQSUBuv2i32:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /* 103937 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQSUBuv2i32),
     /* 103940 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 103942 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 103944 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 103946 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 103949 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 103955 */   GIR_RootConstrainSelectedInstOperands,
     /* 103956 */   // GIR_Coverage, 1014,
     /* 103956 */   GIR_EraseRootFromParent_Done,
     /* 103957 */ // Label 1963: @103957
     /* 103957 */ GIM_Reject,
     /* 103958 */ // Label 1955: @103958
     /* 103958 */ GIM_Try, /*On fail goto*//*Label 1964*/ GIMT_Encode4(104004), // Rule ID 1020 //
     /* 103963 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 103966 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 103969 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 103972 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 103976 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 103980 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 103984 */   // (usubsat:{ *:[v2i64] } QPR:{ *:[v2i64] }:$Vn, QPR:{ *:[v2i64] }:$Vm)  =>  (VQSUBuv2i64:{ *:[v2i64] } QPR:{ *:[v2i64] }:$Vn, QPR:{ *:[v2i64] }:$Vm)
     /* 103984 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQSUBuv2i64),
     /* 103987 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 103989 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 103991 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 103993 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 103996 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 104002 */   GIR_RootConstrainSelectedInstOperands,
     /* 104003 */   // GIR_Coverage, 1020,
     /* 104003 */   GIR_EraseRootFromParent_Done,
     /* 104004 */ // Label 1964: @104004
     /* 104004 */ GIM_Reject,
     /* 104005 */ // Label 1956: @104005
     /* 104005 */ GIM_Try, /*On fail goto*//*Label 1965*/ GIMT_Encode4(104051), // Rule ID 1013 //
     /* 104010 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 104013 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 104016 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 104019 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 104023 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 104027 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 104031 */   // (usubsat:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)  =>  (VQSUBuv4i16:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /* 104031 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQSUBuv4i16),
     /* 104034 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 104036 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 104038 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 104040 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 104043 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 104049 */   GIR_RootConstrainSelectedInstOperands,
     /* 104050 */   // GIR_Coverage, 1013,
     /* 104050 */   GIR_EraseRootFromParent_Done,
     /* 104051 */ // Label 1965: @104051
     /* 104051 */ GIM_Reject,
     /* 104052 */ // Label 1957: @104052
     /* 104052 */ GIM_Try, /*On fail goto*//*Label 1966*/ GIMT_Encode4(104165),
     /* 104057 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 104060 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 104063 */   GIM_Try, /*On fail goto*//*Label 1967*/ GIMT_Encode4(104103), // Rule ID 1016 //
     /* 104068 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 104071 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 104075 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 104079 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 104083 */     // (usubsat:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)  =>  (VQSUBuv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)
     /* 104083 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQSUBuv4i32),
     /* 104086 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 104088 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 104090 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 104092 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 104095 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 104101 */     GIR_RootConstrainSelectedInstOperands,
     /* 104102 */     // GIR_Coverage, 1016,
     /* 104102 */     GIR_EraseRootFromParent_Done,
     /* 104103 */   // Label 1967: @104103
     /* 104103 */   GIM_Try, /*On fail goto*//*Label 1968*/ GIMT_Encode4(104164), // Rule ID 3542 //
     /* 104108 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 104111 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 104115 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 104119 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 104123 */     // (usubsat:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)  =>  (MVE_VQSUBu32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)
     /* 104123 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 104126 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 104130 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 104135 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQSUBu32),
     /* 104138 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 104140 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /* 104142 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /* 104144 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 104147 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 104153 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 104159 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 104162 */     GIR_RootConstrainSelectedInstOperands,
     /* 104163 */     // GIR_Coverage, 3542,
     /* 104163 */     GIR_EraseRootFromParent_Done,
     /* 104164 */   // Label 1968: @104164
     /* 104164 */   GIM_Reject,
     /* 104165 */ // Label 1966: @104165
     /* 104165 */ GIM_Reject,
     /* 104166 */ // Label 1958: @104166
     /* 104166 */ GIM_Try, /*On fail goto*//*Label 1969*/ GIMT_Encode4(104212), // Rule ID 1017 //
     /* 104171 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 104174 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 104177 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 104180 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 104184 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 104188 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 104192 */   // (usubsat:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)  =>  (VQSUBuv8i8:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /* 104192 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQSUBuv8i8),
     /* 104195 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 104197 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 104199 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 104201 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 104204 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 104210 */   GIR_RootConstrainSelectedInstOperands,
     /* 104211 */   // GIR_Coverage, 1017,
     /* 104211 */   GIR_EraseRootFromParent_Done,
     /* 104212 */ // Label 1969: @104212
     /* 104212 */ GIM_Reject,
     /* 104213 */ // Label 1959: @104213
     /* 104213 */ GIM_Try, /*On fail goto*//*Label 1970*/ GIMT_Encode4(104326),
     /* 104218 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 104221 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 104224 */   GIM_Try, /*On fail goto*//*Label 1971*/ GIMT_Encode4(104264), // Rule ID 1015 //
     /* 104229 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 104232 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 104236 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 104240 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 104244 */     // (usubsat:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)  =>  (VQSUBuv8i16:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)
     /* 104244 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQSUBuv8i16),
     /* 104247 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 104249 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 104251 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 104253 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 104256 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 104262 */     GIR_RootConstrainSelectedInstOperands,
     /* 104263 */     // GIR_Coverage, 1015,
     /* 104263 */     GIR_EraseRootFromParent_Done,
     /* 104264 */   // Label 1971: @104264
     /* 104264 */   GIM_Try, /*On fail goto*//*Label 1972*/ GIMT_Encode4(104325), // Rule ID 3539 //
     /* 104269 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 104272 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 104276 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 104280 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 104284 */     // (usubsat:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)  =>  (MVE_VQSUBu16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)
     /* 104284 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 104287 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 104291 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 104296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQSUBu16),
     /* 104299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 104301 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /* 104303 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /* 104305 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 104308 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 104314 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 104320 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 104323 */     GIR_RootConstrainSelectedInstOperands,
     /* 104324 */     // GIR_Coverage, 3539,
     /* 104324 */     GIR_EraseRootFromParent_Done,
     /* 104325 */   // Label 1972: @104325
     /* 104325 */   GIM_Reject,
     /* 104326 */ // Label 1970: @104326
     /* 104326 */ GIM_Reject,
     /* 104327 */ // Label 1960: @104327
     /* 104327 */ GIM_Try, /*On fail goto*//*Label 1973*/ GIMT_Encode4(104440),
     /* 104332 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 104335 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 104338 */   GIM_Try, /*On fail goto*//*Label 1974*/ GIMT_Encode4(104378), // Rule ID 1018 //
     /* 104343 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 104346 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 104350 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 104354 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 104358 */     // (usubsat:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)  =>  (VQSUBuv16i8:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)
     /* 104358 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQSUBuv16i8),
     /* 104361 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 104363 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 104365 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 104367 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 104370 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 104376 */     GIR_RootConstrainSelectedInstOperands,
     /* 104377 */     // GIR_Coverage, 1018,
     /* 104377 */     GIR_EraseRootFromParent_Done,
     /* 104378 */   // Label 1974: @104378
     /* 104378 */   GIM_Try, /*On fail goto*//*Label 1975*/ GIMT_Encode4(104439), // Rule ID 3536 //
     /* 104383 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 104386 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 104390 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 104394 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 104398 */     // (usubsat:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)  =>  (MVE_VQSUBu8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)
     /* 104398 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 104401 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 104405 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 104410 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQSUBu8),
     /* 104413 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 104415 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /* 104417 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /* 104419 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 104422 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 104428 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 104434 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 104437 */     GIR_RootConstrainSelectedInstOperands,
     /* 104438 */     // GIR_Coverage, 3536,
     /* 104438 */     GIR_EraseRootFromParent_Done,
     /* 104439 */   // Label 1975: @104439
     /* 104439 */   GIM_Reject,
     /* 104440 */ // Label 1973: @104440
     /* 104440 */ GIM_Reject,
     /* 104441 */ // Label 1961: @104441
     /* 104441 */ GIM_Reject,
     /* 104442 */ // Label 33: @104442
     /* 104442 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(16), /*)*//*default:*//*Label 1985*/ GIMT_Encode4(105461),
     /* 104453 */ /*GILLT_s32*//*Label 1976*/ GIMT_Encode4(104513),
     /* 104457 */ /*GILLT_s64*//*Label 1977*/ GIMT_Encode4(104730), GIMT_Encode4(0),
     /* 104465 */ /*GILLT_v2s32*//*Label 1978*/ GIMT_Encode4(104777),
     /* 104469 */ /*GILLT_v2s64*//*Label 1979*/ GIMT_Encode4(104824), GIMT_Encode4(0),
     /* 104477 */ /*GILLT_v4s16*//*Label 1980*/ GIMT_Encode4(104947),
     /* 104481 */ /*GILLT_v4s32*//*Label 1981*/ GIMT_Encode4(104994), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 104493 */ /*GILLT_v8s8*//*Label 1982*/ GIMT_Encode4(105186),
     /* 104497 */ /*GILLT_v8s16*//*Label 1983*/ GIMT_Encode4(105233), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 104509 */ /*GILLT_v16s8*//*Label 1984*/ GIMT_Encode4(105347),
     /* 104513 */ // Label 1976: @104513
     /* 104513 */ GIM_Try, /*On fail goto*//*Label 1986*/ GIMT_Encode4(104729),
     /* 104518 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 104521 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 104524 */   GIM_Try, /*On fail goto*//*Label 1987*/ GIMT_Encode4(104586), // Rule ID 1868 //
     /* 104529 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV5TE_IsARM),
     /* 104532 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /* 104536 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 104540 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 104544 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SADDSAT),
     /* 104548 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 104552 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 104557 */     // MIs[1] Rn
     /* 104557 */     GIM_CheckIsSameOperand, /*MI*/1, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 104562 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 104564 */     // (ssubsat:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, (saddsat:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rn))  =>  (QDSUB:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, rGPR:{ *:[i32] }:$Rn)
     /* 104564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::QDSUB),
     /* 104567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 104569 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /* 104571 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 104575 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 104578 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 104584 */     GIR_RootConstrainSelectedInstOperands,
     /* 104585 */     // GIR_Coverage, 1868,
     /* 104585 */     GIR_EraseRootFromParent_Done,
     /* 104586 */   // Label 1987: @104586
     /* 104586 */   GIM_Try, /*On fail goto*//*Label 1988*/ GIMT_Encode4(104648), // Rule ID 2134 //
     /* 104591 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /* 104594 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 104598 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 104602 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 104606 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SADDSAT),
     /* 104610 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 104614 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 104619 */     // MIs[1] Rn
     /* 104619 */     GIM_CheckIsSameOperand, /*MI*/1, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 104624 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 104626 */     // (ssubsat:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, (saddsat:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rn))  =>  (t2QDSUB:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, rGPR:{ *:[i32] }:$Rn)
     /* 104626 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2QDSUB),
     /* 104629 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 104631 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /* 104633 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 104637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 104640 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 104646 */     GIR_RootConstrainSelectedInstOperands,
     /* 104647 */     // GIR_Coverage, 2134,
     /* 104647 */     GIR_EraseRootFromParent_Done,
     /* 104648 */   // Label 1988: @104648
     /* 104648 */   GIM_Try, /*On fail goto*//*Label 1989*/ GIMT_Encode4(104688), // Rule ID 1866 //
     /* 104653 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV5TE_IsARM),
     /* 104656 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /* 104660 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 104664 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 104668 */     // (ssubsat:{ *:[i32] } GPR:{ *:[i32] }:$a, GPR:{ *:[i32] }:$b)  =>  (QSUB:{ *:[i32] } GPR:{ *:[i32] }:$a, GPR:{ *:[i32] }:$b)
     /* 104668 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::QSUB),
     /* 104671 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 104673 */     GIR_RootToRootCopy, /*OpIdx*/1, // a
     /* 104675 */     GIR_RootToRootCopy, /*OpIdx*/2, // b
     /* 104677 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 104680 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 104686 */     GIR_RootConstrainSelectedInstOperands,
     /* 104687 */     // GIR_Coverage, 1866,
     /* 104687 */     GIR_EraseRootFromParent_Done,
     /* 104688 */   // Label 1989: @104688
     /* 104688 */   GIM_Try, /*On fail goto*//*Label 1990*/ GIMT_Encode4(104728), // Rule ID 2132 //
     /* 104693 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /* 104696 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 104700 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 104704 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 104708 */     // (ssubsat:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, rGPR:{ *:[i32] }:$Rn)  =>  (t2QSUB:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, rGPR:{ *:[i32] }:$Rn)
     /* 104708 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2QSUB),
     /* 104711 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 104713 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /* 104715 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 104717 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 104720 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 104726 */     GIR_RootConstrainSelectedInstOperands,
     /* 104727 */     // GIR_Coverage, 2132,
     /* 104727 */     GIR_EraseRootFromParent_Done,
     /* 104728 */   // Label 1990: @104728
     /* 104728 */   GIM_Reject,
     /* 104729 */ // Label 1986: @104729
     /* 104729 */ GIM_Reject,
     /* 104730 */ // Label 1977: @104730
     /* 104730 */ GIM_Try, /*On fail goto*//*Label 1991*/ GIMT_Encode4(104776), // Rule ID 1011 //
     /* 104735 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 104738 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 104741 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 104744 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 104748 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 104752 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 104756 */   // (ssubsat:{ *:[v1i64] } DPR:{ *:[v1i64] }:$Vn, DPR:{ *:[v1i64] }:$Vm)  =>  (VQSUBsv1i64:{ *:[v1i64] } DPR:{ *:[v1i64] }:$Vn, DPR:{ *:[v1i64] }:$Vm)
     /* 104756 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQSUBsv1i64),
     /* 104759 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 104761 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 104763 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 104765 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 104768 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 104774 */   GIR_RootConstrainSelectedInstOperands,
     /* 104775 */   // GIR_Coverage, 1011,
     /* 104775 */   GIR_EraseRootFromParent_Done,
     /* 104776 */ // Label 1991: @104776
     /* 104776 */ GIM_Reject,
     /* 104777 */ // Label 1978: @104777
     /* 104777 */ GIM_Try, /*On fail goto*//*Label 1992*/ GIMT_Encode4(104823), // Rule ID 1006 //
     /* 104782 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 104785 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 104788 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 104791 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 104795 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 104799 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 104803 */   // (ssubsat:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)  =>  (VQSUBsv2i32:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /* 104803 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQSUBsv2i32),
     /* 104806 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 104808 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 104810 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 104812 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 104815 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 104821 */   GIR_RootConstrainSelectedInstOperands,
     /* 104822 */   // GIR_Coverage, 1006,
     /* 104822 */   GIR_EraseRootFromParent_Done,
     /* 104823 */ // Label 1992: @104823
     /* 104823 */ GIM_Reject,
     /* 104824 */ // Label 1979: @104824
     /* 104824 */ GIM_Try, /*On fail goto*//*Label 1993*/ GIMT_Encode4(104946),
     /* 104829 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 104832 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 104835 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 104839 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 104843 */   GIM_Try, /*On fail goto*//*Label 1994*/ GIMT_Encode4(104913), // Rule ID 2493 //
     /* 104848 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 104851 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 104855 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 104859 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 104862 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqdmull),
     /* 104867 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 104871 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 104875 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 104880 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 104885 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 104887 */     // (ssubsat:{ *:[v2i64] } QPR:{ *:[v2i64] }:$src1, (intrinsic_wo_chain:{ *:[v2i64] } 3813:{ *:[iPTR] }, DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm))  =>  (VQDMLSLv2i64:{ *:[v2i64] } QPR:{ *:[v2i64] }:$src1, DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /* 104887 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQDMLSLv2i64),
     /* 104890 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 104892 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 104894 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vn
     /* 104898 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Vm
     /* 104902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 104905 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 104911 */     GIR_RootConstrainSelectedInstOperands,
     /* 104912 */     // GIR_Coverage, 2493,
     /* 104912 */     GIR_EraseRootFromParent_Done,
     /* 104913 */   // Label 1994: @104913
     /* 104913 */   GIM_Try, /*On fail goto*//*Label 1995*/ GIMT_Encode4(104945), // Rule ID 1012 //
     /* 104918 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 104921 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 104925 */     // (ssubsat:{ *:[v2i64] } QPR:{ *:[v2i64] }:$Vn, QPR:{ *:[v2i64] }:$Vm)  =>  (VQSUBsv2i64:{ *:[v2i64] } QPR:{ *:[v2i64] }:$Vn, QPR:{ *:[v2i64] }:$Vm)
     /* 104925 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQSUBsv2i64),
     /* 104928 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 104930 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 104932 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 104934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 104937 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 104943 */     GIR_RootConstrainSelectedInstOperands,
     /* 104944 */     // GIR_Coverage, 1012,
     /* 104944 */     GIR_EraseRootFromParent_Done,
     /* 104945 */   // Label 1995: @104945
     /* 104945 */   GIM_Reject,
     /* 104946 */ // Label 1993: @104946
     /* 104946 */ GIM_Reject,
     /* 104947 */ // Label 1980: @104947
     /* 104947 */ GIM_Try, /*On fail goto*//*Label 1996*/ GIMT_Encode4(104993), // Rule ID 1005 //
     /* 104952 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 104955 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 104958 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 104961 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 104965 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 104969 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 104973 */   // (ssubsat:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)  =>  (VQSUBsv4i16:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /* 104973 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQSUBsv4i16),
     /* 104976 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 104978 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 104980 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 104982 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 104985 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 104991 */   GIR_RootConstrainSelectedInstOperands,
     /* 104992 */   // GIR_Coverage, 1005,
     /* 104992 */   GIR_EraseRootFromParent_Done,
     /* 104993 */ // Label 1996: @104993
     /* 104993 */ GIM_Reject,
     /* 104994 */ // Label 1981: @104994
     /* 104994 */ GIM_Try, /*On fail goto*//*Label 1997*/ GIMT_Encode4(105185),
     /* 104999 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 105002 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 105005 */   GIM_Try, /*On fail goto*//*Label 1998*/ GIMT_Encode4(105083), // Rule ID 2492 //
     /* 105010 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 105013 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 105017 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 105021 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 105025 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 105029 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 105032 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqdmull),
     /* 105037 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 105041 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 105045 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 105050 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 105055 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 105057 */     // (ssubsat:{ *:[v4i32] } QPR:{ *:[v4i32] }:$src1, (intrinsic_wo_chain:{ *:[v4i32] } 3813:{ *:[iPTR] }, DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm))  =>  (VQDMLSLv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$src1, DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /* 105057 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQDMLSLv4i32),
     /* 105060 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 105062 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 105064 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vn
     /* 105068 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Vm
     /* 105072 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 105075 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 105081 */     GIR_RootConstrainSelectedInstOperands,
     /* 105082 */     // GIR_Coverage, 2492,
     /* 105082 */     GIR_EraseRootFromParent_Done,
     /* 105083 */   // Label 1998: @105083
     /* 105083 */   GIM_Try, /*On fail goto*//*Label 1999*/ GIMT_Encode4(105123), // Rule ID 1008 //
     /* 105088 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 105091 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 105095 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 105099 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 105103 */     // (ssubsat:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)  =>  (VQSUBsv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)
     /* 105103 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQSUBsv4i32),
     /* 105106 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 105108 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 105110 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 105112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 105115 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 105121 */     GIR_RootConstrainSelectedInstOperands,
     /* 105122 */     // GIR_Coverage, 1008,
     /* 105122 */     GIR_EraseRootFromParent_Done,
     /* 105123 */   // Label 1999: @105123
     /* 105123 */   GIM_Try, /*On fail goto*//*Label 2000*/ GIMT_Encode4(105184), // Rule ID 3533 //
     /* 105128 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 105131 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 105135 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 105139 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 105143 */     // (ssubsat:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)  =>  (MVE_VQSUBs32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)
     /* 105143 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 105146 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 105150 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 105155 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQSUBs32),
     /* 105158 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 105160 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /* 105162 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /* 105164 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 105167 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 105173 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 105179 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 105182 */     GIR_RootConstrainSelectedInstOperands,
     /* 105183 */     // GIR_Coverage, 3533,
     /* 105183 */     GIR_EraseRootFromParent_Done,
     /* 105184 */   // Label 2000: @105184
     /* 105184 */   GIM_Reject,
     /* 105185 */ // Label 1997: @105185
     /* 105185 */ GIM_Reject,
     /* 105186 */ // Label 1982: @105186
     /* 105186 */ GIM_Try, /*On fail goto*//*Label 2001*/ GIMT_Encode4(105232), // Rule ID 1009 //
     /* 105191 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 105194 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 105197 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 105200 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 105204 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 105208 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 105212 */   // (ssubsat:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)  =>  (VQSUBsv8i8:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /* 105212 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQSUBsv8i8),
     /* 105215 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 105217 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 105219 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 105221 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 105224 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 105230 */   GIR_RootConstrainSelectedInstOperands,
     /* 105231 */   // GIR_Coverage, 1009,
     /* 105231 */   GIR_EraseRootFromParent_Done,
     /* 105232 */ // Label 2001: @105232
     /* 105232 */ GIM_Reject,
     /* 105233 */ // Label 1983: @105233
     /* 105233 */ GIM_Try, /*On fail goto*//*Label 2002*/ GIMT_Encode4(105346),
     /* 105238 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 105241 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 105244 */   GIM_Try, /*On fail goto*//*Label 2003*/ GIMT_Encode4(105284), // Rule ID 1007 //
     /* 105249 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 105252 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 105256 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 105260 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 105264 */     // (ssubsat:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)  =>  (VQSUBsv8i16:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)
     /* 105264 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQSUBsv8i16),
     /* 105267 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 105269 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 105271 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 105273 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 105276 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 105282 */     GIR_RootConstrainSelectedInstOperands,
     /* 105283 */     // GIR_Coverage, 1007,
     /* 105283 */     GIR_EraseRootFromParent_Done,
     /* 105284 */   // Label 2003: @105284
     /* 105284 */   GIM_Try, /*On fail goto*//*Label 2004*/ GIMT_Encode4(105345), // Rule ID 3530 //
     /* 105289 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 105292 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 105296 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 105300 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 105304 */     // (ssubsat:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)  =>  (MVE_VQSUBs16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)
     /* 105304 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 105307 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 105311 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 105316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQSUBs16),
     /* 105319 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 105321 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /* 105323 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /* 105325 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 105328 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 105334 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 105340 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 105343 */     GIR_RootConstrainSelectedInstOperands,
     /* 105344 */     // GIR_Coverage, 3530,
     /* 105344 */     GIR_EraseRootFromParent_Done,
     /* 105345 */   // Label 2004: @105345
     /* 105345 */   GIM_Reject,
     /* 105346 */ // Label 2002: @105346
     /* 105346 */ GIM_Reject,
     /* 105347 */ // Label 1984: @105347
     /* 105347 */ GIM_Try, /*On fail goto*//*Label 2005*/ GIMT_Encode4(105460),
     /* 105352 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 105355 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 105358 */   GIM_Try, /*On fail goto*//*Label 2006*/ GIMT_Encode4(105398), // Rule ID 1010 //
     /* 105363 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 105366 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 105370 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 105374 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 105378 */     // (ssubsat:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)  =>  (VQSUBsv16i8:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)
     /* 105378 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQSUBsv16i8),
     /* 105381 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 105383 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 105385 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 105387 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 105390 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 105396 */     GIR_RootConstrainSelectedInstOperands,
     /* 105397 */     // GIR_Coverage, 1010,
     /* 105397 */     GIR_EraseRootFromParent_Done,
     /* 105398 */   // Label 2006: @105398
     /* 105398 */   GIM_Try, /*On fail goto*//*Label 2007*/ GIMT_Encode4(105459), // Rule ID 3527 //
     /* 105403 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 105406 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 105410 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 105414 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 105418 */     // (ssubsat:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)  =>  (MVE_VQSUBs8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)
     /* 105418 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 105421 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 105425 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 105430 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQSUBs8),
     /* 105433 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 105435 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /* 105437 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /* 105439 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 105442 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 105448 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 105454 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 105457 */     GIR_RootConstrainSelectedInstOperands,
     /* 105458 */     // GIR_Coverage, 3527,
     /* 105458 */     GIR_EraseRootFromParent_Done,
     /* 105459 */   // Label 2007: @105459
     /* 105459 */   GIM_Reject,
     /* 105460 */ // Label 2005: @105460
     /* 105460 */ GIM_Reject,
     /* 105461 */ // Label 1985: @105461
     /* 105461 */ GIM_Reject,
     /* 105462 */ // Label 34: @105462
     /* 105462 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(13), /*)*//*default:*//*Label 2015*/ GIMT_Encode4(107814),
     /* 105473 */ /*GILLT_s16*//*Label 2008*/ GIMT_Encode4(105525),
     /* 105477 */ /*GILLT_s32*//*Label 2009*/ GIMT_Encode4(105572),
     /* 105481 */ /*GILLT_s64*//*Label 2010*/ GIMT_Encode4(107167), GIMT_Encode4(0),
     /* 105489 */ /*GILLT_v2s32*//*Label 2011*/ GIMT_Encode4(107214), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 105501 */ /*GILLT_v4s16*//*Label 2012*/ GIMT_Encode4(107261),
     /* 105505 */ /*GILLT_v4s32*//*Label 2013*/ GIMT_Encode4(107446), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 105521 */ /*GILLT_v8s16*//*Label 2014*/ GIMT_Encode4(107560),
     /* 105525 */ // Label 2008: @105525
     /* 105525 */ GIM_Try, /*On fail goto*//*Label 2016*/ GIMT_Encode4(105571), // Rule ID 614 //
     /* 105530 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 105533 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 105536 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 105539 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 105543 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 105547 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 105551 */   // (fadd:{ *:[f16] } HPR:{ *:[f16] }:$Sn, HPR:{ *:[f16] }:$Sm)  =>  (VADDH:{ *:[f16] } HPR:{ *:[f16] }:$Sn, HPR:{ *:[f16] }:$Sm)
     /* 105551 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDH),
     /* 105554 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /* 105556 */   GIR_RootToRootCopy, /*OpIdx*/1, // Sn
     /* 105558 */   GIR_RootToRootCopy, /*OpIdx*/2, // Sm
     /* 105560 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 105563 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 105569 */   GIR_RootConstrainSelectedInstOperands,
     /* 105570 */   // GIR_Coverage, 614,
     /* 105570 */   GIR_EraseRootFromParent_Done,
     /* 105571 */ // Label 2016: @105571
     /* 105571 */ GIM_Reject,
     /* 105572 */ // Label 2009: @105572
     /* 105572 */ GIM_Try, /*On fail goto*//*Label 2017*/ GIMT_Encode4(107166),
     /* 105577 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 105580 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 105583 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 105587 */   GIM_Try, /*On fail goto*//*Label 2018*/ GIMT_Encode4(105915), // Rule ID 5918 //
     /* 105592 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_UseFPVMLx_UseNEONForFP),
     /* 105595 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 105599 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMUL),
     /* 105603 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 105607 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 105611 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 105616 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 105621 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 105625 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 105627 */     // (fadd:{ *:[f32] } (fmul:{ *:[f32] } SPR:{ *:[f32] }:$a, SPR:{ *:[f32] }:$b), SPR:{ *:[f32] }:$acc)  =>  (EXTRACT_SUBREG:{ *:[f32] } (COPY_TO_REGCLASS:{ *:[v2f32] } (VMLAfd:{ *:[f64] } (INSERT_SUBREG:{ *:[v2f32] } (COPY_TO_REGCLASS:{ *:[v2f32] } (IMPLICIT_DEF:{ *:[v2f32] }), DPR_VFP2:{ *:[i32] }), SPR:{ *:[f32] }:$acc, ssub_0:{ *:[i32] }), (INSERT_SUBREG:{ *:[v2f32] } (COPY_TO_REGCLASS:{ *:[v2f32] } (IMPLICIT_DEF:{ *:[v2f32] }), DPR_VFP2:{ *:[i32] }), SPR:{ *:[f32] }:$a, ssub_0:{ *:[i32] }), (INSERT_SUBREG:{ *:[v2f32] } (COPY_TO_REGCLASS:{ *:[v2f32] } (IMPLICIT_DEF:{ *:[v2f32] }), DPR_VFP2:{ *:[i32] }), SPR:{ *:[f32] }:$b, ssub_0:{ *:[i32] })), DPR_VFP2:{ *:[i32] }), ssub_0:{ *:[i32] })
     /* 105627 */     GIR_MakeTempReg, /*TempRegID*/10, /*TypeID*/GILLT_v2s32,
     /* 105630 */     GIR_BuildMI, /*InsnID*/11, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 105634 */     GIR_AddTempRegister, /*InsnID*/11, /*TempRegID*/10, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 105639 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/11,
     /* 105641 */     GIR_MakeTempReg, /*TempRegID*/9, /*TypeID*/GILLT_v2s32,
     /* 105644 */     GIR_BuildMI, /*InsnID*/10, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 105648 */     GIR_AddTempRegister, /*InsnID*/10, /*TempRegID*/9, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 105653 */     GIR_AddSimpleTempRegister, /*InsnID*/10, /*TempRegID*/10,
     /* 105656 */     GIR_ConstrainOperandRC, /*InsnID*/10, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 105661 */     GIR_MakeTempReg, /*TempRegID*/8, /*TypeID*/GILLT_v2s32,
     /* 105664 */     GIR_BuildMI, /*InsnID*/9, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 105668 */     GIR_AddTempRegister, /*InsnID*/9, /*TempRegID*/8, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 105673 */     GIR_AddSimpleTempRegister, /*InsnID*/9, /*TempRegID*/9,
     /* 105676 */     GIR_Copy, /*NewInsnID*/9, /*OldInsnID*/1, /*OpIdx*/2, // b
     /* 105680 */     GIR_AddImm8, /*InsnID*/9, /*Imm*/17,
     /* 105683 */     GIR_ConstrainOperandRC, /*InsnID*/9, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 105688 */     GIR_ConstrainOperandRC, /*InsnID*/9, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 105693 */     GIR_ConstrainOperandRC, /*InsnID*/9, /*Op*/2, GIMT_Encode2(ARM::SPRRegClassID),
     /* 105698 */     GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_v2s32,
     /* 105701 */     GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 105705 */     GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 105710 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/8,
     /* 105712 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v2s32,
     /* 105715 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 105719 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 105724 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
     /* 105727 */     GIR_ConstrainOperandRC, /*InsnID*/7, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 105732 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v2s32,
     /* 105735 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 105739 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 105744 */     GIR_AddSimpleTempRegister, /*InsnID*/6, /*TempRegID*/6,
     /* 105747 */     GIR_Copy, /*NewInsnID*/6, /*OldInsnID*/1, /*OpIdx*/1, // a
     /* 105751 */     GIR_AddImm8, /*InsnID*/6, /*Imm*/17,
     /* 105754 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 105759 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 105764 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/2, GIMT_Encode2(ARM::SPRRegClassID),
     /* 105769 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v2s32,
     /* 105772 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 105776 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 105781 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 105783 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v2s32,
     /* 105786 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 105790 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 105795 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 105798 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 105803 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s32,
     /* 105806 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 105810 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 105815 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 105818 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // acc
     /* 105822 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/17,
     /* 105825 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 105830 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 105835 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(ARM::SPRRegClassID),
     /* 105840 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 105843 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(ARM::VMLAfd),
     /* 105847 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 105852 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 105855 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/5,
     /* 105858 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/8,
     /* 105861 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/14,
     /* 105864 */     GIR_AddRegister, /*InsnID*/2, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 105870 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 105872 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s32,
     /* 105875 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 105879 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 105884 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 105887 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 105892 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 105895 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 105897 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(ARM::ssub_0),
     /* 105904 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::SPRRegClassID),
     /* 105909 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 105914 */     // GIR_Coverage, 5918,
     /* 105914 */     GIR_EraseRootFromParent_Done,
     /* 105915 */   // Label 2018: @105915
     /* 105915 */   GIM_Try, /*On fail goto*//*Label 2019*/ GIMT_Encode4(106243), // Rule ID 5919 //
     /* 105920 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVFP4_UseFusedMAC_UseNEONForFP),
     /* 105923 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 105927 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMUL),
     /* 105931 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 105935 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 105939 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 105944 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 105949 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 105953 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 105955 */     // (fadd:{ *:[f32] } (fmul:{ *:[f32] } SPR:{ *:[f32] }:$a, SPR:{ *:[f32] }:$b), SPR:{ *:[f32] }:$acc)  =>  (EXTRACT_SUBREG:{ *:[f32] } (COPY_TO_REGCLASS:{ *:[v2f32] } (VFMAfd:{ *:[f64] } (INSERT_SUBREG:{ *:[v2f32] } (COPY_TO_REGCLASS:{ *:[v2f32] } (IMPLICIT_DEF:{ *:[v2f32] }), DPR_VFP2:{ *:[i32] }), SPR:{ *:[f32] }:$acc, ssub_0:{ *:[i32] }), (INSERT_SUBREG:{ *:[v2f32] } (COPY_TO_REGCLASS:{ *:[v2f32] } (IMPLICIT_DEF:{ *:[v2f32] }), DPR_VFP2:{ *:[i32] }), SPR:{ *:[f32] }:$a, ssub_0:{ *:[i32] }), (INSERT_SUBREG:{ *:[v2f32] } (COPY_TO_REGCLASS:{ *:[v2f32] } (IMPLICIT_DEF:{ *:[v2f32] }), DPR_VFP2:{ *:[i32] }), SPR:{ *:[f32] }:$b, ssub_0:{ *:[i32] })), DPR_VFP2:{ *:[i32] }), ssub_0:{ *:[i32] })
     /* 105955 */     GIR_MakeTempReg, /*TempRegID*/10, /*TypeID*/GILLT_v2s32,
     /* 105958 */     GIR_BuildMI, /*InsnID*/11, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 105962 */     GIR_AddTempRegister, /*InsnID*/11, /*TempRegID*/10, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 105967 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/11,
     /* 105969 */     GIR_MakeTempReg, /*TempRegID*/9, /*TypeID*/GILLT_v2s32,
     /* 105972 */     GIR_BuildMI, /*InsnID*/10, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 105976 */     GIR_AddTempRegister, /*InsnID*/10, /*TempRegID*/9, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 105981 */     GIR_AddSimpleTempRegister, /*InsnID*/10, /*TempRegID*/10,
     /* 105984 */     GIR_ConstrainOperandRC, /*InsnID*/10, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 105989 */     GIR_MakeTempReg, /*TempRegID*/8, /*TypeID*/GILLT_v2s32,
     /* 105992 */     GIR_BuildMI, /*InsnID*/9, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 105996 */     GIR_AddTempRegister, /*InsnID*/9, /*TempRegID*/8, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106001 */     GIR_AddSimpleTempRegister, /*InsnID*/9, /*TempRegID*/9,
     /* 106004 */     GIR_Copy, /*NewInsnID*/9, /*OldInsnID*/1, /*OpIdx*/2, // b
     /* 106008 */     GIR_AddImm8, /*InsnID*/9, /*Imm*/17,
     /* 106011 */     GIR_ConstrainOperandRC, /*InsnID*/9, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 106016 */     GIR_ConstrainOperandRC, /*InsnID*/9, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 106021 */     GIR_ConstrainOperandRC, /*InsnID*/9, /*Op*/2, GIMT_Encode2(ARM::SPRRegClassID),
     /* 106026 */     GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_v2s32,
     /* 106029 */     GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 106033 */     GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106038 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/8,
     /* 106040 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v2s32,
     /* 106043 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 106047 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106052 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
     /* 106055 */     GIR_ConstrainOperandRC, /*InsnID*/7, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 106060 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v2s32,
     /* 106063 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 106067 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106072 */     GIR_AddSimpleTempRegister, /*InsnID*/6, /*TempRegID*/6,
     /* 106075 */     GIR_Copy, /*NewInsnID*/6, /*OldInsnID*/1, /*OpIdx*/1, // a
     /* 106079 */     GIR_AddImm8, /*InsnID*/6, /*Imm*/17,
     /* 106082 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 106087 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 106092 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/2, GIMT_Encode2(ARM::SPRRegClassID),
     /* 106097 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v2s32,
     /* 106100 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 106104 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106109 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 106111 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v2s32,
     /* 106114 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 106118 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106123 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 106126 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 106131 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s32,
     /* 106134 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 106138 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106143 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 106146 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // acc
     /* 106150 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/17,
     /* 106153 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 106158 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 106163 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(ARM::SPRRegClassID),
     /* 106168 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 106171 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(ARM::VFMAfd),
     /* 106175 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106180 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 106183 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/5,
     /* 106186 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/8,
     /* 106189 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/14,
     /* 106192 */     GIR_AddRegister, /*InsnID*/2, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 106198 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 106200 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s32,
     /* 106203 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 106207 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106212 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 106215 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 106220 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 106223 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 106225 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(ARM::ssub_0),
     /* 106232 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::SPRRegClassID),
     /* 106237 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 106242 */     // GIR_Coverage, 5919,
     /* 106242 */     GIR_EraseRootFromParent_Done,
     /* 106243 */   // Label 2019: @106243
     /* 106243 */   GIM_Try, /*On fail goto*//*Label 2020*/ GIMT_Encode4(106571), // Rule ID 2697 //
     /* 106248 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_UseFPVMLx_UseNEONForFP),
     /* 106251 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 106255 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 106259 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMUL),
     /* 106263 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 106267 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 106271 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 106276 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 106281 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 106283 */     // (fadd:{ *:[f32] } SPR:{ *:[f32] }:$acc, (fmul:{ *:[f32] } SPR:{ *:[f32] }:$a, SPR:{ *:[f32] }:$b))  =>  (EXTRACT_SUBREG:{ *:[f32] } (COPY_TO_REGCLASS:{ *:[v2f32] } (VMLAfd:{ *:[f64] } (INSERT_SUBREG:{ *:[v2f32] } (COPY_TO_REGCLASS:{ *:[v2f32] } (IMPLICIT_DEF:{ *:[v2f32] }), DPR_VFP2:{ *:[i32] }), SPR:{ *:[f32] }:$acc, ssub_0:{ *:[i32] }), (INSERT_SUBREG:{ *:[v2f32] } (COPY_TO_REGCLASS:{ *:[v2f32] } (IMPLICIT_DEF:{ *:[v2f32] }), DPR_VFP2:{ *:[i32] }), SPR:{ *:[f32] }:$a, ssub_0:{ *:[i32] }), (INSERT_SUBREG:{ *:[v2f32] } (COPY_TO_REGCLASS:{ *:[v2f32] } (IMPLICIT_DEF:{ *:[v2f32] }), DPR_VFP2:{ *:[i32] }), SPR:{ *:[f32] }:$b, ssub_0:{ *:[i32] })), DPR_VFP2:{ *:[i32] }), ssub_0:{ *:[i32] })
     /* 106283 */     GIR_MakeTempReg, /*TempRegID*/10, /*TypeID*/GILLT_v2s32,
     /* 106286 */     GIR_BuildMI, /*InsnID*/11, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 106290 */     GIR_AddTempRegister, /*InsnID*/11, /*TempRegID*/10, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106295 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/11,
     /* 106297 */     GIR_MakeTempReg, /*TempRegID*/9, /*TypeID*/GILLT_v2s32,
     /* 106300 */     GIR_BuildMI, /*InsnID*/10, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 106304 */     GIR_AddTempRegister, /*InsnID*/10, /*TempRegID*/9, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106309 */     GIR_AddSimpleTempRegister, /*InsnID*/10, /*TempRegID*/10,
     /* 106312 */     GIR_ConstrainOperandRC, /*InsnID*/10, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 106317 */     GIR_MakeTempReg, /*TempRegID*/8, /*TypeID*/GILLT_v2s32,
     /* 106320 */     GIR_BuildMI, /*InsnID*/9, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 106324 */     GIR_AddTempRegister, /*InsnID*/9, /*TempRegID*/8, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106329 */     GIR_AddSimpleTempRegister, /*InsnID*/9, /*TempRegID*/9,
     /* 106332 */     GIR_Copy, /*NewInsnID*/9, /*OldInsnID*/1, /*OpIdx*/2, // b
     /* 106336 */     GIR_AddImm8, /*InsnID*/9, /*Imm*/17,
     /* 106339 */     GIR_ConstrainOperandRC, /*InsnID*/9, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 106344 */     GIR_ConstrainOperandRC, /*InsnID*/9, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 106349 */     GIR_ConstrainOperandRC, /*InsnID*/9, /*Op*/2, GIMT_Encode2(ARM::SPRRegClassID),
     /* 106354 */     GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_v2s32,
     /* 106357 */     GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 106361 */     GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106366 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/8,
     /* 106368 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v2s32,
     /* 106371 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 106375 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106380 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
     /* 106383 */     GIR_ConstrainOperandRC, /*InsnID*/7, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 106388 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v2s32,
     /* 106391 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 106395 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106400 */     GIR_AddSimpleTempRegister, /*InsnID*/6, /*TempRegID*/6,
     /* 106403 */     GIR_Copy, /*NewInsnID*/6, /*OldInsnID*/1, /*OpIdx*/1, // a
     /* 106407 */     GIR_AddImm8, /*InsnID*/6, /*Imm*/17,
     /* 106410 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 106415 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 106420 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/2, GIMT_Encode2(ARM::SPRRegClassID),
     /* 106425 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v2s32,
     /* 106428 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 106432 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106437 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 106439 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v2s32,
     /* 106442 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 106446 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106451 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 106454 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 106459 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s32,
     /* 106462 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 106466 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106471 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 106474 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // acc
     /* 106478 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/17,
     /* 106481 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 106486 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 106491 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(ARM::SPRRegClassID),
     /* 106496 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 106499 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(ARM::VMLAfd),
     /* 106503 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106508 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 106511 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/5,
     /* 106514 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/8,
     /* 106517 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/14,
     /* 106520 */     GIR_AddRegister, /*InsnID*/2, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 106526 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 106528 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s32,
     /* 106531 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 106535 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106540 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 106543 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 106548 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 106551 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 106553 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(ARM::ssub_0),
     /* 106560 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::SPRRegClassID),
     /* 106565 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 106570 */     // GIR_Coverage, 2697,
     /* 106570 */     GIR_EraseRootFromParent_Done,
     /* 106571 */   // Label 2020: @106571
     /* 106571 */   GIM_Try, /*On fail goto*//*Label 2021*/ GIMT_Encode4(106899), // Rule ID 2699 //
     /* 106576 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVFP4_UseFusedMAC_UseNEONForFP),
     /* 106579 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 106583 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 106587 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMUL),
     /* 106591 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 106595 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 106599 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 106604 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 106609 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 106611 */     // (fadd:{ *:[f32] } SPR:{ *:[f32] }:$acc, (fmul:{ *:[f32] } SPR:{ *:[f32] }:$a, SPR:{ *:[f32] }:$b))  =>  (EXTRACT_SUBREG:{ *:[f32] } (COPY_TO_REGCLASS:{ *:[v2f32] } (VFMAfd:{ *:[f64] } (INSERT_SUBREG:{ *:[v2f32] } (COPY_TO_REGCLASS:{ *:[v2f32] } (IMPLICIT_DEF:{ *:[v2f32] }), DPR_VFP2:{ *:[i32] }), SPR:{ *:[f32] }:$acc, ssub_0:{ *:[i32] }), (INSERT_SUBREG:{ *:[v2f32] } (COPY_TO_REGCLASS:{ *:[v2f32] } (IMPLICIT_DEF:{ *:[v2f32] }), DPR_VFP2:{ *:[i32] }), SPR:{ *:[f32] }:$a, ssub_0:{ *:[i32] }), (INSERT_SUBREG:{ *:[v2f32] } (COPY_TO_REGCLASS:{ *:[v2f32] } (IMPLICIT_DEF:{ *:[v2f32] }), DPR_VFP2:{ *:[i32] }), SPR:{ *:[f32] }:$b, ssub_0:{ *:[i32] })), DPR_VFP2:{ *:[i32] }), ssub_0:{ *:[i32] })
     /* 106611 */     GIR_MakeTempReg, /*TempRegID*/10, /*TypeID*/GILLT_v2s32,
     /* 106614 */     GIR_BuildMI, /*InsnID*/11, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 106618 */     GIR_AddTempRegister, /*InsnID*/11, /*TempRegID*/10, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106623 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/11,
     /* 106625 */     GIR_MakeTempReg, /*TempRegID*/9, /*TypeID*/GILLT_v2s32,
     /* 106628 */     GIR_BuildMI, /*InsnID*/10, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 106632 */     GIR_AddTempRegister, /*InsnID*/10, /*TempRegID*/9, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106637 */     GIR_AddSimpleTempRegister, /*InsnID*/10, /*TempRegID*/10,
     /* 106640 */     GIR_ConstrainOperandRC, /*InsnID*/10, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 106645 */     GIR_MakeTempReg, /*TempRegID*/8, /*TypeID*/GILLT_v2s32,
     /* 106648 */     GIR_BuildMI, /*InsnID*/9, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 106652 */     GIR_AddTempRegister, /*InsnID*/9, /*TempRegID*/8, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106657 */     GIR_AddSimpleTempRegister, /*InsnID*/9, /*TempRegID*/9,
     /* 106660 */     GIR_Copy, /*NewInsnID*/9, /*OldInsnID*/1, /*OpIdx*/2, // b
     /* 106664 */     GIR_AddImm8, /*InsnID*/9, /*Imm*/17,
     /* 106667 */     GIR_ConstrainOperandRC, /*InsnID*/9, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 106672 */     GIR_ConstrainOperandRC, /*InsnID*/9, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 106677 */     GIR_ConstrainOperandRC, /*InsnID*/9, /*Op*/2, GIMT_Encode2(ARM::SPRRegClassID),
     /* 106682 */     GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_v2s32,
     /* 106685 */     GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 106689 */     GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106694 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/8,
     /* 106696 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v2s32,
     /* 106699 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 106703 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106708 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
     /* 106711 */     GIR_ConstrainOperandRC, /*InsnID*/7, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 106716 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v2s32,
     /* 106719 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 106723 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106728 */     GIR_AddSimpleTempRegister, /*InsnID*/6, /*TempRegID*/6,
     /* 106731 */     GIR_Copy, /*NewInsnID*/6, /*OldInsnID*/1, /*OpIdx*/1, // a
     /* 106735 */     GIR_AddImm8, /*InsnID*/6, /*Imm*/17,
     /* 106738 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 106743 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 106748 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/2, GIMT_Encode2(ARM::SPRRegClassID),
     /* 106753 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v2s32,
     /* 106756 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 106760 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106765 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 106767 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v2s32,
     /* 106770 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 106774 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106779 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 106782 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 106787 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s32,
     /* 106790 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 106794 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106799 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 106802 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // acc
     /* 106806 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/17,
     /* 106809 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 106814 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 106819 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(ARM::SPRRegClassID),
     /* 106824 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 106827 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(ARM::VFMAfd),
     /* 106831 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106836 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 106839 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/5,
     /* 106842 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/8,
     /* 106845 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/14,
     /* 106848 */     GIR_AddRegister, /*InsnID*/2, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 106854 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 106856 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s32,
     /* 106859 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 106863 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106868 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 106871 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 106876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 106879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 106881 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(ARM::ssub_0),
     /* 106888 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::SPRRegClassID),
     /* 106893 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 106898 */     // GIR_Coverage, 2699,
     /* 106898 */     GIR_EraseRootFromParent_Done,
     /* 106899 */   // Label 2021: @106899
     /* 106899 */   GIM_Try, /*On fail goto*//*Label 2022*/ GIMT_Encode4(106935), // Rule ID 613 //
     /* 106904 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_DontUseNEONForFP_HasVFP2),
     /* 106907 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 106911 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 106915 */     // (fadd:{ *:[f32] } SPR:{ *:[f32] }:$Sn, SPR:{ *:[f32] }:$Sm)  =>  (VADDS:{ *:[f32] } SPR:{ *:[f32] }:$Sn, SPR:{ *:[f32] }:$Sm)
     /* 106915 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDS),
     /* 106918 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /* 106920 */     GIR_RootToRootCopy, /*OpIdx*/1, // Sn
     /* 106922 */     GIR_RootToRootCopy, /*OpIdx*/2, // Sm
     /* 106924 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 106927 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 106933 */     GIR_RootConstrainSelectedInstOperands,
     /* 106934 */     // GIR_Coverage, 613,
     /* 106934 */     GIR_EraseRootFromParent_Done,
     /* 106935 */   // Label 2022: @106935
     /* 106935 */   GIM_Try, /*On fail goto*//*Label 2023*/ GIMT_Encode4(107165), // Rule ID 2694 //
     /* 106940 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_UseNEONForFP),
     /* 106943 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 106947 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 106951 */     // (fadd:{ *:[f32] } SPR:{ *:[f32] }:$a, SPR:{ *:[f32] }:$b)  =>  (EXTRACT_SUBREG:{ *:[f32] } (COPY_TO_REGCLASS:{ *:[v2f32] } (VADDfd:{ *:[f64] } (INSERT_SUBREG:{ *:[v2f32] } (COPY_TO_REGCLASS:{ *:[v2f32] } (IMPLICIT_DEF:{ *:[v2f32] }), DPR_VFP2:{ *:[i32] }), SPR:{ *:[f32] }:$a, ssub_0:{ *:[i32] }), (INSERT_SUBREG:{ *:[v2f32] } (COPY_TO_REGCLASS:{ *:[v2f32] } (IMPLICIT_DEF:{ *:[v2f32] }), DPR_VFP2:{ *:[i32] }), SPR:{ *:[f32] }:$b, ssub_0:{ *:[i32] })), DPR_VFP2:{ *:[i32] }), ssub_0:{ *:[i32] })
     /* 106951 */     GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_v2s32,
     /* 106954 */     GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 106958 */     GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106963 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/8,
     /* 106965 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v2s32,
     /* 106968 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 106972 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106977 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
     /* 106980 */     GIR_ConstrainOperandRC, /*InsnID*/7, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 106985 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v2s32,
     /* 106988 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 106992 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106997 */     GIR_AddSimpleTempRegister, /*InsnID*/6, /*TempRegID*/6,
     /* 107000 */     GIR_Copy, /*NewInsnID*/6, /*OldInsnID*/0, /*OpIdx*/2, // b
     /* 107004 */     GIR_AddImm8, /*InsnID*/6, /*Imm*/17,
     /* 107007 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 107012 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 107017 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/2, GIMT_Encode2(ARM::SPRRegClassID),
     /* 107022 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v2s32,
     /* 107025 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 107029 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107034 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 107036 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v2s32,
     /* 107039 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 107043 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107048 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 107051 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 107056 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s32,
     /* 107059 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 107063 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107068 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 107071 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // a
     /* 107075 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/17,
     /* 107078 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 107083 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 107088 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(ARM::SPRRegClassID),
     /* 107093 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 107096 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(ARM::VADDfd),
     /* 107100 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107105 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 107108 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/5,
     /* 107111 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/14,
     /* 107114 */     GIR_AddRegister, /*InsnID*/2, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 107120 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 107122 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s32,
     /* 107125 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 107129 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107134 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 107137 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 107142 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 107145 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 107147 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(ARM::ssub_0),
     /* 107154 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::SPRRegClassID),
     /* 107159 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 107164 */     // GIR_Coverage, 2694,
     /* 107164 */     GIR_EraseRootFromParent_Done,
     /* 107165 */   // Label 2023: @107165
     /* 107165 */   GIM_Reject,
     /* 107166 */ // Label 2017: @107166
     /* 107166 */ GIM_Reject,
     /* 107167 */ // Label 2010: @107167
     /* 107167 */ GIM_Try, /*On fail goto*//*Label 2024*/ GIMT_Encode4(107213), // Rule ID 612 //
     /* 107172 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDPVFP_HasVFP2),
     /* 107175 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 107178 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 107181 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 107185 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 107189 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 107193 */   // (fadd:{ *:[f64] } DPR:{ *:[f64] }:$Dn, DPR:{ *:[f64] }:$Dm)  =>  (VADDD:{ *:[f64] } DPR:{ *:[f64] }:$Dn, DPR:{ *:[f64] }:$Dm)
     /* 107193 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDD),
     /* 107196 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Dd]
     /* 107198 */   GIR_RootToRootCopy, /*OpIdx*/1, // Dn
     /* 107200 */   GIR_RootToRootCopy, /*OpIdx*/2, // Dm
     /* 107202 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 107205 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 107211 */   GIR_RootConstrainSelectedInstOperands,
     /* 107212 */   // GIR_Coverage, 612,
     /* 107212 */   GIR_EraseRootFromParent_Done,
     /* 107213 */ // Label 2024: @107213
     /* 107213 */ GIM_Reject,
     /* 107214 */ // Label 2011: @107214
     /* 107214 */ GIM_Try, /*On fail goto*//*Label 2025*/ GIMT_Encode4(107260), // Rule ID 761 //
     /* 107219 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 107222 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 107225 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 107228 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 107232 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 107236 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 107240 */   // (fadd:{ *:[v2f32] } DPR:{ *:[v2f32] }:$Vn, DPR:{ *:[v2f32] }:$Vm)  =>  (VADDfd:{ *:[v2f32] } DPR:{ *:[v2f32] }:$Vn, DPR:{ *:[v2f32] }:$Vm)
     /* 107240 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDfd),
     /* 107243 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 107245 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 107247 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 107249 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 107252 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 107258 */   GIR_RootConstrainSelectedInstOperands,
     /* 107259 */   // GIR_Coverage, 761,
     /* 107259 */   GIR_EraseRootFromParent_Done,
     /* 107260 */ // Label 2025: @107260
     /* 107260 */ GIM_Reject,
     /* 107261 */ // Label 2012: @107261
     /* 107261 */ GIM_Try, /*On fail goto*//*Label 2026*/ GIMT_Encode4(107445),
     /* 107266 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 107269 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 107272 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 107276 */   GIM_Try, /*On fail goto*//*Label 2027*/ GIMT_Encode4(107342), // Rule ID 5581 //
     /* 107281 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON_UseFusedMAC),
     /* 107284 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 107288 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMUL),
     /* 107292 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 107296 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 107300 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 107305 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 107310 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 107314 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 107316 */     // (fadd:{ *:[v4f16] } (fmul:{ *:[v4f16] } DPR:{ *:[v4f16] }:$Vn, DPR:{ *:[v4f16] }:$Vm), DPR:{ *:[v4f16] }:$src1)  =>  (VFMAhd:{ *:[v4f16] } DPR:{ *:[v4f16] }:$src1, DPR:{ *:[v4f16] }:$Vn, DPR:{ *:[v4f16] }:$Vm)
     /* 107316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VFMAhd),
     /* 107319 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 107321 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 107323 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /* 107327 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /* 107331 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 107334 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 107340 */     GIR_RootConstrainSelectedInstOperands,
     /* 107341 */     // GIR_Coverage, 5581,
     /* 107341 */     GIR_EraseRootFromParent_Done,
     /* 107342 */   // Label 2027: @107342
     /* 107342 */   GIM_Try, /*On fail goto*//*Label 2028*/ GIMT_Encode4(107408), // Rule ID 942 //
     /* 107347 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON_UseFusedMAC),
     /* 107350 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 107354 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 107358 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMUL),
     /* 107362 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 107366 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 107370 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 107375 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 107380 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 107382 */     // (fadd:{ *:[v4f16] } DPR:{ *:[v4f16] }:$src1, (fmul:{ *:[v4f16] } DPR:{ *:[v4f16] }:$Vn, DPR:{ *:[v4f16] }:$Vm))  =>  (VFMAhd:{ *:[v4f16] } DPR:{ *:[v4f16] }:$src1, DPR:{ *:[v4f16] }:$Vn, DPR:{ *:[v4f16] }:$Vm)
     /* 107382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VFMAhd),
     /* 107385 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 107387 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 107389 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /* 107393 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /* 107397 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 107400 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 107406 */     GIR_RootConstrainSelectedInstOperands,
     /* 107407 */     // GIR_Coverage, 942,
     /* 107407 */     GIR_EraseRootFromParent_Done,
     /* 107408 */   // Label 2028: @107408
     /* 107408 */   GIM_Try, /*On fail goto*//*Label 2029*/ GIMT_Encode4(107444), // Rule ID 763 //
     /* 107413 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 107416 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 107420 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 107424 */     // (fadd:{ *:[v4f16] } DPR:{ *:[v4f16] }:$Vn, DPR:{ *:[v4f16] }:$Vm)  =>  (VADDhd:{ *:[v4f16] } DPR:{ *:[v4f16] }:$Vn, DPR:{ *:[v4f16] }:$Vm)
     /* 107424 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDhd),
     /* 107427 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 107429 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 107431 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 107433 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 107436 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 107442 */     GIR_RootConstrainSelectedInstOperands,
     /* 107443 */     // GIR_Coverage, 763,
     /* 107443 */     GIR_EraseRootFromParent_Done,
     /* 107444 */   // Label 2029: @107444
     /* 107444 */   GIM_Reject,
     /* 107445 */ // Label 2026: @107445
     /* 107445 */ GIM_Reject,
     /* 107446 */ // Label 2013: @107446
     /* 107446 */ GIM_Try, /*On fail goto*//*Label 2030*/ GIMT_Encode4(107559),
     /* 107451 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 107454 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 107457 */   GIM_Try, /*On fail goto*//*Label 2031*/ GIMT_Encode4(107497), // Rule ID 762 //
     /* 107462 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 107465 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 107469 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 107473 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 107477 */     // (fadd:{ *:[v4f32] } QPR:{ *:[v4f32] }:$Vn, QPR:{ *:[v4f32] }:$Vm)  =>  (VADDfq:{ *:[v4f32] } QPR:{ *:[v4f32] }:$Vn, QPR:{ *:[v4f32] }:$Vm)
     /* 107477 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDfq),
     /* 107480 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 107482 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 107484 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 107486 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 107489 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 107495 */     GIR_RootConstrainSelectedInstOperands,
     /* 107496 */     // GIR_Coverage, 762,
     /* 107496 */     GIR_EraseRootFromParent_Done,
     /* 107497 */   // Label 2031: @107497
     /* 107497 */   GIM_Try, /*On fail goto*//*Label 2032*/ GIMT_Encode4(107558), // Rule ID 4013 //
     /* 107502 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /* 107505 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 107509 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 107513 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 107517 */     // (fadd:{ *:[v4f32] } MQPR:{ *:[v4f32] }:$Qm, MQPR:{ *:[v4f32] }:$Qn)  =>  (MVE_VADDf32:{ *:[v4f32] } MQPR:{ *:[v4f32] }:$Qm, MQPR:{ *:[v4f32] }:$Qn)
     /* 107517 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 107520 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 107524 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107529 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VADDf32),
     /* 107532 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 107534 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /* 107536 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /* 107538 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 107541 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 107547 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 107553 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 107556 */     GIR_RootConstrainSelectedInstOperands,
     /* 107557 */     // GIR_Coverage, 4013,
     /* 107557 */     GIR_EraseRootFromParent_Done,
     /* 107558 */   // Label 2032: @107558
     /* 107558 */   GIM_Reject,
     /* 107559 */ // Label 2030: @107559
     /* 107559 */ GIM_Reject,
     /* 107560 */ // Label 2014: @107560
     /* 107560 */ GIM_Try, /*On fail goto*//*Label 2033*/ GIMT_Encode4(107813),
     /* 107565 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 107568 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 107571 */   GIM_Try, /*On fail goto*//*Label 2034*/ GIMT_Encode4(107641), // Rule ID 5582 //
     /* 107576 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON_UseFusedMAC),
     /* 107579 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 107583 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 107587 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMUL),
     /* 107591 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 107595 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 107599 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 107604 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 107609 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 107613 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 107615 */     // (fadd:{ *:[v8f16] } (fmul:{ *:[v8f16] } QPR:{ *:[v8f16] }:$Vn, QPR:{ *:[v8f16] }:$Vm), QPR:{ *:[v8f16] }:$src1)  =>  (VFMAhq:{ *:[v8f16] } QPR:{ *:[v8f16] }:$src1, QPR:{ *:[v8f16] }:$Vn, QPR:{ *:[v8f16] }:$Vm)
     /* 107615 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VFMAhq),
     /* 107618 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 107620 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 107622 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /* 107626 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /* 107630 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 107633 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 107639 */     GIR_RootConstrainSelectedInstOperands,
     /* 107640 */     // GIR_Coverage, 5582,
     /* 107640 */     GIR_EraseRootFromParent_Done,
     /* 107641 */   // Label 2034: @107641
     /* 107641 */   GIM_Try, /*On fail goto*//*Label 2035*/ GIMT_Encode4(107711), // Rule ID 943 //
     /* 107646 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON_UseFusedMAC),
     /* 107649 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 107653 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 107657 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 107661 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMUL),
     /* 107665 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 107669 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 107673 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 107678 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 107683 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 107685 */     // (fadd:{ *:[v8f16] } QPR:{ *:[v8f16] }:$src1, (fmul:{ *:[v8f16] } QPR:{ *:[v8f16] }:$Vn, QPR:{ *:[v8f16] }:$Vm))  =>  (VFMAhq:{ *:[v8f16] } QPR:{ *:[v8f16] }:$src1, QPR:{ *:[v8f16] }:$Vn, QPR:{ *:[v8f16] }:$Vm)
     /* 107685 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VFMAhq),
     /* 107688 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 107690 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 107692 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /* 107696 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /* 107700 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 107703 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 107709 */     GIR_RootConstrainSelectedInstOperands,
     /* 107710 */     // GIR_Coverage, 943,
     /* 107710 */     GIR_EraseRootFromParent_Done,
     /* 107711 */   // Label 2035: @107711
     /* 107711 */   GIM_Try, /*On fail goto*//*Label 2036*/ GIMT_Encode4(107751), // Rule ID 764 //
     /* 107716 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 107719 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 107723 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 107727 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 107731 */     // (fadd:{ *:[v8f16] } QPR:{ *:[v8f16] }:$Vn, QPR:{ *:[v8f16] }:$Vm)  =>  (VADDhq:{ *:[v8f16] } QPR:{ *:[v8f16] }:$Vn, QPR:{ *:[v8f16] }:$Vm)
     /* 107731 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDhq),
     /* 107734 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 107736 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 107738 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 107740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 107743 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 107749 */     GIR_RootConstrainSelectedInstOperands,
     /* 107750 */     // GIR_Coverage, 764,
     /* 107750 */     GIR_EraseRootFromParent_Done,
     /* 107751 */   // Label 2036: @107751
     /* 107751 */   GIM_Try, /*On fail goto*//*Label 2037*/ GIMT_Encode4(107812), // Rule ID 4017 //
     /* 107756 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /* 107759 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 107763 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 107767 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 107771 */     // (fadd:{ *:[v8f16] } MQPR:{ *:[v8f16] }:$Qm, MQPR:{ *:[v8f16] }:$Qn)  =>  (MVE_VADDf16:{ *:[v8f16] } MQPR:{ *:[v8f16] }:$Qm, MQPR:{ *:[v8f16] }:$Qn)
     /* 107771 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 107774 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 107778 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107783 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VADDf16),
     /* 107786 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 107788 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /* 107790 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /* 107792 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 107795 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 107801 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 107807 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 107810 */     GIR_RootConstrainSelectedInstOperands,
     /* 107811 */     // GIR_Coverage, 4017,
     /* 107811 */     GIR_EraseRootFromParent_Done,
     /* 107812 */   // Label 2037: @107812
     /* 107812 */   GIM_Reject,
     /* 107813 */ // Label 2033: @107813
     /* 107813 */ GIM_Reject,
     /* 107814 */ // Label 2015: @107814
     /* 107814 */ GIM_Reject,
     /* 107815 */ // Label 35: @107815
     /* 107815 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(13), /*)*//*default:*//*Label 2045*/ GIMT_Encode4(109491),
     /* 107826 */ /*GILLT_s16*//*Label 2038*/ GIMT_Encode4(107878),
     /* 107830 */ /*GILLT_s32*//*Label 2039*/ GIMT_Encode4(107925),
     /* 107834 */ /*GILLT_s64*//*Label 2040*/ GIMT_Encode4(108852), GIMT_Encode4(0),
     /* 107842 */ /*GILLT_v2s32*//*Label 2041*/ GIMT_Encode4(108899), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 107854 */ /*GILLT_v4s16*//*Label 2042*/ GIMT_Encode4(108946),
     /* 107858 */ /*GILLT_v4s32*//*Label 2043*/ GIMT_Encode4(109123), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 107874 */ /*GILLT_v8s16*//*Label 2044*/ GIMT_Encode4(109237),
     /* 107878 */ // Label 2038: @107878
     /* 107878 */ GIM_Try, /*On fail goto*//*Label 2046*/ GIMT_Encode4(107924), // Rule ID 617 //
     /* 107883 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 107886 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 107889 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 107892 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 107896 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 107900 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 107904 */   // (fsub:{ *:[f16] } HPR:{ *:[f16] }:$Sn, HPR:{ *:[f16] }:$Sm)  =>  (VSUBH:{ *:[f16] } HPR:{ *:[f16] }:$Sn, HPR:{ *:[f16] }:$Sm)
     /* 107904 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSUBH),
     /* 107907 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /* 107909 */   GIR_RootToRootCopy, /*OpIdx*/1, // Sn
     /* 107911 */   GIR_RootToRootCopy, /*OpIdx*/2, // Sm
     /* 107913 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 107916 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 107922 */   GIR_RootConstrainSelectedInstOperands,
     /* 107923 */   // GIR_Coverage, 617,
     /* 107923 */   GIR_EraseRootFromParent_Done,
     /* 107924 */ // Label 2046: @107924
     /* 107924 */ GIM_Reject,
     /* 107925 */ // Label 2039: @107925
     /* 107925 */ GIM_Try, /*On fail goto*//*Label 2047*/ GIMT_Encode4(108851),
     /* 107930 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 107933 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 107936 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 107940 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 107944 */   GIM_Try, /*On fail goto*//*Label 2048*/ GIMT_Encode4(108268), // Rule ID 2698 //
     /* 107949 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_UseFPVMLx_UseNEONForFP),
     /* 107952 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 107956 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMUL),
     /* 107960 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 107964 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 107968 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 107973 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 107978 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 107980 */     // (fsub:{ *:[f32] } SPR:{ *:[f32] }:$acc, (fmul:{ *:[f32] } SPR:{ *:[f32] }:$a, SPR:{ *:[f32] }:$b))  =>  (EXTRACT_SUBREG:{ *:[f32] } (COPY_TO_REGCLASS:{ *:[v2f32] } (VMLSfd:{ *:[f64] } (INSERT_SUBREG:{ *:[v2f32] } (COPY_TO_REGCLASS:{ *:[v2f32] } (IMPLICIT_DEF:{ *:[v2f32] }), DPR_VFP2:{ *:[i32] }), SPR:{ *:[f32] }:$acc, ssub_0:{ *:[i32] }), (INSERT_SUBREG:{ *:[v2f32] } (COPY_TO_REGCLASS:{ *:[v2f32] } (IMPLICIT_DEF:{ *:[v2f32] }), DPR_VFP2:{ *:[i32] }), SPR:{ *:[f32] }:$a, ssub_0:{ *:[i32] }), (INSERT_SUBREG:{ *:[v2f32] } (COPY_TO_REGCLASS:{ *:[v2f32] } (IMPLICIT_DEF:{ *:[v2f32] }), DPR_VFP2:{ *:[i32] }), SPR:{ *:[f32] }:$b, ssub_0:{ *:[i32] })), DPR_VFP2:{ *:[i32] }), ssub_0:{ *:[i32] })
     /* 107980 */     GIR_MakeTempReg, /*TempRegID*/10, /*TypeID*/GILLT_v2s32,
     /* 107983 */     GIR_BuildMI, /*InsnID*/11, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 107987 */     GIR_AddTempRegister, /*InsnID*/11, /*TempRegID*/10, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107992 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/11,
     /* 107994 */     GIR_MakeTempReg, /*TempRegID*/9, /*TypeID*/GILLT_v2s32,
     /* 107997 */     GIR_BuildMI, /*InsnID*/10, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 108001 */     GIR_AddTempRegister, /*InsnID*/10, /*TempRegID*/9, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 108006 */     GIR_AddSimpleTempRegister, /*InsnID*/10, /*TempRegID*/10,
     /* 108009 */     GIR_ConstrainOperandRC, /*InsnID*/10, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 108014 */     GIR_MakeTempReg, /*TempRegID*/8, /*TypeID*/GILLT_v2s32,
     /* 108017 */     GIR_BuildMI, /*InsnID*/9, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 108021 */     GIR_AddTempRegister, /*InsnID*/9, /*TempRegID*/8, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 108026 */     GIR_AddSimpleTempRegister, /*InsnID*/9, /*TempRegID*/9,
     /* 108029 */     GIR_Copy, /*NewInsnID*/9, /*OldInsnID*/1, /*OpIdx*/2, // b
     /* 108033 */     GIR_AddImm8, /*InsnID*/9, /*Imm*/17,
     /* 108036 */     GIR_ConstrainOperandRC, /*InsnID*/9, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 108041 */     GIR_ConstrainOperandRC, /*InsnID*/9, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 108046 */     GIR_ConstrainOperandRC, /*InsnID*/9, /*Op*/2, GIMT_Encode2(ARM::SPRRegClassID),
     /* 108051 */     GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_v2s32,
     /* 108054 */     GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 108058 */     GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 108063 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/8,
     /* 108065 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v2s32,
     /* 108068 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 108072 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 108077 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
     /* 108080 */     GIR_ConstrainOperandRC, /*InsnID*/7, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 108085 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v2s32,
     /* 108088 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 108092 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 108097 */     GIR_AddSimpleTempRegister, /*InsnID*/6, /*TempRegID*/6,
     /* 108100 */     GIR_Copy, /*NewInsnID*/6, /*OldInsnID*/1, /*OpIdx*/1, // a
     /* 108104 */     GIR_AddImm8, /*InsnID*/6, /*Imm*/17,
     /* 108107 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 108112 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 108117 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/2, GIMT_Encode2(ARM::SPRRegClassID),
     /* 108122 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v2s32,
     /* 108125 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 108129 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 108134 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 108136 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v2s32,
     /* 108139 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 108143 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 108148 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 108151 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 108156 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s32,
     /* 108159 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 108163 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 108168 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 108171 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // acc
     /* 108175 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/17,
     /* 108178 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 108183 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 108188 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(ARM::SPRRegClassID),
     /* 108193 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 108196 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(ARM::VMLSfd),
     /* 108200 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 108205 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 108208 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/5,
     /* 108211 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/8,
     /* 108214 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/14,
     /* 108217 */     GIR_AddRegister, /*InsnID*/2, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 108223 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 108225 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s32,
     /* 108228 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 108232 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 108237 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 108240 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 108245 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 108248 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 108250 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(ARM::ssub_0),
     /* 108257 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::SPRRegClassID),
     /* 108262 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 108267 */     // GIR_Coverage, 2698,
     /* 108267 */     GIR_EraseRootFromParent_Done,
     /* 108268 */   // Label 2048: @108268
     /* 108268 */   GIM_Try, /*On fail goto*//*Label 2049*/ GIMT_Encode4(108592), // Rule ID 2700 //
     /* 108273 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVFP4_UseFusedMAC_UseNEONForFP),
     /* 108276 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 108280 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMUL),
     /* 108284 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 108288 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 108292 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 108297 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 108302 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 108304 */     // (fsub:{ *:[f32] } SPR:{ *:[f32] }:$acc, (fmul:{ *:[f32] } SPR:{ *:[f32] }:$a, SPR:{ *:[f32] }:$b))  =>  (EXTRACT_SUBREG:{ *:[f32] } (COPY_TO_REGCLASS:{ *:[v2f32] } (VFMSfd:{ *:[f64] } (INSERT_SUBREG:{ *:[v2f32] } (COPY_TO_REGCLASS:{ *:[v2f32] } (IMPLICIT_DEF:{ *:[v2f32] }), DPR_VFP2:{ *:[i32] }), SPR:{ *:[f32] }:$acc, ssub_0:{ *:[i32] }), (INSERT_SUBREG:{ *:[v2f32] } (COPY_TO_REGCLASS:{ *:[v2f32] } (IMPLICIT_DEF:{ *:[v2f32] }), DPR_VFP2:{ *:[i32] }), SPR:{ *:[f32] }:$a, ssub_0:{ *:[i32] }), (INSERT_SUBREG:{ *:[v2f32] } (COPY_TO_REGCLASS:{ *:[v2f32] } (IMPLICIT_DEF:{ *:[v2f32] }), DPR_VFP2:{ *:[i32] }), SPR:{ *:[f32] }:$b, ssub_0:{ *:[i32] })), DPR_VFP2:{ *:[i32] }), ssub_0:{ *:[i32] })
     /* 108304 */     GIR_MakeTempReg, /*TempRegID*/10, /*TypeID*/GILLT_v2s32,
     /* 108307 */     GIR_BuildMI, /*InsnID*/11, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 108311 */     GIR_AddTempRegister, /*InsnID*/11, /*TempRegID*/10, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 108316 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/11,
     /* 108318 */     GIR_MakeTempReg, /*TempRegID*/9, /*TypeID*/GILLT_v2s32,
     /* 108321 */     GIR_BuildMI, /*InsnID*/10, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 108325 */     GIR_AddTempRegister, /*InsnID*/10, /*TempRegID*/9, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 108330 */     GIR_AddSimpleTempRegister, /*InsnID*/10, /*TempRegID*/10,
     /* 108333 */     GIR_ConstrainOperandRC, /*InsnID*/10, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 108338 */     GIR_MakeTempReg, /*TempRegID*/8, /*TypeID*/GILLT_v2s32,
     /* 108341 */     GIR_BuildMI, /*InsnID*/9, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 108345 */     GIR_AddTempRegister, /*InsnID*/9, /*TempRegID*/8, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 108350 */     GIR_AddSimpleTempRegister, /*InsnID*/9, /*TempRegID*/9,
     /* 108353 */     GIR_Copy, /*NewInsnID*/9, /*OldInsnID*/1, /*OpIdx*/2, // b
     /* 108357 */     GIR_AddImm8, /*InsnID*/9, /*Imm*/17,
     /* 108360 */     GIR_ConstrainOperandRC, /*InsnID*/9, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 108365 */     GIR_ConstrainOperandRC, /*InsnID*/9, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 108370 */     GIR_ConstrainOperandRC, /*InsnID*/9, /*Op*/2, GIMT_Encode2(ARM::SPRRegClassID),
     /* 108375 */     GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_v2s32,
     /* 108378 */     GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 108382 */     GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 108387 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/8,
     /* 108389 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v2s32,
     /* 108392 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 108396 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 108401 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
     /* 108404 */     GIR_ConstrainOperandRC, /*InsnID*/7, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 108409 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v2s32,
     /* 108412 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 108416 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 108421 */     GIR_AddSimpleTempRegister, /*InsnID*/6, /*TempRegID*/6,
     /* 108424 */     GIR_Copy, /*NewInsnID*/6, /*OldInsnID*/1, /*OpIdx*/1, // a
     /* 108428 */     GIR_AddImm8, /*InsnID*/6, /*Imm*/17,
     /* 108431 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 108436 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 108441 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/2, GIMT_Encode2(ARM::SPRRegClassID),
     /* 108446 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v2s32,
     /* 108449 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 108453 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 108458 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 108460 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v2s32,
     /* 108463 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 108467 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 108472 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 108475 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 108480 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s32,
     /* 108483 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 108487 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 108492 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 108495 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // acc
     /* 108499 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/17,
     /* 108502 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 108507 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 108512 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(ARM::SPRRegClassID),
     /* 108517 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 108520 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(ARM::VFMSfd),
     /* 108524 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 108529 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 108532 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/5,
     /* 108535 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/8,
     /* 108538 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/14,
     /* 108541 */     GIR_AddRegister, /*InsnID*/2, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 108547 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 108549 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s32,
     /* 108552 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 108556 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 108561 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 108564 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 108569 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 108572 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 108574 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(ARM::ssub_0),
     /* 108581 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::SPRRegClassID),
     /* 108586 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 108591 */     // GIR_Coverage, 2700,
     /* 108591 */     GIR_EraseRootFromParent_Done,
     /* 108592 */   // Label 2049: @108592
     /* 108592 */   GIM_Try, /*On fail goto*//*Label 2050*/ GIMT_Encode4(108624), // Rule ID 616 //
     /* 108597 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_DontUseNEONForFP_HasVFP2),
     /* 108600 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 108604 */     // (fsub:{ *:[f32] } SPR:{ *:[f32] }:$Sn, SPR:{ *:[f32] }:$Sm)  =>  (VSUBS:{ *:[f32] } SPR:{ *:[f32] }:$Sn, SPR:{ *:[f32] }:$Sm)
     /* 108604 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSUBS),
     /* 108607 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /* 108609 */     GIR_RootToRootCopy, /*OpIdx*/1, // Sn
     /* 108611 */     GIR_RootToRootCopy, /*OpIdx*/2, // Sm
     /* 108613 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 108616 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 108622 */     GIR_RootConstrainSelectedInstOperands,
     /* 108623 */     // GIR_Coverage, 616,
     /* 108623 */     GIR_EraseRootFromParent_Done,
     /* 108624 */   // Label 2050: @108624
     /* 108624 */   GIM_Try, /*On fail goto*//*Label 2051*/ GIMT_Encode4(108850), // Rule ID 2695 //
     /* 108629 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_UseNEONForFP),
     /* 108632 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 108636 */     // (fsub:{ *:[f32] } SPR:{ *:[f32] }:$a, SPR:{ *:[f32] }:$b)  =>  (EXTRACT_SUBREG:{ *:[f32] } (COPY_TO_REGCLASS:{ *:[v2f32] } (VSUBfd:{ *:[f64] } (INSERT_SUBREG:{ *:[v2f32] } (COPY_TO_REGCLASS:{ *:[v2f32] } (IMPLICIT_DEF:{ *:[v2f32] }), DPR_VFP2:{ *:[i32] }), SPR:{ *:[f32] }:$a, ssub_0:{ *:[i32] }), (INSERT_SUBREG:{ *:[v2f32] } (COPY_TO_REGCLASS:{ *:[v2f32] } (IMPLICIT_DEF:{ *:[v2f32] }), DPR_VFP2:{ *:[i32] }), SPR:{ *:[f32] }:$b, ssub_0:{ *:[i32] })), DPR_VFP2:{ *:[i32] }), ssub_0:{ *:[i32] })
     /* 108636 */     GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_v2s32,
     /* 108639 */     GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 108643 */     GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 108648 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/8,
     /* 108650 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v2s32,
     /* 108653 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 108657 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 108662 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
     /* 108665 */     GIR_ConstrainOperandRC, /*InsnID*/7, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 108670 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v2s32,
     /* 108673 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 108677 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 108682 */     GIR_AddSimpleTempRegister, /*InsnID*/6, /*TempRegID*/6,
     /* 108685 */     GIR_Copy, /*NewInsnID*/6, /*OldInsnID*/0, /*OpIdx*/2, // b
     /* 108689 */     GIR_AddImm8, /*InsnID*/6, /*Imm*/17,
     /* 108692 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 108697 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 108702 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/2, GIMT_Encode2(ARM::SPRRegClassID),
     /* 108707 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v2s32,
     /* 108710 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 108714 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 108719 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 108721 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v2s32,
     /* 108724 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 108728 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 108733 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 108736 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 108741 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s32,
     /* 108744 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 108748 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 108753 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 108756 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // a
     /* 108760 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/17,
     /* 108763 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 108768 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 108773 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(ARM::SPRRegClassID),
     /* 108778 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 108781 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(ARM::VSUBfd),
     /* 108785 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 108790 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 108793 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/5,
     /* 108796 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/14,
     /* 108799 */     GIR_AddRegister, /*InsnID*/2, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 108805 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 108807 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s32,
     /* 108810 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 108814 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 108819 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 108822 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 108827 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 108830 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 108832 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(ARM::ssub_0),
     /* 108839 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::SPRRegClassID),
     /* 108844 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 108849 */     // GIR_Coverage, 2695,
     /* 108849 */     GIR_EraseRootFromParent_Done,
     /* 108850 */   // Label 2051: @108850
     /* 108850 */   GIM_Reject,
     /* 108851 */ // Label 2047: @108851
     /* 108851 */ GIM_Reject,
     /* 108852 */ // Label 2040: @108852
     /* 108852 */ GIM_Try, /*On fail goto*//*Label 2052*/ GIMT_Encode4(108898), // Rule ID 615 //
     /* 108857 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDPVFP_HasVFP2),
     /* 108860 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 108863 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 108866 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 108870 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 108874 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 108878 */   // (fsub:{ *:[f64] } DPR:{ *:[f64] }:$Dn, DPR:{ *:[f64] }:$Dm)  =>  (VSUBD:{ *:[f64] } DPR:{ *:[f64] }:$Dn, DPR:{ *:[f64] }:$Dm)
     /* 108878 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSUBD),
     /* 108881 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Dd]
     /* 108883 */   GIR_RootToRootCopy, /*OpIdx*/1, // Dn
     /* 108885 */   GIR_RootToRootCopy, /*OpIdx*/2, // Dm
     /* 108887 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 108890 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 108896 */   GIR_RootConstrainSelectedInstOperands,
     /* 108897 */   // GIR_Coverage, 615,
     /* 108897 */   GIR_EraseRootFromParent_Done,
     /* 108898 */ // Label 2052: @108898
     /* 108898 */ GIM_Reject,
     /* 108899 */ // Label 2041: @108899
     /* 108899 */ GIM_Try, /*On fail goto*//*Label 2053*/ GIMT_Encode4(108945), // Rule ID 965 //
     /* 108904 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 108907 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 108910 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 108913 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 108917 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 108921 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 108925 */   // (fsub:{ *:[v2f32] } DPR:{ *:[v2f32] }:$Vn, DPR:{ *:[v2f32] }:$Vm)  =>  (VSUBfd:{ *:[v2f32] } DPR:{ *:[v2f32] }:$Vn, DPR:{ *:[v2f32] }:$Vm)
     /* 108925 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSUBfd),
     /* 108928 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 108930 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 108932 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 108934 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 108937 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 108943 */   GIR_RootConstrainSelectedInstOperands,
     /* 108944 */   // GIR_Coverage, 965,
     /* 108944 */   GIR_EraseRootFromParent_Done,
     /* 108945 */ // Label 2053: @108945
     /* 108945 */ GIM_Reject,
     /* 108946 */ // Label 2042: @108946
     /* 108946 */ GIM_Try, /*On fail goto*//*Label 2054*/ GIMT_Encode4(109122),
     /* 108951 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 108954 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 108957 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 108961 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 108965 */   GIM_Try, /*On fail goto*//*Label 2055*/ GIMT_Encode4(109027), // Rule ID 920 //
     /* 108970 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON_UseFPVMLx),
     /* 108973 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 108977 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMUL),
     /* 108981 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 108985 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 108989 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 108994 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 108999 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 109001 */     // (fsub:{ *:[v4f16] } DPR:{ *:[v4f16] }:$src1, (fmul:{ *:[v4f16] } DPR:{ *:[v4f16] }:$Vn, DPR:{ *:[v4f16] }:$Vm))  =>  (VMLShd:{ *:[v4f16] } DPR:{ *:[v4f16] }:$src1, DPR:{ *:[v4f16] }:$Vn, DPR:{ *:[v4f16] }:$Vm)
     /* 109001 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMLShd),
     /* 109004 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 109006 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 109008 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /* 109012 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /* 109016 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 109019 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 109025 */     GIR_RootConstrainSelectedInstOperands,
     /* 109026 */     // GIR_Coverage, 920,
     /* 109026 */     GIR_EraseRootFromParent_Done,
     /* 109027 */   // Label 2055: @109027
     /* 109027 */   GIM_Try, /*On fail goto*//*Label 2056*/ GIMT_Encode4(109089), // Rule ID 946 //
     /* 109032 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON_UseFusedMAC),
     /* 109035 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 109039 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMUL),
     /* 109043 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 109047 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 109051 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 109056 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 109061 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 109063 */     // (fsub:{ *:[v4f16] } DPR:{ *:[v4f16] }:$src1, (fmul:{ *:[v4f16] } DPR:{ *:[v4f16] }:$Vn, DPR:{ *:[v4f16] }:$Vm))  =>  (VFMShd:{ *:[v4f16] } DPR:{ *:[v4f16] }:$src1, DPR:{ *:[v4f16] }:$Vn, DPR:{ *:[v4f16] }:$Vm)
     /* 109063 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VFMShd),
     /* 109066 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 109068 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 109070 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /* 109074 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /* 109078 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 109081 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 109087 */     GIR_RootConstrainSelectedInstOperands,
     /* 109088 */     // GIR_Coverage, 946,
     /* 109088 */     GIR_EraseRootFromParent_Done,
     /* 109089 */   // Label 2056: @109089
     /* 109089 */   GIM_Try, /*On fail goto*//*Label 2057*/ GIMT_Encode4(109121), // Rule ID 967 //
     /* 109094 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 109097 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 109101 */     // (fsub:{ *:[v4f16] } DPR:{ *:[v4f16] }:$Vn, DPR:{ *:[v4f16] }:$Vm)  =>  (VSUBhd:{ *:[v4f16] } DPR:{ *:[v4f16] }:$Vn, DPR:{ *:[v4f16] }:$Vm)
     /* 109101 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSUBhd),
     /* 109104 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 109106 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 109108 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 109110 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 109113 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 109119 */     GIR_RootConstrainSelectedInstOperands,
     /* 109120 */     // GIR_Coverage, 967,
     /* 109120 */     GIR_EraseRootFromParent_Done,
     /* 109121 */   // Label 2057: @109121
     /* 109121 */   GIM_Reject,
     /* 109122 */ // Label 2054: @109122
     /* 109122 */ GIM_Reject,
     /* 109123 */ // Label 2043: @109123
     /* 109123 */ GIM_Try, /*On fail goto*//*Label 2058*/ GIMT_Encode4(109236),
     /* 109128 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 109131 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 109134 */   GIM_Try, /*On fail goto*//*Label 2059*/ GIMT_Encode4(109174), // Rule ID 966 //
     /* 109139 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 109142 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 109146 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 109150 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 109154 */     // (fsub:{ *:[v4f32] } QPR:{ *:[v4f32] }:$Vn, QPR:{ *:[v4f32] }:$Vm)  =>  (VSUBfq:{ *:[v4f32] } QPR:{ *:[v4f32] }:$Vn, QPR:{ *:[v4f32] }:$Vm)
     /* 109154 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSUBfq),
     /* 109157 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 109159 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 109161 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 109163 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 109166 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 109172 */     GIR_RootConstrainSelectedInstOperands,
     /* 109173 */     // GIR_Coverage, 966,
     /* 109173 */     GIR_EraseRootFromParent_Done,
     /* 109174 */   // Label 2059: @109174
     /* 109174 */   GIM_Try, /*On fail goto*//*Label 2060*/ GIMT_Encode4(109235), // Rule ID 4021 //
     /* 109179 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /* 109182 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 109186 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 109190 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 109194 */     // (fsub:{ *:[v4f32] } MQPR:{ *:[v4f32] }:$Qm, MQPR:{ *:[v4f32] }:$Qn)  =>  (MVE_VSUBf32:{ *:[v4f32] } MQPR:{ *:[v4f32] }:$Qm, MQPR:{ *:[v4f32] }:$Qn)
     /* 109194 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 109197 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 109201 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 109206 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSUBf32),
     /* 109209 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 109211 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /* 109213 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /* 109215 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 109218 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 109224 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 109230 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 109233 */     GIR_RootConstrainSelectedInstOperands,
     /* 109234 */     // GIR_Coverage, 4021,
     /* 109234 */     GIR_EraseRootFromParent_Done,
     /* 109235 */   // Label 2060: @109235
     /* 109235 */   GIM_Reject,
     /* 109236 */ // Label 2058: @109236
     /* 109236 */ GIM_Reject,
     /* 109237 */ // Label 2044: @109237
     /* 109237 */ GIM_Try, /*On fail goto*//*Label 2061*/ GIMT_Encode4(109490),
     /* 109242 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 109245 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 109248 */   GIM_Try, /*On fail goto*//*Label 2062*/ GIMT_Encode4(109318), // Rule ID 921 //
     /* 109253 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON_UseFPVMLx),
     /* 109256 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 109260 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 109264 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 109268 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMUL),
     /* 109272 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 109276 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 109280 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 109285 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 109290 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 109292 */     // (fsub:{ *:[v8f16] } QPR:{ *:[v8f16] }:$src1, (fmul:{ *:[v8f16] } QPR:{ *:[v8f16] }:$Vn, QPR:{ *:[v8f16] }:$Vm))  =>  (VMLShq:{ *:[v8f16] } QPR:{ *:[v8f16] }:$src1, QPR:{ *:[v8f16] }:$Vn, QPR:{ *:[v8f16] }:$Vm)
     /* 109292 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMLShq),
     /* 109295 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 109297 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 109299 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /* 109303 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /* 109307 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 109310 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 109316 */     GIR_RootConstrainSelectedInstOperands,
     /* 109317 */     // GIR_Coverage, 921,
     /* 109317 */     GIR_EraseRootFromParent_Done,
     /* 109318 */   // Label 2062: @109318
     /* 109318 */   GIM_Try, /*On fail goto*//*Label 2063*/ GIMT_Encode4(109388), // Rule ID 947 //
     /* 109323 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON_UseFusedMAC),
     /* 109326 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 109330 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 109334 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 109338 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMUL),
     /* 109342 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 109346 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 109350 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 109355 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 109360 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 109362 */     // (fsub:{ *:[v8f16] } QPR:{ *:[v8f16] }:$src1, (fmul:{ *:[v8f16] } QPR:{ *:[v8f16] }:$Vn, QPR:{ *:[v8f16] }:$Vm))  =>  (VFMShq:{ *:[v8f16] } QPR:{ *:[v8f16] }:$src1, QPR:{ *:[v8f16] }:$Vn, QPR:{ *:[v8f16] }:$Vm)
     /* 109362 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VFMShq),
     /* 109365 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 109367 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 109369 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /* 109373 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /* 109377 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 109380 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 109386 */     GIR_RootConstrainSelectedInstOperands,
     /* 109387 */     // GIR_Coverage, 947,
     /* 109387 */     GIR_EraseRootFromParent_Done,
     /* 109388 */   // Label 2063: @109388
     /* 109388 */   GIM_Try, /*On fail goto*//*Label 2064*/ GIMT_Encode4(109428), // Rule ID 968 //
     /* 109393 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 109396 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 109400 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 109404 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 109408 */     // (fsub:{ *:[v8f16] } QPR:{ *:[v8f16] }:$Vn, QPR:{ *:[v8f16] }:$Vm)  =>  (VSUBhq:{ *:[v8f16] } QPR:{ *:[v8f16] }:$Vn, QPR:{ *:[v8f16] }:$Vm)
     /* 109408 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSUBhq),
     /* 109411 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 109413 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 109415 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 109417 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 109420 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 109426 */     GIR_RootConstrainSelectedInstOperands,
     /* 109427 */     // GIR_Coverage, 968,
     /* 109427 */     GIR_EraseRootFromParent_Done,
     /* 109428 */   // Label 2064: @109428
     /* 109428 */   GIM_Try, /*On fail goto*//*Label 2065*/ GIMT_Encode4(109489), // Rule ID 4025 //
     /* 109433 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /* 109436 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 109440 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 109444 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 109448 */     // (fsub:{ *:[v8f16] } MQPR:{ *:[v8f16] }:$Qm, MQPR:{ *:[v8f16] }:$Qn)  =>  (MVE_VSUBf16:{ *:[v8f16] } MQPR:{ *:[v8f16] }:$Qm, MQPR:{ *:[v8f16] }:$Qn)
     /* 109448 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 109451 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 109455 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 109460 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSUBf16),
     /* 109463 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 109465 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /* 109467 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /* 109469 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 109472 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 109478 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 109484 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 109487 */     GIR_RootConstrainSelectedInstOperands,
     /* 109488 */     // GIR_Coverage, 4025,
     /* 109488 */     GIR_EraseRootFromParent_Done,
     /* 109489 */   // Label 2065: @109489
     /* 109489 */   GIM_Reject,
     /* 109490 */ // Label 2061: @109490
     /* 109490 */ GIM_Reject,
     /* 109491 */ // Label 2045: @109491
     /* 109491 */ GIM_Reject,
     /* 109492 */ // Label 36: @109492
     /* 109492 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(13), /*)*//*default:*//*Label 2073*/ GIMT_Encode4(110472),
     /* 109503 */ /*GILLT_s16*//*Label 2066*/ GIMT_Encode4(109555),
     /* 109507 */ /*GILLT_s32*//*Label 2067*/ GIMT_Encode4(109602),
     /* 109511 */ /*GILLT_s64*//*Label 2068*/ GIMT_Encode4(109991), GIMT_Encode4(0),
     /* 109519 */ /*GILLT_v2s32*//*Label 2069*/ GIMT_Encode4(110150), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 109531 */ /*GILLT_v4s16*//*Label 2070*/ GIMT_Encode4(110197),
     /* 109535 */ /*GILLT_v4s32*//*Label 2071*/ GIMT_Encode4(110244), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 109551 */ /*GILLT_v8s16*//*Label 2072*/ GIMT_Encode4(110358),
     /* 109555 */ // Label 2066: @109555
     /* 109555 */ GIM_Try, /*On fail goto*//*Label 2074*/ GIMT_Encode4(109601), // Rule ID 623 //
     /* 109560 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 109563 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 109566 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 109569 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 109573 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 109577 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 109581 */   // (fmul:{ *:[f16] } HPR:{ *:[f16] }:$Sn, HPR:{ *:[f16] }:$Sm)  =>  (VMULH:{ *:[f16] } HPR:{ *:[f16] }:$Sn, HPR:{ *:[f16] }:$Sm)
     /* 109581 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMULH),
     /* 109584 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /* 109586 */   GIR_RootToRootCopy, /*OpIdx*/1, // Sn
     /* 109588 */   GIR_RootToRootCopy, /*OpIdx*/2, // Sm
     /* 109590 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 109593 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 109599 */   GIR_RootConstrainSelectedInstOperands,
     /* 109600 */   // GIR_Coverage, 623,
     /* 109600 */   GIR_EraseRootFromParent_Done,
     /* 109601 */ // Label 2074: @109601
     /* 109601 */ GIM_Reject,
     /* 109602 */ // Label 2067: @109602
     /* 109602 */ GIM_Try, /*On fail goto*//*Label 2075*/ GIMT_Encode4(109990),
     /* 109607 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 109610 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 109613 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 109617 */   GIM_Try, /*On fail goto*//*Label 2076*/ GIMT_Encode4(109670), // Rule ID 2299 //
     /* 109622 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoHonorSignDependentRounding),
     /* 109625 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 109629 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 109633 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 109637 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 109642 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 109646 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 109648 */     // (fmul:{ *:[f32] } (fneg:{ *:[f32] } SPR:{ *:[f32] }:$a), SPR:{ *:[f32] }:$b)  =>  (VNMULS:{ *:[f32] } SPR:{ *:[f32] }:$a, SPR:{ *:[f32] }:$b)
     /* 109648 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VNMULS),
     /* 109651 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /* 109653 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // a
     /* 109657 */     GIR_RootToRootCopy, /*OpIdx*/2, // b
     /* 109659 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 109662 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 109668 */     GIR_RootConstrainSelectedInstOperands,
     /* 109669 */     // GIR_Coverage, 2299,
     /* 109669 */     GIR_EraseRootFromParent_Done,
     /* 109670 */   // Label 2076: @109670
     /* 109670 */   GIM_Try, /*On fail goto*//*Label 2077*/ GIMT_Encode4(109723), // Rule ID 5708 //
     /* 109675 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoHonorSignDependentRounding),
     /* 109678 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 109682 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 109686 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 109690 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 109694 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 109699 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 109701 */     // (fmul:{ *:[f32] } SPR:{ *:[f32] }:$b, (fneg:{ *:[f32] } SPR:{ *:[f32] }:$a))  =>  (VNMULS:{ *:[f32] } SPR:{ *:[f32] }:$a, SPR:{ *:[f32] }:$b)
     /* 109701 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VNMULS),
     /* 109704 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /* 109706 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // a
     /* 109710 */     GIR_RootToRootCopy, /*OpIdx*/1, // b
     /* 109712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 109715 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 109721 */     GIR_RootConstrainSelectedInstOperands,
     /* 109722 */     // GIR_Coverage, 5708,
     /* 109722 */     GIR_EraseRootFromParent_Done,
     /* 109723 */   // Label 2077: @109723
     /* 109723 */   GIM_Try, /*On fail goto*//*Label 2078*/ GIMT_Encode4(109759), // Rule ID 622 //
     /* 109728 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_DontUseNEONForFP_HasVFP2),
     /* 109731 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 109735 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 109739 */     // (fmul:{ *:[f32] } SPR:{ *:[f32] }:$Sn, SPR:{ *:[f32] }:$Sm)  =>  (VMULS:{ *:[f32] } SPR:{ *:[f32] }:$Sn, SPR:{ *:[f32] }:$Sm)
     /* 109739 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMULS),
     /* 109742 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /* 109744 */     GIR_RootToRootCopy, /*OpIdx*/1, // Sn
     /* 109746 */     GIR_RootToRootCopy, /*OpIdx*/2, // Sm
     /* 109748 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 109751 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 109757 */     GIR_RootConstrainSelectedInstOperands,
     /* 109758 */     // GIR_Coverage, 622,
     /* 109758 */     GIR_EraseRootFromParent_Done,
     /* 109759 */   // Label 2078: @109759
     /* 109759 */   GIM_Try, /*On fail goto*//*Label 2079*/ GIMT_Encode4(109989), // Rule ID 2696 //
     /* 109764 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_UseNEONForFP),
     /* 109767 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 109771 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 109775 */     // (fmul:{ *:[f32] } SPR:{ *:[f32] }:$a, SPR:{ *:[f32] }:$b)  =>  (EXTRACT_SUBREG:{ *:[f32] } (COPY_TO_REGCLASS:{ *:[v2f32] } (VMULfd:{ *:[f64] } (INSERT_SUBREG:{ *:[v2f32] } (COPY_TO_REGCLASS:{ *:[v2f32] } (IMPLICIT_DEF:{ *:[v2f32] }), DPR_VFP2:{ *:[i32] }), SPR:{ *:[f32] }:$a, ssub_0:{ *:[i32] }), (INSERT_SUBREG:{ *:[v2f32] } (COPY_TO_REGCLASS:{ *:[v2f32] } (IMPLICIT_DEF:{ *:[v2f32] }), DPR_VFP2:{ *:[i32] }), SPR:{ *:[f32] }:$b, ssub_0:{ *:[i32] })), DPR_VFP2:{ *:[i32] }), ssub_0:{ *:[i32] })
     /* 109775 */     GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_v2s32,
     /* 109778 */     GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 109782 */     GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 109787 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/8,
     /* 109789 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v2s32,
     /* 109792 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 109796 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 109801 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
     /* 109804 */     GIR_ConstrainOperandRC, /*InsnID*/7, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 109809 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v2s32,
     /* 109812 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 109816 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 109821 */     GIR_AddSimpleTempRegister, /*InsnID*/6, /*TempRegID*/6,
     /* 109824 */     GIR_Copy, /*NewInsnID*/6, /*OldInsnID*/0, /*OpIdx*/2, // b
     /* 109828 */     GIR_AddImm8, /*InsnID*/6, /*Imm*/17,
     /* 109831 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 109836 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 109841 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/2, GIMT_Encode2(ARM::SPRRegClassID),
     /* 109846 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v2s32,
     /* 109849 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 109853 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 109858 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 109860 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v2s32,
     /* 109863 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 109867 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 109872 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 109875 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 109880 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s32,
     /* 109883 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 109887 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 109892 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 109895 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // a
     /* 109899 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/17,
     /* 109902 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 109907 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 109912 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(ARM::SPRRegClassID),
     /* 109917 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 109920 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(ARM::VMULfd),
     /* 109924 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 109929 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 109932 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/5,
     /* 109935 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/14,
     /* 109938 */     GIR_AddRegister, /*InsnID*/2, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 109944 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 109946 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s32,
     /* 109949 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 109953 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 109958 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 109961 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 109966 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 109969 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 109971 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(ARM::ssub_0),
     /* 109978 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::SPRRegClassID),
     /* 109983 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 109988 */     // GIR_Coverage, 2696,
     /* 109988 */     GIR_EraseRootFromParent_Done,
     /* 109989 */   // Label 2079: @109989
     /* 109989 */   GIM_Reject,
     /* 109990 */ // Label 2075: @109990
     /* 109990 */ GIM_Reject,
     /* 109991 */ // Label 2068: @109991
     /* 109991 */ GIM_Try, /*On fail goto*//*Label 2080*/ GIMT_Encode4(110149),
     /* 109996 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 109999 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 110002 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 110006 */   GIM_Try, /*On fail goto*//*Label 2081*/ GIMT_Encode4(110059), // Rule ID 2298 //
     /* 110011 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDPVFP_NoHonorSignDependentRounding),
     /* 110014 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 110018 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 110022 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 110026 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 110031 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 110035 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 110037 */     // (fmul:{ *:[f64] } (fneg:{ *:[f64] } DPR:{ *:[f64] }:$a), DPR:{ *:[f64] }:$b)  =>  (VNMULD:{ *:[f64] } DPR:{ *:[f64] }:$a, DPR:{ *:[f64] }:$b)
     /* 110037 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VNMULD),
     /* 110040 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Dd]
     /* 110042 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // a
     /* 110046 */     GIR_RootToRootCopy, /*OpIdx*/2, // b
     /* 110048 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 110051 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 110057 */     GIR_RootConstrainSelectedInstOperands,
     /* 110058 */     // GIR_Coverage, 2298,
     /* 110058 */     GIR_EraseRootFromParent_Done,
     /* 110059 */   // Label 2081: @110059
     /* 110059 */   GIM_Try, /*On fail goto*//*Label 2082*/ GIMT_Encode4(110112), // Rule ID 5707 //
     /* 110064 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDPVFP_NoHonorSignDependentRounding),
     /* 110067 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 110071 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 110075 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 110079 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 110083 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 110088 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 110090 */     // (fmul:{ *:[f64] } DPR:{ *:[f64] }:$b, (fneg:{ *:[f64] } DPR:{ *:[f64] }:$a))  =>  (VNMULD:{ *:[f64] } DPR:{ *:[f64] }:$a, DPR:{ *:[f64] }:$b)
     /* 110090 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VNMULD),
     /* 110093 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Dd]
     /* 110095 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // a
     /* 110099 */     GIR_RootToRootCopy, /*OpIdx*/1, // b
     /* 110101 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 110104 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 110110 */     GIR_RootConstrainSelectedInstOperands,
     /* 110111 */     // GIR_Coverage, 5707,
     /* 110111 */     GIR_EraseRootFromParent_Done,
     /* 110112 */   // Label 2082: @110112
     /* 110112 */   GIM_Try, /*On fail goto*//*Label 2083*/ GIMT_Encode4(110148), // Rule ID 621 //
     /* 110117 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDPVFP_HasVFP2),
     /* 110120 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 110124 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 110128 */     // (fmul:{ *:[f64] } DPR:{ *:[f64] }:$Dn, DPR:{ *:[f64] }:$Dm)  =>  (VMULD:{ *:[f64] } DPR:{ *:[f64] }:$Dn, DPR:{ *:[f64] }:$Dm)
     /* 110128 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMULD),
     /* 110131 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Dd]
     /* 110133 */     GIR_RootToRootCopy, /*OpIdx*/1, // Dn
     /* 110135 */     GIR_RootToRootCopy, /*OpIdx*/2, // Dm
     /* 110137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 110140 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 110146 */     GIR_RootConstrainSelectedInstOperands,
     /* 110147 */     // GIR_Coverage, 621,
     /* 110147 */     GIR_EraseRootFromParent_Done,
     /* 110148 */   // Label 2083: @110148
     /* 110148 */   GIM_Reject,
     /* 110149 */ // Label 2080: @110149
     /* 110149 */ GIM_Reject,
     /* 110150 */ // Label 2069: @110150
     /* 110150 */ GIM_Try, /*On fail goto*//*Label 2084*/ GIMT_Encode4(110196), // Rule ID 840 //
     /* 110155 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 110158 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 110161 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 110164 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 110168 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 110172 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 110176 */   // (fmul:{ *:[v2f32] } DPR:{ *:[v2f32] }:$Vn, DPR:{ *:[v2f32] }:$Vm)  =>  (VMULfd:{ *:[v2f32] } DPR:{ *:[v2f32] }:$Vn, DPR:{ *:[v2f32] }:$Vm)
     /* 110176 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMULfd),
     /* 110179 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 110181 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 110183 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 110185 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 110188 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 110194 */   GIR_RootConstrainSelectedInstOperands,
     /* 110195 */   // GIR_Coverage, 840,
     /* 110195 */   GIR_EraseRootFromParent_Done,
     /* 110196 */ // Label 2084: @110196
     /* 110196 */ GIM_Reject,
     /* 110197 */ // Label 2070: @110197
     /* 110197 */ GIM_Try, /*On fail goto*//*Label 2085*/ GIMT_Encode4(110243), // Rule ID 842 //
     /* 110202 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 110205 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 110208 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 110211 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 110215 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 110219 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 110223 */   // (fmul:{ *:[v4f16] } DPR:{ *:[v4f16] }:$Vn, DPR:{ *:[v4f16] }:$Vm)  =>  (VMULhd:{ *:[v4f16] } DPR:{ *:[v4f16] }:$Vn, DPR:{ *:[v4f16] }:$Vm)
     /* 110223 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMULhd),
     /* 110226 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 110228 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 110230 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 110232 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 110235 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 110241 */   GIR_RootConstrainSelectedInstOperands,
     /* 110242 */   // GIR_Coverage, 842,
     /* 110242 */   GIR_EraseRootFromParent_Done,
     /* 110243 */ // Label 2085: @110243
     /* 110243 */ GIM_Reject,
     /* 110244 */ // Label 2071: @110244
     /* 110244 */ GIM_Try, /*On fail goto*//*Label 2086*/ GIMT_Encode4(110357),
     /* 110249 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 110252 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 110255 */   GIM_Try, /*On fail goto*//*Label 2087*/ GIMT_Encode4(110295), // Rule ID 841 //
     /* 110260 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 110263 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 110267 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 110271 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 110275 */     // (fmul:{ *:[v4f32] } QPR:{ *:[v4f32] }:$Vn, QPR:{ *:[v4f32] }:$Vm)  =>  (VMULfq:{ *:[v4f32] } QPR:{ *:[v4f32] }:$Vn, QPR:{ *:[v4f32] }:$Vm)
     /* 110275 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMULfq),
     /* 110278 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 110280 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 110282 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 110284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 110287 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 110293 */     GIR_RootConstrainSelectedInstOperands,
     /* 110294 */     // GIR_Coverage, 841,
     /* 110294 */     GIR_EraseRootFromParent_Done,
     /* 110295 */   // Label 2087: @110295
     /* 110295 */   GIM_Try, /*On fail goto*//*Label 2088*/ GIMT_Encode4(110356), // Rule ID 3985 //
     /* 110300 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /* 110303 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 110307 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 110311 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 110315 */     // (fmul:{ *:[v4f32] } MQPR:{ *:[v4f32] }:$Qm, MQPR:{ *:[v4f32] }:$Qn)  =>  (MVE_VMULf32:{ *:[v4f32] } MQPR:{ *:[v4f32] }:$Qm, MQPR:{ *:[v4f32] }:$Qn)
     /* 110315 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 110318 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 110322 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 110327 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMULf32),
     /* 110330 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 110332 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /* 110334 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /* 110336 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 110339 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 110345 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 110351 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 110354 */     GIR_RootConstrainSelectedInstOperands,
     /* 110355 */     // GIR_Coverage, 3985,
     /* 110355 */     GIR_EraseRootFromParent_Done,
     /* 110356 */   // Label 2088: @110356
     /* 110356 */   GIM_Reject,
     /* 110357 */ // Label 2086: @110357
     /* 110357 */ GIM_Reject,
     /* 110358 */ // Label 2072: @110358
     /* 110358 */ GIM_Try, /*On fail goto*//*Label 2089*/ GIMT_Encode4(110471),
     /* 110363 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 110366 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 110369 */   GIM_Try, /*On fail goto*//*Label 2090*/ GIMT_Encode4(110409), // Rule ID 843 //
     /* 110374 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 110377 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 110381 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 110385 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 110389 */     // (fmul:{ *:[v8f16] } QPR:{ *:[v8f16] }:$Vn, QPR:{ *:[v8f16] }:$Vm)  =>  (VMULhq:{ *:[v8f16] } QPR:{ *:[v8f16] }:$Vn, QPR:{ *:[v8f16] }:$Vm)
     /* 110389 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMULhq),
     /* 110392 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 110394 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 110396 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 110398 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 110401 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 110407 */     GIR_RootConstrainSelectedInstOperands,
     /* 110408 */     // GIR_Coverage, 843,
     /* 110408 */     GIR_EraseRootFromParent_Done,
     /* 110409 */   // Label 2090: @110409
     /* 110409 */   GIM_Try, /*On fail goto*//*Label 2091*/ GIMT_Encode4(110470), // Rule ID 3989 //
     /* 110414 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /* 110417 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 110421 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 110425 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 110429 */     // (fmul:{ *:[v8f16] } MQPR:{ *:[v8f16] }:$Qm, MQPR:{ *:[v8f16] }:$Qn)  =>  (MVE_VMULf16:{ *:[v8f16] } MQPR:{ *:[v8f16] }:$Qm, MQPR:{ *:[v8f16] }:$Qn)
     /* 110429 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 110432 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 110436 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 110441 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMULf16),
     /* 110444 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 110446 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /* 110448 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /* 110450 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 110453 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 110459 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 110465 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 110468 */     GIR_RootConstrainSelectedInstOperands,
     /* 110469 */     // GIR_Coverage, 3989,
     /* 110469 */     GIR_EraseRootFromParent_Done,
     /* 110470 */   // Label 2091: @110470
     /* 110470 */   GIM_Reject,
     /* 110471 */ // Label 2089: @110471
     /* 110471 */ GIM_Reject,
     /* 110472 */ // Label 2073: @110472
     /* 110472 */ GIM_Reject,
     /* 110473 */ // Label 37: @110473
     /* 110473 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(13), /*)*//*default:*//*Label 2099*/ GIMT_Encode4(112563),
     /* 110484 */ /*GILLT_s16*//*Label 2092*/ GIMT_Encode4(110536),
     /* 110488 */ /*GILLT_s32*//*Label 2093*/ GIMT_Encode4(110923),
     /* 110492 */ /*GILLT_s64*//*Label 2094*/ GIMT_Encode4(111310), GIMT_Encode4(0),
     /* 110500 */ /*GILLT_v2s32*//*Label 2095*/ GIMT_Encode4(111697), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 110512 */ /*GILLT_v4s16*//*Label 2096*/ GIMT_Encode4(111877),
     /* 110516 */ /*GILLT_v4s32*//*Label 2097*/ GIMT_Encode4(111933), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 110532 */ /*GILLT_v8s16*//*Label 2098*/ GIMT_Encode4(112311),
     /* 110536 */ // Label 2092: @110536
     /* 110536 */ GIM_Try, /*On fail goto*//*Label 2100*/ GIMT_Encode4(110922),
     /* 110541 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 110544 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 110547 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 110550 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 110554 */   GIM_Try, /*On fail goto*//*Label 2101*/ GIMT_Encode4(110628), // Rule ID 2403 //
     /* 110559 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 110562 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 110566 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 110570 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 110574 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 110579 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 110583 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 110587 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 110591 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 110595 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 110600 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 110602 */     // (fma:{ *:[f16] } (fneg:{ *:[f16] } HPR:{ *:[f16] }:$Sn), HPR:{ *:[f16] }:$Sm, (fneg:{ *:[f16] } HPR:{ *:[f16] }:$Sdin))  =>  (VFNMAH:{ *:[f16] } HPR:{ *:[f16] }:$Sdin, HPR:{ *:[f16] }:$Sn, HPR:{ *:[f16] }:$Sm)
     /* 110602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VFNMAH),
     /* 110605 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /* 110607 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Sdin
     /* 110611 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Sn
     /* 110615 */     GIR_RootToRootCopy, /*OpIdx*/2, // Sm
     /* 110617 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 110620 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 110626 */     GIR_RootConstrainSelectedInstOperands,
     /* 110627 */     // GIR_Coverage, 2403,
     /* 110627 */     GIR_EraseRootFromParent_Done,
     /* 110628 */   // Label 2101: @110628
     /* 110628 */   GIM_Try, /*On fail goto*//*Label 2102*/ GIMT_Encode4(110702), // Rule ID 5716 //
     /* 110633 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 110636 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 110640 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 110644 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 110648 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 110652 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 110657 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 110661 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 110665 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 110669 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 110674 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 110676 */     // (fma:{ *:[f16] } HPR:{ *:[f16] }:$Sm, (fneg:{ *:[f16] } HPR:{ *:[f16] }:$Sn), (fneg:{ *:[f16] } HPR:{ *:[f16] }:$Sdin))  =>  (VFNMAH:{ *:[f16] } HPR:{ *:[f16] }:$Sdin, HPR:{ *:[f16] }:$Sn, HPR:{ *:[f16] }:$Sm)
     /* 110676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VFNMAH),
     /* 110679 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /* 110681 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Sdin
     /* 110685 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Sn
     /* 110689 */     GIR_RootToRootCopy, /*OpIdx*/1, // Sm
     /* 110691 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 110694 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 110700 */     GIR_RootConstrainSelectedInstOperands,
     /* 110701 */     // GIR_Coverage, 5716,
     /* 110701 */     GIR_EraseRootFromParent_Done,
     /* 110702 */   // Label 2102: @110702
     /* 110702 */   GIM_Try, /*On fail goto*//*Label 2103*/ GIMT_Encode4(110761), // Rule ID 2395 //
     /* 110707 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 110710 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 110714 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 110718 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 110722 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 110727 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 110731 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 110735 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 110737 */     // (fma:{ *:[f16] } (fneg:{ *:[f16] } HPR:{ *:[f16] }:$Sn), HPR:{ *:[f16] }:$Sm, HPR:{ *:[f16] }:$Sdin)  =>  (VFMSH:{ *:[f16] } HPR:{ *:[f16] }:$Sdin, HPR:{ *:[f16] }:$Sn, HPR:{ *:[f16] }:$Sm)
     /* 110737 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VFMSH),
     /* 110740 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /* 110742 */     GIR_RootToRootCopy, /*OpIdx*/3, // Sdin
     /* 110744 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Sn
     /* 110748 */     GIR_RootToRootCopy, /*OpIdx*/2, // Sm
     /* 110750 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 110753 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 110759 */     GIR_RootConstrainSelectedInstOperands,
     /* 110760 */     // GIR_Coverage, 2395,
     /* 110760 */     GIR_EraseRootFromParent_Done,
     /* 110761 */   // Label 2103: @110761
     /* 110761 */   GIM_Try, /*On fail goto*//*Label 2104*/ GIMT_Encode4(110820), // Rule ID 5713 //
     /* 110766 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 110769 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 110773 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 110777 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 110781 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 110785 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 110790 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 110794 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 110796 */     // (fma:{ *:[f16] } HPR:{ *:[f16] }:$Sm, (fneg:{ *:[f16] } HPR:{ *:[f16] }:$Sn), HPR:{ *:[f16] }:$Sdin)  =>  (VFMSH:{ *:[f16] } HPR:{ *:[f16] }:$Sdin, HPR:{ *:[f16] }:$Sn, HPR:{ *:[f16] }:$Sm)
     /* 110796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VFMSH),
     /* 110799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /* 110801 */     GIR_RootToRootCopy, /*OpIdx*/3, // Sdin
     /* 110803 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Sn
     /* 110807 */     GIR_RootToRootCopy, /*OpIdx*/1, // Sm
     /* 110809 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 110812 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 110818 */     GIR_RootConstrainSelectedInstOperands,
     /* 110819 */     // GIR_Coverage, 5713,
     /* 110819 */     GIR_EraseRootFromParent_Done,
     /* 110820 */   // Label 2104: @110820
     /* 110820 */   GIM_Try, /*On fail goto*//*Label 2105*/ GIMT_Encode4(110879), // Rule ID 2408 //
     /* 110825 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 110828 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 110832 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 110836 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 110840 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 110844 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 110848 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 110853 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 110855 */     // (fma:{ *:[f16] } HPR:{ *:[f16] }:$Sn, HPR:{ *:[f16] }:$Sm, (fneg:{ *:[f16] } HPR:{ *:[f16] }:$Sdin))  =>  (VFNMSH:{ *:[f16] } HPR:{ *:[f16] }:$Sdin, HPR:{ *:[f16] }:$Sn, HPR:{ *:[f16] }:$Sm)
     /* 110855 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VFNMSH),
     /* 110858 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /* 110860 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Sdin
     /* 110864 */     GIR_RootToRootCopy, /*OpIdx*/1, // Sn
     /* 110866 */     GIR_RootToRootCopy, /*OpIdx*/2, // Sm
     /* 110868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 110871 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 110877 */     GIR_RootConstrainSelectedInstOperands,
     /* 110878 */     // GIR_Coverage, 2408,
     /* 110878 */     GIR_EraseRootFromParent_Done,
     /* 110879 */   // Label 2105: @110879
     /* 110879 */   GIM_Try, /*On fail goto*//*Label 2106*/ GIMT_Encode4(110921), // Rule ID 2389 //
     /* 110884 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 110887 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 110891 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 110895 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 110899 */     // (fma:{ *:[f16] } HPR:{ *:[f16] }:$Sn, HPR:{ *:[f16] }:$Sm, HPR:{ *:[f16] }:$Sdin)  =>  (VFMAH:{ *:[f16] } HPR:{ *:[f16] }:$Sdin, HPR:{ *:[f16] }:$Sn, HPR:{ *:[f16] }:$Sm)
     /* 110899 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VFMAH),
     /* 110902 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /* 110904 */     GIR_RootToRootCopy, /*OpIdx*/3, // Sdin
     /* 110906 */     GIR_RootToRootCopy, /*OpIdx*/1, // Sn
     /* 110908 */     GIR_RootToRootCopy, /*OpIdx*/2, // Sm
     /* 110910 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 110913 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 110919 */     GIR_RootConstrainSelectedInstOperands,
     /* 110920 */     // GIR_Coverage, 2389,
     /* 110920 */     GIR_EraseRootFromParent_Done,
     /* 110921 */   // Label 2106: @110921
     /* 110921 */   GIM_Reject,
     /* 110922 */ // Label 2100: @110922
     /* 110922 */ GIM_Reject,
     /* 110923 */ // Label 2093: @110923
     /* 110923 */ GIM_Try, /*On fail goto*//*Label 2107*/ GIMT_Encode4(111309),
     /* 110928 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 110931 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 110934 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 110937 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 110941 */   GIM_Try, /*On fail goto*//*Label 2108*/ GIMT_Encode4(111015), // Rule ID 2402 //
     /* 110946 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVFP4),
     /* 110949 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 110953 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 110957 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 110961 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 110966 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 110970 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 110974 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 110978 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 110982 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 110987 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 110989 */     // (fma:{ *:[f32] } (fneg:{ *:[f32] } SPR:{ *:[f32] }:$Sn), SPR:{ *:[f32] }:$Sm, (fneg:{ *:[f32] } SPR:{ *:[f32] }:$Sdin))  =>  (VFNMAS:{ *:[f32] } SPR:{ *:[f32] }:$Sdin, SPR:{ *:[f32] }:$Sn, SPR:{ *:[f32] }:$Sm)
     /* 110989 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VFNMAS),
     /* 110992 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /* 110994 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Sdin
     /* 110998 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Sn
     /* 111002 */     GIR_RootToRootCopy, /*OpIdx*/2, // Sm
     /* 111004 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 111007 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 111013 */     GIR_RootConstrainSelectedInstOperands,
     /* 111014 */     // GIR_Coverage, 2402,
     /* 111014 */     GIR_EraseRootFromParent_Done,
     /* 111015 */   // Label 2108: @111015
     /* 111015 */   GIM_Try, /*On fail goto*//*Label 2109*/ GIMT_Encode4(111089), // Rule ID 5715 //
     /* 111020 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVFP4),
     /* 111023 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 111027 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 111031 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 111035 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 111039 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 111044 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 111048 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 111052 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 111056 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 111061 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 111063 */     // (fma:{ *:[f32] } SPR:{ *:[f32] }:$Sm, (fneg:{ *:[f32] } SPR:{ *:[f32] }:$Sn), (fneg:{ *:[f32] } SPR:{ *:[f32] }:$Sdin))  =>  (VFNMAS:{ *:[f32] } SPR:{ *:[f32] }:$Sdin, SPR:{ *:[f32] }:$Sn, SPR:{ *:[f32] }:$Sm)
     /* 111063 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VFNMAS),
     /* 111066 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /* 111068 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Sdin
     /* 111072 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Sn
     /* 111076 */     GIR_RootToRootCopy, /*OpIdx*/1, // Sm
     /* 111078 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 111081 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 111087 */     GIR_RootConstrainSelectedInstOperands,
     /* 111088 */     // GIR_Coverage, 5715,
     /* 111088 */     GIR_EraseRootFromParent_Done,
     /* 111089 */   // Label 2109: @111089
     /* 111089 */   GIM_Try, /*On fail goto*//*Label 2110*/ GIMT_Encode4(111148), // Rule ID 2394 //
     /* 111094 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVFP4),
     /* 111097 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 111101 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 111105 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 111109 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 111114 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 111118 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 111122 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 111124 */     // (fma:{ *:[f32] } (fneg:{ *:[f32] } SPR:{ *:[f32] }:$Sn), SPR:{ *:[f32] }:$Sm, SPR:{ *:[f32] }:$Sdin)  =>  (VFMSS:{ *:[f32] } SPR:{ *:[f32] }:$Sdin, SPR:{ *:[f32] }:$Sn, SPR:{ *:[f32] }:$Sm)
     /* 111124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VFMSS),
     /* 111127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /* 111129 */     GIR_RootToRootCopy, /*OpIdx*/3, // Sdin
     /* 111131 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Sn
     /* 111135 */     GIR_RootToRootCopy, /*OpIdx*/2, // Sm
     /* 111137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 111140 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 111146 */     GIR_RootConstrainSelectedInstOperands,
     /* 111147 */     // GIR_Coverage, 2394,
     /* 111147 */     GIR_EraseRootFromParent_Done,
     /* 111148 */   // Label 2110: @111148
     /* 111148 */   GIM_Try, /*On fail goto*//*Label 2111*/ GIMT_Encode4(111207), // Rule ID 5712 //
     /* 111153 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVFP4),
     /* 111156 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 111160 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 111164 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 111168 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 111172 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 111177 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 111181 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 111183 */     // (fma:{ *:[f32] } SPR:{ *:[f32] }:$Sm, (fneg:{ *:[f32] } SPR:{ *:[f32] }:$Sn), SPR:{ *:[f32] }:$Sdin)  =>  (VFMSS:{ *:[f32] } SPR:{ *:[f32] }:$Sdin, SPR:{ *:[f32] }:$Sn, SPR:{ *:[f32] }:$Sm)
     /* 111183 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VFMSS),
     /* 111186 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /* 111188 */     GIR_RootToRootCopy, /*OpIdx*/3, // Sdin
     /* 111190 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Sn
     /* 111194 */     GIR_RootToRootCopy, /*OpIdx*/1, // Sm
     /* 111196 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 111199 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 111205 */     GIR_RootConstrainSelectedInstOperands,
     /* 111206 */     // GIR_Coverage, 5712,
     /* 111206 */     GIR_EraseRootFromParent_Done,
     /* 111207 */   // Label 2111: @111207
     /* 111207 */   GIM_Try, /*On fail goto*//*Label 2112*/ GIMT_Encode4(111266), // Rule ID 2407 //
     /* 111212 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVFP4),
     /* 111215 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 111219 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 111223 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 111227 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 111231 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 111235 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 111240 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 111242 */     // (fma:{ *:[f32] } SPR:{ *:[f32] }:$Sn, SPR:{ *:[f32] }:$Sm, (fneg:{ *:[f32] } SPR:{ *:[f32] }:$Sdin))  =>  (VFNMSS:{ *:[f32] } SPR:{ *:[f32] }:$Sdin, SPR:{ *:[f32] }:$Sn, SPR:{ *:[f32] }:$Sm)
     /* 111242 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VFNMSS),
     /* 111245 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /* 111247 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Sdin
     /* 111251 */     GIR_RootToRootCopy, /*OpIdx*/1, // Sn
     /* 111253 */     GIR_RootToRootCopy, /*OpIdx*/2, // Sm
     /* 111255 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 111258 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 111264 */     GIR_RootConstrainSelectedInstOperands,
     /* 111265 */     // GIR_Coverage, 2407,
     /* 111265 */     GIR_EraseRootFromParent_Done,
     /* 111266 */   // Label 2112: @111266
     /* 111266 */   GIM_Try, /*On fail goto*//*Label 2113*/ GIMT_Encode4(111308), // Rule ID 2388 //
     /* 111271 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVFP4),
     /* 111274 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 111278 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 111282 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 111286 */     // (fma:{ *:[f32] } SPR:{ *:[f32] }:$Sn, SPR:{ *:[f32] }:$Sm, SPR:{ *:[f32] }:$Sdin)  =>  (VFMAS:{ *:[f32] } SPR:{ *:[f32] }:$Sdin, SPR:{ *:[f32] }:$Sn, SPR:{ *:[f32] }:$Sm)
     /* 111286 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VFMAS),
     /* 111289 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /* 111291 */     GIR_RootToRootCopy, /*OpIdx*/3, // Sdin
     /* 111293 */     GIR_RootToRootCopy, /*OpIdx*/1, // Sn
     /* 111295 */     GIR_RootToRootCopy, /*OpIdx*/2, // Sm
     /* 111297 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 111300 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 111306 */     GIR_RootConstrainSelectedInstOperands,
     /* 111307 */     // GIR_Coverage, 2388,
     /* 111307 */     GIR_EraseRootFromParent_Done,
     /* 111308 */   // Label 2113: @111308
     /* 111308 */   GIM_Reject,
     /* 111309 */ // Label 2107: @111309
     /* 111309 */ GIM_Reject,
     /* 111310 */ // Label 2094: @111310
     /* 111310 */ GIM_Try, /*On fail goto*//*Label 2114*/ GIMT_Encode4(111696),
     /* 111315 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 111318 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 111321 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 111324 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 111328 */   GIM_Try, /*On fail goto*//*Label 2115*/ GIMT_Encode4(111402), // Rule ID 2401 //
     /* 111333 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDPVFP_HasVFP4),
     /* 111336 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 111340 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 111344 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 111348 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 111353 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 111357 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 111361 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 111365 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 111369 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 111374 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 111376 */     // (fma:{ *:[f64] } (fneg:{ *:[f64] } DPR:{ *:[f64] }:$Dn), DPR:{ *:[f64] }:$Dm, (fneg:{ *:[f64] } DPR:{ *:[f64] }:$Ddin))  =>  (VFNMAD:{ *:[f64] } DPR:{ *:[f64] }:$Ddin, DPR:{ *:[f64] }:$Dn, DPR:{ *:[f64] }:$Dm)
     /* 111376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VFNMAD),
     /* 111379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Dd]
     /* 111381 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Ddin
     /* 111385 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Dn
     /* 111389 */     GIR_RootToRootCopy, /*OpIdx*/2, // Dm
     /* 111391 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 111394 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 111400 */     GIR_RootConstrainSelectedInstOperands,
     /* 111401 */     // GIR_Coverage, 2401,
     /* 111401 */     GIR_EraseRootFromParent_Done,
     /* 111402 */   // Label 2115: @111402
     /* 111402 */   GIM_Try, /*On fail goto*//*Label 2116*/ GIMT_Encode4(111476), // Rule ID 5714 //
     /* 111407 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDPVFP_HasVFP4),
     /* 111410 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 111414 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 111418 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 111422 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 111426 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 111431 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 111435 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 111439 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 111443 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 111448 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 111450 */     // (fma:{ *:[f64] } DPR:{ *:[f64] }:$Dm, (fneg:{ *:[f64] } DPR:{ *:[f64] }:$Dn), (fneg:{ *:[f64] } DPR:{ *:[f64] }:$Ddin))  =>  (VFNMAD:{ *:[f64] } DPR:{ *:[f64] }:$Ddin, DPR:{ *:[f64] }:$Dn, DPR:{ *:[f64] }:$Dm)
     /* 111450 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VFNMAD),
     /* 111453 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Dd]
     /* 111455 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Ddin
     /* 111459 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Dn
     /* 111463 */     GIR_RootToRootCopy, /*OpIdx*/1, // Dm
     /* 111465 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 111468 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 111474 */     GIR_RootConstrainSelectedInstOperands,
     /* 111475 */     // GIR_Coverage, 5714,
     /* 111475 */     GIR_EraseRootFromParent_Done,
     /* 111476 */   // Label 2116: @111476
     /* 111476 */   GIM_Try, /*On fail goto*//*Label 2117*/ GIMT_Encode4(111535), // Rule ID 2393 //
     /* 111481 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDPVFP_HasVFP4),
     /* 111484 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 111488 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 111492 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 111496 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 111501 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 111505 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 111509 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 111511 */     // (fma:{ *:[f64] } (fneg:{ *:[f64] } DPR:{ *:[f64] }:$Dn), DPR:{ *:[f64] }:$Dm, DPR:{ *:[f64] }:$Ddin)  =>  (VFMSD:{ *:[f64] } DPR:{ *:[f64] }:$Ddin, DPR:{ *:[f64] }:$Dn, DPR:{ *:[f64] }:$Dm)
     /* 111511 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VFMSD),
     /* 111514 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Dd]
     /* 111516 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ddin
     /* 111518 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Dn
     /* 111522 */     GIR_RootToRootCopy, /*OpIdx*/2, // Dm
     /* 111524 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 111527 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 111533 */     GIR_RootConstrainSelectedInstOperands,
     /* 111534 */     // GIR_Coverage, 2393,
     /* 111534 */     GIR_EraseRootFromParent_Done,
     /* 111535 */   // Label 2117: @111535
     /* 111535 */   GIM_Try, /*On fail goto*//*Label 2118*/ GIMT_Encode4(111594), // Rule ID 5711 //
     /* 111540 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDPVFP_HasVFP4),
     /* 111543 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 111547 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 111551 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 111555 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 111559 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 111564 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 111568 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 111570 */     // (fma:{ *:[f64] } DPR:{ *:[f64] }:$Dm, (fneg:{ *:[f64] } DPR:{ *:[f64] }:$Dn), DPR:{ *:[f64] }:$Ddin)  =>  (VFMSD:{ *:[f64] } DPR:{ *:[f64] }:$Ddin, DPR:{ *:[f64] }:$Dn, DPR:{ *:[f64] }:$Dm)
     /* 111570 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VFMSD),
     /* 111573 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Dd]
     /* 111575 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ddin
     /* 111577 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Dn
     /* 111581 */     GIR_RootToRootCopy, /*OpIdx*/1, // Dm
     /* 111583 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 111586 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 111592 */     GIR_RootConstrainSelectedInstOperands,
     /* 111593 */     // GIR_Coverage, 5711,
     /* 111593 */     GIR_EraseRootFromParent_Done,
     /* 111594 */   // Label 2118: @111594
     /* 111594 */   GIM_Try, /*On fail goto*//*Label 2119*/ GIMT_Encode4(111653), // Rule ID 2406 //
     /* 111599 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDPVFP_HasVFP4),
     /* 111602 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 111606 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 111610 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 111614 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 111618 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 111622 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 111627 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 111629 */     // (fma:{ *:[f64] } DPR:{ *:[f64] }:$Dn, DPR:{ *:[f64] }:$Dm, (fneg:{ *:[f64] } DPR:{ *:[f64] }:$Ddin))  =>  (VFNMSD:{ *:[f64] } DPR:{ *:[f64] }:$Ddin, DPR:{ *:[f64] }:$Dn, DPR:{ *:[f64] }:$Dm)
     /* 111629 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VFNMSD),
     /* 111632 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Dd]
     /* 111634 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Ddin
     /* 111638 */     GIR_RootToRootCopy, /*OpIdx*/1, // Dn
     /* 111640 */     GIR_RootToRootCopy, /*OpIdx*/2, // Dm
     /* 111642 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 111645 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 111651 */     GIR_RootConstrainSelectedInstOperands,
     /* 111652 */     // GIR_Coverage, 2406,
     /* 111652 */     GIR_EraseRootFromParent_Done,
     /* 111653 */   // Label 2119: @111653
     /* 111653 */   GIM_Try, /*On fail goto*//*Label 2120*/ GIMT_Encode4(111695), // Rule ID 2387 //
     /* 111658 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDPVFP_HasVFP4),
     /* 111661 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 111665 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 111669 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 111673 */     // (fma:{ *:[f64] } DPR:{ *:[f64] }:$Dn, DPR:{ *:[f64] }:$Dm, DPR:{ *:[f64] }:$Ddin)  =>  (VFMAD:{ *:[f64] } DPR:{ *:[f64] }:$Ddin, DPR:{ *:[f64] }:$Dn, DPR:{ *:[f64] }:$Dm)
     /* 111673 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VFMAD),
     /* 111676 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Dd]
     /* 111678 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ddin
     /* 111680 */     GIR_RootToRootCopy, /*OpIdx*/1, // Dn
     /* 111682 */     GIR_RootToRootCopy, /*OpIdx*/2, // Dm
     /* 111684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 111687 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 111693 */     GIR_RootConstrainSelectedInstOperands,
     /* 111694 */     // GIR_Coverage, 2387,
     /* 111694 */     GIR_EraseRootFromParent_Done,
     /* 111695 */   // Label 2120: @111695
     /* 111695 */   GIM_Reject,
     /* 111696 */ // Label 2114: @111696
     /* 111696 */ GIM_Reject,
     /* 111697 */ // Label 2095: @111697
     /* 111697 */ GIM_Try, /*On fail goto*//*Label 2121*/ GIMT_Encode4(111876),
     /* 111702 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 111705 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 111708 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 111711 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 111715 */   GIM_Try, /*On fail goto*//*Label 2122*/ GIMT_Encode4(111774), // Rule ID 2500 //
     /* 111720 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasVFP4),
     /* 111723 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 111727 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 111731 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 111735 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 111740 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 111744 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 111748 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 111750 */     // (fma:{ *:[v2f32] } (fneg:{ *:[v2f32] } DPR:{ *:[v2f32] }:$Vn), DPR:{ *:[v2f32] }:$Vm, DPR:{ *:[v2f32] }:$src1)  =>  (VFMSfd:{ *:[v2f32] } DPR:{ *:[v2f32] }:$src1, DPR:{ *:[v2f32] }:$Vn, DPR:{ *:[v2f32] }:$Vm)
     /* 111750 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VFMSfd),
     /* 111753 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 111755 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 111757 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /* 111761 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 111763 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 111766 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 111772 */     GIR_RootConstrainSelectedInstOperands,
     /* 111773 */     // GIR_Coverage, 2500,
     /* 111773 */     GIR_EraseRootFromParent_Done,
     /* 111774 */   // Label 2122: @111774
     /* 111774 */   GIM_Try, /*On fail goto*//*Label 2123*/ GIMT_Encode4(111833), // Rule ID 5754 //
     /* 111779 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasVFP4),
     /* 111782 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 111786 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 111790 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 111794 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 111798 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 111803 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 111807 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 111809 */     // (fma:{ *:[v2f32] } DPR:{ *:[v2f32] }:$Vm, (fneg:{ *:[v2f32] } DPR:{ *:[v2f32] }:$Vn), DPR:{ *:[v2f32] }:$src1)  =>  (VFMSfd:{ *:[v2f32] } DPR:{ *:[v2f32] }:$src1, DPR:{ *:[v2f32] }:$Vn, DPR:{ *:[v2f32] }:$Vm)
     /* 111809 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VFMSfd),
     /* 111812 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 111814 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 111816 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /* 111820 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /* 111822 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 111825 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 111831 */     GIR_RootConstrainSelectedInstOperands,
     /* 111832 */     // GIR_Coverage, 5754,
     /* 111832 */     GIR_EraseRootFromParent_Done,
     /* 111833 */   // Label 2123: @111833
     /* 111833 */   GIM_Try, /*On fail goto*//*Label 2124*/ GIMT_Encode4(111875), // Rule ID 2498 //
     /* 111838 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasVFP4),
     /* 111841 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 111845 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 111849 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 111853 */     // (fma:{ *:[v2f32] } DPR:{ *:[v2f32] }:$Vn, DPR:{ *:[v2f32] }:$Vm, DPR:{ *:[v2f32] }:$src1)  =>  (VFMAfd:{ *:[v2f32] } DPR:{ *:[v2f32] }:$src1, DPR:{ *:[v2f32] }:$Vn, DPR:{ *:[v2f32] }:$Vm)
     /* 111853 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VFMAfd),
     /* 111856 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 111858 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 111860 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 111862 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 111864 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 111867 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 111873 */     GIR_RootConstrainSelectedInstOperands,
     /* 111874 */     // GIR_Coverage, 2498,
     /* 111874 */     GIR_EraseRootFromParent_Done,
     /* 111875 */   // Label 2124: @111875
     /* 111875 */   GIM_Reject,
     /* 111876 */ // Label 2121: @111876
     /* 111876 */ GIM_Reject,
     /* 111877 */ // Label 2096: @111877
     /* 111877 */ GIM_Try, /*On fail goto*//*Label 2125*/ GIMT_Encode4(111932), // Rule ID 2496 //
     /* 111882 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 111885 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 111888 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 111891 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 111894 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 111898 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 111902 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 111906 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 111910 */   // (fma:{ *:[v4f16] } DPR:{ *:[v4f16] }:$Vn, DPR:{ *:[v4f16] }:$Vm, DPR:{ *:[v4f16] }:$src1)  =>  (VFMAhd:{ *:[v4f16] } DPR:{ *:[v4f16] }:$src1, DPR:{ *:[v4f16] }:$Vn, DPR:{ *:[v4f16] }:$Vm)
     /* 111910 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VFMAhd),
     /* 111913 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 111915 */   GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 111917 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 111919 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 111921 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 111924 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 111930 */   GIR_RootConstrainSelectedInstOperands,
     /* 111931 */   // GIR_Coverage, 2496,
     /* 111931 */   GIR_EraseRootFromParent_Done,
     /* 111932 */ // Label 2125: @111932
     /* 111932 */ GIM_Reject,
     /* 111933 */ // Label 2097: @111933
     /* 111933 */ GIM_Try, /*On fail goto*//*Label 2126*/ GIMT_Encode4(112310),
     /* 111938 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 111941 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 111944 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 111947 */   GIM_Try, /*On fail goto*//*Label 2127*/ GIMT_Encode4(112010), // Rule ID 2501 //
     /* 111952 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasVFP4),
     /* 111955 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 111959 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 111963 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 111967 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 111971 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 111976 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 111980 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 111984 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 111986 */     // (fma:{ *:[v4f32] } (fneg:{ *:[v4f32] } QPR:{ *:[v4f32] }:$Vn), QPR:{ *:[v4f32] }:$Vm, QPR:{ *:[v4f32] }:$src1)  =>  (VFMSfq:{ *:[v4f32] } QPR:{ *:[v4f32] }:$src1, QPR:{ *:[v4f32] }:$Vn, QPR:{ *:[v4f32] }:$Vm)
     /* 111986 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VFMSfq),
     /* 111989 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 111991 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 111993 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /* 111997 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 111999 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 112002 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 112008 */     GIR_RootConstrainSelectedInstOperands,
     /* 112009 */     // GIR_Coverage, 2501,
     /* 112009 */     GIR_EraseRootFromParent_Done,
     /* 112010 */   // Label 2127: @112010
     /* 112010 */   GIM_Try, /*On fail goto*//*Label 2128*/ GIMT_Encode4(112079), // Rule ID 3999 //
     /* 112015 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /* 112018 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 112022 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 112026 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 112030 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 112034 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 112039 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 112043 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 112047 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 112049 */     // (fma:{ *:[v4f32] } (fneg:{ *:[v4f32] } MQPR:{ *:[v4f32] }:$m1), MQPR:{ *:[v4f32] }:$m2, MQPR:{ *:[v4f32] }:$add)  =>  (MVE_VFMSf32:{ *:[v4f32] } ?:{ *:[v4f32] }:$add, ?:{ *:[v4f32] }:$m1, ?:{ *:[v4f32] }:$m2)
     /* 112049 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VFMSf32),
     /* 112052 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 112054 */     GIR_RootToRootCopy, /*OpIdx*/3, // add
     /* 112056 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // m1
     /* 112060 */     GIR_RootToRootCopy, /*OpIdx*/2, // m2
     /* 112062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 112065 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 112071 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 112077 */     GIR_RootConstrainSelectedInstOperands,
     /* 112078 */     // GIR_Coverage, 3999,
     /* 112078 */     GIR_EraseRootFromParent_Done,
     /* 112079 */   // Label 2128: @112079
     /* 112079 */   GIM_Try, /*On fail goto*//*Label 2129*/ GIMT_Encode4(112142), // Rule ID 5755 //
     /* 112084 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasVFP4),
     /* 112087 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 112091 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 112095 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 112099 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 112103 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 112107 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 112112 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 112116 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 112118 */     // (fma:{ *:[v4f32] } QPR:{ *:[v4f32] }:$Vm, (fneg:{ *:[v4f32] } QPR:{ *:[v4f32] }:$Vn), QPR:{ *:[v4f32] }:$src1)  =>  (VFMSfq:{ *:[v4f32] } QPR:{ *:[v4f32] }:$src1, QPR:{ *:[v4f32] }:$Vn, QPR:{ *:[v4f32] }:$Vm)
     /* 112118 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VFMSfq),
     /* 112121 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 112123 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 112125 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /* 112129 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /* 112131 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 112134 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 112140 */     GIR_RootConstrainSelectedInstOperands,
     /* 112141 */     // GIR_Coverage, 5755,
     /* 112141 */     GIR_EraseRootFromParent_Done,
     /* 112142 */   // Label 2129: @112142
     /* 112142 */   GIM_Try, /*On fail goto*//*Label 2130*/ GIMT_Encode4(112211), // Rule ID 6035 //
     /* 112147 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /* 112150 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 112154 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 112158 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 112162 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 112166 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 112170 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 112175 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 112179 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 112181 */     // (fma:{ *:[v4f32] } MQPR:{ *:[v4f32] }:$m2, (fneg:{ *:[v4f32] } MQPR:{ *:[v4f32] }:$m1), MQPR:{ *:[v4f32] }:$add)  =>  (MVE_VFMSf32:{ *:[v4f32] } ?:{ *:[v4f32] }:$add, ?:{ *:[v4f32] }:$m1, ?:{ *:[v4f32] }:$m2)
     /* 112181 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VFMSf32),
     /* 112184 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 112186 */     GIR_RootToRootCopy, /*OpIdx*/3, // add
     /* 112188 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // m1
     /* 112192 */     GIR_RootToRootCopy, /*OpIdx*/1, // m2
     /* 112194 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 112197 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 112203 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 112209 */     GIR_RootConstrainSelectedInstOperands,
     /* 112210 */     // GIR_Coverage, 6035,
     /* 112210 */     GIR_EraseRootFromParent_Done,
     /* 112211 */   // Label 2130: @112211
     /* 112211 */   GIM_Try, /*On fail goto*//*Label 2131*/ GIMT_Encode4(112257), // Rule ID 2499 //
     /* 112216 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasVFP4),
     /* 112219 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 112223 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 112227 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 112231 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 112235 */     // (fma:{ *:[v4f32] } QPR:{ *:[v4f32] }:$Vn, QPR:{ *:[v4f32] }:$Vm, QPR:{ *:[v4f32] }:$src1)  =>  (VFMAfq:{ *:[v4f32] } QPR:{ *:[v4f32] }:$src1, QPR:{ *:[v4f32] }:$Vn, QPR:{ *:[v4f32] }:$Vm)
     /* 112235 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VFMAfq),
     /* 112238 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 112240 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 112242 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 112244 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 112246 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 112249 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 112255 */     GIR_RootConstrainSelectedInstOperands,
     /* 112256 */     // GIR_Coverage, 2499,
     /* 112256 */     GIR_EraseRootFromParent_Done,
     /* 112257 */   // Label 2131: @112257
     /* 112257 */   GIM_Try, /*On fail goto*//*Label 2132*/ GIMT_Encode4(112309), // Rule ID 4003 //
     /* 112262 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /* 112265 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 112269 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 112273 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 112277 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 112281 */     // (fma:{ *:[v4f32] } MQPR:{ *:[v4f32] }:$m1, MQPR:{ *:[v4f32] }:$m2, MQPR:{ *:[v4f32] }:$add)  =>  (MVE_VFMAf32:{ *:[v4f32] } ?:{ *:[v4f32] }:$add, ?:{ *:[v4f32] }:$m1, ?:{ *:[v4f32] }:$m2)
     /* 112281 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VFMAf32),
     /* 112284 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 112286 */     GIR_RootToRootCopy, /*OpIdx*/3, // add
     /* 112288 */     GIR_RootToRootCopy, /*OpIdx*/1, // m1
     /* 112290 */     GIR_RootToRootCopy, /*OpIdx*/2, // m2
     /* 112292 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 112295 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 112301 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 112307 */     GIR_RootConstrainSelectedInstOperands,
     /* 112308 */     // GIR_Coverage, 4003,
     /* 112308 */     GIR_EraseRootFromParent_Done,
     /* 112309 */   // Label 2132: @112309
     /* 112309 */   GIM_Reject,
     /* 112310 */ // Label 2126: @112310
     /* 112310 */ GIM_Reject,
     /* 112311 */ // Label 2098: @112311
     /* 112311 */ GIM_Try, /*On fail goto*//*Label 2133*/ GIMT_Encode4(112562),
     /* 112316 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 112319 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 112322 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 112325 */   GIM_Try, /*On fail goto*//*Label 2134*/ GIMT_Encode4(112394), // Rule ID 4009 //
     /* 112330 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /* 112333 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 112337 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 112341 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 112345 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 112349 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 112354 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 112358 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 112362 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 112364 */     // (fma:{ *:[v8f16] } (fneg:{ *:[v8f16] } MQPR:{ *:[v8f16] }:$m1), MQPR:{ *:[v8f16] }:$m2, MQPR:{ *:[v8f16] }:$add)  =>  (MVE_VFMSf16:{ *:[v8f16] } ?:{ *:[v8f16] }:$add, ?:{ *:[v8f16] }:$m1, ?:{ *:[v8f16] }:$m2)
     /* 112364 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VFMSf16),
     /* 112367 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 112369 */     GIR_RootToRootCopy, /*OpIdx*/3, // add
     /* 112371 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // m1
     /* 112375 */     GIR_RootToRootCopy, /*OpIdx*/2, // m2
     /* 112377 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 112380 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 112386 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 112392 */     GIR_RootConstrainSelectedInstOperands,
     /* 112393 */     // GIR_Coverage, 4009,
     /* 112393 */     GIR_EraseRootFromParent_Done,
     /* 112394 */   // Label 2134: @112394
     /* 112394 */   GIM_Try, /*On fail goto*//*Label 2135*/ GIMT_Encode4(112463), // Rule ID 6037 //
     /* 112399 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /* 112402 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 112406 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 112410 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 112414 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 112418 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 112422 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 112427 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 112431 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 112433 */     // (fma:{ *:[v8f16] } MQPR:{ *:[v8f16] }:$m2, (fneg:{ *:[v8f16] } MQPR:{ *:[v8f16] }:$m1), MQPR:{ *:[v8f16] }:$add)  =>  (MVE_VFMSf16:{ *:[v8f16] } ?:{ *:[v8f16] }:$add, ?:{ *:[v8f16] }:$m1, ?:{ *:[v8f16] }:$m2)
     /* 112433 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VFMSf16),
     /* 112436 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 112438 */     GIR_RootToRootCopy, /*OpIdx*/3, // add
     /* 112440 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // m1
     /* 112444 */     GIR_RootToRootCopy, /*OpIdx*/1, // m2
     /* 112446 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 112449 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 112455 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 112461 */     GIR_RootConstrainSelectedInstOperands,
     /* 112462 */     // GIR_Coverage, 6037,
     /* 112462 */     GIR_EraseRootFromParent_Done,
     /* 112463 */   // Label 2135: @112463
     /* 112463 */   GIM_Try, /*On fail goto*//*Label 2136*/ GIMT_Encode4(112509), // Rule ID 2497 //
     /* 112468 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 112471 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 112475 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 112479 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 112483 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 112487 */     // (fma:{ *:[v8f16] } QPR:{ *:[v8f16] }:$Vn, QPR:{ *:[v8f16] }:$Vm, QPR:{ *:[v8f16] }:$src1)  =>  (VFMAhq:{ *:[v8f16] } QPR:{ *:[v8f16] }:$src1, QPR:{ *:[v8f16] }:$Vn, QPR:{ *:[v8f16] }:$Vm)
     /* 112487 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VFMAhq),
     /* 112490 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 112492 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 112494 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 112496 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 112498 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 112501 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 112507 */     GIR_RootConstrainSelectedInstOperands,
     /* 112508 */     // GIR_Coverage, 2497,
     /* 112508 */     GIR_EraseRootFromParent_Done,
     /* 112509 */   // Label 2136: @112509
     /* 112509 */   GIM_Try, /*On fail goto*//*Label 2137*/ GIMT_Encode4(112561), // Rule ID 4006 //
     /* 112514 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /* 112517 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 112521 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 112525 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 112529 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 112533 */     // (fma:{ *:[v8f16] } MQPR:{ *:[v8f16] }:$m1, MQPR:{ *:[v8f16] }:$m2, MQPR:{ *:[v8f16] }:$add)  =>  (MVE_VFMAf16:{ *:[v8f16] } ?:{ *:[v8f16] }:$add, ?:{ *:[v8f16] }:$m1, ?:{ *:[v8f16] }:$m2)
     /* 112533 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VFMAf16),
     /* 112536 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 112538 */     GIR_RootToRootCopy, /*OpIdx*/3, // add
     /* 112540 */     GIR_RootToRootCopy, /*OpIdx*/1, // m1
     /* 112542 */     GIR_RootToRootCopy, /*OpIdx*/2, // m2
     /* 112544 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 112547 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 112553 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 112559 */     GIR_RootConstrainSelectedInstOperands,
     /* 112560 */     // GIR_Coverage, 4006,
     /* 112560 */     GIR_EraseRootFromParent_Done,
     /* 112561 */   // Label 2137: @112561
     /* 112561 */   GIM_Reject,
     /* 112562 */ // Label 2133: @112562
     /* 112562 */ GIM_Reject,
     /* 112563 */ // Label 2099: @112563
     /* 112563 */ GIM_Reject,
     /* 112564 */ // Label 38: @112564
     /* 112564 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(3), /*)*//*default:*//*Label 2141*/ GIMT_Encode4(112728),
     /* 112575 */ /*GILLT_s16*//*Label 2138*/ GIMT_Encode4(112587),
     /* 112579 */ /*GILLT_s32*//*Label 2139*/ GIMT_Encode4(112634),
     /* 112583 */ /*GILLT_s64*//*Label 2140*/ GIMT_Encode4(112681),
     /* 112587 */ // Label 2138: @112587
     /* 112587 */ GIM_Try, /*On fail goto*//*Label 2142*/ GIMT_Encode4(112633), // Rule ID 620 //
     /* 112592 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 112595 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 112598 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 112601 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 112605 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 112609 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 112613 */   // (fdiv:{ *:[f16] } HPR:{ *:[f16] }:$Sn, HPR:{ *:[f16] }:$Sm)  =>  (VDIVH:{ *:[f16] } HPR:{ *:[f16] }:$Sn, HPR:{ *:[f16] }:$Sm)
     /* 112613 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VDIVH),
     /* 112616 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /* 112618 */   GIR_RootToRootCopy, /*OpIdx*/1, // Sn
     /* 112620 */   GIR_RootToRootCopy, /*OpIdx*/2, // Sm
     /* 112622 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 112625 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 112631 */   GIR_RootConstrainSelectedInstOperands,
     /* 112632 */   // GIR_Coverage, 620,
     /* 112632 */   GIR_EraseRootFromParent_Done,
     /* 112633 */ // Label 2142: @112633
     /* 112633 */ GIM_Reject,
     /* 112634 */ // Label 2139: @112634
     /* 112634 */ GIM_Try, /*On fail goto*//*Label 2143*/ GIMT_Encode4(112680), // Rule ID 619 //
     /* 112639 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVFP2),
     /* 112642 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 112645 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 112648 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 112652 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 112656 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 112660 */   // (fdiv:{ *:[f32] } SPR:{ *:[f32] }:$Sn, SPR:{ *:[f32] }:$Sm)  =>  (VDIVS:{ *:[f32] } SPR:{ *:[f32] }:$Sn, SPR:{ *:[f32] }:$Sm)
     /* 112660 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VDIVS),
     /* 112663 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /* 112665 */   GIR_RootToRootCopy, /*OpIdx*/1, // Sn
     /* 112667 */   GIR_RootToRootCopy, /*OpIdx*/2, // Sm
     /* 112669 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 112672 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 112678 */   GIR_RootConstrainSelectedInstOperands,
     /* 112679 */   // GIR_Coverage, 619,
     /* 112679 */   GIR_EraseRootFromParent_Done,
     /* 112680 */ // Label 2143: @112680
     /* 112680 */ GIM_Reject,
     /* 112681 */ // Label 2140: @112681
     /* 112681 */ GIM_Try, /*On fail goto*//*Label 2144*/ GIMT_Encode4(112727), // Rule ID 618 //
     /* 112686 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDPVFP_HasVFP2),
     /* 112689 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 112692 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 112695 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 112699 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 112703 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 112707 */   // (fdiv:{ *:[f64] } DPR:{ *:[f64] }:$Dn, DPR:{ *:[f64] }:$Dm)  =>  (VDIVD:{ *:[f64] } DPR:{ *:[f64] }:$Dn, DPR:{ *:[f64] }:$Dm)
     /* 112707 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VDIVD),
     /* 112710 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Dd]
     /* 112712 */   GIR_RootToRootCopy, /*OpIdx*/1, // Dn
     /* 112714 */   GIR_RootToRootCopy, /*OpIdx*/2, // Dm
     /* 112716 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 112719 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 112725 */   GIR_RootConstrainSelectedInstOperands,
     /* 112726 */   // GIR_Coverage, 618,
     /* 112726 */   GIR_EraseRootFromParent_Done,
     /* 112727 */ // Label 2144: @112727
     /* 112727 */ GIM_Reject,
     /* 112728 */ // Label 2141: @112728
     /* 112728 */ GIM_Reject,
     /* 112729 */ // Label 39: @112729
     /* 112729 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(13), /*)*//*default:*//*Label 2152*/ GIMT_Encode4(114259),
     /* 112740 */ /*GILLT_s16*//*Label 2145*/ GIMT_Encode4(112792),
     /* 112744 */ /*GILLT_s32*//*Label 2146*/ GIMT_Encode4(113139),
     /* 112748 */ /*GILLT_s64*//*Label 2147*/ GIMT_Encode4(113638), GIMT_Encode4(0),
     /* 112756 */ /*GILLT_v2s32*//*Label 2148*/ GIMT_Encode4(113985), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 112768 */ /*GILLT_v4s16*//*Label 2149*/ GIMT_Encode4(114023),
     /* 112772 */ /*GILLT_v4s32*//*Label 2150*/ GIMT_Encode4(114061), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 112788 */ /*GILLT_v8s16*//*Label 2151*/ GIMT_Encode4(114160),
     /* 112792 */ // Label 2145: @112792
     /* 112792 */ GIM_Try, /*On fail goto*//*Label 2153*/ GIMT_Encode4(113138),
     /* 112797 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 112800 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 112804 */   GIM_Try, /*On fail goto*//*Label 2154*/ GIMT_Encode4(112889), // Rule ID 2411 //
     /* 112809 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 112812 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 112816 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMA),
     /* 112820 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 112824 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 112828 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s16,
     /* 112832 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 112836 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 112840 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 112844 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 112849 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 112854 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 112859 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 112861 */     // (fneg:{ *:[f16] } (fma:{ *:[f16] } (fneg:{ *:[f16] } HPR:{ *:[f16] }:$Sn), HPR:{ *:[f16] }:$Sm, HPR:{ *:[f16] }:$Sdin))  =>  (VFNMSH:{ *:[f16] } HPR:{ *:[f16] }:$Sdin, HPR:{ *:[f16] }:$Sn, HPR:{ *:[f16] }:$Sm)
     /* 112861 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VFNMSH),
     /* 112864 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /* 112866 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Sdin
     /* 112870 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Sn
     /* 112874 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Sm
     /* 112878 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 112881 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 112887 */     GIR_RootConstrainSelectedInstOperands,
     /* 112888 */     // GIR_Coverage, 2411,
     /* 112888 */     GIR_EraseRootFromParent_Done,
     /* 112889 */   // Label 2154: @112889
     /* 112889 */   GIM_Try, /*On fail goto*//*Label 2155*/ GIMT_Encode4(112974), // Rule ID 5719 //
     /* 112894 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 112897 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 112901 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMA),
     /* 112905 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 112909 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 112913 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s16,
     /* 112917 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 112922 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 112926 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 112930 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 112934 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 112939 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 112944 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 112946 */     // (fneg:{ *:[f16] } (fma:{ *:[f16] } HPR:{ *:[f16] }:$Sm, (fneg:{ *:[f16] } HPR:{ *:[f16] }:$Sn), HPR:{ *:[f16] }:$Sdin))  =>  (VFNMSH:{ *:[f16] } HPR:{ *:[f16] }:$Sdin, HPR:{ *:[f16] }:$Sn, HPR:{ *:[f16] }:$Sm)
     /* 112946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VFNMSH),
     /* 112949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /* 112951 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Sdin
     /* 112955 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Sn
     /* 112959 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Sm
     /* 112963 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 112966 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 112972 */     GIR_RootConstrainSelectedInstOperands,
     /* 112973 */     // GIR_Coverage, 5719,
     /* 112973 */     GIR_EraseRootFromParent_Done,
     /* 112974 */   // Label 2155: @112974
     /* 112974 */   GIM_Try, /*On fail goto*//*Label 2156*/ GIMT_Encode4(113047), // Rule ID 2400 //
     /* 112979 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 112982 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 112986 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMA),
     /* 112990 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 112994 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 112998 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s16,
     /* 113002 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 113007 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 113012 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 113017 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 113019 */     // (fneg:{ *:[f16] } (fma:{ *:[f16] } HPR:{ *:[f16] }:$Sn, HPR:{ *:[f16] }:$Sm, HPR:{ *:[f16] }:$Sdin))  =>  (VFNMAH:{ *:[f16] } HPR:{ *:[f16] }:$Sdin, HPR:{ *:[f16] }:$Sn, HPR:{ *:[f16] }:$Sm)
     /* 113019 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VFNMAH),
     /* 113022 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /* 113024 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Sdin
     /* 113028 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Sn
     /* 113032 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Sm
     /* 113036 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 113039 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 113045 */     GIR_RootConstrainSelectedInstOperands,
     /* 113046 */     // GIR_Coverage, 2400,
     /* 113046 */     GIR_EraseRootFromParent_Done,
     /* 113047 */   // Label 2156: @113047
     /* 113047 */   GIM_Try, /*On fail goto*//*Label 2157*/ GIMT_Encode4(113107), // Rule ID 626 //
     /* 113052 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 113055 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 113059 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMUL),
     /* 113063 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 113067 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 113071 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 113076 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 113081 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 113083 */     // (fneg:{ *:[f16] } (fmul:{ *:[f16] } HPR:{ *:[f16] }:$Sn, HPR:{ *:[f16] }:$Sm))  =>  (VNMULH:{ *:[f16] } HPR:{ *:[f16] }:$Sn, HPR:{ *:[f16] }:$Sm)
     /* 113083 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VNMULH),
     /* 113086 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /* 113088 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Sn
     /* 113092 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Sm
     /* 113096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 113099 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 113105 */     GIR_RootConstrainSelectedInstOperands,
     /* 113106 */     // GIR_Coverage, 626,
     /* 113106 */     GIR_EraseRootFromParent_Done,
     /* 113107 */   // Label 2157: @113107
     /* 113107 */   GIM_Try, /*On fail goto*//*Label 2158*/ GIMT_Encode4(113137), // Rule ID 664 //
     /* 113112 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 113115 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 113119 */     // (fneg:{ *:[f16] } HPR:{ *:[f16] }:$Sm)  =>  (VNEGH:{ *:[f16] } HPR:{ *:[f16] }:$Sm)
     /* 113119 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VNEGH),
     /* 113122 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /* 113124 */     GIR_RootToRootCopy, /*OpIdx*/1, // Sm
     /* 113126 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 113129 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 113135 */     GIR_RootConstrainSelectedInstOperands,
     /* 113136 */     // GIR_Coverage, 664,
     /* 113136 */     GIR_EraseRootFromParent_Done,
     /* 113137 */   // Label 2158: @113137
     /* 113137 */   GIM_Reject,
     /* 113138 */ // Label 2153: @113138
     /* 113138 */ GIM_Reject,
     /* 113139 */ // Label 2146: @113139
     /* 113139 */ GIM_Try, /*On fail goto*//*Label 2159*/ GIMT_Encode4(113637),
     /* 113144 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 113147 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 113151 */   GIM_Try, /*On fail goto*//*Label 2160*/ GIMT_Encode4(113236), // Rule ID 2410 //
     /* 113156 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVFP4),
     /* 113159 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 113163 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMA),
     /* 113167 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 113171 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 113175 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 113179 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 113183 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 113187 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 113191 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 113196 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 113201 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 113206 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 113208 */     // (fneg:{ *:[f32] } (fma:{ *:[f32] } (fneg:{ *:[f32] } SPR:{ *:[f32] }:$Sn), SPR:{ *:[f32] }:$Sm, SPR:{ *:[f32] }:$Sdin))  =>  (VFNMSS:{ *:[f32] } SPR:{ *:[f32] }:$Sdin, SPR:{ *:[f32] }:$Sn, SPR:{ *:[f32] }:$Sm)
     /* 113208 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VFNMSS),
     /* 113211 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /* 113213 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Sdin
     /* 113217 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Sn
     /* 113221 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Sm
     /* 113225 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 113228 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 113234 */     GIR_RootConstrainSelectedInstOperands,
     /* 113235 */     // GIR_Coverage, 2410,
     /* 113235 */     GIR_EraseRootFromParent_Done,
     /* 113236 */   // Label 2160: @113236
     /* 113236 */   GIM_Try, /*On fail goto*//*Label 2161*/ GIMT_Encode4(113321), // Rule ID 5718 //
     /* 113241 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVFP4),
     /* 113244 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 113248 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMA),
     /* 113252 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 113256 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 113260 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 113264 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 113269 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 113273 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 113277 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 113281 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 113286 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 113291 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 113293 */     // (fneg:{ *:[f32] } (fma:{ *:[f32] } SPR:{ *:[f32] }:$Sm, (fneg:{ *:[f32] } SPR:{ *:[f32] }:$Sn), SPR:{ *:[f32] }:$Sdin))  =>  (VFNMSS:{ *:[f32] } SPR:{ *:[f32] }:$Sdin, SPR:{ *:[f32] }:$Sn, SPR:{ *:[f32] }:$Sm)
     /* 113293 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VFNMSS),
     /* 113296 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /* 113298 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Sdin
     /* 113302 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Sn
     /* 113306 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Sm
     /* 113310 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 113313 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 113319 */     GIR_RootConstrainSelectedInstOperands,
     /* 113320 */     // GIR_Coverage, 5718,
     /* 113320 */     GIR_EraseRootFromParent_Done,
     /* 113321 */   // Label 2161: @113321
     /* 113321 */   GIM_Try, /*On fail goto*//*Label 2162*/ GIMT_Encode4(113394), // Rule ID 2399 //
     /* 113326 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVFP4),
     /* 113329 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 113333 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMA),
     /* 113337 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 113341 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 113345 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 113349 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 113354 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 113359 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 113364 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 113366 */     // (fneg:{ *:[f32] } (fma:{ *:[f32] } SPR:{ *:[f32] }:$Sn, SPR:{ *:[f32] }:$Sm, SPR:{ *:[f32] }:$Sdin))  =>  (VFNMAS:{ *:[f32] } SPR:{ *:[f32] }:$Sdin, SPR:{ *:[f32] }:$Sn, SPR:{ *:[f32] }:$Sm)
     /* 113366 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VFNMAS),
     /* 113369 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /* 113371 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Sdin
     /* 113375 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Sn
     /* 113379 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Sm
     /* 113383 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 113386 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 113392 */     GIR_RootConstrainSelectedInstOperands,
     /* 113393 */     // GIR_Coverage, 2399,
     /* 113393 */     GIR_EraseRootFromParent_Done,
     /* 113394 */   // Label 2162: @113394
     /* 113394 */   GIM_Try, /*On fail goto*//*Label 2163*/ GIMT_Encode4(113454), // Rule ID 625 //
     /* 113399 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVFP2),
     /* 113402 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 113406 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMUL),
     /* 113410 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 113414 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 113418 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 113423 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 113428 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 113430 */     // (fneg:{ *:[f32] } (fmul:{ *:[f32] } SPR:{ *:[f32] }:$Sn, SPR:{ *:[f32] }:$Sm))  =>  (VNMULS:{ *:[f32] } SPR:{ *:[f32] }:$Sn, SPR:{ *:[f32] }:$Sm)
     /* 113430 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VNMULS),
     /* 113433 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /* 113435 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Sn
     /* 113439 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Sm
     /* 113443 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 113446 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 113452 */     GIR_RootConstrainSelectedInstOperands,
     /* 113453 */     // GIR_Coverage, 625,
     /* 113453 */     GIR_EraseRootFromParent_Done,
     /* 113454 */   // Label 2163: @113454
     /* 113454 */   GIM_Try, /*On fail goto*//*Label 2164*/ GIMT_Encode4(113484), // Rule ID 663 //
     /* 113459 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_DontUseNEONForFP_HasVFP2),
     /* 113462 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 113466 */     // (fneg:{ *:[f32] } SPR:{ *:[f32] }:$Sm)  =>  (VNEGS:{ *:[f32] } SPR:{ *:[f32] }:$Sm)
     /* 113466 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VNEGS),
     /* 113469 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /* 113471 */     GIR_RootToRootCopy, /*OpIdx*/1, // Sm
     /* 113473 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 113476 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 113482 */     GIR_RootConstrainSelectedInstOperands,
     /* 113483 */     // GIR_Coverage, 663,
     /* 113483 */     GIR_EraseRootFromParent_Done,
     /* 113484 */   // Label 2164: @113484
     /* 113484 */   GIM_Try, /*On fail goto*//*Label 2165*/ GIMT_Encode4(113636), // Rule ID 2702 //
     /* 113489 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_UseNEONForFP),
     /* 113492 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 113496 */     // (fneg:{ *:[f32] } SPR:{ *:[f32] }:$a)  =>  (EXTRACT_SUBREG:{ *:[f32] } (COPY_TO_REGCLASS:{ *:[v2f32] } (VNEGfd:{ *:[f64] } (INSERT_SUBREG:{ *:[v2f32] } (COPY_TO_REGCLASS:{ *:[v2f32] } (IMPLICIT_DEF:{ *:[v2f32] }), DPR_VFP2:{ *:[i32] }), SPR:{ *:[f32] }:$a, ssub_0:{ *:[i32] })), DPR_VFP2:{ *:[i32] }), ssub_0:{ *:[i32] })
     /* 113496 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v2s32,
     /* 113499 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 113503 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 113508 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 113510 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v2s32,
     /* 113513 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 113517 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 113522 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 113525 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 113530 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s32,
     /* 113533 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 113537 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 113542 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 113545 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // a
     /* 113549 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/17,
     /* 113552 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 113557 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 113562 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(ARM::SPRRegClassID),
     /* 113567 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 113570 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(ARM::VNEGfd),
     /* 113574 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 113579 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 113582 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/14,
     /* 113585 */     GIR_AddRegister, /*InsnID*/2, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 113591 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 113593 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s32,
     /* 113596 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 113600 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 113605 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 113608 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 113613 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 113616 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 113618 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(ARM::ssub_0),
     /* 113625 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::SPRRegClassID),
     /* 113630 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 113635 */     // GIR_Coverage, 2702,
     /* 113635 */     GIR_EraseRootFromParent_Done,
     /* 113636 */   // Label 2165: @113636
     /* 113636 */   GIM_Reject,
     /* 113637 */ // Label 2159: @113637
     /* 113637 */ GIM_Reject,
     /* 113638 */ // Label 2147: @113638
     /* 113638 */ GIM_Try, /*On fail goto*//*Label 2166*/ GIMT_Encode4(113984),
     /* 113643 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 113646 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 113650 */   GIM_Try, /*On fail goto*//*Label 2167*/ GIMT_Encode4(113735), // Rule ID 2409 //
     /* 113655 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDPVFP_HasVFP4),
     /* 113658 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 113662 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMA),
     /* 113666 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 113670 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 113674 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 113678 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 113682 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 113686 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 113690 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 113695 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 113700 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 113705 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 113707 */     // (fneg:{ *:[f64] } (fma:{ *:[f64] } (fneg:{ *:[f64] } DPR:{ *:[f64] }:$Dn), DPR:{ *:[f64] }:$Dm, DPR:{ *:[f64] }:$Ddin))  =>  (VFNMSD:{ *:[f64] } DPR:{ *:[f64] }:$Ddin, DPR:{ *:[f64] }:$Dn, DPR:{ *:[f64] }:$Dm)
     /* 113707 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VFNMSD),
     /* 113710 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Dd]
     /* 113712 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ddin
     /* 113716 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Dn
     /* 113720 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Dm
     /* 113724 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 113727 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 113733 */     GIR_RootConstrainSelectedInstOperands,
     /* 113734 */     // GIR_Coverage, 2409,
     /* 113734 */     GIR_EraseRootFromParent_Done,
     /* 113735 */   // Label 2167: @113735
     /* 113735 */   GIM_Try, /*On fail goto*//*Label 2168*/ GIMT_Encode4(113820), // Rule ID 5717 //
     /* 113740 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDPVFP_HasVFP4),
     /* 113743 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 113747 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMA),
     /* 113751 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 113755 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 113759 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 113763 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 113768 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 113772 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 113776 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 113780 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 113785 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 113790 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 113792 */     // (fneg:{ *:[f64] } (fma:{ *:[f64] } DPR:{ *:[f64] }:$Dm, (fneg:{ *:[f64] } DPR:{ *:[f64] }:$Dn), DPR:{ *:[f64] }:$Ddin))  =>  (VFNMSD:{ *:[f64] } DPR:{ *:[f64] }:$Ddin, DPR:{ *:[f64] }:$Dn, DPR:{ *:[f64] }:$Dm)
     /* 113792 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VFNMSD),
     /* 113795 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Dd]
     /* 113797 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ddin
     /* 113801 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Dn
     /* 113805 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Dm
     /* 113809 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 113812 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 113818 */     GIR_RootConstrainSelectedInstOperands,
     /* 113819 */     // GIR_Coverage, 5717,
     /* 113819 */     GIR_EraseRootFromParent_Done,
     /* 113820 */   // Label 2168: @113820
     /* 113820 */   GIM_Try, /*On fail goto*//*Label 2169*/ GIMT_Encode4(113893), // Rule ID 2398 //
     /* 113825 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDPVFP_HasVFP4),
     /* 113828 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 113832 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMA),
     /* 113836 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 113840 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 113844 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 113848 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 113853 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 113858 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 113863 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 113865 */     // (fneg:{ *:[f64] } (fma:{ *:[f64] } DPR:{ *:[f64] }:$Dn, DPR:{ *:[f64] }:$Dm, DPR:{ *:[f64] }:$Ddin))  =>  (VFNMAD:{ *:[f64] } DPR:{ *:[f64] }:$Ddin, DPR:{ *:[f64] }:$Dn, DPR:{ *:[f64] }:$Dm)
     /* 113865 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VFNMAD),
     /* 113868 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Dd]
     /* 113870 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ddin
     /* 113874 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Dn
     /* 113878 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Dm
     /* 113882 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 113885 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 113891 */     GIR_RootConstrainSelectedInstOperands,
     /* 113892 */     // GIR_Coverage, 2398,
     /* 113892 */     GIR_EraseRootFromParent_Done,
     /* 113893 */   // Label 2169: @113893
     /* 113893 */   GIM_Try, /*On fail goto*//*Label 2170*/ GIMT_Encode4(113953), // Rule ID 624 //
     /* 113898 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDPVFP_HasVFP2),
     /* 113901 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 113905 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMUL),
     /* 113909 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 113913 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 113917 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 113922 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 113927 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 113929 */     // (fneg:{ *:[f64] } (fmul:{ *:[f64] } DPR:{ *:[f64] }:$Dn, DPR:{ *:[f64] }:$Dm))  =>  (VNMULD:{ *:[f64] } DPR:{ *:[f64] }:$Dn, DPR:{ *:[f64] }:$Dm)
     /* 113929 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VNMULD),
     /* 113932 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Dd]
     /* 113934 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Dn
     /* 113938 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Dm
     /* 113942 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 113945 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 113951 */     GIR_RootConstrainSelectedInstOperands,
     /* 113952 */     // GIR_Coverage, 624,
     /* 113952 */     GIR_EraseRootFromParent_Done,
     /* 113953 */   // Label 2170: @113953
     /* 113953 */   GIM_Try, /*On fail goto*//*Label 2171*/ GIMT_Encode4(113983), // Rule ID 662 //
     /* 113958 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDPVFP_HasVFP2),
     /* 113961 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 113965 */     // (fneg:{ *:[f64] } DPR:{ *:[f64] }:$Dm)  =>  (VNEGD:{ *:[f64] } DPR:{ *:[f64] }:$Dm)
     /* 113965 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VNEGD),
     /* 113968 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Dd]
     /* 113970 */     GIR_RootToRootCopy, /*OpIdx*/1, // Dm
     /* 113972 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 113975 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 113981 */     GIR_RootConstrainSelectedInstOperands,
     /* 113982 */     // GIR_Coverage, 662,
     /* 113982 */     GIR_EraseRootFromParent_Done,
     /* 113983 */   // Label 2171: @113983
     /* 113983 */   GIM_Reject,
     /* 113984 */ // Label 2166: @113984
     /* 113984 */ GIM_Reject,
     /* 113985 */ // Label 2148: @113985
     /* 113985 */ GIM_Try, /*On fail goto*//*Label 2172*/ GIMT_Encode4(114022), // Rule ID 1527 //
     /* 113990 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 113993 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 113996 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 114000 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 114004 */   // (fneg:{ *:[v2f32] } DPR:{ *:[v2f32] }:$Vm)  =>  (VNEGfd:{ *:[v2f32] } DPR:{ *:[v2f32] }:$Vm)
     /* 114004 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VNEGfd),
     /* 114007 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 114009 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /* 114011 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 114014 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 114020 */   GIR_RootConstrainSelectedInstOperands,
     /* 114021 */   // GIR_Coverage, 1527,
     /* 114021 */   GIR_EraseRootFromParent_Done,
     /* 114022 */ // Label 2172: @114022
     /* 114022 */ GIM_Reject,
     /* 114023 */ // Label 2149: @114023
     /* 114023 */ GIM_Try, /*On fail goto*//*Label 2173*/ GIMT_Encode4(114060), // Rule ID 1529 //
     /* 114028 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 114031 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 114034 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 114038 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 114042 */   // (fneg:{ *:[v4f16] } DPR:{ *:[v4f16] }:$Vm)  =>  (VNEGhd:{ *:[v4f16] } DPR:{ *:[v4f16] }:$Vm)
     /* 114042 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VNEGhd),
     /* 114045 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 114047 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /* 114049 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 114052 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 114058 */   GIR_RootConstrainSelectedInstOperands,
     /* 114059 */   // GIR_Coverage, 1529,
     /* 114059 */   GIR_EraseRootFromParent_Done,
     /* 114060 */ // Label 2173: @114060
     /* 114060 */ GIM_Reject,
     /* 114061 */ // Label 2150: @114061
     /* 114061 */ GIM_Try, /*On fail goto*//*Label 2174*/ GIMT_Encode4(114159),
     /* 114066 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 114069 */   GIM_Try, /*On fail goto*//*Label 2175*/ GIMT_Encode4(114103), // Rule ID 1528 //
     /* 114074 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 114077 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 114081 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 114085 */     // (fneg:{ *:[v4f32] } QPR:{ *:[v4f32] }:$Vm)  =>  (VNEGf32q:{ *:[v4f32] } QPR:{ *:[v4f32] }:$Vm)
     /* 114085 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VNEGf32q),
     /* 114088 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 114090 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /* 114092 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 114095 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 114101 */     GIR_RootConstrainSelectedInstOperands,
     /* 114102 */     // GIR_Coverage, 1528,
     /* 114102 */     GIR_EraseRootFromParent_Done,
     /* 114103 */   // Label 2175: @114103
     /* 114103 */   GIM_Try, /*On fail goto*//*Label 2176*/ GIMT_Encode4(114158), // Rule ID 4113 //
     /* 114108 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 114111 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 114115 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 114119 */     // (fneg:{ *:[v4f32] } MQPR:{ *:[v4f32] }:$v)  =>  (MVE_VNEGf32:{ *:[v4f32] } ?:{ *:[v4f32] }:$v)
     /* 114119 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 114122 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 114126 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 114131 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VNEGf32),
     /* 114134 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 114136 */     GIR_RootToRootCopy, /*OpIdx*/1, // v
     /* 114138 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 114141 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 114147 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 114153 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 114156 */     GIR_RootConstrainSelectedInstOperands,
     /* 114157 */     // GIR_Coverage, 4113,
     /* 114157 */     GIR_EraseRootFromParent_Done,
     /* 114158 */   // Label 2176: @114158
     /* 114158 */   GIM_Reject,
     /* 114159 */ // Label 2174: @114159
     /* 114159 */ GIM_Reject,
     /* 114160 */ // Label 2151: @114160
     /* 114160 */ GIM_Try, /*On fail goto*//*Label 2177*/ GIMT_Encode4(114258),
     /* 114165 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 114168 */   GIM_Try, /*On fail goto*//*Label 2178*/ GIMT_Encode4(114202), // Rule ID 1530 //
     /* 114173 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 114176 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 114180 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 114184 */     // (fneg:{ *:[v8f16] } QPR:{ *:[v8f16] }:$Vm)  =>  (VNEGhq:{ *:[v8f16] } QPR:{ *:[v8f16] }:$Vm)
     /* 114184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VNEGhq),
     /* 114187 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 114189 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /* 114191 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 114194 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 114200 */     GIR_RootConstrainSelectedInstOperands,
     /* 114201 */     // GIR_Coverage, 1530,
     /* 114201 */     GIR_EraseRootFromParent_Done,
     /* 114202 */   // Label 2178: @114202
     /* 114202 */   GIM_Try, /*On fail goto*//*Label 2179*/ GIMT_Encode4(114257), // Rule ID 4111 //
     /* 114207 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 114210 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 114214 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 114218 */     // (fneg:{ *:[v8f16] } MQPR:{ *:[v8f16] }:$v)  =>  (MVE_VNEGf16:{ *:[v8f16] } ?:{ *:[v8f16] }:$v)
     /* 114218 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 114221 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 114225 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 114230 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VNEGf16),
     /* 114233 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 114235 */     GIR_RootToRootCopy, /*OpIdx*/1, // v
     /* 114237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 114240 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 114246 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 114252 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 114255 */     GIR_RootConstrainSelectedInstOperands,
     /* 114256 */     // GIR_Coverage, 4111,
     /* 114256 */     GIR_EraseRootFromParent_Done,
     /* 114257 */   // Label 2179: @114257
     /* 114257 */   GIM_Reject,
     /* 114258 */ // Label 2177: @114258
     /* 114258 */ GIM_Reject,
     /* 114259 */ // Label 2152: @114259
     /* 114259 */ GIM_Reject,
     /* 114260 */ // Label 40: @114260
     /* 114260 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(9), /*)*//*default:*//*Label 2183*/ GIMT_Encode4(114495),
     /* 114271 */ /*GILLT_s32*//*Label 2180*/ GIMT_Encode4(114303),
     /* 114275 */ /*GILLT_s64*//*Label 2181*/ GIMT_Encode4(114363), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 114299 */ /*GILLT_v4s32*//*Label 2182*/ GIMT_Encode4(114460),
     /* 114303 */ // Label 2180: @114303
     /* 114303 */ GIM_Try, /*On fail goto*//*Label 2184*/ GIMT_Encode4(114362), // Rule ID 2300 //
     /* 114308 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 114311 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 114314 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 114318 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 114322 */   // (fpextend:{ *:[f32] } HPR:{ *:[f16] }:$Sm)  =>  (VCVTBHS:{ *:[f32] } (COPY_TO_REGCLASS:{ *:[f32] } HPR:{ *:[f16] }:$Sm, SPR:{ *:[i32] }))
     /* 114322 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 114325 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 114329 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 114334 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Sm
     /* 114338 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(ARM::SPRRegClassID),
     /* 114343 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTBHS),
     /* 114346 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /* 114348 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 114351 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 114354 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 114360 */   GIR_RootConstrainSelectedInstOperands,
     /* 114361 */   // GIR_Coverage, 2300,
     /* 114361 */   GIR_EraseRootFromParent_Done,
     /* 114362 */ // Label 2184: @114362
     /* 114362 */ GIM_Reject,
     /* 114363 */ // Label 2181: @114363
     /* 114363 */ GIM_Try, /*On fail goto*//*Label 2185*/ GIMT_Encode4(114400), // Rule ID 660 //
     /* 114368 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDPVFP_HasVFP2),
     /* 114371 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 114374 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 114378 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 114382 */   // (fpextend:{ *:[f64] } SPR:{ *:[f32] }:$Sm)  =>  (VCVTDS:{ *:[f64] } SPR:{ *:[f32] }:$Sm)
     /* 114382 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTDS),
     /* 114385 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Dd]
     /* 114387 */   GIR_RootToRootCopy, /*OpIdx*/1, // Sm
     /* 114389 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 114392 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 114398 */   GIR_RootConstrainSelectedInstOperands,
     /* 114399 */   // GIR_Coverage, 660,
     /* 114399 */   GIR_EraseRootFromParent_Done,
     /* 114400 */ // Label 2185: @114400
     /* 114400 */ GIM_Try, /*On fail goto*//*Label 2186*/ GIMT_Encode4(114459), // Rule ID 2310 //
     /* 114405 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDPVFP_HasFPARMv8),
     /* 114408 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 114411 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 114415 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 114419 */   // (fpextend:{ *:[f64] } HPR:{ *:[f16] }:$Sm)  =>  (VCVTBHD:{ *:[f64] } (COPY_TO_REGCLASS:{ *:[f32] } HPR:{ *:[f16] }:$Sm, SPR:{ *:[i32] }))
     /* 114419 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 114422 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 114426 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 114431 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Sm
     /* 114435 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(ARM::SPRRegClassID),
     /* 114440 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTBHD),
     /* 114443 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Dd]
     /* 114445 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 114448 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 114451 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 114457 */   GIR_RootConstrainSelectedInstOperands,
     /* 114458 */   // GIR_Coverage, 2310,
     /* 114458 */   GIR_EraseRootFromParent_Done,
     /* 114459 */ // Label 2186: @114459
     /* 114459 */ GIM_Reject,
     /* 114460 */ // Label 2182: @114460
     /* 114460 */ GIM_Try, /*On fail goto*//*Label 2187*/ GIMT_Encode4(114494), // Rule ID 2667 //
     /* 114465 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 114468 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 114472 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 114476 */   // (fpextend:{ *:[v4f32] } DPR:{ *:[v4f16] }:$src)  =>  (VCVTh2f:{ *:[v4f32] } DPR:{ *:[v4f16] }:$src)
     /* 114476 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTh2f),
     /* 114479 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 114481 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 114483 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 114486 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 114492 */   GIR_RootConstrainSelectedInstOperands,
     /* 114493 */   // GIR_Coverage, 2667,
     /* 114493 */   GIR_EraseRootFromParent_Done,
     /* 114494 */ // Label 2187: @114494
     /* 114494 */ GIM_Reject,
     /* 114495 */ // Label 2183: @114495
     /* 114495 */ GIM_Reject,
     /* 114496 */ // Label 41: @114496
     /* 114496 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(8), /*)*//*default:*//*Label 2191*/ GIMT_Encode4(114767),
     /* 114507 */ /*GILLT_s16*//*Label 2188*/ GIMT_Encode4(114539),
     /* 114511 */ /*GILLT_s32*//*Label 2189*/ GIMT_Encode4(114694), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 114535 */ /*GILLT_v4s16*//*Label 2190*/ GIMT_Encode4(114732),
     /* 114539 */ // Label 2188: @114539
     /* 114539 */ GIM_Try, /*On fail goto*//*Label 2192*/ GIMT_Encode4(114616), // Rule ID 2302 //
     /* 114544 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 114547 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 114550 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 114554 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 114558 */   // (fpround:{ *:[f16] } SPR:{ *:[f32] }:$Sm)  =>  (COPY_TO_REGCLASS:{ *:[f16] } (VCVTBSH:{ *:[f32] } (IMPLICIT_DEF:{ *:[f32] }), SPR:{ *:[f32] }:$Sm), HPR:{ *:[i32] })
     /* 114558 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 114561 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 114565 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 114570 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 114572 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 114575 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::VCVTBSH),
     /* 114579 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 114584 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 114587 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Sm
     /* 114591 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/14,
     /* 114594 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 114600 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 114602 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 114605 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 114607 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 114610 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::HPRRegClassID),
     /* 114615 */   // GIR_Coverage, 2302,
     /* 114615 */   GIR_EraseRootFromParent_Done,
     /* 114616 */ // Label 2192: @114616
     /* 114616 */ GIM_Try, /*On fail goto*//*Label 2193*/ GIMT_Encode4(114693), // Rule ID 2312 //
     /* 114621 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDPVFP_HasFPARMv8),
     /* 114624 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 114627 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 114631 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 114635 */   // (fpround:{ *:[f16] } DPR:{ *:[f64] }:$Dm)  =>  (COPY_TO_REGCLASS:{ *:[f16] } (VCVTBDH:{ *:[f32] } (IMPLICIT_DEF:{ *:[f32] }), DPR:{ *:[f64] }:$Dm), HPR:{ *:[i32] })
     /* 114635 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 114638 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 114642 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 114647 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 114649 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 114652 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::VCVTBDH),
     /* 114656 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 114661 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 114664 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Dm
     /* 114668 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/14,
     /* 114671 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 114677 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 114679 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 114682 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 114684 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 114687 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::HPRRegClassID),
     /* 114692 */   // GIR_Coverage, 2312,
     /* 114692 */   GIR_EraseRootFromParent_Done,
     /* 114693 */ // Label 2193: @114693
     /* 114693 */ GIM_Reject,
     /* 114694 */ // Label 2189: @114694
     /* 114694 */ GIM_Try, /*On fail goto*//*Label 2194*/ GIMT_Encode4(114731), // Rule ID 661 //
     /* 114699 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDPVFP_HasVFP2),
     /* 114702 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 114705 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 114709 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 114713 */   // (fpround:{ *:[f32] } DPR:{ *:[f64] }:$Dm)  =>  (VCVTSD:{ *:[f32] } DPR:{ *:[f64] }:$Dm)
     /* 114713 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTSD),
     /* 114716 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /* 114718 */   GIR_RootToRootCopy, /*OpIdx*/1, // Dm
     /* 114720 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 114723 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 114729 */   GIR_RootConstrainSelectedInstOperands,
     /* 114730 */   // GIR_Coverage, 661,
     /* 114730 */   GIR_EraseRootFromParent_Done,
     /* 114731 */ // Label 2194: @114731
     /* 114731 */ GIM_Reject,
     /* 114732 */ // Label 2190: @114732
     /* 114732 */ GIM_Try, /*On fail goto*//*Label 2195*/ GIMT_Encode4(114766), // Rule ID 2666 //
     /* 114737 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 114740 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 114744 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 114748 */   // (fpround:{ *:[v4f16] } QPR:{ *:[v4f32] }:$src)  =>  (VCVTf2h:{ *:[v4f16] } QPR:{ *:[v4f32] }:$src)
     /* 114748 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTf2h),
     /* 114751 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 114753 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 114755 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 114758 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 114764 */   GIR_RootConstrainSelectedInstOperands,
     /* 114765 */   // GIR_Coverage, 2666,
     /* 114765 */   GIR_EraseRootFromParent_Done,
     /* 114766 */ // Label 2195: @114766
     /* 114766 */ GIM_Reject,
     /* 114767 */ // Label 2191: @114767
     /* 114767 */ GIM_Reject,
     /* 114768 */ // Label 42: @114768
     /* 114768 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(13), /*)*//*default:*//*Label 2203*/ GIMT_Encode4(116101),
     /* 114779 */ /*GILLT_s32*//*Label 2196*/ GIMT_Encode4(114827), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 114791 */ /*GILLT_v2s32*//*Label 2197*/ GIMT_Encode4(115721), GIMT_Encode4(0),
     /* 114799 */ /*GILLT_v4s1*//*Label 2198*/ GIMT_Encode4(115759),
     /* 114803 */ /*GILLT_v4s16*//*Label 2199*/ GIMT_Encode4(115812),
     /* 114807 */ /*GILLT_v4s32*//*Label 2200*/ GIMT_Encode4(115850), GIMT_Encode4(0),
     /* 114815 */ /*GILLT_v8s1*//*Label 2201*/ GIMT_Encode4(115949), GIMT_Encode4(0),
     /* 114823 */ /*GILLT_v8s16*//*Label 2202*/ GIMT_Encode4(116002),
     /* 114827 */ // Label 2196: @114827
     /* 114827 */ GIM_Try, /*On fail goto*//*Label 2204*/ GIMT_Encode4(114893), // Rule ID 2320 //
     /* 114832 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 114835 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 114838 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 114842 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 114846 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCEIL),
     /* 114850 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 114854 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 114859 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 114861 */   // (fp_to_sint:{ *:[i32] } (fceil:{ *:[f16] } HPR:{ *:[f16] }:$a))  =>  (COPY_TO_REGCLASS:{ *:[i32] } (VCVTPSH:{ *:[f32] } HPR:{ *:[f16] }:$a), GPR:{ *:[i32] })
     /* 114861 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 114864 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::VCVTPSH),
     /* 114868 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 114873 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // a
     /* 114877 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 114879 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 114882 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 114884 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 114887 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::GPRRegClassID),
     /* 114892 */   // GIR_Coverage, 2320,
     /* 114892 */   GIR_EraseRootFromParent_Done,
     /* 114893 */ // Label 2204: @114893
     /* 114893 */ GIM_Try, /*On fail goto*//*Label 2205*/ GIMT_Encode4(114959), // Rule ID 2322 //
     /* 114898 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 114901 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 114904 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 114908 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 114912 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCEIL),
     /* 114916 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 114920 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 114925 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 114927 */   // (fp_to_sint:{ *:[i32] } (fceil:{ *:[f32] } SPR:{ *:[f32] }:$a))  =>  (COPY_TO_REGCLASS:{ *:[i32] } (VCVTPSS:{ *:[f32] } SPR:{ *:[f32] }:$a), GPR:{ *:[i32] })
     /* 114927 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 114930 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::VCVTPSS),
     /* 114934 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 114939 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // a
     /* 114943 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 114945 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 114948 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 114950 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 114953 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::GPRRegClassID),
     /* 114958 */   // GIR_Coverage, 2322,
     /* 114958 */   GIR_EraseRootFromParent_Done,
     /* 114959 */ // Label 2205: @114959
     /* 114959 */ GIM_Try, /*On fail goto*//*Label 2206*/ GIMT_Encode4(115025), // Rule ID 2324 //
     /* 114964 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDPVFP_HasFPARMv8),
     /* 114967 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 114970 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 114974 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 114978 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCEIL),
     /* 114982 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 114986 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 114991 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 114993 */   // (fp_to_sint:{ *:[i32] } (fceil:{ *:[f64] } DPR:{ *:[f64] }:$a))  =>  (COPY_TO_REGCLASS:{ *:[i32] } (VCVTPSD:{ *:[f32] } DPR:{ *:[f64] }:$a), GPR:{ *:[i32] })
     /* 114993 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 114996 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::VCVTPSD),
     /* 115000 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 115005 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // a
     /* 115009 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 115011 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 115014 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 115016 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 115019 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::GPRRegClassID),
     /* 115024 */   // GIR_Coverage, 2324,
     /* 115024 */   GIR_EraseRootFromParent_Done,
     /* 115025 */ // Label 2206: @115025
     /* 115025 */ GIM_Try, /*On fail goto*//*Label 2207*/ GIMT_Encode4(115091), // Rule ID 2326 //
     /* 115030 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 115033 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 115036 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 115040 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 115044 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FFLOOR),
     /* 115048 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 115052 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 115057 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 115059 */   // (fp_to_sint:{ *:[i32] } (ffloor:{ *:[f16] } HPR:{ *:[f16] }:$a))  =>  (COPY_TO_REGCLASS:{ *:[i32] } (VCVTMSH:{ *:[f32] } HPR:{ *:[f16] }:$a), GPR:{ *:[i32] })
     /* 115059 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 115062 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::VCVTMSH),
     /* 115066 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 115071 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // a
     /* 115075 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 115077 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 115080 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 115082 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 115085 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::GPRRegClassID),
     /* 115090 */   // GIR_Coverage, 2326,
     /* 115090 */   GIR_EraseRootFromParent_Done,
     /* 115091 */ // Label 2207: @115091
     /* 115091 */ GIM_Try, /*On fail goto*//*Label 2208*/ GIMT_Encode4(115157), // Rule ID 2328 //
     /* 115096 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 115099 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 115102 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 115106 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 115110 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FFLOOR),
     /* 115114 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 115118 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 115123 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 115125 */   // (fp_to_sint:{ *:[i32] } (ffloor:{ *:[f32] } SPR:{ *:[f32] }:$a))  =>  (COPY_TO_REGCLASS:{ *:[i32] } (VCVTMSS:{ *:[f32] } SPR:{ *:[f32] }:$a), GPR:{ *:[i32] })
     /* 115125 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 115128 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::VCVTMSS),
     /* 115132 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 115137 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // a
     /* 115141 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 115143 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 115146 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 115148 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 115151 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::GPRRegClassID),
     /* 115156 */   // GIR_Coverage, 2328,
     /* 115156 */   GIR_EraseRootFromParent_Done,
     /* 115157 */ // Label 2208: @115157
     /* 115157 */ GIM_Try, /*On fail goto*//*Label 2209*/ GIMT_Encode4(115223), // Rule ID 2330 //
     /* 115162 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDPVFP_HasFPARMv8),
     /* 115165 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 115168 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 115172 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 115176 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FFLOOR),
     /* 115180 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 115184 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 115189 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 115191 */   // (fp_to_sint:{ *:[i32] } (ffloor:{ *:[f64] } DPR:{ *:[f64] }:$a))  =>  (COPY_TO_REGCLASS:{ *:[i32] } (VCVTMSD:{ *:[f32] } DPR:{ *:[f64] }:$a), GPR:{ *:[i32] })
     /* 115191 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 115194 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::VCVTMSD),
     /* 115198 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 115203 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // a
     /* 115207 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 115209 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 115212 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 115214 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 115217 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::GPRRegClassID),
     /* 115222 */   // GIR_Coverage, 2330,
     /* 115222 */   GIR_EraseRootFromParent_Done,
     /* 115223 */ // Label 2209: @115223
     /* 115223 */ GIM_Try, /*On fail goto*//*Label 2210*/ GIMT_Encode4(115289), // Rule ID 2314 //
     /* 115228 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 115231 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 115234 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 115238 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 115242 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_ROUND),
     /* 115246 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 115250 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 115255 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 115257 */   // (fp_to_sint:{ *:[i32] } (fround:{ *:[f16] } HPR:{ *:[f16] }:$a))  =>  (COPY_TO_REGCLASS:{ *:[i32] } (VCVTASH:{ *:[f32] } HPR:{ *:[f16] }:$a), GPR:{ *:[i32] })
     /* 115257 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 115260 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::VCVTASH),
     /* 115264 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 115269 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // a
     /* 115273 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 115275 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 115278 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 115280 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 115283 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::GPRRegClassID),
     /* 115288 */   // GIR_Coverage, 2314,
     /* 115288 */   GIR_EraseRootFromParent_Done,
     /* 115289 */ // Label 2210: @115289
     /* 115289 */ GIM_Try, /*On fail goto*//*Label 2211*/ GIMT_Encode4(115355), // Rule ID 2316 //
     /* 115294 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 115297 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 115300 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 115304 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 115308 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_ROUND),
     /* 115312 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 115316 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 115321 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 115323 */   // (fp_to_sint:{ *:[i32] } (fround:{ *:[f32] } SPR:{ *:[f32] }:$a))  =>  (COPY_TO_REGCLASS:{ *:[i32] } (VCVTASS:{ *:[f32] } SPR:{ *:[f32] }:$a), GPR:{ *:[i32] })
     /* 115323 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 115326 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::VCVTASS),
     /* 115330 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 115335 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // a
     /* 115339 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 115341 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 115344 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 115346 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 115349 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::GPRRegClassID),
     /* 115354 */   // GIR_Coverage, 2316,
     /* 115354 */   GIR_EraseRootFromParent_Done,
     /* 115355 */ // Label 2211: @115355
     /* 115355 */ GIM_Try, /*On fail goto*//*Label 2212*/ GIMT_Encode4(115421), // Rule ID 2318 //
     /* 115360 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDPVFP_HasFPARMv8),
     /* 115363 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 115366 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 115370 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 115374 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_ROUND),
     /* 115378 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 115382 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 115387 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 115389 */   // (fp_to_sint:{ *:[i32] } (fround:{ *:[f64] } DPR:{ *:[f64] }:$a))  =>  (COPY_TO_REGCLASS:{ *:[i32] } (VCVTASD:{ *:[f32] } DPR:{ *:[f64] }:$a), GPR:{ *:[i32] })
     /* 115389 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 115392 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::VCVTASD),
     /* 115396 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 115401 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // a
     /* 115405 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 115407 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 115410 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 115412 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 115415 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::GPRRegClassID),
     /* 115420 */   // GIR_Coverage, 2318,
     /* 115420 */   GIR_EraseRootFromParent_Done,
     /* 115421 */ // Label 2212: @115421
     /* 115421 */ GIM_Try, /*On fail goto*//*Label 2213*/ GIMT_Encode4(115481), // Rule ID 2349 //
     /* 115426 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDPVFP_HasVFP2),
     /* 115429 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 115432 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 115436 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 115440 */   // (fp_to_sint:{ *:[i32] } DPR:{ *:[f64] }:$a)  =>  (COPY_TO_REGCLASS:{ *:[i32] } (VTOSIZD:{ *:[f32] } DPR:{ *:[f64] }:$a), GPR:{ *:[i32] })
     /* 115440 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 115443 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::VTOSIZD),
     /* 115447 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 115452 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // a
     /* 115456 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/14,
     /* 115459 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 115465 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 115467 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 115470 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 115472 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 115475 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::GPRRegClassID),
     /* 115480 */   // GIR_Coverage, 2349,
     /* 115480 */   GIR_EraseRootFromParent_Done,
     /* 115481 */ // Label 2213: @115481
     /* 115481 */ GIM_Try, /*On fail goto*//*Label 2214*/ GIMT_Encode4(115541), // Rule ID 2353 //
     /* 115486 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_DontUseNEONForFP_HasVFP2),
     /* 115489 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 115492 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 115496 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 115500 */   // (fp_to_sint:{ *:[i32] } SPR:{ *:[f32] }:$a)  =>  (COPY_TO_REGCLASS:{ *:[i32] } (VTOSIZS:{ *:[f32] } SPR:{ *:[f32] }:$a), GPR:{ *:[i32] })
     /* 115500 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 115503 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::VTOSIZS),
     /* 115507 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 115512 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // a
     /* 115516 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/14,
     /* 115519 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 115525 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 115527 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 115530 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 115532 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 115535 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::GPRRegClassID),
     /* 115540 */   // GIR_Coverage, 2353,
     /* 115540 */   GIR_EraseRootFromParent_Done,
     /* 115541 */ // Label 2214: @115541
     /* 115541 */ GIM_Try, /*On fail goto*//*Label 2215*/ GIMT_Encode4(115601), // Rule ID 2357 //
     /* 115546 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_DontUseNEONForFP_HasVFP2),
     /* 115549 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 115552 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 115556 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 115560 */   // (fp_to_sint:{ *:[i32] } HPR:{ *:[f16] }:$a)  =>  (COPY_TO_REGCLASS:{ *:[i32] } (VTOSIZH:{ *:[f32] } HPR:{ *:[f16] }:$a), GPR:{ *:[i32] })
     /* 115560 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 115563 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::VTOSIZH),
     /* 115567 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 115572 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // a
     /* 115576 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/14,
     /* 115579 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 115585 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 115587 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 115590 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 115592 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 115595 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::GPRRegClassID),
     /* 115600 */   // GIR_Coverage, 2357,
     /* 115600 */   GIR_EraseRootFromParent_Done,
     /* 115601 */ // Label 2215: @115601
     /* 115601 */ GIM_Try, /*On fail goto*//*Label 2216*/ GIMT_Encode4(115720), // Rule ID 2707 //
     /* 115606 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_UseNEONForFP),
     /* 115609 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 115612 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 115616 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 115620 */   // (fp_to_sint:{ *:[i32] } SPR:{ *:[f32] }:$a)  =>  (EXTRACT_SUBREG:{ *:[i32] } (VCVTf2sd:{ *:[v2f32] } (INSERT_SUBREG:{ *:[v2f32] } (IMPLICIT_DEF:{ *:[v2f32] }), SPR:{ *:[f32] }:$a, ssub_0:{ *:[i32] })), ssub_0:{ *:[i32] })
     /* 115620 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s32,
     /* 115623 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 115627 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 115632 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 115634 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v2s32,
     /* 115637 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 115641 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 115646 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 115649 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // a
     /* 115653 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/17,
     /* 115656 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 115661 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 115666 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(ARM::SPRRegClassID),
     /* 115671 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s32,
     /* 115674 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::VCVTf2sd),
     /* 115678 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 115683 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 115686 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/14,
     /* 115689 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 115695 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 115697 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 115700 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 115702 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(ARM::ssub_0),
     /* 115709 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::SPRRegClassID),
     /* 115714 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 115719 */   // GIR_Coverage, 2707,
     /* 115719 */   GIR_EraseRootFromParent_Done,
     /* 115720 */ // Label 2216: @115720
     /* 115720 */ GIM_Reject,
     /* 115721 */ // Label 2197: @115721
     /* 115721 */ GIM_Try, /*On fail goto*//*Label 2217*/ GIMT_Encode4(115758), // Rule ID 1601 //
     /* 115726 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 115729 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 115732 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 115736 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 115740 */   // (fp_to_sint:{ *:[v2i32] } DPR:{ *:[v2f32] }:$Vm)  =>  (VCVTf2sd:{ *:[v2i32] } DPR:{ *:[v2f32] }:$Vm)
     /* 115740 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTf2sd),
     /* 115743 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 115745 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /* 115747 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 115750 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 115756 */   GIR_RootConstrainSelectedInstOperands,
     /* 115757 */   // GIR_Coverage, 1601,
     /* 115757 */   GIR_EraseRootFromParent_Done,
     /* 115758 */ // Label 2217: @115758
     /* 115758 */ GIM_Reject,
     /* 115759 */ // Label 2198: @115759
     /* 115759 */ GIM_Try, /*On fail goto*//*Label 2218*/ GIMT_Encode4(115811), // Rule ID 5102 //
     /* 115764 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /* 115767 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 115770 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::VCCRRegClassID),
     /* 115774 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 115778 */   // (fp_to_sint:{ *:[v4i1] } MQPR:{ *:[v4f32] }:$v1)  =>  (MVE_VCMPf32r:{ *:[v4i1] } MQPR:{ *:[v4f32] }:$v1, ZR:{ *:[i32] }, 1:{ *:[i32] })
     /* 115778 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCMPf32r),
     /* 115781 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[P0]
     /* 115783 */   GIR_RootToRootCopy, /*OpIdx*/1, // v1
     /* 115785 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::ZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 115791 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 115794 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 115797 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 115803 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 115809 */   GIR_RootConstrainSelectedInstOperands,
     /* 115810 */   // GIR_Coverage, 5102,
     /* 115810 */   GIR_EraseRootFromParent_Done,
     /* 115811 */ // Label 2218: @115811
     /* 115811 */ GIM_Reject,
     /* 115812 */ // Label 2199: @115812
     /* 115812 */ GIM_Try, /*On fail goto*//*Label 2219*/ GIMT_Encode4(115849), // Rule ID 1609 //
     /* 115817 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 115820 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 115823 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 115827 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 115831 */   // (fp_to_sint:{ *:[v4i16] } DPR:{ *:[v4f16] }:$Vm)  =>  (VCVTh2sd:{ *:[v4i16] } DPR:{ *:[v4f16] }:$Vm)
     /* 115831 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTh2sd),
     /* 115834 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 115836 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /* 115838 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 115841 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 115847 */   GIR_RootConstrainSelectedInstOperands,
     /* 115848 */   // GIR_Coverage, 1609,
     /* 115848 */   GIR_EraseRootFromParent_Done,
     /* 115849 */ // Label 2219: @115849
     /* 115849 */ GIM_Reject,
     /* 115850 */ // Label 2200: @115850
     /* 115850 */ GIM_Try, /*On fail goto*//*Label 2220*/ GIMT_Encode4(115948),
     /* 115855 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 115858 */   GIM_Try, /*On fail goto*//*Label 2221*/ GIMT_Encode4(115892), // Rule ID 1605 //
     /* 115863 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 115866 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 115870 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 115874 */     // (fp_to_sint:{ *:[v4i32] } QPR:{ *:[v4f32] }:$Vm)  =>  (VCVTf2sq:{ *:[v4i32] } QPR:{ *:[v4f32] }:$Vm)
     /* 115874 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTf2sq),
     /* 115877 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 115879 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /* 115881 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 115884 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 115890 */     GIR_RootConstrainSelectedInstOperands,
     /* 115891 */     // GIR_Coverage, 1605,
     /* 115891 */     GIR_EraseRootFromParent_Done,
     /* 115892 */   // Label 2221: @115892
     /* 115892 */   GIM_Try, /*On fail goto*//*Label 2222*/ GIMT_Encode4(115947), // Rule ID 4091 //
     /* 115897 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /* 115900 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 115904 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 115908 */     // (fp_to_sint:{ *:[v4i32] } MQPR:{ *:[v4f32] }:$src)  =>  (MVE_VCVTs32f32z:{ *:[v4i32] } MQPR:{ *:[v4f32] }:$src)
     /* 115908 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 115911 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 115915 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 115920 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCVTs32f32z),
     /* 115923 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 115925 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 115927 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 115930 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 115936 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 115942 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 115945 */     GIR_RootConstrainSelectedInstOperands,
     /* 115946 */     // GIR_Coverage, 4091,
     /* 115946 */     GIR_EraseRootFromParent_Done,
     /* 115947 */   // Label 2222: @115947
     /* 115947 */   GIM_Reject,
     /* 115948 */ // Label 2220: @115948
     /* 115948 */ GIM_Reject,
     /* 115949 */ // Label 2201: @115949
     /* 115949 */ GIM_Try, /*On fail goto*//*Label 2223*/ GIMT_Encode4(116001), // Rule ID 5103 //
     /* 115954 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /* 115957 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 115960 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::VCCRRegClassID),
     /* 115964 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 115968 */   // (fp_to_sint:{ *:[v8i1] } MQPR:{ *:[v8f16] }:$v1)  =>  (MVE_VCMPf16r:{ *:[v8i1] } MQPR:{ *:[v8f16] }:$v1, ZR:{ *:[i32] }, 1:{ *:[i32] })
     /* 115968 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCMPf16r),
     /* 115971 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[P0]
     /* 115973 */   GIR_RootToRootCopy, /*OpIdx*/1, // v1
     /* 115975 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::ZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 115981 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 115984 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 115987 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 115993 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 115999 */   GIR_RootConstrainSelectedInstOperands,
     /* 116000 */   // GIR_Coverage, 5103,
     /* 116000 */   GIR_EraseRootFromParent_Done,
     /* 116001 */ // Label 2223: @116001
     /* 116001 */ GIM_Reject,
     /* 116002 */ // Label 2202: @116002
     /* 116002 */ GIM_Try, /*On fail goto*//*Label 2224*/ GIMT_Encode4(116100),
     /* 116007 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 116010 */   GIM_Try, /*On fail goto*//*Label 2225*/ GIMT_Encode4(116044), // Rule ID 1613 //
     /* 116015 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 116018 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 116022 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 116026 */     // (fp_to_sint:{ *:[v8i16] } QPR:{ *:[v8f16] }:$Vm)  =>  (VCVTh2sq:{ *:[v8i16] } QPR:{ *:[v8f16] }:$Vm)
     /* 116026 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTh2sq),
     /* 116029 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 116031 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /* 116033 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 116036 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 116042 */     GIR_RootConstrainSelectedInstOperands,
     /* 116043 */     // GIR_Coverage, 1613,
     /* 116043 */     GIR_EraseRootFromParent_Done,
     /* 116044 */   // Label 2225: @116044
     /* 116044 */   GIM_Try, /*On fail goto*//*Label 2226*/ GIMT_Encode4(116099), // Rule ID 4087 //
     /* 116049 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /* 116052 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 116056 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 116060 */     // (fp_to_sint:{ *:[v8i16] } MQPR:{ *:[v8f16] }:$src)  =>  (MVE_VCVTs16f16z:{ *:[v8i16] } MQPR:{ *:[v8f16] }:$src)
     /* 116060 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 116063 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 116067 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 116072 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCVTs16f16z),
     /* 116075 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 116077 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 116079 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 116082 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 116088 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 116094 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 116097 */     GIR_RootConstrainSelectedInstOperands,
     /* 116098 */     // GIR_Coverage, 4087,
     /* 116098 */     GIR_EraseRootFromParent_Done,
     /* 116099 */   // Label 2226: @116099
     /* 116099 */   GIM_Reject,
     /* 116100 */ // Label 2224: @116100
     /* 116100 */ GIM_Reject,
     /* 116101 */ // Label 2203: @116101
     /* 116101 */ GIM_Reject,
     /* 116102 */ // Label 43: @116102
     /* 116102 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(13), /*)*//*default:*//*Label 2234*/ GIMT_Encode4(117435),
     /* 116113 */ /*GILLT_s32*//*Label 2227*/ GIMT_Encode4(116161), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 116125 */ /*GILLT_v2s32*//*Label 2228*/ GIMT_Encode4(117055), GIMT_Encode4(0),
     /* 116133 */ /*GILLT_v4s1*//*Label 2229*/ GIMT_Encode4(117093),
     /* 116137 */ /*GILLT_v4s16*//*Label 2230*/ GIMT_Encode4(117146),
     /* 116141 */ /*GILLT_v4s32*//*Label 2231*/ GIMT_Encode4(117184), GIMT_Encode4(0),
     /* 116149 */ /*GILLT_v8s1*//*Label 2232*/ GIMT_Encode4(117283), GIMT_Encode4(0),
     /* 116157 */ /*GILLT_v8s16*//*Label 2233*/ GIMT_Encode4(117336),
     /* 116161 */ // Label 2227: @116161
     /* 116161 */ GIM_Try, /*On fail goto*//*Label 2235*/ GIMT_Encode4(116227), // Rule ID 2321 //
     /* 116166 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 116169 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 116172 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 116176 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 116180 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCEIL),
     /* 116184 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 116188 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 116193 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 116195 */   // (fp_to_uint:{ *:[i32] } (fceil:{ *:[f16] } HPR:{ *:[f16] }:$a))  =>  (COPY_TO_REGCLASS:{ *:[i32] } (VCVTPUH:{ *:[f32] } HPR:{ *:[f16] }:$a), GPR:{ *:[i32] })
     /* 116195 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 116198 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::VCVTPUH),
     /* 116202 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 116207 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // a
     /* 116211 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 116213 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 116216 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 116218 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 116221 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::GPRRegClassID),
     /* 116226 */   // GIR_Coverage, 2321,
     /* 116226 */   GIR_EraseRootFromParent_Done,
     /* 116227 */ // Label 2235: @116227
     /* 116227 */ GIM_Try, /*On fail goto*//*Label 2236*/ GIMT_Encode4(116293), // Rule ID 2323 //
     /* 116232 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 116235 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 116238 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 116242 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 116246 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCEIL),
     /* 116250 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 116254 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 116259 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 116261 */   // (fp_to_uint:{ *:[i32] } (fceil:{ *:[f32] } SPR:{ *:[f32] }:$a))  =>  (COPY_TO_REGCLASS:{ *:[i32] } (VCVTPUS:{ *:[f32] } SPR:{ *:[f32] }:$a), GPR:{ *:[i32] })
     /* 116261 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 116264 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::VCVTPUS),
     /* 116268 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 116273 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // a
     /* 116277 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 116279 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 116282 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 116284 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 116287 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::GPRRegClassID),
     /* 116292 */   // GIR_Coverage, 2323,
     /* 116292 */   GIR_EraseRootFromParent_Done,
     /* 116293 */ // Label 2236: @116293
     /* 116293 */ GIM_Try, /*On fail goto*//*Label 2237*/ GIMT_Encode4(116359), // Rule ID 2325 //
     /* 116298 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDPVFP_HasFPARMv8),
     /* 116301 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 116304 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 116308 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 116312 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCEIL),
     /* 116316 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 116320 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 116325 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 116327 */   // (fp_to_uint:{ *:[i32] } (fceil:{ *:[f64] } DPR:{ *:[f64] }:$a))  =>  (COPY_TO_REGCLASS:{ *:[i32] } (VCVTPUD:{ *:[f32] } DPR:{ *:[f64] }:$a), GPR:{ *:[i32] })
     /* 116327 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 116330 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::VCVTPUD),
     /* 116334 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 116339 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // a
     /* 116343 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 116345 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 116348 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 116350 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 116353 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::GPRRegClassID),
     /* 116358 */   // GIR_Coverage, 2325,
     /* 116358 */   GIR_EraseRootFromParent_Done,
     /* 116359 */ // Label 2237: @116359
     /* 116359 */ GIM_Try, /*On fail goto*//*Label 2238*/ GIMT_Encode4(116425), // Rule ID 2327 //
     /* 116364 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 116367 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 116370 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 116374 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 116378 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FFLOOR),
     /* 116382 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 116386 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 116391 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 116393 */   // (fp_to_uint:{ *:[i32] } (ffloor:{ *:[f16] } HPR:{ *:[f16] }:$a))  =>  (COPY_TO_REGCLASS:{ *:[i32] } (VCVTMUH:{ *:[f32] } HPR:{ *:[f16] }:$a), GPR:{ *:[i32] })
     /* 116393 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 116396 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::VCVTMUH),
     /* 116400 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 116405 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // a
     /* 116409 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 116411 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 116414 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 116416 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 116419 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::GPRRegClassID),
     /* 116424 */   // GIR_Coverage, 2327,
     /* 116424 */   GIR_EraseRootFromParent_Done,
     /* 116425 */ // Label 2238: @116425
     /* 116425 */ GIM_Try, /*On fail goto*//*Label 2239*/ GIMT_Encode4(116491), // Rule ID 2329 //
     /* 116430 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 116433 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 116436 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 116440 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 116444 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FFLOOR),
     /* 116448 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 116452 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 116457 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 116459 */   // (fp_to_uint:{ *:[i32] } (ffloor:{ *:[f32] } SPR:{ *:[f32] }:$a))  =>  (COPY_TO_REGCLASS:{ *:[i32] } (VCVTMUS:{ *:[f32] } SPR:{ *:[f32] }:$a), GPR:{ *:[i32] })
     /* 116459 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 116462 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::VCVTMUS),
     /* 116466 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 116471 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // a
     /* 116475 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 116477 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 116480 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 116482 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 116485 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::GPRRegClassID),
     /* 116490 */   // GIR_Coverage, 2329,
     /* 116490 */   GIR_EraseRootFromParent_Done,
     /* 116491 */ // Label 2239: @116491
     /* 116491 */ GIM_Try, /*On fail goto*//*Label 2240*/ GIMT_Encode4(116557), // Rule ID 2331 //
     /* 116496 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDPVFP_HasFPARMv8),
     /* 116499 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 116502 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 116506 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 116510 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FFLOOR),
     /* 116514 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 116518 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 116523 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 116525 */   // (fp_to_uint:{ *:[i32] } (ffloor:{ *:[f64] } DPR:{ *:[f64] }:$a))  =>  (COPY_TO_REGCLASS:{ *:[i32] } (VCVTMUD:{ *:[f32] } DPR:{ *:[f64] }:$a), GPR:{ *:[i32] })
     /* 116525 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 116528 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::VCVTMUD),
     /* 116532 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 116537 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // a
     /* 116541 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 116543 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 116546 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 116548 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 116551 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::GPRRegClassID),
     /* 116556 */   // GIR_Coverage, 2331,
     /* 116556 */   GIR_EraseRootFromParent_Done,
     /* 116557 */ // Label 2240: @116557
     /* 116557 */ GIM_Try, /*On fail goto*//*Label 2241*/ GIMT_Encode4(116623), // Rule ID 2315 //
     /* 116562 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 116565 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 116568 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 116572 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 116576 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_ROUND),
     /* 116580 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 116584 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 116589 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 116591 */   // (fp_to_uint:{ *:[i32] } (fround:{ *:[f16] } HPR:{ *:[f16] }:$a))  =>  (COPY_TO_REGCLASS:{ *:[i32] } (VCVTAUH:{ *:[f32] } HPR:{ *:[f16] }:$a), GPR:{ *:[i32] })
     /* 116591 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 116594 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::VCVTAUH),
     /* 116598 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 116603 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // a
     /* 116607 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 116609 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 116612 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 116614 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 116617 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::GPRRegClassID),
     /* 116622 */   // GIR_Coverage, 2315,
     /* 116622 */   GIR_EraseRootFromParent_Done,
     /* 116623 */ // Label 2241: @116623
     /* 116623 */ GIM_Try, /*On fail goto*//*Label 2242*/ GIMT_Encode4(116689), // Rule ID 2317 //
     /* 116628 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 116631 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 116634 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 116638 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 116642 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_ROUND),
     /* 116646 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 116650 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 116655 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 116657 */   // (fp_to_uint:{ *:[i32] } (fround:{ *:[f32] } SPR:{ *:[f32] }:$a))  =>  (COPY_TO_REGCLASS:{ *:[i32] } (VCVTAUS:{ *:[f32] } SPR:{ *:[f32] }:$a), GPR:{ *:[i32] })
     /* 116657 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 116660 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::VCVTAUS),
     /* 116664 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 116669 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // a
     /* 116673 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 116675 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 116678 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 116680 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 116683 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::GPRRegClassID),
     /* 116688 */   // GIR_Coverage, 2317,
     /* 116688 */   GIR_EraseRootFromParent_Done,
     /* 116689 */ // Label 2242: @116689
     /* 116689 */ GIM_Try, /*On fail goto*//*Label 2243*/ GIMT_Encode4(116755), // Rule ID 2319 //
     /* 116694 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDPVFP_HasFPARMv8),
     /* 116697 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 116700 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 116704 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 116708 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_ROUND),
     /* 116712 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 116716 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 116721 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 116723 */   // (fp_to_uint:{ *:[i32] } (fround:{ *:[f64] } DPR:{ *:[f64] }:$a))  =>  (COPY_TO_REGCLASS:{ *:[i32] } (VCVTAUD:{ *:[f32] } DPR:{ *:[f64] }:$a), GPR:{ *:[i32] })
     /* 116723 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 116726 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::VCVTAUD),
     /* 116730 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 116735 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // a
     /* 116739 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 116741 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 116744 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 116746 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 116749 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::GPRRegClassID),
     /* 116754 */   // GIR_Coverage, 2319,
     /* 116754 */   GIR_EraseRootFromParent_Done,
     /* 116755 */ // Label 2243: @116755
     /* 116755 */ GIM_Try, /*On fail goto*//*Label 2244*/ GIMT_Encode4(116815), // Rule ID 2359 //
     /* 116760 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDPVFP_HasVFP2),
     /* 116763 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 116766 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 116770 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 116774 */   // (fp_to_uint:{ *:[i32] } DPR:{ *:[f64] }:$a)  =>  (COPY_TO_REGCLASS:{ *:[i32] } (VTOUIZD:{ *:[f32] } DPR:{ *:[f64] }:$a), GPR:{ *:[i32] })
     /* 116774 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 116777 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::VTOUIZD),
     /* 116781 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 116786 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // a
     /* 116790 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/14,
     /* 116793 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 116799 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 116801 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 116804 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 116806 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 116809 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::GPRRegClassID),
     /* 116814 */   // GIR_Coverage, 2359,
     /* 116814 */   GIR_EraseRootFromParent_Done,
     /* 116815 */ // Label 2244: @116815
     /* 116815 */ GIM_Try, /*On fail goto*//*Label 2245*/ GIMT_Encode4(116875), // Rule ID 2363 //
     /* 116820 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_DontUseNEONForFP_HasVFP2),
     /* 116823 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 116826 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 116830 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 116834 */   // (fp_to_uint:{ *:[i32] } SPR:{ *:[f32] }:$a)  =>  (COPY_TO_REGCLASS:{ *:[i32] } (VTOUIZS:{ *:[f32] } SPR:{ *:[f32] }:$a), GPR:{ *:[i32] })
     /* 116834 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 116837 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::VTOUIZS),
     /* 116841 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 116846 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // a
     /* 116850 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/14,
     /* 116853 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 116859 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 116861 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 116864 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 116866 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 116869 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::GPRRegClassID),
     /* 116874 */   // GIR_Coverage, 2363,
     /* 116874 */   GIR_EraseRootFromParent_Done,
     /* 116875 */ // Label 2245: @116875
     /* 116875 */ GIM_Try, /*On fail goto*//*Label 2246*/ GIMT_Encode4(116935), // Rule ID 2367 //
     /* 116880 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_DontUseNEONForFP_HasVFP2),
     /* 116883 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 116886 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 116890 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 116894 */   // (fp_to_uint:{ *:[i32] } HPR:{ *:[f16] }:$a)  =>  (COPY_TO_REGCLASS:{ *:[i32] } (VTOUIZH:{ *:[f32] } HPR:{ *:[f16] }:$a), GPR:{ *:[i32] })
     /* 116894 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 116897 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::VTOUIZH),
     /* 116901 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 116906 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // a
     /* 116910 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/14,
     /* 116913 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 116919 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 116921 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 116924 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 116926 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 116929 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::GPRRegClassID),
     /* 116934 */   // GIR_Coverage, 2367,
     /* 116934 */   GIR_EraseRootFromParent_Done,
     /* 116935 */ // Label 2246: @116935
     /* 116935 */ GIM_Try, /*On fail goto*//*Label 2247*/ GIMT_Encode4(117054), // Rule ID 2708 //
     /* 116940 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_UseNEONForFP),
     /* 116943 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 116946 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 116950 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 116954 */   // (fp_to_uint:{ *:[i32] } SPR:{ *:[f32] }:$a)  =>  (EXTRACT_SUBREG:{ *:[i32] } (VCVTf2ud:{ *:[v2f32] } (INSERT_SUBREG:{ *:[v2f32] } (IMPLICIT_DEF:{ *:[v2f32] }), SPR:{ *:[f32] }:$a, ssub_0:{ *:[i32] })), ssub_0:{ *:[i32] })
     /* 116954 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s32,
     /* 116957 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 116961 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 116966 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 116968 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v2s32,
     /* 116971 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 116975 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 116980 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 116983 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // a
     /* 116987 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/17,
     /* 116990 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 116995 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 117000 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(ARM::SPRRegClassID),
     /* 117005 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s32,
     /* 117008 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::VCVTf2ud),
     /* 117012 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 117017 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 117020 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/14,
     /* 117023 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 117029 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 117031 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 117034 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 117036 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(ARM::ssub_0),
     /* 117043 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::SPRRegClassID),
     /* 117048 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 117053 */   // GIR_Coverage, 2708,
     /* 117053 */   GIR_EraseRootFromParent_Done,
     /* 117054 */ // Label 2247: @117054
     /* 117054 */ GIM_Reject,
     /* 117055 */ // Label 2228: @117055
     /* 117055 */ GIM_Try, /*On fail goto*//*Label 2248*/ GIMT_Encode4(117092), // Rule ID 1602 //
     /* 117060 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 117063 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 117066 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 117070 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 117074 */   // (fp_to_uint:{ *:[v2i32] } DPR:{ *:[v2f32] }:$Vm)  =>  (VCVTf2ud:{ *:[v2i32] } DPR:{ *:[v2f32] }:$Vm)
     /* 117074 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTf2ud),
     /* 117077 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 117079 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /* 117081 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 117084 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 117090 */   GIR_RootConstrainSelectedInstOperands,
     /* 117091 */   // GIR_Coverage, 1602,
     /* 117091 */   GIR_EraseRootFromParent_Done,
     /* 117092 */ // Label 2248: @117092
     /* 117092 */ GIM_Reject,
     /* 117093 */ // Label 2229: @117093
     /* 117093 */ GIM_Try, /*On fail goto*//*Label 2249*/ GIMT_Encode4(117145), // Rule ID 5100 //
     /* 117098 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /* 117101 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 117104 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::VCCRRegClassID),
     /* 117108 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 117112 */   // (fp_to_uint:{ *:[v4i1] } MQPR:{ *:[v4f32] }:$v1)  =>  (MVE_VCMPf32r:{ *:[v4i1] } MQPR:{ *:[v4f32] }:$v1, ZR:{ *:[i32] }, 1:{ *:[i32] })
     /* 117112 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCMPf32r),
     /* 117115 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[P0]
     /* 117117 */   GIR_RootToRootCopy, /*OpIdx*/1, // v1
     /* 117119 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::ZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 117125 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 117128 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 117131 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 117137 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 117143 */   GIR_RootConstrainSelectedInstOperands,
     /* 117144 */   // GIR_Coverage, 5100,
     /* 117144 */   GIR_EraseRootFromParent_Done,
     /* 117145 */ // Label 2249: @117145
     /* 117145 */ GIM_Reject,
     /* 117146 */ // Label 2230: @117146
     /* 117146 */ GIM_Try, /*On fail goto*//*Label 2250*/ GIMT_Encode4(117183), // Rule ID 1610 //
     /* 117151 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 117154 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 117157 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 117161 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 117165 */   // (fp_to_uint:{ *:[v4i16] } DPR:{ *:[v4f16] }:$Vm)  =>  (VCVTh2ud:{ *:[v4i16] } DPR:{ *:[v4f16] }:$Vm)
     /* 117165 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTh2ud),
     /* 117168 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 117170 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /* 117172 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 117175 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 117181 */   GIR_RootConstrainSelectedInstOperands,
     /* 117182 */   // GIR_Coverage, 1610,
     /* 117182 */   GIR_EraseRootFromParent_Done,
     /* 117183 */ // Label 2250: @117183
     /* 117183 */ GIM_Reject,
     /* 117184 */ // Label 2231: @117184
     /* 117184 */ GIM_Try, /*On fail goto*//*Label 2251*/ GIMT_Encode4(117282),
     /* 117189 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 117192 */   GIM_Try, /*On fail goto*//*Label 2252*/ GIMT_Encode4(117226), // Rule ID 1606 //
     /* 117197 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 117200 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 117204 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 117208 */     // (fp_to_uint:{ *:[v4i32] } QPR:{ *:[v4f32] }:$Vm)  =>  (VCVTf2uq:{ *:[v4i32] } QPR:{ *:[v4f32] }:$Vm)
     /* 117208 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTf2uq),
     /* 117211 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 117213 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /* 117215 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 117218 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 117224 */     GIR_RootConstrainSelectedInstOperands,
     /* 117225 */     // GIR_Coverage, 1606,
     /* 117225 */     GIR_EraseRootFromParent_Done,
     /* 117226 */   // Label 2252: @117226
     /* 117226 */   GIM_Try, /*On fail goto*//*Label 2253*/ GIMT_Encode4(117281), // Rule ID 4093 //
     /* 117231 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /* 117234 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 117238 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 117242 */     // (fp_to_uint:{ *:[v4i32] } MQPR:{ *:[v4f32] }:$src)  =>  (MVE_VCVTu32f32z:{ *:[v4i32] } MQPR:{ *:[v4f32] }:$src)
     /* 117242 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 117245 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 117249 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 117254 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCVTu32f32z),
     /* 117257 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 117259 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 117261 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 117264 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 117270 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 117276 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 117279 */     GIR_RootConstrainSelectedInstOperands,
     /* 117280 */     // GIR_Coverage, 4093,
     /* 117280 */     GIR_EraseRootFromParent_Done,
     /* 117281 */   // Label 2253: @117281
     /* 117281 */   GIM_Reject,
     /* 117282 */ // Label 2251: @117282
     /* 117282 */ GIM_Reject,
     /* 117283 */ // Label 2232: @117283
     /* 117283 */ GIM_Try, /*On fail goto*//*Label 2254*/ GIMT_Encode4(117335), // Rule ID 5101 //
     /* 117288 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /* 117291 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 117294 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::VCCRRegClassID),
     /* 117298 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 117302 */   // (fp_to_uint:{ *:[v8i1] } MQPR:{ *:[v8f16] }:$v1)  =>  (MVE_VCMPf16r:{ *:[v8i1] } MQPR:{ *:[v8f16] }:$v1, ZR:{ *:[i32] }, 1:{ *:[i32] })
     /* 117302 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCMPf16r),
     /* 117305 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[P0]
     /* 117307 */   GIR_RootToRootCopy, /*OpIdx*/1, // v1
     /* 117309 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::ZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 117315 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 117318 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 117321 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 117327 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 117333 */   GIR_RootConstrainSelectedInstOperands,
     /* 117334 */   // GIR_Coverage, 5101,
     /* 117334 */   GIR_EraseRootFromParent_Done,
     /* 117335 */ // Label 2254: @117335
     /* 117335 */ GIM_Reject,
     /* 117336 */ // Label 2233: @117336
     /* 117336 */ GIM_Try, /*On fail goto*//*Label 2255*/ GIMT_Encode4(117434),
     /* 117341 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 117344 */   GIM_Try, /*On fail goto*//*Label 2256*/ GIMT_Encode4(117378), // Rule ID 1614 //
     /* 117349 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 117352 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 117356 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 117360 */     // (fp_to_uint:{ *:[v8i16] } QPR:{ *:[v8f16] }:$Vm)  =>  (VCVTh2uq:{ *:[v8i16] } QPR:{ *:[v8f16] }:$Vm)
     /* 117360 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTh2uq),
     /* 117363 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 117365 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /* 117367 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 117370 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 117376 */     GIR_RootConstrainSelectedInstOperands,
     /* 117377 */     // GIR_Coverage, 1614,
     /* 117377 */     GIR_EraseRootFromParent_Done,
     /* 117378 */   // Label 2256: @117378
     /* 117378 */   GIM_Try, /*On fail goto*//*Label 2257*/ GIMT_Encode4(117433), // Rule ID 4089 //
     /* 117383 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /* 117386 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 117390 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 117394 */     // (fp_to_uint:{ *:[v8i16] } MQPR:{ *:[v8f16] }:$src)  =>  (MVE_VCVTu16f16z:{ *:[v8i16] } MQPR:{ *:[v8f16] }:$src)
     /* 117394 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 117397 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 117401 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 117406 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCVTu16f16z),
     /* 117409 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 117411 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 117413 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 117416 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 117422 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 117428 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 117431 */     GIR_RootConstrainSelectedInstOperands,
     /* 117432 */     // GIR_Coverage, 4089,
     /* 117432 */     GIR_EraseRootFromParent_Done,
     /* 117433 */   // Label 2257: @117433
     /* 117433 */   GIM_Reject,
     /* 117434 */ // Label 2255: @117434
     /* 117434 */ GIM_Reject,
     /* 117435 */ // Label 2234: @117435
     /* 117435 */ GIM_Reject,
     /* 117436 */ // Label 44: @117436
     /* 117436 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(13), /*)*//*default:*//*Label 2265*/ GIMT_Encode4(118087),
     /* 117447 */ /*GILLT_s16*//*Label 2258*/ GIMT_Encode4(117499),
     /* 117451 */ /*GILLT_s32*//*Label 2259*/ GIMT_Encode4(117559),
     /* 117455 */ /*GILLT_s64*//*Label 2260*/ GIMT_Encode4(117753), GIMT_Encode4(0),
     /* 117463 */ /*GILLT_v2s32*//*Label 2261*/ GIMT_Encode4(117813), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 117475 */ /*GILLT_v4s16*//*Label 2262*/ GIMT_Encode4(117851),
     /* 117479 */ /*GILLT_v4s32*//*Label 2263*/ GIMT_Encode4(117889), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 117495 */ /*GILLT_v8s16*//*Label 2264*/ GIMT_Encode4(117988),
     /* 117499 */ // Label 2258: @117499
     /* 117499 */ GIM_Try, /*On fail goto*//*Label 2266*/ GIMT_Encode4(117558), // Rule ID 2343 //
     /* 117504 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_DontUseNEONForFP_HasVFP2),
     /* 117507 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 117510 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 117514 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 117518 */   // (sint_to_fp:{ *:[f16] } GPR:{ *:[i32] }:$a)  =>  (VSITOH:{ *:[f16] } (COPY_TO_REGCLASS:{ *:[f32] } GPR:{ *:[i32] }:$a, SPR:{ *:[i32] }))
     /* 117518 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 117521 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 117525 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 117530 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // a
     /* 117534 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(ARM::SPRRegClassID),
     /* 117539 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSITOH),
     /* 117542 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /* 117544 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 117547 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 117550 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 117556 */   GIR_RootConstrainSelectedInstOperands,
     /* 117557 */   // GIR_Coverage, 2343,
     /* 117557 */   GIR_EraseRootFromParent_Done,
     /* 117558 */ // Label 2266: @117558
     /* 117558 */ GIM_Reject,
     /* 117559 */ // Label 2259: @117559
     /* 117559 */ GIM_Try, /*On fail goto*//*Label 2267*/ GIMT_Encode4(117752),
     /* 117564 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 117567 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 117571 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 117575 */   GIM_Try, /*On fail goto*//*Label 2268*/ GIMT_Encode4(117623), // Rule ID 2341 //
     /* 117580 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_DontUseNEONForFP_HasVFP2),
     /* 117583 */     // (sint_to_fp:{ *:[f32] } GPR:{ *:[i32] }:$a)  =>  (VSITOS:{ *:[f32] } (COPY_TO_REGCLASS:{ *:[f32] } GPR:{ *:[i32] }:$a, SPR:{ *:[i32] }))
     /* 117583 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 117586 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 117590 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 117595 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // a
     /* 117599 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(ARM::SPRRegClassID),
     /* 117604 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSITOS),
     /* 117607 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /* 117609 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 117612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 117615 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 117621 */     GIR_RootConstrainSelectedInstOperands,
     /* 117622 */     // GIR_Coverage, 2341,
     /* 117622 */     GIR_EraseRootFromParent_Done,
     /* 117623 */   // Label 2268: @117623
     /* 117623 */   GIM_Try, /*On fail goto*//*Label 2269*/ GIMT_Encode4(117751), // Rule ID 2709 //
     /* 117628 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_UseNEONForFP),
     /* 117631 */     // (sint_to_fp:{ *:[f32] } GPR:{ *:[i32] }:$a)  =>  (EXTRACT_SUBREG:{ *:[f32] } (VCVTs2fd:{ *:[v2f32] } (INSERT_SUBREG:{ *:[v2f32] } (IMPLICIT_DEF:{ *:[v2f32] }), (COPY_TO_REGCLASS:{ *:[i32] } GPR:{ *:[i32] }:$a, SPR:{ *:[i32] }), ssub_0:{ *:[i32] })), ssub_0:{ *:[i32] })
     /* 117631 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 117634 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 117638 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 117643 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/1, // a
     /* 117647 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(ARM::SPRRegClassID),
     /* 117652 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s32,
     /* 117655 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 117659 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 117664 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 117666 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v2s32,
     /* 117669 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 117673 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 117678 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 117681 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/3,
     /* 117684 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/17,
     /* 117687 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 117692 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 117697 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(ARM::SPRRegClassID),
     /* 117702 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s32,
     /* 117705 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::VCVTs2fd),
     /* 117709 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 117714 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 117717 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/14,
     /* 117720 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 117726 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 117728 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 117731 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 117733 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(ARM::ssub_0),
     /* 117740 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::SPRRegClassID),
     /* 117745 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 117750 */     // GIR_Coverage, 2709,
     /* 117750 */     GIR_EraseRootFromParent_Done,
     /* 117751 */   // Label 2269: @117751
     /* 117751 */   GIM_Reject,
     /* 117752 */ // Label 2267: @117752
     /* 117752 */ GIM_Reject,
     /* 117753 */ // Label 2260: @117753
     /* 117753 */ GIM_Try, /*On fail goto*//*Label 2270*/ GIMT_Encode4(117812), // Rule ID 2339 //
     /* 117758 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDPVFP_HasVFP2),
     /* 117761 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 117764 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 117768 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 117772 */   // (sint_to_fp:{ *:[f64] } GPR:{ *:[i32] }:$a)  =>  (VSITOD:{ *:[f64] } (COPY_TO_REGCLASS:{ *:[f32] } GPR:{ *:[i32] }:$a, SPR:{ *:[i32] }))
     /* 117772 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 117775 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 117779 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 117784 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // a
     /* 117788 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(ARM::SPRRegClassID),
     /* 117793 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSITOD),
     /* 117796 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Dd]
     /* 117798 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 117801 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 117804 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 117810 */   GIR_RootConstrainSelectedInstOperands,
     /* 117811 */   // GIR_Coverage, 2339,
     /* 117811 */   GIR_EraseRootFromParent_Done,
     /* 117812 */ // Label 2270: @117812
     /* 117812 */ GIM_Reject,
     /* 117813 */ // Label 2261: @117813
     /* 117813 */ GIM_Try, /*On fail goto*//*Label 2271*/ GIMT_Encode4(117850), // Rule ID 1603 //
     /* 117818 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 117821 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 117824 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 117828 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 117832 */   // (sint_to_fp:{ *:[v2f32] } DPR:{ *:[v2i32] }:$Vm)  =>  (VCVTs2fd:{ *:[v2f32] } DPR:{ *:[v2i32] }:$Vm)
     /* 117832 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTs2fd),
     /* 117835 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 117837 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /* 117839 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 117842 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 117848 */   GIR_RootConstrainSelectedInstOperands,
     /* 117849 */   // GIR_Coverage, 1603,
     /* 117849 */   GIR_EraseRootFromParent_Done,
     /* 117850 */ // Label 2271: @117850
     /* 117850 */ GIM_Reject,
     /* 117851 */ // Label 2262: @117851
     /* 117851 */ GIM_Try, /*On fail goto*//*Label 2272*/ GIMT_Encode4(117888), // Rule ID 1611 //
     /* 117856 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 117859 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 117862 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 117866 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 117870 */   // (sint_to_fp:{ *:[v4f16] } DPR:{ *:[v4i16] }:$Vm)  =>  (VCVTs2hd:{ *:[v4f16] } DPR:{ *:[v4i16] }:$Vm)
     /* 117870 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTs2hd),
     /* 117873 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 117875 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /* 117877 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 117880 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 117886 */   GIR_RootConstrainSelectedInstOperands,
     /* 117887 */   // GIR_Coverage, 1611,
     /* 117887 */   GIR_EraseRootFromParent_Done,
     /* 117888 */ // Label 2272: @117888
     /* 117888 */ GIM_Reject,
     /* 117889 */ // Label 2263: @117889
     /* 117889 */ GIM_Try, /*On fail goto*//*Label 2273*/ GIMT_Encode4(117987),
     /* 117894 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 117897 */   GIM_Try, /*On fail goto*//*Label 2274*/ GIMT_Encode4(117931), // Rule ID 1607 //
     /* 117902 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 117905 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 117909 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 117913 */     // (sint_to_fp:{ *:[v4f32] } QPR:{ *:[v4i32] }:$Vm)  =>  (VCVTs2fq:{ *:[v4f32] } QPR:{ *:[v4i32] }:$Vm)
     /* 117913 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTs2fq),
     /* 117916 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 117918 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /* 117920 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 117923 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 117929 */     GIR_RootConstrainSelectedInstOperands,
     /* 117930 */     // GIR_Coverage, 1607,
     /* 117930 */     GIR_EraseRootFromParent_Done,
     /* 117931 */   // Label 2274: @117931
     /* 117931 */   GIM_Try, /*On fail goto*//*Label 2275*/ GIMT_Encode4(117986), // Rule ID 4099 //
     /* 117936 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /* 117939 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 117943 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 117947 */     // (sint_to_fp:{ *:[v4f32] } MQPR:{ *:[v4i32] }:$src)  =>  (MVE_VCVTf32s32n:{ *:[v4f32] } MQPR:{ *:[v4i32] }:$src)
     /* 117947 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 117950 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 117954 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 117959 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCVTf32s32n),
     /* 117962 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 117964 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 117966 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 117969 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 117975 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 117981 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 117984 */     GIR_RootConstrainSelectedInstOperands,
     /* 117985 */     // GIR_Coverage, 4099,
     /* 117985 */     GIR_EraseRootFromParent_Done,
     /* 117986 */   // Label 2275: @117986
     /* 117986 */   GIM_Reject,
     /* 117987 */ // Label 2273: @117987
     /* 117987 */ GIM_Reject,
     /* 117988 */ // Label 2264: @117988
     /* 117988 */ GIM_Try, /*On fail goto*//*Label 2276*/ GIMT_Encode4(118086),
     /* 117993 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 117996 */   GIM_Try, /*On fail goto*//*Label 2277*/ GIMT_Encode4(118030), // Rule ID 1615 //
     /* 118001 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 118004 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 118008 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 118012 */     // (sint_to_fp:{ *:[v8f16] } QPR:{ *:[v8i16] }:$Vm)  =>  (VCVTs2hq:{ *:[v8f16] } QPR:{ *:[v8i16] }:$Vm)
     /* 118012 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTs2hq),
     /* 118015 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 118017 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /* 118019 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 118022 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 118028 */     GIR_RootConstrainSelectedInstOperands,
     /* 118029 */     // GIR_Coverage, 1615,
     /* 118029 */     GIR_EraseRootFromParent_Done,
     /* 118030 */   // Label 2277: @118030
     /* 118030 */   GIM_Try, /*On fail goto*//*Label 2278*/ GIMT_Encode4(118085), // Rule ID 4095 //
     /* 118035 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /* 118038 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 118042 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 118046 */     // (sint_to_fp:{ *:[v8f16] } MQPR:{ *:[v8i16] }:$src)  =>  (MVE_VCVTf16s16n:{ *:[v8f16] } MQPR:{ *:[v8i16] }:$src)
     /* 118046 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 118049 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 118053 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 118058 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCVTf16s16n),
     /* 118061 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 118063 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 118065 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 118068 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 118074 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 118080 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 118083 */     GIR_RootConstrainSelectedInstOperands,
     /* 118084 */     // GIR_Coverage, 4095,
     /* 118084 */     GIR_EraseRootFromParent_Done,
     /* 118085 */   // Label 2278: @118085
     /* 118085 */   GIM_Reject,
     /* 118086 */ // Label 2276: @118086
     /* 118086 */ GIM_Reject,
     /* 118087 */ // Label 2265: @118087
     /* 118087 */ GIM_Reject,
     /* 118088 */ // Label 45: @118088
     /* 118088 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(13), /*)*//*default:*//*Label 2286*/ GIMT_Encode4(118739),
     /* 118099 */ /*GILLT_s16*//*Label 2279*/ GIMT_Encode4(118151),
     /* 118103 */ /*GILLT_s32*//*Label 2280*/ GIMT_Encode4(118211),
     /* 118107 */ /*GILLT_s64*//*Label 2281*/ GIMT_Encode4(118405), GIMT_Encode4(0),
     /* 118115 */ /*GILLT_v2s32*//*Label 2282*/ GIMT_Encode4(118465), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 118127 */ /*GILLT_v4s16*//*Label 2283*/ GIMT_Encode4(118503),
     /* 118131 */ /*GILLT_v4s32*//*Label 2284*/ GIMT_Encode4(118541), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 118147 */ /*GILLT_v8s16*//*Label 2285*/ GIMT_Encode4(118640),
     /* 118151 */ // Label 2279: @118151
     /* 118151 */ GIM_Try, /*On fail goto*//*Label 2287*/ GIMT_Encode4(118210), // Rule ID 2348 //
     /* 118156 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_DontUseNEONForFP_HasVFP2),
     /* 118159 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 118162 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 118166 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 118170 */   // (uint_to_fp:{ *:[f16] } GPR:{ *:[i32] }:$a)  =>  (VUITOH:{ *:[f16] } (COPY_TO_REGCLASS:{ *:[f32] } GPR:{ *:[i32] }:$a, SPR:{ *:[i32] }))
     /* 118170 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 118173 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 118177 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 118182 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // a
     /* 118186 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(ARM::SPRRegClassID),
     /* 118191 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VUITOH),
     /* 118194 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /* 118196 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 118199 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 118202 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 118208 */   GIR_RootConstrainSelectedInstOperands,
     /* 118209 */   // GIR_Coverage, 2348,
     /* 118209 */   GIR_EraseRootFromParent_Done,
     /* 118210 */ // Label 2287: @118210
     /* 118210 */ GIM_Reject,
     /* 118211 */ // Label 2280: @118211
     /* 118211 */ GIM_Try, /*On fail goto*//*Label 2288*/ GIMT_Encode4(118404),
     /* 118216 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 118219 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 118223 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 118227 */   GIM_Try, /*On fail goto*//*Label 2289*/ GIMT_Encode4(118275), // Rule ID 2346 //
     /* 118232 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_DontUseNEONForFP_HasVFP2),
     /* 118235 */     // (uint_to_fp:{ *:[f32] } GPR:{ *:[i32] }:$a)  =>  (VUITOS:{ *:[f32] } (COPY_TO_REGCLASS:{ *:[f32] } GPR:{ *:[i32] }:$a, SPR:{ *:[i32] }))
     /* 118235 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 118238 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 118242 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 118247 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // a
     /* 118251 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(ARM::SPRRegClassID),
     /* 118256 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VUITOS),
     /* 118259 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /* 118261 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 118264 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 118267 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 118273 */     GIR_RootConstrainSelectedInstOperands,
     /* 118274 */     // GIR_Coverage, 2346,
     /* 118274 */     GIR_EraseRootFromParent_Done,
     /* 118275 */   // Label 2289: @118275
     /* 118275 */   GIM_Try, /*On fail goto*//*Label 2290*/ GIMT_Encode4(118403), // Rule ID 2710 //
     /* 118280 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_UseNEONForFP),
     /* 118283 */     // (uint_to_fp:{ *:[f32] } GPR:{ *:[i32] }:$a)  =>  (EXTRACT_SUBREG:{ *:[f32] } (VCVTu2fd:{ *:[v2f32] } (INSERT_SUBREG:{ *:[v2f32] } (IMPLICIT_DEF:{ *:[v2f32] }), (COPY_TO_REGCLASS:{ *:[i32] } GPR:{ *:[i32] }:$a, SPR:{ *:[i32] }), ssub_0:{ *:[i32] })), ssub_0:{ *:[i32] })
     /* 118283 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 118286 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 118290 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 118295 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/1, // a
     /* 118299 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(ARM::SPRRegClassID),
     /* 118304 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s32,
     /* 118307 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 118311 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 118316 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 118318 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v2s32,
     /* 118321 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 118325 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 118330 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 118333 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/3,
     /* 118336 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/17,
     /* 118339 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 118344 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 118349 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(ARM::SPRRegClassID),
     /* 118354 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s32,
     /* 118357 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::VCVTu2fd),
     /* 118361 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 118366 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 118369 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/14,
     /* 118372 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 118378 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 118380 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 118383 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 118385 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(ARM::ssub_0),
     /* 118392 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::SPRRegClassID),
     /* 118397 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 118402 */     // GIR_Coverage, 2710,
     /* 118402 */     GIR_EraseRootFromParent_Done,
     /* 118403 */   // Label 2290: @118403
     /* 118403 */   GIM_Reject,
     /* 118404 */ // Label 2288: @118404
     /* 118404 */ GIM_Reject,
     /* 118405 */ // Label 2281: @118405
     /* 118405 */ GIM_Try, /*On fail goto*//*Label 2291*/ GIMT_Encode4(118464), // Rule ID 2344 //
     /* 118410 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDPVFP_HasVFP2),
     /* 118413 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 118416 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 118420 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 118424 */   // (uint_to_fp:{ *:[f64] } GPR:{ *:[i32] }:$a)  =>  (VUITOD:{ *:[f64] } (COPY_TO_REGCLASS:{ *:[f32] } GPR:{ *:[i32] }:$a, SPR:{ *:[i32] }))
     /* 118424 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 118427 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 118431 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 118436 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // a
     /* 118440 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(ARM::SPRRegClassID),
     /* 118445 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VUITOD),
     /* 118448 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Dd]
     /* 118450 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 118453 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 118456 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 118462 */   GIR_RootConstrainSelectedInstOperands,
     /* 118463 */   // GIR_Coverage, 2344,
     /* 118463 */   GIR_EraseRootFromParent_Done,
     /* 118464 */ // Label 2291: @118464
     /* 118464 */ GIM_Reject,
     /* 118465 */ // Label 2282: @118465
     /* 118465 */ GIM_Try, /*On fail goto*//*Label 2292*/ GIMT_Encode4(118502), // Rule ID 1604 //
     /* 118470 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 118473 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 118476 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 118480 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 118484 */   // (uint_to_fp:{ *:[v2f32] } DPR:{ *:[v2i32] }:$Vm)  =>  (VCVTu2fd:{ *:[v2f32] } DPR:{ *:[v2i32] }:$Vm)
     /* 118484 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTu2fd),
     /* 118487 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 118489 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /* 118491 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 118494 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 118500 */   GIR_RootConstrainSelectedInstOperands,
     /* 118501 */   // GIR_Coverage, 1604,
     /* 118501 */   GIR_EraseRootFromParent_Done,
     /* 118502 */ // Label 2292: @118502
     /* 118502 */ GIM_Reject,
     /* 118503 */ // Label 2283: @118503
     /* 118503 */ GIM_Try, /*On fail goto*//*Label 2293*/ GIMT_Encode4(118540), // Rule ID 1612 //
     /* 118508 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 118511 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 118514 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 118518 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 118522 */   // (uint_to_fp:{ *:[v4f16] } DPR:{ *:[v4i16] }:$Vm)  =>  (VCVTu2hd:{ *:[v4f16] } DPR:{ *:[v4i16] }:$Vm)
     /* 118522 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTu2hd),
     /* 118525 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 118527 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /* 118529 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 118532 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 118538 */   GIR_RootConstrainSelectedInstOperands,
     /* 118539 */   // GIR_Coverage, 1612,
     /* 118539 */   GIR_EraseRootFromParent_Done,
     /* 118540 */ // Label 2293: @118540
     /* 118540 */ GIM_Reject,
     /* 118541 */ // Label 2284: @118541
     /* 118541 */ GIM_Try, /*On fail goto*//*Label 2294*/ GIMT_Encode4(118639),
     /* 118546 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 118549 */   GIM_Try, /*On fail goto*//*Label 2295*/ GIMT_Encode4(118583), // Rule ID 1608 //
     /* 118554 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 118557 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 118561 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 118565 */     // (uint_to_fp:{ *:[v4f32] } QPR:{ *:[v4i32] }:$Vm)  =>  (VCVTu2fq:{ *:[v4f32] } QPR:{ *:[v4i32] }:$Vm)
     /* 118565 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTu2fq),
     /* 118568 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 118570 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /* 118572 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 118575 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 118581 */     GIR_RootConstrainSelectedInstOperands,
     /* 118582 */     // GIR_Coverage, 1608,
     /* 118582 */     GIR_EraseRootFromParent_Done,
     /* 118583 */   // Label 2295: @118583
     /* 118583 */   GIM_Try, /*On fail goto*//*Label 2296*/ GIMT_Encode4(118638), // Rule ID 4101 //
     /* 118588 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /* 118591 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 118595 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 118599 */     // (uint_to_fp:{ *:[v4f32] } MQPR:{ *:[v4i32] }:$src)  =>  (MVE_VCVTf32u32n:{ *:[v4f32] } MQPR:{ *:[v4i32] }:$src)
     /* 118599 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 118602 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 118606 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 118611 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCVTf32u32n),
     /* 118614 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 118616 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 118618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 118621 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 118627 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 118633 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 118636 */     GIR_RootConstrainSelectedInstOperands,
     /* 118637 */     // GIR_Coverage, 4101,
     /* 118637 */     GIR_EraseRootFromParent_Done,
     /* 118638 */   // Label 2296: @118638
     /* 118638 */   GIM_Reject,
     /* 118639 */ // Label 2294: @118639
     /* 118639 */ GIM_Reject,
     /* 118640 */ // Label 2285: @118640
     /* 118640 */ GIM_Try, /*On fail goto*//*Label 2297*/ GIMT_Encode4(118738),
     /* 118645 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 118648 */   GIM_Try, /*On fail goto*//*Label 2298*/ GIMT_Encode4(118682), // Rule ID 1616 //
     /* 118653 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 118656 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 118660 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 118664 */     // (uint_to_fp:{ *:[v8f16] } QPR:{ *:[v8i16] }:$Vm)  =>  (VCVTu2hq:{ *:[v8f16] } QPR:{ *:[v8i16] }:$Vm)
     /* 118664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTu2hq),
     /* 118667 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 118669 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /* 118671 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 118674 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 118680 */     GIR_RootConstrainSelectedInstOperands,
     /* 118681 */     // GIR_Coverage, 1616,
     /* 118681 */     GIR_EraseRootFromParent_Done,
     /* 118682 */   // Label 2298: @118682
     /* 118682 */   GIM_Try, /*On fail goto*//*Label 2299*/ GIMT_Encode4(118737), // Rule ID 4097 //
     /* 118687 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /* 118690 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 118694 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 118698 */     // (uint_to_fp:{ *:[v8f16] } MQPR:{ *:[v8i16] }:$src)  =>  (MVE_VCVTf16u16n:{ *:[v8f16] } MQPR:{ *:[v8i16] }:$src)
     /* 118698 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 118701 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 118705 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 118710 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCVTf16u16n),
     /* 118713 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 118715 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 118717 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 118720 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 118726 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 118732 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 118735 */     GIR_RootConstrainSelectedInstOperands,
     /* 118736 */     // GIR_Coverage, 4097,
     /* 118736 */     GIR_EraseRootFromParent_Done,
     /* 118737 */   // Label 2299: @118737
     /* 118737 */   GIM_Reject,
     /* 118738 */ // Label 2297: @118738
     /* 118738 */ GIM_Reject,
     /* 118739 */ // Label 2286: @118739
     /* 118739 */ GIM_Reject,
     /* 118740 */ // Label 46: @118740
     /* 118740 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(13), /*)*//*default:*//*Label 2307*/ GIMT_Encode4(119515),
     /* 118751 */ /*GILLT_s16*//*Label 2300*/ GIMT_Encode4(118803),
     /* 118755 */ /*GILLT_s32*//*Label 2301*/ GIMT_Encode4(118841),
     /* 118759 */ /*GILLT_s64*//*Label 2302*/ GIMT_Encode4(119033), GIMT_Encode4(0),
     /* 118767 */ /*GILLT_v2s32*//*Label 2303*/ GIMT_Encode4(119071), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 118779 */ /*GILLT_v4s16*//*Label 2304*/ GIMT_Encode4(119109),
     /* 118783 */ /*GILLT_v4s32*//*Label 2305*/ GIMT_Encode4(119147), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 118799 */ /*GILLT_v8s16*//*Label 2306*/ GIMT_Encode4(119331),
     /* 118803 */ // Label 2300: @118803
     /* 118803 */ GIM_Try, /*On fail goto*//*Label 2308*/ GIMT_Encode4(118840), // Rule ID 653 //
     /* 118808 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 118811 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 118814 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 118818 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 118822 */   // (fabs:{ *:[f16] } HPR:{ *:[f16] }:$Sm)  =>  (VABSH:{ *:[f16] } HPR:{ *:[f16] }:$Sm)
     /* 118822 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VABSH),
     /* 118825 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /* 118827 */   GIR_RootToRootCopy, /*OpIdx*/1, // Sm
     /* 118829 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 118832 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 118838 */   GIR_RootConstrainSelectedInstOperands,
     /* 118839 */   // GIR_Coverage, 653,
     /* 118839 */   GIR_EraseRootFromParent_Done,
     /* 118840 */ // Label 2308: @118840
     /* 118840 */ GIM_Reject,
     /* 118841 */ // Label 2301: @118841
     /* 118841 */ GIM_Try, /*On fail goto*//*Label 2309*/ GIMT_Encode4(119032),
     /* 118846 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 118849 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 118853 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 118857 */   GIM_Try, /*On fail goto*//*Label 2310*/ GIMT_Encode4(118883), // Rule ID 652 //
     /* 118862 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_DontUseNEONForFP_HasVFP2),
     /* 118865 */     // (fabs:{ *:[f32] } SPR:{ *:[f32] }:$Sm)  =>  (VABSS:{ *:[f32] } SPR:{ *:[f32] }:$Sm)
     /* 118865 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VABSS),
     /* 118868 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /* 118870 */     GIR_RootToRootCopy, /*OpIdx*/1, // Sm
     /* 118872 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 118875 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 118881 */     GIR_RootConstrainSelectedInstOperands,
     /* 118882 */     // GIR_Coverage, 652,
     /* 118882 */     GIR_EraseRootFromParent_Done,
     /* 118883 */   // Label 2310: @118883
     /* 118883 */   GIM_Try, /*On fail goto*//*Label 2311*/ GIMT_Encode4(119031), // Rule ID 2701 //
     /* 118888 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_UseNEONForFP),
     /* 118891 */     // (fabs:{ *:[f32] } SPR:{ *:[f32] }:$a)  =>  (EXTRACT_SUBREG:{ *:[f32] } (COPY_TO_REGCLASS:{ *:[v2f32] } (VABSfd:{ *:[f64] } (INSERT_SUBREG:{ *:[v2f32] } (COPY_TO_REGCLASS:{ *:[v2f32] } (IMPLICIT_DEF:{ *:[v2f32] }), DPR_VFP2:{ *:[i32] }), SPR:{ *:[f32] }:$a, ssub_0:{ *:[i32] })), DPR_VFP2:{ *:[i32] }), ssub_0:{ *:[i32] })
     /* 118891 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v2s32,
     /* 118894 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 118898 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 118903 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 118905 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v2s32,
     /* 118908 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 118912 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 118917 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 118920 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 118925 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s32,
     /* 118928 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 118932 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 118937 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 118940 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // a
     /* 118944 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/17,
     /* 118947 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 118952 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 118957 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(ARM::SPRRegClassID),
     /* 118962 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 118965 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(ARM::VABSfd),
     /* 118969 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 118974 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 118977 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/14,
     /* 118980 */     GIR_AddRegister, /*InsnID*/2, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 118986 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 118988 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s32,
     /* 118991 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 118995 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 119000 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 119003 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 119008 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 119011 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 119013 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(ARM::ssub_0),
     /* 119020 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::SPRRegClassID),
     /* 119025 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 119030 */     // GIR_Coverage, 2701,
     /* 119030 */     GIR_EraseRootFromParent_Done,
     /* 119031 */   // Label 2311: @119031
     /* 119031 */   GIM_Reject,
     /* 119032 */ // Label 2309: @119032
     /* 119032 */ GIM_Reject,
     /* 119033 */ // Label 2302: @119033
     /* 119033 */ GIM_Try, /*On fail goto*//*Label 2312*/ GIMT_Encode4(119070), // Rule ID 651 //
     /* 119038 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDPVFP_HasVFP2),
     /* 119041 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 119044 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 119048 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 119052 */   // (fabs:{ *:[f64] } DPR:{ *:[f64] }:$Dm)  =>  (VABSD:{ *:[f64] } DPR:{ *:[f64] }:$Dm)
     /* 119052 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VABSD),
     /* 119055 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Dd]
     /* 119057 */   GIR_RootToRootCopy, /*OpIdx*/1, // Dm
     /* 119059 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 119062 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 119068 */   GIR_RootConstrainSelectedInstOperands,
     /* 119069 */   // GIR_Coverage, 651,
     /* 119069 */   GIR_EraseRootFromParent_Done,
     /* 119070 */ // Label 2312: @119070
     /* 119070 */ GIM_Reject,
     /* 119071 */ // Label 2303: @119071
     /* 119071 */ GIM_Try, /*On fail goto*//*Label 2313*/ GIMT_Encode4(119108), // Rule ID 1511 //
     /* 119076 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 119079 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 119082 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 119086 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 119090 */   // (fabs:{ *:[v2f32] } DPR:{ *:[v2f32] }:$Vm)  =>  (VABSfd:{ *:[v2f32] } DPR:{ *:[v2f32] }:$Vm)
     /* 119090 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VABSfd),
     /* 119093 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 119095 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /* 119097 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 119100 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 119106 */   GIR_RootConstrainSelectedInstOperands,
     /* 119107 */   // GIR_Coverage, 1511,
     /* 119107 */   GIR_EraseRootFromParent_Done,
     /* 119108 */ // Label 2313: @119108
     /* 119108 */ GIM_Reject,
     /* 119109 */ // Label 2304: @119109
     /* 119109 */ GIM_Try, /*On fail goto*//*Label 2314*/ GIMT_Encode4(119146), // Rule ID 1513 //
     /* 119114 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 119117 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 119120 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 119124 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 119128 */   // (fabs:{ *:[v4f16] } DPR:{ *:[v4f16] }:$Vm)  =>  (VABShd:{ *:[v4f16] } DPR:{ *:[v4f16] }:$Vm)
     /* 119128 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VABShd),
     /* 119131 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 119133 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /* 119135 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 119138 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 119144 */   GIR_RootConstrainSelectedInstOperands,
     /* 119145 */   // GIR_Coverage, 1513,
     /* 119145 */   GIR_EraseRootFromParent_Done,
     /* 119146 */ // Label 2314: @119146
     /* 119146 */ GIM_Reject,
     /* 119147 */ // Label 2305: @119147
     /* 119147 */ GIM_Try, /*On fail goto*//*Label 2315*/ GIMT_Encode4(119330),
     /* 119152 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 119155 */   GIM_Try, /*On fail goto*//*Label 2316*/ GIMT_Encode4(119240), // Rule ID 4038 //
     /* 119160 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /* 119163 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 119167 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 119171 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FSUB),
     /* 119175 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 119179 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 119183 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 119188 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 119193 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 119195 */     // (fabs:{ *:[v4f32] } (fsub:{ *:[v4f32] } MQPR:{ *:[v4f32] }:$Qm, MQPR:{ *:[v4f32] }:$Qn))  =>  (MVE_VABDf32:{ *:[v4f32] } MQPR:{ *:[v4f32] }:$Qm, MQPR:{ *:[v4f32] }:$Qn)
     /* 119195 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 119198 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 119202 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 119207 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VABDf32),
     /* 119210 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 119212 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Qm
     /* 119216 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Qn
     /* 119220 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 119223 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 119229 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 119235 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 119238 */     GIR_RootConstrainSelectedInstOperands,
     /* 119239 */     // GIR_Coverage, 4038,
     /* 119239 */     GIR_EraseRootFromParent_Done,
     /* 119240 */   // Label 2316: @119240
     /* 119240 */   GIM_Try, /*On fail goto*//*Label 2317*/ GIMT_Encode4(119274), // Rule ID 1512 //
     /* 119245 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 119248 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 119252 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 119256 */     // (fabs:{ *:[v4f32] } QPR:{ *:[v4f32] }:$Vm)  =>  (VABSfq:{ *:[v4f32] } QPR:{ *:[v4f32] }:$Vm)
     /* 119256 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VABSfq),
     /* 119259 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 119261 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /* 119263 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 119266 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 119272 */     GIR_RootConstrainSelectedInstOperands,
     /* 119273 */     // GIR_Coverage, 1512,
     /* 119273 */     GIR_EraseRootFromParent_Done,
     /* 119274 */   // Label 2317: @119274
     /* 119274 */   GIM_Try, /*On fail goto*//*Label 2318*/ GIMT_Encode4(119329), // Rule ID 4109 //
     /* 119279 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 119282 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 119286 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 119290 */     // (fabs:{ *:[v4f32] } MQPR:{ *:[v4f32] }:$v)  =>  (MVE_VABSf32:{ *:[v4f32] } ?:{ *:[v4f32] }:$v)
     /* 119290 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 119293 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 119297 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 119302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VABSf32),
     /* 119305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 119307 */     GIR_RootToRootCopy, /*OpIdx*/1, // v
     /* 119309 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 119312 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 119318 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 119324 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 119327 */     GIR_RootConstrainSelectedInstOperands,
     /* 119328 */     // GIR_Coverage, 4109,
     /* 119328 */     GIR_EraseRootFromParent_Done,
     /* 119329 */   // Label 2318: @119329
     /* 119329 */   GIM_Reject,
     /* 119330 */ // Label 2315: @119330
     /* 119330 */ GIM_Reject,
     /* 119331 */ // Label 2306: @119331
     /* 119331 */ GIM_Try, /*On fail goto*//*Label 2319*/ GIMT_Encode4(119514),
     /* 119336 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 119339 */   GIM_Try, /*On fail goto*//*Label 2320*/ GIMT_Encode4(119424), // Rule ID 4037 //
     /* 119344 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /* 119347 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 119351 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 119355 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FSUB),
     /* 119359 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 119363 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 119367 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 119372 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 119377 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 119379 */     // (fabs:{ *:[v8f16] } (fsub:{ *:[v8f16] } MQPR:{ *:[v8f16] }:$Qm, MQPR:{ *:[v8f16] }:$Qn))  =>  (MVE_VABDf16:{ *:[v8f16] } MQPR:{ *:[v8f16] }:$Qm, MQPR:{ *:[v8f16] }:$Qn)
     /* 119379 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 119382 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 119386 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 119391 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VABDf16),
     /* 119394 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 119396 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Qm
     /* 119400 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Qn
     /* 119404 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 119407 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 119413 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 119419 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 119422 */     GIR_RootConstrainSelectedInstOperands,
     /* 119423 */     // GIR_Coverage, 4037,
     /* 119423 */     GIR_EraseRootFromParent_Done,
     /* 119424 */   // Label 2320: @119424
     /* 119424 */   GIM_Try, /*On fail goto*//*Label 2321*/ GIMT_Encode4(119458), // Rule ID 1514 //
     /* 119429 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 119432 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 119436 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 119440 */     // (fabs:{ *:[v8f16] } QPR:{ *:[v8f16] }:$Vm)  =>  (VABShq:{ *:[v8f16] } QPR:{ *:[v8f16] }:$Vm)
     /* 119440 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VABShq),
     /* 119443 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 119445 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /* 119447 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 119450 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 119456 */     GIR_RootConstrainSelectedInstOperands,
     /* 119457 */     // GIR_Coverage, 1514,
     /* 119457 */     GIR_EraseRootFromParent_Done,
     /* 119458 */   // Label 2321: @119458
     /* 119458 */   GIM_Try, /*On fail goto*//*Label 2322*/ GIMT_Encode4(119513), // Rule ID 4107 //
     /* 119463 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 119466 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 119470 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 119474 */     // (fabs:{ *:[v8f16] } MQPR:{ *:[v8f16] }:$v)  =>  (MVE_VABSf16:{ *:[v8f16] } ?:{ *:[v8f16] }:$v)
     /* 119474 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 119477 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 119481 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 119486 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VABSf16),
     /* 119489 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 119491 */     GIR_RootToRootCopy, /*OpIdx*/1, // v
     /* 119493 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 119496 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 119502 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 119508 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 119511 */     GIR_RootConstrainSelectedInstOperands,
     /* 119512 */     // GIR_Coverage, 4107,
     /* 119512 */     GIR_EraseRootFromParent_Done,
     /* 119513 */   // Label 2322: @119513
     /* 119513 */   GIM_Reject,
     /* 119514 */ // Label 2319: @119514
     /* 119514 */ GIM_Reject,
     /* 119515 */ // Label 2307: @119515
     /* 119515 */ GIM_Reject,
     /* 119516 */ // Label 47: @119516
     /* 119516 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(13), /*)*//*default:*//*Label 2330*/ GIMT_Encode4(120107),
     /* 119527 */ /*GILLT_s16*//*Label 2323*/ GIMT_Encode4(119579),
     /* 119531 */ /*GILLT_s32*//*Label 2324*/ GIMT_Encode4(119613),
     /* 119535 */ /*GILLT_s64*//*Label 2325*/ GIMT_Encode4(119647), GIMT_Encode4(0),
     /* 119543 */ /*GILLT_v2s32*//*Label 2326*/ GIMT_Encode4(119681), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 119555 */ /*GILLT_v4s16*//*Label 2327*/ GIMT_Encode4(119715),
     /* 119559 */ /*GILLT_v4s32*//*Label 2328*/ GIMT_Encode4(119749), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 119575 */ /*GILLT_v8s16*//*Label 2329*/ GIMT_Encode4(119928),
     /* 119579 */ // Label 2323: @119579
     /* 119579 */ GIM_Try, /*On fail goto*//*Label 2331*/ GIMT_Encode4(119612), // Rule ID 642 //
     /* 119584 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 119587 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 119590 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 119593 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 119597 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 119601 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 119605 */   // (fminnum:{ *:[f16] } HPR:{ *:[f16] }:$Sn, HPR:{ *:[f16] }:$Sm)  =>  (VFP_VMINNMH:{ *:[f16] } HPR:{ *:[f16] }:$Sn, HPR:{ *:[f16] }:$Sm)
     /* 119605 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(ARM::VFP_VMINNMH),
     /* 119610 */   GIR_RootConstrainSelectedInstOperands,
     /* 119611 */   // GIR_Coverage, 642,
     /* 119611 */   GIR_Done,
     /* 119612 */ // Label 2331: @119612
     /* 119612 */ GIM_Reject,
     /* 119613 */ // Label 2324: @119613
     /* 119613 */ GIM_Try, /*On fail goto*//*Label 2332*/ GIMT_Encode4(119646), // Rule ID 643 //
     /* 119618 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 119621 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 119624 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 119627 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 119631 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 119635 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 119639 */   // (fminnum:{ *:[f32] } SPR:{ *:[f32] }:$Sn, SPR:{ *:[f32] }:$Sm)  =>  (VFP_VMINNMS:{ *:[f32] } SPR:{ *:[f32] }:$Sn, SPR:{ *:[f32] }:$Sm)
     /* 119639 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(ARM::VFP_VMINNMS),
     /* 119644 */   GIR_RootConstrainSelectedInstOperands,
     /* 119645 */   // GIR_Coverage, 643,
     /* 119645 */   GIR_Done,
     /* 119646 */ // Label 2332: @119646
     /* 119646 */ GIM_Reject,
     /* 119647 */ // Label 2325: @119647
     /* 119647 */ GIM_Try, /*On fail goto*//*Label 2333*/ GIMT_Encode4(119680), // Rule ID 644 //
     /* 119652 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDPVFP_HasFPARMv8),
     /* 119655 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 119658 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 119661 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 119665 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 119669 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 119673 */   // (fminnum:{ *:[f64] } DPR:{ *:[f64] }:$Dn, DPR:{ *:[f64] }:$Dm)  =>  (VFP_VMINNMD:{ *:[f64] } DPR:{ *:[f64] }:$Dn, DPR:{ *:[f64] }:$Dm)
     /* 119673 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(ARM::VFP_VMINNMD),
     /* 119678 */   GIR_RootConstrainSelectedInstOperands,
     /* 119679 */   // GIR_Coverage, 644,
     /* 119679 */   GIR_Done,
     /* 119680 */ // Label 2333: @119680
     /* 119680 */ GIM_Reject,
     /* 119681 */ // Label 2326: @119681
     /* 119681 */ GIM_Try, /*On fail goto*//*Label 2334*/ GIMT_Encode4(119714), // Rule ID 1230 //
     /* 119686 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8_HasNEON),
     /* 119689 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 119692 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 119695 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 119699 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 119703 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 119707 */   // (fminnum:{ *:[v2f32] } DPR:{ *:[v2f32] }:$Vn, DPR:{ *:[v2f32] }:$Vm)  =>  (NEON_VMINNMNDf:{ *:[v2f32] } DPR:{ *:[v2f32] }:$Vn, DPR:{ *:[v2f32] }:$Vm)
     /* 119707 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(ARM::NEON_VMINNMNDf),
     /* 119712 */   GIR_RootConstrainSelectedInstOperands,
     /* 119713 */   // GIR_Coverage, 1230,
     /* 119713 */   GIR_Done,
     /* 119714 */ // Label 2334: @119714
     /* 119714 */ GIM_Reject,
     /* 119715 */ // Label 2327: @119715
     /* 119715 */ GIM_Try, /*On fail goto*//*Label 2335*/ GIMT_Encode4(119748), // Rule ID 1232 //
     /* 119720 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8_HasFullFP16_HasNEON),
     /* 119723 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 119726 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 119729 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 119733 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 119737 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 119741 */   // (fminnum:{ *:[v4f16] } DPR:{ *:[v4f16] }:$Vn, DPR:{ *:[v4f16] }:$Vm)  =>  (NEON_VMINNMNDh:{ *:[v4f16] } DPR:{ *:[v4f16] }:$Vn, DPR:{ *:[v4f16] }:$Vm)
     /* 119741 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(ARM::NEON_VMINNMNDh),
     /* 119746 */   GIR_RootConstrainSelectedInstOperands,
     /* 119747 */   // GIR_Coverage, 1232,
     /* 119747 */   GIR_Done,
     /* 119748 */ // Label 2335: @119748
     /* 119748 */ GIM_Reject,
     /* 119749 */ // Label 2328: @119749
     /* 119749 */ GIM_Try, /*On fail goto*//*Label 2336*/ GIMT_Encode4(119927),
     /* 119754 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 119757 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 119760 */   GIM_Try, /*On fail goto*//*Label 2337*/ GIMT_Encode4(119838), // Rule ID 4119 //
     /* 119765 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 119768 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 119772 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 119776 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 119780 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 119784 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 119789 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 119793 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 119797 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 119801 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 119806 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 119808 */     // (fminnum:{ *:[v4f32] } (fabs:{ *:[v4f32] } MQPR:{ *:[v4f32] }:$Qd), (fabs:{ *:[v4f32] } MQPR:{ *:[v4f32] }:$Qm))  =>  (MVE_VMINNMAf32:{ *:[v4f32] } MQPR:{ *:[v4f32] }:$Qd, MQPR:{ *:[v4f32] }:$Qm)
     /* 119808 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMINNMAf32),
     /* 119811 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 119813 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Qd
     /* 119817 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Qm
     /* 119821 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 119824 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 119830 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 119836 */     GIR_RootConstrainSelectedInstOperands,
     /* 119837 */     // GIR_Coverage, 4119,
     /* 119837 */     GIR_EraseRootFromParent_Done,
     /* 119838 */   // Label 2337: @119838
     /* 119838 */   GIM_Try, /*On fail goto*//*Label 2338*/ GIMT_Encode4(119865), // Rule ID 1231 //
     /* 119843 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8_HasNEON),
     /* 119846 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 119850 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 119854 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 119858 */     // (fminnum:{ *:[v4f32] } QPR:{ *:[v4f32] }:$Vn, QPR:{ *:[v4f32] }:$Vm)  =>  (NEON_VMINNMNQf:{ *:[v4f32] } QPR:{ *:[v4f32] }:$Vn, QPR:{ *:[v4f32] }:$Vm)
     /* 119858 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(ARM::NEON_VMINNMNQf),
     /* 119863 */     GIR_RootConstrainSelectedInstOperands,
     /* 119864 */     // GIR_Coverage, 1231,
     /* 119864 */     GIR_Done,
     /* 119865 */   // Label 2338: @119865
     /* 119865 */   GIM_Try, /*On fail goto*//*Label 2339*/ GIMT_Encode4(119926), // Rule ID 3285 //
     /* 119870 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /* 119873 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 119877 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 119881 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 119885 */     // (fminnum:{ *:[v4f32] } MQPR:{ *:[v4f32] }:$Qm, MQPR:{ *:[v4f32] }:$Qn)  =>  (MVE_VMINNMf32:{ *:[v4f32] } MQPR:{ *:[v4f32] }:$Qm, MQPR:{ *:[v4f32] }:$Qn)
     /* 119885 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 119888 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 119892 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 119897 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMINNMf32),
     /* 119900 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 119902 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /* 119904 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /* 119906 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 119909 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 119915 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 119921 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 119924 */     GIR_RootConstrainSelectedInstOperands,
     /* 119925 */     // GIR_Coverage, 3285,
     /* 119925 */     GIR_EraseRootFromParent_Done,
     /* 119926 */   // Label 2339: @119926
     /* 119926 */   GIM_Reject,
     /* 119927 */ // Label 2336: @119927
     /* 119927 */ GIM_Reject,
     /* 119928 */ // Label 2329: @119928
     /* 119928 */ GIM_Try, /*On fail goto*//*Label 2340*/ GIMT_Encode4(120106),
     /* 119933 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 119936 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 119939 */   GIM_Try, /*On fail goto*//*Label 2341*/ GIMT_Encode4(120017), // Rule ID 4121 //
     /* 119944 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 119947 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 119951 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 119955 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 119959 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 119963 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 119968 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 119972 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 119976 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 119980 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 119985 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 119987 */     // (fminnum:{ *:[v8f16] } (fabs:{ *:[v8f16] } MQPR:{ *:[v8f16] }:$Qd), (fabs:{ *:[v8f16] } MQPR:{ *:[v8f16] }:$Qm))  =>  (MVE_VMINNMAf16:{ *:[v8f16] } MQPR:{ *:[v8f16] }:$Qd, MQPR:{ *:[v8f16] }:$Qm)
     /* 119987 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMINNMAf16),
     /* 119990 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 119992 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Qd
     /* 119996 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Qm
     /* 120000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 120003 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 120009 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 120015 */     GIR_RootConstrainSelectedInstOperands,
     /* 120016 */     // GIR_Coverage, 4121,
     /* 120016 */     GIR_EraseRootFromParent_Done,
     /* 120017 */   // Label 2341: @120017
     /* 120017 */   GIM_Try, /*On fail goto*//*Label 2342*/ GIMT_Encode4(120044), // Rule ID 1233 //
     /* 120022 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8_HasFullFP16_HasNEON),
     /* 120025 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 120029 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 120033 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 120037 */     // (fminnum:{ *:[v8f16] } QPR:{ *:[v8f16] }:$Vn, QPR:{ *:[v8f16] }:$Vm)  =>  (NEON_VMINNMNQh:{ *:[v8f16] } QPR:{ *:[v8f16] }:$Vn, QPR:{ *:[v8f16] }:$Vm)
     /* 120037 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(ARM::NEON_VMINNMNQh),
     /* 120042 */     GIR_RootConstrainSelectedInstOperands,
     /* 120043 */     // GIR_Coverage, 1233,
     /* 120043 */     GIR_Done,
     /* 120044 */   // Label 2342: @120044
     /* 120044 */   GIM_Try, /*On fail goto*//*Label 2343*/ GIMT_Encode4(120105), // Rule ID 3288 //
     /* 120049 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /* 120052 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 120056 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 120060 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 120064 */     // (fminnum:{ *:[v8f16] } MQPR:{ *:[v8f16] }:$Qm, MQPR:{ *:[v8f16] }:$Qn)  =>  (MVE_VMINNMf16:{ *:[v8f16] } MQPR:{ *:[v8f16] }:$Qm, MQPR:{ *:[v8f16] }:$Qn)
     /* 120064 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 120067 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 120071 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 120076 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMINNMf16),
     /* 120079 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 120081 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /* 120083 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /* 120085 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 120088 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 120094 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 120100 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 120103 */     GIR_RootConstrainSelectedInstOperands,
     /* 120104 */     // GIR_Coverage, 3288,
     /* 120104 */     GIR_EraseRootFromParent_Done,
     /* 120105 */   // Label 2343: @120105
     /* 120105 */   GIM_Reject,
     /* 120106 */ // Label 2340: @120106
     /* 120106 */ GIM_Reject,
     /* 120107 */ // Label 2330: @120107
     /* 120107 */ GIM_Reject,
     /* 120108 */ // Label 48: @120108
     /* 120108 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(13), /*)*//*default:*//*Label 2351*/ GIMT_Encode4(120699),
     /* 120119 */ /*GILLT_s16*//*Label 2344*/ GIMT_Encode4(120171),
     /* 120123 */ /*GILLT_s32*//*Label 2345*/ GIMT_Encode4(120205),
     /* 120127 */ /*GILLT_s64*//*Label 2346*/ GIMT_Encode4(120239), GIMT_Encode4(0),
     /* 120135 */ /*GILLT_v2s32*//*Label 2347*/ GIMT_Encode4(120273), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 120147 */ /*GILLT_v4s16*//*Label 2348*/ GIMT_Encode4(120307),
     /* 120151 */ /*GILLT_v4s32*//*Label 2349*/ GIMT_Encode4(120341), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 120167 */ /*GILLT_v8s16*//*Label 2350*/ GIMT_Encode4(120520),
     /* 120171 */ // Label 2344: @120171
     /* 120171 */ GIM_Try, /*On fail goto*//*Label 2352*/ GIMT_Encode4(120204), // Rule ID 639 //
     /* 120176 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 120179 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 120182 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 120185 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 120189 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 120193 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 120197 */   // (fmaxnum:{ *:[f16] } HPR:{ *:[f16] }:$Sn, HPR:{ *:[f16] }:$Sm)  =>  (VFP_VMAXNMH:{ *:[f16] } HPR:{ *:[f16] }:$Sn, HPR:{ *:[f16] }:$Sm)
     /* 120197 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(ARM::VFP_VMAXNMH),
     /* 120202 */   GIR_RootConstrainSelectedInstOperands,
     /* 120203 */   // GIR_Coverage, 639,
     /* 120203 */   GIR_Done,
     /* 120204 */ // Label 2352: @120204
     /* 120204 */ GIM_Reject,
     /* 120205 */ // Label 2345: @120205
     /* 120205 */ GIM_Try, /*On fail goto*//*Label 2353*/ GIMT_Encode4(120238), // Rule ID 640 //
     /* 120210 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 120213 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 120216 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 120219 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 120223 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 120227 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 120231 */   // (fmaxnum:{ *:[f32] } SPR:{ *:[f32] }:$Sn, SPR:{ *:[f32] }:$Sm)  =>  (VFP_VMAXNMS:{ *:[f32] } SPR:{ *:[f32] }:$Sn, SPR:{ *:[f32] }:$Sm)
     /* 120231 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(ARM::VFP_VMAXNMS),
     /* 120236 */   GIR_RootConstrainSelectedInstOperands,
     /* 120237 */   // GIR_Coverage, 640,
     /* 120237 */   GIR_Done,
     /* 120238 */ // Label 2353: @120238
     /* 120238 */ GIM_Reject,
     /* 120239 */ // Label 2346: @120239
     /* 120239 */ GIM_Try, /*On fail goto*//*Label 2354*/ GIMT_Encode4(120272), // Rule ID 641 //
     /* 120244 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDPVFP_HasFPARMv8),
     /* 120247 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 120250 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 120253 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 120257 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 120261 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 120265 */   // (fmaxnum:{ *:[f64] } DPR:{ *:[f64] }:$Dn, DPR:{ *:[f64] }:$Dm)  =>  (VFP_VMAXNMD:{ *:[f64] } DPR:{ *:[f64] }:$Dn, DPR:{ *:[f64] }:$Dm)
     /* 120265 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(ARM::VFP_VMAXNMD),
     /* 120270 */   GIR_RootConstrainSelectedInstOperands,
     /* 120271 */   // GIR_Coverage, 641,
     /* 120271 */   GIR_Done,
     /* 120272 */ // Label 2354: @120272
     /* 120272 */ GIM_Reject,
     /* 120273 */ // Label 2347: @120273
     /* 120273 */ GIM_Try, /*On fail goto*//*Label 2355*/ GIMT_Encode4(120306), // Rule ID 1210 //
     /* 120278 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8_HasNEON),
     /* 120281 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 120284 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 120287 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 120291 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 120295 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 120299 */   // (fmaxnum:{ *:[v2f32] } DPR:{ *:[v2f32] }:$Vn, DPR:{ *:[v2f32] }:$Vm)  =>  (NEON_VMAXNMNDf:{ *:[v2f32] } DPR:{ *:[v2f32] }:$Vn, DPR:{ *:[v2f32] }:$Vm)
     /* 120299 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(ARM::NEON_VMAXNMNDf),
     /* 120304 */   GIR_RootConstrainSelectedInstOperands,
     /* 120305 */   // GIR_Coverage, 1210,
     /* 120305 */   GIR_Done,
     /* 120306 */ // Label 2355: @120306
     /* 120306 */ GIM_Reject,
     /* 120307 */ // Label 2348: @120307
     /* 120307 */ GIM_Try, /*On fail goto*//*Label 2356*/ GIMT_Encode4(120340), // Rule ID 1212 //
     /* 120312 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8_HasFullFP16_HasNEON),
     /* 120315 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 120318 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 120321 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 120325 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 120329 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 120333 */   // (fmaxnum:{ *:[v4f16] } DPR:{ *:[v4f16] }:$Vn, DPR:{ *:[v4f16] }:$Vm)  =>  (NEON_VMAXNMNDh:{ *:[v4f16] } DPR:{ *:[v4f16] }:$Vn, DPR:{ *:[v4f16] }:$Vm)
     /* 120333 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(ARM::NEON_VMAXNMNDh),
     /* 120338 */   GIR_RootConstrainSelectedInstOperands,
     /* 120339 */   // GIR_Coverage, 1212,
     /* 120339 */   GIR_Done,
     /* 120340 */ // Label 2356: @120340
     /* 120340 */ GIM_Reject,
     /* 120341 */ // Label 2349: @120341
     /* 120341 */ GIM_Try, /*On fail goto*//*Label 2357*/ GIMT_Encode4(120519),
     /* 120346 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 120349 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 120352 */   GIM_Try, /*On fail goto*//*Label 2358*/ GIMT_Encode4(120430), // Rule ID 4115 //
     /* 120357 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 120360 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 120364 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 120368 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 120372 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 120376 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 120381 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 120385 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 120389 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 120393 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 120398 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 120400 */     // (fmaxnum:{ *:[v4f32] } (fabs:{ *:[v4f32] } MQPR:{ *:[v4f32] }:$Qd), (fabs:{ *:[v4f32] } MQPR:{ *:[v4f32] }:$Qm))  =>  (MVE_VMAXNMAf32:{ *:[v4f32] } MQPR:{ *:[v4f32] }:$Qd, MQPR:{ *:[v4f32] }:$Qm)
     /* 120400 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMAXNMAf32),
     /* 120403 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 120405 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Qd
     /* 120409 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Qm
     /* 120413 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 120416 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 120422 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 120428 */     GIR_RootConstrainSelectedInstOperands,
     /* 120429 */     // GIR_Coverage, 4115,
     /* 120429 */     GIR_EraseRootFromParent_Done,
     /* 120430 */   // Label 2358: @120430
     /* 120430 */   GIM_Try, /*On fail goto*//*Label 2359*/ GIMT_Encode4(120457), // Rule ID 1211 //
     /* 120435 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8_HasNEON),
     /* 120438 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 120442 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 120446 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 120450 */     // (fmaxnum:{ *:[v4f32] } QPR:{ *:[v4f32] }:$Vn, QPR:{ *:[v4f32] }:$Vm)  =>  (NEON_VMAXNMNQf:{ *:[v4f32] } QPR:{ *:[v4f32] }:$Vn, QPR:{ *:[v4f32] }:$Vm)
     /* 120450 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(ARM::NEON_VMAXNMNQf),
     /* 120455 */     GIR_RootConstrainSelectedInstOperands,
     /* 120456 */     // GIR_Coverage, 1211,
     /* 120456 */     GIR_Done,
     /* 120457 */   // Label 2359: @120457
     /* 120457 */   GIM_Try, /*On fail goto*//*Label 2360*/ GIMT_Encode4(120518), // Rule ID 3027 //
     /* 120462 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /* 120465 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 120469 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 120473 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 120477 */     // (fmaxnum:{ *:[v4f32] } MQPR:{ *:[v4f32] }:$Qm, MQPR:{ *:[v4f32] }:$Qn)  =>  (MVE_VMAXNMf32:{ *:[v4f32] } MQPR:{ *:[v4f32] }:$Qm, MQPR:{ *:[v4f32] }:$Qn)
     /* 120477 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 120480 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 120484 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 120489 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMAXNMf32),
     /* 120492 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 120494 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /* 120496 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /* 120498 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 120501 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 120507 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 120513 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 120516 */     GIR_RootConstrainSelectedInstOperands,
     /* 120517 */     // GIR_Coverage, 3027,
     /* 120517 */     GIR_EraseRootFromParent_Done,
     /* 120518 */   // Label 2360: @120518
     /* 120518 */   GIM_Reject,
     /* 120519 */ // Label 2357: @120519
     /* 120519 */ GIM_Reject,
     /* 120520 */ // Label 2350: @120520
     /* 120520 */ GIM_Try, /*On fail goto*//*Label 2361*/ GIMT_Encode4(120698),
     /* 120525 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 120528 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 120531 */   GIM_Try, /*On fail goto*//*Label 2362*/ GIMT_Encode4(120609), // Rule ID 4117 //
     /* 120536 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 120539 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 120543 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 120547 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 120551 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 120555 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 120560 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 120564 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 120568 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 120572 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 120577 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 120579 */     // (fmaxnum:{ *:[v8f16] } (fabs:{ *:[v8f16] } MQPR:{ *:[v8f16] }:$Qd), (fabs:{ *:[v8f16] } MQPR:{ *:[v8f16] }:$Qm))  =>  (MVE_VMAXNMAf16:{ *:[v8f16] } MQPR:{ *:[v8f16] }:$Qd, MQPR:{ *:[v8f16] }:$Qm)
     /* 120579 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMAXNMAf16),
     /* 120582 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 120584 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Qd
     /* 120588 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Qm
     /* 120592 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 120595 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 120601 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 120607 */     GIR_RootConstrainSelectedInstOperands,
     /* 120608 */     // GIR_Coverage, 4117,
     /* 120608 */     GIR_EraseRootFromParent_Done,
     /* 120609 */   // Label 2362: @120609
     /* 120609 */   GIM_Try, /*On fail goto*//*Label 2363*/ GIMT_Encode4(120636), // Rule ID 1213 //
     /* 120614 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8_HasFullFP16_HasNEON),
     /* 120617 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 120621 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 120625 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 120629 */     // (fmaxnum:{ *:[v8f16] } QPR:{ *:[v8f16] }:$Vn, QPR:{ *:[v8f16] }:$Vm)  =>  (NEON_VMAXNMNQh:{ *:[v8f16] } QPR:{ *:[v8f16] }:$Vn, QPR:{ *:[v8f16] }:$Vm)
     /* 120629 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(ARM::NEON_VMAXNMNQh),
     /* 120634 */     GIR_RootConstrainSelectedInstOperands,
     /* 120635 */     // GIR_Coverage, 1213,
     /* 120635 */     GIR_Done,
     /* 120636 */   // Label 2363: @120636
     /* 120636 */   GIM_Try, /*On fail goto*//*Label 2364*/ GIMT_Encode4(120697), // Rule ID 3282 //
     /* 120641 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /* 120644 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 120648 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 120652 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 120656 */     // (fmaxnum:{ *:[v8f16] } MQPR:{ *:[v8f16] }:$Qm, MQPR:{ *:[v8f16] }:$Qn)  =>  (MVE_VMAXNMf16:{ *:[v8f16] } MQPR:{ *:[v8f16] }:$Qm, MQPR:{ *:[v8f16] }:$Qn)
     /* 120656 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 120659 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 120663 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 120668 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMAXNMf16),
     /* 120671 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 120673 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /* 120675 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /* 120677 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 120680 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 120686 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 120692 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 120695 */     GIR_RootConstrainSelectedInstOperands,
     /* 120696 */     // GIR_Coverage, 3282,
     /* 120696 */     GIR_EraseRootFromParent_Done,
     /* 120697 */   // Label 2364: @120697
     /* 120697 */   GIM_Reject,
     /* 120698 */ // Label 2361: @120698
     /* 120698 */ GIM_Reject,
     /* 120699 */ // Label 2351: @120699
     /* 120699 */ GIM_Reject,
     /* 120700 */ // Label 49: @120700
     /* 120700 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(13), /*)*//*default:*//*Label 2371*/ GIMT_Encode4(121433),
     /* 120711 */ /*GILLT_s16*//*Label 2365*/ GIMT_Encode4(120763),
     /* 120715 */ /*GILLT_s32*//*Label 2366*/ GIMT_Encode4(121004), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 120727 */ /*GILLT_v2s32*//*Label 2367*/ GIMT_Encode4(121245), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 120739 */ /*GILLT_v4s16*//*Label 2368*/ GIMT_Encode4(121292),
     /* 120743 */ /*GILLT_v4s32*//*Label 2369*/ GIMT_Encode4(121339), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 120759 */ /*GILLT_v8s16*//*Label 2370*/ GIMT_Encode4(121386),
     /* 120763 */ // Label 2365: @120763
     /* 120763 */ GIM_Try, /*On fail goto*//*Label 2372*/ GIMT_Encode4(121003), // Rule ID 2704 //
     /* 120768 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 120771 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 120774 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 120777 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 120781 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 120785 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 120789 */   // (fminimum:{ *:[f16] } HPR:{ *:[f16] }:$a, HPR:{ *:[f16] }:$b)  =>  (EXTRACT_SUBREG:{ *:[f16] } (COPY_TO_REGCLASS:{ *:[v4f16] } (VMINhd:{ *:[f64] } (INSERT_SUBREG:{ *:[v4f16] } (COPY_TO_REGCLASS:{ *:[v4f16] } (IMPLICIT_DEF:{ *:[v4f16] }), DPR_VFP2:{ *:[i32] }), HPR:{ *:[f16] }:$a, ssub_0:{ *:[i32] }), (INSERT_SUBREG:{ *:[v4f16] } (COPY_TO_REGCLASS:{ *:[v4f16] } (IMPLICIT_DEF:{ *:[v4f16] }), DPR_VFP2:{ *:[i32] }), HPR:{ *:[f16] }:$b, ssub_0:{ *:[i32] })), DPR_VFP2:{ *:[i32] }), ssub_0:{ *:[i32] })
     /* 120789 */   GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_v4s16,
     /* 120792 */   GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 120796 */   GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 120801 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/8,
     /* 120803 */   GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v4s16,
     /* 120806 */   GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 120810 */   GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 120815 */   GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
     /* 120818 */   GIR_ConstrainOperandRC, /*InsnID*/7, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 120823 */   GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v4s16,
     /* 120826 */   GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 120830 */   GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 120835 */   GIR_AddSimpleTempRegister, /*InsnID*/6, /*TempRegID*/6,
     /* 120838 */   GIR_Copy, /*NewInsnID*/6, /*OldInsnID*/0, /*OpIdx*/2, // b
     /* 120842 */   GIR_AddImm8, /*InsnID*/6, /*Imm*/17,
     /* 120845 */   GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 120850 */   GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 120855 */   GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/2, GIMT_Encode2(ARM::HPRRegClassID),
     /* 120860 */   GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v4s16,
     /* 120863 */   GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 120867 */   GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 120872 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 120874 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v4s16,
     /* 120877 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 120881 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 120886 */   GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 120889 */   GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 120894 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s16,
     /* 120897 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 120901 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 120906 */   GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 120909 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // a
     /* 120913 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/17,
     /* 120916 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 120921 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 120926 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(ARM::HPRRegClassID),
     /* 120931 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 120934 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(ARM::VMINhd),
     /* 120938 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 120943 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 120946 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/5,
     /* 120949 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/14,
     /* 120952 */   GIR_AddRegister, /*InsnID*/2, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 120958 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 120960 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s16,
     /* 120963 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 120967 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 120972 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 120975 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 120980 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 120983 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 120985 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(ARM::ssub_0),
     /* 120992 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::SPRRegClassID),
     /* 120997 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 121002 */   // GIR_Coverage, 2704,
     /* 121002 */   GIR_EraseRootFromParent_Done,
     /* 121003 */ // Label 2372: @121003
     /* 121003 */ GIM_Reject,
     /* 121004 */ // Label 2366: @121004
     /* 121004 */ GIM_Try, /*On fail goto*//*Label 2373*/ GIMT_Encode4(121244), // Rule ID 2706 //
     /* 121009 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 121012 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 121015 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 121018 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 121022 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 121026 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 121030 */   // (fminimum:{ *:[f32] } SPR:{ *:[f32] }:$a, SPR:{ *:[f32] }:$b)  =>  (EXTRACT_SUBREG:{ *:[f32] } (COPY_TO_REGCLASS:{ *:[v2f32] } (VMINfd:{ *:[f64] } (INSERT_SUBREG:{ *:[v2f32] } (COPY_TO_REGCLASS:{ *:[v2f32] } (IMPLICIT_DEF:{ *:[v2f32] }), DPR_VFP2:{ *:[i32] }), SPR:{ *:[f32] }:$a, ssub_0:{ *:[i32] }), (INSERT_SUBREG:{ *:[v2f32] } (COPY_TO_REGCLASS:{ *:[v2f32] } (IMPLICIT_DEF:{ *:[v2f32] }), DPR_VFP2:{ *:[i32] }), SPR:{ *:[f32] }:$b, ssub_0:{ *:[i32] })), DPR_VFP2:{ *:[i32] }), ssub_0:{ *:[i32] })
     /* 121030 */   GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_v2s32,
     /* 121033 */   GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 121037 */   GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121042 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/8,
     /* 121044 */   GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v2s32,
     /* 121047 */   GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 121051 */   GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121056 */   GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
     /* 121059 */   GIR_ConstrainOperandRC, /*InsnID*/7, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 121064 */   GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v2s32,
     /* 121067 */   GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 121071 */   GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121076 */   GIR_AddSimpleTempRegister, /*InsnID*/6, /*TempRegID*/6,
     /* 121079 */   GIR_Copy, /*NewInsnID*/6, /*OldInsnID*/0, /*OpIdx*/2, // b
     /* 121083 */   GIR_AddImm8, /*InsnID*/6, /*Imm*/17,
     /* 121086 */   GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 121091 */   GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 121096 */   GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/2, GIMT_Encode2(ARM::SPRRegClassID),
     /* 121101 */   GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v2s32,
     /* 121104 */   GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 121108 */   GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121113 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 121115 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v2s32,
     /* 121118 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 121122 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121127 */   GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 121130 */   GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 121135 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s32,
     /* 121138 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 121142 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121147 */   GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 121150 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // a
     /* 121154 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/17,
     /* 121157 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 121162 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 121167 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(ARM::SPRRegClassID),
     /* 121172 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 121175 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(ARM::VMINfd),
     /* 121179 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121184 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 121187 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/5,
     /* 121190 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/14,
     /* 121193 */   GIR_AddRegister, /*InsnID*/2, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 121199 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 121201 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s32,
     /* 121204 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 121208 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121213 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 121216 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 121221 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 121224 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 121226 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(ARM::ssub_0),
     /* 121233 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::SPRRegClassID),
     /* 121238 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 121243 */   // GIR_Coverage, 2706,
     /* 121243 */   GIR_EraseRootFromParent_Done,
     /* 121244 */ // Label 2373: @121244
     /* 121244 */ GIM_Reject,
     /* 121245 */ // Label 2367: @121245
     /* 121245 */ GIM_Try, /*On fail goto*//*Label 2374*/ GIMT_Encode4(121291), // Rule ID 1226 //
     /* 121250 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 121253 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 121256 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 121259 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 121263 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 121267 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 121271 */   // (fminimum:{ *:[v2f32] } DPR:{ *:[v2f32] }:$Vn, DPR:{ *:[v2f32] }:$Vm)  =>  (VMINfd:{ *:[v2f32] } DPR:{ *:[v2f32] }:$Vn, DPR:{ *:[v2f32] }:$Vm)
     /* 121271 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMINfd),
     /* 121274 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 121276 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 121278 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 121280 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 121283 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 121289 */   GIR_RootConstrainSelectedInstOperands,
     /* 121290 */   // GIR_Coverage, 1226,
     /* 121290 */   GIR_EraseRootFromParent_Done,
     /* 121291 */ // Label 2374: @121291
     /* 121291 */ GIM_Reject,
     /* 121292 */ // Label 2368: @121292
     /* 121292 */ GIM_Try, /*On fail goto*//*Label 2375*/ GIMT_Encode4(121338), // Rule ID 1228 //
     /* 121297 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 121300 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 121303 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 121306 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 121310 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 121314 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 121318 */   // (fminimum:{ *:[v4f16] } DPR:{ *:[v4f16] }:$Vn, DPR:{ *:[v4f16] }:$Vm)  =>  (VMINhd:{ *:[v4f16] } DPR:{ *:[v4f16] }:$Vn, DPR:{ *:[v4f16] }:$Vm)
     /* 121318 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMINhd),
     /* 121321 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 121323 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 121325 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 121327 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 121330 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 121336 */   GIR_RootConstrainSelectedInstOperands,
     /* 121337 */   // GIR_Coverage, 1228,
     /* 121337 */   GIR_EraseRootFromParent_Done,
     /* 121338 */ // Label 2375: @121338
     /* 121338 */ GIM_Reject,
     /* 121339 */ // Label 2369: @121339
     /* 121339 */ GIM_Try, /*On fail goto*//*Label 2376*/ GIMT_Encode4(121385), // Rule ID 1227 //
     /* 121344 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 121347 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 121350 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 121353 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 121357 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 121361 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 121365 */   // (fminimum:{ *:[v4f32] } QPR:{ *:[v4f32] }:$Vn, QPR:{ *:[v4f32] }:$Vm)  =>  (VMINfq:{ *:[v4f32] } QPR:{ *:[v4f32] }:$Vn, QPR:{ *:[v4f32] }:$Vm)
     /* 121365 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMINfq),
     /* 121368 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 121370 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 121372 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 121374 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 121377 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 121383 */   GIR_RootConstrainSelectedInstOperands,
     /* 121384 */   // GIR_Coverage, 1227,
     /* 121384 */   GIR_EraseRootFromParent_Done,
     /* 121385 */ // Label 2376: @121385
     /* 121385 */ GIM_Reject,
     /* 121386 */ // Label 2370: @121386
     /* 121386 */ GIM_Try, /*On fail goto*//*Label 2377*/ GIMT_Encode4(121432), // Rule ID 1229 //
     /* 121391 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 121394 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 121397 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 121400 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 121404 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 121408 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 121412 */   // (fminimum:{ *:[v8f16] } QPR:{ *:[v8f16] }:$Vn, QPR:{ *:[v8f16] }:$Vm)  =>  (VMINhq:{ *:[v8f16] } QPR:{ *:[v8f16] }:$Vn, QPR:{ *:[v8f16] }:$Vm)
     /* 121412 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMINhq),
     /* 121415 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 121417 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 121419 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 121421 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 121424 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 121430 */   GIR_RootConstrainSelectedInstOperands,
     /* 121431 */   // GIR_Coverage, 1229,
     /* 121431 */   GIR_EraseRootFromParent_Done,
     /* 121432 */ // Label 2377: @121432
     /* 121432 */ GIM_Reject,
     /* 121433 */ // Label 2371: @121433
     /* 121433 */ GIM_Reject,
     /* 121434 */ // Label 50: @121434
     /* 121434 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(13), /*)*//*default:*//*Label 2384*/ GIMT_Encode4(122167),
     /* 121445 */ /*GILLT_s16*//*Label 2378*/ GIMT_Encode4(121497),
     /* 121449 */ /*GILLT_s32*//*Label 2379*/ GIMT_Encode4(121738), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 121461 */ /*GILLT_v2s32*//*Label 2380*/ GIMT_Encode4(121979), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 121473 */ /*GILLT_v4s16*//*Label 2381*/ GIMT_Encode4(122026),
     /* 121477 */ /*GILLT_v4s32*//*Label 2382*/ GIMT_Encode4(122073), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 121493 */ /*GILLT_v8s16*//*Label 2383*/ GIMT_Encode4(122120),
     /* 121497 */ // Label 2378: @121497
     /* 121497 */ GIM_Try, /*On fail goto*//*Label 2385*/ GIMT_Encode4(121737), // Rule ID 2703 //
     /* 121502 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 121505 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 121508 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 121511 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 121515 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 121519 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 121523 */   // (fmaximum:{ *:[f16] } HPR:{ *:[f16] }:$a, HPR:{ *:[f16] }:$b)  =>  (EXTRACT_SUBREG:{ *:[f16] } (COPY_TO_REGCLASS:{ *:[v4f16] } (VMAXhd:{ *:[f64] } (INSERT_SUBREG:{ *:[v4f16] } (COPY_TO_REGCLASS:{ *:[v4f16] } (IMPLICIT_DEF:{ *:[v4f16] }), DPR_VFP2:{ *:[i32] }), HPR:{ *:[f16] }:$a, ssub_0:{ *:[i32] }), (INSERT_SUBREG:{ *:[v4f16] } (COPY_TO_REGCLASS:{ *:[v4f16] } (IMPLICIT_DEF:{ *:[v4f16] }), DPR_VFP2:{ *:[i32] }), HPR:{ *:[f16] }:$b, ssub_0:{ *:[i32] })), DPR_VFP2:{ *:[i32] }), ssub_0:{ *:[i32] })
     /* 121523 */   GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_v4s16,
     /* 121526 */   GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 121530 */   GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121535 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/8,
     /* 121537 */   GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v4s16,
     /* 121540 */   GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 121544 */   GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121549 */   GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
     /* 121552 */   GIR_ConstrainOperandRC, /*InsnID*/7, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 121557 */   GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v4s16,
     /* 121560 */   GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 121564 */   GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121569 */   GIR_AddSimpleTempRegister, /*InsnID*/6, /*TempRegID*/6,
     /* 121572 */   GIR_Copy, /*NewInsnID*/6, /*OldInsnID*/0, /*OpIdx*/2, // b
     /* 121576 */   GIR_AddImm8, /*InsnID*/6, /*Imm*/17,
     /* 121579 */   GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 121584 */   GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 121589 */   GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/2, GIMT_Encode2(ARM::HPRRegClassID),
     /* 121594 */   GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v4s16,
     /* 121597 */   GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 121601 */   GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121606 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 121608 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v4s16,
     /* 121611 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 121615 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121620 */   GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 121623 */   GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 121628 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s16,
     /* 121631 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 121635 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121640 */   GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 121643 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // a
     /* 121647 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/17,
     /* 121650 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 121655 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 121660 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(ARM::HPRRegClassID),
     /* 121665 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 121668 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(ARM::VMAXhd),
     /* 121672 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121677 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 121680 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/5,
     /* 121683 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/14,
     /* 121686 */   GIR_AddRegister, /*InsnID*/2, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 121692 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 121694 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s16,
     /* 121697 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 121701 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121706 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 121709 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 121714 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 121717 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 121719 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(ARM::ssub_0),
     /* 121726 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::SPRRegClassID),
     /* 121731 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 121736 */   // GIR_Coverage, 2703,
     /* 121736 */   GIR_EraseRootFromParent_Done,
     /* 121737 */ // Label 2385: @121737
     /* 121737 */ GIM_Reject,
     /* 121738 */ // Label 2379: @121738
     /* 121738 */ GIM_Try, /*On fail goto*//*Label 2386*/ GIMT_Encode4(121978), // Rule ID 2705 //
     /* 121743 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 121746 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 121749 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 121752 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 121756 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 121760 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 121764 */   // (fmaximum:{ *:[f32] } SPR:{ *:[f32] }:$a, SPR:{ *:[f32] }:$b)  =>  (EXTRACT_SUBREG:{ *:[f32] } (COPY_TO_REGCLASS:{ *:[v2f32] } (VMAXfd:{ *:[f64] } (INSERT_SUBREG:{ *:[v2f32] } (COPY_TO_REGCLASS:{ *:[v2f32] } (IMPLICIT_DEF:{ *:[v2f32] }), DPR_VFP2:{ *:[i32] }), SPR:{ *:[f32] }:$a, ssub_0:{ *:[i32] }), (INSERT_SUBREG:{ *:[v2f32] } (COPY_TO_REGCLASS:{ *:[v2f32] } (IMPLICIT_DEF:{ *:[v2f32] }), DPR_VFP2:{ *:[i32] }), SPR:{ *:[f32] }:$b, ssub_0:{ *:[i32] })), DPR_VFP2:{ *:[i32] }), ssub_0:{ *:[i32] })
     /* 121764 */   GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_v2s32,
     /* 121767 */   GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 121771 */   GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121776 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/8,
     /* 121778 */   GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v2s32,
     /* 121781 */   GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 121785 */   GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121790 */   GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
     /* 121793 */   GIR_ConstrainOperandRC, /*InsnID*/7, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 121798 */   GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v2s32,
     /* 121801 */   GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 121805 */   GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121810 */   GIR_AddSimpleTempRegister, /*InsnID*/6, /*TempRegID*/6,
     /* 121813 */   GIR_Copy, /*NewInsnID*/6, /*OldInsnID*/0, /*OpIdx*/2, // b
     /* 121817 */   GIR_AddImm8, /*InsnID*/6, /*Imm*/17,
     /* 121820 */   GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 121825 */   GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 121830 */   GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/2, GIMT_Encode2(ARM::SPRRegClassID),
     /* 121835 */   GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v2s32,
     /* 121838 */   GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 121842 */   GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121847 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 121849 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v2s32,
     /* 121852 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 121856 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121861 */   GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 121864 */   GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 121869 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s32,
     /* 121872 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 121876 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121881 */   GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 121884 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // a
     /* 121888 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/17,
     /* 121891 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 121896 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 121901 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(ARM::SPRRegClassID),
     /* 121906 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 121909 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(ARM::VMAXfd),
     /* 121913 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121918 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 121921 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/5,
     /* 121924 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/14,
     /* 121927 */   GIR_AddRegister, /*InsnID*/2, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 121933 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 121935 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s32,
     /* 121938 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 121942 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121947 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 121950 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 121955 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 121958 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 121960 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(ARM::ssub_0),
     /* 121967 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::SPRRegClassID),
     /* 121972 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 121977 */   // GIR_Coverage, 2705,
     /* 121977 */   GIR_EraseRootFromParent_Done,
     /* 121978 */ // Label 2386: @121978
     /* 121978 */ GIM_Reject,
     /* 121979 */ // Label 2380: @121979
     /* 121979 */ GIM_Try, /*On fail goto*//*Label 2387*/ GIMT_Encode4(122025), // Rule ID 1206 //
     /* 121984 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 121987 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 121990 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 121993 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 121997 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 122001 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 122005 */   // (fmaximum:{ *:[v2f32] } DPR:{ *:[v2f32] }:$Vn, DPR:{ *:[v2f32] }:$Vm)  =>  (VMAXfd:{ *:[v2f32] } DPR:{ *:[v2f32] }:$Vn, DPR:{ *:[v2f32] }:$Vm)
     /* 122005 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMAXfd),
     /* 122008 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 122010 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 122012 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 122014 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 122017 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 122023 */   GIR_RootConstrainSelectedInstOperands,
     /* 122024 */   // GIR_Coverage, 1206,
     /* 122024 */   GIR_EraseRootFromParent_Done,
     /* 122025 */ // Label 2387: @122025
     /* 122025 */ GIM_Reject,
     /* 122026 */ // Label 2381: @122026
     /* 122026 */ GIM_Try, /*On fail goto*//*Label 2388*/ GIMT_Encode4(122072), // Rule ID 1208 //
     /* 122031 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 122034 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 122037 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 122040 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 122044 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 122048 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 122052 */   // (fmaximum:{ *:[v4f16] } DPR:{ *:[v4f16] }:$Vn, DPR:{ *:[v4f16] }:$Vm)  =>  (VMAXhd:{ *:[v4f16] } DPR:{ *:[v4f16] }:$Vn, DPR:{ *:[v4f16] }:$Vm)
     /* 122052 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMAXhd),
     /* 122055 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 122057 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 122059 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 122061 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 122064 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 122070 */   GIR_RootConstrainSelectedInstOperands,
     /* 122071 */   // GIR_Coverage, 1208,
     /* 122071 */   GIR_EraseRootFromParent_Done,
     /* 122072 */ // Label 2388: @122072
     /* 122072 */ GIM_Reject,
     /* 122073 */ // Label 2382: @122073
     /* 122073 */ GIM_Try, /*On fail goto*//*Label 2389*/ GIMT_Encode4(122119), // Rule ID 1207 //
     /* 122078 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 122081 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 122084 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 122087 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 122091 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 122095 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 122099 */   // (fmaximum:{ *:[v4f32] } QPR:{ *:[v4f32] }:$Vn, QPR:{ *:[v4f32] }:$Vm)  =>  (VMAXfq:{ *:[v4f32] } QPR:{ *:[v4f32] }:$Vn, QPR:{ *:[v4f32] }:$Vm)
     /* 122099 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMAXfq),
     /* 122102 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 122104 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 122106 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 122108 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 122111 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 122117 */   GIR_RootConstrainSelectedInstOperands,
     /* 122118 */   // GIR_Coverage, 1207,
     /* 122118 */   GIR_EraseRootFromParent_Done,
     /* 122119 */ // Label 2389: @122119
     /* 122119 */ GIM_Reject,
     /* 122120 */ // Label 2383: @122120
     /* 122120 */ GIM_Try, /*On fail goto*//*Label 2390*/ GIMT_Encode4(122166), // Rule ID 1209 //
     /* 122125 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 122128 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 122131 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 122134 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 122138 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 122142 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 122146 */   // (fmaximum:{ *:[v8f16] } QPR:{ *:[v8f16] }:$Vn, QPR:{ *:[v8f16] }:$Vm)  =>  (VMAXhq:{ *:[v8f16] } QPR:{ *:[v8f16] }:$Vn, QPR:{ *:[v8f16] }:$Vm)
     /* 122146 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMAXhq),
     /* 122149 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 122151 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 122153 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 122155 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 122158 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 122164 */   GIR_RootConstrainSelectedInstOperands,
     /* 122165 */   // GIR_Coverage, 1209,
     /* 122165 */   GIR_EraseRootFromParent_Done,
     /* 122166 */ // Label 2390: @122166
     /* 122166 */ GIM_Reject,
     /* 122167 */ // Label 2384: @122167
     /* 122167 */ GIM_Reject,
     /* 122168 */ // Label 51: @122168
     /* 122168 */ GIM_Try, /*On fail goto*//*Label 2391*/ GIMT_Encode4(122200), // Rule ID 2416 //
     /* 122173 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 122176 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /* 122180 */   // (get_fpenv:{ *:[i32] })  =>  (VMRS:{ *:[i32] })
     /* 122180 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMRS),
     /* 122183 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 122185 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 122188 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 122194 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 122198 */   GIR_RootConstrainSelectedInstOperands,
     /* 122199 */   // GIR_Coverage, 2416,
     /* 122199 */   GIR_EraseRootFromParent_Done,
     /* 122200 */ // Label 2391: @122200
     /* 122200 */ GIM_Reject,
     /* 122201 */ // Label 52: @122201
     /* 122201 */ GIM_Try, /*On fail goto*//*Label 2392*/ GIMT_Encode4(122236), // Rule ID 2417 //
     /* 122206 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 122209 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /* 122213 */   // (set_fpenv GPRnopc:{ *:[i32] }:$Rt)  =>  (VMSR:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rt)
     /* 122213 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMSR),
     /* 122216 */   GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 122218 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 122221 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 122227 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for ARM::FPSCR*/0,
     /* 122230 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 122234 */   GIR_RootConstrainSelectedInstOperands,
     /* 122235 */   // GIR_Coverage, 2417,
     /* 122235 */   GIR_EraseRootFromParent_Done,
     /* 122236 */ // Label 2392: @122236
     /* 122236 */ GIM_Reject,
     /* 122237 */ // Label 53: @122237
     /* 122237 */ GIM_Try, /*On fail goto*//*Label 2393*/ GIMT_Encode4(122301), // Rule ID 2418 //
     /* 122242 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /* 122245 */   // (reset_fpenv)  =>  (VMSR:{ *:[i32] } (MOVi:{ *:[i32] } 0:{ *:[i32] }))
     /* 122245 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 122248 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::MOVi),
     /* 122252 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 122257 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 122260 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/14,
     /* 122263 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 122269 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 122275 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 122277 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMSR),
     /* 122280 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 122283 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 122286 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 122292 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for ARM::FPSCR*/0,
     /* 122295 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 122299 */   GIR_RootConstrainSelectedInstOperands,
     /* 122300 */   // GIR_Coverage, 2418,
     /* 122300 */   GIR_EraseRootFromParent_Done,
     /* 122301 */ // Label 2393: @122301
     /* 122301 */ GIM_Try, /*On fail goto*//*Label 2394*/ GIMT_Encode4(122365), // Rule ID 2419 //
     /* 122306 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb),
     /* 122309 */   // (reset_fpenv)  =>  (VMSR:{ *:[i32] } (tMOVi8:{ *:[i32] } 0:{ *:[i32] }))
     /* 122309 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 122312 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::tMOVi8),
     /* 122316 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 122321 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::CPSR), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define | RegState::Dead),
     /* 122327 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 122330 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/14,
     /* 122333 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 122339 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 122341 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMSR),
     /* 122344 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 122347 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 122350 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 122356 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for ARM::FPSCR*/0,
     /* 122359 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 122363 */   GIR_RootConstrainSelectedInstOperands,
     /* 122364 */   // GIR_Coverage, 2419,
     /* 122364 */   GIR_EraseRootFromParent_Done,
     /* 122365 */ // Label 2394: @122365
     /* 122365 */ GIM_Reject,
     /* 122366 */ // Label 54: @122366
     /* 122366 */ GIM_Try, /*On fail goto*//*Label 2395*/ GIMT_Encode4(122398), // Rule ID 2420 //
     /* 122371 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 122374 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /* 122378 */   // (get_fpmode:{ *:[i32] })  =>  (VMRS:{ *:[i32] })
     /* 122378 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMRS),
     /* 122381 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 122383 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 122386 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 122392 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 122396 */   GIR_RootConstrainSelectedInstOperands,
     /* 122397 */   // GIR_Coverage, 2420,
     /* 122397 */   GIR_EraseRootFromParent_Done,
     /* 122398 */ // Label 2395: @122398
     /* 122398 */ GIM_Reject,
     /* 122399 */ // Label 55: @122399
     /* 122399 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(4), GIMT_Encode2(16), /*)*//*default:*//*Label 2402*/ GIMT_Encode4(122941),
     /* 122410 */ /*GILLT_v2s32*//*Label 2396*/ GIMT_Encode4(122458), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 122422 */ /*GILLT_v4s16*//*Label 2397*/ GIMT_Encode4(122505),
     /* 122426 */ /*GILLT_v4s32*//*Label 2398*/ GIMT_Encode4(122552), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 122438 */ /*GILLT_v8s8*//*Label 2399*/ GIMT_Encode4(122666),
     /* 122442 */ /*GILLT_v8s16*//*Label 2400*/ GIMT_Encode4(122713), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 122454 */ /*GILLT_v16s8*//*Label 2401*/ GIMT_Encode4(122827),
     /* 122458 */ // Label 2396: @122458
     /* 122458 */ GIM_Try, /*On fail goto*//*Label 2403*/ GIMT_Encode4(122504), // Rule ID 1215 //
     /* 122463 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 122466 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 122469 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 122472 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 122476 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 122480 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 122484 */   // (smin:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)  =>  (VMINsv2i32:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /* 122484 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMINsv2i32),
     /* 122487 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 122489 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 122491 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 122493 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 122496 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 122502 */   GIR_RootConstrainSelectedInstOperands,
     /* 122503 */   // GIR_Coverage, 1215,
     /* 122503 */   GIR_EraseRootFromParent_Done,
     /* 122504 */ // Label 2403: @122504
     /* 122504 */ GIM_Reject,
     /* 122505 */ // Label 2397: @122505
     /* 122505 */ GIM_Try, /*On fail goto*//*Label 2404*/ GIMT_Encode4(122551), // Rule ID 1214 //
     /* 122510 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 122513 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 122516 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 122519 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 122523 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 122527 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 122531 */   // (smin:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)  =>  (VMINsv4i16:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /* 122531 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMINsv4i16),
     /* 122534 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 122536 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 122538 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 122540 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 122543 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 122549 */   GIR_RootConstrainSelectedInstOperands,
     /* 122550 */   // GIR_Coverage, 1214,
     /* 122550 */   GIR_EraseRootFromParent_Done,
     /* 122551 */ // Label 2404: @122551
     /* 122551 */ GIM_Reject,
     /* 122552 */ // Label 2398: @122552
     /* 122552 */ GIM_Try, /*On fail goto*//*Label 2405*/ GIMT_Encode4(122665),
     /* 122557 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 122560 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 122563 */   GIM_Try, /*On fail goto*//*Label 2406*/ GIMT_Encode4(122603), // Rule ID 1217 //
     /* 122568 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 122571 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 122575 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 122579 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 122583 */     // (smin:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)  =>  (VMINsv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)
     /* 122583 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMINsv4i32),
     /* 122586 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 122588 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 122590 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 122592 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 122595 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 122601 */     GIR_RootConstrainSelectedInstOperands,
     /* 122602 */     // GIR_Coverage, 1217,
     /* 122602 */     GIR_EraseRootFromParent_Done,
     /* 122603 */   // Label 2406: @122603
     /* 122603 */   GIM_Try, /*On fail goto*//*Label 2407*/ GIMT_Encode4(122664), // Rule ID 3297 //
     /* 122608 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 122611 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 122615 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 122619 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 122623 */     // (smin:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)  =>  (MVE_VMINs32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)
     /* 122623 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 122626 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 122630 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 122635 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMINs32),
     /* 122638 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 122640 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /* 122642 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /* 122644 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 122647 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 122653 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 122659 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 122662 */     GIR_RootConstrainSelectedInstOperands,
     /* 122663 */     // GIR_Coverage, 3297,
     /* 122663 */     GIR_EraseRootFromParent_Done,
     /* 122664 */   // Label 2407: @122664
     /* 122664 */   GIM_Reject,
     /* 122665 */ // Label 2405: @122665
     /* 122665 */ GIM_Reject,
     /* 122666 */ // Label 2399: @122666
     /* 122666 */ GIM_Try, /*On fail goto*//*Label 2408*/ GIMT_Encode4(122712), // Rule ID 1218 //
     /* 122671 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 122674 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 122677 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 122680 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 122684 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 122688 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 122692 */   // (smin:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)  =>  (VMINsv8i8:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /* 122692 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMINsv8i8),
     /* 122695 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 122697 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 122699 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 122701 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 122704 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 122710 */   GIR_RootConstrainSelectedInstOperands,
     /* 122711 */   // GIR_Coverage, 1218,
     /* 122711 */   GIR_EraseRootFromParent_Done,
     /* 122712 */ // Label 2408: @122712
     /* 122712 */ GIM_Reject,
     /* 122713 */ // Label 2400: @122713
     /* 122713 */ GIM_Try, /*On fail goto*//*Label 2409*/ GIMT_Encode4(122826),
     /* 122718 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 122721 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 122724 */   GIM_Try, /*On fail goto*//*Label 2410*/ GIMT_Encode4(122764), // Rule ID 1216 //
     /* 122729 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 122732 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 122736 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 122740 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 122744 */     // (smin:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)  =>  (VMINsv8i16:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)
     /* 122744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMINsv8i16),
     /* 122747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 122749 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 122751 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 122753 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 122756 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 122762 */     GIR_RootConstrainSelectedInstOperands,
     /* 122763 */     // GIR_Coverage, 1216,
     /* 122763 */     GIR_EraseRootFromParent_Done,
     /* 122764 */   // Label 2410: @122764
     /* 122764 */   GIM_Try, /*On fail goto*//*Label 2411*/ GIMT_Encode4(122825), // Rule ID 3294 //
     /* 122769 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 122772 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 122776 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 122780 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 122784 */     // (smin:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)  =>  (MVE_VMINs16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)
     /* 122784 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 122787 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 122791 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 122796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMINs16),
     /* 122799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 122801 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /* 122803 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /* 122805 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 122808 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 122814 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 122820 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 122823 */     GIR_RootConstrainSelectedInstOperands,
     /* 122824 */     // GIR_Coverage, 3294,
     /* 122824 */     GIR_EraseRootFromParent_Done,
     /* 122825 */   // Label 2411: @122825
     /* 122825 */   GIM_Reject,
     /* 122826 */ // Label 2409: @122826
     /* 122826 */ GIM_Reject,
     /* 122827 */ // Label 2401: @122827
     /* 122827 */ GIM_Try, /*On fail goto*//*Label 2412*/ GIMT_Encode4(122940),
     /* 122832 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 122835 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 122838 */   GIM_Try, /*On fail goto*//*Label 2413*/ GIMT_Encode4(122878), // Rule ID 1219 //
     /* 122843 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 122846 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 122850 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 122854 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 122858 */     // (smin:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)  =>  (VMINsv16i8:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)
     /* 122858 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMINsv16i8),
     /* 122861 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 122863 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 122865 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 122867 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 122870 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 122876 */     GIR_RootConstrainSelectedInstOperands,
     /* 122877 */     // GIR_Coverage, 1219,
     /* 122877 */     GIR_EraseRootFromParent_Done,
     /* 122878 */   // Label 2413: @122878
     /* 122878 */   GIM_Try, /*On fail goto*//*Label 2414*/ GIMT_Encode4(122939), // Rule ID 3291 //
     /* 122883 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 122886 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 122890 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 122894 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 122898 */     // (smin:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)  =>  (MVE_VMINs8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)
     /* 122898 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 122901 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 122905 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 122910 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMINs8),
     /* 122913 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 122915 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /* 122917 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /* 122919 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 122922 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 122928 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 122934 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 122937 */     GIR_RootConstrainSelectedInstOperands,
     /* 122938 */     // GIR_Coverage, 3291,
     /* 122938 */     GIR_EraseRootFromParent_Done,
     /* 122939 */   // Label 2414: @122939
     /* 122939 */   GIM_Reject,
     /* 122940 */ // Label 2412: @122940
     /* 122940 */ GIM_Reject,
     /* 122941 */ // Label 2402: @122941
     /* 122941 */ GIM_Reject,
     /* 122942 */ // Label 56: @122942
     /* 122942 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(4), GIMT_Encode2(16), /*)*//*default:*//*Label 2421*/ GIMT_Encode4(123484),
     /* 122953 */ /*GILLT_v2s32*//*Label 2415*/ GIMT_Encode4(123001), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 122965 */ /*GILLT_v4s16*//*Label 2416*/ GIMT_Encode4(123048),
     /* 122969 */ /*GILLT_v4s32*//*Label 2417*/ GIMT_Encode4(123095), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 122981 */ /*GILLT_v8s8*//*Label 2418*/ GIMT_Encode4(123209),
     /* 122985 */ /*GILLT_v8s16*//*Label 2419*/ GIMT_Encode4(123256), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 122997 */ /*GILLT_v16s8*//*Label 2420*/ GIMT_Encode4(123370),
     /* 123001 */ // Label 2415: @123001
     /* 123001 */ GIM_Try, /*On fail goto*//*Label 2422*/ GIMT_Encode4(123047), // Rule ID 1195 //
     /* 123006 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 123009 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 123012 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 123015 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 123019 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 123023 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 123027 */   // (smax:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)  =>  (VMAXsv2i32:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /* 123027 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMAXsv2i32),
     /* 123030 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 123032 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 123034 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 123036 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 123039 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 123045 */   GIR_RootConstrainSelectedInstOperands,
     /* 123046 */   // GIR_Coverage, 1195,
     /* 123046 */   GIR_EraseRootFromParent_Done,
     /* 123047 */ // Label 2422: @123047
     /* 123047 */ GIM_Reject,
     /* 123048 */ // Label 2416: @123048
     /* 123048 */ GIM_Try, /*On fail goto*//*Label 2423*/ GIMT_Encode4(123094), // Rule ID 1194 //
     /* 123053 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 123056 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 123059 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 123062 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 123066 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 123070 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 123074 */   // (smax:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)  =>  (VMAXsv4i16:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /* 123074 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMAXsv4i16),
     /* 123077 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 123079 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 123081 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 123083 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 123086 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 123092 */   GIR_RootConstrainSelectedInstOperands,
     /* 123093 */   // GIR_Coverage, 1194,
     /* 123093 */   GIR_EraseRootFromParent_Done,
     /* 123094 */ // Label 2423: @123094
     /* 123094 */ GIM_Reject,
     /* 123095 */ // Label 2417: @123095
     /* 123095 */ GIM_Try, /*On fail goto*//*Label 2424*/ GIMT_Encode4(123208),
     /* 123100 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 123103 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 123106 */   GIM_Try, /*On fail goto*//*Label 2425*/ GIMT_Encode4(123146), // Rule ID 1197 //
     /* 123111 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 123114 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 123118 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 123122 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 123126 */     // (smax:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)  =>  (VMAXsv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)
     /* 123126 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMAXsv4i32),
     /* 123129 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 123131 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 123133 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 123135 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 123138 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 123144 */     GIR_RootConstrainSelectedInstOperands,
     /* 123145 */     // GIR_Coverage, 1197,
     /* 123145 */     GIR_EraseRootFromParent_Done,
     /* 123146 */   // Label 2425: @123146
     /* 123146 */   GIM_Try, /*On fail goto*//*Label 2426*/ GIMT_Encode4(123207), // Rule ID 3315 //
     /* 123151 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 123154 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 123158 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 123162 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 123166 */     // (smax:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)  =>  (MVE_VMAXs32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)
     /* 123166 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 123169 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 123173 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 123178 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMAXs32),
     /* 123181 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 123183 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /* 123185 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /* 123187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 123190 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 123196 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 123202 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 123205 */     GIR_RootConstrainSelectedInstOperands,
     /* 123206 */     // GIR_Coverage, 3315,
     /* 123206 */     GIR_EraseRootFromParent_Done,
     /* 123207 */   // Label 2426: @123207
     /* 123207 */   GIM_Reject,
     /* 123208 */ // Label 2424: @123208
     /* 123208 */ GIM_Reject,
     /* 123209 */ // Label 2418: @123209
     /* 123209 */ GIM_Try, /*On fail goto*//*Label 2427*/ GIMT_Encode4(123255), // Rule ID 1198 //
     /* 123214 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 123217 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 123220 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 123223 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 123227 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 123231 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 123235 */   // (smax:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)  =>  (VMAXsv8i8:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /* 123235 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMAXsv8i8),
     /* 123238 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 123240 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 123242 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 123244 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 123247 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 123253 */   GIR_RootConstrainSelectedInstOperands,
     /* 123254 */   // GIR_Coverage, 1198,
     /* 123254 */   GIR_EraseRootFromParent_Done,
     /* 123255 */ // Label 2427: @123255
     /* 123255 */ GIM_Reject,
     /* 123256 */ // Label 2419: @123256
     /* 123256 */ GIM_Try, /*On fail goto*//*Label 2428*/ GIMT_Encode4(123369),
     /* 123261 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 123264 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 123267 */   GIM_Try, /*On fail goto*//*Label 2429*/ GIMT_Encode4(123307), // Rule ID 1196 //
     /* 123272 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 123275 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 123279 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 123283 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 123287 */     // (smax:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)  =>  (VMAXsv8i16:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)
     /* 123287 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMAXsv8i16),
     /* 123290 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 123292 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 123294 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 123296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 123299 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 123305 */     GIR_RootConstrainSelectedInstOperands,
     /* 123306 */     // GIR_Coverage, 1196,
     /* 123306 */     GIR_EraseRootFromParent_Done,
     /* 123307 */   // Label 2429: @123307
     /* 123307 */   GIM_Try, /*On fail goto*//*Label 2430*/ GIMT_Encode4(123368), // Rule ID 3312 //
     /* 123312 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 123315 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 123319 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 123323 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 123327 */     // (smax:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)  =>  (MVE_VMAXs16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)
     /* 123327 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 123330 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 123334 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 123339 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMAXs16),
     /* 123342 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 123344 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /* 123346 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /* 123348 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 123351 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 123357 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 123363 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 123366 */     GIR_RootConstrainSelectedInstOperands,
     /* 123367 */     // GIR_Coverage, 3312,
     /* 123367 */     GIR_EraseRootFromParent_Done,
     /* 123368 */   // Label 2430: @123368
     /* 123368 */   GIM_Reject,
     /* 123369 */ // Label 2428: @123369
     /* 123369 */ GIM_Reject,
     /* 123370 */ // Label 2420: @123370
     /* 123370 */ GIM_Try, /*On fail goto*//*Label 2431*/ GIMT_Encode4(123483),
     /* 123375 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 123378 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 123381 */   GIM_Try, /*On fail goto*//*Label 2432*/ GIMT_Encode4(123421), // Rule ID 1199 //
     /* 123386 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 123389 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 123393 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 123397 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 123401 */     // (smax:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)  =>  (VMAXsv16i8:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)
     /* 123401 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMAXsv16i8),
     /* 123404 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 123406 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 123408 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 123410 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 123413 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 123419 */     GIR_RootConstrainSelectedInstOperands,
     /* 123420 */     // GIR_Coverage, 1199,
     /* 123420 */     GIR_EraseRootFromParent_Done,
     /* 123421 */   // Label 2432: @123421
     /* 123421 */   GIM_Try, /*On fail goto*//*Label 2433*/ GIMT_Encode4(123482), // Rule ID 3309 //
     /* 123426 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 123429 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 123433 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 123437 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 123441 */     // (smax:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)  =>  (MVE_VMAXs8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)
     /* 123441 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 123444 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 123448 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 123453 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMAXs8),
     /* 123456 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 123458 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /* 123460 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /* 123462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 123465 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 123471 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 123477 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 123480 */     GIR_RootConstrainSelectedInstOperands,
     /* 123481 */     // GIR_Coverage, 3309,
     /* 123481 */     GIR_EraseRootFromParent_Done,
     /* 123482 */   // Label 2433: @123482
     /* 123482 */   GIM_Reject,
     /* 123483 */ // Label 2431: @123483
     /* 123483 */ GIM_Reject,
     /* 123484 */ // Label 2421: @123484
     /* 123484 */ GIM_Reject,
     /* 123485 */ // Label 57: @123485
     /* 123485 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(4), GIMT_Encode2(16), /*)*//*default:*//*Label 2440*/ GIMT_Encode4(124405),
     /* 123496 */ /*GILLT_v2s32*//*Label 2434*/ GIMT_Encode4(123544), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 123508 */ /*GILLT_v4s16*//*Label 2435*/ GIMT_Encode4(123591),
     /* 123512 */ /*GILLT_v4s32*//*Label 2436*/ GIMT_Encode4(123638), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 123524 */ /*GILLT_v8s8*//*Label 2437*/ GIMT_Encode4(123878),
     /* 123528 */ /*GILLT_v8s16*//*Label 2438*/ GIMT_Encode4(123925), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 123540 */ /*GILLT_v16s8*//*Label 2439*/ GIMT_Encode4(124165),
     /* 123544 */ // Label 2434: @123544
     /* 123544 */ GIM_Try, /*On fail goto*//*Label 2441*/ GIMT_Encode4(123590), // Rule ID 1221 //
     /* 123549 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 123552 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 123555 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 123558 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 123562 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 123566 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 123570 */   // (umin:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)  =>  (VMINuv2i32:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /* 123570 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMINuv2i32),
     /* 123573 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 123575 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 123577 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 123579 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 123582 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 123588 */   GIR_RootConstrainSelectedInstOperands,
     /* 123589 */   // GIR_Coverage, 1221,
     /* 123589 */   GIR_EraseRootFromParent_Done,
     /* 123590 */ // Label 2441: @123590
     /* 123590 */ GIM_Reject,
     /* 123591 */ // Label 2435: @123591
     /* 123591 */ GIM_Try, /*On fail goto*//*Label 2442*/ GIMT_Encode4(123637), // Rule ID 1220 //
     /* 123596 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 123599 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 123602 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 123605 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 123609 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 123613 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 123617 */   // (umin:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)  =>  (VMINuv4i16:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /* 123617 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMINuv4i16),
     /* 123620 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 123622 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 123624 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 123626 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 123629 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 123635 */   GIR_RootConstrainSelectedInstOperands,
     /* 123636 */   // GIR_Coverage, 1220,
     /* 123636 */   GIR_EraseRootFromParent_Done,
     /* 123637 */ // Label 2442: @123637
     /* 123637 */ GIM_Reject,
     /* 123638 */ // Label 2436: @123638
     /* 123638 */ GIM_Try, /*On fail goto*//*Label 2443*/ GIMT_Encode4(123877),
     /* 123643 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 123646 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 123649 */   GIM_Try, /*On fail goto*//*Label 2444*/ GIMT_Encode4(123712), // Rule ID 6024 //
     /* 123654 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 123657 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 123661 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 123665 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ABS),
     /* 123669 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 123673 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 123678 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 123682 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 123684 */     // (umin:{ *:[v4i32] } (abs:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm), MQPR:{ *:[v4i32] }:$Qd)  =>  (MVE_VMINAs32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qd, MQPR:{ *:[v4i32] }:$Qm)
     /* 123684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMINAs32),
     /* 123687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 123689 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qd
     /* 123691 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Qm
     /* 123695 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 123698 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 123704 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 123710 */     GIR_RootConstrainSelectedInstOperands,
     /* 123711 */     // GIR_Coverage, 6024,
     /* 123711 */     GIR_EraseRootFromParent_Done,
     /* 123712 */   // Label 2444: @123712
     /* 123712 */   GIM_Try, /*On fail goto*//*Label 2445*/ GIMT_Encode4(123775), // Rule ID 3694 //
     /* 123717 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 123720 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 123724 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 123728 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 123732 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ABS),
     /* 123736 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 123740 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 123745 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 123747 */     // (umin:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qd, (abs:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm))  =>  (MVE_VMINAs32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qd, MQPR:{ *:[v4i32] }:$Qm)
     /* 123747 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMINAs32),
     /* 123750 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 123752 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qd
     /* 123754 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Qm
     /* 123758 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 123761 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 123767 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 123773 */     GIR_RootConstrainSelectedInstOperands,
     /* 123774 */     // GIR_Coverage, 3694,
     /* 123774 */     GIR_EraseRootFromParent_Done,
     /* 123775 */   // Label 2445: @123775
     /* 123775 */   GIM_Try, /*On fail goto*//*Label 2446*/ GIMT_Encode4(123815), // Rule ID 1223 //
     /* 123780 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 123783 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 123787 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 123791 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 123795 */     // (umin:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)  =>  (VMINuv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)
     /* 123795 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMINuv4i32),
     /* 123798 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 123800 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 123802 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 123804 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 123807 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 123813 */     GIR_RootConstrainSelectedInstOperands,
     /* 123814 */     // GIR_Coverage, 1223,
     /* 123814 */     GIR_EraseRootFromParent_Done,
     /* 123815 */   // Label 2446: @123815
     /* 123815 */   GIM_Try, /*On fail goto*//*Label 2447*/ GIMT_Encode4(123876), // Rule ID 3306 //
     /* 123820 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 123823 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 123827 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 123831 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 123835 */     // (umin:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)  =>  (MVE_VMINu32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)
     /* 123835 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 123838 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 123842 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 123847 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMINu32),
     /* 123850 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 123852 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /* 123854 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /* 123856 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 123859 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 123865 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 123871 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 123874 */     GIR_RootConstrainSelectedInstOperands,
     /* 123875 */     // GIR_Coverage, 3306,
     /* 123875 */     GIR_EraseRootFromParent_Done,
     /* 123876 */   // Label 2447: @123876
     /* 123876 */   GIM_Reject,
     /* 123877 */ // Label 2443: @123877
     /* 123877 */ GIM_Reject,
     /* 123878 */ // Label 2437: @123878
     /* 123878 */ GIM_Try, /*On fail goto*//*Label 2448*/ GIMT_Encode4(123924), // Rule ID 1224 //
     /* 123883 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 123886 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 123889 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 123892 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 123896 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 123900 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 123904 */   // (umin:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)  =>  (VMINuv8i8:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /* 123904 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMINuv8i8),
     /* 123907 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 123909 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 123911 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 123913 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 123916 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 123922 */   GIR_RootConstrainSelectedInstOperands,
     /* 123923 */   // GIR_Coverage, 1224,
     /* 123923 */   GIR_EraseRootFromParent_Done,
     /* 123924 */ // Label 2448: @123924
     /* 123924 */ GIM_Reject,
     /* 123925 */ // Label 2438: @123925
     /* 123925 */ GIM_Try, /*On fail goto*//*Label 2449*/ GIMT_Encode4(124164),
     /* 123930 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 123933 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 123936 */   GIM_Try, /*On fail goto*//*Label 2450*/ GIMT_Encode4(123999), // Rule ID 6023 //
     /* 123941 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 123944 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 123948 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 123952 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ABS),
     /* 123956 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 123960 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 123965 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 123969 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 123971 */     // (umin:{ *:[v8i16] } (abs:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm), MQPR:{ *:[v8i16] }:$Qd)  =>  (MVE_VMINAs16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qd, MQPR:{ *:[v8i16] }:$Qm)
     /* 123971 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMINAs16),
     /* 123974 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 123976 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qd
     /* 123978 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Qm
     /* 123982 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 123985 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 123991 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 123997 */     GIR_RootConstrainSelectedInstOperands,
     /* 123998 */     // GIR_Coverage, 6023,
     /* 123998 */     GIR_EraseRootFromParent_Done,
     /* 123999 */   // Label 2450: @123999
     /* 123999 */   GIM_Try, /*On fail goto*//*Label 2451*/ GIMT_Encode4(124062), // Rule ID 3692 //
     /* 124004 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 124007 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 124011 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 124015 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 124019 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ABS),
     /* 124023 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 124027 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 124032 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 124034 */     // (umin:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qd, (abs:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm))  =>  (MVE_VMINAs16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qd, MQPR:{ *:[v8i16] }:$Qm)
     /* 124034 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMINAs16),
     /* 124037 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 124039 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qd
     /* 124041 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Qm
     /* 124045 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 124048 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 124054 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 124060 */     GIR_RootConstrainSelectedInstOperands,
     /* 124061 */     // GIR_Coverage, 3692,
     /* 124061 */     GIR_EraseRootFromParent_Done,
     /* 124062 */   // Label 2451: @124062
     /* 124062 */   GIM_Try, /*On fail goto*//*Label 2452*/ GIMT_Encode4(124102), // Rule ID 1222 //
     /* 124067 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 124070 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 124074 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 124078 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 124082 */     // (umin:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)  =>  (VMINuv8i16:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)
     /* 124082 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMINuv8i16),
     /* 124085 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 124087 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 124089 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 124091 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 124094 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 124100 */     GIR_RootConstrainSelectedInstOperands,
     /* 124101 */     // GIR_Coverage, 1222,
     /* 124101 */     GIR_EraseRootFromParent_Done,
     /* 124102 */   // Label 2452: @124102
     /* 124102 */   GIM_Try, /*On fail goto*//*Label 2453*/ GIMT_Encode4(124163), // Rule ID 3303 //
     /* 124107 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 124110 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 124114 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 124118 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 124122 */     // (umin:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)  =>  (MVE_VMINu16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)
     /* 124122 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 124125 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 124129 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 124134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMINu16),
     /* 124137 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 124139 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /* 124141 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /* 124143 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 124146 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 124152 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 124158 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 124161 */     GIR_RootConstrainSelectedInstOperands,
     /* 124162 */     // GIR_Coverage, 3303,
     /* 124162 */     GIR_EraseRootFromParent_Done,
     /* 124163 */   // Label 2453: @124163
     /* 124163 */   GIM_Reject,
     /* 124164 */ // Label 2449: @124164
     /* 124164 */ GIM_Reject,
     /* 124165 */ // Label 2439: @124165
     /* 124165 */ GIM_Try, /*On fail goto*//*Label 2454*/ GIMT_Encode4(124404),
     /* 124170 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 124173 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 124176 */   GIM_Try, /*On fail goto*//*Label 2455*/ GIMT_Encode4(124239), // Rule ID 6022 //
     /* 124181 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 124184 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 124188 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 124192 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ABS),
     /* 124196 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 124200 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 124205 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 124209 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 124211 */     // (umin:{ *:[v16i8] } (abs:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm), MQPR:{ *:[v16i8] }:$Qd)  =>  (MVE_VMINAs8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qd, MQPR:{ *:[v16i8] }:$Qm)
     /* 124211 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMINAs8),
     /* 124214 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 124216 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qd
     /* 124218 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Qm
     /* 124222 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 124225 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 124231 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 124237 */     GIR_RootConstrainSelectedInstOperands,
     /* 124238 */     // GIR_Coverage, 6022,
     /* 124238 */     GIR_EraseRootFromParent_Done,
     /* 124239 */   // Label 2455: @124239
     /* 124239 */   GIM_Try, /*On fail goto*//*Label 2456*/ GIMT_Encode4(124302), // Rule ID 3690 //
     /* 124244 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 124247 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 124251 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 124255 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 124259 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ABS),
     /* 124263 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 124267 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 124272 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 124274 */     // (umin:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qd, (abs:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm))  =>  (MVE_VMINAs8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qd, MQPR:{ *:[v16i8] }:$Qm)
     /* 124274 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMINAs8),
     /* 124277 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 124279 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qd
     /* 124281 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Qm
     /* 124285 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 124288 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 124294 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 124300 */     GIR_RootConstrainSelectedInstOperands,
     /* 124301 */     // GIR_Coverage, 3690,
     /* 124301 */     GIR_EraseRootFromParent_Done,
     /* 124302 */   // Label 2456: @124302
     /* 124302 */   GIM_Try, /*On fail goto*//*Label 2457*/ GIMT_Encode4(124342), // Rule ID 1225 //
     /* 124307 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 124310 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 124314 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 124318 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 124322 */     // (umin:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)  =>  (VMINuv16i8:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)
     /* 124322 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMINuv16i8),
     /* 124325 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 124327 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 124329 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 124331 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 124334 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 124340 */     GIR_RootConstrainSelectedInstOperands,
     /* 124341 */     // GIR_Coverage, 1225,
     /* 124341 */     GIR_EraseRootFromParent_Done,
     /* 124342 */   // Label 2457: @124342
     /* 124342 */   GIM_Try, /*On fail goto*//*Label 2458*/ GIMT_Encode4(124403), // Rule ID 3300 //
     /* 124347 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 124350 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 124354 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 124358 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 124362 */     // (umin:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)  =>  (MVE_VMINu8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)
     /* 124362 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 124365 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 124369 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 124374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMINu8),
     /* 124377 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 124379 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /* 124381 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /* 124383 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 124386 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 124392 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 124398 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 124401 */     GIR_RootConstrainSelectedInstOperands,
     /* 124402 */     // GIR_Coverage, 3300,
     /* 124402 */     GIR_EraseRootFromParent_Done,
     /* 124403 */   // Label 2458: @124403
     /* 124403 */   GIM_Reject,
     /* 124404 */ // Label 2454: @124404
     /* 124404 */ GIM_Reject,
     /* 124405 */ // Label 2440: @124405
     /* 124405 */ GIM_Reject,
     /* 124406 */ // Label 58: @124406
     /* 124406 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(4), GIMT_Encode2(16), /*)*//*default:*//*Label 2465*/ GIMT_Encode4(125326),
     /* 124417 */ /*GILLT_v2s32*//*Label 2459*/ GIMT_Encode4(124465), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 124429 */ /*GILLT_v4s16*//*Label 2460*/ GIMT_Encode4(124512),
     /* 124433 */ /*GILLT_v4s32*//*Label 2461*/ GIMT_Encode4(124559), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 124445 */ /*GILLT_v8s8*//*Label 2462*/ GIMT_Encode4(124799),
     /* 124449 */ /*GILLT_v8s16*//*Label 2463*/ GIMT_Encode4(124846), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 124461 */ /*GILLT_v16s8*//*Label 2464*/ GIMT_Encode4(125086),
     /* 124465 */ // Label 2459: @124465
     /* 124465 */ GIM_Try, /*On fail goto*//*Label 2466*/ GIMT_Encode4(124511), // Rule ID 1201 //
     /* 124470 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 124473 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 124476 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 124479 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 124483 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 124487 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 124491 */   // (umax:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)  =>  (VMAXuv2i32:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /* 124491 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMAXuv2i32),
     /* 124494 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 124496 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 124498 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 124500 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 124503 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 124509 */   GIR_RootConstrainSelectedInstOperands,
     /* 124510 */   // GIR_Coverage, 1201,
     /* 124510 */   GIR_EraseRootFromParent_Done,
     /* 124511 */ // Label 2466: @124511
     /* 124511 */ GIM_Reject,
     /* 124512 */ // Label 2460: @124512
     /* 124512 */ GIM_Try, /*On fail goto*//*Label 2467*/ GIMT_Encode4(124558), // Rule ID 1200 //
     /* 124517 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 124520 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 124523 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 124526 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 124530 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 124534 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 124538 */   // (umax:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)  =>  (VMAXuv4i16:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /* 124538 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMAXuv4i16),
     /* 124541 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 124543 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 124545 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 124547 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 124550 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 124556 */   GIR_RootConstrainSelectedInstOperands,
     /* 124557 */   // GIR_Coverage, 1200,
     /* 124557 */   GIR_EraseRootFromParent_Done,
     /* 124558 */ // Label 2467: @124558
     /* 124558 */ GIM_Reject,
     /* 124559 */ // Label 2461: @124559
     /* 124559 */ GIM_Try, /*On fail goto*//*Label 2468*/ GIMT_Encode4(124798),
     /* 124564 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 124567 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 124570 */   GIM_Try, /*On fail goto*//*Label 2469*/ GIMT_Encode4(124633), // Rule ID 6027 //
     /* 124575 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 124578 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 124582 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 124586 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ABS),
     /* 124590 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 124594 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 124599 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 124603 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 124605 */     // (umax:{ *:[v4i32] } (abs:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm), MQPR:{ *:[v4i32] }:$Qd)  =>  (MVE_VMAXAs32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qd, MQPR:{ *:[v4i32] }:$Qm)
     /* 124605 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMAXAs32),
     /* 124608 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 124610 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qd
     /* 124612 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Qm
     /* 124616 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 124619 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 124625 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 124631 */     GIR_RootConstrainSelectedInstOperands,
     /* 124632 */     // GIR_Coverage, 6027,
     /* 124632 */     GIR_EraseRootFromParent_Done,
     /* 124633 */   // Label 2469: @124633
     /* 124633 */   GIM_Try, /*On fail goto*//*Label 2470*/ GIMT_Encode4(124696), // Rule ID 3700 //
     /* 124638 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 124641 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 124645 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 124649 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 124653 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ABS),
     /* 124657 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 124661 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 124666 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 124668 */     // (umax:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qd, (abs:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm))  =>  (MVE_VMAXAs32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qd, MQPR:{ *:[v4i32] }:$Qm)
     /* 124668 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMAXAs32),
     /* 124671 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 124673 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qd
     /* 124675 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Qm
     /* 124679 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 124682 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 124688 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 124694 */     GIR_RootConstrainSelectedInstOperands,
     /* 124695 */     // GIR_Coverage, 3700,
     /* 124695 */     GIR_EraseRootFromParent_Done,
     /* 124696 */   // Label 2470: @124696
     /* 124696 */   GIM_Try, /*On fail goto*//*Label 2471*/ GIMT_Encode4(124736), // Rule ID 1203 //
     /* 124701 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 124704 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 124708 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 124712 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 124716 */     // (umax:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)  =>  (VMAXuv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)
     /* 124716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMAXuv4i32),
     /* 124719 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 124721 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 124723 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 124725 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 124728 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 124734 */     GIR_RootConstrainSelectedInstOperands,
     /* 124735 */     // GIR_Coverage, 1203,
     /* 124735 */     GIR_EraseRootFromParent_Done,
     /* 124736 */   // Label 2471: @124736
     /* 124736 */   GIM_Try, /*On fail goto*//*Label 2472*/ GIMT_Encode4(124797), // Rule ID 3324 //
     /* 124741 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 124744 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 124748 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 124752 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 124756 */     // (umax:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)  =>  (MVE_VMAXu32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)
     /* 124756 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 124759 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 124763 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 124768 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMAXu32),
     /* 124771 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 124773 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /* 124775 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /* 124777 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 124780 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 124786 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 124792 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 124795 */     GIR_RootConstrainSelectedInstOperands,
     /* 124796 */     // GIR_Coverage, 3324,
     /* 124796 */     GIR_EraseRootFromParent_Done,
     /* 124797 */   // Label 2472: @124797
     /* 124797 */   GIM_Reject,
     /* 124798 */ // Label 2468: @124798
     /* 124798 */ GIM_Reject,
     /* 124799 */ // Label 2462: @124799
     /* 124799 */ GIM_Try, /*On fail goto*//*Label 2473*/ GIMT_Encode4(124845), // Rule ID 1204 //
     /* 124804 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 124807 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 124810 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 124813 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 124817 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 124821 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 124825 */   // (umax:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)  =>  (VMAXuv8i8:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /* 124825 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMAXuv8i8),
     /* 124828 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 124830 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 124832 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 124834 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 124837 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 124843 */   GIR_RootConstrainSelectedInstOperands,
     /* 124844 */   // GIR_Coverage, 1204,
     /* 124844 */   GIR_EraseRootFromParent_Done,
     /* 124845 */ // Label 2473: @124845
     /* 124845 */ GIM_Reject,
     /* 124846 */ // Label 2463: @124846
     /* 124846 */ GIM_Try, /*On fail goto*//*Label 2474*/ GIMT_Encode4(125085),
     /* 124851 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 124854 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 124857 */   GIM_Try, /*On fail goto*//*Label 2475*/ GIMT_Encode4(124920), // Rule ID 6026 //
     /* 124862 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 124865 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 124869 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 124873 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ABS),
     /* 124877 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 124881 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 124886 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 124890 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 124892 */     // (umax:{ *:[v8i16] } (abs:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm), MQPR:{ *:[v8i16] }:$Qd)  =>  (MVE_VMAXAs16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qd, MQPR:{ *:[v8i16] }:$Qm)
     /* 124892 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMAXAs16),
     /* 124895 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 124897 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qd
     /* 124899 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Qm
     /* 124903 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 124906 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 124912 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 124918 */     GIR_RootConstrainSelectedInstOperands,
     /* 124919 */     // GIR_Coverage, 6026,
     /* 124919 */     GIR_EraseRootFromParent_Done,
     /* 124920 */   // Label 2475: @124920
     /* 124920 */   GIM_Try, /*On fail goto*//*Label 2476*/ GIMT_Encode4(124983), // Rule ID 3698 //
     /* 124925 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 124928 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 124932 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 124936 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 124940 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ABS),
     /* 124944 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 124948 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 124953 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 124955 */     // (umax:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qd, (abs:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm))  =>  (MVE_VMAXAs16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qd, MQPR:{ *:[v8i16] }:$Qm)
     /* 124955 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMAXAs16),
     /* 124958 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 124960 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qd
     /* 124962 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Qm
     /* 124966 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 124969 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 124975 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 124981 */     GIR_RootConstrainSelectedInstOperands,
     /* 124982 */     // GIR_Coverage, 3698,
     /* 124982 */     GIR_EraseRootFromParent_Done,
     /* 124983 */   // Label 2476: @124983
     /* 124983 */   GIM_Try, /*On fail goto*//*Label 2477*/ GIMT_Encode4(125023), // Rule ID 1202 //
     /* 124988 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 124991 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 124995 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 124999 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 125003 */     // (umax:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)  =>  (VMAXuv8i16:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)
     /* 125003 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMAXuv8i16),
     /* 125006 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 125008 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 125010 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 125012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 125015 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 125021 */     GIR_RootConstrainSelectedInstOperands,
     /* 125022 */     // GIR_Coverage, 1202,
     /* 125022 */     GIR_EraseRootFromParent_Done,
     /* 125023 */   // Label 2477: @125023
     /* 125023 */   GIM_Try, /*On fail goto*//*Label 2478*/ GIMT_Encode4(125084), // Rule ID 3321 //
     /* 125028 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 125031 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 125035 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 125039 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 125043 */     // (umax:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)  =>  (MVE_VMAXu16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)
     /* 125043 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 125046 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 125050 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 125055 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMAXu16),
     /* 125058 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 125060 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /* 125062 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /* 125064 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 125067 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 125073 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 125079 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 125082 */     GIR_RootConstrainSelectedInstOperands,
     /* 125083 */     // GIR_Coverage, 3321,
     /* 125083 */     GIR_EraseRootFromParent_Done,
     /* 125084 */   // Label 2478: @125084
     /* 125084 */   GIM_Reject,
     /* 125085 */ // Label 2474: @125085
     /* 125085 */ GIM_Reject,
     /* 125086 */ // Label 2464: @125086
     /* 125086 */ GIM_Try, /*On fail goto*//*Label 2479*/ GIMT_Encode4(125325),
     /* 125091 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 125094 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 125097 */   GIM_Try, /*On fail goto*//*Label 2480*/ GIMT_Encode4(125160), // Rule ID 6025 //
     /* 125102 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 125105 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 125109 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 125113 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ABS),
     /* 125117 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 125121 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 125126 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 125130 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 125132 */     // (umax:{ *:[v16i8] } (abs:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm), MQPR:{ *:[v16i8] }:$Qd)  =>  (MVE_VMAXAs8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qd, MQPR:{ *:[v16i8] }:$Qm)
     /* 125132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMAXAs8),
     /* 125135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 125137 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qd
     /* 125139 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Qm
     /* 125143 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 125146 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 125152 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 125158 */     GIR_RootConstrainSelectedInstOperands,
     /* 125159 */     // GIR_Coverage, 6025,
     /* 125159 */     GIR_EraseRootFromParent_Done,
     /* 125160 */   // Label 2480: @125160
     /* 125160 */   GIM_Try, /*On fail goto*//*Label 2481*/ GIMT_Encode4(125223), // Rule ID 3696 //
     /* 125165 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 125168 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 125172 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 125176 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 125180 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ABS),
     /* 125184 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 125188 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 125193 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 125195 */     // (umax:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qd, (abs:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm))  =>  (MVE_VMAXAs8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qd, MQPR:{ *:[v16i8] }:$Qm)
     /* 125195 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMAXAs8),
     /* 125198 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 125200 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qd
     /* 125202 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Qm
     /* 125206 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 125209 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 125215 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 125221 */     GIR_RootConstrainSelectedInstOperands,
     /* 125222 */     // GIR_Coverage, 3696,
     /* 125222 */     GIR_EraseRootFromParent_Done,
     /* 125223 */   // Label 2481: @125223
     /* 125223 */   GIM_Try, /*On fail goto*//*Label 2482*/ GIMT_Encode4(125263), // Rule ID 1205 //
     /* 125228 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 125231 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 125235 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 125239 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 125243 */     // (umax:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)  =>  (VMAXuv16i8:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)
     /* 125243 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMAXuv16i8),
     /* 125246 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 125248 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 125250 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 125252 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 125255 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 125261 */     GIR_RootConstrainSelectedInstOperands,
     /* 125262 */     // GIR_Coverage, 1205,
     /* 125262 */     GIR_EraseRootFromParent_Done,
     /* 125263 */   // Label 2482: @125263
     /* 125263 */   GIM_Try, /*On fail goto*//*Label 2483*/ GIMT_Encode4(125324), // Rule ID 3318 //
     /* 125268 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 125271 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 125275 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 125279 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 125283 */     // (umax:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)  =>  (MVE_VMAXu8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)
     /* 125283 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 125286 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 125290 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 125295 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMAXu8),
     /* 125298 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 125300 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /* 125302 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /* 125304 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 125307 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 125313 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 125319 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 125322 */     GIR_RootConstrainSelectedInstOperands,
     /* 125323 */     // GIR_Coverage, 3318,
     /* 125323 */     GIR_EraseRootFromParent_Done,
     /* 125324 */   // Label 2483: @125324
     /* 125324 */   GIM_Reject,
     /* 125325 */ // Label 2479: @125325
     /* 125325 */ GIM_Reject,
     /* 125326 */ // Label 2465: @125326
     /* 125326 */ GIM_Reject,
     /* 125327 */ // Label 59: @125327
     /* 125327 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(4), GIMT_Encode2(16), /*)*//*default:*//*Label 2490*/ GIMT_Encode4(125797),
     /* 125338 */ /*GILLT_v2s32*//*Label 2484*/ GIMT_Encode4(125386), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 125350 */ /*GILLT_v4s16*//*Label 2485*/ GIMT_Encode4(125424),
     /* 125354 */ /*GILLT_v4s32*//*Label 2486*/ GIMT_Encode4(125462), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 125366 */ /*GILLT_v8s8*//*Label 2487*/ GIMT_Encode4(125561),
     /* 125370 */ /*GILLT_v8s16*//*Label 2488*/ GIMT_Encode4(125599), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 125382 */ /*GILLT_v16s8*//*Label 2489*/ GIMT_Encode4(125698),
     /* 125386 */ // Label 2484: @125386
     /* 125386 */ GIM_Try, /*On fail goto*//*Label 2491*/ GIMT_Encode4(125423), // Rule ID 1507 //
     /* 125391 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 125394 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 125397 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 125401 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 125405 */   // (abs:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vm)  =>  (VABSv2i32:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vm)
     /* 125405 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VABSv2i32),
     /* 125408 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 125410 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /* 125412 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 125415 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 125421 */   GIR_RootConstrainSelectedInstOperands,
     /* 125422 */   // GIR_Coverage, 1507,
     /* 125422 */   GIR_EraseRootFromParent_Done,
     /* 125423 */ // Label 2491: @125423
     /* 125423 */ GIM_Reject,
     /* 125424 */ // Label 2485: @125424
     /* 125424 */ GIM_Try, /*On fail goto*//*Label 2492*/ GIMT_Encode4(125461), // Rule ID 1506 //
     /* 125429 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 125432 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 125435 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 125439 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 125443 */   // (abs:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vm)  =>  (VABSv4i16:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vm)
     /* 125443 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VABSv4i16),
     /* 125446 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 125448 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /* 125450 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 125453 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 125459 */   GIR_RootConstrainSelectedInstOperands,
     /* 125460 */   // GIR_Coverage, 1506,
     /* 125460 */   GIR_EraseRootFromParent_Done,
     /* 125461 */ // Label 2492: @125461
     /* 125461 */ GIM_Reject,
     /* 125462 */ // Label 2486: @125462
     /* 125462 */ GIM_Try, /*On fail goto*//*Label 2493*/ GIMT_Encode4(125560),
     /* 125467 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 125470 */   GIM_Try, /*On fail goto*//*Label 2494*/ GIMT_Encode4(125504), // Rule ID 1510 //
     /* 125475 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 125478 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 125482 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 125486 */     // (abs:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vm)  =>  (VABSv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vm)
     /* 125486 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VABSv4i32),
     /* 125489 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 125491 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /* 125493 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 125496 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 125502 */     GIR_RootConstrainSelectedInstOperands,
     /* 125503 */     // GIR_Coverage, 1510,
     /* 125503 */     GIR_EraseRootFromParent_Done,
     /* 125504 */   // Label 2494: @125504
     /* 125504 */   GIM_Try, /*On fail goto*//*Label 2495*/ GIMT_Encode4(125559), // Rule ID 3669 //
     /* 125509 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 125512 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 125516 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 125520 */     // (abs:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$v)  =>  (MVE_VABSs32:{ *:[v4i32] } ?:{ *:[v4i32] }:$v)
     /* 125520 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 125523 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 125527 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 125532 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VABSs32),
     /* 125535 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 125537 */     GIR_RootToRootCopy, /*OpIdx*/1, // v
     /* 125539 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 125542 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 125548 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 125554 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 125557 */     GIR_RootConstrainSelectedInstOperands,
     /* 125558 */     // GIR_Coverage, 3669,
     /* 125558 */     GIR_EraseRootFromParent_Done,
     /* 125559 */   // Label 2495: @125559
     /* 125559 */   GIM_Reject,
     /* 125560 */ // Label 2493: @125560
     /* 125560 */ GIM_Reject,
     /* 125561 */ // Label 2487: @125561
     /* 125561 */ GIM_Try, /*On fail goto*//*Label 2496*/ GIMT_Encode4(125598), // Rule ID 1505 //
     /* 125566 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 125569 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 125572 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 125576 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 125580 */   // (abs:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vm)  =>  (VABSv8i8:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vm)
     /* 125580 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VABSv8i8),
     /* 125583 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 125585 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /* 125587 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 125590 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 125596 */   GIR_RootConstrainSelectedInstOperands,
     /* 125597 */   // GIR_Coverage, 1505,
     /* 125597 */   GIR_EraseRootFromParent_Done,
     /* 125598 */ // Label 2496: @125598
     /* 125598 */ GIM_Reject,
     /* 125599 */ // Label 2488: @125599
     /* 125599 */ GIM_Try, /*On fail goto*//*Label 2497*/ GIMT_Encode4(125697),
     /* 125604 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 125607 */   GIM_Try, /*On fail goto*//*Label 2498*/ GIMT_Encode4(125641), // Rule ID 1509 //
     /* 125612 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 125615 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 125619 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 125623 */     // (abs:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vm)  =>  (VABSv8i16:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vm)
     /* 125623 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VABSv8i16),
     /* 125626 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 125628 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /* 125630 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 125633 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 125639 */     GIR_RootConstrainSelectedInstOperands,
     /* 125640 */     // GIR_Coverage, 1509,
     /* 125640 */     GIR_EraseRootFromParent_Done,
     /* 125641 */   // Label 2498: @125641
     /* 125641 */   GIM_Try, /*On fail goto*//*Label 2499*/ GIMT_Encode4(125696), // Rule ID 3663 //
     /* 125646 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 125649 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 125653 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 125657 */     // (abs:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$v)  =>  (MVE_VABSs16:{ *:[v8i16] } ?:{ *:[v8i16] }:$v)
     /* 125657 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 125660 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 125664 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 125669 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VABSs16),
     /* 125672 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 125674 */     GIR_RootToRootCopy, /*OpIdx*/1, // v
     /* 125676 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 125679 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 125685 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 125691 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 125694 */     GIR_RootConstrainSelectedInstOperands,
     /* 125695 */     // GIR_Coverage, 3663,
     /* 125695 */     GIR_EraseRootFromParent_Done,
     /* 125696 */   // Label 2499: @125696
     /* 125696 */   GIM_Reject,
     /* 125697 */ // Label 2497: @125697
     /* 125697 */ GIM_Reject,
     /* 125698 */ // Label 2489: @125698
     /* 125698 */ GIM_Try, /*On fail goto*//*Label 2500*/ GIMT_Encode4(125796),
     /* 125703 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 125706 */   GIM_Try, /*On fail goto*//*Label 2501*/ GIMT_Encode4(125740), // Rule ID 1508 //
     /* 125711 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 125714 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 125718 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 125722 */     // (abs:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vm)  =>  (VABSv16i8:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vm)
     /* 125722 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VABSv16i8),
     /* 125725 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 125727 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /* 125729 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 125732 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 125738 */     GIR_RootConstrainSelectedInstOperands,
     /* 125739 */     // GIR_Coverage, 1508,
     /* 125739 */     GIR_EraseRootFromParent_Done,
     /* 125740 */   // Label 2501: @125740
     /* 125740 */   GIM_Try, /*On fail goto*//*Label 2502*/ GIMT_Encode4(125795), // Rule ID 3657 //
     /* 125745 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 125748 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 125752 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 125756 */     // (abs:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$v)  =>  (MVE_VABSs8:{ *:[v16i8] } ?:{ *:[v16i8] }:$v)
     /* 125756 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 125759 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 125763 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 125768 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VABSs8),
     /* 125771 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 125773 */     GIR_RootToRootCopy, /*OpIdx*/1, // v
     /* 125775 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 125778 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 125784 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 125790 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 125793 */     GIR_RootConstrainSelectedInstOperands,
     /* 125794 */     // GIR_Coverage, 3657,
     /* 125794 */     GIR_EraseRootFromParent_Done,
     /* 125795 */   // Label 2502: @125795
     /* 125795 */   GIM_Reject,
     /* 125796 */ // Label 2500: @125796
     /* 125796 */ GIM_Reject,
     /* 125797 */ // Label 2490: @125797
     /* 125797 */ GIM_Reject,
     /* 125798 */ // Label 60: @125798
     /* 125798 */ GIM_Try, /*On fail goto*//*Label 2503*/ GIMT_Encode4(125870),
     /* 125803 */   GIM_CheckIsMBB, /*MI*/0, /*Op*/0,
     /* 125806 */   GIM_Try, /*On fail goto*//*Label 2504*/ GIMT_Encode4(125821), // Rule ID 32 //
     /* 125811 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /* 125814 */     // (br (bb:{ *:[Other] }):$target)  =>  (B (bb:{ *:[Other] }):$target)
     /* 125814 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(ARM::B),
     /* 125819 */     GIR_RootConstrainSelectedInstOperands,
     /* 125820 */     // GIR_Coverage, 32,
     /* 125820 */     GIR_Done,
     /* 125821 */   // Label 2504: @125821
     /* 125821 */   GIM_Try, /*On fail goto*//*Label 2505*/ GIMT_Encode4(125845), // Rule ID 283 //
     /* 125826 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb_IsThumb1Only),
     /* 125829 */     // (br (bb:{ *:[Other] }):$target)  =>  (tB (bb:{ *:[Other] }):$target)
     /* 125829 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::tB),
     /* 125832 */     GIR_RootToRootCopy, /*OpIdx*/0, // target
     /* 125834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 125837 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 125843 */     GIR_RootConstrainSelectedInstOperands,
     /* 125844 */     // GIR_Coverage, 283,
     /* 125844 */     GIR_EraseRootFromParent_Done,
     /* 125845 */   // Label 2505: @125845
     /* 125845 */   GIM_Try, /*On fail goto*//*Label 2506*/ GIMT_Encode4(125869), // Rule ID 577 //
     /* 125850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV8MBaseline_IsThumb),
     /* 125853 */     // (br (bb:{ *:[Other] }):$target)  =>  (t2B (bb:{ *:[Other] }):$target)
     /* 125853 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2B),
     /* 125856 */     GIR_RootToRootCopy, /*OpIdx*/0, // target
     /* 125858 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 125861 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 125867 */     GIR_RootConstrainSelectedInstOperands,
     /* 125868 */     // GIR_Coverage, 577,
     /* 125868 */     GIR_EraseRootFromParent_Done,
     /* 125869 */   // Label 2506: @125869
     /* 125869 */   GIM_Reject,
     /* 125870 */ // Label 2503: @125870
     /* 125870 */ GIM_Reject,
     /* 125871 */ // Label 61: @125871
     /* 125871 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(7), GIMT_Encode2(16), /*)*//*default:*//*Label 2511*/ GIMT_Encode4(126170),
     /* 125882 */ /*GILLT_v4s16*//*Label 2507*/ GIMT_Encode4(125918), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 125898 */ /*GILLT_v8s8*//*Label 2508*/ GIMT_Encode4(125981),
     /* 125902 */ /*GILLT_v8s16*//*Label 2509*/ GIMT_Encode4(126044), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 125914 */ /*GILLT_v16s8*//*Label 2510*/ GIMT_Encode4(126107),
     /* 125918 */ // Label 2507: @125918
     /* 125918 */ GIM_Try, /*On fail goto*//*Label 2512*/ GIMT_Encode4(125980), // Rule ID 1569 //
     /* 125923 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 125926 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 125929 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 125932 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 125935 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 125939 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 125943 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 125947 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 125951 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 125955 */   // MIs[1] Operand 1
     /* 125955 */   // No operand predicates
     /* 125955 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 125957 */   // (vector_insert:{ *:[v4i16] } DPR:{ *:[v4i16] }:$src1, GPR:{ *:[i32] }:$R, (imm:{ *:[i32] }):$lane)  =>  (VSETLNi16:{ *:[v4i16] } DPR:{ *:[v4i16] }:$src1, GPR:{ *:[i32] }:$R, (imm:{ *:[i32] }):$lane)
     /* 125957 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSETLNi16),
     /* 125960 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[V]
     /* 125962 */   GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 125964 */   GIR_RootToRootCopy, /*OpIdx*/2, // R
     /* 125966 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // lane
     /* 125969 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 125972 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 125978 */   GIR_RootConstrainSelectedInstOperands,
     /* 125979 */   // GIR_Coverage, 1569,
     /* 125979 */   GIR_EraseRootFromParent_Done,
     /* 125980 */ // Label 2512: @125980
     /* 125980 */ GIM_Reject,
     /* 125981 */ // Label 2508: @125981
     /* 125981 */ GIM_Try, /*On fail goto*//*Label 2513*/ GIMT_Encode4(126043), // Rule ID 1568 //
     /* 125986 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 125989 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 125992 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 125995 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 125998 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 126002 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 126006 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 126010 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 126014 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 126018 */   // MIs[1] Operand 1
     /* 126018 */   // No operand predicates
     /* 126018 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 126020 */   // (vector_insert:{ *:[v8i8] } DPR:{ *:[v8i8] }:$src1, GPR:{ *:[i32] }:$R, (imm:{ *:[i32] }):$lane)  =>  (VSETLNi8:{ *:[v8i8] } DPR:{ *:[v8i8] }:$src1, GPR:{ *:[i32] }:$R, (imm:{ *:[i32] }):$lane)
     /* 126020 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSETLNi8),
     /* 126023 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[V]
     /* 126025 */   GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 126027 */   GIR_RootToRootCopy, /*OpIdx*/2, // R
     /* 126029 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // lane
     /* 126032 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 126035 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 126041 */   GIR_RootConstrainSelectedInstOperands,
     /* 126042 */   // GIR_Coverage, 1568,
     /* 126042 */   GIR_EraseRootFromParent_Done,
     /* 126043 */ // Label 2513: @126043
     /* 126043 */ GIM_Reject,
     /* 126044 */ // Label 2509: @126044
     /* 126044 */ GIM_Try, /*On fail goto*//*Label 2514*/ GIMT_Encode4(126106), // Rule ID 3433 //
     /* 126049 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 126052 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 126055 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 126058 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 126061 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 126065 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 126069 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 126073 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 126077 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 126081 */   // MIs[1] Operand 1
     /* 126081 */   // No operand predicates
     /* 126081 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 126083 */   // (vector_insert:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$src1, rGPR:{ *:[i32] }:$src2, (imm:{ *:[i32] }):$lane)  =>  (MVE_VMOV_to_lane_16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$src1, rGPR:{ *:[i32] }:$src2, (imm:{ *:[i32] }):$lane)
     /* 126083 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMOV_to_lane_16),
     /* 126086 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 126088 */   GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 126090 */   GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /* 126092 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // lane
     /* 126095 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 126098 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 126104 */   GIR_RootConstrainSelectedInstOperands,
     /* 126105 */   // GIR_Coverage, 3433,
     /* 126105 */   GIR_EraseRootFromParent_Done,
     /* 126106 */ // Label 2514: @126106
     /* 126106 */ GIM_Reject,
     /* 126107 */ // Label 2510: @126107
     /* 126107 */ GIM_Try, /*On fail goto*//*Label 2515*/ GIMT_Encode4(126169), // Rule ID 3432 //
     /* 126112 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 126115 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 126118 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 126121 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 126124 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 126128 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 126132 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 126136 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 126140 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 126144 */   // MIs[1] Operand 1
     /* 126144 */   // No operand predicates
     /* 126144 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 126146 */   // (vector_insert:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$src1, rGPR:{ *:[i32] }:$src2, (imm:{ *:[i32] }):$lane)  =>  (MVE_VMOV_to_lane_8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$src1, rGPR:{ *:[i32] }:$src2, (imm:{ *:[i32] }):$lane)
     /* 126146 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMOV_to_lane_8),
     /* 126149 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 126151 */   GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 126153 */   GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /* 126155 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // lane
     /* 126158 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 126161 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 126167 */   GIR_RootConstrainSelectedInstOperands,
     /* 126168 */   // GIR_Coverage, 3432,
     /* 126168 */   GIR_EraseRootFromParent_Done,
     /* 126169 */ // Label 2515: @126169
     /* 126169 */ GIM_Reject,
     /* 126170 */ // Label 2511: @126170
     /* 126170 */ GIM_Reject,
     /* 126171 */ // Label 62: @126171
     /* 126171 */ GIM_Try, /*On fail goto*//*Label 2516*/ GIMT_Encode4(126227), // Rule ID 1567 //
     /* 126176 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPRegs_HasFastVGETLNi32),
     /* 126179 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 126182 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 126185 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 126188 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 126192 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 126196 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 126200 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 126204 */   // MIs[1] Operand 1
     /* 126204 */   // No operand predicates
     /* 126204 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 126206 */   // (extractelt:{ *:[i32] } DPR:{ *:[v2i32] }:$V, (imm:{ *:[i32] }):$lane)  =>  (VGETLNi32:{ *:[i32] } DPR:{ *:[v2i32] }:$V, (imm:{ *:[i32] }):$lane)
     /* 126206 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VGETLNi32),
     /* 126209 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[R]
     /* 126211 */   GIR_RootToRootCopy, /*OpIdx*/1, // V
     /* 126213 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // lane
     /* 126216 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 126219 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 126225 */   GIR_RootConstrainSelectedInstOperands,
     /* 126226 */   // GIR_Coverage, 1567,
     /* 126226 */   GIR_EraseRootFromParent_Done,
     /* 126227 */ // Label 2516: @126227
     /* 126227 */ GIM_Reject,
     /* 126228 */ // Label 63: @126228
     /* 126228 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(16), /*)*//*default:*//*Label 2524*/ GIMT_Encode4(126788),
     /* 126239 */ /*GILLT_s32*//*Label 2517*/ GIMT_Encode4(126299), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 126251 */ /*GILLT_v2s32*//*Label 2518*/ GIMT_Encode4(126377), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 126263 */ /*GILLT_v4s16*//*Label 2519*/ GIMT_Encode4(126415),
     /* 126267 */ /*GILLT_v4s32*//*Label 2520*/ GIMT_Encode4(126453), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 126279 */ /*GILLT_v8s8*//*Label 2521*/ GIMT_Encode4(126552),
     /* 126283 */ /*GILLT_v8s16*//*Label 2522*/ GIMT_Encode4(126590), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 126295 */ /*GILLT_v16s8*//*Label 2523*/ GIMT_Encode4(126689),
     /* 126299 */ // Label 2517: @126299
     /* 126299 */ GIM_Try, /*On fail goto*//*Label 2525*/ GIMT_Encode4(126376),
     /* 126304 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 126307 */   GIM_Try, /*On fail goto*//*Label 2526*/ GIMT_Encode4(126341), // Rule ID 197 //
     /* 126312 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV5T_IsARM),
     /* 126315 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 126319 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 126323 */     // (ctlz:{ *:[i32] } GPR:{ *:[i32] }:$Rm)  =>  (CLZ:{ *:[i32] } GPR:{ *:[i32] }:$Rm)
     /* 126323 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::CLZ),
     /* 126326 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 126328 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /* 126330 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 126333 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 126339 */     GIR_RootConstrainSelectedInstOperands,
     /* 126340 */     // GIR_Coverage, 197,
     /* 126340 */     GIR_EraseRootFromParent_Done,
     /* 126341 */   // Label 2526: @126341
     /* 126341 */   GIM_Try, /*On fail goto*//*Label 2527*/ GIMT_Encode4(126375), // Rule ID 534 //
     /* 126346 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /* 126349 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 126353 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 126357 */     // (ctlz:{ *:[i32] } rGPR:{ *:[i32] }:$Rm)  =>  (t2CLZ:{ *:[i32] } rGPR:{ *:[i32] }:$Rm)
     /* 126357 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2CLZ),
     /* 126360 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 126362 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /* 126364 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 126367 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 126373 */     GIR_RootConstrainSelectedInstOperands,
     /* 126374 */     // GIR_Coverage, 534,
     /* 126374 */     GIR_EraseRootFromParent_Done,
     /* 126375 */   // Label 2527: @126375
     /* 126375 */   GIM_Reject,
     /* 126376 */ // Label 2525: @126376
     /* 126376 */ GIM_Reject,
     /* 126377 */ // Label 2518: @126377
     /* 126377 */ GIM_Try, /*On fail goto*//*Label 2528*/ GIMT_Encode4(126414), // Rule ID 1545 //
     /* 126382 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 126385 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 126388 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 126392 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 126396 */   // (ctlz:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vm)  =>  (VCLZv2i32:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vm)
     /* 126396 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCLZv2i32),
     /* 126399 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 126401 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /* 126403 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 126406 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 126412 */   GIR_RootConstrainSelectedInstOperands,
     /* 126413 */   // GIR_Coverage, 1545,
     /* 126413 */   GIR_EraseRootFromParent_Done,
     /* 126414 */ // Label 2528: @126414
     /* 126414 */ GIM_Reject,
     /* 126415 */ // Label 2519: @126415
     /* 126415 */ GIM_Try, /*On fail goto*//*Label 2529*/ GIMT_Encode4(126452), // Rule ID 1544 //
     /* 126420 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 126423 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 126426 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 126430 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 126434 */   // (ctlz:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vm)  =>  (VCLZv4i16:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vm)
     /* 126434 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCLZv4i16),
     /* 126437 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 126439 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /* 126441 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 126444 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 126450 */   GIR_RootConstrainSelectedInstOperands,
     /* 126451 */   // GIR_Coverage, 1544,
     /* 126451 */   GIR_EraseRootFromParent_Done,
     /* 126452 */ // Label 2529: @126452
     /* 126452 */ GIM_Reject,
     /* 126453 */ // Label 2520: @126453
     /* 126453 */ GIM_Try, /*On fail goto*//*Label 2530*/ GIMT_Encode4(126551),
     /* 126458 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 126461 */   GIM_Try, /*On fail goto*//*Label 2531*/ GIMT_Encode4(126495), // Rule ID 1548 //
     /* 126466 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 126469 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 126473 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 126477 */     // (ctlz:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vm)  =>  (VCLZv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vm)
     /* 126477 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCLZv4i32),
     /* 126480 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 126482 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /* 126484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 126487 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 126493 */     GIR_RootConstrainSelectedInstOperands,
     /* 126494 */     // GIR_Coverage, 1548,
     /* 126494 */     GIR_EraseRootFromParent_Done,
     /* 126495 */   // Label 2531: @126495
     /* 126495 */   GIM_Try, /*On fail goto*//*Label 2532*/ GIMT_Encode4(126550), // Rule ID 3655 //
     /* 126500 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 126503 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 126507 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 126511 */     // (ctlz:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$val)  =>  (MVE_VCLZs32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$val)
     /* 126511 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 126514 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 126518 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 126523 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCLZs32),
     /* 126526 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 126528 */     GIR_RootToRootCopy, /*OpIdx*/1, // val
     /* 126530 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 126533 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 126539 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 126545 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 126548 */     GIR_RootConstrainSelectedInstOperands,
     /* 126549 */     // GIR_Coverage, 3655,
     /* 126549 */     GIR_EraseRootFromParent_Done,
     /* 126550 */   // Label 2532: @126550
     /* 126550 */   GIM_Reject,
     /* 126551 */ // Label 2530: @126551
     /* 126551 */ GIM_Reject,
     /* 126552 */ // Label 2521: @126552
     /* 126552 */ GIM_Try, /*On fail goto*//*Label 2533*/ GIMT_Encode4(126589), // Rule ID 1543 //
     /* 126557 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 126560 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 126563 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 126567 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 126571 */   // (ctlz:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vm)  =>  (VCLZv8i8:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vm)
     /* 126571 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCLZv8i8),
     /* 126574 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 126576 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /* 126578 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 126581 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 126587 */   GIR_RootConstrainSelectedInstOperands,
     /* 126588 */   // GIR_Coverage, 1543,
     /* 126588 */   GIR_EraseRootFromParent_Done,
     /* 126589 */ // Label 2533: @126589
     /* 126589 */ GIM_Reject,
     /* 126590 */ // Label 2522: @126590
     /* 126590 */ GIM_Try, /*On fail goto*//*Label 2534*/ GIMT_Encode4(126688),
     /* 126595 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 126598 */   GIM_Try, /*On fail goto*//*Label 2535*/ GIMT_Encode4(126632), // Rule ID 1547 //
     /* 126603 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 126606 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 126610 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 126614 */     // (ctlz:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vm)  =>  (VCLZv8i16:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vm)
     /* 126614 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCLZv8i16),
     /* 126617 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 126619 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /* 126621 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 126624 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 126630 */     GIR_RootConstrainSelectedInstOperands,
     /* 126631 */     // GIR_Coverage, 1547,
     /* 126631 */     GIR_EraseRootFromParent_Done,
     /* 126632 */   // Label 2535: @126632
     /* 126632 */   GIM_Try, /*On fail goto*//*Label 2536*/ GIMT_Encode4(126687), // Rule ID 3653 //
     /* 126637 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 126640 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 126644 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 126648 */     // (ctlz:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$val)  =>  (MVE_VCLZs16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$val)
     /* 126648 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 126651 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 126655 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 126660 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCLZs16),
     /* 126663 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 126665 */     GIR_RootToRootCopy, /*OpIdx*/1, // val
     /* 126667 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 126670 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 126676 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 126682 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 126685 */     GIR_RootConstrainSelectedInstOperands,
     /* 126686 */     // GIR_Coverage, 3653,
     /* 126686 */     GIR_EraseRootFromParent_Done,
     /* 126687 */   // Label 2536: @126687
     /* 126687 */   GIM_Reject,
     /* 126688 */ // Label 2534: @126688
     /* 126688 */ GIM_Reject,
     /* 126689 */ // Label 2523: @126689
     /* 126689 */ GIM_Try, /*On fail goto*//*Label 2537*/ GIMT_Encode4(126787),
     /* 126694 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 126697 */   GIM_Try, /*On fail goto*//*Label 2538*/ GIMT_Encode4(126731), // Rule ID 1546 //
     /* 126702 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 126705 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 126709 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 126713 */     // (ctlz:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vm)  =>  (VCLZv16i8:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vm)
     /* 126713 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCLZv16i8),
     /* 126716 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 126718 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /* 126720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 126723 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 126729 */     GIR_RootConstrainSelectedInstOperands,
     /* 126730 */     // GIR_Coverage, 1546,
     /* 126730 */     GIR_EraseRootFromParent_Done,
     /* 126731 */   // Label 2538: @126731
     /* 126731 */   GIM_Try, /*On fail goto*//*Label 2539*/ GIMT_Encode4(126786), // Rule ID 3651 //
     /* 126736 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 126739 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 126743 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 126747 */     // (ctlz:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$val)  =>  (MVE_VCLZs8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$val)
     /* 126747 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 126750 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 126754 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 126759 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCLZs8),
     /* 126762 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 126764 */     GIR_RootToRootCopy, /*OpIdx*/1, // val
     /* 126766 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 126769 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 126775 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 126781 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 126784 */     GIR_RootConstrainSelectedInstOperands,
     /* 126785 */     // GIR_Coverage, 3651,
     /* 126785 */     GIR_EraseRootFromParent_Done,
     /* 126786 */   // Label 2539: @126786
     /* 126786 */   GIM_Reject,
     /* 126787 */ // Label 2537: @126787
     /* 126787 */ GIM_Reject,
     /* 126788 */ // Label 2524: @126788
     /* 126788 */ GIM_Reject,
     /* 126789 */ // Label 64: @126789
     /* 126789 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(11), GIMT_Encode2(16), /*)*//*default:*//*Label 2542*/ GIMT_Encode4(126896),
     /* 126800 */ /*GILLT_v8s8*//*Label 2540*/ GIMT_Encode4(126820), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 126816 */ /*GILLT_v16s8*//*Label 2541*/ GIMT_Encode4(126858),
     /* 126820 */ // Label 2540: @126820
     /* 126820 */ GIM_Try, /*On fail goto*//*Label 2543*/ GIMT_Encode4(126857), // Rule ID 1549 //
     /* 126825 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 126828 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 126831 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 126835 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 126839 */   // (ctpop:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vm)  =>  (VCNTd:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vm)
     /* 126839 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCNTd),
     /* 126842 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 126844 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /* 126846 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 126849 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 126855 */   GIR_RootConstrainSelectedInstOperands,
     /* 126856 */   // GIR_Coverage, 1549,
     /* 126856 */   GIR_EraseRootFromParent_Done,
     /* 126857 */ // Label 2543: @126857
     /* 126857 */ GIM_Reject,
     /* 126858 */ // Label 2541: @126858
     /* 126858 */ GIM_Try, /*On fail goto*//*Label 2544*/ GIMT_Encode4(126895), // Rule ID 1550 //
     /* 126863 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 126866 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 126869 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 126873 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 126877 */   // (ctpop:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vm)  =>  (VCNTq:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vm)
     /* 126877 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCNTq),
     /* 126880 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 126882 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /* 126884 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 126887 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 126893 */   GIR_RootConstrainSelectedInstOperands,
     /* 126894 */   // GIR_Coverage, 1550,
     /* 126894 */   GIR_EraseRootFromParent_Done,
     /* 126895 */ // Label 2544: @126895
     /* 126895 */ GIM_Reject,
     /* 126896 */ // Label 2542: @126896
     /* 126896 */ GIM_Reject,
     /* 126897 */ // Label 65: @126897
     /* 126897 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(13), /*)*//*default:*//*Label 2548*/ GIMT_Encode4(127186),
     /* 126908 */ /*GILLT_s32*//*Label 2545*/ GIMT_Encode4(126956), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 126936 */ /*GILLT_v4s32*//*Label 2546*/ GIMT_Encode4(127068), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 126952 */ /*GILLT_v8s16*//*Label 2547*/ GIMT_Encode4(127127),
     /* 126956 */ // Label 2545: @126956
     /* 126956 */ GIM_Try, /*On fail goto*//*Label 2549*/ GIMT_Encode4(127067),
     /* 126961 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 126964 */   GIM_Try, /*On fail goto*//*Label 2550*/ GIMT_Encode4(126998), // Rule ID 199 //
     /* 126969 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /* 126972 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 126976 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 126980 */     // (bswap:{ *:[i32] } GPR:{ *:[i32] }:$Rm)  =>  (REV:{ *:[i32] } GPR:{ *:[i32] }:$Rm)
     /* 126980 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::REV),
     /* 126983 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 126985 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /* 126987 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 126990 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 126996 */     GIR_RootConstrainSelectedInstOperands,
     /* 126997 */     // GIR_Coverage, 199,
     /* 126997 */     GIR_EraseRootFromParent_Done,
     /* 126998 */   // Label 2550: @126998
     /* 126998 */   GIM_Try, /*On fail goto*//*Label 2551*/ GIMT_Encode4(127032), // Rule ID 326 //
     /* 127003 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsThumb_IsThumb1Only),
     /* 127006 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /* 127010 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /* 127014 */     // (bswap:{ *:[i32] } tGPR:{ *:[i32] }:$Rm)  =>  (tREV:{ *:[i32] } tGPR:{ *:[i32] }:$Rm)
     /* 127014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::tREV),
     /* 127017 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 127019 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /* 127021 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 127024 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 127030 */     GIR_RootConstrainSelectedInstOperands,
     /* 127031 */     // GIR_Coverage, 326,
     /* 127031 */     GIR_EraseRootFromParent_Done,
     /* 127032 */   // Label 2551: @127032
     /* 127032 */   GIM_Try, /*On fail goto*//*Label 2552*/ GIMT_Encode4(127066), // Rule ID 536 //
     /* 127037 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /* 127040 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 127044 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 127048 */     // (bswap:{ *:[i32] } rGPR:{ *:[i32] }:$Rm)  =>  (t2REV:{ *:[i32] } rGPR:{ *:[i32] }:$Rm)
     /* 127048 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2REV),
     /* 127051 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 127053 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /* 127055 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 127058 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 127064 */     GIR_RootConstrainSelectedInstOperands,
     /* 127065 */     // GIR_Coverage, 536,
     /* 127065 */     GIR_EraseRootFromParent_Done,
     /* 127066 */   // Label 2552: @127066
     /* 127066 */   GIM_Reject,
     /* 127067 */ // Label 2549: @127067
     /* 127067 */ GIM_Reject,
     /* 127068 */ // Label 2546: @127068
     /* 127068 */ GIM_Try, /*On fail goto*//*Label 2553*/ GIMT_Encode4(127126), // Rule ID 3328 //
     /* 127073 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 127076 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 127079 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 127083 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 127087 */   // (bswap:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$src)  =>  (MVE_VREV32_8:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$src)
     /* 127087 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 127090 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 127094 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 127099 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VREV32_8),
     /* 127102 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 127104 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 127106 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 127109 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 127115 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 127121 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 127124 */   GIR_RootConstrainSelectedInstOperands,
     /* 127125 */   // GIR_Coverage, 3328,
     /* 127125 */   GIR_EraseRootFromParent_Done,
     /* 127126 */ // Label 2553: @127126
     /* 127126 */ GIM_Reject,
     /* 127127 */ // Label 2547: @127127
     /* 127127 */ GIM_Try, /*On fail goto*//*Label 2554*/ GIMT_Encode4(127185), // Rule ID 3327 //
     /* 127132 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 127135 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 127138 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 127142 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 127146 */   // (bswap:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$src)  =>  (MVE_VREV16_8:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$src)
     /* 127146 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 127149 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 127153 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 127158 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VREV16_8),
     /* 127161 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 127163 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 127165 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 127168 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 127174 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 127180 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 127183 */   GIR_RootConstrainSelectedInstOperands,
     /* 127184 */   // GIR_Coverage, 3327,
     /* 127184 */   GIR_EraseRootFromParent_Done,
     /* 127185 */ // Label 2554: @127185
     /* 127185 */ GIM_Reject,
     /* 127186 */ // Label 2548: @127186
     /* 127186 */ GIM_Reject,
     /* 127187 */ // Label 66: @127187
     /* 127187 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(16), /*)*//*default:*//*Label 2559*/ GIMT_Encode4(127618),
     /* 127198 */ /*GILLT_s32*//*Label 2555*/ GIMT_Encode4(127258), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 127226 */ /*GILLT_v4s32*//*Label 2556*/ GIMT_Encode4(127336), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 127242 */ /*GILLT_v8s16*//*Label 2557*/ GIMT_Encode4(127430), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 127254 */ /*GILLT_v16s8*//*Label 2558*/ GIMT_Encode4(127524),
     /* 127258 */ // Label 2555: @127258
     /* 127258 */ GIM_Try, /*On fail goto*//*Label 2560*/ GIMT_Encode4(127335),
     /* 127263 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 127266 */   GIM_Try, /*On fail goto*//*Label 2561*/ GIMT_Encode4(127300), // Rule ID 198 //
     /* 127271 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6T2_IsARM),
     /* 127274 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 127278 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 127282 */     // (bitreverse:{ *:[i32] } GPR:{ *:[i32] }:$Rm)  =>  (RBIT:{ *:[i32] } GPR:{ *:[i32] }:$Rm)
     /* 127282 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::RBIT),
     /* 127285 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 127287 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /* 127289 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 127292 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 127298 */     GIR_RootConstrainSelectedInstOperands,
     /* 127299 */     // GIR_Coverage, 198,
     /* 127299 */     GIR_EraseRootFromParent_Done,
     /* 127300 */   // Label 2561: @127300
     /* 127300 */   GIM_Try, /*On fail goto*//*Label 2562*/ GIMT_Encode4(127334), // Rule ID 535 //
     /* 127305 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /* 127308 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 127312 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 127316 */     // (bitreverse:{ *:[i32] } rGPR:{ *:[i32] }:$Rm)  =>  (t2RBIT:{ *:[i32] } rGPR:{ *:[i32] }:$Rm)
     /* 127316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2RBIT),
     /* 127319 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 127321 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /* 127323 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 127326 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 127332 */     GIR_RootConstrainSelectedInstOperands,
     /* 127333 */     // GIR_Coverage, 535,
     /* 127333 */     GIR_EraseRootFromParent_Done,
     /* 127334 */   // Label 2562: @127334
     /* 127334 */   GIM_Reject,
     /* 127335 */ // Label 2560: @127335
     /* 127335 */ GIM_Reject,
     /* 127336 */ // Label 2556: @127336
     /* 127336 */ GIM_Try, /*On fail goto*//*Label 2563*/ GIMT_Encode4(127429), // Rule ID 4755 //
     /* 127341 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 127344 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 127347 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 127351 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 127355 */   // (bitreverse:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$val1)  =>  (MVE_VBRSR32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$val1, (t2MOVi:{ *:[i32] } 32:{ *:[i32] }))
     /* 127355 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /* 127358 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 127362 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 127367 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 127370 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::t2MOVi),
     /* 127374 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 127379 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/32,
     /* 127382 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/14,
     /* 127385 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 127391 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 127397 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 127399 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VBRSR32),
     /* 127402 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 127404 */   GIR_RootToRootCopy, /*OpIdx*/1, // val1
     /* 127406 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 127409 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 127412 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 127418 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 127424 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 127427 */   GIR_RootConstrainSelectedInstOperands,
     /* 127428 */   // GIR_Coverage, 4755,
     /* 127428 */   GIR_EraseRootFromParent_Done,
     /* 127429 */ // Label 2563: @127429
     /* 127429 */ GIM_Reject,
     /* 127430 */ // Label 2557: @127430
     /* 127430 */ GIM_Try, /*On fail goto*//*Label 2564*/ GIMT_Encode4(127523), // Rule ID 4756 //
     /* 127435 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 127438 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 127441 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 127445 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 127449 */   // (bitreverse:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$val1)  =>  (MVE_VBRSR16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$val1, (t2MOVi:{ *:[i32] } 16:{ *:[i32] }))
     /* 127449 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /* 127452 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 127456 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 127461 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 127464 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::t2MOVi),
     /* 127468 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 127473 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/16,
     /* 127476 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/14,
     /* 127479 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 127485 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 127491 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 127493 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VBRSR16),
     /* 127496 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 127498 */   GIR_RootToRootCopy, /*OpIdx*/1, // val1
     /* 127500 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 127503 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 127506 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 127512 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 127518 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 127521 */   GIR_RootConstrainSelectedInstOperands,
     /* 127522 */   // GIR_Coverage, 4756,
     /* 127522 */   GIR_EraseRootFromParent_Done,
     /* 127523 */ // Label 2564: @127523
     /* 127523 */ GIM_Reject,
     /* 127524 */ // Label 2558: @127524
     /* 127524 */ GIM_Try, /*On fail goto*//*Label 2565*/ GIMT_Encode4(127617), // Rule ID 4754 //
     /* 127529 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 127532 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 127535 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 127539 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 127543 */   // (bitreverse:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$val1)  =>  (MVE_VBRSR8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$val1, (t2MOVi:{ *:[i32] } 8:{ *:[i32] }))
     /* 127543 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /* 127546 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 127550 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 127555 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 127558 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::t2MOVi),
     /* 127562 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 127567 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/8,
     /* 127570 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/14,
     /* 127573 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 127579 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 127585 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 127587 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VBRSR8),
     /* 127590 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 127592 */   GIR_RootToRootCopy, /*OpIdx*/1, // val1
     /* 127594 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 127597 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 127600 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 127606 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 127612 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 127615 */   GIR_RootConstrainSelectedInstOperands,
     /* 127616 */   // GIR_Coverage, 4754,
     /* 127616 */   GIR_EraseRootFromParent_Done,
     /* 127617 */ // Label 2565: @127617
     /* 127617 */ GIM_Reject,
     /* 127618 */ // Label 2559: @127618
     /* 127618 */ GIM_Reject,
     /* 127619 */ // Label 67: @127619
     /* 127619 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(13), /*)*//*default:*//*Label 2573*/ GIMT_Encode4(127993),
     /* 127630 */ /*GILLT_s16*//*Label 2566*/ GIMT_Encode4(127682),
     /* 127634 */ /*GILLT_s32*//*Label 2567*/ GIMT_Encode4(127709),
     /* 127638 */ /*GILLT_s64*//*Label 2568*/ GIMT_Encode4(127736), GIMT_Encode4(0),
     /* 127646 */ /*GILLT_v2s32*//*Label 2569*/ GIMT_Encode4(127763), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 127658 */ /*GILLT_v4s16*//*Label 2570*/ GIMT_Encode4(127790),
     /* 127662 */ /*GILLT_v4s32*//*Label 2571*/ GIMT_Encode4(127817), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 127678 */ /*GILLT_v8s16*//*Label 2572*/ GIMT_Encode4(127905),
     /* 127682 */ // Label 2566: @127682
     /* 127682 */ GIM_Try, /*On fail goto*//*Label 2574*/ GIMT_Encode4(127708), // Rule ID 680 //
     /* 127687 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 127690 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 127693 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 127697 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 127701 */   // (fceil:{ *:[f16] } HPR:{ *:[f16] }:$Sm)  =>  (VRINTPH:{ *:[f16] } HPR:{ *:[f16] }:$Sm)
     /* 127701 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(ARM::VRINTPH),
     /* 127706 */   GIR_RootConstrainSelectedInstOperands,
     /* 127707 */   // GIR_Coverage, 680,
     /* 127707 */   GIR_Done,
     /* 127708 */ // Label 2574: @127708
     /* 127708 */ GIM_Reject,
     /* 127709 */ // Label 2567: @127709
     /* 127709 */ GIM_Try, /*On fail goto*//*Label 2575*/ GIMT_Encode4(127735), // Rule ID 681 //
     /* 127714 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 127717 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 127720 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 127724 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 127728 */   // (fceil:{ *:[f32] } SPR:{ *:[f32] }:$Sm)  =>  (VRINTPS:{ *:[f32] } SPR:{ *:[f32] }:$Sm)
     /* 127728 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(ARM::VRINTPS),
     /* 127733 */   GIR_RootConstrainSelectedInstOperands,
     /* 127734 */   // GIR_Coverage, 681,
     /* 127734 */   GIR_Done,
     /* 127735 */ // Label 2575: @127735
     /* 127735 */ GIM_Reject,
     /* 127736 */ // Label 2568: @127736
     /* 127736 */ GIM_Try, /*On fail goto*//*Label 2576*/ GIMT_Encode4(127762), // Rule ID 682 //
     /* 127741 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDPVFP_HasFPARMv8),
     /* 127744 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 127747 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 127751 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 127755 */   // (fceil:{ *:[f64] } DPR:{ *:[f64] }:$Dm)  =>  (VRINTPD:{ *:[f64] } DPR:{ *:[f64] }:$Dm)
     /* 127755 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(ARM::VRINTPD),
     /* 127760 */   GIR_RootConstrainSelectedInstOperands,
     /* 127761 */   // GIR_Coverage, 682,
     /* 127761 */   GIR_Done,
     /* 127762 */ // Label 2576: @127762
     /* 127762 */ GIM_Reject,
     /* 127763 */ // Label 2569: @127763
     /* 127763 */ GIM_Try, /*On fail goto*//*Label 2577*/ GIMT_Encode4(127789), // Rule ID 1708 //
     /* 127768 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasV8),
     /* 127771 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 127774 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 127778 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 127782 */   // (fceil:{ *:[v2f32] } DPR:{ *:[v2f32] }:$Vm)  =>  (VRINTPNDf:{ *:[v2f32] } DPR:{ *:[v2f32] }:$Vm)
     /* 127782 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(ARM::VRINTPNDf),
     /* 127787 */   GIR_RootConstrainSelectedInstOperands,
     /* 127788 */   // GIR_Coverage, 1708,
     /* 127788 */   GIR_Done,
     /* 127789 */ // Label 2577: @127789
     /* 127789 */ GIM_Reject,
     /* 127790 */ // Label 2570: @127790
     /* 127790 */ GIM_Try, /*On fail goto*//*Label 2578*/ GIMT_Encode4(127816), // Rule ID 1710 //
     /* 127795 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON_HasV8),
     /* 127798 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 127801 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 127805 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 127809 */   // (fceil:{ *:[v4f16] } DPR:{ *:[v4f16] }:$Vm)  =>  (VRINTPNDh:{ *:[v4f16] } DPR:{ *:[v4f16] }:$Vm)
     /* 127809 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(ARM::VRINTPNDh),
     /* 127814 */   GIR_RootConstrainSelectedInstOperands,
     /* 127815 */   // GIR_Coverage, 1710,
     /* 127815 */   GIR_Done,
     /* 127816 */ // Label 2578: @127816
     /* 127816 */ GIM_Reject,
     /* 127817 */ // Label 2571: @127817
     /* 127817 */ GIM_Try, /*On fail goto*//*Label 2579*/ GIMT_Encode4(127904),
     /* 127822 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 127825 */   GIM_Try, /*On fail goto*//*Label 2580*/ GIMT_Encode4(127848), // Rule ID 1709 //
     /* 127830 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasV8),
     /* 127833 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 127837 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 127841 */     // (fceil:{ *:[v4f32] } QPR:{ *:[v4f32] }:$Vm)  =>  (VRINTPNQf:{ *:[v4f32] } QPR:{ *:[v4f32] }:$Vm)
     /* 127841 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(ARM::VRINTPNQf),
     /* 127846 */     GIR_RootConstrainSelectedInstOperands,
     /* 127847 */     // GIR_Coverage, 1709,
     /* 127847 */     GIR_Done,
     /* 127848 */   // Label 2580: @127848
     /* 127848 */   GIM_Try, /*On fail goto*//*Label 2581*/ GIMT_Encode4(127903), // Rule ID 3983 //
     /* 127853 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /* 127856 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 127860 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 127864 */     // (fceil:{ *:[v4f32] } MQPR:{ *:[v4f32] }:$val)  =>  (MVE_VRINTf32P:{ *:[v4f32] } MQPR:{ *:[v4f32] }:$val)
     /* 127864 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 127867 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 127871 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 127876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRINTf32P),
     /* 127879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 127881 */     GIR_RootToRootCopy, /*OpIdx*/1, // val
     /* 127883 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 127886 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 127892 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 127898 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 127901 */     GIR_RootConstrainSelectedInstOperands,
     /* 127902 */     // GIR_Coverage, 3983,
     /* 127902 */     GIR_EraseRootFromParent_Done,
     /* 127903 */   // Label 2581: @127903
     /* 127903 */   GIM_Reject,
     /* 127904 */ // Label 2579: @127904
     /* 127904 */ GIM_Reject,
     /* 127905 */ // Label 2572: @127905
     /* 127905 */ GIM_Try, /*On fail goto*//*Label 2582*/ GIMT_Encode4(127992),
     /* 127910 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 127913 */   GIM_Try, /*On fail goto*//*Label 2583*/ GIMT_Encode4(127936), // Rule ID 1711 //
     /* 127918 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON_HasV8),
     /* 127921 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 127925 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 127929 */     // (fceil:{ *:[v8f16] } QPR:{ *:[v8f16] }:$Vm)  =>  (VRINTPNQh:{ *:[v8f16] } QPR:{ *:[v8f16] }:$Vm)
     /* 127929 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(ARM::VRINTPNQh),
     /* 127934 */     GIR_RootConstrainSelectedInstOperands,
     /* 127935 */     // GIR_Coverage, 1711,
     /* 127935 */     GIR_Done,
     /* 127936 */   // Label 2583: @127936
     /* 127936 */   GIM_Try, /*On fail goto*//*Label 2584*/ GIMT_Encode4(127991), // Rule ID 3971 //
     /* 127941 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /* 127944 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 127948 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 127952 */     // (fceil:{ *:[v8f16] } MQPR:{ *:[v8f16] }:$val)  =>  (MVE_VRINTf16P:{ *:[v8f16] } MQPR:{ *:[v8f16] }:$val)
     /* 127952 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 127955 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 127959 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 127964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRINTf16P),
     /* 127967 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 127969 */     GIR_RootToRootCopy, /*OpIdx*/1, // val
     /* 127971 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 127974 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 127980 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 127986 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 127989 */     GIR_RootConstrainSelectedInstOperands,
     /* 127990 */     // GIR_Coverage, 3971,
     /* 127990 */     GIR_EraseRootFromParent_Done,
     /* 127991 */   // Label 2584: @127991
     /* 127991 */   GIM_Reject,
     /* 127992 */ // Label 2582: @127992
     /* 127992 */ GIM_Reject,
     /* 127993 */ // Label 2573: @127993
     /* 127993 */ GIM_Reject,
     /* 127994 */ // Label 68: @127994
     /* 127994 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(3), /*)*//*default:*//*Label 2588*/ GIMT_Encode4(128131),
     /* 128005 */ /*GILLT_s16*//*Label 2585*/ GIMT_Encode4(128017),
     /* 128009 */ /*GILLT_s32*//*Label 2586*/ GIMT_Encode4(128055),
     /* 128013 */ /*GILLT_s64*//*Label 2587*/ GIMT_Encode4(128093),
     /* 128017 */ // Label 2585: @128017
     /* 128017 */ GIM_Try, /*On fail goto*//*Label 2589*/ GIMT_Encode4(128054), // Rule ID 688 //
     /* 128022 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 128025 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 128028 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 128032 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 128036 */   // (fsqrt:{ *:[f16] } HPR:{ *:[f16] }:$Sm)  =>  (VSQRTH:{ *:[f16] } HPR:{ *:[f16] }:$Sm)
     /* 128036 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSQRTH),
     /* 128039 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /* 128041 */   GIR_RootToRootCopy, /*OpIdx*/1, // Sm
     /* 128043 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 128046 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 128052 */   GIR_RootConstrainSelectedInstOperands,
     /* 128053 */   // GIR_Coverage, 688,
     /* 128053 */   GIR_EraseRootFromParent_Done,
     /* 128054 */ // Label 2589: @128054
     /* 128054 */ GIM_Reject,
     /* 128055 */ // Label 2586: @128055
     /* 128055 */ GIM_Try, /*On fail goto*//*Label 2590*/ GIMT_Encode4(128092), // Rule ID 687 //
     /* 128060 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVFP2),
     /* 128063 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 128066 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 128070 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 128074 */   // (fsqrt:{ *:[f32] } SPR:{ *:[f32] }:$Sm)  =>  (VSQRTS:{ *:[f32] } SPR:{ *:[f32] }:$Sm)
     /* 128074 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSQRTS),
     /* 128077 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /* 128079 */   GIR_RootToRootCopy, /*OpIdx*/1, // Sm
     /* 128081 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 128084 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 128090 */   GIR_RootConstrainSelectedInstOperands,
     /* 128091 */   // GIR_Coverage, 687,
     /* 128091 */   GIR_EraseRootFromParent_Done,
     /* 128092 */ // Label 2590: @128092
     /* 128092 */ GIM_Reject,
     /* 128093 */ // Label 2587: @128093
     /* 128093 */ GIM_Try, /*On fail goto*//*Label 2591*/ GIMT_Encode4(128130), // Rule ID 686 //
     /* 128098 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDPVFP_HasVFP2),
     /* 128101 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 128104 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 128108 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 128112 */   // (fsqrt:{ *:[f64] } DPR:{ *:[f64] }:$Dm)  =>  (VSQRTD:{ *:[f64] } DPR:{ *:[f64] }:$Dm)
     /* 128112 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSQRTD),
     /* 128115 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Dd]
     /* 128117 */   GIR_RootToRootCopy, /*OpIdx*/1, // Dm
     /* 128119 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 128122 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 128128 */   GIR_RootConstrainSelectedInstOperands,
     /* 128129 */   // GIR_Coverage, 686,
     /* 128129 */   GIR_EraseRootFromParent_Done,
     /* 128130 */ // Label 2591: @128130
     /* 128130 */ GIM_Reject,
     /* 128131 */ // Label 2588: @128131
     /* 128131 */ GIM_Reject,
     /* 128132 */ // Label 69: @128132
     /* 128132 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(13), /*)*//*default:*//*Label 2599*/ GIMT_Encode4(128506),
     /* 128143 */ /*GILLT_s16*//*Label 2592*/ GIMT_Encode4(128195),
     /* 128147 */ /*GILLT_s32*//*Label 2593*/ GIMT_Encode4(128222),
     /* 128151 */ /*GILLT_s64*//*Label 2594*/ GIMT_Encode4(128249), GIMT_Encode4(0),
     /* 128159 */ /*GILLT_v2s32*//*Label 2595*/ GIMT_Encode4(128276), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 128171 */ /*GILLT_v4s16*//*Label 2596*/ GIMT_Encode4(128303),
     /* 128175 */ /*GILLT_v4s32*//*Label 2597*/ GIMT_Encode4(128330), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 128191 */ /*GILLT_v8s16*//*Label 2598*/ GIMT_Encode4(128418),
     /* 128195 */ // Label 2592: @128195
     /* 128195 */ GIM_Try, /*On fail goto*//*Label 2600*/ GIMT_Encode4(128221), // Rule ID 683 //
     /* 128200 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 128203 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 128206 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 128210 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 128214 */   // (ffloor:{ *:[f16] } HPR:{ *:[f16] }:$Sm)  =>  (VRINTMH:{ *:[f16] } HPR:{ *:[f16] }:$Sm)
     /* 128214 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(ARM::VRINTMH),
     /* 128219 */   GIR_RootConstrainSelectedInstOperands,
     /* 128220 */   // GIR_Coverage, 683,
     /* 128220 */   GIR_Done,
     /* 128221 */ // Label 2600: @128221
     /* 128221 */ GIM_Reject,
     /* 128222 */ // Label 2593: @128222
     /* 128222 */ GIM_Try, /*On fail goto*//*Label 2601*/ GIMT_Encode4(128248), // Rule ID 684 //
     /* 128227 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 128230 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 128233 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 128237 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 128241 */   // (ffloor:{ *:[f32] } SPR:{ *:[f32] }:$Sm)  =>  (VRINTMS:{ *:[f32] } SPR:{ *:[f32] }:$Sm)
     /* 128241 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(ARM::VRINTMS),
     /* 128246 */   GIR_RootConstrainSelectedInstOperands,
     /* 128247 */   // GIR_Coverage, 684,
     /* 128247 */   GIR_Done,
     /* 128248 */ // Label 2601: @128248
     /* 128248 */ GIM_Reject,
     /* 128249 */ // Label 2594: @128249
     /* 128249 */ GIM_Try, /*On fail goto*//*Label 2602*/ GIMT_Encode4(128275), // Rule ID 685 //
     /* 128254 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDPVFP_HasFPARMv8),
     /* 128257 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 128260 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 128264 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 128268 */   // (ffloor:{ *:[f64] } DPR:{ *:[f64] }:$Dm)  =>  (VRINTMD:{ *:[f64] } DPR:{ *:[f64] }:$Dm)
     /* 128268 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(ARM::VRINTMD),
     /* 128273 */   GIR_RootConstrainSelectedInstOperands,
     /* 128274 */   // GIR_Coverage, 685,
     /* 128274 */   GIR_Done,
     /* 128275 */ // Label 2602: @128275
     /* 128275 */ GIM_Reject,
     /* 128276 */ // Label 2595: @128276
     /* 128276 */ GIM_Try, /*On fail goto*//*Label 2603*/ GIMT_Encode4(128302), // Rule ID 1704 //
     /* 128281 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasV8),
     /* 128284 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 128287 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 128291 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 128295 */   // (ffloor:{ *:[v2f32] } DPR:{ *:[v2f32] }:$Vm)  =>  (VRINTMNDf:{ *:[v2f32] } DPR:{ *:[v2f32] }:$Vm)
     /* 128295 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(ARM::VRINTMNDf),
     /* 128300 */   GIR_RootConstrainSelectedInstOperands,
     /* 128301 */   // GIR_Coverage, 1704,
     /* 128301 */   GIR_Done,
     /* 128302 */ // Label 2603: @128302
     /* 128302 */ GIM_Reject,
     /* 128303 */ // Label 2596: @128303
     /* 128303 */ GIM_Try, /*On fail goto*//*Label 2604*/ GIMT_Encode4(128329), // Rule ID 1706 //
     /* 128308 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON_HasV8),
     /* 128311 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 128314 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 128318 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 128322 */   // (ffloor:{ *:[v4f16] } DPR:{ *:[v4f16] }:$Vm)  =>  (VRINTMNDh:{ *:[v4f16] } DPR:{ *:[v4f16] }:$Vm)
     /* 128322 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(ARM::VRINTMNDh),
     /* 128327 */   GIR_RootConstrainSelectedInstOperands,
     /* 128328 */   // GIR_Coverage, 1706,
     /* 128328 */   GIR_Done,
     /* 128329 */ // Label 2604: @128329
     /* 128329 */ GIM_Reject,
     /* 128330 */ // Label 2597: @128330
     /* 128330 */ GIM_Try, /*On fail goto*//*Label 2605*/ GIMT_Encode4(128417),
     /* 128335 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 128338 */   GIM_Try, /*On fail goto*//*Label 2606*/ GIMT_Encode4(128361), // Rule ID 1705 //
     /* 128343 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasV8),
     /* 128346 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 128350 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 128354 */     // (ffloor:{ *:[v4f32] } QPR:{ *:[v4f32] }:$Vm)  =>  (VRINTMNQf:{ *:[v4f32] } QPR:{ *:[v4f32] }:$Vm)
     /* 128354 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(ARM::VRINTMNQf),
     /* 128359 */     GIR_RootConstrainSelectedInstOperands,
     /* 128360 */     // GIR_Coverage, 1705,
     /* 128360 */     GIR_Done,
     /* 128361 */   // Label 2606: @128361
     /* 128361 */   GIM_Try, /*On fail goto*//*Label 2607*/ GIMT_Encode4(128416), // Rule ID 3981 //
     /* 128366 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /* 128369 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 128373 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 128377 */     // (ffloor:{ *:[v4f32] } MQPR:{ *:[v4f32] }:$val)  =>  (MVE_VRINTf32M:{ *:[v4f32] } MQPR:{ *:[v4f32] }:$val)
     /* 128377 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 128380 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 128384 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 128389 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRINTf32M),
     /* 128392 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 128394 */     GIR_RootToRootCopy, /*OpIdx*/1, // val
     /* 128396 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 128399 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 128405 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 128411 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 128414 */     GIR_RootConstrainSelectedInstOperands,
     /* 128415 */     // GIR_Coverage, 3981,
     /* 128415 */     GIR_EraseRootFromParent_Done,
     /* 128416 */   // Label 2607: @128416
     /* 128416 */   GIM_Reject,
     /* 128417 */ // Label 2605: @128417
     /* 128417 */ GIM_Reject,
     /* 128418 */ // Label 2598: @128418
     /* 128418 */ GIM_Try, /*On fail goto*//*Label 2608*/ GIMT_Encode4(128505),
     /* 128423 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 128426 */   GIM_Try, /*On fail goto*//*Label 2609*/ GIMT_Encode4(128449), // Rule ID 1707 //
     /* 128431 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON_HasV8),
     /* 128434 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 128438 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 128442 */     // (ffloor:{ *:[v8f16] } QPR:{ *:[v8f16] }:$Vm)  =>  (VRINTMNQh:{ *:[v8f16] } QPR:{ *:[v8f16] }:$Vm)
     /* 128442 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(ARM::VRINTMNQh),
     /* 128447 */     GIR_RootConstrainSelectedInstOperands,
     /* 128448 */     // GIR_Coverage, 1707,
     /* 128448 */     GIR_Done,
     /* 128449 */   // Label 2609: @128449
     /* 128449 */   GIM_Try, /*On fail goto*//*Label 2610*/ GIMT_Encode4(128504), // Rule ID 3969 //
     /* 128454 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /* 128457 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 128461 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 128465 */     // (ffloor:{ *:[v8f16] } MQPR:{ *:[v8f16] }:$val)  =>  (MVE_VRINTf16M:{ *:[v8f16] } MQPR:{ *:[v8f16] }:$val)
     /* 128465 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 128468 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 128472 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 128477 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRINTf16M),
     /* 128480 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 128482 */     GIR_RootToRootCopy, /*OpIdx*/1, // val
     /* 128484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 128487 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 128493 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 128499 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 128502 */     GIR_RootConstrainSelectedInstOperands,
     /* 128503 */     // GIR_Coverage, 3969,
     /* 128503 */     GIR_EraseRootFromParent_Done,
     /* 128504 */   // Label 2610: @128504
     /* 128504 */   GIM_Reject,
     /* 128505 */ // Label 2608: @128505
     /* 128505 */ GIM_Reject,
     /* 128506 */ // Label 2599: @128506
     /* 128506 */ GIM_Reject,
     /* 128507 */ // Label 70: @128507
     /* 128507 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(13), /*)*//*default:*//*Label 2618*/ GIMT_Encode4(128914),
     /* 128518 */ /*GILLT_s16*//*Label 2611*/ GIMT_Encode4(128570),
     /* 128522 */ /*GILLT_s32*//*Label 2612*/ GIMT_Encode4(128608),
     /* 128526 */ /*GILLT_s64*//*Label 2613*/ GIMT_Encode4(128646), GIMT_Encode4(0),
     /* 128534 */ /*GILLT_v2s32*//*Label 2614*/ GIMT_Encode4(128684), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 128546 */ /*GILLT_v4s16*//*Label 2615*/ GIMT_Encode4(128711),
     /* 128550 */ /*GILLT_v4s32*//*Label 2616*/ GIMT_Encode4(128738), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 128566 */ /*GILLT_v8s16*//*Label 2617*/ GIMT_Encode4(128826),
     /* 128570 */ // Label 2611: @128570
     /* 128570 */ GIM_Try, /*On fail goto*//*Label 2619*/ GIMT_Encode4(128607), // Rule ID 671 //
     /* 128575 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 128578 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 128581 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 128585 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 128589 */   // (frint:{ *:[f16] } HPR:{ *:[f16] }:$Sm)  =>  (VRINTXH:{ *:[f16] } HPR:{ *:[f16] }:$Sm)
     /* 128589 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRINTXH),
     /* 128592 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /* 128594 */   GIR_RootToRootCopy, /*OpIdx*/1, // Sm
     /* 128596 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 128599 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 128605 */   GIR_RootConstrainSelectedInstOperands,
     /* 128606 */   // GIR_Coverage, 671,
     /* 128606 */   GIR_EraseRootFromParent_Done,
     /* 128607 */ // Label 2619: @128607
     /* 128607 */ GIM_Reject,
     /* 128608 */ // Label 2612: @128608
     /* 128608 */ GIM_Try, /*On fail goto*//*Label 2620*/ GIMT_Encode4(128645), // Rule ID 672 //
     /* 128613 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 128616 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 128619 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 128623 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 128627 */   // (frint:{ *:[f32] } SPR:{ *:[f32] }:$Sm)  =>  (VRINTXS:{ *:[f32] } SPR:{ *:[f32] }:$Sm)
     /* 128627 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRINTXS),
     /* 128630 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /* 128632 */   GIR_RootToRootCopy, /*OpIdx*/1, // Sm
     /* 128634 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 128637 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 128643 */   GIR_RootConstrainSelectedInstOperands,
     /* 128644 */   // GIR_Coverage, 672,
     /* 128644 */   GIR_EraseRootFromParent_Done,
     /* 128645 */ // Label 2620: @128645
     /* 128645 */ GIM_Reject,
     /* 128646 */ // Label 2613: @128646
     /* 128646 */ GIM_Try, /*On fail goto*//*Label 2621*/ GIMT_Encode4(128683), // Rule ID 673 //
     /* 128651 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDPVFP_HasFPARMv8),
     /* 128654 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 128657 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 128661 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 128665 */   // (frint:{ *:[f64] } DPR:{ *:[f64] }:$Dm)  =>  (VRINTXD:{ *:[f64] } DPR:{ *:[f64] }:$Dm)
     /* 128665 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRINTXD),
     /* 128668 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Dd]
     /* 128670 */   GIR_RootToRootCopy, /*OpIdx*/1, // Dm
     /* 128672 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 128675 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 128681 */   GIR_RootConstrainSelectedInstOperands,
     /* 128682 */   // GIR_Coverage, 673,
     /* 128682 */   GIR_EraseRootFromParent_Done,
     /* 128683 */ // Label 2621: @128683
     /* 128683 */ GIM_Reject,
     /* 128684 */ // Label 2614: @128684
     /* 128684 */ GIM_Try, /*On fail goto*//*Label 2622*/ GIMT_Encode4(128710), // Rule ID 1692 //
     /* 128689 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasV8),
     /* 128692 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 128695 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 128699 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 128703 */   // (frint:{ *:[v2f32] } DPR:{ *:[v2f32] }:$Vm)  =>  (VRINTXNDf:{ *:[v2f32] } DPR:{ *:[v2f32] }:$Vm)
     /* 128703 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(ARM::VRINTXNDf),
     /* 128708 */   GIR_RootConstrainSelectedInstOperands,
     /* 128709 */   // GIR_Coverage, 1692,
     /* 128709 */   GIR_Done,
     /* 128710 */ // Label 2622: @128710
     /* 128710 */ GIM_Reject,
     /* 128711 */ // Label 2615: @128711
     /* 128711 */ GIM_Try, /*On fail goto*//*Label 2623*/ GIMT_Encode4(128737), // Rule ID 1694 //
     /* 128716 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON_HasV8),
     /* 128719 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 128722 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 128726 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 128730 */   // (frint:{ *:[v4f16] } DPR:{ *:[v4f16] }:$Vm)  =>  (VRINTXNDh:{ *:[v4f16] } DPR:{ *:[v4f16] }:$Vm)
     /* 128730 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(ARM::VRINTXNDh),
     /* 128735 */   GIR_RootConstrainSelectedInstOperands,
     /* 128736 */   // GIR_Coverage, 1694,
     /* 128736 */   GIR_Done,
     /* 128737 */ // Label 2623: @128737
     /* 128737 */ GIM_Reject,
     /* 128738 */ // Label 2616: @128738
     /* 128738 */ GIM_Try, /*On fail goto*//*Label 2624*/ GIMT_Encode4(128825),
     /* 128743 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 128746 */   GIM_Try, /*On fail goto*//*Label 2625*/ GIMT_Encode4(128769), // Rule ID 1693 //
     /* 128751 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasV8),
     /* 128754 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 128758 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 128762 */     // (frint:{ *:[v4f32] } QPR:{ *:[v4f32] }:$Vm)  =>  (VRINTXNQf:{ *:[v4f32] } QPR:{ *:[v4f32] }:$Vm)
     /* 128762 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(ARM::VRINTXNQf),
     /* 128767 */     GIR_RootConstrainSelectedInstOperands,
     /* 128768 */     // GIR_Coverage, 1693,
     /* 128768 */     GIR_Done,
     /* 128769 */   // Label 2625: @128769
     /* 128769 */   GIM_Try, /*On fail goto*//*Label 2626*/ GIMT_Encode4(128824), // Rule ID 3975 //
     /* 128774 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /* 128777 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 128781 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 128785 */     // (frint:{ *:[v4f32] } MQPR:{ *:[v4f32] }:$val)  =>  (MVE_VRINTf32X:{ *:[v4f32] } MQPR:{ *:[v4f32] }:$val)
     /* 128785 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 128788 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 128792 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 128797 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRINTf32X),
     /* 128800 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 128802 */     GIR_RootToRootCopy, /*OpIdx*/1, // val
     /* 128804 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 128807 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 128813 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 128819 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 128822 */     GIR_RootConstrainSelectedInstOperands,
     /* 128823 */     // GIR_Coverage, 3975,
     /* 128823 */     GIR_EraseRootFromParent_Done,
     /* 128824 */   // Label 2626: @128824
     /* 128824 */   GIM_Reject,
     /* 128825 */ // Label 2624: @128825
     /* 128825 */ GIM_Reject,
     /* 128826 */ // Label 2617: @128826
     /* 128826 */ GIM_Try, /*On fail goto*//*Label 2627*/ GIMT_Encode4(128913),
     /* 128831 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 128834 */   GIM_Try, /*On fail goto*//*Label 2628*/ GIMT_Encode4(128857), // Rule ID 1695 //
     /* 128839 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON_HasV8),
     /* 128842 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 128846 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 128850 */     // (frint:{ *:[v8f16] } QPR:{ *:[v8f16] }:$Vm)  =>  (VRINTXNQh:{ *:[v8f16] } QPR:{ *:[v8f16] }:$Vm)
     /* 128850 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(ARM::VRINTXNQh),
     /* 128855 */     GIR_RootConstrainSelectedInstOperands,
     /* 128856 */     // GIR_Coverage, 1695,
     /* 128856 */     GIR_Done,
     /* 128857 */   // Label 2628: @128857
     /* 128857 */   GIM_Try, /*On fail goto*//*Label 2629*/ GIMT_Encode4(128912), // Rule ID 3963 //
     /* 128862 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /* 128865 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 128869 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 128873 */     // (frint:{ *:[v8f16] } MQPR:{ *:[v8f16] }:$val)  =>  (MVE_VRINTf16X:{ *:[v8f16] } MQPR:{ *:[v8f16] }:$val)
     /* 128873 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 128876 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 128880 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 128885 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRINTf16X),
     /* 128888 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 128890 */     GIR_RootToRootCopy, /*OpIdx*/1, // val
     /* 128892 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 128895 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 128901 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 128907 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 128910 */     GIR_RootConstrainSelectedInstOperands,
     /* 128911 */     // GIR_Coverage, 3963,
     /* 128911 */     GIR_EraseRootFromParent_Done,
     /* 128912 */   // Label 2629: @128912
     /* 128912 */   GIM_Reject,
     /* 128913 */ // Label 2627: @128913
     /* 128913 */ GIM_Reject,
     /* 128914 */ // Label 2618: @128914
     /* 128914 */ GIM_Reject,
     /* 128915 */ // Label 71: @128915
     /* 128915 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(3), /*)*//*default:*//*Label 2633*/ GIMT_Encode4(129052),
     /* 128926 */ /*GILLT_s16*//*Label 2630*/ GIMT_Encode4(128938),
     /* 128930 */ /*GILLT_s32*//*Label 2631*/ GIMT_Encode4(128976),
     /* 128934 */ /*GILLT_s64*//*Label 2632*/ GIMT_Encode4(129014),
     /* 128938 */ // Label 2630: @128938
     /* 128938 */ GIM_Try, /*On fail goto*//*Label 2634*/ GIMT_Encode4(128975), // Rule ID 668 //
     /* 128943 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 128946 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 128949 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 128953 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 128957 */   // (fnearbyint:{ *:[f16] } HPR:{ *:[f16] }:$Sm)  =>  (VRINTRH:{ *:[f16] } HPR:{ *:[f16] }:$Sm)
     /* 128957 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRINTRH),
     /* 128960 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /* 128962 */   GIR_RootToRootCopy, /*OpIdx*/1, // Sm
     /* 128964 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 128967 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 128973 */   GIR_RootConstrainSelectedInstOperands,
     /* 128974 */   // GIR_Coverage, 668,
     /* 128974 */   GIR_EraseRootFromParent_Done,
     /* 128975 */ // Label 2634: @128975
     /* 128975 */ GIM_Reject,
     /* 128976 */ // Label 2631: @128976
     /* 128976 */ GIM_Try, /*On fail goto*//*Label 2635*/ GIMT_Encode4(129013), // Rule ID 669 //
     /* 128981 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 128984 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 128987 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 128991 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 128995 */   // (fnearbyint:{ *:[f32] } SPR:{ *:[f32] }:$Sm)  =>  (VRINTRS:{ *:[f32] } SPR:{ *:[f32] }:$Sm)
     /* 128995 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRINTRS),
     /* 128998 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /* 129000 */   GIR_RootToRootCopy, /*OpIdx*/1, // Sm
     /* 129002 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 129005 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 129011 */   GIR_RootConstrainSelectedInstOperands,
     /* 129012 */   // GIR_Coverage, 669,
     /* 129012 */   GIR_EraseRootFromParent_Done,
     /* 129013 */ // Label 2635: @129013
     /* 129013 */ GIM_Reject,
     /* 129014 */ // Label 2632: @129014
     /* 129014 */ GIM_Try, /*On fail goto*//*Label 2636*/ GIMT_Encode4(129051), // Rule ID 670 //
     /* 129019 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDPVFP_HasFPARMv8),
     /* 129022 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 129025 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 129029 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 129033 */   // (fnearbyint:{ *:[f64] } DPR:{ *:[f64] }:$Dm)  =>  (VRINTRD:{ *:[f64] } DPR:{ *:[f64] }:$Dm)
     /* 129033 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRINTRD),
     /* 129036 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Dd]
     /* 129038 */   GIR_RootToRootCopy, /*OpIdx*/1, // Dm
     /* 129040 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 129043 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 129049 */   GIR_RootConstrainSelectedInstOperands,
     /* 129050 */   // GIR_Coverage, 670,
     /* 129050 */   GIR_EraseRootFromParent_Done,
     /* 129051 */ // Label 2636: @129051
     /* 129051 */ GIM_Reject,
     /* 129052 */ // Label 2633: @129052
     /* 129052 */ GIM_Reject,
     /* 129053 */ // Label 72: @129053
     /* 129053 */ GIM_Try, /*On fail goto*//*Label 2637*/ GIMT_Encode4(129068), // Rule ID 12 //
     /* 129058 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM_UseNaClTrap),
     /* 129061 */   // (trap)  =>  (TRAPNaCl)
     /* 129061 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(ARM::TRAPNaCl),
     /* 129066 */   GIR_RootConstrainSelectedInstOperands,
     /* 129067 */   // GIR_Coverage, 12,
     /* 129067 */   GIR_Done,
     /* 129068 */ // Label 2637: @129068
     /* 129068 */ GIM_Try, /*On fail goto*//*Label 2638*/ GIMT_Encode4(129083), // Rule ID 13 //
     /* 129073 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_DontUseNaClTrap_IsARM),
     /* 129076 */   // (trap)  =>  (TRAP)
     /* 129076 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(ARM::TRAP),
     /* 129081 */   GIR_RootConstrainSelectedInstOperands,
     /* 129082 */   // GIR_Coverage, 13,
     /* 129082 */   GIR_Done,
     /* 129083 */ // Label 2638: @129083
     /* 129083 */ GIM_Try, /*On fail goto*//*Label 2639*/ GIMT_Encode4(129098), // Rule ID 285 //
     /* 129088 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb),
     /* 129091 */   // (trap)  =>  (tTRAP)
     /* 129091 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(ARM::tTRAP),
     /* 129096 */   GIR_RootConstrainSelectedInstOperands,
     /* 129097 */   // GIR_Coverage, 285,
     /* 129097 */   GIR_Done,
     /* 129098 */ // Label 2639: @129098
     /* 129098 */ GIM_Reject,
     /* 129099 */ // Label 73: @129099
     /* 129099 */ GIM_Try, /*On fail goto*//*Label 2640*/ GIMT_Encode4(129115), // Rule ID 1835 //
     /* 129104 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV5T_IsARM),
     /* 129107 */   // (debugtrap)  =>  (BKPT 0:{ *:[i32] })
     /* 129107 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::BKPT),
     /* 129110 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 129113 */   GIR_RootConstrainSelectedInstOperands,
     /* 129114 */   // GIR_Coverage, 1835,
     /* 129114 */   GIR_EraseRootFromParent_Done,
     /* 129115 */ // Label 2640: @129115
     /* 129115 */ GIM_Try, /*On fail goto*//*Label 2641*/ GIMT_Encode4(129142), // Rule ID 1836 //
     /* 129120 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM_NoV5T),
     /* 129123 */   // (debugtrap)  =>  (UDF 254:{ *:[i32] })
     /* 129123 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::UDF),
     /* 129126 */   GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(254),
     /* 129136 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 129140 */   GIR_RootConstrainSelectedInstOperands,
     /* 129141 */   // GIR_Coverage, 1836,
     /* 129141 */   GIR_EraseRootFromParent_Done,
     /* 129142 */ // Label 2641: @129142
     /* 129142 */ GIM_Try, /*On fail goto*//*Label 2642*/ GIMT_Encode4(129158), // Rule ID 2021 //
     /* 129147 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV5T_IsThumb),
     /* 129150 */   // (debugtrap)  =>  (tBKPT 0:{ *:[i32] })
     /* 129150 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::tBKPT),
     /* 129153 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 129156 */   GIR_RootConstrainSelectedInstOperands,
     /* 129157 */   // GIR_Coverage, 2021,
     /* 129157 */   GIR_EraseRootFromParent_Done,
     /* 129158 */ // Label 2642: @129158
     /* 129158 */ GIM_Try, /*On fail goto*//*Label 2643*/ GIMT_Encode4(129185), // Rule ID 2022 //
     /* 129163 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb_NoV5T),
     /* 129166 */   // (debugtrap)  =>  (tUDF 254:{ *:[i32] })
     /* 129166 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::tUDF),
     /* 129169 */   GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(254),
     /* 129179 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 129183 */   GIR_RootConstrainSelectedInstOperands,
     /* 129184 */   // GIR_Coverage, 2022,
     /* 129184 */   GIR_EraseRootFromParent_Done,
     /* 129185 */ // Label 2643: @129185
     /* 129185 */ GIM_Reject,
     /* 129186 */ // Label 74: @129186
     /* 129186 */ GIM_Try, /*On fail goto*//*Label 2644*/ GIMT_Encode4(129606),
     /* 129191 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 129194 */   GIM_SwitchType, /*MI*/0, /*Op*/1, /*[*/GIMT_Encode2(8), GIMT_Encode2(16), /*)*//*default:*//*Label 2648*/ GIMT_Encode4(129492),
     /* 129205 */   /*GILLT_v4s32*//*Label 2645*/ GIMT_Encode4(129237), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 129221 */   /*GILLT_v8s16*//*Label 2646*/ GIMT_Encode4(129308), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 129233 */   /*GILLT_v16s8*//*Label 2647*/ GIMT_Encode4(129379),
     /* 129237 */   // Label 2645: @129237
     /* 129237 */   GIM_Try, /*On fail goto*//*Label 2649*/ GIMT_Encode4(129307), // Rule ID 3238 //
     /* 129242 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 129245 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /* 129249 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 129253 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /* 129257 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 129261 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 129265 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 129270 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 129275 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 129277 */     // (vecreduce_add:{ *:[i32] } (mul:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$src1, MQPR:{ *:[v4i32] }:$src2))  =>  (MVE_VMLADAVu32:{ *:[i32] } ?:{ *:[v4i32] }:$src1, ?:{ *:[v4i32] }:$src2)
     /* 129277 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMLADAVu32),
     /* 129280 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /* 129282 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /* 129286 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /* 129290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 129293 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 129299 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 129305 */     GIR_RootConstrainSelectedInstOperands,
     /* 129306 */     // GIR_Coverage, 3238,
     /* 129306 */     GIR_EraseRootFromParent_Done,
     /* 129307 */   // Label 2649: @129307
     /* 129307 */   GIM_Reject,
     /* 129308 */   // Label 2646: @129308
     /* 129308 */   GIM_Try, /*On fail goto*//*Label 2650*/ GIMT_Encode4(129378), // Rule ID 3239 //
     /* 129313 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 129316 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /* 129320 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 129324 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /* 129328 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 129332 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 129336 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 129341 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 129346 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 129348 */     // (vecreduce_add:{ *:[i32] } (mul:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$src1, MQPR:{ *:[v8i16] }:$src2))  =>  (MVE_VMLADAVu16:{ *:[i32] } ?:{ *:[v8i16] }:$src1, ?:{ *:[v8i16] }:$src2)
     /* 129348 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMLADAVu16),
     /* 129351 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /* 129353 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /* 129357 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /* 129361 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 129364 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 129370 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 129376 */     GIR_RootConstrainSelectedInstOperands,
     /* 129377 */     // GIR_Coverage, 3239,
     /* 129377 */     GIR_EraseRootFromParent_Done,
     /* 129378 */   // Label 2650: @129378
     /* 129378 */   GIM_Reject,
     /* 129379 */   // Label 2647: @129379
     /* 129379 */   GIM_Try, /*On fail goto*//*Label 2651*/ GIMT_Encode4(129491),
     /* 129384 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /* 129388 */     GIM_Try, /*On fail goto*//*Label 2652*/ GIMT_Encode4(129454), // Rule ID 3242 //
     /* 129393 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 129396 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 129400 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /* 129404 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 129408 */       GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 129412 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 129417 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 129422 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 129424 */       // (vecreduce_add:{ *:[i32] } (mul:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$src1, MQPR:{ *:[v16i8] }:$src2))  =>  (MVE_VMLADAVu8:{ *:[i32] } ?:{ *:[v16i8] }:$src1, ?:{ *:[v16i8] }:$src2)
     /* 129424 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMLADAVu8),
     /* 129427 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /* 129429 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /* 129433 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /* 129437 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 129440 */       GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 129446 */       GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 129452 */       GIR_RootConstrainSelectedInstOperands,
     /* 129453 */       // GIR_Coverage, 3242,
     /* 129453 */       GIR_EraseRootFromParent_Done,
     /* 129454 */     // Label 2652: @129454
     /* 129454 */     GIM_Try, /*On fail goto*//*Label 2653*/ GIMT_Encode4(129490), // Rule ID 3046 //
     /* 129459 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 129462 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 129466 */       // (vecreduce_add:{ *:[i32] } MQPR:{ *:[v16i8] }:$vec)  =>  (MVE_VADDVu8no_acc:{ *:[i32] } ?:{ *:[v16i8] }:$vec)
     /* 129466 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VADDVu8no_acc),
     /* 129469 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rda]
     /* 129471 */       GIR_RootToRootCopy, /*OpIdx*/1, // vec
     /* 129473 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 129476 */       GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 129482 */       GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 129488 */       GIR_RootConstrainSelectedInstOperands,
     /* 129489 */       // GIR_Coverage, 3046,
     /* 129489 */       GIR_EraseRootFromParent_Done,
     /* 129490 */     // Label 2653: @129490
     /* 129490 */     GIM_Reject,
     /* 129491 */   // Label 2651: @129491
     /* 129491 */   GIM_Reject,
     /* 129492 */   // Label 2648: @129492
     /* 129492 */   GIM_SwitchType, /*MI*/0, /*Op*/1, /*[*/GIMT_Encode2(8), GIMT_Encode2(13), /*)*//*default:*//*Label 2656*/ GIMT_Encode4(129605),
     /* 129503 */   /*GILLT_v4s32*//*Label 2654*/ GIMT_Encode4(129523), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 129519 */   /*GILLT_v8s16*//*Label 2655*/ GIMT_Encode4(129564),
     /* 129523 */   // Label 2654: @129523
     /* 129523 */   GIM_Try, /*On fail goto*//*Label 2657*/ GIMT_Encode4(129563), // Rule ID 3084 //
     /* 129528 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 129531 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /* 129535 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 129539 */     // (vecreduce_add:{ *:[i32] } MQPR:{ *:[v4i32] }:$vec)  =>  (MVE_VADDVu32no_acc:{ *:[i32] } ?:{ *:[v4i32] }:$vec)
     /* 129539 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VADDVu32no_acc),
     /* 129542 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rda]
     /* 129544 */     GIR_RootToRootCopy, /*OpIdx*/1, // vec
     /* 129546 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 129549 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 129555 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 129561 */     GIR_RootConstrainSelectedInstOperands,
     /* 129562 */     // GIR_Coverage, 3084,
     /* 129562 */     GIR_EraseRootFromParent_Done,
     /* 129563 */   // Label 2657: @129563
     /* 129563 */   GIM_Reject,
     /* 129564 */   // Label 2655: @129564
     /* 129564 */   GIM_Try, /*On fail goto*//*Label 2658*/ GIMT_Encode4(129604), // Rule ID 3074 //
     /* 129569 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 129572 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /* 129576 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 129580 */     // (vecreduce_add:{ *:[i32] } MQPR:{ *:[v8i16] }:$vec)  =>  (MVE_VADDVu16no_acc:{ *:[i32] } ?:{ *:[v8i16] }:$vec)
     /* 129580 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VADDVu16no_acc),
     /* 129583 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rda]
     /* 129585 */     GIR_RootToRootCopy, /*OpIdx*/1, // vec
     /* 129587 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 129590 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 129596 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 129602 */     GIR_RootConstrainSelectedInstOperands,
     /* 129603 */     // GIR_Coverage, 3074,
     /* 129603 */     GIR_EraseRootFromParent_Done,
     /* 129604 */   // Label 2658: @129604
     /* 129604 */   GIM_Reject,
     /* 129605 */   // Label 2656: @129605
     /* 129605 */   GIM_Reject,
     /* 129606 */ // Label 2644: @129606
     /* 129606 */ GIM_Reject,
     /* 129607 */ // Label 75: @129607
     /* 129607 */ GIM_Try, /*On fail goto*//*Label 2659*/ GIMT_Encode4(129886),
     /* 129612 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 129615 */   GIM_SwitchType, /*MI*/0, /*Op*/1, /*[*/GIMT_Encode2(8), GIMT_Encode2(16), /*)*//*default:*//*Label 2663*/ GIMT_Encode4(129885),
     /* 129626 */   /*GILLT_v4s32*//*Label 2660*/ GIMT_Encode4(129658), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 129642 */   /*GILLT_v8s16*//*Label 2661*/ GIMT_Encode4(129741), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 129654 */   /*GILLT_v16s8*//*Label 2662*/ GIMT_Encode4(129809),
     /* 129658 */   // Label 2660: @129658
     /* 129658 */   GIM_Try, /*On fail goto*//*Label 2664*/ GIMT_Encode4(129740), // Rule ID 3144 //
     /* 129663 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 129666 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 129670 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 129674 */     // (vecreduce_smax:{ *:[i32] } MQPR:{ *:[v4i32] }:$src)  =>  (MVE_VMAXVs32:{ *:[i32] } (t2MOVi:{ *:[i32] } -2147483648:{ *:[i32] }), ?:{ *:[v4i32] }:$src)
     /* 129674 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 129677 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::t2MOVi),
     /* 129681 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 129686 */     GIR_AddImm, /*InsnID*/1, /*Imm*/GIMT_Encode8(-2147483648),
     /* 129696 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/14,
     /* 129699 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 129705 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 129711 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 129713 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMAXVs32),
     /* 129716 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /* 129718 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 129721 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 129723 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 129726 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 129732 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 129738 */     GIR_RootConstrainSelectedInstOperands,
     /* 129739 */     // GIR_Coverage, 3144,
     /* 129739 */     GIR_EraseRootFromParent_Done,
     /* 129740 */   // Label 2664: @129740
     /* 129740 */   GIM_Reject,
     /* 129741 */   // Label 2661: @129741
     /* 129741 */   GIM_Try, /*On fail goto*//*Label 2665*/ GIMT_Encode4(129808), // Rule ID 3143 //
     /* 129746 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 129749 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 129753 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 129757 */     // (vecreduce_smax:{ *:[i32] } MQPR:{ *:[v8i16] }:$src)  =>  (MVE_VMAXVs16:{ *:[i32] } (t2MOVi32imm:{ *:[i32] } -32768:{ *:[i32] }), ?:{ *:[v8i16] }:$src)
     /* 129757 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 129760 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::t2MOVi32imm),
     /* 129764 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 129769 */     GIR_AddImm, /*InsnID*/1, /*Imm*/GIMT_Encode8(-32768),
     /* 129779 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 129781 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMAXVs16),
     /* 129784 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /* 129786 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 129789 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 129791 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 129794 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 129800 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 129806 */     GIR_RootConstrainSelectedInstOperands,
     /* 129807 */     // GIR_Coverage, 3143,
     /* 129807 */     GIR_EraseRootFromParent_Done,
     /* 129808 */   // Label 2665: @129808
     /* 129808 */   GIM_Reject,
     /* 129809 */   // Label 2662: @129809
     /* 129809 */   GIM_Try, /*On fail goto*//*Label 2666*/ GIMT_Encode4(129884), // Rule ID 3142 //
     /* 129814 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 129817 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 129821 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 129825 */     // (vecreduce_smax:{ *:[i32] } MQPR:{ *:[v16i8] }:$src)  =>  (MVE_VMAXVs8:{ *:[i32] } (t2MVNi:{ *:[i32] } 127:{ *:[i32] }), ?:{ *:[v16i8] }:$src)
     /* 129825 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 129828 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::t2MVNi),
     /* 129832 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 129837 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/127,
     /* 129840 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/14,
     /* 129843 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 129849 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 129855 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 129857 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMAXVs8),
     /* 129860 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /* 129862 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 129865 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 129867 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 129870 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 129876 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 129882 */     GIR_RootConstrainSelectedInstOperands,
     /* 129883 */     // GIR_Coverage, 3142,
     /* 129883 */     GIR_EraseRootFromParent_Done,
     /* 129884 */   // Label 2666: @129884
     /* 129884 */   GIM_Reject,
     /* 129885 */   // Label 2663: @129885
     /* 129885 */   GIM_Reject,
     /* 129886 */ // Label 2659: @129886
     /* 129886 */ GIM_Reject,
     /* 129887 */ // Label 76: @129887
     /* 129887 */ GIM_Try, /*On fail goto*//*Label 2667*/ GIMT_Encode4(130175),
     /* 129892 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 129895 */   GIM_SwitchType, /*MI*/0, /*Op*/1, /*[*/GIMT_Encode2(8), GIMT_Encode2(16), /*)*//*default:*//*Label 2671*/ GIMT_Encode4(130174),
     /* 129906 */   /*GILLT_v4s32*//*Label 2668*/ GIMT_Encode4(129938), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 129922 */   /*GILLT_v8s16*//*Label 2669*/ GIMT_Encode4(130021), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 129934 */   /*GILLT_v16s8*//*Label 2670*/ GIMT_Encode4(130098),
     /* 129938 */   // Label 2668: @129938
     /* 129938 */   GIM_Try, /*On fail goto*//*Label 2672*/ GIMT_Encode4(130020), // Rule ID 3150 //
     /* 129943 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 129946 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 129950 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 129954 */     // (vecreduce_smin:{ *:[i32] } MQPR:{ *:[v4i32] }:$src)  =>  (MVE_VMINVs32:{ *:[i32] } (t2MVNi:{ *:[i32] } -2147483648:{ *:[i32] }), ?:{ *:[v4i32] }:$src)
     /* 129954 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 129957 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::t2MVNi),
     /* 129961 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 129966 */     GIR_AddImm, /*InsnID*/1, /*Imm*/GIMT_Encode8(-2147483648),
     /* 129976 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/14,
     /* 129979 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 129985 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 129991 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 129993 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMINVs32),
     /* 129996 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /* 129998 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 130001 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 130003 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 130006 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 130012 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 130018 */     GIR_RootConstrainSelectedInstOperands,
     /* 130019 */     // GIR_Coverage, 3150,
     /* 130019 */     GIR_EraseRootFromParent_Done,
     /* 130020 */   // Label 2672: @130020
     /* 130020 */   GIM_Reject,
     /* 130021 */   // Label 2669: @130021
     /* 130021 */   GIM_Try, /*On fail goto*//*Label 2673*/ GIMT_Encode4(130097), // Rule ID 3149 //
     /* 130026 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 130029 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 130033 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 130037 */     // (vecreduce_smin:{ *:[i32] } MQPR:{ *:[v8i16] }:$src)  =>  (MVE_VMINVs16:{ *:[i32] } (t2MOVi16:{ *:[i32] } 32767:{ *:[i32] }), ?:{ *:[v8i16] }:$src)
     /* 130037 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 130040 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::t2MOVi16),
     /* 130044 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 130049 */     GIR_AddImm, /*InsnID*/1, /*Imm*/GIMT_Encode8(32767),
     /* 130059 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/14,
     /* 130062 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 130068 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 130070 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMINVs16),
     /* 130073 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /* 130075 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 130078 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 130080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 130083 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 130089 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 130095 */     GIR_RootConstrainSelectedInstOperands,
     /* 130096 */     // GIR_Coverage, 3149,
     /* 130096 */     GIR_EraseRootFromParent_Done,
     /* 130097 */   // Label 2673: @130097
     /* 130097 */   GIM_Reject,
     /* 130098 */   // Label 2670: @130098
     /* 130098 */   GIM_Try, /*On fail goto*//*Label 2674*/ GIMT_Encode4(130173), // Rule ID 3148 //
     /* 130103 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 130106 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 130110 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 130114 */     // (vecreduce_smin:{ *:[i32] } MQPR:{ *:[v16i8] }:$src)  =>  (MVE_VMINVs8:{ *:[i32] } (t2MOVi:{ *:[i32] } 127:{ *:[i32] }), ?:{ *:[v16i8] }:$src)
     /* 130114 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 130117 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::t2MOVi),
     /* 130121 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 130126 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/127,
     /* 130129 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/14,
     /* 130132 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 130138 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 130144 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 130146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMINVs8),
     /* 130149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /* 130151 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 130154 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 130156 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 130159 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 130165 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 130171 */     GIR_RootConstrainSelectedInstOperands,
     /* 130172 */     // GIR_Coverage, 3148,
     /* 130172 */     GIR_EraseRootFromParent_Done,
     /* 130173 */   // Label 2674: @130173
     /* 130173 */   GIM_Reject,
     /* 130174 */   // Label 2671: @130174
     /* 130174 */   GIM_Reject,
     /* 130175 */ // Label 2667: @130175
     /* 130175 */ GIM_Reject,
     /* 130176 */ // Label 77: @130176
     /* 130176 */ GIM_Try, /*On fail goto*//*Label 2675*/ GIMT_Encode4(130456),
     /* 130181 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 130184 */   GIM_SwitchType, /*MI*/0, /*Op*/1, /*[*/GIMT_Encode2(8), GIMT_Encode2(16), /*)*//*default:*//*Label 2679*/ GIMT_Encode4(130455),
     /* 130195 */   /*GILLT_v4s32*//*Label 2676*/ GIMT_Encode4(130227), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 130211 */   /*GILLT_v8s16*//*Label 2677*/ GIMT_Encode4(130303), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 130223 */   /*GILLT_v16s8*//*Label 2678*/ GIMT_Encode4(130379),
     /* 130227 */   // Label 2676: @130227
     /* 130227 */   GIM_Try, /*On fail goto*//*Label 2680*/ GIMT_Encode4(130302), // Rule ID 3147 //
     /* 130232 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 130235 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 130239 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 130243 */     // (vecreduce_umax:{ *:[i32] } MQPR:{ *:[v4i32] }:$src)  =>  (MVE_VMAXVu32:{ *:[i32] } (t2MOVi:{ *:[i32] } 0:{ *:[i32] }), ?:{ *:[v4i32] }:$src)
     /* 130243 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 130246 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::t2MOVi),
     /* 130250 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 130255 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 130258 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/14,
     /* 130261 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 130267 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 130273 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 130275 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMAXVu32),
     /* 130278 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /* 130280 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 130283 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 130285 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 130288 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 130294 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 130300 */     GIR_RootConstrainSelectedInstOperands,
     /* 130301 */     // GIR_Coverage, 3147,
     /* 130301 */     GIR_EraseRootFromParent_Done,
     /* 130302 */   // Label 2680: @130302
     /* 130302 */   GIM_Reject,
     /* 130303 */   // Label 2677: @130303
     /* 130303 */   GIM_Try, /*On fail goto*//*Label 2681*/ GIMT_Encode4(130378), // Rule ID 3146 //
     /* 130308 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 130311 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 130315 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 130319 */     // (vecreduce_umax:{ *:[i32] } MQPR:{ *:[v8i16] }:$src)  =>  (MVE_VMAXVu16:{ *:[i32] } (t2MOVi:{ *:[i32] } 0:{ *:[i32] }), ?:{ *:[v8i16] }:$src)
     /* 130319 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 130322 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::t2MOVi),
     /* 130326 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 130331 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 130334 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/14,
     /* 130337 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 130343 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 130349 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 130351 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMAXVu16),
     /* 130354 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /* 130356 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 130359 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 130361 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 130364 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 130370 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 130376 */     GIR_RootConstrainSelectedInstOperands,
     /* 130377 */     // GIR_Coverage, 3146,
     /* 130377 */     GIR_EraseRootFromParent_Done,
     /* 130378 */   // Label 2681: @130378
     /* 130378 */   GIM_Reject,
     /* 130379 */   // Label 2678: @130379
     /* 130379 */   GIM_Try, /*On fail goto*//*Label 2682*/ GIMT_Encode4(130454), // Rule ID 3145 //
     /* 130384 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 130387 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 130391 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 130395 */     // (vecreduce_umax:{ *:[i32] } MQPR:{ *:[v16i8] }:$src)  =>  (MVE_VMAXVu8:{ *:[i32] } (t2MOVi:{ *:[i32] } 0:{ *:[i32] }), ?:{ *:[v16i8] }:$src)
     /* 130395 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 130398 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::t2MOVi),
     /* 130402 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 130407 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 130410 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/14,
     /* 130413 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 130419 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 130425 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 130427 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMAXVu8),
     /* 130430 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /* 130432 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 130435 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 130437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 130440 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 130446 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 130452 */     GIR_RootConstrainSelectedInstOperands,
     /* 130453 */     // GIR_Coverage, 3145,
     /* 130453 */     GIR_EraseRootFromParent_Done,
     /* 130454 */   // Label 2682: @130454
     /* 130454 */   GIM_Reject,
     /* 130455 */   // Label 2679: @130455
     /* 130455 */   GIM_Reject,
     /* 130456 */ // Label 2675: @130456
     /* 130456 */ GIM_Reject,
     /* 130457 */ // Label 78: @130457
     /* 130457 */ GIM_Try, /*On fail goto*//*Label 2683*/ GIMT_Encode4(130752),
     /* 130462 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 130465 */   GIM_SwitchType, /*MI*/0, /*Op*/1, /*[*/GIMT_Encode2(8), GIMT_Encode2(16), /*)*//*default:*//*Label 2687*/ GIMT_Encode4(130751),
     /* 130476 */   /*GILLT_v4s32*//*Label 2684*/ GIMT_Encode4(130508), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 130492 */   /*GILLT_v8s16*//*Label 2685*/ GIMT_Encode4(130591), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 130504 */   /*GILLT_v16s8*//*Label 2686*/ GIMT_Encode4(130668),
     /* 130508 */   // Label 2684: @130508
     /* 130508 */   GIM_Try, /*On fail goto*//*Label 2688*/ GIMT_Encode4(130590), // Rule ID 3153 //
     /* 130513 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 130516 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 130520 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 130524 */     // (vecreduce_umin:{ *:[i32] } MQPR:{ *:[v4i32] }:$src)  =>  (MVE_VMINVu32:{ *:[i32] } (t2MOVi:{ *:[i32] } 4294967295:{ *:[i32] }), ?:{ *:[v4i32] }:$src)
     /* 130524 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 130527 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::t2MOVi),
     /* 130531 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 130536 */     GIR_AddImm, /*InsnID*/1, /*Imm*/GIMT_Encode8(4294967295),
     /* 130546 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/14,
     /* 130549 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 130555 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 130561 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 130563 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMINVu32),
     /* 130566 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /* 130568 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 130571 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 130573 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 130576 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 130582 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 130588 */     GIR_RootConstrainSelectedInstOperands,
     /* 130589 */     // GIR_Coverage, 3153,
     /* 130589 */     GIR_EraseRootFromParent_Done,
     /* 130590 */   // Label 2688: @130590
     /* 130590 */   GIM_Reject,
     /* 130591 */   // Label 2685: @130591
     /* 130591 */   GIM_Try, /*On fail goto*//*Label 2689*/ GIMT_Encode4(130667), // Rule ID 3152 //
     /* 130596 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 130599 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 130603 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 130607 */     // (vecreduce_umin:{ *:[i32] } MQPR:{ *:[v8i16] }:$src)  =>  (MVE_VMINVu16:{ *:[i32] } (t2MOVi16:{ *:[i32] } 65535:{ *:[i32] }), ?:{ *:[v8i16] }:$src)
     /* 130607 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 130610 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::t2MOVi16),
     /* 130614 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 130619 */     GIR_AddImm, /*InsnID*/1, /*Imm*/GIMT_Encode8(65535),
     /* 130629 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/14,
     /* 130632 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 130638 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 130640 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMINVu16),
     /* 130643 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /* 130645 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 130648 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 130650 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 130653 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 130659 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 130665 */     GIR_RootConstrainSelectedInstOperands,
     /* 130666 */     // GIR_Coverage, 3152,
     /* 130666 */     GIR_EraseRootFromParent_Done,
     /* 130667 */   // Label 2689: @130667
     /* 130667 */   GIM_Reject,
     /* 130668 */   // Label 2686: @130668
     /* 130668 */   GIM_Try, /*On fail goto*//*Label 2690*/ GIMT_Encode4(130750), // Rule ID 3151 //
     /* 130673 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 130676 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 130680 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 130684 */     // (vecreduce_umin:{ *:[i32] } MQPR:{ *:[v16i8] }:$src)  =>  (MVE_VMINVu8:{ *:[i32] } (t2MOVi:{ *:[i32] } 255:{ *:[i32] }), ?:{ *:[v16i8] }:$src)
     /* 130684 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 130687 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::t2MOVi),
     /* 130691 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 130696 */     GIR_AddImm, /*InsnID*/1, /*Imm*/GIMT_Encode8(255),
     /* 130706 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/14,
     /* 130709 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 130715 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 130721 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 130723 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMINVu8),
     /* 130726 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /* 130728 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 130731 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 130733 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 130736 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 130742 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 130748 */     GIR_RootConstrainSelectedInstOperands,
     /* 130749 */     // GIR_Coverage, 3151,
     /* 130749 */     GIR_EraseRootFromParent_Done,
     /* 130750 */   // Label 2690: @130750
     /* 130750 */   GIM_Reject,
     /* 130751 */   // Label 2687: @130751
     /* 130751 */   GIM_Reject,
     /* 130752 */ // Label 2683: @130752
     /* 130752 */ GIM_Reject,
     /* 130753 */ // Label 79: @130753
     /* 130753 */ GIM_Reject,
     /* 130754 */ }; // Size: 130754 bytes
  return MatchTable0;
}
#undef GIMT_Encode2
#undef GIMT_Encode4
#undef GIMT_Encode8

#endif // ifdef GET_GLOBALISEL_IMPL

#ifdef GET_GLOBALISEL_PREDICATES_DECL
PredicateBitset AvailableModuleFeatures;
mutable PredicateBitset AvailableFunctionFeatures;
PredicateBitset getAvailableFeatures() const {
  return AvailableModuleFeatures | AvailableFunctionFeatures;
}
PredicateBitset
computeAvailableModuleFeatures(const ARMSubtarget *Subtarget) const;
PredicateBitset
computeAvailableFunctionFeatures(const ARMSubtarget *Subtarget,
                                 const MachineFunction *MF) const;
void setupGeneratedPerFunctionState(MachineFunction &MF) override;
#endif // ifdef GET_GLOBALISEL_PREDICATES_DECL
#ifdef GET_GLOBALISEL_PREDICATES_INIT
AvailableModuleFeatures(computeAvailableModuleFeatures(&STI)),
AvailableFunctionFeatures()
#endif // ifdef GET_GLOBALISEL_PREDICATES_INIT
